/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         MYSQLparse
#define yylex           MYSQLlex
#define yyerror         MYSQLerror
#define yydebug         MYSQLdebug
#define yynerrs         MYSQLnerrs

/* First part of user prologue.  */
#line 25 "/home/buildbot/git/sql/sql_yacc.yy"

#define YYLIP  (& thd->m_parser_state->m_lip)
#define YYPS   (& thd->m_parser_state->m_yacc)
#define YYCSCL (thd->variables.character_set_client)

#define MYSQL_YACC
#define YYINITDEPTH 100
#define YYMAXDEPTH 3200                        /* Because of 64K stack */
#define Lex (thd->lex)

#define Select Lex->current_select
#include "mariadb.h"
#include "sql_priv.h"
#include "sql_parse.h"                        /* comp_*_creator */
#include "sql_table.h"                        /* primary_key_name */
#include "sql_partition.h"  /* partition_info, HASH_PARTITION */
#include "sql_acl.h"                          /* *_ACL */
#include "sql_class.h"      /* Key_part_spec, enum_filetype, Diag_condition_item_name */
#include "slave.h"
#include "lex_symbol.h"
#include "item_create.h"
#include "sp_head.h"
#include "sp_rcontext.h"
#include "sp.h"
#include "sql_show.h"
#include "sql_alter.h"                         // Sql_cmd_alter_table*
#include "sql_truncate.h"                      // Sql_cmd_truncate_table
#include "sql_admin.h"                         // Sql_cmd_analyze/Check..._table
#include "sql_partition_admin.h"               // Sql_cmd_alter_table_*_part.
#include "sql_handler.h"                       // Sql_cmd_handler_*
#include "sql_signal.h"
#include "sql_get_diagnostics.h"               // Sql_cmd_get_diagnostics
#include "sql_cte.h"
#include "sql_window.h"
#include "item_windowfunc.h"
#include "event_parse_data.h"
#include "create_options.h"
#include <myisam.h>
#include <myisammrg.h>
#include "keycaches.h"
#include "set_var.h"
#include "rpl_mi.h"
#include "lex_token.h"
#include "sql_lex.h"
#include "sql_sequence.h"
#include "my_base.h"
#include "sql_type_json.h"

/* this is to get the bison compilation windows warnings out */
#ifdef _MSC_VER
/* warning C4065: switch statement contains 'default' but no 'case' labels */
/* warning C4102: 'yyexhaustedlab': unreferenced label */
#pragma warning (disable : 4065 4102)
#endif
#ifdef __GNUC__
#pragma GCC diagnostic ignored "-Wunused-label" /* yyexhaustedlab: */
#endif

int yylex(void *yylval, void *yythd);

#define yyoverflow(A,B,C,D,E,F)               \
  {                                           \
    size_t val= *(F);                         \
    if (unlikely(my_yyoverflow((B), (D), &val))) \
    {                                         \
      yyerror(thd, (char*) (A));              \
      return 2;                               \
    }                                         \
    else                                      \
    {                                         \
      *(F)= (YYSIZE_T)val;                    \
    }                                         \
  }

#define MYSQL_YYABORT                         \
  do                                          \
  {                                           \
    LEX::cleanup_lex_after_parse_error(thd);  \
    YYABORT;                                  \
  } while (0)

#define MYSQL_YYABORT_UNLESS(A)                  \
  if (unlikely(!(A)))                            \
  {                                              \
    thd->parse_error();                          \
    MYSQL_YYABORT;                               \
  }

#define my_yyabort_error(A)                      \
  do { my_error A; MYSQL_YYABORT; } while(0)

#ifndef DBUG_OFF
#define YYDEBUG 1
#else
#define YYDEBUG 0
#endif


static Item* escape(THD *thd)
{
  thd->lex->escape_used= false;
  const char *esc= thd->variables.sql_mode & MODE_NO_BACKSLASH_ESCAPES ? "" : "\\";
  return new (thd->mem_root) Item_string_ascii(thd, esc, MY_TEST(esc[0]));
}


/**
  @brief Bison callback to report a syntax/OOM error

  This function is invoked by the bison-generated parser
  when a syntax error, a parse error or an out-of-memory
  condition occurs. This function is not invoked when the
  parser is requested to abort by semantic action code
  by means of YYABORT or YYACCEPT macros. This is why these
  macros should not be used (use MYSQL_YYABORT/MYSQL_YYACCEPT
  instead).

  The parser will abort immediately after invoking this callback.

  This function is not for use in semantic actions and is internal to
  the parser, as it performs some pre-return cleanup. 
  In semantic actions, please use thd->parse_error() or my_error to
  push an error into the error stack and MYSQL_YYABORT
  to abort from the parser.
*/

void MYSQLerror(THD *thd, const char *s)
{
  /*
    Restore the original LEX if it was replaced when parsing
    a stored procedure. We must ensure that a parsing error
    does not leave any side effects in the THD.
  */
  LEX::cleanup_lex_after_parse_error(thd);

  /* "parse error" changed into "syntax error" between bison 1.75 and 1.875 */
  if (strcmp(s,"parse error") == 0 || strcmp(s,"syntax error") == 0)
    s= ER_THD(thd, ER_SYNTAX_ERROR);
  thd->parse_error(s, 0);
}


#ifndef DBUG_OFF
void turn_parser_debug_on()
{
  /*
     MYSQLdebug is in sql/sql_yacc.cc, in bison generated code.
     Turning this option on is **VERY** verbose, and should be
     used when investigating a syntax error problem only.

     The syntax to run with bison traces is as follows :
     - Starting a server manually :
       mysqld --debug-dbug="d,parser_debug" ...
     - Running a test :
       mysql-test-run.pl --mysqld="--debug-dbug=d,parser_debug" ...

     The result will be in the process stderr (var/log/master.err)
   */

  extern int yydebug;
  yydebug= 1;
}
#endif


/**
  Helper action for a case expression statement (the expr in 'CASE expr').
  This helper is used for 'searched' cases only.
  @param lex the parser lex context
  @param expr the parsed expression
  @return 0 on success
*/

int LEX::case_stmt_action_expr(Item* expr)
{
  int case_expr_id= spcont->register_case_expr();
  sp_instr_set_case_expr *i;

  if (spcont->push_case_expr_id(case_expr_id))
    return 1;

  i= new (thd->mem_root)
    sp_instr_set_case_expr(sphead->instructions(), spcont, case_expr_id, expr,
                           this);

  sphead->add_cont_backpatch(i);
  return sphead->add_instr(i);
}

/**
  Helper action for a case when condition.
  This helper is used for both 'simple' and 'searched' cases.
  @param lex the parser lex context
  @param when the parsed expression for the WHEN clause
  @param simple true for simple cases, false for searched cases
*/

int LEX::case_stmt_action_when(Item *when, bool simple)
{
  uint ip= sphead->instructions();
  sp_instr_jump_if_not *i;
  Item_case_expr *var;
  Item *expr;

  if (simple)
  {
    var= new (thd->mem_root)
         Item_case_expr(thd, spcont->get_current_case_expr_id());

#ifdef DBUG_ASSERT_EXISTS
    if (var)
    {
      var->m_sp= sphead;
    }
#endif

    expr= new (thd->mem_root) Item_func_eq(thd, var, when);
    i= new (thd->mem_root) sp_instr_jump_if_not(ip, spcont, expr, this);
  }
  else
    i= new (thd->mem_root) sp_instr_jump_if_not(ip, spcont, when, this);

  /*
    BACKPATCH: Registering forward jump from
    "case_stmt_action_when" to "case_stmt_action_then"
    (jump_if_not from instruction 2 to 5, 5 to 8 ... in the example)
  */

  return
    !MY_TEST(i) ||
    sphead->push_backpatch(thd, i, spcont->push_label(thd, &empty_clex_str, 0)) ||
    sphead->add_cont_backpatch(i) ||
    sphead->add_instr(i);
}

/**
  Helper action for a case then statements.
  This helper is used for both 'simple' and 'searched' cases.
  @param lex the parser lex context
*/

int LEX::case_stmt_action_then()
{
  uint ip= sphead->instructions();
  sp_instr_jump *i= new (thd->mem_root) sp_instr_jump(ip, spcont);
  if (!MY_TEST(i) || sphead->add_instr(i))
    return 1;

  /*
    BACKPATCH: Resolving forward jump from
    "case_stmt_action_when" to "case_stmt_action_then"
    (jump_if_not from instruction 2 to 5, 5 to 8 ... in the example)
  */

  sphead->backpatch(spcont->pop_label());

  /*
    BACKPATCH: Registering forward jump from
    "case_stmt_action_then" to after END CASE
    (jump from instruction 4 to 12, 7 to 12 ... in the example)
  */

  return sphead->push_backpatch(thd, i, spcont->last_label());
}


/**
  Helper action for a SET statement.
  Used to push a system variable into the assignment list.

  @param tmp      the system variable with base name
  @param var_type the scope of the variable
  @param val      the value being assigned to the variable

  @return TRUE if error, FALSE otherwise.
*/

bool
LEX::set_system_variable(enum enum_var_type var_type,
                         sys_var *sysvar, const LEX_CSTRING *base_name,
                         Item *val)
{
  set_var *setvar;

  /* No AUTOCOMMIT from a stored function or trigger. */
  if (spcont && sysvar == Sys_autocommit_ptr)
    sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;

  if (val && val->type() == Item::FIELD_ITEM &&
      ((Item_field*)val)->table_name)
  {
    my_error(ER_WRONG_TYPE_FOR_VAR, MYF(0), sysvar->name.str);
    return TRUE;
  }

  if (!(setvar= new (thd->mem_root) set_var(thd, var_type, sysvar,
                                            base_name, val)))
    return TRUE;

  return var_list.push_back(setvar, thd->mem_root);
}


/**
  Helper action for a SET statement.
  Used to SET a field of NEW row.

  @param name     the field name
  @param val      the value being assigned to the row

  @return TRUE if error, FALSE otherwise.
*/

bool LEX::set_trigger_new_row(const LEX_CSTRING *name, Item *val)
{
  Item_trigger_field *trg_fld;
  sp_instr_set_trigger_field *sp_fld;

  /* QQ: Shouldn't this be field's default value ? */
  if (! val)
    val= new (thd->mem_root) Item_null(thd);

  DBUG_ASSERT(trg_chistics.action_time == TRG_ACTION_BEFORE &&
              (trg_chistics.event == TRG_EVENT_INSERT ||
               trg_chistics.event == TRG_EVENT_UPDATE));

  trg_fld= new (thd->mem_root)
            Item_trigger_field(thd, current_context(),
                               Item_trigger_field::NEW_ROW,
                               name, UPDATE_ACL, FALSE);

  if (unlikely(trg_fld == NULL))
    return TRUE;

  sp_fld= new (thd->mem_root)
        sp_instr_set_trigger_field(sphead->instructions(),
                                   spcont, trg_fld, val, this);

  if (unlikely(sp_fld == NULL))
    return TRUE;

  /*
    Let us add this item to list of all Item_trigger_field
    objects in trigger.
  */
  trg_table_fields.link_in_list(trg_fld, &trg_fld->next_trg_field);

  return sphead->add_instr(sp_fld);
}


/**
  Create an object to represent a SP variable in the Item-hierarchy.

  @param  name        The SP variable name.
  @param  spvar       The SP variable (optional).
  @param  start_in_q  Start position of the SP variable name in the query.
  @param  end_in_q    End position of the SP variable name in the query.

  @remark If spvar is not specified, the name is used to search for the
          variable in the parse-time context. If the variable does not
          exist, a error is set and NULL is returned to the caller.

  @return An Item_splocal object representing the SP variable, or NULL on error.
*/
Item_splocal*
LEX::create_item_for_sp_var(const Lex_ident_cli_st *cname, sp_variable *spvar)
{
  const Sp_rcontext_handler *rh;
  Item_splocal *item;
  const char *start_in_q= cname->pos();
  const char *end_in_q= cname->end();
  uint pos_in_q, len_in_q;
  Lex_ident_sys name(thd, cname);

  if (name.is_null())
    return NULL;  // EOM

  /* If necessary, look for the variable. */
  if (spcont && !spvar)
    spvar= find_variable(&name, &rh);

  if (!spvar)
  {
    my_error(ER_SP_UNDECLARED_VAR, MYF(0), name.str);
    return NULL;
  }

  DBUG_ASSERT(spcont && spvar);

  /* Position and length of the SP variable name in the query. */
  pos_in_q= (uint)(start_in_q - sphead->m_tmp_query);
  len_in_q= (uint)(end_in_q - start_in_q);

  item= new (thd->mem_root)
    Item_splocal(thd, rh, &name, spvar->offset, spvar->type_handler(),
                 pos_in_q, len_in_q);

#ifdef DBUG_ASSERT_EXISTS
  if (item)
    item->m_sp= sphead;
#endif

  return item;
}

/**
  Helper to resolve the SQL:2003 Syntax exception 1) in <in predicate>.
  See SQL:2003, Part 2, section 8.4 <in predicate>, Note 184, page 383.
  This function returns the proper item for the SQL expression
  <code>left [NOT] IN ( expr )</code>
  @param thd the current thread
  @param left the in predicand
  @param equal true for IN predicates, false for NOT IN predicates
  @param expr first and only expression of the in value list
  @return an expression representing the IN predicate.
*/
Item* handle_sql2003_note184_exception(THD *thd, Item* left, bool equal,
                                       Item *expr)
{
  /*
    Relevant references for this issue:
    - SQL:2003, Part 2, section 8.4 <in predicate>, page 383,
    - SQL:2003, Part 2, section 7.2 <row value expression>, page 296,
    - SQL:2003, Part 2, section 6.3 <value expression primary>, page 174,
    - SQL:2003, Part 2, section 7.15 <subquery>, page 370,
    - SQL:2003 Feature F561, "Full value expressions".

    The exception in SQL:2003 Note 184 means:
    Item_singlerow_subselect, which corresponds to a <scalar subquery>,
    should be re-interpreted as an Item_in_subselect, which corresponds
    to a <table subquery> when used inside an <in predicate>.

    Our reading of Note 184 is reccursive, so that all:
    - IN (( <subquery> ))
    - IN ((( <subquery> )))
    - IN '('^N <subquery> ')'^N
    - etc
    should be interpreted as a <table subquery>, no matter how deep in the
    expression the <subquery> is.
  */

  Item *result;

  DBUG_ENTER("handle_sql2003_note184_exception");

  if (expr->type() == Item::SUBSELECT_ITEM)
  {
    Item_subselect *expr2 = (Item_subselect*) expr;

    if (expr2->substype() == Item_subselect::SINGLEROW_SUBS)
    {
      Item_singlerow_subselect *expr3 = (Item_singlerow_subselect*) expr2;
      st_select_lex *subselect;

      /*
        Implement the mandated change, by altering the semantic tree:
          left IN Item_singlerow_subselect(subselect)
        is modified to
          left IN (subselect)
        which is represented as
          Item_in_subselect(left, subselect)
      */
      subselect= expr3->invalidate_and_restore_select_lex();
      result= new (thd->mem_root) Item_in_subselect(thd, left, subselect);

      if (! equal)
        result = negate_expression(thd, result);

      DBUG_RETURN(result);
    }
  }

  if (equal)
    result= new (thd->mem_root) Item_func_eq(thd, left, expr);
  else
    result= new (thd->mem_root) Item_func_ne(thd, left, expr);

  DBUG_RETURN(result);
}

/**
  Create a separate LEX for each assignment if in SP.

  If we are in SP we want have own LEX for each assignment.
  This is mostly because it is hard for several sp_instr_set
  and sp_instr_set_trigger instructions share one LEX.
  (Well, it is theoretically possible but adds some extra
  overhead on preparation for execution stage and IMO less
  robust).

  QQ: May be we should simply prohibit group assignments in SP?

  @see sp_create_assignment_instr

  @param thd           Thread context
  @param no_lookahead  True if the parser has no lookahead
*/

bool sp_create_assignment_lex(THD *thd, bool no_lookahead)
{
  LEX *lex= thd->lex;

  if (lex->sphead)
  {
    Lex_input_stream *lip= &thd->m_parser_state->m_lip;
    LEX *old_lex= lex;
    lex->sphead->reset_lex(thd);
    lex= thd->lex;

    /* Set new LEX as if we at start of set rule. */
    lex->sql_command= SQLCOM_SET_OPTION;
    if (lex->main_select_push())
      return true;
    mysql_init_select(lex);
    lex->var_list.empty();
    lex->autocommit= 0;
    /* get_ptr() is only correct with no lookahead. */
    if (no_lookahead)
        lex->sphead->m_tmp_query= lip->get_ptr();
    else
        lex->sphead->m_tmp_query= lip->get_tok_end();
    /* Inherit from outer lex. */
    lex->option_type= old_lex->option_type;
  }
  return false;
}


/**
  Create a SP instruction for a SET assignment.

  @see sp_create_assignment_lex

  @param thd           Thread context
  @param no_lookahead  True if the parser has no lookahead

  @return false if success, true otherwise.
*/

bool sp_create_assignment_instr(THD *thd, bool no_lookahead)
{
  LEX *lex= thd->lex;

  if (lex->sphead)
  {
    if (!lex->var_list.is_empty())
    {
      /*
        We have assignment to user or system variable or
        option setting, so we should construct sp_instr_stmt
        for it.
      */
      Lex_input_stream *lip= &thd->m_parser_state->m_lip;

      /*
        Extract the query statement from the tokenizer.  The
        end is either lip->ptr, if there was no lookahead,
        lip->tok_end otherwise.
      */
      static const LEX_CSTRING setsp= { STRING_WITH_LEN("SET ") };
      const char *qend= no_lookahead ? lip->get_ptr() : lip->get_tok_end();
      Lex_cstring qbuf(lex->sphead->m_tmp_query, qend);
      if (lex->new_sp_instr_stmt(thd, setsp, qbuf))
        return true;
    }
    lex->pop_select();
    if (lex->check_main_unit_semantics())
    {
      /*
        "lex" can be referrenced by:
        - sp_instr_set                          SET a= expr;
        - sp_instr_set_row_field                SET r.a= expr;
        - sp_instr_stmt (just generated above)  SET @a= expr;
        In this case, "lex" is fully owned by sp_instr_xxx and it will
        be deleted by the destructor ~sp_instr_xxx().
        So we should remove "lex" from the stack sp_head::m_lex,
        to avoid double free.
        Note, in case "lex" is not owned by any sp_instr_xxx,
        it's also safe to remove it from the stack right now.
        So we can remove it unconditionally, without testing lex->sp_lex_in_use.
      */
      lex->sphead->restore_lex(thd);
      return true;
    }
    enum_var_type inner_option_type= lex->option_type;
    if (lex->sphead->restore_lex(thd))
      return true;
    /* Copy option_type to outer lex in case it has changed. */
    thd->lex->option_type= inner_option_type;
  }
  return false;
}

void LEX::add_key_to_list(LEX_CSTRING *field_name,
                          enum Key::Keytype type, bool check_exists)
{
  Key *key;
  MEM_ROOT *mem_root= thd->mem_root;
  key= new (mem_root)
        Key(type, &null_clex_str, HA_KEY_ALG_UNDEF, false,
             DDL_options(check_exists ?
                         DDL_options::OPT_IF_NOT_EXISTS :
                         DDL_options::OPT_NONE));
  key->columns.push_back(new (mem_root) Key_part_spec(field_name, 0),
                         mem_root);
  alter_info.key_list.push_back(key, mem_root);
}

bool LEX::add_alter_list(const char *name, Virtual_column_info *expr,
                         bool exists)
{
  MEM_ROOT *mem_root= thd->mem_root;
  Alter_column *ac= new (mem_root) Alter_column(name, expr, exists);
  if (unlikely(ac == NULL))
    return true;
  alter_info.alter_list.push_back(ac, mem_root);
  alter_info.flags|= ALTER_CHANGE_COLUMN_DEFAULT;
  return false;
}

void LEX::init_last_field(Column_definition *field,
                          const LEX_CSTRING *field_name,
                          const CHARSET_INFO *cs)
{
  last_field= field;

  field->field_name= *field_name;

  /* reset LEX fields that are used in Create_field::set_and_check() */
  charset= cs;
}


bool LEX::set_bincmp(CHARSET_INFO *cs, bool bin)
{
  /*
     if charset is NULL - we're parsing a field declaration.
     we cannot call find_bin_collation for a field here, because actual
     field charset is determined in get_sql_field_charset() much later.
     so we only set a flag.
  */
  if (!charset)
  {
    charset= cs;
    last_field->flags|= bin ? BINCMP_FLAG : 0;
    return false;
  }

  charset= bin ? find_bin_collation(cs ? cs : charset)
               :                    cs ? cs : charset;
  return charset == NULL;
}

#define bincmp_collation(X,Y)           \
  do                                    \
  {                                     \
     if (unlikely(Lex->set_bincmp(X,Y))) \
       MYSQL_YYABORT;                   \
  } while(0)


Virtual_column_info *add_virtual_expression(THD *thd, Item *expr)
{
  Virtual_column_info *v= new (thd->mem_root) Virtual_column_info();
  if (unlikely(!v))
     return 0;
   v->expr= expr;
   v->utf8= 0;  /* connection charset */
   return v;
}



#line 751 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "sql_yacc.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ABORT_SYM = 3,                  /* ABORT_SYM  */
  YYSYMBOL_ACCESSIBLE_SYM = 4,             /* ACCESSIBLE_SYM  */
  YYSYMBOL_ADD = 5,                        /* ADD  */
  YYSYMBOL_ALL = 6,                        /* ALL  */
  YYSYMBOL_ALTER = 7,                      /* ALTER  */
  YYSYMBOL_ANALYZE_SYM = 8,                /* ANALYZE_SYM  */
  YYSYMBOL_AND_AND_SYM = 9,                /* AND_AND_SYM  */
  YYSYMBOL_AND_SYM = 10,                   /* AND_SYM  */
  YYSYMBOL_AS = 11,                        /* AS  */
  YYSYMBOL_ASC = 12,                       /* ASC  */
  YYSYMBOL_ASENSITIVE_SYM = 13,            /* ASENSITIVE_SYM  */
  YYSYMBOL_BEFORE_SYM = 14,                /* BEFORE_SYM  */
  YYSYMBOL_BETWEEN_SYM = 15,               /* BETWEEN_SYM  */
  YYSYMBOL_BIGINT = 16,                    /* BIGINT  */
  YYSYMBOL_BINARY = 17,                    /* BINARY  */
  YYSYMBOL_BIN_NUM = 18,                   /* BIN_NUM  */
  YYSYMBOL_BIT_AND = 19,                   /* BIT_AND  */
  YYSYMBOL_BIT_OR = 20,                    /* BIT_OR  */
  YYSYMBOL_BIT_XOR = 21,                   /* BIT_XOR  */
  YYSYMBOL_BLOB_MARIADB_SYM = 22,          /* BLOB_MARIADB_SYM  */
  YYSYMBOL_BLOB_ORACLE_SYM = 23,           /* BLOB_ORACLE_SYM  */
  YYSYMBOL_BODY_ORACLE_SYM = 24,           /* BODY_ORACLE_SYM  */
  YYSYMBOL_BOTH = 25,                      /* BOTH  */
  YYSYMBOL_BY = 26,                        /* BY  */
  YYSYMBOL_CALL_SYM = 27,                  /* CALL_SYM  */
  YYSYMBOL_CASCADE = 28,                   /* CASCADE  */
  YYSYMBOL_CASE_SYM = 29,                  /* CASE_SYM  */
  YYSYMBOL_CAST_SYM = 30,                  /* CAST_SYM  */
  YYSYMBOL_CHANGE = 31,                    /* CHANGE  */
  YYSYMBOL_CHAR_SYM = 32,                  /* CHAR_SYM  */
  YYSYMBOL_CHECK_SYM = 33,                 /* CHECK_SYM  */
  YYSYMBOL_COLLATE_SYM = 34,               /* COLLATE_SYM  */
  YYSYMBOL_CONDITION_SYM = 35,             /* CONDITION_SYM  */
  YYSYMBOL_CONSTRAINT = 36,                /* CONSTRAINT  */
  YYSYMBOL_CONTINUE_MARIADB_SYM = 37,      /* CONTINUE_MARIADB_SYM  */
  YYSYMBOL_CONTINUE_ORACLE_SYM = 38,       /* CONTINUE_ORACLE_SYM  */
  YYSYMBOL_CONVERT_SYM = 39,               /* CONVERT_SYM  */
  YYSYMBOL_COUNT_SYM = 40,                 /* COUNT_SYM  */
  YYSYMBOL_CREATE = 41,                    /* CREATE  */
  YYSYMBOL_CROSS = 42,                     /* CROSS  */
  YYSYMBOL_CUME_DIST_SYM = 43,             /* CUME_DIST_SYM  */
  YYSYMBOL_CURDATE = 44,                   /* CURDATE  */
  YYSYMBOL_CURRENT_USER = 45,              /* CURRENT_USER  */
  YYSYMBOL_CURRENT_ROLE = 46,              /* CURRENT_ROLE  */
  YYSYMBOL_CURSOR_SYM = 47,                /* CURSOR_SYM  */
  YYSYMBOL_CURTIME = 48,                   /* CURTIME  */
  YYSYMBOL_DATABASE = 49,                  /* DATABASE  */
  YYSYMBOL_DATABASES = 50,                 /* DATABASES  */
  YYSYMBOL_DATE_ADD_INTERVAL = 51,         /* DATE_ADD_INTERVAL  */
  YYSYMBOL_DATE_SUB_INTERVAL = 52,         /* DATE_SUB_INTERVAL  */
  YYSYMBOL_DAY_HOUR_SYM = 53,              /* DAY_HOUR_SYM  */
  YYSYMBOL_DAY_MICROSECOND_SYM = 54,       /* DAY_MICROSECOND_SYM  */
  YYSYMBOL_DAY_MINUTE_SYM = 55,            /* DAY_MINUTE_SYM  */
  YYSYMBOL_DAY_SECOND_SYM = 56,            /* DAY_SECOND_SYM  */
  YYSYMBOL_DECIMAL_NUM = 57,               /* DECIMAL_NUM  */
  YYSYMBOL_DECIMAL_SYM = 58,               /* DECIMAL_SYM  */
  YYSYMBOL_DECLARE_MARIADB_SYM = 59,       /* DECLARE_MARIADB_SYM  */
  YYSYMBOL_DECLARE_ORACLE_SYM = 60,        /* DECLARE_ORACLE_SYM  */
  YYSYMBOL_DEFAULT = 61,                   /* DEFAULT  */
  YYSYMBOL_DELETE_DOMAIN_ID_SYM = 62,      /* DELETE_DOMAIN_ID_SYM  */
  YYSYMBOL_DELETE_SYM = 63,                /* DELETE_SYM  */
  YYSYMBOL_DENSE_RANK_SYM = 64,            /* DENSE_RANK_SYM  */
  YYSYMBOL_DESC = 65,                      /* DESC  */
  YYSYMBOL_DESCRIBE = 66,                  /* DESCRIBE  */
  YYSYMBOL_DETERMINISTIC_SYM = 67,         /* DETERMINISTIC_SYM  */
  YYSYMBOL_DISTINCT = 68,                  /* DISTINCT  */
  YYSYMBOL_DIV_SYM = 69,                   /* DIV_SYM  */
  YYSYMBOL_DOUBLE_SYM = 70,                /* DOUBLE_SYM  */
  YYSYMBOL_DO_DOMAIN_IDS_SYM = 71,         /* DO_DOMAIN_IDS_SYM  */
  YYSYMBOL_DOT_DOT_SYM = 72,               /* DOT_DOT_SYM  */
  YYSYMBOL_DROP = 73,                      /* DROP  */
  YYSYMBOL_DUAL_SYM = 74,                  /* DUAL_SYM  */
  YYSYMBOL_EACH_SYM = 75,                  /* EACH_SYM  */
  YYSYMBOL_ELSE = 76,                      /* ELSE  */
  YYSYMBOL_ELSEIF_MARIADB_SYM = 77,        /* ELSEIF_MARIADB_SYM  */
  YYSYMBOL_ELSIF_ORACLE_SYM = 78,          /* ELSIF_ORACLE_SYM  */
  YYSYMBOL_ENCLOSED = 79,                  /* ENCLOSED  */
  YYSYMBOL_END_OF_INPUT = 80,              /* END_OF_INPUT  */
  YYSYMBOL_EQUAL_SYM = 81,                 /* EQUAL_SYM  */
  YYSYMBOL_ESCAPED = 82,                   /* ESCAPED  */
  YYSYMBOL_EXCEPT_SYM = 83,                /* EXCEPT_SYM  */
  YYSYMBOL_EXISTS = 84,                    /* EXISTS  */
  YYSYMBOL_EXTRACT_SYM = 85,               /* EXTRACT_SYM  */
  YYSYMBOL_FALSE_SYM = 86,                 /* FALSE_SYM  */
  YYSYMBOL_FETCH_SYM = 87,                 /* FETCH_SYM  */
  YYSYMBOL_FIRST_VALUE_SYM = 88,           /* FIRST_VALUE_SYM  */
  YYSYMBOL_FLOAT_NUM = 89,                 /* FLOAT_NUM  */
  YYSYMBOL_FLOAT_SYM = 90,                 /* FLOAT_SYM  */
  YYSYMBOL_FORCE_LOOKAHEAD = 91,           /* FORCE_LOOKAHEAD  */
  YYSYMBOL_FOREIGN = 92,                   /* FOREIGN  */
  YYSYMBOL_FOR_SYM = 93,                   /* FOR_SYM  */
  YYSYMBOL_FOR_SYSTEM_TIME_SYM = 94,       /* FOR_SYSTEM_TIME_SYM  */
  YYSYMBOL_FROM = 95,                      /* FROM  */
  YYSYMBOL_FULLTEXT_SYM = 96,              /* FULLTEXT_SYM  */
  YYSYMBOL_GE = 97,                        /* GE  */
  YYSYMBOL_GOTO_ORACLE_SYM = 98,           /* GOTO_ORACLE_SYM  */
  YYSYMBOL_GRANT = 99,                     /* GRANT  */
  YYSYMBOL_GROUP_SYM = 100,                /* GROUP_SYM  */
  YYSYMBOL_GROUP_CONCAT_SYM = 101,         /* GROUP_CONCAT_SYM  */
  YYSYMBOL_LAG_SYM = 102,                  /* LAG_SYM  */
  YYSYMBOL_LEAD_SYM = 103,                 /* LEAD_SYM  */
  YYSYMBOL_HAVING = 104,                   /* HAVING  */
  YYSYMBOL_HEX_NUM = 105,                  /* HEX_NUM  */
  YYSYMBOL_HEX_STRING = 106,               /* HEX_STRING  */
  YYSYMBOL_HOUR_MICROSECOND_SYM = 107,     /* HOUR_MICROSECOND_SYM  */
  YYSYMBOL_HOUR_MINUTE_SYM = 108,          /* HOUR_MINUTE_SYM  */
  YYSYMBOL_HOUR_SECOND_SYM = 109,          /* HOUR_SECOND_SYM  */
  YYSYMBOL_IDENT = 110,                    /* IDENT  */
  YYSYMBOL_IDENT_QUOTED = 111,             /* IDENT_QUOTED  */
  YYSYMBOL_IF_SYM = 112,                   /* IF_SYM  */
  YYSYMBOL_IGNORE_DOMAIN_IDS_SYM = 113,    /* IGNORE_DOMAIN_IDS_SYM  */
  YYSYMBOL_IGNORE_SYM = 114,               /* IGNORE_SYM  */
  YYSYMBOL_INDEX_SYM = 115,                /* INDEX_SYM  */
  YYSYMBOL_INFILE = 116,                   /* INFILE  */
  YYSYMBOL_INNER_SYM = 117,                /* INNER_SYM  */
  YYSYMBOL_INOUT_SYM = 118,                /* INOUT_SYM  */
  YYSYMBOL_INSENSITIVE_SYM = 119,          /* INSENSITIVE_SYM  */
  YYSYMBOL_INSERT = 120,                   /* INSERT  */
  YYSYMBOL_INTERSECT_SYM = 121,            /* INTERSECT_SYM  */
  YYSYMBOL_INTERVAL_SYM = 122,             /* INTERVAL_SYM  */
  YYSYMBOL_INTO = 123,                     /* INTO  */
  YYSYMBOL_INT_SYM = 124,                  /* INT_SYM  */
  YYSYMBOL_IN_SYM = 125,                   /* IN_SYM  */
  YYSYMBOL_IS = 126,                       /* IS  */
  YYSYMBOL_ITERATE_SYM = 127,              /* ITERATE_SYM  */
  YYSYMBOL_JOIN_SYM = 128,                 /* JOIN_SYM  */
  YYSYMBOL_KEYS = 129,                     /* KEYS  */
  YYSYMBOL_KEY_SYM = 130,                  /* KEY_SYM  */
  YYSYMBOL_KILL_SYM = 131,                 /* KILL_SYM  */
  YYSYMBOL_LE = 132,                       /* LE  */
  YYSYMBOL_LEADING = 133,                  /* LEADING  */
  YYSYMBOL_LEAVE_SYM = 134,                /* LEAVE_SYM  */
  YYSYMBOL_LEFT = 135,                     /* LEFT  */
  YYSYMBOL_LEFT_PAREN_ALT = 136,           /* LEFT_PAREN_ALT  */
  YYSYMBOL_LEFT_PAREN_WITH = 137,          /* LEFT_PAREN_WITH  */
  YYSYMBOL_LEFT_PAREN_LIKE = 138,          /* LEFT_PAREN_LIKE  */
  YYSYMBOL_LEX_HOSTNAME = 139,             /* LEX_HOSTNAME  */
  YYSYMBOL_LIKE = 140,                     /* LIKE  */
  YYSYMBOL_LIMIT = 141,                    /* LIMIT  */
  YYSYMBOL_LINEAR_SYM = 142,               /* LINEAR_SYM  */
  YYSYMBOL_LINES = 143,                    /* LINES  */
  YYSYMBOL_LOAD = 144,                     /* LOAD  */
  YYSYMBOL_LOCATOR_SYM = 145,              /* LOCATOR_SYM  */
  YYSYMBOL_LOCK_SYM = 146,                 /* LOCK_SYM  */
  YYSYMBOL_LONGBLOB = 147,                 /* LONGBLOB  */
  YYSYMBOL_LONGTEXT = 148,                 /* LONGTEXT  */
  YYSYMBOL_LONG_NUM = 149,                 /* LONG_NUM  */
  YYSYMBOL_LONG_SYM = 150,                 /* LONG_SYM  */
  YYSYMBOL_LOOP_SYM = 151,                 /* LOOP_SYM  */
  YYSYMBOL_LOW_PRIORITY = 152,             /* LOW_PRIORITY  */
  YYSYMBOL_MASTER_SSL_VERIFY_SERVER_CERT_SYM = 153, /* MASTER_SSL_VERIFY_SERVER_CERT_SYM  */
  YYSYMBOL_MATCH = 154,                    /* MATCH  */
  YYSYMBOL_MAX_SYM = 155,                  /* MAX_SYM  */
  YYSYMBOL_MAXVALUE_SYM = 156,             /* MAXVALUE_SYM  */
  YYSYMBOL_MEDIAN_SYM = 157,               /* MEDIAN_SYM  */
  YYSYMBOL_MEDIUMBLOB = 158,               /* MEDIUMBLOB  */
  YYSYMBOL_MEDIUMINT = 159,                /* MEDIUMINT  */
  YYSYMBOL_MEDIUMTEXT = 160,               /* MEDIUMTEXT  */
  YYSYMBOL_MINUTE_MICROSECOND_SYM = 161,   /* MINUTE_MICROSECOND_SYM  */
  YYSYMBOL_MINUTE_SECOND_SYM = 162,        /* MINUTE_SECOND_SYM  */
  YYSYMBOL_MIN_SYM = 163,                  /* MIN_SYM  */
  YYSYMBOL_MODIFIES_SYM = 164,             /* MODIFIES_SYM  */
  YYSYMBOL_MOD_SYM = 165,                  /* MOD_SYM  */
  YYSYMBOL_MYSQL_CONCAT_SYM = 166,         /* MYSQL_CONCAT_SYM  */
  YYSYMBOL_NATURAL = 167,                  /* NATURAL  */
  YYSYMBOL_NCHAR_STRING = 168,             /* NCHAR_STRING  */
  YYSYMBOL_NE = 169,                       /* NE  */
  YYSYMBOL_NEG = 170,                      /* NEG  */
  YYSYMBOL_NOT2_SYM = 171,                 /* NOT2_SYM  */
  YYSYMBOL_NOT_SYM = 172,                  /* NOT_SYM  */
  YYSYMBOL_NOW_SYM = 173,                  /* NOW_SYM  */
  YYSYMBOL_NO_WRITE_TO_BINLOG = 174,       /* NO_WRITE_TO_BINLOG  */
  YYSYMBOL_NTILE_SYM = 175,                /* NTILE_SYM  */
  YYSYMBOL_NULL_SYM = 176,                 /* NULL_SYM  */
  YYSYMBOL_NUM = 177,                      /* NUM  */
  YYSYMBOL_NUMERIC_SYM = 178,              /* NUMERIC_SYM  */
  YYSYMBOL_NTH_VALUE_SYM = 179,            /* NTH_VALUE_SYM  */
  YYSYMBOL_ON = 180,                       /* ON  */
  YYSYMBOL_OPTIMIZE = 181,                 /* OPTIMIZE  */
  YYSYMBOL_OPTIONALLY = 182,               /* OPTIONALLY  */
  YYSYMBOL_ORACLE_CONCAT_SYM = 183,        /* ORACLE_CONCAT_SYM  */
  YYSYMBOL_OR2_SYM = 184,                  /* OR2_SYM  */
  YYSYMBOL_ORDER_SYM = 185,                /* ORDER_SYM  */
  YYSYMBOL_OR_SYM = 186,                   /* OR_SYM  */
  YYSYMBOL_OTHERS_ORACLE_SYM = 187,        /* OTHERS_ORACLE_SYM  */
  YYSYMBOL_OUTER = 188,                    /* OUTER  */
  YYSYMBOL_OUTFILE = 189,                  /* OUTFILE  */
  YYSYMBOL_OUT_SYM = 190,                  /* OUT_SYM  */
  YYSYMBOL_OVER_SYM = 191,                 /* OVER_SYM  */
  YYSYMBOL_PACKAGE_ORACLE_SYM = 192,       /* PACKAGE_ORACLE_SYM  */
  YYSYMBOL_PAGE_CHECKSUM_SYM = 193,        /* PAGE_CHECKSUM_SYM  */
  YYSYMBOL_PARAM_MARKER = 194,             /* PARAM_MARKER  */
  YYSYMBOL_PARSE_VCOL_EXPR_SYM = 195,      /* PARSE_VCOL_EXPR_SYM  */
  YYSYMBOL_PARTITION_SYM = 196,            /* PARTITION_SYM  */
  YYSYMBOL_PERCENT_ORACLE_SYM = 197,       /* PERCENT_ORACLE_SYM  */
  YYSYMBOL_PERCENT_RANK_SYM = 198,         /* PERCENT_RANK_SYM  */
  YYSYMBOL_PERCENTILE_CONT_SYM = 199,      /* PERCENTILE_CONT_SYM  */
  YYSYMBOL_PERCENTILE_DISC_SYM = 200,      /* PERCENTILE_DISC_SYM  */
  YYSYMBOL_PORTION_SYM = 201,              /* PORTION_SYM  */
  YYSYMBOL_POSITION_SYM = 202,             /* POSITION_SYM  */
  YYSYMBOL_PRECISION = 203,                /* PRECISION  */
  YYSYMBOL_PRIMARY_SYM = 204,              /* PRIMARY_SYM  */
  YYSYMBOL_PROCEDURE_SYM = 205,            /* PROCEDURE_SYM  */
  YYSYMBOL_PURGE = 206,                    /* PURGE  */
  YYSYMBOL_RAISE_ORACLE_SYM = 207,         /* RAISE_ORACLE_SYM  */
  YYSYMBOL_RANGE_SYM = 208,                /* RANGE_SYM  */
  YYSYMBOL_RANK_SYM = 209,                 /* RANK_SYM  */
  YYSYMBOL_READS_SYM = 210,                /* READS_SYM  */
  YYSYMBOL_READ_SYM = 211,                 /* READ_SYM  */
  YYSYMBOL_READ_WRITE_SYM = 212,           /* READ_WRITE_SYM  */
  YYSYMBOL_REAL = 213,                     /* REAL  */
  YYSYMBOL_RECURSIVE_SYM = 214,            /* RECURSIVE_SYM  */
  YYSYMBOL_REF_SYSTEM_ID_SYM = 215,        /* REF_SYSTEM_ID_SYM  */
  YYSYMBOL_REFERENCES = 216,               /* REFERENCES  */
  YYSYMBOL_REGEXP = 217,                   /* REGEXP  */
  YYSYMBOL_RELEASE_SYM = 218,              /* RELEASE_SYM  */
  YYSYMBOL_RENAME = 219,                   /* RENAME  */
  YYSYMBOL_REPEAT_SYM = 220,               /* REPEAT_SYM  */
  YYSYMBOL_REQUIRE_SYM = 221,              /* REQUIRE_SYM  */
  YYSYMBOL_RESIGNAL_SYM = 222,             /* RESIGNAL_SYM  */
  YYSYMBOL_RESTRICT = 223,                 /* RESTRICT  */
  YYSYMBOL_RETURNING_SYM = 224,            /* RETURNING_SYM  */
  YYSYMBOL_RETURN_MARIADB_SYM = 225,       /* RETURN_MARIADB_SYM  */
  YYSYMBOL_RETURN_ORACLE_SYM = 226,        /* RETURN_ORACLE_SYM  */
  YYSYMBOL_REVOKE = 227,                   /* REVOKE  */
  YYSYMBOL_RIGHT = 228,                    /* RIGHT  */
  YYSYMBOL_ROWS_SYM = 229,                 /* ROWS_SYM  */
  YYSYMBOL_ROWTYPE_ORACLE_SYM = 230,       /* ROWTYPE_ORACLE_SYM  */
  YYSYMBOL_ROW_NUMBER_SYM = 231,           /* ROW_NUMBER_SYM  */
  YYSYMBOL_SECOND_MICROSECOND_SYM = 232,   /* SECOND_MICROSECOND_SYM  */
  YYSYMBOL_SELECT_SYM = 233,               /* SELECT_SYM  */
  YYSYMBOL_SENSITIVE_SYM = 234,            /* SENSITIVE_SYM  */
  YYSYMBOL_SEPARATOR_SYM = 235,            /* SEPARATOR_SYM  */
  YYSYMBOL_SERVER_OPTIONS = 236,           /* SERVER_OPTIONS  */
  YYSYMBOL_SET = 237,                      /* SET  */
  YYSYMBOL_SET_VAR = 238,                  /* SET_VAR  */
  YYSYMBOL_SHIFT_LEFT = 239,               /* SHIFT_LEFT  */
  YYSYMBOL_SHIFT_RIGHT = 240,              /* SHIFT_RIGHT  */
  YYSYMBOL_SHOW = 241,                     /* SHOW  */
  YYSYMBOL_SIGNAL_SYM = 242,               /* SIGNAL_SYM  */
  YYSYMBOL_SMALLINT = 243,                 /* SMALLINT  */
  YYSYMBOL_SPATIAL_SYM = 244,              /* SPATIAL_SYM  */
  YYSYMBOL_SPECIFIC_SYM = 245,             /* SPECIFIC_SYM  */
  YYSYMBOL_SQLEXCEPTION_SYM = 246,         /* SQLEXCEPTION_SYM  */
  YYSYMBOL_SQLSTATE_SYM = 247,             /* SQLSTATE_SYM  */
  YYSYMBOL_SQLWARNING_SYM = 248,           /* SQLWARNING_SYM  */
  YYSYMBOL_SQL_BIG_RESULT = 249,           /* SQL_BIG_RESULT  */
  YYSYMBOL_SQL_SMALL_RESULT = 250,         /* SQL_SMALL_RESULT  */
  YYSYMBOL_SQL_SYM = 251,                  /* SQL_SYM  */
  YYSYMBOL_SSL_SYM = 252,                  /* SSL_SYM  */
  YYSYMBOL_STARTING = 253,                 /* STARTING  */
  YYSYMBOL_STATS_AUTO_RECALC_SYM = 254,    /* STATS_AUTO_RECALC_SYM  */
  YYSYMBOL_STATS_PERSISTENT_SYM = 255,     /* STATS_PERSISTENT_SYM  */
  YYSYMBOL_STATS_SAMPLE_PAGES_SYM = 256,   /* STATS_SAMPLE_PAGES_SYM  */
  YYSYMBOL_STDDEV_SAMP_SYM = 257,          /* STDDEV_SAMP_SYM  */
  YYSYMBOL_STD_SYM = 258,                  /* STD_SYM  */
  YYSYMBOL_STRAIGHT_JOIN = 259,            /* STRAIGHT_JOIN  */
  YYSYMBOL_SUM_SYM = 260,                  /* SUM_SYM  */
  YYSYMBOL_SYSDATE = 261,                  /* SYSDATE  */
  YYSYMBOL_TABLE_REF_PRIORITY = 262,       /* TABLE_REF_PRIORITY  */
  YYSYMBOL_TABLE_SYM = 263,                /* TABLE_SYM  */
  YYSYMBOL_TERMINATED = 264,               /* TERMINATED  */
  YYSYMBOL_TEXT_STRING = 265,              /* TEXT_STRING  */
  YYSYMBOL_THEN_SYM = 266,                 /* THEN_SYM  */
  YYSYMBOL_TINYBLOB = 267,                 /* TINYBLOB  */
  YYSYMBOL_TINYINT = 268,                  /* TINYINT  */
  YYSYMBOL_TINYTEXT = 269,                 /* TINYTEXT  */
  YYSYMBOL_TO_SYM = 270,                   /* TO_SYM  */
  YYSYMBOL_TRAILING = 271,                 /* TRAILING  */
  YYSYMBOL_TRIGGER_SYM = 272,              /* TRIGGER_SYM  */
  YYSYMBOL_TRUE_SYM = 273,                 /* TRUE_SYM  */
  YYSYMBOL_ULONGLONG_NUM = 274,            /* ULONGLONG_NUM  */
  YYSYMBOL_UNDERSCORE_CHARSET = 275,       /* UNDERSCORE_CHARSET  */
  YYSYMBOL_UNDO_SYM = 276,                 /* UNDO_SYM  */
  YYSYMBOL_UNION_SYM = 277,                /* UNION_SYM  */
  YYSYMBOL_UNIQUE_SYM = 278,               /* UNIQUE_SYM  */
  YYSYMBOL_UNLOCK_SYM = 279,               /* UNLOCK_SYM  */
  YYSYMBOL_UNSIGNED = 280,                 /* UNSIGNED  */
  YYSYMBOL_UPDATE_SYM = 281,               /* UPDATE_SYM  */
  YYSYMBOL_USAGE = 282,                    /* USAGE  */
  YYSYMBOL_USE_SYM = 283,                  /* USE_SYM  */
  YYSYMBOL_USING = 284,                    /* USING  */
  YYSYMBOL_UTC_DATE_SYM = 285,             /* UTC_DATE_SYM  */
  YYSYMBOL_UTC_TIMESTAMP_SYM = 286,        /* UTC_TIMESTAMP_SYM  */
  YYSYMBOL_UTC_TIME_SYM = 287,             /* UTC_TIME_SYM  */
  YYSYMBOL_VALUES = 288,                   /* VALUES  */
  YYSYMBOL_VALUES_IN_SYM = 289,            /* VALUES_IN_SYM  */
  YYSYMBOL_VALUES_LESS_SYM = 290,          /* VALUES_LESS_SYM  */
  YYSYMBOL_VARBINARY = 291,                /* VARBINARY  */
  YYSYMBOL_VARCHAR = 292,                  /* VARCHAR  */
  YYSYMBOL_VARIANCE_SYM = 293,             /* VARIANCE_SYM  */
  YYSYMBOL_VARYING = 294,                  /* VARYING  */
  YYSYMBOL_VAR_SAMP_SYM = 295,             /* VAR_SAMP_SYM  */
  YYSYMBOL_WHEN_SYM = 296,                 /* WHEN_SYM  */
  YYSYMBOL_WHERE = 297,                    /* WHERE  */
  YYSYMBOL_WHILE_SYM = 298,                /* WHILE_SYM  */
  YYSYMBOL_WITH = 299,                     /* WITH  */
  YYSYMBOL_WITH_CUBE_SYM = 300,            /* WITH_CUBE_SYM  */
  YYSYMBOL_WITH_ROLLUP_SYM = 301,          /* WITH_ROLLUP_SYM  */
  YYSYMBOL_WITH_SYSTEM_SYM = 302,          /* WITH_SYSTEM_SYM  */
  YYSYMBOL_XOR = 303,                      /* XOR  */
  YYSYMBOL_YEAR_MONTH_SYM = 304,           /* YEAR_MONTH_SYM  */
  YYSYMBOL_ZEROFILL = 305,                 /* ZEROFILL  */
  YYSYMBOL_IMPOSSIBLE_ACTION = 306,        /* IMPOSSIBLE_ACTION  */
  YYSYMBOL_BODY_MARIADB_SYM = 307,         /* BODY_MARIADB_SYM  */
  YYSYMBOL_ELSEIF_ORACLE_SYM = 308,        /* ELSEIF_ORACLE_SYM  */
  YYSYMBOL_ELSIF_MARIADB_SYM = 309,        /* ELSIF_MARIADB_SYM  */
  YYSYMBOL_EXCEPTION_ORACLE_SYM = 310,     /* EXCEPTION_ORACLE_SYM  */
  YYSYMBOL_GOTO_MARIADB_SYM = 311,         /* GOTO_MARIADB_SYM  */
  YYSYMBOL_OTHERS_MARIADB_SYM = 312,       /* OTHERS_MARIADB_SYM  */
  YYSYMBOL_PACKAGE_MARIADB_SYM = 313,      /* PACKAGE_MARIADB_SYM  */
  YYSYMBOL_RAISE_MARIADB_SYM = 314,        /* RAISE_MARIADB_SYM  */
  YYSYMBOL_ROWTYPE_MARIADB_SYM = 315,      /* ROWTYPE_MARIADB_SYM  */
  YYSYMBOL_REPLACE = 316,                  /* REPLACE  */
  YYSYMBOL_SUBSTRING = 317,                /* SUBSTRING  */
  YYSYMBOL_TRIM = 318,                     /* TRIM  */
  YYSYMBOL_ACCOUNT_SYM = 319,              /* ACCOUNT_SYM  */
  YYSYMBOL_ACTION = 320,                   /* ACTION  */
  YYSYMBOL_ADMIN_SYM = 321,                /* ADMIN_SYM  */
  YYSYMBOL_ADDDATE_SYM = 322,              /* ADDDATE_SYM  */
  YYSYMBOL_AFTER_SYM = 323,                /* AFTER_SYM  */
  YYSYMBOL_AGAINST = 324,                  /* AGAINST  */
  YYSYMBOL_AGGREGATE_SYM = 325,            /* AGGREGATE_SYM  */
  YYSYMBOL_ALGORITHM_SYM = 326,            /* ALGORITHM_SYM  */
  YYSYMBOL_ALWAYS_SYM = 327,               /* ALWAYS_SYM  */
  YYSYMBOL_ANY_SYM = 328,                  /* ANY_SYM  */
  YYSYMBOL_ASCII_SYM = 329,                /* ASCII_SYM  */
  YYSYMBOL_AT_SYM = 330,                   /* AT_SYM  */
  YYSYMBOL_ATOMIC_SYM = 331,               /* ATOMIC_SYM  */
  YYSYMBOL_AUTHORS_SYM = 332,              /* AUTHORS_SYM  */
  YYSYMBOL_AUTOEXTEND_SIZE_SYM = 333,      /* AUTOEXTEND_SIZE_SYM  */
  YYSYMBOL_AUTO_INC = 334,                 /* AUTO_INC  */
  YYSYMBOL_AUTO_SYM = 335,                 /* AUTO_SYM  */
  YYSYMBOL_AVG_ROW_LENGTH = 336,           /* AVG_ROW_LENGTH  */
  YYSYMBOL_AVG_SYM = 337,                  /* AVG_SYM  */
  YYSYMBOL_BACKUP_SYM = 338,               /* BACKUP_SYM  */
  YYSYMBOL_BEGIN_MARIADB_SYM = 339,        /* BEGIN_MARIADB_SYM  */
  YYSYMBOL_BEGIN_ORACLE_SYM = 340,         /* BEGIN_ORACLE_SYM  */
  YYSYMBOL_BINLOG_SYM = 341,               /* BINLOG_SYM  */
  YYSYMBOL_BIT_SYM = 342,                  /* BIT_SYM  */
  YYSYMBOL_BLOCK_SYM = 343,                /* BLOCK_SYM  */
  YYSYMBOL_BOOL_SYM = 344,                 /* BOOL_SYM  */
  YYSYMBOL_BOOLEAN_SYM = 345,              /* BOOLEAN_SYM  */
  YYSYMBOL_BTREE_SYM = 346,                /* BTREE_SYM  */
  YYSYMBOL_BYTE_SYM = 347,                 /* BYTE_SYM  */
  YYSYMBOL_CACHE_SYM = 348,                /* CACHE_SYM  */
  YYSYMBOL_CASCADED = 349,                 /* CASCADED  */
  YYSYMBOL_CATALOG_NAME_SYM = 350,         /* CATALOG_NAME_SYM  */
  YYSYMBOL_CHAIN_SYM = 351,                /* CHAIN_SYM  */
  YYSYMBOL_CHANGED = 352,                  /* CHANGED  */
  YYSYMBOL_CHARSET = 353,                  /* CHARSET  */
  YYSYMBOL_CHECKPOINT_SYM = 354,           /* CHECKPOINT_SYM  */
  YYSYMBOL_CHECKSUM_SYM = 355,             /* CHECKSUM_SYM  */
  YYSYMBOL_CIPHER_SYM = 356,               /* CIPHER_SYM  */
  YYSYMBOL_CLASS_ORIGIN_SYM = 357,         /* CLASS_ORIGIN_SYM  */
  YYSYMBOL_CLIENT_SYM = 358,               /* CLIENT_SYM  */
  YYSYMBOL_CLOB_MARIADB_SYM = 359,         /* CLOB_MARIADB_SYM  */
  YYSYMBOL_CLOB_ORACLE_SYM = 360,          /* CLOB_ORACLE_SYM  */
  YYSYMBOL_CLOSE_SYM = 361,                /* CLOSE_SYM  */
  YYSYMBOL_COALESCE = 362,                 /* COALESCE  */
  YYSYMBOL_CODE_SYM = 363,                 /* CODE_SYM  */
  YYSYMBOL_COLLATION_SYM = 364,            /* COLLATION_SYM  */
  YYSYMBOL_COLON_ORACLE_SYM = 365,         /* COLON_ORACLE_SYM  */
  YYSYMBOL_COLUMNS = 366,                  /* COLUMNS  */
  YYSYMBOL_COLUMN_ADD_SYM = 367,           /* COLUMN_ADD_SYM  */
  YYSYMBOL_COLUMN_CHECK_SYM = 368,         /* COLUMN_CHECK_SYM  */
  YYSYMBOL_COLUMN_CREATE_SYM = 369,        /* COLUMN_CREATE_SYM  */
  YYSYMBOL_COLUMN_DELETE_SYM = 370,        /* COLUMN_DELETE_SYM  */
  YYSYMBOL_COLUMN_GET_SYM = 371,           /* COLUMN_GET_SYM  */
  YYSYMBOL_COLUMN_SYM = 372,               /* COLUMN_SYM  */
  YYSYMBOL_COLUMN_NAME_SYM = 373,          /* COLUMN_NAME_SYM  */
  YYSYMBOL_COMMENT_SYM = 374,              /* COMMENT_SYM  */
  YYSYMBOL_COMMITTED_SYM = 375,            /* COMMITTED_SYM  */
  YYSYMBOL_COMMIT_SYM = 376,               /* COMMIT_SYM  */
  YYSYMBOL_COMPACT_SYM = 377,              /* COMPACT_SYM  */
  YYSYMBOL_COMPLETION_SYM = 378,           /* COMPLETION_SYM  */
  YYSYMBOL_COMPRESSED_SYM = 379,           /* COMPRESSED_SYM  */
  YYSYMBOL_CONCURRENT = 380,               /* CONCURRENT  */
  YYSYMBOL_CONNECTION_SYM = 381,           /* CONNECTION_SYM  */
  YYSYMBOL_CONSISTENT_SYM = 382,           /* CONSISTENT_SYM  */
  YYSYMBOL_CONSTRAINT_CATALOG_SYM = 383,   /* CONSTRAINT_CATALOG_SYM  */
  YYSYMBOL_CONSTRAINT_NAME_SYM = 384,      /* CONSTRAINT_NAME_SYM  */
  YYSYMBOL_CONSTRAINT_SCHEMA_SYM = 385,    /* CONSTRAINT_SCHEMA_SYM  */
  YYSYMBOL_CONTAINS_SYM = 386,             /* CONTAINS_SYM  */
  YYSYMBOL_CONTEXT_SYM = 387,              /* CONTEXT_SYM  */
  YYSYMBOL_CONTRIBUTORS_SYM = 388,         /* CONTRIBUTORS_SYM  */
  YYSYMBOL_CPU_SYM = 389,                  /* CPU_SYM  */
  YYSYMBOL_CUBE_SYM = 390,                 /* CUBE_SYM  */
  YYSYMBOL_CURRENT_SYM = 391,              /* CURRENT_SYM  */
  YYSYMBOL_CURRENT_POS_SYM = 392,          /* CURRENT_POS_SYM  */
  YYSYMBOL_CURSOR_NAME_SYM = 393,          /* CURSOR_NAME_SYM  */
  YYSYMBOL_CYCLE_SYM = 394,                /* CYCLE_SYM  */
  YYSYMBOL_DATAFILE_SYM = 395,             /* DATAFILE_SYM  */
  YYSYMBOL_DATA_SYM = 396,                 /* DATA_SYM  */
  YYSYMBOL_DATETIME = 397,                 /* DATETIME  */
  YYSYMBOL_DATE_FORMAT_SYM = 398,          /* DATE_FORMAT_SYM  */
  YYSYMBOL_DATE_SYM = 399,                 /* DATE_SYM  */
  YYSYMBOL_DAY_SYM = 400,                  /* DAY_SYM  */
  YYSYMBOL_DEALLOCATE_SYM = 401,           /* DEALLOCATE_SYM  */
  YYSYMBOL_DEFINER_SYM = 402,              /* DEFINER_SYM  */
  YYSYMBOL_DELAYED_SYM = 403,              /* DELAYED_SYM  */
  YYSYMBOL_DELAY_KEY_WRITE_SYM = 404,      /* DELAY_KEY_WRITE_SYM  */
  YYSYMBOL_DES_KEY_FILE = 405,             /* DES_KEY_FILE  */
  YYSYMBOL_DIAGNOSTICS_SYM = 406,          /* DIAGNOSTICS_SYM  */
  YYSYMBOL_DIRECTORY_SYM = 407,            /* DIRECTORY_SYM  */
  YYSYMBOL_DISABLE_SYM = 408,              /* DISABLE_SYM  */
  YYSYMBOL_DISCARD = 409,                  /* DISCARD  */
  YYSYMBOL_DISK_SYM = 410,                 /* DISK_SYM  */
  YYSYMBOL_DO_SYM = 411,                   /* DO_SYM  */
  YYSYMBOL_DUMPFILE = 412,                 /* DUMPFILE  */
  YYSYMBOL_DUPLICATE_SYM = 413,            /* DUPLICATE_SYM  */
  YYSYMBOL_DYNAMIC_SYM = 414,              /* DYNAMIC_SYM  */
  YYSYMBOL_ENABLE_SYM = 415,               /* ENABLE_SYM  */
  YYSYMBOL_END = 416,                      /* END  */
  YYSYMBOL_ENDS_SYM = 417,                 /* ENDS_SYM  */
  YYSYMBOL_ENGINES_SYM = 418,              /* ENGINES_SYM  */
  YYSYMBOL_ENGINE_SYM = 419,               /* ENGINE_SYM  */
  YYSYMBOL_ENUM = 420,                     /* ENUM  */
  YYSYMBOL_ERROR_SYM = 421,                /* ERROR_SYM  */
  YYSYMBOL_ERRORS = 422,                   /* ERRORS  */
  YYSYMBOL_ESCAPE_SYM = 423,               /* ESCAPE_SYM  */
  YYSYMBOL_EVENTS_SYM = 424,               /* EVENTS_SYM  */
  YYSYMBOL_EVENT_SYM = 425,                /* EVENT_SYM  */
  YYSYMBOL_EVERY_SYM = 426,                /* EVERY_SYM  */
  YYSYMBOL_EXCHANGE_SYM = 427,             /* EXCHANGE_SYM  */
  YYSYMBOL_EXAMINED_SYM = 428,             /* EXAMINED_SYM  */
  YYSYMBOL_EXCLUDE_SYM = 429,              /* EXCLUDE_SYM  */
  YYSYMBOL_EXECUTE_SYM = 430,              /* EXECUTE_SYM  */
  YYSYMBOL_EXCEPTION_MARIADB_SYM = 431,    /* EXCEPTION_MARIADB_SYM  */
  YYSYMBOL_EXIT_MARIADB_SYM = 432,         /* EXIT_MARIADB_SYM  */
  YYSYMBOL_EXIT_ORACLE_SYM = 433,          /* EXIT_ORACLE_SYM  */
  YYSYMBOL_EXPANSION_SYM = 434,            /* EXPANSION_SYM  */
  YYSYMBOL_EXPIRE_SYM = 435,               /* EXPIRE_SYM  */
  YYSYMBOL_EXPORT_SYM = 436,               /* EXPORT_SYM  */
  YYSYMBOL_EXTENDED_SYM = 437,             /* EXTENDED_SYM  */
  YYSYMBOL_EXTENT_SIZE_SYM = 438,          /* EXTENT_SIZE_SYM  */
  YYSYMBOL_FAST_SYM = 439,                 /* FAST_SYM  */
  YYSYMBOL_FAULTS_SYM = 440,               /* FAULTS_SYM  */
  YYSYMBOL_FILE_SYM = 441,                 /* FILE_SYM  */
  YYSYMBOL_FIRST_SYM = 442,                /* FIRST_SYM  */
  YYSYMBOL_FIXED_SYM = 443,                /* FIXED_SYM  */
  YYSYMBOL_FLUSH_SYM = 444,                /* FLUSH_SYM  */
  YYSYMBOL_FOLLOWS_SYM = 445,              /* FOLLOWS_SYM  */
  YYSYMBOL_FOLLOWING_SYM = 446,            /* FOLLOWING_SYM  */
  YYSYMBOL_FORCE_SYM = 447,                /* FORCE_SYM  */
  YYSYMBOL_FORMAT_SYM = 448,               /* FORMAT_SYM  */
  YYSYMBOL_FOUND_SYM = 449,                /* FOUND_SYM  */
  YYSYMBOL_FULL = 450,                     /* FULL  */
  YYSYMBOL_FUNCTION_SYM = 451,             /* FUNCTION_SYM  */
  YYSYMBOL_GENERAL = 452,                  /* GENERAL  */
  YYSYMBOL_GENERATED_SYM = 453,            /* GENERATED_SYM  */
  YYSYMBOL_GEOMETRYCOLLECTION = 454,       /* GEOMETRYCOLLECTION  */
  YYSYMBOL_GEOMETRY_SYM = 455,             /* GEOMETRY_SYM  */
  YYSYMBOL_GET_FORMAT = 456,               /* GET_FORMAT  */
  YYSYMBOL_GET_SYM = 457,                  /* GET_SYM  */
  YYSYMBOL_GLOBAL_SYM = 458,               /* GLOBAL_SYM  */
  YYSYMBOL_GRANTS = 459,                   /* GRANTS  */
  YYSYMBOL_HANDLER_SYM = 460,              /* HANDLER_SYM  */
  YYSYMBOL_HARD_SYM = 461,                 /* HARD_SYM  */
  YYSYMBOL_HASH_SYM = 462,                 /* HASH_SYM  */
  YYSYMBOL_HELP_SYM = 463,                 /* HELP_SYM  */
  YYSYMBOL_HIGH_PRIORITY = 464,            /* HIGH_PRIORITY  */
  YYSYMBOL_HISTORY_SYM = 465,              /* HISTORY_SYM  */
  YYSYMBOL_HOST_SYM = 466,                 /* HOST_SYM  */
  YYSYMBOL_HOSTS_SYM = 467,                /* HOSTS_SYM  */
  YYSYMBOL_HOUR_SYM = 468,                 /* HOUR_SYM  */
  YYSYMBOL_ID_SYM = 469,                   /* ID_SYM  */
  YYSYMBOL_IDENTIFIED_SYM = 470,           /* IDENTIFIED_SYM  */
  YYSYMBOL_IGNORE_SERVER_IDS_SYM = 471,    /* IGNORE_SERVER_IDS_SYM  */
  YYSYMBOL_IMMEDIATE_SYM = 472,            /* IMMEDIATE_SYM  */
  YYSYMBOL_IMPORT = 473,                   /* IMPORT  */
  YYSYMBOL_INCREMENT_SYM = 474,            /* INCREMENT_SYM  */
  YYSYMBOL_INDEXES = 475,                  /* INDEXES  */
  YYSYMBOL_INITIAL_SIZE_SYM = 476,         /* INITIAL_SIZE_SYM  */
  YYSYMBOL_INSERT_METHOD = 477,            /* INSERT_METHOD  */
  YYSYMBOL_INSTALL_SYM = 478,              /* INSTALL_SYM  */
  YYSYMBOL_INVOKER_SYM = 479,              /* INVOKER_SYM  */
  YYSYMBOL_IO_SYM = 480,                   /* IO_SYM  */
  YYSYMBOL_IPC_SYM = 481,                  /* IPC_SYM  */
  YYSYMBOL_ISOLATION = 482,                /* ISOLATION  */
  YYSYMBOL_ISOPEN_SYM = 483,               /* ISOPEN_SYM  */
  YYSYMBOL_ISSUER_SYM = 484,               /* ISSUER_SYM  */
  YYSYMBOL_INVISIBLE_SYM = 485,            /* INVISIBLE_SYM  */
  YYSYMBOL_JSON_SYM = 486,                 /* JSON_SYM  */
  YYSYMBOL_KEY_BLOCK_SIZE = 487,           /* KEY_BLOCK_SIZE  */
  YYSYMBOL_LANGUAGE_SYM = 488,             /* LANGUAGE_SYM  */
  YYSYMBOL_LAST_SYM = 489,                 /* LAST_SYM  */
  YYSYMBOL_LAST_VALUE = 490,               /* LAST_VALUE  */
  YYSYMBOL_LASTVAL_SYM = 491,              /* LASTVAL_SYM  */
  YYSYMBOL_LEAVES = 492,                   /* LEAVES  */
  YYSYMBOL_LESS_SYM = 493,                 /* LESS_SYM  */
  YYSYMBOL_LEVEL_SYM = 494,                /* LEVEL_SYM  */
  YYSYMBOL_LINESTRING = 495,               /* LINESTRING  */
  YYSYMBOL_LIST_SYM = 496,                 /* LIST_SYM  */
  YYSYMBOL_LOCAL_SYM = 497,                /* LOCAL_SYM  */
  YYSYMBOL_LOCKS_SYM = 498,                /* LOCKS_SYM  */
  YYSYMBOL_LOGFILE_SYM = 499,              /* LOGFILE_SYM  */
  YYSYMBOL_LOGS_SYM = 500,                 /* LOGS_SYM  */
  YYSYMBOL_MASTER_CONNECT_RETRY_SYM = 501, /* MASTER_CONNECT_RETRY_SYM  */
  YYSYMBOL_MASTER_DELAY_SYM = 502,         /* MASTER_DELAY_SYM  */
  YYSYMBOL_MASTER_GTID_POS_SYM = 503,      /* MASTER_GTID_POS_SYM  */
  YYSYMBOL_MASTER_HOST_SYM = 504,          /* MASTER_HOST_SYM  */
  YYSYMBOL_MASTER_LOG_FILE_SYM = 505,      /* MASTER_LOG_FILE_SYM  */
  YYSYMBOL_MASTER_LOG_POS_SYM = 506,       /* MASTER_LOG_POS_SYM  */
  YYSYMBOL_MASTER_PASSWORD_SYM = 507,      /* MASTER_PASSWORD_SYM  */
  YYSYMBOL_MASTER_PORT_SYM = 508,          /* MASTER_PORT_SYM  */
  YYSYMBOL_MASTER_SERVER_ID_SYM = 509,     /* MASTER_SERVER_ID_SYM  */
  YYSYMBOL_MASTER_SSL_CAPATH_SYM = 510,    /* MASTER_SSL_CAPATH_SYM  */
  YYSYMBOL_MASTER_SSL_CA_SYM = 511,        /* MASTER_SSL_CA_SYM  */
  YYSYMBOL_MASTER_SSL_CERT_SYM = 512,      /* MASTER_SSL_CERT_SYM  */
  YYSYMBOL_MASTER_SSL_CIPHER_SYM = 513,    /* MASTER_SSL_CIPHER_SYM  */
  YYSYMBOL_MASTER_SSL_CRL_SYM = 514,       /* MASTER_SSL_CRL_SYM  */
  YYSYMBOL_MASTER_SSL_CRLPATH_SYM = 515,   /* MASTER_SSL_CRLPATH_SYM  */
  YYSYMBOL_MASTER_SSL_KEY_SYM = 516,       /* MASTER_SSL_KEY_SYM  */
  YYSYMBOL_MASTER_SSL_SYM = 517,           /* MASTER_SSL_SYM  */
  YYSYMBOL_MASTER_SYM = 518,               /* MASTER_SYM  */
  YYSYMBOL_MASTER_USER_SYM = 519,          /* MASTER_USER_SYM  */
  YYSYMBOL_MASTER_USE_GTID_SYM = 520,      /* MASTER_USE_GTID_SYM  */
  YYSYMBOL_MASTER_HEARTBEAT_PERIOD_SYM = 521, /* MASTER_HEARTBEAT_PERIOD_SYM  */
  YYSYMBOL_MAX_CONNECTIONS_PER_HOUR = 522, /* MAX_CONNECTIONS_PER_HOUR  */
  YYSYMBOL_MAX_QUERIES_PER_HOUR = 523,     /* MAX_QUERIES_PER_HOUR  */
  YYSYMBOL_MAX_ROWS = 524,                 /* MAX_ROWS  */
  YYSYMBOL_MAX_SIZE_SYM = 525,             /* MAX_SIZE_SYM  */
  YYSYMBOL_MAX_UPDATES_PER_HOUR = 526,     /* MAX_UPDATES_PER_HOUR  */
  YYSYMBOL_MAX_STATEMENT_TIME_SYM = 527,   /* MAX_STATEMENT_TIME_SYM  */
  YYSYMBOL_MAX_USER_CONNECTIONS_SYM = 528, /* MAX_USER_CONNECTIONS_SYM  */
  YYSYMBOL_MEDIUM_SYM = 529,               /* MEDIUM_SYM  */
  YYSYMBOL_MEMORY_SYM = 530,               /* MEMORY_SYM  */
  YYSYMBOL_MERGE_SYM = 531,                /* MERGE_SYM  */
  YYSYMBOL_MESSAGE_TEXT_SYM = 532,         /* MESSAGE_TEXT_SYM  */
  YYSYMBOL_MICROSECOND_SYM = 533,          /* MICROSECOND_SYM  */
  YYSYMBOL_MIGRATE_SYM = 534,              /* MIGRATE_SYM  */
  YYSYMBOL_MINUTE_SYM = 535,               /* MINUTE_SYM  */
  YYSYMBOL_MINVALUE_SYM = 536,             /* MINVALUE_SYM  */
  YYSYMBOL_MIN_ROWS = 537,                 /* MIN_ROWS  */
  YYSYMBOL_MODE_SYM = 538,                 /* MODE_SYM  */
  YYSYMBOL_MODIFY_SYM = 539,               /* MODIFY_SYM  */
  YYSYMBOL_MONTH_SYM = 540,                /* MONTH_SYM  */
  YYSYMBOL_MULTILINESTRING = 541,          /* MULTILINESTRING  */
  YYSYMBOL_MULTIPOINT = 542,               /* MULTIPOINT  */
  YYSYMBOL_MULTIPOLYGON = 543,             /* MULTIPOLYGON  */
  YYSYMBOL_MUTEX_SYM = 544,                /* MUTEX_SYM  */
  YYSYMBOL_MYSQL_SYM = 545,                /* MYSQL_SYM  */
  YYSYMBOL_MYSQL_ERRNO_SYM = 546,          /* MYSQL_ERRNO_SYM  */
  YYSYMBOL_NAMES_SYM = 547,                /* NAMES_SYM  */
  YYSYMBOL_NAME_SYM = 548,                 /* NAME_SYM  */
  YYSYMBOL_NATIONAL_SYM = 549,             /* NATIONAL_SYM  */
  YYSYMBOL_NCHAR_SYM = 550,                /* NCHAR_SYM  */
  YYSYMBOL_NEVER_SYM = 551,                /* NEVER_SYM  */
  YYSYMBOL_NEW_SYM = 552,                  /* NEW_SYM  */
  YYSYMBOL_NEXT_SYM = 553,                 /* NEXT_SYM  */
  YYSYMBOL_NEXTVAL_SYM = 554,              /* NEXTVAL_SYM  */
  YYSYMBOL_NOCACHE_SYM = 555,              /* NOCACHE_SYM  */
  YYSYMBOL_NOCYCLE_SYM = 556,              /* NOCYCLE_SYM  */
  YYSYMBOL_NODEGROUP_SYM = 557,            /* NODEGROUP_SYM  */
  YYSYMBOL_NONE_SYM = 558,                 /* NONE_SYM  */
  YYSYMBOL_NOTFOUND_SYM = 559,             /* NOTFOUND_SYM  */
  YYSYMBOL_NO_SYM = 560,                   /* NO_SYM  */
  YYSYMBOL_NOMAXVALUE_SYM = 561,           /* NOMAXVALUE_SYM  */
  YYSYMBOL_NOMINVALUE_SYM = 562,           /* NOMINVALUE_SYM  */
  YYSYMBOL_NO_WAIT_SYM = 563,              /* NO_WAIT_SYM  */
  YYSYMBOL_NOWAIT_SYM = 564,               /* NOWAIT_SYM  */
  YYSYMBOL_NUMBER_MARIADB_SYM = 565,       /* NUMBER_MARIADB_SYM  */
  YYSYMBOL_NUMBER_ORACLE_SYM = 566,        /* NUMBER_ORACLE_SYM  */
  YYSYMBOL_NVARCHAR_SYM = 567,             /* NVARCHAR_SYM  */
  YYSYMBOL_OF_SYM = 568,                   /* OF_SYM  */
  YYSYMBOL_OFFSET_SYM = 569,               /* OFFSET_SYM  */
  YYSYMBOL_OLD_PASSWORD_SYM = 570,         /* OLD_PASSWORD_SYM  */
  YYSYMBOL_ONE_SYM = 571,                  /* ONE_SYM  */
  YYSYMBOL_ONLY_SYM = 572,                 /* ONLY_SYM  */
  YYSYMBOL_ONLINE_SYM = 573,               /* ONLINE_SYM  */
  YYSYMBOL_OPEN_SYM = 574,                 /* OPEN_SYM  */
  YYSYMBOL_OPTIONS_SYM = 575,              /* OPTIONS_SYM  */
  YYSYMBOL_OPTION = 576,                   /* OPTION  */
  YYSYMBOL_OWNER_SYM = 577,                /* OWNER_SYM  */
  YYSYMBOL_PACK_KEYS_SYM = 578,            /* PACK_KEYS_SYM  */
  YYSYMBOL_PAGE_SYM = 579,                 /* PAGE_SYM  */
  YYSYMBOL_PARSER_SYM = 580,               /* PARSER_SYM  */
  YYSYMBOL_PARTIAL = 581,                  /* PARTIAL  */
  YYSYMBOL_PARTITIONS_SYM = 582,           /* PARTITIONS_SYM  */
  YYSYMBOL_PARTITIONING_SYM = 583,         /* PARTITIONING_SYM  */
  YYSYMBOL_PASSWORD_SYM = 584,             /* PASSWORD_SYM  */
  YYSYMBOL_PERIOD_SYM = 585,               /* PERIOD_SYM  */
  YYSYMBOL_PERSISTENT_SYM = 586,           /* PERSISTENT_SYM  */
  YYSYMBOL_PHASE_SYM = 587,                /* PHASE_SYM  */
  YYSYMBOL_PLUGINS_SYM = 588,              /* PLUGINS_SYM  */
  YYSYMBOL_PLUGIN_SYM = 589,               /* PLUGIN_SYM  */
  YYSYMBOL_POINT_SYM = 590,                /* POINT_SYM  */
  YYSYMBOL_POLYGON = 591,                  /* POLYGON  */
  YYSYMBOL_PORT_SYM = 592,                 /* PORT_SYM  */
  YYSYMBOL_PRECEDES_SYM = 593,             /* PRECEDES_SYM  */
  YYSYMBOL_PRECEDING_SYM = 594,            /* PRECEDING_SYM  */
  YYSYMBOL_PREPARE_SYM = 595,              /* PREPARE_SYM  */
  YYSYMBOL_PRESERVE_SYM = 596,             /* PRESERVE_SYM  */
  YYSYMBOL_PREV_SYM = 597,                 /* PREV_SYM  */
  YYSYMBOL_PREVIOUS_SYM = 598,             /* PREVIOUS_SYM  */
  YYSYMBOL_PRIVILEGES = 599,               /* PRIVILEGES  */
  YYSYMBOL_PROCESS = 600,                  /* PROCESS  */
  YYSYMBOL_PROCESSLIST_SYM = 601,          /* PROCESSLIST_SYM  */
  YYSYMBOL_PROFILE_SYM = 602,              /* PROFILE_SYM  */
  YYSYMBOL_PROFILES_SYM = 603,             /* PROFILES_SYM  */
  YYSYMBOL_PROXY_SYM = 604,                /* PROXY_SYM  */
  YYSYMBOL_QUARTER_SYM = 605,              /* QUARTER_SYM  */
  YYSYMBOL_QUERY_SYM = 606,                /* QUERY_SYM  */
  YYSYMBOL_QUICK = 607,                    /* QUICK  */
  YYSYMBOL_RAW_MARIADB_SYM = 608,          /* RAW_MARIADB_SYM  */
  YYSYMBOL_RAW_ORACLE_SYM = 609,           /* RAW_ORACLE_SYM  */
  YYSYMBOL_READ_ONLY_SYM = 610,            /* READ_ONLY_SYM  */
  YYSYMBOL_REBUILD_SYM = 611,              /* REBUILD_SYM  */
  YYSYMBOL_RECOVER_SYM = 612,              /* RECOVER_SYM  */
  YYSYMBOL_REDOFILE_SYM = 613,             /* REDOFILE_SYM  */
  YYSYMBOL_REDO_BUFFER_SIZE_SYM = 614,     /* REDO_BUFFER_SIZE_SYM  */
  YYSYMBOL_REDUNDANT_SYM = 615,            /* REDUNDANT_SYM  */
  YYSYMBOL_RELAY = 616,                    /* RELAY  */
  YYSYMBOL_RELAYLOG_SYM = 617,             /* RELAYLOG_SYM  */
  YYSYMBOL_RELAY_LOG_FILE_SYM = 618,       /* RELAY_LOG_FILE_SYM  */
  YYSYMBOL_RELAY_LOG_POS_SYM = 619,        /* RELAY_LOG_POS_SYM  */
  YYSYMBOL_RELAY_THREAD = 620,             /* RELAY_THREAD  */
  YYSYMBOL_RELOAD = 621,                   /* RELOAD  */
  YYSYMBOL_REMOVE_SYM = 622,               /* REMOVE_SYM  */
  YYSYMBOL_REORGANIZE_SYM = 623,           /* REORGANIZE_SYM  */
  YYSYMBOL_REPAIR = 624,                   /* REPAIR  */
  YYSYMBOL_REPEATABLE_SYM = 625,           /* REPEATABLE_SYM  */
  YYSYMBOL_REPLICATION = 626,              /* REPLICATION  */
  YYSYMBOL_RESET_SYM = 627,                /* RESET_SYM  */
  YYSYMBOL_RESTART_SYM = 628,              /* RESTART_SYM  */
  YYSYMBOL_RESOURCES = 629,                /* RESOURCES  */
  YYSYMBOL_RESTORE_SYM = 630,              /* RESTORE_SYM  */
  YYSYMBOL_RESUME_SYM = 631,               /* RESUME_SYM  */
  YYSYMBOL_RETURNED_SQLSTATE_SYM = 632,    /* RETURNED_SQLSTATE_SYM  */
  YYSYMBOL_RETURNS_SYM = 633,              /* RETURNS_SYM  */
  YYSYMBOL_REUSE_SYM = 634,                /* REUSE_SYM  */
  YYSYMBOL_REVERSE_SYM = 635,              /* REVERSE_SYM  */
  YYSYMBOL_ROLE_SYM = 636,                 /* ROLE_SYM  */
  YYSYMBOL_ROLLBACK_SYM = 637,             /* ROLLBACK_SYM  */
  YYSYMBOL_ROLLUP_SYM = 638,               /* ROLLUP_SYM  */
  YYSYMBOL_ROUTINE_SYM = 639,              /* ROUTINE_SYM  */
  YYSYMBOL_ROWCOUNT_SYM = 640,             /* ROWCOUNT_SYM  */
  YYSYMBOL_ROW_SYM = 641,                  /* ROW_SYM  */
  YYSYMBOL_ROW_COUNT_SYM = 642,            /* ROW_COUNT_SYM  */
  YYSYMBOL_ROW_FORMAT_SYM = 643,           /* ROW_FORMAT_SYM  */
  YYSYMBOL_RTREE_SYM = 644,                /* RTREE_SYM  */
  YYSYMBOL_SAVEPOINT_SYM = 645,            /* SAVEPOINT_SYM  */
  YYSYMBOL_SCHEDULE_SYM = 646,             /* SCHEDULE_SYM  */
  YYSYMBOL_SCHEMA_NAME_SYM = 647,          /* SCHEMA_NAME_SYM  */
  YYSYMBOL_SECOND_SYM = 648,               /* SECOND_SYM  */
  YYSYMBOL_SECURITY_SYM = 649,             /* SECURITY_SYM  */
  YYSYMBOL_SEQUENCE_SYM = 650,             /* SEQUENCE_SYM  */
  YYSYMBOL_SERIALIZABLE_SYM = 651,         /* SERIALIZABLE_SYM  */
  YYSYMBOL_SERIAL_SYM = 652,               /* SERIAL_SYM  */
  YYSYMBOL_SESSION_SYM = 653,              /* SESSION_SYM  */
  YYSYMBOL_SERVER_SYM = 654,               /* SERVER_SYM  */
  YYSYMBOL_SETVAL_SYM = 655,               /* SETVAL_SYM  */
  YYSYMBOL_SHARE_SYM = 656,                /* SHARE_SYM  */
  YYSYMBOL_SHUTDOWN = 657,                 /* SHUTDOWN  */
  YYSYMBOL_SIGNED_SYM = 658,               /* SIGNED_SYM  */
  YYSYMBOL_SIMPLE_SYM = 659,               /* SIMPLE_SYM  */
  YYSYMBOL_SLAVE = 660,                    /* SLAVE  */
  YYSYMBOL_SLAVES = 661,                   /* SLAVES  */
  YYSYMBOL_SLAVE_POS_SYM = 662,            /* SLAVE_POS_SYM  */
  YYSYMBOL_SLOW = 663,                     /* SLOW  */
  YYSYMBOL_SNAPSHOT_SYM = 664,             /* SNAPSHOT_SYM  */
  YYSYMBOL_SOCKET_SYM = 665,               /* SOCKET_SYM  */
  YYSYMBOL_SOFT_SYM = 666,                 /* SOFT_SYM  */
  YYSYMBOL_SONAME_SYM = 667,               /* SONAME_SYM  */
  YYSYMBOL_SOUNDS_SYM = 668,               /* SOUNDS_SYM  */
  YYSYMBOL_SOURCE_SYM = 669,               /* SOURCE_SYM  */
  YYSYMBOL_SQL_BUFFER_RESULT = 670,        /* SQL_BUFFER_RESULT  */
  YYSYMBOL_SQL_CACHE_SYM = 671,            /* SQL_CACHE_SYM  */
  YYSYMBOL_SQL_CALC_FOUND_ROWS = 672,      /* SQL_CALC_FOUND_ROWS  */
  YYSYMBOL_SQL_NO_CACHE_SYM = 673,         /* SQL_NO_CACHE_SYM  */
  YYSYMBOL_SQL_THREAD = 674,               /* SQL_THREAD  */
  YYSYMBOL_STAGE_SYM = 675,                /* STAGE_SYM  */
  YYSYMBOL_STARTS_SYM = 676,               /* STARTS_SYM  */
  YYSYMBOL_START_SYM = 677,                /* START_SYM  */
  YYSYMBOL_STATEMENT_SYM = 678,            /* STATEMENT_SYM  */
  YYSYMBOL_STATUS_SYM = 679,               /* STATUS_SYM  */
  YYSYMBOL_STOP_SYM = 680,                 /* STOP_SYM  */
  YYSYMBOL_STORAGE_SYM = 681,              /* STORAGE_SYM  */
  YYSYMBOL_STORED_SYM = 682,               /* STORED_SYM  */
  YYSYMBOL_STRING_SYM = 683,               /* STRING_SYM  */
  YYSYMBOL_SUBCLASS_ORIGIN_SYM = 684,      /* SUBCLASS_ORIGIN_SYM  */
  YYSYMBOL_SUBDATE_SYM = 685,              /* SUBDATE_SYM  */
  YYSYMBOL_SUBJECT_SYM = 686,              /* SUBJECT_SYM  */
  YYSYMBOL_SUBPARTITIONS_SYM = 687,        /* SUBPARTITIONS_SYM  */
  YYSYMBOL_SUBPARTITION_SYM = 688,         /* SUBPARTITION_SYM  */
  YYSYMBOL_SUPER_SYM = 689,                /* SUPER_SYM  */
  YYSYMBOL_SUSPEND_SYM = 690,              /* SUSPEND_SYM  */
  YYSYMBOL_SWAPS_SYM = 691,                /* SWAPS_SYM  */
  YYSYMBOL_SWITCHES_SYM = 692,             /* SWITCHES_SYM  */
  YYSYMBOL_SYSTEM = 693,                   /* SYSTEM  */
  YYSYMBOL_SYSTEM_TIME_SYM = 694,          /* SYSTEM_TIME_SYM  */
  YYSYMBOL_TABLES = 695,                   /* TABLES  */
  YYSYMBOL_TABLESPACE = 696,               /* TABLESPACE  */
  YYSYMBOL_TABLE_CHECKSUM_SYM = 697,       /* TABLE_CHECKSUM_SYM  */
  YYSYMBOL_TABLE_NAME_SYM = 698,           /* TABLE_NAME_SYM  */
  YYSYMBOL_TEMPORARY = 699,                /* TEMPORARY  */
  YYSYMBOL_TEMPTABLE_SYM = 700,            /* TEMPTABLE_SYM  */
  YYSYMBOL_TEXT_SYM = 701,                 /* TEXT_SYM  */
  YYSYMBOL_THAN_SYM = 702,                 /* THAN_SYM  */
  YYSYMBOL_TIES_SYM = 703,                 /* TIES_SYM  */
  YYSYMBOL_TIMESTAMP = 704,                /* TIMESTAMP  */
  YYSYMBOL_TIMESTAMP_ADD = 705,            /* TIMESTAMP_ADD  */
  YYSYMBOL_TIMESTAMP_DIFF = 706,           /* TIMESTAMP_DIFF  */
  YYSYMBOL_TIME_SYM = 707,                 /* TIME_SYM  */
  YYSYMBOL_TRANSACTION_SYM = 708,          /* TRANSACTION_SYM  */
  YYSYMBOL_TRANSACTIONAL_SYM = 709,        /* TRANSACTIONAL_SYM  */
  YYSYMBOL_TRIGGERS_SYM = 710,             /* TRIGGERS_SYM  */
  YYSYMBOL_TRIM_ORACLE = 711,              /* TRIM_ORACLE  */
  YYSYMBOL_TRUNCATE_SYM = 712,             /* TRUNCATE_SYM  */
  YYSYMBOL_TYPES_SYM = 713,                /* TYPES_SYM  */
  YYSYMBOL_TYPE_SYM = 714,                 /* TYPE_SYM  */
  YYSYMBOL_UDF_RETURNS_SYM = 715,          /* UDF_RETURNS_SYM  */
  YYSYMBOL_UNBOUNDED_SYM = 716,            /* UNBOUNDED_SYM  */
  YYSYMBOL_UNCOMMITTED_SYM = 717,          /* UNCOMMITTED_SYM  */
  YYSYMBOL_UNDEFINED_SYM = 718,            /* UNDEFINED_SYM  */
  YYSYMBOL_UNDOFILE_SYM = 719,             /* UNDOFILE_SYM  */
  YYSYMBOL_UNDO_BUFFER_SIZE_SYM = 720,     /* UNDO_BUFFER_SIZE_SYM  */
  YYSYMBOL_UNICODE_SYM = 721,              /* UNICODE_SYM  */
  YYSYMBOL_UNINSTALL_SYM = 722,            /* UNINSTALL_SYM  */
  YYSYMBOL_UNKNOWN_SYM = 723,              /* UNKNOWN_SYM  */
  YYSYMBOL_UNTIL_SYM = 724,                /* UNTIL_SYM  */
  YYSYMBOL_UPGRADE_SYM = 725,              /* UPGRADE_SYM  */
  YYSYMBOL_USER_SYM = 726,                 /* USER_SYM  */
  YYSYMBOL_USE_FRM = 727,                  /* USE_FRM  */
  YYSYMBOL_VALUE_SYM = 728,                /* VALUE_SYM  */
  YYSYMBOL_VARCHAR2_MARIADB_SYM = 729,     /* VARCHAR2_MARIADB_SYM  */
  YYSYMBOL_VARCHAR2_ORACLE_SYM = 730,      /* VARCHAR2_ORACLE_SYM  */
  YYSYMBOL_VARIABLES = 731,                /* VARIABLES  */
  YYSYMBOL_VERSIONING_SYM = 732,           /* VERSIONING_SYM  */
  YYSYMBOL_VIA_SYM = 733,                  /* VIA_SYM  */
  YYSYMBOL_VIEW_SYM = 734,                 /* VIEW_SYM  */
  YYSYMBOL_VIRTUAL_SYM = 735,              /* VIRTUAL_SYM  */
  YYSYMBOL_WAIT_SYM = 736,                 /* WAIT_SYM  */
  YYSYMBOL_WARNINGS = 737,                 /* WARNINGS  */
  YYSYMBOL_WEEK_SYM = 738,                 /* WEEK_SYM  */
  YYSYMBOL_WEIGHT_STRING_SYM = 739,        /* WEIGHT_STRING_SYM  */
  YYSYMBOL_WINDOW_SYM = 740,               /* WINDOW_SYM  */
  YYSYMBOL_WITHIN = 741,                   /* WITHIN  */
  YYSYMBOL_WITHOUT = 742,                  /* WITHOUT  */
  YYSYMBOL_WORK_SYM = 743,                 /* WORK_SYM  */
  YYSYMBOL_WRAPPER_SYM = 744,              /* WRAPPER_SYM  */
  YYSYMBOL_WRITE_SYM = 745,                /* WRITE_SYM  */
  YYSYMBOL_X509_SYM = 746,                 /* X509_SYM  */
  YYSYMBOL_XA_SYM = 747,                   /* XA_SYM  */
  YYSYMBOL_XML_SYM = 748,                  /* XML_SYM  */
  YYSYMBOL_YEAR_SYM = 749,                 /* YEAR_SYM  */
  YYSYMBOL_CONDITIONLESS_JOIN = 750,       /* CONDITIONLESS_JOIN  */
  YYSYMBOL_ON_SYM = 751,                   /* ON_SYM  */
  YYSYMBOL_PREC_BELOW_NOT = 752,           /* PREC_BELOW_NOT  */
  YYSYMBOL_753_ = 753,                     /* '='  */
  YYSYMBOL_754_ = 754,                     /* '>'  */
  YYSYMBOL_755_ = 755,                     /* '<'  */
  YYSYMBOL_756_ = 756,                     /* '|'  */
  YYSYMBOL_757_ = 757,                     /* '&'  */
  YYSYMBOL_758_ = 758,                     /* '-'  */
  YYSYMBOL_759_ = 759,                     /* '+'  */
  YYSYMBOL_760_ = 760,                     /* '*'  */
  YYSYMBOL_761_ = 761,                     /* '/'  */
  YYSYMBOL_762_ = 762,                     /* '%'  */
  YYSYMBOL_763_ = 763,                     /* '^'  */
  YYSYMBOL_764_ = 764,                     /* '~'  */
  YYSYMBOL_SUBQUERY_AS_EXPR = 765,         /* SUBQUERY_AS_EXPR  */
  YYSYMBOL_PREC_BELOW_IDENTIFIER_OPT_SPECIAL_CASE = 766, /* PREC_BELOW_IDENTIFIER_OPT_SPECIAL_CASE  */
  YYSYMBOL_USER = 767,                     /* USER  */
  YYSYMBOL_PREC_BELOW_CONTRACTION_TOKEN2 = 768, /* PREC_BELOW_CONTRACTION_TOKEN2  */
  YYSYMBOL_769_ = 769,                     /* '('  */
  YYSYMBOL_770_ = 770,                     /* ')'  */
  YYSYMBOL_EMPTY_FROM_CLAUSE = 771,        /* EMPTY_FROM_CLAUSE  */
  YYSYMBOL_772_ = 772,                     /* ','  */
  YYSYMBOL_773_ = 773,                     /* '!'  */
  YYSYMBOL_774_ = 774,                     /* '{'  */
  YYSYMBOL_775_ = 775,                     /* '}'  */
  YYSYMBOL_776_ = 776,                     /* ';'  */
  YYSYMBOL_777_ = 777,                     /* '.'  */
  YYSYMBOL_778_ = 778,                     /* '@'  */
  YYSYMBOL_779_ = 779,                     /* ':'  */
  YYSYMBOL_YYACCEPT = 780,                 /* $accept  */
  YYSYMBOL_query = 781,                    /* query  */
  YYSYMBOL_782_1 = 782,                    /* $@1  */
  YYSYMBOL_opt_end_of_input = 783,         /* opt_end_of_input  */
  YYSYMBOL_verb_clause = 784,              /* verb_clause  */
  YYSYMBOL_statement = 785,                /* statement  */
  YYSYMBOL_deallocate = 786,               /* deallocate  */
  YYSYMBOL_deallocate_or_drop = 787,       /* deallocate_or_drop  */
  YYSYMBOL_prepare = 788,                  /* prepare  */
  YYSYMBOL_789_2 = 789,                    /* $@2  */
  YYSYMBOL_execute = 790,                  /* execute  */
  YYSYMBOL_791_3 = 791,                    /* $@3  */
  YYSYMBOL_792_4 = 792,                    /* $@4  */
  YYSYMBOL_execute_using = 793,            /* execute_using  */
  YYSYMBOL_794_5 = 794,                    /* $@5  */
  YYSYMBOL_execute_params = 795,           /* execute_params  */
  YYSYMBOL_help = 796,                     /* help  */
  YYSYMBOL_797_6 = 797,                    /* $@6  */
  YYSYMBOL_change = 798,                   /* change  */
  YYSYMBOL_799_7 = 799,                    /* $@7  */
  YYSYMBOL_master_defs = 800,              /* master_defs  */
  YYSYMBOL_master_def = 801,               /* master_def  */
  YYSYMBOL_ignore_server_id_list = 802,    /* ignore_server_id_list  */
  YYSYMBOL_ignore_server_id = 803,         /* ignore_server_id  */
  YYSYMBOL_do_domain_id_list = 804,        /* do_domain_id_list  */
  YYSYMBOL_do_domain_id = 805,             /* do_domain_id  */
  YYSYMBOL_ignore_domain_id_list = 806,    /* ignore_domain_id_list  */
  YYSYMBOL_ignore_domain_id = 807,         /* ignore_domain_id  */
  YYSYMBOL_master_file_def = 808,          /* master_file_def  */
  YYSYMBOL_optional_connection_name = 809, /* optional_connection_name  */
  YYSYMBOL_connection_name = 810,          /* connection_name  */
  YYSYMBOL_create = 811,                   /* create  */
  YYSYMBOL_812_8 = 812,                    /* $@8  */
  YYSYMBOL_813_9 = 813,                    /* $@9  */
  YYSYMBOL_814_10 = 814,                   /* $@10  */
  YYSYMBOL_815_11 = 815,                   /* $@11  */
  YYSYMBOL_816_12 = 816,                   /* $@12  */
  YYSYMBOL_817_13 = 817,                   /* $@13  */
  YYSYMBOL_818_14 = 818,                   /* $@14  */
  YYSYMBOL_819_15 = 819,                   /* $@15  */
  YYSYMBOL_820_16 = 820,                   /* $@16  */
  YYSYMBOL_821_17 = 821,                   /* $@17  */
  YYSYMBOL_822_18 = 822,                   /* $@18  */
  YYSYMBOL_823_19 = 823,                   /* $@19  */
  YYSYMBOL_824_20 = 824,                   /* $@20  */
  YYSYMBOL_825_21 = 825,                   /* $@21  */
  YYSYMBOL_826_22 = 826,                   /* $@22  */
  YYSYMBOL_827_23 = 827,                   /* $@23  */
  YYSYMBOL_828_24 = 828,                   /* $@24  */
  YYSYMBOL_829_25 = 829,                   /* $@25  */
  YYSYMBOL_opt_sequence = 830,             /* opt_sequence  */
  YYSYMBOL_sequence_defs = 831,            /* sequence_defs  */
  YYSYMBOL_sequence_def = 832,             /* sequence_def  */
  YYSYMBOL_force_lookahead = 833,          /* force_lookahead  */
  YYSYMBOL_server_def = 834,               /* server_def  */
  YYSYMBOL_835_26 = 835,                   /* $@26  */
  YYSYMBOL_server_options_list = 836,      /* server_options_list  */
  YYSYMBOL_server_option = 837,            /* server_option  */
  YYSYMBOL_event_tail = 838,               /* event_tail  */
  YYSYMBOL_839_27 = 839,                   /* $@27  */
  YYSYMBOL_ev_schedule_time = 840,         /* ev_schedule_time  */
  YYSYMBOL_841_28 = 841,                   /* $@28  */
  YYSYMBOL_opt_ev_status = 842,            /* opt_ev_status  */
  YYSYMBOL_ev_starts = 843,                /* ev_starts  */
  YYSYMBOL_ev_ends = 844,                  /* ev_ends  */
  YYSYMBOL_opt_ev_on_completion = 845,     /* opt_ev_on_completion  */
  YYSYMBOL_ev_on_completion = 846,         /* ev_on_completion  */
  YYSYMBOL_opt_ev_comment = 847,           /* opt_ev_comment  */
  YYSYMBOL_ev_sql_stmt = 848,              /* ev_sql_stmt  */
  YYSYMBOL_849_29 = 849,                   /* $@29  */
  YYSYMBOL_clear_privileges = 850,         /* clear_privileges  */
  YYSYMBOL_opt_aggregate = 851,            /* opt_aggregate  */
  YYSYMBOL_sp_name = 852,                  /* sp_name  */
  YYSYMBOL_sp_a_chistics = 853,            /* sp_a_chistics  */
  YYSYMBOL_sp_c_chistics = 854,            /* sp_c_chistics  */
  YYSYMBOL_sp_chistic = 855,               /* sp_chistic  */
  YYSYMBOL_sp_c_chistic = 856,             /* sp_c_chistic  */
  YYSYMBOL_sp_suid = 857,                  /* sp_suid  */
  YYSYMBOL_call = 858,                     /* call  */
  YYSYMBOL_859_30 = 859,                   /* $@30  */
  YYSYMBOL_860_31 = 860,                   /* $@31  */
  YYSYMBOL_861_32 = 861,                   /* $@32  */
  YYSYMBOL_opt_sp_cparam_list = 862,       /* opt_sp_cparam_list  */
  YYSYMBOL_opt_sp_cparams = 863,           /* opt_sp_cparams  */
  YYSYMBOL_sp_cparams = 864,               /* sp_cparams  */
  YYSYMBOL_sp_fdparam_list = 865,          /* sp_fdparam_list  */
  YYSYMBOL_866_33 = 866,                   /* $@33  */
  YYSYMBOL_sp_fdparams = 867,              /* sp_fdparams  */
  YYSYMBOL_sp_param_name = 868,            /* sp_param_name  */
  YYSYMBOL_sp_param_name_and_type = 869,   /* sp_param_name_and_type  */
  YYSYMBOL_sp_pdparam_list = 870,          /* sp_pdparam_list  */
  YYSYMBOL_sp_pdparams = 871,              /* sp_pdparams  */
  YYSYMBOL_sp_pdparam = 872,               /* sp_pdparam  */
  YYSYMBOL_sp_opt_inout = 873,             /* sp_opt_inout  */
  YYSYMBOL_sp_parenthesized_pdparam_list = 874, /* sp_parenthesized_pdparam_list  */
  YYSYMBOL_875_34 = 875,                   /* $@34  */
  YYSYMBOL_sp_proc_stmts = 876,            /* sp_proc_stmts  */
  YYSYMBOL_sp_proc_stmts1 = 877,           /* sp_proc_stmts1  */
  YYSYMBOL_sp_decls = 878,                 /* sp_decls  */
  YYSYMBOL_sp_decl = 879,                  /* sp_decl  */
  YYSYMBOL_optionally_qualified_column_ident = 880, /* optionally_qualified_column_ident  */
  YYSYMBOL_row_field_name = 881,           /* row_field_name  */
  YYSYMBOL_row_field_definition = 882,     /* row_field_definition  */
  YYSYMBOL_row_field_definition_list = 883, /* row_field_definition_list  */
  YYSYMBOL_row_type_body = 884,            /* row_type_body  */
  YYSYMBOL_sp_decl_idents_init_vars = 885, /* sp_decl_idents_init_vars  */
  YYSYMBOL_sp_decl_variable_list = 886,    /* sp_decl_variable_list  */
  YYSYMBOL_sp_decl_body = 887,             /* sp_decl_body  */
  YYSYMBOL_888_35 = 888,                   /* $@35  */
  YYSYMBOL_sp_decl_handler = 889,          /* sp_decl_handler  */
  YYSYMBOL_890_36 = 890,                   /* $@36  */
  YYSYMBOL_opt_parenthesized_cursor_formal_parameters = 891, /* opt_parenthesized_cursor_formal_parameters  */
  YYSYMBOL_sp_cursor_stmt_lex = 892,       /* sp_cursor_stmt_lex  */
  YYSYMBOL_sp_cursor_stmt = 893,           /* sp_cursor_stmt  */
  YYSYMBOL_894_37 = 894,                   /* $@37  */
  YYSYMBOL_sp_handler_type = 895,          /* sp_handler_type  */
  YYSYMBOL_sp_hcond_list = 896,            /* sp_hcond_list  */
  YYSYMBOL_sp_hcond_element = 897,         /* sp_hcond_element  */
  YYSYMBOL_sp_cond = 898,                  /* sp_cond  */
  YYSYMBOL_sqlstate = 899,                 /* sqlstate  */
  YYSYMBOL_opt_value = 900,                /* opt_value  */
  YYSYMBOL_sp_hcond = 901,                 /* sp_hcond  */
  YYSYMBOL_raise_stmt_oracle = 902,        /* raise_stmt_oracle  */
  YYSYMBOL_signal_stmt = 903,              /* signal_stmt  */
  YYSYMBOL_signal_value = 904,             /* signal_value  */
  YYSYMBOL_opt_signal_value = 905,         /* opt_signal_value  */
  YYSYMBOL_opt_set_signal_information = 906, /* opt_set_signal_information  */
  YYSYMBOL_signal_information_item_list = 907, /* signal_information_item_list  */
  YYSYMBOL_signal_allowed_expr = 908,      /* signal_allowed_expr  */
  YYSYMBOL_signal_condition_information_item_name = 909, /* signal_condition_information_item_name  */
  YYSYMBOL_resignal_stmt = 910,            /* resignal_stmt  */
  YYSYMBOL_get_diagnostics = 911,          /* get_diagnostics  */
  YYSYMBOL_which_area = 912,               /* which_area  */
  YYSYMBOL_diagnostics_information = 913,  /* diagnostics_information  */
  YYSYMBOL_statement_information = 914,    /* statement_information  */
  YYSYMBOL_statement_information_item = 915, /* statement_information_item  */
  YYSYMBOL_simple_target_specification = 916, /* simple_target_specification  */
  YYSYMBOL_statement_information_item_name = 917, /* statement_information_item_name  */
  YYSYMBOL_condition_number = 918,         /* condition_number  */
  YYSYMBOL_condition_information = 919,    /* condition_information  */
  YYSYMBOL_condition_information_item = 920, /* condition_information_item  */
  YYSYMBOL_condition_information_item_name = 921, /* condition_information_item_name  */
  YYSYMBOL_sp_decl_ident = 922,            /* sp_decl_ident  */
  YYSYMBOL_sp_decl_idents = 923,           /* sp_decl_idents  */
  YYSYMBOL_sp_opt_default = 924,           /* sp_opt_default  */
  YYSYMBOL_sp_proc_stmt_in_returns_clause = 925, /* sp_proc_stmt_in_returns_clause  */
  YYSYMBOL_sp_proc_stmt = 926,             /* sp_proc_stmt  */
  YYSYMBOL_sp_proc_stmt_compound_ok = 927, /* sp_proc_stmt_compound_ok  */
  YYSYMBOL_sp_proc_stmt_if = 928,          /* sp_proc_stmt_if  */
  YYSYMBOL_929_38 = 929,                   /* $@38  */
  YYSYMBOL_sp_proc_stmt_statement = 930,   /* sp_proc_stmt_statement  */
  YYSYMBOL_931_39 = 931,                   /* $@39  */
  YYSYMBOL_RETURN_ALLMODES_SYM = 932,      /* RETURN_ALLMODES_SYM  */
  YYSYMBOL_sp_proc_stmt_return = 933,      /* sp_proc_stmt_return  */
  YYSYMBOL_934_40 = 934,                   /* $@40  */
  YYSYMBOL_reset_lex_expr = 935,           /* reset_lex_expr  */
  YYSYMBOL_936_41 = 936,                   /* $@41  */
  YYSYMBOL_sp_proc_stmt_exit_oracle = 937, /* sp_proc_stmt_exit_oracle  */
  YYSYMBOL_sp_proc_stmt_continue_oracle = 938, /* sp_proc_stmt_continue_oracle  */
  YYSYMBOL_sp_proc_stmt_leave = 939,       /* sp_proc_stmt_leave  */
  YYSYMBOL_sp_proc_stmt_iterate = 940,     /* sp_proc_stmt_iterate  */
  YYSYMBOL_sp_proc_stmt_goto_oracle = 941, /* sp_proc_stmt_goto_oracle  */
  YYSYMBOL_assignment_source_lex = 942,    /* assignment_source_lex  */
  YYSYMBOL_assignment_source_expr = 943,   /* assignment_source_expr  */
  YYSYMBOL_944_42 = 944,                   /* $@42  */
  YYSYMBOL_for_loop_bound_expr = 945,      /* for_loop_bound_expr  */
  YYSYMBOL_946_43 = 946,                   /* $@43  */
  YYSYMBOL_cursor_actual_parameters = 947, /* cursor_actual_parameters  */
  YYSYMBOL_opt_parenthesized_cursor_actual_parameters = 948, /* opt_parenthesized_cursor_actual_parameters  */
  YYSYMBOL_sp_proc_stmt_open = 949,        /* sp_proc_stmt_open  */
  YYSYMBOL_sp_proc_stmt_fetch_head = 950,  /* sp_proc_stmt_fetch_head  */
  YYSYMBOL_sp_proc_stmt_fetch = 951,       /* sp_proc_stmt_fetch  */
  YYSYMBOL_sp_proc_stmt_close = 952,       /* sp_proc_stmt_close  */
  YYSYMBOL_sp_fetch_list = 953,            /* sp_fetch_list  */
  YYSYMBOL_sp_if = 954,                    /* sp_if  */
  YYSYMBOL_955_44 = 955,                   /* $@44  */
  YYSYMBOL_956_45 = 956,                   /* $@45  */
  YYSYMBOL_957_46 = 957,                   /* $@46  */
  YYSYMBOL_sp_elseifs = 958,               /* sp_elseifs  */
  YYSYMBOL_case_stmt_specification = 959,  /* case_stmt_specification  */
  YYSYMBOL_960_47 = 960,                   /* $@47  */
  YYSYMBOL_case_stmt_body = 961,           /* case_stmt_body  */
  YYSYMBOL_962_48 = 962,                   /* $@48  */
  YYSYMBOL_963_49 = 963,                   /* $@49  */
  YYSYMBOL_simple_when_clause_list = 964,  /* simple_when_clause_list  */
  YYSYMBOL_searched_when_clause_list = 965, /* searched_when_clause_list  */
  YYSYMBOL_simple_when_clause = 966,       /* simple_when_clause  */
  YYSYMBOL_967_50 = 967,                   /* $@50  */
  YYSYMBOL_968_51 = 968,                   /* $@51  */
  YYSYMBOL_searched_when_clause = 969,     /* searched_when_clause  */
  YYSYMBOL_970_52 = 970,                   /* $@52  */
  YYSYMBOL_971_53 = 971,                   /* $@53  */
  YYSYMBOL_else_clause_opt = 972,          /* else_clause_opt  */
  YYSYMBOL_sp_label = 973,                 /* sp_label  */
  YYSYMBOL_sp_opt_label = 974,             /* sp_opt_label  */
  YYSYMBOL_sp_block_label = 975,           /* sp_block_label  */
  YYSYMBOL_sp_labeled_block = 976,         /* sp_labeled_block  */
  YYSYMBOL_977_54 = 977,                   /* $@54  */
  YYSYMBOL_sp_unlabeled_block = 978,       /* sp_unlabeled_block  */
  YYSYMBOL_979_55 = 979,                   /* $@55  */
  YYSYMBOL_sp_unlabeled_block_not_atomic = 980, /* sp_unlabeled_block_not_atomic  */
  YYSYMBOL_981_56 = 981,                   /* $@56  */
  YYSYMBOL_opt_sp_for_loop_direction = 982, /* opt_sp_for_loop_direction  */
  YYSYMBOL_sp_for_loop_index_and_bounds = 983, /* sp_for_loop_index_and_bounds  */
  YYSYMBOL_984_57 = 984,                   /* $@57  */
  YYSYMBOL_sp_for_loop_bounds = 985,       /* sp_for_loop_bounds  */
  YYSYMBOL_loop_body = 986,                /* loop_body  */
  YYSYMBOL_while_body = 987,               /* while_body  */
  YYSYMBOL_988_58 = 988,                   /* $@58  */
  YYSYMBOL_repeat_body = 989,              /* repeat_body  */
  YYSYMBOL_990_59 = 990,                   /* $@59  */
  YYSYMBOL_pop_sp_loop_label = 991,        /* pop_sp_loop_label  */
  YYSYMBOL_sp_labeled_control = 992,       /* sp_labeled_control  */
  YYSYMBOL_993_60 = 993,                   /* $@60  */
  YYSYMBOL_994_61 = 994,                   /* $@61  */
  YYSYMBOL_995_62 = 995,                   /* $@62  */
  YYSYMBOL_996_63 = 996,                   /* $@63  */
  YYSYMBOL_997_64 = 997,                   /* $@64  */
  YYSYMBOL_998_65 = 998,                   /* $@65  */
  YYSYMBOL_sp_unlabeled_control = 999,     /* sp_unlabeled_control  */
  YYSYMBOL_1000_66 = 1000,                 /* $@66  */
  YYSYMBOL_1001_67 = 1001,                 /* $@67  */
  YYSYMBOL_1002_68 = 1002,                 /* $@68  */
  YYSYMBOL_1003_69 = 1003,                 /* $@69  */
  YYSYMBOL_1004_70 = 1004,                 /* $@70  */
  YYSYMBOL_trg_action_time = 1005,         /* trg_action_time  */
  YYSYMBOL_trg_event = 1006,               /* trg_event  */
  YYSYMBOL_change_tablespace_access = 1007, /* change_tablespace_access  */
  YYSYMBOL_change_tablespace_info = 1008,  /* change_tablespace_info  */
  YYSYMBOL_tablespace_info = 1009,         /* tablespace_info  */
  YYSYMBOL_opt_logfile_group_name = 1010,  /* opt_logfile_group_name  */
  YYSYMBOL_alter_tablespace_info = 1011,   /* alter_tablespace_info  */
  YYSYMBOL_logfile_group_info = 1012,      /* logfile_group_info  */
  YYSYMBOL_alter_logfile_group_info = 1013, /* alter_logfile_group_info  */
  YYSYMBOL_add_log_file = 1014,            /* add_log_file  */
  YYSYMBOL_change_ts_option_list = 1015,   /* change_ts_option_list  */
  YYSYMBOL_1016_71 = 1016,                 /* $@71  */
  YYSYMBOL_change_ts_options = 1017,       /* change_ts_options  */
  YYSYMBOL_change_ts_option = 1018,        /* change_ts_option  */
  YYSYMBOL_tablespace_option_list = 1019,  /* tablespace_option_list  */
  YYSYMBOL_tablespace_options = 1020,      /* tablespace_options  */
  YYSYMBOL_tablespace_option = 1021,       /* tablespace_option  */
  YYSYMBOL_alter_tablespace_option_list = 1022, /* alter_tablespace_option_list  */
  YYSYMBOL_alter_tablespace_options = 1023, /* alter_tablespace_options  */
  YYSYMBOL_alter_tablespace_option = 1024, /* alter_tablespace_option  */
  YYSYMBOL_logfile_group_option_list = 1025, /* logfile_group_option_list  */
  YYSYMBOL_logfile_group_options = 1026,   /* logfile_group_options  */
  YYSYMBOL_logfile_group_option = 1027,    /* logfile_group_option  */
  YYSYMBOL_alter_logfile_group_option_list = 1028, /* alter_logfile_group_option_list  */
  YYSYMBOL_alter_logfile_group_options = 1029, /* alter_logfile_group_options  */
  YYSYMBOL_alter_logfile_group_option = 1030, /* alter_logfile_group_option  */
  YYSYMBOL_ts_datafile = 1031,             /* ts_datafile  */
  YYSYMBOL_lg_undofile = 1032,             /* lg_undofile  */
  YYSYMBOL_lg_redofile = 1033,             /* lg_redofile  */
  YYSYMBOL_tablespace_name = 1034,         /* tablespace_name  */
  YYSYMBOL_logfile_group_name = 1035,      /* logfile_group_name  */
  YYSYMBOL_ts_access_mode = 1036,          /* ts_access_mode  */
  YYSYMBOL_opt_ts_initial_size = 1037,     /* opt_ts_initial_size  */
  YYSYMBOL_opt_ts_autoextend_size = 1038,  /* opt_ts_autoextend_size  */
  YYSYMBOL_opt_ts_max_size = 1039,         /* opt_ts_max_size  */
  YYSYMBOL_opt_ts_extent_size = 1040,      /* opt_ts_extent_size  */
  YYSYMBOL_opt_ts_undo_buffer_size = 1041, /* opt_ts_undo_buffer_size  */
  YYSYMBOL_opt_ts_redo_buffer_size = 1042, /* opt_ts_redo_buffer_size  */
  YYSYMBOL_opt_ts_nodegroup = 1043,        /* opt_ts_nodegroup  */
  YYSYMBOL_opt_ts_comment = 1044,          /* opt_ts_comment  */
  YYSYMBOL_opt_ts_engine = 1045,           /* opt_ts_engine  */
  YYSYMBOL_opt_ts_wait = 1046,             /* opt_ts_wait  */
  YYSYMBOL_ts_wait = 1047,                 /* ts_wait  */
  YYSYMBOL_size_number = 1048,             /* size_number  */
  YYSYMBOL_create_body = 1049,             /* create_body  */
  YYSYMBOL_1050_72 = 1050,                 /* $@72  */
  YYSYMBOL_create_like = 1051,             /* create_like  */
  YYSYMBOL_opt_create_select = 1052,       /* opt_create_select  */
  YYSYMBOL_create_select_query_expression = 1053, /* create_select_query_expression  */
  YYSYMBOL_opt_create_partitioning = 1054, /* opt_create_partitioning  */
  YYSYMBOL_opt_partitioning = 1055,        /* opt_partitioning  */
  YYSYMBOL_partitioning = 1056,            /* partitioning  */
  YYSYMBOL_1057_73 = 1057,                 /* $@73  */
  YYSYMBOL_have_partitioning = 1058,       /* have_partitioning  */
  YYSYMBOL_partition_entry = 1059,         /* partition_entry  */
  YYSYMBOL_1060_74 = 1060,                 /* $@74  */
  YYSYMBOL_partition = 1061,               /* partition  */
  YYSYMBOL_1062_75 = 1062,                 /* $@75  */
  YYSYMBOL_part_type_def = 1063,           /* part_type_def  */
  YYSYMBOL_1064_76 = 1064,                 /* $@76  */
  YYSYMBOL_1065_77 = 1065,                 /* $@77  */
  YYSYMBOL_1066_78 = 1066,                 /* $@78  */
  YYSYMBOL_opt_linear = 1067,              /* opt_linear  */
  YYSYMBOL_opt_key_algo = 1068,            /* opt_key_algo  */
  YYSYMBOL_part_field_list = 1069,         /* part_field_list  */
  YYSYMBOL_part_field_item_list = 1070,    /* part_field_item_list  */
  YYSYMBOL_part_field_item = 1071,         /* part_field_item  */
  YYSYMBOL_part_column_list = 1072,        /* part_column_list  */
  YYSYMBOL_part_func = 1073,               /* part_func  */
  YYSYMBOL_sub_part_func = 1074,           /* sub_part_func  */
  YYSYMBOL_opt_num_parts = 1075,           /* opt_num_parts  */
  YYSYMBOL_opt_sub_part = 1076,            /* opt_sub_part  */
  YYSYMBOL_1077_79 = 1077,                 /* $@79  */
  YYSYMBOL_1078_80 = 1078,                 /* $@80  */
  YYSYMBOL_sub_part_field_list = 1079,     /* sub_part_field_list  */
  YYSYMBOL_sub_part_field_item = 1080,     /* sub_part_field_item  */
  YYSYMBOL_part_func_expr = 1081,          /* part_func_expr  */
  YYSYMBOL_opt_num_subparts = 1082,        /* opt_num_subparts  */
  YYSYMBOL_part_defs = 1083,               /* part_defs  */
  YYSYMBOL_part_def_list = 1084,           /* part_def_list  */
  YYSYMBOL_part_definition = 1085,         /* part_definition  */
  YYSYMBOL_1086_81 = 1086,                 /* $@81  */
  YYSYMBOL_part_name = 1087,               /* part_name  */
  YYSYMBOL_opt_part_values = 1088,         /* opt_part_values  */
  YYSYMBOL_1089_82 = 1089,                 /* $@82  */
  YYSYMBOL_1090_83 = 1090,                 /* $@83  */
  YYSYMBOL_part_func_max = 1091,           /* part_func_max  */
  YYSYMBOL_part_values_in = 1092,          /* part_values_in  */
  YYSYMBOL_part_value_list = 1093,         /* part_value_list  */
  YYSYMBOL_part_value_item = 1094,         /* part_value_item  */
  YYSYMBOL_1095_84 = 1095,                 /* $@84  */
  YYSYMBOL_1096_85 = 1096,                 /* $@85  */
  YYSYMBOL_part_value_item_list = 1097,    /* part_value_item_list  */
  YYSYMBOL_part_value_expr_item = 1098,    /* part_value_expr_item  */
  YYSYMBOL_opt_sub_partition = 1099,       /* opt_sub_partition  */
  YYSYMBOL_sub_part_list = 1100,           /* sub_part_list  */
  YYSYMBOL_sub_part_definition = 1101,     /* sub_part_definition  */
  YYSYMBOL_1102_86 = 1102,                 /* $@86  */
  YYSYMBOL_sub_name = 1103,                /* sub_name  */
  YYSYMBOL_opt_part_options = 1104,        /* opt_part_options  */
  YYSYMBOL_opt_part_option_list = 1105,    /* opt_part_option_list  */
  YYSYMBOL_opt_part_option = 1106,         /* opt_part_option  */
  YYSYMBOL_opt_versioning_rotation = 1107, /* opt_versioning_rotation  */
  YYSYMBOL_1108_87 = 1108,                 /* $@87  */
  YYSYMBOL_opt_versioning_interval_start = 1109, /* opt_versioning_interval_start  */
  YYSYMBOL_opt_as = 1110,                  /* opt_as  */
  YYSYMBOL_opt_create_database_options = 1111, /* opt_create_database_options  */
  YYSYMBOL_create_database_options = 1112, /* create_database_options  */
  YYSYMBOL_create_database_option = 1113,  /* create_database_option  */
  YYSYMBOL_opt_if_not_exists_table_element = 1114, /* opt_if_not_exists_table_element  */
  YYSYMBOL_opt_if_not_exists = 1115,       /* opt_if_not_exists  */
  YYSYMBOL_create_or_replace = 1116,       /* create_or_replace  */
  YYSYMBOL_opt_create_table_options = 1117, /* opt_create_table_options  */
  YYSYMBOL_create_table_options_space_separated = 1118, /* create_table_options_space_separated  */
  YYSYMBOL_create_table_options = 1119,    /* create_table_options  */
  YYSYMBOL_create_table_option = 1120,     /* create_table_option  */
  YYSYMBOL_1121_88 = 1121,                 /* $@88  */
  YYSYMBOL_opt_versioning_option = 1122,   /* opt_versioning_option  */
  YYSYMBOL_versioning_option = 1123,       /* versioning_option  */
  YYSYMBOL_default_charset = 1124,         /* default_charset  */
  YYSYMBOL_default_collation = 1125,       /* default_collation  */
  YYSYMBOL_storage_engines = 1126,         /* storage_engines  */
  YYSYMBOL_known_storage_engines = 1127,   /* known_storage_engines  */
  YYSYMBOL_row_types = 1128,               /* row_types  */
  YYSYMBOL_merge_insert_types = 1129,      /* merge_insert_types  */
  YYSYMBOL_udf_type = 1130,                /* udf_type  */
  YYSYMBOL_create_field_list = 1131,       /* create_field_list  */
  YYSYMBOL_create_field_list_parens = 1132, /* create_field_list_parens  */
  YYSYMBOL_field_list = 1133,              /* field_list  */
  YYSYMBOL_field_list_item = 1134,         /* field_list_item  */
  YYSYMBOL_column_def = 1135,              /* column_def  */
  YYSYMBOL_key_def = 1136,                 /* key_def  */
  YYSYMBOL_1137_89 = 1137,                 /* $@89  */
  YYSYMBOL_1138_90 = 1138,                 /* $@90  */
  YYSYMBOL_1139_91 = 1139,                 /* $@91  */
  YYSYMBOL_1140_92 = 1140,                 /* $@92  */
  YYSYMBOL_1141_93 = 1141,                 /* $@93  */
  YYSYMBOL_1142_94 = 1142,                 /* $@94  */
  YYSYMBOL_1143_95 = 1143,                 /* $@95  */
  YYSYMBOL_constraint_def = 1144,          /* constraint_def  */
  YYSYMBOL_period_for_system_time = 1145,  /* period_for_system_time  */
  YYSYMBOL_period_for_application_time = 1146, /* period_for_application_time  */
  YYSYMBOL_opt_check_constraint = 1147,    /* opt_check_constraint  */
  YYSYMBOL_check_constraint = 1148,        /* check_constraint  */
  YYSYMBOL_opt_constraint_no_id = 1149,    /* opt_constraint_no_id  */
  YYSYMBOL_opt_constraint = 1150,          /* opt_constraint  */
  YYSYMBOL_constraint = 1151,              /* constraint  */
  YYSYMBOL_field_spec = 1152,              /* field_spec  */
  YYSYMBOL_1153_96 = 1153,                 /* @96  */
  YYSYMBOL_field_type_or_serial = 1154,    /* field_type_or_serial  */
  YYSYMBOL_1155_97 = 1155,                 /* $@97  */
  YYSYMBOL_1156_98 = 1156,                 /* $@98  */
  YYSYMBOL_opt_serial_attribute = 1157,    /* opt_serial_attribute  */
  YYSYMBOL_opt_serial_attribute_list = 1158, /* opt_serial_attribute_list  */
  YYSYMBOL_opt_asrow_attribute = 1159,     /* opt_asrow_attribute  */
  YYSYMBOL_opt_asrow_attribute_list = 1160, /* opt_asrow_attribute_list  */
  YYSYMBOL_field_def = 1161,               /* field_def  */
  YYSYMBOL_1162_99 = 1162,                 /* $@99  */
  YYSYMBOL_opt_generated_always = 1163,    /* opt_generated_always  */
  YYSYMBOL_vcol_opt_specifier = 1164,      /* vcol_opt_specifier  */
  YYSYMBOL_vcol_opt_attribute = 1165,      /* vcol_opt_attribute  */
  YYSYMBOL_vcol_opt_attribute_list = 1166, /* vcol_opt_attribute_list  */
  YYSYMBOL_vcol_attribute = 1167,          /* vcol_attribute  */
  YYSYMBOL_parse_vcol_expr = 1168,         /* parse_vcol_expr  */
  YYSYMBOL_1169_100 = 1169,                /* $@100  */
  YYSYMBOL_parenthesized_expr = 1170,      /* parenthesized_expr  */
  YYSYMBOL_virtual_column_func = 1171,     /* virtual_column_func  */
  YYSYMBOL_expr_or_literal = 1172,         /* expr_or_literal  */
  YYSYMBOL_column_default_expr = 1173,     /* column_default_expr  */
  YYSYMBOL_field_type = 1174,              /* field_type  */
  YYSYMBOL_qualified_field_type = 1175,    /* qualified_field_type  */
  YYSYMBOL_field_type_all = 1176,          /* field_type_all  */
  YYSYMBOL_field_type_numeric = 1177,      /* field_type_numeric  */
  YYSYMBOL_opt_binary_and_compression = 1178, /* opt_binary_and_compression  */
  YYSYMBOL_field_type_string = 1179,       /* field_type_string  */
  YYSYMBOL_field_type_temporal = 1180,     /* field_type_temporal  */
  YYSYMBOL_field_type_lob = 1181,          /* field_type_lob  */
  YYSYMBOL_field_type_misc = 1182,         /* field_type_misc  */
  YYSYMBOL_spatial_type = 1183,            /* spatial_type  */
  YYSYMBOL_char = 1184,                    /* char  */
  YYSYMBOL_nchar = 1185,                   /* nchar  */
  YYSYMBOL_varchar = 1186,                 /* varchar  */
  YYSYMBOL_nvarchar = 1187,                /* nvarchar  */
  YYSYMBOL_int_type = 1188,                /* int_type  */
  YYSYMBOL_real_type = 1189,               /* real_type  */
  YYSYMBOL_srid_option = 1190,             /* srid_option  */
  YYSYMBOL_float_options = 1191,           /* float_options  */
  YYSYMBOL_precision = 1192,               /* precision  */
  YYSYMBOL_field_options = 1193,           /* field_options  */
  YYSYMBOL_field_length = 1194,            /* field_length  */
  YYSYMBOL_opt_field_length = 1195,        /* opt_field_length  */
  YYSYMBOL_opt_field_length_default_1 = 1196, /* opt_field_length_default_1  */
  YYSYMBOL_opt_precision = 1197,           /* opt_precision  */
  YYSYMBOL_attribute_list = 1198,          /* attribute_list  */
  YYSYMBOL_attribute = 1199,               /* attribute  */
  YYSYMBOL_opt_compression_method = 1200,  /* opt_compression_method  */
  YYSYMBOL_opt_compressed = 1201,          /* opt_compressed  */
  YYSYMBOL_compressed = 1202,              /* compressed  */
  YYSYMBOL_compressed_deprecated_data_type_attribute = 1203, /* compressed_deprecated_data_type_attribute  */
  YYSYMBOL_compressed_deprecated_column_attribute = 1204, /* compressed_deprecated_column_attribute  */
  YYSYMBOL_asrow_attribute = 1205,         /* asrow_attribute  */
  YYSYMBOL_serial_attribute = 1206,        /* serial_attribute  */
  YYSYMBOL_with_or_without_system = 1207,  /* with_or_without_system  */
  YYSYMBOL_charset = 1208,                 /* charset  */
  YYSYMBOL_charset_name = 1209,            /* charset_name  */
  YYSYMBOL_charset_name_or_default = 1210, /* charset_name_or_default  */
  YYSYMBOL_opt_load_data_charset = 1211,   /* opt_load_data_charset  */
  YYSYMBOL_old_or_new_charset_name = 1212, /* old_or_new_charset_name  */
  YYSYMBOL_old_or_new_charset_name_or_default = 1213, /* old_or_new_charset_name_or_default  */
  YYSYMBOL_collation_name = 1214,          /* collation_name  */
  YYSYMBOL_opt_collate = 1215,             /* opt_collate  */
  YYSYMBOL_collation_name_or_default = 1216, /* collation_name_or_default  */
  YYSYMBOL_opt_default = 1217,             /* opt_default  */
  YYSYMBOL_charset_or_alias = 1218,        /* charset_or_alias  */
  YYSYMBOL_collate = 1219,                 /* collate  */
  YYSYMBOL_opt_binary = 1220,              /* opt_binary  */
  YYSYMBOL_binary = 1221,                  /* binary  */
  YYSYMBOL_opt_bin_mod = 1222,             /* opt_bin_mod  */
  YYSYMBOL_ws_nweights = 1223,             /* ws_nweights  */
  YYSYMBOL_1224_101 = 1224,                /* $@101  */
  YYSYMBOL_ws_level_flag_desc = 1225,      /* ws_level_flag_desc  */
  YYSYMBOL_ws_level_flag_reverse = 1226,   /* ws_level_flag_reverse  */
  YYSYMBOL_ws_level_flags = 1227,          /* ws_level_flags  */
  YYSYMBOL_ws_level_number = 1228,         /* ws_level_number  */
  YYSYMBOL_ws_level_list_item = 1229,      /* ws_level_list_item  */
  YYSYMBOL_ws_level_list = 1230,           /* ws_level_list  */
  YYSYMBOL_ws_level_range = 1231,          /* ws_level_range  */
  YYSYMBOL_ws_level_list_or_range = 1232,  /* ws_level_list_or_range  */
  YYSYMBOL_opt_ws_levels = 1233,           /* opt_ws_levels  */
  YYSYMBOL_opt_primary = 1234,             /* opt_primary  */
  YYSYMBOL_references = 1235,              /* references  */
  YYSYMBOL_opt_ref_list = 1236,            /* opt_ref_list  */
  YYSYMBOL_ref_list = 1237,                /* ref_list  */
  YYSYMBOL_opt_match_clause = 1238,        /* opt_match_clause  */
  YYSYMBOL_opt_on_update_delete = 1239,    /* opt_on_update_delete  */
  YYSYMBOL_delete_option = 1240,           /* delete_option  */
  YYSYMBOL_constraint_key_type = 1241,     /* constraint_key_type  */
  YYSYMBOL_key_or_index = 1242,            /* key_or_index  */
  YYSYMBOL_opt_key_or_index = 1243,        /* opt_key_or_index  */
  YYSYMBOL_keys_or_index = 1244,           /* keys_or_index  */
  YYSYMBOL_opt_unique = 1245,              /* opt_unique  */
  YYSYMBOL_fulltext = 1246,                /* fulltext  */
  YYSYMBOL_spatial = 1247,                 /* spatial  */
  YYSYMBOL_normal_key_options = 1248,      /* normal_key_options  */
  YYSYMBOL_fulltext_key_options = 1249,    /* fulltext_key_options  */
  YYSYMBOL_spatial_key_options = 1250,     /* spatial_key_options  */
  YYSYMBOL_normal_key_opts = 1251,         /* normal_key_opts  */
  YYSYMBOL_spatial_key_opts = 1252,        /* spatial_key_opts  */
  YYSYMBOL_fulltext_key_opts = 1253,       /* fulltext_key_opts  */
  YYSYMBOL_opt_USING_key_algorithm = 1254, /* opt_USING_key_algorithm  */
  YYSYMBOL_opt_key_algorithm_clause = 1255, /* opt_key_algorithm_clause  */
  YYSYMBOL_key_using_alg = 1256,           /* key_using_alg  */
  YYSYMBOL_all_key_opt = 1257,             /* all_key_opt  */
  YYSYMBOL_normal_key_opt = 1258,          /* normal_key_opt  */
  YYSYMBOL_spatial_key_opt = 1259,         /* spatial_key_opt  */
  YYSYMBOL_fulltext_key_opt = 1260,        /* fulltext_key_opt  */
  YYSYMBOL_btree_or_rtree = 1261,          /* btree_or_rtree  */
  YYSYMBOL_key_list = 1262,                /* key_list  */
  YYSYMBOL_key_part = 1263,                /* key_part  */
  YYSYMBOL_opt_ident = 1264,               /* opt_ident  */
  YYSYMBOL_string_list = 1265,             /* string_list  */
  YYSYMBOL_alter = 1266,                   /* alter  */
  YYSYMBOL_1267_102 = 1267,                /* $@102  */
  YYSYMBOL_1268_103 = 1268,                /* $@103  */
  YYSYMBOL_1269_104 = 1269,                /* $@104  */
  YYSYMBOL_1270_105 = 1270,                /* $@105  */
  YYSYMBOL_1271_106 = 1271,                /* $@106  */
  YYSYMBOL_1272_107 = 1272,                /* $@107  */
  YYSYMBOL_1273_108 = 1273,                /* $@108  */
  YYSYMBOL_1274_109 = 1274,                /* $@109  */
  YYSYMBOL_1275_110 = 1275,                /* $@110  */
  YYSYMBOL_1276_111 = 1276,                /* $@111  */
  YYSYMBOL_1277_112 = 1277,                /* $@112  */
  YYSYMBOL_account_locking_option = 1278,  /* account_locking_option  */
  YYSYMBOL_opt_password_expire_option = 1279, /* opt_password_expire_option  */
  YYSYMBOL_opt_account_locking_and_opt_password_expiration = 1280, /* opt_account_locking_and_opt_password_expiration  */
  YYSYMBOL_ev_alter_on_schedule_completion = 1281, /* ev_alter_on_schedule_completion  */
  YYSYMBOL_opt_ev_rename_to = 1282,        /* opt_ev_rename_to  */
  YYSYMBOL_opt_ev_sql_stmt = 1283,         /* opt_ev_sql_stmt  */
  YYSYMBOL_ident_or_empty = 1284,          /* ident_or_empty  */
  YYSYMBOL_alter_commands = 1285,          /* alter_commands  */
  YYSYMBOL_1286_113 = 1286,                /* $@113  */
  YYSYMBOL_1287_114 = 1287,                /* $@114  */
  YYSYMBOL_1288_115 = 1288,                /* $@115  */
  YYSYMBOL_remove_partitioning = 1289,     /* remove_partitioning  */
  YYSYMBOL_all_or_alt_part_name_list = 1290, /* all_or_alt_part_name_list  */
  YYSYMBOL_add_partition_rule = 1291,      /* add_partition_rule  */
  YYSYMBOL_1292_116 = 1292,                /* $@116  */
  YYSYMBOL_add_part_extra = 1293,          /* add_part_extra  */
  YYSYMBOL_reorg_partition_rule = 1294,    /* reorg_partition_rule  */
  YYSYMBOL_1295_117 = 1295,                /* $@117  */
  YYSYMBOL_reorg_parts_rule = 1296,        /* reorg_parts_rule  */
  YYSYMBOL_1297_118 = 1297,                /* $@118  */
  YYSYMBOL_alt_part_name_list = 1298,      /* alt_part_name_list  */
  YYSYMBOL_alt_part_name_item = 1299,      /* alt_part_name_item  */
  YYSYMBOL_alter_list = 1300,              /* alter_list  */
  YYSYMBOL_add_column = 1301,              /* add_column  */
  YYSYMBOL_alter_list_item = 1302,         /* alter_list_item  */
  YYSYMBOL_opt_index_lock_algorithm = 1303, /* opt_index_lock_algorithm  */
  YYSYMBOL_alter_algorithm_option = 1304,  /* alter_algorithm_option  */
  YYSYMBOL_alter_lock_option = 1305,       /* alter_lock_option  */
  YYSYMBOL_opt_column = 1306,              /* opt_column  */
  YYSYMBOL_opt_ignore = 1307,              /* opt_ignore  */
  YYSYMBOL_alter_options = 1308,           /* alter_options  */
  YYSYMBOL_1309_119 = 1309,                /* $@119  */
  YYSYMBOL_alter_options_part2 = 1310,     /* alter_options_part2  */
  YYSYMBOL_alter_option_list = 1311,       /* alter_option_list  */
  YYSYMBOL_alter_option = 1312,            /* alter_option  */
  YYSYMBOL_opt_restrict = 1313,            /* opt_restrict  */
  YYSYMBOL_opt_place = 1314,               /* opt_place  */
  YYSYMBOL_opt_to = 1315,                  /* opt_to  */
  YYSYMBOL_slave = 1316,                   /* slave  */
  YYSYMBOL_1317_120 = 1317,                /* $@120  */
  YYSYMBOL_1318_121 = 1318,                /* $@121  */
  YYSYMBOL_start = 1319,                   /* start  */
  YYSYMBOL_opt_start_transaction_option_list = 1320, /* opt_start_transaction_option_list  */
  YYSYMBOL_start_transaction_option_list = 1321, /* start_transaction_option_list  */
  YYSYMBOL_start_transaction_option = 1322, /* start_transaction_option  */
  YYSYMBOL_slave_thread_opts = 1323,       /* slave_thread_opts  */
  YYSYMBOL_1324_122 = 1324,                /* $@122  */
  YYSYMBOL_slave_thread_opt_list = 1325,   /* slave_thread_opt_list  */
  YYSYMBOL_slave_thread_opt = 1326,        /* slave_thread_opt  */
  YYSYMBOL_slave_until = 1327,             /* slave_until  */
  YYSYMBOL_slave_until_opts = 1328,        /* slave_until_opts  */
  YYSYMBOL_checksum = 1329,                /* checksum  */
  YYSYMBOL_1330_123 = 1330,                /* $@123  */
  YYSYMBOL_opt_checksum_type = 1331,       /* opt_checksum_type  */
  YYSYMBOL_repair_table_or_view = 1332,    /* repair_table_or_view  */
  YYSYMBOL_1333_124 = 1333,                /* $@124  */
  YYSYMBOL_repair = 1334,                  /* repair  */
  YYSYMBOL_1335_125 = 1335,                /* $@125  */
  YYSYMBOL_opt_mi_repair_type = 1336,      /* opt_mi_repair_type  */
  YYSYMBOL_mi_repair_types = 1337,         /* mi_repair_types  */
  YYSYMBOL_mi_repair_type = 1338,          /* mi_repair_type  */
  YYSYMBOL_opt_view_repair_type = 1339,    /* opt_view_repair_type  */
  YYSYMBOL_analyze = 1340,                 /* analyze  */
  YYSYMBOL_1341_126 = 1341,                /* $@126  */
  YYSYMBOL_analyze_table_list = 1342,      /* analyze_table_list  */
  YYSYMBOL_analyze_table_elem_spec = 1343, /* analyze_table_elem_spec  */
  YYSYMBOL_opt_persistent_stat_clause = 1344, /* opt_persistent_stat_clause  */
  YYSYMBOL_persistent_stat_spec = 1345,    /* persistent_stat_spec  */
  YYSYMBOL_persistent_column_stat_spec = 1346, /* persistent_column_stat_spec  */
  YYSYMBOL_1347_127 = 1347,                /* $@127  */
  YYSYMBOL_persistent_index_stat_spec = 1348, /* persistent_index_stat_spec  */
  YYSYMBOL_1349_128 = 1349,                /* $@128  */
  YYSYMBOL_table_column_list = 1350,       /* table_column_list  */
  YYSYMBOL_table_index_list = 1351,        /* table_index_list  */
  YYSYMBOL_table_index_name = 1352,        /* table_index_name  */
  YYSYMBOL_binlog_base64_event = 1353,     /* binlog_base64_event  */
  YYSYMBOL_check_view_or_table = 1354,     /* check_view_or_table  */
  YYSYMBOL_1355_129 = 1355,                /* $@129  */
  YYSYMBOL_check = 1356,                   /* check  */
  YYSYMBOL_1357_130 = 1357,                /* $@130  */
  YYSYMBOL_opt_mi_check_type = 1358,       /* opt_mi_check_type  */
  YYSYMBOL_mi_check_types = 1359,          /* mi_check_types  */
  YYSYMBOL_mi_check_type = 1360,           /* mi_check_type  */
  YYSYMBOL_opt_view_check_type = 1361,     /* opt_view_check_type  */
  YYSYMBOL_optimize = 1362,                /* optimize  */
  YYSYMBOL_1363_131 = 1363,                /* $@131  */
  YYSYMBOL_opt_no_write_to_binlog = 1364,  /* opt_no_write_to_binlog  */
  YYSYMBOL_rename = 1365,                  /* rename  */
  YYSYMBOL_1366_132 = 1366,                /* $@132  */
  YYSYMBOL_rename_list = 1367,             /* rename_list  */
  YYSYMBOL_table_to_table_list = 1368,     /* table_to_table_list  */
  YYSYMBOL_table_to_table = 1369,          /* table_to_table  */
  YYSYMBOL_keycache = 1370,                /* keycache  */
  YYSYMBOL_1371_133 = 1371,                /* $@133  */
  YYSYMBOL_keycache_list_or_parts = 1372,  /* keycache_list_or_parts  */
  YYSYMBOL_keycache_list = 1373,           /* keycache_list  */
  YYSYMBOL_assign_to_keycache = 1374,      /* assign_to_keycache  */
  YYSYMBOL_assign_to_keycache_parts = 1375, /* assign_to_keycache_parts  */
  YYSYMBOL_key_cache_name = 1376,          /* key_cache_name  */
  YYSYMBOL_preload = 1377,                 /* preload  */
  YYSYMBOL_1378_134 = 1378,                /* $@134  */
  YYSYMBOL_preload_list_or_parts = 1379,   /* preload_list_or_parts  */
  YYSYMBOL_preload_list = 1380,            /* preload_list  */
  YYSYMBOL_preload_keys = 1381,            /* preload_keys  */
  YYSYMBOL_preload_keys_parts = 1382,      /* preload_keys_parts  */
  YYSYMBOL_adm_partition = 1383,           /* adm_partition  */
  YYSYMBOL_1384_135 = 1384,                /* $@135  */
  YYSYMBOL_cache_keys_spec = 1385,         /* cache_keys_spec  */
  YYSYMBOL_1386_136 = 1386,                /* $@136  */
  YYSYMBOL_cache_key_list_or_empty = 1387, /* cache_key_list_or_empty  */
  YYSYMBOL_opt_ignore_leaves = 1388,       /* opt_ignore_leaves  */
  YYSYMBOL_select = 1389,                  /* select  */
  YYSYMBOL_1390_137 = 1390,                /* $@137  */
  YYSYMBOL_1391_138 = 1391,                /* $@138  */
  YYSYMBOL_select_into = 1392,             /* select_into  */
  YYSYMBOL_1393_139 = 1393,                /* $@139  */
  YYSYMBOL_1394_140 = 1394,                /* $@140  */
  YYSYMBOL_simple_table = 1395,            /* simple_table  */
  YYSYMBOL_table_value_constructor = 1396, /* table_value_constructor  */
  YYSYMBOL_1397_141 = 1397,                /* $@141  */
  YYSYMBOL_query_specification_start = 1398, /* query_specification_start  */
  YYSYMBOL_1399_142 = 1399,                /* $@142  */
  YYSYMBOL_1400_143 = 1400,                /* $@143  */
  YYSYMBOL_query_specification = 1401,     /* query_specification  */
  YYSYMBOL_select_into_query_specification = 1402, /* select_into_query_specification  */
  YYSYMBOL_query_expression = 1403,        /* query_expression  */
  YYSYMBOL_query_expression_no_with_clause = 1404, /* query_expression_no_with_clause  */
  YYSYMBOL_query_expression_body_ext = 1405, /* query_expression_body_ext  */
  YYSYMBOL_1406_144 = 1406,                /* $@144  */
  YYSYMBOL_1407_145 = 1407,                /* $@145  */
  YYSYMBOL_query_expression_body_ext_parens = 1408, /* query_expression_body_ext_parens  */
  YYSYMBOL_query_expression_body = 1409,   /* query_expression_body  */
  YYSYMBOL_1410_146 = 1410,                /* $@146  */
  YYSYMBOL_query_primary = 1411,           /* query_primary  */
  YYSYMBOL_query_simple = 1412,            /* query_simple  */
  YYSYMBOL_subselect = 1413,               /* subselect  */
  YYSYMBOL_subquery = 1414,                /* subquery  */
  YYSYMBOL_opt_from_clause = 1415,         /* opt_from_clause  */
  YYSYMBOL_from_clause = 1416,             /* from_clause  */
  YYSYMBOL_table_reference_list = 1417,    /* table_reference_list  */
  YYSYMBOL_select_options = 1418,          /* select_options  */
  YYSYMBOL_opt_history_unit = 1419,        /* opt_history_unit  */
  YYSYMBOL_history_point = 1420,           /* history_point  */
  YYSYMBOL_for_portion_of_time_clause = 1421, /* for_portion_of_time_clause  */
  YYSYMBOL_opt_for_portion_of_time_clause = 1422, /* opt_for_portion_of_time_clause  */
  YYSYMBOL_opt_for_system_time_clause = 1423, /* opt_for_system_time_clause  */
  YYSYMBOL_system_time_expr = 1424,        /* system_time_expr  */
  YYSYMBOL_select_option_list = 1425,      /* select_option_list  */
  YYSYMBOL_select_option = 1426,           /* select_option  */
  YYSYMBOL_select_lock_type = 1427,        /* select_lock_type  */
  YYSYMBOL_opt_select_lock_type = 1428,    /* opt_select_lock_type  */
  YYSYMBOL_opt_lock_wait_timeout_new = 1429, /* opt_lock_wait_timeout_new  */
  YYSYMBOL_select_item_list = 1430,        /* select_item_list  */
  YYSYMBOL_select_item = 1431,             /* select_item  */
  YYSYMBOL_remember_tok_start = 1432,      /* remember_tok_start  */
  YYSYMBOL_remember_name = 1433,           /* remember_name  */
  YYSYMBOL_remember_end = 1434,            /* remember_end  */
  YYSYMBOL_select_alias = 1435,            /* select_alias  */
  YYSYMBOL_opt_default_time_precision = 1436, /* opt_default_time_precision  */
  YYSYMBOL_opt_time_precision = 1437,      /* opt_time_precision  */
  YYSYMBOL_optional_braces = 1438,         /* optional_braces  */
  YYSYMBOL_expr = 1439,                    /* expr  */
  YYSYMBOL_boolean_test = 1440,            /* boolean_test  */
  YYSYMBOL_predicate = 1441,               /* predicate  */
  YYSYMBOL_bit_expr = 1442,                /* bit_expr  */
  YYSYMBOL_or = 1443,                      /* or  */
  YYSYMBOL_and = 1444,                     /* and  */
  YYSYMBOL_not = 1445,                     /* not  */
  YYSYMBOL_not2 = 1446,                    /* not2  */
  YYSYMBOL_comp_op = 1447,                 /* comp_op  */
  YYSYMBOL_all_or_any = 1448,              /* all_or_any  */
  YYSYMBOL_opt_dyncol_type = 1449,         /* opt_dyncol_type  */
  YYSYMBOL_dyncol_type = 1450,             /* dyncol_type  */
  YYSYMBOL_numeric_dyncol_type = 1451,     /* numeric_dyncol_type  */
  YYSYMBOL_temporal_dyncol_type = 1452,    /* temporal_dyncol_type  */
  YYSYMBOL_string_dyncol_type = 1453,      /* string_dyncol_type  */
  YYSYMBOL_1454_147 = 1454,                /* $@147  */
  YYSYMBOL_dyncall_create_element = 1455,  /* dyncall_create_element  */
  YYSYMBOL_dyncall_create_list = 1456,     /* dyncall_create_list  */
  YYSYMBOL_plsql_cursor_attr = 1457,       /* plsql_cursor_attr  */
  YYSYMBOL_explicit_cursor_attr = 1458,    /* explicit_cursor_attr  */
  YYSYMBOL_trim_operands = 1459,           /* trim_operands  */
  YYSYMBOL_trim_operands_regular = 1460,   /* trim_operands_regular  */
  YYSYMBOL_trim_operands_special = 1461,   /* trim_operands_special  */
  YYSYMBOL_column_default_non_parenthesized_expr = 1462, /* column_default_non_parenthesized_expr  */
  YYSYMBOL_primary_expr = 1463,            /* primary_expr  */
  YYSYMBOL_string_factor_expr = 1464,      /* string_factor_expr  */
  YYSYMBOL_simple_expr = 1465,             /* simple_expr  */
  YYSYMBOL_mysql_concatenation_expr = 1466, /* mysql_concatenation_expr  */
  YYSYMBOL_function_call_keyword_timestamp = 1467, /* function_call_keyword_timestamp  */
  YYSYMBOL_function_call_keyword = 1468,   /* function_call_keyword  */
  YYSYMBOL_substring_operands = 1469,      /* substring_operands  */
  YYSYMBOL_substring_operands_regular = 1470, /* substring_operands_regular  */
  YYSYMBOL_substring_operands_special = 1471, /* substring_operands_special  */
  YYSYMBOL_function_call_nonkeyword = 1472, /* function_call_nonkeyword  */
  YYSYMBOL_function_call_conflict = 1473,  /* function_call_conflict  */
  YYSYMBOL_geometry_function = 1474,       /* geometry_function  */
  YYSYMBOL_function_call_generic = 1475,   /* function_call_generic  */
  YYSYMBOL_1476_148 = 1476,                /* @148  */
  YYSYMBOL_fulltext_options = 1477,        /* fulltext_options  */
  YYSYMBOL_opt_natural_language_mode = 1478, /* opt_natural_language_mode  */
  YYSYMBOL_opt_query_expansion = 1479,     /* opt_query_expansion  */
  YYSYMBOL_opt_udf_expr_list = 1480,       /* opt_udf_expr_list  */
  YYSYMBOL_udf_expr_list = 1481,           /* udf_expr_list  */
  YYSYMBOL_udf_expr = 1482,                /* udf_expr  */
  YYSYMBOL_sum_expr = 1483,                /* sum_expr  */
  YYSYMBOL_1484_149 = 1484,                /* $@149  */
  YYSYMBOL_1485_150 = 1485,                /* $@150  */
  YYSYMBOL_1486_151 = 1486,                /* $@151  */
  YYSYMBOL_window_func_expr = 1487,        /* window_func_expr  */
  YYSYMBOL_window_func = 1488,             /* window_func  */
  YYSYMBOL_simple_window_func = 1489,      /* simple_window_func  */
  YYSYMBOL_inverse_distribution_function = 1490, /* inverse_distribution_function  */
  YYSYMBOL_percentile_function = 1491,     /* percentile_function  */
  YYSYMBOL_1492_152 = 1492,                /* $@152  */
  YYSYMBOL_inverse_distribution_function_def = 1493, /* inverse_distribution_function_def  */
  YYSYMBOL_order_by_single_element_list = 1494, /* order_by_single_element_list  */
  YYSYMBOL_window_name = 1495,             /* window_name  */
  YYSYMBOL_variable = 1496,                /* variable  */
  YYSYMBOL_1497_153 = 1497,                /* $@153  */
  YYSYMBOL_variable_aux = 1498,            /* variable_aux  */
  YYSYMBOL_opt_distinct = 1499,            /* opt_distinct  */
  YYSYMBOL_opt_gconcat_separator = 1500,   /* opt_gconcat_separator  */
  YYSYMBOL_opt_gorder_clause = 1501,       /* opt_gorder_clause  */
  YYSYMBOL_gorder_list = 1502,             /* gorder_list  */
  YYSYMBOL_opt_glimit_clause = 1503,       /* opt_glimit_clause  */
  YYSYMBOL_glimit_clause_init = 1504,      /* glimit_clause_init  */
  YYSYMBOL_glimit_clause = 1505,           /* glimit_clause  */
  YYSYMBOL_glimit_options = 1506,          /* glimit_options  */
  YYSYMBOL_in_sum_expr = 1507,             /* in_sum_expr  */
  YYSYMBOL_1508_154 = 1508,                /* $@154  */
  YYSYMBOL_cast_type = 1509,               /* cast_type  */
  YYSYMBOL_1510_155 = 1510,                /* $@155  */
  YYSYMBOL_1511_156 = 1511,                /* $@156  */
  YYSYMBOL_1512_157 = 1512,                /* $@157  */
  YYSYMBOL_cast_type_numeric = 1513,       /* cast_type_numeric  */
  YYSYMBOL_cast_type_temporal = 1514,      /* cast_type_temporal  */
  YYSYMBOL_opt_expr_list = 1515,           /* opt_expr_list  */
  YYSYMBOL_expr_list = 1516,               /* expr_list  */
  YYSYMBOL_ident_list_arg = 1517,          /* ident_list_arg  */
  YYSYMBOL_ident_list = 1518,              /* ident_list  */
  YYSYMBOL_when_list = 1519,               /* when_list  */
  YYSYMBOL_when_list_opt_else = 1520,      /* when_list_opt_else  */
  YYSYMBOL_table_ref = 1521,               /* table_ref  */
  YYSYMBOL_join_table_list = 1522,         /* join_table_list  */
  YYSYMBOL_esc_table_ref = 1523,           /* esc_table_ref  */
  YYSYMBOL_derived_table_list = 1524,      /* derived_table_list  */
  YYSYMBOL_join_table = 1525,              /* join_table  */
  YYSYMBOL_1526_158 = 1526,                /* $@158  */
  YYSYMBOL_1527_159 = 1527,                /* $@159  */
  YYSYMBOL_1528_160 = 1528,                /* $@160  */
  YYSYMBOL_1529_161 = 1529,                /* $@161  */
  YYSYMBOL_1530_162 = 1530,                /* $@162  */
  YYSYMBOL_1531_163 = 1531,                /* $@163  */
  YYSYMBOL_inner_join = 1532,              /* inner_join  */
  YYSYMBOL_normal_join = 1533,             /* normal_join  */
  YYSYMBOL_opt_use_partition = 1534,       /* opt_use_partition  */
  YYSYMBOL_use_partition = 1535,           /* use_partition  */
  YYSYMBOL_table_factor = 1536,            /* table_factor  */
  YYSYMBOL_table_primary_ident_opt_parens = 1537, /* table_primary_ident_opt_parens  */
  YYSYMBOL_table_primary_derived_opt_parens = 1538, /* table_primary_derived_opt_parens  */
  YYSYMBOL_table_reference_list_parens = 1539, /* table_reference_list_parens  */
  YYSYMBOL_nested_table_reference_list = 1540, /* nested_table_reference_list  */
  YYSYMBOL_join_table_parens = 1541,       /* join_table_parens  */
  YYSYMBOL_table_primary_ident = 1542,     /* table_primary_ident  */
  YYSYMBOL_table_primary_derived = 1543,   /* table_primary_derived  */
  YYSYMBOL_opt_outer = 1544,               /* opt_outer  */
  YYSYMBOL_index_hint_clause = 1545,       /* index_hint_clause  */
  YYSYMBOL_index_hint_type = 1546,         /* index_hint_type  */
  YYSYMBOL_index_hint_definition = 1547,   /* index_hint_definition  */
  YYSYMBOL_1548_164 = 1548,                /* $@164  */
  YYSYMBOL_1549_165 = 1549,                /* $@165  */
  YYSYMBOL_index_hints_list = 1550,        /* index_hints_list  */
  YYSYMBOL_opt_index_hints_list = 1551,    /* opt_index_hints_list  */
  YYSYMBOL_1552_166 = 1552,                /* $@166  */
  YYSYMBOL_opt_key_definition = 1553,      /* opt_key_definition  */
  YYSYMBOL_1554_167 = 1554,                /* $@167  */
  YYSYMBOL_opt_key_usage_list = 1555,      /* opt_key_usage_list  */
  YYSYMBOL_key_usage_element = 1556,       /* key_usage_element  */
  YYSYMBOL_key_usage_list = 1557,          /* key_usage_list  */
  YYSYMBOL_using_list = 1558,              /* using_list  */
  YYSYMBOL_interval = 1559,                /* interval  */
  YYSYMBOL_interval_time_stamp = 1560,     /* interval_time_stamp  */
  YYSYMBOL_date_time_type = 1561,          /* date_time_type  */
  YYSYMBOL_table_alias = 1562,             /* table_alias  */
  YYSYMBOL_opt_table_alias_clause = 1563,  /* opt_table_alias_clause  */
  YYSYMBOL_table_alias_clause = 1564,      /* table_alias_clause  */
  YYSYMBOL_opt_all = 1565,                 /* opt_all  */
  YYSYMBOL_opt_where_clause = 1566,        /* opt_where_clause  */
  YYSYMBOL_1567_168 = 1567,                /* $@168  */
  YYSYMBOL_opt_having_clause = 1568,       /* opt_having_clause  */
  YYSYMBOL_1569_169 = 1569,                /* $@169  */
  YYSYMBOL_opt_group_clause = 1570,        /* opt_group_clause  */
  YYSYMBOL_group_list = 1571,              /* group_list  */
  YYSYMBOL_olap_opt = 1572,                /* olap_opt  */
  YYSYMBOL_opt_window_clause = 1573,       /* opt_window_clause  */
  YYSYMBOL_window_def_list = 1574,         /* window_def_list  */
  YYSYMBOL_window_def = 1575,              /* window_def  */
  YYSYMBOL_window_spec = 1576,             /* window_spec  */
  YYSYMBOL_1577_170 = 1577,                /* $@170  */
  YYSYMBOL_opt_window_ref = 1578,          /* opt_window_ref  */
  YYSYMBOL_opt_window_partition_clause = 1579, /* opt_window_partition_clause  */
  YYSYMBOL_opt_window_order_clause = 1580, /* opt_window_order_clause  */
  YYSYMBOL_opt_window_frame_clause = 1581, /* opt_window_frame_clause  */
  YYSYMBOL_window_frame_units = 1582,      /* window_frame_units  */
  YYSYMBOL_window_frame_extent = 1583,     /* window_frame_extent  */
  YYSYMBOL_window_frame_start = 1584,      /* window_frame_start  */
  YYSYMBOL_window_frame_bound = 1585,      /* window_frame_bound  */
  YYSYMBOL_opt_window_frame_exclusion = 1586, /* opt_window_frame_exclusion  */
  YYSYMBOL_alter_order_clause = 1587,      /* alter_order_clause  */
  YYSYMBOL_alter_order_list = 1588,        /* alter_order_list  */
  YYSYMBOL_alter_order_item = 1589,        /* alter_order_item  */
  YYSYMBOL_opt_order_clause = 1590,        /* opt_order_clause  */
  YYSYMBOL_order_clause = 1591,            /* order_clause  */
  YYSYMBOL_1592_171 = 1592,                /* $@171  */
  YYSYMBOL_order_list = 1593,              /* order_list  */
  YYSYMBOL_order_dir = 1594,               /* order_dir  */
  YYSYMBOL_opt_limit_clause = 1595,        /* opt_limit_clause  */
  YYSYMBOL_limit_clause = 1596,            /* limit_clause  */
  YYSYMBOL_opt_global_limit_clause = 1597, /* opt_global_limit_clause  */
  YYSYMBOL_limit_options = 1598,           /* limit_options  */
  YYSYMBOL_limit_option = 1599,            /* limit_option  */
  YYSYMBOL_limit_rows_option = 1600,       /* limit_rows_option  */
  YYSYMBOL_delete_limit_clause = 1601,     /* delete_limit_clause  */
  YYSYMBOL_order_limit_lock = 1602,        /* order_limit_lock  */
  YYSYMBOL_opt_order_limit_lock = 1603,    /* opt_order_limit_lock  */
  YYSYMBOL_query_expression_tail = 1604,   /* query_expression_tail  */
  YYSYMBOL_opt_query_expression_tail = 1605, /* opt_query_expression_tail  */
  YYSYMBOL_opt_procedure_or_into = 1606,   /* opt_procedure_or_into  */
  YYSYMBOL_order_or_limit = 1607,          /* order_or_limit  */
  YYSYMBOL_opt_plus = 1608,                /* opt_plus  */
  YYSYMBOL_int_num = 1609,                 /* int_num  */
  YYSYMBOL_ulong_num = 1610,               /* ulong_num  */
  YYSYMBOL_real_ulong_num = 1611,          /* real_ulong_num  */
  YYSYMBOL_longlong_num = 1612,            /* longlong_num  */
  YYSYMBOL_ulonglong_num = 1613,           /* ulonglong_num  */
  YYSYMBOL_real_ulonglong_num = 1614,      /* real_ulonglong_num  */
  YYSYMBOL_dec_num_error = 1615,           /* dec_num_error  */
  YYSYMBOL_dec_num = 1616,                 /* dec_num  */
  YYSYMBOL_choice = 1617,                  /* choice  */
  YYSYMBOL_bool = 1618,                    /* bool  */
  YYSYMBOL_procedure_clause = 1619,        /* procedure_clause  */
  YYSYMBOL_1620_172 = 1620,                /* $@172  */
  YYSYMBOL_procedure_list = 1621,          /* procedure_list  */
  YYSYMBOL_procedure_list2 = 1622,         /* procedure_list2  */
  YYSYMBOL_procedure_item = 1623,          /* procedure_item  */
  YYSYMBOL_select_var_list_init = 1624,    /* select_var_list_init  */
  YYSYMBOL_1625_173 = 1625,                /* $@173  */
  YYSYMBOL_select_var_list = 1626,         /* select_var_list  */
  YYSYMBOL_select_var_ident = 1627,        /* select_var_ident  */
  YYSYMBOL_select_outvar = 1628,           /* select_outvar  */
  YYSYMBOL_into = 1629,                    /* into  */
  YYSYMBOL_into_destination = 1630,        /* into_destination  */
  YYSYMBOL_1631_174 = 1631,                /* $@174  */
  YYSYMBOL_1632_175 = 1632,                /* $@175  */
  YYSYMBOL_do = 1633,                      /* do  */
  YYSYMBOL_1634_176 = 1634,                /* $@176  */
  YYSYMBOL_drop = 1635,                    /* drop  */
  YYSYMBOL_1636_177 = 1636,                /* $@177  */
  YYSYMBOL_1637_178 = 1637,                /* $@178  */
  YYSYMBOL_1638_179 = 1638,                /* $@179  */
  YYSYMBOL_1639_180 = 1639,                /* $@180  */
  YYSYMBOL_table_list = 1640,              /* table_list  */
  YYSYMBOL_table_name = 1641,              /* table_name  */
  YYSYMBOL_table_name_with_opt_use_partition = 1642, /* table_name_with_opt_use_partition  */
  YYSYMBOL_table_alias_ref_list = 1643,    /* table_alias_ref_list  */
  YYSYMBOL_table_alias_ref = 1644,         /* table_alias_ref  */
  YYSYMBOL_opt_if_exists_table_element = 1645, /* opt_if_exists_table_element  */
  YYSYMBOL_opt_if_exists = 1646,           /* opt_if_exists  */
  YYSYMBOL_opt_temporary = 1647,           /* opt_temporary  */
  YYSYMBOL_insert = 1648,                  /* insert  */
  YYSYMBOL_1649_181 = 1649,                /* $@181  */
  YYSYMBOL_1650_182 = 1650,                /* $@182  */
  YYSYMBOL_replace = 1651,                 /* replace  */
  YYSYMBOL_1652_183 = 1652,                /* $@183  */
  YYSYMBOL_1653_184 = 1653,                /* $@184  */
  YYSYMBOL_insert_lock_option = 1654,      /* insert_lock_option  */
  YYSYMBOL_replace_lock_option = 1655,     /* replace_lock_option  */
  YYSYMBOL_insert2 = 1656,                 /* insert2  */
  YYSYMBOL_insert_table = 1657,            /* insert_table  */
  YYSYMBOL_1658_185 = 1658,                /* $@185  */
  YYSYMBOL_insert_field_spec = 1659,       /* insert_field_spec  */
  YYSYMBOL_1660_186 = 1660,                /* $@186  */
  YYSYMBOL_insert_field_list = 1661,       /* insert_field_list  */
  YYSYMBOL_opt_fields = 1662,              /* opt_fields  */
  YYSYMBOL_fields = 1663,                  /* fields  */
  YYSYMBOL_insert_values = 1664,           /* insert_values  */
  YYSYMBOL_values_list = 1665,             /* values_list  */
  YYSYMBOL_ident_eq_list = 1666,           /* ident_eq_list  */
  YYSYMBOL_ident_eq_value = 1667,          /* ident_eq_value  */
  YYSYMBOL_equal = 1668,                   /* equal  */
  YYSYMBOL_opt_equal = 1669,               /* opt_equal  */
  YYSYMBOL_opt_with = 1670,                /* opt_with  */
  YYSYMBOL_opt_by = 1671,                  /* opt_by  */
  YYSYMBOL_no_braces = 1672,               /* no_braces  */
  YYSYMBOL_1673_187 = 1673,                /* $@187  */
  YYSYMBOL_no_braces_with_names = 1674,    /* no_braces_with_names  */
  YYSYMBOL_1675_188 = 1675,                /* $@188  */
  YYSYMBOL_opt_values = 1676,              /* opt_values  */
  YYSYMBOL_opt_values_with_names = 1677,   /* opt_values_with_names  */
  YYSYMBOL_values = 1678,                  /* values  */
  YYSYMBOL_values_with_names = 1679,       /* values_with_names  */
  YYSYMBOL_expr_or_ignore = 1680,          /* expr_or_ignore  */
  YYSYMBOL_expr_or_ignore_or_default = 1681, /* expr_or_ignore_or_default  */
  YYSYMBOL_opt_insert_update = 1682,       /* opt_insert_update  */
  YYSYMBOL_1683_189 = 1683,                /* $@189  */
  YYSYMBOL_1684_190 = 1684,                /* $@190  */
  YYSYMBOL_update_table_list = 1685,       /* update_table_list  */
  YYSYMBOL_update = 1686,                  /* update  */
  YYSYMBOL_1687_191 = 1687,                /* $@191  */
  YYSYMBOL_1688_192 = 1688,                /* $@192  */
  YYSYMBOL_update_list = 1689,             /* update_list  */
  YYSYMBOL_update_elem = 1690,             /* update_elem  */
  YYSYMBOL_insert_update_list = 1691,      /* insert_update_list  */
  YYSYMBOL_insert_update_elem = 1692,      /* insert_update_elem  */
  YYSYMBOL_opt_low_priority = 1693,        /* opt_low_priority  */
  YYSYMBOL_delete = 1694,                  /* delete  */
  YYSYMBOL_1695_193 = 1695,                /* $@193  */
  YYSYMBOL_opt_delete_system_time = 1696,  /* opt_delete_system_time  */
  YYSYMBOL_delete_part2 = 1697,            /* delete_part2  */
  YYSYMBOL_delete_single_table = 1698,     /* delete_single_table  */
  YYSYMBOL_delete_single_table_for_period = 1699, /* delete_single_table_for_period  */
  YYSYMBOL_single_multi = 1700,            /* single_multi  */
  YYSYMBOL_1701_194 = 1701,                /* $@194  */
  YYSYMBOL_1702_195 = 1702,                /* $@195  */
  YYSYMBOL_opt_select_expressions = 1703,  /* opt_select_expressions  */
  YYSYMBOL_table_wild_list = 1704,         /* table_wild_list  */
  YYSYMBOL_table_wild_one = 1705,          /* table_wild_one  */
  YYSYMBOL_opt_wild = 1706,                /* opt_wild  */
  YYSYMBOL_opt_delete_options = 1707,      /* opt_delete_options  */
  YYSYMBOL_opt_delete_option = 1708,       /* opt_delete_option  */
  YYSYMBOL_truncate = 1709,                /* truncate  */
  YYSYMBOL_1710_196 = 1710,                /* $@196  */
  YYSYMBOL_opt_table_sym = 1711,           /* opt_table_sym  */
  YYSYMBOL_opt_profile_defs = 1712,        /* opt_profile_defs  */
  YYSYMBOL_profile_defs = 1713,            /* profile_defs  */
  YYSYMBOL_profile_def = 1714,             /* profile_def  */
  YYSYMBOL_opt_profile_args = 1715,        /* opt_profile_args  */
  YYSYMBOL_show = 1716,                    /* show  */
  YYSYMBOL_1717_197 = 1717,                /* $@197  */
  YYSYMBOL_show_param = 1718,              /* show_param  */
  YYSYMBOL_1719_198 = 1719,                /* $@198  */
  YYSYMBOL_1720_199 = 1720,                /* $@199  */
  YYSYMBOL_show_engine_param = 1721,       /* show_engine_param  */
  YYSYMBOL_master_or_binary = 1722,        /* master_or_binary  */
  YYSYMBOL_opt_storage = 1723,             /* opt_storage  */
  YYSYMBOL_opt_db = 1724,                  /* opt_db  */
  YYSYMBOL_opt_full = 1725,                /* opt_full  */
  YYSYMBOL_from_or_in = 1726,              /* from_or_in  */
  YYSYMBOL_binlog_in = 1727,               /* binlog_in  */
  YYSYMBOL_binlog_from = 1728,             /* binlog_from  */
  YYSYMBOL_wild_and_where = 1729,          /* wild_and_where  */
  YYSYMBOL_describe = 1730,                /* describe  */
  YYSYMBOL_1731_200 = 1731,                /* $@200  */
  YYSYMBOL_1732_201 = 1732,                /* $@201  */
  YYSYMBOL_explainable_command = 1733,     /* explainable_command  */
  YYSYMBOL_describe_command = 1734,        /* describe_command  */
  YYSYMBOL_analyze_stmt_command = 1735,    /* analyze_stmt_command  */
  YYSYMBOL_opt_extended_describe = 1736,   /* opt_extended_describe  */
  YYSYMBOL_opt_format_json = 1737,         /* opt_format_json  */
  YYSYMBOL_opt_describe_column = 1738,     /* opt_describe_column  */
  YYSYMBOL_flush = 1739,                   /* flush  */
  YYSYMBOL_1740_202 = 1740,                /* $@202  */
  YYSYMBOL_flush_options = 1741,           /* flush_options  */
  YYSYMBOL_1742_203 = 1742,                /* $@203  */
  YYSYMBOL_opt_flush_lock = 1743,          /* opt_flush_lock  */
  YYSYMBOL_flush_lock = 1744,              /* flush_lock  */
  YYSYMBOL_1745_204 = 1745,                /* $@204  */
  YYSYMBOL_flush_options_list = 1746,      /* flush_options_list  */
  YYSYMBOL_flush_option = 1747,            /* flush_option  */
  YYSYMBOL_opt_table_list = 1748,          /* opt_table_list  */
  YYSYMBOL_backup = 1749,                  /* backup  */
  YYSYMBOL_backup_statements = 1750,       /* backup_statements  */
  YYSYMBOL_1751_205 = 1751,                /* $@205  */
  YYSYMBOL_opt_delete_gtid_domain = 1752,  /* opt_delete_gtid_domain  */
  YYSYMBOL_delete_domain_id_list = 1753,   /* delete_domain_id_list  */
  YYSYMBOL_delete_domain_id = 1754,        /* delete_domain_id  */
  YYSYMBOL_optional_flush_tables_arguments = 1755, /* optional_flush_tables_arguments  */
  YYSYMBOL_reset = 1756,                   /* reset  */
  YYSYMBOL_1757_206 = 1757,                /* $@206  */
  YYSYMBOL_reset_options = 1758,           /* reset_options  */
  YYSYMBOL_reset_option = 1759,            /* reset_option  */
  YYSYMBOL_1760_207 = 1760,                /* $@207  */
  YYSYMBOL_1761_208 = 1761,                /* $@208  */
  YYSYMBOL_slave_reset_options = 1762,     /* slave_reset_options  */
  YYSYMBOL_master_reset_options = 1763,    /* master_reset_options  */
  YYSYMBOL_purge = 1764,                   /* purge  */
  YYSYMBOL_1765_209 = 1765,                /* $@209  */
  YYSYMBOL_kill = 1766,                    /* kill  */
  YYSYMBOL_1767_210 = 1767,                /* $@210  */
  YYSYMBOL_kill_type = 1768,               /* kill_type  */
  YYSYMBOL_kill_option = 1769,             /* kill_option  */
  YYSYMBOL_opt_connection = 1770,          /* opt_connection  */
  YYSYMBOL_kill_expr = 1771,               /* kill_expr  */
  YYSYMBOL_shutdown = 1772,                /* shutdown  */
  YYSYMBOL_1773_211 = 1773,                /* $@211  */
  YYSYMBOL_shutdown_option = 1774,         /* shutdown_option  */
  YYSYMBOL_use = 1775,                     /* use  */
  YYSYMBOL_load = 1776,                    /* load  */
  YYSYMBOL_1777_212 = 1777,                /* $@212  */
  YYSYMBOL_1778_213 = 1778,                /* $@213  */
  YYSYMBOL_1779_214 = 1779,                /* $@214  */
  YYSYMBOL_1780_215 = 1780,                /* $@215  */
  YYSYMBOL_data_or_xml = 1781,             /* data_or_xml  */
  YYSYMBOL_opt_local = 1782,               /* opt_local  */
  YYSYMBOL_load_data_lock = 1783,          /* load_data_lock  */
  YYSYMBOL_opt_duplicate = 1784,           /* opt_duplicate  */
  YYSYMBOL_opt_field_term = 1785,          /* opt_field_term  */
  YYSYMBOL_field_term_list = 1786,         /* field_term_list  */
  YYSYMBOL_field_term = 1787,              /* field_term  */
  YYSYMBOL_opt_line_term = 1788,           /* opt_line_term  */
  YYSYMBOL_line_term_list = 1789,          /* line_term_list  */
  YYSYMBOL_line_term = 1790,               /* line_term  */
  YYSYMBOL_opt_xml_rows_identified_by = 1791, /* opt_xml_rows_identified_by  */
  YYSYMBOL_opt_ignore_lines = 1792,        /* opt_ignore_lines  */
  YYSYMBOL_lines_or_rows = 1793,           /* lines_or_rows  */
  YYSYMBOL_opt_field_or_var_spec = 1794,   /* opt_field_or_var_spec  */
  YYSYMBOL_fields_or_vars = 1795,          /* fields_or_vars  */
  YYSYMBOL_field_or_var = 1796,            /* field_or_var  */
  YYSYMBOL_opt_load_data_set_spec = 1797,  /* opt_load_data_set_spec  */
  YYSYMBOL_load_data_set_list = 1798,      /* load_data_set_list  */
  YYSYMBOL_load_data_set_elem = 1799,      /* load_data_set_elem  */
  YYSYMBOL_text_literal = 1800,            /* text_literal  */
  YYSYMBOL_text_string = 1801,             /* text_string  */
  YYSYMBOL_hex_or_bin_String = 1802,       /* hex_or_bin_String  */
  YYSYMBOL_param_marker = 1803,            /* param_marker  */
  YYSYMBOL_signed_literal = 1804,          /* signed_literal  */
  YYSYMBOL_literal = 1805,                 /* literal  */
  YYSYMBOL_NUM_literal = 1806,             /* NUM_literal  */
  YYSYMBOL_temporal_literal = 1807,        /* temporal_literal  */
  YYSYMBOL_with_clause = 1808,             /* with_clause  */
  YYSYMBOL_1809_216 = 1809,                /* $@216  */
  YYSYMBOL_opt_recursive = 1810,           /* opt_recursive  */
  YYSYMBOL_with_list = 1811,               /* with_list  */
  YYSYMBOL_with_list_element = 1812,       /* with_list_element  */
  YYSYMBOL_1813_217 = 1813,                /* $@217  */
  YYSYMBOL_opt_with_column_list = 1814,    /* opt_with_column_list  */
  YYSYMBOL_with_column_list = 1815,        /* with_column_list  */
  YYSYMBOL_with_element_head = 1816,       /* with_element_head  */
  YYSYMBOL_insert_ident = 1817,            /* insert_ident  */
  YYSYMBOL_table_wild = 1818,              /* table_wild  */
  YYSYMBOL_select_sublist_qualified_asterisk = 1819, /* select_sublist_qualified_asterisk  */
  YYSYMBOL_order_ident = 1820,             /* order_ident  */
  YYSYMBOL_simple_ident = 1821,            /* simple_ident  */
  YYSYMBOL_simple_ident_nospvar = 1822,    /* simple_ident_nospvar  */
  YYSYMBOL_field_ident = 1823,             /* field_ident  */
  YYSYMBOL_table_ident = 1824,             /* table_ident  */
  YYSYMBOL_table_ident_opt_wild = 1825,    /* table_ident_opt_wild  */
  YYSYMBOL_table_ident_nodb = 1826,        /* table_ident_nodb  */
  YYSYMBOL_IDENT_cli = 1827,               /* IDENT_cli  */
  YYSYMBOL_ident_cli = 1828,               /* ident_cli  */
  YYSYMBOL_IDENT_sys = 1829,               /* IDENT_sys  */
  YYSYMBOL_TEXT_STRING_sys = 1830,         /* TEXT_STRING_sys  */
  YYSYMBOL_TEXT_STRING_literal = 1831,     /* TEXT_STRING_literal  */
  YYSYMBOL_TEXT_STRING_filesystem = 1832,  /* TEXT_STRING_filesystem  */
  YYSYMBOL_ident_table_alias = 1833,       /* ident_table_alias  */
  YYSYMBOL_ident_set_usual_case = 1834,    /* ident_set_usual_case  */
  YYSYMBOL_ident_sysvar_name = 1835,       /* ident_sysvar_name  */
  YYSYMBOL_ident = 1836,                   /* ident  */
  YYSYMBOL_label_ident = 1837,             /* label_ident  */
  YYSYMBOL_ident_or_text = 1838,           /* ident_or_text  */
  YYSYMBOL_user_maybe_role = 1839,         /* user_maybe_role  */
  YYSYMBOL_user_or_role = 1840,            /* user_or_role  */
  YYSYMBOL_user = 1841,                    /* user  */
  YYSYMBOL_keyword_table_alias = 1842,     /* keyword_table_alias  */
  YYSYMBOL_keyword_ident = 1843,           /* keyword_ident  */
  YYSYMBOL_keyword_label = 1844,           /* keyword_label  */
  YYSYMBOL_keyword_sysvar_name = 1845,     /* keyword_sysvar_name  */
  YYSYMBOL_keyword_sp_decl = 1846,         /* keyword_sp_decl  */
  YYSYMBOL_keyword_set_usual_case = 1847,  /* keyword_set_usual_case  */
  YYSYMBOL_keyword_sp_var_not_label = 1848, /* keyword_sp_var_not_label  */
  YYSYMBOL_keyword_sp_head = 1849,         /* keyword_sp_head  */
  YYSYMBOL_keyword_verb_clause = 1850,     /* keyword_verb_clause  */
  YYSYMBOL_keyword_set_special_case = 1851, /* keyword_set_special_case  */
  YYSYMBOL_keyword_sp_block_section = 1852, /* keyword_sp_block_section  */
  YYSYMBOL_keyword_sysvar_type = 1853,     /* keyword_sysvar_type  */
  YYSYMBOL_keyword_data_type = 1854,       /* keyword_data_type  */
  YYSYMBOL_keyword_sp_var_and_label = 1855, /* keyword_sp_var_and_label  */
  YYSYMBOL_set = 1856,                     /* set  */
  YYSYMBOL_1857_218 = 1857,                /* $@218  */
  YYSYMBOL_1858_219 = 1858,                /* $@219  */
  YYSYMBOL_1859_220 = 1859,                /* $@220  */
  YYSYMBOL_set_stmt_option_value_following_option_type_list = 1860, /* set_stmt_option_value_following_option_type_list  */
  YYSYMBOL_start_option_value_list = 1861, /* start_option_value_list  */
  YYSYMBOL_1862_221 = 1862,                /* $@221  */
  YYSYMBOL_1863_222 = 1863,                /* $@222  */
  YYSYMBOL_1864_223 = 1864,                /* $@223  */
  YYSYMBOL_start_option_value_list_following_option_type = 1865, /* start_option_value_list_following_option_type  */
  YYSYMBOL_1866_224 = 1866,                /* $@224  */
  YYSYMBOL_option_value_list_continued = 1867, /* option_value_list_continued  */
  YYSYMBOL_option_value_list = 1868,       /* option_value_list  */
  YYSYMBOL_1869_225 = 1869,                /* $@225  */
  YYSYMBOL_1870_226 = 1870,                /* $@226  */
  YYSYMBOL_option_value = 1871,            /* option_value  */
  YYSYMBOL_1872_227 = 1872,                /* $@227  */
  YYSYMBOL_option_type = 1873,             /* option_type  */
  YYSYMBOL_opt_var_type = 1874,            /* opt_var_type  */
  YYSYMBOL_opt_var_ident_type = 1875,      /* opt_var_ident_type  */
  YYSYMBOL_option_value_following_option_type = 1876, /* option_value_following_option_type  */
  YYSYMBOL_option_value_no_option_type = 1877, /* option_value_no_option_type  */
  YYSYMBOL_transaction_characteristics = 1878, /* transaction_characteristics  */
  YYSYMBOL_transaction_access_mode = 1879, /* transaction_access_mode  */
  YYSYMBOL_isolation_level = 1880,         /* isolation_level  */
  YYSYMBOL_transaction_access_mode_types = 1881, /* transaction_access_mode_types  */
  YYSYMBOL_isolation_types = 1882,         /* isolation_types  */
  YYSYMBOL_opt_for_user = 1883,            /* opt_for_user  */
  YYSYMBOL_text_or_password = 1884,        /* text_or_password  */
  YYSYMBOL_set_expr_or_default = 1885,     /* set_expr_or_default  */
  YYSYMBOL_lock = 1886,                    /* lock  */
  YYSYMBOL_1887_228 = 1887,                /* $@228  */
  YYSYMBOL_opt_lock_wait_timeout = 1888,   /* opt_lock_wait_timeout  */
  YYSYMBOL_table_or_tables = 1889,         /* table_or_tables  */
  YYSYMBOL_table_lock_list = 1890,         /* table_lock_list  */
  YYSYMBOL_table_lock = 1891,              /* table_lock  */
  YYSYMBOL_lock_option = 1892,             /* lock_option  */
  YYSYMBOL_unlock = 1893,                  /* unlock  */
  YYSYMBOL_1894_229 = 1894,                /* $@229  */
  YYSYMBOL_handler = 1895,                 /* handler  */
  YYSYMBOL_1896_230 = 1896,                /* $@230  */
  YYSYMBOL_handler_tail = 1897,            /* handler_tail  */
  YYSYMBOL_1898_231 = 1898,                /* $@231  */
  YYSYMBOL_handler_read_or_scan = 1899,    /* handler_read_or_scan  */
  YYSYMBOL_handler_scan_function = 1900,   /* handler_scan_function  */
  YYSYMBOL_handler_rkey_function = 1901,   /* handler_rkey_function  */
  YYSYMBOL_1902_232 = 1902,                /* $@232  */
  YYSYMBOL_handler_rkey_mode = 1903,       /* handler_rkey_mode  */
  YYSYMBOL_revoke = 1904,                  /* revoke  */
  YYSYMBOL_revoke_command = 1905,          /* revoke_command  */
  YYSYMBOL_admin_option_for_role = 1906,   /* admin_option_for_role  */
  YYSYMBOL_grant = 1907,                   /* grant  */
  YYSYMBOL_grant_command = 1908,           /* grant_command  */
  YYSYMBOL_opt_with_admin = 1909,          /* opt_with_admin  */
  YYSYMBOL_opt_with_admin_option = 1910,   /* opt_with_admin_option  */
  YYSYMBOL_role_list = 1911,               /* role_list  */
  YYSYMBOL_current_role = 1912,            /* current_role  */
  YYSYMBOL_grant_role = 1913,              /* grant_role  */
  YYSYMBOL_opt_table = 1914,               /* opt_table  */
  YYSYMBOL_grant_privileges = 1915,        /* grant_privileges  */
  YYSYMBOL_opt_privileges = 1916,          /* opt_privileges  */
  YYSYMBOL_object_privilege_list = 1917,   /* object_privilege_list  */
  YYSYMBOL_object_privilege = 1918,        /* object_privilege  */
  YYSYMBOL_1919_233 = 1919,                /* $@233  */
  YYSYMBOL_1920_234 = 1920,                /* $@234  */
  YYSYMBOL_1921_235 = 1921,                /* $@235  */
  YYSYMBOL_1922_236 = 1922,                /* $@236  */
  YYSYMBOL_opt_and = 1923,                 /* opt_and  */
  YYSYMBOL_require_list = 1924,            /* require_list  */
  YYSYMBOL_require_list_element = 1925,    /* require_list_element  */
  YYSYMBOL_grant_ident = 1926,             /* grant_ident  */
  YYSYMBOL_user_list = 1927,               /* user_list  */
  YYSYMBOL_grant_list = 1928,              /* grant_list  */
  YYSYMBOL_user_and_role_list = 1929,      /* user_and_role_list  */
  YYSYMBOL_via_or_with = 1930,             /* via_or_with  */
  YYSYMBOL_using_or_as = 1931,             /* using_or_as  */
  YYSYMBOL_grant_user = 1932,              /* grant_user  */
  YYSYMBOL_auth_expression = 1933,         /* auth_expression  */
  YYSYMBOL_auth_token = 1934,              /* auth_token  */
  YYSYMBOL_opt_auth_str = 1935,            /* opt_auth_str  */
  YYSYMBOL_opt_column_list = 1936,         /* opt_column_list  */
  YYSYMBOL_column_list = 1937,             /* column_list  */
  YYSYMBOL_column_list_id = 1938,          /* column_list_id  */
  YYSYMBOL_opt_require_clause = 1939,      /* opt_require_clause  */
  YYSYMBOL_resource_option = 1940,         /* resource_option  */
  YYSYMBOL_resource_option_list = 1941,    /* resource_option_list  */
  YYSYMBOL_opt_resource_options = 1942,    /* opt_resource_options  */
  YYSYMBOL_opt_grant_options = 1943,       /* opt_grant_options  */
  YYSYMBOL_opt_grant_option = 1944,        /* opt_grant_option  */
  YYSYMBOL_grant_option_list = 1945,       /* grant_option_list  */
  YYSYMBOL_grant_option = 1946,            /* grant_option  */
  YYSYMBOL_begin_stmt_mariadb = 1947,      /* begin_stmt_mariadb  */
  YYSYMBOL_1948_237 = 1948,                /* $@237  */
  YYSYMBOL_compound_statement = 1949,      /* compound_statement  */
  YYSYMBOL_opt_not = 1950,                 /* opt_not  */
  YYSYMBOL_opt_work = 1951,                /* opt_work  */
  YYSYMBOL_opt_chain = 1952,               /* opt_chain  */
  YYSYMBOL_opt_release = 1953,             /* opt_release  */
  YYSYMBOL_commit = 1954,                  /* commit  */
  YYSYMBOL_rollback = 1955,                /* rollback  */
  YYSYMBOL_savepoint = 1956,               /* savepoint  */
  YYSYMBOL_release = 1957,                 /* release  */
  YYSYMBOL_unit_type_decl = 1958,          /* unit_type_decl  */
  YYSYMBOL_union_option = 1959,            /* union_option  */
  YYSYMBOL_query_expression_option = 1960, /* query_expression_option  */
  YYSYMBOL_definer_opt = 1961,             /* definer_opt  */
  YYSYMBOL_no_definer = 1962,              /* no_definer  */
  YYSYMBOL_definer = 1963,                 /* definer  */
  YYSYMBOL_view_algorithm = 1964,          /* view_algorithm  */
  YYSYMBOL_opt_view_suid = 1965,           /* opt_view_suid  */
  YYSYMBOL_view_suid = 1966,               /* view_suid  */
  YYSYMBOL_view_list_opt = 1967,           /* view_list_opt  */
  YYSYMBOL_view_list = 1968,               /* view_list  */
  YYSYMBOL_view_select = 1969,             /* view_select  */
  YYSYMBOL_1970_238 = 1970,                /* $@238  */
  YYSYMBOL_view_check_option = 1971,       /* view_check_option  */
  YYSYMBOL_trigger_action_order = 1972,    /* trigger_action_order  */
  YYSYMBOL_trigger_follows_precedes_clause = 1973, /* trigger_follows_precedes_clause  */
  YYSYMBOL_trigger_tail = 1974,            /* trigger_tail  */
  YYSYMBOL_1975_239 = 1975,                /* $@239  */
  YYSYMBOL_1976_240 = 1976,                /* $@240  */
  YYSYMBOL_1977_241 = 1977,                /* $@241  */
  YYSYMBOL_1978_242 = 1978,                /* $@242  */
  YYSYMBOL_1979_243 = 1979,                /* $@243  */
  YYSYMBOL_sf_return_type = 1980,          /* sf_return_type  */
  YYSYMBOL_1981_244 = 1981,                /* $@244  */
  YYSYMBOL_sf_c_chistics_and_body = 1982,  /* sf_c_chistics_and_body  */
  YYSYMBOL_1983_245 = 1983,                /* $@245  */
  YYSYMBOL_sp_tail = 1984,                 /* sp_tail  */
  YYSYMBOL_1985_246 = 1985,                /* $@246  */
  YYSYMBOL_1986_247 = 1986,                /* $@247  */
  YYSYMBOL_xa = 1987,                      /* xa  */
  YYSYMBOL_opt_format_xid = 1988,          /* opt_format_xid  */
  YYSYMBOL_xid = 1989,                     /* xid  */
  YYSYMBOL_begin_or_start = 1990,          /* begin_or_start  */
  YYSYMBOL_opt_join_or_resume = 1991,      /* opt_join_or_resume  */
  YYSYMBOL_opt_one_phase = 1992,           /* opt_one_phase  */
  YYSYMBOL_opt_suspend = 1993,             /* opt_suspend  */
  YYSYMBOL_1994_248 = 1994,                /* $@248  */
  YYSYMBOL_opt_migrate = 1995,             /* opt_migrate  */
  YYSYMBOL_install = 1996,                 /* install  */
  YYSYMBOL_uninstall = 1997,               /* uninstall  */
  YYSYMBOL_keep_gcc_happy = 1998           /* keep_gcc_happy  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 826 "/home/buildbot/git/sql/sql_yacc.yy"

/* avoid unintentional %union size increases, it's what a parser stack made of */
static_assert(sizeof(YYSTYPE) == sizeof(void*)*2+8, "%union size check");
bool my_yyoverflow(short **a, YYSTYPE **b, size_t *yystacksize);

#line 2789 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  733
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   100487

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  780
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  1219
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3407
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  5910

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   1012


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   773,     2,     2,     2,   762,   757,     2,
     769,   770,   760,   759,   772,   758,   777,   761,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   779,   776,
     755,   753,   754,     2,   778,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   763,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   774,   756,   775,   764,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   765,   766,
     767,   768,   771
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,  2263,  2263,  2273,  2272,  2297,  2304,  2306,  2310,  2311,
    2312,  2317,  2318,  2319,  2320,  2321,  2322,  2323,  2324,  2325,
    2326,  2327,  2328,  2329,  2330,  2331,  2332,  2333,  2334,  2335,
    2336,  2337,  2338,  2339,  2340,  2341,  2342,  2343,  2344,  2345,
    2346,  2347,  2348,  2349,  2350,  2351,  2352,  2353,  2354,  2355,
    2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,  2365,
    2366,  2367,  2368,  2369,  2370,  2371,  2372,  2373,  2374,  2375,
    2379,  2386,  2387,  2392,  2391,  2402,  2408,  2410,  2407,  2419,
    2421,  2420,  2430,  2435,  2447,  2446,  2463,  2462,  2471,  2472,
    2476,  2480,  2484,  2488,  2492,  2496,  2506,  2511,  2515,  2519,
    2523,  2527,  2531,  2536,  2540,  2545,  2573,  2577,  2581,  2586,
    2589,  2591,  2592,  2596,  2602,  2604,  2605,  2609,  2615,  2617,
    2618,  2622,  2629,  2633,  2648,  2652,  2658,  2664,  2670,  2680,
    2684,  2688,  2702,  2714,  2701,  2738,  2737,  2793,  2800,  2792,
    2812,  2818,  2811,  2830,  2836,  2829,  2848,  2847,  2862,  2860,
    2876,  2874,  2888,  2887,  2898,  2897,  2907,  2906,  2918,  2916,
    2930,  2928,  2940,  2947,  2954,  2961,  2965,  2969,  2969,  2975,
    2976,  2980,  2981,  2985,  2990,  2996,  3002,  3010,  3016,  3022,
    3030,  3038,  3046,  3054,  3062,  3070,  3082,  3098,  3098,  3102,
    3101,  3113,  3114,  3118,  3123,  3128,  3133,  3138,  3143,  3148,
    3156,  3155,  3188,  3187,  3194,  3201,  3202,  3208,  3214,  3224,
    3230,  3236,  3238,  3245,  3246,  3250,  3260,  3261,  3269,  3269,
    3311,  3323,  3324,  3328,  3333,  3341,  3342,  3346,  3347,  3352,
    3354,  3356,  3358,  3360,  3362,  3364,  3370,  3371,  3375,  3376,
    3381,  3380,  3391,  3390,  3401,  3400,  3413,  3415,  3418,  3420,
    3424,  3428,  3437,  3442,  3442,  3452,  3453,  3457,  3465,  3470,
    3477,  3483,  3488,  3493,  3501,  3503,  3507,  3508,  3512,  3516,
    3517,  3518,  3519,  3524,  3523,  3535,  3536,  3540,  3541,  3546,
    3549,  3561,  3566,  3572,  3578,  3587,  3595,  3599,  3604,  3612,
    3616,  3623,  3633,  3641,  3649,  3660,  3661,  3668,  3670,  3669,
    3688,  3687,  3701,  3703,  3708,  3718,  3717,  3736,  3737,  3738,
    3739,  3744,  3746,  3751,  3766,  3774,  3778,  3798,  3799,  3803,
    3807,  3813,  3819,  3825,  3831,  3841,  3846,  3854,  3862,  3877,
    3883,  3884,  3890,  3893,  3897,  3905,  3922,  3924,  3942,  3948,
    3950,  3952,  3954,  3956,  3958,  3960,  3962,  3964,  3966,  3968,
    3970,  3975,  3983,  3999,  4000,  4005,  4011,  4020,  4027,  4036,
    4045,  4050,  4059,  4061,  4063,  4072,  4077,  4084,  4093,  4102,
    4104,  4106,  4108,  4110,  4112,  4114,  4116,  4118,  4120,  4122,
    4124,  4126,  4131,  4132,  4140,  4152,  4167,  4168,  4181,  4182,
    4183,  4184,  4185,  4189,  4190,  4191,  4192,  4193,  4194,  4195,
    4196,  4197,  4198,  4202,  4203,  4204,  4205,  4210,  4209,  4220,
    4220,  4242,  4243,  4248,  4247,  4265,  4276,  4276,  4289,  4294,
    4299,  4305,  4314,  4319,  4324,  4330,  4340,  4348,  4356,  4364,
    4374,  4373,  4395,  4394,  4415,  4421,  4429,  4430,  4434,  4442,
    4447,  4452,  4460,  4461,  4469,  4487,  4503,  4522,  4528,  4545,
    4522,  4564,  4566,  4567,  4572,  4571,  4641,  4647,  4641,  4657,
    4662,  4663,  4667,  4668,  4673,  4679,  4672,  4700,  4706,  4699,
    4725,  4735,  4739,  4743,  4744,  4748,  4759,  4757,  4774,  4773,
    4788,  4787,  4804,  4805,  4810,  4809,  4823,  4828,  4835,  4844,
    4859,  4858,  4878,  4877,  4902,  4911,  4910,  4918,  4917,  4928,
    4933,  4942,  4927,  4952,  4951,  4962,  4961,  4971,  4970,  4983,
    4990,  4982,  5007,  5006,  5018,  5020,  5025,  5027,  5029,  5046,
    5051,  5057,  5064,  5065,  5073,  5079,  5088,  5094,  5100,  5101,
    5105,  5105,  5110,  5111,  5112,  5116,  5117,  5118,  5122,  5126,
    5127,  5128,  5132,  5133,  5134,  5135,  5136,  5137,  5138,  5139,
    5143,  5147,  5148,  5149,  5153,  5154,  5155,  5156,  5157,  5161,
    5165,  5166,  5167,  5171,  5172,  5173,  5174,  5175,  5176,  5177,
    5181,  5185,  5186,  5187,  5191,  5192,  5193,  5198,  5206,  5214,
    5222,  5235,  5248,  5253,  5258,  5266,  5274,  5282,  5290,  5298,
    5306,  5314,  5324,  5334,  5344,  5346,  5350,  5355,  5365,  5366,
    5379,  5378,  5381,  5382,  5396,  5397,  5401,  5402,  5411,  5416,
    5427,  5464,  5465,  5470,  5469,  5485,  5500,  5499,  5521,  5520,
    5526,  5534,  5533,  5536,  5538,  5541,  5540,  5549,  5552,  5551,
    5560,  5561,  5567,  5568,  5585,  5586,  5590,  5591,  5595,  5609,
    5619,  5630,  5639,  5640,  5653,  5655,  5654,  5659,  5657,  5668,
    5669,  5673,  5687,  5699,  5700,  5713,  5722,  5744,  5745,  5750,
    5749,  5773,  5785,  5801,  5800,  5815,  5814,  5828,  5833,  5838,
    5858,  5876,  5880,  5907,  5919,  5920,  5925,  5934,  5924,  5959,
    5960,  5964,  5975,  5994,  6007,  6033,  6034,  6039,  6038,  6075,
    6084,  6085,  6089,  6090,  6094,  6096,  6102,  6108,  6110,  6112,
    6114,  6116,  6118,  6123,  6124,  6124,  6131,  6147,  6150,  6167,
    6168,  6172,  6173,  6177,  6178,  6182,  6183,  6188,  6191,  6199,
    6202,  6209,  6213,  6219,  6221,  6225,  6226,  6230,  6231,  6232,
    6236,  6251,  6256,  6261,  6266,  6271,  6276,  6281,  6296,  6302,
    6317,  6322,  6337,  6343,  6361,  6366,  6371,  6376,  6381,  6386,
    6392,  6391,  6417,  6418,  6419,  6424,  6429,  6434,  6436,  6438,
    6440,  6446,  6451,  6456,  6465,  6474,  6480,  6486,  6491,  6494,
    6496,  6500,  6519,  6527,  6542,  6552,  6563,  6564,  6565,  6566,
    6567,  6568,  6569,  6573,  6574,  6575,  6579,  6580,  6581,  6582,
    6587,  6594,  6601,  6602,  6606,  6607,  6608,  6609,  6610,  6614,
    6616,  6622,  6621,  6629,  6628,  6636,  6635,  6643,  6642,  6652,
    6649,  6660,  6658,  6667,  6666,  6705,  6713,  6721,  6729,  6730,
    6734,  6744,  6745,  6749,  6750,  6754,  6759,  6758,  6796,  6796,
    6799,  6798,  6809,  6810,  6814,  6815,  6819,  6820,  6824,  6825,
    6829,  6830,  6831,  6832,  6834,  6833,  6839,  6844,  6852,  6853,
    6858,  6861,  6865,  6869,  6876,  6877,  6881,  6882,  6886,  6892,
    6898,  6899,  6907,  6906,  6928,  6929,  6939,  6947,  6959,  6959,
    6962,  6963,  6970,  6978,  6982,  6990,  6991,  6992,  6993,  6994,
    6998,  6999,  7000,  7016,  7020,  7024,  7028,  7030,  7037,  7039,
    7044,  7046,  7047,  7048,  7052,  7056,  7061,  7066,  7070,  7074,
    7079,  7084,  7092,  7110,  7111,  7118,  7125,  7133,  7138,  7143,
    7148,  7153,  7164,  7169,  7174,  7179,  7181,  7183,  7185,  7187,
    7189,  7191,  7193,  7201,  7203,  7208,  7209,  7210,  7211,  7212,
    7213,  7214,  7215,  7219,  7223,  7224,  7228,  7229,  7233,  7234,
    7235,  7236,  7237,  7241,  7242,  7243,  7244,  7245,  7249,  7255,
    7256,  7261,  7263,  7270,  7271,  7272,  7276,  7280,  7281,  7282,
    7283,  7284,  7285,  7289,  7290,  7291,  7292,  7296,  7297,  7301,
    7302,  7306,  7307,  7312,  7313,  7317,  7318,  7319,  7326,  7327,
    7333,  7340,  7344,  7345,  7349,  7350,  7354,  7362,  7370,  7379,
    7383,  7389,  7393,  7394,  7403,  7412,  7418,  7424,  7437,  7443,
    7453,  7454,  7458,  7463,  7467,  7468,  7472,  7473,  7477,  7484,
    7488,  7489,  7493,  7501,  7502,  7506,  7507,  7511,  7512,  7516,
    7517,  7518,  7525,  7529,  7530,  7534,  7535,  7536,  7537,  7538,
    7550,  7554,  7555,  7560,  7559,  7572,  7573,  7577,  7580,  7581,
    7582,  7583,  7587,  7595,  7602,  7603,  7607,  7617,  7618,  7622,
    7623,  7626,  7628,  7632,  7644,  7645,  7649,  7656,  7669,  7670,
    7672,  7674,  7680,  7685,  7691,  7697,  7704,  7714,  7715,  7716,
    7717,  7718,  7722,  7723,  7727,  7728,  7732,  7733,  7737,  7738,
    7739,  7743,  7744,  7748,  7752,  7764,  7765,  7769,  7770,  7774,
    7775,  7779,  7780,  7784,  7785,  7789,  7790,  7794,  7795,  7800,
    7801,  7802,  7806,  7808,  7813,  7818,  7820,  7828,  7836,  7842,
    7851,  7852,  7856,  7860,  7861,  7871,  7872,  7873,  7877,  7881,
    7888,  7894,  7906,  7907,  7911,  7913,  7923,  7939,  7922,  7961,
    7960,  7977,  7986,  7985,  8006,  8005,  8026,  8025,  8044,  8038,
    8057,  8056,  8095,  8100,  8105,  8110,  8116,  8115,  8122,  8129,
    8137,  8128,  8159,  8163,  8171,  8174,  8178,  8182,  8190,  8192,
    8193,  8194,  8195,  8199,  8200,  8201,  8202,  8206,  8207,  8219,
    8220,  8224,  8225,  8228,  8230,  8238,  8246,  8248,  8250,  8251,
    8259,  8260,  8266,  8275,  8273,  8286,  8299,  8298,  8311,  8309,
    8322,  8329,  8339,  8340,  8349,  8356,  8360,  8366,  8364,  8381,
    8383,  8388,  8396,  8395,  8409,  8413,  8412,  8424,  8425,  8429,
    8442,  8443,  8447,  8451,  8458,  8463,  8467,  8474,  8481,  8485,
    8490,  8498,  8506,  8516,  8527,  8537,  8548,  8558,  8564,  8570,
    8577,  8583,  8597,  8611,  8616,  8620,  8625,  8626,  8627,  8632,
    8637,  8641,  8651,  8653,  8654,  8655,  8656,  8660,  8665,  8673,
    8678,  8686,  8687,  8691,  8692,  8696,  8696,  8699,  8701,  8705,
    8706,  8710,  8711,  8719,  8720,  8721,  8725,  8726,  8731,  8740,
    8741,  8742,  8743,  8748,  8747,  8757,  8756,  8764,  8771,  8781,
    8798,  8801,  8808,  8812,  8819,  8823,  8827,  8834,  8834,  8840,
    8841,  8845,  8846,  8847,  8851,  8852,  8861,  8868,  8869,  8874,
    8873,  8885,  8886,  8887,  8891,  8893,  8892,  8899,  8898,  8919,
    8920,  8924,  8925,  8929,  8930,  8931,  8935,  8936,  8941,  8940,
    8961,  8962,  8966,  8971,  8972,  8979,  8981,  8986,  8988,  8987,
    9000,  9002,  9001,  9015,  9016,  9021,  9030,  9031,  9032,  9036,
    9043,  9053,  9061,  9070,  9072,  9071,  9077,  9076,  9099,  9100,
    9104,  9105,  9109,  9110,  9111,  9112,  9113,  9114,  9118,  9119,
    9124,  9123,  9144,  9145,  9146,  9151,  9150,  9160,  9167,  9173,
    9182,  9183,  9187,  9203,  9202,  9215,  9216,  9220,  9221,  9225,
    9236,  9247,  9248,  9253,  9252,  9267,  9268,  9272,  9273,  9277,
    9288,  9300,  9299,  9307,  9307,  9316,  9317,  9322,  9323,  9333,
    9332,  9347,  9346,  9365,  9364,  9381,  9379,  9400,  9401,  9406,
    9405,  9419,  9429,  9418,  9439,  9451,  9515,  9520,  9535,  9536,
    9551,  9550,  9566,  9565,  9578,  9580,  9595,  9603,  9601,  9617,
    9635,  9637,  9647,  9651,  9692,  9701,  9711,  9712,  9716,  9720,
    9726,  9733,  9735,  9744,  9748,  9752,  9759,  9768,  9772,  9779,
    9796,  9799,  9807,  9810,  9817,  9821,  9825,  9829,  9836,  9837,
    9841,  9842,  9851,  9864,  9870,  9881,  9884,  9893,  9896,  9901,
    9909,  9910,  9911,  9925,  9930,  9952,  9958,  9964,  9970,  9971,
    9972,  9973,  9974,  9978,  9979,  9980,  9984,  9985,  9986,  9990,
    9991,  9996, 10047, 10054, 10097, 10103, 10107, 10113, 10119, 10125,
   10131, 10137, 10143, 10149, 10155, 10161, 10167, 10173, 10177, 10183,
   10192, 10198, 10206, 10212, 10221, 10227, 10235, 10245, 10251, 10258,
   10265, 10273, 10279, 10288, 10292, 10298, 10304, 10310, 10316, 10323,
   10329, 10335, 10341, 10347, 10354, 10360, 10366, 10372, 10378, 10384,
   10390, 10396, 10402, 10406, 10407, 10411, 10412, 10416, 10417, 10421,
   10422, 10426, 10427, 10428, 10429, 10430, 10431, 10435, 10436, 10441,
   10445, 10449, 10450, 10451, 10455, 10456, 10457, 10458, 10459, 10460,
   10464, 10465, 10466, 10471, 10470, 10476, 10484, 10507, 10514, 10523,
   10524, 10525, 10526, 10530, 10539, 10540, 10544, 10548, 10549, 10550,
   10551, 10552, 10553, 10554, 10586, 10587, 10588, 10589, 10590, 10591,
   10592, 10593, 10594, 10602, 10610, 10611, 10618, 10624, 10629, 10639,
   10644, 10649, 10655, 10660, 10666, 10677, 10684, 10689, 10694, 10699,
   10704, 10709, 10714, 10722, 10723, 10724, 10725, 10733, 10734, 10742,
   10743, 10749, 10753, 10759, 10765, 10774, 10775, 10784, 10791, 10805,
   10811, 10817, 10826, 10835, 10841, 10847, 10853, 10859, 10874, 10885,
   10891, 10897, 10903, 10909, 10915, 10923, 10930, 10934, 10940, 10948,
   10957, 10958, 10962, 10966, 10973, 10977, 10997, 11004, 11010, 11017,
   11024, 11030, 11036, 11042, 11048, 11054, 11060, 11067, 11073, 11080,
   11086, 11092, 11110, 11116, 11122, 11127, 11134, 11141, 11149, 11156,
   11163, 11170, 11177, 11194, 11200, 11206, 11212, 11218, 11225, 11231,
   11237, 11246, 11257, 11264, 11270, 11276, 11283, 11291, 11297, 11303,
   11309, 11315, 11323, 11329, 11335, 11341, 11347, 11355, 11367, 11374,
   11389, 11395, 11402, 11409, 11416, 11423, 11430, 11434, 11441, 11459,
   11458, 11527, 11532, 11537, 11542, 11547, 11552, 11557, 11577, 11579,
   11584, 11585, 11589, 11590, 11594, 11595, 11599, 11606, 11614, 11641,
   11647, 11653, 11659, 11665, 11671, 11680, 11687, 11689, 11686, 11696,
   11707, 11713, 11719, 11725, 11731, 11737, 11743, 11749, 11755, 11762,
   11761, 11786, 11795, 11813, 11815, 11817, 11832, 11839, 11846, 11853,
   11860, 11867, 11874, 11881, 11888, 11895, 11906, 11913, 11924, 11935,
   11955, 11954, 11960, 11977, 11983, 11992, 12001, 12011, 12010, 12022,
   12032, 12040, 12045, 12053, 12054, 12059, 12064, 12067, 12069, 12073,
   12078, 12086, 12087, 12091, 12095, 12102, 12109, 12116, 12129, 12128,
   12145, 12148, 12147, 12152, 12151, 12156, 12155, 12159, 12164, 12165,
   12169, 12170, 12171, 12172, 12173, 12174, 12175, 12176, 12180, 12181,
   12182, 12183, 12190, 12191, 12195, 12200, 12208, 12209, 12213, 12220,
   12228, 12237, 12247, 12248, 12259, 12260, 12272, 12283, 12284, 12290,
   12295, 12309, 12317, 12315, 12335, 12333, 12346, 12358, 12356, 12376,
   12375, 12387, 12400, 12398, 12419, 12418, 12431, 12445, 12446, 12447,
   12451, 12452, 12460, 12461, 12465, 12474, 12475, 12476, 12481, 12485,
   12486, 12490, 12491, 12495, 12496, 12504, 12512, 12520, 12521, 12534,
   12552, 12561, 12562, 12567, 12570, 12571, 12572, 12576, 12577, 12582,
   12581, 12587, 12586, 12594, 12595, 12598, 12600, 12600, 12604, 12604,
   12609, 12610, 12614, 12616, 12621, 12622, 12626, 12637, 12651, 12652,
   12653, 12654, 12655, 12656, 12657, 12658, 12659, 12660, 12661, 12662,
   12666, 12667, 12668, 12669, 12670, 12671, 12672, 12673, 12674, 12678,
   12679, 12680, 12681, 12684, 12686, 12687, 12691, 12692, 12696, 12704,
   12706, 12710, 12712, 12711, 12725, 12728, 12727, 12745, 12747, 12751,
   12756, 12764, 12765, 12782, 12805, 12806, 12812, 12813, 12817, 12830,
   12829, 12838, 12839, 12848, 12849, 12853, 12854, 12858, 12859, 12873,
   12874, 12878, 12888, 12897, 12904, 12911, 12921, 12922, 12929, 12939,
   12940, 12942, 12944, 12946, 12948, 12957, 12961, 12962, 12966, 12980,
   12981, 12987, 12986, 12997, 13003, 13012, 13013, 13014, 13019, 13020,
   13025, 13032, 13038, 13048, 13057, 13063, 13069, 13078, 13083, 13088,
   13092, 13098, 13104, 13113, 13122, 13126, 13133, 13134, 13138, 13143,
   13148, 13161, 13165, 13169, 13173, 13178, 13181, 13185, 13198, 13206,
   13219, 13221, 13225, 13226, 13230, 13231, 13232, 13233, 13234, 13235,
   13239, 13240, 13241, 13242, 13243, 13247, 13248, 13249, 13250, 13254,
   13255, 13256, 13257, 13258, 13262, 13263, 13264, 13265, 13266, 13270,
   13275, 13276, 13280, 13281, 13285, 13286, 13287, 13292, 13291, 13323,
   13324, 13328, 13329, 13333, 13343, 13343, 13355, 13356, 13359, 13379,
   13383, 13388, 13396, 13402, 13413, 13401, 13415, 13430, 13442, 13441,
   13464, 13463, 13473, 13472, 13495, 13501, 13515, 13530, 13538, 13542,
   13547, 13546, 13555, 13560, 13566, 13571, 13576, 13583, 13581, 13595,
   13596, 13600, 13612, 13625, 13626, 13630, 13644, 13648, 13657, 13660,
   13667, 13668, 13676, 13688, 13675, 13703, 13714, 13702, 13729, 13737,
   13738, 13745, 13749, 13750, 13759, 13760, 13764, 13764, 13777, 13778,
   13780, 13779, 13792, 13798, 13800, 13804, 13806, 13812, 13816, 13817,
   13821, 13822, 13826, 13836, 13837, 13841, 13842, 13846, 13847, 13851,
   13852, 13857, 13856, 13872, 13871, 13886, 13887, 13891, 13892, 13896,
   13901, 13909, 13917, 13928, 13929, 13938, 13939, 13947, 13949, 13951,
   13949, 13961, 13975, 13982, 13992, 13981, 14021, 14022, 14026, 14033,
   14041, 14042, 14046, 14056, 14057, 14064, 14063, 14084, 14087, 14094,
   14095, 14105, 14120, 14128, 14141, 14140, 14155, 14154, 14170, 14172,
   14176, 14177, 14181, 14196, 14214, 14215, 14219, 14220, 14224, 14225,
   14226, 14231, 14230, 14251, 14253, 14256, 14258, 14261, 14262, 14265,
   14269, 14273, 14277, 14281, 14285, 14289, 14293, 14297, 14305, 14308,
   14318, 14317, 14336, 14343, 14351, 14359, 14367, 14375, 14383, 14390,
   14397, 14403, 14405, 14407, 14416, 14420, 14425, 14424, 14431, 14430,
   14436, 14445, 14452, 14457, 14462, 14467, 14472, 14477, 14479, 14481,
   14483, 14490, 14498, 14500, 14508, 14515, 14522, 14530, 14536, 14541,
   14549, 14557, 14565, 14569, 14574, 14581, 14586, 14593, 14600, 14606,
   14612, 14618, 14626, 14631, 14638, 14645, 14652, 14659, 14664, 14669,
   14674, 14679, 14686, 14708, 14710, 14712, 14717, 14718, 14721, 14723,
   14727, 14728, 14732, 14733, 14737, 14738, 14742, 14743, 14747, 14748,
   14752, 14753, 14761, 14773, 14772, 14791, 14790, 14800, 14801, 14802,
   14803, 14804, 14805, 14809, 14810, 14814, 14821, 14822, 14824, 14825,
   14829, 14830, 14843, 14844, 14845, 14860, 14859, 14871, 14870, 14882,
   14887, 14888, 14903, 14906, 14905, 14918, 14919, 14924, 14926, 14928,
   14930, 14932, 14934, 14942, 14944, 14946, 14948, 14953, 14955, 14963,
   14965, 14967, 14969, 14971, 14988, 14989, 14993, 14997, 15010, 15009,
   15024, 15034, 15035, 15038, 15040, 15041, 15045, 15061, 15062, 15067,
   15066, 15076, 15077, 15081, 15081, 15085, 15084, 15090, 15094, 15095,
   15099, 15100, 15107, 15112, 15111, 15126, 15125, 15140, 15141, 15142,
   15146, 15147, 15148, 15157, 15158, 15162, 15166, 15174, 15174, 15179,
   15180, 15189, 15201, 15215, 15226, 15239, 15200, 15252, 15253, 15257,
   15258, 15262, 15263, 15271, 15275, 15276, 15277, 15280, 15282, 15286,
   15287, 15291, 15296, 15303, 15308, 15315, 15317, 15321, 15322, 15326,
   15331, 15339, 15340, 15344, 15346, 15354, 15355, 15359, 15360, 15361,
   15365, 15367, 15372, 15373, 15382, 15383, 15387, 15388, 15392, 15405,
   15410, 15415, 15420, 15428, 15436, 15441, 15449, 15457, 15472, 15479,
   15485, 15495, 15496, 15504, 15505, 15506, 15507, 15521, 15527, 15533,
   15539, 15545, 15551, 15570, 15580, 15590, 15596, 15603, 15613, 15620,
   15627, 15638, 15637, 15662, 15663, 15668, 15669, 15676, 15674, 15701,
   15702, 15708, 15713, 15722, 15740, 15741, 15745, 15750, 15758, 15763,
   15771, 15776, 15781, 15786, 15792, 15797, 15805, 15810, 15815, 15820,
   15826, 15834, 15835, 15846, 15854, 15858, 15864, 15870, 15880, 15886,
   15895, 15905, 15906, 15910, 15911, 15912, 15916, 15924, 15932, 15940,
   15948, 15949, 15957, 15958, 15966, 15967, 15972, 15981, 15982, 15990,
   15991, 15999, 16000, 16001, 16005, 16016, 16045, 16054, 16054, 16056,
   16066, 16067, 16068, 16069, 16070, 16071, 16072, 16073, 16078, 16079,
   16080, 16081, 16082, 16083, 16084, 16085, 16086, 16094, 16095, 16096,
   16097, 16101, 16102, 16103, 16104, 16105, 16106, 16107, 16108, 16112,
   16113, 16114, 16115, 16116, 16117, 16118, 16119, 16120, 16124, 16125,
   16126, 16127, 16128, 16129, 16130, 16131, 16144, 16145, 16146, 16147,
   16148, 16149, 16150, 16151, 16152, 16153, 16154, 16155, 16156, 16157,
   16158, 16159, 16160, 16161, 16162, 16163, 16164, 16165, 16166, 16167,
   16168, 16169, 16170, 16171, 16172, 16173, 16174, 16175, 16176, 16177,
   16178, 16179, 16180, 16181, 16182, 16183, 16184, 16185, 16186, 16187,
   16188, 16189, 16190, 16191, 16192, 16193, 16194, 16195, 16196, 16197,
   16198, 16239, 16240, 16241, 16242, 16243, 16244, 16255, 16256, 16257,
   16258, 16259, 16260, 16261, 16262, 16263, 16264, 16268, 16269, 16270,
   16277, 16278, 16279, 16283, 16284, 16285, 16294, 16295, 16296, 16297,
   16298, 16299, 16300, 16301, 16302, 16303, 16304, 16305, 16306, 16307,
   16308, 16309, 16310, 16311, 16312, 16313, 16314, 16315, 16316, 16317,
   16318, 16319, 16320, 16321, 16322, 16323, 16324, 16325, 16326, 16327,
   16335, 16336, 16337, 16338, 16339, 16340, 16341, 16342, 16343, 16344,
   16345, 16346, 16347, 16348, 16349, 16350, 16351, 16352, 16353, 16354,
   16355, 16356, 16357, 16358, 16359, 16360, 16361, 16362, 16363, 16364,
   16365, 16366, 16367, 16368, 16369, 16370, 16371, 16372, 16373, 16374,
   16375, 16376, 16377, 16378, 16379, 16380, 16381, 16386, 16387, 16388,
   16389, 16390, 16391, 16392, 16393, 16394, 16395, 16396, 16397, 16398,
   16399, 16400, 16401, 16402, 16403, 16404, 16405, 16406, 16407, 16408,
   16409, 16410, 16411, 16412, 16413, 16414, 16415, 16416, 16417, 16418,
   16419, 16420, 16421, 16422, 16423, 16424, 16425, 16426, 16427, 16428,
   16429, 16430, 16431, 16432, 16433, 16434, 16435, 16436, 16437, 16438,
   16439, 16440, 16441, 16442, 16443, 16444, 16445, 16446, 16447, 16448,
   16449, 16450, 16451, 16452, 16453, 16454, 16455, 16456, 16457, 16458,
   16459, 16460, 16461, 16462, 16463, 16464, 16465, 16466, 16467, 16468,
   16469, 16470, 16471, 16472, 16473, 16474, 16475, 16476, 16477, 16478,
   16479, 16480, 16481, 16482, 16483, 16484, 16485, 16486, 16487, 16488,
   16489, 16490, 16491, 16492, 16493, 16494, 16495, 16496, 16497, 16498,
   16499, 16500, 16501, 16502, 16503, 16504, 16505, 16506, 16507, 16508,
   16509, 16510, 16511, 16512, 16513, 16514, 16515, 16516, 16517, 16518,
   16519, 16520, 16521, 16522, 16523, 16524, 16525, 16526, 16527, 16528,
   16529, 16530, 16531, 16532, 16533, 16534, 16535, 16536, 16537, 16538,
   16539, 16540, 16541, 16542, 16543, 16544, 16545, 16546, 16547, 16548,
   16549, 16550, 16551, 16552, 16553, 16554, 16555, 16556, 16557, 16558,
   16559, 16560, 16561, 16562, 16563, 16564, 16565, 16566, 16567, 16568,
   16569, 16570, 16571, 16572, 16573, 16574, 16575, 16576, 16577, 16578,
   16579, 16580, 16581, 16582, 16583, 16584, 16585, 16586, 16587, 16588,
   16589, 16590, 16591, 16592, 16593, 16594, 16595, 16596, 16597, 16598,
   16599, 16600, 16601, 16602, 16603, 16604, 16605, 16606, 16607, 16608,
   16609, 16610, 16611, 16612, 16613, 16614, 16615, 16616, 16617, 16618,
   16619, 16620, 16621, 16622, 16623, 16624, 16625, 16626, 16627, 16628,
   16629, 16630, 16631, 16632, 16633, 16634, 16635, 16636, 16637, 16638,
   16639, 16640, 16641, 16642, 16643, 16644, 16645, 16646, 16647, 16648,
   16649, 16650, 16651, 16652, 16653, 16665, 16664, 16681, 16687, 16680,
   16707, 16708, 16714, 16713, 16720, 16719, 16729, 16728, 16739, 16738,
   16744, 16752, 16754, 16759, 16759, 16769, 16768, 16783, 16782, 16787,
   16791, 16792, 16793, 16797, 16798, 16799, 16800, 16804, 16805, 16806,
   16807, 16812, 16817, 16822, 16831, 16836, 16841, 16846, 16851, 16856,
   16861, 16866, 16880, 16891, 16910, 16928, 16940, 16948, 16953, 16969,
   16970, 16971, 16972, 16976, 16995, 17013, 17014, 17018, 17019, 17020,
   17021, 17025, 17039, 17043, 17048, 17053, 17064, 17065, 17066, 17072,
   17078, 17090, 17089, 17103, 17104, 17110, 17119, 17120, 17124, 17125,
   17129, 17148, 17149, 17150, 17155, 17156, 17161, 17160, 17178, 17177,
   17189, 17198, 17208, 17207, 17248, 17249, 17253, 17254, 17258, 17259,
   17260, 17261, 17263, 17262, 17275, 17276, 17277, 17278, 17279, 17285,
   17290, 17296, 17302, 17308, 17315, 17322, 17326, 17333, 17342, 17344,
   17349, 17354, 17361, 17368, 17375, 17382, 17389, 17396, 17408, 17409,
   17413, 17414, 17418, 17423, 17431, 17441, 17460, 17463, 17465, 17469,
   17470, 17477, 17479, 17483, 17484, 17489, 17488, 17492, 17491, 17495,
   17494, 17498, 17497, 17500, 17501, 17502, 17503, 17504, 17505, 17506,
   17507, 17508, 17509, 17510, 17511, 17512, 17513, 17514, 17515, 17516,
   17517, 17518, 17519, 17520, 17521, 17522, 17523, 17524, 17525, 17526,
   17530, 17531, 17535, 17536, 17540, 17547, 17554, 17564, 17574, 17583,
   17592, 17605, 17610, 17618, 17623, 17631, 17636, 17643, 17643, 17644,
   17644, 17647, 17653, 17659, 17664, 17671, 17677, 17684, 17693, 17697,
   17703, 17713, 17717, 17721, 17722, 17726, 17754, 17756, 17760, 17764,
   17768, 17775, 17780, 17785, 17790, 17795, 17803, 17804, 17808, 17809,
   17814, 17815, 17819, 17820, 17824, 17825, 17829, 17830, 17835, 17834,
   17844, 17853, 17854, 17858, 17859, 17864, 17865, 17866, 17871, 17872,
   17873, 17877, 17889, 17898, 17904, 17913, 17922, 17935, 17937, 17939,
   17947, 17948, 17949, 17953, 17954, 17960, 17961, 17962, 17963, 17964,
   17965, 17975, 17976, 17981, 17994, 18008, 18009, 18010, 18014, 18015,
   18019, 18020, 18025, 18026, 18030, 18036, 18045, 18045, 18059, 18060,
   18061, 18062, 18072, 18074, 18080, 18086, 18096, 18105, 18111, 18116,
   18120, 18094, 18170, 18169, 18186, 18185, 18201, 18209, 18200, 18223,
   18227, 18231, 18235, 18239, 18243, 18251, 18252, 18268, 18275, 18282,
   18292, 18293, 18294, 18298, 18299, 18300, 18304, 18305, 18310, 18312,
   18311, 18317, 18318, 18322, 18327, 18334, 18339, 18348
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ABORT_SYM",
  "ACCESSIBLE_SYM", "ADD", "ALL", "ALTER", "ANALYZE_SYM", "AND_AND_SYM",
  "AND_SYM", "AS", "ASC", "ASENSITIVE_SYM", "BEFORE_SYM", "BETWEEN_SYM",
  "BIGINT", "BINARY", "BIN_NUM", "BIT_AND", "BIT_OR", "BIT_XOR",
  "BLOB_MARIADB_SYM", "BLOB_ORACLE_SYM", "BODY_ORACLE_SYM", "BOTH", "BY",
  "CALL_SYM", "CASCADE", "CASE_SYM", "CAST_SYM", "CHANGE", "CHAR_SYM",
  "CHECK_SYM", "COLLATE_SYM", "CONDITION_SYM", "CONSTRAINT",
  "CONTINUE_MARIADB_SYM", "CONTINUE_ORACLE_SYM", "CONVERT_SYM",
  "COUNT_SYM", "CREATE", "CROSS", "CUME_DIST_SYM", "CURDATE",
  "CURRENT_USER", "CURRENT_ROLE", "CURSOR_SYM", "CURTIME", "DATABASE",
  "DATABASES", "DATE_ADD_INTERVAL", "DATE_SUB_INTERVAL", "DAY_HOUR_SYM",
  "DAY_MICROSECOND_SYM", "DAY_MINUTE_SYM", "DAY_SECOND_SYM", "DECIMAL_NUM",
  "DECIMAL_SYM", "DECLARE_MARIADB_SYM", "DECLARE_ORACLE_SYM", "DEFAULT",
  "DELETE_DOMAIN_ID_SYM", "DELETE_SYM", "DENSE_RANK_SYM", "DESC",
  "DESCRIBE", "DETERMINISTIC_SYM", "DISTINCT", "DIV_SYM", "DOUBLE_SYM",
  "DO_DOMAIN_IDS_SYM", "DOT_DOT_SYM", "DROP", "DUAL_SYM", "EACH_SYM",
  "ELSE", "ELSEIF_MARIADB_SYM", "ELSIF_ORACLE_SYM", "ENCLOSED",
  "END_OF_INPUT", "EQUAL_SYM", "ESCAPED", "EXCEPT_SYM", "EXISTS",
  "EXTRACT_SYM", "FALSE_SYM", "FETCH_SYM", "FIRST_VALUE_SYM", "FLOAT_NUM",
  "FLOAT_SYM", "FORCE_LOOKAHEAD", "FOREIGN", "FOR_SYM",
  "FOR_SYSTEM_TIME_SYM", "FROM", "FULLTEXT_SYM", "GE", "GOTO_ORACLE_SYM",
  "GRANT", "GROUP_SYM", "GROUP_CONCAT_SYM", "LAG_SYM", "LEAD_SYM",
  "HAVING", "HEX_NUM", "HEX_STRING", "HOUR_MICROSECOND_SYM",
  "HOUR_MINUTE_SYM", "HOUR_SECOND_SYM", "IDENT", "IDENT_QUOTED", "IF_SYM",
  "IGNORE_DOMAIN_IDS_SYM", "IGNORE_SYM", "INDEX_SYM", "INFILE",
  "INNER_SYM", "INOUT_SYM", "INSENSITIVE_SYM", "INSERT", "INTERSECT_SYM",
  "INTERVAL_SYM", "INTO", "INT_SYM", "IN_SYM", "IS", "ITERATE_SYM",
  "JOIN_SYM", "KEYS", "KEY_SYM", "KILL_SYM", "LE", "LEADING", "LEAVE_SYM",
  "LEFT", "LEFT_PAREN_ALT", "LEFT_PAREN_WITH", "LEFT_PAREN_LIKE",
  "LEX_HOSTNAME", "LIKE", "LIMIT", "LINEAR_SYM", "LINES", "LOAD",
  "LOCATOR_SYM", "LOCK_SYM", "LONGBLOB", "LONGTEXT", "LONG_NUM",
  "LONG_SYM", "LOOP_SYM", "LOW_PRIORITY",
  "MASTER_SSL_VERIFY_SERVER_CERT_SYM", "MATCH", "MAX_SYM", "MAXVALUE_SYM",
  "MEDIAN_SYM", "MEDIUMBLOB", "MEDIUMINT", "MEDIUMTEXT",
  "MINUTE_MICROSECOND_SYM", "MINUTE_SECOND_SYM", "MIN_SYM", "MODIFIES_SYM",
  "MOD_SYM", "MYSQL_CONCAT_SYM", "NATURAL", "NCHAR_STRING", "NE", "NEG",
  "NOT2_SYM", "NOT_SYM", "NOW_SYM", "NO_WRITE_TO_BINLOG", "NTILE_SYM",
  "NULL_SYM", "NUM", "NUMERIC_SYM", "NTH_VALUE_SYM", "ON", "OPTIMIZE",
  "OPTIONALLY", "ORACLE_CONCAT_SYM", "OR2_SYM", "ORDER_SYM", "OR_SYM",
  "OTHERS_ORACLE_SYM", "OUTER", "OUTFILE", "OUT_SYM", "OVER_SYM",
  "PACKAGE_ORACLE_SYM", "PAGE_CHECKSUM_SYM", "PARAM_MARKER",
  "PARSE_VCOL_EXPR_SYM", "PARTITION_SYM", "PERCENT_ORACLE_SYM",
  "PERCENT_RANK_SYM", "PERCENTILE_CONT_SYM", "PERCENTILE_DISC_SYM",
  "PORTION_SYM", "POSITION_SYM", "PRECISION", "PRIMARY_SYM",
  "PROCEDURE_SYM", "PURGE", "RAISE_ORACLE_SYM", "RANGE_SYM", "RANK_SYM",
  "READS_SYM", "READ_SYM", "READ_WRITE_SYM", "REAL", "RECURSIVE_SYM",
  "REF_SYSTEM_ID_SYM", "REFERENCES", "REGEXP", "RELEASE_SYM", "RENAME",
  "REPEAT_SYM", "REQUIRE_SYM", "RESIGNAL_SYM", "RESTRICT", "RETURNING_SYM",
  "RETURN_MARIADB_SYM", "RETURN_ORACLE_SYM", "REVOKE", "RIGHT", "ROWS_SYM",
  "ROWTYPE_ORACLE_SYM", "ROW_NUMBER_SYM", "SECOND_MICROSECOND_SYM",
  "SELECT_SYM", "SENSITIVE_SYM", "SEPARATOR_SYM", "SERVER_OPTIONS", "SET",
  "SET_VAR", "SHIFT_LEFT", "SHIFT_RIGHT", "SHOW", "SIGNAL_SYM", "SMALLINT",
  "SPATIAL_SYM", "SPECIFIC_SYM", "SQLEXCEPTION_SYM", "SQLSTATE_SYM",
  "SQLWARNING_SYM", "SQL_BIG_RESULT", "SQL_SMALL_RESULT", "SQL_SYM",
  "SSL_SYM", "STARTING", "STATS_AUTO_RECALC_SYM", "STATS_PERSISTENT_SYM",
  "STATS_SAMPLE_PAGES_SYM", "STDDEV_SAMP_SYM", "STD_SYM", "STRAIGHT_JOIN",
  "SUM_SYM", "SYSDATE", "TABLE_REF_PRIORITY", "TABLE_SYM", "TERMINATED",
  "TEXT_STRING", "THEN_SYM", "TINYBLOB", "TINYINT", "TINYTEXT", "TO_SYM",
  "TRAILING", "TRIGGER_SYM", "TRUE_SYM", "ULONGLONG_NUM",
  "UNDERSCORE_CHARSET", "UNDO_SYM", "UNION_SYM", "UNIQUE_SYM",
  "UNLOCK_SYM", "UNSIGNED", "UPDATE_SYM", "USAGE", "USE_SYM", "USING",
  "UTC_DATE_SYM", "UTC_TIMESTAMP_SYM", "UTC_TIME_SYM", "VALUES",
  "VALUES_IN_SYM", "VALUES_LESS_SYM", "VARBINARY", "VARCHAR",
  "VARIANCE_SYM", "VARYING", "VAR_SAMP_SYM", "WHEN_SYM", "WHERE",
  "WHILE_SYM", "WITH", "WITH_CUBE_SYM", "WITH_ROLLUP_SYM",
  "WITH_SYSTEM_SYM", "XOR", "YEAR_MONTH_SYM", "ZEROFILL",
  "IMPOSSIBLE_ACTION", "BODY_MARIADB_SYM", "ELSEIF_ORACLE_SYM",
  "ELSIF_MARIADB_SYM", "EXCEPTION_ORACLE_SYM", "GOTO_MARIADB_SYM",
  "OTHERS_MARIADB_SYM", "PACKAGE_MARIADB_SYM", "RAISE_MARIADB_SYM",
  "ROWTYPE_MARIADB_SYM", "REPLACE", "SUBSTRING", "TRIM", "ACCOUNT_SYM",
  "ACTION", "ADMIN_SYM", "ADDDATE_SYM", "AFTER_SYM", "AGAINST",
  "AGGREGATE_SYM", "ALGORITHM_SYM", "ALWAYS_SYM", "ANY_SYM", "ASCII_SYM",
  "AT_SYM", "ATOMIC_SYM", "AUTHORS_SYM", "AUTOEXTEND_SIZE_SYM", "AUTO_INC",
  "AUTO_SYM", "AVG_ROW_LENGTH", "AVG_SYM", "BACKUP_SYM",
  "BEGIN_MARIADB_SYM", "BEGIN_ORACLE_SYM", "BINLOG_SYM", "BIT_SYM",
  "BLOCK_SYM", "BOOL_SYM", "BOOLEAN_SYM", "BTREE_SYM", "BYTE_SYM",
  "CACHE_SYM", "CASCADED", "CATALOG_NAME_SYM", "CHAIN_SYM", "CHANGED",
  "CHARSET", "CHECKPOINT_SYM", "CHECKSUM_SYM", "CIPHER_SYM",
  "CLASS_ORIGIN_SYM", "CLIENT_SYM", "CLOB_MARIADB_SYM", "CLOB_ORACLE_SYM",
  "CLOSE_SYM", "COALESCE", "CODE_SYM", "COLLATION_SYM", "COLON_ORACLE_SYM",
  "COLUMNS", "COLUMN_ADD_SYM", "COLUMN_CHECK_SYM", "COLUMN_CREATE_SYM",
  "COLUMN_DELETE_SYM", "COLUMN_GET_SYM", "COLUMN_SYM", "COLUMN_NAME_SYM",
  "COMMENT_SYM", "COMMITTED_SYM", "COMMIT_SYM", "COMPACT_SYM",
  "COMPLETION_SYM", "COMPRESSED_SYM", "CONCURRENT", "CONNECTION_SYM",
  "CONSISTENT_SYM", "CONSTRAINT_CATALOG_SYM", "CONSTRAINT_NAME_SYM",
  "CONSTRAINT_SCHEMA_SYM", "CONTAINS_SYM", "CONTEXT_SYM",
  "CONTRIBUTORS_SYM", "CPU_SYM", "CUBE_SYM", "CURRENT_SYM",
  "CURRENT_POS_SYM", "CURSOR_NAME_SYM", "CYCLE_SYM", "DATAFILE_SYM",
  "DATA_SYM", "DATETIME", "DATE_FORMAT_SYM", "DATE_SYM", "DAY_SYM",
  "DEALLOCATE_SYM", "DEFINER_SYM", "DELAYED_SYM", "DELAY_KEY_WRITE_SYM",
  "DES_KEY_FILE", "DIAGNOSTICS_SYM", "DIRECTORY_SYM", "DISABLE_SYM",
  "DISCARD", "DISK_SYM", "DO_SYM", "DUMPFILE", "DUPLICATE_SYM",
  "DYNAMIC_SYM", "ENABLE_SYM", "END", "ENDS_SYM", "ENGINES_SYM",
  "ENGINE_SYM", "ENUM", "ERROR_SYM", "ERRORS", "ESCAPE_SYM", "EVENTS_SYM",
  "EVENT_SYM", "EVERY_SYM", "EXCHANGE_SYM", "EXAMINED_SYM", "EXCLUDE_SYM",
  "EXECUTE_SYM", "EXCEPTION_MARIADB_SYM", "EXIT_MARIADB_SYM",
  "EXIT_ORACLE_SYM", "EXPANSION_SYM", "EXPIRE_SYM", "EXPORT_SYM",
  "EXTENDED_SYM", "EXTENT_SIZE_SYM", "FAST_SYM", "FAULTS_SYM", "FILE_SYM",
  "FIRST_SYM", "FIXED_SYM", "FLUSH_SYM", "FOLLOWS_SYM", "FOLLOWING_SYM",
  "FORCE_SYM", "FORMAT_SYM", "FOUND_SYM", "FULL", "FUNCTION_SYM",
  "GENERAL", "GENERATED_SYM", "GEOMETRYCOLLECTION", "GEOMETRY_SYM",
  "GET_FORMAT", "GET_SYM", "GLOBAL_SYM", "GRANTS", "HANDLER_SYM",
  "HARD_SYM", "HASH_SYM", "HELP_SYM", "HIGH_PRIORITY", "HISTORY_SYM",
  "HOST_SYM", "HOSTS_SYM", "HOUR_SYM", "ID_SYM", "IDENTIFIED_SYM",
  "IGNORE_SERVER_IDS_SYM", "IMMEDIATE_SYM", "IMPORT", "INCREMENT_SYM",
  "INDEXES", "INITIAL_SIZE_SYM", "INSERT_METHOD", "INSTALL_SYM",
  "INVOKER_SYM", "IO_SYM", "IPC_SYM", "ISOLATION", "ISOPEN_SYM",
  "ISSUER_SYM", "INVISIBLE_SYM", "JSON_SYM", "KEY_BLOCK_SIZE",
  "LANGUAGE_SYM", "LAST_SYM", "LAST_VALUE", "LASTVAL_SYM", "LEAVES",
  "LESS_SYM", "LEVEL_SYM", "LINESTRING", "LIST_SYM", "LOCAL_SYM",
  "LOCKS_SYM", "LOGFILE_SYM", "LOGS_SYM", "MASTER_CONNECT_RETRY_SYM",
  "MASTER_DELAY_SYM", "MASTER_GTID_POS_SYM", "MASTER_HOST_SYM",
  "MASTER_LOG_FILE_SYM", "MASTER_LOG_POS_SYM", "MASTER_PASSWORD_SYM",
  "MASTER_PORT_SYM", "MASTER_SERVER_ID_SYM", "MASTER_SSL_CAPATH_SYM",
  "MASTER_SSL_CA_SYM", "MASTER_SSL_CERT_SYM", "MASTER_SSL_CIPHER_SYM",
  "MASTER_SSL_CRL_SYM", "MASTER_SSL_CRLPATH_SYM", "MASTER_SSL_KEY_SYM",
  "MASTER_SSL_SYM", "MASTER_SYM", "MASTER_USER_SYM", "MASTER_USE_GTID_SYM",
  "MASTER_HEARTBEAT_PERIOD_SYM", "MAX_CONNECTIONS_PER_HOUR",
  "MAX_QUERIES_PER_HOUR", "MAX_ROWS", "MAX_SIZE_SYM",
  "MAX_UPDATES_PER_HOUR", "MAX_STATEMENT_TIME_SYM",
  "MAX_USER_CONNECTIONS_SYM", "MEDIUM_SYM", "MEMORY_SYM", "MERGE_SYM",
  "MESSAGE_TEXT_SYM", "MICROSECOND_SYM", "MIGRATE_SYM", "MINUTE_SYM",
  "MINVALUE_SYM", "MIN_ROWS", "MODE_SYM", "MODIFY_SYM", "MONTH_SYM",
  "MULTILINESTRING", "MULTIPOINT", "MULTIPOLYGON", "MUTEX_SYM",
  "MYSQL_SYM", "MYSQL_ERRNO_SYM", "NAMES_SYM", "NAME_SYM", "NATIONAL_SYM",
  "NCHAR_SYM", "NEVER_SYM", "NEW_SYM", "NEXT_SYM", "NEXTVAL_SYM",
  "NOCACHE_SYM", "NOCYCLE_SYM", "NODEGROUP_SYM", "NONE_SYM",
  "NOTFOUND_SYM", "NO_SYM", "NOMAXVALUE_SYM", "NOMINVALUE_SYM",
  "NO_WAIT_SYM", "NOWAIT_SYM", "NUMBER_MARIADB_SYM", "NUMBER_ORACLE_SYM",
  "NVARCHAR_SYM", "OF_SYM", "OFFSET_SYM", "OLD_PASSWORD_SYM", "ONE_SYM",
  "ONLY_SYM", "ONLINE_SYM", "OPEN_SYM", "OPTIONS_SYM", "OPTION",
  "OWNER_SYM", "PACK_KEYS_SYM", "PAGE_SYM", "PARSER_SYM", "PARTIAL",
  "PARTITIONS_SYM", "PARTITIONING_SYM", "PASSWORD_SYM", "PERIOD_SYM",
  "PERSISTENT_SYM", "PHASE_SYM", "PLUGINS_SYM", "PLUGIN_SYM", "POINT_SYM",
  "POLYGON", "PORT_SYM", "PRECEDES_SYM", "PRECEDING_SYM", "PREPARE_SYM",
  "PRESERVE_SYM", "PREV_SYM", "PREVIOUS_SYM", "PRIVILEGES", "PROCESS",
  "PROCESSLIST_SYM", "PROFILE_SYM", "PROFILES_SYM", "PROXY_SYM",
  "QUARTER_SYM", "QUERY_SYM", "QUICK", "RAW_MARIADB_SYM", "RAW_ORACLE_SYM",
  "READ_ONLY_SYM", "REBUILD_SYM", "RECOVER_SYM", "REDOFILE_SYM",
  "REDO_BUFFER_SIZE_SYM", "REDUNDANT_SYM", "RELAY", "RELAYLOG_SYM",
  "RELAY_LOG_FILE_SYM", "RELAY_LOG_POS_SYM", "RELAY_THREAD", "RELOAD",
  "REMOVE_SYM", "REORGANIZE_SYM", "REPAIR", "REPEATABLE_SYM",
  "REPLICATION", "RESET_SYM", "RESTART_SYM", "RESOURCES", "RESTORE_SYM",
  "RESUME_SYM", "RETURNED_SQLSTATE_SYM", "RETURNS_SYM", "REUSE_SYM",
  "REVERSE_SYM", "ROLE_SYM", "ROLLBACK_SYM", "ROLLUP_SYM", "ROUTINE_SYM",
  "ROWCOUNT_SYM", "ROW_SYM", "ROW_COUNT_SYM", "ROW_FORMAT_SYM",
  "RTREE_SYM", "SAVEPOINT_SYM", "SCHEDULE_SYM", "SCHEMA_NAME_SYM",
  "SECOND_SYM", "SECURITY_SYM", "SEQUENCE_SYM", "SERIALIZABLE_SYM",
  "SERIAL_SYM", "SESSION_SYM", "SERVER_SYM", "SETVAL_SYM", "SHARE_SYM",
  "SHUTDOWN", "SIGNED_SYM", "SIMPLE_SYM", "SLAVE", "SLAVES",
  "SLAVE_POS_SYM", "SLOW", "SNAPSHOT_SYM", "SOCKET_SYM", "SOFT_SYM",
  "SONAME_SYM", "SOUNDS_SYM", "SOURCE_SYM", "SQL_BUFFER_RESULT",
  "SQL_CACHE_SYM", "SQL_CALC_FOUND_ROWS", "SQL_NO_CACHE_SYM", "SQL_THREAD",
  "STAGE_SYM", "STARTS_SYM", "START_SYM", "STATEMENT_SYM", "STATUS_SYM",
  "STOP_SYM", "STORAGE_SYM", "STORED_SYM", "STRING_SYM",
  "SUBCLASS_ORIGIN_SYM", "SUBDATE_SYM", "SUBJECT_SYM", "SUBPARTITIONS_SYM",
  "SUBPARTITION_SYM", "SUPER_SYM", "SUSPEND_SYM", "SWAPS_SYM",
  "SWITCHES_SYM", "SYSTEM", "SYSTEM_TIME_SYM", "TABLES", "TABLESPACE",
  "TABLE_CHECKSUM_SYM", "TABLE_NAME_SYM", "TEMPORARY", "TEMPTABLE_SYM",
  "TEXT_SYM", "THAN_SYM", "TIES_SYM", "TIMESTAMP", "TIMESTAMP_ADD",
  "TIMESTAMP_DIFF", "TIME_SYM", "TRANSACTION_SYM", "TRANSACTIONAL_SYM",
  "TRIGGERS_SYM", "TRIM_ORACLE", "TRUNCATE_SYM", "TYPES_SYM", "TYPE_SYM",
  "UDF_RETURNS_SYM", "UNBOUNDED_SYM", "UNCOMMITTED_SYM", "UNDEFINED_SYM",
  "UNDOFILE_SYM", "UNDO_BUFFER_SIZE_SYM", "UNICODE_SYM", "UNINSTALL_SYM",
  "UNKNOWN_SYM", "UNTIL_SYM", "UPGRADE_SYM", "USER_SYM", "USE_FRM",
  "VALUE_SYM", "VARCHAR2_MARIADB_SYM", "VARCHAR2_ORACLE_SYM", "VARIABLES",
  "VERSIONING_SYM", "VIA_SYM", "VIEW_SYM", "VIRTUAL_SYM", "WAIT_SYM",
  "WARNINGS", "WEEK_SYM", "WEIGHT_STRING_SYM", "WINDOW_SYM", "WITHIN",
  "WITHOUT", "WORK_SYM", "WRAPPER_SYM", "WRITE_SYM", "X509_SYM", "XA_SYM",
  "XML_SYM", "YEAR_SYM", "CONDITIONLESS_JOIN", "ON_SYM", "PREC_BELOW_NOT",
  "'='", "'>'", "'<'", "'|'", "'&'", "'-'", "'+'", "'*'", "'/'", "'%'",
  "'^'", "'~'", "SUBQUERY_AS_EXPR",
  "PREC_BELOW_IDENTIFIER_OPT_SPECIAL_CASE", "USER",
  "PREC_BELOW_CONTRACTION_TOKEN2", "'('", "')'", "EMPTY_FROM_CLAUSE",
  "','", "'!'", "'{'", "'}'", "';'", "'.'", "'@'", "':'", "$accept",
  "query", "$@1", "opt_end_of_input", "verb_clause", "statement",
  "deallocate", "deallocate_or_drop", "prepare", "$@2", "execute", "$@3",
  "$@4", "execute_using", "$@5", "execute_params", "help", "$@6", "change",
  "$@7", "master_defs", "master_def", "ignore_server_id_list",
  "ignore_server_id", "do_domain_id_list", "do_domain_id",
  "ignore_domain_id_list", "ignore_domain_id", "master_file_def",
  "optional_connection_name", "connection_name", "create", "$@8", "$@9",
  "$@10", "$@11", "$@12", "$@13", "$@14", "$@15", "$@16", "$@17", "$@18",
  "$@19", "$@20", "$@21", "$@22", "$@23", "$@24", "$@25", "opt_sequence",
  "sequence_defs", "sequence_def", "force_lookahead", "server_def", "$@26",
  "server_options_list", "server_option", "event_tail", "$@27",
  "ev_schedule_time", "$@28", "opt_ev_status", "ev_starts", "ev_ends",
  "opt_ev_on_completion", "ev_on_completion", "opt_ev_comment",
  "ev_sql_stmt", "$@29", "clear_privileges", "opt_aggregate", "sp_name",
  "sp_a_chistics", "sp_c_chistics", "sp_chistic", "sp_c_chistic",
  "sp_suid", "call", "$@30", "$@31", "$@32", "opt_sp_cparam_list",
  "opt_sp_cparams", "sp_cparams", "sp_fdparam_list", "$@33", "sp_fdparams",
  "sp_param_name", "sp_param_name_and_type", "sp_pdparam_list",
  "sp_pdparams", "sp_pdparam", "sp_opt_inout",
  "sp_parenthesized_pdparam_list", "$@34", "sp_proc_stmts",
  "sp_proc_stmts1", "sp_decls", "sp_decl",
  "optionally_qualified_column_ident", "row_field_name",
  "row_field_definition", "row_field_definition_list", "row_type_body",
  "sp_decl_idents_init_vars", "sp_decl_variable_list", "sp_decl_body",
  "$@35", "sp_decl_handler", "$@36",
  "opt_parenthesized_cursor_formal_parameters", "sp_cursor_stmt_lex",
  "sp_cursor_stmt", "$@37", "sp_handler_type", "sp_hcond_list",
  "sp_hcond_element", "sp_cond", "sqlstate", "opt_value", "sp_hcond",
  "raise_stmt_oracle", "signal_stmt", "signal_value", "opt_signal_value",
  "opt_set_signal_information", "signal_information_item_list",
  "signal_allowed_expr", "signal_condition_information_item_name",
  "resignal_stmt", "get_diagnostics", "which_area",
  "diagnostics_information", "statement_information",
  "statement_information_item", "simple_target_specification",
  "statement_information_item_name", "condition_number",
  "condition_information", "condition_information_item",
  "condition_information_item_name", "sp_decl_ident", "sp_decl_idents",
  "sp_opt_default", "sp_proc_stmt_in_returns_clause", "sp_proc_stmt",
  "sp_proc_stmt_compound_ok", "sp_proc_stmt_if", "$@38",
  "sp_proc_stmt_statement", "$@39", "RETURN_ALLMODES_SYM",
  "sp_proc_stmt_return", "$@40", "reset_lex_expr", "$@41",
  "sp_proc_stmt_exit_oracle", "sp_proc_stmt_continue_oracle",
  "sp_proc_stmt_leave", "sp_proc_stmt_iterate", "sp_proc_stmt_goto_oracle",
  "assignment_source_lex", "assignment_source_expr", "$@42",
  "for_loop_bound_expr", "$@43", "cursor_actual_parameters",
  "opt_parenthesized_cursor_actual_parameters", "sp_proc_stmt_open",
  "sp_proc_stmt_fetch_head", "sp_proc_stmt_fetch", "sp_proc_stmt_close",
  "sp_fetch_list", "sp_if", "$@44", "$@45", "$@46", "sp_elseifs",
  "case_stmt_specification", "$@47", "case_stmt_body", "$@48", "$@49",
  "simple_when_clause_list", "searched_when_clause_list",
  "simple_when_clause", "$@50", "$@51", "searched_when_clause", "$@52",
  "$@53", "else_clause_opt", "sp_label", "sp_opt_label", "sp_block_label",
  "sp_labeled_block", "$@54", "sp_unlabeled_block", "$@55",
  "sp_unlabeled_block_not_atomic", "$@56", "opt_sp_for_loop_direction",
  "sp_for_loop_index_and_bounds", "$@57", "sp_for_loop_bounds",
  "loop_body", "while_body", "$@58", "repeat_body", "$@59",
  "pop_sp_loop_label", "sp_labeled_control", "$@60", "$@61", "$@62",
  "$@63", "$@64", "$@65", "sp_unlabeled_control", "$@66", "$@67", "$@68",
  "$@69", "$@70", "trg_action_time", "trg_event",
  "change_tablespace_access", "change_tablespace_info", "tablespace_info",
  "opt_logfile_group_name", "alter_tablespace_info", "logfile_group_info",
  "alter_logfile_group_info", "add_log_file", "change_ts_option_list",
  "$@71", "change_ts_options", "change_ts_option",
  "tablespace_option_list", "tablespace_options", "tablespace_option",
  "alter_tablespace_option_list", "alter_tablespace_options",
  "alter_tablespace_option", "logfile_group_option_list",
  "logfile_group_options", "logfile_group_option",
  "alter_logfile_group_option_list", "alter_logfile_group_options",
  "alter_logfile_group_option", "ts_datafile", "lg_undofile",
  "lg_redofile", "tablespace_name", "logfile_group_name", "ts_access_mode",
  "opt_ts_initial_size", "opt_ts_autoextend_size", "opt_ts_max_size",
  "opt_ts_extent_size", "opt_ts_undo_buffer_size",
  "opt_ts_redo_buffer_size", "opt_ts_nodegroup", "opt_ts_comment",
  "opt_ts_engine", "opt_ts_wait", "ts_wait", "size_number", "create_body",
  "$@72", "create_like", "opt_create_select",
  "create_select_query_expression", "opt_create_partitioning",
  "opt_partitioning", "partitioning", "$@73", "have_partitioning",
  "partition_entry", "$@74", "partition", "$@75", "part_type_def", "$@76",
  "$@77", "$@78", "opt_linear", "opt_key_algo", "part_field_list",
  "part_field_item_list", "part_field_item", "part_column_list",
  "part_func", "sub_part_func", "opt_num_parts", "opt_sub_part", "$@79",
  "$@80", "sub_part_field_list", "sub_part_field_item", "part_func_expr",
  "opt_num_subparts", "part_defs", "part_def_list", "part_definition",
  "$@81", "part_name", "opt_part_values", "$@82", "$@83", "part_func_max",
  "part_values_in", "part_value_list", "part_value_item", "$@84", "$@85",
  "part_value_item_list", "part_value_expr_item", "opt_sub_partition",
  "sub_part_list", "sub_part_definition", "$@86", "sub_name",
  "opt_part_options", "opt_part_option_list", "opt_part_option",
  "opt_versioning_rotation", "$@87", "opt_versioning_interval_start",
  "opt_as", "opt_create_database_options", "create_database_options",
  "create_database_option", "opt_if_not_exists_table_element",
  "opt_if_not_exists", "create_or_replace", "opt_create_table_options",
  "create_table_options_space_separated", "create_table_options",
  "create_table_option", "$@88", "opt_versioning_option",
  "versioning_option", "default_charset", "default_collation",
  "storage_engines", "known_storage_engines", "row_types",
  "merge_insert_types", "udf_type", "create_field_list",
  "create_field_list_parens", "field_list", "field_list_item",
  "column_def", "key_def", "$@89", "$@90", "$@91", "$@92", "$@93", "$@94",
  "$@95", "constraint_def", "period_for_system_time",
  "period_for_application_time", "opt_check_constraint",
  "check_constraint", "opt_constraint_no_id", "opt_constraint",
  "constraint", "field_spec", "@96", "field_type_or_serial", "$@97",
  "$@98", "opt_serial_attribute", "opt_serial_attribute_list",
  "opt_asrow_attribute", "opt_asrow_attribute_list", "field_def", "$@99",
  "opt_generated_always", "vcol_opt_specifier", "vcol_opt_attribute",
  "vcol_opt_attribute_list", "vcol_attribute", "parse_vcol_expr", "$@100",
  "parenthesized_expr", "virtual_column_func", "expr_or_literal",
  "column_default_expr", "field_type", "qualified_field_type",
  "field_type_all", "field_type_numeric", "opt_binary_and_compression",
  "field_type_string", "field_type_temporal", "field_type_lob",
  "field_type_misc", "spatial_type", "char", "nchar", "varchar",
  "nvarchar", "int_type", "real_type", "srid_option", "float_options",
  "precision", "field_options", "field_length", "opt_field_length",
  "opt_field_length_default_1", "opt_precision", "attribute_list",
  "attribute", "opt_compression_method", "opt_compressed", "compressed",
  "compressed_deprecated_data_type_attribute",
  "compressed_deprecated_column_attribute", "asrow_attribute",
  "serial_attribute", "with_or_without_system", "charset", "charset_name",
  "charset_name_or_default", "opt_load_data_charset",
  "old_or_new_charset_name", "old_or_new_charset_name_or_default",
  "collation_name", "opt_collate", "collation_name_or_default",
  "opt_default", "charset_or_alias", "collate", "opt_binary", "binary",
  "opt_bin_mod", "ws_nweights", "$@101", "ws_level_flag_desc",
  "ws_level_flag_reverse", "ws_level_flags", "ws_level_number",
  "ws_level_list_item", "ws_level_list", "ws_level_range",
  "ws_level_list_or_range", "opt_ws_levels", "opt_primary", "references",
  "opt_ref_list", "ref_list", "opt_match_clause", "opt_on_update_delete",
  "delete_option", "constraint_key_type", "key_or_index",
  "opt_key_or_index", "keys_or_index", "opt_unique", "fulltext", "spatial",
  "normal_key_options", "fulltext_key_options", "spatial_key_options",
  "normal_key_opts", "spatial_key_opts", "fulltext_key_opts",
  "opt_USING_key_algorithm", "opt_key_algorithm_clause", "key_using_alg",
  "all_key_opt", "normal_key_opt", "spatial_key_opt", "fulltext_key_opt",
  "btree_or_rtree", "key_list", "key_part", "opt_ident", "string_list",
  "alter", "$@102", "$@103", "$@104", "$@105", "$@106", "$@107", "$@108",
  "$@109", "$@110", "$@111", "$@112", "account_locking_option",
  "opt_password_expire_option",
  "opt_account_locking_and_opt_password_expiration",
  "ev_alter_on_schedule_completion", "opt_ev_rename_to", "opt_ev_sql_stmt",
  "ident_or_empty", "alter_commands", "$@113", "$@114", "$@115",
  "remove_partitioning", "all_or_alt_part_name_list", "add_partition_rule",
  "$@116", "add_part_extra", "reorg_partition_rule", "$@117",
  "reorg_parts_rule", "$@118", "alt_part_name_list", "alt_part_name_item",
  "alter_list", "add_column", "alter_list_item",
  "opt_index_lock_algorithm", "alter_algorithm_option",
  "alter_lock_option", "opt_column", "opt_ignore", "alter_options",
  "$@119", "alter_options_part2", "alter_option_list", "alter_option",
  "opt_restrict", "opt_place", "opt_to", "slave", "$@120", "$@121",
  "start", "opt_start_transaction_option_list",
  "start_transaction_option_list", "start_transaction_option",
  "slave_thread_opts", "$@122", "slave_thread_opt_list",
  "slave_thread_opt", "slave_until", "slave_until_opts", "checksum",
  "$@123", "opt_checksum_type", "repair_table_or_view", "$@124", "repair",
  "$@125", "opt_mi_repair_type", "mi_repair_types", "mi_repair_type",
  "opt_view_repair_type", "analyze", "$@126", "analyze_table_list",
  "analyze_table_elem_spec", "opt_persistent_stat_clause",
  "persistent_stat_spec", "persistent_column_stat_spec", "$@127",
  "persistent_index_stat_spec", "$@128", "table_column_list",
  "table_index_list", "table_index_name", "binlog_base64_event",
  "check_view_or_table", "$@129", "check", "$@130", "opt_mi_check_type",
  "mi_check_types", "mi_check_type", "opt_view_check_type", "optimize",
  "$@131", "opt_no_write_to_binlog", "rename", "$@132", "rename_list",
  "table_to_table_list", "table_to_table", "keycache", "$@133",
  "keycache_list_or_parts", "keycache_list", "assign_to_keycache",
  "assign_to_keycache_parts", "key_cache_name", "preload", "$@134",
  "preload_list_or_parts", "preload_list", "preload_keys",
  "preload_keys_parts", "adm_partition", "$@135", "cache_keys_spec",
  "$@136", "cache_key_list_or_empty", "opt_ignore_leaves", "select",
  "$@137", "$@138", "select_into", "$@139", "$@140", "simple_table",
  "table_value_constructor", "$@141", "query_specification_start", "$@142",
  "$@143", "query_specification", "select_into_query_specification",
  "query_expression", "query_expression_no_with_clause",
  "query_expression_body_ext", "$@144", "$@145",
  "query_expression_body_ext_parens", "query_expression_body", "$@146",
  "query_primary", "query_simple", "subselect", "subquery",
  "opt_from_clause", "from_clause", "table_reference_list",
  "select_options", "opt_history_unit", "history_point",
  "for_portion_of_time_clause", "opt_for_portion_of_time_clause",
  "opt_for_system_time_clause", "system_time_expr", "select_option_list",
  "select_option", "select_lock_type", "opt_select_lock_type",
  "opt_lock_wait_timeout_new", "select_item_list", "select_item",
  "remember_tok_start", "remember_name", "remember_end", "select_alias",
  "opt_default_time_precision", "opt_time_precision", "optional_braces",
  "expr", "boolean_test", "predicate", "bit_expr", "or", "and", "not",
  "not2", "comp_op", "all_or_any", "opt_dyncol_type", "dyncol_type",
  "numeric_dyncol_type", "temporal_dyncol_type", "string_dyncol_type",
  "$@147", "dyncall_create_element", "dyncall_create_list",
  "plsql_cursor_attr", "explicit_cursor_attr", "trim_operands",
  "trim_operands_regular", "trim_operands_special",
  "column_default_non_parenthesized_expr", "primary_expr",
  "string_factor_expr", "simple_expr", "mysql_concatenation_expr",
  "function_call_keyword_timestamp", "function_call_keyword",
  "substring_operands", "substring_operands_regular",
  "substring_operands_special", "function_call_nonkeyword",
  "function_call_conflict", "geometry_function", "function_call_generic",
  "@148", "fulltext_options", "opt_natural_language_mode",
  "opt_query_expansion", "opt_udf_expr_list", "udf_expr_list", "udf_expr",
  "sum_expr", "$@149", "$@150", "$@151", "window_func_expr", "window_func",
  "simple_window_func", "inverse_distribution_function",
  "percentile_function", "$@152", "inverse_distribution_function_def",
  "order_by_single_element_list", "window_name", "variable", "$@153",
  "variable_aux", "opt_distinct", "opt_gconcat_separator",
  "opt_gorder_clause", "gorder_list", "opt_glimit_clause",
  "glimit_clause_init", "glimit_clause", "glimit_options", "in_sum_expr",
  "$@154", "cast_type", "$@155", "$@156", "$@157", "cast_type_numeric",
  "cast_type_temporal", "opt_expr_list", "expr_list", "ident_list_arg",
  "ident_list", "when_list", "when_list_opt_else", "table_ref",
  "join_table_list", "esc_table_ref", "derived_table_list", "join_table",
  "$@158", "$@159", "$@160", "$@161", "$@162", "$@163", "inner_join",
  "normal_join", "opt_use_partition", "use_partition", "table_factor",
  "table_primary_ident_opt_parens", "table_primary_derived_opt_parens",
  "table_reference_list_parens", "nested_table_reference_list",
  "join_table_parens", "table_primary_ident", "table_primary_derived",
  "opt_outer", "index_hint_clause", "index_hint_type",
  "index_hint_definition", "$@164", "$@165", "index_hints_list",
  "opt_index_hints_list", "$@166", "opt_key_definition", "$@167",
  "opt_key_usage_list", "key_usage_element", "key_usage_list",
  "using_list", "interval", "interval_time_stamp", "date_time_type",
  "table_alias", "opt_table_alias_clause", "table_alias_clause", "opt_all",
  "opt_where_clause", "$@168", "opt_having_clause", "$@169",
  "opt_group_clause", "group_list", "olap_opt", "opt_window_clause",
  "window_def_list", "window_def", "window_spec", "$@170",
  "opt_window_ref", "opt_window_partition_clause",
  "opt_window_order_clause", "opt_window_frame_clause",
  "window_frame_units", "window_frame_extent", "window_frame_start",
  "window_frame_bound", "opt_window_frame_exclusion", "alter_order_clause",
  "alter_order_list", "alter_order_item", "opt_order_clause",
  "order_clause", "$@171", "order_list", "order_dir", "opt_limit_clause",
  "limit_clause", "opt_global_limit_clause", "limit_options",
  "limit_option", "limit_rows_option", "delete_limit_clause",
  "order_limit_lock", "opt_order_limit_lock", "query_expression_tail",
  "opt_query_expression_tail", "opt_procedure_or_into", "order_or_limit",
  "opt_plus", "int_num", "ulong_num", "real_ulong_num", "longlong_num",
  "ulonglong_num", "real_ulonglong_num", "dec_num_error", "dec_num",
  "choice", "bool", "procedure_clause", "$@172", "procedure_list",
  "procedure_list2", "procedure_item", "select_var_list_init", "$@173",
  "select_var_list", "select_var_ident", "select_outvar", "into",
  "into_destination", "$@174", "$@175", "do", "$@176", "drop", "$@177",
  "$@178", "$@179", "$@180", "table_list", "table_name",
  "table_name_with_opt_use_partition", "table_alias_ref_list",
  "table_alias_ref", "opt_if_exists_table_element", "opt_if_exists",
  "opt_temporary", "insert", "$@181", "$@182", "replace", "$@183", "$@184",
  "insert_lock_option", "replace_lock_option", "insert2", "insert_table",
  "$@185", "insert_field_spec", "$@186", "insert_field_list", "opt_fields",
  "fields", "insert_values", "values_list", "ident_eq_list",
  "ident_eq_value", "equal", "opt_equal", "opt_with", "opt_by",
  "no_braces", "$@187", "no_braces_with_names", "$@188", "opt_values",
  "opt_values_with_names", "values", "values_with_names", "expr_or_ignore",
  "expr_or_ignore_or_default", "opt_insert_update", "$@189", "$@190",
  "update_table_list", "update", "$@191", "$@192", "update_list",
  "update_elem", "insert_update_list", "insert_update_elem",
  "opt_low_priority", "delete", "$@193", "opt_delete_system_time",
  "delete_part2", "delete_single_table", "delete_single_table_for_period",
  "single_multi", "$@194", "$@195", "opt_select_expressions",
  "table_wild_list", "table_wild_one", "opt_wild", "opt_delete_options",
  "opt_delete_option", "truncate", "$@196", "opt_table_sym",
  "opt_profile_defs", "profile_defs", "profile_def", "opt_profile_args",
  "show", "$@197", "show_param", "$@198", "$@199", "show_engine_param",
  "master_or_binary", "opt_storage", "opt_db", "opt_full", "from_or_in",
  "binlog_in", "binlog_from", "wild_and_where", "describe", "$@200",
  "$@201", "explainable_command", "describe_command",
  "analyze_stmt_command", "opt_extended_describe", "opt_format_json",
  "opt_describe_column", "flush", "$@202", "flush_options", "$@203",
  "opt_flush_lock", "flush_lock", "$@204", "flush_options_list",
  "flush_option", "opt_table_list", "backup", "backup_statements", "$@205",
  "opt_delete_gtid_domain", "delete_domain_id_list", "delete_domain_id",
  "optional_flush_tables_arguments", "reset", "$@206", "reset_options",
  "reset_option", "$@207", "$@208", "slave_reset_options",
  "master_reset_options", "purge", "$@209", "kill", "$@210", "kill_type",
  "kill_option", "opt_connection", "kill_expr", "shutdown", "$@211",
  "shutdown_option", "use", "load", "$@212", "$@213", "$@214", "$@215",
  "data_or_xml", "opt_local", "load_data_lock", "opt_duplicate",
  "opt_field_term", "field_term_list", "field_term", "opt_line_term",
  "line_term_list", "line_term", "opt_xml_rows_identified_by",
  "opt_ignore_lines", "lines_or_rows", "opt_field_or_var_spec",
  "fields_or_vars", "field_or_var", "opt_load_data_set_spec",
  "load_data_set_list", "load_data_set_elem", "text_literal",
  "text_string", "hex_or_bin_String", "param_marker", "signed_literal",
  "literal", "NUM_literal", "temporal_literal", "with_clause", "$@216",
  "opt_recursive", "with_list", "with_list_element", "$@217",
  "opt_with_column_list", "with_column_list", "with_element_head",
  "insert_ident", "table_wild", "select_sublist_qualified_asterisk",
  "order_ident", "simple_ident", "simple_ident_nospvar", "field_ident",
  "table_ident", "table_ident_opt_wild", "table_ident_nodb", "IDENT_cli",
  "ident_cli", "IDENT_sys", "TEXT_STRING_sys", "TEXT_STRING_literal",
  "TEXT_STRING_filesystem", "ident_table_alias", "ident_set_usual_case",
  "ident_sysvar_name", "ident", "label_ident", "ident_or_text",
  "user_maybe_role", "user_or_role", "user", "keyword_table_alias",
  "keyword_ident", "keyword_label", "keyword_sysvar_name",
  "keyword_sp_decl", "keyword_set_usual_case", "keyword_sp_var_not_label",
  "keyword_sp_head", "keyword_verb_clause", "keyword_set_special_case",
  "keyword_sp_block_section", "keyword_sysvar_type", "keyword_data_type",
  "keyword_sp_var_and_label", "set", "$@218", "$@219", "$@220",
  "set_stmt_option_value_following_option_type_list",
  "start_option_value_list", "$@221", "$@222", "$@223",
  "start_option_value_list_following_option_type", "$@224",
  "option_value_list_continued", "option_value_list", "$@225", "$@226",
  "option_value", "$@227", "option_type", "opt_var_type",
  "opt_var_ident_type", "option_value_following_option_type",
  "option_value_no_option_type", "transaction_characteristics",
  "transaction_access_mode", "isolation_level",
  "transaction_access_mode_types", "isolation_types", "opt_for_user",
  "text_or_password", "set_expr_or_default", "lock", "$@228",
  "opt_lock_wait_timeout", "table_or_tables", "table_lock_list",
  "table_lock", "lock_option", "unlock", "$@229", "handler", "$@230",
  "handler_tail", "$@231", "handler_read_or_scan", "handler_scan_function",
  "handler_rkey_function", "$@232", "handler_rkey_mode", "revoke",
  "revoke_command", "admin_option_for_role", "grant", "grant_command",
  "opt_with_admin", "opt_with_admin_option", "role_list", "current_role",
  "grant_role", "opt_table", "grant_privileges", "opt_privileges",
  "object_privilege_list", "object_privilege", "$@233", "$@234", "$@235",
  "$@236", "opt_and", "require_list", "require_list_element",
  "grant_ident", "user_list", "grant_list", "user_and_role_list",
  "via_or_with", "using_or_as", "grant_user", "auth_expression",
  "auth_token", "opt_auth_str", "opt_column_list", "column_list",
  "column_list_id", "opt_require_clause", "resource_option",
  "resource_option_list", "opt_resource_options", "opt_grant_options",
  "opt_grant_option", "grant_option_list", "grant_option",
  "begin_stmt_mariadb", "$@237", "compound_statement", "opt_not",
  "opt_work", "opt_chain", "opt_release", "commit", "rollback",
  "savepoint", "release", "unit_type_decl", "union_option",
  "query_expression_option", "definer_opt", "no_definer", "definer",
  "view_algorithm", "opt_view_suid", "view_suid", "view_list_opt",
  "view_list", "view_select", "$@238", "view_check_option",
  "trigger_action_order", "trigger_follows_precedes_clause",
  "trigger_tail", "$@239", "$@240", "$@241", "$@242", "$@243",
  "sf_return_type", "$@244", "sf_c_chistics_and_body", "$@245", "sp_tail",
  "$@246", "$@247", "xa", "opt_format_xid", "xid", "begin_or_start",
  "opt_join_or_resume", "opt_one_phase", "opt_suspend", "$@248",
  "opt_migrate", "install", "uninstall", "keep_gcc_happy", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-4883)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-3349)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const int yypact[] =
{
    7647,  3105,  2451, 93050, -4883,   885, -4883,   330, -4883, -4883,
   -4883,  4134, -4883, -4883, -4883, -4883, -4883, -4883,   122,   401,
   -4883,   228, -4883, -4883,   256, 88570,   816,   494, -4883, 89850,
   -4883, -4883,   969, -4883, 89850, -4883, -4883, 93050, -4883, -4883,
    1465, -4883, -4883,   121,  2010,    37,  1761,   401,  1171, -4883,
   -4883, 93690,   228,  1592, -4883, -4883,  1157, 93050,   228, -4883,
    1171, 93050, -4883,   233,   280, -4883,  1389,  2462,   362,  2023,
    2107, -4883, -4883,  1437, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
    4594, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,   429, -4883,
   -4883, -4883, -4883,  4564,  1626, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, 77030, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883,   362, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, 93050, 93050,  1305,  1347, 93050,  2131,  2156, 89210,
   93050,  2156, -4883,    70, -4883, -4883,  1871, -4883,  1549, -4883,
     401,  2781, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883,  1586, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883,  2086,  2051,   519,  2110,
    2365, 93050,   698,  2156, -4883,  2156,  2156,  2156,  2156,  2401,
    2156,  2156, 93050, -4883,  2156,  2156,   794, 93050, 36604, -4883,
    1206,  1006,  2348, -4883, -4883, -4883, -4883, -4883, -4883, 55142,
     401, 22843,  2482, -4883, -4883,  2015,  4561,  1845, -4883,  2364,
   -4883, -4883, 93050, -4883, -4883, 55142, -4883,  2364, 37348,  3473,
   -4883, 35147, 11358,  2364,   401,  2461, -4883,  1851, 22843, -4883,
   -4883,  1077, -4883, -4883, 93050, -4883, -4883, -4883,  2316,  1171,
   -4883, 89210, -4883, -4883, -4883, -4883,  2640, 22843,   238,  2387,
   -4883, -4883,  2287, 77670, 89210,  2598,  2051,  2631, -4883,  1702,
    1370, -4883,  2014,  2098,  2051,   267,  2106,  2051,  2491,  2156,
    2156, -4883, -4883,  1803,  1803,  1803,  2327,  1803, -4883,  1803,
    2675,  2016,   314, -4883, -4883,  2034, 93050,  2598, -4883, -4883,
   -4883,  2598,  2598,  2139,  2704,  2716,  2733,   467,  1814,  1697,
    1697,  1871, 59224,  1079,  2553, -4883,  2675,  2076,  1946, -4883,
   -4883,  2068,  2076,   362,  2076, -4883,   220,  1549,  2784, 93050,
   -4883, -4883, -4883,  2085, -4883, -4883, -4883,  2130, -4883,  2094,
    1174, 57853, -4883, 93050,  2795, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883,   589, -4883, -4883,  2620,   214,  2241,  2493,
    2152, -4883,  2671, 89210, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, 93050,  2159, -4883,  2879, 22843,  2086, -4883,  2677,
   -4883, -4883, -4883, -4883, 77670, -4883, 93050, -4883,  2957, -4883,
   -4883,  2881, -4883, -4883, 80890,   620, 93050,  2867, 93050, 93050,
   93050, 93050, 93050, -4883, 89210,  2301, -4883, -4883,  2156,  2156,
   -4883, -4883,  2391,  2361,  2927,  2259,  2566, -4883,  2470, -4883,
   -4883,  2359, -4883, -4883,   124, -4883, -4883, -4883,   113,   136,
     137,   174,  2880,   243,   764,   276,   297, -4883, -4883, -4883,
    2793,  2886,  2312, -4883,  2662, 22843, -4883, -4883, -4883,  2979,
   -4883, -4883,    10,  2750,   231, 77670, 98810, 80240, 99738, 99738,
   99738, -4883,   217,  2010, 93050, 99274, 93050, 49076, -4883,  2346,
   -4883, -4883,  6463, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, 93050, -4883, -4883,  1573,  2803, -4883, -4883, -4883, -4883,
   -4883,  2352, -4883, -4883, -4883, -4883, -4883, -4883, 27995, -4883,
    2390,  2393,  2427, 18427,  2429,  2430,  2440,  2460,  2466,  2259,
    2259,  2259,  2472,  2473,  2480,  2489, -4883,  2492,  2499,  2510,
    2518, -4883,  2542, -4883,  2560,  2568,  2569, -4883, -4883,   133,
     151,  2577,  2578, 23579,  2593, -4883, 71910,  2617,  2626,  2634,
    2644, -4883, -4883, 22843,  2472,  2649, -4883, -4883,  2650, -4883,
    2658,  2666,  2676,  2681,  2699,  2705,  2711,  2712,  2950,  2715,
    2726,  2727,  2472, -4883, -4883, -4883,  2349,  2259,  2472,  2472,
    2734,  2737,  2741,  2744,  2757,  2760,  2762,  2763,  2767,  2782,
    2802, 90490,  2806,  2811,  2815,  2818,  2819,  2823,  2832,    47,
    2838,  2841,  2846,  2856,  2863,  2873,  2883,  2896,  2902,  2906,
    2909,  2910,  2915,  2916,  2458,  2919,  2920,  2923,  2932,  2937,
    2554,  2955,  2958,  2959,  2970,  2973,  2974,  2982,    80,  2983,
    2988,    92,  2992,  3011,  3030,  3051,  3056,  3069,  3084,  3094,
   28731, 29467, 27995, 16955, -4883, 93050, 94330, -4883, -4883, -4883,
    3427,  2350,  2826,  3417, 27995, -4883, -4883, -4883,  3196, -4883,
    3072, -4883, -4883, -4883, -4883, -4883,  3114,  3117, -4883,  3176,
   -4883, -4883,  3261,  2807, -4883,  3228, -4883, -4883, -4883, -4883,
   -4883,  2783,  3099,  3364,  3458, -4883, -4883,   416, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
    2976,  3013, -4883,  3228, -4883, -4883, 58553, 77670, 55816, -4883,
   -4883,  2391,  3241,  3696, -4883,  3751, -4883,  3699, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,  3473,
   -4883, -4883, 63370,  3643,   644,   359,   392,   407, 42139,   112,
   85370,   413,   907,  3104, 68070, 43601,  3106,   101,  3108, -4883,
    3110,  3113,  3116,  3118,  3122,  3123,  3131, -4883, -4883, -4883,
    3233,  3140,  2667,   329, -4883, -4883,   830,  3235,    81, -4883,
    3488, -4883,   329, -4883, 38014,  3777,   432, -4883,   891, -4883,
    3828, -4883, -4883,  3244,  3231,  3260, -4883,  2868, -4883,  2051,
   -4883,   878, -4883,  3777,   329,   432, -4883,  3428,  3511,   986,
    3842, -4883,  1669, -4883, -4883, -4883,  2979, -4883,  3167, -4883,
   -4883,  3156, 93050, -4883,  3824, -4883, 77670, -4883, -4883, -4883,
    3180, 77670, 77670,  1059,   970,  3427,  3184, 22843, -4883, -4883,
    5692, 38724,  3383,  1158,   630, -4883, -4883,  2010, 93050, -4883,
   -4883,   744, -4883,  3616, -4883,  3197, -4883, 94970,   970,  3877,
   -4883, -4883, -4883,  1087,  3589, -4883,  3200, -4883, -4883, -4883,
   -4883, 77670, 93050,  2051, -4883, -4883, -4883, -4883,  3201, -4883,
   -4883,  3404,  3289, -4883,  3236, -4883, -4883,   153, -4883, -4883,
    3908, -4883, 93050, -4883, -4883,  2598, -4883,  2598, -4883, -4883,
    2598,  2598,  2598, -4883, -4883,  3256, -4883,  3543,  3544,  2671,
   -4883, 71270, 93050,  3902, -4883,  3612, -4883, -4883,  3237, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883,  3811,  3743,  3743,
   -4883, 68710, -4883, -4883,  3910,  2553,  3732, 86010,  3898,  3998,
   -4883,  3777, -4883, -4883, -4883,  1118, 93050, -4883,  1118,  1118,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
     362, -4883, -4883,  2781, 45638, 93050,  2076,  1946,  3964,  3631,
   -4883, 93050, -4883, -4883, -4883,  2259,  3252, -4883, -4883, -4883,
   -4883, -4883,  4026, -4883, -4883, 77670,  3457,  3639,  3639,  3639,
    4032, -4883, -4883, -4883, 57853, 77670, -4883, -4883, -4883,   214,
   -4883,  1751, 93050, 77670,  3306, -4883, 77670,  3264, 22843, -4883,
   22843, 55142,  3627,  3427, -4883, -4883, 77670,  1900, -4883, -4883,
   -4883,  4026,  3639, 77670,  4030, 77670,  3955,  2553, -4883,  3277,
   -4883,  3274, -4883, -4883,  3969, 93050, -4883, -4883, -4883,  3278,
    2301, 59923, -4883,  1307,  3638, 58553, 77670, -4883, -4883,  3647,
    3938, -4883, -4883, -4883, -4883, -4883,  3370, -4883, -4883,  3297,
   -4883, -4883, -4883,  3299, -4883,  3299,  3299, -4883, -4883,  3299,
   58553, -4883, -4883, 57853,  1785,  4802,  3957,  3525, -4883,  3824,
   -4883, 24315, -4883, 25051, -4883, -4883, -4883,  3574,   197,  1279,
   -4883, -4883,  3780, 93050,  3534,  3987,  3960, -4883, -4883, -4883,
   -4883, -4883, -4883,  3801,  3338,  3951,  3335, -4883, -4883, 22843,
    3340, -4883, -4883, -4883, -4883, -4883, -4883, -4883, 77670,  3347,
   27995, 27995, -4883,  4111,  4111,  4111, 22843,  3040,  1185,  3703,
   22843, 22843, 22843,  2306,  3350, -4883, -4883, -4883,   425, -4883,
    3351, 22843, 22843, 73190,  3352,   457,  4132, 22843,  4055, 22843,
   22843, 22843, 22843, 16955,  3681, 22843, -4883, -4883, 94330, 73190,
    3803,  3358, -4883,  3354, -4883,  2330, 22843,  2413, 22843, -4883,
   -4883, 22843, 22843,  3362, 22843, 22843, 30203,  3377, 22843, 22843,
    3378,  3510,  4111,  4111,  2424, -4883, -4883, -4883, -4883, -4883,
   -4883,  4111,  4111, 22843, 22843, 17691, 22843, 22843,  2426, 22843,
   22843, 22843, -4883,  3374, 22843, 22843, 22843, 22843, 22843, 22843,
   22843, -4883, 22843, 22843, 22843, 22843,  1226, 22843, 22843, 77670,
   22843, 22843, 22843, 22843, 22843, 22843, 22843,  4059, 77670, 22843,
   22843, 22843, 22843,  4061, 22843, 22843, 22843,  3385, 22843, 77670,
   22843, -4883, 22843,  3666,  3666, -4883, 22843, 17691, 22843,  3386,
   73830, 22843, 22843, 22843, 22843, 23579, -4883, 23579, -4883, -4883,
    3387,   929,   363,   362, 22843,  3382, 69350, -4883, -4883, -4883,
   -4883, 22843, 22843, 22843, 30203, -4883,  2223, -4883, -4883, -4883,
   -4883, -4883, 16219, 30203,  3391, 30203, 30203,  4022,  2556, 30203,
   30203, 30203, 30203, 30203, 30203, 30203, 30939, 31675, 30203, 30203,
   30203, 30203, -4883, 89210, 27995, 78950,  3397,  4067, -4883, 87930,
   -4883,  1688,   568, -4883,  2051,  4561, 33138, -4883,  3396, -4883,
    3899,  3409, -4883,  1317,  3403,  3412,  4077, 58553, 57853,  1824,
    3434, -4883,  3419,   483,  3425, -4883, -4883, 59923, 93050, -4883,
   -4883, -4883, -4883, -4883,  4164, 22843, -4883, 58553, -4883,  1004,
   15457, -4883,  1047,  1479,   101, -4883, -4883, -4883, -4883, -4883,
   15457, 93050, 64054,  3432,  3526,  3449,  2598, 93050, 77670, 93050,
   95610, 93050, 93050, 77670, 58553, 77670, -4883, -4883, -4883, 93050,
     329,   432,  1001,   329,  4085, -4883,  1698,  1698, -4883, -4883,
   -4883, -4883, -4883, -4883,   329, 93050, 93050,   329, 57853, -4883,
     432,  1980, -4883,  3731,  3520, -4883, -4883, -4883,  3779, -4883,
   -4883,  4130,  3454, -4883,  3804, -4883, -4883,  3548, -4883, -4883,
   77670, -4883, -4883,   432, -4883,   432,   432, 22843,   329,   329,
     329, 72550,  3465,  3469, -4883,  3470, -4883,  3475, -4883, -4883,
   -4883, -4883, 77670, -4883, -4883,  3467,  4123,  3478, -4883, -4883,
    4057,   665, -4883,  3913, -4883,  4043, -4883, 22843,  3427, 19163,
    3765, -4883, -4883,  3766,  3770,  3775, -4883, -4883, -4883, -4883,
    3928,  3781, -4883,  2051,  3783, -4883, -4883,  3505, -4883, -4883,
   -4883, 33138, 89210, -4883,  3507, -4883,  3532, -4883,   172, -4883,
   -4883,  4205,  3625, 22843, -4883, -4883, 77670,  4025, -4883,  2051,
    1702, 93050, -4883, -4883,  4291, -4883,  1714, -4883, -4883, -4883,
    3635,   267, -4883, -4883,  1317, -4883, -4883,  1803,  3713, -4883,
   -4883, -4883, 89210, -4883, -4883, -4883, -4883, -4883, -4883, 59923,
   57853, 89210, -4883,  2598,  2598, -4883, 77670, -4883, -4883, -4883,
    2598,  2598,  2598,  3569,  1882,  3535,  3538,  3541,  3546,  -205,
    3547, 74470,  2265,   249,  4190,  4191, -4883,  4133,  2892,  4133,
   -4883, -4883, 74470, 72550,  3554,  3902, -4883, -4883, -4883, -4883,
   89210,  3552, -4883, -4883,  3555, -4883, 22843,  4305,  4229,  3910,
    1422, -4883, -4883,  3907, -4883, 90490,  4107,   989, -4883,  3560,
    3682, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883,   218, -4883, -4883,
   -4883,  1293,  3935,  2665, -4883, -4883, 89210,  2665,  -137,  1581,
   -4883,  3575,  2051,  1373, -4883,  1373, -4883,  3873, -4883,  3876,
     263, -4883,  1317, -4883, -4883, -4883, -4883, -4883, 77670,  3577,
   -4883,  3761, 93050,  2159,  3580,  3579,  3427,  3427, 49750,  4323,
    4060,  5032,   150,  3632, -4883, -4883, -4883, -4883, -4883, 77670,
   -4883, -4883,  3065,  4047,  4078,  3811,  3668, -4883,  3591, -4883,
   -4883,   515,  4159, -4883, -4883,  4181, 93050,  4272, 82170, -4883,
   -4883,  4188, 93050,  1307,  3597, -4883, -4883, -4883, -4883, -4883,
     101, -4883,  3601,   142, 77670, 77670, 55142,  3747, -4883, -4883,
   -4883, 93050, -4883, -4883, -4883, -4883,  4115,    33, 33786, 75110,
   -4883, 75110, 75110, -4883, -4883, -4883, -4883, -4883,   764, -4883,
   -4883, -4883, -4883, -4883, -4883, 22843, 46338,  3427, -4883, -4883,
   77670, -4883,  4271, -4883, -4883, 97530,   318, -4883, -4883,   266,
   77670, -4883, -4883, 22843, -4883,  4266,  3749, 93050, -4883,  4332,
   -4883, -4883, -4883, -4883, -4883, -4883,  3427, 93050, 93050, 55142,
   55142, 22843, -4883,  1309, 22843, -4883,  3622, -4883,  3624,  3628,
    3530,  3979, 22843, 22843, -4883,  3588,    38,   248, -4883,  3629,
    3642, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,  3648,
   -4883, -4883, -4883,   376,   415,  3656, -4883, -4883, -4883,  3657,
     362, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883,  4318, -4883,   236, -4883, -4883,   212,   281,   419,   428,
     433,  3658,   441,  3374,  1570,  3660, 73190, 94330,  4111,  3662,
     384,  4111,  3663,   462,   406,   569, -4883,   797,  1668,  3243,
   -4883,   646,   660, -4883, -4883,  3667,  3676,  4111,  3677,  3678,
    3679,   673,   268,  3683, -4883, -4883, 19899, 20635, 21371,  3599,
    3684, -4883, -4883,   685,  1721,  4111,  3686,  1922,  1768,  1954,
   94330,   696,  1982,   782, -4883,  1892,   943,   995,  1073,  1173,
    2017,  2029,  1269,  1933, -4883, -4883, -4883, -4883,  3685,  2054,
    2070,  3688,  3694,  2020,  2088,  2121,  2140,  2065,  2093,  2112,
   77670,  3700,  2167,  2170,  1330,  2128, 77670,  2182,  2186,  1387,
   -4883,  2197,  3690,  1416,   295,  3697,  3708,  2225,  3712,  1440,
   -4883, 94330, 93050,  3715,  3661,   304,   203,  1511,  2260,  3681,
    3681, -4883, 22843,  3718,   152, 94330,  1479, -4883,  4220,  2817,
    1351, -4883,  2826, -4883, -4883, -4883, -4883,   434, -4883,  3721,
    2826,  3722,  2724, 16955, -4883,  1199,  2010, 30203, 30203,  3725,
   30203, 30203,  3733,  3733,   332,  3048,  3048,  3617,  3183, 23579,
     332, 23579,   332,  3733,  3733,  3733, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883,  4270,  3728,  3729,  3735,  3736,  1805,
    3738, -4883, -4883, -4883, -4883, -4883, -4883,     0,  4136, -4883,
    3924,  1038, 22843, -4883,  3760,  4251,  4253,  4254, -4883, -4883,
   -4883, -4883, 58553, 58553, 77670,  4255, 22843,  4422, 59923,  4429,
   -4883,  3756, 34434, 75110, 75110, 75110, -4883,  3757, -4883, 22843,
   93050, 93050, 15457, 63370,  4437,  4438,   101, 62686, -4883,  3427,
     101, -4883,  3764,  3767, -4883, -4883, 27995,  2492, -4883,  3427,
   -4883,  1382,  4041, -4883,  3772,  3776, -4883,  3773,  3784,  3785,
   66790, 22843, -4883,   101,  1047, -4883, -4883, -4883, -4883, -4883,
    3768, 93050, -4883, -4883, -4883, 93050, -4883, -4883, -4883, -4883,
   -4883, -4883,  2051, 22843, -4883, -4883,   329, 93050,   329, -4883,
    2051,  4454, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883,   329, -4883, -4883, -4883, -4883, -4883,  3946,  3777,
    2868,  4085, -4883,   432, 77670,   329,   329,  3427, -4883, -4883,
   -4883, -4883,  4316,  3811, 19163,  3786,  3782, -4883, -4883, 55142,
   93050, 93050, -4883, -4883,  1673, -4883,  3811,  4332, 89210, 64738,
   77670, -4883, -4883, -4883,  2078, -4883, -4883, -4883, -4883, -4883,
    3427,  2387,  2492, -4883,  3788,  3427, -4883, -4883,  4495, -4883,
   -4883, -4883, -4883,  2051, -4883, -4883,  5717, -4883, 77670, -4883,
   70630, -4883, 70630,  1716, -4883, 96250, -4883,  2051,  3427, 77670,
    1056,   266, -4883,  4557, -4883, -4883,  3903, -4883, -4883, -4883,
    3793, -4883,  3845, -4883, -4883, -4883,  3799, -4883,  4479, -4883,
    1652,   333,   263, -4883, 93050, 93050, 93050, 77670, -4883, 93050,
    2598, -4883, -4883,  2598, 77670, 93050, 93050,  2598, 74470, -4883,
   -4883, -4883, -4883, -4883, 74470, -4883,  1045, -4883,  4007,  1936,
    1936, -4883, -4883, -4883, -4883, -4883,  4449,  4133,  4133, 74470,
    4450,  3293, -4883, 93050,  5578,  1189, -4883, 68710, 93050,  3427,
   22843, -4883,  3840,  4229, -4883,   266, -4883, 87290, -4883,  4153,
   87290, 87290, 94330,  4044, 22843,  3814, -4883,   101,   101,  4038,
    4341,  4342,  3945,  2051,  4344,  4345,  4348, -4883, -4883, -4883,
    2051,  2051, -4883, -4883,   101, -4883,  1874, -4883, -4883, -4883,
   -4883,  3398,  2723, -4883,   101,   101, -4883,  2791, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883,  1679, -4883,   158,  2692, 57853,
    4306, -4883,  4427,  3839, -4883, 77670,  4516, -4883, -4883, -4883,
   -4883, 22843,  4347, -4883, -4883,  4060, -4883,  3858,  3861,  3862,
    3863,  3864,  3866,  3869,  3875,  3881,  3882,  3884,  3885,  3891,
    3892,  3893,  3895,  3896,  3897,  3900,  3901,  3905,  3906,  3909,
    3915,  3880, -4883, -4883,  3941, -4883, -4883, -4883, -4883,   101,
     101,   101,   101, -4883,  3739, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883,  4131,  3727, -4883,  1936, 93050,  4379, 82170,
   -4883,  4102,  4530, -4883, -4883, 72550, -4883,  3912, 77670, -4883,
   -4883, 59923, -4883, 89210, 58553, -4883, -4883, -4883,  3904,  1309,
   50424, -4883,  3911, -4883,  2173, -4883, 57853,  4352, -4883, 75110,
    3914, -4883,  3916,  4408,  4409,  4413,  4417, 55142,  1673,  3427,
   -4883, -4883,  3925, -4883, -4883,  4057,  3743, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,  3954,  4206,
    4322, -4883, -4883, -4883,  2696, -4883, -4883,  3427, -4883, -4883,
   -4883,  4583, 57148, 51098,  3931, -4883, -4883, -4883,  2219, -4883,
   -4883, 99738, 99738, 99738,  4332, -4883,  1514, -4883, 22843, -4883,
   -4883, 22843, -4883,  3427,  3630,  3506, 44984, -4883, 44984,  3506,
   22843, -4883,  3944, -4883,  4586,  4597, -4883, -4883, -4883, 22843,
   -4883, 22843, -4883, 22843, -4883, 22843, 22843, 22843, 22843, 22843,
   22843, -4883, 30203, -4883,  3939,  3948, -4883, -4883,  3950, -4883,
   22843, -4883, 22843, -4883, -4883, 22843, 22843, 22843, -4883, -4883,
    3952, -4883, -4883, -4883, 22843, 22843, 22843, -4883, 22843,  3868,
   22843,  3888, 22843,  3940, 22843, -4883, 25787, -4883,  3953, -4883,
   -4883, -4883, -4883, -4883, 22843, -4883, 22843, -4883, 22843, 22843,
   22843, 22843, 22843, -4883, -4883, 22843, -4883, 22843, -4883,  4536,
   22843, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, 22843, -4883, -4883, -4883, -4883, 22843, -4883,
     340, 26523, -4883, 22843, 22843, 22843, -4883, -4883, 22843,  3958,
    3959, -4883, 93050, -4883, 22843,  1786,  3528,   266,  3961, 22843,
   -4883,  3971,  3973,  3184, -4883, -4883, -4883, 98170, 22843, -4883,
   -4883, -4883, -4883,   457, 30203,   337, 30203,  2010,  3159, 16955,
   -4883,  1294,  2010,  3681,  3681, 93050,  4708,  3970, -4883, 22843,
   22843, 17691, 22843, 94330, 22843,  3972,  3967, -4883,  3974, 30203,
   -4883, -4883,  3975, -4883,   418,  3528,  4053,  4420, -4883,  3427,
   33138,  4481, -4883, -4883, 77670,  3490,  4177, -4883, 58553, 57853,
   75110,  4660,  4664,  4665,  4666, -4883,  3427, -4883,  3985,   101,
     101, -4883, -4883,  8435, 58553, 15457, -4883, -4883, -4883, -4883,
    4498,  4499, -4883, -4883,   670,  4286,  4558, -4883, -4883, -4883,
    3994, -4883, -4883, -4883,   537, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883,  3427, 15457, -4883,  3432,  4002, 35860,   875,
   -4883, -4883, -4883,  3427, -4883, -4883, -4883, -4883,  4016, -4883,
   -4883, -4883,  4599, -4883, -4883,  4454,  2553,   432, -4883, -4883,
   73830,  2840, -4883, -4883, -4883, 19163, 51772, -4883,  2224, -4883,
    4766, 73830,  4480, -4883, -4883, -4883, -4883,   118, -4883, -4883,
   52446, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883,  4015, -4883, -4883, 19163,  4033, -4883, -4883, -4883,  3904,
    1454,  4034,  4013, -4883, -4883, -4883, -4883, -4883, -4883,   327,
     706,  2792,  2553, -4883, -4883,   192, -4883, -4883, -4883, -4883,
   -4883,  1198, -4883, -4883, -4883, -4883,  1714,  2603, -4883,   266,
    4244, -4883, -4883,  1652,  4470, -4883,  4306,  4700,   424,  4613,
    4614, -4883,  3398, -4883, -4883, -4883, 93050, -4883,  4028,   933,
    4035, 77670,  3612,  3612, -4883,  1936,   283, -4883, 30203,  4785,
   -4883,  4532, 74470,  4675,  4677, -4883, 74470, -4883, -4883,  2229,
   -4883, -4883, 44329, -4883, -4883, -4883,  3427,   790,  1764, 22843,
   93050, -4883,  3840, -4883, -4883, -4883, 87290, -4883, -4883, -4883,
    1422,  4050,  1764,  4045, 62686, 44329, -4883,  4428,  4430,  1771,
   -4883, -4883, -4883, -4883, -4883, -4883,  3740,  1581, -4883,   101,
     101, -4883,   126,   101, -4883, -4883,   187, -4883, -4883,  1170,
     307,  3398, -4883,  2051,  2051,  2051,  2051,   266,  2051,  2051,
    2252, -4883,  3740,  3740,  1373, -4883,   841, -4883, -4883, -4883,
   -4883,   846, -4883, -4883, 89210, -4883,  4551,  4560, -4883,  4563,
   -4883, -4883,   342, -4883,  3296,  1081,  6084,    17, -4883,  4612,
   93050,  4821,  3839, -4883,  1126,  2159,  3427, 55142, 22843, -4883,
    4065,  4066,   266,  4068,   266,   266,  2051,  2051,  4016,  2051,
     266,  2051,  2051,  2051,  2051,  2051,  2051,  2051,   266,  2051,
      12,  3126,  2051,   266,  5032, -4883,  2051,  3528,  3740,  3740,
    4047, -4883,  4736,   101, -4883,  3032, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883,  4069, 72550,   813,
   -4883, 86650,  4618,  2553,  4084, -4883,  1317, -4883, -4883, -4883,
   -4883,  1632,  4752, -4883, -4883,  4775, -4883, 93050,   334,  4273,
    4580,  4091, 82810, 57853, 57853, 57853, 57853, 47054,  4672, 77670,
   -4883,  4739, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883,  9547, -4883, -4883,
   -4883,  4394,  2497,  4083, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883,  4090, -4883, 22843, -4883, -4883,
    4448, -4883, -4883, -4883, -4883, -4883, 53120, 22843,  3427,  3427,
   22843,  4092,  4092,  4098,  4104, -4883,  4815, -4883,  4754,  4092,
    4092, -4883,  4092,  4755,  4092,  4092,  4110, -4883, -4883,  4112,
    4117,  4121,  3184, -4883, 22843, 22843,  2291,    76,  2294,  2320,
    1539,  1550,   351, -4883,  2366,  3333, 94330, -4883, -4883,  2370,
    2412,  2453,  2474,  2502, -4883,  1574,  3977,  1641,  3427, 22843,
    3427, 22843,  3427, 22843,  3427, 23579,  2513, -4883,  2305,  4006,
   -4883,  2355,  4009,  2520,   358,   369,  2527,  2536,  2539,  2371,
   -4883,  2192,  4711,  2378, 23579,  2574,  2590,  1694,  1718,  2594,
   94330, 93050,  4116,  2722,  4126,  4126,   199, -4883,  4124, -4883,
   -4883, -4883,  4125, -4883,  2731, 22843, 22843,  4127,  3427,  4128,
    2826, -4883, 22843,  2010, 30203,   372, 30203, -4883, -4883,  4270,
   -4883, 22843, -4883,  4715,  4135,  3184,  4317,  4137,  4139,  3599,
    4140,  4142,  4143,  4145,  3427, -4883, -4883, 93050,  4146,  3417,
   -4883,  4016, -4883,  4781, -4883,  4893,  4152,  4170,  4155,  3975,
   -4883, 58553, -4883,  4706,  4832,  3601, -4883,  4833, 57853, 57853,
   57853, 57853, -4883, 41411, -4883, 81530, 15457, 15457, -4883, -4883,
   -4883,  4161,  4163,   -44,  4718, -4883, -4883, -4883, -4883, 93050,
   93050, 15457, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
    3692, -4883,  3777, -4883, -4883, -4883,   329,  4165, -4883,   101,
     326, -4883, 19163,  4166,  4167, -4883,  4637, -4883, 93050,  4169,
    4171,  4175, -4883, -4883, -4883,  4172,   362, 73830, -4883, -4883,
    4173, 91130, -4883,  4174, -4883,  4740, -4883, -4883,  4731, 70630,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883,  3777,  4405, -4883, -4883, -4883,  4199, -4883,  4183, -4883,
   -4883, 57853,  1081,  4562,  1190,  1190,  4773, 77670, 77670,  7195,
    7895,  3398,  4192, 93050, -4883,  3839, -4883,   383, -4883, -4883,
   -4883, -4883,  3417,  1936,  1936,  3017,  4676, 74470, 74470,  4423,
    4678, 22843,  4194, -4883, 93050, -4883,  1194, -4883,  4593, -4883,
   -4883, 22843, -4883, -4883, -4883, -4883,  3427,  4953,  4197, -4883,
   -4883, -4883, -4883, 22843, -4883, 22843,  4196,  4200, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883,   340,   340, -4883, -4883,   340,   340,
   -4883, -4883, -4883, -4883,   340,   340, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883,  2723, -4883, -4883, -4883,  1679,
   -4883, -4883,  4709,  1227, -4883,  4787, -4883, -4883, -4883, -4883,
     895,   266,   266,   266,  3126,  2247, -4883,  3296,  1636,  4540,
   -4883,  4585,  4604,  4782,  4604,  4783,  4701,  3846,  4570,   101,
    4786,  4955,   101, -4883,   157,   101,   101,   101,   101,  4256,
     101,   101,   101,   101,  4789,   101,   101,  4576,   101,  4857,
    4293,  4858,   101,  4794, -4883,  4295,   101,   101,   101,   101,
    4604,   101,   101,  4796,  4410,  4798,  4799,   101,   101,  1711,
   93050,   101,   101,  4801, -4883, -4883,  7895, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883,   451, 75750, -4883, -4883, -4883, -4883,
     101,  2010,  1407,  4728,  2059, -4883,  2405, -4883,  4988, -4883,
     148, -4883, -4883, 47728,  3427,   184,   264, -4883,   271, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, 93050,  3740,  3727,
   -4883, 82170,  2553, -4883, 93050,  4572,  4772,  3434, -4883, -4883,
   -4883, -4883, -4883, -4883,  4232, 22843, -4883, -4883,  4904, -4883,
   -4883, 57853, -4883, -4883,   263,   263,   263,   263,  2935,  4591,
   -4883, -4883, -4883,  4739,  4513, -4883,  1287, -4883,  4092,  4092,
     368, -4883,  4098,  4803,  4098, -4883,  4628,  1968,  2941,  4628,
   -4883,  1968,  4098, -4883,  4239, -4883,  4628, -4883,  1968,  4092,
   -4883,  4092, -4883, -4883,  1968,  4092, -4883,  4240,  4098, -4883,
   -4883,  4628, -4883, -4883, -4883, -4883,  1366,  2615,  4098, -4883,
   -4883, -4883,  4092,  1220,  4092,  4092,  4092,  4442,  4092,  4092,
    4951, -4883, -4883, -4883, -4883, -4883, -4883,  4098,   287,  4092,
    4092,  4092,  4092,  4104,  4922,  4923, -4883, 93050, -4883,  3427,
   -4883, 55142, 99738,   351,  3427,  1720, -4883, -4883, -4883,  2194,
   -4883, -4883, -4883,  4840, -4883, -4883,  4092, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,  4249,  3681,
    3681, -4883,  4994,  4788, -4883, -4883, 22843, 22843, -4883, 22843,
   -4883,   244,  4252,  4722, -4883, -4883, -4883, -4883, -4883, -4883,
   22843, 22843, 22843,  3427,  3427,  3427,  3681, -4883, -4883,  2764,
   -4883, -4883,  3506, -4883, -4883, 22843, -4883, 22843, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883,   387,  3681, -4883, -4883,
   22843, 22843, -4883, -4883, -4883, 93050, -4883,  3528,  4258,  4531,
   -4883, -4883, -4883,  3528,  4391, -4883, -4883,  3528,   266, -4883,
   -4883, -4883, 93050, -4883,  2408,  2826, -4883, 22843,  2010,  4844,
    4259,  5004,  4262, -4883, -4883, -4883, -4883, -4883, -4883, 22843,
   41411, -4883,  4267,  4264, -4883, -4883, -4883, -4883, 22843,  4896,
    4843, -4883,  3528, 93050, -4883, -4883, -4883, 57853, 57853,  3756,
    3756,  3756,  3756, 91770, -4883, -4883, -4883, -4883,  1858, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883,   101,   101, -4883, 35860,
   63370, -4883, -4883, -4883, -4883, -4883, -4883,  3777, -4883, 73830,
    2553, 22107, -4883, -4883, -4883, 19163, -4883, -4883,   457, -4883,
   73830, 83450,  4274,  4275, -4883,   101, 39390, -4883,  4276, -4883,
    4277, -4883,  1906,  4606,  4899, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
    4279, -4883, -4883,  2051,  2308, -4883, -4883,  4307, -4883, -4883,
   -4883, -4883, -4883, 77670, -4883, -4883, 40750,  4916, 77670, -4883,
   -4883,  4862, -4883,  7105, -4883, -4883, -4883, -4883,  1211,  4880,
    5050,  4292, -4883, -4883, -4883, -4883,  4399,  4292,  3839, -4883,
   -4883, -4883,  4791, -4883, -4883, -4883,  4792,  3427, 93050, -4883,
   -4883, -4883,  1261,  2137,  4924,  1764,  4300, 93050,  1764,  3427,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883,   931, -4883, 89210, -4883, -4883, -4883, -4883,
   -4883,  4894,  4895, -4883, -4883, -4883, -4883,  4493,   641, 76390,
    2598, -4883,  2048,  4346, -4883, -4883, -4883,  1857, -4883,  2598,
    2078,  2078,  4974,  2867,   228,  2867, 39390,  1189,  1559,  4957,
    2156,  2448,  4357,  4886,  2867,  2867,   101, 65422,   228, 73830,
     164, -4883, -4883, -4883, -4883, 77670,   219,   239,   250, -4883,
   -4883, 66106,  4016,   266,   266,   228,  2051,  2051,   101,   266,
   -4883, -4883, -4883, 89210, 93050, -4883,  1825,   266,  4016,  4016,
    2867,   254,  2051,   228, -4883,   228,   228,  1380,   164, -4883,
   -4883, -4883,   266,   164, 39390, -4883,  8228, -4883, -4883, -4883,
   40750, 93050,   143,  4876, -4883,  4319, 60616, -4883,  4501, 22843,
   22843,  4914, 93050,  4915, -4883,  4724, -4883, 93050, -4883,   457,
   -4883, -4883, -4883,  4624,  4835,  2415, -4883, -4883,  2434, -4883,
   -4883,  2444, -4883, -4883, -4883, -4883, -4883,  3912, -4883,  5010,
   -4883,  4680,  3757,   457, -4883,  3427, -4883,  4533,   263,  4807,
    4807,  4807,  4807, 55142, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883,  4987, -4883, -4883,  4628,   101,  4628, -4883, -4883,   870,
   -4883,   870, -4883,   338, 62686, -4883, -4883, -4883, -4883,   430,
   44984,  2469, -4883,  4732,  3643,  4628, -4883,  4818,  1968, -4883,
   -4883,   870,  1803, -4883, -4883,  4628, -4883, -4883, -4883,  1803,
     870, -4883,  4819, -4883, -4883, -4883,   870,  4628,  4549, 93050,
    4951,  1968, -4883, -4883, 96890,  1968,   870, 22843, -4883,  4903,
   -4883,   430,  5102,  1968,  4628,   870,   870, -4883,   257,  4351,
   -4883, 53794, -4883,  4356,  4360,  4361,  4364,   430,  2484,  4349,
   -4883,   430,   430, -4883,  4365,  4368, 22843,  1803,  4986,  2735,
    1891,  2494,  4651,  4603, -4883,  4537, -4883,  2739,  3427,  3427,
    -195,  4098, -4883, -4883, -4883, -4883,  5022,  4092, -4883,  5115,
   -4883,  4092, -4883, -4883, -4883, -4883, -4883, -4883,  4380,  2752,
    2773, -4883, -4883, -4883,  2501,  1794,  2779,  2785, -4883, -4883,
   -4883,  4382, -4883, -4883,   270, -4883,  4377, -4883, -4883,  2508,
    5127,   317, 22843, -4883,  4384, -4883, -4883, 93050,  3681,  1055,
   -4883,  2523, -4883, -4883,  4385,  3756,  3756, -4883, -4883, 84090,
   15457, 15457, -4883, -4883, -4883, -4883,  4181,  2492, -4883, -4883,
   -4883, -4883,  4386, -4883, -4883,  4381, -4883, 73830, 19163, -4883,
    4389,  4390, -4883, -4883, -4883, 91130, -4883,  2526, -4883, -4883,
    5151, 19163, -4883, -4883, 89210, -4883,  4395,  4396, 78310,  2943,
    2532, -4883, -4883, -4883, -4883, -4883, 77670, -4883,   312, -4883,
    7497, -4883,  7895,   259,  4705, -4883, -4883,  1535,  4517, -4883,
    4397, 93050,  2051,  4398,  5155, 22843,  4400, 22843,  4403,  2562,
   -4883,  2078, -4883,  2078, -4883,  1261,  5147,  5148,  5096,  5150,
    2137, -4883,  2322, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
    4411, -4883, -4883, -4883, -4883,  4742, -4883,  5005, -4883,  4865,
    2010, -4883, -4883,   228,  4418,  2010,  5095, -4883,  4432,  5068,
    5073,  2078, -4883,  2598, 78310, -4883,  2598,  2598, -4883, 78310,
   39390, 78310, -4883, 44329, 78310,  2867, 93050, -4883,  5111, -4883,
    5075, 78310, 78310,  2051, -4883, -4883, 39390,  4435, -4883,  1764,
   -4883, -4883, -4883,  2482, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883,  4440, -4883, -4883, -4883, -4883, -4883,  3528, -4883, -4883,
    2051, -4883, -4883,  4918, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, 78310, -4883, -4883, -4883, 39390, -4883, 39390, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
    4596,  3529, -4883,  4444,  4447, -4883, 93050, -4883, -4883, 77670,
   -4883, 42873, 93050, -4883, -4883, -4883, -4883, -4883,  3427,  3681,
    4842, -4883, -4883,  4568,  2051,  4812, -4883,  4925, -4883, 93050,
     165, 55142, -4883,   266, -4883,   266, -4883,   266, 30203, -4883,
   -4883,   362, -4883,  4807,  1116, -4883, -4883, -4883, -4883, 54468,
   -4883,  5103,  4971, -4883, -4883, 93050, -4883,  4930,  4956, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
     101, -4883, -4883, -4883, -4883,  2583, -4883, -4883,  2589, -4883,
   -4883, -4883, -4883, 96890, 10736, -4883,  2601, -4883, -4883, -4883,
    4951,  4460, -4883, -4883,  3427,  4485, -4883, -4883, -4883, -4883,
    5102, -4883, -4883, 79590, -4883, -4883, -4883, 93050,  5146,  5149,
   -4883, -4883, -4883, -4883, -4883,  5063, -4883, -4883, -4883, -4883,
    4469,  1764, -4883, -4883,  4476, 87290, -4883, -4883, 22843, -4883,
    4712, -4883,  4817, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
     430, -4883, -4883, -4883, -4883,  4016, -4883, -4883, -4883,  4482,
   -4883,   266, -4883, 22843, -4883, -4883,  4483,  4366,  1764, -4883,
   -4883,  4573,  4420,  4486, 93050, -4883,  4843, -4883, -4883, -4883,
   -4883,  4530, -4883, 84730, -4883, -4883, -4883, 93050, -4883, -4883,
    4016,  4846, -4883,  2660,  4681,  4488, 93050, 93050, 93050, -4883,
   -4883, 40750,  4494, -4883,  5255, -4883,  4862, -4883, -4883, -4883,
    4500,  4496, -4883, 93050, -4883, -4883,  5204, 55142, -4883, -4883,
   -4883,  5092,  1407, -4883,  4640,  4502,  9825, -4883, -4883, -4883,
    4640, -4883,  3427, 93050,  3427, 93050, -4883,  5182,  5182, -4883,
    1803,  1803,  5250,  1803, -4883,  5253,  5254,  2322, -4883,  5016,
     641,  4882,  1636,  5199, -4883, 93050,  5200, -4883, 22843,  2598,
   -4883, -4883, 78310,  5001,  1356, 78310, 78310,  1374, -4883, 78310,
    3065,  4164, -4883, 78310,  4390, 93050, -4883, -4883,  1632, -4883,
   -4883, 73830, -4883, -4883, 77670, -4883, -4883,  5024,   143, -4883,
   93050, -4883, -4883, -4883,  4519,  1880,  4514,  4515,   324,  1908,
    4518,  4240,  1921,  4520,  4521,   707,  4522,  4524,  4526,  4527,
    1366,   167,  1952,  4534,  4535,  4538,  4092,  4539,  1958,  1969,
    1978,  4092,  1988,  4541,  5261, -4883, -4883,  4544, -4883, -4883,
   -4883, -4883, -4883,  1137, -4883,  2683, -4883, -4883, -4883, -4883,
   48402, -4883, -4883, -4883,  3379, -4883,  4720, -4883,  1116, -4883,
    5026, 77670, -4883, -4883, -4883, -4883,   430,  1803,   430,  4951,
   -4883, -4883, 93050, -4883, 93050,  5133, -4883, -4883, -4883, -4883,
   40106, -4883, -4883, -4883,  4864, -4883,  2691, -4883, -4883,  4547,
   22843, -4883, -4883, -4883,  1036,  2788, -4883, -4883, -4883,  4552,
   -4883,  4554,  4050, -4883,  4421,  4673,  4251,  4253,  4254,  4733,
    4897, -4883,  4735, -4883,   266, -4883,  4556, 30203, -4883,  2237,
   -4883, -4883, -4883, -4883, -4883, -4883,  4976, -4883,  4565, 93050,
    2694,  1764,  4567,  2747,  4569, -4883, -4883, -4883,   118,   312,
   -4883,  2220, -4883, -4883,  5240, -4883,  4914, -4883, -4883, 93050,
    1458,  4764, -4883, -4883, -4883,  2798,  2821,  2105, -4883, -4883,
   -4883, -4883,  1803, -4883,  1803,  1803, -4883,  4574, -4883, -4883,
   -4883, 78310,  1169,  4571, -4883,  2799, 78310,  5001,  1488,  1190,
   -4883,  1190, -4883, -4883,  5276,  5278,   143, -4883, -4883, -4883,
   -4883, -4883,   228, -4883,  4577, 77670, -4883, -4883,  4390,  1198,
   93050,  5186,  3492, 10736, -4883, -4883,  3240, 93050,  4674, -4883,
   55142,  4777,  5309,  5315, -4883, 93050, 92410, 30203, -4883, -4883,
   -4883,  3811, -4883, -4883, -4883, -4883, -4883,  4578, -4883, 79590,
   -4883, -4883, -4883, -4883, 99738, -4883,  1764, 87290, 87290, -4883,
   -4883, -4883,  1242, -4883,  5339,  1497, -4883, -4883,   671, -4883,
   -4883, -4883, 93050,  4581,  4667, -4883, -4883,  4654, -4883, -4883,
    4118, -4883,  2723,  2859,  1317, 93050, -4883,  5181,  1317, 93050,
    5057, -4883, -4883, -4883, -4883, -4883,  2059, -4883, 10736,  4705,
   -4883, -4883,  4793, -4883, 93050, -4883, -4883, -4883,  5334, -4883,
    5336,  4598,  4600, -4883, -4883, -4883, -4883,  5261,  3528,  4843,
   -4883, 93050, -4883, -4883, -4883,  1190, -4883,  4601, -4883,  4602,
    4605, -4883, 32411, -4883, -4883, -4883, -4883,  5242, -4883,  2865,
   -4883,  1187,  5188, -4883,  5236, -4883,  2051, -4883,  4682, -4883,
    3492, -4883, -4883, -4883,  4644,  5247,  5203,   101, -4883, 89210,
   32411, -4883,  5099, -4883,  5054,  5321, -4883,  5372,  2984, -4883,
   -4883, -4883, 22843,  4968,  5240, -4883,  4811,  4813, -4883, -4883,
    2871, -4883, -4883,  3417, 73830, -4883, 93050, -4883, -4883, -4883,
   -4883, -4883, -4883,  4421, -4883, -4883,  4747,  1708, -4883,  2888,
   -4883, -4883, -4883,  3528, -4883,  4621, -4883,  4984,   101,   101,
    4985,   101,   101,   101,   101,  4625,  4118, -4883,  4978,  2898,
    1317,  2759,  1764,  4623,  1392,  4626, -4883, -4883, 77670,  4724,
   -4883, 56464, 93050,  4622, -4883, -4883, 91130, 91130, -4883, -4883,
    2930,  4630,  4632,  4634, -4883, 93050,  4635, 93050, 93050,  3126,
    3126, 16955, -4883, -4883, -4883, -4883, -4883, -4883,  3099, -4883,
    4636, -4883, 93050, -4883, -4883, -4883,   397, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, 61309, -4883, -4883,  5222, -4883,
    4679,  -196,   101, -4883,  3744,  3427, 22843, -4883, -4883, -4883,
   -4883, -4883, 92410,  4638, -4883,   101,  1189, -4883, -4883, -4883,
   -4883, -4883, -4883, 93050, -4883,  4642, -4883, -4883,    59,   101,
    2051,  2051,   101,  3755,  3755,  3528, 89210,  4725, -4883, -4883,
     101, -4883,  1364,  4826,  2051,   101,  1415,  2759, -4883, -4883,
     101, -4883, -4883,  1415,  1392, -4883, -4883, 93050,  5319,  5006,
    5240,  4639, 93050,  4648,  2947, -4883, -4883, 93050, 93050,  4650,
    2948, 93050,  2990,  2997, -4883, -4883,  4655,  4843, -4883,  1097,
    1097, -4883, -4883, -4883, -4883,  4652, -4883,   -36, -4883, -4883,
    3744,  3427, -4883, 73830, 19163, -4883,  4667, -4883, -4883,  3005,
   -4883, 27259, -4883, -4883, -4883,  2051, -4883, -4883,  2051, -4883,
   -4883, -4883, -4883, -4883,  3043, -4883, 89210,  1190,  1190,  1415,
    1364, -4883, -4883, -4883,  3061, -4883,   266, -4883,  5274,  5098,
   -4883, 62002, -4883, -4883,  4657, -4883, -4883, -4883, 93050,  4653,
   -4883, -4883,  3060,  3064, 93050,  1364,  3077,  2759,  1392, -4883,
    3089, -4883, -4883,  1650,  5116,  5251,  5257,   912, -4883,  2417,
    2417,  1474, -4883, -4883,  5209, -4883, -4883,  4642, -4883,  4668,
   -4883,  3417, -4883, -4883, 89210, -4883,  4725, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, 93050,  4876,  1364,  3092, -4883,  1364,
   -4883, -4883, -4883, -4883, -4883, -4883,  5158,  5379, -4883,  4683,
   -4883,  2417, -4883, -4883, -4883, -4883, -4883,  1733,  4973,  4593,
   -4883, 27259,  4684,  4118, -4883, -4883,  5370, -4883, -4883, -4883,
    1364, -4883,  1097,  1097, -4883, -4883, -4883,  1733, -4883,  5422,
    4924, -4883, -4883, -4883,  4808, -4883, -4883, -4883, -4883,  1803,
    5337, -4883, -4883,  5273,  4686,  1621,  1578, 67430,  5215, -4883,
   -4883, 89210, -4883, -4883, -4883, -4883, -4883, 89210,  3103, -4883,
   -4883, 73830, -4883, -4883, 55142, -4883, -4883, 69990,  4685, -4883,
     101,  5240, -4883, 73830, -4883, -4883, -4883, 19163, -4883, -4883
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,  1126,  2360,     0,   454,     0,  1346,   721,  2215,  2353,
    2354,  2140,     2,   509,   220,   407,  2142,  2425,     0,     0,
     505,  1362,   862,   616,     0,   332,     0,     0,   512,   330,
     220,  1411,  3065,  2260,     0,  3156,  2203,     0,  1409,   507,
    2523,  3407,  2145,     0,  3308,     0,     0,     0,  3313,    71,
    2108,     0,  1362,   353,  3158,    84,     0,     0,  1362,  2409,
    3313,     0,  2437,     0,     0,  2241,     0,     0,     0,     0,
       3,     8,    22,     0,    44,    27,    32,    17,    21,    16,
      46,    59,    52,    29,  3310,   403,   404,   405,   406,    42,
    3343,    41,    11,    62,    63,    19,    49,    12,    15,    18,
      40,    48,    36,    43,    56,    57,  1432,  1408,  1436,  1407,
    1403,  1399,  1418,  1419,  1420,  1426,    25,    26,    33,    50,
      67,    23,    64,    60,    24,  2360,    13,    28,    14,    51,
      45,    37,    61,    68,    38,     0,    58,    39,    66,    31,
      53,    30,     9,    10,    20,    54,    55,    47,    69,    34,
      65,    35,  1171,     0,     0,     0,     0,     0,  2138,     0,
       0,  2138,  1255,  1476,  3341,  3342,  3343,  1363,     0,  1364,
       0,     0,  2561,  2562,  2769,  2815,  2816,  2711,  2844,  2663,
    2939,  2961,  2987,  2751,  2750,  2753,  2752,  2754,  2755,  2756,
    2757,  2758,  2759,  2636,  2760,  2761,  2762,  2764,  2763,  2765,
    2766,  2767,  2637,  2710,  2638,  2716,  2768,  2718,  2717,  2770,
    2639,  2640,  2771,  2772,  2773,  2774,  2694,  2642,  2641,  2775,
    2777,  2776,  2719,  2720,  2697,  2778,  2779,  2780,  2782,  2643,
    2644,  2645,  2646,  2647,  2781,  2648,  2783,  2698,  2784,  2785,
    2649,  2786,  2787,  2788,  2789,  2791,  2790,  2691,  2792,  2793,
    2795,  2796,  2797,  2794,  2798,  2799,  2801,  2800,  2722,  2802,
    2721,  2803,  2650,  2804,  2805,  2806,  2807,  2808,  2809,  2810,
    2811,  2699,  2812,  2813,  2814,  2836,  2712,  2817,  2819,  2818,
    2723,  2820,  2821,  2822,  2824,  2823,  2825,  2827,  2651,  2652,
    2653,  2826,  2828,  2829,  2830,  2831,  2832,  2834,  2833,  2838,
    2839,  2724,  2654,  2695,  2655,  2656,  2835,  2837,  3042,  2840,
    2841,  2725,  2726,  2842,  2657,  2713,  2843,  2700,  2846,  2845,
    2658,  2847,  2659,  2848,  2849,  2850,  2851,  2852,  2854,  2856,
    2853,  2857,  2858,  2864,  2660,  2855,  2859,  2860,  2861,  2862,
    2863,  2865,  2727,  2866,  2692,  2868,  2867,  2869,  2870,  2871,
    2872,  2728,  2873,  2714,  2874,  2875,  2876,  2889,  2890,  2880,
    2881,  2883,  2884,  2887,  2882,  2888,  2893,  2892,  2894,  2895,
    2896,  2897,  2898,  2891,  2878,  2885,  2886,  2879,  2899,  2900,
    2877,  2901,  2903,  2902,  2904,  2729,  2905,  2906,  2907,  2908,
    2909,  2910,  2911,  2912,  2914,  2913,  2915,  2730,  2731,  2732,
    2916,  2917,  2918,  2707,  2919,  2733,  2734,  2920,  2923,  2921,
    2922,  2924,  2925,  2930,  2931,  2932,  2693,  2927,  2926,  2928,
    2929,  2735,  2736,  2737,  2933,  2934,  2935,  2936,  2938,  2937,
    2701,  2662,  2661,  2664,  2940,  2941,  2665,  2942,  2944,  2943,
    2709,  2666,  2945,  2946,  2948,  2947,  2738,  2739,  2667,  2696,
    2668,  2669,  2949,  2950,  2951,  2952,  2953,  2954,  2955,  2956,
    2957,  2958,  2959,  2960,  2740,  2741,  2962,  2963,  2964,  2966,
    2965,  2967,  2968,  2969,  2970,  2971,  2972,  2973,  2670,  2974,
    2702,  2975,  2976,  2671,  2978,  2977,  2672,  2979,  2980,  2981,
    2982,  2983,  2708,  2703,  2984,  2985,  2986,  2742,  2988,  2989,
    2990,  2704,  2991,  2992,  2993,  2673,  2994,  2995,  2743,  2715,
    2674,  2996,  2998,  2705,  2675,  2997,  2677,  2678,  2999,  3000,
    3001,  2676,  3002,  2679,  3003,  3004,  3006,  3005,  3007,  3008,
    3009,  3010,  2680,  3011,  3012,  2681,  3013,  2682,  3014,  3015,
    3016,  3017,  3019,  3018,  3020,  3021,  3022,  3023,  3024,  3025,
    3027,  3029,  3028,  3026,  3030,  3031,  2744,  3032,  2683,  2745,
    3037,  3038,  2746,  3033,  3034,  3035,  3036,  2706,  3039,  3040,
    3041,  2686,  3043,  3044,  3046,  3045,  2684,  2685,  3047,  3048,
    2690,  3049,  3050,  3055,  2747,  2748,  3051,  3052,  3064,  3053,
    3054,  3057,  3056,  3058,  3059,  2606,  2687,  3060,  3061,  2688,
    3062,  2689,  3063,  2749,  2566,  2577,   240,  2578,  2603,  2601,
    2605,  2599,  2600,  2604,  2598,  2602,   456,   129,     0,     0,
       0,     0,  2236,  2138,  2112,  2138,  2138,  2138,  2138,     0,
    2138,  2138,     0,  2141,  2138,  2138,     0,     0,     0,   447,
    2148,  2427,     0,  2447,  2448,  2442,  3146,  3147,  3141,   409,
       0,     0,     0,  2327,  2326,     0,     0,   317,   329,   332,
     325,   328,     0,   220,  1365,   409,   331,   332,     0,  1441,
    3067,     0,  2332,   332,     0,  2213,  2441,     0,     0,  2524,
    2521,  2213,  2398,  2400,     0,  2396,  1548,  1547,     0,  3313,
    2567,     0,  1341,  1373,  1299,  3314,  3315,     0,    76,    79,
    2365,   354,     0,     0,     0,   719,     0,     0,  1307,     0,
    3315,  3325,  2439,     0,   129,  1280,     0,   129,  2243,  2138,
    2138,  3390,  3391,     0,     0,     0,  3385,     0,  3392,     0,
    1436,     0,  1422,     1,     5,     0,     0,   719,  1083,  1084,
    1082,   719,   719,     0,     0,     0,     0,     0,  3348,  3341,
    3342,  3343,     0,  2094,  1961,  1437,  1436,  2041,  2045,  3329,
    3328,  3330,     0,     0,  2041,  1427,  2831,  2656,  2944,     0,
    2345,  2359,  2343,  2555,  1405,  1401,  1129,  1172,  1132,   224,
       0,     0,  1134,     0,     0,  1149,  2583,  2582,  2581,  1146,
    1145,  1144,  1142,     0,   580,   220,     0,  1257,     0,     0,
       0,  3349,  3348,     0,  1318,  2347,  2348,  2349,  2350,  2351,
    2352,  2355,     0,   246,   467,   470,     0,   459,   462,     0,
     130,   131,  1344,  1347,     0,   722,     0,   166,     0,  2240,
    2239,     0,  2238,  2216,     0,  2236,     0,  2136,     0,     0,
       0,     0,     0,   220,     0,  2328,   220,  2120,  2138,  2138,
     510,   484,  3211,  3226,  3227,  1489,  3223,  3228,     0,  3225,
    3217,     0,  3221,  3215,     0,  3247,  3219,  3224,  2823,  2653,
    2838,  2953,  2957,  2973,  2976,  2705,  3020,  3205,  3190,  3206,
       0,     0,  3209,  3213,     0,     0,  2149,  2150,  2151,  1253,
    2428,  2429,  2433,     0,  2451,     0,   422,     0,     0,     0,
       0,   411,   412,   478,     0,   418,     0,   409,   393,     0,
     392,   394,     0,   413,   388,   396,   395,   397,   398,   399,
     400,     0,   401,   402,   475,     0,   389,   390,   506,   391,
    2579,     0,  2580,  2608,  2610,  2607,  2609,  1360,     0,  2511,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1489,
    1489,  1489,  1486,     0,     0,     0,  2516,     0,     0,     0,
       0,  2507,     0,  2517,     0,     0,     0,  2509,  2510,  2563,
    2564,     0,     0,     0,     0,  2514,     0,     0,     0,     0,
       0,  2490,  1550,     0,  1486,     0,  2506,  2513,     0,  2498,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1486,  2489,  2508,  2515,     0,  1489,  1486,  1486,
       0,     0,     0,     0,     0,  2752,  2636,  2767,  2694,  2778,
    2780,     0,  2643,  2644,  2645,  2646,  2647,  2691,  2802,  2721,
    2803,  2656,  2725,  2842,  2849,  2867,  2869,  2728,  2908,  2910,
    2915,  2730,  2731,  2732,  2921,  2922,  2935,  2709,  2738,  2739,
    2951,  2958,  2983,  2742,  2988,  2993,  2996,  3016,  2745,  3037,
    3038,  2746,  3036,  2706,  3049,  3055,  3058,  3059,  2687,  2749,
       0,     0,     0,     0,  1549,     0,     0,  1797,  1434,  1626,
     863,  1495,  1507,  1523,     0,  1624,  1623,  1627,  1629,  1635,
    1542,  1656,  1595,  1596,  1598,  1719,  1597,  1602,  1603,     0,
    1773,  1604,     0,     0,  1601,  2503,  1600,  1599,  2504,  2505,
    1594,  2541,  2577,     0,  2565,   618,   617,     0,   344,   339,
     347,   341,   343,   342,   348,   349,   350,   345,   340,   346,
     333,     0,   318,     0,   326,  3326,     0,     0,   409,   513,
     351,  3211,  2753,  2957,  3179,     0,  3189,     0,  3340,  3335,
    3337,  3336,  3333,  3334,  3338,  1462,  3339,  1461,  1412,  1442,
    1459,  1460,     0,     0,     0,  1001,  3090,  3091,  2707,  2709,
    2708,  3092,  3033,  2635,     0,     0,  2572,     0,     0,  2573,
    2632,  2630,  2634,  2629,  2633,  2628,  2631,  3066,  3076,  3072,
       0,     0,     0,  2340,  1079,  1078,     0,     0,     0,  2282,
       0,  1001,  2340,  2283,     0,  2018,  2330,  2333,     0,  3094,
    2296,  1080,  3095,  2326,     0,  2268,  2284,  2245,  2289,   129,
    3096,     0,  2329,  2018,  2340,     0,  2261,     0,     0,     0,
       0,  1475,     0,   327,  3157,  2214,  1253,  2183,  1410,  2169,
     508,     0,     0,  2153,  2156,  2152,     0,  2397,   480,  3309,
       0,     0,     0,     0,  3318,  1844,  2109,     0,    80,    75,
       0,     0,     0,     0,  2560,  3159,    85,     0,     0,  3404,
      73,     0,  2415,     0,  2413,  2410,  2412,     0,  3318,     0,
    2438,  1287,  1287,     0,     0,  1279,  1281,  1282,  1287,  1287,
    2244,     0,     0,     0,  2497,  2495,  2496,  2568,  3387,  2494,
    2493,  3396,  3398,  3381,     0,  3384,  3383,  3393,  1425,  1424,
       6,    70,     0,   220,   220,   719,   168,   719,   140,   143,
     719,   719,   719,   152,   156,     0,   222,     0,     0,  3348,
    1440,     0,     0,  1452,  1438,  1857,  1439,  1859,  1856,  1855,
    1854,  1885,  1886,  1888,  1887,  1889,  1891,  1882,     0,     0,
    2107,     0,  2102,  1962,  1967,  1961,     0,     0,     0,     0,
    2040,  2018,  2049,  2042,  1404,  2038,     0,  1400,  1465,  1465,
    3332,  3331,  3327,  2043,  1423,  1431,  1429,  1430,  2044,  1421,
       0,  2357,  2557,     0,  2362,     0,  2041,  2045,  1017,     0,
     225,     0,  3346,  3347,  3345,  1489,  2584,  2587,  3344,  2588,
     225,  1143,     0,   581,  2139,     0,     0,     0,     0,     0,
       0,   583,   582,   519,     0,     0,  1261,  1262,  1256,  1258,
    1260,     0,     0,     0,     0,  2361,     0,   242,   248,   241,
       0,   409,     0,   457,   463,    86,     0,  1348,  2129,  2131,
     165,     0,     0,     0,  2217,     0,  1450,  1961,  2219,  2224,
    2230,  2234,  2237,  2114,     0,     0,  2117,  2123,  2122,  2116,
    2328,     0,  2126,   594,     0,     0,     0,  2127,  2110,     0,
       0,  3212,  3210,  3244,  3243,  3248,     0,  3245,  3241,     0,
    3204,  3249,  3234,  3281,  3238,  3281,  3281,  3235,  3242,  3281,
       0,  3240,  3239,     0,  3207,     0,     0,     0,  1254,  2156,
    2434,     0,  2426,     0,  1383,  2453,  2452,  2449,  1953,  3143,
    3148,   416,   423,     0,     0,  2921,     0,   428,   427,   426,
     279,   444,   416,   419,   436,     0,     0,   277,   410,     0,
     442,   445,   499,   495,   503,   497,   476,   472,     0,     0,
       0,     0,  1630,  1959,  1959,  1959,     0,     0,  1852,     0,
       0,     0,     0,  1959,     0,  1668,  1641,  1642,     0,  1669,
       0,     0,     0,     0,     0,     0,     0,     0,  1803,     0,
       0,     0,     0,     0,     0,     0,  2563,  2564,     0,     0,
       0,  1846,  1848,  2541,  2565,  1959,     0,  1959,     0,  1494,
    1676,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1959,  1959,  1959,  1681,  2491,  2512,  1685,  1687,
    1686,  1959,  1959,     0,     0,     0,     0,     0,  1959,     0,
       0,     0,  2500,  2499,     0,     0,     0,     0,     0,     0,
       0,  2518,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2520,     0,     0,     0,  2519,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1632,     0,  1631,  1633,
       0,  1434,   864,     0,     0,     0,     0,  1546,  1545,  1544,
    1543,     0,     0,     0,     0,  1552,     0,  1554,  1556,  1551,
    1553,  1555,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1634,     0,     0,     0,     0,     0,  2492,     0,
    1729,     0,   630,  2423,     0,     0,     0,   316,  1367,  2589,
       0,  1366,  1370,  3143,   492,  3210,     0,     0,     0,  3207,
    1476,  1458,     0,     0,  3068,  3070,  1000,     0,     0,  1003,
    1005,  2174,  2173,  1004,  1013,     0,  1002,     0,  3131,     0,
       0,  3116,     0,  3097,     0,  1009,  1011,  1010,  3111,  1008,
       0,     0,     0,  3081,     0,     0,   719,     0,     0,     0,
       0,     0,     0,     0,  2311,     0,  1475,  1475,  2262,     0,
    2340,  2330,     0,  2340,  2336,  2295,     0,     0,   775,  2023,
    2019,  2288,  2334,  2335,  2340,     0,     0,  2340,     0,  2302,
    2330,  2340,  2257,     0,     0,  2249,  2254,  2250,     0,  2256,
    2255,  2258,  2246,  2247,     0,  2275,  2304,     0,  2287,  2294,
       0,  2274,  2281,     0,  2292,  2330,  2330,     0,  2340,  2340,
    2340,     0,  1476,     0,   490,  2522,  2525,  2529,  2533,  2156,
    2146,  2155,     0,  2399,   279,     0,     0,  1375,  1377,  1376,
    1393,  1301,  3317,     0,  3319,     0,  3321,     0,    77,     0,
       0,  2392,  2390,     0,     0,     0,  2384,  2386,  2389,  2385,
       0,     0,  2391,   129,     0,  2387,  2366,  2369,  2376,  1475,
    2367,     0,     0,   352,   355,   357,     0,   360,  1953,  3162,
    3161,     0,     0,     0,  1305,  1308,     0,  2420,  2417,   129,
       0,  2704,  3324,  3322,     0,  1275,  1291,  1273,  1285,  1286,
       0,     0,  1278,  1277,  3143,  3405,  3406,     0,     0,  3382,
    3399,  3380,     0,  3394,  3395,  3379,     7,     4,   146,     0,
       0,     0,   137,   719,   719,   132,     0,   154,  1476,  1476,
     719,   719,   719,     0,     0,  1855,  1885,  1886,  1888,     0,
    1887,     0,     0,  1953,     0,     0,  1877,  1901,     0,  1901,
    1879,  1880,     0,     0,     0,  1452,  1883,  2569,  2103,  2106,
       0,  2095,  2097,  2098,  2581,  2100,     0,     0,  1964,  1967,
    1467,  2031,  2032,     0,  2030,     0,  2020,  2024,  2029,  2027,
       0,  2011,  2048,  2039,  2087,  1466,  2046,  2047,  1428,  2346,
    2344,  2363,  2364,  2556,  1406,  1402,  1018,  1017,   713,   716,
     715,     0,     0,  1133,   223,  2586,     0,  1135,     0,  2328,
    1150,     0,     0,  2328,   530,  2328,   584,  2587,  3274,     0,
    3286,  3263,  3143,  1259,  3350,  3351,  1140,  1138,     0,  1319,
    1320,  1323,     0,   246,     0,   249,   251,   468,   409,     0,
       0,     0,  1358,     0,  1356,  1355,  1353,  1354,  1352,     0,
    1343,  1349,  1350,  2328,   522,  1882,     0,  2220,  2226,  2133,
    2135,  2555,     0,  1451,  2222,  2009,     0,     0,     0,  2232,
    2137,     0,     0,   594,  2119,  3202,   597,   596,  2124,   595,
    2175,  3261,  2118,  1263,     0,     0,   409,   482,   485,  3237,
    1490,     0,  3218,  3222,  3216,  3220,     0,  3200,     0,     0,
    3208,     0,     0,  3246,  3229,  3233,  3232,  3230,     0,  3231,
    3236,  3214,   408,   448,  2143,  2850,  3049,  2435,  2431,  2430,
       0,  2450,     0,  1954,  1955,     0,     0,  1957,  3145,  2050,
       0,  3142,   424,     0,   416,     0,     0,     0,   439,   275,
     420,   416,   429,   438,   489,   278,   414,     0,     0,   409,
     409,     0,   279,  3143,     0,  1960,     0,  1818,     0,     0,
       0,     0,     0,     0,  1610,     0,     0,     0,  1756,     0,
    1818,  1780,  2080,  2081,  2061,  2062,  2060,  2063,  1487,     0,
    2064,  2079,  1697,     0,     0,     0,  1778,  1433,  1416,     0,
       0,  1929,  1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,
    1938,  1939,  1940,  1942,  1947,  1943,  1944,  1945,  1946,  1941,
    1948,     0,  1928,     0,  1804,  1769,     0,     0,     0,     0,
     864,     0,     0,     0,     0,     0,     0,     0,  1959,     0,
       0,  1959,     0,     0,     0,     0,  1779,     0,     0,     0,
    1777,     0,     0,  1776,  1654,     0,     0,  1959,     0,     0,
       0,     0,     0,     0,  1660,  1661,     0,     0,     0,  1586,
       0,  1584,  1585,     0,     0,  1959,     0,     0,     0,     0,
       0,     0,     0,     0,  1577,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1951,  1949,  1952,  1950,     0,     0,
    1844,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1711,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1658,     0,     0,     0,  2546,     0,  1049,     0,     0,     0,
       0,  1625,     0,     0,     0,     0,  3097,  1798,  1800,  1492,
    1491,  1493,  1504,  1498,  1502,  1496,  1500,     0,  1557,  2759,
    1505,     0,     0,     0,  1508,  1517,  1521,     0,     0,     0,
       0,     0,  1539,  1540,  1528,  1526,  1527,  1524,  1525,     0,
    1530,     0,  1529,  1536,  1537,  1538,  1541,  1628,  1012,  1636,
    1979,  1771,  1772,  1796,  1983,     0,     0,     0,     0,  2542,
    1476,  1580,  1579,  1581,  1582,  1583,   631,     0,   625,   628,
     642,     0,     0,  2422,     0,  2721,  2745,  2746,   334,   337,
     336,   338,     0,     0,     0,     0,     0,     0,     0,     0,
    3265,  3187,     0,     0,     0,     0,  1472,  1413,  1471,     0,
       0,     0,     0,     0,     0,  3114,     0,     0,  3113,  3112,
       0,  3133,     0,     0,  3118,  3139,  3140,  3137,  3138,  3136,
    3117,     0,     0,  3075,  3119,  3120,  3123,     0,     0,     0,
       0,     0,  3104,     0,  3033,  3077,  3078,  3083,  3073,  2303,
       0,     0,  2306,  2299,  2310,  2769,  2308,  2320,  2307,  2301,
    2312,  2300,     0,     0,  2317,  2313,  2340,     0,  2340,  2315,
       0,  2338,  2325,  2324,  2323,  2272,  2271,  2265,  2331,  2318,
    2314,   220,  2340,  2270,  2269,  2251,  2252,  2253,     0,  2018,
       0,  2336,  2305,  2330,     0,  2340,  2340,  2321,  2322,  2291,
    2293,  2202,     0,  1882,     0,     0,  2188,  2181,  2168,   409,
       0,     0,  2527,  2154,     0,  2157,  1882,   275,     0,     0,
       0,   615,  1393,  1379,  1395,  1303,  1302,  1300,  3316,  3320,
    1845,    79,  2196,  2194,    81,  2193,  2195,    82,  2401,  2378,
    2377,  2379,  2383,   129,  2388,  2380,     0,  2393,  2394,   365,
       0,   361,     0,     0,  3160,     0,   720,     0,    74,     0,
    1309,  2050,  2416,  2418,  2411,  3323,     0,  1276,  1293,  1292,
    1288,  1289,  1294,  1284,  1283,  2242,  3388,  3397,  3401,  3386,
     711,  3198,  3286,   189,     0,     0,     0,     0,   135,     0,
     719,   153,   157,   719,     0,     0,     0,   719,     0,  1898,
    1890,  1892,  1893,  1894,     0,  1897,     0,  1455,     0,  1443,
    1443,  1453,  1900,  1881,  1878,  1902,     0,  1901,  1901,     0,
       0,  1861,  1860,     0,  1953,  1006,  2099,     0,     0,  1963,
       0,  1965,  1974,  1964,  1469,  2050,  1463,     0,  2499,     0,
       0,     0,     0,     0,     0,     0,   714,  2175,  2175,     0,
       0,     0,     0,     0,     0,     0,     0,   226,   235,  2585,
       0,     0,   528,   529,  2175,   527,   570,   571,   574,   575,
     576,     0,     0,   577,  2175,  2175,   524,   550,   551,   554,
     555,   556,   557,   558,   520,     0,   525,     0,     0,     0,
    3298,  1127,  1163,  3352,  1136,     0,     0,  1322,   244,   243,
     247,     0,     0,   455,   464,   458,   460,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    87,    88,   109,     0,  1345,  1357,  2130,  1351,  2175,
    2175,  2175,  2175,   526,   559,   560,   563,   564,   565,   566,
     569,   567,   568,     0,  2328,  2221,  1443,     0,     0,     0,
    2558,     0,  2034,  2010,  2231,     0,  2235,  2234,     0,  2115,
    2125,     0,  2176,     0,     0,  1265,  1264,  2121,  2128,  3143,
     409,   483,   429,  3285,     0,  3284,     0,     0,  3197,     0,
    3257,  3260,  2555,     0,     0,     0,     0,   409,     0,  2432,
    2436,  1384,  1386,  1387,  1385,  1393,     0,  2570,  1958,  2571,
    2595,  2593,  2597,  2591,  2592,  2596,  2590,  2594,     0,  3151,
    3152,  3150,  2055,  2051,     0,  3144,  3149,   417,   425,   440,
     443,     0,     0,   409,     0,   421,   430,   434,     0,   446,
     500,   473,   473,   473,   275,  1361,     0,  1751,     0,  1752,
    1753,     0,  1611,  1853,     0,     0,     0,  1639,     0,     0,
       0,  1755,     0,  1488,     0,     0,  1614,  1606,  1417,     0,
    1782,     0,  1787,     0,  1785,     0,     0,     0,     0,     0,
       0,  1847,     0,  1849,  2542,     0,  1761,  1792,     0,  1759,
       0,  1781,     0,  1793,  1794,     0,     0,     0,  1765,  1763,
       0,  1767,  1764,  1766,     0,     0,     0,  1680,     0,     0,
       0,     0,     0,     0,     0,  1657,     0,  1693,     0,  1749,
    1694,  1695,  1696,  2545,     0,  1690,     0,  1691,     0,     0,
       0,     0,     0,  1643,  1644,     0,  1721,     0,  1645,  1701,
       0,  1619,  1722,  1703,  1650,  1651,  1723,  1724,  1725,  1616,
    1617,  1705,  1706,     0,  1727,  1618,  1707,  1710,     0,  1653,
    2050,     0,  1637,     0,     0,     0,  1655,  1684,     0,     0,
       0,  1615,     0,  1713,     0,     0,     0,  2050,     0,     0,
    1659,     0,     0,   865,  1435,  1607,  2543,     0,     0,  1499,
    1503,  1497,  1501,     0,     0,     0,     0,  1516,     0,     0,
    1509,  1519,  1522,     0,     0,  1981,     0,     0,  1790,  1842,
    1842,  1842,  1842,     0,     0,     0,  1745,  1746,     0,     0,
     624,   623,     0,   627,   703,     0,   644,   632,   621,  2424,
       0,     0,  1368,  1371,     0,     0,     0,  3188,     0,     0,
       0,     0,     0,     0,     0,  1476,  1477,  1477,  2541,     0,
       0,  3101,  3071,     0,     0,     0,  1016,  1015,  1014,  3132,
       0,     0,  3125,  3126,     0,     0,     0,  3098,  3099,  3100,
       0,  2618,  2574,  2576,     0,  2575,  2616,  2614,  2617,  2612,
    2613,  2611,  2615,  3107,     0,  3080,  3081,  3082,     0,     0,
    2298,  2309,  2341,  2342,  2266,  2319,  2316,  2337,  2050,  2276,
    2297,  2267,     0,  2290,  2248,  2338,  1961,  2330,  2263,  2264,
       0,  1452,  1477,  2184,  1476,  2185,   409,  2526,     0,  2531,
       0,  2163,     0,  2160,  2167,   608,  2147,     0,  2158,  2132,
     409,  1342,  1382,  1374,  1381,  1378,  1393,  1391,  1380,  1075,
    1074,     0,  1394,    78,     0,     0,  2381,  2382,  2375,  2395,
    2370,     0,   356,   366,   358,   362,   363,   364,   359,  2839,
    2921,     0,  1961,  3164,  3403,  1316,  1314,  1313,  1315,  1304,
    1310,  1311,  2421,  2419,  2414,  2440,  1291,     0,  1274,  2050,
       0,  3400,   147,   712,     0,   164,  3298,     0,  1099,     0,
       0,   133,   169,  3376,   155,  3366,     0,   148,     0,   224,
       0,     0,  1895,  1896,  1858,  1443,  1445,  1444,     0,     0,
    1447,     0,     0,     0,     0,  1866,     0,  1862,  1864,     0,
    1926,  1918,     0,  2104,  2096,  2101,  2540,  1971,  2015,     0,
       0,  1414,  1974,  1468,  2033,  2022,     0,  2026,  2025,  2028,
    1467,  2012,  2015,  1476,     0,     0,  1131,     0,     0,     0,
     229,   232,   230,   231,   579,   578,     0,  2328,   572,  2175,
    2175,   183,  2175,  2175,   182,   184,     0,   178,   175,   185,
    2175,  1151,   171,     0,     0,     0,     0,  2050,     0,     0,
       0,   191,     0,     0,  2328,   552,   531,   532,   535,   536,
     537,     0,  3268,  3267,     0,  3288,     0,     0,  3290,     0,
    3289,  3287,  3253,  3264,     0,  1158,  1017,     0,  1165,  1167,
       0,     0,  3352,  1321,     0,   246,   250,   409,     0,   461,
       0,     0,  2050,     0,  2050,  2050,     0,     0,  2050,     0,
    2050,     0,     0,     0,     0,     0,     0,     0,  2050,     0,
       0,     0,     0,  2050,     0,  1359,     0,     0,     0,     0,
    2328,   561,     0,  2175,   521,   538,   539,   542,   543,   544,
     545,   546,   549,   547,   548,  2218,  2134,  2234,     0,  2556,
    1475,     0,  2228,  1961,     0,  2233,  3143,  3203,   593,   774,
    3262,  1263,     0,   304,   432,   487,  3282,     0,  3302,     0,
       0,     0,     0,     0,     0,     0,     0,   409,  2197,     0,
    1393,  1397,  2443,  3154,  3155,  3153,  2058,  2059,  2056,  2054,
    2057,   441,   308,   310,   307,   309,  2627,     0,   295,   281,
     297,     0,   384,   290,   382,   383,  2624,  2622,  2626,  2620,
    2621,  2625,  2619,  2623,   479,     0,   280,     0,   437,   429,
       0,   494,   496,   474,   504,   498,   409,     0,  1819,  1850,
       0,   967,   967,   953,   971,  1836,     0,  1830,  1833,     0,
     967,  1838,   967,  1831,   967,     0,     0,  1828,  1829,     0,
       0,     0,  1757,  1754,     0,     0,     0,  1807,     0,     0,
       0,     0,     0,  1533,     0,  1740,     0,  1762,  1760,     0,
       0,     0,     0,     0,  1768,     0,  1665,  1663,  1592,     0,
    1590,     0,  1591,     0,  1593,     0,     0,  1750,     0,  1559,
    1578,     0,     0,     0,     0,     0,     0,  1845,     0,     0,
    2066,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2547,     0,     0,     0,  1038,  1044,  1047,  1048,
    1050,  1042,     0,  1715,     0,     0,     0,  1801,  1799,     0,
    1514,  1510,     0,  1518,     0,     0,     0,  1532,  1531,  1983,
    1982,     0,  1789,     0,     0,  1843,  1844,     0,     0,  1844,
       0,     0,     0,  2544,  1477,  1730,  1476,   634,     0,   652,
     626,  2050,   629,     0,   643,     0,   655,     0,     0,     0,
     335,     0,  1372,     0,     0,  3186,  3266,     0,     0,     0,
       0,     0,  1470,  1478,  1473,     0,     0,     0,  3069,  3115,
    3106,     0,     0,     0,     0,  3130,  3124,  3121,  3122,     0,
       0,     0,  3105,  3079,  3085,  3084,  3087,  3089,  2286,  2285,
       0,  2339,  2018,  2259,  2278,  2280,  2340,  2204,  2207,     0,
    1953,  2192,     0,     0,  2186,  2190,     0,  2530,     0,     0,
       0,  2164,  2166,  2535,  2534,  2546,     0,     0,  2159,   481,
       0,  1920,    83,     0,  2373,     0,  2368,  2371,     0,     0,
    3175,  3176,  3168,  3171,  3169,  3170,  3174,  3177,  3178,  3165,
    3172,  2018,     0,  1306,  1312,  1290,     0,  1297,  1295,  3389,
    3402,     0,  1158,     0,     0,     0,     0,     0,     0,   723,
     723,   170,     0,     0,   200,  3352,   160,     0,   158,   150,
    1454,  1446,  1448,  1443,  1443,     0,  1854,     0,     0,     0,
    1854,     0,     0,   615,     0,  1899,  1915,  1007,  2457,  1972,
    1973,     0,  1968,  2016,  2017,  1970,  1966,     0,  1975,  1977,
    1415,  2021,  1464,     0,  2014,     0,     0,  2090,  2092,   773,
     772,   234,   233,   238,   239,  2076,  2077,  2074,  2075,   585,
     598,  2078,   599,   573,  2050,  2050,  2180,  2179,  2050,  2050,
     177,   174,  2178,  2177,  2050,  2050,   172,   195,   194,   196,
     197,   199,   198,   193,  1147,     0,   586,   587,   553,     0,
     533,  3271,     0,  3278,  3273,  3276,  3256,  3255,  3254,  3251,
       0,  2050,  2050,  2050,     0,  2050,  3297,  3299,     0,     0,
    1148,  1251,  1251,     0,  1251,     0,     0,  1251,     0,  2175,
       0,     0,  2175,   615,  1269,  2175,  2175,  2175,  2175,     0,
    2175,  2175,  2175,  2175,     0,  2175,  2175,     0,  2175,     0,
       0,     0,  2175,     0,  1234,     0,  2175,  2175,  2175,  2175,
    1251,  2175,  2175,     0,     0,     0,     0,  2175,  2175,     0,
       0,  2175,  2175,     0,  1179,  1233,   725,   768,   752,   753,
    1128,  1178,  1180,  1192,   611,     0,  1210,  1236,  1237,  1235,
       0,  3311,     0,     0,   205,  3354,     0,  3356,     0,  1325,
       0,  1324,   245,   409,   465,  2050,  2050,   102,  2050,    94,
      95,    90,   122,   123,    92,    93,    98,    97,    99,   100,
     103,   104,   101,    96,    91,   126,   128,   127,   105,   124,
     125,    89,   592,   591,   590,   589,   562,     0,     0,  2328,
     540,     0,  1961,  2559,     0,     0,  2035,  1476,  2223,  2225,
    2113,  2111,   511,   305,     0,     0,   429,  3283,     0,  3196,
    3201,     0,  3259,  3258,  3286,  3286,  3286,  3286,   451,     0,
    2144,  1388,  1393,  1397,     0,  1389,  2454,   947,   969,   967,
     984,   933,   953,   949,   953,   943,   984,   890,   890,   984,
     946,   890,   953,   948,     0,   945,   984,   944,   890,     0,
     937,   969,   884,   885,   890,   967,   903,     0,   953,   926,
     925,   984,   929,   930,   928,   932,     0,   934,   953,   939,
     927,   931,     0,     0,   967,   967,   967,     0,     0,   967,
     386,   872,   875,   877,   876,   878,   879,   953,   969,   969,
       0,     0,   967,   971,     0,     0,   298,     0,   276,   431,
     435,   409,   473,     0,  1851,     0,   968,  1820,  1821,     0,
    1835,   955,   954,     0,   972,  1837,     0,  1834,  1823,  1840,
    1827,  1832,  1839,  1825,  1609,  1640,  1613,  1612,     0,     0,
       0,  1674,     0,  1805,  1788,  1786,     0,     0,  1647,     0,
    1649,     0,     0,  1742,  2544,  1704,  1784,  1677,  1708,  1652,
       0,     0,     0,  1589,  1587,  1588,     0,  1666,  1688,     0,
    1576,  1689,     0,  1720,  1672,     0,  1699,     0,  1675,  1702,
    1726,  1605,  2068,  2067,  2065,  1620,  2050,     0,  1678,  1638,
       0,     0,  1712,  2548,  2549,     0,  1714,     0,     0,  1049,
    1035,  1036,  1037,     0,  1039,  1041,  1043,     0,  2050,  1728,
    1535,  1534,     0,  1506,     0,  1515,  1512,     0,  1520,  1985,
    1984,     0,     0,  1733,  1735,  1734,  1737,  1736,  1731,  1842,
    1478,  1747,     0,   635,   636,   638,   640,   706,     0,   630,
       0,   619,     0,   634,   622,  1369,   493,     0,     0,  3183,
    3182,  3181,  3180,     0,  1474,  1482,  1481,  2538,  2542,  3103,
    3102,  3135,  3134,  3128,  3127,  3129,     0,     0,  3108,     0,
       0,  2072,  2073,  2071,  2069,  2070,  2277,  2018,  2273,     0,
    1961,     0,  1918,  1477,  2182,     0,   491,  2532,     0,  2162,
       0,     0,     0,  2161,  2171,     0,     0,  1923,     0,  1924,
    1921,  1922,  2050,     0,     0,   374,   369,   377,   371,   373,
     372,   378,   379,   380,   381,   375,   370,   376,   368,   367,
       0,  3163,  1317,     0,     0,  3199,   163,     0,  1115,  1117,
    1116,  1100,  1101,     0,   141,   144,   823,     0,     0,   134,
     603,   611,   724,   727,   600,   136,   273,   227,     0,     0,
       0,   253,   788,   789,   787,   786,     0,   253,  3352,  1457,
    1456,  1867,     0,  1871,  1876,  1872,     0,  1863,     0,  1884,
    1927,  1919,     0,     0,  2465,  2015,     0,     0,  2015,  1477,
    2088,  1476,   176,   181,   180,   173,   186,   179,   192,   534,
    3272,  3270,  3269,     0,  3277,     0,  3252,  3293,  3291,  3292,
    3295,     0,     0,  3294,  3296,  1152,  1153,  1159,  1154,  1122,
     719,  1252,   717,     0,  1214,  1218,  1215,     0,   824,   719,
    1076,  1076,   717,  2136,  1362,  2136,     0,     0,  2136,     0,
    2138,  2136,     0,     0,  2136,  2136,  2175,     0,  1362,     0,
    2050,   613,  1272,  1270,  1271,     0,  2050,  2050,  2050,   750,
     771,     0,  2050,  2050,  2050,  1362,     0,     0,  2175,  2050,
    1227,  1174,  1228,     0,     0,  1175,     0,  2050,  2050,  2050,
    2136,  2050,     0,  1362,  1194,  1362,  1362,     0,  2050,   758,
     759,   757,  2050,  2050,     0,   726,  1017,  1176,   612,  1177,
     823,     0,  1266,   799,   826,  2551,     0,  3312,     0,     0,
       0,  1164,     0,   208,   206,   216,  3353,     0,  1139,     0,
    3356,  1327,  1328,     0,     0,     0,   115,   117,     0,   119,
     121,     0,   111,   113,   523,   588,   541,  2234,  2227,     0,
    2036,     0,  2229,     0,   488,   433,   486,     0,  3286,  3300,
    3300,  3300,  3300,   409,   447,   450,  2198,  1390,  1398,  2456,
    2455,     0,   970,   896,   984,   982,   984,   910,   985,   957,
     950,   957,   913,  1027,     0,  1020,  1025,  1021,   919,  1023,
       0,  1031,  1030,   891,   933,   984,   921,     0,   890,   912,
     918,   957,     0,   907,   916,   984,   883,   920,   906,     0,
     957,   922,   935,   938,   940,   942,   957,   984,     0,     0,
     386,   890,   905,   904,     0,   890,   957,     0,   291,   951,
     936,  1023,  1031,   890,   984,   957,   957,   300,  2050,   302,
     385,   409,   477,     0,     0,     0,     0,  1023,     0,     0,
    1841,  1023,  1023,  1758,     0,     0,     0,     0,  1811,     0,
       0,     0,     0,     0,  1608,     0,  1738,     0,  1664,  1662,
       0,   953,  1566,  1568,  1564,  1567,     0,   967,  1570,     0,
     934,   967,  1573,  1575,  1560,  1561,  1562,  1563,     0,     0,
       0,  2086,  2085,  2084,     0,     0,     0,     0,  2550,  1033,
    1717,     0,  1046,  1040,  1038,  1045,     0,  1802,  1511,     0,
       0,  1987,     0,  1791,     0,  1748,   639,     0,     0,     0,
     659,     0,   657,   633,     0,  3185,  3184,  1480,  1479,     0,
       0,     0,  3086,  3088,  2279,  2206,  2009,  2208,  2209,  2201,
    2191,  2189,     0,  2165,  2536,  2547,   609,     0,     0,  1195,
       0,  1196,  1207,  1209,  1396,     0,  2406,     0,  2404,  2374,
    2407,     0,  1296,  1298,     0,   138,     0,     0,  1122,  2666,
       0,   792,   794,   795,   796,   797,     0,   604,  2454,   610,
    1017,   728,   723,   269,  3377,   514,   515,     0,     0,  3356,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1908,     0,  1907,     0,  1913,  1917,     0,     0,     0,     0,
    2458,  2460,     0,  2105,  1969,  1978,  1976,  2013,  2093,  2091,
       0,  3279,  3275,  2053,  2052,     0,  1156,     0,  1155,  1160,
       0,   825,  1123,  1362,     0,     0,     0,  1238,     0,     0,
       0,  1076,   815,   719,  1122,  1077,   719,   719,  1212,     0,
       0,     0,  1186,     0,     0,  2136,     0,  1240,     0,  1239,
       0,     0,     0,     0,  1249,  1250,     0,  2005,  2007,  2015,
    2083,  2082,   747,     0,  1231,   740,   739,   742,   741,   744,
     743,     0,  1247,  1248,   736,   733,   745,     0,   735,   760,
       0,   748,   730,     0,   784,   785,   783,   754,   761,   731,
     732,     0,   738,   737,   734,     0,  1202,     0,   776,   781,
     779,   778,   777,   782,   780,   749,   767,   746,   762,  1191,
    1251,  1251,  1211,     0,   790,  2554,     0,  1268,  1213,     0,
     800,     0,     0,   766,   765,   763,   764,   215,   204,     0,
       0,  1166,  1168,     0,     0,  1169,  3355,  3358,  1137,  1333,
       0,   409,   107,  2050,   108,  2050,   106,  2050,     0,  2037,
     306,     0,  3303,  3300,     0,  3194,  3193,  3192,  3191,   409,
     452,     0,     0,   908,   986,     0,   909,   959,   960,   958,
     886,   882,  1028,  1022,   893,  1024,  1019,  1032,  1029,  1026,
     982,   892,   914,   915,   888,     0,  1124,   900,     0,   889,
     941,   887,   901,     0,     0,   287,     0,   285,   294,   917,
     386,   282,   898,   902,   387,     0,   911,   894,   895,   897,
    1031,   880,   881,  2050,   296,   315,   314,     0,     0,     0,
     965,   963,   966,   964,  1822,     0,  1824,  1826,  1670,  1671,
    1808,  2015,  1806,  1813,     0,     0,  1812,  1698,     0,  1648,
       0,  1739,     0,  1709,  1667,  1569,  1565,  1572,   935,  1571,
    1023,  1692,  1673,  1700,  1621,  2050,  1679,  1682,  1683,     0,
    1716,  2050,  1513,     0,  1990,  1989,     0,     0,  2015,  1732,
     637,   707,   632,     0,     0,   656,     0,   620,  2539,  3110,
    3109,  2034,  2528,     0,  2170,  2172,  1392,     0,  1925,  2402,
    2050,     0,  2372,     0,     0,     0,     0,     0,     0,   798,
     791,   823,     0,   602,   709,   729,   611,   272,   270,   271,
       0,   265,   267,     0,   236,   228,     0,   409,   518,   516,
     517,     0,     0,   149,     0,   254,     0,   256,   257,   162,
       0,  3356,  1868,     0,  1873,     0,  1865,  1903,  1903,  1914,
       0,     0,     0,     0,  2459,     0,     0,  2466,  2468,     0,
    1154,     0,     0,     0,  1197,     0,     0,  1216,     0,   719,
    1072,  1073,  1122,  1097,  2551,  1122,  1122,     0,  1185,     0,
    1348,  1013,  1223,     0,  1181,     0,  1225,  1226,  1263,   756,
    1183,     0,  2008,   614,  2394,  1190,   755,     0,  1266,  1182,
    1204,  1188,  1217,  1267,  1054,   969,   884,   885,   890,   967,
     903,  2723,   953,   926,   925,   984,   929,   930,   928,   932,
    2733,   934,   953,   939,   927,   931,  2741,   830,   967,   967,
     967,  2748,   967,     0,   818,   828,   873,  2553,   202,   207,
     217,   218,  1141,     0,  3357,     0,  1334,  1330,  1331,  1326,
     409,   116,   120,   112,     0,  3195,     0,  3307,  3301,  3305,
       0,     0,   983,   961,   962,   987,  1023,     0,  1023,   386,
     286,   289,     0,   292,     0,     0,   899,   324,   323,   321,
     409,   311,   319,   313,     0,   320,     0,   304,   501,     0,
       0,  1810,  1770,  1814,  1815,     0,  1741,  1743,  1574,     0,
    1034,     0,  1986,  1980,     0,     0,     0,     0,     0,     0,
    1999,  1991,     0,  1795,  2050,   705,     0,     0,   645,   662,
     661,   658,  2205,  2537,  1208,  2405,     0,  3173,     0,     0,
       0,  2015,  1120,     0,     0,   793,   605,   710,     0,  2454,
     274,   269,   268,   237,   187,  1476,   213,  3372,   227,     0,
       0,     0,   258,   227,   151,     0,     0,     0,  1911,  1909,
    2463,  2464,     0,  2461,     0,     0,  2467,     0,  1161,  1157,
    1162,     0,  1199,     0,   718,     0,  1122,  1097,  2551,     0,
     801,     0,   805,   807,     0,     0,  1266,  1187,  1232,  1224,
    1241,  1222,  1362,  2006,     0,     0,  1221,  1203,  1205,  1309,
       0,  1058,   832,     0,   827,   819,   840,     0,   209,  1170,
     409,     0,     0,     0,  1329,     0,  1336,     0,  3306,  3304,
    2199,  1882,   924,  1125,   923,   293,   288,   283,   952,  2050,
     301,   322,   303,   299,   473,   956,  2015,     0,     0,  1646,
    1622,  1718,     0,  1996,     0,     0,  1994,  1993,     0,  1988,
    1995,   708,     0,     0,   653,   669,   665,     0,   667,   668,
     690,  2408,     0,     0,  3143,     0,  1119,     0,  3143,     0,
     769,   601,   266,   188,  3378,  3367,   205,   214,     0,  3374,
     161,   255,     0,   263,     0,   159,  1870,  1875,     0,  1904,
       0,     0,     0,  2462,  2470,  2469,  3280,     0,     0,     0,
    1198,     0,   820,   813,   809,     0,  1098,     0,   803,     0,
       0,  1230,     0,  1220,  1184,   751,   615,     0,  1189,     0,
    1057,     0,  1062,  1052,   858,   998,     0,   861,     0,   831,
     833,   991,   992,   835,     0,     0,     0,     0,   874,     0,
       0,   975,     0,   978,     0,     0,   829,     0,   841,   974,
     981,  2552,     0,   211,   187,  3359,     0,     0,  1335,  1340,
       0,  1337,  1339,  1449,     0,  2444,     0,   312,   502,  1809,
    1817,  1816,  1997,     0,  1998,  2001,     0,     0,  2002,     0,
     649,   651,   641,     0,   646,     0,   663,     0,  2175,  2175,
       0,  2175,  2175,  2175,  2175,   683,   691,   693,     0,     0,
    3143,  1087,  2015,     0,  1089,     0,   607,   770,     0,   216,
    3373,     0,     0,     0,  1906,  1905,  1920,     0,  1219,  1201,
       0,     0,     0,     0,   811,     0,     0,     0,     0,     0,
       0,     0,   870,   871,  1229,   867,   868,   869,     0,  1193,
       0,  1055,     0,  1059,  1060,  1061,     0,  1053,   859,   860,
     999,   834,   997,   990,   989,     0,   980,   976,     0,   849,
       0,     0,   982,   973,   842,   210,     0,   203,   219,  3360,
    3361,  1332,     0,  2200,  2211,     0,  1006,   284,  1992,  2000,
    2004,  2003,   647,     0,   654,   676,   666,   672,     0,  2175,
       0,     0,  2175,     0,     0,     0,     0,     0,   660,   692,
    2175,   190,  1085,     0,     0,  2175,  1242,  1088,  1113,  1095,
       0,  1118,  1121,  1242,  1090,  1112,  1093,     0,     0,     0,
     187,   261,     0,     0,     0,  1200,   816,     0,     0,     0,
       0,     0,     0,     0,  2502,  2501,     0,     0,  1056,     0,
       0,   996,   995,   993,   994,  1483,   979,     0,   844,   988,
     843,   212,  1338,     0,     0,  2445,   653,   650,   676,     0,
     674,     0,   670,   664,   671,     0,   702,   696,     0,   698,
     699,   697,   694,   687,     0,   685,     0,     0,     0,  1242,
    1086,  1111,  1110,  1091,     0,  1105,  2050,   142,  1244,  1243,
    1096,     0,   145,  1094,     0,  1476,   218,  3375,     0,   259,
    1912,  1910,     0,     0,     0,  1085,     0,  1087,  1089,   866,
       0,  1068,  1067,     0,     0,  1064,  1063,     0,   977,   836,
     836,   850,  2210,  2212,  2471,   648,   673,     0,   681,   677,
     679,   682,   701,   700,     0,   684,     0,   695,  1102,  1103,
     139,  1092,  1114,  1104,  1246,  1245,  1109,  1108,  1106,  1107,
     817,  3368,   201,   262,     0,     0,  1085,     0,   802,  1085,
     806,   808,  1206,  1071,  1069,  1070,     0,     0,  1484,     0,
     847,   837,   839,   846,   852,   853,   851,   854,     0,  2457,
     675,     0,     0,   690,   689,   686,     0,   260,   814,   810,
    1085,   804,     0,     0,  1485,   838,   845,   855,   857,     0,
    2465,   680,   678,   688,     0,   812,  1066,  1065,   856,     0,
    2473,  3369,  2472,     0,  2477,  3364,     0,     0,  2484,  3362,
    3363,     0,  3370,  2475,  2476,  2474,  2479,     0,     0,  2481,
    2482,     0,  2446,  3365,   409,  2483,  2478,     0,  2485,  2487,
       0,   187,  2480,     0,  1476,  3371,  2486,     0,  1477,  2488
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -4883, -4883, -4883, -4883,  2353,  4548, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883,  2882, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883,  2073, -4883,   545, -4883,   551, -4883,   553, -3096,  -626,
    4248, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883,  2228, -2211, -4237, -4883, -4883,    49,  1637, -4883, -4883,
     381, -4883,    39, -4883, -4883, -4883, -4326,   -95,  -280, -4883,
      30,  4727,    73,  4079,  1151, -4511, -4883, -4883, -4883, -4883,
   -4883, -4883, -1974, -4883, -4883,  1143, -4883,   495, -4883, -4709,
   -4883, -4883,   180, -4883, -4883, -4883, -1593,  -637, -1428, -4883,
     520, -4883,   253, -4883,   176, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883,   240, -4883, -4883, -4883,    99,   892, -4452,
   -4883, -4883, -4883, -4883,   509, -4883,  1920, -4883, -1781,  3754,
   -4883, -4883, -4883, -4883, -4883,  2890, -2467, -4883, -4883, -4883,
    1774, -4883, -2809, -4883, -4274,   -77,  -870,    23, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -1117, -4883, -4883, -4883, -4883,
   -4883, -4883, -2702,  2006, -4883,  1501, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883,   974, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883,  2746, -4883, -4883,  4687,
   -4883, -4883, -4883, -4883,  1410, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883,  3321, -4883, -4883,  3326,  3325, -4883,  3327,
   -4883, -2822, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883,  4070, -4883, -4883, -4883, -3017, -4883,
   -4883, -3080,  3463, -4883, -2428, -4883, -4883, -2547, -4883, -4883,
   -2451,  1027, -4883, -4883,  1987,  1717, -4883, -1809, -2617, -2594,
   -4883, -4883, -4883, -2677, -2676,  -776,  3406, -1215, -2062, -4883,
   -4883, -4883,   211,   215,   436,  1590,  2160, -4883, -3670, -4883,
   -4883,   682, -4883, -4883, -4883, -4883, -4883,  1298,   477,  1297,
   -4883,   845,  3096, -2639, -4883, -4883, -4883, -4883, -4883, -4883,
    -118,   251,  -189, -4883, -4141,   484, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -3601, -4883, -4883, -4883,  -310, -4883,
   -4883,  -264, -4883, -4883,  -308, -4883,   -15, -4883, -4883, -4883,
   -4883, -4883,  2924, -1927,  1148,  -678, -4883, -3616,  1639, -3990,
   -3231, -4883, -4883,   127, -1314, -1307,  -180, -4883, -4883, -4883,
   -4883, -4883, -4883,  1088,   488,  1635, -3725, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -3724, -3716,   765, -4883, -3864, -4883,
   -4883, -4883, -3654, -4883, -4883, -4883, -4883, -4883, -4883,  -218,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -3340, -4883, -4883,
     -28,   -54, -4883,    64, -3886, -4883, -4565, -4883, -1096, -4883,
   -4883, -4883, -4883, -4883, -3580,  1417,  1540, -4883, -4883, -4883,
   -4883, -3401, -3228, -1368, -2306, -3027, -1498,  1487,   -53, -4049,
   -4802,   262, -3800, -4883, -4883, -3246, -4882, -4883,  -666, -2821,
   -3186,   -64, -4883, -4883, -1704,   435, -3198, -4883,  1032,  1026,
   -3176, -2842, -4161,  1993, -4883, -4883,  1395, -4883, -1500,  1393,
   -4883, -4883, -4883,  1404, -4883,  -229, -4883, -4883, -4883, -4883,
   -3748, -4883, -2517, -4011, -4883, -4883,  5497,  5498, -3363,  -177,
    -176, -4883, -4883, -4883,   260, -4883, -4883, -2780,  -149,   -81,
     -71, -3666, -2572,   177, -4318,  1031, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,   481,   485,
    1862, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,  1682,
   -2869, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4127, -4182,
   -4883, -4883,  1141, -3872, -3288, -3289, -3644,  4372, -4883, -4883,
   -4883, -4883,  4195, -3353, -3661, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883,  3680,  1379, -4883, -4883,  2389, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883,   258,  2395, -4883, -4883,
   -4883, -4883, -4883,  2876, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883,   -14, -4883, -4883, -4883, -4883, -4883,   486,  3542,
   -4883, -4883, -4883, -4883,   -11, -4883, -4883, -4883, -4883,  3179,
   -4883, -4883, -4883, -4883,  3055, -4883, -4883, -4883, -4883, -4883,
   -4883,  2178, -4883,  2775, -4883, -2480, -4883, -4883,  1615,  -155,
   -4883, -4883,   -61, -4883, -4883, -4883, -4883, -4883,    46, -4883,
   -4883, -4883,  5496, -1525,     9,   -65, -4883, -4883,     4, -4883,
   -4883,  4257,  -429,  2591,  -727,  4877, -4883, -4883, -4883, -4883,
   -2531,  2471, -4883,  4302, -4883, -4883,  4477,  1585,  4269,  2351,
    1655,  2544, -1680,  -161, -3047,  1433, -4883,  1984,   667, 10014,
   -4883, -1452, -1519, -4883, -4883,   -43, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883,  2668,  2670, -4883, -4883,  3978,
   -4883,  2586, -3141, -4883, -4883,  -800, -4883, -2453, -4883, -4883,
   -4883,  2592, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883,  2028, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883,  3930, -1642, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883,  1526, -4883, -2810,
   -4883, -4883, -4883, -4883, -4883, -2896,  -673, -4883,  4080, -4883,
    4109, -1220, -1769,  3674, -4883,  4329, -4883, -4883, -4883, -4883,
   -4883, -4883,  3687, -4883, -2053, -4883, -2527,  4333,  4335,  4337,
   -4883,  4339, -4883, -4883, -1738,   555, -4883,   908, -4883, -4883,
   -4883, -4883, -4883,  1413, -4883,   100,   957,   103, -4144, -1508,
    1556, -4883, -4883, -1832,  3704,  4138, -1300, -4883,  3000, -4883,
    3691,  2075, -4883,  2407, -4883,  1336,  1331, -4883, -4883,  2087,
   -4883, -4883, -4883, -4883,   657,   169, -4883, -4883, -4883,   546,
    1002, -2043, -4883,   672, -3197,  4343,  -318, -1161, -4883, -1318,
    2414,   652,  4945,  -524, -4883, -4883,  4321, -4883, -2828, -4883,
     140, -1522,  -624, -3055, -4368, -3226, -4883, -2362, -4883, -4883,
   -4883, -4883, -4883,  1350, -4883, -4883, -4883,  3035, -4883,  5606,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
    -698, -1190, -4883, -4883,  2908, -1382,  -132,  5626,   -59, -4883,
   -4883,   -57, -4883, -4883, -4883, -4883,  4218,  3859, -4883,  2872,
   -4883, -4883, -4883, -4883,  2545, -4883, -4883,  1014, -1010,  1314,
    2409, -4883, -4883, -4883, -4883, -4883, -4883, -4883,  1007, -4883,
    1464, -1862, -4883, -4883, -4883, -4883,   -52, -4883, -4883, -4883,
    1468, -4883,    19,  5060,   -50, -4883, -4883, -4883,  4901, -4883,
   -4883, -4883, -4883, -4883, -4883,  3646, -1418,  4909, -4883, -4883,
   -4883, -4883, -4883, -4883,  3198, -4883, -4883, -4883, -4883, -4883,
   -4883,  3943,  5074,  -664, -1669, -4883,  -976,  3206,  2596,  -917,
   -4883, -4883, -4883,  4370,  5082, -4883, -4883,  5631, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883,  3161,   605, -4883,
   -4883, -4883, -4883, -4883,   700, -4883, -4883, -4883, -4883,  3844,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883,  4263, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883,  1746,   -74, -4883,   998,   -91, -4883,
     653, -4883, -4883, -4883, -4883, -4883,  -126, -4883, -4883,  -131,
   -4883, -1357,  4767, -1336, -4883, -1685, -3326, -4883,     7, -4883,
   -4883, -4883,  3214, -4883, -4883, -4883, -4883,  1505, -4883, -4883,
   -2641,  -941, -1640, -3790,   163, -4883, -4883, -4883,  -852,  4362,
      -2,  1315, -1259, -4883, -4883,  2740,    -3,  -885,   -55,    32,
    -737,  -904, -4883,  7759, -4883, -4883, -4883, -4883,  -659,  -633,
    -629,  -604,  -622,  1518,  -486,  1217, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883,  2642, -4883, -4883,
   -4883,  1527, -4883,  5108, -4883,  3414, -1726,  5110,  3288,  2669,
    2672, -4883, -4883, -4883, -4883, -1683, -4883, -4883, -1725,    96,
   -4883,  3626, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
   -4883,  3835,  -563,  -555,  4040,  5126,  4656, -4883,  4301, -4883,
   -4883, -4883, -4883, -4883,  1945, -4883, -1943,  2710, -1409, -2144,
   -4883, -4883,  3066,  1424, -4883, -4883,  1371, -4883,  2363, -2534,
   -3012, -4883,  2571, -2957, -4883, -4883,   586, -4883, -4883, -4883,
    1877,   175,  5100,  4542, -4883, -4883, -4883, -4883,  5695, -4883,
   -4883,   144,  5722,  5723,  5724,  -285, -4883, -3222, -4883, -4091,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883,
     716, -4883,   504, -4883, -4883, -4883, -4883, -4883, -4883,  2680,
   -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883, -4883
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    69,   735,  1947,    70,    71,    72,    73,    74,  1913,
      75,  1257,  2581,  1259,  1879,  2584,    76,   704,    77,  2071,
    2781,  2782,  4501,  4502,  4495,  4496,  4498,  4499,  2783,   819,
     820,    78,  2637,  3749,  3242,  2634,  5065,  1953,  4726,  1954,
    4727,  2630,  3755,  4338,  1958,  2639,  1959,  4337,  4331,   743,
    3750,  3321,  3322,  5434,  1316,  3237,  3330,  3331,  2642,  4329,
    4481,  5368,  4485,  5513,  5627,  5436,  3358,  4905,  5369,  5370,
     638,  1327,   778,  2033,  5439,  2707,  5085,  2708,    79,   813,
    2063,  3365,  1429,  2064,  2065,  4750,  4751,  5095,  5096,  5097,
    5080,  5081,  5082,  5083,  4327,  4743,  2883,   907,  2169,  2884,
    4970,  4964,  4965,  4966,  4580,  3467,  3468,  3469,  4599,  3470,
    4983,  4988,  3993,  3994,  4513,  3471,  5240,  5241,  5242,   658,
    1133,  5243,    80,    81,   659,   667,   660,  1130,  2438,  1131,
      82,    83,   702,  1903,  1904,  1905,  1906,  3208,  2600,  3202,
    3203,  4298,  4971,  3473,  4588,   908,   909,   910,    85,   639,
     911,   912,   913,   914,  1529,  2162,  2163,   915,   916,   917,
     918,   919,  2886,  2887,  3487,  3435,  3995,  2888,  2173,   920,
     921,   922,   923,  1530,   884,   885,  2847,  4008,  4525,    86,
     616,   815,   816,  2070,  2755,   817,  2756,  3368,  4494,   818,
    1430,  2752,  1432,   924,  3491,   925,   926,  2182,   927,  1520,
      87,  1864,  2832,   850,  1470,  2118,   928,  1240,  2559,  1139,
    2446,  3492,   929,  2179,  2181,  2178,  3490,  5394,  2180,    88,
     649,   678,   637,  1469,   665,  4747,  5091,   790,   791,   827,
    2804,   792,  1440,  1401,  2039,  2734,  2735,  3336,  3337,  3404,
    3405,  3406,  2726,  2727,  2728,  2793,  2794,  2795,  2715,  2716,
    2717,  2043,  2712,  2713,   793,  1402,  1413,  2729,  2730,  2731,
    3410,  2797,  2798,  2799,  2800,  2732,  2108,  2733,  3809,  4319,
    4742,  4320,  5073,  3174,  4738,  4739,  4468,  4833,  3187,    89,
     652,  1116,  1732,  2430,  3639,  3072,  3074,  2431,  3638,  4212,
    4213,  4214,  3070,  3071,  5278,  3076,  3636,  5414,  5716,  5539,
    5540,  3628,  5544,  4221,  4681,  4682,  5044,  5279,  5420,  5648,
    5545,  5723,  5646,  5719,  5647,  5721,  5842,  5789,  5790,  5658,
    5734,  5735,  5794,  5843,  5555,  5556,  5557,  3632,  3633,  5275,
    5298,  3232,  2027,  2028,  4796,  1268,    90,  4321,  3915,  4322,
    4323,  4841,  5566,  3917,  3918,  3919,  3428,  1807,  4875,  4857,
    4336,  4883,  4324,  4730,  4731,  4732,  4733,  5467,  5586,  5469,
    5470,  5583,  5689,  5582,  4734,  4735,  5069,  5364,  4802,  4413,
    4397,  4398,  4473,  4891,  5194,  5366,  5362,  5489,  5490,  5830,
    5831,  5506,  5781,  5507,  5837,  5856,  5857,  5491,    91,   651,
    1680,  5592,  5593,  5594,  4070,  5195,  4071,  4072,  4567,  4073,
    4074,  4075,  4076,  4077,  4078,  4079,  4080,  4081,  4082,  4083,
    4976,  4570,  4101,  4940,  4096,  4568,  4566,  4105,  5508,  5509,
    4934,  4571,  4538,  4951,  5624,  5492,  5510,  5494,  4550,  1763,
    1764,  3273,  1777,  1778,  3107,  2468,  3108,  2031,  4551,  4552,
    4944,  4553,  4949,  4178,  5029,  4184,  4185,  4186,  3586,  3587,
    3588,  3589,  3590,  3028,  5495,  4890,  5361,  5479,  5482,  5607,
    5775,  4803,  4399,  4806,  1225,   744,  4400,  4401,  5739,  5666,
    5673,  5740,  5674,  5667,  5340,  3746,  5741,  5742,  5743,  5676,
    5669,  4311,  5290,  5291,  4791,  4955,    92,   162,  3356,  1388,
    1390,  1400,  3362,  2743,  2742,  1406,  1405,  2721,  4387,  4789,
    3860,  3359,  3934,  5202,   776,  3920,  5352,  5140,  5359,  3921,
    4710,  3922,  5332,  5460,  3923,  5160,  5357,  5477,  4711,  4712,
    3924,  3925,  3926,  5747,  5748,  5749,  4402,  1499,   796,   797,
    1418,  1419,  1420,  2827,  4888,  4425,    93,  2622,  2617,    94,
    1285,  1286,  1287,  1925,  1926,  2620,  2621,  3228,  3738,    95,
    1252,  2577,  1915,  2609,    96,  1271,  3219,  3220,  3221,  3733,
      97,  1426,  2059,  2060,  2747,  3941,  4493,  4909,  5209,  5376,
    5205,  5520,  5521,    98,   823,  1436,    99,   618,  2080,  2081,
    2082,  2785,   100,  1538,   170,   101,  1137,  1738,  1741,  1742,
     102,  1251,  1866,  1867,  1868,  1869,  3183,   103,  2150,  2851,
    2852,  2853,  2854,  2572,  3710,  2573,  2574,  3192,  4015,   104,
     758,  1387,   105,   757,  1386,   106,   107,   677,   730,   669,
    1750,   109,   110,  3175,  2218,   112,   764,   762,  1078,   114,
    1380,  1376,   115,  2219,  1079,   754,   755,  1334,  1158,  3258,
    3259,  2093,  2094,  2674,  2661,  1159,  1160,  1360,  2016,  2686,
    2457,  2458,  1848,  2459,  3653,  4234,  5778,  1559,  1480,  1255,
    1081,  1082,  1083,  1692,  1693,  1708,  1084,  1702,  2381,  4150,
    4644,  4645,  4646,  4647,  5020,  2304,  2305,  2425,  1085,  2290,
    2291,  2292,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  2283,
    2284,  2285,  1093,  1094,  1095,  1096,  2420,  4132,  4133,  4626,
    3065,  3066,  3067,  1097,  2910,  4118,  2921,  1098,  1099,  1100,
    1101,  1102,  3613,  1103,  4202,  3787,  1104,  1686,  2367,  2245,
    4618,  4123,  5000,  5004,  5005,  5006,  5253,  2186,  2898,  3516,
    4607,  4611,  4612,  3517,  3518,  3614,  3615,  1580,  1581,  1548,
    1549,  1335,  1336,  1337,  1338,  1339,  3771,  3772,  4755,  4342,
    4757,  4346,  1981,  1982,  1985,  1986,  1340,  1341,  1342,  1343,
    1969,  1344,  1345,  1346,  2666,  5318,  4763,  4764,  5452,  5451,
    4765,  4351,  4352,  3775,  3776,  4278,  4279,  4280,  3269,  2241,
    2242,  2318,  2155,  2156,  2157,  2187,  1354,  1996,  2682,  3279,
    1998,  3277,  3782,  3281,  3788,  3789,  2412,  3055,  3609,  3057,
    4671,  5036,  5037,  5270,  5403,  5404,  5409,  3929,  4827,  4828,
    2812,  1361,  2694,  3291,  3785,  1809,  1810,  1811,  2006,  3284,
    3285,  3422,  1363,  1364,  1374,  1379,  1367,  1365,  2874,  4383,
    4831,  3591,  3573,  4716,  3810,  2210,  2211,  4832,  4654,  1368,
    2695,  3796,  3797,  3798,  1350,  1351,  1991,  1992,  1993,  1369,
    1352,  2675,  3778,   116,   697,   117,  2115,   837,  1466,  2114,
    3199,  1438,  2565,  2088,  2089,  1455,   785,   636,   118,   640,
    2848,   119,   681,  2564,   889,  1244,  1860,  1861,  1862,  3176,
    3707,  3177,  3700,  3701,  3178,  1238,  4273,  4274,  2822,  3823,
    3824,  3818,  2558,  3165,  1239,  1852,  3693,  2555,  3694,  2556,
    2586,  3695,  4010,  4931,  5524,  2552,   120,   675,  4260,  3687,
    3688,  5633,  5634,  1236,   121,   622,  2087,   833,  1444,  1447,
    1448,  2097,  2808,  3988,  1449,  1450,  2810,   834,   835,   122,
     718,  1291,  1831,  1832,  1833,  2539,   123,   672,  1226,  3682,
    4257,  2525,   655,  1464,  1814,  1229,  1815,  2521,  3149,  1798,
     124,  1384,  1383,   811,   125,   126,   770,   171,  2020,   127,
    1260,  1896,  2598,  3716,  3717,  4283,  1897,  1898,  3200,   128,
     685,  1246,  3196,  4717,  4718,  5062,   129,   709,  1275,  1276,
    1919,  1917,  3224,  2612,   130,  2432,   131,   641,   892,  1502,
    1503,  2148,   132,   712,  1280,   133,   134,   894,  4016,  5636,
    5784,   645,  2152,  1507,  5074,  4354,  4770,  4771,  4773,  5117,
    5118,  5839,  5874,  5885,  5878,  5888,  5889,  5892,  5898,  5899,
    1105,  1298,  1299,  1106,  5597,  1107,  1108,  1109,  2220,  1242,
     680,  1855,  1856,  3170,  2562,  3168,  1857,  3702,  3703,  3097,
    3278,  1110,  3689,  4792,  1439,  2090,  1263,   604,  1111,   605,
     787,  1300,  1988,  2858,  1177,  3124,  1113,   931,  1396,  1739,
    2048,  2049,  2859,   607,   932,  3125,  3475,  1179,   608,   609,
     610,   611,   612,   613,   614,   615,   136,   671,  1162,  2464,
    1754,  1187,  1783,  1772,  1782,  2495,  3136,  2498,  3137,  3138,
    4249,  3675,  4250,  3676,  1232,  2490,  1755,  3677,  2483,  2484,
    2485,  2486,  3666,  1769,  2474,  2480,   137,   895,  2161,   648,
    1509,  1510,  2871,   138,   674,   139,   703,  1265,  2605,  3212,
    3213,  3729,  4300,  3730,   140,  1144,  1145,   141,   878,  3235,
    2838,  2104,  1399,  2105,  2132,   881,  1472,   882,   883,  1486,
    1483,  1489,  1485,  3850,  3351,  3352,  2843,  2112,  2050,  2451,
    3344,  4373,  2051,  3844,  3845,  4374,  2122,  2834,  2835,  2740,
    5217,  3857,  3355,  4925,  3999,  5218,  5219,   142,   689,   143,
    5086,   696,  1254,  1876,   144,   145,   146,   147,   763,  1372,
    1161,   163,   164,   165,   166,   800,   801,  3361,  3936,  4488,
    4489,  5204,  5881,  5882,  2641,  3753,  5568,  5846,  5875,  5894,
    5308,  5438,  5440,  5571,  3244,  3752,  5087,   148,  1305,  1301,
     729,  1945,  1939,  1941,  2628,  3231,   149,   150,   151
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     606,   688,   799,   731,   113,  1175,  1224,   135,  1228,   111,
     650,  1512,  1180,  1517,  1518,  1519,   805,  2587,  2445,  2407,
    1523,  2008,   661,    84,  1256,  1333,   661,  2021,  1138,   795,
    2353,   661,  2805,  2099,   676,  1582,  2209,  1526,  1181,  2007,
    2217,   700,  1182,   692,  1398,   933,   108,   708,   699,  1183,
    3654,  2440,  2813,  3292,   707,  1999,  2496,  3191,   711,  1312,
     668,   933,  1838,  1313,  1314,  3968,  2251,  3928,  3927,  1463,
    3494,  3495,   732,  3472,  2029,   879,  2604,  2269,  3991,  4312,
    3811,  2030,  2551,   880,  2127,  3519,  3777,  3520,  1282,  2749,
    1989,  1289,  3188,  3681,  2439,  3794,  3799,  2492,  3236,  3521,
    2696,  1934,  4100,  4349,   789,   879,  3811,  3811,  4894,  3800,
     806,  1964,   807,  1146,   808,  3691,  2512,  2513,  3339,   809,
    2599,   810,   773,   664,  1583,  3916,  1437,  3411,  3412,  3261,
    3434,  3737,  2516,  3201,  4325,  4474,  4394,  4395,  1542,   113,
    3938,  3340,  3265,   694,   775,  4396,  4985,  2095,  5225,   777,
     779,  2532,  3816,   779,  4491,  4901,   788,   794,  1765,  1768,
    1770,  1687,  1688,   935,  3618,  3621,  3622,  1780,  4422,  1623,
    2825,  5207,  3811,  3811,  1487,   113,  2545,  2546,   135,   935,
     111,   108,  3572,  2153,  3341,  1185,  2844,  3408,  2845,  2846,
    2392,  2393,  2394,  2395,  2396,  2397,  2398,  2400,  2402,  2403,
    2404,  2405,  2406,  4421,  4759,  1767,  3260,  3260,  2153,  2625,
    3409,  4180,  1687,  1688,  3025,  5722,  2440,   108,  4403,  2597,
    4405,  1687,  1688,  4415,  1685,  4830,  1381,  4549,  4549,   782,
    2718,  4549,  1740,  5084,   748,   710,  2061,   642,  4549,   713,
    1378,  2670,  2372,  2784,  4549,  1687,  1688,  3401,  2109,  1840,
    2380,  2382, -1956,  2385,  2386,  3172,  4450,  1687,  1688,  2439,
    2153,  4122,  4853, -1956,  4181,  3308,   804,   682,  1526,  2872,
    1676,  1678,  1679,   653,  2796,  3415,  4104,  1687,  1688,  2026,
    4835,  1943,  4180, -2356,  1722,  1805,   716,  3732,   772,  2872,
    1687,  1688,   933, -3246,   933,   933,   933,  -415, -1130,  3335,
    4837,   933,   690,   933,  1687,  1688,  4968,  1839,  -415, -1130,
     802,  4839,  1631,  1687,  1688,  4862, -3229, -3233, -2854,  3840,
    3680,   798,  2906,  3953,  2872,  3980,  5196,  2741,  1416, -2854,
   -2561,  4243,  2837,  4741,  1377,  4181,  1689,  2153,  1690,  1761,
   -2356,  4543,  3856,  3820,  2872,  1661,  1687,  1688, -2562, -1956,
    1761,    31,  3849,  3260, -3232,  2872,  1163,  1665,  4544,  2872,
    1687,  1688,  2872,  2955,  1761,  2826,  3068,  1687,  1688,  2872,
    1163,  2872,  1687,  1688,  5302,  3451,  2872,  5077,  1687,  1688,
    5779,  1687,  1688,  1505,  5078,  1687,  1688,  1689,  1802,  1690,
    4807,  1500,  -606,  1687,  1688,  3931,  1689,   759,  1690,  4908,
     683,  1709,   167,  -606,  3965,  2170,    38, -3166, -1956,  1907,
     935,  4622,   935,   935,   935,  1687,  1688,    40, -3166,   935,
    1689,   935,  1690, -3230,  1687,  1688,  4529,  4423,  1687,  1688,
    1733,  4978,  1689,  3630,  1690,   760,  2567,  1687,  1688,  1362,
   -1956,  4332,  1687,  1688,  1362,  5707,  1362,  4543,  4557,  5079,
    1687,  1688,  1689, -2356,  1690,  1691, -3231,  3342,  2895,  4574,
    5699,  4575,  1163,  1325,  4544,  1689,  4886,  1690, -3166,  1796,
    2868,  1687,  1688,  4651,  4097,  4098,  2710, -3236,  1283,  1689,
    5493,  1690,  2202,  4109,  2738,  4110,  5133,  4112,  1689,  3570,
    1690,   836,  2872,   838,   839,   840,   841,  1710,   843,   844,
    3161, -2356,   846,   847,   657,  2009,  1691,  4333, -2356,  3091,
    3092,  3093,  3094,  3179,  2203,  1691,   619,  1424,   643, -2356,
    3039,  1689, -2854,  1690,   752,  5034,  4474,  1812,  4380,  2869,
    2204,  4985,  2908,  4330,   933,  1689, -2356,  1690,   666,  1691,
    -704,  2632,  1689,   673,  1690,  1761,  5035,  1689,  3761,  1690,
    3680,  1691,   753,  1689,  1871,  1690,  1689,  1813,  1690,  3631,
    1689,  2111,  1690, -1956,  2929,  2653,  1284,  2654,  1689,  4642,
    1690,  1691,  3966,  5591,  2205,  5014,  4217,  4210,  1687,  1688,
    2626,  4590,  2711,   877,  1691,  4887,  2126,  1292,  1293,  4623,
    1689,   761,  1690,  1834,  1407,    31,  4334, -2694,  1691,  1689,
    5441,  1690,  2206,  1689,  1333,  1690,  3822,  1691,  5611, -1956,
    3040,  1506,  1689,   877,  1690,   821,  1501,  1689,   794,  1690,
    1408,  4539,  2215,  4541, -3166,  1689,  1797,  1690,  4530,   794,
   -2713,  4561,  3234,  3998,   851,   788,  1250,  1951,  1582,  1952,
    1691,  5780,  1955,  1956,  1957, -2714,  1689,  3873,  1690,  1266,
      38, -2715,   935,  4545,  1691,  1687,  1688,  4576,  5093,  1135,
    4652,  1691,  1409,  3932,   646,   788,  1691,  4545,  1178,  1687,
    1688,  4546,  1691,  4244,  3967,  1691,  4589,  1201,  5700,  1691,
    4474,  1247,  1687,  1688,  2103,  3916,  1734,  1691,   788,  5144,
      31,  1201,  3162,  1136,  1687,  1688,  5233,  3026, -3250,  2207,
    1264,   788,  4786,  4535,  1269,  1687,  1688,  3041,  3744,  1691,
    2426,  1583,   821,  2029,   824,   821,  1467,  1468,  1691,  3339,
    2030,  1761,  1691,  3821,  3760,   169,  2253,  1583,  3411,  3412,
    1320,  1691,   849,  1311,   829,  3766,  1691,  3102,  2072,  3770,
    1676,  1678,  3340,  2462,  1691,    38,   937,  4535,  1425,   773,
    5075,  2656,  3811,  1689,  2894,  1690,    40,   646,  4549,  4545,
    1803,  1410,  2671,  4787,  2491,  1691,  1382,  1375,  2113,  3069,
    1234,  5535,   830, -1956,   654,  1761,  2427,  4546,   788,  3101,
    1403,  4549,   646,  1201,  1944,  4549, -3167,  1417,  3408,  1462,
    5131,  1687,  1688,  4549,  2068,  2441,   684, -3167,  5498, -2234,
     788,  1411,  3260,  3680, -3348,  2739,  1687,  1688,  2907,  1427,
    1877,  3409,   829,  1397,  5337,   691,  1632,  5342,  5343,  5236,
    5709,   773,  4369,  1403,  2720,  1414, -3250,   933,  5718,   620,
    1689,  1451,  1690,  1453,  4182,   779,   779,   779,  1459,  1403,
    2183,   788,  3271,  2449,  1689,  4384,  1690, -3167,  1877,  1662,
     830,  3031,  3032,  3976,  1762,  4104,  3813,  1689,  1488,  1690,
     688,  1666,  2024,  2470,  1249,  1762,  1262,  2544,  2802,  1689,
     644,  1690,  1691,  1461,  3156,  5284,  1465,  2419,  2196,  1762,
    1689,  3663,  1690,  2515,  1583, -3246,  2519,    68,  2109,  2787,
    2510,  3343,   773,   714,  1516,  1329,  3440,  2527,   879,  4506,
    2530,  1521, -2561,  1524,  2533,  4182,  3838,  2718, -3229, -3233,
    4424,  1456,  1457,  1458,  2079,  1347,   113,  4492,  1531,   135,
   -2562,   111,  2079,  2873,  2409,  2154,  3338,  3035,  5084,  3263,
    3264,  2548,  2549,  2550,  5208,  3047,  3048,  4985,  3051,  3052,
     717,   715, -1956,  2873, -2734,   935, -3232,  2298, -1956,  1691,
    2154,  1377,  1687,  1688,  -114,  5385,  -114,  4183,   108,  5315,
    2441,  5316,  2313,  1691,  2079,  2321,  1689,  2323,  1690,  2202,
    4013,  2327,  2328,  2329,  3180,  3027,  1691,  2384,  2873,  2335,
    5437,  1689,  2922,  1690,  2923,  2796,  3572,  3572,  1691, -2356,
    3572,  3572,  4534,  -415, -1130,  3407,  3572,  3572,  2873,  1691,
    4224,  2203,  2154, -3167,  1687,  1688,  2920,   646,   731,  2873,
    5314,  2450,   759,  2873, -2854, -3230,  2873,  2204,  5463,  5137,
    2909,  5139, -1422,  2873,  5142,  2873,   621,  4382, -3250,  -264,
    2873,  5147,  5148,  5358,  -118,  2739,  -118,  4581,  4582,  4583,
    2956,  -110,  4586,  -110,  1963,  4547,  3423,  2878, -3231,  1583,
     760,  2924,  1662,  2925,  2885,  4595,  4095,   646,  1508,  4547,
    1762,  2205,  5536,  2870,  2428,  3012,  4335,  3013,  1362, -3236,
   -1422,  4474,  1684,  3904,  3023, -1422,  3024,  1681,  5230,  2154,
    1683,  2531,  1687,  1688,  1309,  1691,  4535,  1974,  -606,  2206,
    3779,  3780,  1718,  1719,  1720,  1721,   647, -2234,  3571,  2873,
    1691, -2720,  2575, -3166,  3431,  2821,  2739,  3601,  2501,  3602,
    3826,  3841, -2694,  1766, -1422,  1771,  4754,  1321, -3074,  1774,
    1779,  4128,  1491,  4129,  1333,  5771,  5076,  1689,  4154,  1690,
    4155,    68,  3939,   788,   773,  2362, -2694,  4095,  3745,  4156,
    4355,  4157,  4196,   690,  4197, -2713,  2873,  3647,  2914,  1808,
    4937,  4547,  4358,  2688,  2937,  4394,  4395,  3042,  4774,  1753,
   -2714,  4777,  1975,   831,  4396,   788, -2715,   788,  3077, -2713,
    5371,   788,   788,  1976,  2724,  4938,  2941,  3928,  3927,  1689,
    1977,  1690,  1687,  1688, -2714,  5042,  2207,  2915,  1874,   647,
   -2715,  2926,  4788,  1799,   879,  2208,   690,  4102,  1526,  1412,
    2927,   788,  2465,  4108, -2555,  2928,   761,  5158,  4723,  4113,
    5312,  1356,  1978,  2930,   647,  5216,  4700,   821,  2610,   821,
     663,  1163,  3339,  4466,  1911,  4745,    68,   832,   805,  1235,
    5015,  5537,  4339,  4340,  2940,  3916,  1762,  4415,  4371,  1858,
    4343,  4344,  2850,   773,  1333,  3340,  1691,  5702,   773,   773,
    3811,  3346,  3201,   822,  1816,  1333,  1333,  1689,  2481,  1690,
    2461,  2192,  2429,  2719,  1358,  1912,   731,  2594,  1348,  2471,
    3836,  3837,  2576,  1979,  1922,  2635,  2636,  5628,  1687,  1688,
    1757,  4474,  2644,  2645,  2646,  5729,  5730, -2234,   773,  1935,
    1762,  1936,  2809,  2613,  3434,  3664,  1995,  3678,  1691,  3640,
    1743,  3496,  3411,  3412,  1980,   832,  2696,  2801, -1916,  1948,
    3260,  3260,  4778,  4674,  3670,  2933,  2029,  2714,  5580, -2175,
    5772,  3665,   806,  2030,   807,  1163,   808,  2697,   773,  1971,
    5365,   809,  3712,   810,  5773,  1681,  3974,  3975,  1683,  1687,
    1688,  2942,  4648,  1949,  1950,  1835,  4943, -2175,  1994,  4474,
    4414,  2008,  1843,  5349,  2008,  2008,  1900,  1689,   886,  1690,
    1687,  1688,  3408,  2014,  2517,  2698,  2725,  1916,  4549,  1909,
     686,   687,  3287,  3288,  5538,  4760,  1691,  4844,  3153,  3347,
    1253,  2022,  2023,  5807,  1375,  3409,   879,   113,  2034, -3074,
     135,  3942,   111,  4859,  4860,  2440,  1687,  1688,  4572,  3425,
    3858,  4529,   773,   617,  1583,  2934,   877,  1385,  1761,  1863,
    1872,   788,   773,  3535,  1870,  4977,  2828,  2829,  2946,   779,
     773,  1758,  3660,   773,  1492,  1687,  1688,  3438,  3252,   108,
    3842,  4994,  2947,   773,  3253,  4996,  4997,  2079,  2439,   647,
     773,  4868,  2091,  5757,   848,  2954,  2047,  5344,  2973,  1687,
    1688,  3672,  2101,  1689,  3680,  1690,  3105,  2966,   788,  5623,
    3109,   662,   788,   773,   933,   686,   687,   890,  2974,  3822,
    4519,  4520,  4521,  4522,   172,   173,  1691, -1916,  1914,  2830,
    1243,  2193, -3167,  3134, -2727,  5346,  5372,   788,  3686,   647,
     788,  1349,  3940,  3216,  1347,  2056,  2860,  5356,  2718,  3019,
    3078,  2720,   172,   173,  4229,  4230,  4231,  4232,   731,  1800,
    2165,  4372,   933,  3036,  1689,  4780,  1690,  5043,  2217,  1910,
    1687,  1688,  2861,  1687,  1688,  2047,  2862,  3338,  4939,  2482,
    1875,  3704,  3451,  2864,  4746,   773,  4308,  4812,  3081,  3082,
    3826,  5457,  1201,  1138,  4761,  3607,  3608,  3714,  1687,  1688,
    3629,  2863,  5570,  3634,  2976,  2061,  5770,  1836,  2690,  1687,
    1688,  3869,  3781,  4926,  4927,  4928,  3757,  2943,  2040,   113,
    1817,  1689,  1691,  1690,  2472,   933,   933,  1681,  2052,  2802,
    1683,  3349,   935,  1687,  1688, -2234,  2057,  1844,  2473,  3414,
    3424,  2796,  3600,  5578,  3603,  4879,  3407,  3452,  5088,  3144,
    1689,  3146,  1690,  4530,  3680,  5397,  2085,  3098,  2085,   887,
    5017,  5345,  3679,  3839,  5019,  3151,  1555,  1556,  1557,  1873,
    3680,  3680,  3046,  2314,  1689,  2315,  1690,  5141,  3158,  3159,
     935,  2368,  5152,  1691,  5373,  3216,   773,  5603,  3851,  3852,
    1277, -1916,  3853,  3854,  3855,   773,  1201,   670,  5737,  3982,
    1687,  1688,  4309,  2377,  1691,  5089,   773,  5774,  4573,  1928,
    2825,  5623,  3050,  3217,  5905,  3859,  1532,  2354,  2408,  2866,
     888,  1454,   891,  5466,  1608,  5468,  1542,  1687,  1688,   679,
    2518,  1845,  5828,   788, -1017,  5473, -1017,   113,  5532,  3033,
    1691,  2554,  2363,   935,   935,  1689,  1846,  1690,  1689,  1309,
    1690,  3990,   877,  1687,  1688,  1392,  2724,  4945,  4762,   759,
    1391,  5823,  4532,  2026,  4536,  2979,  4102,  3606,  4102,  1691,
     788,  5883,  2413,  1689,  1533,  1690,  4102,  1687,  1688,  4946,
    1687,  1688,  2433,  4565,  1689,  4532,  1690,  4479,  5664,  3762,
    3984,  3880,  4102,  1691,   788,   788,   705,   760,  1907,  4945,
    1907,  5458,  4102,  3715,   788,  2466,  4577,  4869,  1689,  4870,
    1690,  2691,  4585,  -822,   788,  4945,  5664,  2980,  5604,  4945,
    4945,  4102,  4532,  4532,  4593,  4594,  3783,  4603,  2493,  1753,
    1397,  4576,  4385,  3218,   779,   773,   779,   779,   779,   779,
     773,   788,   773,  1534,  4871,  5351,   779,  2640,  2643,  5584,
    4610,  5752,  2322,  3584,  5251,  3217,  5599,  5884,  5398,  3171,
    3172,  2331,  2528,   779,  1691,   788,  5090,  1691,  3585,  2534,
    3254,  1294,  2342,  4872,   706,  1689,  5824,  1690,  2079,  3784,
    4263,  3126,  1929,  4480,  4310,  2009,  5407,   773,  2009,  2009,
    3289,  5273,  1691,  2158,  5258,  2981,  5605,  2601,   773,  2714,
    1397,  5665,  1689,  1691,  1690,  2826,  3685,  3127,  4262,   773,
    2502,  3128,  2504,  2506,  2507,  2508,   936,  5800,  3130,  4604,
    2106,  1535,  2514,  2158,  1393,  3973,   693,  1691,  1689,  5665,
    1690,  2158,   936,  4805,  4805,   879,  3129,  2629,  1186,  2529,
    4798,   821,  1394,  3087,   877,  5640,  2633,  4605,  2725,   788,
    1687,  1688,  1689,   761,  1690,  1689,    31,  1690,  1295,  1296,
    3173,  3215,  3731,   773,   695,  4386,  4505,   821,  2615,  2029,
    3430,  1333,  3166,  1762,  1974,  3218,  2030,  1333, -2175, -2175,
    2316,  1687,  1688,  2317,  4578,  2676,  2106,  2487,  5459,   788,
    2719,  5138,  1333,  5534,  1691,  2982,   788,   788,   788,  4799,
    2008,  2503,  5776,   773,  3112,   933,  2509,  5150,  2511,  4873,
    1526,    38,  3245,  1687,  1688,  3246,  5215,  3197,   773,  3251,
    5259,  1691,    40,  4239,  4240,  5001,  2488,  2128,   719,   773,
     773,  2709,  2047,   701,  4923,  4543,  2684,   788,  4248,  4579,
    2129,  1687,  1688,  2073,  4606,  4874,  5159,  1691,  5161,  1975,
    1163,  3983,  4544,  2543,  3131, -1017,  3493,  3493,  3493,  3272,
    1976,  5484,  2724,  3485,  2553,  2159,  2452,  1977,  2801,  1322,
    5641,  1691,  1326,   733,  1691,  2566,  1687,  1688,  3413,  2453,
    3338,  5038,   736,   788,  4004,  4005,  4006,  4007,  1687,  1688,
    2723,  2985,  3765,  2107,  5720,  2159,  3769,  5724,  2130,  1978,
    5382,  2160,  5384,  2159,  1222,   773,   720,  2714,   780,  2748,
    5834,  4800,  2035,  1687,  1688,   798,  5879,  4275,  1297,   753,
    5341,  5798,  5799,   935,  1370,  1689,   773,  1690,  5738,  1687,
    1688,  2079,  5193,  4685,  4686,  2008,  1323,  2130,  1333,  3656,
    3657,  5410,  2720,  1451,  5426,  2817,  4876,  1687,  1688,  2819,
     781,  4878,  3003,  3986,  5866,  5867,  1689,  5486,  1690,  2107,
    1979,   773,   773,   936,  3671,   936,   936,   936,  2833,  2638,
    1796,  4459,   936,  3989,   936,  2842,  2842,  3113,  2842,  2842,
    1687,  1688,  2489,  4892,  1347,  4801,  1371,  2421,  1689,  2441,
    1690,  1980,  4794,   788,  2106,  1347,  1347,   773,  -221,  1687,
    1688,  1366,  4195,  2054,  4198,  2714,  5835,   773,  2685,  3008,
    4795,  4581,  4582,  4583,  2881,  4586,  1689,   934,  1690,  1356,
    3407,  2422,  5442,  3803,  2889,   851,  1687,  1688,  4945,  1687,
    1688,   686,   687,   934,  2111,  2802,  5840,   734,  3011,  1184,
    3414,  1687,  1688,  3189,  1691,  1687,  1688,  3680,  2522,  5529,
    3659,  1689,  5465,  1690,  2725,  5448,  1687,  1688,  3190,  5836,
    3447,  3623,  3018,  1689,  5880,  1690,  4766,  1357,  5487,  4767,
    1272,  2744,  1358,  3476,   113,  1691,   933,  4579,  1583,  2918,
    2055,   783,  3680,  5449,  1687,  1688,  2131,  3522,  1689,  1324,
    1690,  4460,  2523,   933,  5107,   690,  5108,  2423,  3527,  3477,
    3804,  4603,  2074,  3478,  1689,  3033,  1690,  1691,   879,  3064,
    3480,  1359,  1222,  5694,  5695,  4892,  3427,  4854,   784,  1687,
    1688,  2657,  1689,   155,  1690,  2454,  2658,  1797,  3479,   933,
    2659,  3205,  3206,  3029,  4805,  1691,  3497,   933,   933,   933,
    5450,  2841,  2841, -2328,  2841,  2841,  1526,  4545,  5415,  2875,
    1687,  1688,   803,  1687,  1688,  1689,  3561,  1690,  1273,  2373,
    3485,  4126,  2185,  2855,  4855,  4546,   690,  2107,   731,  4768,
    1691,  1201,  4127,  1508,  1689,  4102,  1690,   773,  2424,  1687,
    1688,  5596,  1691,   773,  2618,  3569,  2185,  2075,  5077,  2076,
    2931,  4162,  2256,  4604,   935,  5078,  4140,  4535,  1849,  3020,
    2714,  1689,  3646,  1690,  1689,   936,  1690,  1691,  3207,  5596,
    2660,   935,  1274,   812,  4414,  5671,  1689,  1294,  1690,  4163,
    1689,  4608,  1690,  1691,  2198,  1687,  1688,  2524,  3126,  1687,
    1688,  1689,   814,  1690,  4945,  4856,  4945,  1681,  2619,  3811,
    1683,  1691,  3292,   877,   686,   687,  3482,   935,  2258,  2374,
    1850,  4769,  5818,  4701,  3127,   935,   935,   935,  3128,  1689,
    5079,  1690,  2408,  4142,   934,  3130,   934,   934,   934,  2185,
    1728,  1687,  1688,   934,  1691,   934,   825,  3811,  3811,  2077,
    2185,  1694,  2185,  3129,  2009,  2044,  2045,  2106,  2944,   788,
     788,   773,    68,  1691,  1689,   788,  1690,  1695,  1737,  2842,
    2842,  2842,  2842,  5849,  1295,  1296,  5851,  3099,  3100,  5804,
    1753,  5805,  1687,  1688,   788,   826,  4170,  4483,  4606,  2084,
    1691,   893,  1175,  1691,  4484,  1689,  1696,  1690,  1689,  1180,
    1690,  2261,  1697,  1687,  1688,  1691,  4947,  5865,  3123,  1691,
    4171,  2967,  2277,  2999,  2295,  5293,  2375,  5858,  3140,  3005,
    1691,   842,   779,  4544,  1689,  1181,  1690,  2078,  1115,  1182,
    3142,  1687,  1688,  3181,   779,  1117,  1183,  5868,  3147,  1698,
    4533,  4256,  1687,  1688,  4693,  3811,  5416,  5417,  1691,  1687,
    1688,  2719,  4085,  5832,  5832,  1333,  1687,  1688,  2971,  1333,
    1877,   773,  4817,  1441,  4086,  1687,  1688, -1051,  1687,  1688,
    1689,  3131,  1690,  2929,  1689,  1222,  1690,  1858,  3169,  1460,
    1454,  3150,   933,  1691,  5026,   788,  3184,   773,   113,  2009,
    4301,  2388,  5528,  1132,  3062,  5115,   933,  1526,  3141,  1134,
    4591,  4592,  3063,  1687,  1688,  5855,  5116,  1140,   686,   687,
    3145,   821,  4518,  1233,  1691,   773,  1689,  1691,  1690,  1687,
    1688,   656,  3211,  1687,  1688,  3214,   773,  1743,   828,  5396,
    2107,  4614,  4615,  1235,  1606,  2841,  2841,  2841,  2841,   845,
    1237,  5483,  1995,  1691,  2801,   167,  3485,  3062,  5418,  3413,
    3704,  3238,  3239,  3240,   773,  4689,   779,  1689,  4630,  1690,
    3256,   773,  3249,   779,  3257,   773,  3307,  1248,   936,  4095,
    1253,   773,  1185,  2813,  2648,  4659,   934, -2716,  1689,  4655,
    1690,  1927,  2977,  5008,  2978,  2873,   773,  1932,  1933,  1691,
    3270,  1258,  2079,  1691,  1994,  3275, -2403,  4095, -2403,  4261,
     935,  2389,  4508,  4662,  4134, -2722,  1689,  4664,  1690,  4547,
    4099,  1333,  2970,  1261,   935,  5484,  2390,  1689, -2724,  1690,
    4683,  3300,  5419,  2986,  1689,  1877,  1690,  3157,  3304,  3305,
    1267,  1689,  3243,  1690, -1362,  1691,  1786,  5423,  3248,  3250,
    1689,  4099,  1690,  1689,  2972,  1690,  1270,  4095,  4173, -2736,
    3943,  1687,  1688,  3186,  3044, -2744,   788,  4225,  4095,  1703,
    1687,  1688,   773,  4702,  1687,  1688, -2745,  4095,  1687,  1688,
    1279,  3222,  2975,  3456,  1290, -2746,  1691,  4095,  1689,  1281,
    1690,  1687,  1688,   933,  3414, -2749,   877,  1288,  3429,  4258,
     752,  2047,  3323,  2391,  1689,  1304,  1690,  1691,  1689,  4829,
    1690,  5668,  1687,  1688,  5675,  3457,  1308,  2983,  1687,  1688,
    2992,  5486,  1877,  1315,  1687,  1688,  4021,  1687,  1688,  2984,
    3241,   721,   722,  4238,  3417,  1691,  3419,  3247,  1687,  1688,
    1310,  1347,   773,  2764,  2765,   773,  1691,  1347,   788,  1317,
     788,   788,  4631,  1691,  2988,  3283,  1687,  1688,  2777,  2700,
    1691,  1318,  1347,   788,  4632,  2996,  2842,  1877,   723,  1691,
    2989,  1703,  1691,   933,     8,  3458,  5055, -2358,  1319,  1704,
    1353,  1766,   113,  1766,  4633,  1389,  2123,  2124,  2993,  4532,
    2125,  5909,  1385,  2997,  1705,  1877,  4102,  1907,  2047,   172,
     173,  1391,  1787,  3459,  1822,  2701,  4102,  1691,   724,  1404,
    4577,   935,  2998,  1415,  1877,  4585,  1423,  5668,  4634,  3720,
    1421,  2994,   933,  1691,  5675,   686,   687,  1691,  3004,   168,
    1877,    16,  5487,   788, -2358,   788,  1689,  4574,  1690,  4575,
    2995,  2450,  2450,  2450,  2450,  1689,  2702,  1690,  1422,  1689,
    4476,  1690,   798,  1689,  3721,  1690,  2779,  2780,  1428,  4194,
    1788,  4548,  4556,  2092,  1972,  4560,  1689,  3001,  1690,  1789,
    3002,  1706,  4564,  3436,  3345,  3437,  2376,  1435,   169,   934,
    2013,  1704,  3006,  2015,  2015,  1431,  3007,  1689,  4543,  1690,
    4696,   935,  1442,  1689,  4907,  1690,  1705,  3009,  1590,  1689,
    3460,  1690,  1689,  4554,  1690,  4544,  1443,  4635,  1347,  1454,
    1790,  3426,  1222,  1689,   731,  1690,  1605,  5668,  5675,  3488,
    1471,  3489,  1609,  1610,  3697,  3016,  3698,   686,   687,  3773,
    1473,  3774,  2841,  3692,  4305,  4381,  2873,  5049,  5050,  1975,
     935,  4523,  4524,  5690,    31,  5692,  5693, -2358,  5499,  3582,
    1976,  4809,  3834,  4811,  3835,  1691,  4814,  2667,  1479,  4818,
    3030,  1481,  4821,  4822,  1691,  3123,  5068,  4794,  1691,  2703,
    1333,  1333,  1691,  1706,  4636,  5500,  1482,   113,  3346,  1687,
    1688,  2704,  3610,  1681,  1484,  1691,  1683,   725,  5663,  1974,
    1490,  4121,    36,  1493,  4124, -2358,  1494,  4275,  4861,    38,
    2188,  2189, -2358,  1526,   726,  4148,  1691,  2978,  1496,  2199,
      40,   773,  1691, -2358,  1495,   788,   788,  2842,  1691,  3983,
    4125,  1691,  1791,  1498,   172,   173,  4694,    42,  1504,   727,
   -2358,   788,  1691,  1699,  1700,  1701,  3736,   113,  2764,  2765,
     135,  2259,   111,  2262, -1051,  5762,  5763,  1709,  1792,  5766,
    2668,  1397,  1527,  2777,  2724,  4151,    84,  1877,  2275,  2276,
    2278,  1537,  3795,  5664,  1975,  1178,  4130,  2279,  2280,   728,
    4135,  4161,  1536,  1877,  2296,  1976, -1362,  1601,  4165,   108,
    4166,  1980,  1977,  2705,   152,   686,   687,  2354,  2073,  1543,
    5501,  4637,  1544,  4638,  5502,  1687,  1688,  3592,  3705,  3604,
    5041,   172,   173,  4941,  1703,  4486,  3347,  4487,  4668,  3706,
    1877,   113,  4136,   956,  1978,  4912,  1647,  4913,  5483,  3324,
    4362,  4363,  5817,  4954,  4364,  4365,  1545,  4341,  1550,  1551,
    4366,  4367,  4959,  3413,  4914,  4956,  4915,  3493,  4961,  1552,
   -2328,  1823,  4956,  1710,  4916,   963,  4917,  1766,  4973,  2345,
    2346,  2779,  2780,  4137,  1689,  2706,  1690,  4981,  4982,  1553,
    1723,  1711,  4555,  4040,  3722,  1554,  4690,  4691,  1724,  2408,
    1766,  1558,  1560,   779,  4138,  1979,  5665,  3642,   773,  1561,
    3348,  -848,  1709,  2841,  4992,  1824,  4995,  1825,  1562,   773,
    5002,  1563,  5484,   773,  5009,  4708,  1877,  2714,  1564,   788,
    4545,  5024,  4139,  5025,  5499,   975,  1980,  2413,  5032,  1565,
    1877,  3723,  1653,  4147,  1704,   936,  5485,  1566,  4546,  3843,
    4153,   788,   788,  5045,  1201,  5046,  5059,  4158,  5060,  1705,
    3325,  5500,  5070,   987,  5071, -1775,  4159,  3326, -1774,  4160,
     153,  1567,  1709,  4639,  4640,  3327,  2725,  1793,  5503,  3754,
    4535,  3827,  3828,  3829,  3830,  5155,  3832,  3833,  5525,  1568,
     686,   687,  5106,   936,  3774,  1974,  1546,  1569,  1570,   933,
    1689,   788,  1690,  1691,  4168,  3724,  1571,  1572,  1710,  1826,
     172,   173,  5272,  5226,  2106,  5227, -3343,  3935,  5486,  5228,
    4169,  5227,  1575,  5622,  4172,  2724,  1711,  1725,  2945,  3739,
   -1051,  5231,  2867,  5232,  3951,  3952,  1706,  3954,  3349,  3956,
    3957,  3958,  3959,  3960,  3961,  3962,  1585,  3964,  3328,  3725,
    3969,  5198,  1707,  1794,  3972,  1586,   936,   936,  1827,  5214,
    1005,  1795,  1709,  1587,  1302,  1303,  2789,  1306,  1710,  1307,
    1975,   686,   687,  1588,  3759,   773,  5501,  2074,  1591,  1592,
    5502,  1976,  1712,  1713,  2823,  1347,  1711,  1593,  1977,  1347,
    5287,   154,  4265,  5143,  2833,  1594,  1687,  1688,  3350,  2023,
     788,   788,   788,   788,  5483,  1595,   773,  1828,  1709,  3329,
    1596, -2328,  1726,  5374,  4601,  5375,  4621,   935,  4131,  1691,
    1978,  5392,  4953,  5309,  5424,  3064,  5425,  3831,  1597,  5487,
    3403,  4641,  1222,  3267,  1598,  2047,  2047,  2047,  2047,  1148,
    1599,  1600,  1712,  1713,  1602,  4969,  1709,   933,   933,  4972,
    2450,  2450,  4176,  1297,  1707,  1603,  1604,  4979,  1710,  1687,
    1688,  4189,  2075,  1611,  2076,  5007,  1612,   155,  2714,  5013,
    1613,  4829,  3947,  1614,  3949,  3950,  1711,  5428,  5484,  5425,
    3955,  1979,  5022,  3501,  4669,  4935,  1615,  2107,  3963,  1616,
   -3343,  1617,  1618,  3970,  1687,  1688,  1619,  1829,  3502,  1687,
    1688,  1149,  5485,  5023,  1710,  3726,  3727,  3728,  1727,  5027,
      68,  1620,  1980, -2358,  3309,  5028,   156,  2725,  5399,  1830,
    1729,  1731,  1711,  3334,  3503,  4408,  1474,  1854,  5446,  5462,
    3774,  1621,  1712,  1713,  5503,  1624,  3504,  3268,  4174,  5405,
    1625,  1347,  1710,  1175,  1626,  2202,   934,  1627,  1628,  2790,
    1180,  5447,  1629,  3774,  2077,  2106,  3505,  1687,  1688,  2905,
    1711,  1630,   172,   173,   157,   935,   935,  1633,  1687,  1688,
    1634,  1689,  4012,  1690,  5486,  1635,  1181,  2203,  1712,  1713,
    1182,  4409, -1051,  1475,  4215,  1636,  1476,  1183,  3506,  5560,
    3507,  5425,  1637,  2204,   934,  5601,  5505,  5602,   788,  1687,
    1688,  5631,  1638,  5632,  3189,   788,   788,   788,   788,  5377,
    4236,  4235,  1639,  1477,  1974, -2578,  1712,  1713,  5642,  3190,
    5643,  1478,  4547,   686,   687,  1640,  4246,  4247,  5661,  2008,
    3835,  1641,  2078,  2865,  1689,  1642,  1690,  2205,  1643,  1644,
    1397,  1397,  1397,  1397,  1645,  1646,  1709,  5254,  1648,  1649,
    1687,  1688,  1650,  5504,  2964,  4267,  5483,   934,   934,  5561,
    5685,  1651,  5046,  5564,  2354,  2206,  1652,  3132,  4281,  1689,
     113,  1690,  4793,  1222,  1689,  4272,  1690,  5761,  5765,  4715,
    5425,  4804,  1150,  1151,  1654,  5487,  5488,  1655,  1656,  1975,
    1691,  1526,  1152,  -821,  2221,  2222,  2223,  2224,   788,  1657,
    1976,  4813,  1658,  1659,   773,   773,  3310,  1977,  1735,  4251,
     779,  1660,  1663,  5320,  5321,   158,  5323,  1664,  3629,   159,
    5767,  1667,  5425,  1185,   773,   773,  1736,  5768,  2107,  5425,
    5484,  4350,  1689,  1397,  1690,  5786,   936,  5787,  5499,  1978,
    1668,  4252,  1710,  1689,  2935,  1690,  3508,  2938,  2225,  2226,
    2227,  2143,  3311,  1691,  5485,  5616,  2901,  2202,  3509,  1669,
    1711,   160,  2207,  2950,  3979,  5500,  1716,  1717,  1718,  1719,
    1720,  1721,  2202,  5795,  1689,  5796,  1690,  1746,  3851,  3852,
    1670,  2968,  3853,  3854,  3855,  1671,  4328,  1707,  1691,  2203,
    5815,   161,  5425,  1691,  5816,  5662,  5425,  3623,  1672, -3343,
    1979,  4253,  2228,  2229,  2203,  3805,  1748,  5819,  5405,  5425,
     172,   173,  5783,  1673,   172,   173,  1712,  1713,  5523,  5822,
    3805,  5046,  5850,  1674,  5425,  1689,  5486,  1690,  1730,  4254,
    5383,  1980,  3312,  5896, -1051,  5897,  1747,  1687,  1688,  1749,
    1756, -2606,  4408, -2577,  5635,  1781,  4929, -2603,  4477,  3806,
   -2601,  1691,  5505, -2605,  1784, -2600,  3500,  1687,  1688, -2604,
   -2598,  4391,  1691,  3510,  3806,  3511,  3643,  4461, -2602,  1785,
    4314,  4315,  1804,  2230,  1801,   686,   687,  3807,  1357,   933,
    5501,  1818,  4475,  1819,  5502,  3476,  1820,  1821,  1841,  1842,
    1347,  1347,  3807,  1691,  3313,  1847,  5579,  1153,  4409,  1853,
    4935,  1716,  1717,  1718,  1719,  1720,  1721,  1859,  5483,  1687,
    1688,  3477,  1865,  3314,  3315,  3478,  1877,  1908,  3316,  3317,
    3318,  3189,  3480,  3549,  1918,  5453,  4255,  5454,  5455,  1920,
    1924,  1930,  1931,  1937,  4504,  1938,  3190,  5487,  4507,  1940,
    3479,  4509,  5488,  3551,  1691,  2231,  1687,  1688,  1946,  1942,
    1960,  4377,  4378,  4379,  1961,  1962,  1972,   933,   788,  1714,
    1715,  1716,  1717,  1718,  1719,  1720,  1721,  1984,  1987,  1983,
    1997,  3294,  3295,  2000,  3808,  1687,  1688,  4149,  1687,  1688,
    4152,  5644,  5484,  2010,  2011,  2026,  3319,  2032,  3306,  3808,
    2036,  2038,  2041,  2047,  2042,  3553,  2046,   935,  3332,  3333,
    2058,  2062,  4410,  2069,  2086,  5908,  5485,   936,  2092,  2096,
    -821,  2098,  1689,  2100,  1690,  2102,  3512,  2110,  2116,  1526,
    2724,  2008,  2008,  2117,   936,  2119,  2232,  2120,  2121,  2142,
    4141,  2151,  1689,  5635,  1690,  3320,  2164,   934,  5503,  5530,
    5531,  2232,  2167,  2168,  4600,  4497,  4500,  2166,  4503,  1714,
    1715,  1716,  1717,  1718,  1719,  1720,  1721,  2171,  3482,  3483,
     936,  2789,  2174,  3396,  3397,  3398,  3399,  2172,   936,   936,
     936,  2175,  2177,  2789,  4411,   935,  2184,  2185,  5486,  2194,
    2201,  2212,  2216,  2244,  1689,  5132,  1690,  2255,  5135,  5136,
    2256,  2257,  2266,  5731,  2233,  1714,  1715,  1716,  1717,  1718,
    1719,  1720,  1721,  1154,  1155,  1156,  1157,  2270,  2273,  2233,
    2274,  2300,  2330,  2009,  2336,  2340,  2350,  2361, -2328,  2365,
    2383,  1689,  2387,  1690,  3513,  3403,  2414,  2415,  2442,  2443,
    2448,  1691,  4658,  1714,  1715,  1716,  1717,  1718,  1719,  1720,
    1721,  2444, -3048,   623,  2447,  2221,  2222,  2223,  2224,  4667,
    1689,  1691,  1690,  1689,  2456,  1690,  2460,  2463,  2467,  2234,
    3795,  2235,  5791,  2714,  2497,  2499,  2236,  4236,  4235,  2500,
    2520,  2535,  2536,  3514,  2234,  2714,  2235,  5304,  4391,  2537,
    4215,  2236,  4412,  2538,   788,   788,  2540,  2542,  2541,  5487,
    4688,  4687,  3476,  5547,  5488, -2187,  3515,  5890,  2557,  2225,
    2226,  2227,  2560,  1691,  2561,  2568,  1178,  1753,  2569,   624,
    2570,  5900,  2725,  2571,  3132,  5829,  2354,  5890,  3477,  1397,
    1397,  2579,  3478,  5900,  2578,  2588,  2589,  3705,  4705,  3480,
    2590,  2237,   113,  4713,  5210,  2591,  2592,  2596,  4816,  2602,
    1691,  2593,  4537,  2595,  2790,  2603,  2237,  3479,  4542,  2606,
    2106,  4559,  2607,  2228,  2229,  2611,  2790,  2616,  4563,  2623,
    2627,  4722,  2106,  2647,  3476,  2649,  4653,   933,  2650,  1691,
     773,  2651,  1691,  4475,  2238,   773,  2652,  2655,  2663,  2664,
    3843,  2665,  5791,  2673,  2677,   933,  1687,  1688,  4666,  2238,
    3477,  2680,  2678,  2681,  3478,  2687,  2689,  2692,  2693,   625,
    1526,  3480,  2699, -2589,  2722,  3270,  2737,  2746,   934,  2745,
    2750,  2751,  2753,  2791,  2413,  1186,  2754,  2786,  4920,  3479,
    2811,  2803,  2806,  2807,  2230,   934,  1359,  2815,  2818,  2821,
    5390,  4781,   788,  2824,  1715,  1716,  1717,  1718,  1719,  1720,
    1721,  5264,  2831,   936,   939,  2836,  4475,  2856,  4852,  2879,
    2880,  2882,  2897,  4810,  2899,  2902,  5505,   936,  2900,  2911,
    3481,   934,  2912,  4713,  2239,  3482,   626,  4826,  1222,   934,
     934,   934,  2955,  2919,  4825,  2240,  2354,  2929,  2913,  2239,
    1222,  2789,   773,   956,  4847,   935,  2916,  2917,  4843,  2932,
    2240,  4411,  2936,  2939,  4848,  4849,  2231,  2948,  3022,   939,
     788,  4713,  4865,   935,  4866,  4867,  2949,  2951,  2952,  2953,
    4864,  5336,   961,  2957,  2965,   963,  2969,  2987,  3038,  2792,
    2990,  4713,  3010,  2107,  2991,  1974,  3056,  4475,  4885,  3014,
    3000,   967,   968,  4896,  4895,  2107,  4725,  3482,   956,   779,
    3015,  4737,  3017,   933,  4906,  3021,  5488,  5615,  3034,  2408,
   -1558,  3043,  5548,   113,  3049,  1766,  1721,  3058,  3059,  5549,
    5514,  1689,  3068,  1690,  3060,  3061,  3075,   961, -1744,  3493,
     963,  3400,  5872,  3080,  5550,   975,  1631,   113,  1661,  1665,
    4921,  3086,   111,  2714,  3088,  3084,   967,   968,  3089,  3095,
    3103,  3104,  2232,  3110,   981,  3114,  3111, -2328,  3139,  4412,
    1975,   788,   986,   987,  3115,  2009,  2009,   788,  3116,  3148,
    3117,  1976,  3152,  3160,  3164,  4902,  3163,  3195,  1977,   627,
    3194,  3118,  3119,  3223,  3225,  3226,  4836,  4838,  4840,  3227,
     975,  3229,  3230,  4845,  4846,  3255,  4967,  3262,  3266,  4851,
    3280,  3286,  3290,  3293,   936,   628,  3296,  4858,  4834,   981,
    1978,  4863,  3297,  3298,  3299,  3301,  3302,   986,   987,  3303,
    2233,   935,  4877,  4345,  2790,  3354,   933,  3357,  3360,  3364,
    2106,  3370,  4935,  3367,  3371,  3372,  3373,  3374,  -823,  3375,
    1691,  4389,  3376,  3814,  3815,  5714,  3817,  3819,  3377,  -823,
    3402,  1003,  4389,   629,  3378,  3379,   933,  3380,  3381,  1004,
    1005,  1006,  5551,   737,  3382,  3383,  3384,   759,  3385,  3386,
    3387,  1979,  3394,  3388,  3389,  5552,  1184, -1422,  3390,  3391,
    5751,  2791,  3392,  3418,   936,  2234,  3395,  2235,  3393,  5064,
    3420,  3421,  2236,  3439,  4215,  5553,  2079,  -823,  3443,  3444,
    3433,   738,  1980,  3445,   934,   760,  1003,  3446,  -823,  3424,
     738,  3441,   738,  3442,  1004,  1005,  1006,  3449,   934,  3453,
    3189,  4477,  3455,  3454,  2354, -1422,  3461,  3486,  3524, -1081,
   -1422,  3189,  4281,   936,  3523,  3190,  3536,  3978,  3537,  3525,
    3538,   788,  3544,  3557,   935,  4475,  3190, -1783,  1222,   -72,
    3595,  3593,  3596,   773,  3611,  3580,  3581,  2237,  4986,  3626,
    3612,  3635,  3625,  3627,  3069,  5595,  3637,  5123,  5098, -1422,
    5099,  3641,  5126,  3644,   935,  3648,  5558,  5265,  1766,  3649,
    3650,  3651,  3655,  3661,  3662,  5266,   933,  2792,  2482,  2481,
     630,  3669, -3311,  5595,  3674,  2873,  3683,  3699,  3740,    40,
    2238,  4390,  5124,  2107,  3711,  3719,  3713,  3718,   631,  -823,
     933,  3741,  3743,  3747,  3748,  3763,  4933,  3756,  4936,  1222,
    -823,  5134,  3764,  3767,  3758,  3768,  4475,  4713,  4475,   853,
     788,  4475,  5265,  4713,  5554, -2089,  3846,  4952,  4475,  4475,
    5266,  5149,  3793,  4713,  3801,  3847,  3802,  4957,  3848,   739,
     632,  3933,  3937,   633,  3945,  3946,  3977,  3948,   739,  4962,
     739,   761,  3987,   854,  2816,  3992,  3981,  3996,  5156,  4000,
    4001,  4002,  4009,  4014,  4084,  4087,  4980, -2140,  4475,  4091,
     634,  4095,  4713,  -823,  4713,   856,  4088,  4099,   635,  2700,
    2239,  4106,   740,  4103,  -823,   857,   686,   687,  4107,  4111,
    4114,  2240,  4115,  5163,   935,   934,   773,  4116,  4164,  5197,
    5904,  4117,  5558,  4175,  5595,  4177,  4187,  4188,  4193,  5072,
    4201,   858,  5200,  4218,  4192,  4203,  5206,  4204,   935,  4205,
    4206,  1118,  4207,  4208,  4209,  2701,  4216,   859,  1119,  4219,
     154,  4220,   860,  4222,  4223,   113,  4226,  4227,  4228,  4245,
     775,  4241,  5222,  4242,  1120,  4266,  4264,  4259,  4268,  4265,
    5244,  4269,  4276,  4282,  1121,  1122,  1123,  4270,   861,  4271,
    4302,  4284,  4303,  4313,  1124,  4304,  2702,  4391,  4307,  4353,
   -1869,  4326, -1874,  4348,  4356,   934,  4360,   933,  4391,  4357,
    3272,  4407,  4361,  4375,  4370,  4388,  4391,  4416,  4404,  4406,
    5245,  4419,  4418,  4438,  5098,  4435,  4440,  4442,  4430,  4441,
    4444,  4445,  4453,  4454,  4455,  4456,   155,  4464,  4482,  4490,
    4510,  4511,  4514,  4517,  4526,  4528,  4540,  4535,  4562,  4569,
    4584,   930,  4587,  1112,   934,  4597,  4598,  4609,   862,  4613,
    4616,  4625,  4624,  4617,  5901,  3026,  4182,   930,  4660,  4670,
    4672,  3781,  4673,  1176,  1231,   863,  4677,  4676,  2426,  4680,
    1112,  5280,  4719,   864,  4706,  4720,  4714,  4707,  4721,  4715,
    4658,  4724,  5164,  4497,  4713,  4500,  4736,  4503,  3873,  1112,
    4748,  4749,  -252,  5292,  5292,  5294,  4752,  4772,  4475,  2410,
    5267,  4783,  4784,  5268,   865,  4756,  4758,  4785,  4797,  2703,
    5098,  4285,  5269,   866,   867,   935,  4795,  4815,  4286,  4819,
    4820,  2704,  4889,  1125,  4900,  4903,  4892,  4897,  4904,  4910,
    3270,  4911,  3270,  2757,  4287,  4918,  4924,  1126,  4919,  4922,
    4932,  4950,  4590,  4960,  4288,  4289,  4290,  4963,  4975,  4947,
    4987,  4995,  5333,  4986,  4291,  5267,  4990,  5003,  5268,  5338,
    4991,  4992,  4475,  4475,  4993,  4998,  4475,  5402,  4999,  5010,
    4475,  5011,  5350,  5012,  5435,  2758,  5016,  5018,  2354,  5031,
    5021,   773,  5030,  5033,  5039,  5047,  5052,  4713,  5053,  5056,
     936,  5061,  5057,  5092,  5066,  5067,  5101,  5094,  5100,  5103,
    4392,  5261,  5105,  5110,  5111,  5112,  5113,  5120,  1112,  5558,
    5119,  4392,  5121,  4417,  5122,  2759,  4420,  5125,  5068,  4426,
    4427,  4428,  4429,  2705,  4431,  4432,  4433,  4434,  5129,  4436,
    4437,  5128,  4439,  5130,  5145,  5146,  4443,  5151,  1127,  5154,
    4446,  4447,  4448,  4449,  5162,  4451,  4452,  5157,   773,  5071,
    3931,  4457,  4458,  5201,  5203,  4462,  4463,  2133,  5199,  4967,
     741,  5387,  2134,  5220,  5221,  5223,  5224,  5234,  5235,  5247,
    5249,  5250,  5248,  2135, -2140,  1128,  5252,  1112,  -167,  5274,
    5256,  5257,  5260,  5263,  5286,  5277,  5288,  5289,   930,  1129,
     930,   930,   930,  4292,  5296,  2706,  5297,   930,  5301,   930,
    5300,  5303,  5305,  5307,  5309,  5317,  5322,  4293,  4393,  5324,
    5325,  5327,  5329,  5331,  5334,  5339,  5292,  5355,  5360,  4393,
     933, -2718, -2717,   633,  4798, -2721,  5378, -2725, -2726, -2728,
    1112, -2730,   113, -2731, -2732,  1112,  5098,  5380,   936,   936,
    5388, -2737, -2738,  5391,  5406, -2739, -2743,  5395,  5363,  5496,
     742,  5367,  5400,  5496,  5401,  5412,  5408,  5407,  4475,  5410,
    5421,  5433,  5444,  4475,  5422,  1112,  5427,  5471,  5429,  5472,
    5481,  5474,  5516,  5461,  5456,  1112,  5244,  5475,  5517,  5533,
    5512,  5542,   773,  5515,  5543,  5526,  5546,  5480,  5563,  3879,
    5574,  5572,  5575,  4294,  5511,  5600,  5608,  5576,  5606,  5577,
    5585,  5587,  5518,  5522,  5588,  5610,  5612,  5613,  4295,  5614,
    5618,  5619,  5620,  5621,  5381,  5626,  5245,  5629,  5639,  5630,
    5645,  5649,  5652,  5672,  5657,  5705,  4477,  5660,  5677,  5682,
    5686,  5687,  2136,  5688,  5691,  5697,  5744,  5706,   935,  5541,
    5713,  5718,  5755,  5733,  5411,  4296,  5758,  5756,  5760,  5764,
    3869,  5777,  5292,  2137,  3880,  5769,  5565,  5810,  2138,  4297,
    5814,  5826,  1112,  1112,  1112,  1112,  5825,  5827,  5838,  5852,
    5841,  5573,  5853,  5859,  2408,  5864,  1112,  5496,  5869,  5871,
    5876,  5873,  5891,  5854,  5862,  5877,  3658,  5903,  5581,  2139,
    1528,   934,  5213,  3193,  5211,  5496,  1186,  3971,  5212,  1837,
    3751,  5559,  4368,  5306,  5679,  5569,  5812,  1328,  4744,  2037,
    4753,  5432,  5246,  5229,  5609,  5386,  5443,  5393,  5527,  2434,
    4984,  2140,  3204,  4299,  5680,  4090,   788,  4516,  4930,  2890,
     930,  3369,  4602,  2760,  1434,  2891,  2893,  2892,  2736,  2820,
    5431,  2083,  5299,  5430,  4467,  5153,  3914,  4679,  5476,  5276,
    4684,  2354,  5040,  5637,  3073,  5717,   731,  5785,  5413,  4986,
    5281,  5861,  5845,  2761,  2762,  5863,  2763,  2764,  2765,  2766,
    2767,  5659,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,
    4808,  2776,  2777,  2778,  3233,  4465,  5797,  5567,  4884,  5295,
    4472,  5127,  5833,  5696,  5617,   773,  4643,  5708,  4558,  5681,
    4596,  5710,  5715,  4281,  4281,  4942,  5348,  4948,  4179,  4663,
    4665,  5496,  5292,  4661,  5292,  5292,  5848,   745,   746,  2153,
    5820,  5801,  5821,  5753,  5811,  1681,  5750,  5464,  1683,  5698,
    4958,  5732,  5562,  5330,  4306,  5328,  4469,  4882,  1851,   934,
     934,  2624,  5704,  5703,  2053,  3735,  3734,  5478,  5712,  1112,
   -1956,  3363,  1899,  3083,  2788,  3185,  5347,  4011,  4527,  5522,
    3450,   774,  3690,  1355,  3599,  1973,  1751,  2018,  2017,  3652,
    5541,  3792,  4512,  4675,  3558,  2348,  3560,  3620,  5726,  5727,
    2779,  2780,  3617,   788,  4211,  2411,  2191,  2672, -1956,  2254,
    1965, -1956,  5745,  5319,  1966,  2669,  1967,  5496,  1968, -1956,
    1970, -1956,  5058,  5109,  5754,  4699,  5683,  2662, -1956,  5759,
    5684,  3429, -1956,  3282,  5292,  5292,  4200,  4775,  5292,  3790,
    2683,  2200, -1956,  4776,  5271, -1956,  4199,  5353,  5051, -1956,
    3791, -1956,  5638,  5282,  2012,  5262, -1956,  1373,  2025,  1880,
    2354,  4779,  3274, -1956,   756,  3416,   747,  2144,  2563, -1956,
    3448,  5054,  3708,  5792, -1956,  4698,  5793,  4695,  5063,  3825,
    4823,  5678,  5782,   788,  1880,  1446,  5496,  5496,  3154,  5844,
     936,  1245,  2814,  5907,  1452, -1956,  1227,  3155,  5809,  5808,
    2526,  3684,  4850,  2019,  1230,  5813,   771,  3198, -1956,  5354,
    5285,  5292,  4531, -1956,  2614,  5860,  2149,  1184,  5114,  5870,
    5326,  5902,  5906,  1607,  3167,  4703,  4692,  3597,  3673,  1188,
    3037,  1189,  3135, -1956,  2631,  3668,  2876,  3667,  5496,  2455,
    1112,   788,  1112,   930,  1147,  4376,  2141,  1745,  3645,  4782,
    3997,  3483,   172,   173,  5379,  3353, -1956,  3742,  4478,   765,
    1278,  5847,   749,   750,   751, -1956,  5313,  5445,   936,     0,
    1923,     0,     0,     0,     0,     0,  5893,   172,   173,     0,
       0,     0,  5895,     0,     0,     0,     0, -1956,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0, -1956,     0,     0,     0,     0,
       0, -1956, -1956,  1112,     0,  1112,     0,     0,     0,     0,
       0,     0,     0,     0,  2354, -1956,     0, -1956,   788,     0,
   -1956,     0,     0,     0,   788,     0,  5803,     0,  2354,     0,
       0,  1112,     0,     0,  2354,     0,     0,     0,     0,     0,
    2354,     0,  1112,  1112,     0,     0,     0,     0,  1112,     0,
       0,     0,  1112,  1112,  1112,     0,     0,     0,     0,     0,
       0,     0,     0,  1112,  1112,     0,     0,     0,     0,  1112,
       0,  1112,  1112,  1112,  1112,  1112,     0,  1112,     0,     0,
       0,     0,     0,     0,  1881,     0,     0,     0,  1112,     0,
    1112,     0,     0,  1112,  1112,   646,  1112,  1112,  1112,     0,
    1112,  1112,     0,     0,     0,     0,     0,     0,     0,  1881,
       0,     0,     0,     0,     0,  1112,  1112,  1112,  1112,  1112,
       0,  1112,  1112,  1112,     0,     0,  1112,  1112,  1112,  1112,
    1112,  1112,  1112,     0,  1112,  1112,  1112,  1112,     0,  1112,
    1112,     0,  1112,  1112,  1112,  1112,  1112,  1112,  1112,     0,
       0,  1112,  1112,  1112,  1112,     0,  1112,  1112,  1112,     0,
    1112,     0,  1112,     0,  1112, -1956,     0,     0,  1112,  1112,
    1112,     0,     0,  1112,  1112,  1112,  1112,  1112,     0,  1112,
       0,   934,     0,     0,     0,     0,  1112,     0,     0,     0,
       0,     0,     0,  1112,  1112,  1112,  1112,     0,     0,     0,
       0,     0,     0,     0,  1112,  1112,     0,  1112,  1112,     0,
       0,  1112,  1112,  1112,  1112,  1112,  1112,  1112,  1112,  1112,
    1112,  1112,  1112,  1112,     0,     0,  1112,     0,     0,  3861,
       0,  3862,  3863,     0,     0,     0,     0,  1882,     0,     0,
       0,     0,  3481,     0,     0,     0,     0,     0,  3483,     0,
       0,  1883,     0,  1884,     0,  3864,     0,  3865,     0,   934,
       0,     0,  1882,  3866,     0,     0,     0,  1112,   936,     0,
       0,     0,  1112,     0,     0,     0,  1883,     0,  1884,     0,
       0,     0,  1112,     0,  1885,  2026,   936,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3867,     0,  1886,
       0,     0,     0,     0, -1173,     0,     0,     0,     0,  1885,
       0,     0,     0,     0,     0, -1173,     0,     0,     0,     0,
    3483,     0,     0,     0,  1886,     0,     0,     0,     0,     0,
       0,     0,  1887,     0,   172,   173,     0,     0,     0,  3868,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1112,
    1888,     0,     0,     0,     0,     0,     0,  1887,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3869,     0,     0,     0,     0,  1888,     0,     0,     0,  1112,
       0,  1112,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3870,     0,     0,     0,  3871,
       0,     0,     0,     0,     0,  1112,     0,  3872,     0,     0,
    3873,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1889,     0,     0,     0,     0,     0,     0,  1890,     0,
       0,     0,     0,  3874,   936,     0,     0,     0,  1891,     0,
       0,     0,     0,     0,     0,     0,  1889,     0, -1956,     0,
       0,  1892,     0,  1890,     0,     0,     0,     0,     0,     0,
       0,  2154,     0,  1891,     0,     0,     0,     0,  3875,  3876,
    3877,     0,     0,     0,     0,     0,  1892,     0, -1956,     0,
   -1956,     0,  1893, -1956, -1956,  1894,     0,     0,  1112,     0,
       0,  3878,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1895,     0,     0,     0,     0,     0,  1893,     0,     0,
    1894,     0,     0,     0,     0,     0,  3879,   647,     0,     0,
       0,     0,     0,     0,     0,     0,  1895,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3481,
    3880,     0,     0,     0,     0,     0,     0,     0,  3881,     0,
    3882,     0,     0,     0,     0,     0,     0,   936,     0,   934,
     930,     0,     0,     0,     0,     0,     0,     0,     0,  3883,
       0,     0,     0,     0,     0,     0,  3884,   934,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   936,  3885,     0,
       0,     0,     0,     0,     0,  3886,     0,     0,     0,     0,
       1,     2,     0,     0,     0,     0,     0,     0,   930,     0,
    3887,  3481,     0,     0,     0,     0,     0,     0,  3888,     0,
       3,     0,  3889,  3890,     5,     0,     6,     0,     0,  3891,
       0,     0,     0,  3892,     7,     0,     0,  1112,     0,     0,
       0,  3893,     0,     0,     0,     0,     0,  2857,     0,     0,
       0,     0,     0,     0,     0,  1112,     8,     0,     9,    10,
       0,  3894,     0,     0,     0,     0,    11,     0,     0,     0,
       0,   930,   930,  1112,     0,     0,  1112,     0,     0,     0,
       0,     0,     0,     0,  1112,  1112,     0,  3895,     0,     0,
       0,  3896,    14,     0,     0,     0,     0,     0,     0,     0,
       0,  3897,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,     0,     0,     0,   936,     0,     0,
       0,     0,     0,     0,    17,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   934,     0,    18,  3898,    19,
       0,   936,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3899,     0,  3900,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    21,     0,     0,     0,  1112,  1112,
    1112,     0,     0,     0,     0,     0,     0,     0,    22,    23,
       0,     0,  3901,     0,     0,     0,     0,     0,  3902,    24,
      25,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    26,    27,     0,     0,    29,     0,     0,     0,     0,
      30,     0,     0,     0,     0,  3903,    31,     0,     0,     0,
      32,     0,     0,     0,    33,    34,  3904,  3905,  3906,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1112,     0,     0,  3907,   934,     0,
       0,     0,     0,     0,  3908,     0,     0,     0,     0,     0,
       0,     0,    35,     0,    36,  1112,    37,     0,     0,  1112,
    1112,    38,  1112,  1112,     0,     0,     0,     0,   934,     0,
       0,  1112,    40,  1112,     0,  3909,     0,     0,     0,    41,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    42,
    3910,  3911,     0,     0,     0,     0,     0,     0,   936,     0,
       0,     0,     0,  3912,  1112,     0,  3913,     0,     0,     0,
       0,    43,     0,     0,    45,     0,     0,     0,  1112,     0,
       0,    46,     0,     0,     0,     0,     0,     0,    47,     0,
       0,  1112,     0,     0,  1112,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1112,    48,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3122,  1112,     0,     0,     0,     0,     0,     0,
   -1173,     0,  5650,  5651,    49,  5653,  5654,  5655,  5656,     0,
       0,     0,     0,     0,    50,  1112,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   934,     0,
       0,     0,     0,    51,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    52,     0,     0,
       0,     0,   934,     0,     0,     0,  1112,     0,     0,     0,
      53,   930,     0,    54,     0,     0,    55,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    56,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1899,     0,
       0,     0,     0,  5725,     0,     0,  5728,     0,     0,     0,
       0,     0,     0,     0,  5736,     0,     0,     0,     0,  5746,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1112,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1112,     0,    57,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    58,     0,   934,
      59,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      60,     0,     0,     0,     0,     0,     0,     0,    61,     0,
       0,   936,     0,  1112,     0,     0,     0,     0,     0,     0,
      62,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -1017,     0, -1017,
      63,     0,     0,    64,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2026,     0,     0,     0,
       0,     0,     0,     0,     0,    65,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    66,     0,     0,     0,     0,
       0,     0,   930,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   930,
      67,     0,     0,     0,     0,   172,   173,     0,     0,     0,
    3868,     0,     0,     0,     0,     0,     0, -1017,     0, -1017,
       0,     0,    68,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3474,   930,     0,     0,     0,     0,
       0,     0,     0,   930,   930,   930,  2026,     0,     0,     0,
    1112,     0,     0,  1112,     0,     0,     0,     0,     0,     0,
       0,     0,  1112,     0,     0,     0,     0,     0,     0,     0,
       0,  1112,     0,  1112,     0,  1112,     0,  1112,  1112,  1112,
    1112,  1112,  1112,     0,  1112,     0,     0,     0,  3872,     0,
       0,     0,  1112,     0,  1112,   172,   173,  1112,  1112,  1112,
    3868,     0,     0,     0,     0,     0,  1112,  1112,  1112,     0,
    1112,     0,  1112,     0,  1112,     0,  1112,     0,  1112,     0,
       0,  4316,     0,  4317,     0,  4318,  1112,     0,  1112,     0,
    1112,  1112,  1112,  1112,  1112,     0,     0,  1112,     0,  1112,
       0,     0,  1112,     0,     0,     0,     0,     0,     0,  3875,
    3876,  3877,     0,     0,     0,  1112,     0,     0,     0,     0,
    1112,     0,     0,  1112,     0,  1112,  1112,  1112,     0,     0,
    1112,     0,  3878,     0,     0,     0,  1112,     0,  3872,     0,
       0,  1112,     0,     0,     0,     0,     0,     0,     0,  3122,
    1112,     0,     0,     0,     0,     0,  1112,  3879,  1112,     0,
       0,  1112,   934,     0,     0,     0,     0,     0,     0,     0,
       0,  1112,  1112,  1112,  1112,     0,  1112,     0,     0,     0,
       0,  1112,     0,     0,     0,     0,     0,     0,     0,  3881,
       0,  3882,     0,     0,     0,     0,     0,     0,     0,  3875,
    3876,  3877,     0,     0,     0,     0,     0,     0, -1017,     0,
    3883,     0,     0,     0,     0,     0,     0,  1112,     0,     0,
       0,     0,  3878,     0,     0,     0,     0,     0,     0,  3885,
       0,     0,     0,     0,     0,     0,  3886,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1112,  3879,     0,     0,
    1176,  3887,     0,     0,     0,     0,     0,     0,     0,  3888,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3892,     0,     0,  1112,   930,  3881,
       0,  3882,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   930,     0,     0,     0,     0,     0, -1017,     0,
    3883,     0,     0,     0,     0,     0,  1112,     0,  2026,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3885,
       0,     0,     0,     0,     0,     0,  3886,     0,     0,     0,
       0,     0,  3896,     0,     0,     0,     0,     0,     0,     0,
       0,  3887,  3897,     0,     0,     0,     0,     0,     0,  3888,
       0,     0,     0,     0,     0,     0,     0,   172,   173,     0,
       0,     0,  3868,     0,  3892,     0,     0,     0,     0,     0,
    1112,     0,     0,     0,     0,     0,     0,     0,     0,  3898,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1112,  3899,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     1,     2,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3812,     0,
       0,     0,  3896,     0,     3,     0,     4,     0,     5,     0,
       6,     0,  3897,  3901,     0,     0,     0,     0,     7,  3902,
    3872,     0,     0,     0,  3812,  3812,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       8,     0,     9,    10,     0,     0,     0,     0,  3930,  3898,
      11,     0,     0,     0,     0,     0,     0,    12,     0,   930,
    1112,     0,  3899,     0,     0,     0,     0,     0,     0,     0,
      13,     0,     0,     0,     0,     0,    14,     0,  3907,     0,
       0,  3875,  3876,  3877,     0,  3908,     0,     0,     0,    15,
    3812,  3812,     0,     0,     0,     0,     0,    16,     0,     0,
       0,     0,     0,  3901,  3878,     0,     0,     0,    17,  3902,
       0,     0,     0,     0,     0,     0,  3909,     0,     0,     0,
       0,    18,     0,    19,     0,     0,     0,     0,    20,  3879,
       0,  3910,  3911,     0,     0,     0,     0,     0,     0,   930,
       0,     0,     0,     0,  3912,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    21,     0,
       0,  3881,     0,  3882,     0,     0,     0,     0,  3907,     0,
       0,     0,    22,    23,     0,  3908,     0,     0,     0,  1112,
       0,     0,  3883,    24,    25,     0,     0,     0,   930,  1112,
       0,     0,  1112,     0,     0,    26,    27,    28,     0,    29,
       0,  3885,     0,     0,    30,     0,  3909,  4740,  3886,     0,
      31,     0,     0,     0,    32,     0,  1112,  1112,    33,    34,
       0,  3910,  3911,  3887,     0,     0,     0,     0,     0,     0,
       0,  3888,     0,     0,  3912,     0,     0,     0,     0,     0,
       0,  1112,     0,  1112,     0,  1112,  3892,  1112,     0,     0,
       0,     0,     0,     0,     0,     0,    35, -1017,    36, -1017,
      37,     0,     0,     0,     0,    38,  1112,     0,     0,     0,
       0,     0,     0,     0,     0,    39,    40,     0,     0,     0,
       0,     0,     0,    41,     0,     0,  2026,  1112,  1112,     0,
       0,     0,     0,    42,  1112,     0,  1112,     0,  1112,     0,
       0,     0,     0,  1112,  3896,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3897,    43,    44,     0,    45,     0,
       0,     0,     0,     0,     0,    46,     0,     0,     0,     0,
       0,     0,    47,     0,     0,   172,   173,     0,     0,     0,
    3868,     0,     0,     0,     0,     0,     0,     0,  1112,  1112,
       0,  3898,     0,    48,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1112,  3899,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    49,     0,
       0,     0,     0,     0,  1112,     0,     0,     0,    50,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3901,     0,    51,     0,     0,
       0,  3902,     0,     0,     0,     0,     0,     0,  3872,     0,
       0,    52,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    53,     0,     0,    54,     0,     0,
      55,  3930,  3930,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    56,     0,     0,     0,     0,
       0,     0,     0,  1112,     0,     0,     0,     0,     0,     0,
    3907,     0,     0,  1112,     0,     0,     0,  3908,     0,  3875,
    3876,  3877,     0,     0,     0,  1112,     0,  1112,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3878,     0,     0,     0,     0,     0,  3909,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3910,  3911,     0,     0,  3879,     0,     0,
       0,     0,     0,     0,     0,     0,  3912,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3881,
       0,  3882,     0,  4880,     0,  3862,     0,     0,     0,     0,
       0,     0,    57,     0,     0,     0,     0,     0, -1017,     0,
    3883,     0,     0,     0,     0,     0,     0,     0,     0,  3864,
       0,     0,     0,     0,     0,     0,     0,  3866,     0,  3885,
       0,    58,     0,     0,    59,     0,  3886,     0,  3930,     0,
       0,     0,     0,     0,    60,     0,     0,     0,     0,  2026,
       0,  3887,    61,     0,     0,     0,     0,     0,     0,  3888,
       0,  4881,     0,     0,    62,   930,     0,     0,     0,     0,
       0,     0,     0,     0,  3892,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    63,     0,     0,    64,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
    3812,     0,     0,  3868,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1112,     0,    65,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    66,
       0,     0,  3896,     0,  3869,     0,     0,     0,     0,     0,
       0,     0,  3897,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    67,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1114,     0,     0,  3871,     0,     0,    68,     0,     0,  3898,
       0,  3872,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3899,     0,     0,     0,     0,  1114,     0,     0,
       0,     0,     1,     2,     0,     0,     0,  3874,     0,     0,
       0,     0,     0,   930,   930,     0,  1114,     0,     0,     0,
       0,     0,     3,     0,     4,     0,     5,     0,     6,     0,
       0,     0,     0,  3901,     0,     0,     7,     0,     0,  3902,
       0,     0,  3875,  3876,  3877,     0,     0,     0,  1112,  1112,
       0,  1112,     0,     0,     0,     0,     0,     0,     8,     0,
       9,    10,  1112,  1112,  1112,  3878,     0,     0,    11,     0,
       0,     0,     0,     0,     0,     0,     0,  1112,     0,  1112,
       0,     0,     0,     0,     0,     0,     0,     0,    13,     0,
    3879,     0,  1112,  1112,    14,     0,     0,     0,  3907,     0,
       0,     0,     0,     0,     0,  3908,     0,    15,     0,     0,
       0,     0,     0,     0,  3880,    16,     0,     0,     0,  1112,
       0,     0,  3881,     0,  3882,     0,    17,     0,     0,     0,
       0,  1112,     0,     0,     0,  1114,  3909,     0,     0,    18,
    1112,    19,     0,  3883,     0,     0,    20,     0,     0,     0,
       0,  3910,  3911,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3885,     0,  3912,     0,     0,     0,     0,  3886,
       0,  1176,     0,     0,     0,     0,    21,     0,     0,     0,
       0,     0,     0,  1112,  3887,     0,     0,  1112,     0,     0,
      22,    23,  3888,     0,     0,     0,  3889,     0,     0,     0,
       0,    24,    25,  3891,  1114,     0,     0,  3892,     0,     0,
       0,     0,     0,    26,    27,    28,     0,    29,     0,     0,
       0,     0,    30,     0,     0,     0,     0,     0,    31,     0,
       0,     0,    32,     0,     0,  3894,    33,    34,     0,     0,
       0,     0,     0,     0,     0,  3930,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1114,     0,     0,
       0,     0,  1114,     0,     0,  3896,     0,     0,     0,     0,
       0,     0,     0,     0,    35,  3897,    36,     0,    37,     0,
       0,     0,     0,    38,     0,     0,     0,     0,     0,     0,
       0,     0,  1114,    39,    40,  1584,     0,     0,     0,     0,
       0,    41,  1114,     0,     0,     0,     0,     0,     0,     0,
       0,    42,  3898,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3899,     0,  3900,     0,     0,
       0,     0,     0,    43,    44,     0,    45,     0,     0,     0,
    1584,     0,     0,    46,     0,     0,     0,     0,     0,     0,
      47,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3901,     0,     0,     0,
       0,    48,  3902,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3930,  1114,
    1114,  1114,  1114,     0,     0,  1584,    49,     0,     0,     0,
       0,  1112,  1112,  1114,     0,     0,    50,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    51,     0,     0,     0,     0,
       0,  3907,     0,     0,     0,     0,     0,     0,  3908,    52,
       0,     0,     0,     0,     0,   930,     0,     0,     0,     0,
       0,     0,    53,     0,     0,    54,     0,     0,    55,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3909,
       0,     0,     0,    56,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3910,  3911,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3912,     0,     0,
       0,     0,     0,     0,     0,     0,  3474,     0,     0,  1112,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   930,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1112,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1114,     0,     0,     0,
    1584,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      57,     0,     0,     0,  1112,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1112,  1112,     0,     0,     0,     0,     0,    58,
       0,     0,    59,     0,     0,     0,     0,     0,     0,     0,
    1112,     0,    60,     0,     0,     0,     0,     0,     0,     0,
      61,     0,     0,  1112,     0,     0,     0,     0,     0,     0,
       0,     0,    62,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3930,     0,  3930,     0,     0,     0,     0,     0,
       0,     0,    63,     0,     0,    64,  1584,  1112,     0,  1112,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    65,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    66,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    67,     0,     0,     0,     0,  1114,     0,  1114,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    68,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3474,     0,     0,     0,     0,     0,     0,
    1114,     0,  1114,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   930,     0,     0,     0,     0,     0,     0,
    1112,     0,     0,     0,     0,     0,     0,     0,  1114,     0,
       0,   930,     0,     0,     0,     0,     0,     0,     0,  1114,
    1114,     0,     0,     0,     0,  1114,     0,     0,     0,  1114,
    1114,  1114,     0,     0,     0,     0,     0,     0,     0,     0,
    1114,  1114,  1584,     0,     0,  3474,  1114,     0,  1114,  1114,
    1114,  1114,  1114,     0,  1114,     0,     0,  1584,  1584,     0,
       0,     0,     0,     0,     0,  1114,     0,  1114,     0,     0,
    1114,  1114,     0,  1114,  1114,  1114,     0,  1114,  1114,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1112,     0,  1114,  1114,  1114,  1114,  1114,     0,  1114,  1114,
    1114,     0,     0,  1114,  1114,  1114,  1114,  1114,  1114,  1114,
       0,  1114,  1114,  1114,  1114,  1112,  1114,  1114,     0,  1114,
    1114,  1114,  1114,  1114,  1114,  1114,     0,     0,  1114,  1114,
    1114,  1114,     0,  1114,  1114,  1114,     0,  1114,     0,  1114,
       0,  1114,     0,     0,     0,  1114,  1114,  1114,     0,     0,
    1114,  1114,  1114,  1114,  1114,     0,  1114,     0,     0,     0,
       0,     0,     0,  1114,     0,     0,     0,     0,     0,   930,
    1114,  1114,  1114,  1114,     0,     0,     0,     0,     0,     0,
       0,  1114,  1114,     0,  1114,  1114,     0,     0,  1114,  1114,
    1114,  1114,  1114,  1114,  1114,  1114,  1114,  1114,  1114,  1114,
    1114,     0,     0,  1114,     0,     0,     0,     0,  1584,     0,
    1112,     0,     0,     0,     0,  1584,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1114,     0,     0,     0,     0,  1114,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1114,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4017,  4018,     0,     0,     0,     0,  4019,
    4020,     0,   930,     0,     0,     0,     0,     0,     0,  4021,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   930,     0,     0,  4022,  1114,     0,     0,     0,
       0,     0,  1112,     0,     0,     0,     0,  4023,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1114,  4024,  1114,  1112,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1584,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4025,  1114,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4026,  4027,     0,  4028,     0,     0,
       0,     0,     0,     0,     0,  4029,  4030,  4031,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5497,  4032,     0,     0,  5497,     0,
       0,     0,   930,     0,     0,     0,     0,     0,     0,  1112,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1114,   930,     0,     0,     0,
    4033,     0,     0,     0,  1584,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4034,     0,     0,     0,     0,     0,
    4035,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4036,  4037,  4038,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5598,     0,     0,     0,  4039,  4040,
       0,  4017,  4018,     0,     0,     0,     0,  4019,  4020,     0,
       0,     0,  5497,     0,     0,     0,     0,  4021,     0,     0,
       0,     0,  5598,     0,     0,     0,     0,     0,     0,     0,
    5497,     0,     0,     0,  1112,     0,     0,     0,     0,     0,
       0,     0,     0,  4022,     0,     0,     0,     0,     0,  4041,
       0,  4042,  4043,     0,     0,  4023,     0,     0,     0,     0,
       0,     0,     0,     0,  1114,     0,     0,  4044,     0,     0,
       0,     0,     0,     0,     0,  4024,     0,     0,     0,     0,
       0,     0,  1114,  5670,     0,     0,  5670,     0,     0,     0,
       0,     0,     0,   930,     0,     0,     0,     0,     0,     0,
    1114,     0,     0,  1114,  4045,     0,  4046,     0,     0,  4025,
       0,  1114,  1114,  1112,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4047,     0,     0,
       0,     0,  4026,  4027,     0,  4028,     0,     0,     0,     0,
       0,     0,     0,  4029,  4030,  4031,  5497,     0,  1112,     0,
    4048,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4049,  4050,  4032,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1584,  1584,     0,     0,     0,
       0,     0,     0,     0,  5670,     0,     0,     0,     0,  5670,
       0,     0,     0,  4051,     0,     0,  5670,     0,  4033,     0,
       0,     0,  4052,     0,     0,  1114,  1114,  1114,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1584,
       0,     0,  4034,     0,     0,     0,     0,     0,  4035,     0,
       0,     0,  5497,     0,     0,     0,  1112,     0,     0,     0,
       0,     0,     0,  1112,     0,     0,     0,     0,  4053,  4054,
    4055,     0,  4036,  4037,  4038,     0,  4056,  4057,     0,     0,
       0,     0,  5670,     0,     0,     0,  5802,     0,     0,     0,
    1584,     0,     0,  4058,  4059,     0,  4039,  4040,     0,     0,
       0,  1114,     0,     0,  1584,     0,     0,  5670,     0,  5670,
    5670,     0,     0,     0,     0,     0,     0,  4060,  4061,     0,
       0,     0,  1114,     0,     0,     0,  1114,  1114,     0,  1114,
    1114,     0,     0,     0,     0,     0,  4062,     0,  1114,     0,
    1114,     0,     0,     0,     0,     0,     0,  4041,     0,  4042,
    4043,     0,     0,     0,     0,     0,     0,     0,  5670,     0,
       0,  5670,     0,     0,     0,  4044,     0,     0,  4063,     0,
       0,  1114,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1112,     0,  1114,     0,     0,     0,     0,
       0,     0,  5670,     0,     0,     0,     0,     0,  1114,     0,
       0,  1114,  4045,     0,  4046,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1114,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4047,     0,     0,  4064,     0,
    1114,  4065,     0,     0,  4066,     0,   930,     0,     0,     0,
       0,  4067,     0,     0,     0,     0,     0,     0,  4048,  1112,
       0,     0,  1114,     0,     0,     0,     0,  4068,     0,  4049,
    4050,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4069,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4051,     0,  1114,     0,     0,     0,     0,     0,     0,
    4052,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1584,
       0,  1584,     0,     0,     0,     0,  4053,  4054,  4055,     0,
       0,     0,     0,     0,  4056,  4057,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4058,  4059,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4060,  4061,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4062,     0,     0,     0,     0,  1114,
       0,     0,     0,     0,     0,     0,  1584,     0,     0,  1584,
    1584,  1584,     0,  1114,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5310,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1114,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4064,     0,     0,  4065,
       0,     0,  4066,     0,     0,     0,     0,     0,     0,  5311,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4068,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4069,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1114,     0,     0,
    1114,     0,     0,     0,     0,  1080,     0,     0,     0,  1114,
       0,     0,     0,     0,     0,     0,     0,     0,  1114,     0,
    1114,     0,  1114,     0,  1114,  1114,  1114,  1114,  1114,  1114,
       0,  1114,  1241,     0,     0,     0,     0,     0,     0,  1114,
       0,  1114,     0,     0,  1114,  1114,  1114,     0,     0,     0,
       0,     0,     0,  1114,  1114,  1114,     0,  1114,     0,  1114,
       0,  1114,     0,  1114,     0,  1114,     0,     0,     0,     0,
       0,     0,     0,  1114,     0,  1114,     0,  1114,  1114,  1114,
    1114,  1114,     0,     0,  1114,     0,  1114,     0,     0,  1114,
       0,     0,  4017,  4018,     0,     0,     0,     0,  4019,  4020,
       0,     0,  1114,     0,     0,     0,     0,  1114,  4021,     0,
    1114,     0,  1114,  1114,  1114,     0,     0,  1114,     0,     0,
       0,     0,     0,  1114,     0,     0,     0,     0,  1114,     0,
       0,     0,     0,     0,  4022,     0,     0,  1114,     0,     0,
       0,     0,     0,  1114,     0,  1114,  4023,     0,  1114,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1114,  1114,
    1114,  1114,  1584,  1114,     0,     0,  4024,     0,  1114,     0,
    1433,     0,     0,     0,     0,     0,     0,     0,     0,  1584,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4025,     0,     0,     0,  1114,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4026,  4027,     0,  4028,     0,     0,     0,
       0,     0,     0,  1114,  4029,  4030,  4031,     0,     0,  1497,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4032,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1114,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4033,
       0,     0,     0,  1114,     0,     0,     0,  1547,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4034,     0,     0,     0,     0,     0,  4035,
       0,     0,     0,     0,     0,     0,     0,  1574,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1589,     0,     0,
       0,     0,     0,  4036,  4037,  4038,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1114,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4039,  4040,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1114,     0,
       0,     0,     0,     0,     0,  1584,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4041,     0,
    4042,  4043,     0,     0,     0,     0,     0,  1682,     0,     0,
       0,     0,     0,     0,     0,     0,  4044,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1114,     0,     0,
       0,     0,     0,  4045,     0,  4046,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4047,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4048,
    1584,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4049,  4050,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4051,     0,     0,     0,     0,     0,     0,     0,
       0,  4052,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1114,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1114,     0,     0,  1114,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1878,     0,     0,     0,     0,     0,  4053,  4054,  4055,
       0,     0,     0,  1114,  1114,  4056,  4057,     0,     0,     0,
       0,     0,     0,     0,     0,  1584,     0,     0,     0,     0,
       0,     0,  4058,  4059,     0,     0,     0,     0,  1114,     0,
    1114,     0,  1114,     0,  1114,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4060,  4061,     0,     0,
       0,     0,     0,  1114,     0,     0,     0,     0,     0,  1584,
       0,     0,     0,     0,     0,  4062,     0,     0,     0,     0,
       0,     0,     0,     0,  1114,  1114,     0,     0,     0,     0,
       0,  1114,     0,  1114,  1190,  1114,     0,     0,     0,     0,
    1114,     0,     0,     0,     0,   653,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1163,     0,     0,     0,     0,     0,     0,     0,  1191,  1192,
       0,     0,     0,     0,     0,     0,     0,     0,  1193,     0,
       0,     0,     0,     0,  1584,  1114,  1114,     0,     0,     0,
       0,     0,     0,     9,    10,     0,     0,     0,     0,     0,
    1114,     0,     0,     0,     0,     0,     0,  4064,     0,     0,
    4065,     0,  2066,  4066,  2067,     0,     0,     0,     0,     0,
       0,  1114,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4068,     0,   172,   173,
       0,     0,     0,  1194,     0,     0,     0,     0,  1584,     0,
       0,     0,     0,     0,     0,  4069,     0,  1195,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2147,     0,  2147,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1114,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1114,     0,     0,  2176,     0,     0,     0,     0,     0,     0,
       0,     0,  1114,     0,  1114,     0,     0,     0,     0,     0,
    2190,     0,     0,  1196,  2195,     0,  2197,     0,     0,     0,
       0,     0,     0,     0,     0,  2213,  2214,     0,     0,     0,
       0,  2243,     0,  2246,  2247,  2248,  2249,  2250,     0,  2252,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2260,     0,  2263,     0,     0,  2264,  2265,     0,  2267,  2268,
       0,     0,  2271,  2272,     0,     0,     0,     0,     0,     0,
       0,  1197,     0,     0,     0,     0,     0,  2281,  2282,  2289,
    2293,  2294,     0,  2297,     0,  2299,     0,     0,  2301,  2302,
    2303,  2306,  2307,  2308,  2309,     0,  2310,  2311,  2312,     0,
       0,  2319,  2320,     0,     0,  2324,  2325,  2326,     0,     0,
       0,     0,     0,  2332,  2333,  2334,     0,     0,  2337,  2338,
    2339,  1198,  2341,     0,  2343,     0,  2344,     0,     0,     0,
    2347,  2289,  2349,     0,     0,  2355,  2356,  2357,  2358,  2359,
    1199,  2360,     0,     0,     0,     0,     0,     0,  2364,  1200,
       0,     0,     0,     0,     0,  2369,  2370,  2371,     0,     0,
       0,  1201,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1202,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1203,     0,     0,     0,
       0,     0,     0,     0,  1114,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0, -2328,  1204,     0,  2469,
    1205,     0,  1206,     0,  2479,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2479,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1207,  1208,
       0,     0,     0,     0,     0,     0,  1209,  1210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1211,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1212,     0,     0,     0,     0,
       0,  2547,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1213,     0,     0,     0,
       0,     0,     0,     0,     0,  1114,  1114,     0,  1114,     0,
       0,  2580,     0,  2585,     0,     0,     0,     0,     0,  1114,
    1114,  1114,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1114,     0,  1114,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2608,     0,  1114,
    1114,     0,  1214,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1215,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1114,  1216,     0,     0,
    1217,  1218,     0,     0,     0,     0,     0,     0,  1114,     0,
       0,     0,     0,     0,     0,  1219,     0,  1114,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2679,  1220,     0,     0,     0,     0,     0,     0,  1221,     0,
    1114,     0,     0,     0,  1114,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -3093,     0,  1222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -3093,
       0,     0,     0,     0,     0,  1223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2849,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2877,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1241,     0,     0,  2896,     0,
       0,     0,     0,     0,     0,     0,  2903,  2904,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1114,  1114,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2959,  2961,  2963,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1114,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1114,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3045,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3053,     0,  3054,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1114,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3079,     0,  1584,  1114,
    1114,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3085,     0,     0,     0,     0,     0,     0,  1114,     0,     0,
       0,     0,     0,  3096,     0,     0,  2479,     0,     0,     0,
    1114,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3133,     0,     0,     0,     0,
       0,     0,     0,     0,  1114,     0,  1114,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3143,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2585,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1114,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3276,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3276,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1584,  3366,     0,  1114,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1114,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1114,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3498,     0,     0,  3499,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3526,     0,     0,     0,  3528,     0,  3529,
    3530,  3531,  3532,  3533,  3534,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3539,     0,  3540,     0,     0,  3541,
    3542,  3543,     0,     0,     0,     0,     0,     0,  3545,  3546,
    3547,     0,  3548,     0,  3550,     0,  3552,     0,  3554,     0,
    3556,     0,     0,     0,     0,     0,     0,     0,  2303,     0,
    3559,     0,  2303,     0,  3562,  3563,  3564,     0,     0,  3565,
       0,  3566,     0,     0,  3567,     0,     0,     0,     0,  1114,
       0,     0,     0,     0,     0,     0,     0,  3568,     0,     0,
       0,     0,     0,     0,     0,  3575,     0,  3576,  3577,  3578,
       0,     0,  3579,     0,     0,     0,  1114,     0,  3583,     0,
       0,     0,     0,  3594,     0,     0,     0,     0,     0,     0,
       0,     0,  3598,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3605,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3616,  3619,     0,     0,  3624,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2479,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1114,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2479,     0,
       0,     0,     0,     0,     0,     0,  1584,  1584,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2585,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2585,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1584,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1584,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1114,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3786,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1114,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3944,     0,     0,  1114,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1114,     0,     0,     0,     0,     0,     0,
    1114,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4089,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4093,     0,     0,  4094,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4119,  4120,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4143,     0,  4144,     0,  4145,     0,  4146,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4167,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1114,     0,     0,     0,     0,     0,     0,     0,     0,  4190,
    4191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3276,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1114,     0,     0,     0,
    2479,  2479,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2479,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2585,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4347,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3276,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3276,     0,  4359,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4515,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4619,  4620,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4627,  4628,  4629,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4649,
       0,  4650,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4656,  4657,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4678,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2585,     0,     0,     0,  2585,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4898,  4899,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4974,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3276,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3276,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2479,  2479,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2585,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2585,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5102,
       0,  5104,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5255,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3276,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5335,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3276,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2475,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2476,   939,   940,   941,   942,     0,
       0,     0,     0,     0,     0,     0,   943,   944,     0,   945,
       0,     0,     0,     0,     0,     0,   946,   947,     0,     0,
     948,   949,   950,   951,     0,   952,   953,     0,   954,   955,
       0,     0,     0,     0,   956,     0,     0,     0,  2477,     0,
       0,   958,     0,     0,     0,     0,  5625,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   959,   960,   961,     0,   962,   963,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   964,   965,
     966,     0,   967,   968,     0,     0,     0,   969,   970,   971,
       0,     0,     0,     0,     0,     0,     0,   972,     0,   973,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1682,   975,     0,     0,     0,
       0,   976,   977,     0,   978,     0,     0,     0,     0,     0,
     979,     0,   980,     0,     0,   981,     0,     0,   982,   983,
     984,     0,   985,   986,   987,     0,   988,  2478,     0,     0,
    5711,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   989,     0,     0,     0,   990,   991,   992,     0,   993,
       0,     0,     0,     0,     0,     0,   994,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   995,     0,     0,
       0,     0,     0,     0,     0,   996,     0,     0,   997,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   998,     0,
       0,     0,     0,     0,   999,  1000,     0,  1001,  1002,     0,
       0,     0,  1003,     0,     0,     0,     0,     0,  2585,     0,
    1004,  1005,  1006,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1007,  1008,  1009,     0,     0,     0,     0,     0,
    1010,     0,  1011,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,   175,   176,   177,   178,   179,
     180,   181,   182,  1012,  1013,  1014,   183,   184,   185,  1015,
     187,   188,   189,   190,   191,   192,  1016,   194,   195,   196,
     197,   198,   199,   200,  1017,   202,   203,     0,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
    1018,   217,   218,   219,   220,   221,   222,   223,   224,  1019,
     226,  1020,  1021,   228,  1022,  1023,  1024,  1025,  1026,     0,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,  1027,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1028,  1029,  1030,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,     0,  1031,   306,   307,   308,   309,
     310,  1032,   312,  1033,   314,   315,   316,   317,   318,   319,
     320,  2585,   321,   322,   323,  1034,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,  1035,  1036,   348,
     349,   350,  1037,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
    1038,   390,  1039,   392,   393,   394,   395,  1040,  1041,  1042,
    1043,   400,   401,   402,   403,   404,   405,   406,   407,   408,
    1044,  1045,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,  1046,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,  1047,   441,   442,   443,   444,   445,  1048,  1049,   448,
     449,   450,   451,   452,   453,  1050,   455,   456,   457,   458,
     459,   460,  1051,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,  1052,   492,   493,   494,   495,   496,  1053,  1054,
     499,   500,   501,   502,   503,  1055,   505,   506,   507,   508,
     509,   510,  1056,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,     0,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,  1057,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,  1058,  1059,  1060,  1061,   563,   564,   565,  1062,  1063,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,  1064,   582,  1065,   584,   585,   586,   587,
     588,   589,   590,   591,   592,  1066,  1067,   595,  1068,   597,
     598,   599,     0,   600,   601,   602,  1069,     0,     0,     0,
       0,     0,     0,     0,     0,  1070,  1071,     0,     0,     0,
       0,  1072,     0,     0,     0,  2378,  1073,     0,     0,     0,
    1074,  1075,     0,     0,  1076,  1077,   938,   939,   940,   941,
     942,     0,     0,     0,     0,     0,     0,     0,   943,   944,
       0,   945,     0,     0,     0,     0,     0,     0,   946,   947,
       0,     0,   948,   949,   950,   951,     0,   952,   953,     0,
     954,   955,     0,     0,     0,     0,   956,     0,     0,     0,
     957,     0,     0,   958,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   959,   960,   961,     0,   962,   963,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     964,   965,   966,     0,   967,   968,     0,     0,     0,   969,
     970,   971,     0,     0,     0,     0,     0,     0,     0,   972,
       0,   973,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   974,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   975,     0,
       0,     0,     0,   976,   977,     0,   978,     0,     0,     0,
       0,     0,   979,     0,   980,     0,     0,   981,     0,     0,
     982,     0,   984,     0,   985,   986,   987,     0,   988,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   989,     0,     0,     0,   990,   991,   992,
       0,   993,     0,     0,     0,     0,     0,     0,   994,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   995,
       0,     0,     0,     0,     0,     0,     0,   996,     0,     0,
     997,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     998,     0,     0,     0,     0,     0,   999,  1000,     0,  1001,
    1002,     0,     0,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1007,  1008,  1009,     0,     0,     0,
       0,     0,  1010,     0,  1011,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   174,   175,   176,   177,
     178,   179,   180,   181,   182,  1012,  1013,  1014,   183,   184,
     185,  1015,   187,   188,   189,   190,   191,  2379,  1016,   194,
     195,   196,   197,   198,   199,   200,  1017,   202,   203,     0,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,  1018,   217,   218,   219,   220,   221,   222,   223,
     224,  1019,   226,  1020,  1021,   228,  1022,  1023,  1024,  1025,
    1026,     0,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,  1027,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1028,  1029,  1030,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,     0,  1031,   306,   307,
     308,   309,   310,  1032,   312,  1033,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,  1034,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,  1035,
    1036,   348,   349,   350,  1037,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,  1038,   390,  1039,   392,   393,   394,   395,  1040,
    1041,  1042,  1043,   400,   401,   402,   403,   404,   405,   406,
     407,   408,  1044,  1045,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1046,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,  1047,   441,   442,   443,   444,   445,  1048,
    1049,   448,   449,   450,   451,   452,   453,  1050,   455,   456,
     457,   458,   459,   460,  1051,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,  1052,   492,   493,   494,   495,   496,
    1053,  1054,   499,   500,   501,   502,   503,  1055,   505,   506,
     507,   508,   509,   510,  1056,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,     0,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,  1057,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,  1058,  1059,  1060,  1061,   563,   564,   565,
    1062,  1063,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,  1064,   582,  1065,   584,   585,
     586,   587,   588,   589,   590,   591,   592,  1066,  1067,   595,
    1068,   597,   598,   599,     0,   600,   601,   602,  1069,     0,
       0,     0,   938,   939,   940,   941,   942,  1070,  1071,     0,
       0,     0,     0,  1072,   943,   944,     0,   945,  1073,     0,
       0,     0,  1074,  1075,   946,   947,  1076,  1077,   948,   949,
     950,   951,     0,   952,   953,     0,   954,   955,     0,     0,
       0,     0,   956,     0,     0,     0,   957,     0,     0,   958,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   959,
     960,   961,     0,   962,   963,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   964,   965,   966,     0,
     967,   968,     0,     0,     0,   969,   970,   971,     0,     0,
       0,     0,     0,     0,     0,   972,     0,   973,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     974,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,   976,
     977,     0,   978,     0,     0,     0,     0,     0,   979,     0,
     980,     0,     0,   981,     0,     0,   982,   983,   984,     0,
     985,   986,   987,     0,   988,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   989,
       0,     0,     0,   990,   991,   992,     0,   993,     0,     0,
       0,     0,     0,     0,   994,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   995,     0,     0,     0,     0,
       0,     0,     0,   996,     0,     0,   997,     0,    31,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   998,     0,     0,     0,
       0,     0,   999,  1000,     0,  1001,  1002,     0,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,  1004,  1005,
    1006,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1007,  1008,  1009,    38,     0,     0,     0,     0,  1010,     0,
    1011,     0,     0,     0,    40,     0,     0,     0,     0,     0,
       0,     0,   174,   175,   176,   177,   178,   179,   180,   181,
     182,  1012,  1013,  1014,   183,   184,   185,  1015,   187,   188,
     189,   190,   191,   192,  1016,   194,   195,   196,   197,   198,
     199,   200,  1017,   202,   203,     0,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,  1018,   217,
     218,   219,   220,   221,   222,   223,   224,  1019,   226,  1020,
    1021,   228,  1022,  1023,  1024,  1025,  1026,     0,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,  1027,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1028,  1029,  1030,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,     0,  1031,   306,   307,   308,   309,   310,  1032,
     312,  1033,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,  1034,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,  1035,  1036,   348,   349,   350,
    1037,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,  1038,   390,
    1039,   392,   393,   394,   395,  1040,  1041,  1042,  1043,   400,
     401,   402,   403,   404,   405,   406,   407,   408,  1044,  1045,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,  1046,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,  1047,
     441,   442,   443,   444,   445,  1048,  1049,   448,   449,   450,
     451,   452,   453,  1050,   455,   456,   457,   458,   459,   460,
    1051,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
    1052,   492,   493,   494,   495,   496,  1053,  1054,   499,   500,
     501,   502,   503,  1055,   505,   506,   507,   508,   509,   510,
    1056,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,     0,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
    1057,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,  1058,
    1059,  1060,  1061,   563,   564,   565,  1062,  1063,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,  1064,   582,  1065,   584,   585,   586,   587,   588,   589,
     590,   591,   592,  1066,  1067,   595,  1068,   597,   598,   599,
       0,   600,   601,   602,  1069,     0,     0,     0,   938,   939,
     940,   941,   942,  1070,  1071,     0,  2286,     0,     0,  1072,
     943,   944,     0,   945,  1073,     0,     0,     0,  1074,  1075,
     946,   947,  1076,  1077,   948,   949,   950,   951,     0,   952,
     953,     0,   954,   955,     0,     0,     0,     0,   956,     0,
       0,     0,   957,     0,     0,   958,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   959,   960,   961,     0,   962,
     963,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   964,   965,   966,     0,   967,   968,     0,     0,
       0,   969,   970,   971,     0,     0,     0,     0,     0,     0,
       0,   972,     0,   973,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2287,     0,   974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     975,     0,     0,     0,     0,   976,   977,     0,   978,     0,
       0,     0,     0,     0,   979,     0,   980,     0,     0,   981,
       0,     0,   982,   983,   984,     0,   985,   986,   987,     0,
     988,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   989,     0,     0,     0,   990,
     991,   992,     0,   993,     0,     0,     0,     0,     0,     0,
     994,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   995,     0,     0,     0,     0,     0,     0,     0,   996,
       0,     0,   997,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   998,     0,     0,     0,     0,     0,   999,  1000,
       0,  1001,  1002,     0,     0,     0,  1003,     0,     0,     0,
       0,     0,  2288,     0,  1004,  1005,  1006,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1007,  1008,  1009,     0,
       0,     0,     0,     0,  1010,     0,  1011,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,  1012,  1013,  1014,
     183,   184,   185,  1015,   187,   188,   189,   190,   191,   192,
    1016,   194,   195,   196,   197,   198,   199,   200,  1017,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,  1018,   217,   218,   219,   220,   221,
     222,   223,   224,  1019,   226,  1020,  1021,   228,  1022,  1023,
    1024,  1025,  1026,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,  1027,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1028,
    1029,  1030,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,     0,  1031,
     306,   307,   308,   309,   310,  1032,   312,  1033,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,  1034,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,  1035,  1036,   348,   349,   350,  1037,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,  1038,   390,  1039,   392,   393,   394,
     395,  1040,  1041,  1042,  1043,   400,   401,   402,   403,   404,
     405,   406,   407,   408,  1044,  1045,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,  1046,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,  1047,   441,   442,   443,   444,
     445,  1048,  1049,   448,   449,   450,   451,   452,   453,  1050,
     455,   456,   457,   458,   459,   460,  1051,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,  1052,   492,   493,   494,
     495,   496,  1053,  1054,   499,   500,   501,   502,   503,  1055,
     505,   506,   507,   508,   509,   510,  1056,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,     0,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,  1057,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,  1058,  1059,  1060,  1061,   563,
     564,   565,  1062,  1063,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,  1064,   582,  1065,
     584,   585,   586,   587,   588,   589,   590,   591,   592,  1066,
    1067,   595,  1068,   597,   598,   599,     0,   600,   601,   602,
    1069,     0,     0,     0,   938,   939,   940,   941,   942,  1070,
    1071,     0,     0,     0,     0,  1072,   943,   944,     0,   945,
    1073,     0,     0,     0,  1074,  1075,   946,   947,  1076,  1077,
     948,   949,   950,   951,     0,   952,   953,     0,   954,   955,
       0,     0,     0,     0,   956,     0,     0,     0,   957,     0,
       0,   958,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   959,   960,   961,     0,   962,   963,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   964,   965,
     966,     0,   967,   968,     0,     0,     0,   969,   970,   971,
       0,     0,     0,     0,     0,     0,     0,   972,     0,   973,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   975,     0,     0,     0,
       0,   976,   977,     0,   978,     0,     0,     0,     0,     0,
     979,     0,   980,     0,     0,   981,     0,     0,   982,   983,
     984,     0,   985,   986,   987,     0,   988,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   989,     0,     0,     0,   990,   991,   992,     0,   993,
       0,     0,     0,     0,     0,     0,   994,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   995,     0,     0,
       0,     0,     0,     0,     0,   996,     0,     0,   997,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   998,     0,
       0,     0,     0,     0,   999,  1000,     0,  1001,  1002,     0,
       0,     0,  1003,     0,     0,     0,     0,     0,     0,     0,
    1004,  1005,  1006,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1007,  1008,  1009,     0,     0,     0,     0,     0,
    1010,     0,  1011,  1546,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,   175,   176,   177,   178,   179,
     180,   181,   182,  1012,  1013,  1014,   183,   184,   185,  1015,
     187,   188,   189,   190,   191,   192,  1016,   194,   195,   196,
     197,   198,   199,   200,  1017,   202,   203,     0,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
    1018,   217,   218,   219,   220,   221,   222,   223,   224,  1019,
     226,  1020,  1021,   228,  1022,  1023,  1024,  1025,  1026,     0,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,  1027,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1028,  1029,  1030,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,     0,  1031,   306,   307,   308,   309,
     310,  1032,   312,  1033,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,  1034,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,  1035,  1036,   348,
     349,   350,  1037,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
    1038,   390,  1039,   392,   393,   394,   395,  1040,  1041,  1042,
    1043,   400,   401,   402,   403,   404,   405,   406,   407,   408,
    1044,  1045,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,  1046,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,  1047,   441,   442,   443,   444,   445,  1048,  1049,   448,
     449,   450,   451,   452,   453,  1050,   455,   456,   457,   458,
     459,   460,  1051,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,  1052,   492,   493,   494,   495,   496,  1053,  1054,
     499,   500,   501,   502,   503,  1055,   505,   506,   507,   508,
     509,   510,  1056,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,     0,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,  1057,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,  1058,  1059,  1060,  1061,   563,   564,   565,  1062,  1063,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,  1064,   582,  1065,   584,   585,   586,   587,
     588,   589,   590,   591,   592,  1066,  1067,   595,  1068,   597,
     598,   599,     0,   600,   601,   602,  1069,     0,     0,     0,
     938,   939,   940,   941,   942,  1070,  1071,     0,     0,     0,
       0,  1072,   943,   944,     0,   945,  1073,     0,     0,     0,
    1074,  1075,   946,   947,  1076,  1077,   948,   949,   950,   951,
       0,   952,   953,     0,   954,   955,     0,     0,     0,     0,
     956,     0,     0,     0,  2582,     0,     0,   958,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   959,   960,   961,
       0,   962,   963,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   964,   965,   966,     0,   967,   968,
       0,     0,     0,   969,   970,   971,     0,  2583,     0,     0,
       0,     0,     0,   972,     0,   973,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   974,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   975,     0,     0,     0,     0,   976,   977,     0,
     978,     0,     0,     0,     0,     0,   979,     0,   980,     0,
       0,   981,     0,     0,   982,   983,   984,     0,   985,   986,
     987,     0,   988,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   989,     0,     0,
       0,   990,   991,   992,     0,   993,     0,     0,     0,     0,
       0,     0,   994,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   995,     0,     0,     0,     0,     0,     0,
       0,   996,     0,     0,   997,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   998,     0,     0,     0,     0,     0,
     999,  1000,     0,  1001,  1002,     0,     0,     0,  1003,     0,
       0,     0,     0,     0,     0,     0,  1004,  1005,  1006,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1007,  1008,
    1009,     0,     0,     0,     0,     0,  1010,     0,  1011,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,   176,   177,   178,   179,   180,   181,   182,  1012,
    1013,  1014,   183,   184,   185,  1015,   187,   188,   189,   190,
     191,   192,  1016,   194,   195,   196,   197,   198,   199,   200,
    1017,   202,   203,     0,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,  1018,   217,   218,   219,
     220,   221,   222,   223,   224,  1019,   226,  1020,  1021,   228,
    1022,  1023,  1024,  1025,  1026,     0,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,  1027,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1028,  1029,  1030,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
       0,  1031,   306,   307,   308,   309,   310,  1032,   312,  1033,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,  1034,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,  1035,  1036,   348,   349,   350,  1037,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,  1038,   390,  1039,   392,
     393,   394,   395,  1040,  1041,  1042,  1043,   400,   401,   402,
     403,   404,   405,   406,   407,   408,  1044,  1045,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,  1046,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,  1047,   441,   442,
     443,   444,   445,  1048,  1049,   448,   449,   450,   451,   452,
     453,  1050,   455,   456,   457,   458,   459,   460,  1051,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,  1052,   492,
     493,   494,   495,   496,  1053,  1054,   499,   500,   501,   502,
     503,  1055,   505,   506,   507,   508,   509,   510,  1056,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,     0,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,  1057,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,  1058,  1059,  1060,
    1061,   563,   564,   565,  1062,  1063,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1064,
     582,  1065,   584,   585,   586,   587,   588,   589,   590,   591,
     592,  1066,  1067,   595,  1068,   597,   598,   599,     0,   600,
     601,   602,  1069,     0,     0,     0,   938,   939,   940,   941,
     942,  1070,  1071,     0,     0,     0,     0,  1072,   943,   944,
       0,   945,  1073,     0,     0,     0,  1074,  1075,   946,   947,
    1076,  1077,   948,   949,   950,   951,     0,   952,   953,     0,
     954,   955,     0,     0,     0,     0,   956,     0,     0,     0,
     957,     0,     0,   958,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   959,   960,   961,     0,   962,   963,     0,
       0,     0,     0,     0,  2958,     0,     0,     0,     0,     0,
     964,   965,   966,     0,   967,   968,     0,     0,     0,   969,
     970,   971,     0,     0,     0,     0,     0,     0,     0,   972,
       0,   973,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   974,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   975,     0,
       0,     0,     0,   976,   977,     0,   978,     0,     0,     0,
       0,     0,   979,     0,   980,     0,     0,   981,     0,     0,
     982,   983,   984,     0,   985,   986,   987,     0,   988,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   989,     0,     0,     0,   990,   991,   992,
       0,   993,     0,     0,     0,     0,     0,     0,   994,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   995,
       0,     0,     0,     0,     0,     0,     0,   996,     0,     0,
     997,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     998,     0,     0,     0,     0,     0,   999,  1000,     0,  1001,
    1002,     0,     0,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1007,  1008,  1009,     0,     0,     0,
       0,     0,  1010,     0,  1011,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   174,   175,   176,   177,
     178,   179,   180,   181,   182,  1012,  1013,  1014,   183,   184,
     185,  1015,   187,   188,   189,   190,   191,   192,  1016,   194,
     195,   196,   197,   198,   199,   200,  1017,   202,   203,     0,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,  1018,   217,   218,   219,   220,   221,   222,   223,
     224,  1019,   226,  1020,  1021,   228,  1022,  1023,  1024,  1025,
    1026,     0,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,  1027,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1028,  1029,  1030,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,     0,  1031,   306,   307,
     308,   309,   310,  1032,   312,  1033,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,  1034,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,  1035,
    1036,   348,   349,   350,  1037,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,  1038,   390,  1039,   392,   393,   394,   395,  1040,
    1041,  1042,  1043,   400,   401,   402,   403,   404,   405,   406,
     407,   408,  1044,  1045,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1046,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,  1047,   441,   442,   443,   444,   445,  1048,
    1049,   448,   449,   450,   451,   452,   453,  1050,   455,   456,
     457,   458,   459,   460,  1051,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,  1052,   492,   493,   494,   495,   496,
    1053,  1054,   499,   500,   501,   502,   503,  1055,   505,   506,
     507,   508,   509,   510,  1056,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,     0,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,  1057,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,  1058,  1059,  1060,  1061,   563,   564,   565,
    1062,  1063,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,  1064,   582,  1065,   584,   585,
     586,   587,   588,   589,   590,   591,   592,  1066,  1067,   595,
    1068,   597,   598,   599,     0,   600,   601,   602,  1069,     0,
       0,     0,   938,   939,   940,   941,   942,  1070,  1071,     0,
       0,     0,     0,  1072,   943,   944,     0,   945,  1073,     0,
       0,     0,  1074,  1075,   946,   947,  1076,  1077,   948,   949,
     950,   951,     0,   952,   953,     0,   954,   955,     0,     0,
       0,     0,   956,     0,     0,     0,   957,     0,     0,   958,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   959,
     960,   961,     0,   962,   963,     0,     0,     0,     0,     0,
    2960,     0,     0,     0,     0,     0,   964,   965,   966,     0,
     967,   968,     0,     0,     0,   969,   970,   971,     0,     0,
       0,     0,     0,     0,     0,   972,     0,   973,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     974,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,   976,
     977,     0,   978,     0,     0,     0,     0,     0,   979,     0,
     980,     0,     0,   981,     0,     0,   982,   983,   984,     0,
     985,   986,   987,     0,   988,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   989,
       0,     0,     0,   990,   991,   992,     0,   993,     0,     0,
       0,     0,     0,     0,   994,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   995,     0,     0,     0,     0,
       0,     0,     0,   996,     0,     0,   997,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   998,     0,     0,     0,
       0,     0,   999,  1000,     0,  1001,  1002,     0,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,  1004,  1005,
    1006,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1007,  1008,  1009,     0,     0,     0,     0,     0,  1010,     0,
    1011,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   174,   175,   176,   177,   178,   179,   180,   181,
     182,  1012,  1013,  1014,   183,   184,   185,  1015,   187,   188,
     189,   190,   191,   192,  1016,   194,   195,   196,   197,   198,
     199,   200,  1017,   202,   203,     0,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,  1018,   217,
     218,   219,   220,   221,   222,   223,   224,  1019,   226,  1020,
    1021,   228,  1022,  1023,  1024,  1025,  1026,     0,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,  1027,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1028,  1029,  1030,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,     0,  1031,   306,   307,   308,   309,   310,  1032,
     312,  1033,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,  1034,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,  1035,  1036,   348,   349,   350,
    1037,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,  1038,   390,
    1039,   392,   393,   394,   395,  1040,  1041,  1042,  1043,   400,
     401,   402,   403,   404,   405,   406,   407,   408,  1044,  1045,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,  1046,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,  1047,
     441,   442,   443,   444,   445,  1048,  1049,   448,   449,   450,
     451,   452,   453,  1050,   455,   456,   457,   458,   459,   460,
    1051,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
    1052,   492,   493,   494,   495,   496,  1053,  1054,   499,   500,
     501,   502,   503,  1055,   505,   506,   507,   508,   509,   510,
    1056,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,     0,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
    1057,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,  1058,
    1059,  1060,  1061,   563,   564,   565,  1062,  1063,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,  1064,   582,  1065,   584,   585,   586,   587,   588,   589,
     590,   591,   592,  1066,  1067,   595,  1068,   597,   598,   599,
       0,   600,   601,   602,  1069,     0,     0,     0,   938,   939,
     940,   941,   942,  1070,  1071,     0,     0,     0,     0,  1072,
     943,   944,     0,   945,  1073,     0,     0,     0,  1074,  1075,
     946,   947,  1076,  1077,   948,   949,   950,   951,     0,   952,
     953,     0,   954,   955,     0,     0,     0,     0,   956,     0,
       0,     0,   957,     0,     0,   958,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   959,   960,   961,     0,   962,
     963,     0,     0,     0,     0,     0,  2962,     0,     0,     0,
       0,     0,   964,   965,   966,     0,   967,   968,     0,     0,
       0,   969,   970,   971,     0,     0,     0,     0,     0,     0,
       0,   972,     0,   973,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     975,     0,     0,     0,     0,   976,   977,     0,   978,     0,
       0,     0,     0,     0,   979,     0,   980,     0,     0,   981,
       0,     0,   982,   983,   984,     0,   985,   986,   987,     0,
     988,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   989,     0,     0,     0,   990,
     991,   992,     0,   993,     0,     0,     0,     0,     0,     0,
     994,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   995,     0,     0,     0,     0,     0,     0,     0,   996,
       0,     0,   997,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   998,     0,     0,     0,     0,     0,   999,  1000,
       0,  1001,  1002,     0,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,  1004,  1005,  1006,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1007,  1008,  1009,     0,
       0,     0,     0,     0,  1010,     0,  1011,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,  1012,  1013,  1014,
     183,   184,   185,  1015,   187,   188,   189,   190,   191,   192,
    1016,   194,   195,   196,   197,   198,   199,   200,  1017,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,  1018,   217,   218,   219,   220,   221,
     222,   223,   224,  1019,   226,  1020,  1021,   228,  1022,  1023,
    1024,  1025,  1026,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,  1027,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1028,
    1029,  1030,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,     0,  1031,
     306,   307,   308,   309,   310,  1032,   312,  1033,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,  1034,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,  1035,  1036,   348,   349,   350,  1037,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,  1038,   390,  1039,   392,   393,   394,
     395,  1040,  1041,  1042,  1043,   400,   401,   402,   403,   404,
     405,   406,   407,   408,  1044,  1045,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,  1046,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,  1047,   441,   442,   443,   444,
     445,  1048,  1049,   448,   449,   450,   451,   452,   453,  1050,
     455,   456,   457,   458,   459,   460,  1051,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,  1052,   492,   493,   494,
     495,   496,  1053,  1054,   499,   500,   501,   502,   503,  1055,
     505,   506,   507,   508,   509,   510,  1056,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,     0,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,  1057,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,  1058,  1059,  1060,  1061,   563,
     564,   565,  1062,  1063,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,  1064,   582,  1065,
     584,   585,   586,   587,   588,   589,   590,   591,   592,  1066,
    1067,   595,  1068,   597,   598,   599,     0,   600,   601,   602,
    1069,     0,     0,     0,   938,   939,   940,   941,   942,  1070,
    1071,     0,     0,     0,     0,  1072,   943,   944,     0,   945,
    1073,     0,     0,     0,  1074,  1075,   946,   947,  1076,  1077,
     948,   949,   950,   951,     0,   952,   953,     0,   954,   955,
       0,     0,     0,     0,   956,     0,     0,     0,  4697,     0,
       0,   958,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   959,   960,   961,     0,   962,   963,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   964,   965,
     966,     0,   967,   968,     0,     0,     0,   969,   970,   971,
       0,  2583,     0,     0,     0,     0,     0,   972,     0,   973,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   975,     0,     0,     0,
       0,   976,   977,     0,   978,     0,     0,     0,     0,     0,
     979,     0,   980,     0,     0,   981,     0,     0,   982,   983,
     984,     0,   985,   986,   987,     0,   988,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   989,     0,     0,     0,   990,   991,   992,     0,   993,
       0,     0,     0,     0,     0,     0,   994,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   995,     0,     0,
       0,     0,     0,     0,     0,   996,     0,     0,   997,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   998,     0,
       0,     0,     0,     0,   999,  1000,     0,  1001,  1002,     0,
       0,     0,  1003,     0,     0,     0,     0,     0,     0,     0,
    1004,  1005,  1006,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1007,  1008,  1009,     0,     0,     0,     0,     0,
    1010,     0,  1011,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,   175,   176,   177,   178,   179,
     180,   181,   182,  1012,  1013,  1014,   183,   184,   185,  1015,
     187,   188,   189,   190,   191,   192,  1016,   194,   195,   196,
     197,   198,   199,   200,  1017,   202,   203,     0,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
    1018,   217,   218,   219,   220,   221,   222,   223,   224,  1019,
     226,  1020,  1021,   228,  1022,  1023,  1024,  1025,  1026,     0,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,  1027,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1028,  1029,  1030,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,     0,  1031,   306,   307,   308,   309,
     310,  1032,   312,  1033,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,  1034,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,  1035,  1036,   348,
     349,   350,  1037,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
    1038,   390,  1039,   392,   393,   394,   395,  1040,  1041,  1042,
    1043,   400,   401,   402,   403,   404,   405,   406,   407,   408,
    1044,  1045,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,  1046,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,  1047,   441,   442,   443,   444,   445,  1048,  1049,   448,
     449,   450,   451,   452,   453,  1050,   455,   456,   457,   458,
     459,   460,  1051,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,  1052,   492,   493,   494,   495,   496,  1053,  1054,
     499,   500,   501,   502,   503,  1055,   505,   506,   507,   508,
     509,   510,  1056,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,     0,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,  1057,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,  1058,  1059,  1060,  1061,   563,   564,   565,  1062,  1063,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,  1064,   582,  1065,   584,   585,   586,   587,
     588,   589,   590,   591,   592,  1066,  1067,   595,  1068,   597,
     598,   599,     0,   600,   601,   602,  1069,     0,     0,     0,
     938,   939,   940,   941,   942,  1070,  1071,     0,     0,     0,
       0,  1072,   943,   944,     0,   945,  1073,     0,     0,     0,
    1074,  1075,   946,   947,  1076,  1077,   948,   949,   950,   951,
       0,   952,   953,     0,   954,   955,     0,     0,     0,     0,
     956,     0,     0,     0,   957,     0,     0,   958,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   959,   960,   961,
       0,   962,   963,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   964,   965,   966,     0,   967,   968,
       0,     0,     0,   969,   970,   971,     0,     0,     0,     0,
       0,     0,     0,   972,     0,   973,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   974,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   975,     0,     0,     0,     0,   976,   977,     0,
     978,     0,     0,     0,     0,     0,   979,     0,   980,     0,
       0,   981,     0,     0,   982,   983,   984,     0,   985,   986,
     987,     0,   988,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   989,     0,     0,
       0,   990,   991,   992,     0,   993,     0,     0,     0,     0,
       0,     0,   994,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   995,     0,     0,     0,     0,     0,     0,
       0,   996,     0,     0,   997,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   998,     0,     0,     0,     0,     0,
     999,  1000,     0,  1001,  1002,     0,     0,     0,  1003,     0,
       0,     0,     0,     0,     0,     0,  1004,  1005,  1006,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1007,  1008,
    1009,     0,     0,     0,     0,     0,  1010,     0,  1011,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,   176,   177,   178,   179,   180,   181,   182,  1012,
    1013,  1014,   183,   184,   185,  1015,   187,   188,   189,   190,
     191,   192,  1016,   194,   195,   196,   197,   198,   199,   200,
    1017,   202,   203,     0,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,  1018,   217,   218,   219,
     220,   221,   222,   223,   224,  1019,   226,  1020,  1021,   228,
    1022,  1023,  1024,  1025,  1026,     0,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,  1027,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1028,  1029,  1030,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
       0,  1031,   306,   307,   308,   309,   310,  1032,   312,  1033,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,  1034,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,  1035,  1036,   348,   349,   350,  1037,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,  1038,   390,  1039,   392,
     393,   394,   395,  1040,  1041,  1042,  1043,   400,   401,   402,
     403,   404,   405,   406,   407,   408,  1044,  1045,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,  1046,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,  1047,   441,   442,
     443,   444,   445,  1048,  1049,   448,   449,   450,   451,   452,
     453,  1050,   455,   456,   457,   458,   459,   460,  1051,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,  1052,   492,
     493,   494,   495,   496,  1053,  1054,   499,   500,   501,   502,
     503,  1055,   505,   506,   507,   508,   509,   510,  1056,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,     0,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,  1057,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,  1058,  1059,  1060,
    1061,   563,   564,   565,  1062,  1063,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1064,
     582,  1065,   584,   585,   586,   587,   588,   589,   590,   591,
     592,  1066,  1067,   595,  1068,   597,   598,   599,     0,   600,
     601,   602,  1069,     0,     0,     0,   938,   939,   940,   941,
     942,  1070,  1071,     0,     0,     0,     0,  1072,   943,   944,
       0,   945,  1073,     0,     0,     0,  1074,  1075,   946,   947,
    1076,  1077,   948,   949,   950,   951,     0,   952,   953,     0,
     954,   955,     0,     0,     0,     0,   956,     0,     0,     0,
     957,     0,     0,   958,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   959,   960,   961,     0,   962,   963,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     964,   965,   966,     0,   967,   968,     0,     0,     0,   969,
     970,   971,     0,     0,     0,     0,     0,     0,     0,   972,
       0,   973,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   974,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   975,     0,
       0,     0,     0,   976,   977,     0,   978,     0,     0,     0,
       0,     0,   979,     0,   980,     0,     0,   981,     0,     0,
     982,   983,   984,     0,   985,   986,   987,     0,   988,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   989,     0,     0,     0,   990,   991,   992,
       0,   993,     0,     0,     0,     0,     0,     0,   994,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   995,
       0,     0,     0,     0,     0,     0,     0,   996,     0,     0,
     997,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     998,     0,     0,     0,     0,     0,   999,  1000,     0,  1001,
    1002,     0,     0,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1007,  1008,  1009,     0,     0,     0,
       0,     0,  1010,     0,  1011,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   174,   175,   176,   177,
     178,   179,   180,   181,   182,  1012,  1013,  1014,   183,   184,
     185,  1015,   187,   188,   189,   190,   191,   192,  1016,   194,
     195,   196,   197,   198,   199,   200,  1017,   202,   203,     0,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,  1018,   217,   218,   219,   220,   221,   222,   223,
     224,  1019,   226,  1020,  1021,   228,  1022,  1023,  1024,  1025,
    1026,     0,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,  1027,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1028,  1029,  1030,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,     0,  1031,   306,   307,
     308,   309,   310,  1032,   312,  1033,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,  1034,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,  1035,
    1036,   348,   349,   350,  1037,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,  1038,   390,  1039,   392,   393,   394,   395,  1040,
    1041,  1042,  1043,   400,   401,   402,   403,   404,   405,   406,
     407,   408,  1044,  1045,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1046,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,  1047,   441,   442,   443,   444,   445,  1048,
    1049,   448,   449,   450,   451,   452,   453,  1050,   455,   456,
     457,   458,   459,   460,  1051,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,  1052,   492,   493,   494,   495,   496,
    1053,  1054,   499,   500,   501,   502,   503,  1055,   505,   506,
     507,   508,   509,   510,  1056,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,     0,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,  1057,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,  1058,  1059,  1060,  1061,   563,   564,   565,
    1062,  1063,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,  1064,   582,  1065,   584,   585,
     586,   587,   588,   589,   590,   591,   592,  1066,  1067,   595,
    1068,   597,   598,   599,     0,   600,   601,   602,  1069,     0,
       0,     0,   938,   939,   940,   941,   942,  1070,  1071,     0,
       0,     0,     0,  1072,   943,   944,     0,   945,  1573,     0,
       0,     0,  1074,  1075,   946,   947,  1076,  1077,   948,   949,
     950,   951,     0,   952,   953,     0,   954,   955,     0,     0,
       0,     0,   956,     0,     0,     0,   957,     0,     0,   958,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   959,
     960,   961,     0,   962,   963,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   964,   965,   966,     0,
     967,   968,     0,     0,     0,   969,   970,   971,     0,     0,
       0,     0,     0,     0,     0,   972,     0,   973,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     974,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,   976,
     977,     0,   978,     0,     0,     0,     0,     0,   979,     0,
     980,     0,     0,   981,     0,     0,   982,   983,   984,     0,
     985,   986,   987,     0,   988,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   989,
       0,     0,     0,   990,   991,   992,     0,   993,     0,     0,
       0,     0,     0,     0,   994,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   995,     0,     0,     0,     0,
       0,     0,     0,   996,     0,     0,   997,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   998,     0,     0,     0,
       0,     0,   999,  1000,     0,  1001,  1002,     0,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,  1004,  1005,
    1006,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1007,  1008,  1009,     0,     0,     0,     0,     0,  1010,     0,
    1011,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   174,   175,   176,   177,   178,   179,   180,   181,
     182,  1012,  1013,  1014,   183,   184,   185,  1015,   187,   188,
     189,   190,   191,   192,  1016,   194,   195,   196,   197,   198,
     199,   200,  1017,   202,   203,     0,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,  1018,   217,
     218,   219,   220,   221,   222,   223,   224,  1019,   226,  1020,
    1021,   228,  1022,  1023,  1024,  1025,  1026,     0,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,  1027,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1028,  1029,  1030,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,     0,  1031,   306,   307,   308,   309,   310,  1032,
     312,  1033,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,  1034,  2145,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,  1035,  1036,   348,   349,   350,
    1037,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,  1038,   390,
    1039,   392,   393,   394,   395,  1040,  1041,  1042,  1043,   400,
     401,   402,   403,   404,   405,   406,   407,   408,  1044,  1045,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,  1046,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,  1047,
     441,   442,   443,   444,   445,  1048,  1049,   448,   449,   450,
     451,   452,   453,  1050,   455,   456,   457,   458,   459,   460,
    1051,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
    1052,   492,   493,   494,   495,   496,  1053,  1054,   499,   500,
     501,   502,   503,  1055,   505,   506,   507,   508,   509,   510,
    1056,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,     0,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
    1057,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,  1058,
    1059,  1060,  1061,   563,   564,   565,  1062,  1063,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,  2146,   582,  1065,   584,   585,   586,   587,   588,   589,
     590,   591,   592,  1066,  1067,   595,  1068,   597,   598,   599,
       0,   600,   601,   602,  1069,     0,     0,     0,   938,   939,
     940,   941,   942,  1070,  1071,     0,     0,     0,     0,  1072,
     943,   944,     0,   945,  1073,     0,     0,     0,  1074,  1075,
     946,   947,  1076,  1077,   948,   949,   950,   951,     0,   952,
     953,     0,   954,   955,     0,     0,     0,     0,   956,     0,
       0,     0,   957,     0,     0,   958,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   959,   960,   961,     0,   962,
     963,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   964,   965,   966,     0,   967,   968,     0,     0,
       0,   969,   970,   971,     0,     0,     0,     0,     0,     0,
       0,   972,     0,   973,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     975,     0,     0,     0,     0,   976,   977,     0,   978,     0,
       0,     0,     0,     0,   979,     0,   980,     0,     0,   981,
       0,     0,   982,   983,   984,     0,   985,   986,   987,     0,
     988,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   989,     0,     0,     0,   990,
     991,   992,     0,   993,     0,     0,     0,     0,     0,     0,
     994,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   995,     0,     0,     0,     0,     0,     0,     0,   996,
       0,     0,   997,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   998,     0,     0,     0,     0,     0,   999,  1000,
       0,  1001,  1002,     0,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,  1004,  1005,  1006,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1007,  1008,  1009,     0,
       0,     0,     0,     0,  1010,     0,  1011,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,  1012,  1013,  1014,
     183,   184,   185,  1015,   187,   188,   189,   190,   191,   192,
    1016,   194,   195,   196,   197,   198,   199,   200,  1017,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,  1018,   217,   218,   219,   220,   221,
     222,   223,   224,  1019,   226,  1020,  1021,   228,  1022,  1023,
    1024,  1025,  1026,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,  1027,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1028,
    1029,  1030,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,     0,  1031,
     306,   307,   308,   309,   310,  1032,   312,  1033,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,  1034,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,  1035,  1036,   348,   349,   350,  1037,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,  1038,   390,  1039,   392,   393,   394,
     395,  1040,  1041,  1042,  1043,   400,   401,   402,   403,   404,
     405,   406,   407,   408,  1044,  1045,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,  1046,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,  1047,   441,   442,   443,   444,
     445,  1048,  1049,   448,   449,   450,   451,   452,   453,  1050,
     455,   456,   457,   458,   459,   460,  1051,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,  1052,   492,   493,   494,
     495,   496,  1053,  1054,   499,   500,   501,   502,   503,  1055,
     505,   506,   507,   508,   509,   510,  1056,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,     0,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,  1057,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,  1058,  1059,  1060,  1061,   563,
     564,   565,  1062,  1063,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,  2146,   582,  1065,
     584,   585,   586,   587,   588,   589,   590,   591,   592,  1066,
    1067,   595,  1068,   597,   598,   599,     0,   600,   601,   602,
    1069,     0,     0,     0,   938,   939,   940,   941,   942,  1070,
    1071,     0,     0,     0,     0,  1072,   943,   944,     0,   945,
    1073,     0,     0,     0,  1074,  1075,   946,   947,  1076,  1077,
     948,   949,   950,   951,     0,   952,   953,     0,   954,   955,
       0,     0,     0,     0,   956,     0,     0,     0,   957,     0,
       0,   958,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   959,   960,   961,     0,   962,   963,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   964,   965,
     966,     0,   967,   968,     0,     0,     0,   969,   970,   971,
       0,     0,     0,     0,     0,     0,     0,   972,     0,  3555,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   975,     0,     0,     0,
       0,   976,   977,     0,   978,     0,     0,     0,     0,     0,
     979,     0,   980,     0,     0,   981,     0,     0,   982,   983,
     984,     0,   985,   986,   987,     0,   988,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   989,     0,     0,     0,   990,   991,   992,     0,   993,
       0,     0,     0,     0,     0,     0,   994,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   995,     0,     0,
       0,     0,     0,     0,     0,   996,     0,     0,   997,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   998,     0,
       0,     0,     0,     0,   999,  1000,     0,  1001,  1002,     0,
       0,     0,  1003,     0,     0,     0,     0,     0,     0,     0,
    1004,  1005,  1006,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1007,  1008,  1009,     0,     0,     0,     0,     0,
    1010,     0,  1011,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,   175,   176,   177,   178,   179,
     180,   181,   182,  1012,  1013,  1014,   183,   184,   185,  1015,
     187,   188,   189,   190,   191,   192,  1016,   194,   195,   196,
     197,   198,   199,   200,  1017,   202,   203,     0,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
    1018,   217,   218,   219,   220,   221,   222,   223,   224,  1019,
     226,  1020,  1021,   228,  1022,  1023,  1024,  1025,  1026,     0,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,  1027,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1028,  1029,  1030,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,     0,  1031,   306,   307,   308,   309,
     310,  1032,   312,  1033,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,  1034,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,  1035,  1036,   348,
     349,   350,  1037,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
    1038,   390,  1039,   392,   393,   394,   395,  1040,  1041,  1042,
    1043,   400,   401,   402,   403,   404,   405,   406,   407,   408,
    1044,  1045,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,  1046,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,  1047,   441,   442,   443,   444,   445,  1048,  1049,   448,
     449,   450,   451,   452,   453,  1050,   455,   456,   457,   458,
     459,   460,  1051,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,  1052,   492,   493,   494,   495,   496,  1053,  1054,
     499,   500,   501,   502,   503,  1055,   505,   506,   507,   508,
     509,   510,  1056,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,     0,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,  1057,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,  1058,  1059,  1060,  1061,   563,   564,   565,  1062,  1063,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,  1064,   582,  1065,   584,   585,   586,   587,
     588,   589,   590,   591,   592,  1066,  1067,   595,  1068,   597,
     598,   599,     0,   600,   601,   602,  1069,     0,     0,     0,
     938,   939,   940,   941,   942,  1070,  1071,     0,     0,     0,
       0,  1072,   943,   944,     0,   945,  1073,     0,     0,     0,
    1074,  1075,   946,   947,  1076,  1077,   948,   949,   950,   951,
       0,   952,   953,     0,   954,   955,     0,     0,     0,     0,
     956,     0,     0,     0,   957,     0,     0,   958,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   959,   960,   961,
       0,   962,   963,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   964,   965,   966,     0,   967,   968,
       0,     0,     0,   969,   970,   971,     0,     0,     0,     0,
       0,     0,     0,   972,     0,  3574,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   974,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   975,     0,     0,     0,     0,   976,   977,     0,
     978,     0,     0,     0,     0,     0,   979,     0,   980,     0,
       0,   981,     0,     0,   982,   983,   984,     0,   985,   986,
     987,     0,   988,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   989,     0,     0,
       0,   990,   991,   992,     0,   993,     0,     0,     0,     0,
       0,     0,   994,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   995,     0,     0,     0,     0,     0,     0,
       0,   996,     0,     0,   997,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   998,     0,     0,     0,     0,     0,
     999,  1000,     0,  1001,  1002,     0,     0,     0,  1003,     0,
       0,     0,     0,     0,     0,     0,  1004,  1005,  1006,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1007,  1008,
    1009,     0,     0,     0,     0,     0,  1010,     0,  1011,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,   176,   177,   178,   179,   180,   181,   182,  1012,
    1013,  1014,   183,   184,   185,  1015,   187,   188,   189,   190,
     191,   192,  1016,   194,   195,   196,   197,   198,   199,   200,
    1017,   202,   203,     0,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,  1018,   217,   218,   219,
     220,   221,   222,   223,   224,  1019,   226,  1020,  1021,   228,
    1022,  1023,  1024,  1025,  1026,     0,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,  1027,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1028,  1029,  1030,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
       0,  1031,   306,   307,   308,   309,   310,  1032,   312,  1033,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,  1034,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,  1035,  1036,   348,   349,   350,  1037,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,  1038,   390,  1039,   392,
     393,   394,   395,  1040,  1041,  1042,  1043,   400,   401,   402,
     403,   404,   405,   406,   407,   408,  1044,  1045,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,  1046,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,  1047,   441,   442,
     443,   444,   445,  1048,  1049,   448,   449,   450,   451,   452,
     453,  1050,   455,   456,   457,   458,   459,   460,  1051,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,  1052,   492,
     493,   494,   495,   496,  1053,  1054,   499,   500,   501,   502,
     503,  1055,   505,   506,   507,   508,   509,   510,  1056,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,     0,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,  1057,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,  1058,  1059,  1060,
    1061,   563,   564,   565,  1062,  1063,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1064,
     582,  1065,   584,   585,   586,   587,   588,   589,   590,   591,
     592,  1066,  1067,   595,  1068,   597,   598,   599,     0,   600,
     601,   602,  1069,     0,     0,     0,   938,   939,   940,   941,
     942,  1070,  1071,     0,     0,     0,     0,  1072,   943,   944,
       0,   945,  1073,     0,     0,     0,  1074,  1075,   946,   947,
    1076,  1077,   948,   949,   950,   951,     0,   952,   953,     0,
     954,   955,     0,     0,     0,     0,   956,     0,     0,     0,
     957,     0,     0,   958,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   959,   960,   961,     0,   962,   963,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     964,   965,   966,     0,   967,   968,     0,     0,     0,   969,
     970,   971,     0,     0,     0,     0,     0,     0,     0,   972,
       0,   973,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   974,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   975,     0,
       0,     0,     0,   976,   977,  5788,   978,     0,     0,     0,
       0,     0,   979,     0,   980,     0,     0,   981,     0,     0,
     982,     0,   984,     0,   985,   986,   987,     0,   988,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   989,     0,     0,     0,   990,   991,   992,
       0,   993,     0,     0,     0,     0,     0,     0,   994,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   995,
       0,     0,     0,     0,     0,     0,     0,   996,     0,     0,
     997,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     998,     0,     0,     0,     0,     0,   999,  1000,     0,  1001,
    1002,     0,     0,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1007,  1008,  1009,     0,     0,     0,
       0,     0,  1010,     0,  1011,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   174,   175,   176,   177,
     178,   179,   180,   181,   182,  1012,  1013,  1014,   183,   184,
     185,  1015,   187,   188,   189,   190,   191,   192,  1016,   194,
     195,   196,   197,   198,   199,   200,  1017,   202,   203,     0,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,  1018,   217,   218,   219,   220,   221,   222,   223,
     224,  1019,   226,  1020,  1021,   228,  1022,  1023,  1024,  1025,
    1026,     0,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,  1027,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1028,  1029,  1030,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,     0,  1031,   306,   307,
     308,   309,   310,  1032,   312,  1033,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,  1034,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,  1035,
    1036,   348,   349,   350,  1037,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,  1038,   390,  1039,   392,   393,   394,   395,  1040,
    1041,  1042,  1043,   400,   401,   402,   403,   404,   405,   406,
     407,   408,  1044,  1045,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1046,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,  1047,   441,   442,   443,   444,   445,  1048,
    1049,   448,   449,   450,   451,   452,   453,  1050,   455,   456,
     457,   458,   459,   460,  1051,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,  1052,   492,   493,   494,   495,   496,
    1053,  1054,   499,   500,   501,   502,   503,  1055,   505,   506,
     507,   508,   509,   510,  1056,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,     0,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,  1057,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,  1058,  1059,  1060,  1061,   563,   564,   565,
    1062,  1063,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,  1064,   582,  1065,   584,   585,
     586,   587,   588,   589,   590,   591,   592,  1066,  1067,   595,
    1068,   597,   598,   599,     0,   600,   601,   602,  1069,     0,
       0,     0,   938,   939,   940,   941,   942,  1070,  1071,     0,
       0,     0,     0,  1072,   943,   944,     0,   945,  1073,     0,
       0,     0,  1074,  1075,   946,   947,  1076,  1077,   948,   949,
     950,   951,     0,   952,   953,     0,   954,   955,     0,     0,
       0,     0,   956,     0,     0,     0,   957,     0,     0,   958,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   959,
     960,   961,     0,   962,   963,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   964,   965,   966,     0,
     967,   968,     0,     0,     0,   969,   970,   971,     0,     0,
       0,     0,     0,     0,     0,   972,     0,  1539,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     974,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,   976,
     977,     0,   978,     0,     0,     0,     0,     0,   979,     0,
     980,     0,     0,   981,     0,     0,   982,     0,   984,     0,
     985,   986,   987,     0,   988,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   989,
       0,     0,     0,   990,   991,   992,     0,   993,     0,     0,
       0,     0,     0,     0,   994,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   995,     0,     0,     0,     0,
       0,     0,     0,   996,     0,     0,   997,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   998,     0,     0,     0,
       0,     0,   999,  1000,     0,  1001,  1002,     0,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,  1004,  1005,
    1006,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1007,  1008,  1009,     0,     0,     0,     0,     0,  1010,     0,
    1011,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   174,   175,   176,   177,   178,   179,   180,   181,
     182,  1012,  1013,  1014,   183,   184,   185,  1015,   187,   188,
     189,   190,   191,   192,  1016,   194,   195,   196,   197,   198,
     199,   200,  1017,   202,   203,     0,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,  1018,   217,
     218,   219,   220,   221,   222,   223,   224,  1019,   226,  1020,
    1021,   228,  1022,  1023,  1024,  1025,  1026,     0,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,  1027,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1028,  1029,  1030,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,     0,  1031,   306,   307,   308,   309,   310,  1032,
     312,  1033,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,  1034,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,  1035,  1036,   348,   349,   350,
    1037,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,  1038,   390,
    1039,   392,   393,   394,   395,  1040,  1041,  1042,  1043,   400,
     401,   402,   403,   404,   405,   406,   407,   408,  1044,  1045,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,  1046,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,  1047,
     441,   442,   443,   444,   445,  1048,  1049,   448,   449,   450,
     451,   452,   453,  1050,   455,   456,   457,   458,   459,   460,
    1051,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
    1052,   492,   493,   494,   495,   496,  1053,  1054,   499,   500,
     501,   502,   503,  1055,   505,   506,   507,   508,   509,   510,
    1056,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,     0,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
    1057,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,  1058,
    1059,  1060,  1061,   563,   564,   565,  1062,  1063,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,  1064,   582,  1065,   584,   585,   586,   587,   588,   589,
     590,   591,   592,  1066,  1067,   595,  1068,   597,   598,   599,
       0,   600,   601,   602,  1069,     0,     0,     0,   938,   939,
     940,   941,   942,  1540,  1541,     0,     0,     0,     0,  1072,
     943,   944,     0,   945,  1073,     0,     0,     0,  1074,  1075,
     946,   947,  1076,  1077,   948,   949,   950,   951,     0,   952,
     953,     0,   954,   955,     0,     0,     0,     0,   956,     0,
       0,     0,   957,     0,     0,   958,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   959,   960,   961,     0,   962,
     963,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   964,   965,   966,     0,   967,   968,     0,     0,
       0,   969,   970,   971,     0,     0,     0,     0,     0,     0,
       0,   972,     0,  1675,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     975,     0,     0,     0,     0,   976,   977,     0,   978,     0,
       0,     0,     0,     0,   979,     0,   980,     0,     0,   981,
       0,     0,   982,     0,   984,     0,   985,   986,   987,     0,
     988,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   989,     0,     0,     0,   990,
     991,   992,     0,   993,     0,     0,     0,     0,     0,     0,
     994,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   995,     0,     0,     0,     0,     0,     0,     0,   996,
       0,     0,   997,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   998,     0,     0,     0,     0,     0,   999,  1000,
       0,  1001,  1002,     0,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,  1004,  1005,  1006,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1007,  1008,  1009,     0,
       0,     0,     0,     0,  1010,     0,  1011,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,  1012,  1013,  1014,
     183,   184,   185,  1015,   187,   188,   189,   190,   191,   192,
    1016,   194,   195,   196,   197,   198,   199,   200,  1017,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,  1018,   217,   218,   219,   220,   221,
     222,   223,   224,  1019,   226,  1020,  1021,   228,  1022,  1023,
    1024,  1025,  1026,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,  1027,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1028,
    1029,  1030,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,     0,  1031,
     306,   307,   308,   309,   310,  1032,   312,  1033,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,  1034,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,  1035,  1036,   348,   349,   350,  1037,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,  1038,   390,  1039,   392,   393,   394,
     395,  1040,  1041,  1042,  1043,   400,   401,   402,   403,   404,
     405,   406,   407,   408,  1044,  1045,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,  1046,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,  1047,   441,   442,   443,   444,
     445,  1048,  1049,   448,   449,   450,   451,   452,   453,  1050,
     455,   456,   457,   458,   459,   460,  1051,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,  1052,   492,   493,   494,
     495,   496,  1053,  1054,   499,   500,   501,   502,   503,  1055,
     505,   506,   507,   508,   509,   510,  1056,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,     0,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,  1057,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,  1058,  1059,  1060,  1061,   563,
     564,   565,  1062,  1063,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,  1064,   582,  1065,
     584,   585,   586,   587,   588,   589,   590,   591,   592,  1066,
    1067,   595,  1068,   597,   598,   599,     0,   600,   601,   602,
    1069,     0,     0,     0,   938,   939,   940,   941,   942,  1540,
    1541,     0,     0,     0,     0,  1072,   943,   944,     0,   945,
    1073,     0,     0,     0,  1074,  1075,   946,   947,  1076,  1077,
     948,   949,   950,   951,     0,   952,   953,     0,   954,   955,
       0,     0,     0,     0,   956,     0,     0,     0,   957,     0,
       0,   958,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   959,   960,   961,     0,   962,   963,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   964,   965,
     966,     0,   967,   968,     0,     0,     0,   969,   970,   971,
       0,     0,     0,     0,     0,     0,     0,   972,     0,  1677,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   975,     0,     0,     0,
       0,   976,   977,     0,   978,     0,     0,     0,     0,     0,
     979,     0,   980,     0,     0,   981,     0,     0,   982,     0,
     984,     0,   985,   986,   987,     0,   988,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   989,     0,     0,     0,   990,   991,   992,     0,   993,
       0,     0,     0,     0,     0,     0,   994,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   995,     0,     0,
       0,     0,     0,     0,     0,   996,     0,     0,   997,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   998,     0,
       0,     0,     0,     0,   999,  1000,     0,  1001,  1002,     0,
       0,     0,  1003,     0,     0,     0,     0,     0,     0,     0,
    1004,  1005,  1006,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1007,  1008,  1009,     0,     0,     0,     0,     0,
    1010,     0,  1011,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,   175,   176,   177,   178,   179,
     180,   181,   182,  1012,  1013,  1014,   183,   184,   185,  1015,
     187,   188,   189,   190,   191,   192,  1016,   194,   195,   196,
     197,   198,   199,   200,  1017,   202,   203,     0,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
    1018,   217,   218,   219,   220,   221,   222,   223,   224,  1019,
     226,  1020,  1021,   228,  1022,  1023,  1024,  1025,  1026,     0,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,  1027,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1028,  1029,  1030,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,     0,  1031,   306,   307,   308,   309,
     310,  1032,   312,  1033,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,  1034,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,  1035,  1036,   348,
     349,   350,  1037,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
    1038,   390,  1039,   392,   393,   394,   395,  1040,  1041,  1042,
    1043,   400,   401,   402,   403,   404,   405,   406,   407,   408,
    1044,  1045,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,  1046,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,  1047,   441,   442,   443,   444,   445,  1048,  1049,   448,
     449,   450,   451,   452,   453,  1050,   455,   456,   457,   458,
     459,   460,  1051,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,  1052,   492,   493,   494,   495,   496,  1053,  1054,
     499,   500,   501,   502,   503,  1055,   505,   506,   507,   508,
     509,   510,  1056,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,     0,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,  1057,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,  1058,  1059,  1060,  1061,   563,   564,   565,  1062,  1063,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,  1064,   582,  1065,   584,   585,   586,   587,
     588,   589,   590,   591,   592,  1066,  1067,   595,  1068,   597,
     598,   599,     0,   600,   601,   602,  1069,     0,     0,     0,
     938,   939,   940,   941,   942,  1540,  1541,     0,     0,     0,
       0,  1072,   943,   944,     0,   945,  1073,     0,     0,     0,
    1074,  1075,   946,   947,  1076,  1077,   948,   949,   950,   951,
       0,   952,   953,     0,   954,   955,     0,     0,     0,     0,
     956,     0,     0,     0,   957,     0,     0,   958,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   959,   960,   961,
       0,   962,   963,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   964,   965,   966,     0,   967,   968,
       0,     0,     0,   969,   970,   971,     0,     0,     0,     0,
       0,     0,     0,   972,     0,   973,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   974,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   975,     0,     0,     0,     0,   976,   977,     0,
     978,     0,     0,     0,     0,     0,   979,     0,   980,     0,
       0,   981,     0,     0,   982,     0,   984,     0,   985,   986,
     987,     0,   988,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   989,     0,     0,
       0,   990,   991,   992,     0,   993,     0,     0,     0,     0,
       0,     0,   994,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   995,     0,     0,     0,     0,     0,     0,
       0,   996,     0,     0,   997,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   998,     0,     0,     0,     0,     0,
     999,  1000,     0,  1001,  1002,     0,     0,     0,  1003,     0,
       0,     0,     0,     0,     0,     0,  1004,  1005,  1006,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1007,  1008,
    1009,     0,     0,     0,     0,     0,  1010,     0,  1011,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,   176,   177,   178,   179,   180,   181,   182,  1012,
    1013,  1014,   183,   184,   185,  1015,   187,   188,   189,   190,
     191,   192,  1016,   194,   195,   196,   197,   198,   199,   200,
    1017,   202,   203,     0,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,  1018,   217,   218,   219,
     220,   221,   222,   223,   224,  1019,   226,  1020,  1021,   228,
    1022,  1023,  1024,  1025,  1026,     0,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,  1027,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1028,  1029,  1030,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
       0,  1031,   306,   307,   308,   309,   310,  1032,   312,  1033,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,  1034,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,  1035,  1036,   348,   349,   350,  1037,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,  1038,   390,  1039,   392,
     393,   394,   395,  1040,  1041,  1042,  1043,   400,   401,   402,
     403,   404,   405,   406,   407,   408,  1044,  1045,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,  1046,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,  1047,   441,   442,
     443,   444,   445,  1048,  1049,   448,   449,   450,   451,   452,
     453,  1050,   455,   456,   457,   458,   459,   460,  1051,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,  1052,   492,
     493,   494,   495,   496,  1053,  1054,   499,   500,   501,   502,
     503,  1055,   505,   506,   507,   508,   509,   510,  1056,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,     0,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,  1057,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,  1058,  1059,  1060,
    1061,   563,   564,   565,  1062,  1063,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1064,
     582,  1065,   584,   585,   586,   587,   588,   589,   590,   591,
     592,  1066,  1067,   595,  1068,   597,   598,   599,     0,   600,
     601,   602,  1069,     0,     0,     0,   938,   939,   940,   941,
     942,  1070,  1071,     0,     0,     0,     0,  1072,   943,   944,
       0,   945,  1073,     0,     0,     0,  1074,  1075,   946,   947,
    1076,  1077,   948,   949,   950,   951,     0,   952,   953,     0,
     954,   955,     0,     0,     0,     0,   956,     0,     0,     0,
     957,     0,     0,   958,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   959,   960,   961,     0,   962,   963,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     964,   965,   966,     0,   967,   968,     0,     0,     0,   969,
     970,   971,     0,     0,     0,     0,     0,     0,     0,   972,
       0,  2399,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   974,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   975,     0,
       0,     0,     0,   976,   977,     0,   978,     0,     0,     0,
       0,     0,   979,     0,   980,     0,     0,   981,     0,     0,
     982,     0,   984,     0,   985,   986,   987,     0,   988,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   989,     0,     0,     0,   990,   991,   992,
       0,   993,     0,     0,     0,     0,     0,     0,   994,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   995,
       0,     0,     0,     0,     0,     0,     0,   996,     0,     0,
     997,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     998,     0,     0,     0,     0,     0,   999,  1000,     0,  1001,
    1002,     0,     0,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1007,  1008,  1009,     0,     0,     0,
       0,     0,  1010,     0,  1011,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   174,   175,   176,   177,
     178,   179,   180,   181,   182,  1012,  1013,  1014,   183,   184,
     185,  1015,   187,   188,   189,   190,   191,   192,  1016,   194,
     195,   196,   197,   198,   199,   200,  1017,   202,   203,     0,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,  1018,   217,   218,   219,   220,   221,   222,   223,
     224,  1019,   226,  1020,  1021,   228,  1022,  1023,  1024,  1025,
    1026,     0,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,  1027,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1028,  1029,  1030,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,     0,  1031,   306,   307,
     308,   309,   310,  1032,   312,  1033,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,  1034,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,  1035,
    1036,   348,   349,   350,  1037,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,  1038,   390,  1039,   392,   393,   394,   395,  1040,
    1041,  1042,  1043,   400,   401,   402,   403,   404,   405,   406,
     407,   408,  1044,  1045,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1046,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,  1047,   441,   442,   443,   444,   445,  1048,
    1049,   448,   449,   450,   451,   452,   453,  1050,   455,   456,
     457,   458,   459,   460,  1051,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,  1052,   492,   493,   494,   495,   496,
    1053,  1054,   499,   500,   501,   502,   503,  1055,   505,   506,
     507,   508,   509,   510,  1056,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,     0,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,  1057,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,  1058,  1059,  1060,  1061,   563,   564,   565,
    1062,  1063,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,  1064,   582,  1065,   584,   585,
     586,   587,   588,   589,   590,   591,   592,  1066,  1067,   595,
    1068,   597,   598,   599,     0,   600,   601,   602,  1069,     0,
       0,     0,   938,   939,   940,   941,   942,  1070,  1071,     0,
       0,     0,     0,  1072,   943,   944,     0,   945,  1073,     0,
       0,     0,  1074,  1075,   946,   947,  1076,  1077,   948,   949,
     950,   951,     0,   952,   953,     0,   954,   955,     0,     0,
       0,     0,   956,     0,     0,     0,   957,     0,     0,   958,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   959,
     960,   961,     0,   962,   963,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   964,   965,   966,     0,
     967,   968,     0,     0,     0,   969,   970,   971,     0,     0,
       0,     0,     0,     0,     0,   972,     0,  2401,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     974,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,   976,
     977,     0,   978,     0,     0,     0,     0,     0,   979,     0,
     980,     0,     0,   981,     0,     0,   982,     0,   984,     0,
     985,   986,   987,     0,   988,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   989,
       0,     0,     0,   990,   991,   992,     0,   993,     0,     0,
       0,     0,     0,     0,   994,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   995,     0,     0,     0,     0,
       0,     0,     0,   996,     0,     0,   997,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   998,     0,     0,     0,
       0,     0,   999,  1000,     0,  1001,  1002,     0,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,  1004,  1005,
    1006,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1007,  1008,  1009,     0,     0,     0,     0,     0,  1010,     0,
    1011,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   174,   175,   176,   177,   178,   179,   180,   181,
     182,  1012,  1013,  1014,   183,   184,   185,  1015,   187,   188,
     189,   190,   191,   192,  1016,   194,   195,   196,   197,   198,
     199,   200,  1017,   202,   203,     0,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,  1018,   217,
     218,   219,   220,   221,   222,   223,   224,  1019,   226,  1020,
    1021,   228,  1022,  1023,  1024,  1025,  1026,     0,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,  1027,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1028,  1029,  1030,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,     0,  1031,   306,   307,   308,   309,   310,  1032,
     312,  1033,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,  1034,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,  1035,  1036,   348,   349,   350,
    1037,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,  1038,   390,
    1039,   392,   393,   394,   395,  1040,  1041,  1042,  1043,   400,
     401,   402,   403,   404,   405,   406,   407,   408,  1044,  1045,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,  1046,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,  1047,
     441,   442,   443,   444,   445,  1048,  1049,   448,   449,   450,
     451,   452,   453,  1050,   455,   456,   457,   458,   459,   460,
    1051,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
    1052,   492,   493,   494,   495,   496,  1053,  1054,   499,   500,
     501,   502,   503,  1055,   505,   506,   507,   508,   509,   510,
    1056,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,     0,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
    1057,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,  1058,
    1059,  1060,  1061,   563,   564,   565,  1062,  1063,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,  1064,   582,  1065,   584,   585,   586,   587,   588,   589,
     590,   591,   592,  1066,  1067,   595,  1068,   597,   598,   599,
       0,   600,   601,   602,  1069,     0,     0,     0,     0,   939,
     940,   941,   942,  1070,  1071,     0,     0,     0,     0,  1072,
     943,   944,     0,   945,  1073,     0,     0,     0,  1074,  1075,
     946,   947,  1076,  1077,   948,   949,   950,   951,     0,   952,
     953,     0,   954,   955,     0,     0,     0,     0,   956,     0,
       0,     0,   957,     0,     0,   958,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   959,   960,   961,     0,   962,
     963,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   964,   965,   966,     0,   967,   968,     0,     0,
       0,   969,   970,   971,     0,     0,     0,     0,     0,     0,
       0,   972,     0,  1539,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     975,     0,     0,     0,     0,   976,   977,     0,   978,     0,
       0,     0,     0,     0,   979,     0,   980,     0,     0,   981,
       0,     0,     0,     0,   984,     0,   985,   986,   987,     0,
     988,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   989,     0,     0,     0,   990,
     991,   992,     0,   993,     0,     0,     0,     0,     0,     0,
     994,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   995,     0,     0,     0,     0,     0,     0,     0,   996,
       0,     0,   997,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   998,     0,     0,     0,     0,     0,   999,  1000,
       0,  1001,  1002,     0,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,  1004,  1005,  1006,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1007,  1008,  1009,     0,
       0,     0,     0,     0,  1010,     0,  1011,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,  1012,  1013,  1014,
     183,   184,   185,  1015,   187,   188,   189,   190,   191,   192,
    1016,   194,   195,   196,   197,   198,   199,   200,  1017,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,  1018,   217,   218,   219,   220,   221,
     222,   223,   224,  1019,   226,  1020,  1021,   228,  1022,  1023,
    1024,  1025,  1026,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,  1027,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1028,
    1029,  1030,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,     0,  1031,
     306,   307,   308,   309,   310,  1032,   312,  1033,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,  1034,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,  1035,  1036,   348,   349,   350,  1037,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,  1038,   390,  1039,   392,   393,   394,
     395,  1040,  1041,  1042,  1043,   400,   401,   402,   403,   404,
     405,   406,   407,   408,  1044,  1045,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,  1046,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,  1047,   441,   442,   443,   444,
     445,  1048,  1049,   448,   449,   450,   451,   452,   453,  1050,
     455,   456,   457,   458,   459,   460,  1051,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,  1052,   492,   493,   494,
     495,   496,  1053,  1054,   499,   500,   501,   502,   503,  1055,
     505,   506,   507,   508,   509,   510,  1056,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,     0,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,  1057,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,  1058,  1059,  1060,  1061,   563,
     564,   565,  1062,  1063,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,  1064,   582,  1065,
     584,   585,   586,   587,   588,   589,   590,   591,   592,  1066,
    1067,   595,  1068,   597,   598,   599,   939,   600,   601,   602,
    1069,     0,     0,     0,     0,     0,     0,     0,     0,  5589,
    5590,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5591,     0,     0,     0,     0,  1075,     0,     0,  1076,  1077,
       0,     0,     0,     0,     0,   956,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   961,     0,     0,   963,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   967,   968,     0,     0,     0,  1576,  1577,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   975,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   981,     0,     0,     0,
       0,     0,     0,     0,   986,   987,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1003,     0,     0,     0,     0,     0,     0,
       0,  1004,  1005,  1006,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,  1578,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,  2435,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,     0,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
    2839,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,  2436,   560,   561,  2437,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,     0,   600,   601,   602,   603,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1076,  1077,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,     0,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,  3090,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,     0,   600,   601,   602,   603,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,  2840,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   769,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,     0,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,     0,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,  1163,
     600,   601,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2840,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1164,     0,
       0,   769,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   172,   173,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,   175,   176,   177,   178,   179,
     180,   181,   182,     0,     0,     0,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,     0,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
    1165,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,     0,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,  1166,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,  1167,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,  1168,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,  1169,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,  1170,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
    1171,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,     0,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,  1172,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,  1173,   596,   597,
     598,   599,  1163,   600,   601,   602,   603,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1164,     0,     0,     0,  1174,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,  1165,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,  1166,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,  1167,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,  1168,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,  1169,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,  1170,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,  1171,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
    1173,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     852,   853,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1174,     0,
       0,     0,     0,     0,     0,   854,     0,     0,     0,     0,
     855,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   856,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   857,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   858,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,     0,     0,     0,   859,
       0,     0,     0,     0,   860,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   786,     0,     0,     0,     0,     0,     0,
     861,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     862,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   863,     0,     0,
       0,     0,     0,     0,     0,   864,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   690,
       0,     0,     0,     0,     0,     0,   865,     0,     0,     0,
       0,     0,     0,     0,     0,   866,   867,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   868,
     286,   287,   288,   289,   869,   291,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   870,   300,   301,   302,   303,
     304,     0,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   871,   457,   458,   459,   872,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   873,   478,   479,   480,   481,
     874,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   875,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,     0,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   876,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,     0,
     600,   601,   602,   603,  1141,   853,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   854,
       0,     0,     0,     0,   855,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   856,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   857,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   858,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
       0,     0,     0,   859,     0,     0,     0,     0,   860,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   786,     0,     0,
       0,     0,     0,     0,   861,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   862,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   863,     0,     0,     0,     0,     0,     0,     0,   864,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   690,     0,     0,     0,     0,     0,     0,
     865,     0,     0,     0,     0,     0,     0,     0,     0,   866,
     867,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,  1142,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   868,   286,   287,   288,   289,   869,   291,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   870,
     300,   301,   302,   303,   304,     0,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   871,   457,
     458,   459,  1143,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   873,
     478,   479,   480,   481,   874,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   875,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
    1806,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   876,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,     0,   600,   601,   602,   603,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   786,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   690,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,     0,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,     0,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,  1901,
     600,   601,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1576,  1577,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,     0,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,  4709,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,     0,
     600,   601,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,  1902,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     4,   600,   601,   602,   603,
       0,     0,     0,     0,   896,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   897,     0,     0,     0,     0,     0,    13,
       0,     0,     0,     0,   898,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,    15,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   899,     0,     0,     0,     0,     0,     0,
     900,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    20,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    28,     0,     0,     0,
       0,   901,   902,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    39,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,     0,   178,     0,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,     0,   194,   195,   196,   197,
     198,   199,   200,   201,     0,   903,     0,     0,   205,   206,
     207,   208,   209,     0,     0,   212,   213,   214,   215,     0,
       0,     0,   219,   220,   221,   222,   223,   904,   225,   226,
     227,     0,   228,     0,     0,     0,     0,     0,     0,   234,
       0,   236,     0,   238,   239,     0,   241,   242,   243,   244,
     245,   246,     0,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,   272,   273,
     274,   275,     0,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,     0,     0,     0,   291,     0,   905,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,     0,     0,     0,     0,   306,   307,   308,   309,   310,
     311,   312,   313,     0,   315,   316,     0,   318,   319,     0,
       0,   321,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,     0,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     906,     0,     0,     0,   434,   435,     0,   437,   438,   439,
     440,     0,   442,   443,   444,   445,   446,   447,     0,     0,
       0,     0,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     0,   479,
       0,   481,   482,     0,   484,   485,     0,   487,   488,   489,
     490,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,     0,   502,   503,   504,     0,   506,   507,   508,   509,
       0,   511,   512,     0,     0,   515,     0,     0,   518,   519,
     520,     0,   522,     0,   524,   525,   526,   527,     0,   528,
     529,   530,   531,     0,   533,   534,  4728,   536,     0,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,     0,
     559,   560,   561,   562,   563,   564,   565,   566,     0,   568,
     569,   570,     0,   572,   573,   574,   575,     0,     0,   578,
     579,     0,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   738,     0,   597,   598,
       0,     0,   600,     0,   602,   603,     0,     0,     0,     0,
     172,   173,     0,     0,     0,  3189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5389,     0,
    3190,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   739,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,  4729,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,  4233,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   172,   173,     0,     0,     0,     0,  4471,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   690,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,     0,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,     0,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,     0,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,  1759,   600,   601,   602,
     603,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1760,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   172,
     173,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   786,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1761,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   690,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   174,   175,   176,   177,
     178,   179,   180,   181,   182,     0,     0,     0,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,     0,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,     0,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,     0,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,     0,   600,   601,   602,   603,  4017,
    4018,     0,  1762,     0,     0,  4019,  4020,     0,     0,     0,
       0,     0,     0,     0,     0,  4021,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4022,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4023,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4024,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   172,   173,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4025,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4026,  4027,     0,  4028,     0,     0,     0,     0,     0,     0,
       0,  4029,  4030,  4031,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4032,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4033,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4034,     0,     0,     0,     0,     0,  4035,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4036,  4037,  4038,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4039,  4040,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,   176,   177,   178,   179,   180,   181,   182,     0,
       0,     0,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,     0,   204,  5165,   206,  5166,  5167,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,  5168,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
    5169,   259,  5170,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,  5171,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,  5172,   302,   303,   304,
       0,   305,   306,   307,   308,   309,   310,  5173,  5174,   313,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,  5175,
     343,   344,   345,   346,   347,   348,   349,   350,  5176,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,  5177,  5178,  5179,   400,   401,   402,
     403,   404,  5180,  5181,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,  5182,
    5183,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,  5184,  5185,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,  5186,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,  5187,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,     0,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,  5188,   557,   558,  5189,   560,   561,
    5190,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,  5191,   586,   587,   588,   589,   590,   591,
     592,   593,   594,  3466,   596,   597,   598,   599,  1775,   600,
     601,   602,  5192,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1776,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   172,   173,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     786,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   690,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,     0,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,     0,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,     0,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,  1759,   600,   601,   602,
     603,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1760,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   172,
     173,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   786,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   690,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   174,   175,   176,   177,
     178,   179,   180,   181,   182,     0,     0,     0,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,     0,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,     0,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,  1759,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,     0,   600,   601,   602,   603,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   786,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   690,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,     0,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,  1294,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,     0,
     600,   601,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1295,  1296,     0,     0,     0,   172,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1297,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,     0,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
       0,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,  1395,   600,   601,   602,   603,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   786,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   690,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,     0,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,     0,   525,   526,   527,
       0,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,     4,   600,   601,   602,   603,     0,     0,
       0,     0,   896,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1669,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -449,  -449,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   897,     0,     0,     0,     0,     0,    13,     0,     0,
       0,     0,   898,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,    15,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   899,     0,     0,     0,     0,     0,     0,   900,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    28,     0,     0,     0,     0,   901,
     902,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    39,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,     0,   178,     0,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,     0,   194,   195,   196,   197,   198,   199,
     200,   201,     0,   903,     0,     0,   205,   206,   207,   208,
     209,     0,     0,   212,   213,   214,   215,     0,     0,     0,
     219,   220,   221,   222,   223,   904,   225,   226,   227,     0,
     228,     0,     0,     0,     0,     0,     0,   234,     0,   236,
       0,   238,   239,     0,   241,   242,   243,   244,   245,   246,
       0,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,   272,   273,   274,   275,
    -449,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,     0,     0,     0,   291,     0,   905,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,     0,
       0,     0,     0,   306,   307,   308,   309,   310,   311,   312,
     313,     0,   315,   316,     0,   318,   319,     0,     0,   321,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   906,     0,
       0,     0,   434,   435,     0,   437,   438,   439,   440,     0,
     442,   443,   444,   445,   446,   447,     0,     0,     0,     0,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,     0,   479,     0,   481,
     482,     0,   484,   485,     0,   487,   488,   489,   490,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,     0,
     502,   503,   504,     0,   506,   507,   508,   509,     0,   511,
     512,     0,     0,   515,     0,     0,   518,   519,   520,     0,
     522,     0,   524,   525,   526,   527,     0,   528,   529,   530,
     531,     0,   533,   534,     0,   536,     0,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,     4,   559,   560,
     561,   562,   563,   564,   565,   566,   896,   568,   569,   570,
       0,   572,   573,   574,   575,     0,     0,   578,   579,     0,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,     0,     0,   597,   598,     0,     0,
     600,     0,   602,   603,  -469,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   897,     0,     0,     0,     0,
       0,    13,     0,     0,     0,     0,   898,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
      15,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   899,     0,     0,     0,     0,
       0,     0,   900,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    20,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    28,     0,
       0,     0,     0,   901,   902,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -469,     0,    39,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,     0,   178,
       0,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,     0,   194,   195,
     196,   197,   198,   199,   200,   201,     0,   903,     0,     0,
     205,   206,   207,   208,   209,     0,     0,   212,   213,   214,
     215,     0,     0,     0,   219,   220,   221,   222,   223,   904,
     225,   226,   227,     0,   228,     0,     0,     0,     0,     0,
       0,   234,     0,   236,     0,   238,   239,     0,   241,   242,
     243,   244,   245,   246,     0,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,     0,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
     272,   273,   274,   275,  -469,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,     0,     0,     0,   291,
       0,   905,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,     0,     0,     0,     0,   306,   307,   308,
     309,   310,   311,   312,   313,     0,   315,   316,     0,   318,
     319,     0,     0,   321,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,     0,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   906,     0,     0,     0,   434,   435,     0,   437,
     438,   439,   440,     0,   442,   443,   444,   445,   446,   447,
       0,     0,     0,     0,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
       0,   479,     0,   481,   482,     0,   484,   485,     0,   487,
     488,   489,   490,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,     0,   502,   503,   504,     0,   506,   507,
     508,   509,     0,   511,   512,     0,     0,   515,     0,     0,
     518,   519,   520,     0,   522,     0,   524,   525,   526,   527,
       0,   528,   529,   530,   531,     0,   533,   534,     0,   536,
       0,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,     4,   559,   560,   561,   562,   563,   564,   565,   566,
     896,   568,   569,   570,     0,   572,   573,   574,   575,     0,
       0,   578,   579,     0,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,     0,     0,
     597,   598,     0,     0,   600,     0,   602,   603,  -466,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   897,
       0,     0,     0,     0,     0,    13,     0,     0,     0,     0,
     898,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,    15,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   899,
       0,     0,     0,     0,     0,     0,   900,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    20,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,     0,     0,     0,     0,   901,   902,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -466,     0,
      39,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,     0,   178,     0,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,     0,   194,   195,   196,   197,   198,   199,   200,   201,
       0,   903,     0,     0,   205,   206,   207,   208,   209,     0,
       0,   212,   213,   214,   215,     0,     0,     0,   219,   220,
     221,   222,   223,   904,   225,   226,   227,     0,   228,     0,
       0,     0,     0,     0,     0,   234,     0,   236,     0,   238,
     239,     0,   241,   242,   243,   244,   245,   246,     0,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,     0,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,   272,   273,   274,   275,  -466,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
       0,     0,     0,   291,     0,   905,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,     0,     0,     0,
       0,   306,   307,   308,   309,   310,   311,   312,   313,     0,
     315,   316,     0,   318,   319,     0,     0,   321,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
       0,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   906,     0,     0,     0,
     434,   435,     0,   437,   438,   439,   440,     0,   442,   443,
     444,   445,   446,   447,     0,     0,     0,     0,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,     0,   479,     0,   481,   482,     0,
     484,   485,     0,   487,   488,   489,   490,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,     0,   502,   503,
     504,     0,   506,   507,   508,   509,     0,   511,   512,     0,
       0,   515,     0,     0,   518,   519,   520,     0,   522,     0,
     524,   525,   526,   527,     0,   528,   529,   530,   531,     0,
     533,   534,     0,   536,     0,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,     4,   559,   560,   561,   562,
     563,   564,   565,   566,   896,   568,   569,   570,     0,   572,
     573,   574,   575,     0,     0,   578,   579,     0,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,     0,     0,   597,   598,     0,     0,   600,     0,
     602,   603,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   897,     0,     0,     0,     0,     0,    13,
       0,     0,     0,     0,   898,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,    15,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   899,     0,     0,     0,     0,     0,     0,
     900,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    20,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    28,     0,     0,     0,
       0,   901,   902,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    39,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,     0,   178,     0,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,     0,   194,   195,   196,   197,
     198,   199,   200,   201,     0,   903,     0,     0,   205,   206,
     207,   208,   209,     0,     0,   212,   213,   214,   215,     0,
       0,     0,   219,   220,   221,   222,   223,   904,   225,   226,
     227,     0,   228,     0,     0,     0,     0,     0,     0,   234,
       0,   236,     0,   238,   239,     0,   241,   242,   243,   244,
     245,   246,     0,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,   272,   273,
     274,   275,  1525,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,     0,     0,     0,   291,     0,   905,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,     0,     0,     0,     0,   306,   307,   308,   309,   310,
     311,   312,   313,     0,   315,   316,     0,   318,   319,     0,
       0,   321,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,     0,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     906,     0,     0,     0,   434,   435,     0,   437,   438,   439,
     440,     0,   442,   443,   444,   445,   446,   447,     0,     0,
       0,     0,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     0,   479,
       0,   481,   482,     0,   484,   485,     0,   487,   488,   489,
     490,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,     0,   502,   503,   504,     0,   506,   507,   508,   509,
       0,   511,   512,     0,     0,   515,     0,     0,   518,   519,
     520,     0,   522,     0,   524,   525,   526,   527,     0,   528,
     529,   530,   531,     0,   533,   534,     0,   536,     0,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,     4,
     559,   560,   561,   562,   563,   564,   565,   566,   896,   568,
     569,   570,     0,   572,   573,   574,   575,     0,     0,   578,
     579,     0,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,     0,     0,   597,   598,
       0,     0,   600,     0,   602,   603,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   897,     0,     0,
       0,     0,     0,    13,     0,     0,     0,     0,   898,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,    15,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   899,     0,     0,
       0,     0,     0,     0,   900,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    20,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      28,     0,     0,     0,     0,   901,   902,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    39,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
       0,   178,     0,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,     0,
     194,   195,   196,   197,   198,   199,   200,   201,     0,   903,
       0,     0,   205,   206,   207,   208,   209,     0,     0,   212,
     213,   214,   215,     0,     0,     0,   219,   220,   221,   222,
     223,   904,   225,   226,   227,     0,   228,     0,     0,     0,
       0,     0,     0,   234,     0,   236,     0,   238,   239,     0,
     241,   242,   243,   244,   245,   246,     0,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,   272,   273,   274,   275,  -471,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,     0,     0,
       0,   291,     0,   905,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,     0,     0,     0,     0,   306,
     307,   308,   309,   310,   311,   312,   313,     0,   315,   316,
       0,   318,   319,     0,     0,   321,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   906,     0,     0,     0,   434,   435,
       0,   437,   438,   439,   440,     0,   442,   443,   444,   445,
     446,   447,     0,     0,     0,     0,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     0,   479,     0,   481,   482,     0,   484,   485,
       0,   487,   488,   489,   490,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,     0,   502,   503,   504,     0,
     506,   507,   508,   509,     0,   511,   512,     0,     0,   515,
       0,     0,   518,   519,   520,     0,   522,     0,   524,   525,
     526,   527,     0,   528,   529,   530,   531,     0,   533,   534,
       0,   536,     0,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,     4,   559,   560,   561,   562,   563,   564,
     565,   566,   896,   568,   569,   570,     0,   572,   573,   574,
     575,     0,     0,   578,   579,     0,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
       0,     0,   597,   598,     0,     0,   600,     0,   602,   603,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   897,     0,     0,     0,     0,     0,    13,     0,     0,
       0,     0,   898,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,    15,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   899,     0,     0,     0,     0,     0,     0,   900,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    28,     0,     0,     0,     0,   901,
     902,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    39,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,     0,   178,     0,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,     0,   194,   195,   196,   197,   198,   199,
     200,   201,     0,   903,     0,     0,   205,   206,   207,   208,
     209,     0,     0,   212,   213,   214,   215,     0,     0,     0,
     219,   220,   221,   222,   223,   904,   225,   226,   227,     0,
     228,     0,     0,     0,     0,     0,     0,   234,     0,   236,
       0,   238,   239,     0,   241,   242,   243,   244,   245,   246,
       0,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,   272,   273,   274,   275,
    3432,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,     0,     0,     0,   291,     0,   905,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,     0,
       0,     0,     0,   306,   307,   308,   309,   310,   311,   312,
     313,     0,   315,   316,     0,   318,   319,     0,     0,   321,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   906,     0,
       0,     0,   434,   435,     0,   437,   438,   439,   440,     0,
     442,   443,   444,   445,   446,   447,     0,     0,     0,     0,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,     0,   479,     0,   481,
     482,     0,   484,   485,     0,   487,   488,   489,   490,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,     0,
     502,   503,   504,     0,   506,   507,   508,   509,     0,   511,
     512,     0,     0,   515,     0,     0,   518,   519,   520,     0,
     522,     0,   524,   525,   526,   527,     0,   528,   529,   530,
     531,     0,   533,   534,     0,   536,     0,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,     4,   559,   560,
     561,   562,   563,   564,   565,   566,   896,   568,   569,   570,
       0,   572,   573,   574,   575,     0,     0,   578,   579,     0,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,     0,     0,   597,   598,     0,     0,
     600,     0,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   897,     0,     0,     0,     0,
       0,    13,     0,     0,     0,     0,   898,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
      15,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   899,     0,     0,     0,     0,
       0,     0,   900,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    20,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    28,     0,
       0,     0,     0,   901,   902,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    39,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,     0,   178,
       0,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,     0,   194,   195,
     196,   197,   198,   199,   200,   201,     0,   903,     0,     0,
     205,   206,   207,   208,   209,     0,     0,   212,   213,   214,
     215,     0,     0,     0,   219,   220,   221,   222,   223,   904,
     225,   226,   227,     0,   228,     0,     0,     0,     0,     0,
       0,   234,     0,   236,     0,   238,   239,     0,   241,   242,
     243,   244,   245,   246,     0,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,     0,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
     272,   273,   274,   275,  3484,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,     0,     0,     0,   291,
       0,   905,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,     0,     0,     0,     0,   306,   307,   308,
     309,   310,   311,   312,   313,     0,   315,   316,     0,   318,
     319,     0,     0,   321,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,     0,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   906,     0,     0,     0,   434,   435,     0,   437,
     438,   439,   440,     0,   442,   443,   444,   445,   446,   447,
       0,     0,     0,     0,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
       0,   479,     0,   481,   482,     0,   484,   485,     0,   487,
     488,   489,   490,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,     0,   502,   503,   504,     0,   506,   507,
     508,   509,     0,   511,   512,     0,     0,   515,     0,     0,
     518,   519,   520,     0,   522,     0,   524,   525,   526,   527,
       0,   528,   529,   530,   531,     0,   533,   534,     0,   536,
       0,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,     4,   559,   560,   561,   562,   563,   564,   565,   566,
     896,   568,   569,   570,     0,   572,   573,   574,   575,     0,
       0,   578,   579,     0,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,     0,     0,
     597,   598,     0,     0,   600,     0,   602,   603,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   897,
       0,     0,     0,     0,     0,    13,     0,     0,     0,     0,
     898,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,    15,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   899,
       0,     0,     0,     0,     0,     0,   900,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    20,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,     0,     0,     0,     0,   901,   902,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      39,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,     0,   178,     0,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,     0,   194,   195,   196,   197,   198,   199,   200,   201,
       0,   903,     0,     0,   205,   206,   207,   208,   209,     0,
       0,   212,   213,   214,   215,     0,     0,     0,   219,   220,
     221,   222,   223,   904,   225,   226,   227,     0,   228,     0,
       0,     0,     0,     0,     0,   234,     0,   236,     0,   238,
     239,     0,   241,   242,   243,   244,   245,   246,     0,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,     0,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,   272,   273,   274,   275,  3696,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
       0,     0,     0,   291,     0,   905,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,     0,     0,     0,
       0,   306,   307,   308,   309,   310,   311,   312,   313,     0,
     315,   316,     0,   318,   319,     0,     0,   321,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
       0,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   906,     0,     0,     0,
     434,   435,     0,   437,   438,   439,   440,     0,   442,   443,
     444,   445,   446,   447,     0,     0,     0,     0,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,     0,   479,     0,   481,   482,     0,
     484,   485,     0,   487,   488,   489,   490,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,     0,   502,   503,
     504,     0,   506,   507,   508,   509,     0,   511,   512,     0,
       0,   515,     0,     0,   518,   519,   520,     0,   522,     0,
     524,   525,   526,   527,     0,   528,   529,   530,   531,     0,
     533,   534,     0,   536,     0,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,     4,   559,   560,   561,   562,
     563,   564,   565,   566,   896,   568,   569,   570,     0,   572,
     573,   574,   575,     0,     0,   578,   579,     0,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,     0,     0,   597,   598,     0,     0,   600,     0,
     602,   603,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   897,     0,     0,     0,     0,     0,    13,
       0,     0,     0,     0,   898,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,    15,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   899,     0,     0,     0,     0,     0,     0,
     900,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    20,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    28,     0,     0,     0,
       0,   901,   902,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    39,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,     0,   178,     0,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,     0,   194,   195,   196,   197,
     198,   199,   200,   201,     0,   903,     0,     0,   205,   206,
     207,   208,   209,     0,     0,   212,   213,   214,   215,     0,
       0,     0,   219,   220,   221,   222,   223,   904,   225,   226,
     227,     0,   228,     0,     0,     0,     0,     0,     0,   234,
       0,   236,     0,   238,   239,     0,   241,   242,   243,   244,
     245,   246,     0,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,   272,   273,
     274,   275,  3709,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,     0,     0,     0,   291,     0,   905,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,     0,     0,     0,     0,   306,   307,   308,   309,   310,
     311,   312,   313,     0,   315,   316,     0,   318,   319,     0,
       0,   321,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,     0,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     906,     0,     0,     0,   434,   435,     0,   437,   438,   439,
     440,     0,   442,   443,   444,   445,   446,   447,     0,     0,
       0,     0,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     0,   479,
       0,   481,   482,     0,   484,   485,     0,   487,   488,   489,
     490,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,     0,   502,   503,   504,     0,   506,   507,   508,   509,
       0,   511,   512,     0,     0,   515,     0,     0,   518,   519,
     520,     0,   522,     0,   524,   525,   526,   527,     0,   528,
     529,   530,   531,     0,   533,   534,     0,   536,     0,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,     4,
     559,   560,   561,   562,   563,   564,   565,   566,   896,   568,
     569,   570,     0,   572,   573,   574,   575,     0,     0,   578,
     579,     0,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,     0,     0,   597,   598,
       0,     0,   600,     0,   602,   603,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   897,     0,     0,
       0,     0,     0,    13,     0,     0,     0,     0,   898,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,    15,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   899,     0,     0,
       0,     0,     0,     0,   900,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    20,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      28,     0,     0,     0,     0,   901,   902,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    39,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
       0,   178,     0,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,     0,
     194,   195,   196,   197,   198,   199,   200,   201,     0,   903,
       0,     0,   205,   206,   207,   208,   209,     0,     0,   212,
     213,   214,   215,     0,     0,     0,   219,   220,   221,   222,
     223,   904,   225,   226,   227,     0,   228,     0,     0,     0,
       0,     0,     0,   234,     0,   236,     0,   238,   239,     0,
     241,   242,   243,   244,   245,   246,     0,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,   272,   273,   274,   275,  4092,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,     0,     0,
       0,   291,     0,   905,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,     0,     0,     0,     0,   306,
     307,   308,   309,   310,   311,   312,   313,     0,   315,   316,
       0,   318,   319,     0,     0,   321,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   906,     0,     0,     0,   434,   435,
       0,   437,   438,   439,   440,     0,   442,   443,   444,   445,
     446,   447,     0,     0,     0,     0,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     0,   479,     0,   481,   482,     0,   484,   485,
       0,   487,   488,   489,   490,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,     0,   502,   503,   504,     0,
     506,   507,   508,   509,     0,   511,   512,     0,     0,   515,
       0,     0,   518,   519,   520,     0,   522,     0,   524,   525,
     526,   527,     0,   528,   529,   530,   531,     0,   533,   534,
       0,   536,     0,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,     4,   559,   560,   561,   562,   563,   564,
     565,   566,   896,   568,   569,   570,     0,   572,   573,   574,
     575,     0,     0,   578,   579,     0,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
       0,     0,   597,   598,     0,     0,   600,     0,   602,   603,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   897,     0,     0,     0,     0,     0,    13,     0,     0,
       0,     0,   898,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,    15,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   899,     0,     0,     0,     0,     0,     0,   900,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    28,     0,     0,     0,     0,   901,
     902,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    39,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,     0,   178,     0,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,     0,   194,   195,   196,   197,   198,   199,
     200,   201,     0,   903,     0,     0,   205,   206,   207,   208,
     209,     0,     0,   212,   213,   214,   215,     0,     0,     0,
     219,   220,   221,   222,   223,   904,   225,   226,   227,     0,
     228,     0,     0,     0,     0,     0,     0,   234,     0,   236,
       0,   238,   239,     0,   241,   242,   243,   244,   245,   246,
       0,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,   272,   273,   274,   275,
    4989,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,     0,     0,     0,   291,     0,   905,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,     0,
       0,     0,     0,   306,   307,   308,   309,   310,   311,   312,
     313,     0,   315,   316,     0,   318,   319,     0,     0,   321,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   906,     0,
       0,     0,   434,   435,     0,   437,   438,   439,   440,     0,
     442,   443,   444,   445,   446,   447,     0,     0,     0,     0,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,     0,   479,     0,   481,
     482,     0,   484,   485,     0,   487,   488,   489,   490,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,     0,
     502,   503,   504,     0,   506,   507,   508,   509,     0,   511,
     512,     0,     0,   515,     0,     0,   518,   519,   520,     0,
     522,     0,   524,   525,   526,   527,     0,   528,   529,   530,
     531,     0,   533,   534,     0,   536,     0,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,     4,   559,   560,
     561,   562,   563,   564,   565,   566,   896,   568,   569,   570,
       0,   572,   573,   574,   575,     0,     0,   578,   579,     0,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,     0,     0,   597,   598,     0,     0,
     600,     0,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   897,     0,     0,     0,     0,
       0,    13,     0,     0,     0,     0,   898,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
      15,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   899,     0,     0,     0,     0,
       0,     0,   900,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    20,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    28,     0,
       0,     0,     0,   901,   902,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    39,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,     0,   178,
       0,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,     0,   194,   195,
     196,   197,   198,   199,   200,   201,     0,   903,     0,     0,
     205,   206,   207,   208,   209,     0,     0,   212,   213,   214,
     215,     0,     0,     0,   219,   220,   221,   222,   223,   904,
     225,   226,   227,     0,   228,     0,     0,     0,     0,     0,
       0,   234,     0,   236,     0,   238,   239,     0,   241,   242,
     243,   244,   245,   246,     0,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,     0,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
     272,   273,   274,   275,  -453,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,     0,     0,     0,   291,
       0,   905,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,     0,     0,     0,     0,   306,   307,   308,
     309,   310,   311,   312,   313,     0,   315,   316,     0,   318,
     319,     0,     0,   321,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,     0,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   906,     0,     0,     0,   434,   435,     0,   437,
     438,   439,   440,     0,   442,   443,   444,   445,   446,   447,
       0,     0,     0,     0,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
       0,   479,     0,   481,   482,     0,   484,   485,     0,   487,
     488,   489,   490,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,     0,   502,   503,   504,     0,   506,   507,
     508,   509,     0,   511,   512,     0,     0,   515,     0,     0,
     518,   519,   520,     0,   522,     0,   524,   525,   526,   527,
       0,   528,   529,   530,   531,     0,   533,   534,     0,   536,
       0,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,     4,   559,   560,   561,   562,   563,   564,   565,   566,
     896,   568,   569,   570,     0,   572,   573,   574,   575,     0,
       0,   578,   579,     0,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,     0,     0,
     597,   598,     0,     0,   600,     0,   602,   603,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   897,
       0,     0,     0,     0,     0,    13,     0,     0,     0,     0,
     898,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,    15,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   899,
       0,     0,     0,     0,     0,     0,   900,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    20,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,     0,     0,     0,     0,   901,   902,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      39,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,     0,   178,     0,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,     0,   194,   195,   196,   197,   198,   199,   200,   201,
       0,   903,     0,     0,   205,   206,   207,   208,   209,     0,
       0,   212,   213,   214,   215,     0,     0,     0,   219,   220,
     221,   222,   223,   904,   225,   226,   227,     0,   228,     0,
       0,     0,     0,     0,     0,   234,     0,   236,     0,   238,
     239,     0,   241,   242,   243,   244,   245,   246,     0,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,     0,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,   272,   273,   274,   275,     0,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
       0,     0,     0,   291,     0,   905,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,     0,     0,     0,
       0,   306,   307,   308,   309,   310,   311,   312,   313,     0,
     315,   316,     0,   318,   319,     0,     0,   321,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
       0,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   906,     0,     0,     0,
     434,   435,     0,   437,   438,   439,   440,     0,   442,   443,
     444,   445,   446,   447,     0,     0,     0,     0,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,     0,   479,     0,   481,   482,     0,
     484,   485,     0,   487,   488,   489,   490,   491,   492,     0,
     494,   495,   496,   497,   498,   499,   500,     0,   502,   503,
     504,     0,   506,   507,   508,   509,     0,   511,   512,     0,
       0,   515,     0,     0,   518,   519,   520,     0,   522,     0,
     524,   525,   526,   527,     0,   528,   529,   530,   531,     0,
     533,   534,     0,   536,     0,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,     4,   559,   560,   561,   562,
     563,   564,   565,   566,   896,   568,   569,   570,     0,   572,
     573,   574,   575,     0,     0,   578,   579,     0,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,     0,     0,   597,   598,     0,     0,   600,     0,
     602,   603,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   897,     0,     0,     0,     0,     0,    13,
       0,     0,     0,     0,   898,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,    15,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   899,     0,     0,     0,     0,     0,     0,
     900,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    20,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    28,     0,     0,     0,
       0,   901,   902,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    39,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,     0,   178,     0,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,     0,   194,   195,   196,   197,
     198,   199,   200,   201,     0,   903,     0,     0,   205,   206,
     207,   208,   209,     0,     0,   212,   213,   214,   215,     0,
       0,     0,   219,   220,   221,   222,   223,   904,   225,   226,
     227,     0,   228,     0,     0,     0,     0,     0,     0,   234,
       0,   236,     0,   238,   239,     0,   241,   242,   243,   244,
     245,   246,     0,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,   272,   273,
     274,   275,     0,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,     0,     0,     0,   291,     0,   905,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,     0,     0,     0,     0,   306,   307,   308,   309,   310,
     311,   312,   313,     0,   315,   316,     0,   318,   319,     0,
       0,   321,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,     0,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     906,     0,     0,     0,   434,   435,     0,   437,   438,   439,
     440,     0,   442,   443,   444,   445,   446,   447,     0,     0,
       0,     0,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     0,   479,
       0,   481,   482,     0,   484,   485,     0,   487,   488,   489,
     490,   491,   492,     0,   494,   495,   496,   497,   498,   499,
     500,     0,   502,   503,   504,     0,   506,   507,   508,   509,
       0,   511,   512,     0,     0,   515,     0,     0,   518,   519,
     520,     0,   522,     0,   524,   525,   526,   527,     0,   528,
     529,   530,   531,     4,   533,   534,     0,   536,     0,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,     0,
     559,   560,   561,   562,   563,   564,   565,   566,     0,   568,
     569,   570,     0,   572,   573,   574,   575,     0,     0,   578,
    1744,     0,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,     0,    13,   597,   598,
       0,     0,   600,     0,   602,   603,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,    15,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    28,     0,     0,     0,     0,   901,
     902,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    39,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,     0,   178,     0,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,     0,   194,   195,   196,   197,   198,   199,
     200,   201,     0,   903,     0,     0,   205,   206,   207,   208,
     209,     0,     0,   212,   213,   214,   215,     0,     0,     0,
     219,   220,   221,   222,   223,     0,   225,   226,   227,     0,
     228,     0,     0,     0,     0,     0,     0,   234,     0,   236,
       0,   238,   239,     0,   241,   242,   243,   244,   245,   246,
       0,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,   272,   273,   274,   275,
       0,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,     0,     0,     0,   291,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,     0,
       0,     0,     0,   306,   307,   308,   309,   310,   311,   312,
     313,     0,   315,   316,     0,   318,   319,     0,     0,   321,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,     0,     0,
       0,     0,   434,   435,     0,   437,   438,   439,   440,     0,
     442,   443,   444,   445,   446,   447,     0,     0,     0,     0,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,     0,   479,     0,   481,
     482,     0,   484,   485,     0,   487,   488,   489,   490,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,     0,
     502,   503,   504,     0,   506,   507,   508,   509,     0,   511,
     512,     0,     0,   515,     0,     0,   518,   519,   520,     0,
     522,     0,   524,   525,   526,   527,     0,   528,   529,   530,
     531,     0,   533,   534,     0,   536,     0,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,     0,   559,   560,
     561,   562,   563,   564,   565,   566,     0,   568,   569,   570,
       0,   572,   573,   574,   575,  3462,  3463,   578,   579,     0,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,     0,     0,   597,   598,     0,     0,
     600,     0,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
    3464,  3465,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,     0,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
       0,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,  3466,   596,
     597,   598,   599,     0,   600,   601,   602,   603,  1395,   855,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   172,   173,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   786,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   690,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,   176,   177,   178,   179,   180,   181,   182,     0,
       0,     0,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,     0,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
       0,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,     0,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,  1395,   600,
     601,   602,   603,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   172,   173,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   786,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   690,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,   176,   177,   178,   179,   180,   181,   182,     0,
       0,     0,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,     0,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
       0,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,     0,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,  1330,   600,
     601,   602,   603,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,     0,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,     0,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   855,
     600,   601,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1331,     0,     0,     0,     0,  1332,     0,
       0,   769,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   172,   173,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   786,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   690,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,   176,   177,   178,   179,   180,   181,   182,     0,
       0,     0,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,     0,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
       0,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,     0,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,     0,   600,
     601,   602,   603,  2202,     0,     0,     0,  4893,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2203,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3805,     0,     0,     0,     0,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3806,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3807,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   690,     0,     0,     0,     0,     0,     0,     0,     0,
    3808,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,     0,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,     0,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,     0,   600,   601,   602,   603,  2202,     0,     0,     0,
    5701,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2203,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3805,     0,     0,     0,     0,   172,
     173,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3806,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3807,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   690,     0,     0,     0,     0,     0,
       0,     0,     0,  3808,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   174,   175,   176,   177,
     178,   179,   180,   181,   182,     0,     0,     0,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,     0,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,     0,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,     0,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,     0,   600,   601,   602,   603,  2202,
       0,     0,     0,  5806,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2203,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3805,     0,     0,
       0,     0,   172,   173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3806,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3807,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   690,     0,     0,
       0,     0,     0,     0,     0,     0,  3808,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,     0,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,     0,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,  3106,   600,   601,
     602,   603,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   786,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   690,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,     0,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,     0,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,  1752,   600,   601,   602,   603,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,  1752,   600,   601,   602,   603,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,     0,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,     0,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,  2494,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,  3182,
     600,   601,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,     0,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
       0,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,  4824,   600,   601,   602,   603,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,     0,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,     0,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,  4842,   600,   601,
     602,   603,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,     0,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,     0,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,  3120,   600,   601,   602,   603,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   690,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,     0,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
    3121,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,  2351,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5886,     0,     0,     0,     0,     0,     0,  2352,  5887,   786,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   690,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1773,   786,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   690,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1990,   786,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   690,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2366,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,  2351,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2352,  5887,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1902,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    31,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    38,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    40,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1331,
       0,     0,     0,     0,     0,     0,     0,   769,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,  1578,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1579,
       0,     0,     0,     0,     0,     0,     0,  1076,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1331,
       0,     0,     0,     0,  1332,     0,     0,   769,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,  1578,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1076,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,  2351,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2352,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1331,
       0,     0,     0,     0,     0,     0,     0,   769,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
    2840,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   769,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,  4790,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4470,
       0,     0,     0,     0,     0,     0,     0,  4471,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4471,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   766,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   767,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   768,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   769,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   769,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4471,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,  2872,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2410,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   686,   687,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5237,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5238,   657,  5239,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,  1513,   600,   601,   602,   603,
    1514,     0,     0,     0,     0,     0,     0,     0,     0,  2873,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,  1515,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,  1445,   600,   601,   602,   603,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,  2416,  2417,  2418,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
    4237,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
    2816,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
    4003,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,     0,     0,     0,     0,     0,     0,     0,
    4704,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
    5048,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
    5283,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   786,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1761,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   690,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,  1762,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2001,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2002,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   989,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2003,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2004,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,  2005,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2001,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2002,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   989,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3985,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2004,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,  2005,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2001,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2002,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   989,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2004,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,  2005,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,  2416,  2417,  2418,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   657,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   786,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   690,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   657,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4277,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   690,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5519,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   698,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
    1576,  1577,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,  1921,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2505,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,  3209,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,  3210,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
    3466,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
       0,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   690,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,     0,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,     0,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,     0,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
    3121,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1511,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
       0,   178,     0,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,     0,
     194,   195,   196,   197,   198,   199,   200,   201,     0,     0,
       0,     0,   205,   206,   207,   208,   209,     0,     0,   212,
     213,   214,   215,     0,     0,     0,   219,   220,   221,   222,
     223,     0,   225,   226,   227,     0,   228,     0,     0,     0,
       0,     0,     0,   234,     0,   236,     0,   238,   239,     0,
     241,   242,   243,   244,   245,   246,     0,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,   272,   273,   274,   275,     0,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,     0,     0,
       0,   291,     0,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,     0,     0,     0,     0,   306,
     307,   308,   309,   310,   311,   312,   313,     0,   315,   316,
       0,   318,   319,     0,     0,   321,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
       0,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   172,   173,     0,     0,   434,   435,
       0,   437,   438,   439,   440,     0,   442,   443,   444,   445,
     446,   447,     0,     0,     0,     0,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     0,   479,     0,   481,   482,     0,   484,   485,
       0,   487,   488,   489,   490,   491,   492,     0,   494,   495,
     496,   497,   498,   499,   500,     0,   502,   503,   504,     0,
     506,   507,   508,   509,     0,   511,   512,     0,     0,   515,
       0,     0,   518,   519,   520,     0,   522,     0,   524,   525,
     526,   527,     0,   528,   529,   530,   531,     0,   533,   534,
       0,   536,     0,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,     0,   559,   560,   561,   562,   563,   564,
     565,   566,     0,   568,   569,   570,     0,   572,   573,   574,
     575,     0,     0,   578,   579,     0,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
       0,     0,   597,   598,     0,     0,   600,     0,   602,   603,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1522,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,     0,   178,     0,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,     0,   194,   195,   196,   197,   198,   199,
     200,   201,     0,     0,     0,     0,   205,   206,   207,   208,
     209,     0,     0,   212,   213,   214,   215,     0,     0,     0,
     219,   220,   221,   222,   223,     0,   225,   226,   227,     0,
     228,     0,     0,     0,     0,     0,     0,   234,     0,   236,
       0,   238,   239,     0,   241,   242,   243,   244,   245,   246,
       0,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,   272,   273,   274,   275,
       0,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,     0,     0,     0,   291,     0,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,     0,
       0,     0,     0,   306,   307,   308,   309,   310,   311,   312,
     313,     0,   315,   316,     0,   318,   319,     0,     0,   321,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   172,   173,
       0,     0,   434,   435,     0,   437,   438,   439,   440,     0,
     442,   443,   444,   445,   446,   447,     0,     0,     0,     0,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,     0,   479,     0,   481,
     482,     0,   484,   485,     0,   487,   488,   489,   490,   491,
     492,     0,   494,   495,   496,   497,   498,   499,   500,     0,
     502,   503,   504,     0,   506,   507,   508,   509,     0,   511,
     512,     0,     0,   515,     0,     0,   518,   519,   520,     0,
     522,     0,   524,   525,   526,   527,     0,   528,   529,   530,
     531,     0,   533,   534,     0,   536,     0,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,     0,   559,   560,
     561,   562,   563,   564,   565,   566,     0,   568,   569,   570,
       0,   572,   573,   574,   575,     0,     0,   578,   579,     0,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,     0,     0,   597,   598,     0,     0,
     600,     0,   602,   603,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,     0,   178,
       0,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,     0,   194,   195,
     196,   197,   198,   199,   200,   201,     0,     0,     0,     0,
     205,   206,   207,   208,   209,     0,     0,   212,   213,   214,
     215,     0,     0,     0,   219,   220,   221,   222,   223,     0,
     225,   226,   227,     0,   228,     0,     0,     0,     0,     0,
       0,   234,     0,   236,     0,   238,   239,     0,   241,   242,
     243,   244,   245,   246,     0,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,     0,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
     272,   273,   274,   275,     0,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,     0,     0,     0,   291,
       0,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,     0,     0,     0,     0,   306,   307,   308,
     309,   310,   311,   312,   313,     0,   315,   316,     0,   318,
     319,     0,     0,   321,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,     0,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,     0,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,     0,     0,     0,     0,   434,   435,     0,   437,
     438,   439,   440,     0,   442,   443,   444,   445,   446,   447,
       0,     0,     0,     0,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
       0,   479,     0,   481,   482,     0,   484,   485,     0,   487,
     488,   489,   490,   491,   492,     0,   494,   495,   496,   497,
     498,   499,   500,     0,   502,   503,   504,     0,   506,   507,
     508,   509,     0,   511,   512,     0,     0,   515,     0,     0,
     518,   519,   520,     0,   522,     0,   524,   525,   526,   527,
       0,   528,   529,   530,   531,     0,   533,   534,     0,   536,
       0,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,     0,   559,   560,   561,   562,   563,   564,   565,   566,
       0,   568,   569,   570,     0,   572,   573,   574,   575,     0,
       0,   578,   579,     0,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,     0,     0,
     597,   598,     0,     0,   600,     0,   602,   603
};

static const yytype_int16 yycheck[] =
{
       3,    44,   163,    68,     0,   671,   672,     0,   672,     0,
      21,   896,   671,   898,   899,   900,   171,  1879,  1743,  1723,
     905,  1357,    25,     0,   697,   752,    29,  1384,   665,   161,
    1670,    34,  2085,  1451,    37,   976,  1558,   907,   671,  1357,
    1565,    52,   671,    45,   781,   649,     0,    58,    51,   671,
    3097,  1736,  2095,  2694,    57,  1355,  1782,  2574,    61,   737,
      30,   665,  1223,   741,   742,  3391,  1574,  3356,  3356,   845,
    2892,  2893,    68,  2882,  1388,   638,  1908,  1596,  3431,  3745,
    3306,  1388,  1851,   638,  1493,  2906,  3272,  2908,   714,  2063,
    1349,   717,  2572,  3148,  1736,  3292,  3294,  1780,  2632,  2909,
    2027,  1291,  3503,  3773,   159,   668,  3332,  3333,  4476,  3295,
     171,  1331,   171,   668,   171,  3162,  1796,  1797,  2735,   171,
    1901,   171,   125,    27,   976,  3356,   824,  2804,  2804,  2660,
    2832,  3227,  1801,  2600,  3750,  3925,  3861,  3861,   938,   135,
    3362,  2735,  2669,    47,   135,  3861,  4598,  1447,  4950,   152,
     153,  1820,    26,   156,     6,  4481,   159,   160,  1168,  1169,
    1170,     9,    10,   649,  3060,  3061,  3062,  1177,    11,  1021,
      28,     6,  3398,  3399,    50,   171,  1845,  1846,   171,   665,
     171,   135,  3010,    11,    26,   671,  2129,  2804,  2131,  2132,
    1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,
    1719,  1720,  1721,  3873,  4348,    93,  2659,  2660,    11,  1934,
    2804,    12,     9,    10,    11,   156,  1901,   171,  3862,  1899,
    3864,     9,    10,  3867,  1076,    61,     6,  4027,  4028,   156,
    2039,  4031,  1136,  4744,    90,    60,  1426,   115,  4038,     6,
     764,  1979,  1694,    93,  4044,     9,    10,  2794,  1463,  1225,
    1702,  1703,    80,  1705,  1706,   137,  3900,     9,    10,  1901,
      11,   185,  4444,    91,    65,  2716,   170,   146,  1138,   105,
    1070,  1071,  1072,    17,  2083,  2806,  3504,     9,    10,    61,
      61,   128,    12,    63,  1084,  1202,     6,    95,   125,   105,
       9,    10,   896,   180,   898,   899,   900,    80,    80,  2727,
      61,   905,   265,   907,     9,    10,  4580,  1224,    91,    91,
     166,    61,   265,     9,    10,    61,   180,   180,    80,  3336,
    3148,   251,   284,  3378,   105,  3405,  4891,  2052,   114,    91,
     197,   375,   299,  4323,   763,    65,   184,    11,   186,   238,
     120,    17,  3354,   156,   105,   265,     9,    10,   197,   152,
     238,   233,    10,  2806,   180,   105,    32,   265,    34,   105,
       9,    10,   105,    95,   238,   223,   366,     9,    10,   105,
      32,   105,     9,    10,  5083,  2855,   105,   118,     9,    10,
     416,     9,    10,   152,   125,     9,    10,   184,   307,   186,
    4401,   381,    80,     9,    10,   378,   184,    83,   186,  4490,
     279,    69,   174,    91,   392,  1522,   288,    80,   211,  1261,
     896,   167,   898,   899,   900,     9,    10,   299,    91,   905,
     184,   907,   186,   180,     9,    10,   114,   270,     9,    10,
      14,  4592,   184,  3072,   186,   121,  1864,     9,    10,   757,
     114,    58,     9,    10,   762,   641,   764,    17,  4028,   190,
       9,    10,   184,   233,   186,   303,   180,   299,  2183,   292,
      63,   294,    32,   748,    34,   184,   323,   186,   141,   140,
     152,     9,    10,    86,  3501,  3502,   613,   180,   211,   184,
    5362,   186,    57,  3510,   221,  3512,  4804,  3514,   184,   149,
     186,   623,   105,   625,   626,   627,   628,   165,   630,   631,
    2553,   281,   634,   635,   247,  1357,   303,   124,   288,  2452,
    2453,  2454,  2455,  2566,    89,   303,   186,   802,   396,   299,
      86,   184,   284,   186,    95,   208,  4316,    95,  3854,   211,
     105,  4983,   284,  3755,  1138,   184,   316,   186,    29,   303,
     122,  1950,   184,    34,   186,   238,   229,   184,   265,   186,
    3378,   303,   123,   184,  1252,   186,   184,   125,   186,   141,
     184,  1465,   186,   237,   759,   770,   299,   772,   184,  4149,
     186,   303,   560,   769,   149,   770,  3631,  3624,     9,    10,
    1937,   294,   719,   638,   303,   442,  1490,   719,   720,   345,
     184,   277,   186,  1219,     5,   233,   213,   238,   303,   184,
    5309,   186,   177,   184,  1331,   186,   299,   303,  5490,   283,
     176,   380,   184,   668,   186,   617,   606,   184,   621,   186,
      31,  4022,  1563,  4024,   297,   184,   297,   186,   316,   632,
     238,  4032,   299,   299,   637,   638,   691,  1315,  1579,  1317,
     303,   677,  1320,  1321,  1322,   238,   184,   196,   186,   704,
     288,   238,  1138,   329,   303,     9,    10,  4058,  4749,   662,
     273,   303,    73,   646,   263,   668,   303,   329,   671,     9,
      10,   347,   303,   717,   662,   303,  4077,   353,   281,   303,
    4470,   684,     9,    10,  1460,  3916,   270,   303,   691,  4816,
     233,   353,  2554,   663,     9,    10,  4970,   494,   356,   274,
     703,   704,    61,   379,   706,     9,    10,   273,   284,   303,
     142,  1563,   714,  2027,   618,   717,   848,   849,   303,  3336,
    2027,   238,   303,   536,  3255,   497,  1578,  1579,  3405,  3405,
     263,   303,   636,   736,   114,  3262,   303,  2463,  1436,  3266,
    1540,  1541,  3336,  1753,   303,   288,   650,   379,   803,   752,
    4740,  1971,  3978,   184,  2182,   186,   299,   263,  4558,   329,
     679,   172,  1982,   122,  1774,   303,   769,   763,  1466,   769,
     674,   100,   152,   447,   518,   238,   208,   347,   781,  2462,
     783,  4581,   263,   353,   631,  4585,    80,   573,  3405,   844,
    4801,     9,    10,  4593,  1431,  1736,   675,    91,  5363,   284,
     803,   212,  3255,  3631,   734,   772,     9,    10,   770,   812,
     772,  3405,   114,   781,  5132,   778,   769,  5135,  5136,  4980,
    5622,   824,  3839,   826,  2039,   795,   484,  1431,   769,   499,
     184,   834,   186,   836,   635,   838,   839,   840,   841,   842,
    1538,   844,  2674,  1747,   184,  3857,   186,   141,   772,   769,
     152,  2359,  2360,  3400,   753,  4083,  3307,   184,   734,   186,
     903,   769,  1386,  1767,   689,   753,   703,  1843,  2083,   184,
     748,   186,   303,   843,  2543,  5057,   846,  1729,  1551,   753,
     184,   211,   186,  1800,  1736,   772,  1803,   769,  2103,  2079,
    1794,   733,   895,   660,   897,   751,  2839,  1814,  1461,  3979,
    1817,   904,   769,   906,  1821,   635,  3334,  2716,   772,   772,
     753,   838,   839,   840,   772,   752,   912,   769,   921,   912,
     769,   912,   772,   759,  1724,   753,  2735,   775,  5439,  2667,
    2668,  1848,  1849,  1850,   769,  2387,  2388,  5389,  2390,  2391,
     660,   708,   745,   759,   777,  1431,   772,  1620,   776,   303,
     753,  1380,     9,    10,   770,  5229,   772,   758,   912,  5103,
    1901,  5105,  1635,   303,   772,  1638,   184,  1640,   186,    57,
    3450,  1644,  1645,  1646,  2567,   772,   303,  1704,   759,  1652,
    5306,   184,   770,   186,   772,  2794,  3814,  3815,   303,   769,
    3818,  3819,  4019,   776,   776,  2804,  3824,  3825,   759,   303,
    3639,    89,   753,   297,     9,    10,   770,   263,  1073,   759,
    5101,  1748,    83,   759,   776,   772,   759,   105,  5336,  4809,
     772,  4811,    93,   759,  4814,   759,   696,  3855,   686,   770,
     759,  4821,  4822,  5160,   770,   772,   772,  4064,  4065,  4066,
     772,   770,  4069,   772,  1329,   721,  2815,  2164,   772,  1901,
     121,   770,   769,   772,  2171,  4082,   769,   263,   895,   721,
     753,   149,   391,   745,   496,   770,   683,   772,  1386,   772,
     141,  4861,  1075,   622,   770,   146,   772,  1073,  4964,   753,
    1073,  1818,     9,    10,   770,   303,   379,    42,   776,   177,
     300,   301,   760,   761,   762,   763,   695,   284,   758,   759,
     303,   777,   437,   776,  2829,   772,   772,   770,  1786,   772,
    3321,   265,   753,  1168,   185,  1170,  4338,   650,   211,  1174,
    1175,   770,   358,   772,  1851,    28,  4742,   184,   770,   186,
     772,   769,     6,  1136,  1137,   772,   777,   769,   714,   770,
    3781,   772,   770,   265,   772,   753,   759,  3090,   772,  1204,
     280,   721,  3793,  2005,   770,  4880,  4880,   723,  4355,  1162,
     753,  4358,   117,   465,  4880,  1168,   753,  1170,   130,   777,
      33,  1174,  1175,   128,   333,   305,   770,  4466,  4466,   184,
     135,   186,     9,    10,   777,   130,   274,   772,   218,   695,
     777,   772,   551,   363,  1757,   770,   265,  3503,  2068,   610,
     772,  1204,  1757,  3509,   574,   772,   277,  4861,  4304,  3515,
    5096,    93,   167,   772,   695,    99,  4263,  1219,  1916,  1221,
     726,    32,  3839,   772,  1267,    14,   769,   607,  1383,   152,
    4631,   560,  3763,  3764,   772,  4466,   753,  4881,    11,  1242,
    3767,  3768,  2146,  1246,  1971,  3839,   303,  5615,  1251,  1252,
    4476,   356,  3719,   734,   363,  1982,  1983,   184,   211,   186,
     777,    76,   694,  2039,   146,  1268,  1331,  1893,   189,   265,
    3332,  3333,   607,   228,  1277,  1953,  1954,  5514,     9,    10,
     636,  5071,  1960,  1961,  1962,  5653,  5654,   772,  1291,  1292,
     753,  1293,   777,  1919,  3996,   625,  1351,   422,   303,  3080,
    1137,  2894,  3979,  3979,   259,   607,  3233,  2083,   114,  1312,
    3763,  3764,  4359,  4209,   777,  2256,  2630,   476,  5459,   149,
     223,   651,  1383,  2630,  1383,    32,  1383,    34,  1331,  1332,
    5194,  1383,  3194,  1383,   237,  1331,  3398,  3399,  1331,     9,
      10,   772,  4152,  1313,  1314,   467,  4544,   177,  1351,  5139,
    3867,  2687,   366,  5143,  2690,  2691,  1260,   184,   152,   186,
       9,    10,  3979,  1366,   363,  2031,   525,  1271,  5168,   211,
     171,   172,  2690,  2691,   703,   114,   303,  4432,  2539,   484,
      10,  1384,  1385,  5751,  1380,  3979,  1949,  1383,  1391,   482,
    1383,  3365,  1383,  4448,  4449,  3080,     9,    10,    32,  2817,
     319,   114,  1405,   518,  2256,  2257,  1461,   777,   238,  1246,
     351,  1414,  1415,  2932,  1251,  4591,  2114,  2115,   772,  1422,
    1423,   777,  3105,  1426,   660,     9,    10,  2836,  2648,  1383,
     584,  4607,   772,  1436,  2654,  4611,  4612,   772,  3080,   695,
    1443,    61,  1445,  5680,   650,   772,  1414,    73,  2300,     9,
      10,  3134,  1455,   184,  4282,   186,  2466,   772,  1461,  5508,
    2470,   645,  1465,  1466,  2068,   171,   172,   461,   772,   299,
    4004,  4005,  4006,  4007,   110,   111,   303,   283,   734,  2116,
     403,   296,   776,  2493,   777,  5139,   349,  1490,  3157,   695,
    1493,   412,   366,   437,  1331,  1422,  2155,  5158,  3307,  2351,
     462,  2716,   110,   111,  3648,  3649,  3650,  3651,  1573,   679,
    1513,   284,  2116,  2365,   184,   584,   186,   462,  3043,   361,
       9,    10,  2155,     9,    10,  1493,  2155,  3336,   658,   482,
     560,  3171,  4012,  2155,   323,  1538,   346,  4406,  2442,  2443,
    3751,  5331,   353,  2180,   283,  3053,  3054,    93,     9,    10,
    3069,  2155,  5438,  3075,   772,  2745,  5697,   679,   569,     9,
      10,   146,   772,  4520,  4521,  4522,   633,   770,  1405,  1565,
     679,   184,   303,   186,   570,  2179,  2180,  1573,  1415,  2794,
    1573,   686,  2068,     9,    10,   772,  1423,   601,   584,  2804,
     777,  3400,  3044,  5457,  3046,  4464,  3405,  2856,    63,  2516,
     184,  2518,   186,   316,  4432,   569,  1443,  2459,  1445,   403,
    4637,   237,   737,   772,  4641,  2532,   949,   950,   951,   560,
    4448,  4449,   423,   397,   184,   399,   186,  4813,  2545,  2546,
    2116,  1686,  4829,   303,   497,   437,  1639,   450,   522,   523,
     270,   447,   526,   527,   528,  1648,   353,   678,   284,  3418,
       9,    10,   462,  1696,   303,   120,  1659,   560,   292,   572,
      28,  5710,  2389,   607,  5901,   584,    93,  1670,  1723,  2155,
     464,   112,   666,  5339,  1007,  5341,  2476,     9,    10,   214,
     679,   695,   770,  1686,    32,  5346,    34,  1683,   446,  2362,
     303,  1852,  1683,  2179,  2180,   184,   710,   186,   184,   770,
     186,  3426,  1757,     9,    10,   531,   333,  4549,   447,    83,
     777,    61,  4018,    61,  4020,   772,  4022,   423,  4024,   303,
    1723,   143,  1725,   184,   151,   186,  4032,     9,    10,  4550,
       9,    10,  1734,  4039,   184,  4041,   186,   330,   374,  3258,
    3420,   326,  4048,   303,  1747,  1748,   589,   121,  2600,  4591,
    2602,   582,  4058,   299,  1757,  1758,  4062,   377,   184,   379,
     186,   772,  4068,   204,  1767,  4607,   374,   772,   581,  4611,
    4612,  4077,  4078,  4079,  4080,  4081,    12,    57,  1781,  1782,
    1748,  5182,   146,   727,  1787,  1788,  1789,  1790,  1791,  1792,
    1793,  1794,  1795,   220,   414,  5148,  1799,  1958,  1959,  5465,
    4106,  5673,  1639,    17,  5001,   607,  5476,   229,   772,   136,
     137,  1648,  1815,  1816,   303,  1818,   281,   303,    32,  1821,
     775,    18,  1659,   443,   667,   184,   176,   186,   772,    65,
    3692,  2490,   745,   426,   644,  2687,   594,  1840,  2690,  2691,
    2692,  5038,   303,   564,  5020,   772,   659,  1902,  1851,   476,
    1818,   487,   184,   303,   186,   223,  3156,  2490,  3690,  1862,
    1787,  2490,  1789,  1790,  1791,  1792,   649,  5739,  2490,   149,
     563,   298,  1799,   564,   700,  3397,   115,   303,   184,   487,
     186,   564,   665,  4400,  4401,  2448,  2490,  1942,   671,  1816,
      33,  1893,   718,  2448,  1949,   187,  1951,   177,   525,  1902,
       9,    10,   184,   277,   186,   184,   233,   186,   105,   106,
     237,  2609,  3212,  1916,   743,   279,  3978,  1919,  1921,  3233,
    2824,  2648,  2559,   753,    42,   727,  3233,  2654,   758,   759,
     704,     9,    10,   707,   714,  1990,   563,   458,   769,  1942,
    2716,  4810,  2669,   446,   303,   772,  1949,  1950,  1951,    92,
    3286,  1788,  5700,  1956,   572,  2559,  1793,  4826,  1795,   579,
    2830,   288,  2640,     9,    10,  2643,  4923,  2593,  1971,  2647,
    5025,   303,   299,  3656,  3657,  4616,   497,   192,   589,  1982,
    1983,  2036,  1950,   391,  4518,    17,   564,  1990,  3671,   769,
     205,     9,    10,    93,   274,   615,  4865,   303,  4867,   117,
      32,  3419,    34,  1840,  2490,   353,  2891,  2892,  2893,  2675,
     128,   278,   333,  2883,  1851,   736,   192,   135,  2794,   205,
     312,   303,   325,     0,   303,  1862,     9,    10,  2804,   205,
    3839,  4672,   595,  2036,  3443,  3444,  3445,  3446,     9,    10,
    2042,   772,  3262,   736,  5645,   736,  3266,  5648,   263,   167,
    5226,   772,  5228,   736,   681,  2058,   667,   476,   753,  2062,
     586,   204,  1395,     9,    10,   251,   445,  3707,   265,   123,
     714,  5737,  5738,  2559,     6,   184,  2079,   186,   714,     9,
      10,   772,  4891,  4227,  4228,  3421,   272,   263,  2815,  3099,
    3100,   594,  3307,  2096,  5291,  2098,  4458,     9,    10,  2102,
     753,  4463,   772,  3421,  5852,  5853,   184,   374,   186,   736,
     228,  2114,  2115,   896,  3124,   898,   899,   900,  2121,  1956,
     140,   410,   905,  3423,   907,  2128,  2129,   745,  2131,  2132,
       9,    10,   653,   777,  1971,   278,    68,   449,   184,  3080,
     186,   259,    94,  2146,   563,  1982,  1983,  2150,   451,     9,
      10,   205,  3604,   402,  3606,   476,   682,  2160,   736,   772,
     112,  5188,  5189,  5190,  2167,  5192,   184,   649,   186,    93,
    3979,   483,   714,   402,  2177,  2178,     9,    10,  5020,     9,
      10,   171,   172,   665,  3088,  3400,  5787,    80,   772,   671,
    3405,     9,    10,   115,   303,     9,    10,  5025,   500,  5396,
    3104,   184,   714,   186,   525,   100,     9,    10,   130,   735,
    2847,  3063,   772,   184,   593,   186,    79,   141,   485,    82,
     518,  2058,   146,  2882,  2220,   303,  2830,   769,  3080,  2220,
     479,   100,  5060,   128,     9,    10,   451,  2910,   184,   425,
     186,   530,   544,  2847,  4761,   265,  4763,   559,  2921,  2882,
     479,    57,   352,  2882,   184,  2928,   186,   303,  2821,  2420,
    2882,   185,   681,  5589,  5590,   777,  2821,   442,   112,     9,
      10,     6,   184,   402,   186,   451,    11,   297,  2882,  2883,
      15,   565,   566,   772,  4801,   303,   772,  2891,  2892,  2893,
     185,  2128,  2129,   419,  2131,  2132,  3166,   329,    61,  2159,
       9,    10,   753,     9,    10,   184,  2979,   186,   606,    86,
    3180,   772,     6,  2150,   489,   347,   265,   736,  2383,   182,
     303,   353,   772,  2160,   184,  4631,   186,  2330,   640,     9,
      10,  5472,   303,  2336,   620,  3008,     6,   437,   118,   439,
     770,   149,   772,   149,  2830,   125,   772,   379,   679,  2352,
     476,   184,  3089,   186,   184,  1138,   186,   303,   642,  5500,
      95,  2847,   660,   777,  4881,  5562,   184,    18,   186,   177,
     184,   177,   186,   303,    68,     9,    10,   679,  3037,     9,
      10,   184,   296,   186,  5226,   560,  5228,  2383,   674,  5615,
    2383,   303,  5033,  2448,   171,   172,  2882,  2883,    68,   176,
     731,   264,  5765,  4265,  3037,  2891,  2892,  2893,  3037,   184,
     190,   186,  2467,   772,   896,  3037,   898,   899,   900,     6,
    1105,     9,    10,   905,   303,   907,   316,  5653,  5654,   529,
       6,    81,     6,  3037,  3286,  1408,  1409,   563,   770,  2442,
    2443,  2444,   769,   303,   184,  2448,   186,    97,  1133,  2452,
    2453,  2454,  2455,  5816,   105,   106,  5819,  2460,  2461,  5748,
    2463,  5749,     9,    10,  2467,   100,   772,   408,   274,  1442,
     303,   123,  3138,   303,   415,   184,   126,   186,   184,  3138,
     186,    68,   132,     9,    10,   303,    17,  5850,  2490,   303,
     772,   770,    68,  2330,    68,  5067,   273,  5837,  2501,  2336,
     303,   100,  2505,    34,   184,  3138,   186,   607,    26,  3138,
    2512,     9,    10,  2568,  2517,   500,  3138,  5857,  2520,   169,
    4018,  3682,     9,    10,  4250,  5751,   289,   290,   303,     9,
      10,  3307,    35,  5779,  5780,  3262,     9,    10,   770,  3266,
     772,  2544,    94,   826,    47,     9,    10,   130,     9,    10,
     184,  3037,   186,   759,   184,   681,   186,  2560,  2561,   842,
     112,  2531,  3166,   303,   770,  2568,  2569,  2570,  2564,  3421,
    3731,    15,  5394,   728,   769,   253,  3180,  3447,  2505,   659,
    4078,  4079,   777,     9,    10,  5831,   264,   667,   171,   172,
    2517,  2593,  4001,   673,   303,  2598,   184,   303,   186,     9,
      10,   237,  2605,     9,    10,  2607,  2609,  2444,   621,  5250,
     736,  4119,  4120,   152,   265,  2452,  2453,  2454,  2455,   632,
     769,   204,  2677,   303,  3400,   174,  3496,   769,   391,  3405,
    4270,  2634,  2635,  2636,  2637,   777,  2639,   184,  4146,   186,
     704,  2644,  2645,  2646,   708,  2648,   772,   331,  1431,   769,
      10,  2654,  3138,  4696,   772,  4177,  1138,   777,   184,  4167,
     186,  1282,   770,   772,   772,   759,  2669,  1288,  1289,   303,
    2673,   284,   772,   303,  2677,  2678,   770,   769,   772,  3689,
    3166,   125,  3982,  4183,  3536,   777,   184,  4187,   186,   721,
     769,  3418,   770,   406,  3180,   278,   140,   184,   777,   186,
    4222,  2703,   465,   770,   184,   772,   186,  2544,  2710,  2711,
     112,   184,  2639,   186,   263,   303,    49,  5289,  2645,  2646,
     184,   769,   186,   184,   770,   186,    95,   769,  3580,   777,
    3367,     9,    10,  2570,    10,   777,  2739,  3641,   769,    15,
       9,    10,  2745,  4268,     9,    10,   777,   769,     9,    10,
     736,  2611,   770,    57,   263,   777,   303,   769,   184,   661,
     186,     9,    10,  3367,  3979,   777,  2821,   661,  2823,  3686,
      95,  2739,    49,   217,   184,   448,   186,   303,   184,  4419,
     186,  5561,     9,    10,  5564,    89,   770,   770,     9,    10,
     770,   374,   772,   654,     9,    10,    32,     9,    10,   770,
    2637,   339,   340,  3655,  2807,   303,  2809,  2644,     9,    10,
     776,  2648,  2815,   505,   506,  2818,   303,  2654,  2821,   115,
    2823,  2824,    58,   303,   770,  2685,     9,    10,   520,   164,
     303,   115,  2669,  2836,    70,   770,  2839,   772,   376,   303,
     770,    15,   303,  3447,    63,   149,  4708,    63,   115,   125,
     297,  2906,  2848,  2908,    90,   725,  1485,  1486,   770,  5165,
    1489,  5908,   777,   770,   140,   772,  5172,  3719,  2836,   110,
     111,   777,   205,   177,     6,   210,  5182,   303,   416,    84,
    5186,  3367,   770,   263,   772,  5191,   734,  5667,   124,    97,
     649,   770,  3496,   303,  5674,   171,   172,   303,   770,   448,
     772,   120,   485,  2906,   120,  2908,   184,   292,   186,   294,
     770,  3648,  3649,  3650,  3651,   184,   251,   186,   425,   184,
    3930,   186,   251,   184,   132,   186,   618,   619,   769,  3602,
     263,  4027,  4028,    93,    94,  4031,   184,   770,   186,   272,
     770,   217,  4038,   770,   252,   772,   723,   270,   497,  1431,
    1365,   125,   770,  1368,  1369,    76,   770,   184,    17,   186,
    4260,  3447,     5,   184,  4489,   186,   140,   770,   984,   184,
     274,   186,   184,    32,   186,    34,    95,   213,  2815,   112,
     313,  2818,   681,   184,  3049,   186,  1002,  5767,  5768,   770,
     599,   772,  1008,  1009,   770,   770,   772,   171,   172,   770,
     639,   772,  2839,  3164,  3741,   758,   759,  4690,  4691,   117,
    3496,    76,    77,  5585,   233,  5587,  5588,   233,    34,  3022,
     128,  4403,   770,  4405,   772,   303,  4408,   135,   769,  4411,
     770,   465,  4414,  4415,   303,  3037,    93,    94,   303,   374,
    3767,  3768,   303,   217,   280,    61,   576,  3043,   356,     9,
      10,   386,  3055,  3049,   695,   303,  3049,   595,   299,    42,
     180,   770,   281,   270,   770,   281,   180,  4707,  4450,   288,
    1544,  1545,   288,  3943,   612,   770,   303,   772,   416,  1553,
     299,  3084,   303,   299,   772,  3088,  3089,  3090,   303,  4507,
     770,   303,   425,   114,   110,   111,  4257,   316,   348,   637,
     316,  3104,   303,   753,   754,   755,   503,  3103,   505,   506,
    3103,  1585,  3103,  1587,   130,  5687,  5688,    69,   451,  5691,
     228,  3089,   776,   520,   333,   770,  3103,   772,  1602,  1603,
    1604,   779,  3293,   374,   117,  3138,   770,  1611,  1612,   677,
     770,   770,   339,   772,  1618,   128,   695,   197,   770,  3103,
     772,   259,   135,   488,    49,   171,   172,  3160,    93,   769,
     176,   397,   769,   399,   180,     9,    10,  3027,  3171,    10,
    4678,   110,   111,  4541,    15,   770,   484,   772,   770,  3172,
     772,  3177,   770,    57,   167,   770,   728,   772,   204,   466,
    3814,  3815,  5764,  4561,  3818,  3819,   769,   180,   769,   769,
    3824,  3825,  4570,  3979,   770,  4562,   772,  4092,  4576,   769,
     419,   343,  4569,   165,   770,    89,   772,  3272,  4586,  1663,
    1664,   618,   619,   770,   184,   560,   186,  4595,  4596,   769,
      34,   183,   291,   292,   442,   769,  4246,  4247,   166,  3294,
    3295,   769,   769,  3246,   770,   228,   487,  3084,  3251,   769,
     558,    11,    69,  3090,   770,   387,   772,   389,   769,  3262,
    4617,   769,   278,  3266,   770,  4275,   772,   476,   769,  3272,
     329,   770,   770,   772,    34,   149,   259,  3280,   770,   769,
     772,   489,   728,   770,   125,  2068,   302,   769,   347,  3344,
     770,  3294,  3295,   770,   353,   772,   770,   770,   772,   140,
     577,    61,   770,   177,   772,   191,   770,   584,   191,   770,
     205,   769,    69,   549,   550,   592,   525,   650,   334,  3246,
     379,  3323,  3324,  3325,  3326,  4847,  3328,  3329,  5381,   769,
     171,   172,   770,  2116,   772,    42,   296,   769,   769,  3943,
     184,  3344,   186,   303,   770,   553,   769,   769,   165,   481,
     110,   111,  5037,   770,   563,   772,   251,  3360,   374,   770,
     770,   772,   769,   379,   770,   333,   183,   191,   125,  3229,
     130,   770,  2155,   772,  3376,  3377,   217,  3379,   686,  3381,
    3382,  3383,  3384,  3385,  3386,  3387,   769,  3389,   665,   597,
    3392,  4899,   668,   726,  3396,   769,  2179,  2180,   530,  4918,
     274,   734,    69,   769,   724,   725,   374,   727,   165,   729,
     117,   171,   172,   769,  3251,  3418,   176,   352,   769,   769,
     180,   128,   239,   240,  2110,  3262,   183,   769,   135,  3266,
     770,   326,   772,  4815,  3437,   769,     9,    10,   746,  3442,
    3443,  3444,  3445,  3446,   204,   769,  3449,   579,    69,   726,
     769,   419,   191,   770,  4091,   772,  4129,  3943,   125,   303,
     167,   770,  4558,   772,   770,  3626,   772,  3327,   769,   485,
     438,   707,   681,   180,   769,  3443,  3444,  3445,  3446,     6,
     769,   769,   239,   240,   769,  4581,    69,  4091,  4092,  4585,
    4227,  4228,   770,   265,   668,   769,   769,  4593,   165,     9,
      10,   770,   437,   769,   439,   770,   769,   402,   476,   770,
     769,  5151,  3372,   769,  3374,  3375,   183,   770,   278,   772,
    3380,   228,   770,    17,  4197,  4535,   769,   736,  3388,   769,
     425,   769,   769,  3393,     9,    10,   769,   669,    32,     9,
      10,    68,   302,   770,   165,   753,   754,   755,   741,   770,
     769,   769,   259,   769,   156,   770,   451,   525,   770,   691,
     777,   197,   183,   772,    58,    36,   639,   411,   770,   770,
     772,   769,   239,   240,   334,   769,    70,   284,  3581,  5264,
     769,  3418,   165,  4249,   769,    57,  2068,   769,   769,   557,
    4249,   770,   769,   772,   529,   563,    90,     9,    10,    11,
     183,   769,   110,   111,   499,  4091,  4092,   769,     9,    10,
     769,   184,  3449,   186,   374,   769,  4249,    89,   239,   240,
    4249,    92,   130,   696,  3627,   769,   699,  4249,   122,   770,
     124,   772,   769,   105,  2116,   770,   652,   772,  3641,     9,
      10,   770,   769,   772,   115,  3648,  3649,  3650,  3651,   270,
    3653,  3653,   769,   726,    42,   197,   239,   240,   770,   130,
     772,   734,   721,   171,   172,   769,  3669,  3670,   770,  5005,
     772,   769,   607,  2155,   184,   769,   186,   149,   769,   769,
    3648,  3649,  3650,  3651,   769,   769,    69,  5005,   769,   769,
       9,    10,   769,   453,    95,  3698,   204,  2179,  2180,  5424,
     770,   769,   772,  5428,  3707,   177,   769,  2490,  3711,   184,
    3706,   186,  4390,   681,   184,  3706,   186,   770,   770,   772,
     772,  4399,   249,   250,   769,   485,   742,   769,   769,   117,
     303,  4601,   259,   204,    53,    54,    55,    56,  3741,   769,
     128,  4407,   769,   769,  3747,  3748,   348,   135,   772,    57,
    3753,   769,   769,  5110,  5111,   650,  5113,   769,  5277,   654,
     770,   769,   772,  4249,  3767,  3768,   753,   770,   736,   772,
     278,  3774,   184,  3741,   186,   770,  2559,   772,    34,   167,
     769,    89,   165,   184,  2258,   186,   280,  2261,   107,   108,
     109,   266,   394,   303,   302,  5499,   266,    57,   292,   769,
     183,   696,   274,  2277,   772,    61,   758,   759,   760,   761,
     762,   763,    57,   770,   184,   772,   186,   576,   522,   523,
     769,  2295,   526,   527,   528,   769,  3753,   668,   303,    89,
     770,   726,   772,   303,   770,  5560,   772,  4689,   769,   734,
     228,   149,   161,   162,    89,   105,    95,   770,  5533,   772,
     110,   111,  5714,   769,   110,   111,   239,   240,  5377,   770,
     105,   772,   770,   769,   772,   184,   374,   186,   769,   177,
    5227,   259,   474,   770,   130,   772,   180,     9,    10,   180,
     237,   777,    36,   777,  5524,   777,  4523,   777,  3931,   149,
     777,   303,   652,   777,   661,   777,   266,     9,    10,   777,
     777,   372,   303,   397,   149,   399,   416,  3910,   777,   769,
    3747,  3748,   424,   232,   679,   171,   172,   177,   141,  4523,
     176,    93,  3925,   679,   180,  4584,   695,   667,   500,   418,
    3767,  3768,   177,   303,   536,    93,  5458,   464,    92,   772,
    4950,   758,   759,   760,   761,   762,   763,   123,   204,     9,
      10,  4584,   772,   555,   556,  4584,   772,   574,   560,   561,
     562,   115,  4584,    95,   348,  5322,   274,  5324,  5325,   772,
      93,   382,   772,   772,  3977,   571,   130,   485,  3981,   690,
    4584,  3984,   742,    95,   303,   304,     9,    10,    80,   753,
     734,  3851,  3852,  3853,   451,   451,    94,  4601,  4001,   756,
     757,   758,   759,   760,   761,   762,   763,   196,   265,   772,
     100,  2697,  2698,   281,   274,     9,    10,    11,     9,    10,
      11,  5543,   278,   125,    26,    61,   628,   396,  2714,   274,
     778,     5,   575,  4001,   395,    95,     4,  4523,  2724,  2725,
     734,   777,   196,   416,    14,  5907,   302,  2830,    93,   772,
     204,   777,   184,    84,   186,   777,   550,   419,   411,  4929,
     333,  5397,  5398,   125,  2847,   695,   400,   770,   769,   112,
      93,   497,   184,  5713,   186,   677,   296,  2559,   334,  5397,
    5398,   400,    95,   123,  4087,  3945,  3946,   553,  3948,   756,
     757,   758,   759,   760,   761,   762,   763,   296,  4584,  2882,
    2883,   374,   151,  2789,  2790,  2791,  2792,   769,  2891,  2892,
    2893,   776,   772,   374,   585,  4601,   769,     6,   374,   416,
     770,   770,   770,    68,   184,  4803,   186,   324,  4806,  4807,
     772,   777,   770,  5655,   468,   756,   757,   758,   759,   760,
     761,   762,   763,   670,   671,   672,   673,   770,   770,   468,
     640,   777,    93,  5005,    93,   770,   770,   770,   419,   777,
     769,   184,   140,   186,   658,   438,   769,   100,   772,   270,
      93,   303,  4175,   756,   757,   758,   759,   760,   761,   762,
     763,   772,   779,    49,   772,    53,    54,    55,    56,  4192,
     184,   303,   186,   184,   760,   186,   777,   772,    34,   533,
    4361,   535,  5721,   476,   772,   679,   540,  4210,  4210,   760,
     125,   480,   692,   707,   533,   476,   535,  5087,   372,   440,
    4223,   540,   693,    93,  4227,  4228,   772,   679,   424,   485,
    4233,  4233,  4891,   115,   742,   770,   730,  5877,   769,   107,
     108,   109,   772,   303,   769,   778,  4249,  4250,   125,   115,
     772,  5891,   525,   196,  3037,  5777,  4259,  5897,  4891,  4227,
    4228,   218,  4891,  5903,   351,   500,   500,  4270,  4271,  4891,
     500,   605,  4268,  4276,  4911,   500,   348,   772,  4410,   772,
     303,   500,  4020,   500,   557,   753,   605,  4891,  4026,    84,
     563,  4029,   667,   161,   162,   270,   557,     6,  4036,   664,
     587,  4303,   563,   734,  4963,   770,  4166,  4911,   770,   303,
    4313,   770,   303,  4316,   648,  4318,   770,   770,   128,   128,
    4375,   188,  5841,   769,   772,  4929,     9,    10,  4188,   648,
    4963,    26,   777,   104,  4963,   428,   229,   777,   656,   205,
    5210,  4963,   407,   470,   769,  4348,   470,   586,  2830,   772,
     770,   772,    29,   614,  4357,  3138,   296,   725,  4513,  4963,
     201,   283,   694,   772,   232,  2847,   185,    95,   180,   772,
    5240,  4373,  4375,   772,   757,   758,   759,   760,   761,   762,
     763,    15,   635,  3166,    18,   270,  4389,   116,  4443,   123,
     641,    59,   770,  4404,   770,   416,   652,  3180,   770,   770,
    2882,  2883,   760,  4406,   738,  4891,   272,  4418,   681,  2891,
    2892,  2893,    95,    95,  4417,   749,  4419,   759,   770,   738,
     681,   374,  4425,    57,  4435,  4911,   770,   770,  4431,   769,
     749,   585,   770,   770,  4436,  4437,   304,   770,   777,    18,
    4443,  4444,  4453,  4929,  4455,  4456,   770,   770,   770,   770,
    4452,  5129,    86,   770,   770,    89,   770,   772,   238,   720,
     772,  4464,   772,   736,   770,    42,   196,  4470,  4471,   772,
     770,   105,   106,  4476,  4476,   736,  4313,  4963,    57,  4482,
     772,  4318,   770,  5087,  4487,   770,   742,  5497,   770,  4544,
     769,   769,   374,  4489,   769,  4550,   763,   769,   769,   381,
    5370,   184,   366,   186,   769,   769,   582,    86,   770,  5394,
      89,   772,  5869,   753,   396,   149,   265,  4513,   265,   265,
    4513,    99,  4513,   476,    95,   270,   105,   106,   772,   772,
      93,    93,   400,   769,   168,   494,   769,   419,   770,   693,
     117,  4544,   176,   177,   772,  5397,  5398,  4550,   772,    95,
     777,   128,   606,   237,   772,  4482,   770,    62,   135,   425,
     772,   777,   777,     6,   661,   772,  4426,  4427,  4428,   724,
     149,   772,    93,  4433,  4434,   568,  4579,   128,   128,  4439,
     740,   428,   538,   769,  3367,   451,   548,  4447,  4425,   168,
     167,  4451,   251,   251,   649,   251,   251,   176,   177,   251,
     468,  5087,  4462,   180,   557,   299,  5210,   180,   769,    93,
     563,   753,  5622,   266,   753,   753,   753,   753,    33,   753,
     303,    36,   753,  3309,  3310,  5635,  3312,  3313,   753,    33,
     499,   265,    36,   499,   753,   753,  5240,   753,   753,   273,
     274,   275,   524,    49,   753,   753,   753,    83,   753,   753,
     753,   228,   772,   753,   753,   537,  3138,    93,   753,   753,
    5670,   614,   753,   284,  3447,   533,   725,   535,   753,  4724,
     568,   141,   540,   321,  4677,   557,   772,    92,   270,   270,
     769,    96,   259,   270,  3166,   121,   265,   270,    92,   777,
      96,   777,    96,   777,   273,   274,   275,   772,  3180,   745,
     115,  4744,   380,   497,  4707,   141,   123,   776,   122,   115,
     146,   115,  4715,  3496,   770,   130,   777,  3403,   770,   122,
     770,  4724,   770,   770,  5210,  4728,   130,   191,   681,   595,
     759,   770,   759,  4736,    26,   777,   777,   605,  4598,   772,
     770,   688,   770,   769,   769,  5472,   326,  4790,  4751,   185,
    4752,   270,  4795,   576,  5240,    95,  5420,   391,  4813,    95,
      95,    95,   777,   265,   265,   399,  5370,   720,   482,   211,
     636,   777,    67,  5500,   772,   759,   177,    11,   534,   299,
     648,   196,  4793,   736,   769,   772,   753,   753,   654,   204,
    5394,   321,    92,   180,   180,    10,  4534,   769,  4536,   681,
     204,  4804,   270,   128,   769,   128,  4809,  4810,  4811,     7,
    4813,  4814,   391,  4816,   696,   770,   265,  4555,  4821,  4822,
     399,  4823,   772,  4826,   396,   265,   396,  4565,   265,   244,
     696,   219,    11,   699,   769,   769,   100,   769,   244,  4577,
     244,   277,   224,    41,   760,    93,   777,    72,  4850,   576,
     270,   760,   180,   114,   460,   772,  4594,   263,  4861,   411,
     726,   769,  4865,   278,  4867,    63,   776,   769,   734,   164,
     738,    56,   278,   769,   278,    73,   171,   172,   124,   124,
     770,   749,   770,  4886,  5370,  3367,  4889,   770,   177,  4892,
    5900,   770,  5556,   777,  5621,   769,   772,   772,   770,  4736,
     185,    99,  4904,   122,   777,   770,  4909,   770,  5394,   770,
     770,   350,   770,   770,   769,   210,   770,   115,   357,    26,
     326,   769,   120,   753,   769,  4921,   220,    95,    95,   211,
    4921,   770,  4935,   770,   373,   298,   770,   772,   769,   772,
    4983,   770,   769,   769,   383,   384,   385,   772,   146,   777,
     545,   211,   753,   180,   393,   772,   251,   372,   396,   366,
     284,   769,   284,   769,    11,  3447,   770,  5571,   372,   772,
    5636,   270,   772,   186,   265,   435,   372,   407,   196,   196,
    4983,    26,   196,   407,  4987,   196,   129,   129,   732,   696,
     196,   696,   196,   583,   196,   196,   402,   196,   270,    11,
     428,   229,   770,    99,   413,   492,   203,   379,   769,   769,
     568,   649,    61,   651,  3496,    93,    93,   177,   216,   770,
      26,   299,   770,   235,  5894,   494,   635,   665,   770,   185,
      26,   772,   770,   671,   672,   233,   772,   770,   142,   196,
     678,  5044,   436,   241,   770,   146,   770,   772,   769,   772,
    5053,   744,  4889,  4913,  5057,  4915,   140,  4917,   196,   697,
     180,    11,   770,  5066,  5067,  5068,   667,   143,  5071,   769,
     704,   177,   177,   707,   272,   284,   284,   584,   732,   374,
    5083,   350,   716,   281,   282,  5571,   112,   130,   357,   732,
     204,   386,   216,   532,   180,   180,   777,   596,   374,   475,
    5103,   266,  5105,    71,   373,    95,   299,   546,   428,   576,
     123,   379,   294,   294,   383,   384,   385,   568,   215,    17,
     769,   772,  5125,  4983,   393,   704,   770,   141,   707,  5132,
     770,   770,  5135,  5136,   770,   770,  5139,   716,   770,   488,
    5143,   538,  5145,   606,  5305,   113,   124,    32,  5151,   772,
     770,  5154,   770,    26,   770,   770,   770,  5160,   777,   770,
    3943,    10,   772,   646,   769,   769,    11,   770,   770,   769,
     585,  5031,   769,    26,    26,    79,    26,   435,   816,  5843,
     769,   585,   177,  3869,   319,   153,  3872,   769,    93,  3875,
    3876,  3877,  3878,   488,  3880,  3881,  3882,  3883,   130,  3885,
    3886,   769,  3888,   130,    93,   130,  3892,   772,   647,   769,
    3896,  3897,  3898,  3899,   770,  3901,  3902,   299,  5221,   772,
     378,  3907,  3908,   411,   299,  3911,  3912,   425,   660,  5232,
     636,  5234,   430,   130,   263,   305,   280,   777,   753,    93,
     177,   772,    93,   441,   650,   684,   770,   885,   654,   676,
     538,   434,   770,   770,   408,   769,   575,   769,   896,   698,
     898,   899,   900,   532,   770,   560,    11,   905,   772,   907,
     770,    67,   180,   633,   772,    93,    26,   546,   693,    26,
      26,   265,   400,    84,    84,   284,  5289,   263,   769,   693,
    5894,   777,   777,   699,    33,   777,   576,   777,   777,   777,
     938,   777,  5298,   777,   777,   943,  5309,   281,  4091,  4092,
     177,   777,   777,   449,   641,   777,   777,   770,   777,  5362,
     726,   777,   770,  5366,   770,   769,   429,   594,  5331,   594,
     354,    91,   568,  5336,   769,   973,   769,    61,   769,    61,
     154,  5352,    33,   772,   770,   983,  5389,   770,    33,    10,
     676,   770,  5355,   576,   687,   777,   702,  5360,   177,   302,
      26,   568,    26,   632,  5367,   123,   130,   769,   180,   769,
     769,   769,  5375,  5376,   769,   693,   732,   130,   647,   176,
     281,   327,    61,    11,  5221,   417,  5389,   576,   641,   576,
     769,   407,   407,   770,   769,   173,  5439,   419,   772,   777,
     770,   769,   600,   769,   769,   769,   580,   728,  5894,  5412,
     772,   769,    93,   688,  5274,   684,   777,   411,   770,   769,
     146,   769,  5425,   621,   326,   770,  5429,   770,   626,   698,
     777,   180,  1070,  1071,  1072,  1073,   320,   180,   229,   281,
     772,  5444,    63,   470,  5499,    75,  1084,  5490,    26,   641,
     177,   114,   237,   770,   770,   769,  3103,   772,  5461,   657,
     912,  3943,  4917,  2581,  4913,  5508,  4249,  3394,  4915,  1221,
    3242,  5422,  3835,  5092,  5569,  5436,  5756,   750,  4327,  1400,
    4337,  5301,  4987,  4963,  5486,  5232,  5310,  5247,  5389,  1735,
    4598,   689,  2602,  3719,  5571,  3489,  5499,  3996,  4524,  2178,
    1138,  2755,  4092,   471,   817,  2179,  2181,  2180,  2045,  2103,
    5299,  1441,  5076,  5298,  3924,  4833,  3356,  4219,  5355,  5042,
    4223,  5524,  4677,  5526,  2428,  5643,  5591,  5716,  5277,  5389,
    5046,  5841,  5796,   501,   502,  5843,   504,   505,   506,   507,
     508,  5556,   510,   511,   512,   513,   514,   515,   516,   517,
    4402,   519,   520,   521,  2630,  3916,  5736,  5430,  4470,  5071,
    3925,  4796,  5780,  5591,  5500,  5568,  4149,  5621,  4028,  5572,
    4083,  5624,  5636,  5576,  5577,  4543,  5141,  4551,  3585,  4184,
    4187,  5624,  5585,  4179,  5587,  5588,  5815,    90,    90,    11,
    5767,  5740,  5768,  5674,  5755,  5591,  5667,  5337,  5591,  5602,
    4569,  5656,  5425,  5122,  3742,  5120,  3924,  4466,  1236,  4091,
    4092,  1931,  5615,  5615,  1419,  3226,  3221,  5359,  5632,  1257,
      42,  2745,  1260,  2444,  2082,  2570,  5140,  3449,  4013,  5632,
    2855,   135,  3161,   756,  3043,  1333,  1159,  1380,  1369,  3095,
    5643,  3290,  3987,  4210,  2974,  1667,  2978,  3061,  5650,  5651,
     618,   619,  3060,  5656,  3626,  1725,  1547,  1983,    80,  1579,
    1331,    83,  5664,  5108,  1331,  1978,  1331,  5710,  1331,    91,
    1331,    93,  4715,  4765,  5677,  4262,  5576,  1973,   100,  5682,
    5577,  5736,   104,  2683,  5687,  5688,  3611,  4356,  5691,  3282,
    1999,  1553,   114,  4357,  5037,   117,  3609,  5151,  4696,   121,
    3286,   123,  5533,  5051,  1361,  5033,   128,   762,  1387,    17,
    5713,  4361,  2677,   135,   108,  2807,    90,  1499,  1859,   141,
    2848,  4707,  3177,  5725,   146,  4261,  5728,  4259,  4721,  3320,
    4416,  5568,  5713,  5736,    17,   834,  5779,  5780,  2540,  5794,
    4523,   681,  2096,  5904,   835,   167,   672,  2541,  5751,  5751,
    1807,  3155,  4438,  1383,   672,  5758,   125,  2596,   180,  5154,
    5060,  5764,  4016,   185,  1920,  5839,  1503,  4249,  4770,  5860,
    5117,  5897,  5903,  1006,  2560,  4270,  4249,  3037,  3136,   671,
    2366,   671,  2494,   205,  1949,  3116,  2160,  3115,  5831,  1749,
    1428,  5794,  1430,  1431,   668,  3850,  1495,  1141,  3088,  4375,
    3437,  4584,   110,   111,  5218,  2739,   228,  3236,  3931,   114,
     710,  5814,    90,    90,    90,   237,  5100,  5313,  4601,    -1,
    1278,    -1,    -1,    -1,    -1,    -1,  5881,   110,   111,    -1,
      -1,    -1,  5887,    -1,    -1,    -1,    -1,   259,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   277,    -1,    -1,    -1,    -1,
      -1,   283,   284,  1501,    -1,  1503,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5877,   297,    -1,   299,  5881,    -1,
     302,    -1,    -1,    -1,  5887,    -1,  5746,    -1,  5891,    -1,
      -1,  1529,    -1,    -1,  5897,    -1,    -1,    -1,    -1,    -1,
    5903,    -1,  1540,  1541,    -1,    -1,    -1,    -1,  1546,    -1,
      -1,    -1,  1550,  1551,  1552,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1561,  1562,    -1,    -1,    -1,    -1,  1567,
      -1,  1569,  1570,  1571,  1572,  1573,    -1,  1575,    -1,    -1,
      -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,  1586,    -1,
    1588,    -1,    -1,  1591,  1592,   263,  1594,  1595,  1596,    -1,
    1598,  1599,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,
      -1,    -1,    -1,    -1,    -1,  1613,  1614,  1615,  1616,  1617,
      -1,  1619,  1620,  1621,    -1,    -1,  1624,  1625,  1626,  1627,
    1628,  1629,  1630,    -1,  1632,  1633,  1634,  1635,    -1,  1637,
    1638,    -1,  1640,  1641,  1642,  1643,  1644,  1645,  1646,    -1,
      -1,  1649,  1650,  1651,  1652,    -1,  1654,  1655,  1656,    -1,
    1658,    -1,  1660,    -1,  1662,   447,    -1,    -1,  1666,  1667,
    1668,    -1,    -1,  1671,  1672,  1673,  1674,  1675,    -1,  1677,
      -1,  4523,    -1,    -1,    -1,    -1,  1684,    -1,    -1,    -1,
      -1,    -1,    -1,  1691,  1692,  1693,  1694,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1702,  1703,    -1,  1705,  1706,    -1,
      -1,  1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,
    1718,  1719,  1720,  1721,    -1,    -1,  1724,    -1,    -1,     5,
      -1,     7,     8,    -1,    -1,    -1,    -1,   405,    -1,    -1,
      -1,    -1,  4584,    -1,    -1,    -1,    -1,    -1,  4891,    -1,
      -1,   419,    -1,   421,    -1,    31,    -1,    33,    -1,  4601,
      -1,    -1,   405,    39,    -1,    -1,    -1,  1765,  4911,    -1,
      -1,    -1,  1770,    -1,    -1,    -1,   419,    -1,   421,    -1,
      -1,    -1,  1780,    -1,   452,    61,  4929,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,   467,
      -1,    -1,    -1,    -1,    80,    -1,    -1,    -1,    -1,   452,
      -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,
    4963,    -1,    -1,    -1,   467,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   500,    -1,   110,   111,    -1,    -1,    -1,   115,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1847,
     518,    -1,    -1,    -1,    -1,    -1,    -1,   500,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     146,    -1,    -1,    -1,    -1,   518,    -1,    -1,    -1,  1877,
      -1,  1879,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,   185,
      -1,    -1,    -1,    -1,    -1,  1913,    -1,   193,    -1,    -1,
     196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   599,    -1,    -1,    -1,    -1,    -1,    -1,   606,    -1,
      -1,    -1,    -1,   219,  5087,    -1,    -1,    -1,   616,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   599,    -1,   740,    -1,
      -1,   629,    -1,   606,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   753,    -1,   616,    -1,    -1,    -1,    -1,   254,   255,
     256,    -1,    -1,    -1,    -1,    -1,   629,    -1,   770,    -1,
     772,    -1,   660,   775,   776,   663,    -1,    -1,  1996,    -1,
      -1,   277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   679,    -1,    -1,    -1,    -1,    -1,   660,    -1,    -1,
     663,    -1,    -1,    -1,    -1,    -1,   302,   695,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   679,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4891,
     326,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   334,    -1,
     336,    -1,    -1,    -1,    -1,    -1,    -1,  5210,    -1,  4911,
    2068,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   355,
      -1,    -1,    -1,    -1,    -1,    -1,   362,  4929,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5240,   374,    -1,
      -1,    -1,    -1,    -1,    -1,   381,    -1,    -1,    -1,    -1,
       7,     8,    -1,    -1,    -1,    -1,    -1,    -1,  2116,    -1,
     396,  4963,    -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,
      27,    -1,   408,   409,    31,    -1,    33,    -1,    -1,   415,
      -1,    -1,    -1,   419,    41,    -1,    -1,  2145,    -1,    -1,
      -1,   427,    -1,    -1,    -1,    -1,    -1,  2155,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2163,    63,    -1,    65,    66,
      -1,   447,    -1,    -1,    -1,    -1,    73,    -1,    -1,    -1,
      -1,  2179,  2180,  2181,    -1,    -1,  2184,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2192,  2193,    -1,   473,    -1,    -1,
      -1,   477,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   487,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   120,    -1,    -1,    -1,  5370,    -1,    -1,
      -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5087,    -1,   144,   524,   146,
      -1,  5394,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   537,    -1,   539,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,  2286,  2287,
    2288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   195,   196,
      -1,    -1,   578,    -1,    -1,    -1,    -1,    -1,   584,   206,
     207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   218,   219,    -1,    -1,   222,    -1,    -1,    -1,    -1,
     227,    -1,    -1,    -1,    -1,   611,   233,    -1,    -1,    -1,
     237,    -1,    -1,    -1,   241,   242,   622,   623,   624,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2362,    -1,    -1,   643,  5210,    -1,
      -1,    -1,    -1,    -1,   650,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   279,    -1,   281,  2383,   283,    -1,    -1,  2387,
    2388,   288,  2390,  2391,    -1,    -1,    -1,    -1,  5240,    -1,
      -1,  2399,   299,  2401,    -1,   681,    -1,    -1,    -1,   306,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   316,
     696,   697,    -1,    -1,    -1,    -1,    -1,    -1,  5571,    -1,
      -1,    -1,    -1,   709,  2432,    -1,   712,    -1,    -1,    -1,
      -1,   338,    -1,    -1,   341,    -1,    -1,    -1,  2446,    -1,
      -1,   348,    -1,    -1,    -1,    -1,    -1,    -1,   355,    -1,
      -1,  2459,    -1,    -1,  2462,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2476,   376,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2490,  2491,    -1,    -1,    -1,    -1,    -1,    -1,
     776,    -1,  5548,  5549,   401,  5551,  5552,  5553,  5554,    -1,
      -1,    -1,    -1,    -1,   411,  2513,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5370,    -1,
      -1,    -1,    -1,   430,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   444,    -1,    -1,
      -1,    -1,  5394,    -1,    -1,    -1,  2554,    -1,    -1,    -1,
     457,  2559,    -1,   460,    -1,    -1,   463,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2596,    -1,
      -1,    -1,    -1,  5649,    -1,    -1,  5652,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5660,    -1,    -1,    -1,    -1,  5665,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2680,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2694,    -1,   595,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   624,    -1,  5571,
     627,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     637,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   645,    -1,
      -1,  5894,    -1,  2751,    -1,    -1,    -1,    -1,    -1,    -1,
     657,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,    -1,    34,
     677,    -1,    -1,   680,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   712,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   722,    -1,    -1,    -1,    -1,
      -1,    -1,  2830,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2847,
     747,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
     115,    -1,    -1,    -1,    -1,    -1,    -1,    32,    -1,    34,
      -1,    -1,   769,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2882,  2883,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2891,  2892,  2893,    61,    -1,    -1,    -1,
    2898,    -1,    -1,  2901,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2910,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2919,    -1,  2921,    -1,  2923,    -1,  2925,  2926,  2927,
    2928,  2929,  2930,    -1,  2932,    -1,    -1,    -1,   193,    -1,
      -1,    -1,  2940,    -1,  2942,   110,   111,  2945,  2946,  2947,
     115,    -1,    -1,    -1,    -1,    -1,  2954,  2955,  2956,    -1,
    2958,    -1,  2960,    -1,  2962,    -1,  2964,    -1,  2966,    -1,
      -1,   136,    -1,   138,    -1,   140,  2974,    -1,  2976,    -1,
    2978,  2979,  2980,  2981,  2982,    -1,    -1,  2985,    -1,  2987,
      -1,    -1,  2990,    -1,    -1,    -1,    -1,    -1,    -1,   254,
     255,   256,    -1,    -1,    -1,  3003,    -1,    -1,    -1,    -1,
    3008,    -1,    -1,  3011,    -1,  3013,  3014,  3015,    -1,    -1,
    3018,    -1,   277,    -1,    -1,    -1,  3024,    -1,   193,    -1,
      -1,  3029,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3037,
    3038,    -1,    -1,    -1,    -1,    -1,  3044,   302,  3046,    -1,
      -1,  3049,  5894,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3059,  3060,  3061,  3062,    -1,  3064,    -1,    -1,    -1,
      -1,  3069,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   334,
      -1,   336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   254,
     255,   256,    -1,    -1,    -1,    -1,    -1,    -1,   353,    -1,
     355,    -1,    -1,    -1,    -1,    -1,    -1,  3105,    -1,    -1,
      -1,    -1,   277,    -1,    -1,    -1,    -1,    -1,    -1,   374,
      -1,    -1,    -1,    -1,    -1,    -1,   381,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3134,   302,    -1,    -1,
    3138,   396,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   419,    -1,    -1,  3165,  3166,   334,
      -1,   336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3180,    -1,    -1,    -1,    -1,    -1,   353,    -1,
     355,    -1,    -1,    -1,    -1,    -1,  3194,    -1,    61,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   374,
      -1,    -1,    -1,    -1,    -1,    -1,   381,    -1,    -1,    -1,
      -1,    -1,   477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   396,   487,    -1,    -1,    -1,    -1,    -1,    -1,   404,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,   115,    -1,   419,    -1,    -1,    -1,    -1,    -1,
    3258,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   524,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3279,   537,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     7,     8,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3306,    -1,
      -1,    -1,   477,    -1,    27,    -1,    29,    -1,    31,    -1,
      33,    -1,   487,   578,    -1,    -1,    -1,    -1,    41,   584,
     193,    -1,    -1,    -1,  3332,  3333,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      63,    -1,    65,    66,    -1,    -1,    -1,    -1,  3356,   524,
      73,    -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,  3367,
    3368,    -1,   537,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    -1,    -1,    99,    -1,   643,    -1,
      -1,   254,   255,   256,    -1,   650,    -1,    -1,    -1,   112,
    3398,  3399,    -1,    -1,    -1,    -1,    -1,   120,    -1,    -1,
      -1,    -1,    -1,   578,   277,    -1,    -1,    -1,   131,   584,
      -1,    -1,    -1,    -1,    -1,    -1,   681,    -1,    -1,    -1,
      -1,   144,    -1,   146,    -1,    -1,    -1,    -1,   151,   302,
      -1,   696,   697,    -1,    -1,    -1,    -1,    -1,    -1,  3447,
      -1,    -1,    -1,    -1,   709,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   181,    -1,
      -1,   334,    -1,   336,    -1,    -1,    -1,    -1,   643,    -1,
      -1,    -1,   195,   196,    -1,   650,    -1,    -1,    -1,  3487,
      -1,    -1,   355,   206,   207,    -1,    -1,    -1,  3496,  3497,
      -1,    -1,  3500,    -1,    -1,   218,   219,   220,    -1,   222,
      -1,   374,    -1,    -1,   227,    -1,   681,   772,   381,    -1,
     233,    -1,    -1,    -1,   237,    -1,  3524,  3525,   241,   242,
      -1,   696,   697,   396,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   404,    -1,    -1,   709,    -1,    -1,    -1,    -1,    -1,
      -1,  3549,    -1,  3551,    -1,  3553,   419,  3555,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   279,    32,   281,    34,
     283,    -1,    -1,    -1,    -1,   288,  3574,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   298,   299,    -1,    -1,    -1,
      -1,    -1,    -1,   306,    -1,    -1,    61,  3595,  3596,    -1,
      -1,    -1,    -1,   316,  3602,    -1,  3604,    -1,  3606,    -1,
      -1,    -1,    -1,  3611,   477,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   487,   338,   339,    -1,   341,    -1,
      -1,    -1,    -1,    -1,    -1,   348,    -1,    -1,    -1,    -1,
      -1,    -1,   355,    -1,    -1,   110,   111,    -1,    -1,    -1,
     115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3656,  3657,
      -1,   524,    -1,   376,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3671,   537,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,    -1,
      -1,    -1,    -1,    -1,  3692,    -1,    -1,    -1,   411,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   578,    -1,   430,    -1,    -1,
      -1,   584,    -1,    -1,    -1,    -1,    -1,    -1,   193,    -1,
      -1,   444,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   457,    -1,    -1,   460,    -1,    -1,
     463,  3749,  3750,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   478,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3771,    -1,    -1,    -1,    -1,    -1,    -1,
     643,    -1,    -1,  3781,    -1,    -1,    -1,   650,    -1,   254,
     255,   256,    -1,    -1,    -1,  3793,    -1,  3795,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   277,    -1,    -1,    -1,    -1,    -1,   681,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   696,   697,    -1,    -1,   302,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   709,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   334,
      -1,   336,    -1,     5,    -1,     7,    -1,    -1,    -1,    -1,
      -1,    -1,   595,    -1,    -1,    -1,    -1,    -1,   353,    -1,
     355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    -1,   374,
      -1,   624,    -1,    -1,   627,    -1,   381,    -1,  3916,    -1,
      -1,    -1,    -1,    -1,   637,    -1,    -1,    -1,    -1,    61,
      -1,   396,   645,    -1,    -1,    -1,    -1,    -1,    -1,   404,
      -1,    73,    -1,    -1,   657,  3943,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   419,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   677,    -1,    -1,   680,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
    3978,    -1,    -1,   115,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3995,    -1,   712,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   722,
      -1,    -1,   477,    -1,   146,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   487,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   747,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     651,    -1,    -1,   185,    -1,    -1,   769,    -1,    -1,   524,
      -1,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   537,    -1,    -1,    -1,    -1,   678,    -1,    -1,
      -1,    -1,     7,     8,    -1,    -1,    -1,   219,    -1,    -1,
      -1,    -1,    -1,  4091,  4092,    -1,   697,    -1,    -1,    -1,
      -1,    -1,    27,    -1,    29,    -1,    31,    -1,    33,    -1,
      -1,    -1,    -1,   578,    -1,    -1,    41,    -1,    -1,   584,
      -1,    -1,   254,   255,   256,    -1,    -1,    -1,  4126,  4127,
      -1,  4129,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,
      65,    66,  4140,  4141,  4142,   277,    -1,    -1,    73,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4155,    -1,  4157,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
     302,    -1,  4170,  4171,    99,    -1,    -1,    -1,   643,    -1,
      -1,    -1,    -1,    -1,    -1,   650,    -1,   112,    -1,    -1,
      -1,    -1,    -1,    -1,   326,   120,    -1,    -1,    -1,  4197,
      -1,    -1,   334,    -1,   336,    -1,   131,    -1,    -1,    -1,
      -1,  4209,    -1,    -1,    -1,   816,   681,    -1,    -1,   144,
    4218,   146,    -1,   355,    -1,    -1,   151,    -1,    -1,    -1,
      -1,   696,   697,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   374,    -1,   709,    -1,    -1,    -1,    -1,   381,
      -1,  4249,    -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,
      -1,    -1,    -1,  4261,   396,    -1,    -1,  4265,    -1,    -1,
     195,   196,   404,    -1,    -1,    -1,   408,    -1,    -1,    -1,
      -1,   206,   207,   415,   885,    -1,    -1,   419,    -1,    -1,
      -1,    -1,    -1,   218,   219,   220,    -1,   222,    -1,    -1,
      -1,    -1,   227,    -1,    -1,    -1,    -1,    -1,   233,    -1,
      -1,    -1,   237,    -1,    -1,   447,   241,   242,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4323,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   938,    -1,    -1,
      -1,    -1,   943,    -1,    -1,   477,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   279,   487,   281,    -1,   283,    -1,
      -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   973,   298,   299,   976,    -1,    -1,    -1,    -1,
      -1,   306,   983,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   316,   524,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   537,    -1,   539,    -1,    -1,
      -1,    -1,    -1,   338,   339,    -1,   341,    -1,    -1,    -1,
    1021,    -1,    -1,   348,    -1,    -1,    -1,    -1,    -1,    -1,
     355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   578,    -1,    -1,    -1,
      -1,   376,   584,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4466,  1070,
    1071,  1072,  1073,    -1,    -1,  1076,   401,    -1,    -1,    -1,
      -1,  4479,  4480,  1084,    -1,    -1,   411,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   430,    -1,    -1,    -1,    -1,
      -1,   643,    -1,    -1,    -1,    -1,    -1,    -1,   650,   444,
      -1,    -1,    -1,    -1,    -1,  4523,    -1,    -1,    -1,    -1,
      -1,    -1,   457,    -1,    -1,   460,    -1,    -1,   463,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   681,
      -1,    -1,    -1,   478,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   696,   697,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   709,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4584,    -1,    -1,  4587,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4601,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4616,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1257,    -1,    -1,    -1,
    1261,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     595,    -1,    -1,    -1,  4672,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4690,  4691,    -1,    -1,    -1,    -1,    -1,   624,
      -1,    -1,   627,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4708,    -1,   637,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     645,    -1,    -1,  4721,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   657,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4740,    -1,  4742,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   677,    -1,    -1,   680,  1357,  4755,    -1,  4757,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   712,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   722,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   747,    -1,    -1,    -1,    -1,  1428,    -1,  1430,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   769,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4891,    -1,    -1,    -1,    -1,    -1,    -1,
    1501,    -1,  1503,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4911,    -1,    -1,    -1,    -1,    -1,    -1,
    4918,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1529,    -1,
      -1,  4929,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1540,
    1541,    -1,    -1,    -1,    -1,  1546,    -1,    -1,    -1,  1550,
    1551,  1552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1561,  1562,  1563,    -1,    -1,  4963,  1567,    -1,  1569,  1570,
    1571,  1572,  1573,    -1,  1575,    -1,    -1,  1578,  1579,    -1,
      -1,    -1,    -1,    -1,    -1,  1586,    -1,  1588,    -1,    -1,
    1591,  1592,    -1,  1594,  1595,  1596,    -1,  1598,  1599,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5008,    -1,  1613,  1614,  1615,  1616,  1617,    -1,  1619,  1620,
    1621,    -1,    -1,  1624,  1625,  1626,  1627,  1628,  1629,  1630,
      -1,  1632,  1633,  1634,  1635,  5033,  1637,  1638,    -1,  1640,
    1641,  1642,  1643,  1644,  1645,  1646,    -1,    -1,  1649,  1650,
    1651,  1652,    -1,  1654,  1655,  1656,    -1,  1658,    -1,  1660,
      -1,  1662,    -1,    -1,    -1,  1666,  1667,  1668,    -1,    -1,
    1671,  1672,  1673,  1674,  1675,    -1,  1677,    -1,    -1,    -1,
      -1,    -1,    -1,  1684,    -1,    -1,    -1,    -1,    -1,  5087,
    1691,  1692,  1693,  1694,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1702,  1703,    -1,  1705,  1706,    -1,    -1,  1709,  1710,
    1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,  1720,
    1721,    -1,    -1,  1724,    -1,    -1,    -1,    -1,  1729,    -1,
    5128,    -1,    -1,    -1,    -1,  1736,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1765,    -1,    -1,    -1,    -1,  1770,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1780,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    16,    17,    -1,    -1,    -1,    -1,    22,
      23,    -1,  5210,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5240,    -1,    -1,    58,  1847,    -1,    -1,    -1,
      -1,    -1,  5250,    -1,    -1,    -1,    -1,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1877,    90,  1879,  5277,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1901,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   124,  1913,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   147,   148,    -1,   150,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   158,   159,   160,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5362,   178,    -1,    -1,  5366,    -1,
      -1,    -1,  5370,    -1,    -1,    -1,    -1,    -1,    -1,  5377,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1996,  5394,    -1,    -1,    -1,
     213,    -1,    -1,    -1,  2005,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   237,    -1,    -1,    -1,    -1,    -1,
     243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   267,   268,   269,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5472,    -1,    -1,    -1,   291,   292,
      -1,    16,    17,    -1,    -1,    -1,    -1,    22,    23,    -1,
      -1,    -1,  5490,    -1,    -1,    -1,    -1,    32,    -1,    -1,
      -1,    -1,  5500,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5508,    -1,    -1,    -1,  5512,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,   342,
      -1,   344,   345,    -1,    -1,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2145,    -1,    -1,   360,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,
      -1,    -1,  2163,  5561,    -1,    -1,  5564,    -1,    -1,    -1,
      -1,    -1,    -1,  5571,    -1,    -1,    -1,    -1,    -1,    -1,
    2181,    -1,    -1,  2184,   397,    -1,   399,    -1,    -1,   124,
      -1,  2192,  2193,  5591,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,    -1,    -1,
      -1,    -1,   147,   148,    -1,   150,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   158,   159,   160,  5624,    -1,  5626,    -1,
     443,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   454,   455,   178,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2256,  2257,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5662,    -1,    -1,    -1,    -1,  5667,
      -1,    -1,    -1,   486,    -1,    -1,  5674,    -1,   213,    -1,
      -1,    -1,   495,    -1,    -1,  2286,  2287,  2288,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2300,
      -1,    -1,   237,    -1,    -1,    -1,    -1,    -1,   243,    -1,
      -1,    -1,  5710,    -1,    -1,    -1,  5714,    -1,    -1,    -1,
      -1,    -1,    -1,  5721,    -1,    -1,    -1,    -1,   541,   542,
     543,    -1,   267,   268,   269,    -1,   549,   550,    -1,    -1,
      -1,    -1,  5740,    -1,    -1,    -1,  5744,    -1,    -1,    -1,
    2351,    -1,    -1,   566,   567,    -1,   291,   292,    -1,    -1,
      -1,  2362,    -1,    -1,  2365,    -1,    -1,  5765,    -1,  5767,
    5768,    -1,    -1,    -1,    -1,    -1,    -1,   590,   591,    -1,
      -1,    -1,  2383,    -1,    -1,    -1,  2387,  2388,    -1,  2390,
    2391,    -1,    -1,    -1,    -1,    -1,   609,    -1,  2399,    -1,
    2401,    -1,    -1,    -1,    -1,    -1,    -1,   342,    -1,   344,
     345,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5816,    -1,
      -1,  5819,    -1,    -1,    -1,   360,    -1,    -1,   641,    -1,
      -1,  2432,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5841,    -1,  2446,    -1,    -1,    -1,    -1,
      -1,    -1,  5850,    -1,    -1,    -1,    -1,    -1,  2459,    -1,
      -1,  2462,   397,    -1,   399,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2476,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   420,    -1,    -1,   701,    -1,
    2491,   704,    -1,    -1,   707,    -1,  5894,    -1,    -1,    -1,
      -1,   714,    -1,    -1,    -1,    -1,    -1,    -1,   443,  5907,
      -1,    -1,  2513,    -1,    -1,    -1,    -1,   730,    -1,   454,
     455,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   749,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   486,    -1,  2554,    -1,    -1,    -1,    -1,    -1,    -1,
     495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2600,
      -1,  2602,    -1,    -1,    -1,    -1,   541,   542,   543,    -1,
      -1,    -1,    -1,    -1,   549,   550,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   566,   567,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   590,   591,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   609,    -1,    -1,    -1,    -1,  2680,
      -1,    -1,    -1,    -1,    -1,    -1,  2687,    -1,    -1,  2690,
    2691,  2692,    -1,  2694,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   641,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   701,    -1,    -1,   704,
      -1,    -1,   707,    -1,    -1,    -1,    -1,    -1,    -1,   714,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   730,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   749,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2898,    -1,    -1,
    2901,    -1,    -1,    -1,    -1,   651,    -1,    -1,    -1,  2910,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2919,    -1,
    2921,    -1,  2923,    -1,  2925,  2926,  2927,  2928,  2929,  2930,
      -1,  2932,   678,    -1,    -1,    -1,    -1,    -1,    -1,  2940,
      -1,  2942,    -1,    -1,  2945,  2946,  2947,    -1,    -1,    -1,
      -1,    -1,    -1,  2954,  2955,  2956,    -1,  2958,    -1,  2960,
      -1,  2962,    -1,  2964,    -1,  2966,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2974,    -1,  2976,    -1,  2978,  2979,  2980,
    2981,  2982,    -1,    -1,  2985,    -1,  2987,    -1,    -1,  2990,
      -1,    -1,    16,    17,    -1,    -1,    -1,    -1,    22,    23,
      -1,    -1,  3003,    -1,    -1,    -1,    -1,  3008,    32,    -1,
    3011,    -1,  3013,  3014,  3015,    -1,    -1,  3018,    -1,    -1,
      -1,    -1,    -1,  3024,    -1,    -1,    -1,    -1,  3029,    -1,
      -1,    -1,    -1,    -1,    58,    -1,    -1,  3038,    -1,    -1,
      -1,    -1,    -1,  3044,    -1,  3046,    70,    -1,  3049,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3059,  3060,
    3061,  3062,  3063,  3064,    -1,    -1,    90,    -1,  3069,    -1,
     816,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3080,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     124,    -1,    -1,    -1,  3105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   147,   148,    -1,   150,    -1,    -1,    -1,
      -1,    -1,    -1,  3134,   158,   159,   160,    -1,    -1,   885,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   178,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3165,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   213,
      -1,    -1,    -1,  3194,    -1,    -1,    -1,   943,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   237,    -1,    -1,    -1,    -1,    -1,   243,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   973,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   983,    -1,    -1,
      -1,    -1,    -1,   267,   268,   269,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3258,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   291,   292,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3279,    -1,
      -1,    -1,    -1,    -1,    -1,  3286,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   342,    -1,
     344,   345,    -1,    -1,    -1,    -1,    -1,  1073,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   360,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3368,    -1,    -1,
      -1,    -1,    -1,   397,    -1,   399,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   420,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   443,
    3421,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     454,   455,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   486,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3487,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3497,    -1,    -1,  3500,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1257,    -1,    -1,    -1,    -1,    -1,   541,   542,   543,
      -1,    -1,    -1,  3524,  3525,   549,   550,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3536,    -1,    -1,    -1,    -1,
      -1,    -1,   566,   567,    -1,    -1,    -1,    -1,  3549,    -1,
    3551,    -1,  3553,    -1,  3555,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   590,   591,    -1,    -1,
      -1,    -1,    -1,  3574,    -1,    -1,    -1,    -1,    -1,  3580,
      -1,    -1,    -1,    -1,    -1,   609,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3595,  3596,    -1,    -1,    -1,    -1,
      -1,  3602,    -1,  3604,     6,  3606,    -1,    -1,    -1,    -1,
    3611,    -1,    -1,    -1,    -1,    17,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,
      -1,    -1,    -1,    -1,  3655,  3656,  3657,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    66,    -1,    -1,    -1,    -1,    -1,
    3671,    -1,    -1,    -1,    -1,    -1,    -1,   701,    -1,    -1,
     704,    -1,  1428,   707,  1430,    -1,    -1,    -1,    -1,    -1,
      -1,  3692,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   730,    -1,   110,   111,
      -1,    -1,    -1,   115,    -1,    -1,    -1,    -1,  3719,    -1,
      -1,    -1,    -1,    -1,    -1,   749,    -1,   129,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1501,    -1,  1503,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3771,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3781,    -1,    -1,  1529,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3793,    -1,  3795,    -1,    -1,    -1,    -1,    -1,
    1546,    -1,    -1,   205,  1550,    -1,  1552,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1561,  1562,    -1,    -1,    -1,
      -1,  1567,    -1,  1569,  1570,  1571,  1572,  1573,    -1,  1575,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1586,    -1,  1588,    -1,    -1,  1591,  1592,    -1,  1594,  1595,
      -1,    -1,  1598,  1599,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   263,    -1,    -1,    -1,    -1,    -1,  1613,  1614,  1615,
    1616,  1617,    -1,  1619,    -1,  1621,    -1,    -1,  1624,  1625,
    1626,  1627,  1628,  1629,  1630,    -1,  1632,  1633,  1634,    -1,
      -1,  1637,  1638,    -1,    -1,  1641,  1642,  1643,    -1,    -1,
      -1,    -1,    -1,  1649,  1650,  1651,    -1,    -1,  1654,  1655,
    1656,   313,  1658,    -1,  1660,    -1,  1662,    -1,    -1,    -1,
    1666,  1667,  1668,    -1,    -1,  1671,  1672,  1673,  1674,  1675,
     332,  1677,    -1,    -1,    -1,    -1,    -1,    -1,  1684,   341,
      -1,    -1,    -1,    -1,    -1,  1691,  1692,  1693,    -1,    -1,
      -1,   353,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   364,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   388,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3995,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   418,   419,    -1,  1765,
     422,    -1,   424,    -1,  1770,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1780,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   450,   451,
      -1,    -1,    -1,    -1,    -1,    -1,   458,   459,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   475,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   497,    -1,    -1,    -1,    -1,
      -1,  1847,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   518,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4126,  4127,    -1,  4129,    -1,
      -1,  1877,    -1,  1879,    -1,    -1,    -1,    -1,    -1,  4140,
    4141,  4142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4155,    -1,  4157,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1913,    -1,  4170,
    4171,    -1,   574,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   588,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4197,   599,    -1,    -1,
     602,   603,    -1,    -1,    -1,    -1,    -1,    -1,  4209,    -1,
      -1,    -1,    -1,    -1,    -1,   617,    -1,  4218,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1996,   653,    -1,    -1,    -1,    -1,    -1,    -1,   660,    -1,
    4261,    -1,    -1,    -1,  4265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   679,    -1,   681,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   731,
      -1,    -1,    -1,    -1,    -1,   737,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2145,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2181,    -1,    -1,  2184,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2192,  2193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4479,  4480,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2286,  2287,  2288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4587,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4616,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2383,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2399,    -1,  2401,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4672,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2432,    -1,  4689,  4690,
    4691,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2446,    -1,    -1,    -1,    -1,    -1,    -1,  4708,    -1,    -1,
      -1,    -1,    -1,  2459,    -1,    -1,  2462,    -1,    -1,    -1,
    4721,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2491,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4755,    -1,  4757,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2513,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2554,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4918,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2680,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2694,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5005,  2751,    -1,  5008,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5033,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5128,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2898,    -1,    -1,  2901,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2919,    -1,    -1,    -1,  2923,    -1,  2925,
    2926,  2927,  2928,  2929,  2930,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2940,    -1,  2942,    -1,    -1,  2945,
    2946,  2947,    -1,    -1,    -1,    -1,    -1,    -1,  2954,  2955,
    2956,    -1,  2958,    -1,  2960,    -1,  2962,    -1,  2964,    -1,
    2966,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2974,    -1,
    2976,    -1,  2978,    -1,  2980,  2981,  2982,    -1,    -1,  2985,
      -1,  2987,    -1,    -1,  2990,    -1,    -1,    -1,    -1,  5250,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3003,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3011,    -1,  3013,  3014,  3015,
      -1,    -1,  3018,    -1,    -1,    -1,  5277,    -1,  3024,    -1,
      -1,    -1,    -1,  3029,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3038,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3049,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3060,  3061,    -1,    -1,  3064,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5377,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3134,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5397,  5398,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3165,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3194,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5472,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5500,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5512,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3279,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5591,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3368,    -1,    -1,  5626,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5714,    -1,    -1,    -1,    -1,    -1,    -1,
    5721,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3487,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3497,    -1,    -1,  3500,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3524,  3525,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3549,    -1,  3551,    -1,  3553,    -1,  3555,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3574,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5841,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3595,
    3596,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3611,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5907,    -1,    -1,    -1,
    3656,  3657,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3671,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3692,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3771,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3781,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3793,    -1,  3795,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3995,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4126,  4127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4140,  4141,  4142,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4155,
      -1,  4157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4170,  4171,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4261,    -1,    -1,    -1,  4265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4479,  4480,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4587,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4616,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4672,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4690,  4691,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4708,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4721,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4755,
      -1,  4757,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5008,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5033,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5128,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5250,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    29,    30,    -1,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    -1,
      43,    44,    45,    46,    -1,    48,    49,    -1,    51,    52,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,
      -1,    64,    -1,    -1,    -1,    -1,  5512,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,
     103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5591,   149,    -1,    -1,    -1,
      -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,
     163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,   172,
     173,    -1,   175,   176,   177,    -1,   179,   180,    -1,    -1,
    5626,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,
      -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,  5714,    -1,
     273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,
     293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,  5907,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   758,   759,    -1,    -1,    -1,
      -1,   764,    -1,    -1,    -1,     6,   769,    -1,    -1,    -1,
     773,   774,    -1,    -1,   777,   778,    17,    18,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    29,    30,
      -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    -1,
      51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,
      61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,
      -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,
     171,    -1,   173,    -1,   175,   176,   177,    -1,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,
     231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,
     261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,
      -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    -1,
      -1,    -1,    17,    18,    19,    20,    21,   758,   759,    -1,
      -1,    -1,    -1,   764,    29,    30,    -1,    32,   769,    -1,
      -1,    -1,   773,   774,    39,    40,   777,   778,    43,    44,
      45,    46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,
     105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,
     155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,
     165,    -1,    -1,   168,    -1,    -1,   171,   172,   173,    -1,
     175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,
      -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   228,    -1,    -1,   231,    -1,   233,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,
     275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,   286,   287,   288,    -1,    -1,    -1,    -1,   293,    -1,
     295,    -1,    -1,    -1,   299,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,    -1,    -1,    -1,    17,    18,
      19,    20,    21,   758,   759,    -1,    25,    -1,    -1,   764,
      29,    30,    -1,    32,   769,    -1,    -1,    -1,   773,   774,
      39,    40,   777,   778,    43,    44,    45,    46,    -1,    48,
      49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,
      -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,
      -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   133,    -1,   135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,
      -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,
      -1,    -1,   171,   172,   173,    -1,   175,   176,   177,    -1,
     179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,
     199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
     209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,
      -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,
      -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,   271,    -1,   273,   274,   275,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,
      -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,    -1,    -1,    -1,    17,    18,    19,    20,    21,   758,
     759,    -1,    -1,    -1,    -1,   764,    29,    30,    -1,    32,
     769,    -1,    -1,    -1,   773,   774,    39,    40,   777,   778,
      43,    44,    45,    46,    -1,    48,    49,    -1,    51,    52,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,
     103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,
      -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,
     163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,   172,
     173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,
      -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,
     293,    -1,   295,   296,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,
      17,    18,    19,    20,    21,   758,   759,    -1,    -1,    -1,
      -1,   764,    29,    30,    -1,    32,   769,    -1,    -1,    -1,
     773,   774,    39,    40,   777,   778,    43,    44,    45,    46,
      -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,
      57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,
      -1,    -1,    -1,   110,   111,   112,    -1,   114,    -1,    -1,
      -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,
     157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,
      -1,   168,    -1,    -1,   171,   172,   173,    -1,   175,   176,
     177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,
      -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,
      -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,
     257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,
     287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    -1,   746,
     747,   748,   749,    -1,    -1,    -1,    17,    18,    19,    20,
      21,   758,   759,    -1,    -1,    -1,    -1,   764,    29,    30,
      -1,    32,   769,    -1,    -1,    -1,   773,   774,    39,    40,
     777,   778,    43,    44,    45,    46,    -1,    48,    49,    -1,
      51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,
      61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    95,    -1,    -1,    -1,    -1,    -1,
     101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,
      -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,
     171,   172,   173,    -1,   175,   176,   177,    -1,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,
     231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,
     261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,
      -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    -1,
      -1,    -1,    17,    18,    19,    20,    21,   758,   759,    -1,
      -1,    -1,    -1,   764,    29,    30,    -1,    32,   769,    -1,
      -1,    -1,   773,   774,    39,    40,   777,   778,    43,    44,
      45,    46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      95,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,
     105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,
     155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,
     165,    -1,    -1,   168,    -1,    -1,   171,   172,   173,    -1,
     175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,
      -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,
     275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,
     295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,    -1,    -1,    -1,    17,    18,
      19,    20,    21,   758,   759,    -1,    -1,    -1,    -1,   764,
      29,    30,    -1,    32,   769,    -1,    -1,    -1,   773,   774,
      39,    40,   777,   778,    43,    44,    45,    46,    -1,    48,
      49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,
      -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    95,    -1,    -1,    -1,
      -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,
      -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,
      -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,
      -1,    -1,   171,   172,   173,    -1,   175,   176,   177,    -1,
     179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,
     199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
     209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,
      -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,
      -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,
      -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,    -1,    -1,    -1,    17,    18,    19,    20,    21,   758,
     759,    -1,    -1,    -1,    -1,   764,    29,    30,    -1,    32,
     769,    -1,    -1,    -1,   773,   774,    39,    40,   777,   778,
      43,    44,    45,    46,    -1,    48,    49,    -1,    51,    52,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,
     103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,
      -1,   114,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,
      -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,
     163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,   172,
     173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,
      -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,
     293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,
      17,    18,    19,    20,    21,   758,   759,    -1,    -1,    -1,
      -1,   764,    29,    30,    -1,    32,   769,    -1,    -1,    -1,
     773,   774,    39,    40,   777,   778,    43,    44,    45,    46,
      -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,
      57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,
      -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,
     157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,
      -1,   168,    -1,    -1,   171,   172,   173,    -1,   175,   176,
     177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,
      -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,
      -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,
     257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,
     287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    -1,   746,
     747,   748,   749,    -1,    -1,    -1,    17,    18,    19,    20,
      21,   758,   759,    -1,    -1,    -1,    -1,   764,    29,    30,
      -1,    32,   769,    -1,    -1,    -1,   773,   774,    39,    40,
     777,   778,    43,    44,    45,    46,    -1,    48,    49,    -1,
      51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,
      61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,
      -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,
     171,   172,   173,    -1,   175,   176,   177,    -1,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,
     231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,
     261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,
      -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    -1,
      -1,    -1,    17,    18,    19,    20,    21,   758,   759,    -1,
      -1,    -1,    -1,   764,    29,    30,    -1,    32,   769,    -1,
      -1,    -1,   773,   774,    39,    40,   777,   778,    43,    44,
      45,    46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,
     105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,
     155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,
     165,    -1,    -1,   168,    -1,    -1,   171,   172,   173,    -1,
     175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,
      -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,
     275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,
     295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,    -1,    -1,    -1,    17,    18,
      19,    20,    21,   758,   759,    -1,    -1,    -1,    -1,   764,
      29,    30,    -1,    32,   769,    -1,    -1,    -1,   773,   774,
      39,    40,   777,   778,    43,    44,    45,    46,    -1,    48,
      49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,
      -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,
      -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,
      -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,
      -1,    -1,   171,   172,   173,    -1,   175,   176,   177,    -1,
     179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,
     199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
     209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,
      -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,
      -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,
      -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,    -1,    -1,    -1,    17,    18,    19,    20,    21,   758,
     759,    -1,    -1,    -1,    -1,   764,    29,    30,    -1,    32,
     769,    -1,    -1,    -1,   773,   774,    39,    40,   777,   778,
      43,    44,    45,    46,    -1,    48,    49,    -1,    51,    52,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,
     103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,
      -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,
     163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,   172,
     173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,
      -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,
     293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,
      17,    18,    19,    20,    21,   758,   759,    -1,    -1,    -1,
      -1,   764,    29,    30,    -1,    32,   769,    -1,    -1,    -1,
     773,   774,    39,    40,   777,   778,    43,    44,    45,    46,
      -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,
      57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,
      -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,
     157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,
      -1,   168,    -1,    -1,   171,   172,   173,    -1,   175,   176,
     177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,
      -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,
      -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,
     257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,
     287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    -1,   746,
     747,   748,   749,    -1,    -1,    -1,    17,    18,    19,    20,
      21,   758,   759,    -1,    -1,    -1,    -1,   764,    29,    30,
      -1,    32,   769,    -1,    -1,    -1,   773,   774,    39,    40,
     777,   778,    43,    44,    45,    46,    -1,    48,    49,    -1,
      51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,
      61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,   154,   155,   156,   157,    -1,    -1,    -1,
      -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,
     171,    -1,   173,    -1,   175,   176,   177,    -1,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,
     231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,
     261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,
      -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    -1,
      -1,    -1,    17,    18,    19,    20,    21,   758,   759,    -1,
      -1,    -1,    -1,   764,    29,    30,    -1,    32,   769,    -1,
      -1,    -1,   773,   774,    39,    40,   777,   778,    43,    44,
      45,    46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,
     105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,
     155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,
     165,    -1,    -1,   168,    -1,    -1,   171,    -1,   173,    -1,
     175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,
      -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,
     275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,
     295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,    -1,    -1,    -1,    17,    18,
      19,    20,    21,   758,   759,    -1,    -1,    -1,    -1,   764,
      29,    30,    -1,    32,   769,    -1,    -1,    -1,   773,   774,
      39,    40,   777,   778,    43,    44,    45,    46,    -1,    48,
      49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,
      -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,
      -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,
      -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,
      -1,    -1,   171,    -1,   173,    -1,   175,   176,   177,    -1,
     179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,
     199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
     209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,
      -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,
      -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,
      -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,    -1,    -1,    -1,    17,    18,    19,    20,    21,   758,
     759,    -1,    -1,    -1,    -1,   764,    29,    30,    -1,    32,
     769,    -1,    -1,    -1,   773,   774,    39,    40,   777,   778,
      43,    44,    45,    46,    -1,    48,    49,    -1,    51,    52,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,
     103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,
      -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,
     163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,    -1,
     173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,
      -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,
     293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,
      17,    18,    19,    20,    21,   758,   759,    -1,    -1,    -1,
      -1,   764,    29,    30,    -1,    32,   769,    -1,    -1,    -1,
     773,   774,    39,    40,   777,   778,    43,    44,    45,    46,
      -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,
      57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,
      -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,
     157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,
      -1,   168,    -1,    -1,   171,    -1,   173,    -1,   175,   176,
     177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,
      -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,
      -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,
     257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,
     287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    -1,   746,
     747,   748,   749,    -1,    -1,    -1,    17,    18,    19,    20,
      21,   758,   759,    -1,    -1,    -1,    -1,   764,    29,    30,
      -1,    32,   769,    -1,    -1,    -1,   773,   774,    39,    40,
     777,   778,    43,    44,    45,    46,    -1,    48,    49,    -1,
      51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,
      61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,
      -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,
     171,    -1,   173,    -1,   175,   176,   177,    -1,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,
     231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,
     261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,
      -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    -1,
      -1,    -1,    17,    18,    19,    20,    21,   758,   759,    -1,
      -1,    -1,    -1,   764,    29,    30,    -1,    32,   769,    -1,
      -1,    -1,   773,   774,    39,    40,   777,   778,    43,    44,
      45,    46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,
     105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,
     155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,
     165,    -1,    -1,   168,    -1,    -1,   171,    -1,   173,    -1,
     175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,
      -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,
     275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,
     295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,   758,   759,    -1,    -1,    -1,    -1,   764,
      29,    30,    -1,    32,   769,    -1,    -1,    -1,   773,   774,
      39,    40,   777,   778,    43,    44,    45,    46,    -1,    48,
      49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,
      -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,
      -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,
      -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,
      -1,    -1,    -1,    -1,   173,    -1,   175,   176,   177,    -1,
     179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,
     199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
     209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,
      -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,
      -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,
      -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    18,   746,   747,   748,
     749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   758,
     759,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     769,    -1,    -1,    -1,    -1,   774,    -1,    -1,   777,   778,
      -1,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    86,    -1,    -1,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      24,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    -1,   746,   747,   748,   749,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   777,   778,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    24,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   760,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    32,
     746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   760,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,
      -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    32,   746,   747,   748,   749,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    61,    -1,    -1,    -1,   778,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
       6,     7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   778,    -1,
      -1,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,
      46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    99,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,   115,
      -1,    -1,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,
     146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,   272,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   281,   282,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    -1,
     746,   747,   748,   749,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,
      -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    99,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,   115,    -1,    -1,    -1,    -1,   120,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,
      -1,    -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   216,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
     272,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   281,
     282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
       6,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    -1,   746,   747,   748,   749,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    35,
     746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,     6,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    -1,
     746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   778,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    29,   746,   747,   748,   749,
      -1,    -1,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,
     134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,    -1,   311,    -1,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,    -1,    -1,   342,   343,
     344,   345,   346,    -1,    -1,   349,   350,   351,   352,    -1,
      -1,    -1,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,    -1,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,    -1,    -1,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,    -1,    -1,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,    -1,   458,   459,    -1,   461,   462,    -1,
      -1,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,    -1,   479,   480,   481,   482,   483,
     484,   485,   486,   487,    -1,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,    -1,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,    -1,    -1,    -1,   578,   579,    -1,   581,   582,   583,
     584,    -1,   586,   587,   588,   589,   590,   591,    -1,    -1,
      -1,    -1,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,    -1,   623,
      -1,   625,   626,    -1,   628,   629,    -1,   631,   632,   633,
     634,   635,   636,    -1,   638,   639,   640,   641,   642,   643,
     644,    -1,   646,   647,   648,    -1,   650,   651,   652,   653,
      -1,   655,   656,    -1,    -1,   659,    -1,    -1,   662,   663,
     664,    -1,   666,    -1,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,    -1,   678,   679,    36,   681,    -1,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,    -1,
     704,   705,   706,   707,   708,   709,   710,   711,    -1,   713,
     714,   715,    -1,   717,   718,   719,   720,    -1,    -1,   723,
     724,    -1,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,    96,    -1,   742,   743,
      -1,    -1,   746,    -1,   748,   749,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,   115,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   772,    -1,
     130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   244,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    11,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    17,   746,   747,   748,
     749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,    -1,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    16,
      17,    -1,   753,    -1,    -1,    22,    23,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   124,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     147,   148,    -1,   150,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   158,   159,   160,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   213,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     237,    -1,    -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     267,   268,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   291,   292,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    17,   746,
     747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    17,   746,   747,   748,
     749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,    -1,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    17,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    18,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    -1,
     746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    45,   746,   747,   748,   749,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,    -1,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    29,   746,   747,   748,   749,    -1,    -1,
      -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,
      -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,   225,
     226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,    -1,   311,    -1,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,    -1,    -1,   342,   343,   344,   345,
     346,    -1,    -1,   349,   350,   351,   352,    -1,    -1,    -1,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,    -1,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,    -1,    -1,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
      -1,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,    -1,   458,   459,    -1,   461,   462,    -1,    -1,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,    -1,   479,   480,   481,   482,   483,   484,   485,
     486,   487,    -1,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,    -1,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,    -1,
      -1,    -1,   578,   579,    -1,   581,   582,   583,   584,    -1,
     586,   587,   588,   589,   590,   591,    -1,    -1,    -1,    -1,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,    -1,   623,    -1,   625,
     626,    -1,   628,   629,    -1,   631,   632,   633,   634,   635,
     636,    -1,   638,   639,   640,   641,   642,   643,   644,    -1,
     646,   647,   648,    -1,   650,   651,   652,   653,    -1,   655,
     656,    -1,    -1,   659,    -1,    -1,   662,   663,   664,    -1,
     666,    -1,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,    -1,   678,   679,    -1,   681,    -1,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,    29,   704,   705,
     706,   707,   708,   709,   710,   711,    38,   713,   714,   715,
      -1,   717,   718,   719,   720,    -1,    -1,   723,   724,    -1,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,    -1,    -1,   742,   743,    -1,    -1,
     746,    -1,   748,   749,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,
      -1,    93,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,
      -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,   225,   226,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   296,    -1,   298,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,    -1,   311,
      -1,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,    -1,    -1,
     342,   343,   344,   345,   346,    -1,    -1,   349,   350,   351,
     352,    -1,    -1,    -1,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,    -1,    -1,    -1,    -1,    -1,
      -1,   373,    -1,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,    -1,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,    -1,    -1,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,    -1,    -1,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,    -1,   458,   459,    -1,   461,
     462,    -1,    -1,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,    -1,   479,   480,   481,
     482,   483,   484,   485,   486,   487,    -1,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,    -1,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,    -1,    -1,    -1,   578,   579,    -1,   581,
     582,   583,   584,    -1,   586,   587,   588,   589,   590,   591,
      -1,    -1,    -1,    -1,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
      -1,   623,    -1,   625,   626,    -1,   628,   629,    -1,   631,
     632,   633,   634,   635,   636,    -1,   638,   639,   640,   641,
     642,   643,   644,    -1,   646,   647,   648,    -1,   650,   651,
     652,   653,    -1,   655,   656,    -1,    -1,   659,    -1,    -1,
     662,   663,   664,    -1,   666,    -1,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,    -1,   678,   679,    -1,   681,
      -1,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,    29,   704,   705,   706,   707,   708,   709,   710,   711,
      38,   713,   714,   715,    -1,   717,   718,   719,   720,    -1,
      -1,   723,   724,    -1,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,    -1,    -1,
     742,   743,    -1,    -1,   746,    -1,   748,   749,    76,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,
      -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,   225,   226,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,
     298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,    -1,   311,    -1,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,    -1,    -1,   342,   343,   344,   345,   346,    -1,
      -1,   349,   350,   351,   352,    -1,    -1,    -1,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,    -1,
      -1,    -1,    -1,    -1,    -1,   373,    -1,   375,    -1,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,    -1,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,    -1,    -1,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,    -1,    -1,    -1,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,    -1,
     458,   459,    -1,   461,   462,    -1,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
      -1,   479,   480,   481,   482,   483,   484,   485,   486,   487,
      -1,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,    -1,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,    -1,    -1,    -1,
     578,   579,    -1,   581,   582,   583,   584,    -1,   586,   587,
     588,   589,   590,   591,    -1,    -1,    -1,    -1,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,    -1,   623,    -1,   625,   626,    -1,
     628,   629,    -1,   631,   632,   633,   634,   635,   636,    -1,
     638,   639,   640,   641,   642,   643,   644,    -1,   646,   647,
     648,    -1,   650,   651,   652,   653,    -1,   655,   656,    -1,
      -1,   659,    -1,    -1,   662,   663,   664,    -1,   666,    -1,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,    -1,
     678,   679,    -1,   681,    -1,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,    29,   704,   705,   706,   707,
     708,   709,   710,   711,    38,   713,   714,   715,    -1,   717,
     718,   719,   720,    -1,    -1,   723,   724,    -1,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,    -1,    -1,   742,   743,    -1,    -1,   746,    -1,
     748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,
     134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,    -1,   311,    -1,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,    -1,    -1,   342,   343,
     344,   345,   346,    -1,    -1,   349,   350,   351,   352,    -1,
      -1,    -1,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,    -1,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,    -1,    -1,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,    -1,    -1,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,    -1,   458,   459,    -1,   461,   462,    -1,
      -1,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,    -1,   479,   480,   481,   482,   483,
     484,   485,   486,   487,    -1,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,    -1,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,    -1,    -1,    -1,   578,   579,    -1,   581,   582,   583,
     584,    -1,   586,   587,   588,   589,   590,   591,    -1,    -1,
      -1,    -1,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,    -1,   623,
      -1,   625,   626,    -1,   628,   629,    -1,   631,   632,   633,
     634,   635,   636,    -1,   638,   639,   640,   641,   642,   643,
     644,    -1,   646,   647,   648,    -1,   650,   651,   652,   653,
      -1,   655,   656,    -1,    -1,   659,    -1,    -1,   662,   663,
     664,    -1,   666,    -1,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,    -1,   678,   679,    -1,   681,    -1,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,    29,
     704,   705,   706,   707,   708,   709,   710,   711,    38,   713,
     714,   715,    -1,   717,   718,   719,   720,    -1,    -1,   723,
     724,    -1,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,    -1,    -1,   742,   743,
      -1,    -1,   746,    -1,   748,   749,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,
      -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,    98,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,
      -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,   225,   226,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   298,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
      -1,   311,    -1,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
      -1,    -1,   342,   343,   344,   345,   346,    -1,    -1,   349,
     350,   351,   352,    -1,    -1,    -1,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,    -1,    -1,    -1,
      -1,    -1,    -1,   373,    -1,   375,    -1,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,    -1,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,    -1,
      -1,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,    -1,    -1,    -1,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,    -1,   458,   459,
      -1,   461,   462,    -1,    -1,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,    -1,   479,
     480,   481,   482,   483,   484,   485,   486,   487,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
      -1,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,    -1,    -1,    -1,   578,   579,
      -1,   581,   582,   583,   584,    -1,   586,   587,   588,   589,
     590,   591,    -1,    -1,    -1,    -1,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,    -1,   623,    -1,   625,   626,    -1,   628,   629,
      -1,   631,   632,   633,   634,   635,   636,    -1,   638,   639,
     640,   641,   642,   643,   644,    -1,   646,   647,   648,    -1,
     650,   651,   652,   653,    -1,   655,   656,    -1,    -1,   659,
      -1,    -1,   662,   663,   664,    -1,   666,    -1,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,    -1,   678,   679,
      -1,   681,    -1,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,    29,   704,   705,   706,   707,   708,   709,
     710,   711,    38,   713,   714,   715,    -1,   717,   718,   719,
     720,    -1,    -1,   723,   724,    -1,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
      -1,    -1,   742,   743,    -1,    -1,   746,    -1,   748,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,
      -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,   225,
     226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,    -1,   311,    -1,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,    -1,    -1,   342,   343,   344,   345,
     346,    -1,    -1,   349,   350,   351,   352,    -1,    -1,    -1,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,    -1,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,    -1,    -1,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
      -1,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,    -1,   458,   459,    -1,   461,   462,    -1,    -1,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,    -1,   479,   480,   481,   482,   483,   484,   485,
     486,   487,    -1,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,    -1,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,    -1,
      -1,    -1,   578,   579,    -1,   581,   582,   583,   584,    -1,
     586,   587,   588,   589,   590,   591,    -1,    -1,    -1,    -1,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,    -1,   623,    -1,   625,
     626,    -1,   628,   629,    -1,   631,   632,   633,   634,   635,
     636,    -1,   638,   639,   640,   641,   642,   643,   644,    -1,
     646,   647,   648,    -1,   650,   651,   652,   653,    -1,   655,
     656,    -1,    -1,   659,    -1,    -1,   662,   663,   664,    -1,
     666,    -1,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,    -1,   678,   679,    -1,   681,    -1,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,    29,   704,   705,
     706,   707,   708,   709,   710,   711,    38,   713,   714,   715,
      -1,   717,   718,   719,   720,    -1,    -1,   723,   724,    -1,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,    -1,    -1,   742,   743,    -1,    -1,
     746,    -1,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,
      -1,    93,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,
      -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,   225,   226,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,    -1,   311,
      -1,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,    -1,    -1,
     342,   343,   344,   345,   346,    -1,    -1,   349,   350,   351,
     352,    -1,    -1,    -1,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,    -1,    -1,    -1,    -1,    -1,
      -1,   373,    -1,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,    -1,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,    -1,    -1,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,    -1,    -1,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,    -1,   458,   459,    -1,   461,
     462,    -1,    -1,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,    -1,   479,   480,   481,
     482,   483,   484,   485,   486,   487,    -1,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,    -1,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,    -1,    -1,    -1,   578,   579,    -1,   581,
     582,   583,   584,    -1,   586,   587,   588,   589,   590,   591,
      -1,    -1,    -1,    -1,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
      -1,   623,    -1,   625,   626,    -1,   628,   629,    -1,   631,
     632,   633,   634,   635,   636,    -1,   638,   639,   640,   641,
     642,   643,   644,    -1,   646,   647,   648,    -1,   650,   651,
     652,   653,    -1,   655,   656,    -1,    -1,   659,    -1,    -1,
     662,   663,   664,    -1,   666,    -1,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,    -1,   678,   679,    -1,   681,
      -1,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,    29,   704,   705,   706,   707,   708,   709,   710,   711,
      38,   713,   714,   715,    -1,   717,   718,   719,   720,    -1,
      -1,   723,   724,    -1,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,    -1,    -1,
     742,   743,    -1,    -1,   746,    -1,   748,   749,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,
      -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,   225,   226,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,    -1,   311,    -1,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,    -1,    -1,   342,   343,   344,   345,   346,    -1,
      -1,   349,   350,   351,   352,    -1,    -1,    -1,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,    -1,
      -1,    -1,    -1,    -1,    -1,   373,    -1,   375,    -1,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,    -1,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,    -1,    -1,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,    -1,    -1,    -1,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,    -1,
     458,   459,    -1,   461,   462,    -1,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
      -1,   479,   480,   481,   482,   483,   484,   485,   486,   487,
      -1,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,    -1,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,    -1,    -1,    -1,
     578,   579,    -1,   581,   582,   583,   584,    -1,   586,   587,
     588,   589,   590,   591,    -1,    -1,    -1,    -1,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,    -1,   623,    -1,   625,   626,    -1,
     628,   629,    -1,   631,   632,   633,   634,   635,   636,    -1,
     638,   639,   640,   641,   642,   643,   644,    -1,   646,   647,
     648,    -1,   650,   651,   652,   653,    -1,   655,   656,    -1,
      -1,   659,    -1,    -1,   662,   663,   664,    -1,   666,    -1,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,    -1,
     678,   679,    -1,   681,    -1,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,    29,   704,   705,   706,   707,
     708,   709,   710,   711,    38,   713,   714,   715,    -1,   717,
     718,   719,   720,    -1,    -1,   723,   724,    -1,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,    -1,    -1,   742,   743,    -1,    -1,   746,    -1,
     748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,
     134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,    -1,   311,    -1,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,    -1,    -1,   342,   343,
     344,   345,   346,    -1,    -1,   349,   350,   351,   352,    -1,
      -1,    -1,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,    -1,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,    -1,    -1,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,    -1,    -1,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,    -1,   458,   459,    -1,   461,   462,    -1,
      -1,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,    -1,   479,   480,   481,   482,   483,
     484,   485,   486,   487,    -1,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,    -1,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,    -1,    -1,    -1,   578,   579,    -1,   581,   582,   583,
     584,    -1,   586,   587,   588,   589,   590,   591,    -1,    -1,
      -1,    -1,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,    -1,   623,
      -1,   625,   626,    -1,   628,   629,    -1,   631,   632,   633,
     634,   635,   636,    -1,   638,   639,   640,   641,   642,   643,
     644,    -1,   646,   647,   648,    -1,   650,   651,   652,   653,
      -1,   655,   656,    -1,    -1,   659,    -1,    -1,   662,   663,
     664,    -1,   666,    -1,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,    -1,   678,   679,    -1,   681,    -1,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,    29,
     704,   705,   706,   707,   708,   709,   710,   711,    38,   713,
     714,   715,    -1,   717,   718,   719,   720,    -1,    -1,   723,
     724,    -1,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,    -1,    -1,   742,   743,
      -1,    -1,   746,    -1,   748,   749,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,
      -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,    98,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,
      -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,   225,   226,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   298,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
      -1,   311,    -1,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
      -1,    -1,   342,   343,   344,   345,   346,    -1,    -1,   349,
     350,   351,   352,    -1,    -1,    -1,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,    -1,    -1,    -1,
      -1,    -1,    -1,   373,    -1,   375,    -1,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,    -1,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,    -1,
      -1,   431,    -1,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,    -1,    -1,    -1,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,    -1,   458,   459,
      -1,   461,   462,    -1,    -1,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,    -1,   479,
     480,   481,   482,   483,   484,   485,   486,   487,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
      -1,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,    -1,    -1,    -1,   578,   579,
      -1,   581,   582,   583,   584,    -1,   586,   587,   588,   589,
     590,   591,    -1,    -1,    -1,    -1,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,    -1,   623,    -1,   625,   626,    -1,   628,   629,
      -1,   631,   632,   633,   634,   635,   636,    -1,   638,   639,
     640,   641,   642,   643,   644,    -1,   646,   647,   648,    -1,
     650,   651,   652,   653,    -1,   655,   656,    -1,    -1,   659,
      -1,    -1,   662,   663,   664,    -1,   666,    -1,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,    -1,   678,   679,
      -1,   681,    -1,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,    29,   704,   705,   706,   707,   708,   709,
     710,   711,    38,   713,   714,   715,    -1,   717,   718,   719,
     720,    -1,    -1,   723,   724,    -1,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
      -1,    -1,   742,   743,    -1,    -1,   746,    -1,   748,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,
      -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,   225,
     226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,    -1,   311,    -1,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,    -1,    -1,   342,   343,   344,   345,
     346,    -1,    -1,   349,   350,   351,   352,    -1,    -1,    -1,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,    -1,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,    -1,    -1,   431,    -1,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
      -1,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,    -1,   458,   459,    -1,   461,   462,    -1,    -1,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,    -1,   479,   480,   481,   482,   483,   484,   485,
     486,   487,    -1,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,    -1,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,    -1,
      -1,    -1,   578,   579,    -1,   581,   582,   583,   584,    -1,
     586,   587,   588,   589,   590,   591,    -1,    -1,    -1,    -1,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,    -1,   623,    -1,   625,
     626,    -1,   628,   629,    -1,   631,   632,   633,   634,   635,
     636,    -1,   638,   639,   640,   641,   642,   643,   644,    -1,
     646,   647,   648,    -1,   650,   651,   652,   653,    -1,   655,
     656,    -1,    -1,   659,    -1,    -1,   662,   663,   664,    -1,
     666,    -1,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,    -1,   678,   679,    -1,   681,    -1,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,    29,   704,   705,
     706,   707,   708,   709,   710,   711,    38,   713,   714,   715,
      -1,   717,   718,   719,   720,    -1,    -1,   723,   724,    -1,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,    -1,    -1,   742,   743,    -1,    -1,
     746,    -1,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,
      -1,    93,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,
      -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,   225,   226,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,    -1,   311,
      -1,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,    -1,    -1,
     342,   343,   344,   345,   346,    -1,    -1,   349,   350,   351,
     352,    -1,    -1,    -1,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,    -1,    -1,    -1,    -1,    -1,
      -1,   373,    -1,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,    -1,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,    -1,    -1,   431,
      -1,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,    -1,    -1,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,    -1,   458,   459,    -1,   461,
     462,    -1,    -1,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,    -1,   479,   480,   481,
     482,   483,   484,   485,   486,   487,    -1,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,    -1,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,    -1,    -1,    -1,   578,   579,    -1,   581,
     582,   583,   584,    -1,   586,   587,   588,   589,   590,   591,
      -1,    -1,    -1,    -1,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
      -1,   623,    -1,   625,   626,    -1,   628,   629,    -1,   631,
     632,   633,   634,   635,   636,    -1,   638,   639,   640,   641,
     642,   643,   644,    -1,   646,   647,   648,    -1,   650,   651,
     652,   653,    -1,   655,   656,    -1,    -1,   659,    -1,    -1,
     662,   663,   664,    -1,   666,    -1,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,    -1,   678,   679,    -1,   681,
      -1,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,    29,   704,   705,   706,   707,   708,   709,   710,   711,
      38,   713,   714,   715,    -1,   717,   718,   719,   720,    -1,
      -1,   723,   724,    -1,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,    -1,    -1,
     742,   743,    -1,    -1,   746,    -1,   748,   749,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,
      -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,   225,   226,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,    -1,   311,    -1,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,    -1,    -1,   342,   343,   344,   345,   346,    -1,
      -1,   349,   350,   351,   352,    -1,    -1,    -1,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,    -1,
      -1,    -1,    -1,    -1,    -1,   373,    -1,   375,    -1,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,    -1,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,    -1,    -1,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,    -1,    -1,    -1,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,    -1,
     458,   459,    -1,   461,   462,    -1,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
      -1,   479,   480,   481,   482,   483,   484,   485,   486,   487,
      -1,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,    -1,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,    -1,    -1,    -1,
     578,   579,    -1,   581,   582,   583,   584,    -1,   586,   587,
     588,   589,   590,   591,    -1,    -1,    -1,    -1,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,    -1,   623,    -1,   625,   626,    -1,
     628,   629,    -1,   631,   632,   633,   634,   635,   636,    -1,
     638,   639,   640,   641,   642,   643,   644,    -1,   646,   647,
     648,    -1,   650,   651,   652,   653,    -1,   655,   656,    -1,
      -1,   659,    -1,    -1,   662,   663,   664,    -1,   666,    -1,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,    -1,
     678,   679,    -1,   681,    -1,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,    29,   704,   705,   706,   707,
     708,   709,   710,   711,    38,   713,   714,   715,    -1,   717,
     718,   719,   720,    -1,    -1,   723,   724,    -1,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,    -1,    -1,   742,   743,    -1,    -1,   746,    -1,
     748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,
     134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,    -1,   311,    -1,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,    -1,    -1,   342,   343,
     344,   345,   346,    -1,    -1,   349,   350,   351,   352,    -1,
      -1,    -1,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,    -1,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,    -1,    -1,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,    -1,    -1,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,    -1,   458,   459,    -1,   461,   462,    -1,
      -1,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,    -1,   479,   480,   481,   482,   483,
     484,   485,   486,   487,    -1,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,    -1,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,    -1,    -1,    -1,   578,   579,    -1,   581,   582,   583,
     584,    -1,   586,   587,   588,   589,   590,   591,    -1,    -1,
      -1,    -1,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,    -1,   623,
      -1,   625,   626,    -1,   628,   629,    -1,   631,   632,   633,
     634,   635,   636,    -1,   638,   639,   640,   641,   642,   643,
     644,    -1,   646,   647,   648,    -1,   650,   651,   652,   653,
      -1,   655,   656,    -1,    -1,   659,    -1,    -1,   662,   663,
     664,    -1,   666,    -1,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,    29,   678,   679,    -1,   681,    -1,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,    -1,
     704,   705,   706,   707,   708,   709,   710,   711,    -1,   713,
     714,   715,    -1,   717,   718,   719,   720,    -1,    -1,   723,
     724,    -1,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,    -1,    93,   742,   743,
      -1,    -1,   746,    -1,   748,   749,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,   225,
     226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,    -1,   311,    -1,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,    -1,    -1,   342,   343,   344,   345,
     346,    -1,    -1,   349,   350,   351,   352,    -1,    -1,    -1,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,    -1,
     366,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,    -1,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,    -1,    -1,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
      -1,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,    -1,   458,   459,    -1,   461,   462,    -1,    -1,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,    -1,   479,   480,   481,   482,   483,   484,   485,
     486,   487,    -1,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,    -1,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,    -1,    -1,
      -1,    -1,   578,   579,    -1,   581,   582,   583,   584,    -1,
     586,   587,   588,   589,   590,   591,    -1,    -1,    -1,    -1,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,    -1,   623,    -1,   625,
     626,    -1,   628,   629,    -1,   631,   632,   633,   634,   635,
     636,    -1,   638,   639,   640,   641,   642,   643,   644,    -1,
     646,   647,   648,    -1,   650,   651,   652,   653,    -1,   655,
     656,    -1,    -1,   659,    -1,    -1,   662,   663,   664,    -1,
     666,    -1,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,    -1,   678,   679,    -1,   681,    -1,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,    -1,   704,   705,
     706,   707,   708,   709,   710,   711,    -1,   713,   714,   715,
      -1,   717,   718,   719,   720,    37,    38,   723,   724,    -1,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,    -1,    -1,   742,   743,    -1,    -1,
     746,    -1,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    -1,   746,   747,   748,   749,    45,    46,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    45,   746,
     747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    74,   746,
     747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    46,
     746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   769,    -1,    -1,    -1,    -1,   774,    -1,
      -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    -1,   746,
     747,   748,   749,    57,    -1,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    -1,   746,   747,   748,   749,    57,    -1,    -1,    -1,
      61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,    -1,    -1,    -1,    -1,   110,
     111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,    -1,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    57,
      -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,    -1,
      -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,    -1,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,    61,   746,   747,
     748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    61,   746,   747,   748,   749,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    61,   746,   747,   748,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    61,
     746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    61,   746,   747,   748,   749,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,    -1,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,    61,   746,   747,
     748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    61,   746,   747,   748,   749,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,    -1,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,    -1,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     770,    -1,    -1,    -1,    -1,    -1,    -1,   777,   778,   139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   778,   139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   778,   139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   778,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,   778,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   778,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   299,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,
      -1,    -1,    -1,    -1,   774,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   105,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   171,   172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   187,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   246,   247,   248,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    95,   746,   747,   748,   749,
     100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   759,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    95,   746,   747,   748,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,   753,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   229,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   229,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   237,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   247,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   247,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   204,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   204,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
      -1,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,    -1,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,    -1,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
      -1,   311,    -1,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,    -1,
      -1,    -1,   342,   343,   344,   345,   346,    -1,    -1,   349,
     350,   351,   352,    -1,    -1,    -1,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,    -1,   366,    -1,    -1,    -1,
      -1,    -1,    -1,   373,    -1,   375,    -1,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,    -1,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,    -1,
      -1,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,    -1,    -1,    -1,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,    -1,   458,   459,
      -1,   461,   462,    -1,    -1,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,    -1,   479,
     480,   481,   482,   483,   484,   485,   486,   487,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
      -1,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   110,   111,    -1,    -1,   578,   579,
      -1,   581,   582,   583,   584,    -1,   586,   587,   588,   589,
     590,   591,    -1,    -1,    -1,    -1,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,    -1,   623,    -1,   625,   626,    -1,   628,   629,
      -1,   631,   632,   633,   634,   635,   636,    -1,   638,   639,
     640,   641,   642,   643,   644,    -1,   646,   647,   648,    -1,
     650,   651,   652,   653,    -1,   655,   656,    -1,    -1,   659,
      -1,    -1,   662,   663,   664,    -1,   666,    -1,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,    -1,   678,   679,
      -1,   681,    -1,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,    -1,   704,   705,   706,   707,   708,   709,
     710,   711,    -1,   713,   714,   715,    -1,   717,   718,   719,
     720,    -1,    -1,   723,   724,    -1,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
      -1,    -1,   742,   743,    -1,    -1,   746,    -1,   748,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,    -1,   311,    -1,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,    -1,    -1,    -1,   342,   343,   344,   345,
     346,    -1,    -1,   349,   350,   351,   352,    -1,    -1,    -1,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,    -1,
     366,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,    -1,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,    -1,    -1,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
      -1,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,    -1,   458,   459,    -1,   461,   462,    -1,    -1,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,    -1,   479,   480,   481,   482,   483,   484,   485,
     486,   487,    -1,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,    -1,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   110,   111,
      -1,    -1,   578,   579,    -1,   581,   582,   583,   584,    -1,
     586,   587,   588,   589,   590,   591,    -1,    -1,    -1,    -1,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,    -1,   623,    -1,   625,
     626,    -1,   628,   629,    -1,   631,   632,   633,   634,   635,
     636,    -1,   638,   639,   640,   641,   642,   643,   644,    -1,
     646,   647,   648,    -1,   650,   651,   652,   653,    -1,   655,
     656,    -1,    -1,   659,    -1,    -1,   662,   663,   664,    -1,
     666,    -1,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,    -1,   678,   679,    -1,   681,    -1,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,    -1,   704,   705,
     706,   707,   708,   709,   710,   711,    -1,   713,   714,   715,
      -1,   717,   718,   719,   720,    -1,    -1,   723,   724,    -1,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,    -1,    -1,   742,   743,    -1,    -1,
     746,    -1,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,    -1,   311,
      -1,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,    -1,    -1,    -1,
     342,   343,   344,   345,   346,    -1,    -1,   349,   350,   351,
     352,    -1,    -1,    -1,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,    -1,   366,    -1,    -1,    -1,    -1,    -1,
      -1,   373,    -1,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,    -1,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,    -1,    -1,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,    -1,    -1,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,    -1,   458,   459,    -1,   461,
     462,    -1,    -1,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,    -1,   479,   480,   481,
     482,   483,   484,   485,   486,   487,    -1,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,    -1,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,    -1,    -1,    -1,    -1,   578,   579,    -1,   581,
     582,   583,   584,    -1,   586,   587,   588,   589,   590,   591,
      -1,    -1,    -1,    -1,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
      -1,   623,    -1,   625,   626,    -1,   628,   629,    -1,   631,
     632,   633,   634,   635,   636,    -1,   638,   639,   640,   641,
     642,   643,   644,    -1,   646,   647,   648,    -1,   650,   651,
     652,   653,    -1,   655,   656,    -1,    -1,   659,    -1,    -1,
     662,   663,   664,    -1,   666,    -1,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,    -1,   678,   679,    -1,   681,
      -1,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,    -1,   704,   705,   706,   707,   708,   709,   710,   711,
      -1,   713,   714,   715,    -1,   717,   718,   719,   720,    -1,
      -1,   723,   724,    -1,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,    -1,    -1,
     742,   743,    -1,    -1,   746,    -1,   748,   749
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     7,     8,    27,    29,    31,    33,    41,    63,    65,
      66,    73,    80,    93,    99,   112,   120,   131,   144,   146,
     151,   181,   195,   196,   206,   207,   218,   219,   220,   222,
     227,   233,   237,   241,   242,   279,   281,   283,   288,   298,
     299,   306,   316,   338,   339,   341,   348,   355,   376,   401,
     411,   430,   444,   457,   460,   463,   478,   595,   624,   627,
     637,   645,   657,   677,   680,   712,   722,   747,   769,   781,
     784,   785,   786,   787,   788,   790,   796,   798,   811,   858,
     902,   903,   910,   911,   927,   928,   959,   980,   999,  1059,
    1116,  1168,  1266,  1316,  1319,  1329,  1334,  1340,  1353,  1356,
    1362,  1365,  1370,  1377,  1389,  1392,  1395,  1396,  1398,  1401,
    1402,  1404,  1405,  1408,  1409,  1412,  1633,  1635,  1648,  1651,
    1686,  1694,  1709,  1716,  1730,  1734,  1735,  1739,  1749,  1756,
    1764,  1766,  1772,  1775,  1776,  1808,  1856,  1886,  1893,  1895,
    1904,  1907,  1947,  1949,  1954,  1955,  1956,  1957,  1987,  1996,
    1997,  1998,    49,   205,   326,   402,   451,   499,   650,   654,
     696,   726,  1267,  1961,  1962,  1963,  1964,   174,   448,   497,
    1364,  1737,   110,   111,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   366,   367,
     368,   369,   370,   371,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     746,   747,   748,   749,  1827,  1829,  1836,  1843,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,   960,   518,  1357,   186,
     499,   696,  1695,    49,   115,   205,   272,   425,   451,   499,
     636,   654,   696,   699,   726,   734,  1647,  1002,   850,   929,
    1649,  1767,   115,   396,   748,  1781,   263,   695,  1889,  1000,
    1364,  1169,  1060,    17,   518,  1722,   237,   247,   899,   904,
     906,  1836,   645,   726,  1889,  1004,   904,   905,   850,  1399,
     678,  1857,  1717,   904,  1894,  1687,  1836,  1397,  1001,   214,
    1810,  1652,   146,   279,   675,  1750,   171,   172,  1445,  1948,
     265,   778,  1830,   115,  1889,   743,  1951,  1634,   472,  1836,
    1364,   391,   912,  1896,   797,   589,   667,  1836,  1364,  1757,
    1951,  1836,  1773,     6,   660,   708,     6,   660,  1710,   589,
     667,   339,   340,   376,   416,   595,   612,   637,   677,  1990,
    1398,  1405,  1408,     0,    80,   782,   595,    49,    96,   244,
     278,   636,   726,   829,  1245,  1246,  1247,  1647,  1961,  1962,
    1963,  1964,    95,   123,  1415,  1416,  1629,  1393,  1390,    83,
     121,   277,  1407,  1958,  1406,  1958,   437,   448,   582,   777,
    1736,  1737,  1824,  1836,  1402,  1404,  1284,  1836,   852,  1836,
     753,   753,   852,   100,   112,  1646,   139,  1830,  1836,  1838,
    1007,  1008,  1011,  1034,  1836,  1646,  1308,  1309,   251,  1433,
    1965,  1966,  1961,   753,  1889,  1389,  1392,  1648,  1651,  1686,
    1694,  1733,   777,   859,   296,   961,   962,   965,   969,   809,
     810,  1830,   734,  1354,  1889,   316,   100,  1009,  1034,   114,
     152,   465,   607,  1697,  1707,  1708,  1646,  1637,  1646,  1646,
    1646,  1646,   100,  1646,  1646,  1034,  1646,  1646,   650,  1889,
     983,  1836,     6,     7,    41,    46,    63,    73,    99,   115,
     120,   146,   216,   233,   241,   272,   281,   282,   425,   430,
     441,   600,   604,   621,   626,   657,   689,  1838,  1908,  1912,
    1913,  1915,  1917,  1918,   954,   955,   152,   403,   464,  1654,
     461,   666,  1768,   123,  1777,  1887,    38,    87,    98,   127,
     134,   225,   226,   339,   361,   433,   574,   877,   925,   926,
     927,   930,   931,   932,   933,   937,   938,   939,   940,   941,
     949,   950,   951,   952,   973,   975,   976,   978,   986,   992,
    1829,  1837,  1844,  1851,  1853,  1854,  1855,  1889,    17,    18,
      19,    20,    21,    29,    30,    32,    39,    40,    43,    44,
      45,    46,    48,    49,    51,    52,    57,    61,    64,    84,
      85,    86,    88,    89,   101,   102,   103,   105,   106,   110,
     111,   112,   120,   122,   135,   149,   154,   155,   157,   163,
     165,   168,   171,   172,   173,   175,   176,   177,   179,   194,
     198,   199,   200,   202,   209,   220,   228,   231,   251,   257,
     258,   260,   261,   265,   273,   274,   275,   285,   286,   287,
     293,   295,   316,   317,   318,   322,   329,   337,   353,   362,
     364,   365,   367,   368,   369,   370,   371,   386,   398,   399,
     400,   448,   454,   456,   468,   490,   491,   495,   533,   535,
     540,   541,   542,   543,   553,   554,   570,   584,   590,   591,
     598,   605,   635,   641,   642,   648,   655,   685,   704,   705,
     706,   707,   711,   712,   726,   728,   738,   739,   741,   749,
     758,   759,   764,   769,   773,   774,   777,   778,  1408,  1414,
    1439,  1440,  1441,  1442,  1446,  1458,  1462,  1463,  1464,  1465,
    1466,  1467,  1468,  1472,  1473,  1474,  1475,  1483,  1487,  1488,
    1489,  1490,  1491,  1493,  1496,  1800,  1803,  1805,  1806,  1807,
    1821,  1828,  1829,  1836,  1843,    26,  1061,   500,   350,   357,
     373,   383,   384,   385,   393,   532,   546,   647,   684,   698,
     907,   909,   728,   900,   906,  1836,   850,  1366,   877,   989,
     906,     6,   321,   604,  1905,  1906,  1913,  1915,     6,    68,
     249,   250,   259,   464,   670,   671,   672,   673,  1418,  1425,
    1426,  1960,  1858,    32,    61,   353,   458,   497,   547,   584,
     636,   653,   708,   740,   778,  1208,  1829,  1834,  1836,  1847,
    1848,  1849,  1850,  1852,  1853,  1854,  1855,  1861,  1873,  1877,
       6,    40,    41,    50,   115,   129,   205,   263,   313,   332,
     341,   353,   364,   388,   419,   422,   424,   450,   451,   458,
     459,   475,   497,   518,   574,   588,   599,   602,   603,   617,
     653,   660,   681,   737,  1208,  1244,  1718,  1722,  1723,  1725,
    1734,  1829,  1874,   906,  1889,   152,  1693,   769,  1665,  1674,
     987,  1439,  1809,   403,  1655,  1693,  1751,  1836,   331,  1951,
    1838,  1371,  1330,    10,  1952,  1439,  1516,   791,   284,   793,
    1740,   406,  1824,  1826,  1836,  1897,  1838,   112,  1115,  1830,
      95,  1335,   518,   606,   660,  1758,  1759,   270,  1952,   736,
    1774,   661,   809,   211,   299,  1320,  1321,  1322,   661,   809,
     263,  1711,  1646,  1646,    18,   105,   106,   265,  1801,  1802,
    1831,  1989,  1989,  1989,   448,  1988,  1989,  1989,   770,   770,
     776,  1836,  1115,  1115,  1115,   654,   834,   115,   115,   115,
     263,   650,   205,   272,   425,  1965,   325,   851,   851,  1961,
      74,   769,   774,  1414,  1417,  1521,  1522,  1523,  1524,  1525,
    1536,  1537,  1538,  1539,  1541,  1542,  1543,  1824,   189,   412,
    1624,  1625,  1630,   297,  1566,  1415,    93,   141,   146,   185,
    1427,  1591,  1596,  1602,  1603,  1607,   205,  1606,  1619,  1629,
       6,    68,  1959,  1602,  1604,  1408,  1411,  1412,  1603,  1605,
    1410,     6,  1836,  1732,  1731,   777,  1394,  1391,  1269,   725,
    1270,   777,   531,   700,   718,    45,  1838,  1839,  1840,  1912,
    1271,  1013,  1035,  1836,    84,  1276,  1275,     5,    31,    73,
     172,   212,   610,  1036,   850,   263,   114,   573,  1310,  1311,
    1312,   649,   425,   734,  1965,  1838,  1341,  1836,   769,   862,
     970,    76,   972,  1439,   969,   270,  1355,  1640,  1641,  1824,
    1012,  1035,     5,    95,  1698,    95,  1698,  1699,  1700,  1704,
    1705,  1836,  1707,  1836,   112,  1645,   852,   852,   852,  1836,
    1035,   850,  1838,  1045,  1723,   850,  1638,  1646,  1646,  1003,
     984,   599,  1916,   639,   639,   696,   699,   726,   734,   769,
    1438,   465,   576,  1920,   695,  1922,  1919,    50,   734,  1921,
     180,   358,   660,   270,   180,   772,   416,  1439,   114,  1307,
     381,   606,  1769,  1770,   348,   152,   380,  1783,  1824,  1890,
    1891,   296,  1837,    95,   100,   553,  1836,  1837,  1837,  1837,
     979,  1836,   296,  1837,  1836,   416,   926,   776,   785,   934,
     953,  1836,    93,   151,   220,   298,   339,   779,  1363,   122,
     758,   759,  1465,   769,   769,   769,   296,  1439,  1519,  1520,
     769,   769,   769,   769,   769,  1438,  1438,  1438,   769,  1437,
     769,   769,   769,   769,   769,   769,   769,   769,   769,   769,
     769,   769,   769,   769,  1439,   769,   110,   111,   365,   769,
    1517,  1518,  1821,  1828,  1843,   769,   769,   769,   769,  1439,
    1437,   769,   769,   769,   769,   769,   769,   769,   769,   769,
     769,   197,   769,   769,   769,  1437,   265,  1802,  1438,  1437,
    1437,   769,   769,   769,   769,   769,   769,   769,   769,   769,
     769,   769,   177,  1828,   769,   769,   769,   769,   769,   769,
     769,   265,   769,   769,   769,   769,   769,   769,   769,   769,
     769,   769,   769,   769,   769,   769,   769,   728,   769,   769,
     769,   769,   769,   728,   769,   769,   769,   769,   769,   769,
     769,   265,   769,   769,   769,   265,   769,   769,   769,   769,
     769,   769,   769,   769,   769,   122,  1465,   122,  1465,  1465,
    1170,  1408,  1439,  1808,  1836,  1828,  1497,     9,    10,   184,
     186,   303,  1443,  1444,    81,    97,   126,   132,   169,   753,
     754,   755,  1447,    15,   125,   140,   217,   668,  1445,    69,
     165,   183,   239,   240,   756,   757,   758,   759,   760,   761,
     762,   763,  1465,    34,   166,   191,   191,   741,  1831,   777,
     769,   197,  1062,    14,   270,   772,   753,  1831,  1367,  1839,
    1841,  1368,  1369,  1824,   724,  1916,   576,   180,    95,   180,
    1400,  1426,    61,  1836,  1860,  1876,   237,   636,   777,    17,
      61,   238,   753,  1209,  1210,  1668,  1838,    93,  1668,  1883,
    1668,  1838,  1863,   778,  1838,    17,    61,  1212,  1213,  1838,
    1668,   777,  1864,  1862,   661,   769,    49,   205,   263,   272,
     313,   425,   451,   650,   726,   734,   140,   297,  1729,   363,
     679,   679,   307,   679,   424,  1729,     6,  1127,  1838,  1595,
    1596,  1597,    95,   125,  1724,  1726,   363,   679,    93,   679,
     695,   667,     6,   343,   387,   389,   481,   530,   579,   669,
     691,  1712,  1713,  1714,   809,   467,   679,   810,  1597,  1729,
    1726,   500,   418,   366,   601,   695,   710,    93,  1432,   679,
     731,  1307,  1675,   772,   411,  1811,  1812,  1816,  1836,   123,
    1656,  1657,  1658,  1824,   981,   772,  1372,  1373,  1374,  1375,
    1824,  1640,   351,   560,   218,   560,  1953,   772,  1439,   794,
      17,   252,   405,   419,   421,   452,   467,   500,   518,   599,
     606,   616,   629,   660,   663,   679,  1741,  1746,  1747,  1829,
    1889,    35,   778,   913,   914,   915,   916,  1828,   574,   211,
     361,  1445,  1836,   789,   734,  1332,  1889,  1761,   348,  1760,
     772,   645,  1836,  1953,    93,  1323,  1324,  1323,   572,   745,
     382,   772,  1323,  1323,  1641,  1836,  1830,   772,   571,  1992,
     690,  1993,   753,   128,   631,  1991,    80,   783,  1836,   850,
     850,  1115,  1115,   817,   819,  1115,  1115,  1115,   824,   826,
     734,   451,   451,  1965,  1521,  1525,  1537,  1538,  1539,  1540,
    1541,  1836,    94,  1423,    42,   117,   128,   135,   167,   228,
     259,  1532,  1533,   772,   196,  1534,  1535,   265,  1832,  1832,
     778,  1626,  1627,  1628,  1836,  1838,  1567,   100,  1570,  1566,
     281,   149,   177,   229,   274,   365,  1598,  1599,  1803,  1828,
     125,    26,  1595,  1427,  1836,  1427,  1428,  1428,  1411,  1733,
    1738,  1801,  1836,  1836,  1603,  1606,    61,  1112,  1113,  1124,
    1125,  1217,   396,   853,  1836,  1438,   778,   853,     5,  1014,
    1824,   575,   395,  1031,  1031,  1031,     4,  1839,  1840,  1841,
    1928,  1932,  1824,  1312,   402,   479,   852,  1824,   734,  1342,
    1343,  1641,   777,   860,   863,   864,  1439,  1439,   877,   416,
     963,   799,  1640,    93,   352,   437,   439,   529,   607,   772,
    1358,  1359,  1360,  1014,  1031,  1824,    14,  1696,  1643,  1644,
    1825,  1836,    93,  1421,  1422,  1566,   772,  1701,   777,  1706,
      84,  1836,   777,  1045,  1911,  1913,   563,   736,  1046,  1047,
     419,  1841,  1927,  1640,  1639,  1636,   411,   125,   985,   695,
     770,   769,  1936,  1936,  1936,  1936,  1841,  1928,   192,   205,
     263,   451,  1914,   425,   430,   441,   600,   621,   626,   657,
     689,  1918,   112,   266,  1656,   469,   726,  1439,  1771,  1771,
    1378,   497,  1782,    11,   753,  1562,  1563,  1564,   564,   736,
     772,  1888,   935,   936,   296,  1836,   553,    95,   123,   878,
     935,   296,   769,   948,   151,   776,  1439,   772,   995,   993,
     998,   994,   977,  1640,   769,     6,  1507,  1565,  1507,  1507,
    1439,  1520,    76,   296,   416,  1439,  1516,  1439,    68,  1507,
    1565,   770,    57,    89,   105,   149,   177,   274,   770,  1611,
    1615,  1616,   770,  1439,  1439,  1821,   770,  1403,  1404,  1413,
    1808,    53,    54,    55,    56,   107,   108,   109,   161,   162,
     232,   304,   400,   468,   533,   535,   540,   605,   648,   738,
     749,  1559,  1560,  1439,    68,  1499,  1439,  1439,  1439,  1439,
    1439,  1559,  1439,  1828,  1518,   324,   772,   777,    68,  1507,
    1439,    68,  1507,  1439,  1439,  1439,   770,  1439,  1439,  1442,
     770,  1439,  1439,   770,   640,  1507,  1507,    68,  1507,  1507,
    1507,  1439,  1439,  1469,  1470,  1471,    25,   133,   271,  1439,
    1459,  1460,  1461,  1439,  1439,    68,  1507,  1439,  1516,  1439,
     777,  1439,  1439,  1439,  1455,  1456,  1439,  1439,  1439,  1439,
    1439,  1439,  1439,  1516,   397,   399,   704,   707,  1561,  1439,
    1439,  1516,  1824,  1516,  1439,  1439,  1439,  1516,  1516,  1516,
      93,  1824,  1439,  1439,  1439,  1516,    93,  1439,  1439,  1439,
     770,  1439,  1824,  1439,  1439,  1560,  1560,  1439,  1459,  1439,
     770,   365,   777,  1822,  1836,  1439,  1439,  1439,  1439,  1439,
    1439,   770,   772,  1404,  1439,   777,   778,  1498,  1838,  1439,
    1439,  1439,  1441,    86,   176,   273,   723,  1445,     6,   328,
    1441,  1448,  1441,   769,  1414,  1441,  1441,   140,    15,   125,
     140,   217,  1442,  1442,  1442,  1442,  1442,  1442,  1442,   122,
    1442,   122,  1442,  1442,  1442,  1442,  1442,  1214,  1838,  1465,
     769,  1495,  1576,  1836,   769,   100,   316,   317,   318,  1828,
    1476,   449,   483,   559,   640,  1457,   142,   208,   496,   694,
    1063,  1067,  1765,  1830,   909,   399,   704,   707,   908,  1496,
    1805,  1821,   772,   270,   772,  1888,   990,   772,    93,  1841,
    1840,  1929,   192,   205,   451,  1914,   760,  1430,  1431,  1433,
     777,   777,  1668,   772,  1859,  1913,  1836,    34,  1215,  1439,
    1841,   265,   570,   584,  1884,     6,    17,    61,   180,  1439,
    1885,   211,   482,  1878,  1879,  1880,  1881,   458,   497,   653,
    1875,  1668,  1885,  1836,   708,  1865,  1876,   772,  1867,   679,
     760,  1115,   852,  1824,   852,   307,   852,   852,   852,  1824,
    1841,  1824,  1432,  1432,   852,  1729,  1724,   363,   679,  1729,
     125,  1727,   500,   544,   679,  1721,  1721,  1729,  1836,   852,
    1729,  1840,  1724,  1729,  1830,   480,   692,   440,    93,  1715,
     772,   424,   679,  1824,  1726,  1724,  1724,  1439,  1729,  1729,
    1729,  1522,  1685,  1824,  1433,  1677,  1679,   769,  1672,   988,
     772,   769,  1814,  1657,  1653,  1642,  1824,   878,   778,   125,
     772,   196,  1383,  1385,  1386,   437,   607,  1331,   351,   218,
    1439,   792,    61,   114,   795,  1439,  1680,  1681,   500,   500,
     500,   500,   348,   500,   809,   500,   772,  1432,  1742,   908,
     918,  1838,   772,   753,  1563,  1898,    84,   667,  1439,  1333,
    1640,   270,  1763,   809,  1759,  1836,     6,  1318,   620,   674,
    1325,  1326,  1317,   664,  1322,  1888,  1801,   587,  1994,  1838,
     821,  1911,  1928,  1838,   815,  1115,  1115,   812,  1824,   825,
    1433,  1974,   838,  1433,  1115,  1115,  1115,   734,   772,   770,
     770,   770,   770,   770,   772,   770,  1521,     6,    11,    15,
      95,  1424,  1564,   128,   128,   188,  1544,   135,   228,  1532,
    1544,  1521,  1523,   769,  1423,  1631,  1838,   772,   777,  1439,
      26,   104,  1568,  1570,   564,   736,  1429,   428,  1828,   229,
     569,   772,   777,   656,  1592,  1620,  1113,    34,  1208,   407,
     164,   210,   251,   374,   386,   488,   560,   855,   857,  1838,
     613,   719,  1032,  1033,   476,  1028,  1029,  1030,  1037,  1045,
    1047,  1277,   769,  1830,   333,   525,  1022,  1023,  1024,  1037,
    1038,  1039,  1045,  1047,  1015,  1016,  1022,   470,   221,   772,
    1939,  1888,  1274,  1273,  1824,   772,   586,  1344,  1836,   862,
     770,   772,   971,    29,   296,   964,   966,    71,   113,   153,
     471,   501,   502,   504,   505,   506,   507,   508,   510,   511,
     512,   513,   514,   515,   516,   517,   519,   520,   521,   618,
     619,   800,   801,   808,    93,  1361,   725,  1641,  1359,   374,
     557,   614,   720,  1025,  1026,  1027,  1037,  1041,  1042,  1043,
    1044,  1045,  1047,   283,  1010,  1534,   694,   772,  1702,   777,
    1706,   201,  1590,  1591,  1705,    95,   760,  1836,   180,  1836,
    1046,   772,  1668,  1669,   772,    28,   223,  1313,  1640,  1640,
     877,   635,   982,  1836,  1937,  1938,   270,   299,  1910,    24,
     760,  1824,  1836,  1926,  1926,  1926,  1926,   956,  1650,  1439,
    1841,  1379,  1380,  1381,  1382,  1824,   116,  1829,  1833,  1842,
    1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,   152,   211,
     745,  1892,   105,   759,  1608,  1610,  1891,  1439,   935,   123,
     641,  1836,    59,   876,   879,   935,   942,   943,   947,  1836,
     983,   986,   989,   987,   878,  1888,  1439,   770,  1508,   770,
     770,   266,   416,  1439,  1439,    11,   284,   770,   284,   772,
    1484,   770,   760,   770,   772,   772,   770,   770,  1404,    95,
     770,  1486,   770,   772,   770,   772,   772,   772,   772,   759,
     772,   770,   769,  1821,  1828,  1507,   770,   770,  1507,   770,
     772,   770,   772,   770,   770,   125,   772,   772,   770,   770,
    1507,   770,   770,   770,   772,    95,   772,   770,    95,  1439,
      95,  1439,    95,  1439,    95,   770,   772,   770,  1507,   770,
     770,   770,   770,  1828,   772,   770,   772,   770,   772,   772,
     772,   772,   772,   770,   770,   772,   770,   772,   770,   770,
     772,   770,   770,   770,   770,   770,   770,   770,   770,  1824,
     770,   770,   770,   772,   770,  1824,   770,   770,   772,   770,
     772,   772,   770,   772,   772,   772,   770,   770,   772,  1828,
    1836,   770,   777,   770,   772,    11,   494,   772,  1233,   772,
     770,  1559,  1559,  1516,   770,   775,  1828,  1875,   238,    86,
     176,   273,   723,   769,    10,  1439,   423,  1441,  1441,   769,
    1414,  1441,  1441,  1439,  1439,  1577,   196,  1579,   769,   769,
     769,   769,   769,   777,  1433,  1480,  1481,  1482,   366,   769,
    1072,  1073,  1065,  1072,  1066,   582,  1075,   130,   462,  1439,
     753,  1841,  1841,  1369,   270,  1439,    99,  1913,    95,   772,
      24,  1926,  1926,  1926,  1926,   772,  1439,  1819,  1828,  1836,
    1836,  1885,  1876,    93,    93,  1668,    61,  1214,  1216,  1668,
     769,   769,   572,   745,   494,   772,   772,   777,   777,   777,
      61,   740,  1829,  1830,  1835,  1845,  1848,  1849,  1850,  1851,
    1852,  1854,  1855,  1439,  1668,  1878,  1866,  1868,  1869,   770,
    1836,   852,  1830,  1439,  1729,   852,  1729,  1830,    95,  1728,
     850,  1729,   606,  1597,  1714,  1727,  1724,  1824,  1729,  1729,
     237,  1534,  1681,   770,   772,  1673,   877,  1812,  1815,  1836,
    1813,   136,   137,   237,  1053,  1403,  1659,  1661,  1664,  1534,
     876,  1838,    61,  1376,  1836,  1374,  1824,  1058,  1385,   115,
     130,  1242,  1387,   793,   772,    62,  1752,   809,  1747,  1640,
    1748,   916,   919,   920,   915,   565,   566,   642,   917,   442,
     553,  1836,  1899,  1900,  1830,  1640,   437,   607,   727,  1336,
    1337,  1338,  1610,     6,  1762,   661,   772,   724,  1327,   772,
      93,  1995,  1111,  1112,   299,  1909,  1939,   835,  1836,  1836,
    1836,  1824,   814,   852,  1984,  1115,  1115,  1824,   852,  1836,
     852,  1115,  1521,  1521,   775,   568,   704,   708,  1419,  1420,
    1467,  1420,   128,  1544,  1544,  1536,   128,   180,   284,  1558,
    1836,  1563,  1208,  1211,  1627,  1836,  1439,  1571,  1820,  1569,
     740,  1573,  1568,  1610,  1599,  1600,   428,  1599,  1599,  1828,
     538,  1593,  1820,   769,  1669,  1669,   548,   251,   251,   649,
    1830,   251,   251,   251,  1830,  1830,  1669,   772,  1030,   156,
     348,   394,   474,   536,   555,   556,   560,   561,   562,   628,
     677,   831,   832,    49,   466,   577,   584,   592,   665,   726,
     836,   837,  1669,  1669,   772,  1024,  1017,  1018,  1037,  1038,
    1039,    26,   299,   733,  1930,   252,   356,   484,   558,   686,
     746,  1924,  1925,  1932,   299,  1942,  1268,   180,   846,  1281,
     769,  1967,  1272,  1343,    93,   861,  1439,   266,   967,   966,
     753,   753,   753,   753,   753,   753,   753,   753,   753,   753,
     753,   753,   753,   753,   753,   753,   753,   753,   753,   753,
     753,   753,   753,   753,   772,   725,  1669,  1669,  1669,  1669,
     772,  1027,   499,   438,  1019,  1020,  1021,  1037,  1038,  1039,
    1040,  1043,  1044,  1045,  1047,  1420,  1644,  1836,   284,  1836,
     568,   141,  1601,  1522,   777,  1706,  1824,  1913,  1126,  1838,
    1841,  1888,   416,   769,   942,   945,   770,   772,  1928,   321,
    1926,   777,   777,   270,   270,   270,   270,   877,  1659,   772,
    1383,  1385,  1832,   745,   497,   380,    57,    89,   149,   177,
     274,   123,    37,    38,   432,   433,   740,   885,   886,   887,
     889,   895,   922,   923,  1829,  1846,  1848,  1849,  1850,  1851,
    1852,  1853,  1854,  1855,   416,   926,   776,   944,   770,   772,
     996,   974,   991,  1837,   991,   991,   876,   772,  1439,  1439,
     266,    17,    32,    58,    70,    90,   122,   124,   280,   292,
     397,   399,   550,   658,   707,   730,  1509,  1513,  1514,  1209,
    1209,  1509,  1516,   770,   122,   122,  1439,  1516,  1439,  1439,
    1439,  1439,  1439,  1439,  1439,  1442,   777,   770,   770,  1439,
    1439,  1439,  1439,  1439,   770,  1439,  1439,  1439,  1439,    95,
    1439,    95,  1439,    95,  1439,   122,  1439,   770,  1456,  1439,
    1455,  1516,  1439,  1439,  1439,  1439,  1439,  1439,  1439,  1516,
     149,   758,  1608,  1612,   122,  1439,  1439,  1439,  1439,  1439,
     777,   777,  1836,  1439,    17,    32,  1228,  1229,  1230,  1231,
    1232,  1611,  1610,   770,  1439,   759,   759,  1835,  1439,  1413,
    1441,   770,   772,  1441,    10,  1439,   423,  1559,  1559,  1578,
    1836,    26,   770,  1492,  1515,  1516,  1439,  1471,  1515,  1439,
    1461,  1515,  1515,  1828,  1439,   770,   772,   769,  1081,  1442,
    1073,   141,  1107,  1108,  1611,   688,  1076,   326,  1068,  1064,
     908,   270,  1824,   416,   576,  1927,  1840,  1926,    95,    95,
      95,    95,  1431,  1434,  1434,   777,  1668,  1668,   784,  1841,
    1885,   265,   265,   211,   625,   651,  1882,  1880,  1879,   777,
     777,  1668,  1885,  1867,   772,  1871,  1873,  1877,   422,   737,
    1608,  1613,  1719,   177,  1728,  1566,  1724,  1689,  1690,  1822,
    1421,  1434,  1433,  1676,  1678,  1681,   416,   770,   772,    11,
    1662,  1663,  1817,  1818,  1822,  1836,  1808,  1660,  1664,   416,
    1384,   769,  1681,   753,    93,   299,  1743,  1744,   753,   772,
      97,   132,   442,   489,   553,   597,   753,   754,   755,  1901,
    1903,  1566,    95,  1339,  1337,  1326,   503,   808,  1328,  1610,
     534,   321,  1942,    92,   284,   714,  1255,   180,   180,   813,
     830,   831,  1985,  1975,   852,   822,   769,   633,   769,  1824,
    1420,   265,  1442,    10,   270,  1521,  1536,   128,   128,  1521,
    1536,  1526,  1527,   770,   772,  1553,  1554,  1210,  1632,   300,
     301,   772,  1572,    12,    65,  1594,  1439,  1495,  1574,  1575,
    1573,  1600,  1429,   772,  1594,  1433,  1621,  1622,  1623,  1216,
    1210,   396,   396,   402,   479,   105,   149,   177,   274,  1048,
    1614,  1615,  1829,  1030,  1669,  1669,    26,  1669,  1671,  1669,
     156,   536,   299,  1669,  1670,  1670,   832,  1830,  1830,  1830,
    1830,  1610,  1830,  1830,   770,   772,  1048,  1048,  1024,   772,
    1018,   265,   584,  1838,  1933,  1934,   265,   265,   265,    10,
    1923,   522,   523,   526,   527,   528,  1940,  1941,   319,   584,
    1280,     5,     7,     8,    31,    33,    39,    73,   115,   146,
     181,   185,   193,   196,   219,   254,   255,   256,   277,   302,
     326,   334,   336,   355,   362,   374,   381,   396,   404,   408,
     409,   415,   419,   427,   447,   473,   477,   487,   524,   537,
     539,   578,   584,   611,   622,   623,   624,   643,   650,   681,
     696,   697,   709,   712,  1056,  1118,  1120,  1123,  1124,  1125,
    1285,  1289,  1291,  1294,  1300,  1301,  1302,  1304,  1305,  1587,
    1829,   378,   646,   219,  1282,  1836,  1968,    11,  1967,     6,
     366,  1345,   862,   877,  1439,   769,   769,  1610,   769,  1610,
    1610,  1830,  1830,  1613,  1830,  1610,  1830,  1830,  1830,  1830,
    1830,  1830,  1830,  1610,  1830,   392,   560,   662,  1806,  1830,
    1610,   801,  1830,  1611,  1048,  1048,  1027,   100,  1669,   772,
    1021,   777,  1522,  1706,  1432,   229,  1599,   224,  1703,  1566,
    1888,  1313,    93,   892,   893,   946,    72,  1938,   299,  1944,
     576,   270,   760,   760,  1928,  1928,  1928,  1928,   957,   180,
    1682,  1381,  1824,  1385,   114,  1388,  1778,    16,    17,    22,
      23,    32,    58,    70,    90,   124,   147,   148,   150,   158,
     159,   160,   178,   213,   237,   243,   267,   268,   269,   291,
     292,   342,   344,   345,   360,   397,   399,   420,   443,   454,
     455,   486,   495,   541,   542,   543,   549,   550,   566,   567,
     590,   591,   609,   641,   701,   704,   707,   714,   730,   749,
    1174,  1176,  1177,  1179,  1180,  1181,  1182,  1183,  1184,  1185,
    1186,  1187,  1188,  1189,   460,    35,    47,   772,   776,  1439,
     943,   411,   416,  1439,  1439,   769,  1194,  1195,  1195,   769,
    1191,  1192,  1194,   769,  1192,  1197,    56,   124,  1194,  1195,
    1195,   124,  1195,  1194,   770,   770,   770,   770,  1485,  1439,
    1439,   770,   185,  1501,   770,   770,   772,   772,   770,   772,
     770,   125,  1477,  1478,  1828,   770,   770,   770,   770,   770,
     772,    93,   772,  1439,  1439,  1439,  1439,   770,   770,    11,
    1449,   770,    11,   770,   770,   772,   770,   772,   770,   770,
     770,   770,   149,   177,   177,   770,   772,  1439,   770,   770,
     772,   772,   770,  1828,  1836,   777,   770,   769,  1223,  1223,
      12,    65,   635,   758,  1225,  1226,  1227,   772,   772,   770,
    1439,  1439,   777,   770,  1516,  1441,   770,   772,  1441,  1579,
    1571,   185,  1494,   770,   770,   770,   770,   770,   770,   769,
    1434,  1482,  1069,  1070,  1071,  1836,   770,  1613,   122,    26,
     769,  1083,   753,   769,  1073,  1841,   220,    95,    95,  1929,
    1929,  1929,  1929,    11,  1435,  1830,  1836,   760,  1828,  1885,
    1885,   770,   770,   375,   717,   211,  1836,  1836,  1885,  1870,
    1872,    57,    89,   149,   177,   274,  1597,  1720,  1729,   772,
    1688,  1668,  1563,  1681,   770,   772,   298,  1836,   769,   770,
     772,   777,  1404,  1666,  1667,  1822,   769,   204,  1555,  1556,
    1557,  1836,   769,  1745,   211,   350,   357,   373,   383,   384,
     385,   393,   532,   546,   632,   647,   684,   698,   921,   920,
    1902,  1597,   545,   753,   772,  1840,  1280,   396,   346,   462,
     644,  1261,  1261,   180,  1824,  1824,   136,   138,   140,  1049,
    1051,  1117,  1119,  1120,  1132,  1117,   769,   874,   852,   839,
    1967,   828,    58,   124,   213,   683,  1130,   827,   823,  1420,
    1420,   180,  1529,  1536,  1536,   180,  1531,  1439,   769,  1058,
    1836,  1551,  1552,   366,  1785,  1820,    11,   772,  1820,  1439,
     770,   772,  1612,  1612,  1612,  1612,  1612,  1612,   837,  1018,
     265,    11,   284,  1931,  1935,   186,  1924,  1610,  1610,  1610,
    1806,   758,  1608,  1609,  1940,   146,   279,  1278,   435,    36,
     196,   372,   585,   693,  1136,  1144,  1145,  1150,  1151,  1242,
    1246,  1247,  1306,  1306,   196,  1306,   196,   270,    36,    92,
     196,   585,   693,  1149,  1242,  1306,   407,  1669,   196,    26,
    1669,  1058,    11,   270,   753,  1315,  1669,  1669,  1669,  1669,
     732,  1669,  1669,  1669,  1669,   196,  1669,  1669,   407,  1669,
     129,   696,   129,  1669,   196,   696,  1669,  1669,  1669,  1669,
    1306,  1669,  1669,   196,   583,   196,   196,  1669,  1669,   410,
     530,  1836,  1669,  1669,   196,  1118,   772,  1055,  1056,  1289,
     769,   777,  1135,  1152,  1823,  1836,  1668,  1445,  1950,   330,
     426,   840,   270,   408,   415,   842,   770,   772,  1969,  1970,
      11,     6,   769,  1346,   968,   804,   805,  1610,   806,   807,
    1610,   802,   803,  1610,  1836,  1048,  1021,  1836,  1566,  1836,
     428,   229,  1430,   894,   770,  1439,   945,    99,  1928,  1939,
    1939,  1939,  1939,    76,    77,   958,   413,  1388,   492,   114,
     316,  1784,  1194,  1196,  1195,   379,  1194,  1201,  1202,  1191,
     203,  1191,  1201,    17,    34,   329,   347,   721,  1178,  1202,
    1208,  1218,  1219,  1221,    32,   291,  1178,  1184,  1186,  1201,
    1178,  1191,   769,  1201,  1178,  1194,  1196,  1178,  1195,   769,
    1191,  1201,    32,   292,   292,   294,  1191,  1194,   714,   769,
     884,  1195,  1195,  1195,   568,  1194,  1195,    61,   924,  1191,
     294,  1196,  1196,  1194,  1194,  1195,  1197,    93,    93,   888,
    1836,   877,   974,    57,   149,   177,   274,  1510,   177,   177,
    1194,  1511,  1512,   770,  1559,  1559,    26,   235,  1500,  1439,
    1439,  1516,   167,   345,   770,   299,  1479,  1439,  1439,  1439,
    1559,    58,    70,    90,   124,   213,   280,   397,   399,   549,
     550,   707,  1184,  1185,  1450,  1451,  1452,  1453,  1509,  1439,
    1439,    86,   273,  1610,  1618,  1559,  1439,  1439,  1836,  1611,
     770,  1233,  1228,  1226,  1228,  1229,  1610,  1836,   770,  1516,
     185,  1580,    26,   770,  1515,  1435,   770,   772,  1439,  1067,
     196,  1084,  1085,  1611,  1069,  1929,  1929,  1830,  1836,   777,
    1668,  1668,  1871,  1876,  1597,  1690,  1566,    61,  1680,  1553,
    1434,  1681,  1403,  1817,   760,  1836,   770,   772,  1668,     6,
    1290,  1298,  1299,  1836,   770,   772,  1613,  1753,  1754,   436,
     146,   769,  1830,   808,   744,  1824,   818,   820,    36,   585,
    1133,  1134,  1135,  1136,  1144,  1145,   140,  1824,  1054,  1055,
     772,  1119,  1050,   875,   854,    14,   323,  1005,   180,    11,
     865,   866,   667,   865,  1967,  1528,   284,  1530,   284,  1558,
     114,   283,   447,  1546,  1547,  1550,    79,    82,   182,   264,
    1786,  1787,   143,  1788,  1594,  1576,  1575,  1594,  1434,  1623,
     584,  1830,  1933,   177,   177,   584,    61,   122,   551,  1279,
     112,  1264,  1823,  1115,    94,   112,  1114,   732,    33,    92,
     204,   278,  1148,  1241,  1115,  1242,  1243,  1243,  1114,  1645,
    1364,  1645,  1290,  1208,  1645,   130,  1646,    94,  1645,   732,
     204,  1645,  1645,  1669,    61,  1836,  1364,  1588,  1589,  1822,
      61,  1610,  1617,  1057,  1824,    61,  1610,    61,  1610,    61,
    1610,  1121,    61,  1836,  1613,  1610,  1610,  1364,  1830,  1830,
    1669,  1610,  1838,  1299,   442,   489,   560,  1129,  1610,  1613,
    1613,  1645,    61,  1610,  1830,  1364,  1364,  1364,    61,   377,
     379,   414,   443,   579,   615,  1128,  1617,  1610,  1617,  1290,
       5,    73,  1302,  1131,  1133,  1836,   323,   442,  1314,   216,
    1235,  1153,   777,    61,  1614,  1830,  1836,   596,  1439,  1439,
     180,   846,   852,   180,   374,   847,  1836,  1403,  1969,  1347,
     475,   266,   770,   772,   770,   772,   770,   772,    95,   428,
    1389,  1808,   576,  1939,   299,  1943,  1943,  1943,  1943,   877,
     954,  1683,   123,  1201,  1200,  1668,  1201,   280,   305,   658,
    1193,  1193,  1218,  1216,  1220,  1221,  1209,    17,  1219,  1222,
     379,  1203,  1201,  1178,  1193,  1265,  1801,  1201,  1265,  1193,
     294,  1193,  1201,   568,   881,   882,   883,  1836,   924,  1178,
     880,   922,  1178,  1193,  1439,   215,  1190,  1220,  1222,  1178,
    1201,  1193,  1193,   890,   898,   899,  1610,   769,   891,   416,
     770,   770,   770,   770,  1220,   772,  1220,  1220,   770,   770,
    1502,  1820,  1801,   141,  1503,  1504,  1505,   770,   772,   770,
     488,   538,   606,   770,   770,  1191,   124,  1195,    32,  1195,
    1454,   770,   770,   770,   770,   772,   770,   770,   770,  1224,
     770,   772,   770,    26,   208,   229,  1581,  1582,  1820,   770,
    1071,  1559,   130,   462,  1086,   770,   772,   770,   760,  1885,
    1885,  1590,   770,   777,  1667,  1681,   770,   772,  1556,   770,
     772,    10,  1755,  1678,  1838,   816,   769,   769,    93,  1146,
     770,   772,  1824,  1052,  1784,  1119,  1117,   118,   125,   190,
     870,   871,   872,   873,   855,   856,  1950,  1986,    63,   120,
     281,  1006,   646,  1969,   770,   867,   868,   869,  1836,  1830,
     770,    11,  1439,   769,  1439,   769,   770,  1242,  1242,  1547,
      26,    26,    79,    26,  1787,   253,   264,  1789,  1790,   769,
     435,   177,   319,  1445,  1364,   769,  1445,  1146,   769,   130,
     130,  1243,  1115,  1264,  1836,  1115,  1115,  1823,  1290,  1823,
    1287,  1210,  1823,  1645,  1298,    93,   130,  1823,  1823,  1830,
    1290,   772,  1594,  1061,   769,  1611,  1830,   299,  1152,  1290,
    1295,  1290,   770,  1836,  1824,   342,   344,   345,   360,   397,
     399,   420,   443,   454,   455,   486,   495,   541,   542,   543,
     549,   550,   566,   567,   590,   591,   609,   652,   701,   704,
     707,   730,   749,   922,  1154,  1175,  1176,  1836,  1559,   660,
    1830,   411,  1283,   299,  1971,  1350,  1836,     6,   769,  1348,
     877,   805,   807,   803,  1442,  1943,    99,  1940,  1945,  1946,
     130,   263,  1836,   305,   280,  1200,   770,   772,   770,   880,
    1174,   770,   772,   924,   777,   753,  1222,   187,   246,   248,
     896,   897,   898,   901,  1445,  1836,   867,    93,    93,   177,
     772,  1594,   770,  1506,  1599,  1439,   538,   434,  1220,  1613,
     770,  1610,  1593,   770,    15,   391,   399,   704,   707,   716,
    1583,  1584,  1805,  1594,   676,  1109,  1068,   769,  1074,  1087,
    1836,  1085,  1601,   760,  1299,  1754,   408,   770,   575,   769,
    1262,  1263,  1836,  1262,  1836,  1134,   770,    11,  1110,  1054,
     770,   772,   869,    67,   926,   180,   840,   633,  1980,   772,
     641,   714,  1174,  1980,  1969,  1558,  1558,    93,  1545,  1545,
    1801,  1801,    26,  1801,    26,    26,  1790,   265,  1279,   400,
    1278,    84,  1292,  1836,    84,  1439,  1115,  1264,  1836,   284,
    1254,   714,  1264,  1264,    73,   237,  1152,  1358,  1215,  1823,
    1836,  1313,  1286,  1589,  1748,   263,  1314,  1296,  1298,  1288,
     769,  1236,  1156,   777,  1147,  1148,  1155,   777,   841,   848,
     849,    33,   349,   497,   770,   772,  1349,   270,   576,  1946,
     281,  1824,  1220,  1801,  1220,   924,   882,  1836,   177,   772,
     926,   449,   770,   893,   997,   770,  1820,   569,   772,   770,
     770,   770,   716,  1584,  1585,  1805,   641,   594,   429,  1586,
     594,  1610,   769,  1081,  1077,    61,   289,   290,   391,   465,
    1088,   354,   769,  1262,   770,   772,  1594,   769,   770,   769,
    1053,  1052,   872,    91,   833,  1433,   845,   846,  1981,   854,
    1982,   869,   714,   884,   568,  1982,   770,   770,   100,   128,
     185,  1549,  1548,  1801,  1801,  1801,   770,  1823,   582,   769,
    1293,   772,   770,  1264,  1254,   714,  1261,  1137,  1261,  1139,
    1140,    61,    61,  1314,  1364,   770,  1824,  1297,  1336,  1237,
    1836,   154,  1238,   204,   278,   302,   374,   485,   742,  1157,
    1158,  1167,  1205,  1206,  1207,  1234,  1445,  1829,  1176,    34,
      61,   176,   180,   334,   453,   652,  1161,  1163,  1198,  1199,
    1206,  1836,   676,   843,   926,   576,    33,    33,  1836,   204,
    1351,  1352,  1836,  1442,  1684,  1534,   777,   897,   991,  1594,
    1599,  1599,   446,    10,   446,   100,   391,   560,   703,  1079,
    1080,  1836,   770,   687,  1082,  1090,   702,   115,   374,   381,
     396,   524,   537,   557,   696,  1104,  1105,  1106,  1723,   836,
     770,  1888,  1263,   177,  1888,  1836,  1122,  1123,  1976,   842,
    1174,  1983,   568,  1836,    26,    26,   769,   769,  1148,  1611,
    1084,  1836,  1143,  1141,  1261,   769,  1138,   769,   769,   758,
     759,   769,  1171,  1172,  1173,  1414,  1462,  1804,  1829,  1058,
     123,   770,   772,   450,   581,   659,   180,  1239,   130,  1830,
     693,  1206,   732,   130,   176,  1668,  1214,  1173,   281,   327,
      61,    11,   379,  1199,  1204,  1439,   417,   844,   833,   576,
     576,   770,   772,  1691,  1692,  1822,  1779,  1836,  1585,   641,
     187,   312,   770,   772,  1611,   769,  1092,  1094,  1089,   407,
    1669,  1669,   407,  1669,  1669,  1669,  1669,   769,  1099,  1106,
     419,   770,  1888,   299,   374,   487,  1249,  1253,  1257,  1260,
    1829,  1594,   770,  1250,  1252,  1257,  1259,   772,  1824,   847,
     925,  1836,   777,  1555,  1557,   770,   770,   769,   769,  1142,
    1262,   769,  1262,  1262,  1806,  1806,  1170,   769,  1836,    63,
     281,    61,  1614,  1830,  1836,   173,   728,   641,  1171,  1200,
    1198,  1439,  1352,   772,  1668,  1211,  1078,  1080,   769,  1093,
    1094,  1095,   156,  1091,  1094,  1669,  1830,  1830,  1669,  1614,
    1614,  1611,  1838,   688,  1100,  1101,  1669,   284,   714,  1248,
    1251,  1256,  1257,  1258,   580,  1830,  1669,  1303,  1304,  1305,
    1260,  1668,  1303,  1259,  1836,    93,   411,   833,   777,  1836,
     770,   770,  1262,  1262,   769,   770,  1262,   770,   770,   770,
    1084,    28,   223,   237,   560,  1240,  1240,   769,  1436,   416,
     677,  1162,  1692,  1681,  1780,  1082,   770,   772,   156,  1097,
    1098,  1442,  1830,  1830,  1102,   770,   772,  1126,  1261,  1261,
    1303,  1258,  1829,  1610,  1305,  1304,    61,  1614,  1830,  1836,
     770,  1433,   848,  1836,   777,   770,   770,  1262,  1248,   770,
    1249,  1250,   770,    61,   176,   320,   180,   180,   770,  1611,
    1159,  1160,  1205,  1159,   586,   682,   735,  1164,   229,  1791,
    1094,   772,  1096,  1103,  1838,  1101,  1977,  1836,  1235,  1248,
     770,  1248,   281,    63,   770,  1205,  1165,  1166,  1167,   470,
    1785,  1098,   770,  1104,    75,  1248,  1240,  1240,  1167,    26,
    1788,   641,  1801,   114,  1792,  1978,   177,   769,  1794,   445,
     593,  1972,  1973,   143,   229,  1793,   770,   778,  1795,  1796,
    1822,   237,  1797,  1838,  1979,  1838,   770,   772,  1798,  1799,
    1822,   926,  1796,   772,  1668,   833,  1799,  1433,  1681,  1434
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   780,   781,   782,   781,   781,   783,   783,   784,   784,
     784,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     786,   787,   787,   789,   788,   790,   791,   792,   790,   793,
     794,   793,   795,   795,   797,   796,   799,   798,   800,   800,
     801,   801,   801,   801,   801,   801,   801,   801,   801,   801,
     801,   801,   801,   801,   801,   801,   801,   801,   801,   801,
     802,   802,   802,   803,   804,   804,   804,   805,   806,   806,
     806,   807,   808,   808,   808,   808,   808,   808,   808,   809,
     809,   810,   812,   813,   811,   814,   811,   815,   816,   811,
     817,   818,   811,   819,   820,   811,   821,   811,   822,   811,
     823,   811,   824,   811,   825,   811,   826,   811,   827,   811,
     828,   811,   811,   811,   811,   811,   811,   829,   811,   830,
     830,   831,   831,   832,   832,   832,   832,   832,   832,   832,
     832,   832,   832,   832,   832,   832,   832,   833,   833,   835,
     834,   836,   836,   837,   837,   837,   837,   837,   837,   837,
     839,   838,   841,   840,   840,   842,   842,   842,   842,   843,
     843,   844,   844,   845,   845,   846,   847,   847,   849,   848,
     850,   851,   851,   852,   852,   853,   853,   854,   854,   855,
     855,   855,   855,   855,   855,   855,   856,   856,   857,   857,
     859,   858,   860,   858,   861,   858,   862,   862,   863,   863,
     864,   864,   865,   866,   865,   867,   867,   868,   869,   869,
     869,   869,   869,   869,   870,   870,   871,   871,   872,   873,
     873,   873,   873,   875,   874,   876,   876,   877,   877,   878,
     878,   879,   880,   880,   880,   881,   882,   883,   883,   884,
     885,   886,   886,   886,   886,   887,   887,   887,   888,   887,
     890,   889,   891,   891,   892,   894,   893,   895,   895,   895,
     895,   896,   896,   897,   898,   898,   899,   900,   900,   901,
     901,   901,   901,   901,   901,   902,   902,   903,   904,   904,
     905,   905,   906,   906,   907,   907,   908,   908,   908,   909,
     909,   909,   909,   909,   909,   909,   909,   909,   909,   909,
     909,   910,   911,   912,   912,   913,   913,   914,   914,   915,
     916,   916,   917,   917,   917,   918,   919,   919,   920,   921,
     921,   921,   921,   921,   921,   921,   921,   921,   921,   921,
     921,   921,   922,   922,   923,   923,   924,   924,   925,   925,
     925,   925,   925,   926,   926,   926,   926,   926,   926,   926,
     926,   926,   926,   927,   927,   927,   927,   929,   928,   931,
     930,   932,   932,   934,   933,   933,   936,   935,   937,   937,
     937,   937,   938,   938,   938,   938,   939,   940,   941,   942,
     944,   943,   946,   945,   947,   947,   948,   948,   949,   950,
     950,   950,   951,   951,   952,   953,   953,   955,   956,   957,
     954,   958,   958,   958,   960,   959,   962,   963,   961,   961,
     964,   964,   965,   965,   967,   968,   966,   970,   971,   969,
     972,   972,   973,   974,   974,   975,   977,   976,   979,   978,
     981,   980,   982,   982,   984,   983,   985,   985,   985,   986,
     988,   987,   990,   989,   991,   993,   992,   994,   992,   995,
     996,   997,   992,   998,   992,  1000,   999,  1001,   999,  1002,
    1003,   999,  1004,   999,  1005,  1005,  1006,  1006,  1006,  1007,
    1008,  1009,  1010,  1010,  1011,  1011,  1012,  1013,  1014,  1014,
    1016,  1015,  1017,  1017,  1017,  1018,  1018,  1018,  1019,  1020,
    1020,  1020,  1021,  1021,  1021,  1021,  1021,  1021,  1021,  1021,
    1022,  1023,  1023,  1023,  1024,  1024,  1024,  1024,  1024,  1025,
    1026,  1026,  1026,  1027,  1027,  1027,  1027,  1027,  1027,  1027,
    1028,  1029,  1029,  1029,  1030,  1030,  1030,  1031,  1032,  1033,
    1034,  1035,  1036,  1036,  1036,  1037,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,  1045,  1046,  1046,  1047,  1047,  1048,  1048,
    1050,  1049,  1049,  1049,  1051,  1051,  1052,  1052,  1053,  1053,
    1054,  1055,  1055,  1057,  1056,  1058,  1060,  1059,  1062,  1061,
    1063,  1064,  1063,  1063,  1063,  1065,  1063,  1063,  1066,  1063,
    1067,  1067,  1068,  1068,  1069,  1069,  1070,  1070,  1071,  1072,
    1073,  1074,  1075,  1075,  1076,  1077,  1076,  1078,  1076,  1079,
    1079,  1080,  1081,  1082,  1082,  1083,  1083,  1084,  1084,  1086,
    1085,  1087,  1088,  1089,  1088,  1090,  1088,  1088,  1088,  1088,
    1091,  1091,  1092,  1092,  1093,  1093,  1095,  1096,  1094,  1097,
    1097,  1098,  1098,  1099,  1099,  1100,  1100,  1102,  1101,  1103,
    1104,  1104,  1105,  1105,  1106,  1106,  1106,  1106,  1106,  1106,
    1106,  1106,  1106,  1107,  1108,  1107,  1107,  1109,  1109,  1110,
    1110,  1111,  1111,  1112,  1112,  1113,  1113,  1114,  1114,  1115,
    1115,  1116,  1116,  1117,  1117,  1118,  1118,  1119,  1119,  1119,
    1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,
    1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,
    1121,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,
    1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1122,
    1122,  1123,  1124,  1125,  1126,  1127,  1128,  1128,  1128,  1128,
    1128,  1128,  1128,  1129,  1129,  1129,  1130,  1130,  1130,  1130,
    1131,  1132,  1133,  1133,  1134,  1134,  1134,  1134,  1134,  1135,
    1135,  1137,  1136,  1138,  1136,  1139,  1136,  1140,  1136,  1141,
    1136,  1142,  1136,  1143,  1136,  1144,  1145,  1146,  1147,  1147,
    1148,  1149,  1149,  1150,  1150,  1151,  1153,  1152,  1155,  1154,
    1156,  1154,  1157,  1157,  1158,  1158,  1159,  1159,  1160,  1160,
    1161,  1161,  1161,  1161,  1162,  1161,  1161,  1161,  1163,  1163,
    1164,  1164,  1164,  1164,  1165,  1165,  1166,  1166,  1167,  1167,
    1167,  1167,  1169,  1168,  1170,  1170,  1171,  1171,  1172,  1172,
    1173,  1173,  1174,  1175,  1175,  1176,  1176,  1176,  1176,  1176,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1178,  1178,  1178,  1178,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1180,  1180,  1180,  1180,  1180,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1182,  1182,  1183,  1183,  1183,  1183,  1183,
    1183,  1183,  1183,  1184,  1185,  1185,  1186,  1186,  1187,  1187,
    1187,  1187,  1187,  1188,  1188,  1188,  1188,  1188,  1189,  1189,
    1189,  1190,  1190,  1191,  1191,  1191,  1192,  1193,  1193,  1193,
    1193,  1193,  1193,  1194,  1194,  1194,  1194,  1195,  1195,  1196,
    1196,  1197,  1197,  1198,  1198,  1199,  1199,  1199,  1199,  1199,
    1199,  1199,  1200,  1200,  1201,  1201,  1202,  1203,  1204,  1205,
    1205,  1205,  1206,  1206,  1206,  1206,  1206,  1206,  1207,  1207,
    1208,  1208,  1209,  1209,  1210,  1210,  1211,  1211,  1212,  1212,
    1213,  1213,  1214,  1215,  1215,  1216,  1216,  1217,  1217,  1218,
    1218,  1218,  1219,  1220,  1220,  1221,  1221,  1221,  1221,  1221,
    1221,  1222,  1222,  1224,  1223,  1225,  1225,  1226,  1227,  1227,
    1227,  1227,  1228,  1229,  1230,  1230,  1231,  1232,  1232,  1233,
    1233,  1234,  1234,  1235,  1236,  1236,  1237,  1237,  1238,  1238,
    1238,  1238,  1239,  1239,  1239,  1239,  1239,  1240,  1240,  1240,
    1240,  1240,  1241,  1241,  1242,  1242,  1243,  1243,  1244,  1244,
    1244,  1245,  1245,  1246,  1247,  1248,  1248,  1249,  1249,  1250,
    1250,  1251,  1251,  1252,  1252,  1253,  1253,  1254,  1254,  1255,
    1255,  1255,  1256,  1256,  1257,  1257,  1257,  1257,  1257,  1257,
    1258,  1258,  1259,  1260,  1260,  1261,  1261,  1261,  1262,  1262,
    1263,  1263,  1264,  1264,  1265,  1265,  1267,  1268,  1266,  1269,
    1266,  1266,  1270,  1266,  1271,  1266,  1272,  1266,  1273,  1266,
    1274,  1266,  1266,  1266,  1266,  1266,  1275,  1266,  1266,  1276,
    1277,  1266,  1278,  1278,  1279,  1279,  1279,  1279,  1280,  1280,
    1280,  1280,  1280,  1281,  1281,  1281,  1281,  1282,  1282,  1283,
    1283,  1284,  1284,  1285,  1285,  1285,  1285,  1285,  1285,  1285,
    1285,  1285,  1285,  1286,  1285,  1285,  1287,  1285,  1288,  1285,
    1285,  1285,  1285,  1285,  1289,  1290,  1290,  1292,  1291,  1293,
    1293,  1293,  1295,  1294,  1296,  1297,  1296,  1298,  1298,  1299,
    1300,  1300,  1301,  1302,  1302,  1302,  1302,  1302,  1302,  1302,
    1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,
    1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,  1302,
    1302,  1302,  1303,  1303,  1303,  1303,  1303,  1304,  1304,  1305,
    1305,  1306,  1306,  1307,  1307,  1309,  1308,  1310,  1310,  1311,
    1311,  1312,  1312,  1313,  1313,  1313,  1314,  1314,  1314,  1315,
    1315,  1315,  1315,  1317,  1316,  1318,  1316,  1316,  1316,  1319,
    1320,  1320,  1321,  1321,  1322,  1322,  1322,  1324,  1323,  1325,
    1325,  1326,  1326,  1326,  1327,  1327,  1327,  1328,  1328,  1330,
    1329,  1331,  1331,  1331,  1332,  1333,  1332,  1335,  1334,  1336,
    1336,  1337,  1337,  1338,  1338,  1338,  1339,  1339,  1341,  1340,
    1342,  1342,  1343,  1344,  1344,  1345,  1345,  1346,  1347,  1346,
    1348,  1349,  1348,  1350,  1350,  1350,  1351,  1351,  1351,  1352,
    1352,  1353,  1353,  1354,  1355,  1354,  1357,  1356,  1358,  1358,
    1359,  1359,  1360,  1360,  1360,  1360,  1360,  1360,  1361,  1361,
    1363,  1362,  1364,  1364,  1364,  1366,  1365,  1365,  1367,  1367,
    1368,  1368,  1369,  1371,  1370,  1372,  1372,  1373,  1373,  1374,
    1375,  1376,  1376,  1378,  1377,  1379,  1379,  1380,  1380,  1381,
    1382,  1384,  1383,  1386,  1385,  1387,  1387,  1388,  1388,  1390,
    1389,  1391,  1389,  1393,  1392,  1394,  1392,  1395,  1395,  1397,
    1396,  1399,  1400,  1398,  1401,  1402,  1403,  1403,  1404,  1404,
    1406,  1405,  1407,  1405,  1408,  1408,  1409,  1410,  1409,  1409,
    1411,  1411,  1412,  1413,  1414,  1414,  1415,  1415,  1416,  1417,
    1417,  1418,  1418,  1419,  1419,  1419,  1420,  1420,  1420,  1421,
    1422,  1422,  1423,  1423,  1424,  1424,  1424,  1424,  1425,  1425,
    1426,  1426,  1426,  1427,  1427,  1428,  1428,  1429,  1429,  1429,
    1430,  1430,  1430,  1431,  1431,  1432,  1433,  1434,  1435,  1435,
    1435,  1435,  1435,  1436,  1436,  1436,  1437,  1437,  1437,  1438,
    1438,  1439,  1439,  1439,  1439,  1439,  1440,  1440,  1440,  1440,
    1440,  1440,  1440,  1440,  1440,  1440,  1440,  1440,  1441,  1441,
    1441,  1441,  1441,  1441,  1441,  1441,  1441,  1441,  1441,  1441,
    1441,  1441,  1441,  1441,  1442,  1442,  1442,  1442,  1442,  1442,
    1442,  1442,  1442,  1442,  1442,  1442,  1442,  1442,  1442,  1442,
    1442,  1442,  1442,  1443,  1443,  1444,  1444,  1445,  1445,  1446,
    1446,  1447,  1447,  1447,  1447,  1447,  1447,  1448,  1448,  1449,
    1449,  1450,  1450,  1450,  1451,  1451,  1451,  1451,  1451,  1451,
    1452,  1452,  1452,  1454,  1453,  1453,  1455,  1456,  1456,  1457,
    1457,  1457,  1457,  1458,  1459,  1459,  1460,  1461,  1461,  1461,
    1461,  1461,  1461,  1461,  1462,  1462,  1462,  1462,  1462,  1462,
    1462,  1462,  1462,  1462,  1462,  1462,  1462,  1462,  1462,  1462,
    1462,  1462,  1462,  1462,  1462,  1462,  1462,  1462,  1462,  1462,
    1462,  1462,  1462,  1463,  1463,  1463,  1463,  1464,  1464,  1465,
    1465,  1465,  1465,  1465,  1465,  1466,  1466,  1467,  1467,  1468,
    1468,  1468,  1468,  1468,  1468,  1468,  1468,  1468,  1468,  1468,
    1468,  1468,  1468,  1468,  1468,  1468,  1468,  1468,  1468,  1468,
    1469,  1469,  1470,  1470,  1471,  1471,  1472,  1472,  1472,  1472,
    1472,  1472,  1472,  1472,  1472,  1472,  1472,  1472,  1472,  1472,
    1472,  1472,  1472,  1472,  1472,  1472,  1472,  1472,  1472,  1472,
    1472,  1472,  1472,  1473,  1473,  1473,  1473,  1473,  1473,  1473,
    1473,  1473,  1473,  1473,  1473,  1473,  1473,  1473,  1473,  1473,
    1473,  1473,  1473,  1473,  1473,  1473,  1473,  1473,  1473,  1473,
    1474,  1474,  1474,  1474,  1474,  1474,  1474,  1474,  1474,  1476,
    1475,  1475,  1475,  1475,  1475,  1475,  1475,  1475,  1477,  1477,
    1478,  1478,  1479,  1479,  1480,  1480,  1481,  1481,  1482,  1483,
    1483,  1483,  1483,  1483,  1483,  1483,  1484,  1485,  1483,  1483,
    1483,  1483,  1483,  1483,  1483,  1483,  1483,  1483,  1483,  1486,
    1483,  1487,  1487,  1488,  1488,  1488,  1489,  1489,  1489,  1489,
    1489,  1489,  1489,  1489,  1489,  1489,  1489,  1489,  1489,  1490,
    1492,  1491,  1491,  1493,  1493,  1494,  1495,  1497,  1496,  1498,
    1498,  1498,  1498,  1499,  1499,  1500,  1500,  1501,  1501,  1502,
    1502,  1503,  1503,  1504,  1505,  1506,  1506,  1506,  1508,  1507,
    1509,  1510,  1509,  1511,  1509,  1512,  1509,  1509,  1509,  1509,
    1513,  1513,  1513,  1513,  1513,  1513,  1513,  1513,  1514,  1514,
    1514,  1514,  1515,  1515,  1516,  1516,  1517,  1517,  1518,  1518,
    1519,  1519,  1520,  1520,  1521,  1521,  1522,  1523,  1523,  1524,
    1524,  1525,  1526,  1525,  1527,  1525,  1525,  1528,  1525,  1529,
    1525,  1525,  1530,  1525,  1531,  1525,  1525,  1532,  1532,  1532,
    1533,  1533,  1534,  1534,  1535,  1536,  1536,  1536,  1536,  1537,
    1537,  1538,  1538,  1539,  1539,  1540,  1540,  1541,  1541,  1542,
    1543,  1544,  1544,  1545,  1545,  1545,  1545,  1546,  1546,  1548,
    1547,  1549,  1547,  1550,  1550,  1551,  1552,  1551,  1554,  1553,
    1555,  1555,  1556,  1556,  1557,  1557,  1558,  1558,  1559,  1559,
    1559,  1559,  1559,  1559,  1559,  1559,  1559,  1559,  1559,  1559,
    1560,  1560,  1560,  1560,  1560,  1560,  1560,  1560,  1560,  1561,
    1561,  1561,  1561,  1562,  1562,  1562,  1563,  1563,  1564,  1565,
    1565,  1566,  1567,  1566,  1568,  1569,  1568,  1570,  1570,  1571,
    1571,  1572,  1572,  1572,  1573,  1573,  1574,  1574,  1575,  1577,
    1576,  1578,  1578,  1579,  1579,  1580,  1580,  1581,  1581,  1582,
    1582,  1583,  1583,  1584,  1584,  1584,  1585,  1585,  1585,  1586,
    1586,  1586,  1586,  1586,  1586,  1587,  1588,  1588,  1589,  1590,
    1590,  1592,  1591,  1593,  1593,  1594,  1594,  1594,  1595,  1595,
    1596,  1596,  1596,  1597,  1598,  1598,  1598,  1599,  1599,  1599,
    1599,  1599,  1599,  1600,  1601,  1601,  1601,  1601,  1602,  1602,
    1602,  1603,  1603,  1604,  1605,  1606,  1606,  1606,  1607,  1607,
    1608,  1608,  1609,  1609,  1610,  1610,  1610,  1610,  1610,  1610,
    1611,  1611,  1611,  1611,  1611,  1612,  1612,  1612,  1612,  1613,
    1613,  1613,  1613,  1613,  1614,  1614,  1614,  1614,  1614,  1615,
    1616,  1616,  1617,  1617,  1618,  1618,  1618,  1620,  1619,  1621,
    1621,  1622,  1622,  1623,  1625,  1624,  1626,  1626,  1627,  1628,
    1628,  1628,  1629,  1631,  1632,  1630,  1630,  1630,  1634,  1633,
    1636,  1635,  1637,  1635,  1635,  1635,  1635,  1635,  1635,  1635,
    1638,  1635,  1635,  1635,  1635,  1635,  1635,  1639,  1635,  1640,
    1640,  1641,  1642,  1643,  1643,  1644,  1645,  1645,  1646,  1646,
    1647,  1647,  1649,  1650,  1648,  1652,  1653,  1651,  1654,  1654,
    1654,  1654,  1655,  1655,  1656,  1656,  1658,  1657,  1659,  1659,
    1660,  1659,  1661,  1662,  1662,  1663,  1663,  1664,  1665,  1665,
    1666,  1666,  1667,  1668,  1668,  1669,  1669,  1670,  1670,  1671,
    1671,  1673,  1672,  1675,  1674,  1676,  1676,  1677,  1677,  1678,
    1678,  1679,  1679,  1680,  1680,  1681,  1681,  1682,  1683,  1684,
    1682,  1685,  1685,  1687,  1688,  1686,  1689,  1689,  1690,  1690,
    1691,  1691,  1692,  1693,  1693,  1695,  1694,  1696,  1696,  1697,
    1697,  1698,  1699,  1700,  1701,  1700,  1702,  1700,  1703,  1703,
    1704,  1704,  1705,  1705,  1706,  1706,  1707,  1707,  1708,  1708,
    1708,  1710,  1709,  1711,  1711,  1712,  1712,  1713,  1713,  1714,
    1714,  1714,  1714,  1714,  1714,  1714,  1714,  1714,  1715,  1715,
    1717,  1716,  1718,  1718,  1718,  1718,  1718,  1718,  1718,  1718,
    1718,  1718,  1718,  1718,  1718,  1718,  1719,  1718,  1720,  1718,
    1718,  1718,  1718,  1718,  1718,  1718,  1718,  1718,  1718,  1718,
    1718,  1718,  1718,  1718,  1718,  1718,  1718,  1718,  1718,  1718,
    1718,  1718,  1718,  1718,  1718,  1718,  1718,  1718,  1718,  1718,
    1718,  1718,  1718,  1718,  1718,  1718,  1718,  1718,  1718,  1718,
    1718,  1718,  1718,  1721,  1721,  1721,  1722,  1722,  1723,  1723,
    1724,  1724,  1725,  1725,  1726,  1726,  1727,  1727,  1728,  1728,
    1729,  1729,  1729,  1731,  1730,  1732,  1730,  1733,  1733,  1733,
    1733,  1733,  1733,  1734,  1734,  1735,  1736,  1736,  1736,  1736,
    1737,  1737,  1738,  1738,  1738,  1740,  1739,  1742,  1741,  1741,
    1743,  1743,  1744,  1745,  1744,  1746,  1746,  1747,  1747,  1747,
    1747,  1747,  1747,  1747,  1747,  1747,  1747,  1747,  1747,  1747,
    1747,  1747,  1747,  1747,  1748,  1748,  1749,  1750,  1751,  1750,
    1750,  1752,  1752,  1753,  1753,  1753,  1754,  1755,  1755,  1757,
    1756,  1758,  1758,  1760,  1759,  1761,  1759,  1759,  1762,  1762,
    1763,  1763,  1764,  1765,  1764,  1767,  1766,  1768,  1768,  1768,
    1769,  1769,  1769,  1770,  1770,  1771,  1771,  1773,  1772,  1774,
    1774,  1775,  1777,  1778,  1779,  1780,  1776,  1781,  1781,  1782,
    1782,  1783,  1783,  1783,  1784,  1784,  1784,  1785,  1785,  1786,
    1786,  1787,  1787,  1787,  1787,  1788,  1788,  1789,  1789,  1790,
    1790,  1791,  1791,  1792,  1792,  1793,  1793,  1794,  1794,  1794,
    1795,  1795,  1796,  1796,  1797,  1797,  1798,  1798,  1799,  1800,
    1800,  1800,  1800,  1801,  1801,  1802,  1802,  1802,  1803,  1803,
    1803,  1804,  1804,  1805,  1805,  1805,  1805,  1805,  1805,  1805,
    1805,  1805,  1805,  1806,  1806,  1806,  1806,  1806,  1807,  1807,
    1807,  1809,  1808,  1810,  1810,  1811,  1811,  1813,  1812,  1814,
    1814,  1815,  1815,  1816,  1817,  1817,  1818,  1818,  1819,  1819,
    1820,  1821,  1821,  1821,  1821,  1821,  1822,  1822,  1822,  1822,
    1822,  1823,  1823,  1823,  1823,  1824,  1824,  1824,  1825,  1825,
    1826,  1827,  1827,  1828,  1828,  1828,  1829,  1830,  1831,  1832,
    1833,  1833,  1834,  1834,  1835,  1835,  1835,  1836,  1836,  1837,
    1837,  1838,  1838,  1838,  1839,  1839,  1839,  1840,  1840,  1841,
    1842,  1842,  1842,  1842,  1842,  1842,  1842,  1842,  1843,  1843,
    1843,  1843,  1843,  1843,  1843,  1843,  1843,  1844,  1844,  1844,
    1844,  1845,  1845,  1845,  1845,  1845,  1845,  1845,  1845,  1846,
    1846,  1846,  1846,  1846,  1846,  1846,  1846,  1846,  1847,  1847,
    1847,  1847,  1847,  1847,  1847,  1847,  1848,  1848,  1848,  1848,
    1848,  1848,  1848,  1848,  1848,  1848,  1848,  1848,  1848,  1848,
    1848,  1848,  1848,  1848,  1848,  1848,  1848,  1848,  1848,  1848,
    1848,  1848,  1848,  1848,  1848,  1848,  1848,  1848,  1848,  1848,
    1848,  1848,  1848,  1848,  1848,  1848,  1848,  1848,  1848,  1848,
    1848,  1848,  1848,  1848,  1848,  1848,  1848,  1848,  1848,  1848,
    1848,  1849,  1849,  1849,  1849,  1849,  1849,  1850,  1850,  1850,
    1850,  1850,  1850,  1850,  1850,  1850,  1850,  1851,  1851,  1851,
    1852,  1852,  1852,  1853,  1853,  1853,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,  1855,
    1855,  1855,  1855,  1855,  1855,  1857,  1856,  1858,  1859,  1856,
    1860,  1860,  1862,  1861,  1863,  1861,  1864,  1861,  1866,  1865,
    1865,  1867,  1867,  1869,  1868,  1870,  1868,  1872,  1871,  1871,
    1873,  1873,  1873,  1874,  1874,  1874,  1874,  1875,  1875,  1875,
    1875,  1876,  1876,  1876,  1877,  1877,  1877,  1877,  1877,  1877,
    1877,  1877,  1877,  1877,  1877,  1877,  1877,  1877,  1877,  1878,
    1878,  1878,  1878,  1879,  1880,  1881,  1881,  1882,  1882,  1882,
    1882,  1883,  1883,  1884,  1884,  1884,  1885,  1885,  1885,  1885,
    1885,  1887,  1886,  1888,  1888,  1888,  1889,  1889,  1890,  1890,
    1891,  1892,  1892,  1892,  1892,  1892,  1894,  1893,  1896,  1895,
    1897,  1897,  1898,  1897,  1899,  1899,  1900,  1900,  1901,  1901,
    1901,  1901,  1902,  1901,  1903,  1903,  1903,  1903,  1903,  1904,
    1905,  1905,  1905,  1905,  1905,  1905,  1905,  1905,  1906,  1906,
    1907,  1908,  1908,  1908,  1908,  1908,  1908,  1908,  1909,  1909,
    1910,  1910,  1911,  1911,  1912,  1913,  1913,  1914,  1914,  1915,
    1915,  1916,  1916,  1917,  1917,  1919,  1918,  1920,  1918,  1921,
    1918,  1922,  1918,  1918,  1918,  1918,  1918,  1918,  1918,  1918,
    1918,  1918,  1918,  1918,  1918,  1918,  1918,  1918,  1918,  1918,
    1918,  1918,  1918,  1918,  1918,  1918,  1918,  1918,  1918,  1918,
    1923,  1923,  1924,  1924,  1925,  1925,  1925,  1926,  1926,  1926,
    1926,  1927,  1927,  1928,  1928,  1929,  1929,  1930,  1930,  1931,
    1931,  1932,  1932,  1932,  1932,  1933,  1933,  1934,  1935,  1935,
    1935,  1936,  1936,  1937,  1937,  1938,  1939,  1939,  1939,  1939,
    1939,  1940,  1940,  1940,  1940,  1940,  1941,  1941,  1942,  1942,
    1943,  1943,  1944,  1944,  1945,  1945,  1946,  1946,  1948,  1947,
    1949,  1950,  1950,  1951,  1951,  1952,  1952,  1952,  1953,  1953,
    1953,  1954,  1955,  1955,  1955,  1956,  1957,  1958,  1958,  1958,
    1959,  1959,  1959,  1960,  1960,  1960,  1960,  1960,  1960,  1960,
    1960,  1961,  1961,  1962,  1963,  1964,  1964,  1964,  1965,  1965,
    1966,  1966,  1967,  1967,  1968,  1968,  1970,  1969,  1971,  1971,
    1971,  1971,  1972,  1972,  1973,  1973,  1975,  1976,  1977,  1978,
    1979,  1974,  1981,  1980,  1983,  1982,  1985,  1986,  1984,  1987,
    1987,  1987,  1987,  1987,  1987,  1988,  1988,  1989,  1989,  1989,
    1990,  1990,  1990,  1991,  1991,  1991,  1992,  1992,  1993,  1994,
    1993,  1995,  1995,  1996,  1996,  1997,  1997,  1998
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     4,     2,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     1,     0,     5,     3,     0,     0,     6,     0,
       0,     3,     1,     3,     0,     3,     0,     6,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     5,     5,     5,     1,
       0,     1,     3,     1,     0,     1,     3,     1,     0,     1,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     0,
       1,     1,     0,     0,     8,     0,     8,     0,     0,    16,
       0,     0,    15,     0,     0,    15,     0,     6,     0,    10,
       0,    11,     0,     5,     0,     6,     0,     5,     0,    12,
       0,    12,    10,     8,     6,     4,     3,     0,     3,     0,
       1,     1,     2,     3,     2,     1,     3,     2,     1,     3,
       3,     3,     1,     1,     1,     1,     3,     0,     1,     0,
      12,     1,     3,     2,     2,     2,     2,     2,     2,     2,
       0,    12,     0,     6,     2,     0,     1,     3,     1,     0,
       2,     0,     2,     0,     1,     4,     0,     2,     0,     3,
       0,     0,     1,     3,     1,     0,     2,     0,     2,     2,
       2,     2,     2,     3,     3,     1,     1,     2,     3,     3,
       0,     4,     0,     6,     0,     8,     0,     3,     0,     1,
       3,     1,     0,     0,     2,     3,     1,     1,     2,     6,
       8,     5,     7,     3,     0,     1,     3,     1,     2,     0,
       1,     1,     1,     0,     4,     0,     3,     2,     3,     0,
       3,     2,     1,     3,     5,     1,     2,     1,     3,     3,
       1,     3,     5,     6,     4,     1,     4,     1,     0,     6,
       0,     6,     0,     3,     0,     0,     3,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     3,     0,     1,     1,
       1,     1,     2,     1,     1,     2,     3,     3,     1,     1,
       0,     1,     0,     2,     3,     5,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     4,     0,     1,     1,     3,     1,     3,     3,
       1,     2,     1,     1,     1,     1,     1,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     0,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     5,     0,
       2,     1,     1,     0,     3,     1,     0,     2,     1,     2,
       3,     4,     1,     2,     3,     4,     2,     2,     2,     0,
       0,     3,     0,     3,     1,     3,     0,     3,     3,     3,
       4,     5,     2,     4,     2,     1,     3,     0,     0,     0,
       7,     0,     2,     2,     0,     6,     0,     0,     4,     1,
       1,     2,     1,     2,     0,     0,     6,     0,     0,     6,
       0,     2,     2,     0,     1,     1,     0,     7,     0,     5,
       0,     7,     0,     1,     0,     3,     5,     3,     5,     3,
       0,     6,     0,     6,     1,     0,     5,     0,     5,     0,
       0,     0,    11,     0,     5,     0,     3,     0,     3,     0,
       0,     8,     0,     3,     1,     1,     1,     1,     1,     2,
       4,     5,     0,     4,     4,     4,     3,     3,     2,     2,
       0,     2,     1,     2,     3,     1,     1,     1,     1,     1,
       2,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     1,     1,     1,     1,     1,     1,
       1,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     1,     1,     1,     2,     2,     2,
       1,     1,     1,     1,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     4,     0,     1,     1,     1,     1,     1,
       0,     5,     3,     1,     2,     4,     0,     4,     1,     4,
       1,     0,     1,     0,     4,     0,     0,     3,     0,     6,
       6,     0,     4,     2,     2,     0,     3,     2,     0,     3,
       0,     1,     0,     3,     0,     1,     1,     3,     1,     4,
       3,     3,     0,     2,     0,     0,     7,     0,    10,     1,
       3,     1,     1,     0,     2,     0,     3,     1,     3,     0,
       6,     1,     0,     0,     4,     0,     3,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     0,     0,     5,     1,
       3,     1,     1,     0,     3,     1,     3,     0,     4,     1,
       0,     1,     2,     1,     3,     4,     3,     3,     3,     3,
       4,     4,     3,     0,     0,     5,     2,     0,     2,     0,
       1,     0,     1,     1,     2,     1,     1,     0,     3,     0,
       3,     1,     3,     0,     1,     1,     2,     1,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       0,     6,     1,     1,     3,     4,     4,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     0,
       1,     2,     4,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     3,     1,     1,     1,     1,     2,     1,
       2,     0,     9,     0,    10,     0,     9,     0,     9,     0,
      10,     0,    11,     0,    10,     2,     7,     7,     0,     1,
       4,     0,     1,     0,     1,     2,     0,     4,     0,     3,
       0,     3,     0,     1,     2,     1,     0,     1,     2,     1,
       0,     1,     2,     3,     0,     6,     5,     5,     0,     2,
       0,     1,     1,     1,     0,     1,     2,     1,     1,     2,
       2,     1,     0,     3,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     1,     1,     1,     1,
       3,     3,     3,     2,     1,     1,     3,     3,     3,     3,
       0,     1,     2,     2,     3,     3,     2,     3,     3,     4,
       3,     3,     3,     1,     2,     2,     2,     2,     3,     3,
       2,     3,     2,     2,     3,     3,     2,     3,     2,     2,
       2,     2,     2,     5,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     2,     1,
       2,     3,     2,     1,     1,     1,     1,     1,     1,     1,
       2,     0,     3,     0,     1,     1,     5,     0,     1,     1,
       1,     2,     2,     3,     3,     3,     3,     0,     1,     0,
       1,     0,     1,     2,     1,     1,     2,     4,     1,     3,
       2,     1,     0,     2,     0,     1,     2,     2,     2,     2,
       2,     1,     1,     3,     3,     3,     3,     2,     1,     2,
       2,     1,     1,     1,     1,     1,     0,     2,     1,     1,
       1,     1,     1,     0,     2,     1,     1,     0,     1,     2,
       1,     1,     2,     0,     1,     1,     2,     1,     2,     2,
       1,     0,     1,     0,     4,     1,     1,     1,     0,     1,
       2,     1,     1,     2,     1,     3,     3,     1,     1,     0,
       2,     0,     1,     5,     0,     3,     3,     1,     0,     2,
       2,     2,     0,     3,     3,     6,     6,     1,     1,     2,
       2,     2,     2,     2,     1,     1,     0,     1,     1,     1,
       1,     0,     1,     1,     1,     0,     1,     0,     1,     0,
       1,     1,     2,     1,     2,     1,     2,     0,     2,     0,
       2,     2,     2,     2,     3,     2,     3,     3,     3,     3,
       1,     1,     1,     1,     3,     1,     1,     1,     4,     2,
       1,     4,     0,     1,     1,     3,     0,     0,     8,     0,
       5,     7,     0,     5,     0,     5,     0,    10,     0,     9,
       0,    11,     3,     4,     3,     3,     0,     8,     8,     0,
       0,     7,     1,     1,     0,     1,     1,     3,     0,     2,
       3,     5,     5,     0,     3,     1,     4,     0,     3,     0,
       2,     0,     1,     0,     2,     2,     2,     2,     1,     1,
       1,     4,     4,     0,     6,     4,     0,     5,     0,     6,
       4,     3,     1,     7,     2,     1,     1,     0,     6,     0,
       3,     2,     0,     5,     0,     0,     6,     1,     3,     1,
       1,     3,     3,     3,     2,     2,     4,     4,     2,     7,
       6,     5,     5,     4,     5,     4,     4,     2,     2,     7,
       6,     3,     5,     1,     1,     1,     1,     1,     3,     3,
       3,     5,     0,     1,     1,     2,     2,     3,     3,     3,
       3,     0,     1,     0,     1,     0,     2,     0,     1,     2,
       1,     1,     1,     0,     1,     1,     0,     2,     1,     0,
       1,     1,     1,     0,     6,     0,     5,     4,     4,     3,
       0,     1,     1,     3,     3,     2,     2,     0,     2,     1,
       3,     0,     1,     1,     0,     2,     4,     1,     3,     0,
       5,     0,     1,     1,     3,     0,     4,     0,     4,     0,
       1,     1,     2,     1,     1,     1,     0,     2,     0,     5,
       1,     3,     2,     0,     3,     1,     4,     1,     0,     4,
       1,     0,     4,     0,     1,     3,     0,     1,     3,     1,
       1,     2,     6,     3,     0,     4,     0,     3,     0,     1,
       1,     2,     1,     1,     1,     1,     1,     2,     0,     2,
       0,     6,     0,     1,     1,     0,     4,     4,     3,     5,
       1,     3,     4,     0,     6,     1,     1,     1,     3,     2,
       3,     1,     1,     0,     6,     1,     1,     1,     3,     3,
       4,     0,     6,     0,     2,     0,     4,     0,     2,     0,
       3,     0,     4,     0,     3,     0,     4,     1,     1,     0,
       3,     0,     0,     5,     6,     7,     1,     2,     1,     1,
       0,     3,     0,     3,     3,     3,     1,     0,     4,     3,
       1,     1,     1,     1,     1,     4,     0,     1,     2,     1,
       1,     0,     1,     0,     1,     1,     2,     1,     2,     9,
       0,     1,     0,     2,     3,     1,     4,     4,     2,     1,
       1,     1,     1,     3,     5,     0,     1,     0,     2,     1,
       3,     1,     1,     3,     4,     0,     0,     0,     0,     2,
       2,     1,     1,     0,     2,     3,     0,     2,     3,     0,
       2,     3,     3,     3,     2,     1,     3,     4,     3,     4,
       3,     4,     3,     4,     3,     3,     6,     1,     3,     4,
       5,     7,     6,     8,     5,     6,     4,     3,     5,     4,
       6,     3,     4,     1,     3,     3,     3,     3,     3,     3,
       3,     5,     5,     5,     6,     6,     3,     3,     3,     3,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       2,     1,     1,     1,     1,     2,     1,     1,     1,     2,
       1,     2,     2,     0,     3,     1,     4,     1,     3,     1,
       1,     1,     1,     3,     1,     1,     1,     4,     4,     4,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     6,     4,     4,     7,     6,
       3,     4,     6,     6,     4,     4,     4,     4,     4,     4,
       6,     8,    10,     1,     1,     3,     1,     1,     3,     1,
       2,     2,     2,     2,     2,     1,     3,     4,     6,     4,
       6,     2,     2,     4,     4,     4,    10,     6,     8,     6,
       4,     4,     6,     4,     3,     4,     1,     4,     3,     4,
       1,     1,     5,     3,     5,     3,     6,     8,     2,     2,
       8,     8,     6,     8,     6,     6,     2,     6,     6,     8,
       4,     2,     8,     8,     4,     2,     2,     2,     6,     6,
       4,     4,     8,     4,     4,     4,     4,     3,     8,     6,
       8,     4,     6,     4,     6,     4,     4,     4,     6,     8,
       4,     3,     6,     4,     6,     5,     8,     7,    10,     1,
       6,     4,     4,     4,     4,     4,     6,     4,     6,     0,
       5,     6,     8,     6,     6,     6,     6,     6,     2,     3,
       0,     4,     0,     3,     0,     1,     1,     3,     4,     4,
       5,     4,     4,     4,     5,     4,     0,     0,     7,     4,
       5,     4,     5,     4,     4,     4,     4,     4,     5,     0,
       9,     3,     3,     1,     1,     1,     3,     3,     3,     3,
       3,     4,     4,     4,     6,     4,     6,     4,     6,     5,
       0,     7,     4,     4,     4,     4,     1,     0,     3,     3,
       1,     3,     5,     0,     1,     0,     2,     0,     3,     4,
       2,     0,     1,     1,     2,     1,     3,     3,     0,     3,
       2,     0,     4,     0,     4,     0,     4,     2,     1,     1,
       1,     1,     2,     1,     2,     2,     1,     2,     1,     2,
       2,     3,     0,     1,     1,     3,     1,     3,     1,     3,
       4,     5,     1,     3,     1,     1,     1,     1,     4,     1,
       3,     3,     0,     6,     0,     8,     4,     0,     8,     0,
      10,     6,     0,     8,     0,    10,     6,     1,     2,     1,
       1,     2,     0,     1,     5,     1,     1,     1,     1,     1,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     5,
       3,     0,     1,     0,     2,     3,     3,     1,     1,     0,
       7,     0,     7,     1,     2,     0,     0,     2,     0,     2,
       0,     1,     1,     1,     1,     3,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     1,     0,     1,     2,     0,
       1,     0,     0,     3,     0,     0,     3,     0,     4,     4,
       2,     0,     1,     1,     0,     2,     3,     1,     3,     0,
       7,     0,     1,     0,     3,     0,     3,     0,     3,     1,
       1,     1,     4,     2,     2,     2,     1,     2,     2,     0,
       3,     2,     2,     3,     3,     3,     3,     1,     2,     0,
       1,     0,     4,     4,     2,     0,     1,     1,     0,     1,
       2,     5,     4,     1,     1,     3,     3,     1,     3,     1,
       1,     1,     1,     1,     0,     2,     3,     4,     1,     2,
       1,     0,     1,     1,     1,     0,     2,     2,     2,     1,
       0,     1,     2,     2,     2,     1,     2,     2,     2,     2,
       1,     1,     1,     1,     1,     2,     1,     2,     2,     2,
       2,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     6,     0,
       1,     3,     1,     3,     0,     2,     3,     1,     1,     2,
       1,     3,     2,     0,     0,     7,     2,     1,     0,     3,
       0,     8,     0,     8,     4,     6,     4,     4,     5,     5,
       0,     6,     4,     4,     5,     6,     4,     0,     6,     1,
       3,     1,     2,     1,     3,     1,     0,     2,     0,     2,
       0,     1,     0,     0,     8,     0,     0,     6,     0,     1,
       1,     1,     1,     1,     2,     1,     0,     2,     1,     2,
       0,     3,     3,     0,     1,     3,     1,     1,     3,     1,
       3,     1,     3,     1,     1,     0,     1,     1,     1,     1,
       1,     0,     4,     0,     4,     0,     1,     0,     1,     3,
       1,     5,     3,     1,     1,     1,     1,     0,     0,     0,
       7,     5,     1,     0,     0,    11,     3,     1,     3,     3,
       3,     1,     3,     0,     1,     0,     3,     0,     3,     2,
       3,     3,     2,     5,     0,     5,     0,     6,     0,     2,
       1,     3,     2,     4,     0,     2,     0,     2,     1,     1,
       1,     0,     5,     0,     1,     0,     1,     1,     3,     1,
       1,     2,     2,     2,     1,     1,     1,     1,     0,     3,
       0,     3,     2,     4,     4,     3,     4,     4,     1,     3,
       3,     3,     3,     6,     2,     2,     0,     6,     0,     7,
       5,     2,     1,     1,     1,     5,     5,     2,     2,     1,
       4,     3,     2,     3,     2,     2,     1,     4,     4,     3,
       3,     3,     2,     3,     2,     3,     3,     3,     3,     4,
       3,     2,     3,     3,     3,     3,     4,     3,     3,     4,
       3,     3,     3,     1,     1,     1,     1,     1,     0,     1,
       0,     2,     0,     1,     1,     1,     0,     2,     0,     2,
       0,     3,     3,     0,     4,     0,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     2,     1,     1,
       0,     3,     0,     1,     1,     0,     4,     0,     4,     1,
       0,     1,     4,     0,     3,     3,     1,     2,     2,     2,
       2,     3,     3,     2,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     2,     0,     1,     2,     2,     0,     3,
       1,     0,     5,     0,     1,     3,     1,     0,     3,     0,
       3,     3,     1,     0,     4,     0,     3,     2,     0,     1,
       0,     2,     5,     0,     6,     0,     4,     0,     1,     1,
       2,     2,     3,     0,     1,     1,     2,     0,     3,     0,
       4,     2,     0,     0,     0,     0,    22,     1,     1,     0,
       1,     0,     1,     1,     0,     1,     1,     0,     2,     2,
       1,     3,     4,     3,     3,     0,     2,     2,     1,     3,
       3,     0,     4,     0,     3,     1,     1,     0,     3,     2,
       3,     1,     1,     2,     0,     2,     3,     1,     5,     1,
       1,     2,     2,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     2,     2,
       2,     0,     4,     0,     1,     1,     3,     0,     7,     0,
       3,     1,     3,     1,     1,     1,     3,     5,     3,     5,
       1,     1,     3,     4,     5,     4,     1,     3,     4,     4,
       5,     1,     5,     3,     2,     1,     3,     2,     2,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     3,     0,     0,     7,
       1,     3,     0,     3,     0,     3,     0,     3,     0,     3,
       2,     0,     2,     0,     2,     0,     4,     0,     3,     1,
       1,     1,     1,     0,     1,     1,     1,     0,     2,     2,
       2,     3,     5,     5,     3,     5,     5,     4,     6,     8,
       8,     2,     3,     3,     3,     5,     2,     3,     3,     1,
       1,     3,     3,     1,     3,     2,     2,     2,     2,     2,
       1,     1,     3,     1,     4,     4,     1,     1,     1,     1,
       1,     0,     5,     0,     2,     1,     1,     1,     1,     3,
       3,     1,     1,     2,     2,     2,     0,     3,     0,     3,
       3,     2,     0,     6,     1,     2,     1,     1,     1,     1,
       1,     1,     0,     5,     1,     1,     1,     1,     1,     3,
       6,     6,     6,     6,     7,     7,     5,     3,     4,     1,
       3,     8,     8,     8,     8,     9,     6,     4,     0,     3,
       0,     3,     1,     3,     2,     1,     1,     0,     1,     1,
       2,     0,     1,     1,     3,     0,     3,     0,     3,     0,
       3,     0,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     1,     3,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     1,     2,     2,
       0,     1,     3,     1,     2,     2,     2,     1,     3,     3,
       1,     1,     3,     1,     3,     1,     3,     1,     1,     1,
       1,     4,     5,     4,     1,     3,     1,     2,     0,     2,
       5,     0,     3,     3,     1,     1,     0,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     1,     0,     2,
       0,     2,     0,     3,     2,     1,     2,     1,     0,     3,
       1,     0,     1,     0,     1,     0,     3,     2,     0,     1,
       2,     4,     4,     5,     4,     2,     3,     2,     1,     1,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     3,     3,     3,     3,     0,     1,
       3,     3,     0,     3,     1,     3,     0,     3,     0,     3,
       4,     4,     1,     1,     0,     2,     0,     0,     0,     0,
       0,    20,     0,     3,     0,     4,     0,     0,     7,     4,
       4,     3,     4,     3,     3,     0,     3,     1,     3,     5,
       1,     1,     1,     0,     1,     1,     0,     2,     0,     0,
       3,     0,     2,     6,     3,     4,     4,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (thd, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, thd); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, THD *thd)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (thd);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, THD *thd)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, thd);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, THD *thd)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], thd);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, thd); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, THD *thd)
{
  YY_USE (yyvaluep);
  YY_USE (thd);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (THD *thd)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, thd);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* query: END_OF_INPUT  */
#line 2264 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!thd->bootstrap &&
              (!(thd->lex->lex_options & OPTION_LEX_FOUND_COMMENT)))
              my_yyabort_error((ER_EMPTY_QUERY, MYF(0)));

            thd->lex->sql_command= SQLCOM_EMPTY_QUERY;
            YYLIP->found_semicolon= NULL;
          }
#line 27453 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3: /* $@1: %empty  */
#line 2273 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex_input_stream *lip = YYLIP;

            if ((thd->client_capabilities & CLIENT_MULTI_QUERIES) &&
                lip->multi_statements &&
                ! lip->eof())
            {
              /*
                We found a well formed query, and multi queries are allowed:
                - force the parser to stop after the ';'
                - mark the start of the next query for the next invocation
                  of the parser.
              */
              lip->next_state= MY_LEX_END;
              lip->found_semicolon= lip->get_ptr();
            }
            else
            {
              /* Single query, terminated. */
              lip->found_semicolon= NULL;
            }
          }
#line 27480 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 5: /* query: verb_clause END_OF_INPUT  */
#line 2298 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* Single query, not terminated. */
            YYLIP->found_semicolon= NULL;
          }
#line 27489 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 70: /* deallocate: deallocate_or_drop PREPARE_SYM ident  */
#line 2380 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->stmt_deallocate_prepare((yyvsp[0].ident_sys));
          }
#line 27497 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 73: /* $@2: %empty  */
#line 2392 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->clause_that_disallows_subselect= "PREPARE..FROM"; }
#line 27503 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 74: /* prepare: PREPARE_SYM ident FROM $@2 expr  */
#line 2394 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->clause_that_disallows_subselect= NULL;
            if (Lex->stmt_prepare((yyvsp[-3].ident_sys), (yyvsp[0].item)))
              MYSQL_YYABORT;
          }
#line 27513 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 75: /* execute: EXECUTE_SYM ident execute_using  */
#line 2403 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_execute((yyvsp[-1].ident_sys), (yyvsp[0].item_list)))
              MYSQL_YYABORT;
          }
#line 27522 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 76: /* $@3: %empty  */
#line 2408 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->clause_that_disallows_subselect= "EXECUTE IMMEDIATE"; }
#line 27528 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 77: /* $@4: %empty  */
#line 2410 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->clause_that_disallows_subselect= NULL; }
#line 27534 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 78: /* execute: EXECUTE_SYM IMMEDIATE_SYM $@3 expr $@4 execute_using  */
#line 2412 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_execute_immediate((yyvsp[-2].item), (yyvsp[0].item_list)))
              MYSQL_YYABORT;
          }
#line 27543 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 79: /* execute_using: %empty  */
#line 2419 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.item_list)= NULL; }
#line 27549 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 80: /* $@5: %empty  */
#line 2421 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->clause_that_disallows_subselect= "EXECUTE..USING"; }
#line 27555 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 81: /* execute_using: USING $@5 execute_params  */
#line 2423 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_list)= (yyvsp[0].item_list);
            Lex->clause_that_disallows_subselect= NULL;
          }
#line 27564 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 82: /* execute_params: expr_or_ignore_or_default  */
#line 2431 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_list)= List<Item>::make(thd->mem_root, (yyvsp[0].item)))))
              MYSQL_YYABORT;
          }
#line 27573 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 83: /* execute_params: execute_params ',' expr_or_ignore_or_default  */
#line 2436 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (((yyval.item_list)= (yyvsp[-2].item_list))->push_back((yyvsp[0].item), thd->mem_root))
              MYSQL_YYABORT;
          }
#line 27582 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 84: /* $@6: %empty  */
#line 2447 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HELP"));
          }
#line 27591 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 85: /* help: HELP_SYM $@6 ident_or_text  */
#line 2452 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_HELP;
            lex->help_arg= (yyvsp[0].lex_str).str;
          }
#line 27601 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 86: /* $@7: %empty  */
#line 2463 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_CHANGE_MASTER;
          }
#line 27609 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 87: /* change: CHANGE MASTER_SYM optional_connection_name TO_SYM $@7 master_defs  */
#line 2467 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 27615 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 90: /* master_def: MASTER_HOST_SYM '=' TEXT_STRING_sys  */
#line 2477 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.host = (yyvsp[0].lex_str).str;
          }
#line 27623 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 91: /* master_def: MASTER_USER_SYM '=' TEXT_STRING_sys  */
#line 2481 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.user = (yyvsp[0].lex_str).str;
          }
#line 27631 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 92: /* master_def: MASTER_PASSWORD_SYM '=' TEXT_STRING_sys  */
#line 2485 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.password = (yyvsp[0].lex_str).str;
          }
#line 27639 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 93: /* master_def: MASTER_PORT_SYM '=' ulong_num  */
#line 2489 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.port = (yyvsp[0].ulong_num);
          }
#line 27647 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 94: /* master_def: MASTER_CONNECT_RETRY_SYM '=' ulong_num  */
#line 2493 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.connect_retry = (yyvsp[0].ulong_num);
          }
#line 27655 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 95: /* master_def: MASTER_DELAY_SYM '=' ulong_num  */
#line 2497 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[0].ulong_num) > MASTER_DELAY_MAX)
            {
              my_error(ER_MASTER_DELAY_VALUE_OUT_OF_RANGE, MYF(0),
                       (ulong) (yyvsp[0].ulong_num), (ulong) MASTER_DELAY_MAX);
            }
            else
              Lex->mi.sql_delay = (yyvsp[0].ulong_num);
          }
#line 27669 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 96: /* master_def: MASTER_SSL_SYM '=' ulong_num  */
#line 2507 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl= (yyvsp[0].ulong_num) ? 
              LEX_MASTER_INFO::LEX_MI_ENABLE : LEX_MASTER_INFO::LEX_MI_DISABLE;
          }
#line 27678 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 97: /* master_def: MASTER_SSL_CA_SYM '=' TEXT_STRING_sys  */
#line 2512 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_ca= (yyvsp[0].lex_str).str;
          }
#line 27686 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 98: /* master_def: MASTER_SSL_CAPATH_SYM '=' TEXT_STRING_sys  */
#line 2516 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_capath= (yyvsp[0].lex_str).str;
          }
#line 27694 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 99: /* master_def: MASTER_SSL_CERT_SYM '=' TEXT_STRING_sys  */
#line 2520 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_cert= (yyvsp[0].lex_str).str;
          }
#line 27702 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 100: /* master_def: MASTER_SSL_CIPHER_SYM '=' TEXT_STRING_sys  */
#line 2524 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_cipher= (yyvsp[0].lex_str).str;
          }
#line 27710 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 101: /* master_def: MASTER_SSL_KEY_SYM '=' TEXT_STRING_sys  */
#line 2528 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_key= (yyvsp[0].lex_str).str;
          }
#line 27718 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 102: /* master_def: MASTER_SSL_VERIFY_SERVER_CERT_SYM '=' ulong_num  */
#line 2532 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_verify_server_cert= (yyvsp[0].ulong_num) ?
              LEX_MASTER_INFO::LEX_MI_ENABLE : LEX_MASTER_INFO::LEX_MI_DISABLE;
          }
#line 27727 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 103: /* master_def: MASTER_SSL_CRL_SYM '=' TEXT_STRING_sys  */
#line 2537 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_crl= (yyvsp[0].lex_str).str;
          }
#line 27735 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 104: /* master_def: MASTER_SSL_CRLPATH_SYM '=' TEXT_STRING_sys  */
#line 2541 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_crlpath= (yyvsp[0].lex_str).str;
          }
#line 27743 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 105: /* master_def: MASTER_HEARTBEAT_PERIOD_SYM '=' NUM_literal  */
#line 2546 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.heartbeat_period= (float) (yyvsp[0].item_num)->val_real();
            if (unlikely(Lex->mi.heartbeat_period >
                         SLAVE_MAX_HEARTBEAT_PERIOD) ||
                unlikely(Lex->mi.heartbeat_period < 0.0))
               my_yyabort_error((ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE, MYF(0),
                                 SLAVE_MAX_HEARTBEAT_PERIOD));

            if (unlikely(Lex->mi.heartbeat_period > slave_net_timeout))
            {
              push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                                  ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MAX,
                                  ER_THD(thd, ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MAX));
            }
            if (unlikely(Lex->mi.heartbeat_period < 0.001))
            {
              if (unlikely(Lex->mi.heartbeat_period != 0.0))
              {
                push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                                    ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MIN,
                                    ER_THD(thd, ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MIN));
                Lex->mi.heartbeat_period= 0.0;
              }
              Lex->mi.heartbeat_opt=  LEX_MASTER_INFO::LEX_MI_DISABLE;
            }
            Lex->mi.heartbeat_opt=  LEX_MASTER_INFO::LEX_MI_ENABLE;
          }
#line 27775 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 106: /* master_def: IGNORE_SERVER_IDS_SYM '=' '(' ignore_server_id_list ')'  */
#line 2574 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.repl_ignore_server_ids_opt= LEX_MASTER_INFO::LEX_MI_ENABLE;
           }
#line 27783 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 107: /* master_def: DO_DOMAIN_IDS_SYM '=' '(' do_domain_id_list ')'  */
#line 2578 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.repl_do_domain_ids_opt= LEX_MASTER_INFO::LEX_MI_ENABLE;
          }
#line 27791 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 108: /* master_def: IGNORE_DOMAIN_IDS_SYM '=' '(' ignore_domain_id_list ')'  */
#line 2582 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.repl_ignore_domain_ids_opt= LEX_MASTER_INFO::LEX_MI_ENABLE;
          }
#line 27799 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 113: /* ignore_server_id: ulong_num  */
#line 2597 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            insert_dynamic(&Lex->mi.repl_ignore_server_ids, (uchar*) &((yyvsp[0].ulong_num)));
          }
#line 27807 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 117: /* do_domain_id: ulong_num  */
#line 2610 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            insert_dynamic(&Lex->mi.repl_do_domain_ids, (uchar*) &((yyvsp[0].ulong_num)));
          }
#line 27815 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 121: /* ignore_domain_id: ulong_num  */
#line 2623 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            insert_dynamic(&Lex->mi.repl_ignore_domain_ids, (uchar*) &((yyvsp[0].ulong_num)));
          }
#line 27823 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 122: /* master_file_def: MASTER_LOG_FILE_SYM '=' TEXT_STRING_sys  */
#line 2630 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.log_file_name = (yyvsp[0].lex_str).str;
          }
#line 27831 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 123: /* master_file_def: MASTER_LOG_POS_SYM '=' ulonglong_num  */
#line 2634 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* 
               If the user specified a value < BIN_LOG_HEADER_SIZE, adjust it
               instead of causing subsequent errors. 
               We need to do it in this file, because only there we know that 
               MASTER_LOG_POS has been explicitly specified. On the contrary
               in change_master() (sql_repl.cc) we cannot distinguish between 0
               (MASTER_LOG_POS explicitly specified as 0) and 0 (unspecified),
               whereas we want to distinguish (specified 0 means "read the binlog
               from 0" (4 in fact), unspecified means "don't change the position
               (keep the preceding value)").
            */
            Lex->mi.pos= MY_MAX(BIN_LOG_HEADER_SIZE, (yyvsp[0].ulonglong_number));
          }
#line 27850 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 124: /* master_file_def: RELAY_LOG_FILE_SYM '=' TEXT_STRING_sys  */
#line 2649 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.relay_log_name = (yyvsp[0].lex_str).str;
          }
#line 27858 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 125: /* master_file_def: RELAY_LOG_POS_SYM '=' ulong_num  */
#line 2653 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.relay_log_pos = (yyvsp[0].ulong_num);
            /* Adjust if < BIN_LOG_HEADER_SIZE (same comment as Lex->mi.pos) */
            Lex->mi.relay_log_pos= MY_MAX(BIN_LOG_HEADER_SIZE, Lex->mi.relay_log_pos);
          }
#line 27868 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 126: /* master_file_def: MASTER_USE_GTID_SYM '=' CURRENT_POS_SYM  */
#line 2659 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->mi.use_gtid_opt != LEX_MASTER_INFO::LEX_GTID_UNCHANGED))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MASTER_use_gtid"));
            Lex->mi.use_gtid_opt= LEX_MASTER_INFO::LEX_GTID_CURRENT_POS;
          }
#line 27878 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 127: /* master_file_def: MASTER_USE_GTID_SYM '=' SLAVE_POS_SYM  */
#line 2665 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->mi.use_gtid_opt != LEX_MASTER_INFO::LEX_GTID_UNCHANGED))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MASTER_use_gtid"));
            Lex->mi.use_gtid_opt= LEX_MASTER_INFO::LEX_GTID_SLAVE_POS;
          }
#line 27888 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 128: /* master_file_def: MASTER_USE_GTID_SYM '=' NO_SYM  */
#line 2671 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->mi.use_gtid_opt != LEX_MASTER_INFO::LEX_GTID_UNCHANGED))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MASTER_use_gtid"));
            Lex->mi.use_gtid_opt= LEX_MASTER_INFO::LEX_GTID_NO;
          }
#line 27898 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 129: /* optional_connection_name: %empty  */
#line 2680 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->mi.connection_name= null_clex_str;
          }
#line 27907 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 131: /* connection_name: TEXT_STRING_sys  */
#line 2689 "/home/buildbot/git/sql/sql_yacc.yy"
        {
           Lex->mi.connection_name= (yyvsp[0].lex_str);
#ifdef HAVE_REPLICATION
           if (unlikely(check_master_connection_name(&(yyvsp[0].lex_str))))
              my_yyabort_error((ER_WRONG_ARGUMENTS, MYF(0), "MASTER_CONNECTION_NAME"));
#endif
         }
#line 27919 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 132: /* $@8: %empty  */
#line 2702 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            if (!(lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_create_table()))
              MYSQL_YYABORT;
            lex->create_info.init();
            if (lex->main_select_push())
              MYSQL_YYABORT;
            lex->current_select->parsing_place= BEFORE_OPT_LIST;
            if (lex->set_command_with_check(SQLCOM_CREATE_TABLE, (yyvsp[-2].num), (yyvsp[-3].object_ddl_options) | (yyvsp[0].object_ddl_options)))
               MYSQL_YYABORT;
          }
#line 27935 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 133: /* $@9: %empty  */
#line 2714 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            if (!lex->first_select_lex()->
                  add_table_to_list(thd, (yyvsp[0].table), NULL, TL_OPTION_UPDATING,
                                    TL_WRITE, MDL_SHARED_UPGRADABLE))
              MYSQL_YYABORT;
            lex->alter_info.reset();
            /*
              For CREATE TABLE we should not open the table even if it exists.
              If the table exists, we should either not create it or replace it
            */
            lex->query_tables->open_strategy= TABLE_LIST::OPEN_STUB;
            lex->create_info.default_table_charset= NULL;
            lex->name= null_clex_str;
            lex->create_last_non_select_table= lex->last_table();
            lex->inc_select_stack_outer_barrier();
          }
#line 27957 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 134: /* create: create_or_replace opt_temporary TABLE_SYM opt_if_not_exists $@8 table_ident $@9 create_body  */
#line 2732 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            create_table_set_open_action_and_adjust_tables(lex);
            Lex->pop_select(); //main select
          }
#line 27967 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 135: /* $@10: %empty  */
#line 2738 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           LEX *lex= thd->lex;
           if (lex->main_select_push())
             MYSQL_YYABORT;
           if (!(lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_create_sequence()))
              MYSQL_YYABORT;
           lex->create_info.init();
           if (unlikely(lex->set_command_with_check(SQLCOM_CREATE_SEQUENCE, (yyvsp[-3].num),
                        (yyvsp[-4].object_ddl_options) | (yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;

           if (!lex->first_select_lex()->
                 add_table_to_list(thd, (yyvsp[0].table), NULL, TL_OPTION_UPDATING,
                                   TL_WRITE, MDL_EXCLUSIVE))
             MYSQL_YYABORT;

               /*
                 For CREATE TABLE, an non-existing table is not an error.
                 Instruct open_tables() to just take an MDL lock if the
                 table does not exist.
               */
             lex->alter_info.reset();
             lex->query_tables->open_strategy= TABLE_LIST::OPEN_STUB;
             lex->name= null_clex_str;
             lex->create_last_non_select_table= lex->last_table();
             if (unlikely(!(lex->create_info.seq_create_info=
                            new (thd->mem_root) sequence_definition())))
               MYSQL_YYABORT;
         }
#line 28001 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 136: /* create: create_or_replace opt_temporary SEQUENCE_SYM opt_if_not_exists table_ident $@10 opt_sequence opt_create_table_options  */
#line 2768 "/home/buildbot/git/sql/sql_yacc.yy"
         {
            LEX *lex= thd->lex;

            if (unlikely(lex->create_info.seq_create_info->check_and_adjust(1)))
            {
              my_error(ER_SEQUENCE_INVALID_DATA, MYF(0),
                       lex->first_select_lex()->table_list.first->db.str,
                       lex->first_select_lex()->table_list.first->
                         table_name.str);
              MYSQL_YYABORT;
            }

            /* No fields specified, generate them */
            if (unlikely(prepare_sequence_fields(thd,
                         &lex->alter_info.create_list)))
               MYSQL_YYABORT;

            /* CREATE SEQUENCE always creates a sequence */
	    Lex->create_info.used_fields|= HA_CREATE_USED_SEQUENCE;
            Lex->create_info.sequence= 1;

            create_table_set_open_action_and_adjust_tables(lex);
            Lex->pop_select(); //main select
          }
#line 28030 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 137: /* $@11: %empty  */
#line 2793 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 28039 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 138: /* $@12: %empty  */
#line 2800 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->add_create_index_prepare((yyvsp[0].table)))
              MYSQL_YYABORT;
            if (Lex->add_create_index((yyvsp[-7].key_type), &(yyvsp[-3].ident_sys), (yyvsp[-2].key_alg), (yyvsp[-8].object_ddl_options) | (yyvsp[-5].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 28050 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 139: /* create: create_or_replace opt_unique INDEX_SYM opt_if_not_exists $@11 ident opt_key_algorithm_clause ON table_ident $@12 '(' key_list ')' opt_lock_wait_timeout normal_key_options opt_index_lock_algorithm  */
#line 2808 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28058 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 140: /* $@13: %empty  */
#line 2812 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 28067 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 141: /* $@14: %empty  */
#line 2818 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->add_create_index_prepare((yyvsp[0].table)))
              MYSQL_YYABORT;
            if (Lex->add_create_index((yyvsp[-6].key_type), &(yyvsp[-2].ident_sys), HA_KEY_ALG_UNDEF, (yyvsp[-7].object_ddl_options) | (yyvsp[-3].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 28078 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 142: /* create: create_or_replace fulltext INDEX_SYM $@13 opt_if_not_exists ident ON table_ident $@14 '(' key_list ')' opt_lock_wait_timeout fulltext_key_options opt_index_lock_algorithm  */
#line 2826 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28086 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 143: /* $@15: %empty  */
#line 2830 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 28095 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 144: /* $@16: %empty  */
#line 2836 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->add_create_index_prepare((yyvsp[0].table)))
              MYSQL_YYABORT;
            if (Lex->add_create_index((yyvsp[-6].key_type), &(yyvsp[-2].ident_sys), HA_KEY_ALG_UNDEF, (yyvsp[-7].object_ddl_options) | (yyvsp[-3].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 28106 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 145: /* create: create_or_replace spatial INDEX_SYM $@15 opt_if_not_exists ident ON table_ident $@16 '(' key_list ')' opt_lock_wait_timeout spatial_key_options opt_index_lock_algorithm  */
#line 2844 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28114 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 146: /* $@17: %empty  */
#line 2848 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.default_table_charset= NULL;
            Lex->create_info.used_fields= 0;
          }
#line 28123 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 147: /* create: create_or_replace DATABASE opt_if_not_exists ident $@17 opt_create_database_options  */
#line 2853 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->set_command_with_check(SQLCOM_CREATE_DB, 0,
                         (yyvsp[-5].object_ddl_options) | (yyvsp[-3].object_ddl_options))))
               MYSQL_YYABORT;
            lex->name= (yyvsp[-2].ident_sys);
          }
#line 28135 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 148: /* $@18: %empty  */
#line 2862 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->inc_select_stack_outer_barrier();
            if (Lex->add_create_view(thd, (yyvsp[-5].object_ddl_options) | (yyvsp[-1].object_ddl_options),
                                     DTYPE_ALGORITHM_UNDEFINED, (yyvsp[-3].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
          }
#line 28148 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 149: /* create: create_or_replace definer_opt opt_view_suid VIEW_SYM opt_if_not_exists table_ident $@18 view_list_opt AS view_select  */
#line 2871 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28156 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 150: /* $@19: %empty  */
#line 2876 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_create_view(thd, (yyvsp[-6].object_ddl_options) | (yyvsp[-1].object_ddl_options), (yyvsp[-5].num), (yyvsp[-3].view_suid), (yyvsp[0].table))))
              MYSQL_YYABORT;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->inc_select_stack_outer_barrier();
          }
#line 28168 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 151: /* create: create_or_replace view_algorithm definer_opt opt_view_suid VIEW_SYM opt_if_not_exists table_ident $@19 view_list_opt AS view_select  */
#line 2884 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28176 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 152: /* $@20: %empty  */
#line 2888 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->create_info.set((yyvsp[-2].object_ddl_options));
          }
#line 28186 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 153: /* create: create_or_replace definer_opt TRIGGER_SYM $@20 trigger_tail  */
#line 2894 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28194 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 154: /* $@21: %empty  */
#line 2898 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_create_procedure_start((yyvsp[-3].object_ddl_options) | (yyvsp[0].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 28203 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 155: /* create: create_or_replace definer_opt PROCEDURE_SYM opt_if_not_exists $@21 sp_tail  */
#line 2903 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->stmt_create_routine_finalize();
          }
#line 28211 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 156: /* $@22: %empty  */
#line 2907 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->create_info.set((yyvsp[-2].object_ddl_options));
          }
#line 28221 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 157: /* create: create_or_replace definer_opt EVENT_SYM $@22 event_tail  */
#line 2913 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28229 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 158: /* $@23: %empty  */
#line 2918 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_create_stored_function_start((yyvsp[-6].object_ddl_options) | (yyvsp[-2].object_ddl_options), (yyvsp[-4].sp_aggregate_type), (yyvsp[-1].spname)))
              MYSQL_YYABORT;
          }
#line 28238 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 159: /* create: create_or_replace definer opt_aggregate FUNCTION_SYM opt_if_not_exists sp_name '(' $@23 sp_fdparam_list ')' sf_return_type sf_c_chistics_and_body  */
#line 2925 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->stmt_create_routine_finalize();
          }
#line 28246 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 160: /* $@24: %empty  */
#line 2930 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_create_stored_function_start((yyvsp[-6].object_ddl_options) | (yyvsp[-2].object_ddl_options), (yyvsp[-4].sp_aggregate_type), (yyvsp[-1].spname)))
              MYSQL_YYABORT;
          }
#line 28255 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 161: /* create: create_or_replace no_definer opt_aggregate FUNCTION_SYM opt_if_not_exists sp_name '(' $@24 sp_fdparam_list ')' sf_return_type sf_c_chistics_and_body  */
#line 2937 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->stmt_create_routine_finalize();
          }
#line 28263 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 162: /* create: create_or_replace no_definer opt_aggregate FUNCTION_SYM opt_if_not_exists ident RETURNS_SYM udf_type SONAME_SYM TEXT_STRING_sys  */
#line 2942 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_create_udf_function((yyvsp[-9].object_ddl_options) | (yyvsp[-5].object_ddl_options), (yyvsp[-7].sp_aggregate_type), (yyvsp[-4].ident_sys),
                                              (Item_result) (yyvsp[-2].num), (yyvsp[0].lex_str)))
              MYSQL_YYABORT;
          }
#line 28273 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 163: /* create: create_or_replace USER_SYM opt_if_not_exists clear_privileges grant_list opt_require_clause opt_resource_options opt_account_locking_and_opt_password_expiration  */
#line 2949 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_command_with_check(SQLCOM_CREATE_USER,
                                                     (yyvsp[-7].object_ddl_options) | (yyvsp[-5].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 28283 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 164: /* create: create_or_replace ROLE_SYM opt_if_not_exists clear_privileges role_list opt_with_admin  */
#line 2956 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_command_with_check(SQLCOM_CREATE_ROLE,
                         (yyvsp[-5].object_ddl_options) | (yyvsp[-3].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 28293 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 165: /* create: CREATE LOGFILE_SYM GROUP_SYM logfile_group_info  */
#line 2962 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_tablespace_info->ts_cmd_type= CREATE_LOGFILE_GROUP;
          }
#line 28301 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 166: /* create: CREATE TABLESPACE tablespace_info  */
#line 2966 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_tablespace_info->ts_cmd_type= CREATE_TABLESPACE;
          }
#line 28309 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 167: /* $@25: %empty  */
#line 2969 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->set_command(SQLCOM_CREATE_SERVER, (yyvsp[0].object_ddl_options)); }
#line 28315 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 168: /* create: create_or_replace $@25 server_def  */
#line 2971 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 28321 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 169: /* opt_sequence: %empty  */
#line 2975 "/home/buildbot/git/sql/sql_yacc.yy"
                     { }
#line 28327 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 173: /* sequence_def: MINVALUE_SYM opt_equal longlong_num  */
#line 2986 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.seq_create_info->min_value= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_min_value;
          }
#line 28336 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 174: /* sequence_def: NO_SYM MINVALUE_SYM  */
#line 2991 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_min_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MINVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_min_value;
          }
#line 28346 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 175: /* sequence_def: NOMINVALUE_SYM  */
#line 2997 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_min_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MINVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_min_value;
          }
#line 28356 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 176: /* sequence_def: MAXVALUE_SYM opt_equal longlong_num  */
#line 3003 "/home/buildbot/git/sql/sql_yacc.yy"
          {
           if (unlikely(Lex->create_info.seq_create_info->used_fields &
               seq_field_used_max_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MAXVALUE"));
            Lex->create_info.seq_create_info->max_value= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_max_value;
          }
#line 28368 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 177: /* sequence_def: NO_SYM MAXVALUE_SYM  */
#line 3011 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_max_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MAXVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_max_value;
          }
#line 28378 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 178: /* sequence_def: NOMAXVALUE_SYM  */
#line 3017 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_max_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MAXVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_max_value;
          }
#line 28388 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 179: /* sequence_def: START_SYM opt_with longlong_num  */
#line 3023 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                         seq_field_used_start))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "START"));
            Lex->create_info.seq_create_info->start= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_start;
          }
#line 28400 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 180: /* sequence_def: INCREMENT_SYM opt_by longlong_num  */
#line 3031 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_increment))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "INCREMENT"));
            Lex->create_info.seq_create_info->increment= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_increment;
          }
#line 28412 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 181: /* sequence_def: CACHE_SYM opt_equal longlong_num  */
#line 3039 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cache))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CACHE"));
            Lex->create_info.seq_create_info->cache= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cache;
          }
#line 28424 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 182: /* sequence_def: NOCACHE_SYM  */
#line 3047 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cache))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CACHE"));
            Lex->create_info.seq_create_info->cache= 0;
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cache;
          }
#line 28436 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 183: /* sequence_def: CYCLE_SYM  */
#line 3055 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cycle))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CYCLE"));
            Lex->create_info.seq_create_info->cycle= 1;
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cycle;
          }
#line 28448 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 184: /* sequence_def: NOCYCLE_SYM  */
#line 3063 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cycle))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CYCLE"));
            Lex->create_info.seq_create_info->cycle= 0;
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cycle;
          }
#line 28460 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 185: /* sequence_def: RESTART_SYM  */
#line 3071 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sql_command != SQLCOM_ALTER_SEQUENCE))
            {
              thd->parse_error(ER_SYNTAX_ERROR, "RESTART");
              MYSQL_YYABORT;
            }
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                         seq_field_used_restart))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "RESTART"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_restart;
          }
#line 28476 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 186: /* sequence_def: RESTART_SYM opt_with longlong_num  */
#line 3083 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sql_command != SQLCOM_ALTER_SEQUENCE))
            {
              thd->parse_error(ER_SYNTAX_ERROR, "RESTART");
              MYSQL_YYABORT;
            }
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                         seq_field_used_restart))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "RESTART"));
            Lex->create_info.seq_create_info->restart= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_restart | seq_field_used_restart_value;
          }
#line 28493 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 187: /* force_lookahead: %empty  */
#line 3098 "/home/buildbot/git/sql/sql_yacc.yy"
                 {}
#line 28499 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 188: /* force_lookahead: FORCE_LOOKAHEAD  */
#line 3098 "/home/buildbot/git/sql/sql_yacc.yy"
                                      {}
#line 28505 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 189: /* $@26: %empty  */
#line 3102 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_create_options_with_check((yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
            Lex->server_options.reset((yyvsp[0].lex_str));
          }
#line 28515 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 190: /* server_def: SERVER_SYM opt_if_not_exists ident_or_text $@26 FOREIGN DATA_SYM WRAPPER_SYM ident_or_text OPTIONS_SYM '(' server_options_list ')'  */
#line 3109 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->server_options.scheme= (yyvsp[-4].lex_str); }
#line 28521 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 193: /* server_option: USER_SYM TEXT_STRING_sys  */
#line 3119 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.username.str == 0);
            Lex->server_options.username= (yyvsp[0].lex_str);
          }
#line 28530 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 194: /* server_option: HOST_SYM TEXT_STRING_sys  */
#line 3124 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.host.str == 0);
            Lex->server_options.host= (yyvsp[0].lex_str);
          }
#line 28539 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 195: /* server_option: DATABASE TEXT_STRING_sys  */
#line 3129 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.db.str == 0);
            Lex->server_options.db= (yyvsp[0].lex_str);
          }
#line 28548 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 196: /* server_option: OWNER_SYM TEXT_STRING_sys  */
#line 3134 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.owner.str == 0);
            Lex->server_options.owner= (yyvsp[0].lex_str);
          }
#line 28557 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 197: /* server_option: PASSWORD_SYM TEXT_STRING_sys  */
#line 3139 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.password.str == 0);
            Lex->server_options.password= (yyvsp[0].lex_str);
          }
#line 28566 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 198: /* server_option: SOCKET_SYM TEXT_STRING_sys  */
#line 3144 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.socket.str == 0);
            Lex->server_options.socket= (yyvsp[0].lex_str);
          }
#line 28575 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 199: /* server_option: PORT_SYM ulong_num  */
#line 3149 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->server_options.port= (yyvsp[0].ulong_num);
          }
#line 28583 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 200: /* $@27: %empty  */
#line 3156 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;

            lex->stmt_definition_begin= (yyvsp[-2].simple_string);
            if (unlikely(lex->add_create_options_with_check((yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
            if (unlikely(!(lex->event_parse_data=
                           Event_parse_data::new_instance(thd))))
              MYSQL_YYABORT;
            lex->event_parse_data->identifier= (yyvsp[0].spname);
            lex->event_parse_data->on_completion=
                                  Event_parse_data::ON_COMPLETION_DROP;

            lex->sql_command= SQLCOM_CREATE_EVENT;
            /* We need that for disallowing subqueries */
          }
#line 28604 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 201: /* event_tail: remember_name opt_if_not_exists sp_name $@27 ON SCHEDULE_SYM ev_schedule_time opt_ev_on_completion opt_ev_status opt_ev_comment DO_SYM ev_sql_stmt  */
#line 3177 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              sql_command is set here because some rules in ev_sql_stmt
              can overwrite it
            */
            Lex->sql_command= SQLCOM_CREATE_EVENT;
          }
#line 28616 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 202: /* $@28: %empty  */
#line 3188 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->item_expression= (yyvsp[-1].item);
            Lex->event_parse_data->interval= (yyvsp[0].interval);
          }
#line 28625 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 204: /* ev_schedule_time: AT_SYM expr  */
#line 3195 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->item_execute_at= (yyvsp[0].item);
          }
#line 28633 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 205: /* opt_ev_status: %empty  */
#line 3201 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0; }
#line 28639 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 206: /* opt_ev_status: ENABLE_SYM  */
#line 3203 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->status= Event_parse_data::ENABLED;
            Lex->event_parse_data->status_changed= true;
            (yyval.num)= 1;
          }
#line 28649 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 207: /* opt_ev_status: DISABLE_SYM ON SLAVE  */
#line 3209 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->status= Event_parse_data::SLAVESIDE_DISABLED;
            Lex->event_parse_data->status_changed= true; 
            (yyval.num)= 1;
          }
#line 28659 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 208: /* opt_ev_status: DISABLE_SYM  */
#line 3215 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->status= Event_parse_data::DISABLED;
            Lex->event_parse_data->status_changed= true;
            (yyval.num)= 1;
          }
#line 28669 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 209: /* ev_starts: %empty  */
#line 3224 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_func_now_local(thd, 0);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            Lex->event_parse_data->item_starts= item;
          }
#line 28680 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 210: /* ev_starts: STARTS_SYM expr  */
#line 3231 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->item_starts= (yyvsp[0].item);
          }
#line 28688 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 212: /* ev_ends: ENDS_SYM expr  */
#line 3239 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->item_ends= (yyvsp[0].item);
          }
#line 28696 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 213: /* opt_ev_on_completion: %empty  */
#line 3245 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0; }
#line 28702 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 215: /* ev_on_completion: ON COMPLETION_SYM opt_not PRESERVE_SYM  */
#line 3251 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->on_completion= (yyvsp[-1].num)
                                    ? Event_parse_data::ON_COMPLETION_DROP
                                    : Event_parse_data::ON_COMPLETION_PRESERVE;
            (yyval.num)= 1;
          }
#line 28713 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 216: /* opt_ev_comment: %empty  */
#line 3260 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0; }
#line 28719 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 217: /* opt_ev_comment: COMMENT_SYM TEXT_STRING_sys  */
#line 3262 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->comment= Lex->event_parse_data->comment= (yyvsp[0].lex_str);
            (yyval.num)= 1;
          }
#line 28728 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 218: /* $@29: %empty  */
#line 3269 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            Lex_input_stream *lip= YYLIP;

            /*
              This stops the following :
              - CREATE EVENT ... DO CREATE EVENT ...;
              - ALTER  EVENT ... DO CREATE EVENT ...;
              - CREATE EVENT ... DO ALTER EVENT DO ....;
              - CREATE PROCEDURE ... BEGIN CREATE EVENT ... END|
              This allows:
              - CREATE EVENT ... DO DROP EVENT yyy;
              - CREATE EVENT ... DO ALTER EVENT yyy;
                (the nested ALTER EVENT can have anything but DO clause)
              - ALTER  EVENT ... DO ALTER EVENT yyy;
                (the nested ALTER EVENT can have anything but DO clause)
              - ALTER  EVENT ... DO DROP EVENT yyy;
              - CREATE PROCEDURE ... BEGIN ALTER EVENT ... END|
                (the nested ALTER EVENT can have anything but DO clause)
              - CREATE PROCEDURE ... BEGIN DROP EVENT ... END|
            */
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_EVENT_RECURSION_FORBIDDEN, MYF(0)));
              
            if (unlikely(!lex->make_sp_head(thd,
                                            lex->event_parse_data->identifier,
                                            &sp_handler_procedure,
                                            DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;

            lex->sphead->set_body_start(thd, lip->get_cpp_ptr());
          }
#line 28765 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 219: /* ev_sql_stmt: $@29 sp_proc_stmt force_lookahead  */
#line 3302 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* return back to the original memory root ASAP */
            if (Lex->sp_body_finalize_event(thd))
              MYSQL_YYABORT;
          }
#line 28775 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 220: /* clear_privileges: %empty  */
#line 3311 "/home/buildbot/git/sql/sql_yacc.yy"
          {
           LEX *lex=Lex;
           lex->users_list.empty();
           lex->columns.empty();
           lex->grant= lex->grant_tot_col= 0;
           lex->all_privileges= 0;
           lex->first_select_lex()->db= null_clex_str;
           lex->account_options.reset();
         }
#line 28789 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 221: /* opt_aggregate: %empty  */
#line 3323 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.sp_aggregate_type)= NOT_AGGREGATE; }
#line 28795 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 222: /* opt_aggregate: AGGREGATE_SYM  */
#line 3324 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.sp_aggregate_type)= GROUP_AGGREGATE; }
#line 28801 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 223: /* sp_name: ident '.' ident  */
#line 3329 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.spname)= Lex->make_sp_name(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 28810 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 224: /* sp_name: ident  */
#line 3334 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.spname)= Lex->make_sp_name(thd, &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 28819 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 225: /* sp_a_chistics: %empty  */
#line 3341 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 28825 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 226: /* sp_a_chistics: sp_a_chistics sp_chistic  */
#line 3342 "/home/buildbot/git/sql/sql_yacc.yy"
                                   {}
#line 28831 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 227: /* sp_c_chistics: %empty  */
#line 3346 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 28837 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 228: /* sp_c_chistics: sp_c_chistics sp_c_chistic  */
#line 3347 "/home/buildbot/git/sql/sql_yacc.yy"
                                     {}
#line 28843 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 229: /* sp_chistic: COMMENT_SYM TEXT_STRING_sys  */
#line 3353 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sp_chistics.comment= (yyvsp[0].lex_str); }
#line 28849 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 230: /* sp_chistic: LANGUAGE_SYM SQL_SYM  */
#line 3355 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* Just parse it, we only have one language for now. */ }
#line 28855 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 231: /* sp_chistic: NO_SYM SQL_SYM  */
#line 3357 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sp_chistics.daccess= SP_NO_SQL; }
#line 28861 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 232: /* sp_chistic: CONTAINS_SYM SQL_SYM  */
#line 3359 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sp_chistics.daccess= SP_CONTAINS_SQL; }
#line 28867 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 233: /* sp_chistic: READS_SYM SQL_SYM DATA_SYM  */
#line 3361 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sp_chistics.daccess= SP_READS_SQL_DATA; }
#line 28873 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 234: /* sp_chistic: MODIFIES_SYM SQL_SYM DATA_SYM  */
#line 3363 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sp_chistics.daccess= SP_MODIFIES_SQL_DATA; }
#line 28879 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 235: /* sp_chistic: sp_suid  */
#line 3365 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sp_chistics.suid= (yyvsp[0].sp_suid); }
#line 28885 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 236: /* sp_c_chistic: sp_chistic  */
#line 3370 "/home/buildbot/git/sql/sql_yacc.yy"
                                { }
#line 28891 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 237: /* sp_c_chistic: opt_not DETERMINISTIC_SYM  */
#line 3371 "/home/buildbot/git/sql/sql_yacc.yy"
                                    { Lex->sp_chistics.detistic= ! (yyvsp[-1].num); }
#line 28897 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 238: /* sp_suid: SQL_SYM SECURITY_SYM DEFINER_SYM  */
#line 3375 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.sp_suid)= SP_IS_SUID; }
#line 28903 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 239: /* sp_suid: SQL_SYM SECURITY_SYM INVOKER_SYM  */
#line 3376 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.sp_suid)= SP_IS_NOT_SUID; }
#line 28909 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 240: /* $@30: %empty  */
#line 3381 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28918 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 241: /* call: CALL_SYM ident $@30 opt_sp_cparam_list  */
#line 3386 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 28927 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 242: /* $@31: %empty  */
#line 3391 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28936 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 243: /* call: CALL_SYM ident '.' ident $@31 opt_sp_cparam_list  */
#line 3396 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 28945 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 244: /* $@32: %empty  */
#line 3401 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys), (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28954 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 245: /* call: CALL_SYM ident '.' ident '.' ident $@32 opt_sp_cparam_list  */
#line 3406 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 28963 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 250: /* sp_cparams: sp_cparams ',' expr  */
#line 3425 "/home/buildbot/git/sql/sql_yacc.yy"
          {
           Lex->value_list.push_back((yyvsp[0].item), thd->mem_root);
          }
#line 28971 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 251: /* sp_cparams: expr  */
#line 3429 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->value_list.push_back((yyvsp[0].item), thd->mem_root);
          }
#line 28979 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 252: /* sp_fdparam_list: %empty  */
#line 3437 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->m_param_begin= YYLIP->get_cpp_tok_start();
            Lex->sphead->m_param_end= Lex->sphead->m_param_begin;
          }
#line 28988 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 253: /* $@33: %empty  */
#line 3442 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->m_param_begin= YYLIP->get_cpp_tok_start();
          }
#line 28996 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 254: /* sp_fdparam_list: $@33 sp_fdparams  */
#line 3446 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->m_param_end= YYLIP->get_cpp_tok_start();
          }
#line 29004 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 257: /* sp_param_name: ident  */
#line 3458 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.spvar)= Lex->sp_param_init(&(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 29013 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 258: /* sp_param_name_and_type: sp_param_name field_type  */
#line 3466 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_param_fill_definition((yyval.spvar)= (yyvsp[-1].spvar))))
              MYSQL_YYABORT;
          }
#line 29022 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 259: /* sp_param_name_and_type: sp_param_name TYPE_SYM OF_SYM ident '.' ident  */
#line 3471 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_type_reference(thd,
                                                                (yyval.spvar)= (yyvsp[-5].spvar), (yyvsp[-2].ident_sys),
                                                                (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29033 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 260: /* sp_param_name_and_type: sp_param_name TYPE_SYM OF_SYM ident '.' ident '.' ident  */
#line 3478 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_type_reference(thd, (yyval.spvar)= (yyvsp[-7].spvar),
                                                                (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys), (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29043 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 261: /* sp_param_name_and_type: sp_param_name ROW_SYM TYPE_SYM OF_SYM ident  */
#line 3484 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_table_rowtype_reference(thd, (yyval.spvar)= (yyvsp[-4].spvar), (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29052 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 262: /* sp_param_name_and_type: sp_param_name ROW_SYM TYPE_SYM OF_SYM ident '.' ident  */
#line 3489 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_table_rowtype_reference(thd, (yyval.spvar)= (yyvsp[-6].spvar), (yyvsp[-2].ident_sys), (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29061 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 263: /* sp_param_name_and_type: sp_param_name ROW_SYM row_type_body  */
#line 3494 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_row(thd, (yyval.spvar)= (yyvsp[-2].spvar), (yyvsp[0].spvar_definition_list))))
              MYSQL_YYABORT;
          }
#line 29070 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 268: /* sp_pdparam: sp_opt_inout sp_param_name_and_type  */
#line 3512 "/home/buildbot/git/sql/sql_yacc.yy"
                                              { (yyvsp[0].spvar)->mode=(yyvsp[-1].spvar_mode); }
#line 29076 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 269: /* sp_opt_inout: %empty  */
#line 3516 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_IN; }
#line 29082 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 270: /* sp_opt_inout: IN_SYM  */
#line 3517 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_IN; }
#line 29088 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 271: /* sp_opt_inout: OUT_SYM  */
#line 3518 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_OUT; }
#line 29094 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 272: /* sp_opt_inout: INOUT_SYM  */
#line 3519 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_INOUT; }
#line 29100 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 273: /* $@34: %empty  */
#line 3524 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->m_param_begin= YYLIP->get_cpp_tok_start() + 1;
          }
#line 29108 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 274: /* sp_parenthesized_pdparam_list: '(' $@34 sp_pdparam_list ')'  */
#line 3529 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->m_param_end= YYLIP->get_cpp_tok_start();
          }
#line 29116 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 275: /* sp_proc_stmts: %empty  */
#line 3535 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 29122 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 277: /* sp_proc_stmts1: sp_proc_stmt ';'  */
#line 3540 "/home/buildbot/git/sql/sql_yacc.yy"
                           {}
#line 29128 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 279: /* sp_decls: %empty  */
#line 3546 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spblock).init();
          }
#line 29136 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 280: /* sp_decls: sp_decls sp_decl ';'  */
#line 3550 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* We check for declarations out of (standard) order this way
              because letting the grammar rules reflect it caused tricky
               shift/reduce conflicts with the wrong result. (And we get
               better error handling this way.) */
            if (unlikely(Lex->sp_declarations_join(&(yyval.spblock), (yyvsp[-2].spblock), (yyvsp[-1].spblock))))
              MYSQL_YYABORT;
          }
#line 29149 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 281: /* sp_decl: DECLARE_MARIADB_SYM sp_decl_body  */
#line 3561 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.spblock)= (yyvsp[0].spblock); }
#line 29155 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 282: /* optionally_qualified_column_ident: sp_decl_ident  */
#line 3567 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.qualified_column_ident)= new (thd->mem_root)
                         Qualified_column_ident(&(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 29165 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 283: /* optionally_qualified_column_ident: sp_decl_ident '.' ident  */
#line 3573 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.qualified_column_ident)= new (thd->mem_root)
                           Qualified_column_ident(&(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 29175 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 284: /* optionally_qualified_column_ident: sp_decl_ident '.' ident '.' ident  */
#line 3579 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.qualified_column_ident)= new (thd->mem_root)
                           Qualified_column_ident(thd, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 29185 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 285: /* row_field_name: ident  */
#line 3588 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.spvar_definition)= Lex->row_field_name(thd, (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29194 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 287: /* row_field_definition_list: row_field_definition  */
#line 3600 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.spvar_definition_list)= Row_definition_list::make(thd->mem_root, (yyvsp[0].spvar_definition))))
              MYSQL_YYABORT;
          }
#line 29203 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 288: /* row_field_definition_list: row_field_definition_list ',' row_field_definition  */
#line 3605 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (((yyval.spvar_definition_list)= (yyvsp[-2].spvar_definition_list))->append_uniq(thd->mem_root, (yyvsp[0].spvar_definition)))
              MYSQL_YYABORT;
          }
#line 29212 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 289: /* row_type_body: '(' row_field_definition_list ')'  */
#line 3612 "/home/buildbot/git/sql/sql_yacc.yy"
                                            { (yyval.spvar_definition_list)= (yyvsp[-1].spvar_definition_list); }
#line 29218 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 290: /* sp_decl_idents_init_vars: sp_decl_idents  */
#line 3617 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_variable_declarations_init(thd, (yyvsp[0].num));
          }
#line 29226 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 291: /* sp_decl_variable_list: sp_decl_idents_init_vars field_type sp_opt_default  */
#line 3626 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_finalize(thd, (yyvsp[-2].num),
                                                                &Lex->last_field[0],
                                                                (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-2].num));
          }
#line 29238 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 292: /* sp_decl_variable_list: sp_decl_idents_init_vars TYPE_SYM OF_SYM optionally_qualified_column_ident sp_opt_default  */
#line 3636 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_with_ref_finalize(thd, (yyvsp[-4].num), (yyvsp[-1].qualified_column_ident), (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-4].num));
          }
#line 29248 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 293: /* sp_decl_variable_list: sp_decl_idents_init_vars ROW_SYM TYPE_SYM OF_SYM optionally_qualified_column_ident sp_opt_default  */
#line 3644 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_rowtype_finalize(thd, (yyvsp[-5].num), (yyvsp[-1].qualified_column_ident), (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-5].num));
          }
#line 29258 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 294: /* sp_decl_variable_list: sp_decl_idents_init_vars ROW_SYM row_type_body sp_opt_default  */
#line 3652 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_row_finalize(thd, (yyvsp[-3].num), (yyvsp[-1].spvar_definition_list), (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-3].num));
          }
#line 29268 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 296: /* sp_decl_body: sp_decl_ident CONDITION_SYM FOR_SYM sp_cond  */
#line 3662 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->spcont->declare_condition(thd, &(yyvsp[-3].ident_sys), (yyvsp[0].spcondvalue))))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).hndlrs= (yyval.spblock).curs= 0;
            (yyval.spblock).conds= 1;
          }
#line 29279 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 298: /* $@35: %empty  */
#line 3670 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_block_init(thd);
          }
#line 29287 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 299: /* sp_decl_body: sp_decl_ident CURSOR_SYM $@35 opt_parenthesized_cursor_formal_parameters FOR_SYM sp_cursor_stmt  */
#line 3675 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            sp_pcontext *param_ctx= Lex->spcont;
            if (unlikely(Lex->sp_block_finalize(thd)))
              MYSQL_YYABORT;
            if (unlikely(Lex->sp_declare_cursor(thd, &(yyvsp[-5].ident_sys), (yyvsp[0].sp_cursor_stmt), param_ctx, true)))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).conds= (yyval.spblock).hndlrs= 0;
            (yyval.spblock).curs= 1;
          }
#line 29301 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 300: /* $@36: %empty  */
#line 3688 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_handler_declaration_init(thd, (yyvsp[-2].num))))
              MYSQL_YYABORT;
          }
#line 29310 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 301: /* sp_decl_handler: sp_handler_type HANDLER_SYM FOR_SYM $@36 sp_hcond_list sp_proc_stmt  */
#line 3693 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_handler_declaration_finalize(thd, (yyvsp[-5].num))))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).conds= (yyval.spblock).curs= 0;
            (yyval.spblock).hndlrs= 1;
          }
#line 29321 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 304: /* sp_cursor_stmt_lex: %empty  */
#line 3708 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(thd->lex->sphead);
            if (unlikely(!((yyval.sp_cursor_stmt)= new (thd->mem_root)
                           sp_lex_cursor(thd, thd->lex))))
              MYSQL_YYABORT;
          }
#line 29332 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 305: /* $@37: %empty  */
#line 3718 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(thd->free_list == NULL);
            Lex->sphead->reset_lex(thd, (yyvsp[0].sp_cursor_stmt));
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29343 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 306: /* sp_cursor_stmt: sp_cursor_stmt_lex $@37 select  */
#line 3725 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex == (yyvsp[-2].sp_cursor_stmt));
            Lex->pop_select(); //main select
            if (unlikely((yyvsp[-2].sp_cursor_stmt)->stmt_finalize(thd)) ||
                unlikely((yyvsp[-2].sp_cursor_stmt)->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
            (yyval.sp_cursor_stmt)= (yyvsp[-2].sp_cursor_stmt);
          }
#line 29356 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 307: /* sp_handler_type: EXIT_MARIADB_SYM  */
#line 3736 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.num)= sp_handler::EXIT; }
#line 29362 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 308: /* sp_handler_type: CONTINUE_MARIADB_SYM  */
#line 3737 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.num)= sp_handler::CONTINUE; }
#line 29368 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 309: /* sp_handler_type: EXIT_ORACLE_SYM  */
#line 3738 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.num)= sp_handler::EXIT; }
#line 29374 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 310: /* sp_handler_type: CONTINUE_ORACLE_SYM  */
#line 3739 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.num)= sp_handler::CONTINUE; }
#line 29380 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 311: /* sp_hcond_list: sp_hcond_element  */
#line 3745 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)= 1; }
#line 29386 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 312: /* sp_hcond_list: sp_hcond_list ',' sp_hcond_element  */
#line 3747 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)+= 1; }
#line 29392 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 313: /* sp_hcond_element: sp_hcond  */
#line 3752 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *ctx= lex->spcont->parent_context();

            if (unlikely(ctx->check_duplicate_handler((yyvsp[0].spcondvalue))))
              my_yyabort_error((ER_SP_DUP_HANDLER, MYF(0)));

            sp_instr_hpush_jump *i= (sp_instr_hpush_jump *)sp->last_instruction();
            i->add_condition((yyvsp[0].spcondvalue));
          }
#line 29408 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 314: /* sp_cond: ulong_num  */
#line 3767 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* mysql errno */
            if (unlikely((yyvsp[0].ulong_num) == 0))
              my_yyabort_error((ER_WRONG_VALUE, MYF(0), "CONDITION", "0"));
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value((yyvsp[0].ulong_num));
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 29420 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 316: /* sqlstate: SQLSTATE_SYM opt_value TEXT_STRING_literal  */
#line 3779 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* SQLSTATE */

            /*
              An error is triggered:
                - if the specified string is not a valid SQLSTATE,
                - or if it represents the completion condition -- it is not
                  allowed to SIGNAL, or declare a handler for the completion
                  condition.
            */
            if (unlikely(!is_sqlstate_valid(&(yyvsp[0].lex_str)) ||
                         is_sqlstate_completion((yyvsp[0].lex_str).str)))
              my_yyabort_error((ER_SP_BAD_SQLSTATE, MYF(0), (yyvsp[0].lex_str).str));
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value((yyvsp[0].lex_str).str);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 29441 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 317: /* opt_value: %empty  */
#line 3798 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 29447 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 318: /* opt_value: VALUE_SYM  */
#line 3799 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 29453 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 319: /* sp_hcond: sp_cond  */
#line 3804 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spcondvalue)= (yyvsp[0].spcondvalue);
          }
#line 29461 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 320: /* sp_hcond: ident  */
#line 3808 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spcondvalue)= Lex->spcont->find_declared_or_predefined_condition(thd, &(yyvsp[0].ident_sys));
            if (unlikely((yyval.spcondvalue) == NULL))
              my_yyabort_error((ER_SP_COND_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 29471 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 321: /* sp_hcond: SQLWARNING_SYM  */
#line 3814 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::WARNING);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 29481 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 322: /* sp_hcond: not FOUND_SYM  */
#line 3820 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::NOT_FOUND);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 29491 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 323: /* sp_hcond: SQLEXCEPTION_SYM  */
#line 3826 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::EXCEPTION);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 29501 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 324: /* sp_hcond: OTHERS_ORACLE_SYM  */
#line 3832 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::EXCEPTION);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 29511 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 325: /* raise_stmt_oracle: RAISE_ORACLE_SYM opt_set_signal_information  */
#line 3842 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_resignal_statement(thd, NULL)))
              MYSQL_YYABORT;
          }
#line 29520 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 326: /* raise_stmt_oracle: RAISE_ORACLE_SYM signal_value opt_set_signal_information  */
#line 3847 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_signal_statement(thd, (yyvsp[-1].spcondvalue))))
              MYSQL_YYABORT;
          }
#line 29529 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 327: /* signal_stmt: SIGNAL_SYM signal_value opt_set_signal_information  */
#line 3855 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->add_signal_statement(thd, (yyvsp[-1].spcondvalue)))
              MYSQL_YYABORT;
          }
#line 29538 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 328: /* signal_value: ident  */
#line 3863 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_condition_value *cond;

            /* SIGNAL foo cannot be used outside of stored programs */
            if (unlikely(lex->spcont == NULL))
              my_yyabort_error((ER_SP_COND_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
            cond= lex->spcont->find_declared_or_predefined_condition(thd, &(yyvsp[0].ident_sys));
            if (unlikely(cond == NULL))
              my_yyabort_error((ER_SP_COND_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
            if (unlikely(cond->type != sp_condition_value::SQLSTATE))
              my_yyabort_error((ER_SIGNAL_BAD_CONDITION_TYPE, MYF(0)));
            (yyval.spcondvalue)= cond;
          }
#line 29557 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 329: /* signal_value: sqlstate  */
#line 3878 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.spcondvalue)= (yyvsp[0].spcondvalue); }
#line 29563 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 330: /* opt_signal_value: %empty  */
#line 3883 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.spcondvalue)= NULL; }
#line 29569 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 331: /* opt_signal_value: signal_value  */
#line 3885 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.spcondvalue)= (yyvsp[0].spcondvalue); }
#line 29575 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 332: /* opt_set_signal_information: %empty  */
#line 3890 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            thd->m_parser_state->m_yacc.m_set_signal_info.clear();
          }
#line 29583 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 334: /* signal_information_item_list: signal_condition_information_item_name '=' signal_allowed_expr  */
#line 3898 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Set_signal_information *info;
            info= &thd->m_parser_state->m_yacc.m_set_signal_info;
            int index= (int) (yyvsp[-2].diag_condition_item_name);
            info->clear();
            info->m_item[index]= (yyvsp[0].item);
          }
#line 29595 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 335: /* signal_information_item_list: signal_information_item_list ',' signal_condition_information_item_name '=' signal_allowed_expr  */
#line 3907 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Set_signal_information *info;
            info= &thd->m_parser_state->m_yacc.m_set_signal_info;
            int index= (int) (yyvsp[-2].diag_condition_item_name);
            if (unlikely(info->m_item[index] != NULL))
              my_yyabort_error((ER_DUP_SIGNAL_SET, MYF(0),
                                Diag_condition_item_names[index].str));
            info->m_item[index]= (yyvsp[0].item);
          }
#line 29609 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 336: /* signal_allowed_expr: literal  */
#line 3923 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.item)= (yyvsp[0].item); }
#line 29615 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 337: /* signal_allowed_expr: variable  */
#line 3925 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[0].item)->type() == Item::FUNC_ITEM)
            {
              Item_func *item= (Item_func*) (yyvsp[0].item);
              if (unlikely(item->functype() == Item_func::SUSERVAR_FUNC))
              {
                /*
                  Don't allow the following syntax:
                    SIGNAL/RESIGNAL ...
                    SET <signal condition item name> = @foo := expr
                */
                thd->parse_error();
                MYSQL_YYABORT;
              }
            }
            (yyval.item)= (yyvsp[0].item);
          }
#line 29637 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 338: /* signal_allowed_expr: simple_ident  */
#line 3943 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.item)= (yyvsp[0].item); }
#line 29643 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 339: /* signal_condition_information_item_name: CLASS_ORIGIN_SYM  */
#line 3949 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_CLASS_ORIGIN; }
#line 29649 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 340: /* signal_condition_information_item_name: SUBCLASS_ORIGIN_SYM  */
#line 3951 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_SUBCLASS_ORIGIN; }
#line 29655 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 341: /* signal_condition_information_item_name: CONSTRAINT_CATALOG_SYM  */
#line 3953 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_CONSTRAINT_CATALOG; }
#line 29661 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 342: /* signal_condition_information_item_name: CONSTRAINT_SCHEMA_SYM  */
#line 3955 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_CONSTRAINT_SCHEMA; }
#line 29667 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 343: /* signal_condition_information_item_name: CONSTRAINT_NAME_SYM  */
#line 3957 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_CONSTRAINT_NAME; }
#line 29673 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 344: /* signal_condition_information_item_name: CATALOG_NAME_SYM  */
#line 3959 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_CATALOG_NAME; }
#line 29679 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 345: /* signal_condition_information_item_name: SCHEMA_NAME_SYM  */
#line 3961 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_SCHEMA_NAME; }
#line 29685 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 346: /* signal_condition_information_item_name: TABLE_NAME_SYM  */
#line 3963 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_TABLE_NAME; }
#line 29691 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 347: /* signal_condition_information_item_name: COLUMN_NAME_SYM  */
#line 3965 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_COLUMN_NAME; }
#line 29697 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 348: /* signal_condition_information_item_name: CURSOR_NAME_SYM  */
#line 3967 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_CURSOR_NAME; }
#line 29703 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 349: /* signal_condition_information_item_name: MESSAGE_TEXT_SYM  */
#line 3969 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_MESSAGE_TEXT; }
#line 29709 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 350: /* signal_condition_information_item_name: MYSQL_ERRNO_SYM  */
#line 3971 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_MYSQL_ERRNO; }
#line 29715 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 351: /* resignal_stmt: RESIGNAL_SYM opt_signal_value opt_set_signal_information  */
#line 3976 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_resignal_statement(thd, (yyvsp[-1].spcondvalue))))
              MYSQL_YYABORT;
          }
#line 29724 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 352: /* get_diagnostics: GET_SYM which_area DIAGNOSTICS_SYM diagnostics_information  */
#line 3984 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Diagnostics_information *info= (yyvsp[0].diag_info);

            info->set_which_da((yyvsp[-2].diag_area));

            Lex->sql_command= SQLCOM_GET_DIAGNOSTICS;
            Lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_get_diagnostics(info);

            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 29740 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 353: /* which_area: %empty  */
#line 3999 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_area)= Diagnostics_information::CURRENT_AREA; }
#line 29746 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 354: /* which_area: CURRENT_SYM  */
#line 4001 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_area)= Diagnostics_information::CURRENT_AREA; }
#line 29752 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 355: /* diagnostics_information: statement_information  */
#line 4006 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.diag_info)= new (thd->mem_root) Statement_information((yyvsp[0].stmt_info_list));
            if (unlikely((yyval.diag_info) == NULL))
              MYSQL_YYABORT;
          }
#line 29762 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 356: /* diagnostics_information: CONDITION_SYM condition_number condition_information  */
#line 4012 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.diag_info)= new (thd->mem_root) Condition_information((yyvsp[-1].item), (yyvsp[0].cond_info_list));
            if (unlikely((yyval.diag_info) == NULL))
              MYSQL_YYABORT;
          }
#line 29772 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 357: /* statement_information: statement_information_item  */
#line 4021 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.stmt_info_list)= new (thd->mem_root) List<Statement_information_item>;
            if (unlikely((yyval.stmt_info_list) == NULL) ||
                unlikely((yyval.stmt_info_list)->push_back((yyvsp[0].stmt_info_item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 29783 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 358: /* statement_information: statement_information ',' statement_information_item  */
#line 4028 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[-2].stmt_info_list)->push_back((yyvsp[0].stmt_info_item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.stmt_info_list)= (yyvsp[-2].stmt_info_list);
          }
#line 29793 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 359: /* statement_information_item: simple_target_specification '=' statement_information_item_name  */
#line 4037 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.stmt_info_item)= new (thd->mem_root) Statement_information_item((yyvsp[0].stmt_info_item_name), (yyvsp[-2].item));
            if (unlikely((yyval.stmt_info_item) == NULL))
              MYSQL_YYABORT;
          }
#line 29803 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 360: /* simple_target_specification: ident_cli  */
#line 4046 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= thd->lex->create_item_for_sp_var(&(yyvsp[0].ident_cli), NULL))))
              MYSQL_YYABORT;
          }
#line 29812 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 361: /* simple_target_specification: '@' ident_or_text  */
#line 4051 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_get_user_var(thd, &(yyvsp[0].lex_str));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 29822 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 362: /* statement_information_item_name: NUMBER_MARIADB_SYM  */
#line 4060 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.stmt_info_item_name)= Statement_information_item::NUMBER; }
#line 29828 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 363: /* statement_information_item_name: NUMBER_ORACLE_SYM  */
#line 4062 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.stmt_info_item_name)= Statement_information_item::NUMBER; }
#line 29834 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 364: /* statement_information_item_name: ROW_COUNT_SYM  */
#line 4064 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.stmt_info_item_name)= Statement_information_item::ROW_COUNT; }
#line 29840 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 365: /* condition_number: signal_allowed_expr  */
#line 4073 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.item)= (yyvsp[0].item); }
#line 29846 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 366: /* condition_information: condition_information_item  */
#line 4078 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.cond_info_list)= new (thd->mem_root) List<Condition_information_item>;
            if (unlikely((yyval.cond_info_list) == NULL) ||
                unlikely((yyval.cond_info_list)->push_back((yyvsp[0].cond_info_item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 29857 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 367: /* condition_information: condition_information ',' condition_information_item  */
#line 4085 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[-2].cond_info_list)->push_back((yyvsp[0].cond_info_item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.cond_info_list)= (yyvsp[-2].cond_info_list);
          }
#line 29867 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 368: /* condition_information_item: simple_target_specification '=' condition_information_item_name  */
#line 4094 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.cond_info_item)= new (thd->mem_root) Condition_information_item((yyvsp[0].cond_info_item_name), (yyvsp[-2].item));
            if (unlikely((yyval.cond_info_item) == NULL))
              MYSQL_YYABORT;
          }
#line 29877 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 369: /* condition_information_item_name: CLASS_ORIGIN_SYM  */
#line 4103 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CLASS_ORIGIN; }
#line 29883 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 370: /* condition_information_item_name: SUBCLASS_ORIGIN_SYM  */
#line 4105 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::SUBCLASS_ORIGIN; }
#line 29889 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 371: /* condition_information_item_name: CONSTRAINT_CATALOG_SYM  */
#line 4107 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CONSTRAINT_CATALOG; }
#line 29895 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 372: /* condition_information_item_name: CONSTRAINT_SCHEMA_SYM  */
#line 4109 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CONSTRAINT_SCHEMA; }
#line 29901 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 373: /* condition_information_item_name: CONSTRAINT_NAME_SYM  */
#line 4111 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CONSTRAINT_NAME; }
#line 29907 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 374: /* condition_information_item_name: CATALOG_NAME_SYM  */
#line 4113 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CATALOG_NAME; }
#line 29913 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 375: /* condition_information_item_name: SCHEMA_NAME_SYM  */
#line 4115 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::SCHEMA_NAME; }
#line 29919 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 376: /* condition_information_item_name: TABLE_NAME_SYM  */
#line 4117 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::TABLE_NAME; }
#line 29925 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 377: /* condition_information_item_name: COLUMN_NAME_SYM  */
#line 4119 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::COLUMN_NAME; }
#line 29931 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 378: /* condition_information_item_name: CURSOR_NAME_SYM  */
#line 4121 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CURSOR_NAME; }
#line 29937 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 379: /* condition_information_item_name: MESSAGE_TEXT_SYM  */
#line 4123 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::MESSAGE_TEXT; }
#line 29943 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 380: /* condition_information_item_name: MYSQL_ERRNO_SYM  */
#line 4125 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::MYSQL_ERRNO; }
#line 29949 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 381: /* condition_information_item_name: RETURNED_SQLSTATE_SYM  */
#line 4127 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::RETURNED_SQLSTATE; }
#line 29955 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 383: /* sp_decl_ident: keyword_sp_decl  */
#line 4133 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_ident_cli(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 29964 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 384: /* sp_decl_idents: sp_decl_ident  */
#line 4141 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* NOTE: field definition is filled in sp_decl section. */

            LEX *lex= Lex;
            sp_pcontext *spc= lex->spcont;

            if (unlikely(spc->find_variable(&(yyvsp[0].ident_sys), TRUE)))
              my_yyabort_error((ER_SP_DUP_VAR, MYF(0), (yyvsp[0].ident_sys).str));
            spc->add_variable(thd, &(yyvsp[0].ident_sys));
            (yyval.num)= 1;
          }
#line 29980 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 385: /* sp_decl_idents: sp_decl_idents ',' ident  */
#line 4153 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* NOTE: field definition is filled in sp_decl section. */

            LEX *lex= Lex;
            sp_pcontext *spc= lex->spcont;

            if (unlikely(spc->find_variable(&(yyvsp[0].ident_sys), TRUE)))
              my_yyabort_error((ER_SP_DUP_VAR, MYF(0), (yyvsp[0].ident_sys).str));
            spc->add_variable(thd, &(yyvsp[0].ident_sys));
            (yyval.num)= (yyvsp[-2].num) + 1;
          }
#line 29996 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 386: /* sp_opt_default: %empty  */
#line 4167 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.item) = NULL; }
#line 30002 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 387: /* sp_opt_default: DEFAULT expr  */
#line 4168 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.item) = (yyvsp[0].item); }
#line 30008 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 407: /* $@38: %empty  */
#line 4210 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sphead->new_cont_backpatch(NULL);
          }
#line 30018 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 408: /* sp_proc_stmt_if: IF_SYM $@38 sp_if END IF_SYM  */
#line 4216 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sphead->do_cont_backpatch(); }
#line 30024 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 409: /* $@39: %empty  */
#line 4220 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            Lex_input_stream *lip= YYLIP;

            lex->sphead->reset_lex(thd);
            /*
              We should not push main select here, it will be done or not
              done by the statement, we just provide only a new LEX for the
              statement here as if it is start of parsing a new statement.
            */
            lex->sphead->m_tmp_query= lip->get_tok_start();
          }
#line 30041 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 410: /* sp_proc_stmt_statement: $@39 statement  */
#line 4233 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->sp_proc_stmt_statement_finalize(thd, yychar == YYEMPTY) ||
                Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 30051 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 413: /* $@40: %empty  */
#line 4248 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30061 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 414: /* sp_proc_stmt_return: RETURN_ALLMODES_SYM $@40 expr  */
#line 4254 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            Lex->pop_select(); //main select
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
            if (unlikely(sp->m_handler->add_instr_freturn(thd, sp, lex->spcont,
                                                          (yyvsp[0].item), lex)) ||
                unlikely(sp->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30077 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 415: /* sp_proc_stmt_return: RETURN_ORACLE_SYM  */
#line 4266 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            if (unlikely(sp->m_handler->add_instr_preturn(thd, sp,
                                                               lex->spcont)))
              MYSQL_YYABORT;
          }
#line 30089 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 416: /* $@41: %empty  */
#line 4276 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30099 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 417: /* reset_lex_expr: $@41 expr  */
#line 4282 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            (yyval.item)= (yyvsp[0].item);
          }
#line 30108 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 418: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM  */
#line 4290 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_exit_statement(thd, NULL)))
              MYSQL_YYABORT;
          }
#line 30117 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 419: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM label_ident  */
#line 4295 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_exit_statement(thd, &(yyvsp[0].ident_sys), NULL)))
              MYSQL_YYABORT;
          }
#line 30126 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 420: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM WHEN_SYM reset_lex_expr  */
#line 4300 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_exit_statement(thd, (yyvsp[0].item))) ||
                unlikely(Lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30136 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 421: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM label_ident WHEN_SYM reset_lex_expr  */
#line 4306 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_exit_statement(thd, &(yyvsp[-2].ident_sys), (yyvsp[0].item))) ||
                unlikely(Lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30146 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 422: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM  */
#line 4315 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_continue_statement(thd, NULL)))
              MYSQL_YYABORT;
          }
#line 30155 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 423: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM label_ident  */
#line 4320 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_continue_statement(thd, &(yyvsp[0].ident_sys), NULL)))
              MYSQL_YYABORT;
          }
#line 30164 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 424: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM WHEN_SYM reset_lex_expr  */
#line 4325 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_continue_statement(thd, (yyvsp[0].item))) ||
                unlikely(Lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30174 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 425: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM label_ident WHEN_SYM reset_lex_expr  */
#line 4331 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_continue_statement(thd, &(yyvsp[-2].ident_sys), (yyvsp[0].item))) ||
                unlikely(Lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30184 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 426: /* sp_proc_stmt_leave: LEAVE_SYM label_ident  */
#line 4341 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_leave_statement(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 30193 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 427: /* sp_proc_stmt_iterate: ITERATE_SYM label_ident  */
#line 4349 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_iterate_statement(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 30202 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 428: /* sp_proc_stmt_goto_oracle: GOTO_ORACLE_SYM label_ident  */
#line 4357 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_goto_statement(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 30211 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 429: /* assignment_source_lex: %empty  */
#line 4364 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->sphead);
            if (unlikely(!((yyval.assignment_lex)= new (thd->mem_root)
                           sp_assignment_lex(thd, thd->lex))))
              MYSQL_YYABORT;
          }
#line 30222 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 430: /* $@42: %empty  */
#line 4374 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(thd->free_list == NULL);
            Lex->sphead->reset_lex(thd, (yyvsp[0].assignment_lex));
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30233 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 431: /* assignment_source_expr: assignment_source_lex $@42 expr  */
#line 4381 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT((yyvsp[-2].assignment_lex) == thd->lex);
            (yyval.assignment_lex)= (yyvsp[-2].assignment_lex);
            (yyval.assignment_lex)->sp_lex_in_use= true;
            (yyval.assignment_lex)->set_item_and_free_list((yyvsp[0].item), thd->free_list);
            thd->free_list= NULL;
            Lex->pop_select(); //min select
            if ((yyval.assignment_lex)->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 30248 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 432: /* $@43: %empty  */
#line 4395 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd, (yyvsp[0].assignment_lex));
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
            Lex->current_select->parsing_place= FOR_LOOP_BOUND;
          }
#line 30259 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 433: /* for_loop_bound_expr: assignment_source_lex $@43 expr  */
#line 4402 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT((yyvsp[-2].assignment_lex) == thd->lex);
            (yyval.assignment_lex)= (yyvsp[-2].assignment_lex);
            (yyval.assignment_lex)->sp_lex_in_use= true;
            (yyval.assignment_lex)->set_item_and_free_list((yyvsp[0].item), NULL);
            Lex->pop_select(); //main select
            if (unlikely((yyval.assignment_lex)->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
            Lex->current_select->parsing_place= NO_MATTER;
          }
#line 30274 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 434: /* cursor_actual_parameters: assignment_source_expr  */
#line 4416 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.sp_assignment_lex_list)= new (thd->mem_root) List<sp_assignment_lex>)))
              MYSQL_YYABORT;
            (yyval.sp_assignment_lex_list)->push_back((yyvsp[0].assignment_lex), thd->mem_root);
          }
#line 30284 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 435: /* cursor_actual_parameters: cursor_actual_parameters ',' assignment_source_expr  */
#line 4422 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.sp_assignment_lex_list)= (yyvsp[-2].sp_assignment_lex_list);
            (yyval.sp_assignment_lex_list)->push_back((yyvsp[0].assignment_lex), thd->mem_root);
          }
#line 30293 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 436: /* opt_parenthesized_cursor_actual_parameters: %empty  */
#line 4429 "/home/buildbot/git/sql/sql_yacc.yy"
                                             { (yyval.sp_assignment_lex_list)= NULL; }
#line 30299 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 437: /* opt_parenthesized_cursor_actual_parameters: '(' cursor_actual_parameters ')'  */
#line 4430 "/home/buildbot/git/sql/sql_yacc.yy"
                                             { (yyval.sp_assignment_lex_list)= (yyvsp[-1].sp_assignment_lex_list); }
#line 30305 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 438: /* sp_proc_stmt_open: OPEN_SYM ident opt_parenthesized_cursor_actual_parameters  */
#line 4435 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_open_cursor(thd, &(yyvsp[-1].ident_sys), (yyvsp[0].sp_assignment_lex_list))))
              MYSQL_YYABORT;
          }
#line 30314 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 439: /* sp_proc_stmt_fetch_head: FETCH_SYM ident INTO  */
#line 4443 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_add_cfetch(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
          }
#line 30323 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 440: /* sp_proc_stmt_fetch_head: FETCH_SYM FROM ident INTO  */
#line 4448 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_add_cfetch(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
          }
#line 30332 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 441: /* sp_proc_stmt_fetch_head: FETCH_SYM NEXT_SYM FROM ident INTO  */
#line 4453 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_add_cfetch(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
          }
#line 30341 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 442: /* sp_proc_stmt_fetch: sp_proc_stmt_fetch_head sp_fetch_list  */
#line 4460 "/home/buildbot/git/sql/sql_yacc.yy"
                                               { }
#line 30347 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 443: /* sp_proc_stmt_fetch: FETCH_SYM GROUP_SYM NEXT_SYM ROW_SYM  */
#line 4462 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           if (unlikely(Lex->sp_add_agg_cfetch()))
             MYSQL_YYABORT;
         }
#line 30356 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 444: /* sp_proc_stmt_close: CLOSE_SYM ident  */
#line 4470 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            uint offset;
            sp_instr_cclose *i;

            if (unlikely(!lex->spcont->find_cursor(&(yyvsp[0].ident_sys), &offset, false)))
              my_yyabort_error((ER_SP_CURSOR_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
            i= new (thd->mem_root)
              sp_instr_cclose(sp->instructions(), lex->spcont,  offset);
            if (unlikely(i == NULL) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
          }
#line 30375 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 445: /* sp_fetch_list: ident  */
#line 4488 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *spc= lex->spcont;
            sp_variable *spv= likely(spc != NULL)
              ? spc->find_variable(&(yyvsp[0].ident_sys), false)
              : NULL;

            if (unlikely(!spv))
              my_yyabort_error((ER_SP_UNDECLARED_VAR, MYF(0), (yyvsp[0].ident_sys).str));

            /* An SP local variable */
            sp_instr_cfetch *i= (sp_instr_cfetch *)sp->last_instruction();
            i->add_to_varlist(spv);
          }
#line 30395 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 446: /* sp_fetch_list: sp_fetch_list ',' ident  */
#line 4504 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *spc= lex->spcont;
            sp_variable *spv= likely(spc != NULL)
              ? spc->find_variable(&(yyvsp[0].ident_sys), false)
              : NULL;

            if (unlikely(!spv))
              my_yyabort_error((ER_SP_UNDECLARED_VAR, MYF(0), (yyvsp[0].ident_sys).str));

            /* An SP local variable */
            sp_instr_cfetch *i= (sp_instr_cfetch *)sp->last_instruction();
            i->add_to_varlist(spv);
          }
#line 30415 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 447: /* $@44: %empty  */
#line 4522 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30425 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 448: /* $@45: %empty  */
#line 4528 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *ctx= lex->spcont;
            uint ip= sp->instructions();
            sp_instr_jump_if_not *i= new (thd->mem_root)
              sp_instr_jump_if_not(ip, ctx, (yyvsp[-1].item), lex);
            if (unlikely(i == NULL) ||
                unlikely(sp->push_backpatch(thd, i, ctx->push_label(thd, &empty_clex_str, 0))) ||
                unlikely(sp->add_cont_backpatch(i)) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (unlikely(sp->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30446 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 449: /* $@46: %empty  */
#line 4545 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            sp_head *sp= Lex->sphead;
            sp_pcontext *ctx= Lex->spcont;
            uint ip= sp->instructions();
            sp_instr_jump *i= new (thd->mem_root) sp_instr_jump(ip, ctx);
            if (unlikely(i == NULL) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
            sp->backpatch(ctx->pop_label());
            sp->push_backpatch(thd, i, ctx->push_label(thd, &empty_clex_str, 0));
          }
#line 30462 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 450: /* sp_if: $@44 expr THEN_SYM $@45 sp_proc_stmts1 $@46 sp_elseifs  */
#line 4557 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            lex->sphead->backpatch(lex->spcont->pop_label());
          }
#line 30472 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 454: /* $@47: %empty  */
#line 4572 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;

            /**
              An example of the CASE statement in use is
            <pre>
            CREATE PROCEDURE proc_19194_simple(i int)
            BEGIN
              DECLARE str CHAR(10);

              CASE i
                WHEN 1 THEN SET str="1";
                WHEN 2 THEN SET str="2";
                WHEN 3 THEN SET str="3";
                ELSE SET str="unknown";
              END CASE;

              SELECT str;
            END
            </pre>
              The actions are used to generate the following code:
            <pre>
            SHOW PROCEDURE CODE proc_19194_simple;
            Pos     Instruction
            0       set str@1 NULL
            1       set_case_expr (12) 0 i@0
            2       jump_if_not 5(12) (case_expr@0 = 1)
            3       set str@1 _latin1'1'
            4       jump 12
            5       jump_if_not 8(12) (case_expr@0 = 2)
            6       set str@1 _latin1'2'
            7       jump 12
            8       jump_if_not 11(12) (case_expr@0 = 3)
            9       set str@1 _latin1'3'
            10      jump 12
            11      set str@1 _latin1'unknown'
            12      stmt 0 "SELECT str"
            </pre>
            */

            Lex->sphead->new_cont_backpatch(NULL);

            /*
              BACKPATCH: Creating target label for the jump to after END CASE
              (instruction 12 in the example)
            */
            Lex->spcont->push_label(thd, &empty_clex_str, Lex->sphead->instructions());
          }
#line 30526 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 455: /* case_stmt_specification: CASE_SYM $@47 case_stmt_body else_clause_opt END CASE_SYM  */
#line 4625 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              BACKPATCH: Resolving forward jump from
              "case_stmt_action_then" to after END CASE
              (jump from instruction 4 to 12, 7 to 12 ... in the example)
            */
            Lex->sphead->backpatch(Lex->spcont->pop_label());

            if ((yyvsp[-3].num))
              Lex->spcont->pop_case_expr_id();

            Lex->sphead->do_cont_backpatch();
          }
#line 30544 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 456: /* $@48: %empty  */
#line 4641 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd); /* For expr $2 */
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30554 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 457: /* $@49: %empty  */
#line 4647 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->case_stmt_action_expr((yyvsp[0].item))))
              MYSQL_YYABORT;

            Lex->pop_select(); //main select
            if (Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 30567 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 458: /* case_stmt_body: $@48 expr $@49 simple_when_clause_list  */
#line 4656 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)= 1; }
#line 30573 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 459: /* case_stmt_body: searched_when_clause_list  */
#line 4658 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)= 0; }
#line 30579 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 464: /* $@50: %empty  */
#line 4673 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd); /* For expr $3 */
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30589 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 465: /* $@51: %empty  */
#line 4679 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* Simple case: <caseval> = <whenval> */

            LEX *lex= Lex;
            if (unlikely(lex->case_stmt_action_when((yyvsp[0].item), true)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            /* For expr $3 */
            if (unlikely(lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30605 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 466: /* simple_when_clause: WHEN_SYM $@50 expr $@51 THEN_SYM sp_proc_stmts1  */
#line 4692 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->case_stmt_action_then()))
              MYSQL_YYABORT;
          }
#line 30614 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 467: /* $@52: %empty  */
#line 4700 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd); /* For expr $3 */
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30624 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 468: /* $@53: %empty  */
#line 4706 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->case_stmt_action_when((yyvsp[0].item), false)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            /* For expr $3 */
            if (unlikely(lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30638 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 469: /* searched_when_clause: WHEN_SYM $@52 expr $@53 THEN_SYM sp_proc_stmts1  */
#line 4717 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->case_stmt_action_then()))
              MYSQL_YYABORT;
          }
#line 30647 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 470: /* else_clause_opt: %empty  */
#line 4725 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            uint ip= sp->instructions();
            sp_instr_error *i= new (thd->mem_root)
              sp_instr_error(ip, lex->spcont, ER_SP_CASE_NOT_FOUND);
            if (unlikely(i == NULL) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
          }
#line 30662 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 472: /* sp_label: label_ident ':'  */
#line 4739 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.lex_str)= (yyvsp[-1].ident_sys); }
#line 30668 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 473: /* sp_opt_label: %empty  */
#line 4743 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.lex_str)= null_clex_str; }
#line 30674 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 474: /* sp_opt_label: label_ident  */
#line 4744 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 30680 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 475: /* sp_block_label: sp_label  */
#line 4749 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->spcont->block_label_declare(&(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
            (yyval.lex_str)= (yyvsp[0].lex_str);
          }
#line 30690 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 476: /* $@54: %empty  */
#line 4759 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_block_init(thd, &(yyvsp[-1].lex_str));
          }
#line 30698 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 477: /* sp_labeled_block: sp_block_label BEGIN_MARIADB_SYM $@54 sp_decls sp_proc_stmts END sp_opt_label  */
#line 4766 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-3].spblock), &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 30707 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 478: /* $@55: %empty  */
#line 4774 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_block_init(thd);
          }
#line 30715 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 479: /* sp_unlabeled_block: BEGIN_MARIADB_SYM $@55 sp_decls sp_proc_stmts END  */
#line 4780 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-2].spblock))))
              MYSQL_YYABORT;
          }
#line 30724 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 480: /* $@56: %empty  */
#line 4788 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sp_block_init(thd);
          }
#line 30734 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 481: /* sp_unlabeled_block_not_atomic: BEGIN_MARIADB_SYM not ATOMIC_SYM $@56 sp_decls sp_proc_stmts END  */
#line 4796 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-2].spblock))))
              MYSQL_YYABORT;
          }
#line 30743 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 482: /* opt_sp_for_loop_direction: %empty  */
#line 4804 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.num)= 1; }
#line 30749 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 483: /* opt_sp_for_loop_direction: REVERSE_SYM  */
#line 4805 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.num)= -1; }
#line 30755 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 484: /* $@57: %empty  */
#line 4810 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30764 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 485: /* sp_for_loop_index_and_bounds: ident $@57 sp_for_loop_bounds  */
#line 4815 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (unlikely(Lex->sp_for_loop_declarations(thd, &(yyval.for_loop), &(yyvsp[-2].ident_sys), (yyvsp[0].for_loop_bounds))))
              MYSQL_YYABORT;
          }
#line 30774 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 486: /* sp_for_loop_bounds: IN_SYM opt_sp_for_loop_direction for_loop_bound_expr DOT_DOT_SYM for_loop_bound_expr  */
#line 4825 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.for_loop_bounds)= Lex_for_loop_bounds_intrange((yyvsp[-3].num), (yyvsp[-2].assignment_lex), (yyvsp[0].assignment_lex));
          }
#line 30782 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 487: /* sp_for_loop_bounds: IN_SYM opt_sp_for_loop_direction for_loop_bound_expr  */
#line 4829 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.for_loop_bounds).m_direction= (yyvsp[-1].num);
            (yyval.for_loop_bounds).m_index= (yyvsp[0].assignment_lex);
            (yyval.for_loop_bounds).m_target_bound= NULL;
            (yyval.for_loop_bounds).m_implicit_cursor= false;
          }
#line 30793 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 488: /* sp_for_loop_bounds: IN_SYM opt_sp_for_loop_direction '(' sp_cursor_stmt ')'  */
#line 4836 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_for_loop_implicit_cursor_statement(thd, &(yyval.for_loop_bounds),
                                                                    (yyvsp[-1].sp_cursor_stmt))))
              MYSQL_YYABORT;
          }
#line 30803 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 489: /* loop_body: sp_proc_stmts1 END LOOP_SYM  */
#line 4845 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            uint ip= lex->sphead->instructions();
            sp_label *lab= lex->spcont->last_label();  /* Jumping back */
            sp_instr_jump *i= new (thd->mem_root)
              sp_instr_jump(ip, lex->spcont, lab->ip);
            if (unlikely(i == NULL) ||
                unlikely(lex->sphead->add_instr(i)))
              MYSQL_YYABORT;
          }
#line 30818 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 490: /* $@58: %empty  */
#line 4859 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sp_while_loop_expression(thd, (yyvsp[-1].item))))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
            if (lex->main_select_push(true))
               MYSQL_YYABORT;
          }
#line 30833 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 491: /* while_body: expr DO_SYM $@58 sp_proc_stmts1 END WHILE_SYM  */
#line 4870 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_while_loop_finalize(thd)))
              MYSQL_YYABORT;
          }
#line 30842 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 492: /* $@59: %empty  */
#line 4878 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30852 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 493: /* repeat_body: sp_proc_stmts1 UNTIL_SYM $@59 expr END REPEAT_SYM  */
#line 4884 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            uint ip= lex->sphead->instructions();
            sp_label *lab= lex->spcont->last_label();  /* Jumping back */
            sp_instr_jump_if_not *i= new (thd->mem_root)
              sp_instr_jump_if_not(ip, lex->spcont, (yyvsp[-2].item), lab->ip, lex);
            if (unlikely(i == NULL) ||
                unlikely(lex->sphead->add_instr(i)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
            /* We can shortcut the cont_backpatch here */
            i->m_cont_dest= ip+1;
          }
#line 30872 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 494: /* pop_sp_loop_label: sp_opt_label  */
#line 4903 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_pop_loop_label(thd, &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 30881 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 495: /* $@60: %empty  */
#line 4911 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-1].lex_str))))
              MYSQL_YYABORT;
          }
#line 30890 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 496: /* sp_labeled_control: sp_label LOOP_SYM $@60 loop_body pop_sp_loop_label  */
#line 4916 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 30896 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 497: /* $@61: %empty  */
#line 4918 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-1].lex_str))))
              MYSQL_YYABORT;
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30908 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 498: /* sp_labeled_control: sp_label WHILE_SYM $@61 while_body pop_sp_loop_label  */
#line 4926 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 30914 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 499: /* $@62: %empty  */
#line 4928 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            // See "The FOR LOOP statement" comments in sql_lex.cc
            Lex->sp_block_init(thd); // The outer DECLARE..BEGIN..END block
          }
#line 30923 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 500: /* $@63: %empty  */
#line 4933 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-3].lex_str)))) // The inner WHILE block
              MYSQL_YYABORT;
            if (unlikely(Lex->sp_for_loop_condition_test(thd, (yyvsp[0].for_loop))))
              MYSQL_YYABORT;
          }
#line 30934 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 501: /* $@64: %empty  */
#line 4942 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_for_loop_finalize(thd, (yyvsp[-5].for_loop))))
              MYSQL_YYABORT;
          }
#line 30943 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 502: /* sp_labeled_control: sp_label FOR_SYM $@62 sp_for_loop_index_and_bounds $@63 DO_SYM sp_proc_stmts1 END FOR_SYM $@64 pop_sp_loop_label  */
#line 4947 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_for_loop_outer_block_finalize(thd, (yyvsp[-7].for_loop))))
              MYSQL_YYABORT;
          }
#line 30952 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 503: /* $@65: %empty  */
#line 4952 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-1].lex_str))))
              MYSQL_YYABORT;
          }
#line 30961 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 504: /* sp_labeled_control: sp_label REPEAT_SYM $@65 repeat_body pop_sp_loop_label  */
#line 4957 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 30967 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 505: /* $@66: %empty  */
#line 4962 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd)))
              MYSQL_YYABORT;
          }
#line 30976 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 506: /* sp_unlabeled_control: LOOP_SYM $@66 loop_body  */
#line 4967 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_pop_loop_empty_label(thd);
          }
#line 30984 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 507: /* $@67: %empty  */
#line 4971 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd)))
              MYSQL_YYABORT;
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30996 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 508: /* sp_unlabeled_control: WHILE_SYM $@67 while_body  */
#line 4979 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_pop_loop_empty_label(thd);
          }
#line 31004 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 509: /* $@68: %empty  */
#line 4983 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            // See "The FOR LOOP statement" comments in sql_lex.cc
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sp_block_init(thd); // The outer DECLARE..BEGIN..END block
          }
#line 31015 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 510: /* $@69: %empty  */
#line 4990 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd))) // The inner WHILE block
              MYSQL_YYABORT;
            if (unlikely(Lex->sp_for_loop_condition_test(thd, (yyvsp[0].for_loop))))
              MYSQL_YYABORT;
          }
#line 31026 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 511: /* sp_unlabeled_control: FOR_SYM $@68 sp_for_loop_index_and_bounds $@69 DO_SYM sp_proc_stmts1 END FOR_SYM  */
#line 4999 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_for_loop_finalize(thd, (yyvsp[-5].for_loop))))
              MYSQL_YYABORT;
            Lex->sp_pop_loop_empty_label(thd); // The inner WHILE block
            if (unlikely(Lex->sp_for_loop_outer_block_finalize(thd, (yyvsp[-5].for_loop))))
              MYSQL_YYABORT;
          }
#line 31038 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 512: /* $@70: %empty  */
#line 5007 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd)))
              MYSQL_YYABORT;
          }
#line 31047 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 513: /* sp_unlabeled_control: REPEAT_SYM $@70 repeat_body  */
#line 5012 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_pop_loop_empty_label(thd);
          }
#line 31055 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 514: /* trg_action_time: BEFORE_SYM  */
#line 5019 "/home/buildbot/git/sql/sql_yacc.yy"
            { Lex->trg_chistics.action_time= TRG_ACTION_BEFORE; }
#line 31061 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 515: /* trg_action_time: AFTER_SYM  */
#line 5021 "/home/buildbot/git/sql/sql_yacc.yy"
            { Lex->trg_chistics.action_time= TRG_ACTION_AFTER; }
#line 31067 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 516: /* trg_event: INSERT  */
#line 5026 "/home/buildbot/git/sql/sql_yacc.yy"
            { Lex->trg_chistics.event= TRG_EVENT_INSERT; }
#line 31073 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 517: /* trg_event: UPDATE_SYM  */
#line 5028 "/home/buildbot/git/sql/sql_yacc.yy"
            { Lex->trg_chistics.event= TRG_EVENT_UPDATE; }
#line 31079 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 518: /* trg_event: DELETE_SYM  */
#line 5030 "/home/buildbot/git/sql/sql_yacc.yy"
            { Lex->trg_chistics.event= TRG_EVENT_DELETE; }
#line 31085 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 522: /* opt_logfile_group_name: %empty  */
#line 5064 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31091 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 523: /* opt_logfile_group_name: USE_SYM LOGFILE_SYM GROUP_SYM ident  */
#line 5066 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->logfile_group_name= (yyvsp[0].ident_sys).str;
          }
#line 31100 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 524: /* alter_tablespace_info: tablespace_name ADD ts_datafile alter_tablespace_option_list  */
#line 5076 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            Lex->alter_tablespace_info->ts_alter_tablespace_type= ALTER_TABLESPACE_ADD_FILE; 
          }
#line 31108 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 525: /* alter_tablespace_info: tablespace_name DROP ts_datafile alter_tablespace_option_list  */
#line 5082 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            Lex->alter_tablespace_info->ts_alter_tablespace_type= ALTER_TABLESPACE_DROP_FILE; 
          }
#line 31116 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 530: /* $@71: %empty  */
#line 5105 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31122 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 577: /* ts_datafile: DATAFILE_SYM TEXT_STRING_sys  */
#line 5199 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->data_file_name= (yyvsp[0].lex_str).str;
          }
#line 31131 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 578: /* lg_undofile: UNDOFILE_SYM TEXT_STRING_sys  */
#line 5207 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->undo_file_name= (yyvsp[0].lex_str).str;
          }
#line 31140 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 579: /* lg_redofile: REDOFILE_SYM TEXT_STRING_sys  */
#line 5215 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->redo_file_name= (yyvsp[0].lex_str).str;
          }
#line 31149 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 580: /* tablespace_name: ident  */
#line 5223 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info= (new (thd->mem_root)
                                         st_alter_tablespace());
            if (unlikely(lex->alter_tablespace_info == NULL))
              MYSQL_YYABORT;
            lex->alter_tablespace_info->tablespace_name= (yyvsp[0].ident_sys).str;
            lex->sql_command= SQLCOM_ALTER_TABLESPACE;
          }
#line 31163 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 581: /* logfile_group_name: ident  */
#line 5236 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info= (new (thd->mem_root)
                                         st_alter_tablespace());
            if (unlikely(lex->alter_tablespace_info == NULL))
              MYSQL_YYABORT;
            lex->alter_tablespace_info->logfile_group_name= (yyvsp[0].ident_sys).str;
            lex->sql_command= SQLCOM_ALTER_TABLESPACE;
          }
#line 31177 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 582: /* ts_access_mode: READ_ONLY_SYM  */
#line 5249 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_access_mode= TS_READ_ONLY;
          }
#line 31186 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 583: /* ts_access_mode: READ_WRITE_SYM  */
#line 5254 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_access_mode= TS_READ_WRITE;
          }
#line 31195 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 584: /* ts_access_mode: NOT_SYM ACCESSIBLE_SYM  */
#line 5259 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_access_mode= TS_NOT_ACCESSIBLE;
          }
#line 31204 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 585: /* opt_ts_initial_size: INITIAL_SIZE_SYM opt_equal size_number  */
#line 5267 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->initial_size= (yyvsp[0].ulonglong_number);
          }
#line 31213 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 586: /* opt_ts_autoextend_size: AUTOEXTEND_SIZE_SYM opt_equal size_number  */
#line 5275 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->autoextend_size= (yyvsp[0].ulonglong_number);
          }
#line 31222 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 587: /* opt_ts_max_size: MAX_SIZE_SYM opt_equal size_number  */
#line 5283 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->max_size= (yyvsp[0].ulonglong_number);
          }
#line 31231 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 588: /* opt_ts_extent_size: EXTENT_SIZE_SYM opt_equal size_number  */
#line 5291 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->extent_size= (yyvsp[0].ulonglong_number);
          }
#line 31240 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 589: /* opt_ts_undo_buffer_size: UNDO_BUFFER_SIZE_SYM opt_equal size_number  */
#line 5299 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->undo_buffer_size= (yyvsp[0].ulonglong_number);
          }
#line 31249 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 590: /* opt_ts_redo_buffer_size: REDO_BUFFER_SIZE_SYM opt_equal size_number  */
#line 5307 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->redo_buffer_size= (yyvsp[0].ulonglong_number);
          }
#line 31258 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 591: /* opt_ts_nodegroup: NODEGROUP_SYM opt_equal real_ulong_num  */
#line 5315 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->alter_tablespace_info->nodegroup_id != UNDEF_NODEGROUP))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE,MYF(0),"NODEGROUP"));
            lex->alter_tablespace_info->nodegroup_id= (yyvsp[0].ulong_num);
          }
#line 31269 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 592: /* opt_ts_comment: COMMENT_SYM opt_equal TEXT_STRING_sys  */
#line 5325 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->alter_tablespace_info->ts_comment != NULL))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE,MYF(0),"COMMENT"));
            lex->alter_tablespace_info->ts_comment= (yyvsp[0].lex_str).str;
          }
#line 31280 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 593: /* opt_ts_engine: opt_storage ENGINE_SYM opt_equal storage_engines  */
#line 5335 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->alter_tablespace_info->storage_engine != NULL))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE, MYF(0),
                                "STORAGE ENGINE"));
            lex->alter_tablespace_info->storage_engine= (yyvsp[0].db_type);
          }
#line 31292 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 596: /* ts_wait: WAIT_SYM  */
#line 5351 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->wait_until_completed= TRUE;
          }
#line 31301 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 597: /* ts_wait: NO_WAIT_SYM  */
#line 5356 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!(lex->alter_tablespace_info->wait_until_completed)))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE,MYF(0),"NO_WAIT"));
            lex->alter_tablespace_info->wait_until_completed= FALSE;
          }
#line 31312 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 598: /* size_number: real_ulonglong_num  */
#line 5365 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.ulonglong_number)= (yyvsp[0].ulonglong_number);}
#line 31318 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 599: /* size_number: IDENT_sys  */
#line 5367 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[0].ident_sys).to_size_number(&(yyval.ulonglong_number)))
              MYSQL_YYABORT;
          }
#line 31327 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 600: /* $@72: %empty  */
#line 5379 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->create_info.option_list= NULL; }
#line 31333 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 601: /* create_body: create_field_list_parens $@72 opt_create_table_options opt_create_partitioning opt_create_select  */
#line 5380 "/home/buildbot/git/sql/sql_yacc.yy"
                                                                             {}
#line 31339 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 602: /* create_body: opt_create_table_options opt_create_partitioning opt_create_select  */
#line 5381 "/home/buildbot/git/sql/sql_yacc.yy"
                                                                             {}
#line 31345 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 603: /* create_body: create_like  */
#line 5383 "/home/buildbot/git/sql/sql_yacc.yy"
          {

            Lex->create_info.add(DDL_options_st::OPT_LIKE);
            TABLE_LIST *src_table= Lex->first_select_lex()->
              add_table_to_list(thd, (yyvsp[0].table), NULL, 0, TL_READ, MDL_SHARED_READ);
            if (unlikely(! src_table))
              MYSQL_YYABORT;
            /* CREATE TABLE ... LIKE is not allowed for views. */
            src_table->required_type= TABLE_TYPE_NORMAL;
          }
#line 31360 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 604: /* create_like: LIKE table_ident  */
#line 5396 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.table)= (yyvsp[0].table); }
#line 31366 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 605: /* create_like: LEFT_PAREN_LIKE LIKE table_ident ')'  */
#line 5397 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.table)= (yyvsp[-1].table); }
#line 31372 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 606: /* opt_create_select: %empty  */
#line 5401 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31378 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 607: /* opt_create_select: opt_duplicate opt_as create_select_query_expression opt_versioning_option  */
#line 5404 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 31387 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 608: /* create_select_query_expression: query_expression  */
#line 5412 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->parsed_insert_select((yyvsp[0].select_lex_unit)->first_select()))
              MYSQL_YYABORT;
          }
#line 31396 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 609: /* create_select_query_expression: LEFT_PAREN_WITH with_clause query_expression_no_with_clause ')'  */
#line 5417 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *first_select= (yyvsp[-1].select_lex_unit)->first_select();
            (yyvsp[-1].select_lex_unit)->set_with_clause((yyvsp[-2].with_clause));
            (yyvsp[-2].with_clause)->attach_to(first_select);
            if (Lex->parsed_insert_select(first_select))
              MYSQL_YYABORT;
          }
#line 31408 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 610: /* opt_create_partitioning: opt_partitioning  */
#line 5428 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Remove all tables used in PARTITION clause from the global table
              list. Partitioning with subqueries is not allowed anyway.
            */
            TABLE_LIST *last_non_sel_table= Lex->create_last_non_select_table;
            last_non_sel_table->next_global= 0;
            Lex->query_tables_last= &last_non_sel_table->next_global;
          }
#line 31422 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 611: /* opt_partitioning: %empty  */
#line 5464 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31428 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 613: /* $@73: %empty  */
#line 5470 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->part_info= new (thd->mem_root) partition_info();
            if (unlikely(!lex->part_info))
              MYSQL_YYABORT;
            if (lex->sql_command == SQLCOM_ALTER_TABLE)
            {
              lex->alter_info.partition_flags|= ALTER_PARTITION_INFO;
            }
          }
#line 31443 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 615: /* have_partitioning: %empty  */
#line 5485 "/home/buildbot/git/sql/sql_yacc.yy"
          {
#ifdef WITH_PARTITION_STORAGE_ENGINE
            LEX_CSTRING partition_name={STRING_WITH_LEN("partition")};
            if (unlikely(!plugin_is_ready(&partition_name, MYSQL_STORAGE_ENGINE_PLUGIN)))
              my_yyabort_error((ER_OPTION_PREVENTS_STATEMENT, MYF(0),
                                "--skip-partition"));
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), "partitioning",
                              "--with-plugin-partition"));
#endif
          }
#line 31459 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 616: /* $@74: %empty  */
#line 5500 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Lex->part_info))
            {
              thd->parse_error(ER_PARTITION_ENTRY_ERROR);
              MYSQL_YYABORT;
            }
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            /*
              We enter here when opening the frm file to translate
              partition info string into part_info data structure.
            */
          }
#line 31477 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 617: /* partition_entry: PARTITION_SYM $@74 partition  */
#line 5514 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 31485 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 618: /* $@75: %empty  */
#line 5521 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->safe_to_cache_query= 1; }
#line 31491 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 620: /* part_type_def: opt_linear KEY_SYM opt_key_algo '(' part_field_list ')'  */
#line 5527 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->list_of_part_fields= TRUE;
            part_info->column_list= FALSE;
            part_info->part_type= HASH_PARTITION;
          }
#line 31502 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 621: /* $@76: %empty  */
#line 5534 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->part_type= HASH_PARTITION; }
#line 31508 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 622: /* part_type_def: opt_linear HASH_SYM $@76 part_func  */
#line 5535 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 31514 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 623: /* part_type_def: RANGE_SYM part_func  */
#line 5537 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->part_type= RANGE_PARTITION; }
#line 31520 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 624: /* part_type_def: RANGE_SYM part_column_list  */
#line 5539 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->part_type= RANGE_PARTITION; }
#line 31526 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 625: /* $@77: %empty  */
#line 5541 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    Select->parsing_place= IN_PART_FUNC;
          }
#line 31534 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 626: /* part_type_def: LIST_SYM $@77 part_func  */
#line 5545 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
	    Lex->part_info->part_type= LIST_PARTITION; 
	    Select->parsing_place= NO_MATTER;
	  }
#line 31543 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 627: /* part_type_def: LIST_SYM part_column_list  */
#line 5550 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->part_type= LIST_PARTITION; }
#line 31549 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 628: /* $@78: %empty  */
#line 5552 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             if (unlikely(Lex->part_info->vers_init_info(thd)))
               MYSQL_YYABORT;
          }
#line 31558 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 630: /* opt_linear: %empty  */
#line 5560 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31564 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 631: /* opt_linear: LINEAR_SYM  */
#line 5562 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->linear_hash_ind= TRUE;}
#line 31570 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 632: /* opt_key_algo: %empty  */
#line 5567 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->key_algorithm= partition_info::KEY_ALGORITHM_NONE;}
#line 31576 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 633: /* opt_key_algo: ALGORITHM_SYM '=' real_ulong_num  */
#line 5569 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            switch ((yyvsp[0].ulong_num)) {
            case 1:
              Lex->part_info->key_algorithm= partition_info::KEY_ALGORITHM_51;
              break;
            case 2:
              Lex->part_info->key_algorithm= partition_info::KEY_ALGORITHM_55;
              break;
            default:
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 31594 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 634: /* part_field_list: %empty  */
#line 5585 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31600 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 635: /* part_field_list: part_field_item_list  */
#line 5586 "/home/buildbot/git/sql/sql_yacc.yy"
                               {}
#line 31606 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 636: /* part_field_item_list: part_field_item  */
#line 5590 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 31612 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 637: /* part_field_item_list: part_field_item_list ',' part_field_item  */
#line 5591 "/home/buildbot/git/sql/sql_yacc.yy"
                                                   {}
#line 31618 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 638: /* part_field_item: ident  */
#line 5596 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->num_columns++;
            if (unlikely(part_info->part_field_list.push_back((yyvsp[0].ident_sys).str,
                         thd->mem_root)))
              MYSQL_YYABORT;
            if (unlikely(part_info->num_columns > MAX_REF_PARTS))
              my_yyabort_error((ER_TOO_MANY_PARTITION_FUNC_FIELDS_ERROR, MYF(0),
                                "list of partition fields"));
          }
#line 31633 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 639: /* part_column_list: COLUMNS '(' part_field_list ')'  */
#line 5610 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->column_list= TRUE;
            part_info->list_of_part_fields= TRUE;
          }
#line 31643 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 640: /* part_func: '(' part_func_expr ')'  */
#line 5620 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->set_part_expr(thd, (yyvsp[-1].item), FALSE)))
              MYSQL_YYABORT;
            part_info->num_columns= 1;
            part_info->column_list= FALSE;
          }
#line 31655 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 641: /* sub_part_func: '(' part_func_expr ')'  */
#line 5631 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->part_info->set_part_expr(thd, (yyvsp[-1].item), TRUE)))
              MYSQL_YYABORT;
          }
#line 31664 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 642: /* opt_num_parts: %empty  */
#line 5639 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31670 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 643: /* opt_num_parts: PARTITIONS_SYM real_ulong_num  */
#line 5641 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            uint num_parts= (yyvsp[0].ulong_num);
            partition_info *part_info= Lex->part_info;
            if (unlikely(num_parts == 0))
              my_yyabort_error((ER_NO_PARTS_ERROR, MYF(0), "partitions"));

            part_info->num_parts= num_parts;
            part_info->use_default_num_partitions= FALSE;
          }
#line 31684 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 644: /* opt_sub_part: %empty  */
#line 5653 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31690 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 645: /* $@79: %empty  */
#line 5655 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->subpart_type= HASH_PARTITION; }
#line 31696 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 646: /* opt_sub_part: SUBPARTITION_SYM BY opt_linear HASH_SYM sub_part_func $@79 opt_num_subparts  */
#line 5656 "/home/buildbot/git/sql/sql_yacc.yy"
                           {}
#line 31702 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 647: /* $@80: %empty  */
#line 5659 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->subpart_type= HASH_PARTITION;
            part_info->list_of_subpart_fields= TRUE;
          }
#line 31712 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 648: /* opt_sub_part: SUBPARTITION_SYM BY opt_linear KEY_SYM opt_key_algo '(' sub_part_field_list ')' $@80 opt_num_subparts  */
#line 5664 "/home/buildbot/git/sql/sql_yacc.yy"
                           {}
#line 31718 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 649: /* sub_part_field_list: sub_part_field_item  */
#line 5668 "/home/buildbot/git/sql/sql_yacc.yy"
                              {}
#line 31724 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 650: /* sub_part_field_list: sub_part_field_list ',' sub_part_field_item  */
#line 5669 "/home/buildbot/git/sql/sql_yacc.yy"
                                                      {}
#line 31730 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 651: /* sub_part_field_item: ident  */
#line 5674 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->subpart_field_list.push_back((yyvsp[0].ident_sys).str,
                         thd->mem_root)))
              MYSQL_YYABORT;

            if (unlikely(part_info->subpart_field_list.elements > MAX_REF_PARTS))
              my_yyabort_error((ER_TOO_MANY_PARTITION_FUNC_FIELDS_ERROR, MYF(0),
                                "list of subpartition fields"));
          }
#line 31745 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 652: /* part_func_expr: bit_expr  */
#line 5688 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Lex->safe_to_cache_query))
            {
              thd->parse_error(ER_WRONG_EXPR_IN_PARTITION_FUNC_ERROR);
              MYSQL_YYABORT;
            }
            (yyval.item)=(yyvsp[0].item);
          }
#line 31758 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 653: /* opt_num_subparts: %empty  */
#line 5699 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31764 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 654: /* opt_num_subparts: SUBPARTITIONS_SYM real_ulong_num  */
#line 5701 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            uint num_parts= (yyvsp[0].ulong_num);
            LEX *lex= Lex;
            if (unlikely(num_parts == 0))
              my_yyabort_error((ER_NO_PARTS_ERROR, MYF(0), "subpartitions"));
            lex->part_info->num_subparts= num_parts;
            lex->part_info->use_default_num_subpartitions= FALSE;
          }
#line 31777 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 655: /* part_defs: %empty  */
#line 5713 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->part_type == RANGE_PARTITION))
              my_yyabort_error((ER_PARTITIONS_MUST_BE_DEFINED_ERROR, MYF(0),
                                "RANGE"));
            if (unlikely(part_info->part_type == LIST_PARTITION))
              my_yyabort_error((ER_PARTITIONS_MUST_BE_DEFINED_ERROR, MYF(0),
                                "LIST"));
          }
#line 31791 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 656: /* part_defs: '(' part_def_list ')'  */
#line 5723 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            uint count_curr_parts= part_info->partitions.elements;
            if (part_info->num_parts != 0)
            {
              if (unlikely(part_info->num_parts !=
                           count_curr_parts))
              {
                thd->parse_error(ER_PARTITION_WRONG_NO_PART_ERROR);
                MYSQL_YYABORT;
              }
            }
            else if (count_curr_parts > 0)
            {
              part_info->num_parts= count_curr_parts;
            }
            part_info->count_curr_subparts= 0;
          }
#line 31814 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 657: /* part_def_list: part_definition  */
#line 5744 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 31820 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 658: /* part_def_list: part_def_list ',' part_definition  */
#line 5745 "/home/buildbot/git/sql/sql_yacc.yy"
                                            {}
#line 31826 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 659: /* $@81: %empty  */
#line 5750 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            partition_element *p_elem= new (thd->mem_root) partition_element();

            if (unlikely(!p_elem) ||
                unlikely(part_info->partitions.push_back(p_elem, thd->mem_root)))
              MYSQL_YYABORT;

            p_elem->part_state= PART_NORMAL;
            p_elem->id= part_info->partitions.elements - 1;
            part_info->curr_part_elem= p_elem;
            part_info->current_partition= p_elem;
            part_info->use_default_partitions= FALSE;
            part_info->use_default_num_partitions= FALSE;
          }
#line 31846 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 660: /* part_definition: PARTITION_SYM $@81 part_name opt_part_values opt_part_options opt_sub_partition  */
#line 5769 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 31852 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 661: /* part_name: ident  */
#line 5774 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            partition_element *p_elem= part_info->curr_part_elem;
            if (unlikely(check_ident_length(&(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
            p_elem->partition_name= (yyvsp[0].ident_sys).str;
          }
#line 31864 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 662: /* opt_part_values: %empty  */
#line 5785 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->error_if_requires_values()))
                MYSQL_YYABORT;
              if (unlikely(part_info->part_type == VERSIONING_PARTITION))
                my_yyabort_error((ER_VERS_WRONG_PARTS, MYF(0),
                                  lex->create_last_non_select_table->
                                  table_name.str));
            }
            else
              part_info->part_type= HASH_PARTITION;
          }
#line 31884 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 663: /* $@82: %empty  */
#line 5801 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->part_type != RANGE_PARTITION))
                my_yyabort_error((ER_PARTITION_WRONG_VALUES_ERROR, MYF(0),
                                  "RANGE", "LESS THAN"));
            }
            else
              part_info->part_type= RANGE_PARTITION;
          }
#line 31901 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 664: /* opt_part_values: VALUES_LESS_SYM THAN_SYM $@82 part_func_max  */
#line 5813 "/home/buildbot/git/sql/sql_yacc.yy"
                        {}
#line 31907 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 665: /* $@83: %empty  */
#line 5815 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->part_type != LIST_PARTITION))
                my_yyabort_error((ER_PARTITION_WRONG_VALUES_ERROR, MYF(0),
                                  "LIST", "IN"));
            }
            else
              part_info->part_type= LIST_PARTITION;
          }
#line 31924 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 666: /* opt_part_values: VALUES_IN_SYM $@83 part_values_in  */
#line 5827 "/home/buildbot/git/sql/sql_yacc.yy"
                         {}
#line 31930 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 667: /* opt_part_values: CURRENT_SYM  */
#line 5829 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->part_values_current(thd))
              MYSQL_YYABORT;
          }
#line 31939 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 668: /* opt_part_values: HISTORY_SYM  */
#line 5834 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->part_values_history(thd))
              MYSQL_YYABORT;
          }
#line 31948 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 669: /* opt_part_values: DEFAULT  */
#line 5839 "/home/buildbot/git/sql/sql_yacc.yy"
         {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->part_type != LIST_PARTITION))
                my_yyabort_error((ER_PARTITION_WRONG_VALUES_ERROR, MYF(0),
                                  "LIST", "DEFAULT"));
            }
            else
              part_info->part_type= LIST_PARTITION;
            if (unlikely(part_info->init_column_part(thd)))
              MYSQL_YYABORT;
            if (unlikely(part_info->add_max_value(thd)))
              MYSQL_YYABORT;
         }
#line 31969 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 670: /* part_func_max: MAXVALUE_SYM  */
#line 5859 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;

            if (unlikely(part_info->num_columns &&
                         part_info->num_columns != 1U))
            {
              part_info->print_debug("Kilroy II", NULL);
              thd->parse_error(ER_PARTITION_COLUMN_LIST_ERROR);
              MYSQL_YYABORT;
            }
            else
              part_info->num_columns= 1U;
            if (unlikely(part_info->init_column_part(thd)))
              MYSQL_YYABORT;
            if (unlikely(part_info->add_max_value(thd)))
              MYSQL_YYABORT;
          }
#line 31991 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 671: /* part_func_max: part_value_item  */
#line 5876 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 31997 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 672: /* part_values_in: part_value_item  */
#line 5881 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            part_info->print_debug("part_values_in: part_value_item", NULL);

            if (part_info->num_columns != 1U)
            {
              if (unlikely(!lex->is_partition_management() ||
                           part_info->num_columns == 0 ||
                           part_info->num_columns > MAX_REF_PARTS))
              {
                part_info->print_debug("Kilroy III", NULL);
                thd->parse_error(ER_PARTITION_COLUMN_LIST_ERROR);
                MYSQL_YYABORT;
              }
              /*
                Reorganize the current large array into a list of small
                arrays with one entry in each array. This can happen
                in the first partition of an ALTER TABLE statement where
                we ADD or REORGANIZE partitions. Also can only happen
                for LIST partitions.
              */
              if (unlikely(part_info->reorganize_into_single_field_col_val(thd)))
                MYSQL_YYABORT;
            }
          }
#line 32028 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 673: /* part_values_in: '(' part_value_list ')'  */
#line 5908 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->num_columns < 2U))
            {
              thd->parse_error(ER_ROW_SINGLE_PARTITION_FIELD_ERROR);
              MYSQL_YYABORT;
            }
          }
#line 32041 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 674: /* part_value_list: part_value_item  */
#line 5919 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 32047 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 675: /* part_value_list: part_value_list ',' part_value_item  */
#line 5920 "/home/buildbot/git/sql/sql_yacc.yy"
                                              {}
#line 32053 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 676: /* $@84: %empty  */
#line 5925 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->print_debug("( part_value_item", NULL);
            /* Initialisation code needed for each list of value expressions */
            if (unlikely(!(part_info->part_type == LIST_PARTITION &&
                           part_info->num_columns == 1U) &&
                           part_info->init_column_part(thd)))
              MYSQL_YYABORT;
          }
#line 32067 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 677: /* $@85: %empty  */
#line 5934 "/home/buildbot/git/sql/sql_yacc.yy"
                               {}
#line 32073 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 678: /* part_value_item: '(' $@84 part_value_item_list $@85 ')'  */
#line 5936 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->print_debug(") part_value_item", NULL);
            if (part_info->num_columns == 0)
              part_info->num_columns= part_info->curr_list_object;
            if (unlikely(part_info->num_columns != part_info->curr_list_object))
            {
              /*
                All value items lists must be of equal length, in some cases
                which is covered by the above if-statement we don't know yet
                how many columns is in the partition so the assignment above
                ensures that we only report errors when we know we have an
                error.
              */
              part_info->print_debug("Kilroy I", NULL);
              thd->parse_error(ER_PARTITION_COLUMN_LIST_ERROR);
              MYSQL_YYABORT;
            }
            part_info->curr_list_object= 0;
          }
#line 32098 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 679: /* part_value_item_list: part_value_expr_item  */
#line 5959 "/home/buildbot/git/sql/sql_yacc.yy"
                               {}
#line 32104 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 680: /* part_value_item_list: part_value_item_list ',' part_value_expr_item  */
#line 5960 "/home/buildbot/git/sql/sql_yacc.yy"
                                                        {}
#line 32110 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 681: /* part_value_expr_item: MAXVALUE_SYM  */
#line 5965 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->part_type == LIST_PARTITION))
            {
              thd->parse_error(ER_MAXVALUE_IN_VALUES_IN);
              MYSQL_YYABORT;
            }
            if (unlikely(part_info->add_max_value(thd)))
              MYSQL_YYABORT;
          }
#line 32125 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 682: /* part_value_expr_item: bit_expr  */
#line 5976 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            Item *part_expr= (yyvsp[0].item);

            if (unlikely(!lex->safe_to_cache_query))
            {
              thd->parse_error(ER_WRONG_EXPR_IN_PARTITION_FUNC_ERROR);
              MYSQL_YYABORT;
            }
            if (unlikely(part_info->add_column_list_value(thd, part_expr)))
              MYSQL_YYABORT;
          }
#line 32143 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 683: /* opt_sub_partition: %empty  */
#line 5994 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->num_subparts != 0 &&
                         !part_info->use_default_subpartitions))
            {
              /*
                We come here when we have defined subpartitions on the first
                partition but not on all the subsequent partitions. 
              */
              thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
              MYSQL_YYABORT;
            }
          }
#line 32161 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 684: /* opt_sub_partition: '(' sub_part_list ')'  */
#line 6008 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (part_info->num_subparts != 0)
            {
              if (unlikely(part_info->num_subparts !=
                           part_info->count_curr_subparts))
              {
                thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
                MYSQL_YYABORT;
              }
            }
            else if (part_info->count_curr_subparts > 0)
            {
              if (unlikely(part_info->partitions.elements > 1))
              {
                thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
                MYSQL_YYABORT;
              }
              part_info->num_subparts= part_info->count_curr_subparts;
            }
            part_info->count_curr_subparts= 0;
          }
#line 32188 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 685: /* sub_part_list: sub_part_definition  */
#line 6033 "/home/buildbot/git/sql/sql_yacc.yy"
                              {}
#line 32194 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 686: /* sub_part_list: sub_part_list ',' sub_part_definition  */
#line 6034 "/home/buildbot/git/sql/sql_yacc.yy"
                                                {}
#line 32200 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 687: /* $@86: %empty  */
#line 6039 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            partition_element *curr_part= part_info->current_partition;
            partition_element *sub_p_elem= new (thd->mem_root)
                                           partition_element(curr_part);
            if (unlikely(part_info->use_default_subpartitions &&
                         part_info->partitions.elements >= 2))
            {
              /*
                create table t1 (a int)
                partition by list (a) subpartition by hash (a)
                (partition p0 values in (1),
                 partition p1 values in (2) subpartition sp11);
                causes use to arrive since we are on the second
                partition, but still use_default_subpartitions
                is set. When we come here we're processing at least
                the second partition (the current partition processed
                have already been put into the partitions list.
              */
              thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
              MYSQL_YYABORT;
            }
            if (unlikely(!sub_p_elem) ||
                unlikely(curr_part->subpartitions.push_back(sub_p_elem, thd->mem_root)))
              MYSQL_YYABORT;

            sub_p_elem->id= curr_part->subpartitions.elements - 1;
            part_info->curr_part_elem= sub_p_elem;
            part_info->use_default_subpartitions= FALSE;
            part_info->use_default_num_subpartitions= FALSE;
            part_info->count_curr_subparts++;
          }
#line 32237 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 688: /* sub_part_definition: SUBPARTITION_SYM $@86 sub_name opt_part_options  */
#line 6071 "/home/buildbot/git/sql/sql_yacc.yy"
                                    {}
#line 32243 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 689: /* sub_name: ident_or_text  */
#line 6076 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(check_ident_length(&(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
            Lex->part_info->curr_part_elem->partition_name= (yyvsp[0].lex_str).str;
          }
#line 32253 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 690: /* opt_part_options: %empty  */
#line 6084 "/home/buildbot/git/sql/sql_yacc.yy"
                     {}
#line 32259 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 691: /* opt_part_options: opt_part_option_list  */
#line 6085 "/home/buildbot/git/sql/sql_yacc.yy"
                              {}
#line 32265 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 692: /* opt_part_option_list: opt_part_option_list opt_part_option  */
#line 6089 "/home/buildbot/git/sql/sql_yacc.yy"
                                              {}
#line 32271 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 693: /* opt_part_option_list: opt_part_option  */
#line 6090 "/home/buildbot/git/sql/sql_yacc.yy"
                         {}
#line 32277 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 694: /* opt_part_option: TABLESPACE opt_equal ident_or_text  */
#line 6095 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->tablespace_name= (yyvsp[0].lex_str).str; }
#line 32283 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 695: /* opt_part_option: opt_storage ENGINE_SYM opt_equal storage_engines  */
#line 6097 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->curr_part_elem->engine_type= (yyvsp[0].db_type);
            part_info->default_engine_type= (yyvsp[0].db_type);
          }
#line 32293 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 696: /* opt_part_option: CONNECTION_SYM opt_equal TEXT_STRING_sys  */
#line 6103 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->part_info->curr_part_elem->connect_string.str= (yyvsp[0].lex_str).str;
            lex->part_info->curr_part_elem->connect_string.length= (yyvsp[0].lex_str).length;
          }
#line 32303 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 697: /* opt_part_option: NODEGROUP_SYM opt_equal real_ulong_num  */
#line 6109 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->nodegroup_id= (uint16) (yyvsp[0].ulong_num); }
#line 32309 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 698: /* opt_part_option: MAX_ROWS opt_equal real_ulonglong_num  */
#line 6111 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->part_max_rows= (ha_rows) (yyvsp[0].ulonglong_number); }
#line 32315 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 699: /* opt_part_option: MIN_ROWS opt_equal real_ulonglong_num  */
#line 6113 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->part_min_rows= (ha_rows) (yyvsp[0].ulonglong_number); }
#line 32321 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 700: /* opt_part_option: DATA_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6115 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->data_file_name= (yyvsp[0].lex_str).str; }
#line 32327 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 701: /* opt_part_option: INDEX_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6117 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->index_file_name= (yyvsp[0].lex_str).str; }
#line 32333 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 702: /* opt_part_option: COMMENT_SYM opt_equal TEXT_STRING_sys  */
#line 6119 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->part_comment= (yyvsp[0].lex_str).str; }
#line 32339 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 703: /* opt_versioning_rotation: %empty  */
#line 6123 "/home/buildbot/git/sql/sql_yacc.yy"
                     {}
#line 32345 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 704: /* $@87: %empty  */
#line 6124 "/home/buildbot/git/sql/sql_yacc.yy"
         { Lex->clause_that_disallows_subselect= "INTERVAL"; }
#line 32351 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 705: /* opt_versioning_rotation: $@87 INTERVAL_SYM expr interval opt_versioning_interval_start  */
#line 6126 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           partition_info *part_info= Lex->part_info;
           if (unlikely(part_info->vers_set_interval(thd, (yyvsp[-2].item), (yyvsp[-1].interval), (yyvsp[0].ulong_num))))
             MYSQL_YYABORT;
         }
#line 32361 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 706: /* opt_versioning_rotation: LIMIT ulonglong_num  */
#line 6132 "/home/buildbot/git/sql/sql_yacc.yy"
       {
         partition_info *part_info= Lex->part_info;
         if (unlikely(part_info->vers_set_limit((yyvsp[0].ulonglong_number))))
         {
           my_error(ER_PART_WRONG_VALUE, MYF(0),
                    Lex->create_last_non_select_table->table_name.str,
                    "LIMIT");
           MYSQL_YYABORT;
         }
       }
#line 32376 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 707: /* opt_versioning_interval_start: %empty  */
#line 6147 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           (yyval.ulong_num)= thd->query_start();
         }
#line 32384 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 708: /* opt_versioning_interval_start: STARTS_SYM ulong_num  */
#line 6151 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           /* only allowed from mysql_unpack_partition() */
           if (unlikely(!Lex->part_info->table))
           {
             thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-1].kwd).pos());
             MYSQL_YYABORT;
           }
           (yyval.ulong_num)= (ulong)(yyvsp[0].ulong_num);
         }
#line 32398 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 709: /* opt_as: %empty  */
#line 6167 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 32404 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 710: /* opt_as: AS  */
#line 6168 "/home/buildbot/git/sql/sql_yacc.yy"
             {}
#line 32410 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 711: /* opt_create_database_options: %empty  */
#line 6172 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 32416 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 712: /* opt_create_database_options: create_database_options  */
#line 6173 "/home/buildbot/git/sql/sql_yacc.yy"
                                  {}
#line 32422 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 713: /* create_database_options: create_database_option  */
#line 6177 "/home/buildbot/git/sql/sql_yacc.yy"
                                 {}
#line 32428 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 714: /* create_database_options: create_database_options create_database_option  */
#line 6178 "/home/buildbot/git/sql/sql_yacc.yy"
                                                         {}
#line 32434 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 715: /* create_database_option: default_collation  */
#line 6182 "/home/buildbot/git/sql/sql_yacc.yy"
                            {}
#line 32440 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 716: /* create_database_option: default_charset  */
#line 6183 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 32446 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 717: /* opt_if_not_exists_table_element: %empty  */
#line 6188 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->check_exists= FALSE;
          }
#line 32454 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 718: /* opt_if_not_exists_table_element: IF_SYM not EXISTS  */
#line 6192 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->check_exists= TRUE;
          }
#line 32462 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 719: /* opt_if_not_exists: %empty  */
#line 6199 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.object_ddl_options).init();
          }
#line 32470 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 720: /* opt_if_not_exists: IF_SYM not EXISTS  */
#line 6203 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.object_ddl_options).set(DDL_options_st::OPT_IF_NOT_EXISTS);
          }
#line 32478 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 721: /* create_or_replace: CREATE  */
#line 6210 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.object_ddl_options).init();
          }
#line 32486 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 722: /* create_or_replace: CREATE OR_SYM REPLACE  */
#line 6214 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.object_ddl_options).set(DDL_options_st::OPT_OR_REPLACE);
          }
#line 32494 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 730: /* create_table_option: ENGINE_SYM opt_equal ident_or_text  */
#line 6237 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (!lex->m_sql_cmd)
            {
              DBUG_ASSERT(lex->sql_command == SQLCOM_ALTER_TABLE);
              if (!(lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_alter_table()))
                MYSQL_YYABORT;
            }
            Storage_engine_name *opt=
              lex->m_sql_cmd->option_storage_engine_name();
            DBUG_ASSERT(opt); // Expect a proper Sql_cmd
            *opt= Storage_engine_name((yyvsp[0].lex_str));
            lex->create_info.used_fields|= HA_CREATE_USED_ENGINE;
          }
#line 32513 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 731: /* create_table_option: MAX_ROWS opt_equal ulonglong_num  */
#line 6252 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.max_rows= (yyvsp[0].ulonglong_number);
            Lex->create_info.used_fields|= HA_CREATE_USED_MAX_ROWS;
          }
#line 32522 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 732: /* create_table_option: MIN_ROWS opt_equal ulonglong_num  */
#line 6257 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.min_rows= (yyvsp[0].ulonglong_number);
            Lex->create_info.used_fields|= HA_CREATE_USED_MIN_ROWS;
          }
#line 32531 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 733: /* create_table_option: AVG_ROW_LENGTH opt_equal ulong_num  */
#line 6262 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.avg_row_length=(yyvsp[0].ulong_num);
            Lex->create_info.used_fields|= HA_CREATE_USED_AVG_ROW_LENGTH;
          }
#line 32540 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 734: /* create_table_option: PASSWORD_SYM opt_equal TEXT_STRING_sys  */
#line 6267 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.password=(yyvsp[0].lex_str).str;
            Lex->create_info.used_fields|= HA_CREATE_USED_PASSWORD;
          }
#line 32549 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 735: /* create_table_option: COMMENT_SYM opt_equal TEXT_STRING_sys  */
#line 6272 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.comment=(yyvsp[0].lex_str);
            Lex->create_info.used_fields|= HA_CREATE_USED_COMMENT;
          }
#line 32558 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 736: /* create_table_option: AUTO_INC opt_equal ulonglong_num  */
#line 6277 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.auto_increment_value=(yyvsp[0].ulonglong_number);
            Lex->create_info.used_fields|= HA_CREATE_USED_AUTO;
          }
#line 32567 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 737: /* create_table_option: PACK_KEYS_SYM opt_equal ulong_num  */
#line 6282 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            switch((yyvsp[0].ulong_num)) {
            case 0:
                Lex->create_info.table_options|= HA_OPTION_NO_PACK_KEYS;
                break;
            case 1:
                Lex->create_info.table_options|= HA_OPTION_PACK_KEYS;
                break;
            default:
                thd->parse_error();
                MYSQL_YYABORT;
            }
            Lex->create_info.used_fields|= HA_CREATE_USED_PACK_KEYS;
          }
#line 32586 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 738: /* create_table_option: PACK_KEYS_SYM opt_equal DEFAULT  */
#line 6297 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.table_options&=
              ~(HA_OPTION_PACK_KEYS | HA_OPTION_NO_PACK_KEYS);
            Lex->create_info.used_fields|= HA_CREATE_USED_PACK_KEYS;
          }
#line 32596 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 739: /* create_table_option: STATS_AUTO_RECALC_SYM opt_equal ulong_num  */
#line 6303 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            switch((yyvsp[0].ulong_num)) {
            case 0:
                Lex->create_info.stats_auto_recalc= HA_STATS_AUTO_RECALC_OFF;
                break;
            case 1:
                Lex->create_info.stats_auto_recalc= HA_STATS_AUTO_RECALC_ON;
                break;
            default:
                thd->parse_error();
                MYSQL_YYABORT;
            }
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_AUTO_RECALC;
          }
#line 32615 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 740: /* create_table_option: STATS_AUTO_RECALC_SYM opt_equal DEFAULT  */
#line 6318 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.stats_auto_recalc= HA_STATS_AUTO_RECALC_DEFAULT;
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_AUTO_RECALC;
          }
#line 32624 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 741: /* create_table_option: STATS_PERSISTENT_SYM opt_equal ulong_num  */
#line 6323 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            switch((yyvsp[0].ulong_num)) {
            case 0:
                Lex->create_info.table_options|= HA_OPTION_NO_STATS_PERSISTENT;
                break;
            case 1:
                Lex->create_info.table_options|= HA_OPTION_STATS_PERSISTENT;
                break;
            default:
                thd->parse_error();
                MYSQL_YYABORT;
            }
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_PERSISTENT;
          }
#line 32643 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 742: /* create_table_option: STATS_PERSISTENT_SYM opt_equal DEFAULT  */
#line 6338 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.table_options&=
              ~(HA_OPTION_STATS_PERSISTENT | HA_OPTION_NO_STATS_PERSISTENT);
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_PERSISTENT;
          }
#line 32653 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 743: /* create_table_option: STATS_SAMPLE_PAGES_SYM opt_equal ulong_num  */
#line 6344 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* From user point of view STATS_SAMPLE_PAGES can be specified as
            STATS_SAMPLE_PAGES=N (where 0<N<=65535, it does not make sense to
            scan 0 pages) or STATS_SAMPLE_PAGES=default. Internally we record
            =default as 0. See create_frm() in sql/table.cc, we use only two
            bytes for stats_sample_pages and this is why we do not allow
            larger values. 65535 pages, 16kb each means to sample 1GB, which
            is impractical. If at some point this needs to be extended, then
            we can store the higher bits from stats_sample_pages in .frm too. */
            if (unlikely((yyvsp[0].ulong_num) == 0 || (yyvsp[0].ulong_num) > 0xffff))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
            Lex->create_info.stats_sample_pages=(yyvsp[0].ulong_num);
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_SAMPLE_PAGES;
          }
#line 32675 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 744: /* create_table_option: STATS_SAMPLE_PAGES_SYM opt_equal DEFAULT  */
#line 6362 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.stats_sample_pages=0;
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_SAMPLE_PAGES;
          }
#line 32684 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 745: /* create_table_option: CHECKSUM_SYM opt_equal ulong_num  */
#line 6367 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.table_options|= (yyvsp[0].ulong_num) ? HA_OPTION_CHECKSUM : HA_OPTION_NO_CHECKSUM;
            Lex->create_info.used_fields|= HA_CREATE_USED_CHECKSUM;
          }
#line 32693 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 746: /* create_table_option: TABLE_CHECKSUM_SYM opt_equal ulong_num  */
#line 6372 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             Lex->create_info.table_options|= (yyvsp[0].ulong_num) ? HA_OPTION_CHECKSUM : HA_OPTION_NO_CHECKSUM;
             Lex->create_info.used_fields|= HA_CREATE_USED_CHECKSUM;
          }
#line 32702 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 747: /* create_table_option: PAGE_CHECKSUM_SYM opt_equal choice  */
#line 6377 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.used_fields|= HA_CREATE_USED_PAGE_CHECKSUM;
            Lex->create_info.page_checksum= (yyvsp[0].choice);
          }
#line 32711 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 748: /* create_table_option: DELAY_KEY_WRITE_SYM opt_equal ulong_num  */
#line 6382 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.table_options|= (yyvsp[0].ulong_num) ? HA_OPTION_DELAY_KEY_WRITE : HA_OPTION_NO_DELAY_KEY_WRITE;
            Lex->create_info.used_fields|= HA_CREATE_USED_DELAY_KEY_WRITE;
          }
#line 32720 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 749: /* create_table_option: ROW_FORMAT_SYM opt_equal row_types  */
#line 6387 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.row_type= (yyvsp[0].row_type);
            Lex->create_info.used_fields|= HA_CREATE_USED_ROW_FORMAT;
          }
#line 32729 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 750: /* $@88: %empty  */
#line 6392 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->first_select_lex()->table_list.save_and_clear(&Lex->save_list);
          }
#line 32737 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 751: /* create_table_option: UNION_SYM opt_equal $@88 '(' opt_table_list ')'  */
#line 6396 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Move the union list to the merge_list and exclude its tables
              from the global list.
            */
            LEX *lex=Lex;
            lex->create_info.merge_list= lex->first_select_lex()->table_list.first;
            lex->first_select_lex()->table_list= lex->save_list;
            /*
              When excluding union list from the global list we assume that
              elements of the former immediately follow elements which represent
              table being created/altered and parent tables.
            */
            TABLE_LIST *last_non_sel_table= lex->create_last_non_select_table;
            DBUG_ASSERT(last_non_sel_table->next_global ==
                        lex->create_info.merge_list);
            last_non_sel_table->next_global= 0;
            Lex->query_tables_last= &last_non_sel_table->next_global;

            lex->create_info.used_fields|= HA_CREATE_USED_UNION;
          }
#line 32763 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 754: /* create_table_option: INSERT_METHOD opt_equal merge_insert_types  */
#line 6420 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.merge_insert_method= (yyvsp[0].ulong_num);
            Lex->create_info.used_fields|= HA_CREATE_USED_INSERT_METHOD;
          }
#line 32772 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 755: /* create_table_option: DATA_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6425 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.data_file_name= (yyvsp[0].lex_str).str;
            Lex->create_info.used_fields|= HA_CREATE_USED_DATADIR;
          }
#line 32781 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 756: /* create_table_option: INDEX_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6430 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.index_file_name= (yyvsp[0].lex_str).str;
            Lex->create_info.used_fields|= HA_CREATE_USED_INDEXDIR;
          }
#line 32790 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 757: /* create_table_option: TABLESPACE ident  */
#line 6435 "/home/buildbot/git/sql/sql_yacc.yy"
          {Lex->create_info.tablespace= (yyvsp[0].ident_sys).str;}
#line 32796 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 758: /* create_table_option: STORAGE_SYM DISK_SYM  */
#line 6437 "/home/buildbot/git/sql/sql_yacc.yy"
          {Lex->create_info.storage_media= HA_SM_DISK;}
#line 32802 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 759: /* create_table_option: STORAGE_SYM MEMORY_SYM  */
#line 6439 "/home/buildbot/git/sql/sql_yacc.yy"
          {Lex->create_info.storage_media= HA_SM_MEMORY;}
#line 32808 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 760: /* create_table_option: CONNECTION_SYM opt_equal TEXT_STRING_sys  */
#line 6441 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.connect_string.str= (yyvsp[0].lex_str).str;
            Lex->create_info.connect_string.length= (yyvsp[0].lex_str).length;
            Lex->create_info.used_fields|= HA_CREATE_USED_CONNECTION;
          }
#line 32818 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 761: /* create_table_option: KEY_BLOCK_SIZE opt_equal ulong_num  */
#line 6447 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.used_fields|= HA_CREATE_USED_KEY_BLOCK_SIZE;
            Lex->create_info.key_block_size= (yyvsp[0].ulong_num);
          }
#line 32827 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 762: /* create_table_option: TRANSACTIONAL_SYM opt_equal choice  */
#line 6452 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    Lex->create_info.used_fields|= HA_CREATE_USED_TRANSACTIONAL;
            Lex->create_info.transactional= (yyvsp[0].choice);
          }
#line 32836 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 763: /* create_table_option: IDENT_sys equal TEXT_STRING_sys  */
#line 6457 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[0].lex_str).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].lex_str), true,
                                       &Lex->create_info.option_list,
                                       &Lex->option_list_last);
          }
#line 32849 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 764: /* create_table_option: IDENT_sys equal ident  */
#line 6466 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[0].ident_sys).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ident_sys), false,
                                       &Lex->create_info.option_list,
                                       &Lex->option_list_last);
          }
#line 32862 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 765: /* create_table_option: IDENT_sys equal real_ulonglong_num  */
#line 6475 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ulonglong_number), &Lex->create_info.option_list,
                                       &Lex->option_list_last, thd->mem_root);
          }
#line 32872 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 766: /* create_table_option: IDENT_sys equal DEFAULT  */
#line 6481 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), &Lex->create_info.option_list,
                                       &Lex->option_list_last);
          }
#line 32882 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 767: /* create_table_option: SEQUENCE_SYM opt_equal choice  */
#line 6487 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    Lex->create_info.used_fields|= HA_CREATE_USED_SEQUENCE;
            Lex->create_info.sequence= ((yyvsp[0].choice) == HA_CHOICE_YES);
	  }
#line 32891 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 771: /* versioning_option: WITH_SYSTEM_SYM VERSIONING_SYM  */
#line 6501 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.options & HA_LEX_CREATE_TMP_TABLE))
            {
              if (DBUG_EVALUATE_IF("sysvers_force", 0, 1))
              {
                my_error(ER_VERS_NOT_SUPPORTED, MYF(0), "CREATE TEMPORARY TABLE");
                MYSQL_YYABORT;
              }
            }
            else
            {
              Lex->alter_info.flags|= ALTER_ADD_SYSTEM_VERSIONING;
              Lex->create_info.options|= HA_VERSIONED_TABLE;
            }
          }
#line 32911 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 772: /* default_charset: opt_default charset opt_equal charset_name_or_default  */
#line 6520 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.add_table_option_default_charset((yyvsp[0].charset))))
              MYSQL_YYABORT;
          }
#line 32920 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 773: /* default_collation: opt_default COLLATE_SYM opt_equal collation_name_or_default  */
#line 6528 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            HA_CREATE_INFO *cinfo= &Lex->create_info;
            if (unlikely((cinfo->used_fields & HA_CREATE_USED_DEFAULT_CHARSET) &&
                         cinfo->default_table_charset && (yyvsp[0].charset) &&
                         !((yyvsp[0].charset)= merge_charset_and_collation(cinfo->default_table_charset,
                                                           (yyvsp[0].charset)))))
              MYSQL_YYABORT;

            Lex->create_info.default_table_charset= (yyvsp[0].charset);
            Lex->create_info.used_fields|= HA_CREATE_USED_DEFAULT_CHARSET;
          }
#line 32936 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 774: /* storage_engines: ident_or_text  */
#line 6543 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Storage_engine_name((yyvsp[0].lex_str)).
                 resolve_storage_engine_with_error(thd, &(yyval.db_type),
                                            thd->lex->create_info.tmp_table()))
              MYSQL_YYABORT;
          }
#line 32947 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 775: /* known_storage_engines: ident_or_text  */
#line 6553 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            plugin_ref plugin;
            if (likely((plugin= ha_resolve_by_name(thd, &(yyvsp[0].lex_str), false))))
              (yyval.db_type)= plugin_hton(plugin);
            else
              my_yyabort_error((ER_UNKNOWN_STORAGE_ENGINE, MYF(0), (yyvsp[0].lex_str).str));
          }
#line 32959 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 776: /* row_types: DEFAULT  */
#line 6563 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_DEFAULT; }
#line 32965 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 777: /* row_types: FIXED_SYM  */
#line 6564 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_FIXED; }
#line 32971 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 778: /* row_types: DYNAMIC_SYM  */
#line 6565 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_DYNAMIC; }
#line 32977 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 779: /* row_types: COMPRESSED_SYM  */
#line 6566 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_COMPRESSED; }
#line 32983 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 780: /* row_types: REDUNDANT_SYM  */
#line 6567 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_REDUNDANT; }
#line 32989 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 781: /* row_types: COMPACT_SYM  */
#line 6568 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_COMPACT; }
#line 32995 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 782: /* row_types: PAGE_SYM  */
#line 6569 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_PAGE; }
#line 33001 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 783: /* merge_insert_types: NO_SYM  */
#line 6573 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.ulong_num)= MERGE_INSERT_DISABLED; }
#line 33007 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 784: /* merge_insert_types: FIRST_SYM  */
#line 6574 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.ulong_num)= MERGE_INSERT_TO_FIRST; }
#line 33013 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 785: /* merge_insert_types: LAST_SYM  */
#line 6575 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.ulong_num)= MERGE_INSERT_TO_LAST; }
#line 33019 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 786: /* udf_type: STRING_SYM  */
#line 6579 "/home/buildbot/git/sql/sql_yacc.yy"
                     {(yyval.num) = (int) STRING_RESULT; }
#line 33025 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 787: /* udf_type: REAL  */
#line 6580 "/home/buildbot/git/sql/sql_yacc.yy"
               {(yyval.num) = (int) REAL_RESULT; }
#line 33031 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 788: /* udf_type: DECIMAL_SYM  */
#line 6581 "/home/buildbot/git/sql/sql_yacc.yy"
                      {(yyval.num) = (int) DECIMAL_RESULT; }
#line 33037 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 789: /* udf_type: INT_SYM  */
#line 6582 "/home/buildbot/git/sql/sql_yacc.yy"
                  {(yyval.num) = (int) INT_RESULT; }
#line 33043 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 790: /* create_field_list: field_list  */
#line 6588 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->create_last_non_select_table= Lex->last_table();
        }
#line 33051 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 791: /* create_field_list_parens: LEFT_PAREN_ALT field_list ')'  */
#line 6595 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->create_last_non_select_table= Lex->last_table();
        }
#line 33059 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 794: /* field_list_item: column_def  */
#line 6606 "/home/buildbot/git/sql/sql_yacc.yy"
                     { }
#line 33065 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 798: /* field_list_item: PERIOD_SYM period_for_application_time  */
#line 6610 "/home/buildbot/git/sql/sql_yacc.yy"
                                                 { }
#line 33071 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 799: /* column_def: field_spec  */
#line 6615 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.create_field)= (yyvsp[0].create_field); }
#line 33077 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 800: /* column_def: field_spec references  */
#line 6617 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.create_field)= (yyvsp[-1].create_field); }
#line 33083 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 801: /* $@89: %empty  */
#line 6622 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key(Key::MULTIPLE, &(yyvsp[-1].lex_str), (yyvsp[0].key_alg), (yyvsp[-2].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 33093 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 802: /* key_def: key_or_index opt_if_not_exists opt_ident opt_USING_key_algorithm $@89 '(' key_list ')' normal_key_options  */
#line 6627 "/home/buildbot/git/sql/sql_yacc.yy"
                                              { }
#line 33099 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 803: /* $@90: %empty  */
#line 6629 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key(Key::MULTIPLE, &(yyvsp[-2].ident_sys), (yyvsp[0].key_alg), (yyvsp[-3].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 33109 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 804: /* key_def: key_or_index opt_if_not_exists ident TYPE_SYM btree_or_rtree $@90 '(' key_list ')' normal_key_options  */
#line 6634 "/home/buildbot/git/sql/sql_yacc.yy"
                                              { }
#line 33115 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 805: /* $@91: %empty  */
#line 6636 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-3].key_type), &(yyvsp[0].lex_str), HA_KEY_ALG_UNDEF, (yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 33125 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 806: /* key_def: fulltext opt_key_or_index opt_if_not_exists opt_ident $@91 '(' key_list ')' fulltext_key_options  */
#line 6641 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { }
#line 33131 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 807: /* $@92: %empty  */
#line 6643 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-3].key_type), &(yyvsp[0].lex_str), HA_KEY_ALG_UNDEF, (yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 33141 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 808: /* key_def: spatial opt_key_or_index opt_if_not_exists opt_ident $@92 '(' key_list ')' spatial_key_options  */
#line 6648 "/home/buildbot/git/sql/sql_yacc.yy"
                                               { }
#line 33147 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 809: /* $@93: %empty  */
#line 6652 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-3].key_type), (yyvsp[-1].lex_str).str ? &(yyvsp[-1].lex_str) : &(yyvsp[-4].lex_str), (yyvsp[0].key_alg), (yyvsp[-2].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 33157 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 810: /* key_def: opt_constraint constraint_key_type opt_if_not_exists opt_ident opt_USING_key_algorithm $@93 '(' key_list ')' normal_key_options  */
#line 6657 "/home/buildbot/git/sql/sql_yacc.yy"
                                              { }
#line 33163 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 811: /* $@94: %empty  */
#line 6660 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-4].key_type), (yyvsp[-2].ident_sys).str ? &(yyvsp[-2].ident_sys) : &(yyvsp[-5].lex_str), (yyvsp[0].key_alg), (yyvsp[-3].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 33173 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 812: /* key_def: opt_constraint constraint_key_type opt_if_not_exists ident TYPE_SYM btree_or_rtree $@94 '(' key_list ')' normal_key_options  */
#line 6665 "/home/buildbot/git/sql/sql_yacc.yy"
                                              { }
#line 33179 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 813: /* $@95: %empty  */
#line 6667 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->check_add_key((yyvsp[-1].object_ddl_options))) ||
                unlikely(!(Lex->last_key= (new (thd->mem_root)
                                           Key(Key::MULTIPLE,
                                           (yyvsp[-4].lex_str).str ? &(yyvsp[-4].lex_str) : &(yyvsp[0].lex_str),
                                           HA_KEY_ALG_UNDEF, true, (yyvsp[-1].object_ddl_options))))))
              MYSQL_YYABORT;
            Lex->option_list= NULL;
          }
#line 33193 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 814: /* key_def: opt_constraint FOREIGN KEY_SYM opt_if_not_exists opt_ident $@95 '(' key_list ')' references  */
#line 6677 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Key *key= (new (thd->mem_root)
                       Foreign_key((yyvsp[-5].lex_str).str ? &(yyvsp[-5].lex_str) : &(yyvsp[-9].lex_str),
                                   &lex->last_key->columns,
                                   &(yyvsp[0].table)->db,
                                   &(yyvsp[0].table)->table,
                                   &lex->ref_list,
                                   lex->fk_delete_opt,
                                   lex->fk_update_opt,
                                   lex->fk_match_option,
                                    (yyvsp[-6].object_ddl_options)));
            if (unlikely(key == NULL))
              MYSQL_YYABORT;
            /*
              handle_if_exists_options() expectes the two keys in this order:
              the Foreign_key, followed by its auto-generated Key.
            */
            lex->alter_info.key_list.push_back(key, thd->mem_root);
            lex->alter_info.key_list.push_back(Lex->last_key, thd->mem_root);
            lex->option_list= NULL;

            /* Only used for ALTER TABLE. Ignored otherwise. */
            lex->alter_info.flags|= ALTER_ADD_FOREIGN_KEY;
          }
#line 33223 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 815: /* constraint_def: opt_constraint check_constraint  */
#line 6706 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           Lex->add_constraint((yyvsp[-1].lex_str), (yyvsp[0].virtual_column), FALSE);
         }
#line 33231 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 816: /* period_for_system_time: PERIOD_SYM FOR_SYSTEM_TIME_SYM '(' ident ',' ident ')'  */
#line 6714 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Vers_parse_info &info= Lex->vers_get_info();
            info.set_period((yyvsp[-3].ident_sys), (yyvsp[-1].ident_sys));
          }
#line 33240 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 817: /* period_for_application_time: FOR_SYM ident '(' ident ',' ident ')'  */
#line 6722 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->add_period((yyvsp[-5].ident_sys), (yyvsp[-3].ident_sys), (yyvsp[-1].ident_sys)))
              MYSQL_YYABORT;
          }
#line 33249 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 818: /* opt_check_constraint: %empty  */
#line 6729 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.virtual_column)= (Virtual_column_info*) 0; }
#line 33255 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 819: /* opt_check_constraint: check_constraint  */
#line 6730 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.virtual_column)= (yyvsp[0].virtual_column);}
#line 33261 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 820: /* check_constraint: CHECK_SYM '(' expr ')'  */
#line 6735 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Virtual_column_info *v= add_virtual_expression(thd, (yyvsp[-1].item));
            if (unlikely(!v))
              MYSQL_YYABORT;
            (yyval.virtual_column)= v;
          }
#line 33272 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 821: /* opt_constraint_no_id: %empty  */
#line 6744 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 33278 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 822: /* opt_constraint_no_id: CONSTRAINT  */
#line 6745 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 33284 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 823: /* opt_constraint: %empty  */
#line 6749 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lex_str)= null_clex_str; }
#line 33290 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 824: /* opt_constraint: constraint  */
#line 6750 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.lex_str)= (yyvsp[0].lex_str); }
#line 33296 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 825: /* constraint: CONSTRAINT opt_ident  */
#line 6754 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.lex_str)=(yyvsp[0].lex_str); }
#line 33302 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 826: /* @96: %empty  */
#line 6759 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Create_field *f= new (thd->mem_root) Create_field();

            if (unlikely(check_string_char_length(&(yyvsp[0].lex_str), 0, NAME_CHAR_LEN,
                                                  system_charset_info, 1)))
              my_yyabort_error((ER_TOO_LONG_IDENT, MYF(0), (yyvsp[0].lex_str).str));

            if (unlikely(!f))
              MYSQL_YYABORT;

            lex->init_last_field(f, &(yyvsp[0].lex_str), NULL);
            (yyval.create_field)= f;
            lex->parsing_options.lookup_keywords_after_qualifier= true;
          }
#line 33322 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 827: /* field_spec: field_ident @96 field_type_or_serial opt_check_constraint  */
#line 6775 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->parsing_options.lookup_keywords_after_qualifier= false;
            (yyval.create_field)= (yyvsp[-2].create_field);

            (yyval.create_field)->check_constraint= (yyvsp[0].virtual_column);

            if (unlikely((yyval.create_field)->check(thd)))
              MYSQL_YYABORT;

            lex->alter_info.create_list.push_back((yyval.create_field), thd->mem_root);

            (yyval.create_field)->create_if_not_exists= Lex->check_exists;
            if ((yyval.create_field)->flags & PRI_KEY_FLAG)
              lex->add_key_to_list(&(yyvsp[-3].lex_str), Key::PRIMARY, lex->check_exists);
            else if ((yyval.create_field)->flags & UNIQUE_KEY_FLAG)
              lex->add_key_to_list(&(yyvsp[-3].lex_str), Key::UNIQUE, lex->check_exists);
          }
#line 33345 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 828: /* $@97: %empty  */
#line 6796 "/home/buildbot/git/sql/sql_yacc.yy"
                                { Lex->last_field->set_attributes((yyvsp[0].Lex_field_type), Lex->charset); }
#line 33351 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 830: /* $@98: %empty  */
#line 6799 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->set_handler(&type_handler_longlong);
            Lex->last_field->flags|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG
                                     | UNSIGNED_FLAG | UNIQUE_KEY_FLAG;
            Lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 33362 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 832: /* opt_serial_attribute: %empty  */
#line 6809 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 33368 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 833: /* opt_serial_attribute: opt_serial_attribute_list  */
#line 6810 "/home/buildbot/git/sql/sql_yacc.yy"
                                    {}
#line 33374 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 834: /* opt_serial_attribute_list: opt_serial_attribute_list serial_attribute  */
#line 6814 "/home/buildbot/git/sql/sql_yacc.yy"
                                                     {}
#line 33380 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 836: /* opt_asrow_attribute: %empty  */
#line 6819 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 33386 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 837: /* opt_asrow_attribute: opt_asrow_attribute_list  */
#line 6820 "/home/buildbot/git/sql/sql_yacc.yy"
                                   {}
#line 33392 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 838: /* opt_asrow_attribute_list: opt_asrow_attribute_list asrow_attribute  */
#line 6824 "/home/buildbot/git/sql/sql_yacc.yy"
                                                   {}
#line 33398 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 840: /* field_def: %empty  */
#line 6829 "/home/buildbot/git/sql/sql_yacc.yy"
                      { }
#line 33404 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 844: /* $@99: %empty  */
#line 6834 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           Lex->last_field->vcol_info= (yyvsp[0].virtual_column);
           Lex->last_field->flags&= ~NOT_NULL_FLAG; // undo automatic NOT NULL for timestamps
         }
#line 33413 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 846: /* field_def: opt_generated_always AS ROW_SYM START_SYM opt_asrow_attribute  */
#line 6840 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->last_field_generated_always_as_row_start())
              MYSQL_YYABORT;
          }
#line 33422 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 847: /* field_def: opt_generated_always AS ROW_SYM END opt_asrow_attribute  */
#line 6845 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->last_field_generated_always_as_row_end())
              MYSQL_YYABORT;
          }
#line 33431 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 848: /* opt_generated_always: %empty  */
#line 6852 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 33437 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 849: /* opt_generated_always: GENERATED_SYM ALWAYS_SYM  */
#line 6853 "/home/buildbot/git/sql/sql_yacc.yy"
                                   {}
#line 33443 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 850: /* vcol_opt_specifier: %empty  */
#line 6858 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(FALSE);
          }
#line 33451 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 851: /* vcol_opt_specifier: VIRTUAL_SYM  */
#line 6862 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(FALSE);
          }
#line 33459 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 852: /* vcol_opt_specifier: PERSISTENT_SYM  */
#line 6866 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(TRUE);
          }
#line 33467 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 853: /* vcol_opt_specifier: STORED_SYM  */
#line 6870 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(TRUE);
          }
#line 33475 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 854: /* vcol_opt_attribute: %empty  */
#line 6876 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 33481 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 855: /* vcol_opt_attribute: vcol_opt_attribute_list  */
#line 6877 "/home/buildbot/git/sql/sql_yacc.yy"
                                  {}
#line 33487 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 856: /* vcol_opt_attribute_list: vcol_opt_attribute_list vcol_attribute  */
#line 6881 "/home/buildbot/git/sql/sql_yacc.yy"
                                                 {}
#line 33493 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 858: /* vcol_attribute: UNIQUE_SYM  */
#line 6887 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= UNIQUE_KEY_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 33503 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 859: /* vcol_attribute: UNIQUE_SYM KEY_SYM  */
#line 6893 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= UNIQUE_KEY_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 33513 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 860: /* vcol_attribute: COMMENT_SYM TEXT_STRING_sys  */
#line 6898 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->last_field->comment= (yyvsp[0].lex_str); }
#line 33519 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 861: /* vcol_attribute: INVISIBLE_SYM  */
#line 6900 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->invisible= INVISIBLE_USER;
          }
#line 33527 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 862: /* $@100: %empty  */
#line 6907 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              "PARSE_VCOL_EXPR" can only be used by the SQL server
              when reading a '*.frm' file.
              Prevent the end user from invoking this command.
            */
            MYSQL_YYABORT_UNLESS(Lex->parse_vcol_expr);
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 33542 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 863: /* parse_vcol_expr: PARSE_VCOL_EXPR_SYM $@100 expr  */
#line 6918 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Virtual_column_info *v= add_virtual_expression(thd, (yyvsp[0].item));
            if (unlikely(!v))
              MYSQL_YYABORT;
            Lex->last_field->vcol_info= v;
            Lex->pop_select(); //main select
          }
#line 33554 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 865: /* parenthesized_expr: expr ',' expr_list  */
#line 6930 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[0].item_list)->push_front((yyvsp[-2].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_row(thd, *(yyvsp[0].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 33565 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 866: /* virtual_column_func: '(' parenthesized_expr ')'  */
#line 6940 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Virtual_column_info *v=
              add_virtual_expression(thd, (yyvsp[-1].item));
            if (unlikely(!v))
              MYSQL_YYABORT;
            (yyval.virtual_column)= v;
          }
#line 33577 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 867: /* virtual_column_func: subquery  */
#line 6948 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item;
            if (!(item= new (thd->mem_root) Item_singlerow_subselect(thd, (yyvsp[0].select_lex))))
              MYSQL_YYABORT;
            Virtual_column_info *v= add_virtual_expression(thd, item);
            if (unlikely(!v))
              MYSQL_YYABORT;
            (yyval.virtual_column)= v;
          }
#line 33591 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 871: /* column_default_expr: expr_or_literal  */
#line 6964 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.virtual_column)= add_virtual_expression(thd, (yyvsp[0].item)))))
              MYSQL_YYABORT;
          }
#line 33600 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 872: /* field_type: field_type_all  */
#line 6971 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->map_data_type(Lex_ident_sys(), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type)));
          Lex->last_field->set_attributes((yyval.Lex_field_type), Lex->charset);
        }
#line 33609 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 873: /* qualified_field_type: field_type_all  */
#line 6979 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->map_data_type(Lex_ident_sys(), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type)));
          }
#line 33617 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 874: /* qualified_field_type: sp_decl_ident '.' field_type_all  */
#line 6983 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->map_data_type((yyvsp[-2].ident_sys), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type))))
              MYSQL_YYABORT;
          }
#line 33626 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 880: /* field_type_numeric: int_type opt_field_length field_options  */
#line 6998 "/home/buildbot/git/sql/sql_yacc.yy"
                                                  { (yyval.Lex_field_type).set((yyvsp[-2].type_handler), (yyvsp[-1].const_simple_string)); }
#line 33632 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 881: /* field_type_numeric: real_type opt_precision field_options  */
#line 6999 "/home/buildbot/git/sql/sql_yacc.yy"
                                                  { (yyval.Lex_field_type).set((yyvsp[-2].type_handler), (yyvsp[-1].Lex_length_and_dec)); }
#line 33638 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 882: /* field_type_numeric: FLOAT_SYM float_options field_options  */
#line 7001 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_float, (yyvsp[-1].Lex_length_and_dec));
            if ((yyvsp[-1].Lex_length_and_dec).length() && !(yyvsp[-1].Lex_length_and_dec).dec())
            {
              int err;
              ulonglong tmp_length= my_strtoll10((yyvsp[-1].Lex_length_and_dec).length(), NULL, &err);
              if (unlikely(err || tmp_length > PRECISION_FOR_DOUBLE))
                my_yyabort_error((ER_WRONG_FIELD_SPEC, MYF(0),
                                  Lex->last_field->field_name.str));
              if (tmp_length > PRECISION_FOR_FLOAT)
                (yyval.Lex_field_type).set(&type_handler_double);
              else
                (yyval.Lex_field_type).set(&type_handler_float);
            }
          }
#line 33658 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 883: /* field_type_numeric: BIT_SYM opt_field_length_default_1  */
#line 7017 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_bit, (yyvsp[0].const_simple_string));
          }
#line 33666 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 884: /* field_type_numeric: BOOL_SYM  */
#line 7021 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_tiny, "1");
          }
#line 33674 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 885: /* field_type_numeric: BOOLEAN_SYM  */
#line 7025 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_tiny, "1");
          }
#line 33682 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 886: /* field_type_numeric: DECIMAL_SYM float_options field_options  */
#line 7029 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));}
#line 33688 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 887: /* field_type_numeric: NUMBER_ORACLE_SYM float_options field_options  */
#line 7031 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[-1].Lex_length_and_dec).length() != 0)
              (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));
            else
              (yyval.Lex_field_type).set(&type_handler_double);
          }
#line 33699 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 888: /* field_type_numeric: NUMERIC_SYM float_options field_options  */
#line 7038 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));}
#line 33705 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 889: /* field_type_numeric: FIXED_SYM float_options field_options  */
#line 7040 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));}
#line 33711 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 894: /* field_type_string: char opt_field_length_default_1 opt_binary  */
#line 7053 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_string, (yyvsp[-1].const_simple_string));
          }
#line 33719 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 895: /* field_type_string: nchar opt_field_length_default_1 opt_bin_mod  */
#line 7057 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_string, (yyvsp[-1].const_simple_string));
            bincmp_collation(national_charset_info, (yyvsp[0].num));
          }
#line 33728 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 896: /* field_type_string: BINARY opt_field_length_default_1  */
#line 7062 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_string, (yyvsp[0].const_simple_string));
          }
#line 33737 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 897: /* field_type_string: varchar field_length opt_binary_and_compression  */
#line 7067 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33745 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 898: /* field_type_string: VARCHAR2_ORACLE_SYM field_length opt_binary_and_compression  */
#line 7071 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33753 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 899: /* field_type_string: nvarchar field_length opt_compressed opt_bin_mod  */
#line 7075 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-2].const_simple_string));
            bincmp_collation(national_charset_info, (yyvsp[0].num));
          }
#line 33762 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 900: /* field_type_string: VARBINARY field_length opt_compressed  */
#line 7080 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33771 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 901: /* field_type_string: RAW_ORACLE_SYM field_length opt_compressed  */
#line 7085 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset= &my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33780 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 902: /* field_type_temporal: YEAR_SYM opt_field_length field_options  */
#line 7093 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[-1].const_simple_string))
            {
              errno= 0;
              ulong length= strtoul((yyvsp[-1].const_simple_string), NULL, 10);
              if (errno == 0 && length <= MAX_FIELD_BLOBLENGTH && length != 4)
              {
                char buff[sizeof("YEAR()") + MY_INT64_NUM_DECIMAL_DIGITS + 1];
                my_snprintf(buff, sizeof(buff), "YEAR(%lu)", length);
                push_warning_printf(thd, Sql_condition::WARN_LEVEL_NOTE,
                                    ER_WARN_DEPRECATED_SYNTAX,
                                    ER_THD(thd, ER_WARN_DEPRECATED_SYNTAX),
                                    buff, "YEAR(4)");
              }
            }
            (yyval.Lex_field_type).set(&type_handler_year, (yyvsp[-1].const_simple_string));
          }
#line 33802 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 903: /* field_type_temporal: DATE_SYM  */
#line 7110 "/home/buildbot/git/sql/sql_yacc.yy"
                   { (yyval.Lex_field_type).set(&type_handler_newdate); }
#line 33808 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 904: /* field_type_temporal: TIME_SYM opt_field_length  */
#line 7112 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(opt_mysql56_temporal_format ?
                   static_cast<const Type_handler*>(&type_handler_time2) :
                   static_cast<const Type_handler*>(&type_handler_time),
                   (yyvsp[0].const_simple_string));
          }
#line 33819 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 905: /* field_type_temporal: TIMESTAMP opt_field_length  */
#line 7119 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(opt_mysql56_temporal_format ?
                   static_cast<const Type_handler*>(&type_handler_timestamp2):
                   static_cast<const Type_handler*>(&type_handler_timestamp),
                   (yyvsp[0].const_simple_string));
          }
#line 33830 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 906: /* field_type_temporal: DATETIME opt_field_length  */
#line 7126 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(thd->type_handler_for_datetime(), (yyvsp[0].const_simple_string));
          }
#line 33838 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 907: /* field_type_lob: TINYBLOB opt_compressed  */
#line 7134 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_tiny_blob);
          }
#line 33847 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 908: /* field_type_lob: BLOB_MARIADB_SYM opt_field_length opt_compressed  */
#line 7139 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_blob, (yyvsp[-1].const_simple_string));
          }
#line 33856 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 909: /* field_type_lob: BLOB_ORACLE_SYM field_length opt_compressed  */
#line 7144 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_blob, (yyvsp[-1].const_simple_string));
          }
#line 33865 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 910: /* field_type_lob: BLOB_ORACLE_SYM opt_compressed  */
#line 7149 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_long_blob);
          }
#line 33874 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 911: /* field_type_lob: spatial_type float_options srid_option  */
#line 7154 "/home/buildbot/git/sql/sql_yacc.yy"
          {
#ifdef HAVE_SPATIAL
            Lex->charset=&my_charset_bin;
            Lex->last_field->geom_type= (yyvsp[-2].geom_type);
            (yyval.Lex_field_type).set(&type_handler_geometry, (yyvsp[-1].Lex_length_and_dec));
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), sym_group_geom.name,
                              sym_group_geom.needed_define));
#endif
          }
#line 33889 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 912: /* field_type_lob: MEDIUMBLOB opt_compressed  */
#line 7165 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_medium_blob);
          }
#line 33898 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 913: /* field_type_lob: LONGBLOB opt_compressed  */
#line 7170 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_long_blob);
          }
#line 33907 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 914: /* field_type_lob: LONG_SYM VARBINARY opt_compressed  */
#line 7175 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_medium_blob);
          }
#line 33916 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 915: /* field_type_lob: LONG_SYM varchar opt_binary_and_compression  */
#line 7180 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_medium_blob); }
#line 33922 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 916: /* field_type_lob: TINYTEXT opt_binary_and_compression  */
#line 7182 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_tiny_blob); }
#line 33928 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 917: /* field_type_lob: TEXT_SYM opt_field_length opt_binary_and_compression  */
#line 7184 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_blob, (yyvsp[-1].const_simple_string)); }
#line 33934 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 918: /* field_type_lob: MEDIUMTEXT opt_binary_and_compression  */
#line 7186 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_medium_blob); }
#line 33940 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 919: /* field_type_lob: LONGTEXT opt_binary_and_compression  */
#line 7188 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_long_blob); }
#line 33946 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 920: /* field_type_lob: CLOB_ORACLE_SYM opt_binary_and_compression  */
#line 7190 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_long_blob); }
#line 33952 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 921: /* field_type_lob: LONG_SYM opt_binary_and_compression  */
#line 7192 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_medium_blob); }
#line 33958 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 922: /* field_type_lob: JSON_SYM opt_compressed  */
#line 7194 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset= &my_charset_utf8mb4_bin;
            (yyval.Lex_field_type).set(&type_handler_json_longtext);
          }
#line 33967 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 923: /* field_type_misc: ENUM '(' string_list ')' opt_binary  */
#line 7202 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_enum); }
#line 33973 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 924: /* field_type_misc: SET '(' string_list ')' opt_binary  */
#line 7204 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_set); }
#line 33979 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 925: /* spatial_type: GEOMETRY_SYM  */
#line 7208 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_GEOMETRY; }
#line 33985 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 926: /* spatial_type: GEOMETRYCOLLECTION  */
#line 7209 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_GEOMETRYCOLLECTION; }
#line 33991 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 927: /* spatial_type: POINT_SYM  */
#line 7210 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_POINT; }
#line 33997 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 928: /* spatial_type: MULTIPOINT  */
#line 7211 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_MULTIPOINT; }
#line 34003 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 929: /* spatial_type: LINESTRING  */
#line 7212 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_LINESTRING; }
#line 34009 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 930: /* spatial_type: MULTILINESTRING  */
#line 7213 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_MULTILINESTRING; }
#line 34015 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 931: /* spatial_type: POLYGON  */
#line 7214 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_POLYGON; }
#line 34021 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 932: /* spatial_type: MULTIPOLYGON  */
#line 7215 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_MULTIPOLYGON; }
#line 34027 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 933: /* char: CHAR_SYM  */
#line 7219 "/home/buildbot/git/sql/sql_yacc.yy"
                   {}
#line 34033 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 934: /* nchar: NCHAR_SYM  */
#line 7223 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 34039 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 935: /* nchar: NATIONAL_SYM CHAR_SYM  */
#line 7224 "/home/buildbot/git/sql/sql_yacc.yy"
                                {}
#line 34045 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 936: /* varchar: char VARYING  */
#line 7228 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 34051 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 937: /* varchar: VARCHAR  */
#line 7229 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 34057 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 938: /* nvarchar: NATIONAL_SYM VARCHAR  */
#line 7233 "/home/buildbot/git/sql/sql_yacc.yy"
                               {}
#line 34063 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 939: /* nvarchar: NVARCHAR_SYM  */
#line 7234 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 34069 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 940: /* nvarchar: NCHAR_SYM VARCHAR  */
#line 7235 "/home/buildbot/git/sql/sql_yacc.yy"
                            {}
#line 34075 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 941: /* nvarchar: NATIONAL_SYM CHAR_SYM VARYING  */
#line 7236 "/home/buildbot/git/sql/sql_yacc.yy"
                                        {}
#line 34081 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 942: /* nvarchar: NCHAR_SYM VARYING  */
#line 7237 "/home/buildbot/git/sql/sql_yacc.yy"
                            {}
#line 34087 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 943: /* int_type: INT_SYM  */
#line 7241 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.type_handler)= &type_handler_long; }
#line 34093 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 944: /* int_type: TINYINT  */
#line 7242 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.type_handler)= &type_handler_tiny; }
#line 34099 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 945: /* int_type: SMALLINT  */
#line 7243 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.type_handler)= &type_handler_short; }
#line 34105 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 946: /* int_type: MEDIUMINT  */
#line 7244 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.type_handler)= &type_handler_int24; }
#line 34111 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 947: /* int_type: BIGINT  */
#line 7245 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.type_handler)= &type_handler_longlong; }
#line 34117 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 948: /* real_type: REAL  */
#line 7250 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.type_handler)= thd->variables.sql_mode & MODE_REAL_AS_FLOAT ?
              static_cast<const Type_handler *>(&type_handler_float) :
              static_cast<const Type_handler *>(&type_handler_double);
          }
#line 34127 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 949: /* real_type: DOUBLE_SYM  */
#line 7255 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.type_handler)= &type_handler_double; }
#line 34133 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 950: /* real_type: DOUBLE_SYM PRECISION  */
#line 7256 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.type_handler)= &type_handler_double; }
#line 34139 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 951: /* srid_option: %empty  */
#line 7261 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->last_field->srid= 0; }
#line 34145 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 952: /* srid_option: REF_SYSTEM_ID_SYM '=' NUM  */
#line 7264 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->srid=atoi((yyvsp[0].lex_str).str);
          }
#line 34153 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 953: /* float_options: %empty  */
#line 7270 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.Lex_length_and_dec).set(0, 0);  }
#line 34159 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 954: /* float_options: field_length  */
#line 7271 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.Lex_length_and_dec).set((yyvsp[0].const_simple_string), 0); }
#line 34165 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 955: /* float_options: precision  */
#line 7272 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.Lex_length_and_dec)= (yyvsp[0].Lex_length_and_dec); }
#line 34171 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 956: /* precision: '(' NUM ',' NUM ')'  */
#line 7276 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.Lex_length_and_dec).set((yyvsp[-3].lex_str).str, (yyvsp[-1].lex_str).str); }
#line 34177 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 957: /* field_options: %empty  */
#line 7280 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 34183 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 958: /* field_options: SIGNED_SYM  */
#line 7281 "/home/buildbot/git/sql/sql_yacc.yy"
                     {}
#line 34189 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 959: /* field_options: UNSIGNED  */
#line 7282 "/home/buildbot/git/sql/sql_yacc.yy"
                   { Lex->last_field->flags|= UNSIGNED_FLAG;}
#line 34195 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 960: /* field_options: ZEROFILL  */
#line 7283 "/home/buildbot/git/sql/sql_yacc.yy"
                   { Lex->last_field->flags|= UNSIGNED_FLAG | ZEROFILL_FLAG; }
#line 34201 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 961: /* field_options: UNSIGNED ZEROFILL  */
#line 7284 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->last_field->flags|= UNSIGNED_FLAG | ZEROFILL_FLAG; }
#line 34207 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 962: /* field_options: ZEROFILL UNSIGNED  */
#line 7285 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->last_field->flags|= UNSIGNED_FLAG | ZEROFILL_FLAG; }
#line 34213 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 963: /* field_length: '(' LONG_NUM ')'  */
#line 7289 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 34219 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 964: /* field_length: '(' ULONGLONG_NUM ')'  */
#line 7290 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 34225 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 965: /* field_length: '(' DECIMAL_NUM ')'  */
#line 7291 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 34231 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 966: /* field_length: '(' NUM ')'  */
#line 7292 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 34237 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 967: /* opt_field_length: %empty  */
#line 7296 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.const_simple_string)= (char*) 0; /* use default length */ }
#line 34243 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 968: /* opt_field_length: field_length  */
#line 7297 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.const_simple_string)= (yyvsp[0].const_simple_string); }
#line 34249 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 969: /* opt_field_length_default_1: %empty  */
#line 7301 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.const_simple_string)= (char*) "1"; }
#line 34255 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 970: /* opt_field_length_default_1: field_length  */
#line 7302 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.const_simple_string)= (yyvsp[0].const_simple_string); }
#line 34261 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 971: /* opt_precision: %empty  */
#line 7306 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.Lex_length_and_dec).set(0, 0); }
#line 34267 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 972: /* opt_precision: precision  */
#line 7307 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.Lex_length_and_dec)= (yyvsp[0].Lex_length_and_dec); }
#line 34273 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 973: /* attribute_list: attribute_list attribute  */
#line 7312 "/home/buildbot/git/sql/sql_yacc.yy"
                                   {}
#line 34279 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 975: /* attribute: NULL_SYM  */
#line 7317 "/home/buildbot/git/sql/sql_yacc.yy"
                   { Lex->last_field->flags&= ~ NOT_NULL_FLAG; }
#line 34285 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 976: /* attribute: DEFAULT column_default_expr  */
#line 7318 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->last_field->default_value= (yyvsp[0].virtual_column); }
#line 34291 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 977: /* attribute: ON UPDATE_SYM NOW_SYM opt_default_time_precision  */
#line 7320 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_func_now_local(thd, (yyvsp[0].num));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            Lex->last_field->on_update= item;
          }
#line 34302 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 978: /* attribute: AUTO_INC  */
#line 7326 "/home/buildbot/git/sql/sql_yacc.yy"
                   { Lex->last_field->flags|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG; }
#line 34308 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 979: /* attribute: SERIAL_SYM DEFAULT VALUE_SYM  */
#line 7328 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG | UNIQUE_KEY_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 34318 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 980: /* attribute: COLLATE_SYM collation_name  */
#line 7334 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->charset && !my_charset_same(Lex->charset,(yyvsp[0].charset))))
              my_yyabort_error((ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                                (yyvsp[0].charset)->name,Lex->charset->csname));
            Lex->last_field->charset= (yyvsp[0].charset);
          }
#line 34329 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 982: /* opt_compression_method: %empty  */
#line 7344 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.const_simple_string)= NULL; }
#line 34335 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 983: /* opt_compression_method: equal ident  */
#line 7345 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.const_simple_string)= (yyvsp[0].ident_sys).str; }
#line 34341 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 984: /* opt_compressed: %empty  */
#line 7349 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 34347 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 985: /* opt_compressed: compressed  */
#line 7350 "/home/buildbot/git/sql/sql_yacc.yy"
                     { }
#line 34353 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 986: /* compressed: COMPRESSED_SYM opt_compression_method  */
#line 7355 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->last_field->set_compressed((yyvsp[0].const_simple_string))))
              MYSQL_YYABORT;
          }
#line 34362 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 987: /* compressed_deprecated_data_type_attribute: COMPRESSED_SYM opt_compression_method  */
#line 7363 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->last_field->set_compressed_deprecated(thd, (yyvsp[0].const_simple_string))))
              MYSQL_YYABORT;
          }
#line 34371 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 988: /* compressed_deprecated_column_attribute: COMPRESSED_SYM opt_compression_method  */
#line 7371 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->last_field->
                set_compressed_deprecated_column_attribute(thd, (yyvsp[-1].kwd).pos(), (yyvsp[0].const_simple_string))))
              MYSQL_YYABORT;
          }
#line 34381 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 989: /* asrow_attribute: not NULL_SYM  */
#line 7380 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->flags|= NOT_NULL_FLAG;
          }
#line 34389 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 990: /* asrow_attribute: opt_primary KEY_SYM  */
#line 7384 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= PRI_KEY_FLAG | NOT_NULL_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 34399 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 993: /* serial_attribute: IDENT_sys equal TEXT_STRING_sys  */
#line 7395 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[0].lex_str).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].lex_str), true,
                                       &Lex->last_field->option_list,
                                       &Lex->option_list_last);
          }
#line 34412 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 994: /* serial_attribute: IDENT_sys equal ident  */
#line 7404 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[0].ident_sys).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ident_sys), false,
                                       &Lex->last_field->option_list,
                                       &Lex->option_list_last);
          }
#line 34425 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 995: /* serial_attribute: IDENT_sys equal real_ulonglong_num  */
#line 7413 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ulonglong_number), &Lex->last_field->option_list,
                                       &Lex->option_list_last, thd->mem_root);
          }
#line 34435 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 996: /* serial_attribute: IDENT_sys equal DEFAULT  */
#line 7419 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), &Lex->last_field->option_list,
                                       &Lex->option_list_last);
          }
#line 34445 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 997: /* serial_attribute: with_or_without_system VERSIONING_SYM  */
#line 7425 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->versioning= (yyvsp[-1].vers_column_versioning);
            Lex->create_info.options|= HA_VERSIONED_TABLE;
            if (Lex->alter_info.flags & ALTER_DROP_SYSTEM_VERSIONING)
            {
              my_yyabort_error((ER_VERS_NOT_VERSIONED, MYF(0),
                       Lex->create_last_non_select_table->table_name.str));
            }
          }
#line 34459 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 998: /* with_or_without_system: WITH_SYSTEM_SYM  */
#line 7438 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_COLUMN_UNVERSIONED;
            Lex->create_info.vers_info.versioned_fields= true;
            (yyval.vers_column_versioning)= Column_definition::WITH_VERSIONING;
          }
#line 34469 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 999: /* with_or_without_system: WITHOUT SYSTEM  */
#line 7444 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_COLUMN_UNVERSIONED;
            Lex->create_info.vers_info.unversioned_fields= true;
            (yyval.vers_column_versioning)= Column_definition::WITHOUT_VERSIONING;
          }
#line 34479 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1000: /* charset: CHAR_SYM SET  */
#line 7453 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 34485 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1001: /* charset: CHARSET  */
#line 7454 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 34491 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1002: /* charset_name: ident_or_text  */
#line 7459 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.charset)=get_charset_by_csname((yyvsp[0].lex_str).str,MY_CS_PRIMARY,MYF(0)))))
              my_yyabort_error((ER_UNKNOWN_CHARACTER_SET, MYF(0), (yyvsp[0].lex_str).str));
          }
#line 34500 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1003: /* charset_name: BINARY  */
#line 7463 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.charset)= &my_charset_bin; }
#line 34506 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1004: /* charset_name_or_default: charset_name  */
#line 7467 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.charset)=(yyvsp[0].charset);   }
#line 34512 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1005: /* charset_name_or_default: DEFAULT  */
#line 7468 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.charset)=NULL; }
#line 34518 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1006: /* opt_load_data_charset: %empty  */
#line 7472 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.charset)= NULL; }
#line 34524 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1007: /* opt_load_data_charset: charset charset_name_or_default  */
#line 7473 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.charset)= (yyvsp[0].charset); }
#line 34530 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1008: /* old_or_new_charset_name: ident_or_text  */
#line 7478 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.charset)=get_charset_by_csname((yyvsp[0].lex_str).str,
                                                    MY_CS_PRIMARY,MYF(0))) &&
                         !((yyval.charset)=get_old_charset_by_name((yyvsp[0].lex_str).str))))
              my_yyabort_error((ER_UNKNOWN_CHARACTER_SET, MYF(0), (yyvsp[0].lex_str).str));
          }
#line 34541 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1009: /* old_or_new_charset_name: BINARY  */
#line 7484 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.charset)= &my_charset_bin; }
#line 34547 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1010: /* old_or_new_charset_name_or_default: old_or_new_charset_name  */
#line 7488 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.charset)=(yyvsp[0].charset);   }
#line 34553 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1011: /* old_or_new_charset_name_or_default: DEFAULT  */
#line 7489 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.charset)=NULL; }
#line 34559 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1012: /* collation_name: ident_or_text  */
#line 7494 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.charset)= mysqld_collation_get_by_name((yyvsp[0].lex_str).str))))
              MYSQL_YYABORT;
          }
#line 34568 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1013: /* opt_collate: %empty  */
#line 7501 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.charset)=NULL; }
#line 34574 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1014: /* opt_collate: COLLATE_SYM collation_name_or_default  */
#line 7502 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.charset)=(yyvsp[0].charset); }
#line 34580 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1015: /* collation_name_or_default: collation_name  */
#line 7506 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.charset)=(yyvsp[0].charset); }
#line 34586 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1016: /* collation_name_or_default: DEFAULT  */
#line 7507 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.charset)=NULL; }
#line 34592 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1017: /* opt_default: %empty  */
#line 7511 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 34598 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1018: /* opt_default: DEFAULT  */
#line 7512 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 34604 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1019: /* charset_or_alias: charset charset_name  */
#line 7516 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.charset)= (yyvsp[0].charset); }
#line 34610 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1020: /* charset_or_alias: ASCII_SYM  */
#line 7517 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.charset)= &my_charset_latin1; }
#line 34616 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1021: /* charset_or_alias: UNICODE_SYM  */
#line 7519 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.charset)= get_charset_by_csname("ucs2", MY_CS_PRIMARY,MYF(0)))))
              my_yyabort_error((ER_UNKNOWN_CHARACTER_SET, MYF(0), "ucs2"));
          }
#line 34625 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1022: /* collate: COLLATE_SYM collation_name_or_default  */
#line 7525 "/home/buildbot/git/sql/sql_yacc.yy"
                                               { (yyval.charset)= (yyvsp[0].charset); }
#line 34631 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1023: /* opt_binary: %empty  */
#line 7529 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { bincmp_collation(NULL, false); }
#line 34637 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1024: /* opt_binary: binary  */
#line 7530 "/home/buildbot/git/sql/sql_yacc.yy"
                 {}
#line 34643 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1025: /* binary: BYTE_SYM  */
#line 7534 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { bincmp_collation(&my_charset_bin, false); }
#line 34649 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1026: /* binary: charset_or_alias opt_bin_mod  */
#line 7535 "/home/buildbot/git/sql/sql_yacc.yy"
                                       { bincmp_collation((yyvsp[-1].charset), (yyvsp[0].num)); }
#line 34655 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1027: /* binary: BINARY  */
#line 7536 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { bincmp_collation(NULL, true); }
#line 34661 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1028: /* binary: BINARY charset_or_alias  */
#line 7537 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { bincmp_collation((yyvsp[0].charset), true); }
#line 34667 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1029: /* binary: charset_or_alias collate  */
#line 7539 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!(yyvsp[0].charset))
              Lex->charset= (yyvsp[-1].charset); // CHARACTER SET cs COLLATE DEFAULT
            else
            {
              if (!my_charset_same((yyvsp[0].charset), (yyvsp[-1].charset)))
                my_yyabort_error((ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                                  (yyvsp[0].charset)->name, (yyvsp[-1].charset)->csname));
              Lex->charset= (yyvsp[0].charset);
            }
          }
#line 34683 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1030: /* binary: collate  */
#line 7550 "/home/buildbot/git/sql/sql_yacc.yy"
                  { Lex->charset= (yyvsp[0].charset); }
#line 34689 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1031: /* opt_bin_mod: %empty  */
#line 7554 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.num)= false; }
#line 34695 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1032: /* opt_bin_mod: BINARY  */
#line 7555 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.num)= true; }
#line 34701 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1033: /* $@101: %empty  */
#line 7560 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if (unlikely((yyvsp[0].ulong_num) == 0))
          {
            thd->parse_error();
            MYSQL_YYABORT;
          }
        }
#line 34713 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1034: /* ws_nweights: '(' real_ulong_num $@101 ')'  */
#line 7568 "/home/buildbot/git/sql/sql_yacc.yy"
        { (yyval.ulong_num)= (yyvsp[-2].ulong_num); }
#line 34719 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1035: /* ws_level_flag_desc: ASC  */
#line 7572 "/home/buildbot/git/sql/sql_yacc.yy"
            { (yyval.ulong_num)= 0; }
#line 34725 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1036: /* ws_level_flag_desc: DESC  */
#line 7573 "/home/buildbot/git/sql/sql_yacc.yy"
               { (yyval.ulong_num)= 1 << MY_STRXFRM_DESC_SHIFT; }
#line 34731 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1037: /* ws_level_flag_reverse: REVERSE_SYM  */
#line 7577 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.ulong_num)= 1 << MY_STRXFRM_REVERSE_SHIFT; }
#line 34737 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1038: /* ws_level_flags: %empty  */
#line 7580 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.ulong_num)= 0; }
#line 34743 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1039: /* ws_level_flags: ws_level_flag_desc  */
#line 7581 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34749 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1040: /* ws_level_flags: ws_level_flag_desc ws_level_flag_reverse  */
#line 7582 "/home/buildbot/git/sql/sql_yacc.yy"
                                                   { (yyval.ulong_num)= (yyvsp[-1].ulong_num) | (yyvsp[0].ulong_num); }
#line 34755 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1041: /* ws_level_flags: ws_level_flag_reverse  */
#line 7583 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.ulong_num)= (yyvsp[0].ulong_num) ; }
#line 34761 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1042: /* ws_level_number: real_ulong_num  */
#line 7588 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.ulong_num)= (yyvsp[0].ulong_num) < 1 ? 1 : ((yyvsp[0].ulong_num) > MY_STRXFRM_NLEVELS ? MY_STRXFRM_NLEVELS : (yyvsp[0].ulong_num));
          (yyval.ulong_num)--;
        }
#line 34770 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1043: /* ws_level_list_item: ws_level_number ws_level_flags  */
#line 7596 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.ulong_num)= (1 | (yyvsp[0].ulong_num)) << (yyvsp[-1].ulong_num);
        }
#line 34778 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1044: /* ws_level_list: ws_level_list_item  */
#line 7602 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34784 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1045: /* ws_level_list: ws_level_list ',' ws_level_list_item  */
#line 7603 "/home/buildbot/git/sql/sql_yacc.yy"
                                               { (yyval.ulong_num)|= (yyvsp[0].ulong_num); }
#line 34790 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1046: /* ws_level_range: ws_level_number '-' ws_level_number  */
#line 7608 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          uint start= (yyvsp[-2].ulong_num);
          uint end= (yyvsp[0].ulong_num);
          for ((yyval.ulong_num)= 0; start <= end; start++)
            (yyval.ulong_num)|= (1 << start);
        }
#line 34801 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1047: /* ws_level_list_or_range: ws_level_list  */
#line 7617 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34807 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1048: /* ws_level_list_or_range: ws_level_range  */
#line 7618 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34813 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1049: /* opt_ws_levels: %empty  */
#line 7622 "/home/buildbot/git/sql/sql_yacc.yy"
                   { (yyval.ulong_num)= 0; }
#line 34819 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1050: /* opt_ws_levels: LEVEL_SYM ws_level_list_or_range  */
#line 7623 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34825 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1053: /* references: REFERENCES table_ident opt_ref_list opt_match_clause opt_on_update_delete  */
#line 7637 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.table)=(yyvsp[-3].table);
          }
#line 34833 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1054: /* opt_ref_list: %empty  */
#line 7644 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->ref_list.empty(); }
#line 34839 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1056: /* ref_list: ref_list ',' ident  */
#line 7650 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Key_part_spec *key= new (thd->mem_root) Key_part_spec(&(yyvsp[0].ident_sys), 0);
            if (unlikely(key == NULL))
              MYSQL_YYABORT;
            Lex->ref_list.push_back(key, thd->mem_root);
          }
#line 34850 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1057: /* ref_list: ident  */
#line 7657 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Key_part_spec *key= new (thd->mem_root) Key_part_spec(&(yyvsp[0].ident_sys), 0);
            if (unlikely(key == NULL))
              MYSQL_YYABORT;
            LEX *lex= Lex;
            lex->ref_list.empty();
            lex->ref_list.push_back(key, thd->mem_root);
          }
#line 34863 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1058: /* opt_match_clause: %empty  */
#line 7669 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_UNDEF; }
#line 34869 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1059: /* opt_match_clause: MATCH FULL  */
#line 7671 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_FULL; }
#line 34875 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1060: /* opt_match_clause: MATCH PARTIAL  */
#line 7673 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_PARTIAL; }
#line 34881 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1061: /* opt_match_clause: MATCH SIMPLE_SYM  */
#line 7675 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_SIMPLE; }
#line 34887 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1062: /* opt_on_update_delete: %empty  */
#line 7680 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= FK_OPTION_UNDEF;
            lex->fk_delete_opt= FK_OPTION_UNDEF;
          }
#line 34897 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1063: /* opt_on_update_delete: ON UPDATE_SYM delete_option  */
#line 7686 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= (yyvsp[0].m_fk_option);
            lex->fk_delete_opt= FK_OPTION_UNDEF;
          }
#line 34907 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1064: /* opt_on_update_delete: ON DELETE_SYM delete_option  */
#line 7692 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= FK_OPTION_UNDEF;
            lex->fk_delete_opt= (yyvsp[0].m_fk_option);
          }
#line 34917 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1065: /* opt_on_update_delete: ON UPDATE_SYM delete_option ON DELETE_SYM delete_option  */
#line 7699 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= (yyvsp[-3].m_fk_option);
            lex->fk_delete_opt= (yyvsp[0].m_fk_option);
          }
#line 34927 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1066: /* opt_on_update_delete: ON DELETE_SYM delete_option ON UPDATE_SYM delete_option  */
#line 7706 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= (yyvsp[0].m_fk_option);
            lex->fk_delete_opt= (yyvsp[-3].m_fk_option);
          }
#line 34937 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1067: /* delete_option: RESTRICT  */
#line 7714 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.m_fk_option)= FK_OPTION_RESTRICT; }
#line 34943 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1068: /* delete_option: CASCADE  */
#line 7715 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.m_fk_option)= FK_OPTION_CASCADE; }
#line 34949 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1069: /* delete_option: SET NULL_SYM  */
#line 7716 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.m_fk_option)= FK_OPTION_SET_NULL; }
#line 34955 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1070: /* delete_option: NO_SYM ACTION  */
#line 7717 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.m_fk_option)= FK_OPTION_NO_ACTION; }
#line 34961 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1071: /* delete_option: SET DEFAULT  */
#line 7718 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.m_fk_option)= FK_OPTION_SET_DEFAULT; }
#line 34967 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1072: /* constraint_key_type: PRIMARY_SYM KEY_SYM  */
#line 7722 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.key_type)= Key::PRIMARY; }
#line 34973 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1073: /* constraint_key_type: UNIQUE_SYM opt_key_or_index  */
#line 7723 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { (yyval.key_type)= Key::UNIQUE; }
#line 34979 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1074: /* key_or_index: KEY_SYM  */
#line 7727 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 34985 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1075: /* key_or_index: INDEX_SYM  */
#line 7728 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 34991 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1076: /* opt_key_or_index: %empty  */
#line 7732 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 34997 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1078: /* keys_or_index: KEYS  */
#line 7737 "/home/buildbot/git/sql/sql_yacc.yy"
               {}
#line 35003 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1079: /* keys_or_index: INDEX_SYM  */
#line 7738 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 35009 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1080: /* keys_or_index: INDEXES  */
#line 7739 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 35015 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1081: /* opt_unique: %empty  */
#line 7743 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.key_type)= Key::MULTIPLE; }
#line 35021 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1082: /* opt_unique: UNIQUE_SYM  */
#line 7744 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.key_type)= Key::UNIQUE; }
#line 35027 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1083: /* fulltext: FULLTEXT_SYM  */
#line 7748 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.key_type)= Key::FULLTEXT;}
#line 35033 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1084: /* spatial: SPATIAL_SYM  */
#line 7753 "/home/buildbot/git/sql/sql_yacc.yy"
          {
#ifdef HAVE_SPATIAL
            (yyval.key_type)= Key::SPATIAL;
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), sym_group_geom.name,
                              sym_group_geom.needed_define));
#endif
          }
#line 35046 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1085: /* normal_key_options: %empty  */
#line 7764 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 35052 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1086: /* normal_key_options: normal_key_opts  */
#line 7765 "/home/buildbot/git/sql/sql_yacc.yy"
                          { Lex->last_key->option_list= Lex->option_list; }
#line 35058 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1087: /* fulltext_key_options: %empty  */
#line 7769 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 35064 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1088: /* fulltext_key_options: fulltext_key_opts  */
#line 7770 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->last_key->option_list= Lex->option_list; }
#line 35070 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1089: /* spatial_key_options: %empty  */
#line 7774 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 35076 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1090: /* spatial_key_options: spatial_key_opts  */
#line 7775 "/home/buildbot/git/sql/sql_yacc.yy"
                           { Lex->last_key->option_list= Lex->option_list; }
#line 35082 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1097: /* opt_USING_key_algorithm: %empty  */
#line 7794 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.key_alg)= HA_KEY_ALG_UNDEF; }
#line 35088 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1098: /* opt_USING_key_algorithm: USING btree_or_rtree  */
#line 7795 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.key_alg)= (yyvsp[0].key_alg); }
#line 35094 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1099: /* opt_key_algorithm_clause: %empty  */
#line 7800 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.key_alg)= HA_KEY_ALG_UNDEF; }
#line 35100 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1100: /* opt_key_algorithm_clause: USING btree_or_rtree  */
#line 7801 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.key_alg)= (yyvsp[0].key_alg); }
#line 35106 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1101: /* opt_key_algorithm_clause: TYPE_SYM btree_or_rtree  */
#line 7802 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.key_alg)= (yyvsp[0].key_alg); }
#line 35112 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1102: /* key_using_alg: USING btree_or_rtree  */
#line 7807 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->last_key->key_create_info.algorithm= (yyvsp[0].key_alg); }
#line 35118 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1103: /* key_using_alg: TYPE_SYM btree_or_rtree  */
#line 7809 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->last_key->key_create_info.algorithm= (yyvsp[0].key_alg); }
#line 35124 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1104: /* all_key_opt: KEY_BLOCK_SIZE opt_equal ulong_num  */
#line 7814 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_key->key_create_info.block_size= (yyvsp[0].ulong_num);
            Lex->last_key->key_create_info.flags|= HA_USES_BLOCK_SIZE;
         }
#line 35133 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1105: /* all_key_opt: COMMENT_SYM TEXT_STRING_sys  */
#line 7819 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->last_key->key_create_info.comment= (yyvsp[0].lex_str); }
#line 35139 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1106: /* all_key_opt: IDENT_sys equal TEXT_STRING_sys  */
#line 7821 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[0].lex_str).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].lex_str), true, &Lex->option_list,
                                       &Lex->option_list_last);
          }
#line 35151 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1107: /* all_key_opt: IDENT_sys equal ident  */
#line 7829 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[0].ident_sys).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ident_sys), false, &Lex->option_list,
                                       &Lex->option_list_last);
          }
#line 35163 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1108: /* all_key_opt: IDENT_sys equal real_ulonglong_num  */
#line 7837 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (void) new (thd->mem_root)
                  engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ulonglong_number), &Lex->option_list,
                                      &Lex->option_list_last, thd->mem_root);
          }
#line 35173 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1109: /* all_key_opt: IDENT_sys equal DEFAULT  */
#line 7843 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), &Lex->option_list,
                                       &Lex->option_list_last);
          }
#line 35183 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1114: /* fulltext_key_opt: WITH PARSER_SYM IDENT_sys  */
#line 7862 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (likely(plugin_is_ready(&(yyvsp[0].ident_sys), MYSQL_FTPARSER_PLUGIN)))
              Lex->last_key->key_create_info.parser_name= (yyvsp[0].ident_sys);
            else
              my_yyabort_error((ER_FUNCTION_NOT_DEFINED, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 35194 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1115: /* btree_or_rtree: BTREE_SYM  */
#line 7871 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.key_alg)= HA_KEY_ALG_BTREE; }
#line 35200 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1116: /* btree_or_rtree: RTREE_SYM  */
#line 7872 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.key_alg)= HA_KEY_ALG_RTREE; }
#line 35206 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1117: /* btree_or_rtree: HASH_SYM  */
#line 7873 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.key_alg)= HA_KEY_ALG_HASH; }
#line 35212 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1118: /* key_list: key_list ',' key_part order_dir  */
#line 7878 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_key->columns.push_back((yyvsp[-1].key_part), thd->mem_root);
          }
#line 35220 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1119: /* key_list: key_part order_dir  */
#line 7882 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_key->columns.push_back((yyvsp[-1].key_part), thd->mem_root);
          }
#line 35228 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1120: /* key_part: ident  */
#line 7889 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.key_part)= new (thd->mem_root) Key_part_spec(&(yyvsp[0].ident_sys), 0);
            if (unlikely((yyval.key_part) == NULL))
              MYSQL_YYABORT;
          }
#line 35238 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1121: /* key_part: ident '(' NUM ')'  */
#line 7895 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            int key_part_len= atoi((yyvsp[-1].lex_str).str);
            if (unlikely(!key_part_len))
              my_yyabort_error((ER_KEY_PART_0, MYF(0), (yyvsp[-3].ident_sys).str));
            (yyval.key_part)= new (thd->mem_root) Key_part_spec(&(yyvsp[-3].ident_sys), (uint) key_part_len);
            if (unlikely((yyval.key_part) == NULL))
              MYSQL_YYABORT;
          }
#line 35251 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1122: /* opt_ident: %empty  */
#line 7906 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lex_str)= null_clex_str; }
#line 35257 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1123: /* opt_ident: field_ident  */
#line 7907 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lex_str)= (yyvsp[0].lex_str); }
#line 35263 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1124: /* string_list: text_string  */
#line 7912 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->last_field->interval_list.push_back((yyvsp[0].string), thd->mem_root); }
#line 35269 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1125: /* string_list: string_list ',' text_string  */
#line 7914 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->last_field->interval_list.push_back((yyvsp[0].string), thd->mem_root); }
#line 35275 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1126: /* $@102: %empty  */
#line 7923 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->name= null_clex_str;
            Lex->table_type= TABLE_TYPE_UNKNOWN;
            Lex->sql_command= SQLCOM_ALTER_TABLE;
            Lex->duplicates= DUP_ERROR;
            Lex->first_select_lex()->order_list.empty();
            Lex->create_info.init();
            Lex->create_info.row_type= ROW_TYPE_NOT_USED;
            Lex->alter_info.reset();
            Lex->no_write_to_binlog= 0;
            Lex->create_info.storage_media= HA_SM_DEFAULT;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            DBUG_ASSERT(!Lex->m_sql_cmd);
          }
#line 35295 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1127: /* $@103: %empty  */
#line 7939 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!Lex->first_select_lex()->
                 add_table_to_list(thd, (yyvsp[-1].table), NULL, TL_OPTION_UPDATING,
                                   TL_READ_NO_INSERT, MDL_SHARED_UPGRADABLE))
              MYSQL_YYABORT;
            Lex->first_select_lex()->db=
              (Lex->first_select_lex()->table_list.first)->db;
            Lex->create_last_non_select_table= Lex->last_table();
            Lex->mark_first_table_as_inserting();
          }
#line 35310 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1128: /* alter: ALTER $@102 alter_options TABLE_SYM table_ident opt_lock_wait_timeout $@103 alter_commands  */
#line 7950 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (likely(!Lex->m_sql_cmd))
            {
              /* Create a generic ALTER TABLE statment. */
              Lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_alter_table();
              if (unlikely(Lex->m_sql_cmd == NULL))
                MYSQL_YYABORT;
            }
            Lex->pop_select(); //main select
          }
#line 35325 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1129: /* $@104: %empty  */
#line 7961 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.default_table_charset= NULL;
            Lex->create_info.used_fields= 0;
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 35336 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1130: /* alter: ALTER DATABASE ident_or_empty $@104 create_database_options  */
#line 7968 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_ALTER_DB;
            lex->name= (yyvsp[-2].ident_sys);
            if (lex->name.str == NULL &&
                unlikely(lex->copy_db_to(&lex->name)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
          }
#line 35350 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1131: /* alter: ALTER DATABASE ident UPGRADE_SYM DATA_SYM DIRECTORY_SYM NAME_SYM  */
#line 7978 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "DATABASE"));
            lex->sql_command= SQLCOM_ALTER_DB_UPGRADE;
            lex->name= (yyvsp[-4].ident_sys);
          }
#line 35362 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1132: /* $@105: %empty  */
#line 7986 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "PROCEDURE"));
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            lex->sp_chistics.init();
          }
#line 35376 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1133: /* alter: ALTER PROCEDURE_SYM sp_name $@105 sp_a_chistics  */
#line 7996 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;

            lex->sql_command= SQLCOM_ALTER_PROCEDURE;
            lex->spname= (yyvsp[-2].spname);
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 35390 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1134: /* $@106: %empty  */
#line 8006 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "FUNCTION"));
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            lex->sp_chistics.init();
          }
#line 35404 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1135: /* alter: ALTER FUNCTION_SYM sp_name $@106 sp_a_chistics  */
#line 8016 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;

            lex->sql_command= SQLCOM_ALTER_FUNCTION;
            lex->spname= (yyvsp[-2].spname);
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 35418 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1136: /* $@107: %empty  */
#line 8026 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            if (Lex->add_alter_view(thd, (yyvsp[-4].num), (yyvsp[-2].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
          }
#line 35429 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1137: /* alter: ALTER view_algorithm definer_opt opt_view_suid VIEW_SYM table_ident $@107 view_list_opt AS view_select  */
#line 8033 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 35439 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1138: /* $@108: %empty  */
#line 8044 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            if (Lex->add_alter_view(thd, VIEW_ALGORITHM_INHERIT, (yyvsp[-2].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
          }
#line 35450 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1139: /* alter: ALTER definer_opt opt_view_suid VIEW_SYM table_ident $@108 view_list_opt AS view_select  */
#line 8051 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 35460 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1140: /* $@109: %empty  */
#line 8057 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            /*
              It is safe to use Lex->spname because
              ALTER EVENT xxx RENATE TO yyy DO ALTER EVENT RENAME TO
              is not allowed. Lex->spname is used in the case of RENAME TO
              If it had to be supported spname had to be added to
              Event_parse_data.
            */

            if (unlikely(!(Lex->event_parse_data= Event_parse_data::new_instance(thd))))
              MYSQL_YYABORT;
            Lex->event_parse_data->identifier= (yyvsp[0].spname);

            Lex->sql_command= SQLCOM_ALTER_EVENT;
            Lex->stmt_definition_begin= (yyvsp[-2].simple_string);
          }
#line 35483 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1141: /* alter: ALTER definer_opt remember_name EVENT_SYM sp_name $@109 ev_alter_on_schedule_completion opt_ev_rename_to opt_ev_status opt_ev_comment opt_ev_sql_stmt  */
#line 8080 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyvsp[-4].num) || (yyvsp[-3].num) || (yyvsp[-2].num) || (yyvsp[-1].num) || (yyvsp[0].num))))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
            /*
              sql_command is set here because some rules in ev_sql_stmt
              can overwrite it
            */
            Lex->sql_command= SQLCOM_ALTER_EVENT;
            Lex->stmt_definition_end= (char*)YYLIP->get_cpp_ptr();

            Lex->pop_select(); //main select
          }
#line 35503 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1142: /* alter: ALTER TABLESPACE alter_tablespace_info  */
#line 8096 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= ALTER_TABLESPACE;
          }
#line 35512 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1143: /* alter: ALTER LOGFILE_SYM GROUP_SYM alter_logfile_group_info  */
#line 8101 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= ALTER_LOGFILE_GROUP;
          }
#line 35521 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1144: /* alter: ALTER TABLESPACE change_tablespace_info  */
#line 8106 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= CHANGE_FILE_TABLESPACE;
          }
#line 35530 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1145: /* alter: ALTER TABLESPACE change_tablespace_access  */
#line 8111 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= ALTER_ACCESS_MODE_TABLESPACE;
          }
#line 35539 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1146: /* $@110: %empty  */
#line 8116 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_ALTER_SERVER;
            lex->server_options.reset((yyvsp[0].lex_str));
          }
#line 35549 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1147: /* alter: ALTER SERVER_SYM ident_or_text $@110 OPTIONS_SYM '(' server_options_list ')'  */
#line 8120 "/home/buildbot/git/sql/sql_yacc.yy"
                                                    { }
#line 35555 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1148: /* alter: ALTER USER_SYM opt_if_exists clear_privileges grant_list opt_require_clause opt_resource_options opt_account_locking_and_opt_password_expiration  */
#line 8124 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.set((yyvsp[-5].object_ddl_options));
            Lex->sql_command= SQLCOM_ALTER_USER;
          }
#line 35564 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1149: /* $@111: %empty  */
#line 8129 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_ALTER_SEQUENCE;
            DBUG_ASSERT(!lex->m_sql_cmd);
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 35576 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1150: /* $@112: %empty  */
#line 8137 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (!(lex->create_info.seq_create_info= new (thd->mem_root)
                                                     sequence_definition()) ||
                !lex->first_select_lex()->
                  add_table_to_list(thd, (yyvsp[0].table), NULL, TL_OPTION_SEQUENCE,
                                    TL_WRITE, MDL_EXCLUSIVE))
              MYSQL_YYABORT;
          }
#line 35590 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1151: /* alter: ALTER SEQUENCE_SYM opt_if_exists $@111 table_ident $@112 sequence_defs  */
#line 8147 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* Create a generic ALTER SEQUENCE statment. */
            Lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_alter_sequence((yyvsp[-4].object_ddl_options));
            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 35604 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1152: /* account_locking_option: LOCK_SYM  */
#line 8160 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.account_locked= ACCOUNTLOCK_LOCKED;
          }
#line 35612 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1153: /* account_locking_option: UNLOCK_SYM  */
#line 8164 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.account_locked= ACCOUNTLOCK_UNLOCKED;
          }
#line 35620 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1154: /* opt_password_expire_option: %empty  */
#line 8171 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_NOW;
          }
#line 35628 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1155: /* opt_password_expire_option: NEVER_SYM  */
#line 8175 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_NEVER;
          }
#line 35636 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1156: /* opt_password_expire_option: DEFAULT  */
#line 8179 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_DEFAULT;
          }
#line 35644 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1157: /* opt_password_expire_option: INTERVAL_SYM NUM DAY_SYM  */
#line 8183 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_INTERVAL;
            if (!(Lex->account_options.num_expiration_days= atoi((yyvsp[-1].lex_str).str)))
              my_yyabort_error((ER_WRONG_VALUE, MYF(0), "DAY", (yyvsp[-1].lex_str).str));
          }
#line 35654 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1163: /* ev_alter_on_schedule_completion: %empty  */
#line 8199 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0;}
#line 35660 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1164: /* ev_alter_on_schedule_completion: ON SCHEDULE_SYM ev_schedule_time  */
#line 8200 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.num)= 1; }
#line 35666 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1165: /* ev_alter_on_schedule_completion: ev_on_completion  */
#line 8201 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.num)= 1; }
#line 35672 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1166: /* ev_alter_on_schedule_completion: ON SCHEDULE_SYM ev_schedule_time ev_on_completion  */
#line 8202 "/home/buildbot/git/sql/sql_yacc.yy"
                                                            { (yyval.num)= 1; }
#line 35678 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1167: /* opt_ev_rename_to: %empty  */
#line 8206 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0;}
#line 35684 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1168: /* opt_ev_rename_to: RENAME TO_SYM sp_name  */
#line 8208 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Use lex's spname to hold the new name.
              The original name is in the Event_parse_data object
            */
            Lex->spname= (yyvsp[0].spname); 
            (yyval.num)= 1;
          }
#line 35697 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1169: /* opt_ev_sql_stmt: %empty  */
#line 8219 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.num)= 0;}
#line 35703 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1170: /* opt_ev_sql_stmt: DO_SYM ev_sql_stmt  */
#line 8220 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num)= 1; }
#line 35709 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1171: /* ident_or_empty: %empty  */
#line 8224 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.ident_sys)= Lex_ident_sys(); }
#line 35715 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1174: /* alter_commands: DISCARD TABLESPACE  */
#line 8231 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->m_sql_cmd= new (thd->mem_root)
              Sql_cmd_discard_import_tablespace(
                Sql_cmd_discard_import_tablespace::DISCARD_TABLESPACE);
            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35727 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1175: /* alter_commands: IMPORT TABLESPACE  */
#line 8239 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->m_sql_cmd= new (thd->mem_root)
              Sql_cmd_discard_import_tablespace(
                Sql_cmd_discard_import_tablespace::IMPORT_TABLESPACE);
            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35739 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1181: /* alter_commands: DROP PARTITION_SYM opt_if_exists alt_part_name_list  */
#line 8261 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_DROP;
            DBUG_ASSERT(!Lex->if_exists());
            Lex->create_info.add((yyvsp[-1].object_ddl_options));
          }
#line 35749 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1182: /* alter_commands: REBUILD_SYM PARTITION_SYM opt_no_write_to_binlog all_or_alt_part_name_list  */
#line 8268 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_info.partition_flags|= ALTER_PARTITION_REBUILD;
            lex->no_write_to_binlog= (yyvsp[-1].num);
          }
#line 35759 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1183: /* $@113: %empty  */
#line 8275 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_optimize_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35774 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1185: /* alter_commands: ANALYZE_SYM PARTITION_SYM opt_no_write_to_binlog all_or_alt_part_name_list  */
#line 8288 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_analyze_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
               MYSQL_YYABORT;
          }
#line 35789 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1186: /* $@114: %empty  */
#line 8299 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_check_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35803 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1188: /* $@115: %empty  */
#line 8311 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_repair_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35818 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1190: /* alter_commands: COALESCE PARTITION_SYM opt_no_write_to_binlog real_ulong_num  */
#line 8323 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_info.partition_flags|= ALTER_PARTITION_COALESCE;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->alter_info.num_parts= (yyvsp[0].ulong_num);
          }
#line 35829 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1191: /* alter_commands: TRUNCATE_SYM PARTITION_SYM all_or_alt_part_name_list  */
#line 8330 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_truncate_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35843 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1193: /* alter_commands: EXCHANGE_SYM PARTITION_SYM alt_part_name_item WITH TABLE_SYM table_ident have_partitioning  */
#line 8342 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_alter_table_exchange_partition((yyvsp[-1].table)))
              MYSQL_YYABORT;
          }
#line 35852 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1194: /* remove_partitioning: REMOVE_SYM PARTITIONING_SYM  */
#line 8350 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_REMOVE;
          }
#line 35860 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1195: /* all_or_alt_part_name_list: ALL  */
#line 8357 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_ALL;
          }
#line 35868 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1197: /* $@116: %empty  */
#line 8366 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->part_info= new (thd->mem_root) partition_info();
            if (unlikely(!lex->part_info))
              MYSQL_YYABORT;

            lex->alter_info.partition_flags|= ALTER_PARTITION_ADD;
            DBUG_ASSERT(!Lex->create_info.if_not_exists());
            lex->create_info.set((yyvsp[-1].object_ddl_options));
            lex->no_write_to_binlog= (yyvsp[0].num);
          }
#line 35884 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1198: /* add_partition_rule: ADD PARTITION_SYM opt_if_not_exists opt_no_write_to_binlog $@116 add_part_extra  */
#line 8378 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 35890 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1200: /* add_part_extra: '(' part_def_list ')'  */
#line 8384 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->part_info->num_parts= lex->part_info->partitions.elements;
          }
#line 35899 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1201: /* add_part_extra: PARTITIONS_SYM real_ulong_num  */
#line 8389 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->part_info->num_parts= (yyvsp[0].ulong_num);
          }
#line 35907 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1202: /* $@117: %empty  */
#line 8396 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->part_info= new (thd->mem_root) partition_info();
            if (unlikely(!lex->part_info))
              MYSQL_YYABORT;

            lex->no_write_to_binlog= (yyvsp[0].num);
          }
#line 35920 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1204: /* reorg_parts_rule: %empty  */
#line 8409 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_TABLE_REORG;
          }
#line 35928 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1205: /* $@118: %empty  */
#line 8413 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_REORGANIZE;
          }
#line 35936 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1206: /* reorg_parts_rule: alt_part_name_list $@118 INTO '(' part_def_list ')'  */
#line 8417 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->num_parts= part_info->partitions.elements;
          }
#line 35945 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1207: /* alt_part_name_list: alt_part_name_item  */
#line 8424 "/home/buildbot/git/sql/sql_yacc.yy"
                             {}
#line 35951 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1208: /* alt_part_name_list: alt_part_name_list ',' alt_part_name_item  */
#line 8425 "/home/buildbot/git/sql/sql_yacc.yy"
                                                    {}
#line 35957 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1209: /* alt_part_name_item: ident  */
#line 8430 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->alter_info.partition_names.push_back((yyvsp[0].ident_sys).str,
                                                                   thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 35967 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1213: /* alter_list_item: add_column column_def opt_place  */
#line 8452 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->create_last_non_select_table= lex->last_table();
            lex->alter_info.flags|= ALTER_PARSER_ADD_COLUMN;
            (yyvsp[-1].create_field)->after= (yyvsp[0].lex_str);
          }
#line 35978 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1214: /* alter_list_item: ADD key_def  */
#line 8459 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_last_non_select_table= Lex->last_table();
            Lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 35987 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1215: /* alter_list_item: ADD period_for_system_time  */
#line 8464 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_ADD_PERIOD;
          }
#line 35995 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1216: /* alter_list_item: ADD PERIOD_SYM opt_if_not_exists_table_element period_for_application_time  */
#line 8469 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Table_period_info &period= Lex->create_info.period_info;
            period.create_if_not_exists= Lex->check_exists;
            Lex->alter_info.flags|= ALTER_ADD_CHECK_CONSTRAINT;
          }
#line 36005 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1217: /* alter_list_item: add_column '(' create_field_list ')'  */
#line 8475 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.flags|= ALTER_PARSER_ADD_COLUMN;
            if (!lex->alter_info.key_list.is_empty())
              lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 36016 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1218: /* alter_list_item: ADD constraint_def  */
#line 8482 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_ADD_CHECK_CONSTRAINT;
	  }
#line 36024 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1219: /* alter_list_item: ADD CONSTRAINT IF_SYM not EXISTS field_ident check_constraint  */
#line 8486 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           Lex->alter_info.flags|= ALTER_ADD_CHECK_CONSTRAINT;
           Lex->add_constraint((yyvsp[-1].lex_str), (yyvsp[0].virtual_column), TRUE);
         }
#line 36033 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1220: /* alter_list_item: CHANGE opt_column opt_if_exists_table_element field_ident field_spec opt_place  */
#line 8492 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_CHANGE_COLUMN | ALTER_RENAME_COLUMN;
            Lex->create_last_non_select_table= Lex->last_table();
            (yyvsp[-1].create_field)->change= (yyvsp[-2].lex_str);
            (yyvsp[-1].create_field)->after= (yyvsp[0].lex_str);
          }
#line 36044 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1221: /* alter_list_item: MODIFY_SYM opt_column opt_if_exists_table_element field_spec opt_place  */
#line 8500 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_CHANGE_COLUMN;
            Lex->create_last_non_select_table= Lex->last_table();
            (yyvsp[-1].create_field)->change= (yyvsp[-1].create_field)->field_name;
            (yyvsp[-1].create_field)->after= (yyvsp[0].lex_str);
          }
#line 36055 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1222: /* alter_list_item: DROP opt_column opt_if_exists_table_element field_ident opt_restrict  */
#line 8507 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::COLUMN, (yyvsp[-1].lex_str).str, (yyvsp[-2].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_PARSER_DROP_COLUMN;
          }
#line 36069 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1223: /* alter_list_item: DROP CONSTRAINT opt_if_exists_table_element field_ident  */
#line 8517 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::CHECK_CONSTRAINT,
                                        (yyvsp[0].lex_str).str, (yyvsp[-1].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_CHECK_CONSTRAINT;
          }
#line 36084 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1224: /* alter_list_item: DROP FOREIGN KEY_SYM opt_if_exists_table_element field_ident  */
#line 8528 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::FOREIGN_KEY, (yyvsp[0].lex_str).str, (yyvsp[-1].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_FOREIGN_KEY;
          }
#line 36098 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1225: /* alter_list_item: DROP opt_constraint_no_id PRIMARY_SYM KEY_SYM  */
#line 8538 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::KEY, primary_key_name,
                                        FALSE));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_INDEX;
          }
#line 36113 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1226: /* alter_list_item: DROP key_or_index opt_if_exists_table_element field_ident  */
#line 8549 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::KEY, (yyvsp[0].lex_str).str, (yyvsp[-1].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_INDEX;
          }
#line 36127 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1227: /* alter_list_item: DISABLE_SYM KEYS  */
#line 8559 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.keys_onoff= Alter_info::DISABLE;
            lex->alter_info.flags|= ALTER_KEYS_ONOFF;
          }
#line 36137 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1228: /* alter_list_item: ENABLE_SYM KEYS  */
#line 8565 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.keys_onoff= Alter_info::ENABLE;
            lex->alter_info.flags|= ALTER_KEYS_ONOFF;
          }
#line 36147 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1229: /* alter_list_item: ALTER opt_column opt_if_exists_table_element field_ident SET DEFAULT column_default_expr  */
#line 8571 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (check_expression((yyvsp[0].virtual_column), &(yyvsp[-3].lex_str), VCOL_DEFAULT))
              MYSQL_YYABORT;
            if (unlikely(Lex->add_alter_list((yyvsp[-3].lex_str).str, (yyvsp[0].virtual_column), (yyvsp[-4].num))))
              MYSQL_YYABORT;
          }
#line 36158 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1230: /* alter_list_item: ALTER opt_column opt_if_exists_table_element field_ident DROP DEFAULT  */
#line 8578 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_alter_list((yyvsp[-2].lex_str).str, (Virtual_column_info*) 0,
                                             (yyvsp[-3].num))))
              MYSQL_YYABORT;
          }
#line 36168 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1231: /* alter_list_item: RENAME opt_to table_ident  */
#line 8584 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->first_select_lex()->db= (yyvsp[0].table)->db;
            if (lex->first_select_lex()->db.str == NULL &&
                lex->copy_db_to(&lex->first_select_lex()->db))
              MYSQL_YYABORT;
            if (unlikely(check_table_name((yyvsp[0].table)->table.str,(yyvsp[0].table)->table.length,
                                          FALSE)) ||
                ((yyvsp[0].table)->db.str && unlikely(check_db_name((LEX_STRING*) &(yyvsp[0].table)->db))))
              my_yyabort_error((ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[0].table)->table.str));
            lex->name= (yyvsp[0].table)->table;
            lex->alter_info.flags|= ALTER_RENAME;
          }
#line 36186 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1232: /* alter_list_item: CONVERT_SYM TO_SYM charset charset_name_or_default opt_collate  */
#line 8598 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!(yyvsp[-1].charset))
            {
              (yyvsp[-1].charset)= thd->variables.collation_database;
            }
            (yyvsp[0].charset)= (yyvsp[0].charset) ? (yyvsp[0].charset) : (yyvsp[-1].charset);
            if (unlikely(!my_charset_same((yyvsp[-1].charset),(yyvsp[0].charset))))
              my_yyabort_error((ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                                (yyvsp[0].charset)->name, (yyvsp[-1].charset)->csname));
            if (unlikely(Lex->create_info.add_alter_list_item_convert_to_charset((yyvsp[0].charset))))
              MYSQL_YYABORT;
            Lex->alter_info.flags|= ALTER_CONVERT_TO;
          }
#line 36204 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1233: /* alter_list_item: create_table_options_space_separated  */
#line 8612 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.flags|= ALTER_OPTIONS;
          }
#line 36213 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1234: /* alter_list_item: FORCE_SYM  */
#line 8617 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_RECREATE;
          }
#line 36221 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1235: /* alter_list_item: alter_order_clause  */
#line 8621 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.flags|= ALTER_ORDER;
          }
#line 36230 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1238: /* alter_list_item: ADD SYSTEM VERSIONING_SYM  */
#line 8628 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_ADD_SYSTEM_VERSIONING;
            Lex->create_info.options|= HA_VERSIONED_TABLE;
          }
#line 36239 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1239: /* alter_list_item: DROP SYSTEM VERSIONING_SYM  */
#line 8633 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_DROP_SYSTEM_VERSIONING;
            Lex->create_info.options&= ~HA_VERSIONED_TABLE;
          }
#line 36248 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1240: /* alter_list_item: DROP PERIOD_SYM FOR_SYSTEM_TIME_SYM  */
#line 8638 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_DROP_PERIOD;
          }
#line 36256 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1241: /* alter_list_item: DROP PERIOD_SYM opt_if_exists_table_element FOR_SYM ident  */
#line 8642 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Alter_drop *ad= new Alter_drop(Alter_drop::PERIOD, (yyvsp[0].ident_sys).str, (yyvsp[-2].num));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            Lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            Lex->alter_info.flags|= ALTER_DROP_CHECK_CONSTRAINT;
          }
#line 36268 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1247: /* alter_algorithm_option: ALGORITHM_SYM opt_equal DEFAULT  */
#line 8661 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.set_requested_algorithm(
              Alter_info::ALTER_TABLE_ALGORITHM_DEFAULT);
          }
#line 36277 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1248: /* alter_algorithm_option: ALGORITHM_SYM opt_equal ident  */
#line 8666 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->alter_info.set_requested_algorithm(&(yyvsp[0].ident_sys))))
              my_yyabort_error((ER_UNKNOWN_ALTER_ALGORITHM, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 36286 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1249: /* alter_lock_option: LOCK_SYM opt_equal DEFAULT  */
#line 8674 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.requested_lock=
              Alter_info::ALTER_TABLE_LOCK_DEFAULT;
          }
#line 36295 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1250: /* alter_lock_option: LOCK_SYM opt_equal ident  */
#line 8679 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->alter_info.set_requested_lock(&(yyvsp[0].ident_sys))))
              my_yyabort_error((ER_UNKNOWN_ALTER_LOCK, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 36304 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1251: /* opt_column: %empty  */
#line 8686 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 36310 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1252: /* opt_column: COLUMN_SYM  */
#line 8687 "/home/buildbot/git/sql/sql_yacc.yy"
                     {}
#line 36316 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1253: /* opt_ignore: %empty  */
#line 8691 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->ignore= 0;}
#line 36322 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1254: /* opt_ignore: IGNORE_SYM  */
#line 8692 "/home/buildbot/git/sql/sql_yacc.yy"
                     { Lex->ignore= 1;}
#line 36328 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1255: /* $@119: %empty  */
#line 8696 "/home/buildbot/git/sql/sql_yacc.yy"
        { Lex->ignore= 0;}
#line 36334 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1261: /* alter_option: IGNORE_SYM  */
#line 8710 "/home/buildbot/git/sql/sql_yacc.yy"
                     { Lex->ignore= 1;}
#line 36340 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1262: /* alter_option: ONLINE_SYM  */
#line 8712 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.requested_lock=
              Alter_info::ALTER_TABLE_LOCK_NONE;
          }
#line 36349 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1263: /* opt_restrict: %empty  */
#line 8719 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->drop_mode= DROP_DEFAULT; }
#line 36355 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1264: /* opt_restrict: RESTRICT  */
#line 8720 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->drop_mode= DROP_RESTRICT; }
#line 36361 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1265: /* opt_restrict: CASCADE  */
#line 8721 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->drop_mode= DROP_CASCADE; }
#line 36367 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1266: /* opt_place: %empty  */
#line 8725 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.lex_str)= null_clex_str; }
#line 36373 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1267: /* opt_place: AFTER_SYM ident  */
#line 8727 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_str)= (yyvsp[0].ident_sys);
            Lex->alter_info.flags |= ALTER_COLUMN_ORDER;
          }
#line 36382 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1268: /* opt_place: FIRST_SYM  */
#line 8732 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_str).str=    first_keyword;
	    (yyval.lex_str).length= 5; /* Length of "first" */
            Lex->alter_info.flags |= ALTER_COLUMN_ORDER;
          }
#line 36392 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1269: /* opt_to: %empty  */
#line 8740 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 36398 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1270: /* opt_to: TO_SYM  */
#line 8741 "/home/buildbot/git/sql/sql_yacc.yy"
                 {}
#line 36404 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1271: /* opt_to: '='  */
#line 8742 "/home/buildbot/git/sql/sql_yacc.yy"
              {}
#line 36410 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1272: /* opt_to: AS  */
#line 8743 "/home/buildbot/git/sql/sql_yacc.yy"
             {}
#line 36416 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1273: /* $@120: %empty  */
#line 8748 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_START;
            lex->type = 0;
            /* If you change this code don't forget to update SLAVE START too */
          }
#line 36427 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1274: /* slave: START_SYM SLAVE optional_connection_name slave_thread_opts $@120 slave_until  */
#line 8755 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36433 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1275: /* $@121: %empty  */
#line 8757 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_ALL_START;
            lex->type = 0;
            /* If you change this code don't forget to update STOP SLAVE too */
          }
#line 36444 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1276: /* slave: START_SYM ALL SLAVES slave_thread_opts $@121  */
#line 8763 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36450 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1277: /* slave: STOP_SYM SLAVE optional_connection_name slave_thread_opts  */
#line 8765 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_STOP;
            lex->type = 0;
            /* If you change this code don't forget to update SLAVE STOP too */
          }
#line 36461 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1278: /* slave: STOP_SYM ALL SLAVES slave_thread_opts  */
#line 8772 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_ALL_STOP;
            lex->type = 0;
            /* If you change this code don't forget to update SLAVE STOP too */
          }
#line 36472 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1279: /* start: START_SYM TRANSACTION_SYM opt_start_transaction_option_list  */
#line 8782 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_BEGIN;
            /* READ ONLY and READ WRITE are mutually exclusive. */
            if (unlikely(((yyvsp[0].num) & MYSQL_START_TRANS_OPT_READ_WRITE) &&
                         ((yyvsp[0].num) & MYSQL_START_TRANS_OPT_READ_ONLY)))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
            lex->start_transaction_opt= (yyvsp[0].num);
          }
#line 36489 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1280: /* opt_start_transaction_option_list: %empty  */
#line 8798 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= 0;
          }
#line 36497 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1281: /* opt_start_transaction_option_list: start_transaction_option_list  */
#line 8802 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= (yyvsp[0].num);
          }
#line 36505 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1282: /* start_transaction_option_list: start_transaction_option  */
#line 8809 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= (yyvsp[0].num);
          }
#line 36513 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1283: /* start_transaction_option_list: start_transaction_option_list ',' start_transaction_option  */
#line 8813 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= (yyvsp[-2].num) | (yyvsp[0].num);
          }
#line 36521 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1284: /* start_transaction_option: WITH CONSISTENT_SYM SNAPSHOT_SYM  */
#line 8820 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= MYSQL_START_TRANS_OPT_WITH_CONS_SNAPSHOT;
          }
#line 36529 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1285: /* start_transaction_option: READ_SYM ONLY_SYM  */
#line 8824 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= MYSQL_START_TRANS_OPT_READ_ONLY;
          }
#line 36537 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1286: /* start_transaction_option: READ_SYM WRITE_SYM  */
#line 8828 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= MYSQL_START_TRANS_OPT_READ_WRITE;
          }
#line 36545 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1287: /* $@122: %empty  */
#line 8834 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->slave_thd_opt= 0; }
#line 36551 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1288: /* slave_thread_opts: $@122 slave_thread_opt_list  */
#line 8836 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36557 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1291: /* slave_thread_opt: %empty  */
#line 8845 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 36563 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1292: /* slave_thread_opt: SQL_THREAD  */
#line 8846 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->slave_thd_opt|=SLAVE_SQL; }
#line 36569 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1293: /* slave_thread_opt: RELAY_THREAD  */
#line 8847 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->slave_thd_opt|=SLAVE_IO; }
#line 36575 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1294: /* slave_until: %empty  */
#line 8851 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 36581 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1295: /* slave_until: UNTIL_SYM slave_until_opts  */
#line 8853 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(((lex->mi.log_file_name || lex->mi.pos) &&
                         (lex->mi.relay_log_name || lex->mi.relay_log_pos)) ||
                         !((lex->mi.log_file_name && lex->mi.pos) ||
                           (lex->mi.relay_log_name && lex->mi.relay_log_pos))))
               my_yyabort_error((ER_BAD_SLAVE_UNTIL_COND, MYF(0)));
          }
#line 36594 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1296: /* slave_until: UNTIL_SYM MASTER_GTID_POS_SYM '=' TEXT_STRING_sys  */
#line 8862 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.gtid_pos_str = (yyvsp[0].lex_str);
          }
#line 36602 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1299: /* $@123: %empty  */
#line 8874 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_CHECKSUM;
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36613 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1300: /* checksum: CHECKSUM_SYM table_or_tables $@123 table_list opt_checksum_type  */
#line 8881 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36619 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1301: /* opt_checksum_type: %empty  */
#line 8885 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->check_opt.flags= 0; }
#line 36625 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1302: /* opt_checksum_type: QUICK  */
#line 8886 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->check_opt.flags= T_QUICK; }
#line 36631 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1303: /* opt_checksum_type: EXTENDED_SYM  */
#line 8887 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->check_opt.flags= T_EXTEND; }
#line 36637 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1305: /* $@124: %empty  */
#line 8893 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->table_type= TABLE_TYPE_VIEW; }
#line 36643 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1307: /* $@125: %empty  */
#line 8899 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_REPAIR;
            lex->no_write_to_binlog= (yyvsp[0].num);
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36657 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1308: /* repair: REPAIR opt_no_write_to_binlog $@125 repair_table_or_view  */
#line 8909 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_repair_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 36669 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1309: /* opt_mi_repair_type: %empty  */
#line 8919 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->check_opt.flags = T_MEDIUM; }
#line 36675 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1310: /* opt_mi_repair_type: mi_repair_types  */
#line 8920 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 36681 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1311: /* mi_repair_types: mi_repair_type  */
#line 8924 "/home/buildbot/git/sql/sql_yacc.yy"
                         {}
#line 36687 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1312: /* mi_repair_types: mi_repair_type mi_repair_types  */
#line 8925 "/home/buildbot/git/sql/sql_yacc.yy"
                                         {}
#line 36693 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1313: /* mi_repair_type: QUICK  */
#line 8929 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->check_opt.flags|= T_QUICK; }
#line 36699 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1314: /* mi_repair_type: EXTENDED_SYM  */
#line 8930 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->check_opt.flags|= T_EXTEND; }
#line 36705 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1315: /* mi_repair_type: USE_FRM  */
#line 8931 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->check_opt.sql_flags|= TT_USEFRM; }
#line 36711 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1316: /* opt_view_repair_type: %empty  */
#line 8935 "/home/buildbot/git/sql/sql_yacc.yy"
                         { }
#line 36717 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1317: /* opt_view_repair_type: FROM MYSQL_SYM  */
#line 8936 "/home/buildbot/git/sql/sql_yacc.yy"
                         { Lex->check_opt.sql_flags|= TT_FROM_MYSQL; }
#line 36723 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1318: /* $@126: %empty  */
#line 8941 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_ANALYZE;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36737 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1319: /* analyze: ANALYZE_SYM opt_no_write_to_binlog table_or_tables $@126 analyze_table_list  */
#line 8951 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_analyze_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 36749 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1323: /* opt_persistent_stat_clause: %empty  */
#line 8971 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36755 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1324: /* opt_persistent_stat_clause: PERSISTENT_SYM FOR_SYM persistent_stat_spec  */
#line 8973 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            thd->lex->with_persistent_for_clause= TRUE;
          }
#line 36763 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1325: /* persistent_stat_spec: ALL  */
#line 8980 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36769 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1326: /* persistent_stat_spec: COLUMNS persistent_column_stat_spec INDEXES persistent_index_stat_spec  */
#line 8982 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36775 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1327: /* persistent_column_stat_spec: ALL  */
#line 8986 "/home/buildbot/git/sql/sql_yacc.yy"
              {}
#line 36781 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1328: /* $@127: %empty  */
#line 8988 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            LEX* lex= thd->lex;
            lex->column_list= new (thd->mem_root) List<LEX_STRING>;
            if (unlikely(lex->column_list == NULL))
              MYSQL_YYABORT;
          }
#line 36792 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1329: /* persistent_column_stat_spec: '(' $@127 table_column_list ')'  */
#line 8996 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 36798 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1330: /* persistent_index_stat_spec: ALL  */
#line 9000 "/home/buildbot/git/sql/sql_yacc.yy"
              {}
#line 36804 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1331: /* $@128: %empty  */
#line 9002 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            LEX* lex= thd->lex;
            lex->index_list= new (thd->mem_root) List<LEX_STRING>;
            if (unlikely(lex->index_list == NULL))
              MYSQL_YYABORT;
          }
#line 36815 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1332: /* persistent_index_stat_spec: '(' $@128 table_index_list ')'  */
#line 9010 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 36821 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1333: /* table_column_list: %empty  */
#line 9015 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36827 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1334: /* table_column_list: ident  */
#line 9017 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->column_list->push_back((LEX_STRING*)
                thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_STRING)), thd->mem_root);
          }
#line 36836 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1335: /* table_column_list: table_column_list ',' ident  */
#line 9022 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->column_list->push_back((LEX_STRING*)
                thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_STRING)), thd->mem_root);
          }
#line 36845 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1336: /* table_index_list: %empty  */
#line 9030 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36851 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1339: /* table_index_name: ident  */
#line 9037 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->index_list->push_back((LEX_STRING*)
                                       thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_STRING)),
                                       thd->mem_root);
          }
#line 36861 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1340: /* table_index_name: PRIMARY_SYM  */
#line 9044 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX_STRING str= {(char*) "PRIMARY", 7};
            Lex->index_list->push_back((LEX_STRING*)
                                        thd->memdup(&str, sizeof(LEX_STRING)),
                                        thd->mem_root);
          }
#line 36872 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1341: /* binlog_base64_event: BINLOG_SYM TEXT_STRING_sys  */
#line 9054 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_BINLOG_BASE64_EVENT;
            Lex->comment= (yyvsp[0].lex_str);
            Lex->ident.str=    NULL;
            Lex->ident.length= 0;
          }
#line 36883 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1342: /* binlog_base64_event: BINLOG_SYM '@' ident_or_text ',' '@' ident_or_text  */
#line 9062 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_BINLOG_BASE64_EVENT;
            Lex->comment= (yyvsp[-3].lex_str);
            Lex->ident=   (yyvsp[0].lex_str);
          }
#line 36893 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1344: /* $@129: %empty  */
#line 9072 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->table_type= TABLE_TYPE_VIEW; }
#line 36899 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1346: /* $@130: %empty  */
#line 9077 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;

            lex->sql_command = SQLCOM_CHECK;
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36913 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1347: /* check: CHECK_SYM $@130 check_view_or_table  */
#line 9087 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX* lex= thd->lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "CHECK"));
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_check_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 36927 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1348: /* opt_mi_check_type: %empty  */
#line 9099 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->check_opt.flags = T_MEDIUM; }
#line 36933 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1349: /* opt_mi_check_type: mi_check_types  */
#line 9100 "/home/buildbot/git/sql/sql_yacc.yy"
                         {}
#line 36939 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1350: /* mi_check_types: mi_check_type  */
#line 9104 "/home/buildbot/git/sql/sql_yacc.yy"
                        {}
#line 36945 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1351: /* mi_check_types: mi_check_type mi_check_types  */
#line 9105 "/home/buildbot/git/sql/sql_yacc.yy"
                                       {}
#line 36951 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1352: /* mi_check_type: QUICK  */
#line 9109 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.flags|= T_QUICK; }
#line 36957 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1353: /* mi_check_type: FAST_SYM  */
#line 9110 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.flags|= T_FAST; }
#line 36963 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1354: /* mi_check_type: MEDIUM_SYM  */
#line 9111 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.flags|= T_MEDIUM; }
#line 36969 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1355: /* mi_check_type: EXTENDED_SYM  */
#line 9112 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.flags|= T_EXTEND; }
#line 36975 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1356: /* mi_check_type: CHANGED  */
#line 9113 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.flags|= T_CHECK_ONLY_CHANGED; }
#line 36981 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1357: /* mi_check_type: FOR_SYM UPGRADE_SYM  */
#line 9114 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.sql_flags|= TT_FOR_UPGRADE; }
#line 36987 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1358: /* opt_view_check_type: %empty  */
#line 9118 "/home/buildbot/git/sql/sql_yacc.yy"
                              { }
#line 36993 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1359: /* opt_view_check_type: FOR_SYM UPGRADE_SYM  */
#line 9119 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.sql_flags|= TT_FOR_UPGRADE; }
#line 36999 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1360: /* $@131: %empty  */
#line 9124 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_OPTIMIZE;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 37013 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1361: /* optimize: OPTIMIZE opt_no_write_to_binlog table_or_tables $@131 table_list opt_lock_wait_timeout  */
#line 9134 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_optimize_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 37025 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1362: /* opt_no_write_to_binlog: %empty  */
#line 9144 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0; }
#line 37031 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1363: /* opt_no_write_to_binlog: NO_WRITE_TO_BINLOG  */
#line 9145 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num)= 1; }
#line 37037 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1364: /* opt_no_write_to_binlog: LOCAL_SYM  */
#line 9146 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.num)= 1; }
#line 37043 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1365: /* $@132: %empty  */
#line 9151 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_RENAME_TABLE;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 37053 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1366: /* rename: RENAME table_or_tables $@132 table_to_table_list  */
#line 9157 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 37061 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1367: /* rename: RENAME USER_SYM clear_privileges rename_list  */
#line 9161 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_RENAME_USER;
          }
#line 37069 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1368: /* rename_list: user TO_SYM user  */
#line 9168 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[-2].lex_user), thd->mem_root) ||
                         Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 37079 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1369: /* rename_list: rename_list ',' user TO_SYM user  */
#line 9174 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[-2].lex_user), thd->mem_root) ||
                         Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 37089 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1372: /* table_to_table: table_ident opt_lock_wait_timeout TO_SYM table_ident  */
#line 9188 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            SELECT_LEX *sl= lex->current_select;
            if (unlikely(!sl->add_table_to_list(thd, (yyvsp[-3].table),NULL,
                                                TL_OPTION_UPDATING,
                                                TL_IGNORE, MDL_EXCLUSIVE)) ||
                unlikely(!sl->add_table_to_list(thd, (yyvsp[0].table), NULL,
                                                TL_OPTION_UPDATING,
                                                TL_IGNORE, MDL_EXCLUSIVE)))
              MYSQL_YYABORT;
          }
#line 37105 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1373: /* $@133: %empty  */
#line 9203 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.reset();
          }
#line 37113 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1374: /* keycache: CACHE_SYM INDEX_SYM $@133 keycache_list_or_parts IN_SYM key_cache_name  */
#line 9207 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ASSIGN_TO_KEYCACHE;
            lex->ident= (yyvsp[0].lex_str);
          }
#line 37123 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1379: /* assign_to_keycache: table_ident cache_keys_spec  */
#line 9226 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-1].table), NULL, 0, TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 37135 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1380: /* assign_to_keycache_parts: table_ident adm_partition cache_keys_spec  */
#line 9237 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-2].table), NULL, 0, TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 37147 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1381: /* key_cache_name: ident  */
#line 9247 "/home/buildbot/git/sql/sql_yacc.yy"
                   { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 37153 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1382: /* key_cache_name: DEFAULT  */
#line 9248 "/home/buildbot/git/sql/sql_yacc.yy"
                   { (yyval.lex_str) = default_key_cache_base; }
#line 37159 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1383: /* $@134: %empty  */
#line 9253 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_PRELOAD_KEYS;
            lex->alter_info.reset();
            if (lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 37171 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1384: /* preload: LOAD INDEX_SYM INTO CACHE_SYM $@134 preload_list_or_parts  */
#line 9261 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 37179 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1389: /* preload_keys: table_ident cache_keys_spec opt_ignore_leaves  */
#line 9278 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-2].table), NULL, (yyvsp[0].num), TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 37191 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1390: /* preload_keys_parts: table_ident adm_partition cache_keys_spec opt_ignore_leaves  */
#line 9289 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-3].table), NULL, (yyvsp[0].num), TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 37203 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1391: /* $@135: %empty  */
#line 9300 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_ADMIN;
          }
#line 37211 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1393: /* $@136: %empty  */
#line 9307 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->first_select_lex()->alloc_index_hints(thd);
            Select->set_index_hint_type(INDEX_HINT_USE,
                                        INDEX_HINT_MASK_ALL);
          }
#line 37221 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1395: /* cache_key_list_or_empty: %empty  */
#line 9316 "/home/buildbot/git/sql/sql_yacc.yy"
                      { }
#line 37227 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1397: /* opt_ignore_leaves: %empty  */
#line 9322 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)= 0; }
#line 37233 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1398: /* opt_ignore_leaves: IGNORE_SYM LEAVES  */
#line 9323 "/home/buildbot/git/sql/sql_yacc.yy"
                            { (yyval.num)= TL_OPTION_IGNORE_LEAVES; }
#line 37239 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1399: /* $@137: %empty  */
#line 9333 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex_unit)->fake_select_lex ?
                                 (yyvsp[0].select_lex_unit)->fake_select_lex :
                                 (yyvsp[0].select_lex_unit)->first_select()))
              MYSQL_YYABORT;
          }
#line 37250 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1400: /* select: query_expression_no_with_clause $@137 opt_procedure_or_into  */
#line 9340 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select();
            (yyvsp[-2].select_lex_unit)->set_with_clause(NULL);
            if (Lex->select_finalize((yyvsp[-2].select_lex_unit), (yyvsp[0].select_lock)))
              MYSQL_YYABORT;
          }
#line 37261 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1401: /* $@138: %empty  */
#line 9347 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex_unit)->fake_select_lex ?
                                 (yyvsp[0].select_lex_unit)->fake_select_lex :
                                 (yyvsp[0].select_lex_unit)->first_select()))
              MYSQL_YYABORT;
          }
#line 37272 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1402: /* select: with_clause query_expression_no_with_clause $@138 opt_procedure_or_into  */
#line 9354 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select();
            (yyvsp[-2].select_lex_unit)->set_with_clause((yyvsp[-3].with_clause));
            (yyvsp[-3].with_clause)->attach_to((yyvsp[-2].select_lex_unit)->first_select());
            if (Lex->select_finalize((yyvsp[-2].select_lex_unit), (yyvsp[0].select_lock)))
              MYSQL_YYABORT;
          }
#line 37284 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1403: /* $@139: %empty  */
#line 9365 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex)))
              MYSQL_YYABORT;
          }
#line 37293 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1404: /* select_into: select_into_query_specification $@139 opt_order_limit_lock  */
#line 9370 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX_UNIT *unit;
            if (!(unit  = Lex->create_unit((yyvsp[-2].select_lex))))
              MYSQL_YYABORT;
            if ((yyvsp[0].order_limit_lock))
              unit= Lex->add_tail_to_query_expression_body(unit, (yyvsp[0].order_limit_lock));
            if (Lex->select_finalize(unit))
              MYSQL_YYABORT;
          }
#line 37307 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1405: /* $@140: %empty  */
#line 9381 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex)))
              MYSQL_YYABORT;
          }
#line 37316 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1406: /* select_into: with_clause select_into_query_specification $@140 opt_order_limit_lock  */
#line 9386 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX_UNIT *unit;
            if (!(unit  = Lex->create_unit((yyvsp[-2].select_lex))))
              MYSQL_YYABORT;
            if ((yyvsp[0].order_limit_lock))
              unit= Lex->add_tail_to_query_expression_body(unit, (yyvsp[0].order_limit_lock));
            unit->set_with_clause((yyvsp[-3].with_clause));
            (yyvsp[-3].with_clause)->attach_to((yyvsp[-2].select_lex));
            if (Lex->select_finalize(unit))
              MYSQL_YYABORT;
          }
#line 37332 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1407: /* simple_table: query_specification  */
#line 9400 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.select_lex)= (yyvsp[0].select_lex); }
#line 37338 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1408: /* simple_table: table_value_constructor  */
#line 9401 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.select_lex)= (yyvsp[0].select_lex); }
#line 37344 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1409: /* $@141: %empty  */
#line 9406 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->parsed_TVC_start())
              MYSQL_YYABORT;
	  }
#line 37353 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1410: /* table_value_constructor: VALUES $@141 values_list  */
#line 9411 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.select_lex)= Lex->parsed_TVC_end()))
	      MYSQL_YYABORT;
	  }
#line 37362 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1411: /* $@142: %empty  */
#line 9419 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel;
            LEX *lex= Lex;
            if (!(sel= lex->alloc_select(TRUE)) ||
                  lex->push_select(sel))
              MYSQL_YYABORT;
            sel->init_select();
            sel->braces= FALSE;
          }
#line 37376 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1412: /* $@143: %empty  */
#line 9429 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->parsing_place= SELECT_LIST;
          }
#line 37384 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1413: /* query_specification_start: SELECT_SYM $@142 select_options $@143 select_item_list  */
#line 9433 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->parsing_place= NO_MATTER;
          }
#line 37392 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1414: /* query_specification: query_specification_start opt_from_clause opt_where_clause opt_group_clause opt_having_clause opt_window_clause  */
#line 9445 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_lex)= Lex->pop_select();
          }
#line 37400 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1415: /* select_into_query_specification: query_specification_start into opt_from_clause opt_where_clause opt_group_clause opt_having_clause opt_window_clause  */
#line 9458 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_lex)= Lex->pop_select();
          }
#line 37408 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1416: /* query_expression: query_expression_no_with_clause  */
#line 9516 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[0].select_lex_unit)->set_with_clause(NULL);
            (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit);
          }
#line 37417 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1417: /* query_expression: with_clause query_expression_no_with_clause  */
#line 9522 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[0].select_lex_unit)->set_with_clause((yyvsp[-1].with_clause));
            (yyvsp[-1].with_clause)->attach_to((yyvsp[0].select_lex_unit)->first_select());
            (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit);
          }
#line 37427 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1418: /* query_expression_no_with_clause: query_expression_body_ext  */
#line 9535 "/home/buildbot/git/sql/sql_yacc.yy"
                                    { (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit); }
#line 37433 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1419: /* query_expression_no_with_clause: query_expression_body_ext_parens  */
#line 9536 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit); }
#line 37439 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1420: /* $@144: %empty  */
#line 9551 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[0].select_lex_unit)->first_select()->next_select())
            {
              if (Lex->parsed_multi_operand_query_expression_body((yyvsp[0].select_lex_unit)))
                MYSQL_YYABORT;
            }
          }
#line 37451 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1421: /* query_expression_body_ext: query_expression_body $@144 opt_query_expression_tail  */
#line 9559 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!(yyvsp[0].order_limit_lock))
              (yyval.select_lex_unit)= (yyvsp[-2].select_lex_unit);
            else
              (yyval.select_lex_unit)= Lex->add_tail_to_query_expression_body((yyvsp[-2].select_lex_unit), (yyvsp[0].order_limit_lock));
          }
#line 37462 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1422: /* $@145: %empty  */
#line 9566 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->push_select(!(yyvsp[0].select_lex_unit)->first_select()->next_select() ?
                               (yyvsp[0].select_lex_unit)->first_select() : (yyvsp[0].select_lex_unit)->fake_select_lex);
          }
#line 37471 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1423: /* query_expression_body_ext: query_expression_body_ext_parens $@145 query_expression_tail  */
#line 9571 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.select_lex_unit)= Lex->add_tail_to_query_expression_body_ext_parens((yyvsp[-2].select_lex_unit), (yyvsp[0].order_limit_lock))))
               MYSQL_YYABORT;
          }
#line 37480 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1424: /* query_expression_body_ext_parens: '(' query_expression_body_ext_parens ')'  */
#line 9579 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_lex_unit)= (yyvsp[-1].select_lex_unit); }
#line 37486 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1425: /* query_expression_body_ext_parens: '(' query_expression_body_ext ')'  */
#line 9581 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= (yyvsp[-1].select_lex_unit)->first_select()->next_select() ?
                               (yyvsp[-1].select_lex_unit)->fake_select_lex : (yyvsp[-1].select_lex_unit)->first_select();
            sel->braces= true;
            (yyval.select_lex_unit)= (yyvsp[-1].select_lex_unit);
          }
#line 37497 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1426: /* query_expression_body: query_simple  */
#line 9596 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->push_select((yyvsp[0].select_lex));
            if (!((yyval.select_lex_unit)= Lex->create_unit((yyvsp[0].select_lex))))
              MYSQL_YYABORT;
          }
#line 37507 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1427: /* $@146: %empty  */
#line 9603 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!(yyvsp[-1].select_lex_unit)->first_select()->next_select())
            {
              Lex->pop_select();
            }
          }
#line 37518 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1428: /* query_expression_body: query_expression_body unit_type_decl $@146 query_primary  */
#line 9610 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.select_lex_unit)= Lex->add_primary_to_query_expression_body((yyvsp[-3].select_lex_unit), (yyvsp[0].select_lex),
                                                                (yyvsp[-2].unit_operation).unit_type,
                                                                (yyvsp[-2].unit_operation).distinct,
                                                                FALSE)))
              MYSQL_YYABORT;
          }
#line 37530 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1429: /* query_expression_body: query_expression_body_ext_parens unit_type_decl query_primary  */
#line 9620 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.select_lex_unit)= Lex->add_primary_to_query_expression_body_ext_parens(
                                                                (yyvsp[-2].select_lex_unit), (yyvsp[0].select_lex),
                                                                (yyvsp[-1].unit_operation).unit_type,
                                                                (yyvsp[-1].unit_operation).distinct)))
              MYSQL_YYABORT;
          }
#line 37542 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1430: /* query_primary: query_simple  */
#line 9636 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_lex)= (yyvsp[0].select_lex); }
#line 37548 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1431: /* query_primary: query_expression_body_ext_parens  */
#line 9638 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_lex)= (yyvsp[0].select_lex_unit)->first_select(); }
#line 37554 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1432: /* query_simple: simple_table  */
#line 9647 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.select_lex)= (yyvsp[0].select_lex);}
#line 37560 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1433: /* subselect: query_expression  */
#line 9652 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.select_lex)= Lex->parsed_subselect((yyvsp[0].select_lex_unit))))
              MYSQL_YYABORT;
          }
#line 37569 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1434: /* subquery: query_expression_body_ext_parens  */
#line 9693 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!(yyvsp[0].select_lex_unit)->fake_select_lex)
              (yyvsp[0].select_lex_unit)->first_select()->braces= false;
            else
              (yyvsp[0].select_lex_unit)->fake_select_lex->braces= false;
            if (!((yyval.select_lex)= Lex->parsed_subselect((yyvsp[0].select_lex_unit))))
              MYSQL_YYABORT;
          }
#line 37582 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1435: /* subquery: '(' with_clause query_expression_no_with_clause ')'  */
#line 9702 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-1].select_lex_unit)->set_with_clause((yyvsp[-2].with_clause));
            (yyvsp[-2].with_clause)->attach_to((yyvsp[-1].select_lex_unit)->first_select());
            if (!((yyval.select_lex)= Lex->parsed_subselect((yyvsp[-1].select_lex_unit))))
              MYSQL_YYABORT;
          }
#line 37593 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1439: /* table_reference_list: join_table_list  */
#line 9721 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->context.table_list=
              Select->context.first_name_resolution_table=
                Select->table_list.first;
          }
#line 37603 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1442: /* select_options: select_option_list  */
#line 9736 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((Select->options & SELECT_DISTINCT) &&
                         (Select->options & SELECT_ALL)))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "ALL", "DISTINCT"));
          }
#line 37613 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1443: /* opt_history_unit: %empty  */
#line 9745 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.vers_range_unit)= VERS_UNDEFINED;
          }
#line 37621 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1444: /* opt_history_unit: TRANSACTION_SYM  */
#line 9749 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.vers_range_unit)= VERS_TRX_ID;
          }
#line 37629 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1445: /* opt_history_unit: TIMESTAMP  */
#line 9753 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.vers_range_unit)= VERS_TIMESTAMP;
          }
#line 37637 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1446: /* history_point: TIMESTAMP TEXT_STRING  */
#line 9760 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item;
            if (!(item= type_handler_datetime.create_literal_item(thd,
                                                     (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                     YYCSCL, true)))
              MYSQL_YYABORT;
            (yyval.vers_history_point)= Vers_history_point(VERS_TIMESTAMP, item);
          }
#line 37650 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1447: /* history_point: function_call_keyword_timestamp  */
#line 9769 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.vers_history_point)= Vers_history_point(VERS_TIMESTAMP, (yyvsp[0].item));
          }
#line 37658 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1448: /* history_point: opt_history_unit bit_expr  */
#line 9773 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.vers_history_point)= Vers_history_point((yyvsp[-1].vers_range_unit), (yyvsp[0].item));
          }
#line 37666 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1449: /* for_portion_of_time_clause: FOR_SYM PORTION_SYM OF_SYM remember_tok_start ident FROM bit_expr TO_SYM bit_expr  */
#line 9781 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(0 == strcasecmp((yyvsp[-4].ident_sys).str, "SYSTEM_TIME")))
            {
              thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-5].simple_string));
              MYSQL_YYABORT;
            }
            Lex->period_conditions.init(SYSTEM_TIME_FROM_TO,
                                        Vers_history_point(VERS_TIMESTAMP, (yyvsp[-2].item)),
                                        Vers_history_point(VERS_TIMESTAMP, (yyvsp[0].item)),
                                        (yyvsp[-4].ident_sys));
          }
#line 37682 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1450: /* opt_for_portion_of_time_clause: %empty  */
#line 9796 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= false;
          }
#line 37690 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1451: /* opt_for_portion_of_time_clause: for_portion_of_time_clause  */
#line 9800 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= true;
          }
#line 37698 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1452: /* opt_for_system_time_clause: %empty  */
#line 9807 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= false;
          }
#line 37706 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1453: /* opt_for_system_time_clause: FOR_SYSTEM_TIME_SYM system_time_expr  */
#line 9811 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= true;
          }
#line 37714 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1454: /* system_time_expr: AS OF_SYM history_point  */
#line 9818 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_AS_OF, (yyvsp[0].vers_history_point));
          }
#line 37722 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1455: /* system_time_expr: ALL  */
#line 9822 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_ALL);
          }
#line 37730 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1456: /* system_time_expr: FROM history_point TO_SYM history_point  */
#line 9826 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_FROM_TO, (yyvsp[-2].vers_history_point), (yyvsp[0].vers_history_point));
          }
#line 37738 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1457: /* system_time_expr: BETWEEN_SYM history_point AND_SYM history_point  */
#line 9830 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_BETWEEN, (yyvsp[-2].vers_history_point), (yyvsp[0].vers_history_point));
          }
#line 37746 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1461: /* select_option: SQL_NO_CACHE_SYM  */
#line 9843 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Allow this flag once per query.
            */
            if (Select->options & OPTION_NO_QUERY_CACHE)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "SQL_NO_CACHE"));
            Select->options|= OPTION_NO_QUERY_CACHE;
          }
#line 37759 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1462: /* select_option: SQL_CACHE_SYM  */
#line 9852 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Allow this flag once per query.
            */
            if (Select->options & OPTION_TO_QUERY_CACHE)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "SQL_CACHE"));
            Select->options|= OPTION_TO_QUERY_CACHE;
          }
#line 37772 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1463: /* select_lock_type: FOR_SYM UPDATE_SYM opt_lock_wait_timeout_new  */
#line 9865 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_lock)= (yyvsp[0].select_lock);
            (yyval.select_lock).defined_lock= TRUE;
            (yyval.select_lock).update_lock= TRUE;
          }
#line 37782 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1464: /* select_lock_type: LOCK_SYM IN_SYM SHARE_SYM MODE_SYM opt_lock_wait_timeout_new  */
#line 9871 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_lock)= (yyvsp[0].select_lock);
            (yyval.select_lock).defined_lock= TRUE;
            (yyval.select_lock).update_lock= FALSE;
          }
#line 37792 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1465: /* opt_select_lock_type: %empty  */
#line 9881 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.select_lock).empty();
        }
#line 37800 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1466: /* opt_select_lock_type: select_lock_type  */
#line 9885 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.select_lock)= (yyvsp[0].select_lock);
        }
#line 37808 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1467: /* opt_lock_wait_timeout_new: %empty  */
#line 9893 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.select_lock).empty();
        }
#line 37816 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1468: /* opt_lock_wait_timeout_new: WAIT_SYM ulong_num  */
#line 9897 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.select_lock).defined_timeout= TRUE;
          (yyval.select_lock).timeout= (yyvsp[0].ulong_num);
        }
#line 37825 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1469: /* opt_lock_wait_timeout_new: NOWAIT_SYM  */
#line 9902 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.select_lock).defined_timeout= TRUE;
          (yyval.select_lock).timeout= 0;
        }
#line 37834 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1472: /* select_item_list: '*'  */
#line 9912 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root)
                          Item_field(thd, &thd->lex->current_select->context,
                                     NULL, NULL, &star_clex_str);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            if (unlikely(add_item_to_list(thd, item)))
              MYSQL_YYABORT;
            (thd->lex->current_select->with_wild)++;
          }
#line 37849 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1473: /* select_item: remember_name select_sublist_qualified_asterisk remember_end  */
#line 9926 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(add_item_to_list(thd, (yyvsp[-1].item))))
              MYSQL_YYABORT;
          }
#line 37858 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1474: /* select_item: remember_name expr remember_end select_alias  */
#line 9931 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT((yyvsp[-3].simple_string) < (yyvsp[-1].simple_string));

            if (unlikely(add_item_to_list(thd, (yyvsp[-2].item))))
              MYSQL_YYABORT;
            if ((yyvsp[0].lex_str).str)
            {
              if (unlikely(Lex->sql_command == SQLCOM_CREATE_VIEW &&
                          check_column_name((yyvsp[0].lex_str).str)))
                my_yyabort_error((ER_WRONG_COLUMN_NAME, MYF(0), (yyvsp[0].lex_str).str));
              (yyvsp[-2].item)->is_autogenerated_name= FALSE;
              (yyvsp[-2].item)->set_name(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length, system_charset_info);
            }
            else if (!(yyvsp[-2].item)->name.str || (yyvsp[-2].item)->name.str == item_empty_name)
            {
              (yyvsp[-2].item)->set_name(thd, (yyvsp[-3].simple_string), (uint) ((yyvsp[-1].simple_string) - (yyvsp[-3].simple_string)), thd->charset());
            }
          }
#line 37881 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1475: /* remember_tok_start: %empty  */
#line 9952 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.simple_string)= (char*) YYLIP->get_tok_start();
          }
#line 37889 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1476: /* remember_name: %empty  */
#line 9958 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.simple_string)= (char*) YYLIP->get_cpp_tok_start();
          }
#line 37897 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1477: /* remember_end: %empty  */
#line 9964 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.simple_string)= (char*) YYLIP->get_cpp_tok_end_rtrim();
          }
#line 37905 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1478: /* select_alias: %empty  */
#line 9970 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lex_str)=null_clex_str;}
#line 37911 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1479: /* select_alias: AS ident  */
#line 9971 "/home/buildbot/git/sql/sql_yacc.yy"
                   { (yyval.lex_str)=(yyvsp[0].ident_sys); }
#line 37917 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1480: /* select_alias: AS TEXT_STRING_sys  */
#line 9972 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.lex_str)=(yyvsp[0].lex_str); }
#line 37923 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1481: /* select_alias: ident  */
#line 9973 "/home/buildbot/git/sql/sql_yacc.yy"
                { (yyval.lex_str)=(yyvsp[0].ident_sys); }
#line 37929 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1482: /* select_alias: TEXT_STRING_sys  */
#line 9974 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.lex_str)=(yyvsp[0].lex_str); }
#line 37935 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1483: /* opt_default_time_precision: %empty  */
#line 9978 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.num)= NOT_FIXED_DEC;  }
#line 37941 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1484: /* opt_default_time_precision: '(' ')'  */
#line 9979 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.num)= NOT_FIXED_DEC;  }
#line 37947 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1485: /* opt_default_time_precision: '(' real_ulong_num ')'  */
#line 9980 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.num)= (yyvsp[-1].ulong_num); }
#line 37953 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1486: /* opt_time_precision: %empty  */
#line 9984 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.num)= 0;  }
#line 37959 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1487: /* opt_time_precision: '(' ')'  */
#line 9985 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.num)= 0;  }
#line 37965 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1488: /* opt_time_precision: '(' real_ulong_num ')'  */
#line 9986 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.num)= (yyvsp[-1].ulong_num); }
#line 37971 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1489: /* optional_braces: %empty  */
#line 9990 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 37977 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1490: /* optional_braces: '(' ')'  */
#line 9991 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 37983 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1491: /* expr: expr or expr  */
#line 9997 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Design notes:
              Do not use a manually maintained stack like thd->lex->xxx_list,
              but use the internal bison stack ($$, $1 and $3) instead.
              Using the bison stack is:
              - more robust to changes in the grammar,
              - guaranteed to be in sync with the parser state,
              - better for performances (no memory allocation).
            */
            Item_cond_or *item1;
            Item_cond_or *item3;
            if (is_cond_or((yyvsp[-2].item)))
            {
              item1= (Item_cond_or*) (yyvsp[-2].item);
              if (is_cond_or((yyvsp[0].item)))
              {
                item3= (Item_cond_or*) (yyvsp[0].item);
                /*
                  (X1 OR X2) OR (Y1 OR Y2) ==> OR (X1, X2, Y1, Y2)
                */
                item3->add_at_head(item1->argument_list());
                (yyval.item) = (yyvsp[0].item);
              }
              else
              {
                /*
                  (X1 OR X2) OR Y ==> OR (X1, X2, Y)
                */
                item1->add((yyvsp[0].item), thd->mem_root);
                (yyval.item) = (yyvsp[-2].item);
              }
            }
            else if (is_cond_or((yyvsp[0].item)))
            {
              item3= (Item_cond_or*) (yyvsp[0].item);
              /*
                X OR (Y1 OR Y2) ==> OR (X, Y1, Y2)
              */
              item3->add_at_head((yyvsp[-2].item), thd->mem_root);
              (yyval.item) = (yyvsp[0].item);
            }
            else
            {
              /* X OR Y */
              (yyval.item)= new (thd->mem_root) Item_cond_or(thd, (yyvsp[-2].item), (yyvsp[0].item));
              if (unlikely((yyval.item) == NULL))
                MYSQL_YYABORT;
            }
          }
#line 38038 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1492: /* expr: expr XOR expr  */
#line 10048 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* XOR is a proprietary extension */
            (yyval.item)= new (thd->mem_root) Item_func_xor(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38049 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1493: /* expr: expr and expr  */
#line 10055 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* See comments in rule expr: expr or expr */
            Item_cond_and *item1;
            Item_cond_and *item3;
            if (is_cond_and((yyvsp[-2].item)))
            {
              item1= (Item_cond_and*) (yyvsp[-2].item);
              if (is_cond_and((yyvsp[0].item)))
              {
                item3= (Item_cond_and*) (yyvsp[0].item);
                /*
                  (X1 AND X2) AND (Y1 AND Y2) ==> AND (X1, X2, Y1, Y2)
                */
                item3->add_at_head(item1->argument_list());
                (yyval.item) = (yyvsp[0].item);
              }
              else
              {
                /*
                  (X1 AND X2) AND Y ==> AND (X1, X2, Y)
                */
                item1->add((yyvsp[0].item), thd->mem_root);
                (yyval.item) = (yyvsp[-2].item);
              }
            }
            else if (is_cond_and((yyvsp[0].item)))
            {
              item3= (Item_cond_and*) (yyvsp[0].item);
              /*
                X AND (Y1 AND Y2) ==> AND (X, Y1, Y2)
              */
              item3->add_at_head((yyvsp[-2].item), thd->mem_root);
              (yyval.item) = (yyvsp[0].item);
            }
            else
            {
              /* X AND Y */
              (yyval.item)= new (thd->mem_root) Item_cond_and(thd, (yyvsp[-2].item), (yyvsp[0].item));
              if (unlikely((yyval.item) == NULL))
                MYSQL_YYABORT;
            }
          }
#line 38096 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1494: /* expr: NOT_SYM expr  */
#line 10098 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= negate_expression(thd, (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38106 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1496: /* boolean_test: boolean_test IS TRUE_SYM  */
#line 10108 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_istrue(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38116 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1497: /* boolean_test: boolean_test IS not TRUE_SYM  */
#line 10114 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnottrue(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38126 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1498: /* boolean_test: boolean_test IS FALSE_SYM  */
#line 10120 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isfalse(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38136 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1499: /* boolean_test: boolean_test IS not FALSE_SYM  */
#line 10126 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnotfalse(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38146 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1500: /* boolean_test: boolean_test IS UNKNOWN_SYM  */
#line 10132 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnull(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38156 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1501: /* boolean_test: boolean_test IS not UNKNOWN_SYM  */
#line 10138 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnotnull(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38166 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1502: /* boolean_test: boolean_test IS NULL_SYM  */
#line 10144 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnull(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38176 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1503: /* boolean_test: boolean_test IS not NULL_SYM  */
#line 10150 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnotnull(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38186 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1504: /* boolean_test: boolean_test EQUAL_SYM predicate  */
#line 10156 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_equal(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38196 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1505: /* boolean_test: boolean_test comp_op predicate  */
#line 10162 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= (*(yyvsp[-1].boolfunc2creator))(0)->create(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38206 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1506: /* boolean_test: boolean_test comp_op all_or_any '(' subselect ')'  */
#line 10168 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= all_any_subquery_creator(thd, (yyvsp[-5].item), (yyvsp[-4].boolfunc2creator), (yyvsp[-3].num), (yyvsp[-1].select_lex));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38216 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1508: /* predicate: predicate IN_SYM subquery  */
#line 10178 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_in_subselect(thd, (yyvsp[-2].item), (yyvsp[0].select_lex));
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 38226 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1509: /* predicate: predicate not IN_SYM subquery  */
#line 10184 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_in_subselect(thd, (yyvsp[-3].item), (yyvsp[0].select_lex));
            if (unlikely(!item))
              MYSQL_YYABORT;
            (yyval.item)= negate_expression(thd, item);
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 38239 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1510: /* predicate: predicate IN_SYM '(' expr ')'  */
#line 10193 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= handle_sql2003_note184_exception(thd, (yyvsp[-4].item), true, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38249 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1511: /* predicate: predicate IN_SYM '(' expr ',' expr_list ')'  */
#line 10199 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyvsp[-1].item_list)->push_front((yyvsp[-6].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_func_in(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38261 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1512: /* predicate: predicate not IN_SYM '(' expr ')'  */
#line 10207 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= handle_sql2003_note184_exception(thd, (yyvsp[-5].item), false, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38271 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1513: /* predicate: predicate not IN_SYM '(' expr ',' expr_list ')'  */
#line 10213 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyvsp[-1].item_list)->push_front((yyvsp[-7].item), thd->mem_root);
            Item_func_in *item= new (thd->mem_root) Item_func_in(thd, *(yyvsp[-1].item_list));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 38284 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1514: /* predicate: predicate BETWEEN_SYM predicate AND_SYM predicate  */
#line 10222 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_between(thd, (yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38294 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1515: /* predicate: predicate not BETWEEN_SYM predicate AND_SYM predicate  */
#line 10228 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item_func_between *item;
            item= new (thd->mem_root) Item_func_between(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 38306 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1516: /* predicate: predicate SOUNDS_SYM LIKE predicate  */
#line 10236 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item1= new (thd->mem_root) Item_func_soundex(thd, (yyvsp[-3].item));
            Item *item4= new (thd->mem_root) Item_func_soundex(thd, (yyvsp[0].item));
            if (unlikely(item1 == NULL) || unlikely(item4 == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_func_eq(thd, item1, item4);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38320 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1517: /* predicate: predicate LIKE predicate  */
#line 10246 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_like(thd, (yyvsp[-2].item), (yyvsp[0].item), escape(thd), false);
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 38330 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1518: /* predicate: predicate LIKE predicate ESCAPE_SYM predicate  */
#line 10252 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->escape_used= true;
            (yyval.item)= new (thd->mem_root) Item_func_like(thd, (yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item), true);
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 38341 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1519: /* predicate: predicate not LIKE predicate  */
#line 10259 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_func_like(thd, (yyvsp[-3].item), (yyvsp[0].item), escape(thd), false);
            if (unlikely(!item))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 38352 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1520: /* predicate: predicate not LIKE predicate ESCAPE_SYM predicate  */
#line 10266 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->escape_used= true;
            Item *item= new (thd->mem_root) Item_func_like(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[0].item), true);
            if (unlikely(!item))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 38364 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1521: /* predicate: predicate REGEXP predicate  */
#line 10274 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_regex(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38374 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1522: /* predicate: predicate not REGEXP predicate  */
#line 10280 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_func_regex(thd, (yyvsp[-3].item), (yyvsp[0].item));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= negate_expression(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38387 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1524: /* bit_expr: bit_expr '|' bit_expr  */
#line 10293 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_or(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38397 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1525: /* bit_expr: bit_expr '&' bit_expr  */
#line 10299 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_and(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38407 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1526: /* bit_expr: bit_expr SHIFT_LEFT bit_expr  */
#line 10305 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_shift_left(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38417 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1527: /* bit_expr: bit_expr SHIFT_RIGHT bit_expr  */
#line 10311 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_shift_right(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38427 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1528: /* bit_expr: bit_expr ORACLE_CONCAT_SYM bit_expr  */
#line 10317 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_concat_operator_oracle(thd,
                                                                     (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38438 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1529: /* bit_expr: bit_expr '+' bit_expr  */
#line 10324 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_plus(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38448 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1530: /* bit_expr: bit_expr '-' bit_expr  */
#line 10330 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_minus(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38458 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1531: /* bit_expr: bit_expr '+' INTERVAL_SYM expr interval  */
#line 10336 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-4].item), (yyvsp[-1].item), (yyvsp[0].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38468 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1532: /* bit_expr: bit_expr '-' INTERVAL_SYM expr interval  */
#line 10342 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-4].item), (yyvsp[-1].item), (yyvsp[0].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38478 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1533: /* bit_expr: INTERVAL_SYM expr interval '+' expr  */
#line 10349 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[0].item), (yyvsp[-3].item), (yyvsp[-2].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38488 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1534: /* bit_expr: '+' INTERVAL_SYM expr interval '+' expr  */
#line 10355 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[0].item), (yyvsp[-3].item), (yyvsp[-2].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38498 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1535: /* bit_expr: '-' INTERVAL_SYM expr interval '+' expr  */
#line 10361 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[0].item), (yyvsp[-3].item), (yyvsp[-2].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38508 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1536: /* bit_expr: bit_expr '*' bit_expr  */
#line 10367 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mul(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38518 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1537: /* bit_expr: bit_expr '/' bit_expr  */
#line 10373 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_div(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38528 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1538: /* bit_expr: bit_expr '%' bit_expr  */
#line 10379 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mod(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38538 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1539: /* bit_expr: bit_expr DIV_SYM bit_expr  */
#line 10385 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_int_div(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38548 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1540: /* bit_expr: bit_expr MOD_SYM bit_expr  */
#line 10391 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mod(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38558 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1541: /* bit_expr: bit_expr '^' bit_expr  */
#line 10397 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_xor(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38568 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1551: /* comp_op: '='  */
#line 10426 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.boolfunc2creator) = &comp_eq_creator; }
#line 38574 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1552: /* comp_op: GE  */
#line 10427 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.boolfunc2creator) = &comp_ge_creator; }
#line 38580 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1553: /* comp_op: '>'  */
#line 10428 "/home/buildbot/git/sql/sql_yacc.yy"
              { (yyval.boolfunc2creator) = &comp_gt_creator; }
#line 38586 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1554: /* comp_op: LE  */
#line 10429 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.boolfunc2creator) = &comp_le_creator; }
#line 38592 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1555: /* comp_op: '<'  */
#line 10430 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.boolfunc2creator) = &comp_lt_creator; }
#line 38598 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1556: /* comp_op: NE  */
#line 10431 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.boolfunc2creator) = &comp_ne_creator; }
#line 38604 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1557: /* all_or_any: ALL  */
#line 10435 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.num) = 1; }
#line 38610 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1558: /* all_or_any: ANY_SYM  */
#line 10436 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.num) = 0; }
#line 38616 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1559: /* opt_dyncol_type: %empty  */
#line 10441 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_dyncol_type).set(DYN_COL_NULL); /* automatic type */
            Lex->charset= NULL;
	  }
#line 38625 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1560: /* opt_dyncol_type: AS dyncol_type  */
#line 10445 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); }
#line 38631 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1561: /* dyncol_type: numeric_dyncol_type  */
#line 10449 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); Lex->charset= NULL; }
#line 38637 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1562: /* dyncol_type: temporal_dyncol_type  */
#line 10450 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); Lex->charset= NULL; }
#line 38643 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1563: /* dyncol_type: string_dyncol_type  */
#line 10451 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); }
#line 38649 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1564: /* numeric_dyncol_type: INT_SYM  */
#line 10455 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_INT); }
#line 38655 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1565: /* numeric_dyncol_type: UNSIGNED INT_SYM  */
#line 10456 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_UINT);  }
#line 38661 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1566: /* numeric_dyncol_type: DOUBLE_SYM  */
#line 10457 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DOUBLE);  }
#line 38667 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1567: /* numeric_dyncol_type: REAL  */
#line 10458 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DOUBLE); }
#line 38673 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1568: /* numeric_dyncol_type: FLOAT_SYM  */
#line 10459 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DOUBLE); }
#line 38679 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1569: /* numeric_dyncol_type: DECIMAL_SYM float_options  */
#line 10460 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DECIMAL, (yyvsp[0].Lex_length_and_dec)); }
#line 38685 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1570: /* temporal_dyncol_type: DATE_SYM  */
#line 10464 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DATE); }
#line 38691 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1571: /* temporal_dyncol_type: TIME_SYM opt_field_length  */
#line 10465 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_TIME, 0, (yyvsp[0].const_simple_string)); }
#line 38697 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1572: /* temporal_dyncol_type: DATETIME opt_field_length  */
#line 10466 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DATETIME, 0, (yyvsp[0].const_simple_string)); }
#line 38703 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1573: /* $@147: %empty  */
#line 10471 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 38709 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1574: /* string_dyncol_type: char $@147 opt_binary  */
#line 10473 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_dyncol_type).set(DYN_COL_STRING);
          }
#line 38717 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1575: /* string_dyncol_type: nchar  */
#line 10477 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_dyncol_type).set(DYN_COL_STRING);
            Lex->charset= national_charset_info;
          }
#line 38726 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1576: /* dyncall_create_element: expr ',' expr opt_dyncol_type  */
#line 10485 "/home/buildbot/git/sql/sql_yacc.yy"
   {
     LEX *lex= Lex;
     (yyval.dyncol_def)= (DYNCALL_CREATE_DEF *)
       alloc_root(thd->mem_root, sizeof(DYNCALL_CREATE_DEF));
     if (unlikely((yyval.dyncol_def) == NULL))
       MYSQL_YYABORT;
     (yyval.dyncol_def)->key= (yyvsp[-3].item);
     (yyval.dyncol_def)->value= (yyvsp[-1].item);
     (yyval.dyncol_def)->type= (DYNAMIC_COLUMN_TYPE)(yyvsp[0].Lex_dyncol_type).dyncol_type();
     (yyval.dyncol_def)->cs= lex->charset;
     if ((yyvsp[0].Lex_dyncol_type).length())
       (yyval.dyncol_def)->len= strtoul((yyvsp[0].Lex_dyncol_type).length(), NULL, 10);
     else
       (yyval.dyncol_def)->len= 0;
     if ((yyvsp[0].Lex_dyncol_type).dec())
       (yyval.dyncol_def)->frac= strtoul((yyvsp[0].Lex_dyncol_type).dec(), NULL, 10);
     else
       (yyval.dyncol_def)->len= 0;
   }
#line 38750 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1577: /* dyncall_create_list: dyncall_create_element  */
#line 10508 "/home/buildbot/git/sql/sql_yacc.yy"
       {
         (yyval.dyncol_def_list)= new (thd->mem_root) List<DYNCALL_CREATE_DEF>;
         if (unlikely((yyval.dyncol_def_list) == NULL))
           MYSQL_YYABORT;
         (yyval.dyncol_def_list)->push_back((yyvsp[0].dyncol_def), thd->mem_root);
       }
#line 38761 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1578: /* dyncall_create_list: dyncall_create_list ',' dyncall_create_element  */
#line 10515 "/home/buildbot/git/sql/sql_yacc.yy"
       {
         (yyvsp[-2].dyncol_def_list)->push_back((yyvsp[0].dyncol_def), thd->mem_root);
         (yyval.dyncol_def_list)= (yyvsp[-2].dyncol_def_list);
       }
#line 38770 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1579: /* plsql_cursor_attr: ISOPEN_SYM  */
#line 10523 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_ISOPEN; }
#line 38776 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1580: /* plsql_cursor_attr: FOUND_SYM  */
#line 10524 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_FOUND; }
#line 38782 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1581: /* plsql_cursor_attr: NOTFOUND_SYM  */
#line 10525 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_NOTFOUND; }
#line 38788 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1582: /* plsql_cursor_attr: ROWCOUNT_SYM  */
#line 10526 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_ROWCOUNT; }
#line 38794 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1583: /* explicit_cursor_attr: ident PERCENT_ORACLE_SYM plsql_cursor_attr  */
#line 10531 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_plsql_cursor_attr(thd, &(yyvsp[-2].ident_sys), (yyvsp[0].plsql_cursor_attr)))))
              MYSQL_YYABORT;
          }
#line 38803 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1586: /* trim_operands_regular: expr  */
#line 10544 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[0].item));         }
#line 38809 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1587: /* trim_operands_special: LEADING expr FROM expr  */
#line 10548 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_LEADING, (yyvsp[-2].item), (yyvsp[0].item));  }
#line 38815 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1588: /* trim_operands_special: TRAILING expr FROM expr  */
#line 10549 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_TRAILING, (yyvsp[-2].item), (yyvsp[0].item)); }
#line 38821 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1589: /* trim_operands_special: BOTH expr FROM expr  */
#line 10550 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[-2].item), (yyvsp[0].item));     }
#line 38827 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1590: /* trim_operands_special: LEADING FROM expr  */
#line 10551 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_LEADING, (yyvsp[0].item));      }
#line 38833 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1591: /* trim_operands_special: TRAILING FROM expr  */
#line 10552 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_TRAILING, (yyvsp[0].item));     }
#line 38839 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1592: /* trim_operands_special: BOTH FROM expr  */
#line 10553 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[0].item));         }
#line 38845 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1593: /* trim_operands_special: expr FROM expr  */
#line 10554 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[-2].item), (yyvsp[0].item));     }
#line 38851 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1600: /* column_default_non_parenthesized_expr: param_marker  */
#line 10592 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.item)= (yyvsp[0].item_param); }
#line 38857 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1602: /* column_default_non_parenthesized_expr: sum_expr  */
#line 10595 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!Lex->select_stack_top)
            {
              my_error(ER_INVALID_GROUP_FUNC_USE, MYF(0));
              MYSQL_YYABORT;
            }
          }
#line 38869 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1603: /* column_default_non_parenthesized_expr: window_func_expr  */
#line 10603 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!Lex->select_stack_top)
            {
               my_error(ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION, MYF(0));
               MYSQL_YYABORT;
            }
          }
#line 38881 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1605: /* column_default_non_parenthesized_expr: ROW_SYM '(' expr ',' expr_list ')'  */
#line 10612 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_row(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38892 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1606: /* column_default_non_parenthesized_expr: EXISTS '(' subselect ')'  */
#line 10619 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_exists_subselect(thd, (yyvsp[-1].select_lex));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38902 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1607: /* column_default_non_parenthesized_expr: '{' ident expr '}'  */
#line 10625 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].item)->make_odbc_literal(thd, &(yyvsp[-2].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 38911 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1608: /* column_default_non_parenthesized_expr: MATCH ident_list_arg AGAINST '(' bit_expr fulltext_options ')'  */
#line 10630 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-5].item_list)->push_front((yyvsp[-2].item), thd->mem_root);
            Item_func_match *i1= new (thd->mem_root) Item_func_match(thd, *(yyvsp[-5].item_list),
                                                                     (yyvsp[-1].num));
            if (unlikely(i1 == NULL))
              MYSQL_YYABORT;
            Select->add_ftfunc_to_list(thd, i1);
            (yyval.item)= i1;
          }
#line 38925 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1609: /* column_default_non_parenthesized_expr: CAST_SYM '(' expr AS cast_type ')'  */
#line 10640 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].Lex_cast_type).create_typecast_item(thd, (yyvsp[-3].item), Lex->charset))))
              MYSQL_YYABORT;
          }
#line 38934 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1610: /* column_default_non_parenthesized_expr: CASE_SYM when_list_opt_else END  */
#line 10645 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= new(thd->mem_root) Item_func_case_searched(thd, *(yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 38943 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1611: /* column_default_non_parenthesized_expr: CASE_SYM expr when_list_opt_else END  */
#line 10650 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-2].item), thd->mem_root);
            if (unlikely(!((yyval.item)= new (thd->mem_root) Item_func_case_simple(thd, *(yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 38953 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1612: /* column_default_non_parenthesized_expr: CONVERT_SYM '(' expr ',' cast_type ')'  */
#line 10656 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].Lex_cast_type).create_typecast_item(thd, (yyvsp[-3].item), Lex->charset))))
              MYSQL_YYABORT;
          }
#line 38962 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1613: /* column_default_non_parenthesized_expr: CONVERT_SYM '(' expr USING charset_name ')'  */
#line 10661 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_conv_charset(thd, (yyvsp[-3].item), (yyvsp[-1].charset));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38972 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1614: /* column_default_non_parenthesized_expr: DEFAULT '(' simple_ident ')'  */
#line 10667 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item_splocal *il= (yyvsp[-1].item)->get_item_splocal();
            if (unlikely(il))
              my_yyabort_error((ER_WRONG_COLUMN_NAME, MYF(0), il->my_name()->str));
            (yyval.item)= new (thd->mem_root) Item_default_value(thd, Lex->current_context(),
                                                         (yyvsp[-1].item), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->default_used= TRUE;
          }
#line 38987 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1615: /* column_default_non_parenthesized_expr: VALUE_SYM '(' simple_ident_nospvar ')'  */
#line 10678 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_insert_value(thd, Lex->current_context(),
                                                        (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38998 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1616: /* column_default_non_parenthesized_expr: NEXT_SYM VALUE_SYM FOR_SYM table_ident  */
#line 10685 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_nextval(thd, (yyvsp[0].table)))))
              MYSQL_YYABORT;
          }
#line 39007 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1617: /* column_default_non_parenthesized_expr: NEXTVAL_SYM '(' table_ident ')'  */
#line 10690 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_nextval(thd, (yyvsp[-1].table)))))
              MYSQL_YYABORT;
          }
#line 39016 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1618: /* column_default_non_parenthesized_expr: PREVIOUS_SYM VALUE_SYM FOR_SYM table_ident  */
#line 10695 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_lastval(thd, (yyvsp[0].table)))))
              MYSQL_YYABORT;
          }
#line 39025 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1619: /* column_default_non_parenthesized_expr: LASTVAL_SYM '(' table_ident ')'  */
#line 10700 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_lastval(thd, (yyvsp[-1].table)))))
              MYSQL_YYABORT;
          }
#line 39034 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1620: /* column_default_non_parenthesized_expr: SETVAL_SYM '(' table_ident ',' longlong_num ')'  */
#line 10705 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_setval(thd, (yyvsp[-3].table), (yyvsp[-1].longlong_number), 0, 1))))
              MYSQL_YYABORT;
          }
#line 39043 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1621: /* column_default_non_parenthesized_expr: SETVAL_SYM '(' table_ident ',' longlong_num ',' bool ')'  */
#line 10710 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_setval(thd, (yyvsp[-5].table), (yyvsp[-3].longlong_number), 0, (yyvsp[-1].ulong_num)))))
              MYSQL_YYABORT;
          }
#line 39052 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1622: /* column_default_non_parenthesized_expr: SETVAL_SYM '(' table_ident ',' longlong_num ',' bool ',' ulonglong_num ')'  */
#line 10715 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_setval(thd, (yyvsp[-7].table), (yyvsp[-5].longlong_number), (yyvsp[-1].ulonglong_number), (yyvsp[-3].ulong_num)))))
              MYSQL_YYABORT;
          }
#line 39061 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1625: /* primary_expr: '(' parenthesized_expr ')'  */
#line 10724 "/home/buildbot/git/sql/sql_yacc.yy"
                                     { (yyval.item)= (yyvsp[-1].item); }
#line 39067 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1626: /* primary_expr: subquery  */
#line 10726 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.item)= Lex->create_item_query_expression(thd, (yyvsp[0].select_lex)->master_unit())))
              MYSQL_YYABORT;
          }
#line 39076 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1628: /* string_factor_expr: string_factor_expr COLLATE_SYM collation_name  */
#line 10735 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= new (thd->mem_root) Item_func_set_collation(thd, (yyvsp[-2].item), (yyvsp[0].charset)))))
              MYSQL_YYABORT;
          }
#line 39085 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1630: /* simple_expr: BINARY simple_expr  */
#line 10744 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Type_cast_attributes at(&my_charset_bin);
            if (unlikely(!((yyval.item)= type_handler_long_blob.create_typecast_item(thd, (yyvsp[0].item), at))))
              MYSQL_YYABORT;
          }
#line 39095 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1631: /* simple_expr: '+' simple_expr  */
#line 10750 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= (yyvsp[0].item);
          }
#line 39103 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1632: /* simple_expr: '-' simple_expr  */
#line 10754 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= (yyvsp[0].item)->neg(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39113 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1633: /* simple_expr: '~' simple_expr  */
#line 10760 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_neg(thd, (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39123 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1634: /* simple_expr: not2 simple_expr  */
#line 10766 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= negate_expression(thd, (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39133 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1636: /* mysql_concatenation_expr: mysql_concatenation_expr MYSQL_CONCAT_SYM simple_expr  */
#line 10776 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_concat(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39143 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1637: /* function_call_keyword_timestamp: TIMESTAMP '(' expr ')'  */
#line 10785 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_datetime_typecast(thd, (yyvsp[-1].item),
                                      AUTO_SEC_PART_DIGITS);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39154 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1638: /* function_call_keyword_timestamp: TIMESTAMP '(' expr ',' expr ')'  */
#line 10792 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_timestamp(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39164 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1639: /* function_call_keyword: CHAR_SYM '(' expr_list ')'  */
#line 10806 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_char(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39174 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1640: /* function_call_keyword: CHAR_SYM '(' expr_list USING charset_name ')'  */
#line 10812 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_char(thd, *(yyvsp[-3].item_list), (yyvsp[-1].charset));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39184 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1641: /* function_call_keyword: CURRENT_USER optional_braces  */
#line 10818 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_current_user(thd,
                                      Lex->current_context());
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 39197 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1642: /* function_call_keyword: CURRENT_ROLE optional_braces  */
#line 10827 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_current_role(thd,
                                      Lex->current_context());
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 39210 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1643: /* function_call_keyword: DATE_SYM '(' expr ')'  */
#line 10836 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_typecast(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39220 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1644: /* function_call_keyword: DAY_SYM '(' expr ')'  */
#line 10842 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_dayofmonth(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39230 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1645: /* function_call_keyword: HOUR_SYM '(' expr ')'  */
#line 10848 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_hour(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39240 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1646: /* function_call_keyword: INSERT '(' expr ',' expr ',' expr ',' expr ')'  */
#line 10854 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_insert(thd, (yyvsp[-7].item), (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39250 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1647: /* function_call_keyword: INTERVAL_SYM '(' expr ',' expr ')'  */
#line 10860 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            List<Item> *list= new (thd->mem_root) List<Item>;
            if (unlikely(list == NULL))
              MYSQL_YYABORT;
            if (unlikely(list->push_front((yyvsp[-1].item), thd->mem_root)) ||
                unlikely(list->push_front((yyvsp[-3].item), thd->mem_root)))
              MYSQL_YYABORT;
            Item_row *item= new (thd->mem_root) Item_row(thd, *list);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_func_interval(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39269 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1648: /* function_call_keyword: INTERVAL_SYM '(' expr ',' expr ',' expr_list ')'  */
#line 10875 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyvsp[-1].item_list)->push_front((yyvsp[-5].item), thd->mem_root);
            Item_row *item= new (thd->mem_root) Item_row(thd, *(yyvsp[-1].item_list));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_func_interval(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39284 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1649: /* function_call_keyword: LEFT '(' expr ',' expr ')'  */
#line 10886 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_left(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39294 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1650: /* function_call_keyword: MINUTE_SYM '(' expr ')'  */
#line 10892 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_minute(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39304 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1651: /* function_call_keyword: MONTH_SYM '(' expr ')'  */
#line 10898 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_month(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39314 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1652: /* function_call_keyword: RIGHT '(' expr ',' expr ')'  */
#line 10904 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_right(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39324 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1653: /* function_call_keyword: SECOND_SYM '(' expr ')'  */
#line 10910 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_second(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39334 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1654: /* function_call_keyword: SQL_SYM PERCENT_ORACLE_SYM ROWCOUNT_SYM  */
#line 10916 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_oracle_sql_rowcount(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 39346 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1655: /* function_call_keyword: TIME_SYM '(' expr ')'  */
#line 10924 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_time_typecast(thd, (yyvsp[-1].item),
                                      AUTO_SEC_PART_DIGITS);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39357 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1656: /* function_call_keyword: function_call_keyword_timestamp  */
#line 10931 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= (yyvsp[0].item);
          }
#line 39365 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1657: /* function_call_keyword: TRIM '(' trim_operands ')'  */
#line 10935 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Schema::find_implied(thd)->
                                 make_item_func_trim(thd, (yyvsp[-1].trim)))))
              MYSQL_YYABORT;
          }
#line 39375 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1658: /* function_call_keyword: USER_SYM '(' ')'  */
#line 10941 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_user(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query=0;
          }
#line 39387 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1659: /* function_call_keyword: YEAR_SYM '(' expr ')'  */
#line 10949 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_year(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39397 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1662: /* substring_operands_regular: expr ',' expr ',' expr  */
#line 10963 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item));
          }
#line 39405 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1663: /* substring_operands_regular: expr ',' expr  */
#line 10967 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-2].item), (yyvsp[0].item));
          }
#line 39413 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1664: /* substring_operands_special: expr FROM expr FOR_SYM expr  */
#line 10974 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item));
          }
#line 39421 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1665: /* substring_operands_special: expr FROM expr  */
#line 10978 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-2].item), (yyvsp[0].item));
          }
#line 39429 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1666: /* function_call_nonkeyword: ADDDATE_SYM '(' expr ',' expr ')'  */
#line 10998 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                             INTERVAL_DAY, 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39440 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1667: /* function_call_nonkeyword: ADDDATE_SYM '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11005 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39450 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1668: /* function_call_nonkeyword: CURDATE optional_braces  */
#line 11011 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curdate_local(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39461 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1669: /* function_call_nonkeyword: CURTIME opt_time_precision  */
#line 11018 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curtime_local(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39472 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1670: /* function_call_nonkeyword: DATE_ADD_INTERVAL '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11025 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39482 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1671: /* function_call_nonkeyword: DATE_SUB_INTERVAL '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11031 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39492 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1672: /* function_call_nonkeyword: DATE_FORMAT_SYM '(' expr ',' expr ')'  */
#line 11037 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_date_format(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39502 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1673: /* function_call_nonkeyword: DATE_FORMAT_SYM '(' expr ',' expr ',' expr ')'  */
#line 11043 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_date_format(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39512 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1674: /* function_call_nonkeyword: EXTRACT_SYM '(' interval FROM expr ')'  */
#line 11049 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_extract(thd, (yyvsp[-3].interval), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39522 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1675: /* function_call_nonkeyword: GET_FORMAT '(' date_time_type ',' expr ')'  */
#line 11055 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_get_format(thd, (yyvsp[-3].date_time_type), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39532 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1676: /* function_call_nonkeyword: NOW_SYM opt_time_precision  */
#line 11061 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_now_local(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39543 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1677: /* function_call_nonkeyword: POSITION_SYM '(' bit_expr IN_SYM expr ')'  */
#line 11068 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_locate(thd, (yyvsp[-1].item), (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39553 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1678: /* function_call_nonkeyword: SUBDATE_SYM '(' expr ',' expr ')'  */
#line 11074 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                             INTERVAL_DAY, 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39564 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1679: /* function_call_nonkeyword: SUBDATE_SYM '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11081 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39574 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1680: /* function_call_nonkeyword: SUBSTRING '(' substring_operands ')'  */
#line 11087 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Schema::find_implied(thd)->
                                 make_item_func_substr(thd, (yyvsp[-1].substring_spec)))))
              MYSQL_YYABORT;
          }
#line 39584 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1681: /* function_call_nonkeyword: SYSDATE opt_time_precision  */
#line 11093 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Unlike other time-related functions, SYSDATE() is
              replication-unsafe because it is not affected by the
              TIMESTAMP variable.  It is unsafe even if
              sysdate_is_now=1, because the slave may have
              sysdate_is_now=0.
            */
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            if (global_system_variables.sysdate_is_now == 0)
              (yyval.item)= new (thd->mem_root) Item_func_sysdate_local(thd, (yyvsp[0].num));
            else
              (yyval.item)= new (thd->mem_root) Item_func_now_local(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39606 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1682: /* function_call_nonkeyword: TIMESTAMP_ADD '(' interval_time_stamp ',' expr ',' expr ')'  */
#line 11111 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-1].item), (yyvsp[-3].item), (yyvsp[-5].interval_time_st), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39616 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1683: /* function_call_nonkeyword: TIMESTAMP_DIFF '(' interval_time_stamp ',' expr ',' expr ')'  */
#line 11117 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_timestamp_diff(thd, (yyvsp[-3].item), (yyvsp[-1].item), (yyvsp[-5].interval_time_st));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39626 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1684: /* function_call_nonkeyword: TRIM_ORACLE '(' trim_operands ')'  */
#line 11123 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].trim).make_item_func_trim_oracle(thd))))
              MYSQL_YYABORT;
          }
#line 39635 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1685: /* function_call_nonkeyword: UTC_DATE_SYM optional_braces  */
#line 11128 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curdate_utc(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39646 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1686: /* function_call_nonkeyword: UTC_TIME_SYM opt_time_precision  */
#line 11135 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curtime_utc(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39657 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1687: /* function_call_nonkeyword: UTC_TIMESTAMP_SYM opt_time_precision  */
#line 11142 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_now_utc(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39668 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1688: /* function_call_nonkeyword: COLUMN_ADD_SYM '(' expr ',' dyncall_create_list ')'  */
#line 11150 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= create_func_dyncol_add(thd, (yyvsp[-3].item), *(yyvsp[-1].dyncol_def_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39678 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1689: /* function_call_nonkeyword: COLUMN_DELETE_SYM '(' expr ',' expr_list ')'  */
#line 11157 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= create_func_dyncol_delete(thd, (yyvsp[-3].item), *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39688 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1690: /* function_call_nonkeyword: COLUMN_CHECK_SYM '(' expr ')'  */
#line 11164 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_dyncol_check(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39698 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1691: /* function_call_nonkeyword: COLUMN_CREATE_SYM '(' dyncall_create_list ')'  */
#line 11171 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= create_func_dyncol_create(thd, *(yyvsp[-1].dyncol_def_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39708 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1692: /* function_call_nonkeyword: COLUMN_GET_SYM '(' expr ',' expr AS cast_type ')'  */
#line 11178 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            (yyval.item)= create_func_dyncol_get(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].Lex_cast_type).type_handler(),
                                        (yyvsp[-1].Lex_cast_type).length(), (yyvsp[-1].Lex_cast_type).dec(),
                                        lex->charset);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39721 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1693: /* function_call_conflict: ASCII_SYM '(' expr ')'  */
#line 11195 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_ascii(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39731 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1694: /* function_call_conflict: CHARSET '(' expr ')'  */
#line 11201 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_charset(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39741 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1695: /* function_call_conflict: COALESCE '(' expr_list ')'  */
#line 11207 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_coalesce(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39751 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1696: /* function_call_conflict: COLLATION_SYM '(' expr ')'  */
#line 11213 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_collation(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39761 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1697: /* function_call_conflict: DATABASE '(' ')'  */
#line 11219 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_database(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39772 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1698: /* function_call_conflict: IF_SYM '(' expr ',' expr ',' expr ')'  */
#line 11226 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_if(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39782 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1699: /* function_call_conflict: FORMAT_SYM '(' expr ',' expr ')'  */
#line 11232 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_format(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39792 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1700: /* function_call_conflict: FORMAT_SYM '(' expr ',' expr ',' expr ')'  */
#line 11238 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_format(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39802 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1701: /* function_call_conflict: LAST_VALUE '(' expr ')'  */
#line 11247 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            List<Item> *list= new (thd->mem_root) List<Item>;
            if (unlikely(list == NULL))
              MYSQL_YYABORT;
            list->push_back((yyvsp[-1].item), thd->mem_root);

            (yyval.item)= new (thd->mem_root) Item_func_last_value(thd, *list);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39817 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1702: /* function_call_conflict: LAST_VALUE '(' expr_list ',' expr ')'  */
#line 11258 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-3].item_list)->push_back((yyvsp[-1].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_func_last_value(thd, *(yyvsp[-3].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39828 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1703: /* function_call_conflict: MICROSECOND_SYM '(' expr ')'  */
#line 11265 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_microsecond(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39838 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1704: /* function_call_conflict: MOD_SYM '(' expr ',' expr ')'  */
#line 11271 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mod(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39848 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1705: /* function_call_conflict: OLD_PASSWORD_SYM '(' expr ')'  */
#line 11277 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)=  new (thd->mem_root)
              Item_func_password(thd, (yyvsp[-1].item), Item_func_password::OLD);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39859 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1706: /* function_call_conflict: PASSWORD_SYM '(' expr ')'  */
#line 11284 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item* i1;
            i1= new (thd->mem_root) Item_func_password(thd, (yyvsp[-1].item));
            if (unlikely(i1 == NULL))
              MYSQL_YYABORT;
            (yyval.item)= i1;
          }
#line 39871 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1707: /* function_call_conflict: QUARTER_SYM '(' expr ')'  */
#line 11292 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_quarter(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39881 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1708: /* function_call_conflict: REPEAT_SYM '(' expr ',' expr ')'  */
#line 11298 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_repeat(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39891 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1709: /* function_call_conflict: REPLACE '(' expr ',' expr ',' expr ')'  */
#line 11304 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Schema::find_implied(thd)->
                                 make_item_func_replace(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item)))))
              MYSQL_YYABORT;
          }
#line 39901 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1710: /* function_call_conflict: REVERSE_SYM '(' expr ')'  */
#line 11310 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_reverse(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39911 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1711: /* function_call_conflict: ROW_COUNT_SYM '(' ')'  */
#line 11316 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_row_count(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 39923 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1712: /* function_call_conflict: TRUNCATE_SYM '(' expr ',' expr ')'  */
#line 11324 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_round(thd, (yyvsp[-3].item), (yyvsp[-1].item), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39933 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1713: /* function_call_conflict: WEEK_SYM '(' expr ')'  */
#line 11330 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_week(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39943 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1714: /* function_call_conflict: WEEK_SYM '(' expr ',' expr ')'  */
#line 11336 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_week(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39953 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1715: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr opt_ws_levels ')'  */
#line 11342 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_weight_string(thd, (yyvsp[-2].item), 0, 0, (yyvsp[-1].ulong_num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39963 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1716: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr AS CHAR_SYM ws_nweights opt_ws_levels ')'  */
#line 11348 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root)
                Item_func_weight_string(thd, (yyvsp[-5].item), 0, (yyvsp[-2].ulong_num),
                                        (yyvsp[-1].ulong_num) | MY_STRXFRM_PAD_WITH_SPACE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39975 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1717: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr AS BINARY ws_nweights ')'  */
#line 11356 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_char_typecast(thd, (yyvsp[-4].item), (yyvsp[-1].ulong_num),
                                                               &my_charset_bin);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root)
                Item_func_weight_string(thd, item, 0, (yyvsp[-1].ulong_num),
                                        MY_STRXFRM_PAD_WITH_SPACE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39991 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1718: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr ',' ulong_num ',' ulong_num ',' ulong_num ')'  */
#line 11368 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_weight_string(thd, (yyvsp[-7].item), (yyvsp[-5].ulong_num), (yyvsp[-3].ulong_num),
                                                            (yyvsp[-1].ulong_num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40002 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1719: /* function_call_conflict: geometry_function  */
#line 11375 "/home/buildbot/git/sql/sql_yacc.yy"
          {
#ifdef HAVE_SPATIAL
            (yyval.item)= (yyvsp[0].item);
            /* $1 may be NULL, GEOM_NEW not tested for out of memory */
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), sym_group_geom.name,
                              sym_group_geom.needed_define));
#endif
          }
#line 40018 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1720: /* geometry_function: CONTAINS_SYM '(' expr ',' expr ')'  */
#line 11390 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_precise_rel(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                 Item_func::SP_CONTAINS_FUNC));
          }
#line 40028 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1721: /* geometry_function: GEOMETRYCOLLECTION '(' expr_list ')'  */
#line 11396 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_geometrycollection,
                           Geometry::wkb_point));
          }
#line 40039 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1722: /* geometry_function: LINESTRING '(' expr_list ')'  */
#line 11403 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_linestring,
                           Geometry::wkb_point));
          }
#line 40050 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1723: /* geometry_function: MULTILINESTRING '(' expr_list ')'  */
#line 11410 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_multilinestring,
                           Geometry::wkb_linestring));
          }
#line 40061 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1724: /* geometry_function: MULTIPOINT '(' expr_list ')'  */
#line 11417 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_multipoint,
                           Geometry::wkb_point));
          }
#line 40072 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1725: /* geometry_function: MULTIPOLYGON '(' expr_list ')'  */
#line 11424 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_multipolygon,
                           Geometry::wkb_polygon));
          }
#line 40083 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1726: /* geometry_function: POINT_SYM '(' expr ',' expr ')'  */
#line 11431 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd, Item_func_point(thd, (yyvsp[-3].item), (yyvsp[-1].item)));
          }
#line 40091 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1727: /* geometry_function: POLYGON '(' expr_list ')'  */
#line 11435 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_polygon,
                           Geometry::wkb_linestring));
          }
#line 40102 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1728: /* geometry_function: WITHIN '(' expr ',' expr ')'  */
#line 11442 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd, Item_func_spatial_precise_rel(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                    Item_func::SP_WITHIN_FUNC));
          }
#line 40111 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1729: /* @148: %empty  */
#line 11459 "/home/buildbot/git/sql/sql_yacc.yy"
          {
#ifdef HAVE_DLOPEN
            udf_func *udf= 0;
            LEX *lex= Lex;
            if (using_udf_functions &&
                (udf= find_udf((yyvsp[-1].ident_sys).str, (yyvsp[-1].ident_sys).length)) &&
                udf->type == UDFTYPE_AGGREGATE)
            {
              if (unlikely(lex->current_select->inc_in_sum_expr()))
              {
                thd->parse_error();
                MYSQL_YYABORT;
              }
            }
            /* Temporary placing the result of find_udf in $3 */
            (yyval.udf)= udf;
#endif
          }
#line 40134 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1730: /* function_call_generic: IDENT_sys '(' @148 opt_udf_expr_list ')'  */
#line 11478 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Create_func *builder;
            Item *item= NULL;

            if (unlikely(check_routine_name(&(yyvsp[-4].ident_sys))))
              MYSQL_YYABORT;

            /*
              Implementation note:
              names are resolved with the following order:
              - MySQL native functions,
              - User Defined Functions,
              - Stored Functions (assuming the current <use> database)

              This will be revised with WL#2128 (SQL PATH)
            */
            builder= Schema::find_implied(thd)->
                       find_native_function_builder(thd, (yyvsp[-4].ident_sys));
            if (builder)
            {
              item= builder->create_func(thd, &(yyvsp[-4].ident_sys), (yyvsp[-1].item_list));
            }
            else
            {
#ifdef HAVE_DLOPEN
              /* Retrieving the result of find_udf */
              udf_func *udf= (yyvsp[-2].udf);

              if (udf)
              {
                if (udf->type == UDFTYPE_AGGREGATE)
                {
                  Select->in_sum_expr--;
                }

                item= Create_udf_func::s_singleton.create(thd, udf, (yyvsp[-1].item_list));
              }
              else
#endif
              {
                builder= find_qualified_function_builder(thd);
                DBUG_ASSERT(builder);
                item= builder->create_func(thd, &(yyvsp[-4].ident_sys), (yyvsp[-1].item_list));
              }
            }

            if (unlikely(! ((yyval.item)= item)))
              MYSQL_YYABORT;
          }
#line 40188 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1731: /* function_call_generic: ident_cli '.' ident_cli '(' opt_expr_list ')'  */
#line 11528 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_call_generic(thd, &(yyvsp[-5].ident_cli), &(yyvsp[-3].ident_cli), (yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 40197 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1732: /* function_call_generic: ident_cli '.' ident_cli '.' ident_cli '(' opt_expr_list ')'  */
#line 11533 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_call_generic(thd, &(yyvsp[-7].ident_cli), &(yyvsp[-5].ident_cli), &(yyvsp[-3].ident_cli), (yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 40206 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1733: /* function_call_generic: ident_cli '.' REPLACE '(' opt_expr_list ')'  */
#line 11538 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_replace(thd, (yyvsp[-5].ident_cli), (yyvsp[-3].kwd), (yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 40215 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1734: /* function_call_generic: ident_cli '.' SUBSTRING '(' opt_expr_list ')'  */
#line 11543 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_substr(thd, (yyvsp[-5].ident_cli), (yyvsp[-3].kwd), (yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 40224 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1735: /* function_call_generic: ident_cli '.' SUBSTRING '(' substring_operands_special ')'  */
#line 11548 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_substr(thd, (yyvsp[-5].ident_cli), (yyvsp[-3].kwd), (yyvsp[-1].substring_spec)))))
              MYSQL_YYABORT;
          }
#line 40233 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1736: /* function_call_generic: ident_cli '.' TRIM '(' opt_expr_list ')'  */
#line 11553 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_trim(thd, (yyvsp[-5].ident_cli), (yyvsp[-3].kwd), (yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 40242 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1737: /* function_call_generic: ident_cli '.' TRIM '(' trim_operands_special ')'  */
#line 11558 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_trim(thd, (yyvsp[-5].ident_cli), (yyvsp[-3].kwd), (yyvsp[-1].trim)))))
              MYSQL_YYABORT;
          }
#line 40251 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1738: /* fulltext_options: opt_natural_language_mode opt_query_expansion  */
#line 11578 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)= (yyvsp[-1].num) | (yyvsp[0].num); }
#line 40257 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1739: /* fulltext_options: IN_SYM BOOLEAN_SYM MODE_SYM  */
#line 11580 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)= FT_BOOL; }
#line 40263 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1740: /* opt_natural_language_mode: %empty  */
#line 11584 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.num)= FT_NL; }
#line 40269 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1741: /* opt_natural_language_mode: IN_SYM NATURAL LANGUAGE_SYM MODE_SYM  */
#line 11585 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.num)= FT_NL; }
#line 40275 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1742: /* opt_query_expansion: %empty  */
#line 11589 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.num)= 0;         }
#line 40281 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1743: /* opt_query_expansion: WITH QUERY_SYM EXPANSION_SYM  */
#line 11590 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.num)= FT_EXPAND; }
#line 40287 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1744: /* opt_udf_expr_list: %empty  */
#line 11594 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.item_list)= NULL; }
#line 40293 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1745: /* opt_udf_expr_list: udf_expr_list  */
#line 11595 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.item_list)= (yyvsp[0].item_list); }
#line 40299 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1746: /* udf_expr_list: udf_expr  */
#line 11600 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL))
              MYSQL_YYABORT;
            (yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root);
          }
#line 40310 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1747: /* udf_expr_list: udf_expr_list ',' udf_expr  */
#line 11607 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root);
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 40319 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1748: /* udf_expr: remember_name expr remember_end select_alias  */
#line 11615 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
             Use Item::name as a storage for the attribute value of user
             defined function argument. It is safe to use Item::name
             because the syntax will not allow having an explicit name here.
             See WL#1017 re. udf attributes.
            */
            if ((yyvsp[0].lex_str).str)
            {
              (yyvsp[-2].item)->is_autogenerated_name= FALSE;
              (yyvsp[-2].item)->set_name(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length, system_charset_info);
            }
            /* 
               A field has to have its proper name in order for name
               resolution to work, something we are only guaranteed if we
               parse it out. If we hijack the input stream with
               remember_name we may get quoted or escaped names.
            */
            else if ((yyvsp[-2].item)->type() != Item::FIELD_ITEM &&
                     (yyvsp[-2].item)->type() != Item::REF_ITEM /* For HAVING */ )
              (yyvsp[-2].item)->set_name(thd, (yyvsp[-3].simple_string), (uint) ((yyvsp[-1].simple_string) - (yyvsp[-3].simple_string)), thd->charset());
            (yyval.item)= (yyvsp[-2].item);
          }
#line 40347 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1749: /* sum_expr: AVG_SYM '(' in_sum_expr ')'  */
#line 11642 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_avg(thd, (yyvsp[-1].item), FALSE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40357 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1750: /* sum_expr: AVG_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11648 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_avg(thd, (yyvsp[-1].item), TRUE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40367 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1751: /* sum_expr: BIT_AND '(' in_sum_expr ')'  */
#line 11654 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_and(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40377 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1752: /* sum_expr: BIT_OR '(' in_sum_expr ')'  */
#line 11660 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_or(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40387 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1753: /* sum_expr: BIT_XOR '(' in_sum_expr ')'  */
#line 11666 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_xor(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40397 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1754: /* sum_expr: COUNT_SYM '(' opt_all '*' ')'  */
#line 11672 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_int(thd, (int32) 0L, 1);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_sum_count(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40410 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1755: /* sum_expr: COUNT_SYM '(' in_sum_expr ')'  */
#line 11681 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_count(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40420 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1756: /* $@149: %empty  */
#line 11687 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->in_sum_expr++; }
#line 40426 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1757: /* $@150: %empty  */
#line 11689 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->in_sum_expr--; }
#line 40432 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1758: /* sum_expr: COUNT_SYM '(' DISTINCT $@149 expr_list $@150 ')'  */
#line 11691 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_count(thd, *(yyvsp[-2].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40442 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1759: /* sum_expr: MIN_SYM '(' in_sum_expr ')'  */
#line 11697 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_min(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40452 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1760: /* sum_expr: MIN_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11708 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_min(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40462 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1761: /* sum_expr: MAX_SYM '(' in_sum_expr ')'  */
#line 11714 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_max(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40472 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1762: /* sum_expr: MAX_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11720 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_max(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40482 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1763: /* sum_expr: STD_SYM '(' in_sum_expr ')'  */
#line 11726 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_std(thd, (yyvsp[-1].item), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40492 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1764: /* sum_expr: VARIANCE_SYM '(' in_sum_expr ')'  */
#line 11732 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_variance(thd, (yyvsp[-1].item), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40502 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1765: /* sum_expr: STDDEV_SAMP_SYM '(' in_sum_expr ')'  */
#line 11738 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_std(thd, (yyvsp[-1].item), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40512 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1766: /* sum_expr: VAR_SAMP_SYM '(' in_sum_expr ')'  */
#line 11744 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_variance(thd, (yyvsp[-1].item), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40522 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1767: /* sum_expr: SUM_SYM '(' in_sum_expr ')'  */
#line 11750 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_sum(thd, (yyvsp[-1].item), FALSE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40532 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1768: /* sum_expr: SUM_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11756 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_sum(thd, (yyvsp[-1].item), TRUE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40542 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1769: /* $@151: %empty  */
#line 11762 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->in_sum_expr++; }
#line 40548 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1770: /* sum_expr: GROUP_CONCAT_SYM '(' opt_distinct $@151 expr_list opt_gorder_clause opt_gconcat_separator opt_glimit_clause ')'  */
#line 11766 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->in_sum_expr--;
            (yyval.item)= new (thd->mem_root)
                  Item_func_group_concat(thd, Lex->current_context(),
                                        (yyvsp[-6].num), (yyvsp[-4].item_list),
                                        sel->gorder_list, (yyvsp[-2].string), (yyvsp[-1].num),
                                        sel->select_limit,
                                        sel->offset_limit);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            sel->select_limit= NULL;
            sel->offset_limit= NULL;
            sel->explicit_limit= 0;
            (yyvsp[-4].item_list)->empty();
            sel->gorder_list.empty();
          }
#line 40570 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1771: /* window_func_expr: window_func OVER_SYM window_name  */
#line 11787 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_window_func(thd, (Item_sum *) (yyvsp[-2].item), (yyvsp[0].lex_str_ptr));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            if (unlikely(Select->add_window_func((Item_window_func *) (yyval.item))))
              MYSQL_YYABORT;
          }
#line 40582 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1772: /* window_func_expr: window_func OVER_SYM window_spec  */
#line 11796 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(Select->add_window_spec(thd, lex->win_ref,
                                                 Select->group_list,
                                                 Select->order_list,
                                                 lex->win_frame)))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_window_func(thd, (Item_sum *) (yyvsp[-2].item),
                                                      thd->lex->win_spec); 
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            if (unlikely(Select->add_window_func((Item_window_func *) (yyval.item))))
              MYSQL_YYABORT;
          }
#line 40601 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1775: /* window_func: function_call_generic  */
#line 11818 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item* item = (Item*)(yyvsp[0].item);
            /* Only UDF aggregate here possible */
            if ((item == NULL) ||
                (item->type() != Item::SUM_FUNC_ITEM)
                || (((Item_sum *)item)->sum_func() != Item_sum::UDF_SUM_FUNC))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 40617 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1776: /* simple_window_func: ROW_NUMBER_SYM '(' ')'  */
#line 11833 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_row_number(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40627 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1777: /* simple_window_func: RANK_SYM '(' ')'  */
#line 11840 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_rank(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40637 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1778: /* simple_window_func: DENSE_RANK_SYM '(' ')'  */
#line 11847 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_dense_rank(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40647 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1779: /* simple_window_func: PERCENT_RANK_SYM '(' ')'  */
#line 11854 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_percent_rank(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40657 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1780: /* simple_window_func: CUME_DIST_SYM '(' ')'  */
#line 11861 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_cume_dist(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40667 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1781: /* simple_window_func: NTILE_SYM '(' expr ')'  */
#line 11868 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_ntile(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40677 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1782: /* simple_window_func: FIRST_VALUE_SYM '(' expr ')'  */
#line 11875 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_first_value(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40687 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1783: /* simple_window_func: LAST_VALUE '(' expr ')'  */
#line 11882 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_last_value(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40697 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1784: /* simple_window_func: NTH_VALUE_SYM '(' expr ',' expr ')'  */
#line 11889 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_nth_value(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40707 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1785: /* simple_window_func: LEAD_SYM '(' expr ')'  */
#line 11896 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* No second argument defaults to 1. */
            Item* item_offset= new (thd->mem_root) Item_uint(thd, 1);
            if (unlikely(item_offset == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_sum_lead(thd, (yyvsp[-1].item), item_offset);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40721 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1786: /* simple_window_func: LEAD_SYM '(' expr ',' expr ')'  */
#line 11907 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_lead(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40731 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1787: /* simple_window_func: LAG_SYM '(' expr ')'  */
#line 11914 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* No second argument defaults to 1. */
            Item* item_offset= new (thd->mem_root) Item_uint(thd, 1);
            if (unlikely(item_offset == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_sum_lag(thd, (yyvsp[-1].item), item_offset);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40745 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1788: /* simple_window_func: LAG_SYM '(' expr ',' expr ')'  */
#line 11925 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_lag(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40755 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1789: /* inverse_distribution_function: percentile_function OVER_SYM '(' opt_window_partition_clause ')'  */
#line 11937 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(Select->add_window_spec(thd, lex->win_ref,
                                                 Select->group_list,
                                                 Select->order_list,
                                                 NULL)))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_window_func(thd, (Item_sum *) (yyvsp[-4].item),
                                                     thd->lex->win_spec);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            if (unlikely(Select->add_window_func((Item_window_func *) (yyval.item))))
              MYSQL_YYABORT;
          }
#line 40774 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1790: /* $@152: %empty  */
#line 11955 "/home/buildbot/git/sql/sql_yacc.yy"
           { Select->prepare_add_window_spec(thd); }
#line 40780 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1791: /* percentile_function: inverse_distribution_function_def WITHIN GROUP_SYM '(' $@152 order_by_single_element_list ')'  */
#line 11957 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             (yyval.item)= (yyvsp[-6].item);
           }
#line 40788 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1792: /* percentile_function: MEDIAN_SYM '(' expr ')'  */
#line 11961 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *args= new (thd->mem_root) Item_decimal(thd, "0.5", 3,
                                                   thd->charset());
            if (unlikely(args == NULL) || unlikely(thd->is_error()))
              MYSQL_YYABORT;
            Select->prepare_add_window_spec(thd);
            if (unlikely(add_order_to_list(thd, (yyvsp[-1].item),FALSE)))
              MYSQL_YYABORT;

            (yyval.item)= new (thd->mem_root) Item_sum_percentile_cont(thd, args);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40806 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1793: /* inverse_distribution_function_def: PERCENTILE_CONT_SYM '(' expr ')'  */
#line 11978 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_percentile_cont(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40816 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1794: /* inverse_distribution_function_def: PERCENTILE_DISC_SYM '(' expr ')'  */
#line 11984 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_percentile_disc(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40826 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1795: /* order_by_single_element_list: ORDER_SYM BY order_ident order_dir  */
#line 11993 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(add_order_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
          }
#line 40835 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1796: /* window_name: ident  */
#line 12002 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_str_ptr)= (LEX_CSTRING *) thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING));
            if (unlikely((yyval.lex_str_ptr) == NULL))
              MYSQL_YYABORT;
          }
#line 40845 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1797: /* $@153: %empty  */
#line 12011 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(! Lex->parsing_options.allows_variable))
              my_yyabort_error((ER_VIEW_SELECT_VARIABLE, MYF(0)));
          }
#line 40854 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1798: /* variable: '@' $@153 variable_aux  */
#line 12016 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= (yyvsp[0].item);
          }
#line 40862 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1799: /* variable_aux: ident_or_text SET_VAR expr  */
#line 12023 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item_func_set_user_var *item;
            (yyval.item)= item= new (thd->mem_root) Item_func_set_user_var(thd, &(yyvsp[-2].lex_str), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            LEX *lex= Lex;
            lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
            lex->set_var_list.push_back(item, thd->mem_root);
          }
#line 40876 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1800: /* variable_aux: ident_or_text  */
#line 12033 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_get_user_var(thd, &(yyvsp[0].lex_str));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            LEX *lex= Lex;
            lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
          }
#line 40888 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1801: /* variable_aux: '@' opt_var_ident_type ident_sysvar_name  */
#line 12041 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_sysvar(thd, (yyvsp[-1].var_type), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 40897 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1802: /* variable_aux: '@' opt_var_ident_type ident_sysvar_name '.' ident  */
#line 12046 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_sysvar(thd, (yyvsp[-3].var_type), &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 40906 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1803: /* opt_distinct: %empty  */
#line 12053 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num) = 0; }
#line 40912 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1804: /* opt_distinct: DISTINCT  */
#line 12054 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num) = 1; }
#line 40918 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1805: /* opt_gconcat_separator: %empty  */
#line 12059 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.string)= new (thd->mem_root) String(",", 1, &my_charset_latin1);
            if (unlikely((yyval.string) == NULL))
              MYSQL_YYABORT;
          }
#line 40928 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1806: /* opt_gconcat_separator: SEPARATOR_SYM text_string  */
#line 12064 "/home/buildbot/git/sql/sql_yacc.yy"
                                    { (yyval.string) = (yyvsp[0].string); }
#line 40934 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1809: /* gorder_list: gorder_list ',' order_ident order_dir  */
#line 12074 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(add_gorder_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
           }
#line 40943 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1810: /* gorder_list: order_ident order_dir  */
#line 12079 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(add_gorder_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
           }
#line 40952 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1811: /* opt_glimit_clause: %empty  */
#line 12086 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num) = 0; }
#line 40958 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1812: /* opt_glimit_clause: glimit_clause  */
#line 12087 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.num) = 1; }
#line 40964 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1813: /* glimit_clause_init: LIMIT  */
#line 12091 "/home/buildbot/git/sql/sql_yacc.yy"
               {}
#line 40970 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1814: /* glimit_clause: glimit_clause_init glimit_options  */
#line 12096 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 40978 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1815: /* glimit_options: limit_option  */
#line 12103 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[0].item);
            sel->offset_limit= 0;
            sel->explicit_limit= 1;
          }
#line 40989 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1816: /* glimit_options: limit_option ',' limit_option  */
#line 12110 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[0].item);
            sel->offset_limit= (yyvsp[-2].item);
            sel->explicit_limit= 1;
          }
#line 41000 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1817: /* glimit_options: limit_option OFFSET_SYM limit_option  */
#line 12117 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[-2].item);
            sel->offset_limit= (yyvsp[0].item);
            sel->explicit_limit= 1;
          }
#line 41011 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1818: /* $@154: %empty  */
#line 12129 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->current_select->inc_in_sum_expr()))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 41024 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1819: /* in_sum_expr: opt_all $@154 expr  */
#line 12138 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->in_sum_expr--;
            (yyval.item)= (yyvsp[0].item);
          }
#line 41033 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1820: /* cast_type: BINARY opt_field_length  */
#line 12146 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[0].const_simple_string)); Lex->charset= &my_charset_bin; }
#line 41039 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1821: /* $@155: %empty  */
#line 12148 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 41045 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1822: /* cast_type: CHAR_SYM opt_field_length $@155 opt_binary  */
#line 12150 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[-2].const_simple_string)); }
#line 41051 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1823: /* $@156: %empty  */
#line 12152 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 41057 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1824: /* cast_type: VARCHAR field_length $@156 opt_binary  */
#line 12154 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[-2].const_simple_string)); }
#line 41063 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1825: /* $@157: %empty  */
#line 12156 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 41069 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1826: /* cast_type: VARCHAR2_ORACLE_SYM field_length $@157 opt_binary  */
#line 12158 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[-2].const_simple_string)); }
#line 41075 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1827: /* cast_type: NCHAR_SYM opt_field_length  */
#line 12160 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset= national_charset_info;
            (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[0].const_simple_string), 0);
          }
#line 41084 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1828: /* cast_type: cast_type_numeric  */
#line 12164 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.Lex_cast_type)= (yyvsp[0].Lex_cast_type); Lex->charset= NULL; }
#line 41090 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1829: /* cast_type: cast_type_temporal  */
#line 12165 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.Lex_cast_type)= (yyvsp[0].Lex_cast_type); Lex->charset= NULL; }
#line 41096 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1830: /* cast_type_numeric: INT_SYM  */
#line 12169 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_longlong); }
#line 41102 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1831: /* cast_type_numeric: SIGNED_SYM  */
#line 12170 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_longlong); }
#line 41108 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1832: /* cast_type_numeric: SIGNED_SYM INT_SYM  */
#line 12171 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_longlong); }
#line 41114 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1833: /* cast_type_numeric: UNSIGNED  */
#line 12172 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_ulonglong); }
#line 41120 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1834: /* cast_type_numeric: UNSIGNED INT_SYM  */
#line 12173 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_ulonglong); }
#line 41126 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1835: /* cast_type_numeric: DECIMAL_SYM float_options  */
#line 12174 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_newdecimal, (yyvsp[0].Lex_length_and_dec)); }
#line 41132 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1836: /* cast_type_numeric: FLOAT_SYM  */
#line 12175 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_float); }
#line 41138 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1837: /* cast_type_numeric: DOUBLE_SYM opt_precision  */
#line 12176 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_double, (yyvsp[0].Lex_length_and_dec));  }
#line 41144 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1838: /* cast_type_temporal: DATE_SYM  */
#line 12180 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_newdate); }
#line 41150 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1839: /* cast_type_temporal: TIME_SYM opt_field_length  */
#line 12181 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_time2, 0, (yyvsp[0].const_simple_string)); }
#line 41156 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1840: /* cast_type_temporal: DATETIME opt_field_length  */
#line 12182 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_datetime2, 0, (yyvsp[0].const_simple_string)); }
#line 41162 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1841: /* cast_type_temporal: INTERVAL_SYM DAY_SECOND_SYM field_length  */
#line 12184 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_cast_type).set(&type_handler_interval_DDhhmmssff, 0, (yyvsp[0].const_simple_string));
          }
#line 41170 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1842: /* opt_expr_list: %empty  */
#line 12190 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.item_list)= NULL; }
#line 41176 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1843: /* opt_expr_list: expr_list  */
#line 12191 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.item_list)= (yyvsp[0].item_list);}
#line 41182 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1844: /* expr_list: expr  */
#line 12196 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_list)= List<Item>::make(thd->mem_root, (yyvsp[0].item)))))
              MYSQL_YYABORT;
          }
#line 41191 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1845: /* expr_list: expr_list ',' expr  */
#line 12201 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root);
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 41200 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1846: /* ident_list_arg: ident_list  */
#line 12208 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.item_list)= (yyvsp[0].item_list); }
#line 41206 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1847: /* ident_list_arg: '(' ident_list ')'  */
#line 12209 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.item_list)= (yyvsp[-1].item_list); }
#line 41212 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1848: /* ident_list: simple_ident  */
#line 12214 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL) ||
                unlikely((yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 41223 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1849: /* ident_list: ident_list ',' simple_ident  */
#line 12221 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root);
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 41232 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1850: /* when_list: WHEN_SYM expr THEN_SYM expr  */
#line 12229 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL))
              MYSQL_YYABORT;
            if (unlikely((yyval.item_list)->push_back((yyvsp[-2].item), thd->mem_root) ||
                         (yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 41245 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1851: /* when_list: when_list WHEN_SYM expr THEN_SYM expr  */
#line 12238 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[-4].item_list)->push_back((yyvsp[-2].item), thd->mem_root) ||
                         (yyvsp[-4].item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.item_list)= (yyvsp[-4].item_list);
          }
#line 41256 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1853: /* when_list_opt_else: when_list ELSE expr  */
#line 12249 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 41266 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1854: /* table_ref: table_factor  */
#line 12259 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41272 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1855: /* table_ref: join_table  */
#line 12261 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->nest_last_join(thd))))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 41285 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1856: /* join_table_list: derived_table_list  */
#line 12272 "/home/buildbot/git/sql/sql_yacc.yy"
                             { MYSQL_YYABORT_UNLESS((yyval.table_list)=(yyvsp[0].table_list)); }
#line 41291 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1857: /* esc_table_ref: table_ref  */
#line 12283 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.table_list)=(yyvsp[0].table_list); }
#line 41297 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1858: /* esc_table_ref: '{' ident table_ref '}'  */
#line 12284 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.table_list)=(yyvsp[-1].table_list); }
#line 41303 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1859: /* derived_table_list: esc_table_ref  */
#line 12291 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.table_list)=(yyvsp[0].table_list);
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 41312 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1860: /* derived_table_list: derived_table_list ',' esc_table_ref  */
#line 12296 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-2].table_list) && ((yyval.table_list)=(yyvsp[0].table_list)));
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 41321 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1861: /* join_table: table_ref normal_join table_ref  */
#line 12310 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-2].table_list) && ((yyval.table_list)=(yyvsp[0].table_list)));
            if (unlikely(Select->add_cross_joined_table((yyvsp[-2].table_list), (yyvsp[0].table_list), (yyvsp[-1].num))))
              MYSQL_YYABORT;
          }
#line 41331 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1862: /* $@158: %empty  */
#line 12317 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-3].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-3].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
            /* Change the current name resolution context to a local context. */
            if (unlikely(push_new_name_resolution_context(thd, (yyvsp[-3].table_list), (yyvsp[-1].table_list))))
              MYSQL_YYABORT;
            Select->parsing_place= IN_ON;
          }
#line 41345 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1863: /* join_table: table_ref normal_join table_ref ON $@158 expr  */
#line 12327 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-3].table_list)->straight=(yyvsp[-4].num);
            add_join_on(thd, (yyvsp[-3].table_list), (yyvsp[0].item));
            (yyvsp[-3].table_list)->on_context= Lex->pop_context();
            Select->parsing_place= NO_MATTER;
          }
#line 41356 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1864: /* $@159: %empty  */
#line 12335 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-3].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-3].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
          }
#line 41366 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1865: /* join_table: table_ref normal_join table_ref USING $@159 '(' using_list ')'  */
#line 12341 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    (yyvsp[-5].table_list)->straight=(yyvsp[-6].num);
            add_join_natural((yyvsp[-7].table_list),(yyvsp[-5].table_list),(yyvsp[-1].string_list),Select); 
	    (yyval.table_list)=(yyvsp[-5].table_list); 
          }
#line 41376 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1866: /* join_table: table_ref NATURAL inner_join table_factor  */
#line 12347 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-3].table_list) && ((yyval.table_list)=(yyvsp[0].table_list)));
            Select->add_joined_table((yyvsp[-3].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
	    (yyvsp[0].table_list)->straight=(yyvsp[-1].num);
            add_join_natural((yyvsp[-3].table_list),(yyvsp[0].table_list),NULL,Select);
          }
#line 41388 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1867: /* $@160: %empty  */
#line 12358 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
            /* Change the current name resolution context to a local context. */
            if (unlikely(push_new_name_resolution_context(thd, (yyvsp[-5].table_list), (yyvsp[-1].table_list))))
              MYSQL_YYABORT;
            Select->parsing_place= IN_ON;
          }
#line 41402 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1868: /* join_table: table_ref LEFT opt_outer JOIN_SYM table_ref ON $@160 expr  */
#line 12368 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            add_join_on(thd, (yyvsp[-3].table_list), (yyvsp[0].item));
            (yyvsp[-3].table_list)->on_context= Lex->pop_context();
            (yyvsp[-3].table_list)->outer_join|=JOIN_TYPE_LEFT;
            (yyval.table_list)=(yyvsp[-3].table_list);
            Select->parsing_place= NO_MATTER;
          }
#line 41414 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1869: /* $@161: %empty  */
#line 12376 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-4].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-4].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 41424 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1870: /* join_table: table_ref LEFT opt_outer JOIN_SYM table_factor $@161 USING '(' using_list ')'  */
#line 12382 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            add_join_natural((yyvsp[-9].table_list),(yyvsp[-5].table_list),(yyvsp[-1].string_list),Select); 
            (yyvsp[-5].table_list)->outer_join|=JOIN_TYPE_LEFT; 
            (yyval.table_list)=(yyvsp[-5].table_list); 
          }
#line 41434 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1871: /* join_table: table_ref NATURAL LEFT opt_outer JOIN_SYM table_factor  */
#line 12388 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
            add_join_natural((yyvsp[-5].table_list),(yyvsp[0].table_list),NULL,Select);
            (yyvsp[0].table_list)->outer_join|=JOIN_TYPE_LEFT;
            (yyval.table_list)=(yyvsp[0].table_list);
          }
#line 41447 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1872: /* $@162: %empty  */
#line 12400 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
            /* Change the current name resolution context to a local context. */
            if (unlikely(push_new_name_resolution_context(thd, (yyvsp[-5].table_list), (yyvsp[-1].table_list))))
              MYSQL_YYABORT;
            Select->parsing_place= IN_ON;
          }
#line 41461 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1873: /* join_table: table_ref RIGHT opt_outer JOIN_SYM table_ref ON $@162 expr  */
#line 12410 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->convert_right_join())))
              MYSQL_YYABORT;
            add_join_on(thd, (yyval.table_list), (yyvsp[0].item));
            (yyvsp[-7].table_list)->on_context= Lex->pop_context();
            Select->parsing_place= NO_MATTER;
          }
#line 41474 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1874: /* $@163: %empty  */
#line 12419 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-4].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-4].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 41484 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1875: /* join_table: table_ref RIGHT opt_outer JOIN_SYM table_factor $@163 USING '(' using_list ')'  */
#line 12425 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->convert_right_join())))
              MYSQL_YYABORT;
            add_join_natural((yyval.table_list),(yyvsp[-5].table_list),(yyvsp[-1].string_list),Select);
          }
#line 41495 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1876: /* join_table: table_ref NATURAL RIGHT opt_outer JOIN_SYM table_factor  */
#line 12432 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
            add_join_natural((yyvsp[0].table_list),(yyvsp[-5].table_list),NULL,Select);
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->convert_right_join())))
              MYSQL_YYABORT;
          }
#line 41509 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1877: /* inner_join: JOIN_SYM  */
#line 12445 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num) = 0; }
#line 41515 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1878: /* inner_join: INNER_SYM JOIN_SYM  */
#line 12446 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num) = 0; }
#line 41521 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1879: /* inner_join: STRAIGHT_JOIN  */
#line 12447 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num) = 1; }
#line 41527 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1880: /* normal_join: inner_join  */
#line 12451 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num) = (yyvsp[0].num); }
#line 41533 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1881: /* normal_join: CROSS JOIN_SYM  */
#line 12452 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num) = 0; }
#line 41539 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1882: /* opt_use_partition: %empty  */
#line 12460 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.string_list)= 0;}
#line 41545 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1884: /* use_partition: PARTITION_SYM '(' using_list ')' have_partitioning  */
#line 12466 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.string_list)= (yyvsp[-2].string_list);
            Select->parsing_place= Select->save_parsing_place;
            Select->save_parsing_place= NO_MATTER;
          }
#line 41555 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1885: /* table_factor: table_primary_ident_opt_parens  */
#line 12474 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41561 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1886: /* table_factor: table_primary_derived_opt_parens  */
#line 12475 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41567 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1887: /* table_factor: join_table_parens  */
#line 12477 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            (yyvsp[0].table_list)->nested_join->nest_type= 0;
            (yyval.table_list)= (yyvsp[0].table_list);
          }
#line 41576 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1888: /* table_factor: table_reference_list_parens  */
#line 12481 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41582 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1889: /* table_primary_ident_opt_parens: table_primary_ident  */
#line 12485 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41588 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1890: /* table_primary_ident_opt_parens: '(' table_primary_ident_opt_parens ')'  */
#line 12486 "/home/buildbot/git/sql/sql_yacc.yy"
                                                 { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 41594 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1891: /* table_primary_derived_opt_parens: table_primary_derived  */
#line 12490 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41600 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1892: /* table_primary_derived_opt_parens: '(' table_primary_derived_opt_parens ')'  */
#line 12491 "/home/buildbot/git/sql/sql_yacc.yy"
                                                   { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 41606 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1893: /* table_reference_list_parens: '(' table_reference_list_parens ')'  */
#line 12495 "/home/buildbot/git/sql/sql_yacc.yy"
                                              { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 41612 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1894: /* table_reference_list_parens: '(' nested_table_reference_list ')'  */
#line 12497 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.table_list)= Select->end_nested_join(thd)))
              MYSQL_YYABORT;
          }
#line 41621 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1895: /* nested_table_reference_list: table_ref ',' table_ref  */
#line 12505 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Select->init_nested_join(thd))
              MYSQL_YYABORT;
            Select->add_joined_table((yyvsp[-2].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
            (yyval.table_list)= (yyvsp[-2].table_list)->embedding;
          }
#line 41633 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1896: /* nested_table_reference_list: nested_table_reference_list ',' table_ref  */
#line 12513 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->add_joined_table((yyvsp[0].table_list));
            (yyval.table_list)= (yyvsp[-2].table_list);
          }
#line 41642 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1897: /* join_table_parens: '(' join_table_parens ')'  */
#line 12520 "/home/buildbot/git/sql/sql_yacc.yy"
                                    { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 41648 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1898: /* join_table_parens: '(' join_table ')'  */
#line 12522 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (!((yyval.table_list)= lex->current_select->nest_last_join(thd)))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 41661 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1899: /* table_primary_ident: table_ident opt_use_partition opt_for_system_time_clause opt_table_alias_clause opt_key_definition  */
#line 12536 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->table_join_options= 0;
            if (!((yyval.table_list)= Select->add_table_to_list(thd, (yyvsp[-4].table), (yyvsp[-1].lex_str_ptr),
                                                Select->get_table_join_options(),
                                                YYPS->m_lock_type,
                                                YYPS->m_mdl_type,
                                                Select->pop_index_hints(),
                                                (yyvsp[-3].string_list))))
              MYSQL_YYABORT;
            if ((yyvsp[-2].num))
              (yyval.table_list)->vers_conditions= Lex->vers_conditions;
          }
#line 41679 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1900: /* table_primary_derived: subquery opt_for_system_time_clause table_alias_clause  */
#line 12554 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.table_list)= Lex->parsed_derived_table((yyvsp[-2].select_lex)->master_unit(), (yyvsp[-1].num), (yyvsp[0].lex_str_ptr))))
              MYSQL_YYABORT;
          }
#line 41688 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1901: /* opt_outer: %empty  */
#line 12561 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 41694 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1902: /* opt_outer: OUTER  */
#line 12562 "/home/buildbot/git/sql/sql_yacc.yy"
                {}
#line 41700 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1903: /* index_hint_clause: %empty  */
#line 12567 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= thd->variables.old_mode ?  INDEX_HINT_MASK_JOIN : INDEX_HINT_MASK_ALL; 
          }
#line 41708 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1904: /* index_hint_clause: FOR_SYM JOIN_SYM  */
#line 12570 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.num)= INDEX_HINT_MASK_JOIN;  }
#line 41714 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1905: /* index_hint_clause: FOR_SYM ORDER_SYM BY  */
#line 12571 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.num)= INDEX_HINT_MASK_ORDER; }
#line 41720 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1906: /* index_hint_clause: FOR_SYM GROUP_SYM BY  */
#line 12572 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.num)= INDEX_HINT_MASK_GROUP; }
#line 41726 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1907: /* index_hint_type: FORCE_SYM  */
#line 12576 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.index_hint)= INDEX_HINT_FORCE; }
#line 41732 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1908: /* index_hint_type: IGNORE_SYM  */
#line 12577 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.index_hint)= INDEX_HINT_IGNORE; }
#line 41738 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1909: /* $@164: %empty  */
#line 12582 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->set_index_hint_type((yyvsp[-2].index_hint), (yyvsp[0].num));
          }
#line 41746 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1911: /* $@165: %empty  */
#line 12587 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->set_index_hint_type(INDEX_HINT_USE, (yyvsp[0].num));
          }
#line 41754 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1916: /* $@166: %empty  */
#line 12600 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->alloc_index_hints(thd); }
#line 41760 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1918: /* $@167: %empty  */
#line 12604 "/home/buildbot/git/sql/sql_yacc.yy"
          {  Select->clear_index_hints(); }
#line 41766 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1920: /* opt_key_usage_list: %empty  */
#line 12609 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Select->add_index_hint(thd, NULL, 0); }
#line 41772 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1921: /* opt_key_usage_list: key_usage_list  */
#line 12610 "/home/buildbot/git/sql/sql_yacc.yy"
                         {}
#line 41778 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1922: /* key_usage_element: ident  */
#line 12615 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->add_index_hint(thd, (yyvsp[0].ident_sys).str, (yyvsp[0].ident_sys).length); }
#line 41784 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1923: /* key_usage_element: PRIMARY_SYM  */
#line 12617 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->add_index_hint(thd, "PRIMARY", 7); }
#line 41790 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1926: /* using_list: ident  */
#line 12627 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.string_list)= new (thd->mem_root) List<String>)))
              MYSQL_YYABORT;
            String *s= new (thd->mem_root) String((const char *) (yyvsp[0].ident_sys).str,
                                                    (yyvsp[0].ident_sys).length,
                                                    system_charset_info);
            if (unlikely(unlikely(s == NULL)))
              MYSQL_YYABORT;
            (yyval.string_list)->push_back(s, thd->mem_root);
          }
#line 41805 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1927: /* using_list: using_list ',' ident  */
#line 12638 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            String *s= new (thd->mem_root) String((const char *) (yyvsp[0].ident_sys).str,
                                                    (yyvsp[0].ident_sys).length,
                                                    system_charset_info);
            if (unlikely(unlikely(s == NULL)))
              MYSQL_YYABORT;
            if (unlikely((yyvsp[-2].string_list)->push_back(s, thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.string_list)= (yyvsp[-2].string_list);
          }
#line 41820 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1928: /* interval: interval_time_stamp  */
#line 12651 "/home/buildbot/git/sql/sql_yacc.yy"
                                 {}
#line 41826 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1929: /* interval: DAY_HOUR_SYM  */
#line 12652 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_DAY_HOUR; }
#line 41832 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1930: /* interval: DAY_MICROSECOND_SYM  */
#line 12653 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_DAY_MICROSECOND; }
#line 41838 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1931: /* interval: DAY_MINUTE_SYM  */
#line 12654 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_DAY_MINUTE; }
#line 41844 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1932: /* interval: DAY_SECOND_SYM  */
#line 12655 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_DAY_SECOND; }
#line 41850 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1933: /* interval: HOUR_MICROSECOND_SYM  */
#line 12656 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_HOUR_MICROSECOND; }
#line 41856 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1934: /* interval: HOUR_MINUTE_SYM  */
#line 12657 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_HOUR_MINUTE; }
#line 41862 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1935: /* interval: HOUR_SECOND_SYM  */
#line 12658 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_HOUR_SECOND; }
#line 41868 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1936: /* interval: MINUTE_MICROSECOND_SYM  */
#line 12659 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_MINUTE_MICROSECOND; }
#line 41874 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1937: /* interval: MINUTE_SECOND_SYM  */
#line 12660 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_MINUTE_SECOND; }
#line 41880 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1938: /* interval: SECOND_MICROSECOND_SYM  */
#line 12661 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_SECOND_MICROSECOND; }
#line 41886 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1939: /* interval: YEAR_MONTH_SYM  */
#line 12662 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_YEAR_MONTH; }
#line 41892 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1940: /* interval_time_stamp: DAY_SYM  */
#line 12666 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_DAY; }
#line 41898 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1941: /* interval_time_stamp: WEEK_SYM  */
#line 12667 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_WEEK; }
#line 41904 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1942: /* interval_time_stamp: HOUR_SYM  */
#line 12668 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_HOUR; }
#line 41910 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1943: /* interval_time_stamp: MINUTE_SYM  */
#line 12669 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_MINUTE; }
#line 41916 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1944: /* interval_time_stamp: MONTH_SYM  */
#line 12670 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_MONTH; }
#line 41922 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1945: /* interval_time_stamp: QUARTER_SYM  */
#line 12671 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_QUARTER; }
#line 41928 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1946: /* interval_time_stamp: SECOND_SYM  */
#line 12672 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_SECOND; }
#line 41934 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1947: /* interval_time_stamp: MICROSECOND_SYM  */
#line 12673 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_MICROSECOND; }
#line 41940 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1948: /* interval_time_stamp: YEAR_SYM  */
#line 12674 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_YEAR; }
#line 41946 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1949: /* date_time_type: DATE_SYM  */
#line 12678 "/home/buildbot/git/sql/sql_yacc.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_DATE;}
#line 41952 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1950: /* date_time_type: TIME_SYM  */
#line 12679 "/home/buildbot/git/sql/sql_yacc.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_TIME;}
#line 41958 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1951: /* date_time_type: DATETIME  */
#line 12680 "/home/buildbot/git/sql/sql_yacc.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_DATETIME;}
#line 41964 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1952: /* date_time_type: TIMESTAMP  */
#line 12681 "/home/buildbot/git/sql/sql_yacc.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_DATETIME;}
#line 41970 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1956: /* opt_table_alias_clause: %empty  */
#line 12691 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lex_str_ptr)=0; }
#line 41976 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1957: /* opt_table_alias_clause: table_alias_clause  */
#line 12692 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.lex_str_ptr)= (yyvsp[0].lex_str_ptr); }
#line 41982 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1958: /* table_alias_clause: table_alias ident_table_alias  */
#line 12697 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_str_ptr)= (LEX_CSTRING*) thd->memdup(&(yyvsp[0].ident_sys),sizeof(LEX_STRING));
            if (unlikely((yyval.lex_str_ptr) == NULL))
              MYSQL_YYABORT;
          }
#line 41992 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1961: /* opt_where_clause: %empty  */
#line 12710 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Select->where= 0; }
#line 41998 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1962: /* $@168: %empty  */
#line 12712 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->parsing_place= IN_WHERE;
          }
#line 42006 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1963: /* opt_where_clause: WHERE $@168 expr  */
#line 12716 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *select= Select;
            select->where= normalize_cond(thd, (yyvsp[0].item));
            select->parsing_place= NO_MATTER;
            if ((yyvsp[0].item))
              (yyvsp[0].item)->top_level_item();
          }
#line 42018 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1965: /* $@169: %empty  */
#line 12728 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->parsing_place= IN_HAVING;
          }
#line 42026 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1966: /* opt_having_clause: HAVING $@169 expr  */
#line 12732 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->having= normalize_cond(thd, (yyvsp[0].item));
            sel->parsing_place= NO_MATTER;
            if ((yyvsp[0].item))
              (yyvsp[0].item)->top_level_item();
          }
#line 42038 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1969: /* group_list: group_list ',' order_ident order_dir  */
#line 12752 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             if (unlikely(add_group_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
               MYSQL_YYABORT;
           }
#line 42047 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1970: /* group_list: order_ident order_dir  */
#line 12757 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(add_group_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
           }
#line 42056 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1971: /* olap_opt: %empty  */
#line 12764 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 42062 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1972: /* olap_opt: WITH_CUBE_SYM  */
#line 12766 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              'WITH CUBE' is reserved in the MySQL syntax, but not implemented,
              and cause LALR(2) conflicts.
              This syntax is not standard.
              MySQL syntax: GROUP BY col1, col2, col3 WITH CUBE
              SQL-2003: GROUP BY ... CUBE(col1, col2, col3)
            */
            LEX *lex=Lex;
            if (unlikely(lex->current_select->get_linkage() == GLOBAL_OPTIONS_TYPE))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "WITH CUBE",
                                "global union parameters"));
            lex->current_select->olap= CUBE_TYPE;

            my_yyabort_error((ER_NOT_SUPPORTED_YET, MYF(0), "CUBE"));
          }
#line 42083 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1973: /* olap_opt: WITH_ROLLUP_SYM  */
#line 12783 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              'WITH ROLLUP' is needed for backward compatibility,
              and cause LALR(2) conflicts.
              This syntax is not standard.
              MySQL syntax: GROUP BY col1, col2, col3 WITH ROLLUP
              SQL-2003: GROUP BY ... ROLLUP(col1, col2, col3)
            */
            LEX *lex= Lex;
            if (unlikely(lex->current_select->get_linkage() == GLOBAL_OPTIONS_TYPE))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "WITH ROLLUP",
                                "global union parameters"));
            lex->current_select->olap= ROLLUP_TYPE;
          }
#line 42102 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1974: /* opt_window_clause: %empty  */
#line 12805 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 42108 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1975: /* opt_window_clause: WINDOW_SYM window_def_list  */
#line 12808 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 42114 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1978: /* window_def: window_name AS window_spec  */
#line 12818 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            LEX *lex= Lex;
            if (unlikely(Select->add_window_def(thd, (yyvsp[-2].lex_str_ptr), lex->win_ref,
                                                Select->group_list,
                                                Select->order_list,
                                                lex->win_frame)))
              MYSQL_YYABORT;
          }
#line 42127 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1979: /* $@170: %empty  */
#line 12830 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->prepare_add_window_spec(thd); }
#line 42133 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1980: /* window_spec: '(' $@170 opt_window_ref opt_window_partition_clause opt_window_order_clause opt_window_frame_clause ')'  */
#line 12834 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 42139 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1981: /* opt_window_ref: %empty  */
#line 12838 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 42145 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1982: /* opt_window_ref: ident  */
#line 12840 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            thd->lex->win_ref= (LEX_CSTRING *) thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING));
            if (unlikely(thd->lex->win_ref == NULL))
              MYSQL_YYABORT;
          }
#line 42155 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1983: /* opt_window_partition_clause: %empty  */
#line 12848 "/home/buildbot/git/sql/sql_yacc.yy"
                      { }
#line 42161 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1985: /* opt_window_order_clause: %empty  */
#line 12853 "/home/buildbot/git/sql/sql_yacc.yy"
                      { }
#line 42167 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1986: /* opt_window_order_clause: ORDER_SYM BY order_list  */
#line 12854 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Select->order_list= *((yyvsp[0].select_order)); }
#line 42173 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1987: /* opt_window_frame_clause: %empty  */
#line 12858 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 42179 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1988: /* opt_window_frame_clause: window_frame_units window_frame_extent opt_window_frame_exclusion  */
#line 12860 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->win_frame=
              new (thd->mem_root) Window_frame((yyvsp[-2].frame_units),
                                               lex->frame_top_bound,
                                               lex->frame_bottom_bound,
                                               (yyvsp[0].frame_exclusion));
            if (unlikely(lex->win_frame == NULL))
              MYSQL_YYABORT;
          }
#line 42194 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1989: /* window_frame_units: ROWS_SYM  */
#line 12873 "/home/buildbot/git/sql/sql_yacc.yy"
                   { (yyval.frame_units)= Window_frame::UNITS_ROWS; }
#line 42200 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1990: /* window_frame_units: RANGE_SYM  */
#line 12874 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.frame_units)= Window_frame::UNITS_RANGE; }
#line 42206 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1991: /* window_frame_extent: window_frame_start  */
#line 12879 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->frame_top_bound= (yyvsp[0].window_frame_bound);
            lex->frame_bottom_bound=
              new (thd->mem_root)
                Window_frame_bound(Window_frame_bound::CURRENT, NULL);
            if (unlikely(lex->frame_bottom_bound == NULL))
              MYSQL_YYABORT;
          }
#line 42220 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1992: /* window_frame_extent: BETWEEN_SYM window_frame_bound AND_SYM window_frame_bound  */
#line 12889 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->frame_top_bound= (yyvsp[-2].window_frame_bound);
            lex->frame_bottom_bound= (yyvsp[0].window_frame_bound);
          }
#line 42230 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1993: /* window_frame_start: UNBOUNDED_SYM PRECEDING_SYM  */
#line 12898 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root) 
                  Window_frame_bound(Window_frame_bound::PRECEDING, NULL); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 42241 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1994: /* window_frame_start: CURRENT_SYM ROW_SYM  */
#line 12905 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::CURRENT, NULL); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 42252 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1995: /* window_frame_start: literal PRECEDING_SYM  */
#line 12912 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::PRECEDING, (yyvsp[-1].item)); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 42263 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1996: /* window_frame_bound: window_frame_start  */
#line 12921 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.window_frame_bound)= (yyvsp[0].window_frame_bound); }
#line 42269 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1997: /* window_frame_bound: UNBOUNDED_SYM FOLLOWING_SYM  */
#line 12923 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::FOLLOWING, NULL); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 42280 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1998: /* window_frame_bound: literal FOLLOWING_SYM  */
#line 12930 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::FOLLOWING, (yyvsp[-1].item)); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 42291 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1999: /* opt_window_frame_exclusion: %empty  */
#line 12939 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.frame_exclusion)= Window_frame::EXCL_NONE; }
#line 42297 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2000: /* opt_window_frame_exclusion: EXCLUDE_SYM CURRENT_SYM ROW_SYM  */
#line 12941 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_CURRENT_ROW; }
#line 42303 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2001: /* opt_window_frame_exclusion: EXCLUDE_SYM GROUP_SYM  */
#line 12943 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_GROUP; }
#line 42309 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2002: /* opt_window_frame_exclusion: EXCLUDE_SYM TIES_SYM  */
#line 12945 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_TIES; }
#line 42315 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2003: /* opt_window_frame_exclusion: EXCLUDE_SYM NO_SYM OTHERS_MARIADB_SYM  */
#line 12947 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_NONE; }
#line 42321 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2004: /* opt_window_frame_exclusion: EXCLUDE_SYM NO_SYM OTHERS_ORACLE_SYM  */
#line 12949 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_NONE; }
#line 42327 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2008: /* alter_order_item: simple_ident_nospvar order_dir  */
#line 12967 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            bool ascending= ((yyvsp[0].num) == 1) ? true : false;
            if (unlikely(add_order_to_list(thd, (yyvsp[-1].item), ascending)))
              MYSQL_YYABORT;
          }
#line 42337 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2009: /* opt_order_clause: %empty  */
#line 12980 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_order)= NULL; }
#line 42343 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2010: /* opt_order_clause: order_clause  */
#line 12982 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_order)= (yyvsp[0].select_order); }
#line 42349 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2011: /* $@171: %empty  */
#line 12987 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            thd->where= "ORDER clause";
          }
#line 42357 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2012: /* order_clause: ORDER_SYM BY $@171 order_list  */
#line 12991 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_order)= (yyvsp[0].select_order);
          }
#line 42365 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2013: /* order_list: order_list ',' order_ident order_dir  */
#line 12998 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_order)= (yyvsp[-3].select_order);
            if (add_to_list(thd, *(yyval.select_order), (yyvsp[-1].item),(bool) (yyvsp[0].num)))
              MYSQL_YYABORT;
          }
#line 42375 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2014: /* order_list: order_ident order_dir  */
#line 13004 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_order)= new (thd->mem_root) SQL_I_List<ORDER>();
            if (add_to_list(thd, *(yyval.select_order), (yyvsp[-1].item), (bool) (yyvsp[0].num)))
              MYSQL_YYABORT;
          }
#line 42385 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2015: /* order_dir: %empty  */
#line 13012 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num) =  1; }
#line 42391 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2016: /* order_dir: ASC  */
#line 13013 "/home/buildbot/git/sql/sql_yacc.yy"
               { (yyval.num) =1; }
#line 42397 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2017: /* order_dir: DESC  */
#line 13014 "/home/buildbot/git/sql/sql_yacc.yy"
               { (yyval.num) =0; }
#line 42403 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2018: /* opt_limit_clause: %empty  */
#line 13019 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_limit).empty(); }
#line 42409 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2019: /* opt_limit_clause: limit_clause  */
#line 13021 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_limit)= (yyvsp[0].select_limit); }
#line 42415 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2020: /* limit_clause: LIMIT limit_options  */
#line 13026 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_limit)= (yyvsp[0].select_limit);
            if (!(yyval.select_limit).select_limit->basic_const_item() ||
                (yyval.select_limit).select_limit->val_int() > 0)
              Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 42426 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2021: /* limit_clause: LIMIT limit_options ROWS_SYM EXAMINED_SYM limit_rows_option  */
#line 13034 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_limit)= (yyvsp[-3].select_limit);
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 42435 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2022: /* limit_clause: LIMIT ROWS_SYM EXAMINED_SYM limit_rows_option  */
#line 13039 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_limit).select_limit= 0;
            (yyval.select_limit).offset_limit= 0;
            (yyval.select_limit).explicit_limit= 0;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 42446 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2023: /* opt_global_limit_clause: opt_limit_clause  */
#line 13049 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->explicit_limit= (yyvsp[0].select_limit).explicit_limit;
            Select->select_limit= (yyvsp[0].select_limit).select_limit;
            Select->offset_limit= (yyvsp[0].select_limit).offset_limit;
          }
#line 42456 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2024: /* limit_options: limit_option  */
#line 13058 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_limit).select_limit= (yyvsp[0].item);
            (yyval.select_limit).offset_limit= 0;
            (yyval.select_limit).explicit_limit= 1;
          }
#line 42466 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2025: /* limit_options: limit_option ',' limit_option  */
#line 13064 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_limit).select_limit= (yyvsp[0].item);
            (yyval.select_limit).offset_limit= (yyvsp[-2].item);
            (yyval.select_limit).explicit_limit= 1;
          }
#line 42476 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2026: /* limit_options: limit_option OFFSET_SYM limit_option  */
#line 13070 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_limit).select_limit= (yyvsp[-2].item);
            (yyval.select_limit).offset_limit= (yyvsp[0].item);
            (yyval.select_limit).explicit_limit= 1;
          }
#line 42486 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2027: /* limit_option: ident_cli  */
#line 13079 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_limit(thd, &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 42495 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2028: /* limit_option: ident_cli '.' ident_cli  */
#line 13084 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_limit(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 42504 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2029: /* limit_option: param_marker  */
#line 13089 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[0].item_param)->limit_clause_param= TRUE;
          }
#line 42512 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2030: /* limit_option: ULONGLONG_NUM  */
#line 13093 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 42522 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2031: /* limit_option: LONG_NUM  */
#line 13099 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 42532 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2032: /* limit_option: NUM  */
#line 13105 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 42542 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2033: /* limit_rows_option: limit_option  */
#line 13114 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            LEX *lex=Lex;
            lex->limit_rows_examined= (yyvsp[0].item);
          }
#line 42551 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2034: /* delete_limit_clause: %empty  */
#line 13122 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->current_select->select_limit= 0;
          }
#line 42560 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2035: /* delete_limit_clause: LIMIT limit_option  */
#line 13127 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[0].item);
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
            sel->explicit_limit= 1;
          }
#line 42571 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2036: /* delete_limit_clause: LIMIT ROWS_SYM EXAMINED_SYM  */
#line 13133 "/home/buildbot/git/sql/sql_yacc.yy"
                                     { thd->parse_error(); MYSQL_YYABORT; }
#line 42577 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2037: /* delete_limit_clause: LIMIT limit_option ROWS_SYM EXAMINED_SYM  */
#line 13134 "/home/buildbot/git/sql/sql_yacc.yy"
                                                  { thd->parse_error(); MYSQL_YYABORT; }
#line 42583 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2038: /* order_limit_lock: order_or_limit  */
#line 13139 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.order_limit_lock)= (yyvsp[0].order_limit_lock);
            (yyval.order_limit_lock)->lock.empty();
          }
#line 42592 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2039: /* order_limit_lock: order_or_limit select_lock_type  */
#line 13144 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.order_limit_lock)= (yyvsp[-1].order_limit_lock);
            (yyval.order_limit_lock)->lock= (yyvsp[0].select_lock);
          }
#line 42601 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2040: /* order_limit_lock: select_lock_type  */
#line 13149 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.order_limit_lock)= new(thd->mem_root) Lex_order_limit_lock;
            if (!(yyval.order_limit_lock))
              YYABORT;
            (yyval.order_limit_lock)->order_list= NULL;
            (yyval.order_limit_lock)->limit.empty();
            (yyval.order_limit_lock)->lock= (yyvsp[0].select_lock);
          }
#line 42614 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2041: /* opt_order_limit_lock: %empty  */
#line 13161 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select();
            (yyval.order_limit_lock)= NULL;
          }
#line 42623 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2042: /* opt_order_limit_lock: order_limit_lock  */
#line 13165 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.order_limit_lock)= (yyvsp[0].order_limit_lock); }
#line 42629 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2045: /* opt_procedure_or_into: %empty  */
#line 13178 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_lock).empty();
          }
#line 42637 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2046: /* opt_procedure_or_into: procedure_clause opt_select_lock_type  */
#line 13182 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_lock)= (yyvsp[0].select_lock);
          }
#line 42645 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2047: /* opt_procedure_or_into: into opt_select_lock_type  */
#line 13186 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                                ER_WARN_DEPRECATED_SYNTAX,
                                ER_THD(thd, ER_WARN_DEPRECATED_SYNTAX),
                                "<select expression> INTO <destination>;",
                                "'SELECT <select list> INTO <destination>"
                                " FROM...'");
            (yyval.select_lock)= (yyvsp[0].select_lock);
          }
#line 42659 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2048: /* order_or_limit: order_clause opt_limit_clause  */
#line 13199 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.order_limit_lock)= new(thd->mem_root) Lex_order_limit_lock;
            if (!(yyval.order_limit_lock))
              YYABORT;
            (yyval.order_limit_lock)->order_list= (yyvsp[-1].select_order);
            (yyval.order_limit_lock)->limit= (yyvsp[0].select_limit);
          }
#line 42671 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2049: /* order_or_limit: limit_clause  */
#line 13207 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex_order_limit_lock *op= (yyval.order_limit_lock)= new(thd->mem_root) Lex_order_limit_lock;
            if (!(yyval.order_limit_lock))
              YYABORT;
            op->order_list= NULL;
            op->limit= (yyvsp[0].select_limit);
            (yyval.order_limit_lock)->order_list= NULL;
            (yyval.order_limit_lock)->limit= (yyvsp[0].select_limit);
          }
#line 42685 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2052: /* int_num: opt_plus NUM  */
#line 13225 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.num)= (int) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42691 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2053: /* int_num: '-' NUM  */
#line 13226 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.num)= -(int) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42697 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2054: /* ulong_num: opt_plus NUM  */
#line 13230 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42703 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2055: /* ulong_num: HEX_NUM  */
#line 13231 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.ulong_num)= (ulong) strtol((yyvsp[0].lex_str).str, (char**) 0, 16); }
#line 42709 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2056: /* ulong_num: opt_plus LONG_NUM  */
#line 13232 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42715 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2057: /* ulong_num: opt_plus ULONGLONG_NUM  */
#line 13233 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42721 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2058: /* ulong_num: opt_plus DECIMAL_NUM  */
#line 13234 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42727 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2059: /* ulong_num: opt_plus FLOAT_NUM  */
#line 13235 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42733 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2060: /* real_ulong_num: NUM  */
#line 13239 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42739 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2061: /* real_ulong_num: HEX_NUM  */
#line 13240 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.ulong_num)= (ulong) strtol((yyvsp[0].lex_str).str, (char**) 0, 16); }
#line 42745 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2062: /* real_ulong_num: LONG_NUM  */
#line 13241 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42751 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2063: /* real_ulong_num: ULONGLONG_NUM  */
#line 13242 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42757 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2064: /* real_ulong_num: dec_num_error  */
#line 13243 "/home/buildbot/git/sql/sql_yacc.yy"
                        { MYSQL_YYABORT; }
#line 42763 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2065: /* longlong_num: opt_plus NUM  */
#line 13247 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.longlong_number)= (longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42769 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2066: /* longlong_num: LONG_NUM  */
#line 13248 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.longlong_number)= (longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42775 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2067: /* longlong_num: '-' NUM  */
#line 13249 "/home/buildbot/git/sql/sql_yacc.yy"
                          { int error; (yyval.longlong_number)= -(longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42781 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2068: /* longlong_num: '-' LONG_NUM  */
#line 13250 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.longlong_number)= -(longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42787 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2069: /* ulonglong_num: opt_plus NUM  */
#line 13254 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42793 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2070: /* ulonglong_num: opt_plus ULONGLONG_NUM  */
#line 13255 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42799 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2071: /* ulonglong_num: opt_plus LONG_NUM  */
#line 13256 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42805 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2072: /* ulonglong_num: opt_plus DECIMAL_NUM  */
#line 13257 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42811 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2073: /* ulonglong_num: opt_plus FLOAT_NUM  */
#line 13258 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42817 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2074: /* real_ulonglong_num: NUM  */
#line 13262 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42823 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2075: /* real_ulonglong_num: ULONGLONG_NUM  */
#line 13263 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42829 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2076: /* real_ulonglong_num: HEX_NUM  */
#line 13264 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.ulonglong_number)= strtoull((yyvsp[0].lex_str).str, (char**) 0, 16); }
#line 42835 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2077: /* real_ulonglong_num: LONG_NUM  */
#line 13265 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42841 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2078: /* real_ulonglong_num: dec_num_error  */
#line 13266 "/home/buildbot/git/sql/sql_yacc.yy"
                        { MYSQL_YYABORT; }
#line 42847 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2079: /* dec_num_error: dec_num  */
#line 13271 "/home/buildbot/git/sql/sql_yacc.yy"
          { thd->parse_error(ER_ONLY_INTEGERS_ALLOWED); }
#line 42853 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2082: /* choice: ulong_num  */
#line 13280 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.choice)= (yyvsp[0].ulong_num) != 0 ? HA_CHOICE_YES : HA_CHOICE_NO; }
#line 42859 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2083: /* choice: DEFAULT  */
#line 13281 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.choice)= HA_CHOICE_UNDEF; }
#line 42865 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2084: /* bool: ulong_num  */
#line 13285 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.ulong_num)= (yyvsp[0].ulong_num) != 0; }
#line 42871 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2085: /* bool: TRUE_SYM  */
#line 13286 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.ulong_num)= 1; }
#line 42877 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2086: /* bool: FALSE_SYM  */
#line 13287 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.ulong_num)= 0; }
#line 42883 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2087: /* $@172: %empty  */
#line 13292 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;

            lex->proc_list.elements=0;
            lex->proc_list.first=0;
            lex->proc_list.next= &lex->proc_list.first;
            Item_field *item= new (thd->mem_root)
                                Item_field(thd, &lex->current_select->context,
                                           NULL, NULL, &(yyvsp[0].ident_sys));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            if (unlikely(add_proc_to_list(thd, item)))
              MYSQL_YYABORT;
            Lex->uncacheable(UNCACHEABLE_SIDEEFFECT);

            /*
              PROCEDURE CLAUSE cannot handle subquery as one of its parameter,
              so disallow any subqueries further.
              Alow subqueries back once the parameters are reduced.
            */
            Lex->clause_that_disallows_subselect= "PROCEDURE";
            Select->options|= OPTION_PROCEDURE_CLAUSE;
          }
#line 42911 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2088: /* procedure_clause: PROCEDURE_SYM ident $@172 '(' procedure_list ')'  */
#line 13316 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* Subqueries are allowed from now.*/
            Lex->clause_that_disallows_subselect= NULL;
          }
#line 42920 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2089: /* procedure_list: %empty  */
#line 13323 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 42926 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2090: /* procedure_list: procedure_list2  */
#line 13324 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 42932 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2093: /* procedure_item: remember_name expr remember_end  */
#line 13334 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(add_proc_to_list(thd, (yyvsp[-1].item))))
              MYSQL_YYABORT;
            if (!(yyvsp[-1].item)->name.str || (yyvsp[-1].item)->name.str == item_empty_name)
              (yyvsp[-1].item)->set_name(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
          }
#line 42943 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2094: /* $@173: %empty  */
#line 13343 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (!lex->describe &&
                unlikely((!(lex->result= new (thd->mem_root)
                            select_dumpvar(thd)))))
              MYSQL_YYABORT;
          }
#line 42955 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2095: /* select_var_list_init: $@173 select_var_list  */
#line 13351 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 42961 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2097: /* select_var_list: select_var_ident  */
#line 13356 "/home/buildbot/git/sql/sql_yacc.yy"
                           {}
#line 42967 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2098: /* select_var_ident: select_outvar  */
#line 13360 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->result)
            {
              if (unlikely((yyvsp[0].myvar) == NULL))
                MYSQL_YYABORT;
              ((select_dumpvar *)Lex->result)->var_list.push_back((yyvsp[0].myvar), thd->mem_root);
            }
            else
            {
              /*
                The parser won't create select_result instance only
                if it's an EXPLAIN.
              */
              DBUG_ASSERT(Lex->describe);
            }
          }
#line 42988 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2099: /* select_outvar: '@' ident_or_text  */
#line 13380 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.myvar) = Lex->result ? new (thd->mem_root) my_var_user(&(yyvsp[0].lex_str)) : NULL;
          }
#line 42996 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2100: /* select_outvar: ident_or_text  */
#line 13384 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.myvar)= Lex->create_outvar(thd, &(yyvsp[0].lex_str))) && Lex->result))
              MYSQL_YYABORT;
          }
#line 43005 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2101: /* select_outvar: ident '.' ident  */
#line 13389 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.myvar)= Lex->create_outvar(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys))) && Lex->result))
              MYSQL_YYABORT;
          }
#line 43014 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2102: /* into: INTO into_destination  */
#line 13397 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 43020 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2103: /* $@174: %empty  */
#line 13402 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
            if (unlikely(!(lex->exchange=
                         new (thd->mem_root) sql_exchange((yyvsp[0].lex_str).str, 0))) ||
                unlikely(!(lex->result=
                         new (thd->mem_root)
                         select_export(thd, lex->exchange))))
              MYSQL_YYABORT;
          }
#line 43035 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2104: /* $@175: %empty  */
#line 13413 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->exchange->cs= (yyvsp[0].charset); }
#line 43041 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2106: /* into_destination: DUMPFILE TEXT_STRING_filesystem  */
#line 13416 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (!lex->describe)
            {
              lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
              if (unlikely(!(lex->exchange=
                             new (thd->mem_root) sql_exchange((yyvsp[0].lex_str).str,1))))
                MYSQL_YYABORT;
              if (unlikely(!(lex->result=
                           new (thd->mem_root)
                           select_dump(thd, lex->exchange))))
                MYSQL_YYABORT;
            }
          }
#line 43060 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2107: /* into_destination: select_var_list_init  */
#line 13431 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
          }
#line 43068 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2108: /* $@176: %empty  */
#line 13442 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_DO;
            if (lex->main_select_push(true))
              MYSQL_YYABORT;
            mysql_init_select(lex);
          }
#line 43080 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2109: /* do: DO_SYM $@176 expr_list  */
#line 13450 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->insert_list= (yyvsp[0].item_list);
            Lex->pop_select(); //main select
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 43091 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2110: /* $@177: %empty  */
#line 13464 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->set_command(SQLCOM_DROP_TABLE, (yyvsp[-2].num), (yyvsp[0].object_ddl_options));
            YYPS->m_lock_type= TL_UNLOCK;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 43102 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2111: /* drop: DROP opt_temporary table_or_tables opt_if_exists $@177 table_list opt_lock_wait_timeout opt_restrict  */
#line 13471 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 43108 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2112: /* $@178: %empty  */
#line 13473 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 43117 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2113: /* drop: DROP INDEX_SYM $@178 opt_if_exists_table_element ident ON table_ident opt_lock_wait_timeout  */
#line 13478 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::KEY, (yyvsp[-3].ident_sys).str, (yyvsp[-4].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->sql_command= SQLCOM_DROP_INDEX;
            lex->alter_info.reset();
            lex->alter_info.flags= ALTER_DROP_INDEX;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            if (unlikely(!lex->current_select->
                         add_table_to_list(thd, (yyvsp[-1].table), NULL, TL_OPTION_UPDATING,
                                           TL_READ_NO_INSERT,
                                           MDL_SHARED_UPGRADABLE)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
          }
#line 43139 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2114: /* drop: DROP DATABASE opt_if_exists ident  */
#line 13496 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->set_command(SQLCOM_DROP_DB, (yyvsp[-1].object_ddl_options));
            lex->name= (yyvsp[0].ident_sys);
          }
#line 43149 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2115: /* drop: DROP FUNCTION_SYM opt_if_exists ident '.' ident  */
#line 13502 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            sp_name *spname;
            if (unlikely((yyvsp[-2].ident_sys).str && check_db_name((LEX_STRING*) &(yyvsp[-2].ident_sys))))
              my_yyabort_error((ER_WRONG_DB_NAME, MYF(0), (yyvsp[-2].ident_sys).str));
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "FUNCTION"));
            lex->set_command(SQLCOM_DROP_FUNCTION, (yyvsp[-3].object_ddl_options));
            spname= new (thd->mem_root) sp_name(&(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys), true);
            if (unlikely(spname == NULL))
              MYSQL_YYABORT;
            lex->spname= spname;
          }
#line 43167 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2116: /* drop: DROP FUNCTION_SYM opt_if_exists ident  */
#line 13516 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            LEX_CSTRING db= {0, 0};
            sp_name *spname;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "FUNCTION"));
            if (thd->db.str && unlikely(lex->copy_db_to(&db)))
              MYSQL_YYABORT;
            lex->set_command(SQLCOM_DROP_FUNCTION, (yyvsp[-1].object_ddl_options));
            spname= new (thd->mem_root) sp_name(&db, &(yyvsp[0].ident_sys), false);
            if (unlikely(spname == NULL))
              MYSQL_YYABORT;
            lex->spname= spname;
          }
#line 43186 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2117: /* drop: DROP PROCEDURE_SYM opt_if_exists sp_name  */
#line 13531 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "PROCEDURE"));
            lex->set_command(SQLCOM_DROP_PROCEDURE, (yyvsp[-1].object_ddl_options));
            lex->spname= (yyvsp[0].spname);
          }
#line 43198 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2118: /* drop: DROP USER_SYM opt_if_exists clear_privileges user_list  */
#line 13539 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->set_command(SQLCOM_DROP_USER, (yyvsp[-2].object_ddl_options));
          }
#line 43206 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2119: /* drop: DROP ROLE_SYM opt_if_exists clear_privileges role_list  */
#line 13543 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->set_command(SQLCOM_DROP_ROLE, (yyvsp[-2].object_ddl_options));
          }
#line 43214 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2120: /* $@179: %empty  */
#line 13547 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_VIEW, (yyvsp[0].object_ddl_options));
            YYPS->m_lock_type= TL_UNLOCK;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 43225 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2121: /* drop: DROP VIEW_SYM opt_if_exists $@179 table_list opt_restrict  */
#line 13554 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 43231 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2122: /* drop: DROP EVENT_SYM opt_if_exists sp_name  */
#line 13556 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->spname= (yyvsp[0].spname);
            Lex->set_command(SQLCOM_DROP_EVENT, (yyvsp[-1].object_ddl_options));
          }
#line 43240 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2123: /* drop: DROP TRIGGER_SYM opt_if_exists sp_name  */
#line 13561 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_TRIGGER, (yyvsp[-1].object_ddl_options));
            lex->spname= (yyvsp[0].spname);
          }
#line 43250 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2124: /* drop: DROP TABLESPACE tablespace_name opt_ts_engine opt_ts_wait  */
#line 13567 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= DROP_TABLESPACE;
          }
#line 43259 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2125: /* drop: DROP LOGFILE_SYM GROUP_SYM logfile_group_name opt_ts_engine opt_ts_wait  */
#line 13572 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= DROP_LOGFILE_GROUP;
          }
#line 43268 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2126: /* drop: DROP SERVER_SYM opt_if_exists ident_or_text  */
#line 13577 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->set_command(SQLCOM_DROP_SERVER, (yyvsp[-1].object_ddl_options));
            Lex->server_options.reset((yyvsp[0].lex_str));
          }
#line 43277 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2127: /* $@180: %empty  */
#line 13583 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_SEQUENCE, (yyvsp[-2].num), (yyvsp[0].object_ddl_options));
            lex->table_type= TABLE_TYPE_SEQUENCE;
            YYPS->m_lock_type= TL_UNLOCK;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 43289 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2128: /* drop: DROP opt_temporary SEQUENCE_SYM opt_if_exists $@180 table_list  */
#line 13591 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 43295 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2131: /* table_name: table_ident  */
#line 13601 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!thd->lex->current_select_or_default()->
                                           add_table_to_list(thd, (yyvsp[0].table), NULL,
                                           TL_OPTION_UPDATING,
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type))
              MYSQL_YYABORT;
          }
#line 43308 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2132: /* table_name_with_opt_use_partition: table_ident opt_use_partition  */
#line 13613 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-1].table), NULL,
                                                    TL_OPTION_UPDATING,
                                                    YYPS->m_lock_type,
                                                    YYPS->m_mdl_type,
                                                    NULL,
                                                    (yyvsp[0].string_list))))
              MYSQL_YYABORT;
          }
#line 43322 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2135: /* table_alias_ref: table_ident_opt_wild  */
#line 13631 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->
                         add_table_to_list(thd, (yyvsp[0].table), NULL,
                                           (TL_OPTION_UPDATING |
                                            TL_OPTION_ALIAS),
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type)))
              MYSQL_YYABORT;
          }
#line 43336 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2136: /* opt_if_exists_table_element: %empty  */
#line 13644 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->check_exists= FALSE;
          (yyval.num)= 0;
        }
#line 43345 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2137: /* opt_if_exists_table_element: IF_SYM EXISTS  */
#line 13649 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->check_exists= TRUE;
          (yyval.num)= 1;
        }
#line 43354 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2138: /* opt_if_exists: %empty  */
#line 13657 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.object_ddl_options).set(DDL_options_st::OPT_NONE);
        }
#line 43362 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2139: /* opt_if_exists: IF_SYM EXISTS  */
#line 13661 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.object_ddl_options).set(DDL_options_st::OPT_IF_EXISTS);
        }
#line 43370 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2140: /* opt_temporary: %empty  */
#line 13667 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0; }
#line 43376 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2141: /* opt_temporary: TEMPORARY  */
#line 13668 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.num)= HA_LEX_CREATE_TMP_TABLE; }
#line 43382 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2142: /* $@181: %empty  */
#line 13676 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_INSERT;
            lex->duplicates= DUP_ERROR;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->inc_select_stack_outer_barrier();
            lex->current_select->parsing_place= BEFORE_OPT_LIST;
          }
#line 43397 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2143: /* $@182: %empty  */
#line 13688 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->set_lock_for_tables((yyvsp[-2].lock_type), true);
            Lex->current_select= Lex->first_select_lex();
          }
#line 43406 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2144: /* insert: INSERT $@181 insert_lock_option opt_ignore insert2 $@182 insert_field_spec opt_insert_update  */
#line 13693 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
            Lex->mark_first_table_as_inserting();
          }
#line 43417 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2145: /* $@183: %empty  */
#line 13703 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_REPLACE;
            lex->duplicates= DUP_REPLACE;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->inc_select_stack_outer_barrier();
            lex->current_select->parsing_place= BEFORE_OPT_LIST;
          }
#line 43432 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2146: /* $@184: %empty  */
#line 13714 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->set_lock_for_tables((yyvsp[-1].lock_type), true);
            Lex->current_select= Lex->first_select_lex();
          }
#line 43441 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2147: /* replace: REPLACE $@183 replace_lock_option insert2 $@184 insert_field_spec  */
#line 13719 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
            Lex->mark_first_table_as_inserting();
          }
#line 43452 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2148: /* insert_lock_option: %empty  */
#line 13729 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              If it is SP we do not allow insert optimisation when result of
              insert visible only after the table unlocking but everyone can
              read table.
            */
            (yyval.lock_type)= (Lex->sphead ? TL_WRITE_DEFAULT : TL_WRITE_CONCURRENT_INSERT);
          }
#line 43465 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2149: /* insert_lock_option: LOW_PRIORITY  */
#line 13737 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.lock_type)= TL_WRITE_LOW_PRIORITY; }
#line 43471 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2150: /* insert_lock_option: DELAYED_SYM  */
#line 13739 "/home/buildbot/git/sql/sql_yacc.yy"
        {
         // QQ: why was +1?
          Lex->keyword_delayed_begin_offset= (uint)((yyvsp[0].kwd).pos() - thd->query());
          Lex->keyword_delayed_end_offset= (uint)((yyvsp[0].kwd).end() - thd->query());
          (yyval.lock_type)= TL_WRITE_DELAYED;
        }
#line 43482 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2151: /* insert_lock_option: HIGH_PRIORITY  */
#line 13745 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.lock_type)= TL_WRITE; }
#line 43488 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2152: /* replace_lock_option: opt_low_priority  */
#line 13749 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.lock_type)= (yyvsp[0].lock_type); }
#line 43494 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2153: /* replace_lock_option: DELAYED_SYM  */
#line 13751 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->keyword_delayed_begin_offset= (uint)((yyvsp[0].kwd).pos() - thd->query());
          Lex->keyword_delayed_end_offset= (uint)((yyvsp[0].kwd).end() - thd->query());
          (yyval.lock_type)= TL_WRITE_DELAYED;
        }
#line 43504 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2154: /* insert2: INTO insert_table  */
#line 13759 "/home/buildbot/git/sql/sql_yacc.yy"
                            {}
#line 43510 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2155: /* insert2: insert_table  */
#line 13760 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 43516 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2156: /* $@185: %empty  */
#line 13764 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->save_parsing_place= Select->parsing_place;
          }
#line 43524 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2157: /* insert_table: $@185 table_name_with_opt_use_partition  */
#line 13768 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            //lex->field_list.empty();
            lex->many_values.empty();
            lex->insert_list=0;
          }
#line 43535 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2158: /* insert_field_spec: insert_values  */
#line 13777 "/home/buildbot/git/sql/sql_yacc.yy"
                        {}
#line 43541 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2159: /* insert_field_spec: insert_field_list insert_values  */
#line 13778 "/home/buildbot/git/sql/sql_yacc.yy"
                                          {}
#line 43547 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2160: /* $@186: %empty  */
#line 13780 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(!(lex->insert_list= new (thd->mem_root) List_item)) ||
                unlikely(lex->many_values.push_back(lex->insert_list,
                         thd->mem_root)))
              MYSQL_YYABORT;
            lex->current_select->parsing_place= NO_MATTER;
          }
#line 43560 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2162: /* insert_field_list: LEFT_PAREN_ALT opt_fields ')'  */
#line 13793 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->current_select->parsing_place= AFTER_LIST;
          }
#line 43568 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2165: /* fields: fields ',' insert_ident  */
#line 13805 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 43574 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2166: /* fields: insert_ident  */
#line 13806 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 43580 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2167: /* insert_values: create_select_query_expression  */
#line 13812 "/home/buildbot/git/sql/sql_yacc.yy"
                                        {}
#line 43586 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2172: /* ident_eq_value: simple_ident_nospvar equal expr_or_ignore_or_default  */
#line 13827 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->field_list.push_back((yyvsp[-2].item), thd->mem_root)) ||
                unlikely(lex->insert_list->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43597 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2173: /* equal: '='  */
#line 13836 "/home/buildbot/git/sql/sql_yacc.yy"
              {}
#line 43603 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2174: /* equal: SET_VAR  */
#line 13837 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 43609 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2175: /* opt_equal: %empty  */
#line 13841 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 43615 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2176: /* opt_equal: equal  */
#line 13842 "/home/buildbot/git/sql/sql_yacc.yy"
                {}
#line 43621 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2177: /* opt_with: opt_equal  */
#line 13846 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 43627 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2178: /* opt_with: WITH  */
#line 13847 "/home/buildbot/git/sql/sql_yacc.yy"
               {}
#line 43633 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2179: /* opt_by: opt_equal  */
#line 13851 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 43639 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2180: /* opt_by: BY  */
#line 13852 "/home/buildbot/git/sql/sql_yacc.yy"
             {}
#line 43645 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2181: /* $@187: %empty  */
#line 13857 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!(Lex->insert_list= new (thd->mem_root) List_item)))
              MYSQL_YYABORT;
          }
#line 43654 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2182: /* no_braces: '(' $@187 opt_values ')'  */
#line 13862 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->many_values.push_back(lex->insert_list,
                                                    thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43665 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2183: /* $@188: %empty  */
#line 13872 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!(Lex->insert_list= new (thd->mem_root) List_item)))
              MYSQL_YYABORT;
          }
#line 43674 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2184: /* no_braces_with_names: '(' $@188 opt_values_with_names ')'  */
#line 13877 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->many_values.push_back(lex->insert_list,
                                                    thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43685 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2185: /* opt_values: %empty  */
#line 13886 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 43691 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2187: /* opt_values_with_names: %empty  */
#line 13891 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 43697 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2189: /* values: values ',' expr_or_ignore_or_default  */
#line 13897 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43706 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2190: /* values: expr_or_ignore_or_default  */
#line 13902 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43715 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2191: /* values_with_names: values_with_names ',' remember_name expr_or_ignore_or_default remember_end  */
#line 13910 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[-1].item), thd->mem_root)))
               MYSQL_YYABORT;
            // give some name in case of using in table value constuctor (TVC)
            if (!(yyvsp[-1].item)->name.str || (yyvsp[-1].item)->name.str == item_empty_name)
              (yyvsp[-1].item)->set_name(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
           }
#line 43727 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2192: /* values_with_names: remember_name expr_or_ignore_or_default remember_end  */
#line 13918 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[-1].item), thd->mem_root)))
               MYSQL_YYABORT;
            // give some name in case of using in table value constuctor (TVC)
            if (!(yyvsp[-1].item)->name.str || (yyvsp[-1].item)->name.str == item_empty_name)
              (yyvsp[-1].item)->set_name(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
          }
#line 43739 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2193: /* expr_or_ignore: expr  */
#line 13928 "/home/buildbot/git/sql/sql_yacc.yy"
               { (yyval.item)= (yyvsp[0].item);}
#line 43745 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2194: /* expr_or_ignore: IGNORE_SYM  */
#line 13930 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_ignore_specification(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 43755 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2195: /* expr_or_ignore_or_default: expr_or_ignore  */
#line 13938 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.item)= (yyvsp[0].item);}
#line 43761 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2196: /* expr_or_ignore_or_default: DEFAULT  */
#line 13940 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_default_specification(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 43771 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2198: /* $@189: %empty  */
#line 13949 "/home/buildbot/git/sql/sql_yacc.yy"
                           { Lex->duplicates= DUP_UPDATE; }
#line 43777 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2199: /* $@190: %empty  */
#line 13951 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    Select->parsing_place= IN_UPDATE_ON_DUP_KEY;
          }
#line 43785 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2200: /* opt_insert_update: ON DUPLICATE_SYM $@189 KEY_SYM UPDATE_SYM $@190 insert_update_list  */
#line 13955 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    Select->parsing_place= NO_MATTER;
          }
#line 43793 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2201: /* update_table_list: table_ident opt_use_partition for_portion_of_time_clause opt_table_alias_clause opt_key_definition  */
#line 13963 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->table_join_options= 0;
            if (!((yyval.table_list)= Select->add_table_to_list(thd, (yyvsp[-4].table), (yyvsp[-1].lex_str_ptr),
                                                Select->get_table_join_options(),
                                                YYPS->m_lock_type,
                                                YYPS->m_mdl_type,
                                                Select->pop_index_hints(),
                                                (yyvsp[-3].string_list))))
              MYSQL_YYABORT;
            (yyval.table_list)->period_conditions= Lex->period_conditions;
          }
#line 43810 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2202: /* update_table_list: join_table_list  */
#line 13975 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.table_list)= (yyvsp[0].table_list); }
#line 43816 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2203: /* $@191: %empty  */
#line 13982 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->sql_command= SQLCOM_UPDATE;
            lex->duplicates= DUP_ERROR; 
          }
#line 43829 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2204: /* $@192: %empty  */
#line 13992 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *slex= Lex->first_select_lex();
            if (slex->table_list.elements > 1)
              Lex->sql_command= SQLCOM_UPDATE_MULTI;
            else if (slex->get_table_list()->derived)
            {
              /* it is single table update and it is update of derived table */
              my_error(ER_NON_UPDATABLE_TABLE, MYF(0),
                       slex->get_table_list()->alias.str, "UPDATE");
              MYSQL_YYABORT;
            }
            /*
              In case of multi-update setting write lock for all tables may
              be too pessimistic. We will decrease lock level if possible in
              mysql_multi_update().
            */
            slex->set_lock_for_tables((yyvsp[-4].lock_type), slex->table_list.elements == 1);
          }
#line 43852 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2205: /* update: UPDATE_SYM $@191 opt_low_priority opt_ignore update_table_list SET update_list $@192 opt_where_clause opt_order_clause delete_limit_clause  */
#line 14011 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[-1].select_order))
              Select->order_list= *((yyvsp[-1].select_order));
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43864 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2208: /* update_elem: simple_ident_nospvar equal DEFAULT  */
#line 14027 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *def= new (thd->mem_root) Item_default_value(thd,
                                             Lex->current_context(), (yyvsp[-2].item), 1);
            if (!def || add_item_to_list(thd, (yyvsp[-2].item)) || add_value_to_list(thd, def))
              MYSQL_YYABORT;
          }
#line 43875 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2209: /* update_elem: simple_ident_nospvar equal expr_or_ignore  */
#line 14034 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (add_item_to_list(thd, (yyvsp[-2].item)) || add_value_to_list(thd, (yyvsp[0].item)))
              MYSQL_YYABORT;
          }
#line 43884 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2212: /* insert_update_elem: simple_ident_nospvar equal expr_or_ignore_or_default  */
#line 14047 "/home/buildbot/git/sql/sql_yacc.yy"
          {
          LEX *lex= Lex;
          if (unlikely(lex->update_list.push_back((yyvsp[-2].item), thd->mem_root)) ||
              unlikely(lex->value_list.push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43895 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2213: /* opt_low_priority: %empty  */
#line 14056 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lock_type)= TL_WRITE_DEFAULT; }
#line 43901 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2214: /* opt_low_priority: LOW_PRIORITY  */
#line 14057 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.lock_type)= TL_WRITE_LOW_PRIORITY; }
#line 43907 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2215: /* $@193: %empty  */
#line 14064 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_DELETE;
            YYPS->m_lock_type= TL_WRITE_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_WRITE;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->ignore= 0;
            lex->first_select_lex()->order_list.empty();
          }
#line 43923 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2216: /* delete: DELETE_SYM $@193 delete_part2  */
#line 14076 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 43932 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2217: /* opt_delete_system_time: %empty  */
#line 14084 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_HISTORY);
          }
#line 43940 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2218: /* opt_delete_system_time: BEFORE_SYM SYSTEM_TIME_SYM history_point  */
#line 14088 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_BEFORE, (yyvsp[0].vers_history_point));
          }
#line 43948 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2219: /* delete_part2: opt_delete_options single_multi  */
#line 14094 "/home/buildbot/git/sql/sql_yacc.yy"
                                          {}
#line 43954 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2220: /* delete_part2: HISTORY_SYM delete_single_table opt_delete_system_time  */
#line 14096 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_table()->vers_conditions= Lex->vers_conditions;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43965 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2221: /* delete_single_table: FROM table_ident opt_use_partition  */
#line 14106 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->
                         add_table_to_list(thd, (yyvsp[-1].table), NULL, TL_OPTION_UPDATING,
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type,
                                           NULL,
                                           (yyvsp[0].string_list))))
              MYSQL_YYABORT;
            YYPS->m_lock_type= TL_READ_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_READ;
          }
#line 43981 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2222: /* delete_single_table_for_period: delete_single_table opt_for_portion_of_time_clause  */
#line 14121 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if ((yyvsp[0].num))
            Lex->last_table()->period_conditions= Lex->period_conditions;
        }
#line 43990 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2223: /* single_multi: delete_single_table_for_period opt_where_clause opt_order_clause delete_limit_clause opt_select_expressions  */
#line 14133 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[-2].select_order))
              Select->order_list= *((yyvsp[-2].select_order));
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 44002 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2224: /* $@194: %empty  */
#line 14141 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            mysql_init_multi_delete(Lex);
            YYPS->m_lock_type= TL_READ_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_READ;
          }
#line 44012 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2225: /* single_multi: table_wild_list $@194 FROM join_table_list opt_where_clause  */
#line 14147 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(multi_delete_set_locks_and_link_aux_tables(Lex)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 44024 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2226: /* $@195: %empty  */
#line 14155 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            mysql_init_multi_delete(Lex);
            YYPS->m_lock_type= TL_READ_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_READ;
          }
#line 44034 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2227: /* single_multi: FROM table_alias_ref_list $@195 USING join_table_list opt_where_clause  */
#line 14161 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(multi_delete_set_locks_and_link_aux_tables(Lex)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 44046 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2232: /* table_wild_one: ident opt_wild  */
#line 14182 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Table_ident *ti= new (thd->mem_root) Table_ident(&(yyvsp[-1].ident_sys));
            if (unlikely(ti == NULL))
              MYSQL_YYABORT;
            if (unlikely(!Select->
                         add_table_to_list(thd,
                                           ti,
                                           NULL,
                                           (TL_OPTION_UPDATING |
                                            TL_OPTION_ALIAS),
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type)))
              MYSQL_YYABORT;
          }
#line 44065 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2233: /* table_wild_one: ident '.' ident opt_wild  */
#line 14197 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Table_ident *ti= new (thd->mem_root) Table_ident(thd, &(yyvsp[-3].ident_sys), &(yyvsp[-1].ident_sys), 0);
            if (unlikely(ti == NULL))
              MYSQL_YYABORT;
            if (unlikely(!Select->
                         add_table_to_list(thd,
                                           ti,
                                           NULL,
                                           (TL_OPTION_UPDATING |
                                            TL_OPTION_ALIAS),
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type)))
              MYSQL_YYABORT;
          }
#line 44084 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2234: /* opt_wild: %empty  */
#line 14214 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 44090 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2235: /* opt_wild: '.' '*'  */
#line 14215 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 44096 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2236: /* opt_delete_options: %empty  */
#line 14219 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 44102 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2237: /* opt_delete_options: opt_delete_option opt_delete_options  */
#line 14220 "/home/buildbot/git/sql/sql_yacc.yy"
                                               {}
#line 44108 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2238: /* opt_delete_option: QUICK  */
#line 14224 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Select->options|= OPTION_QUICK; }
#line 44114 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2239: /* opt_delete_option: LOW_PRIORITY  */
#line 14225 "/home/buildbot/git/sql/sql_yacc.yy"
                       { YYPS->m_lock_type= TL_WRITE_LOW_PRIORITY; }
#line 44120 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2240: /* opt_delete_option: IGNORE_SYM  */
#line 14226 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->ignore= 1; }
#line 44126 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2241: /* $@196: %empty  */
#line 14231 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX* lex= Lex;
            lex->sql_command= SQLCOM_TRUNCATE;
            lex->alter_info.reset();
            lex->first_select_lex()->options= 0;
            lex->sql_cache= LEX::SQL_CACHE_UNSPECIFIED;
            lex->first_select_lex()->order_list.empty();
            YYPS->m_lock_type= TL_WRITE;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 44141 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2242: /* truncate: TRUNCATE_SYM $@196 opt_table_sym table_name opt_lock_wait_timeout  */
#line 14242 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_truncate_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 44153 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2249: /* profile_def: CPU_SYM  */
#line 14266 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_CPU;
    }
#line 44161 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2250: /* profile_def: MEMORY_SYM  */
#line 14270 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_MEMORY;
    }
#line 44169 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2251: /* profile_def: BLOCK_SYM IO_SYM  */
#line 14274 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_BLOCK_IO;
    }
#line 44177 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2252: /* profile_def: CONTEXT_SYM SWITCHES_SYM  */
#line 14278 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_CONTEXT;
    }
#line 44185 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2253: /* profile_def: PAGE_SYM FAULTS_SYM  */
#line 14282 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_PAGE_FAULTS;
    }
#line 44193 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2254: /* profile_def: IPC_SYM  */
#line 14286 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_IPC;
    }
#line 44201 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2255: /* profile_def: SWAPS_SYM  */
#line 14290 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_SWAPS;
    }
#line 44209 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2256: /* profile_def: SOURCE_SYM  */
#line 14294 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_SOURCE;
    }
#line 44217 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2257: /* profile_def: ALL  */
#line 14298 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_ALL;
    }
#line 44225 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2258: /* opt_profile_args: %empty  */
#line 14305 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_query_id= 0;
    }
#line 44233 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2259: /* opt_profile_args: FOR_SYM QUERY_SYM NUM  */
#line 14309 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_query_id= atoi((yyvsp[0].lex_str).str);
    }
#line 44241 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2260: /* $@197: %empty  */
#line 14318 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->wild=0;
            lex->ident= null_clex_str;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->current_select->parsing_place= SELECT_LIST;
            lex->create_info.init();
          }
#line 44256 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2261: /* show: SHOW $@197 show_param  */
#line 14329 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->parsing_place= NO_MATTER;
            Lex->pop_select(); //main select
          }
#line 44265 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2262: /* show_param: DATABASES wild_and_where  */
#line 14337 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_DATABASES;
             if (unlikely(prepare_schema_table(thd, lex, 0, SCH_SCHEMATA)))
               MYSQL_YYABORT;
           }
#line 44276 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2263: /* show_param: opt_full TABLES opt_db wild_and_where  */
#line 14344 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_TABLES;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_TABLE_NAMES))
               MYSQL_YYABORT;
           }
#line 44288 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2264: /* show_param: opt_full TRIGGERS_SYM opt_db wild_and_where  */
#line 14352 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_TRIGGERS;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_TRIGGERS))
               MYSQL_YYABORT;
           }
#line 44300 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2265: /* show_param: EVENTS_SYM opt_db wild_and_where  */
#line 14360 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_EVENTS;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_EVENTS))
               MYSQL_YYABORT;
           }
#line 44312 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2266: /* show_param: TABLE_SYM STATUS_SYM opt_db wild_and_where  */
#line 14368 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_TABLE_STATUS;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_TABLES))
               MYSQL_YYABORT;
           }
#line 44324 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2267: /* show_param: OPEN_SYM TABLES opt_db wild_and_where  */
#line 14376 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_OPEN_TABLES;
            lex->first_select_lex()->db= (yyvsp[-1].lex_str);
            if (prepare_schema_table(thd, lex, 0, SCH_OPEN_TABLES))
              MYSQL_YYABORT;
          }
#line 44336 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2268: /* show_param: PLUGINS_SYM  */
#line 14384 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_PLUGINS;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PLUGINS)))
              MYSQL_YYABORT;
          }
#line 44347 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2269: /* show_param: PLUGINS_SYM SONAME_SYM TEXT_STRING_sys  */
#line 14391 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->ident= (yyvsp[0].lex_str);
            Lex->sql_command= SQLCOM_SHOW_PLUGINS;
            if (unlikely(prepare_schema_table(thd, Lex, 0, SCH_ALL_PLUGINS)))
              MYSQL_YYABORT;
          }
#line 44358 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2270: /* show_param: PLUGINS_SYM SONAME_SYM wild_and_where  */
#line 14398 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_PLUGINS;
            if (unlikely(prepare_schema_table(thd, Lex, 0, SCH_ALL_PLUGINS)))
              MYSQL_YYABORT;
          }
#line 44368 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2271: /* show_param: ENGINE_SYM known_storage_engines show_engine_param  */
#line 14404 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->create_info.db_type= (yyvsp[-1].db_type); }
#line 44374 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2272: /* show_param: ENGINE_SYM ALL show_engine_param  */
#line 14406 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->create_info.db_type= NULL; }
#line 44380 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2273: /* show_param: opt_full COLUMNS from_or_in table_ident opt_db wild_and_where  */
#line 14408 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_FIELDS;
            if ((yyvsp[-1].lex_str).str)
              (yyvsp[-2].table)->change_db(&(yyvsp[-1].lex_str));
            if (unlikely(prepare_schema_table(thd, lex, (yyvsp[-2].table), SCH_COLUMNS)))
              MYSQL_YYABORT;
          }
#line 44393 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2274: /* show_param: master_or_binary LOGS_SYM  */
#line 14417 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_BINLOGS;
          }
#line 44401 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2275: /* show_param: SLAVE HOSTS_SYM  */
#line 14421 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_SLAVE_HOSTS;
          }
#line 44409 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2276: /* $@198: %empty  */
#line 14425 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_BINLOG_EVENTS;
          }
#line 44418 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2278: /* $@199: %empty  */
#line 14431 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_RELAYLOG_EVENTS;
          }
#line 44427 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2280: /* show_param: keys_or_index from_or_in table_ident opt_db opt_where_clause  */
#line 14437 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_KEYS;
            if ((yyvsp[-1].lex_str).str)
              (yyvsp[-2].table)->change_db(&(yyvsp[-1].lex_str));
            if (unlikely(prepare_schema_table(thd, lex, (yyvsp[-2].table), SCH_STATISTICS)))
              MYSQL_YYABORT;
          }
#line 44440 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2281: /* show_param: opt_storage ENGINES_SYM  */
#line 14446 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_STORAGE_ENGINES;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_ENGINES)))
              MYSQL_YYABORT;
          }
#line 44451 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2282: /* show_param: AUTHORS_SYM  */
#line 14453 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_AUTHORS;
          }
#line 44460 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2283: /* show_param: CONTRIBUTORS_SYM  */
#line 14458 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_CONTRIBUTORS;
          }
#line 44469 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2284: /* show_param: PRIVILEGES  */
#line 14463 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_PRIVILEGES;
          }
#line 44478 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2285: /* show_param: COUNT_SYM '(' '*' ')' WARNINGS  */
#line 14468 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX_CSTRING var= {STRING_WITH_LEN("warning_count")};
            (void) create_select_for_variable(thd, &var);
          }
#line 44487 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2286: /* show_param: COUNT_SYM '(' '*' ')' ERRORS  */
#line 14473 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX_CSTRING var= {STRING_WITH_LEN("error_count")};
            (void) create_select_for_variable(thd, &var);
          }
#line 44496 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2287: /* show_param: WARNINGS opt_global_limit_clause  */
#line 14478 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command = SQLCOM_SHOW_WARNS;}
#line 44502 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2288: /* show_param: ERRORS opt_global_limit_clause  */
#line 14480 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command = SQLCOM_SHOW_ERRORS;}
#line 44508 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2289: /* show_param: PROFILES_SYM  */
#line 14482 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command = SQLCOM_SHOW_PROFILES; }
#line 44514 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2290: /* show_param: PROFILE_SYM opt_profile_defs opt_profile_args opt_global_limit_clause  */
#line 14484 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_PROFILE;
            if (unlikely(prepare_schema_table(thd, lex, NULL, SCH_PROFILES)))
              MYSQL_YYABORT;
          }
#line 44525 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2291: /* show_param: opt_var_type STATUS_SYM wild_and_where  */
#line 14491 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS;
            lex->option_type= (yyvsp[-2].var_type);
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_SESSION_STATUS)))
              MYSQL_YYABORT;
          }
#line 44537 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2292: /* show_param: opt_full PROCESSLIST_SYM  */
#line 14499 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command= SQLCOM_SHOW_PROCESSLIST;}
#line 44543 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2293: /* show_param: opt_var_type VARIABLES wild_and_where  */
#line 14501 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_VARIABLES;
            lex->option_type= (yyvsp[-2].var_type);
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_SESSION_VARIABLES)))
              MYSQL_YYABORT;
          }
#line 44555 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2294: /* show_param: charset wild_and_where  */
#line 14509 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_CHARSETS;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_CHARSETS)))
              MYSQL_YYABORT;
          }
#line 44566 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2295: /* show_param: COLLATION_SYM wild_and_where  */
#line 14516 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_COLLATIONS;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_COLLATIONS)))
              MYSQL_YYABORT;
          }
#line 44577 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2296: /* show_param: GRANTS  */
#line 14523 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_GRANTS;
            if (unlikely(!(Lex->grant_user=
                          (LEX_USER*)thd->alloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            Lex->grant_user->user= current_user_and_current_role;
          }
#line 44589 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2297: /* show_param: GRANTS FOR_SYM user_or_role clear_privileges  */
#line 14531 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_GRANTS;
            lex->grant_user=(yyvsp[-1].lex_user);
          }
#line 44599 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2298: /* show_param: CREATE DATABASE opt_if_not_exists ident  */
#line 14537 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->set_command(SQLCOM_SHOW_CREATE_DB, (yyvsp[-1].object_ddl_options));
            Lex->name= (yyvsp[0].ident_sys);
          }
#line 44608 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2299: /* show_param: CREATE TABLE_SYM table_ident  */
#line 14542 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE;
            if (!lex->first_select_lex()->add_table_to_list(thd, (yyvsp[0].table), NULL,0))
              MYSQL_YYABORT;
            lex->create_info.storage_media= HA_SM_DEFAULT;
          }
#line 44620 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2300: /* show_param: CREATE VIEW_SYM table_ident  */
#line 14550 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE;
            if (!lex->first_select_lex()->add_table_to_list(thd, (yyvsp[0].table), NULL, 0))
              MYSQL_YYABORT;
            lex->table_type= TABLE_TYPE_VIEW;
          }
#line 44632 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2301: /* show_param: CREATE SEQUENCE_SYM table_ident  */
#line 14558 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE;
            if (!lex->first_select_lex()->add_table_to_list(thd, (yyvsp[0].table), NULL, 0))
              MYSQL_YYABORT;
            lex->table_type= TABLE_TYPE_SEQUENCE;
          }
#line 44644 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2302: /* show_param: MASTER_SYM STATUS_SYM  */
#line 14566 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_MASTER_STAT;
          }
#line 44652 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2303: /* show_param: ALL SLAVES STATUS_SYM  */
#line 14570 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_SLAVE_STAT;
            Lex->verbose= 1;
          }
#line 44661 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2304: /* show_param: SLAVE STATUS_SYM  */
#line 14575 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->mi.connection_name= null_clex_str;
            lex->sql_command = SQLCOM_SHOW_SLAVE_STAT;
            lex->verbose= 0;
          }
#line 44672 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2305: /* show_param: SLAVE connection_name STATUS_SYM  */
#line 14582 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_SLAVE_STAT;
            Lex->verbose= 0;
          }
#line 44681 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2306: /* show_param: CREATE PROCEDURE_SYM sp_name  */
#line 14587 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            lex->sql_command = SQLCOM_SHOW_CREATE_PROC;
            lex->spname= (yyvsp[0].spname);
          }
#line 44692 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2307: /* show_param: CREATE FUNCTION_SYM sp_name  */
#line 14594 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            lex->sql_command = SQLCOM_SHOW_CREATE_FUNC;
            lex->spname= (yyvsp[0].spname);
          }
#line 44703 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2308: /* show_param: CREATE PACKAGE_MARIADB_SYM sp_name  */
#line 14601 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE_PACKAGE;
            lex->spname= (yyvsp[0].spname);
          }
#line 44713 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2309: /* show_param: CREATE PACKAGE_MARIADB_SYM BODY_MARIADB_SYM sp_name  */
#line 14607 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE_PACKAGE_BODY;
            lex->spname= (yyvsp[0].spname);
          }
#line 44723 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2310: /* show_param: CREATE TRIGGER_SYM sp_name  */
#line 14613 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_CREATE_TRIGGER;
            lex->spname= (yyvsp[0].spname);
          }
#line 44733 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2311: /* show_param: CREATE USER_SYM  */
#line 14619 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_CREATE_USER;
            if (unlikely(!(Lex->grant_user=
                          (LEX_USER*)thd->alloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            Lex->grant_user->user= current_user;
          }
#line 44745 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2312: /* show_param: CREATE USER_SYM user  */
#line 14627 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             Lex->sql_command= SQLCOM_SHOW_CREATE_USER;
             Lex->grant_user= (yyvsp[0].lex_user);
          }
#line 44754 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2313: /* show_param: PROCEDURE_SYM STATUS_SYM wild_and_where  */
#line 14632 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_PROC;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44765 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2314: /* show_param: FUNCTION_SYM STATUS_SYM wild_and_where  */
#line 14639 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_FUNC;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44776 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2315: /* show_param: PACKAGE_MARIADB_SYM STATUS_SYM wild_and_where  */
#line 14646 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_PACKAGE;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44787 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2316: /* show_param: PACKAGE_MARIADB_SYM BODY_MARIADB_SYM STATUS_SYM wild_and_where  */
#line 14653 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_PACKAGE_BODY;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44798 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2317: /* show_param: PROCEDURE_SYM CODE_SYM sp_name  */
#line 14660 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_PROC_CODE;
            Lex->spname= (yyvsp[0].spname);
          }
#line 44807 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2318: /* show_param: FUNCTION_SYM CODE_SYM sp_name  */
#line 14665 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_FUNC_CODE;
            Lex->spname= (yyvsp[0].spname);
          }
#line 44816 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2319: /* show_param: PACKAGE_MARIADB_SYM BODY_MARIADB_SYM CODE_SYM sp_name  */
#line 14670 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_PACKAGE_BODY_CODE;
            Lex->spname= (yyvsp[0].spname);
          }
#line 44825 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2320: /* show_param: CREATE EVENT_SYM sp_name  */
#line 14675 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->spname= (yyvsp[0].spname);
            Lex->sql_command = SQLCOM_SHOW_CREATE_EVENT;
          }
#line 44834 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2321: /* show_param: describe_command FOR_SYM expr  */
#line 14680 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_EXPLAIN;
            if (unlikely(prepare_schema_table(thd, Lex, 0, SCH_EXPLAIN)))
              MYSQL_YYABORT;
            add_value_to_list(thd, (yyvsp[0].item));
          }
#line 44845 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2322: /* show_param: IDENT_sys remember_tok_start wild_and_where  */
#line 14687 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             LEX *lex= Lex;
             bool in_plugin;
             lex->sql_command= SQLCOM_SHOW_GENERIC;
             ST_SCHEMA_TABLE *table= find_schema_table(thd, &(yyvsp[-2].ident_sys), &in_plugin);
             if (unlikely(!table || !table->old_format || !in_plugin))
             {
               thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-1].simple_string));
               MYSQL_YYABORT;
             }
             if (unlikely(lex->wild && table->idx_field1 < 0))
             {
               thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[0].simple_string));
               MYSQL_YYABORT;
             }
             if (unlikely(make_schema_select(thd, Lex->current_select, table)))
               MYSQL_YYABORT;
           }
#line 44868 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2323: /* show_engine_param: STATUS_SYM  */
#line 14709 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command= SQLCOM_SHOW_ENGINE_STATUS; }
#line 44874 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2324: /* show_engine_param: MUTEX_SYM  */
#line 14711 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command= SQLCOM_SHOW_ENGINE_MUTEX; }
#line 44880 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2325: /* show_engine_param: LOGS_SYM  */
#line 14713 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command= SQLCOM_SHOW_ENGINE_LOGS; }
#line 44886 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2330: /* opt_db: %empty  */
#line 14727 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.lex_str)= null_clex_str; }
#line 44892 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2331: /* opt_db: from_or_in ident  */
#line 14728 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 44898 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2332: /* opt_full: %empty  */
#line 14732 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->verbose=0; }
#line 44904 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2333: /* opt_full: FULL  */
#line 14733 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->verbose=1; }
#line 44910 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2336: /* binlog_in: %empty  */
#line 14742 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { Lex->mi.log_file_name = 0; }
#line 44916 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2337: /* binlog_in: IN_SYM TEXT_STRING_sys  */
#line 14743 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { Lex->mi.log_file_name = (yyvsp[0].lex_str).str; }
#line 44922 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2338: /* binlog_from: %empty  */
#line 14747 "/home/buildbot/git/sql/sql_yacc.yy"
                             { Lex->mi.pos = 4; /* skip magic number */ }
#line 44928 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2339: /* binlog_from: FROM ulonglong_num  */
#line 14748 "/home/buildbot/git/sql/sql_yacc.yy"
                             { Lex->mi.pos = (yyvsp[0].ulonglong_number); }
#line 44934 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2340: /* wild_and_where: %empty  */
#line 14752 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.simple_string)= 0; }
#line 44940 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2341: /* wild_and_where: LIKE remember_tok_start TEXT_STRING_sys  */
#line 14754 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->wild= new (thd->mem_root) String((yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length,
                                                    system_charset_info);
            if (unlikely(Lex->wild == NULL))
              MYSQL_YYABORT;
            (yyval.simple_string)= (yyvsp[-1].simple_string);
          }
#line 44952 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2342: /* wild_and_where: WHERE remember_tok_start expr  */
#line 14762 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->where= normalize_cond(thd, (yyvsp[0].item));
            if ((yyvsp[0].item))
              (yyvsp[0].item)->top_level_item();
            (yyval.simple_string)= (yyvsp[-1].simple_string);
          }
#line 44963 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2343: /* $@200: %empty  */
#line 14773 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->current_select->parsing_place= SELECT_LIST;
            lex->sql_command= SQLCOM_SHOW_FIELDS;
            lex->first_select_lex()->db= null_clex_str;
            lex->verbose= 0;
            if (unlikely(prepare_schema_table(thd, lex, (yyvsp[0].table), SCH_COLUMNS)))
              MYSQL_YYABORT;
          }
#line 44980 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2344: /* describe: describe_command table_ident $@200 opt_describe_column  */
#line 14786 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->parsing_place= NO_MATTER;
            Lex->pop_select(); //main select
          }
#line 44989 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2345: /* $@201: %empty  */
#line 14791 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->describe|= DESCRIBE_NORMAL; }
#line 44995 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2346: /* describe: describe_command opt_extended_describe $@201 explainable_command  */
#line 14793 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->first_select_lex()->options|= SELECT_DESCRIBE;
          }
#line 45004 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2355: /* analyze_stmt_command: ANALYZE_SYM opt_format_json explainable_command  */
#line 14815 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->analyze_stmt= true;
          }
#line 45012 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2356: /* opt_extended_describe: EXTENDED_SYM  */
#line 14821 "/home/buildbot/git/sql/sql_yacc.yy"
                         { Lex->describe|= DESCRIBE_EXTENDED; }
#line 45018 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2357: /* opt_extended_describe: EXTENDED_SYM ALL  */
#line 14823 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->describe|= DESCRIBE_EXTENDED | DESCRIBE_EXTENDED2; }
#line 45024 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2358: /* opt_extended_describe: PARTITIONS_SYM  */
#line 14824 "/home/buildbot/git/sql/sql_yacc.yy"
                         { Lex->describe|= DESCRIBE_PARTITIONS; }
#line 45030 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2359: /* opt_extended_describe: opt_format_json  */
#line 14825 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 45036 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2360: /* opt_format_json: %empty  */
#line 14829 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45042 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2361: /* opt_format_json: FORMAT_SYM '=' ident_or_text  */
#line 14831 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("JSON")))
              Lex->explain_json= true;
            else if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("TRADITIONAL")))
              DBUG_ASSERT(Lex->explain_json==false);
            else
              my_yyabort_error((ER_UNKNOWN_EXPLAIN_FORMAT, MYF(0), "EXPLAIN",
                               (yyvsp[0].lex_str).str));
          }
#line 45056 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2362: /* opt_describe_column: %empty  */
#line 14843 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45062 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2363: /* opt_describe_column: text_string  */
#line 14844 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->wild= (yyvsp[0].string); }
#line 45068 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2364: /* opt_describe_column: ident  */
#line 14846 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->wild= new (thd->mem_root) String((const char*) (yyvsp[0].ident_sys).str,
                                                    (yyvsp[0].ident_sys).length,
                                                    system_charset_info);
            if (unlikely(Lex->wild == NULL))
              MYSQL_YYABORT;
          }
#line 45080 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2365: /* $@202: %empty  */
#line 14860 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_FLUSH;
            lex->type= 0;
            lex->no_write_to_binlog= (yyvsp[0].num);
          }
#line 45091 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2366: /* flush: FLUSH_SYM opt_no_write_to_binlog $@202 flush_options  */
#line 14866 "/home/buildbot/git/sql/sql_yacc.yy"
                        {}
#line 45097 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2367: /* $@203: %empty  */
#line 14871 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->type|= REFRESH_TABLES;
            /*
              Set type of metadata and table locks for
              FLUSH TABLES table_list [WITH READ LOCK].
            */
            YYPS->m_lock_type= TL_READ_NO_INSERT;
            YYPS->m_mdl_type= MDL_SHARED_HIGH_PRIO;
          }
#line 45111 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2368: /* flush_options: table_or_tables $@203 opt_table_list opt_flush_lock  */
#line 14881 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 45117 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2369: /* flush_options: flush_options_list  */
#line 14883 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 45123 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2370: /* opt_flush_lock: %empty  */
#line 14887 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45129 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2371: /* opt_flush_lock: flush_lock  */
#line 14889 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          TABLE_LIST *tables= Lex->query_tables;
          for (; tables; tables= tables->next_global)
          {
            tables->mdl_request.set_type(MDL_SHARED_NO_WRITE);
            /* Don't try to flush views. */
            tables->required_type= TABLE_TYPE_NORMAL;
            /* Ignore temporary tables. */
            tables->open_type= OT_BASE_ONLY;
          }
        }
#line 45145 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2372: /* flush_lock: WITH READ_SYM LOCK_SYM optional_flush_tables_arguments  */
#line 14904 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_READ_LOCK | (yyvsp[0].num); }
#line 45151 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2373: /* $@204: %empty  */
#line 14906 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->query_tables == NULL))
            {
              // Table list can't be empty
              thd->parse_error(ER_NO_TABLES_USED);
              MYSQL_YYABORT;
            } 
            Lex->type|= REFRESH_FOR_EXPORT;
          }
#line 45165 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2374: /* flush_lock: FOR_SYM $@204 EXPORT_SYM  */
#line 14914 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 45171 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2376: /* flush_options_list: flush_option  */
#line 14920 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 45177 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2377: /* flush_option: ERROR_SYM LOGS_SYM  */
#line 14925 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_ERROR_LOG; }
#line 45183 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2378: /* flush_option: ENGINE_SYM LOGS_SYM  */
#line 14927 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_ENGINE_LOG; }
#line 45189 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2379: /* flush_option: GENERAL LOGS_SYM  */
#line 14929 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_GENERAL_LOG; }
#line 45195 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2380: /* flush_option: SLOW LOGS_SYM  */
#line 14931 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_SLOW_LOG; }
#line 45201 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2381: /* flush_option: BINARY LOGS_SYM opt_delete_gtid_domain  */
#line 14933 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_BINARY_LOG; }
#line 45207 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2382: /* flush_option: RELAY LOGS_SYM optional_connection_name  */
#line 14935 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->type & REFRESH_RELAY_LOG))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "FLUSH", "RELAY LOGS"));
            lex->type|= REFRESH_RELAY_LOG;
            lex->relay_log_connection_name= lex->mi.connection_name;
           }
#line 45219 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2383: /* flush_option: QUERY_SYM CACHE_SYM  */
#line 14943 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_QUERY_CACHE_FREE; }
#line 45225 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2384: /* flush_option: HOSTS_SYM  */
#line 14945 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_HOSTS; }
#line 45231 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2385: /* flush_option: PRIVILEGES  */
#line 14947 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_GRANT; }
#line 45237 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2386: /* flush_option: LOGS_SYM  */
#line 14949 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->type|= REFRESH_LOG;
            Lex->relay_log_connection_name= empty_clex_str;
          }
#line 45246 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2387: /* flush_option: STATUS_SYM  */
#line 14954 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_STATUS; }
#line 45252 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2388: /* flush_option: SLAVE optional_connection_name  */
#line 14956 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            LEX *lex= Lex;
            if (unlikely(lex->type & REFRESH_SLAVE))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "FLUSH","SLAVE"));
            lex->type|= REFRESH_SLAVE;
            lex->reset_slave_info.all= false;
          }
#line 45264 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2389: /* flush_option: MASTER_SYM  */
#line 14964 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_MASTER; }
#line 45270 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2390: /* flush_option: DES_KEY_FILE  */
#line 14966 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_DES_KEY_FILE; }
#line 45276 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2391: /* flush_option: RESOURCES  */
#line 14968 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_USER_RESOURCES; }
#line 45282 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2392: /* flush_option: SSL_SYM  */
#line 14970 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_SSL;}
#line 45288 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2393: /* flush_option: IDENT_sys remember_tok_start  */
#line 14972 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             Lex->type|= REFRESH_GENERIC;
             ST_SCHEMA_TABLE *table= find_schema_table(thd, &(yyvsp[-1].ident_sys));
             if (unlikely(!table || !table->reset_table))
             {
               thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[0].simple_string));
               MYSQL_YYABORT;
             }
             if (unlikely(Lex->view_list.push_back((LEX_CSTRING*)
                                                   thd->memdup(&(yyvsp[-1].ident_sys), sizeof(LEX_CSTRING)),
                                                   thd->mem_root)))
               MYSQL_YYABORT;
           }
#line 45306 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2394: /* opt_table_list: %empty  */
#line 14988 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 45312 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2395: /* opt_table_list: table_list  */
#line 14989 "/home/buildbot/git/sql/sql_yacc.yy"
                     {}
#line 45318 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2396: /* backup: BACKUP_SYM backup_statements  */
#line 14993 "/home/buildbot/git/sql/sql_yacc.yy"
                                     {}
#line 45324 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2397: /* backup_statements: STAGE_SYM ident  */
#line 14998 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          int type;
          if (unlikely(Lex->sphead))
            my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "BACKUP STAGE"));
          if ((type= find_type((yyvsp[0].ident_sys).str, &backup_stage_names,
                               FIND_TYPE_NO_PREFIX)) <= 0)
            my_yyabort_error((ER_BACKUP_UNKNOWN_STAGE, MYF(0), (yyvsp[0].ident_sys).str));
          Lex->sql_command= SQLCOM_BACKUP;
          Lex->backup_stage= (backup_stages) (type-1);
          break;
        }
#line 45340 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2398: /* $@205: %empty  */
#line 15010 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "BACKUP LOCK"));
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 45351 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2399: /* backup_statements: LOCK_SYM $@205 table_ident  */
#line 15017 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    if (unlikely(!Select->add_table_to_list(thd, (yyvsp[0].table), NULL, 0,
                                                    TL_READ, MDL_SHARED_HIGH_PRIO)))
             MYSQL_YYABORT;
            Lex->sql_command= SQLCOM_BACKUP_LOCK;
            Lex->pop_select(); //main select
          }
#line 45363 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2400: /* backup_statements: UNLOCK_SYM  */
#line 15025 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "BACKUP UNLOCK"));
	    /* Table list is empty for unlock */
            Lex->sql_command= SQLCOM_BACKUP_LOCK;
          }
#line 45374 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2401: /* opt_delete_gtid_domain: %empty  */
#line 15034 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45380 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2402: /* opt_delete_gtid_domain: DELETE_DOMAIN_ID_SYM '=' '(' delete_domain_id_list ')'  */
#line 15036 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 45386 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2406: /* delete_domain_id: ulonglong_num  */
#line 15046 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            uint32 value= (uint32) (yyvsp[0].ulonglong_number);
            if ((yyvsp[0].ulonglong_number) > UINT_MAX32)
            {
              my_printf_error(ER_BINLOG_CANT_DELETE_GTID_DOMAIN,
                              "The value of gtid domain being deleted ('%llu') "
                              "exceeds its maximum size "
                              "of 32 bit unsigned integer", MYF(0), (yyvsp[0].ulonglong_number));
              MYSQL_YYABORT;
            }
            insert_dynamic(&Lex->delete_gtid_domain, (uchar*) &value);
          }
#line 45403 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2407: /* optional_flush_tables_arguments: %empty  */
#line 15061 "/home/buildbot/git/sql/sql_yacc.yy"
                             {(yyval.num)= 0;}
#line 45409 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2408: /* optional_flush_tables_arguments: AND_SYM DISABLE_SYM CHECKPOINT_SYM  */
#line 15062 "/home/buildbot/git/sql/sql_yacc.yy"
                                             {(yyval.num)= REFRESH_CHECKPOINT; }
#line 45415 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2409: /* $@206: %empty  */
#line 15067 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_RESET; lex->type=0;
          }
#line 45424 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2410: /* reset: RESET_SYM $@206 reset_options  */
#line 15072 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 45430 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2413: /* $@207: %empty  */
#line 15081 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->type|= REFRESH_SLAVE; }
#line 45436 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2414: /* reset_option: SLAVE $@207 optional_connection_name slave_reset_options  */
#line 15083 "/home/buildbot/git/sql/sql_yacc.yy"
                              { }
#line 45442 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2415: /* $@208: %empty  */
#line 15085 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             Lex->type|= REFRESH_MASTER;
             Lex->next_binlog_file_number= 0;
          }
#line 45451 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2417: /* reset_option: QUERY_SYM CACHE_SYM  */
#line 15090 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->type|= REFRESH_QUERY_CACHE;}
#line 45457 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2418: /* slave_reset_options: %empty  */
#line 15094 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->reset_slave_info.all= false; }
#line 45463 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2419: /* slave_reset_options: ALL  */
#line 15095 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->reset_slave_info.all= true; }
#line 45469 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2420: /* master_reset_options: %empty  */
#line 15099 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45475 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2421: /* master_reset_options: TO_SYM ulong_num  */
#line 15101 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->next_binlog_file_number = (yyvsp[0].ulong_num);
          }
#line 45483 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2422: /* purge: PURGE master_or_binary LOGS_SYM TO_SYM TEXT_STRING_sys  */
#line 15108 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->stmt_purge_to((yyvsp[0].lex_str));
          }
#line 45491 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2423: /* $@209: %empty  */
#line 15112 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->clause_that_disallows_subselect= "PURGE..BEFORE"; }
#line 45497 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2424: /* purge: PURGE master_or_binary LOGS_SYM BEFORE_SYM $@209 expr  */
#line 15114 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->clause_that_disallows_subselect= NULL;
            if (Lex->stmt_purge_before((yyvsp[0].item)))
              MYSQL_YYABORT;
          }
#line 45507 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2425: /* $@210: %empty  */
#line 15126 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->value_list.empty();
            lex->users_list.empty();
            lex->sql_command= SQLCOM_KILL;
            lex->kill_type= KILL_TYPE_ID;
          }
#line 45519 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2426: /* kill: KILL_SYM $@210 kill_type kill_option  */
#line 15134 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->kill_signal= (killed_state) ((yyvsp[-1].num) | (yyvsp[0].num));
          }
#line 45527 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2427: /* kill_type: %empty  */
#line 15140 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.num)= (int) KILL_HARD_BIT; }
#line 45533 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2428: /* kill_type: HARD_SYM  */
#line 15141 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.num)= (int) KILL_HARD_BIT; }
#line 45539 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2429: /* kill_type: SOFT_SYM  */
#line 15142 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.num)= 0; }
#line 45545 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2430: /* kill_option: opt_connection kill_expr  */
#line 15146 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.num)= (int) KILL_CONNECTION; }
#line 45551 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2431: /* kill_option: QUERY_SYM kill_expr  */
#line 15147 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.num)= (int) KILL_QUERY; }
#line 45557 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2432: /* kill_option: QUERY_SYM ID_SYM expr  */
#line 15149 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= (int) KILL_QUERY;
            Lex->kill_type= KILL_TYPE_QUERY;
            Lex->value_list.push_front((yyvsp[0].item), thd->mem_root);
          }
#line 45567 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2433: /* opt_connection: %empty  */
#line 15157 "/home/buildbot/git/sql/sql_yacc.yy"
                         { }
#line 45573 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2434: /* opt_connection: CONNECTION_SYM  */
#line 15158 "/home/buildbot/git/sql/sql_yacc.yy"
                         { }
#line 45579 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2435: /* kill_expr: expr  */
#line 15163 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->value_list.push_front((yyval.item), thd->mem_root);
         }
#line 45587 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2436: /* kill_expr: USER_SYM user  */
#line 15167 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root);
            Lex->kill_type= KILL_TYPE_USER;
          }
#line 45596 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2437: /* $@211: %empty  */
#line 15174 "/home/buildbot/git/sql/sql_yacc.yy"
                 { Lex->sql_command= SQLCOM_SHUTDOWN; }
#line 45602 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2438: /* shutdown: SHUTDOWN $@211 shutdown_option  */
#line 15175 "/home/buildbot/git/sql/sql_yacc.yy"
                        {}
#line 45608 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2439: /* shutdown_option: %empty  */
#line 15179 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->is_shutdown_wait_for_slaves= false; }
#line 45614 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2440: /* shutdown_option: WAIT_SYM FOR_SYM ALL SLAVES  */
#line 15181 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->is_shutdown_wait_for_slaves= true;
        }
#line 45622 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2441: /* use: USE_SYM ident  */
#line 15190 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_CHANGE_DB;
            lex->first_select_lex()->db= (yyvsp[0].ident_sys);
          }
#line 45632 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2442: /* $@212: %empty  */
#line 15201 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;

            if (unlikely(lex->sphead))
            {
              my_error(ER_SP_BADSTATEMENT, MYF(0), 
                       (yyvsp[0].filetype) == FILETYPE_CSV ? "LOAD DATA" : "LOAD XML");
              MYSQL_YYABORT;
            }
            if (lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
          }
#line 45650 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2443: /* $@213: %empty  */
#line 15215 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_LOAD;
            lex->local_file=  (yyvsp[-2].num);
            lex->duplicates= DUP_ERROR;
            lex->ignore= 0;
            if (unlikely(!(lex->exchange= new (thd->mem_root)
                         sql_exchange((yyvsp[0].lex_str).str, 0, (yyvsp[-5].filetype)))))
              MYSQL_YYABORT;
          }
#line 45665 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2444: /* $@214: %empty  */
#line 15226 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-1].table), NULL,
                                                   TL_OPTION_UPDATING,
                                                   (yyvsp[-9].lock_type), MDL_SHARED_WRITE,
                                                   NULL, (yyvsp[0].string_list))))
              MYSQL_YYABORT;
            lex->field_list.empty();
            lex->update_list.empty();
            lex->value_list.empty();
            lex->many_values.empty();
          }
#line 45682 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2445: /* $@215: %empty  */
#line 15239 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->exchange->cs= (yyvsp[0].charset); }
#line 45688 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2446: /* load: LOAD data_or_xml $@212 load_data_lock opt_local INFILE TEXT_STRING_filesystem $@213 opt_duplicate INTO TABLE_SYM table_ident opt_use_partition $@214 opt_load_data_charset $@215 opt_xml_rows_identified_by opt_field_term opt_line_term opt_ignore_lines opt_field_or_var_spec opt_load_data_set_spec  */
#line 15243 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
            Lex->mark_first_table_as_inserting();
          }
#line 45699 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2447: /* data_or_xml: DATA_SYM  */
#line 15252 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.filetype)= FILETYPE_CSV; }
#line 45705 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2448: /* data_or_xml: XML_SYM  */
#line 15253 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.filetype)= FILETYPE_XML; }
#line 45711 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2449: /* opt_local: %empty  */
#line 15257 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)=0;}
#line 45717 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2450: /* opt_local: LOCAL_SYM  */
#line 15258 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.num)=1;}
#line 45723 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2451: /* load_data_lock: %empty  */
#line 15262 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lock_type)= TL_WRITE_DEFAULT; }
#line 45729 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2452: /* load_data_lock: CONCURRENT  */
#line 15264 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Ignore this option in SP to avoid problem with query cache and
              triggers with non default priority locks
            */
            (yyval.lock_type)= (Lex->sphead ? TL_WRITE_DEFAULT : TL_WRITE_CONCURRENT_INSERT);
          }
#line 45741 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2453: /* load_data_lock: LOW_PRIORITY  */
#line 15271 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.lock_type)= TL_WRITE_LOW_PRIORITY; }
#line 45747 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2454: /* opt_duplicate: %empty  */
#line 15275 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->duplicates=DUP_ERROR; }
#line 45753 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2455: /* opt_duplicate: REPLACE  */
#line 15276 "/home/buildbot/git/sql/sql_yacc.yy"
                  { Lex->duplicates=DUP_REPLACE; }
#line 45759 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2456: /* opt_duplicate: IGNORE_SYM  */
#line 15277 "/home/buildbot/git/sql/sql_yacc.yy"
                     { Lex->ignore= 1; }
#line 45765 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2461: /* field_term: TERMINATED BY text_string  */
#line 15292 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->field_term= (yyvsp[0].string);
          }
#line 45774 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2462: /* field_term: OPTIONALLY ENCLOSED BY text_string  */
#line 15297 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            DBUG_ASSERT(lex->exchange != 0);
            lex->exchange->enclosed= (yyvsp[0].string);
            lex->exchange->opt_enclosed= 1;
          }
#line 45785 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2463: /* field_term: ENCLOSED BY text_string  */
#line 15304 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->enclosed= (yyvsp[0].string);
          }
#line 45794 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2464: /* field_term: ESCAPED BY text_string  */
#line 15309 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->escaped= (yyvsp[0].string);
          }
#line 45803 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2469: /* line_term: TERMINATED BY text_string  */
#line 15327 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->line_term= (yyvsp[0].string);
          }
#line 45812 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2470: /* line_term: STARTING BY text_string  */
#line 15332 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->line_start= (yyvsp[0].string);
          }
#line 45821 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2471: /* opt_xml_rows_identified_by: %empty  */
#line 15339 "/home/buildbot/git/sql/sql_yacc.yy"
                    { }
#line 45827 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2472: /* opt_xml_rows_identified_by: ROWS_SYM IDENTIFIED_SYM BY text_string  */
#line 15341 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->exchange->line_term = (yyvsp[0].string); }
#line 45833 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2474: /* opt_ignore_lines: IGNORE_SYM NUM lines_or_rows  */
#line 15347 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->skip_lines= atol((yyvsp[-1].lex_str).str);
          }
#line 45842 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2475: /* lines_or_rows: LINES  */
#line 15354 "/home/buildbot/git/sql/sql_yacc.yy"
                { }
#line 45848 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2476: /* lines_or_rows: ROWS_SYM  */
#line 15355 "/home/buildbot/git/sql/sql_yacc.yy"
                   { }
#line 45854 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2477: /* opt_field_or_var_spec: %empty  */
#line 15359 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45860 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2478: /* opt_field_or_var_spec: '(' fields_or_vars ')'  */
#line 15360 "/home/buildbot/git/sql/sql_yacc.yy"
                                 {}
#line 45866 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2479: /* opt_field_or_var_spec: '(' ')'  */
#line 15361 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 45872 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2480: /* fields_or_vars: fields_or_vars ',' field_or_var  */
#line 15366 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 45878 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2481: /* fields_or_vars: field_or_var  */
#line 15368 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 45884 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2482: /* field_or_var: simple_ident_nospvar  */
#line 15372 "/home/buildbot/git/sql/sql_yacc.yy"
                               {(yyval.item)= (yyvsp[0].item);}
#line 45890 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2483: /* field_or_var: '@' ident_or_text  */
#line 15374 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_user_var_as_out_param(thd, &(yyvsp[0].lex_str));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45900 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2484: /* opt_load_data_set_spec: %empty  */
#line 15382 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45906 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2485: /* opt_load_data_set_spec: SET load_data_set_list  */
#line 15383 "/home/buildbot/git/sql/sql_yacc.yy"
                                 {}
#line 45912 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2488: /* load_data_set_elem: simple_ident_nospvar equal remember_name expr_or_ignore_or_default remember_end  */
#line 15393 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->update_list.push_back((yyvsp[-4].item), thd->mem_root)) ||
                unlikely(lex->value_list.push_back((yyvsp[-1].item), thd->mem_root)))
                MYSQL_YYABORT;
            (yyvsp[-1].item)->set_name_no_truncate(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
          }
#line 45924 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2489: /* text_literal: TEXT_STRING  */
#line 15406 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= thd->make_string_literal((yyvsp[0].lex_string_with_metadata)))))
              MYSQL_YYABORT;
          }
#line 45933 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2490: /* text_literal: NCHAR_STRING  */
#line 15411 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= thd->make_string_literal_nchar((yyvsp[0].lex_string_with_metadata)))))
              MYSQL_YYABORT;
          }
#line 45942 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2491: /* text_literal: UNDERSCORE_CHARSET TEXT_STRING  */
#line 15416 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= thd->make_string_literal_charset((yyvsp[0].lex_string_with_metadata), (yyvsp[-1].charset)))))
              MYSQL_YYABORT;
          }
#line 45951 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2492: /* text_literal: text_literal TEXT_STRING_literal  */
#line 15421 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= (yyvsp[-1].item_basic_constant)->make_string_literal_concat(thd, &(yyvsp[0].lex_str)))))
              MYSQL_YYABORT;
          }
#line 45960 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2493: /* text_string: TEXT_STRING_literal  */
#line 15429 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.string)= new (thd->mem_root) String((yyvsp[0].lex_str).str,
                                             (yyvsp[0].lex_str).length,
                                             thd->variables.collation_connection);
            if (unlikely((yyval.string) == NULL))
              MYSQL_YYABORT;
          }
#line 45972 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2494: /* text_string: hex_or_bin_String  */
#line 15436 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.string)= (yyvsp[0].string); }
#line 45978 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2495: /* hex_or_bin_String: HEX_NUM  */
#line 15442 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *tmp= new (thd->mem_root) Item_hex_hybrid(thd, (yyvsp[0].lex_str).str,
                                                           (yyvsp[0].lex_str).length);
            if (unlikely(tmp == NULL))
              MYSQL_YYABORT;
            (yyval.string)= tmp->val_str((String*) 0);
          }
#line 45990 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2496: /* hex_or_bin_String: HEX_STRING  */
#line 15450 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *tmp= new (thd->mem_root) Item_hex_string(thd, (yyvsp[0].lex_str).str,
                                                           (yyvsp[0].lex_str).length);
            if (unlikely(tmp == NULL))
              MYSQL_YYABORT;
            (yyval.string)= tmp->val_str((String*) 0);
          }
#line 46002 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2497: /* hex_or_bin_String: BIN_NUM  */
#line 15458 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *tmp= new (thd->mem_root) Item_bin_string(thd, (yyvsp[0].lex_str).str,
                                                           (yyvsp[0].lex_str).length);
            if (unlikely(tmp == NULL))
              MYSQL_YYABORT;
            /*
              it is OK only emulate fix_fields, because we need only
              value of constant
            */
            (yyval.string)= tmp->val_str((String*) 0);
          }
#line 46018 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2498: /* param_marker: PARAM_MARKER  */
#line 15473 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_param)= Lex->add_placeholder(thd, &param_clex_str,
                                                    YYLIP->get_tok_start(),
                                                    YYLIP->get_tok_start() + 1))))
              MYSQL_YYABORT;
          }
#line 46029 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2499: /* param_marker: COLON_ORACLE_SYM ident_cli  */
#line 15480 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_param)= Lex->add_placeholder(thd, &null_clex_str,
                                                    (yyvsp[-1].kwd).pos(), (yyvsp[0].ident_cli).end()))))
              MYSQL_YYABORT;
          }
#line 46039 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2500: /* param_marker: COLON_ORACLE_SYM NUM  */
#line 15486 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_param)= Lex->add_placeholder(thd, &null_clex_str,
                                                    (yyvsp[-1].kwd).pos(),
                                                    YYLIP->get_ptr()))))
              MYSQL_YYABORT;
          }
#line 46050 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2501: /* signed_literal: '+' NUM_literal  */
#line 15495 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.item) = (yyvsp[0].item_num); }
#line 46056 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2502: /* signed_literal: '-' NUM_literal  */
#line 15497 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[0].item_num)->max_length++;
            (yyval.item)= (yyvsp[0].item_num)->neg(thd);
          }
#line 46065 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2503: /* literal: text_literal  */
#line 15504 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.item) = (yyvsp[0].item_basic_constant); }
#line 46071 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2504: /* literal: NUM_literal  */
#line 15505 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.item) = (yyvsp[0].item_num); }
#line 46077 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2505: /* literal: temporal_literal  */
#line 15506 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.item)= (yyvsp[0].item); }
#line 46083 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2506: /* literal: NULL_SYM  */
#line 15508 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              For the digest computation, in this context only,
              NULL is considered a literal, hence reduced to '?'
              REDUCE:
                TOK_GENERIC_VALUE := NULL_SYM
            */
            YYLIP->reduce_digest_token(TOK_GENERIC_VALUE, NULL_SYM);
            (yyval.item)= new (thd->mem_root) Item_null(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            YYLIP->next_state= MY_LEX_OPERATOR_OR_IDENT;
          }
#line 46101 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2507: /* literal: FALSE_SYM  */
#line 15522 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_bool(thd, (char*) "FALSE",0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46111 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2508: /* literal: TRUE_SYM  */
#line 15528 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_bool(thd, (char*) "TRUE",1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46121 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2509: /* literal: HEX_NUM  */
#line 15534 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_hex_hybrid(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46131 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2510: /* literal: HEX_STRING  */
#line 15540 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_hex_string(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46141 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2511: /* literal: BIN_NUM  */
#line 15546 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_bin_string(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46151 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2512: /* literal: UNDERSCORE_CHARSET hex_or_bin_String  */
#line 15552 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item_string_with_introducer *item_str;
            /*
              Pass NULL as name. Name will be set in the "select_item" rule and
              will include the introducer and the original hex/bin notation.
            */
            item_str= new (thd->mem_root)
               Item_string_with_introducer(thd, NULL, (yyvsp[0].string)->ptr(), (yyvsp[0].string)->length(),
                                           (yyvsp[-1].charset));
            if (unlikely(!item_str ||
                         !item_str->check_well_formed_result(true)))
              MYSQL_YYABORT;

            (yyval.item)= item_str;
          }
#line 46171 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2513: /* NUM_literal: NUM  */
#line 15571 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            int error;
            (yyval.item_num)= new (thd->mem_root)
                  Item_int(thd, (yyvsp[0].lex_str).str,
                           (longlong) my_strtoll10((yyvsp[0].lex_str).str, NULL, &error),
                           (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL))
              MYSQL_YYABORT;
          }
#line 46185 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2514: /* NUM_literal: LONG_NUM  */
#line 15581 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            int error;
            (yyval.item_num)= new (thd->mem_root)
                  Item_int(thd, (yyvsp[0].lex_str).str,
                           (longlong) my_strtoll10((yyvsp[0].lex_str).str, NULL, &error),
                           (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL))
              MYSQL_YYABORT;
          }
#line 46199 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2515: /* NUM_literal: ULONGLONG_NUM  */
#line 15591 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_num)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL))
              MYSQL_YYABORT;
          }
#line 46209 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2516: /* NUM_literal: DECIMAL_NUM  */
#line 15597 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_num)= new (thd->mem_root) Item_decimal(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length,
                                                   thd->charset());
            if (unlikely((yyval.item_num) == NULL) || unlikely(thd->is_error()))
              MYSQL_YYABORT;
          }
#line 46220 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2517: /* NUM_literal: FLOAT_NUM  */
#line 15604 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_num)= new (thd->mem_root) Item_float(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL) || unlikely(thd->is_error()))
              MYSQL_YYABORT;
          }
#line 46230 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2518: /* temporal_literal: DATE_SYM TEXT_STRING  */
#line 15614 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= type_handler_newdate.create_literal_item(thd,
                                                           (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                           YYCSCL, true))))
              MYSQL_YYABORT;
          }
#line 46241 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2519: /* temporal_literal: TIME_SYM TEXT_STRING  */
#line 15621 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= type_handler_time2.create_literal_item(thd,
                                                         (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                         YYCSCL, true))))
              MYSQL_YYABORT;
          }
#line 46252 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2520: /* temporal_literal: TIMESTAMP TEXT_STRING  */
#line 15628 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= type_handler_datetime.create_literal_item(thd,
                                                            (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                            YYCSCL, true))))
              MYSQL_YYABORT;
          }
#line 46263 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2521: /* $@216: %empty  */
#line 15638 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             LEX *lex= Lex;
             With_clause *with_clause=
             new With_clause((yyvsp[0].num), Lex->curr_with_clause);
             if (unlikely(with_clause == NULL))
               MYSQL_YYABORT;
             lex->derived_tables|= DERIVED_WITH;
             lex->with_cte_resolution= true;
             lex->curr_with_clause= with_clause;
             with_clause->add_to_list(&lex->with_clauses_list,
                                      lex->with_clauses_list_last_next);
             if (lex->current_select &&
                 lex->current_select->parsing_place == BEFORE_OPT_LIST)
               lex->current_select->parsing_place= NO_MATTER;
          }
#line 46283 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2522: /* with_clause: WITH opt_recursive $@216 with_list  */
#line 15654 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.with_clause)= Lex->curr_with_clause;
            Lex->curr_with_clause= Lex->curr_with_clause->pop();
          }
#line 46292 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2523: /* opt_recursive: %empty  */
#line 15662 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.num)= 0; }
#line 46298 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2524: /* opt_recursive: RECURSIVE_SYM  */
#line 15663 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.num)= 1; }
#line 46304 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2527: /* $@217: %empty  */
#line 15676 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[0].lex_str_list)= new List<LEX_CSTRING> (Lex->with_column_list);
            if (unlikely((yyvsp[0].lex_str_list) == NULL))
              MYSQL_YYABORT;
            Lex->with_column_list.empty();
          }
#line 46315 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2528: /* with_list_element: with_element_head opt_with_column_list $@217 AS '(' query_expression ')'  */
#line 15683 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            const char *query_start= lex->sphead ? lex->sphead->m_tmp_query
                                                 : thd->query();
            const char *spec_start= (yyvsp[-2].kwd).pos() + 1;
            With_element *elem= new With_element((yyvsp[-6].with_element_head), *(yyvsp[-5].lex_str_list), (yyvsp[-1].select_lex_unit));
	    if (elem == NULL || Lex->curr_with_clause->add_with_element(elem))
	      MYSQL_YYABORT;
            if (elem->set_unparsed_spec(thd, spec_start, (yyvsp[0].kwd).pos(),
                                        spec_start - query_start))
              MYSQL_YYABORT;
            elem->set_tables_end_pos(lex->query_tables_last);
	  }
#line 46333 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2529: /* opt_with_column_list: %empty  */
#line 15701 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.lex_str_list)= NULL; }
#line 46339 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2530: /* opt_with_column_list: '(' with_column_list ')'  */
#line 15703 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.lex_str_list)= NULL; }
#line 46345 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2531: /* with_column_list: ident  */
#line 15709 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->with_column_list.push_back((LEX_CSTRING*)
                    thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)));
	  }
#line 46354 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2532: /* with_column_list: with_column_list ',' ident  */
#line 15714 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->with_column_list.push_back((LEX_CSTRING*)
                    thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)));
          }
#line 46363 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2533: /* with_element_head: ident  */
#line 15723 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX_CSTRING *name=
              (LEX_CSTRING *) thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING));
            (yyval.with_element_head)= new (thd->mem_root) With_element_head(name);
            if (unlikely(name == NULL || (yyval.with_element_head) == NULL))
              MYSQL_YYABORT;
            (yyval.with_element_head)->tables_pos.set_start_pos(Lex->query_tables_last);
          }
#line 46376 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2534: /* insert_ident: simple_ident_nospvar  */
#line 15740 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.item)=(yyvsp[0].item); }
#line 46382 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2535: /* insert_ident: table_wild  */
#line 15741 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.item)=(yyvsp[0].item); }
#line 46388 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2536: /* table_wild: ident '.' '*'  */
#line 15746 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-2].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46397 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2537: /* table_wild: ident '.' ident '.' '*'  */
#line 15751 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46406 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2538: /* select_sublist_qualified_asterisk: ident_cli '.' '*'  */
#line 15759 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-2].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46415 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2539: /* select_sublist_qualified_asterisk: ident_cli '.' ident_cli '.' '*'  */
#line 15764 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-4].ident_cli), &(yyvsp[-2].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46424 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2540: /* order_ident: expr  */
#line 15771 "/home/buildbot/git/sql/sql_yacc.yy"
               { (yyval.item)=(yyvsp[0].item); }
#line 46430 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2541: /* simple_ident: ident_cli  */
#line 15777 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46439 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2542: /* simple_ident: ident_cli '.' ident_cli  */
#line 15782 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46448 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2543: /* simple_ident: '.' ident_cli '.' ident_cli  */
#line 15787 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex_ident_cli empty((yyvsp[-2].ident_cli).pos(), 0);
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &empty, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46458 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2544: /* simple_ident: ident_cli '.' ident_cli '.' ident_cli  */
#line 15793 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[-4].ident_cli), &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46467 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2545: /* simple_ident: COLON_ORACLE_SYM ident_cli '.' ident_cli  */
#line 15798 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_colon_ident_ident(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46476 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2546: /* simple_ident_nospvar: ident  */
#line 15806 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident_nosp(thd, &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46485 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2547: /* simple_ident_nospvar: ident '.' ident  */
#line 15811 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident_nospvar(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46494 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2548: /* simple_ident_nospvar: COLON_ORACLE_SYM ident_cli '.' ident_cli  */
#line 15816 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_colon_ident_ident(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46503 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2549: /* simple_ident_nospvar: '.' ident '.' ident  */
#line 15821 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex_ident_sys none;
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &none, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46513 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2550: /* simple_ident_nospvar: ident '.' ident '.' ident  */
#line 15827 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46522 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2551: /* field_ident: ident  */
#line 15834 "/home/buildbot/git/sql/sql_yacc.yy"
                { (yyval.lex_str)=(yyvsp[0].ident_sys);}
#line 46528 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2552: /* field_ident: ident '.' ident '.' ident  */
#line 15836 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            TABLE_LIST *table= Select->table_list.first;
            if (unlikely(my_strcasecmp(table_alias_charset, (yyvsp[-4].ident_sys).str,
                                       table->db.str)))
              my_yyabort_error((ER_WRONG_DB_NAME, MYF(0), (yyvsp[-4].ident_sys).str));
            if (unlikely(my_strcasecmp(table_alias_charset, (yyvsp[-2].ident_sys).str,
                                       table->table_name.str)))
              my_yyabort_error((ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[-2].ident_sys).str));
            (yyval.lex_str)=(yyvsp[0].ident_sys);
          }
#line 46543 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2553: /* field_ident: ident '.' ident  */
#line 15847 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            TABLE_LIST *table= Select->table_list.first;
            if (unlikely(my_strcasecmp(table_alias_charset, (yyvsp[-2].ident_sys).str,
                         table->alias.str)))
              my_yyabort_error((ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[-2].ident_sys).str));
            (yyval.lex_str)=(yyvsp[0].ident_sys);
          }
#line 46555 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2554: /* field_ident: '.' ident  */
#line 15854 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.lex_str)=(yyvsp[0].ident_sys);}
#line 46561 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2555: /* table_ident: ident  */
#line 15859 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(&(yyvsp[0].ident_sys));
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46571 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2556: /* table_ident: ident '.' ident  */
#line 15865 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys), 0);
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46581 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2557: /* table_ident: '.' ident  */
#line 15871 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* For Delphi */
            (yyval.table)= new (thd->mem_root) Table_ident(&(yyvsp[0].ident_sys));
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46592 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2558: /* table_ident_opt_wild: ident opt_wild  */
#line 15881 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(&(yyvsp[-1].ident_sys));
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46602 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2559: /* table_ident_opt_wild: ident '.' ident opt_wild  */
#line 15887 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(thd, &(yyvsp[-3].ident_sys), &(yyvsp[-1].ident_sys), 0);
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46612 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2560: /* table_ident_nodb: ident  */
#line 15896 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX_CSTRING db={(char*) any_db,3};
            (yyval.table)= new (thd->mem_root) Table_ident(thd, &db, &(yyvsp[0].ident_sys), 0);
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46623 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2565: /* ident_cli: keyword_ident  */
#line 15912 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.ident_cli)= (yyvsp[0].kwd); }
#line 46629 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2566: /* IDENT_sys: IDENT_cli  */
#line 15917 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(thd->to_ident_sys_alloc(&(yyval.ident_sys), &(yyvsp[0].ident_cli))))
              MYSQL_YYABORT;
          }
#line 46638 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2567: /* TEXT_STRING_sys: TEXT_STRING  */
#line 15925 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (thd->make_text_string_sys(&(yyval.lex_str), &(yyvsp[0].lex_string_with_metadata)))
              MYSQL_YYABORT;
          }
#line 46647 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2568: /* TEXT_STRING_literal: TEXT_STRING  */
#line 15933 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (thd->make_text_string_connection(&(yyval.lex_str), &(yyvsp[0].lex_string_with_metadata)))
              MYSQL_YYABORT;
          }
#line 46656 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2569: /* TEXT_STRING_filesystem: TEXT_STRING  */
#line 15941 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (thd->make_text_string_filesystem(&(yyval.lex_str), &(yyvsp[0].lex_string_with_metadata)))
              MYSQL_YYABORT;
          }
#line 46665 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2571: /* ident_table_alias: keyword_table_alias  */
#line 15950 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46674 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2573: /* ident_set_usual_case: keyword_set_usual_case  */
#line 15959 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46683 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2575: /* ident_sysvar_name: keyword_sysvar_name  */
#line 15968 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46692 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2576: /* ident_sysvar_name: TEXT_STRING_sys  */
#line 15973 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_sys(thd, &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 46701 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2578: /* ident: keyword_ident  */
#line 15983 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46710 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2580: /* label_ident: keyword_label  */
#line 15992 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46719 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2581: /* ident_or_text: ident  */
#line 15999 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.lex_str)=(yyvsp[0].ident_sys);}
#line 46725 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2582: /* ident_or_text: TEXT_STRING_sys  */
#line 16000 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.lex_str)=(yyvsp[0].lex_str);}
#line 46731 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2583: /* ident_or_text: LEX_HOSTNAME  */
#line 16001 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.lex_str)=(yyvsp[0].lex_str);}
#line 46737 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2584: /* user_maybe_role: ident_or_text  */
#line 16006 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user = (yyvsp[0].lex_str);

            if (unlikely(check_string_char_length(&(yyval.lex_user)->user, ER_USERNAME,
                                                  username_char_length,
                                                  system_charset_info, 0)))
              MYSQL_YYABORT;
          }
#line 46752 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2585: /* user_maybe_role: ident_or_text '@' ident_or_text  */
#line 16017 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user = (yyvsp[-2].lex_str); (yyval.lex_user)->host=(yyvsp[0].lex_str);

            if (unlikely(check_string_char_length(&(yyval.lex_user)->user, ER_USERNAME,
                                                  username_char_length,
                                                 system_charset_info, 0)) ||
                unlikely(check_host_name(&(yyval.lex_user)->host)))
              MYSQL_YYABORT;
            if ((yyval.lex_user)->host.str[0])
            {
              /*
                Convert hostname part of username to lowercase.
                It's OK to use in-place lowercase as long as
                the character set is utf8.
              */
              my_casedn_str(system_charset_info, (char*) (yyval.lex_user)->host.str);
            }
            else
            {
              /*
                fix historical undocumented convention that empty host is the
                same as '%'
              */
              (yyval.lex_user)->host= host_not_specified;
            }
          }
#line 46785 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2586: /* user_maybe_role: CURRENT_USER optional_braces  */
#line 16046 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*)thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user= current_user;
            (yyval.lex_user)->auth= new (thd->mem_root) USER_AUTH();
          }
#line 46796 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2589: /* user: user_maybe_role  */
#line 16057 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           if ((yyvsp[0].lex_user)->user.str != current_user.str && (yyvsp[0].lex_user)->host.str == 0)
             (yyvsp[0].lex_user)->host= host_not_specified;
           (yyval.lex_user)= (yyvsp[0].lex_user);
         }
#line 46806 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3065: /* $@218: %empty  */
#line 16665 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (lex->main_select_push(true))
              MYSQL_YYABORT;
            lex->set_stmt_init();
            lex->var_list.empty();
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46820 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3066: /* set: SET $@218 start_option_value_list  */
#line 16675 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 46830 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3067: /* $@219: %empty  */
#line 16681 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->set_stmt_init();
          }
#line 46840 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3068: /* $@220: %empty  */
#line 16687 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->table_or_sp_used()))
              my_yyabort_error((ER_SUBQUERIES_NOT_SUPPORTED, MYF(0), "SET STATEMENT"));
            lex->stmt_var_list= lex->var_list;
            lex->var_list.empty();
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 46855 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3069: /* set: SET STATEMENT_SYM $@219 set_stmt_option_value_following_option_type_list $@220 FOR_SYM verb_clause  */
#line 16698 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 46861 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3072: /* $@221: %empty  */
#line 16714 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46870 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3074: /* $@222: %empty  */
#line 16720 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_type= OPT_DEFAULT;
          }
#line 46878 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3075: /* start_option_value_list: TRANSACTION_SYM $@222 transaction_characteristics  */
#line 16724 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46887 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3076: /* $@223: %empty  */
#line 16729 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_type= (yyvsp[0].var_type);
          }
#line 46895 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3078: /* $@224: %empty  */
#line 16739 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46904 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3080: /* start_option_value_list_following_option_type: TRANSACTION_SYM transaction_characteristics  */
#line 16745 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46913 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3083: /* $@225: %empty  */
#line 16759 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46922 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3084: /* option_value_list: $@225 option_value  */
#line 16764 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46931 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3085: /* $@226: %empty  */
#line 16769 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46940 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3086: /* option_value_list: option_value_list ',' $@226 option_value  */
#line 16774 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46949 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3087: /* $@227: %empty  */
#line 16783 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_type= (yyvsp[0].var_type);
          }
#line 46957 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3090: /* option_type: GLOBAL_SYM  */
#line 16791 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_GLOBAL; }
#line 46963 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3091: /* option_type: LOCAL_SYM  */
#line 16792 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46969 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3092: /* option_type: SESSION_SYM  */
#line 16793 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46975 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3093: /* opt_var_type: %empty  */
#line 16797 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46981 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3094: /* opt_var_type: GLOBAL_SYM  */
#line 16798 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_GLOBAL; }
#line 46987 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3095: /* opt_var_type: LOCAL_SYM  */
#line 16799 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46993 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3096: /* opt_var_type: SESSION_SYM  */
#line 16800 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46999 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3097: /* opt_var_ident_type: %empty  */
#line 16804 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.var_type)=OPT_DEFAULT; }
#line 47005 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3098: /* opt_var_ident_type: GLOBAL_SYM '.'  */
#line 16805 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.var_type)=OPT_GLOBAL; }
#line 47011 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3099: /* opt_var_ident_type: LOCAL_SYM '.'  */
#line 16806 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.var_type)=OPT_SESSION; }
#line 47017 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3100: /* opt_var_ident_type: SESSION_SYM '.'  */
#line 16807 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.var_type)=OPT_SESSION; }
#line 47023 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3101: /* option_value_following_option_type: ident equal set_expr_or_default  */
#line 16813 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_system_variable(Lex->option_type, &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47032 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3102: /* option_value_following_option_type: ident '.' ident equal set_expr_or_default  */
#line 16818 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_system_variable(thd, Lex->option_type, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47041 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3103: /* option_value_following_option_type: DEFAULT '.' ident equal set_expr_or_default  */
#line 16823 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_default_system_variable(Lex->option_type, &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47050 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3104: /* option_value_no_option_type: ident_set_usual_case equal set_expr_or_default  */
#line 16832 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47059 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3105: /* option_value_no_option_type: ident '.' ident equal set_expr_or_default  */
#line 16837 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47068 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3106: /* option_value_no_option_type: DEFAULT '.' ident equal set_expr_or_default  */
#line 16842 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_default_system_variable(Lex->option_type, &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47077 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3107: /* option_value_no_option_type: '@' ident_or_text equal expr  */
#line 16847 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_user_variable(thd, &(yyvsp[-2].lex_str), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47086 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3108: /* option_value_no_option_type: '@' '@' opt_var_ident_type ident_sysvar_name equal set_expr_or_default  */
#line 16852 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_system_variable((yyvsp[-3].var_type), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47095 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3109: /* option_value_no_option_type: '@' '@' opt_var_ident_type ident_sysvar_name '.' ident equal set_expr_or_default  */
#line 16857 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_system_variable(thd, (yyvsp[-5].var_type), &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47104 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3110: /* option_value_no_option_type: '@' '@' opt_var_ident_type DEFAULT '.' ident equal set_expr_or_default  */
#line 16862 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_default_system_variable((yyvsp[-5].var_type), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47113 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3111: /* option_value_no_option_type: charset old_or_new_charset_name_or_default  */
#line 16867 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            CHARSET_INFO *cs2;
            cs2= (yyvsp[0].charset) ? (yyvsp[0].charset): global_system_variables.character_set_client;
            set_var_collation_client *var;
            var= (new (thd->mem_root)
                  set_var_collation_client(cs2,
                                           thd->variables.collation_database,
                                            cs2));
            if (unlikely(var == NULL))
              MYSQL_YYABORT;
            lex->var_list.push_back(var, thd->mem_root);
          }
#line 47131 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3112: /* option_value_no_option_type: NAMES_SYM equal expr  */
#line 16881 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_pcontext *spc= lex->spcont;
            LEX_CSTRING names= { STRING_WITH_LEN("names") };
            if (unlikely(spc && spc->find_variable(&names, false)))
              my_error(ER_SP_BAD_VAR_SHADOW, MYF(0), names.str);
            else
              thd->parse_error();
            MYSQL_YYABORT;
          }
#line 47146 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3113: /* option_value_no_option_type: NAMES_SYM charset_name_or_default opt_collate  */
#line 16892 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            CHARSET_INFO *cs2;
            CHARSET_INFO *cs3;
            cs2= (yyvsp[-1].charset) ? (yyvsp[-1].charset) : global_system_variables.character_set_client;
            cs3= (yyvsp[0].charset) ? (yyvsp[0].charset) : cs2;
            if (unlikely(!my_charset_same(cs2, cs3)))
            {
              my_error(ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                       cs3->name, cs2->csname);
              MYSQL_YYABORT;
            }
            set_var_collation_client *var;
            var= new (thd->mem_root) set_var_collation_client(cs3, cs3, cs3);
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47169 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3114: /* option_value_no_option_type: DEFAULT ROLE_SYM grant_role  */
#line 16911 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex = Lex;
            LEX_USER *user;
            if (unlikely(!(user=(LEX_USER *) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            user->user= current_user;
            set_var_default_role *var= (new (thd->mem_root)
                                        set_var_default_role(user,
                                                             (yyvsp[0].lex_user)->user));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;

            thd->lex->autocommit= TRUE;
            if (lex->sphead)
              lex->sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;
          }
#line 47191 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3115: /* option_value_no_option_type: DEFAULT ROLE_SYM grant_role FOR_SYM user  */
#line 16929 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex = Lex;
            set_var_default_role *var= (new (thd->mem_root)
                                        set_var_default_role((yyvsp[0].lex_user), (yyvsp[-2].lex_user)->user));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
            thd->lex->autocommit= TRUE;
            if (lex->sphead)
              lex->sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;
          }
#line 47207 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3116: /* option_value_no_option_type: ROLE_SYM ident_or_text  */
#line 16941 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex = Lex;
            set_var_role *var= new (thd->mem_root) set_var_role((yyvsp[0].lex_str));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47219 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3117: /* option_value_no_option_type: ROLE_SYM equal set_expr_or_default  */
#line 16949 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-2].kwd), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47228 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3118: /* option_value_no_option_type: PASSWORD_SYM opt_for_user text_or_password  */
#line 16954 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex = Lex;
            set_var_password *var= (new (thd->mem_root)
                                    set_var_password(lex->definer));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
            lex->autocommit= TRUE;
            if (lex->sphead)
              lex->sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;
          }
#line 47244 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3123: /* transaction_access_mode: transaction_access_mode_types  */
#line 16977 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Item *item= new (thd->mem_root) Item_int(thd, (int32) (yyvsp[0].num));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            set_var *var= (new (thd->mem_root)
                           set_var(thd, lex->option_type,
                                   find_sys_var(thd, "tx_read_only"),
                                   &null_clex_str,
                                   item));
            if (unlikely(var == NULL))
              MYSQL_YYABORT;
            if (unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47264 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3124: /* isolation_level: ISOLATION LEVEL_SYM isolation_types  */
#line 16996 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Item *item= new (thd->mem_root) Item_int(thd, (int32) (yyvsp[0].tx_isolation));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            set_var *var= (new (thd->mem_root)
                           set_var(thd, lex->option_type,
                                   find_sys_var(thd, "tx_isolation"),
                                   &null_clex_str,
                                   item));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47283 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3125: /* transaction_access_mode_types: READ_SYM ONLY_SYM  */
#line 17013 "/home/buildbot/git/sql/sql_yacc.yy"
                            { (yyval.num)= true; }
#line 47289 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3126: /* transaction_access_mode_types: READ_SYM WRITE_SYM  */
#line 17014 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num)= false; }
#line 47295 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3127: /* isolation_types: READ_SYM UNCOMMITTED_SYM  */
#line 17018 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.tx_isolation)= ISO_READ_UNCOMMITTED; }
#line 47301 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3128: /* isolation_types: READ_SYM COMMITTED_SYM  */
#line 17019 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.tx_isolation)= ISO_READ_COMMITTED; }
#line 47307 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3129: /* isolation_types: REPEATABLE_SYM READ_SYM  */
#line 17020 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.tx_isolation)= ISO_REPEATABLE_READ; }
#line 47313 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3130: /* isolation_types: SERIALIZABLE_SYM  */
#line 17021 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.tx_isolation)= ISO_SERIALIZABLE; }
#line 47319 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3131: /* opt_for_user: equal  */
#line 17026 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            sp_pcontext *spc= lex->spcont;
            LEX_CSTRING pw= { STRING_WITH_LEN("password") };

            if (unlikely(spc && spc->find_variable(&pw, false)))
              my_yyabort_error((ER_SP_BAD_VAR_SHADOW, MYF(0), pw.str));
            if (unlikely(!(lex->definer= (LEX_USER*)
                           thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            lex->definer->user= current_user;
            lex->definer->auth= new (thd->mem_root) USER_AUTH();
          }
#line 47337 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3132: /* opt_for_user: FOR_SYM user equal  */
#line 17039 "/home/buildbot/git/sql/sql_yacc.yy"
                             { Lex->definer= (yyvsp[-1].lex_user); }
#line 47343 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3133: /* text_or_password: TEXT_STRING  */
#line 17044 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->definer->auth= new (thd->mem_root) USER_AUTH();
            Lex->definer->auth->auth_str= (yyvsp[0].lex_string_with_metadata);
          }
#line 47352 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3134: /* text_or_password: PASSWORD_SYM '(' TEXT_STRING ')'  */
#line 17049 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->definer->auth= new (thd->mem_root) USER_AUTH();
            Lex->definer->auth->pwtext= (yyvsp[-1].lex_string_with_metadata);
          }
#line 47361 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3135: /* text_or_password: OLD_PASSWORD_SYM '(' TEXT_STRING ')'  */
#line 17054 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->definer->auth= new (thd->mem_root) USER_AUTH();
            Lex->definer->auth->pwtext= (yyvsp[-1].lex_string_with_metadata);
            Lex->definer->auth->auth_str.str= Item_func_password::alloc(thd,
                                   (yyvsp[-1].lex_string_with_metadata).str, (yyvsp[-1].lex_string_with_metadata).length, Item_func_password::OLD);
            Lex->definer->auth->auth_str.length=  SCRAMBLED_PASSWORD_CHAR_LENGTH_323;
          }
#line 47373 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3136: /* set_expr_or_default: expr  */
#line 17064 "/home/buildbot/git/sql/sql_yacc.yy"
               { (yyval.item)=(yyvsp[0].item); }
#line 47379 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3137: /* set_expr_or_default: DEFAULT  */
#line 17065 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.item)=0; }
#line 47385 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3138: /* set_expr_or_default: ON  */
#line 17067 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_string_sys(thd, "ON",  2);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 47395 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3139: /* set_expr_or_default: ALL  */
#line 17073 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_string_sys(thd, "ALL", 3);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 47405 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3140: /* set_expr_or_default: BINARY  */
#line 17079 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_string_sys(thd, "binary", 6);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 47415 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3141: /* $@228: %empty  */
#line 17090 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "LOCK"));
            lex->sql_command= SQLCOM_LOCK_TABLES;
          }
#line 47427 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3142: /* lock: LOCK_SYM table_or_tables $@228 table_lock_list opt_lock_wait_timeout  */
#line 17098 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 47433 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3143: /* opt_lock_wait_timeout: %empty  */
#line 17103 "/home/buildbot/git/sql/sql_yacc.yy"
        {}
#line 47439 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3144: /* opt_lock_wait_timeout: WAIT_SYM ulong_num  */
#line 17105 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if (unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("lock_wait_timeout"), (yyvsp[0].ulong_num))) ||
              unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("innodb_lock_wait_timeout"), (yyvsp[0].ulong_num))))
            MYSQL_YYABORT;
        }
#line 47449 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3145: /* opt_lock_wait_timeout: NOWAIT_SYM  */
#line 17111 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if (unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("lock_wait_timeout"), 0)) ||
              unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("innodb_lock_wait_timeout"), 0)))
            MYSQL_YYABORT;
        }
#line 47459 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3146: /* table_or_tables: TABLE_SYM  */
#line 17119 "/home/buildbot/git/sql/sql_yacc.yy"
                           { }
#line 47465 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3147: /* table_or_tables: TABLES  */
#line 17120 "/home/buildbot/git/sql/sql_yacc.yy"
                           { }
#line 47471 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3150: /* table_lock: table_ident opt_table_alias_clause lock_option  */
#line 17130 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            thr_lock_type lock_type= (thr_lock_type) (yyvsp[0].num);
            bool lock_for_write= (lock_type >= TL_WRITE_ALLOW_WRITE);
            ulong table_options= lock_for_write ? TL_OPTION_UPDATING : 0;
            enum_mdl_type mdl_type= !lock_for_write
                                    ? MDL_SHARED_READ
                                    : lock_type == TL_WRITE_CONCURRENT_INSERT
                                      ? MDL_SHARED_WRITE
                                      : MDL_SHARED_NO_READ_WRITE;

            if (unlikely(!Lex->current_select_or_default()->
                         add_table_to_list(thd, (yyvsp[-2].table), (yyvsp[-1].lex_str_ptr), table_options,
                                           lock_type, mdl_type)))
              MYSQL_YYABORT;
          }
#line 47491 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3151: /* lock_option: READ_SYM  */
#line 17148 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.num)= TL_READ_NO_INSERT; }
#line 47497 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3152: /* lock_option: WRITE_SYM  */
#line 17149 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.num)= TL_WRITE_DEFAULT; }
#line 47503 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3153: /* lock_option: WRITE_SYM CONCURRENT  */
#line 17151 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= (Lex->sphead ? TL_WRITE_DEFAULT : TL_WRITE_CONCURRENT_INSERT);
          }
#line 47511 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3154: /* lock_option: LOW_PRIORITY WRITE_SYM  */
#line 17155 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.num)= TL_WRITE_LOW_PRIORITY; }
#line 47517 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3155: /* lock_option: READ_SYM LOCAL_SYM  */
#line 17156 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.num)= TL_READ; }
#line 47523 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3156: /* $@229: %empty  */
#line 17161 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "UNLOCK"));
            lex->sql_command= SQLCOM_UNLOCK_TABLES;
          }
#line 47535 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3157: /* unlock: UNLOCK_SYM $@229 table_or_tables  */
#line 17169 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 47541 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3158: /* $@230: %empty  */
#line 17178 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 47550 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3159: /* handler: HANDLER_SYM $@230 handler_tail  */
#line 17183 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 47558 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3160: /* handler_tail: table_ident OPEN_SYM opt_table_alias_clause  */
#line 17190 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HANDLER"));
            lex->sql_command = SQLCOM_HA_OPEN;
            if (!lex->current_select->add_table_to_list(thd, (yyvsp[-2].table), (yyvsp[0].lex_str_ptr), 0))
              MYSQL_YYABORT;
          }
#line 47571 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3161: /* handler_tail: table_ident_nodb CLOSE_SYM  */
#line 17199 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HANDLER"));
            lex->sql_command = SQLCOM_HA_CLOSE;
            if (!lex->current_select->add_table_to_list(thd, (yyvsp[-1].table), 0, 0))
              MYSQL_YYABORT;
          }
#line 47584 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3162: /* $@231: %empty  */
#line 17208 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HANDLER"));
            lex->clause_that_disallows_subselect= "HANDLER..READ";
            lex->sql_command = SQLCOM_HA_READ;
            lex->ha_rkey_mode= HA_READ_KEY_EXACT; /* Avoid purify warnings */
            Item *one= new (thd->mem_root) Item_int(thd, (int32) 1);
            if (unlikely(one == NULL))
              MYSQL_YYABORT;
            lex->current_select->select_limit= one;
            lex->current_select->offset_limit= 0;
            lex->limit_rows_examined= 0;
            if (!lex->current_select->add_table_to_list(thd, (yyvsp[-1].table), 0, 0))
              MYSQL_YYABORT;
          }
#line 47605 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3163: /* handler_tail: table_ident_nodb READ_SYM $@231 handler_read_or_scan opt_where_clause opt_global_limit_clause  */
#line 17225 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->clause_that_disallows_subselect= NULL;
            if (!lex->current_select->explicit_limit)
            {
              Item *one= new (thd->mem_root) Item_int(thd, (int32) 1);
              if (one == NULL)
                MYSQL_YYABORT;
              lex->current_select->select_limit= one;
              lex->current_select->offset_limit= 0;
              lex->limit_rows_examined= 0;
            }
            /* Stored functions are not supported for HANDLER READ. */
            if (lex->uses_stored_routines())
            {
              my_error(ER_NOT_SUPPORTED_YET, MYF(0),
                       "stored functions in HANDLER ... READ");
              MYSQL_YYABORT;
            }
          }
#line 47630 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3164: /* handler_read_or_scan: handler_scan_function  */
#line 17248 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->ident= null_clex_str; }
#line 47636 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3165: /* handler_read_or_scan: ident handler_rkey_function  */
#line 17249 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->ident= (yyvsp[-1].ident_sys); }
#line 47642 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3166: /* handler_scan_function: FIRST_SYM  */
#line 17253 "/home/buildbot/git/sql/sql_yacc.yy"
                    { Lex->ha_read_mode = RFIRST; }
#line 47648 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3167: /* handler_scan_function: NEXT_SYM  */
#line 17254 "/home/buildbot/git/sql/sql_yacc.yy"
                    { Lex->ha_read_mode = RNEXT;  }
#line 47654 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3168: /* handler_rkey_function: FIRST_SYM  */
#line 17258 "/home/buildbot/git/sql/sql_yacc.yy"
                    { Lex->ha_read_mode = RFIRST; }
#line 47660 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3169: /* handler_rkey_function: NEXT_SYM  */
#line 17259 "/home/buildbot/git/sql/sql_yacc.yy"
                    { Lex->ha_read_mode = RNEXT;  }
#line 47666 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3170: /* handler_rkey_function: PREV_SYM  */
#line 17260 "/home/buildbot/git/sql/sql_yacc.yy"
                    { Lex->ha_read_mode = RPREV;  }
#line 47672 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3171: /* handler_rkey_function: LAST_SYM  */
#line 17261 "/home/buildbot/git/sql/sql_yacc.yy"
                    { Lex->ha_read_mode = RLAST;  }
#line 47678 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3172: /* $@232: %empty  */
#line 17263 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->ha_read_mode = RKEY;
            lex->ha_rkey_mode=(yyvsp[0].ha_rkey_mode);
            if (unlikely(!(lex->insert_list= new (thd->mem_root) List_item)))
              MYSQL_YYABORT;
          }
#line 47690 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3173: /* handler_rkey_function: handler_rkey_mode $@232 '(' values ')'  */
#line 17271 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 47696 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3174: /* handler_rkey_mode: '='  */
#line 17275 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.ha_rkey_mode)=HA_READ_KEY_EXACT;   }
#line 47702 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3175: /* handler_rkey_mode: GE  */
#line 17276 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.ha_rkey_mode)=HA_READ_KEY_OR_NEXT; }
#line 47708 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3176: /* handler_rkey_mode: LE  */
#line 17277 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.ha_rkey_mode)=HA_READ_KEY_OR_PREV; }
#line 47714 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3177: /* handler_rkey_mode: '>'  */
#line 17278 "/home/buildbot/git/sql/sql_yacc.yy"
              { (yyval.ha_rkey_mode)=HA_READ_AFTER_KEY;   }
#line 47720 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3178: /* handler_rkey_mode: '<'  */
#line 17279 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.ha_rkey_mode)=HA_READ_BEFORE_KEY;  }
#line 47726 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3179: /* revoke: REVOKE clear_privileges revoke_command  */
#line 17286 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 47732 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3180: /* revoke_command: grant_privileges ON opt_table grant_ident FROM user_and_role_list  */
#line 17291 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_REVOKE;
            lex->type= 0;
          }
#line 47742 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3181: /* revoke_command: grant_privileges ON FUNCTION_SYM grant_ident FROM user_and_role_list  */
#line 17297 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                                                TYPE_ENUM_FUNCTION)))
              MYSQL_YYABORT;
          }
#line 47752 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3182: /* revoke_command: grant_privileges ON PROCEDURE_SYM grant_ident FROM user_and_role_list  */
#line 17303 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                         TYPE_ENUM_PROCEDURE)))
              MYSQL_YYABORT;
          }
#line 47762 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3183: /* revoke_command: grant_privileges ON PACKAGE_ORACLE_SYM grant_ident FROM user_and_role_list  */
#line 17310 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                                                TYPE_ENUM_PACKAGE)))
              MYSQL_YYABORT;
          }
#line 47772 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3184: /* revoke_command: grant_privileges ON PACKAGE_ORACLE_SYM BODY_ORACLE_SYM grant_ident FROM user_and_role_list  */
#line 17317 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                                                TYPE_ENUM_PACKAGE_BODY)))
              MYSQL_YYABORT;
          }
#line 47782 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3185: /* revoke_command: ALL opt_privileges ',' GRANT OPTION FROM user_and_role_list  */
#line 17323 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_REVOKE_ALL;
          }
#line 47790 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3186: /* revoke_command: PROXY_SYM ON user FROM user_list  */
#line 17327 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->users_list.push_front ((yyvsp[-2].lex_user));
            lex->sql_command= SQLCOM_REVOKE;
            lex->type= TYPE_ENUM_PROXY;
          }
#line 47801 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3187: /* revoke_command: admin_option_for_role FROM user_and_role_list  */
#line 17334 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_REVOKE_ROLE;
            if (unlikely(Lex->users_list.push_front((yyvsp[-2].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47811 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3188: /* admin_option_for_role: ADMIN_SYM OPTION FOR_SYM grant_role  */
#line 17343 "/home/buildbot/git/sql/sql_yacc.yy"
        { Lex->with_admin_option= true; (yyval.lex_user)= (yyvsp[0].lex_user); }
#line 47817 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3189: /* admin_option_for_role: grant_role  */
#line 17345 "/home/buildbot/git/sql/sql_yacc.yy"
        { Lex->with_admin_option= false; (yyval.lex_user)= (yyvsp[0].lex_user); }
#line 47823 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3190: /* grant: GRANT clear_privileges grant_command  */
#line 17350 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 47829 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3191: /* grant_command: grant_privileges ON opt_table grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17356 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_GRANT;
            lex->type= 0;
          }
#line 47839 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3192: /* grant_command: grant_privileges ON FUNCTION_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17363 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_FUNCTION)))
              MYSQL_YYABORT;
          }
#line 47849 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3193: /* grant_command: grant_privileges ON PROCEDURE_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17370 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_PROCEDURE)))
              MYSQL_YYABORT;
          }
#line 47859 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3194: /* grant_command: grant_privileges ON PACKAGE_ORACLE_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17377 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_PACKAGE)))
              MYSQL_YYABORT;
          }
#line 47869 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3195: /* grant_command: grant_privileges ON PACKAGE_ORACLE_SYM BODY_ORACLE_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17384 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_PACKAGE_BODY)))
              MYSQL_YYABORT;
          }
#line 47879 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3196: /* grant_command: PROXY_SYM ON user TO_SYM grant_list opt_grant_option  */
#line 17390 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->users_list.push_front ((yyvsp[-3].lex_user));
            lex->sql_command= SQLCOM_GRANT;
            lex->type= TYPE_ENUM_PROXY;
          }
#line 47890 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3197: /* grant_command: grant_role TO_SYM grant_list opt_with_admin_option  */
#line 17397 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_GRANT_ROLE;
            /* The first role is the one that is granted */
            if (unlikely(Lex->users_list.push_front((yyvsp[-3].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47902 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3198: /* opt_with_admin: %empty  */
#line 17408 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->definer = 0; }
#line 47908 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3199: /* opt_with_admin: WITH ADMIN_SYM user_or_role  */
#line 17409 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->definer = (yyvsp[0].lex_user); }
#line 47914 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3200: /* opt_with_admin_option: %empty  */
#line 17413 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->with_admin_option= false; }
#line 47920 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3201: /* opt_with_admin_option: WITH ADMIN_SYM OPTION  */
#line 17414 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->with_admin_option= true; }
#line 47926 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3202: /* role_list: grant_role  */
#line 17419 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47935 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3203: /* role_list: role_list ',' grant_role  */
#line 17424 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47944 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3204: /* current_role: CURRENT_ROLE optional_braces  */
#line 17432 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user= current_role;
            (yyval.lex_user)->auth= NULL;
          }
#line 47955 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3205: /* grant_role: ident_or_text  */
#line 17442 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            CHARSET_INFO *cs= system_charset_info;
            /* trim end spaces (as they'll be lost in mysql.user anyway) */
            (yyvsp[0].lex_str).length= cs->cset->lengthsp(cs, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            ((char*) (yyvsp[0].lex_str).str)[(yyvsp[0].lex_str).length] = '\0';
            if (unlikely((yyvsp[0].lex_str).length == 0))
              my_yyabort_error((ER_INVALID_ROLE, MYF(0), ""));
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->alloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user= (yyvsp[0].lex_str);
            (yyval.lex_user)->host= empty_clex_str;
            (yyval.lex_user)->auth= NULL;

            if (unlikely(check_string_char_length(&(yyval.lex_user)->user, ER_USERNAME,
                                                  username_char_length,
                                                  cs, 0)))
              MYSQL_YYABORT;
          }
#line 47978 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3209: /* grant_privileges: object_privilege_list  */
#line 17469 "/home/buildbot/git/sql/sql_yacc.yy"
                                {}
#line 47984 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3210: /* grant_privileges: ALL opt_privileges  */
#line 17471 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            Lex->all_privileges= 1; 
            Lex->grant= GLOBAL_ACLS;
          }
#line 47993 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3215: /* $@233: %empty  */
#line 17489 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->which_columns = SELECT_ACL;}
#line 47999 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3216: /* object_privilege: SELECT_SYM $@233 opt_column_list  */
#line 17490 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 48005 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3217: /* $@234: %empty  */
#line 17492 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->which_columns = INSERT_ACL;}
#line 48011 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3218: /* object_privilege: INSERT $@234 opt_column_list  */
#line 17493 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 48017 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3219: /* $@235: %empty  */
#line 17495 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->which_columns = UPDATE_ACL; }
#line 48023 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3220: /* object_privilege: UPDATE_SYM $@235 opt_column_list  */
#line 17496 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 48029 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3221: /* $@236: %empty  */
#line 17498 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->which_columns = REFERENCES_ACL;}
#line 48035 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3222: /* object_privilege: REFERENCES $@236 opt_column_list  */
#line 17499 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 48041 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3223: /* object_privilege: DELETE_SYM  */
#line 17500 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= DELETE_ACL;}
#line 48047 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3224: /* object_privilege: USAGE  */
#line 17501 "/home/buildbot/git/sql/sql_yacc.yy"
                                  {}
#line 48053 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3225: /* object_privilege: INDEX_SYM  */
#line 17502 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= INDEX_ACL;}
#line 48059 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3226: /* object_privilege: ALTER  */
#line 17503 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= ALTER_ACL;}
#line 48065 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3227: /* object_privilege: CREATE  */
#line 17504 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= CREATE_ACL;}
#line 48071 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3228: /* object_privilege: DROP  */
#line 17505 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= DROP_ACL;}
#line 48077 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3229: /* object_privilege: EXECUTE_SYM  */
#line 17506 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= EXECUTE_ACL;}
#line 48083 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3230: /* object_privilege: RELOAD  */
#line 17507 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= RELOAD_ACL;}
#line 48089 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3231: /* object_privilege: SHUTDOWN  */
#line 17508 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= SHUTDOWN_ACL;}
#line 48095 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3232: /* object_privilege: PROCESS  */
#line 17509 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= PROCESS_ACL;}
#line 48101 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3233: /* object_privilege: FILE_SYM  */
#line 17510 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= FILE_ACL;}
#line 48107 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3234: /* object_privilege: GRANT OPTION  */
#line 17511 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= GRANT_ACL;}
#line 48113 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3235: /* object_privilege: SHOW DATABASES  */
#line 17512 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= SHOW_DB_ACL;}
#line 48119 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3236: /* object_privilege: SUPER_SYM  */
#line 17513 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= SUPER_ACL;}
#line 48125 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3237: /* object_privilege: CREATE TEMPORARY TABLES  */
#line 17514 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= CREATE_TMP_ACL;}
#line 48131 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3238: /* object_privilege: LOCK_SYM TABLES  */
#line 17515 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= LOCK_TABLES_ACL; }
#line 48137 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3239: /* object_privilege: REPLICATION SLAVE  */
#line 17516 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= REPL_SLAVE_ACL; }
#line 48143 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3240: /* object_privilege: REPLICATION CLIENT_SYM  */
#line 17517 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= REPL_CLIENT_ACL; }
#line 48149 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3241: /* object_privilege: CREATE VIEW_SYM  */
#line 17518 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= CREATE_VIEW_ACL; }
#line 48155 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3242: /* object_privilege: SHOW VIEW_SYM  */
#line 17519 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= SHOW_VIEW_ACL; }
#line 48161 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3243: /* object_privilege: CREATE ROUTINE_SYM  */
#line 17520 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= CREATE_PROC_ACL; }
#line 48167 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3244: /* object_privilege: ALTER ROUTINE_SYM  */
#line 17521 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= ALTER_PROC_ACL; }
#line 48173 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3245: /* object_privilege: CREATE USER_SYM  */
#line 17522 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= CREATE_USER_ACL; }
#line 48179 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3246: /* object_privilege: EVENT_SYM  */
#line 17523 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= EVENT_ACL;}
#line 48185 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3247: /* object_privilege: TRIGGER_SYM  */
#line 17524 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= TRIGGER_ACL; }
#line 48191 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3248: /* object_privilege: CREATE TABLESPACE  */
#line 17525 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= CREATE_TABLESPACE_ACL; }
#line 48197 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3249: /* object_privilege: DELETE_SYM HISTORY_SYM  */
#line 17526 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= DELETE_HISTORY_ACL; }
#line 48203 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3250: /* opt_and: %empty  */
#line 17530 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 48209 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3251: /* opt_and: AND_SYM  */
#line 17531 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 48215 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3254: /* require_list_element: SUBJECT_SYM TEXT_STRING  */
#line 17541 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (lex->account_options.x509_subject.str)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "SUBJECT"));
            lex->account_options.x509_subject= (yyvsp[0].lex_string_with_metadata);
          }
#line 48226 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3255: /* require_list_element: ISSUER_SYM TEXT_STRING  */
#line 17548 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (lex->account_options.x509_issuer.str)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "ISSUER"));
            lex->account_options.x509_issuer= (yyvsp[0].lex_string_with_metadata);
          }
#line 48237 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3256: /* require_list_element: CIPHER_SYM TEXT_STRING  */
#line 17555 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (lex->account_options.ssl_cipher.str)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CIPHER"));
            lex->account_options.ssl_cipher= (yyvsp[0].lex_string_with_metadata);
          }
#line 48248 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3257: /* grant_ident: '*'  */
#line 17565 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->copy_db_to(&lex->first_select_lex()->db)))
              MYSQL_YYABORT;
            if (lex->grant == GLOBAL_ACLS)
              lex->grant = DB_ACLS & ~GRANT_ACL;
            else if (unlikely(lex->columns.elements))
              my_yyabort_error((ER_ILLEGAL_GRANT_FOR_TABLE, MYF(0)));
          }
#line 48262 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3258: /* grant_ident: ident '.' '*'  */
#line 17575 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->first_select_lex()->db= (yyvsp[-2].ident_sys);
            if (lex->grant == GLOBAL_ACLS)
              lex->grant = DB_ACLS & ~GRANT_ACL;
            else if (unlikely(lex->columns.elements))
              my_yyabort_error((ER_ILLEGAL_GRANT_FOR_TABLE, MYF(0)));
          }
#line 48275 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3259: /* grant_ident: '*' '.' '*'  */
#line 17584 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->first_select_lex()->db= null_clex_str;
            if (lex->grant == GLOBAL_ACLS)
              lex->grant= GLOBAL_ACLS & ~GRANT_ACL;
            else if (unlikely(lex->columns.elements))
              my_yyabort_error((ER_ILLEGAL_GRANT_FOR_TABLE, MYF(0)));
          }
#line 48288 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3260: /* grant_ident: table_ident  */
#line 17593 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(!lex->first_select_lex()->
                         add_table_to_list(thd, (yyvsp[0].table),NULL,
                                           TL_OPTION_UPDATING)))
              MYSQL_YYABORT;
            if (lex->grant == GLOBAL_ACLS)
              lex->grant =  TABLE_ACLS & ~GRANT_ACL;
          }
#line 48302 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3261: /* user_list: user  */
#line 17606 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48311 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3262: /* user_list: user_list ',' user  */
#line 17611 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48320 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3263: /* grant_list: grant_user  */
#line 17619 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48329 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3264: /* grant_list: grant_list ',' grant_user  */
#line 17624 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48338 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3265: /* user_and_role_list: user_or_role  */
#line 17632 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48347 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3266: /* user_and_role_list: user_and_role_list ',' user_or_role  */
#line 17637 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48356 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3271: /* grant_user: user IDENTIFIED_SYM BY TEXT_STRING  */
#line 17648 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_user)= (yyvsp[-3].lex_user);
            (yyvsp[-3].lex_user)->auth= new (thd->mem_root) USER_AUTH();
            (yyvsp[-3].lex_user)->auth->pwtext= (yyvsp[0].lex_string_with_metadata);
          }
#line 48366 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3272: /* grant_user: user IDENTIFIED_SYM BY PASSWORD_SYM TEXT_STRING  */
#line 17654 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            (yyval.lex_user)= (yyvsp[-4].lex_user); 
            (yyvsp[-4].lex_user)->auth= new (thd->mem_root) USER_AUTH();
            (yyvsp[-4].lex_user)->auth->auth_str= (yyvsp[0].lex_string_with_metadata);
          }
#line 48376 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3273: /* grant_user: user IDENTIFIED_SYM via_or_with auth_expression  */
#line 17660 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_user)= (yyvsp[-3].lex_user);
            (yyvsp[-3].lex_user)->auth= (yyvsp[0].user_auth);
          }
#line 48385 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3274: /* grant_user: user_or_role  */
#line 17665 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_user)= (yyvsp[0].lex_user);
          }
#line 48393 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3275: /* auth_expression: auth_token OR_SYM auth_expression  */
#line 17672 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.user_auth)= (yyvsp[-2].user_auth);
            DBUG_ASSERT((yyval.user_auth)->next == NULL);
            (yyval.user_auth)->next= (yyvsp[0].user_auth);
          }
#line 48403 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3276: /* auth_expression: auth_token  */
#line 17678 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.user_auth)= (yyvsp[0].user_auth);
          }
#line 48411 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3277: /* auth_token: ident_or_text opt_auth_str  */
#line 17685 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.user_auth)= (yyvsp[0].user_auth);
          (yyval.user_auth)->plugin= (yyvsp[-1].lex_str);
        }
#line 48420 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3278: /* opt_auth_str: %empty  */
#line 17693 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if (!((yyval.user_auth)=(USER_AUTH*) thd->calloc(sizeof(USER_AUTH))))
            MYSQL_YYABORT;
        }
#line 48429 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3279: /* opt_auth_str: using_or_as TEXT_STRING_sys  */
#line 17698 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if (!((yyval.user_auth)=(USER_AUTH*) thd->calloc(sizeof(USER_AUTH))))
            MYSQL_YYABORT;
          (yyval.user_auth)->auth_str= (yyvsp[0].lex_str);
        }
#line 48439 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3280: /* opt_auth_str: using_or_as PASSWORD_SYM '(' TEXT_STRING ')'  */
#line 17704 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if (!((yyval.user_auth)=(USER_AUTH*) thd->calloc(sizeof(USER_AUTH))))
            MYSQL_YYABORT;
          (yyval.user_auth)->pwtext= (yyvsp[-1].lex_string_with_metadata);
        }
#line 48449 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3281: /* opt_column_list: %empty  */
#line 17713 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->grant |= lex->which_columns;
          }
#line 48458 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3282: /* opt_column_list: '(' column_list ')'  */
#line 17717 "/home/buildbot/git/sql/sql_yacc.yy"
                              { }
#line 48464 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3285: /* column_list_id: ident  */
#line 17727 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            String *new_str= new (thd->mem_root) String((const char*) (yyvsp[0].ident_sys).str,(yyvsp[0].ident_sys).length,system_charset_info);
            if (unlikely(new_str == NULL))
              MYSQL_YYABORT;
            List_iterator <LEX_COLUMN> iter(Lex->columns);
            class LEX_COLUMN *point;
            LEX *lex=Lex;
            while ((point=iter++))
            {
              if (!my_strcasecmp(system_charset_info,
                                 point->column.c_ptr(), new_str->c_ptr()))
                break;
            }
            lex->grant_tot_col|= lex->which_columns;
            if (point)
              point->rights |= lex->which_columns;
            else
            {
              LEX_COLUMN *col= (new (thd->mem_root)
                                LEX_COLUMN(*new_str,lex->which_columns));
              if (unlikely(col == NULL))
                MYSQL_YYABORT;
              lex->columns.push_back(col, thd->mem_root);
            }
          }
#line 48494 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3287: /* opt_require_clause: REQUIRE_SYM require_list  */
#line 17757 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_SPECIFIED;
          }
#line 48502 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3288: /* opt_require_clause: REQUIRE_SYM SSL_SYM  */
#line 17761 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_ANY;
          }
#line 48510 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3289: /* opt_require_clause: REQUIRE_SYM X509_SYM  */
#line 17765 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_X509;
          }
#line 48518 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3290: /* opt_require_clause: REQUIRE_SYM NONE_SYM  */
#line 17769 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_NONE;
          }
#line 48526 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3291: /* resource_option: MAX_QUERIES_PER_HOUR ulong_num  */
#line 17776 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.questions=(yyvsp[0].ulong_num);
            Lex->account_options.specified_limits|= USER_RESOURCES::QUERIES_PER_HOUR;
          }
#line 48535 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3292: /* resource_option: MAX_UPDATES_PER_HOUR ulong_num  */
#line 17781 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.updates=(yyvsp[0].ulong_num);
            Lex->account_options.specified_limits|= USER_RESOURCES::UPDATES_PER_HOUR;
          }
#line 48544 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3293: /* resource_option: MAX_CONNECTIONS_PER_HOUR ulong_num  */
#line 17786 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.conn_per_hour= (yyvsp[0].ulong_num);
            Lex->account_options.specified_limits|= USER_RESOURCES::CONNECTIONS_PER_HOUR;
          }
#line 48553 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3294: /* resource_option: MAX_USER_CONNECTIONS_SYM int_num  */
#line 17791 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.user_conn= (yyvsp[0].num);
            Lex->account_options.specified_limits|= USER_RESOURCES::USER_CONNECTIONS;
          }
#line 48562 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3295: /* resource_option: MAX_STATEMENT_TIME_SYM NUM_literal  */
#line 17796 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.max_statement_time= (yyvsp[0].item_num)->val_real();
            Lex->account_options.specified_limits|= USER_RESOURCES::MAX_STATEMENT_TIME;
          }
#line 48571 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3296: /* resource_option_list: resource_option_list resource_option  */
#line 17803 "/home/buildbot/git/sql/sql_yacc.yy"
                                               {}
#line 48577 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3297: /* resource_option_list: resource_option  */
#line 17804 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 48583 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3298: /* opt_resource_options: %empty  */
#line 17808 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 48589 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3300: /* opt_grant_options: %empty  */
#line 17814 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 48595 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3301: /* opt_grant_options: WITH grant_option_list  */
#line 17815 "/home/buildbot/git/sql/sql_yacc.yy"
                                 {}
#line 48601 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3302: /* opt_grant_option: %empty  */
#line 17819 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 48607 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3303: /* opt_grant_option: WITH GRANT OPTION  */
#line 17820 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->grant |= GRANT_ACL;}
#line 48613 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3304: /* grant_option_list: grant_option_list grant_option  */
#line 17824 "/home/buildbot/git/sql/sql_yacc.yy"
                                         {}
#line 48619 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3305: /* grant_option_list: grant_option  */
#line 17825 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 48625 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3306: /* grant_option: GRANT OPTION  */
#line 17829 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->grant |= GRANT_ACL;}
#line 48631 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3307: /* grant_option: resource_option  */
#line 17830 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 48637 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3308: /* $@237: %empty  */
#line 17835 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_BEGIN;
            lex->start_transaction_opt= 0;
          }
#line 48647 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3309: /* begin_stmt_mariadb: BEGIN_MARIADB_SYM $@237 opt_work  */
#line 17840 "/home/buildbot/git/sql/sql_yacc.yy"
                   {}
#line 48653 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3310: /* compound_statement: sp_proc_stmt_compound_ok  */
#line 17845 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_COMPOUND;
            if (Lex->sp_body_finalize_procedure(thd))
              MYSQL_YYABORT;
          }
#line 48663 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3311: /* opt_not: %empty  */
#line 17853 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.num)= 0; }
#line 48669 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3312: /* opt_not: not  */
#line 17854 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.num)= 1; }
#line 48675 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3313: /* opt_work: %empty  */
#line 17858 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 48681 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3314: /* opt_work: WORK_SYM  */
#line 17859 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 48687 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3315: /* opt_chain: %empty  */
#line 17864 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.m_yes_no_unk)= TVL_UNKNOWN; }
#line 48693 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3316: /* opt_chain: AND_SYM NO_SYM CHAIN_SYM  */
#line 17865 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.m_yes_no_unk)= TVL_NO; }
#line 48699 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3317: /* opt_chain: AND_SYM CHAIN_SYM  */
#line 17866 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.m_yes_no_unk)= TVL_YES; }
#line 48705 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3318: /* opt_release: %empty  */
#line 17871 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.m_yes_no_unk)= TVL_UNKNOWN; }
#line 48711 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3319: /* opt_release: RELEASE_SYM  */
#line 17872 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.m_yes_no_unk)= TVL_YES; }
#line 48717 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3320: /* opt_release: NO_SYM RELEASE_SYM  */
#line 17873 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.m_yes_no_unk)= TVL_NO; }
#line 48723 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3321: /* commit: COMMIT_SYM opt_work opt_chain opt_release  */
#line 17878 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_COMMIT;
            /* Don't allow AND CHAIN RELEASE. */
            MYSQL_YYABORT_UNLESS((yyvsp[-1].m_yes_no_unk) != TVL_YES || (yyvsp[0].m_yes_no_unk) != TVL_YES);
            lex->tx_chain= (yyvsp[-1].m_yes_no_unk);
            lex->tx_release= (yyvsp[0].m_yes_no_unk);
          }
#line 48736 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3322: /* rollback: ROLLBACK_SYM opt_work opt_chain opt_release  */
#line 17890 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK;
            /* Don't allow AND CHAIN RELEASE. */
            MYSQL_YYABORT_UNLESS((yyvsp[-1].m_yes_no_unk) != TVL_YES || (yyvsp[0].m_yes_no_unk) != TVL_YES);
            lex->tx_chain= (yyvsp[-1].m_yes_no_unk);
            lex->tx_release= (yyvsp[0].m_yes_no_unk);
          }
#line 48749 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3323: /* rollback: ROLLBACK_SYM opt_work TO_SYM SAVEPOINT_SYM ident  */
#line 17899 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK_TO_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48759 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3324: /* rollback: ROLLBACK_SYM opt_work TO_SYM ident  */
#line 17905 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK_TO_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48769 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3325: /* savepoint: SAVEPOINT_SYM ident  */
#line 17914 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48779 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3326: /* release: RELEASE_SYM SAVEPOINT_SYM ident  */
#line 17923 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_RELEASE_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48789 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3327: /* unit_type_decl: UNION_SYM union_option  */
#line 17936 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.unit_operation).unit_type= UNION_TYPE; (yyval.unit_operation).distinct= (yyvsp[0].num); }
#line 48795 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3328: /* unit_type_decl: INTERSECT_SYM  */
#line 17938 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.unit_operation).unit_type= INTERSECT_TYPE; (yyval.unit_operation).distinct= 1; }
#line 48801 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3329: /* unit_type_decl: EXCEPT_SYM  */
#line 17940 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.unit_operation).unit_type= EXCEPT_TYPE; (yyval.unit_operation).distinct= 1; }
#line 48807 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3330: /* union_option: %empty  */
#line 17947 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)=1; }
#line 48813 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3331: /* union_option: DISTINCT  */
#line 17948 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.num)=1; }
#line 48819 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3332: /* union_option: ALL  */
#line 17949 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.num)=0; }
#line 48825 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3333: /* query_expression_option: STRAIGHT_JOIN  */
#line 17953 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Select->options|= SELECT_STRAIGHT_JOIN; }
#line 48831 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3334: /* query_expression_option: HIGH_PRIORITY  */
#line 17955 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            YYPS->m_lock_type= TL_READ_HIGH_PRIORITY;
            YYPS->m_mdl_type= MDL_SHARED_READ;
            Select->options|= SELECT_HIGH_PRIORITY;
          }
#line 48841 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3335: /* query_expression_option: DISTINCT  */
#line 17960 "/home/buildbot/git/sql/sql_yacc.yy"
                           { Select->options|= SELECT_DISTINCT; }
#line 48847 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3336: /* query_expression_option: SQL_SMALL_RESULT  */
#line 17961 "/home/buildbot/git/sql/sql_yacc.yy"
                           { Select->options|= SELECT_SMALL_RESULT; }
#line 48853 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3337: /* query_expression_option: SQL_BIG_RESULT  */
#line 17962 "/home/buildbot/git/sql/sql_yacc.yy"
                           { Select->options|= SELECT_BIG_RESULT; }
#line 48859 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3338: /* query_expression_option: SQL_BUFFER_RESULT  */
#line 17963 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Select->options|= OPTION_BUFFER_RESULT; }
#line 48865 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3339: /* query_expression_option: SQL_CALC_FOUND_ROWS  */
#line 17964 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Select->options|= OPTION_FOUND_ROWS; }
#line 48871 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3340: /* query_expression_option: ALL  */
#line 17965 "/home/buildbot/git/sql/sql_yacc.yy"
              { Select->options|= SELECT_ALL; }
#line 48877 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3343: /* no_definer: %empty  */
#line 17981 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              We have to distinguish missing DEFINER-clause from case when
              CURRENT_USER specified as definer explicitly in order to properly
              handle CREATE TRIGGER statements which come to replication thread
              from older master servers (i.e. to create non-suid trigger in this
              case).
            */
            thd->lex->definer= 0;
          }
#line 48892 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3344: /* definer: DEFINER_SYM '=' user_or_role  */
#line 17995 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->definer= (yyvsp[0].lex_user);
            Lex->account_options.reset();
          }
#line 48901 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3345: /* view_algorithm: ALGORITHM_SYM '=' UNDEFINED_SYM  */
#line 18008 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= DTYPE_ALGORITHM_UNDEFINED; }
#line 48907 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3346: /* view_algorithm: ALGORITHM_SYM '=' MERGE_SYM  */
#line 18009 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= VIEW_ALGORITHM_MERGE; }
#line 48913 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3347: /* view_algorithm: ALGORITHM_SYM '=' TEMPTABLE_SYM  */
#line 18010 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= VIEW_ALGORITHM_TMPTABLE; }
#line 48919 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3348: /* opt_view_suid: %empty  */
#line 18014 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.view_suid)= VIEW_SUID_DEFAULT; }
#line 48925 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3349: /* opt_view_suid: view_suid  */
#line 18015 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.view_suid)= (yyvsp[0].view_suid); }
#line 48931 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3350: /* view_suid: SQL_SYM SECURITY_SYM DEFINER_SYM  */
#line 18019 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.view_suid)= VIEW_SUID_DEFINER; }
#line 48937 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3351: /* view_suid: SQL_SYM SECURITY_SYM INVOKER_SYM  */
#line 18020 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.view_suid)= VIEW_SUID_INVOKER; }
#line 48943 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3352: /* view_list_opt: %empty  */
#line 18025 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 48949 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3353: /* view_list_opt: '(' view_list ')'  */
#line 18026 "/home/buildbot/git/sql/sql_yacc.yy"
                            { }
#line 48955 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3354: /* view_list: ident  */
#line 18031 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->view_list.push_back((LEX_CSTRING*)
                                     thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)),
                                     thd->mem_root);
          }
#line 48965 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3355: /* view_list: view_list ',' ident  */
#line 18037 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->view_list.push_back((LEX_CSTRING*)
                                     thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)),
                                     thd->mem_root);
          }
#line 48975 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3356: /* $@238: %empty  */
#line 18045 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->parsing_options.allows_variable= FALSE;
            lex->create_view->select.str= (char *) YYLIP->get_cpp_ptr();
          }
#line 48985 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3357: /* view_select: $@238 query_expression view_check_option  */
#line 18052 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->parsed_create_view((yyvsp[-1].select_lex_unit), (yyvsp[0].num)))
              MYSQL_YYABORT;
          }
#line 48994 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3358: /* view_check_option: %empty  */
#line 18059 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= VIEW_CHECK_NONE; }
#line 49000 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3359: /* view_check_option: WITH CHECK_SYM OPTION  */
#line 18060 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= VIEW_CHECK_CASCADED; }
#line 49006 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3360: /* view_check_option: WITH CASCADED CHECK_SYM OPTION  */
#line 18061 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= VIEW_CHECK_CASCADED; }
#line 49012 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3361: /* view_check_option: WITH LOCAL_SYM CHECK_SYM OPTION  */
#line 18062 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= VIEW_CHECK_LOCAL; }
#line 49018 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3362: /* trigger_action_order: FOLLOWS_SYM  */
#line 18073 "/home/buildbot/git/sql/sql_yacc.yy"
            { (yyval.trigger_action_order_type)= TRG_ORDER_FOLLOWS; }
#line 49024 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3363: /* trigger_action_order: PRECEDES_SYM  */
#line 18075 "/home/buildbot/git/sql/sql_yacc.yy"
            { (yyval.trigger_action_order_type)= TRG_ORDER_PRECEDES; }
#line 49030 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3364: /* trigger_follows_precedes_clause: %empty  */
#line 18080 "/home/buildbot/git/sql/sql_yacc.yy"
            {
              (yyval.trg_execution_order).ordering_clause= TRG_ORDER_NONE;
              (yyval.trg_execution_order).anchor_trigger_name.str= NULL;
              (yyval.trg_execution_order).anchor_trigger_name.length= 0;
            }
#line 49040 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3365: /* trigger_follows_precedes_clause: trigger_action_order ident_or_text  */
#line 18087 "/home/buildbot/git/sql/sql_yacc.yy"
            {
              (yyval.trg_execution_order).ordering_clause= (yyvsp[-1].trigger_action_order_type);
              (yyval.trg_execution_order).anchor_trigger_name= (yyvsp[0].lex_str);
            }
#line 49049 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3366: /* $@239: %empty  */
#line 18096 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_create_options_with_check((yyvsp[0].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 49058 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3367: /* $@240: %empty  */
#line 18105 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* $9 */
            Lex->raw_trg_on_table_name_begin= YYLIP->get_tok_start();
          }
#line 49066 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3368: /* $@241: %empty  */
#line 18111 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* $13 */
            Lex->raw_trg_on_table_name_end= YYLIP->get_tok_start();
          }
#line 49074 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3369: /* $@242: %empty  */
#line 18116 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->trg_chistics.ordering_clause_begin= YYLIP->get_cpp_ptr();
          }
#line 49082 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3370: /* $@243: %empty  */
#line 18120 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* $18 */
            LEX *lex= thd->lex;
            Lex_input_stream *lip= YYLIP;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_RECURSIVE_CREATE, MYF(0), "TRIGGER"));

            lex->stmt_definition_begin= (yyvsp[-16].simple_string);
            lex->ident.str= (yyvsp[-9].simple_string);
            lex->ident.length= (yyvsp[-5].simple_string) - (yyvsp[-9].simple_string);
            lex->spname= (yyvsp[-13].spname);
            (*static_cast<st_trg_execution_order*>(&lex->trg_chistics))= ((yyvsp[0].trg_execution_order));
            lex->trg_chistics.ordering_clause_end= lip->get_cpp_ptr();

            if (unlikely(!lex->make_sp_head(thd, (yyvsp[-13].spname), &sp_handler_trigger,
                                            DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;

            lex->sphead->set_body_start(thd, lip->get_cpp_tok_start());
          }
#line 49107 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3371: /* trigger_tail: remember_name opt_if_not_exists $@239 sp_name trg_action_time trg_event ON remember_name $@240 table_ident FOR_SYM remember_name $@241 EACH_SYM ROW_SYM $@242 trigger_follows_precedes_clause $@243 sp_proc_stmt force_lookahead  */
#line 18141 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* $21 */
            LEX *lex= Lex;

            lex->sql_command= SQLCOM_CREATE_TRIGGER;
            if (lex->sp_body_finalize_trigger(thd))
              MYSQL_YYABORT;

            /*
              We have to do it after parsing trigger body, because some of
              sp_proc_stmt alternatives are not saving/restoring LEX, so
              lex->query_tables can be wiped out.
            */
            if (!lex->first_select_lex()->
                 add_table_to_list(thd, (yyvsp[-10].table), (LEX_CSTRING*) 0,
                                   TL_OPTION_UPDATING, TL_READ_NO_INSERT,
                                   MDL_SHARED_NO_WRITE))
              MYSQL_YYABORT;
          }
#line 49130 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3372: /* $@244: %empty  */
#line 18170 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->init_last_field(&lex->sphead->m_return_field_def,
                                 &empty_clex_str,
                                 thd->variables.collation_database);
          }
#line 49141 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3373: /* sf_return_type: RETURNS_SYM $@244 field_type  */
#line 18177 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead->fill_field_definition(thd,
                                                            Lex->last_field)))
              MYSQL_YYABORT;
          }
#line 49151 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3374: /* $@245: %empty  */
#line 18186 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->sphead->set_c_chistics(lex->sp_chistics);
            lex->sphead->set_body_start(thd, YYLIP->get_cpp_tok_start());
          }
#line 49161 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3375: /* sf_c_chistics_and_body: sp_c_chistics $@245 sp_proc_stmt_in_returns_clause force_lookahead  */
#line 18192 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_body_finalize_function(thd)))
              MYSQL_YYABORT;
          }
#line 49170 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3376: /* $@246: %empty  */
#line 18201 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Lex->make_sp_head_no_recursive(thd, (yyvsp[0].spname),
                                                         &sp_handler_procedure,
                                                         DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;
          }
#line 49181 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3377: /* $@247: %empty  */
#line 18209 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->set_c_chistics(Lex->sp_chistics);
            Lex->sphead->set_body_start(thd, YYLIP->get_cpp_tok_start());
          }
#line 49190 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3378: /* sp_tail: sp_name $@246 sp_parenthesized_pdparam_list sp_c_chistics $@247 sp_proc_stmt force_lookahead  */
#line 18214 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_body_finalize_procedure(thd)))
              MYSQL_YYABORT;
          }
#line 49199 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3379: /* xa: XA_SYM begin_or_start xid opt_join_or_resume  */
#line 18224 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_XA_START;
          }
#line 49207 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3380: /* xa: XA_SYM END xid opt_suspend  */
#line 18228 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_XA_END;
          }
#line 49215 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3381: /* xa: XA_SYM PREPARE_SYM xid  */
#line 18232 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_XA_PREPARE;
          }
#line 49223 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3382: /* xa: XA_SYM COMMIT_SYM xid opt_one_phase  */
#line 18236 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_XA_COMMIT;
          }
#line 49231 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3383: /* xa: XA_SYM ROLLBACK_SYM xid  */
#line 18240 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_XA_ROLLBACK;
          }
#line 49239 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3384: /* xa: XA_SYM RECOVER_SYM opt_format_xid  */
#line 18244 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_XA_RECOVER;
            Lex->verbose= (yyvsp[0].num);
          }
#line 49248 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3385: /* opt_format_xid: %empty  */
#line 18251 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.num)= false; }
#line 49254 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3386: /* opt_format_xid: FORMAT_SYM '=' ident_or_text  */
#line 18253 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("SQL")))
              (yyval.num)= true;
            else if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("RAW")))
              (yyval.num)= false;
            else
            {
              my_yyabort_error((ER_UNKNOWN_EXPLAIN_FORMAT, MYF(0),
                               "XA RECOVER", (yyvsp[0].lex_str).str));
              (yyval.num)= false;
            }
          }
#line 49271 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3387: /* xid: text_string  */
#line 18269 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[0].string)->length() <= MAXGTRIDSIZE);
            if (unlikely(!(Lex->xid=(XID *)thd->alloc(sizeof(XID)))))
              MYSQL_YYABORT;
            Lex->xid->set(1L, (yyvsp[0].string)->ptr(), (yyvsp[0].string)->length(), 0, 0);
          }
#line 49282 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3388: /* xid: text_string ',' text_string  */
#line 18276 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-2].string)->length() <= MAXGTRIDSIZE && (yyvsp[0].string)->length() <= MAXBQUALSIZE);
            if (unlikely(!(Lex->xid=(XID *)thd->alloc(sizeof(XID)))))
              MYSQL_YYABORT;
            Lex->xid->set(1L, (yyvsp[-2].string)->ptr(), (yyvsp[-2].string)->length(), (yyvsp[0].string)->ptr(), (yyvsp[0].string)->length());
          }
#line 49293 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3389: /* xid: text_string ',' text_string ',' ulong_num  */
#line 18283 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-4].string)->length() <= MAXGTRIDSIZE && (yyvsp[-2].string)->length() <= MAXBQUALSIZE);
            if (unlikely(!(Lex->xid=(XID *)thd->alloc(sizeof(XID)))))
              MYSQL_YYABORT;
            Lex->xid->set((yyvsp[0].ulong_num), (yyvsp[-4].string)->ptr(), (yyvsp[-4].string)->length(), (yyvsp[-2].string)->ptr(), (yyvsp[-2].string)->length());
          }
#line 49304 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3390: /* begin_or_start: BEGIN_MARIADB_SYM  */
#line 18292 "/home/buildbot/git/sql/sql_yacc.yy"
                            {}
#line 49310 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3391: /* begin_or_start: BEGIN_ORACLE_SYM  */
#line 18293 "/home/buildbot/git/sql/sql_yacc.yy"
                           {}
#line 49316 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3392: /* begin_or_start: START_SYM  */
#line 18294 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 49322 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3393: /* opt_join_or_resume: %empty  */
#line 18298 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->xa_opt=XA_NONE;        }
#line 49328 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3394: /* opt_join_or_resume: JOIN_SYM  */
#line 18299 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->xa_opt=XA_JOIN;        }
#line 49334 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3395: /* opt_join_or_resume: RESUME_SYM  */
#line 18300 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->xa_opt=XA_RESUME;      }
#line 49340 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3396: /* opt_one_phase: %empty  */
#line 18304 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->xa_opt=XA_NONE;        }
#line 49346 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3397: /* opt_one_phase: ONE_SYM PHASE_SYM  */
#line 18305 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->xa_opt=XA_ONE_PHASE;   }
#line 49352 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3398: /* opt_suspend: %empty  */
#line 18310 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->xa_opt=XA_NONE;        }
#line 49358 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3399: /* $@248: %empty  */
#line 18312 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->xa_opt=XA_SUSPEND;     }
#line 49364 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3401: /* opt_migrate: %empty  */
#line 18317 "/home/buildbot/git/sql/sql_yacc.yy"
                              {}
#line 49370 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3402: /* opt_migrate: FOR_SYM MIGRATE_SYM  */
#line 18318 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->xa_opt=XA_FOR_MIGRATE; }
#line 49376 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3403: /* install: INSTALL_SYM PLUGIN_SYM opt_if_not_exists ident SONAME_SYM TEXT_STRING_sys  */
#line 18323 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_install_plugin((yyvsp[-3].object_ddl_options), (yyvsp[-2].ident_sys), (yyvsp[0].lex_str)))
              MYSQL_YYABORT;
          }
#line 49385 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3404: /* install: INSTALL_SYM SONAME_SYM TEXT_STRING_sys  */
#line 18328 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->stmt_install_plugin((yyvsp[0].lex_str));
          }
#line 49393 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3405: /* uninstall: UNINSTALL_SYM PLUGIN_SYM opt_if_exists ident  */
#line 18335 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_uninstall_plugin_by_name((yyvsp[-1].object_ddl_options), (yyvsp[0].ident_sys)))
              MYSQL_YYABORT;
          }
#line 49402 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3406: /* uninstall: UNINSTALL_SYM SONAME_SYM opt_if_exists TEXT_STRING_sys  */
#line 18340 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_uninstall_plugin_by_soname((yyvsp[-1].object_ddl_options), (yyvsp[0].lex_str)))
              MYSQL_YYABORT;
          }
#line 49411 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3407: /* keep_gcc_happy: IMPOSSIBLE_ACTION  */
#line 18349 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            YYERROR;
          }
#line 49419 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;


#line 49423 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (thd, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, thd);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, thd);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (thd, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, thd);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, thd);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

