/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         ORAparse
#define yylex           ORAlex
#define yyerror         ORAerror
#define yydebug         ORAdebug
#define yynerrs         ORAnerrs

/* First part of user prologue.  */
#line 25 "/home/buildbot/git/sql/sql_yacc_ora.yy"

#define YYLIP  (& thd->m_parser_state->m_lip)
#define YYPS   (& thd->m_parser_state->m_yacc)
#define YYCSCL (thd->variables.character_set_client)

#define MYSQL_YACC
#define YYINITDEPTH 100
#define YYMAXDEPTH 3200                        /* Because of 64K stack */
#define Lex (thd->lex)

#define Select Lex->current_select
#include "mariadb.h"
#include "sql_priv.h"
#include "sql_parse.h"                        /* comp_*_creator */
#include "sql_table.h"                        /* primary_key_name */
#include "sql_partition.h"  /* partition_info, HASH_PARTITION */
#include "sql_acl.h"                          /* *_ACL */
#include "sql_class.h"      /* Key_part_spec, enum_filetype, Diag_condition_item_name */
#include "slave.h"
#include "lex_symbol.h"
#include "item_create.h"
#include "sp_head.h"
#include "sp_rcontext.h"
#include "sp.h"
#include "sql_show.h"
#include "sql_alter.h"                         // Sql_cmd_alter_table*
#include "sql_truncate.h"                      // Sql_cmd_truncate_table
#include "sql_admin.h"                         // Sql_cmd_analyze/Check..._table
#include "sql_partition_admin.h"               // Sql_cmd_alter_table_*_part.
#include "sql_handler.h"                       // Sql_cmd_handler_*
#include "sql_signal.h"
#include "sql_get_diagnostics.h"               // Sql_cmd_get_diagnostics
#include "sql_cte.h"
#include "sql_window.h"
#include "item_windowfunc.h"
#include "event_parse_data.h"
#include "create_options.h"
#include <myisam.h>
#include <myisammrg.h>
#include "keycaches.h"
#include "set_var.h"
#include "rpl_mi.h"
#include "lex_token.h"
#include "sql_lex.h"
#include "sql_sequence.h"
#include "my_base.h"
#include "sql_type_json.h"

/* this is to get the bison compilation windows warnings out */
#ifdef _MSC_VER
/* warning C4065: switch statement contains 'default' but no 'case' labels */
/* warning C4102: 'yyexhaustedlab': unreferenced label */
#pragma warning (disable : 4065 4102)
#endif
#ifdef __GNUC__
#pragma GCC diagnostic ignored "-Wunused-label" /* yyexhaustedlab: */
#endif

int yylex(void *yylval, void *yythd);

#define yyoverflow(A,B,C,D,E,F)               \
  {                                           \
    size_t val= *(F);                          \
    if (unlikely(my_yyoverflow((B), (D), &val))) \
    {                                         \
      yyerror(thd, (char*) (A));              \
      return 2;                               \
    }                                         \
    else                                      \
    {                                         \
      *(F)= (YYSIZE_T)val;                    \
    }                                         \
  }

#define MYSQL_YYABORT                         \
  do                                          \
  {                                           \
    LEX::cleanup_lex_after_parse_error(thd);  \
    YYABORT;                                  \
  } while (0)

#define MYSQL_YYABORT_UNLESS(A)                  \
  if (unlikely(!(A)))                            \
  {                                              \
    thd->parse_error();                          \
    MYSQL_YYABORT;                               \
  }

#define my_yyabort_error(A)                      \
  do { my_error A; MYSQL_YYABORT; } while(0)

#ifndef DBUG_OFF
#define YYDEBUG 1
#else
#define YYDEBUG 0
#endif


static Item* escape(THD *thd)
{
  thd->lex->escape_used= false;
  const char *esc= thd->variables.sql_mode & MODE_NO_BACKSLASH_ESCAPES ? "" : "\\";
  return new (thd->mem_root) Item_string_ascii(thd, esc, MY_TEST(esc[0]));
}


/**
  @brief Bison callback to report a syntax/OOM error

  This function is invoked by the bison-generated parser
  when a syntax error, a parse error or an out-of-memory
  condition occurs. This function is not invoked when the
  parser is requested to abort by semantic action code
  by means of YYABORT or YYACCEPT macros. This is why these
  macros should not be used (use MYSQL_YYABORT/MYSQL_YYACCEPT
  instead).

  The parser will abort immediately after invoking this callback.

  This function is not for use in semantic actions and is internal to
  the parser, as it performs some pre-return cleanup. 
  In semantic actions, please use thd->parse_error() or my_error to
  push an error into the error stack and MYSQL_YYABORT
  to abort from the parser.
*/

void ORAerror(THD *thd, const char *s)
{
  /*
    Restore the original LEX if it was replaced when parsing
    a stored procedure. We must ensure that a parsing error
    does not leave any side effects in the THD.
  */
  LEX::cleanup_lex_after_parse_error(thd);

  /* "parse error" changed into "syntax error" between bison 1.75 and 1.875 */
  if (strcmp(s,"parse error") == 0 || strcmp(s,"syntax error") == 0)
    s= ER_THD(thd, ER_SYNTAX_ERROR);
  thd->parse_error(s, 0);
}




#define bincmp_collation(X,Y)           \
  do                                    \
  {                                     \
     if (unlikely(Lex->set_bincmp(X,Y))) \
       MYSQL_YYABORT;                   \
  } while(0)


#line 229 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "sql_yacc_ora.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ABORT_SYM = 3,                  /* ABORT_SYM  */
  YYSYMBOL_ACCESSIBLE_SYM = 4,             /* ACCESSIBLE_SYM  */
  YYSYMBOL_ADD = 5,                        /* ADD  */
  YYSYMBOL_ALL = 6,                        /* ALL  */
  YYSYMBOL_ALTER = 7,                      /* ALTER  */
  YYSYMBOL_ANALYZE_SYM = 8,                /* ANALYZE_SYM  */
  YYSYMBOL_AND_AND_SYM = 9,                /* AND_AND_SYM  */
  YYSYMBOL_AND_SYM = 10,                   /* AND_SYM  */
  YYSYMBOL_AS = 11,                        /* AS  */
  YYSYMBOL_ASC = 12,                       /* ASC  */
  YYSYMBOL_ASENSITIVE_SYM = 13,            /* ASENSITIVE_SYM  */
  YYSYMBOL_BEFORE_SYM = 14,                /* BEFORE_SYM  */
  YYSYMBOL_BETWEEN_SYM = 15,               /* BETWEEN_SYM  */
  YYSYMBOL_BIGINT = 16,                    /* BIGINT  */
  YYSYMBOL_BINARY = 17,                    /* BINARY  */
  YYSYMBOL_BIN_NUM = 18,                   /* BIN_NUM  */
  YYSYMBOL_BIT_AND = 19,                   /* BIT_AND  */
  YYSYMBOL_BIT_OR = 20,                    /* BIT_OR  */
  YYSYMBOL_BIT_XOR = 21,                   /* BIT_XOR  */
  YYSYMBOL_BLOB_MARIADB_SYM = 22,          /* BLOB_MARIADB_SYM  */
  YYSYMBOL_BLOB_ORACLE_SYM = 23,           /* BLOB_ORACLE_SYM  */
  YYSYMBOL_BODY_ORACLE_SYM = 24,           /* BODY_ORACLE_SYM  */
  YYSYMBOL_BOTH = 25,                      /* BOTH  */
  YYSYMBOL_BY = 26,                        /* BY  */
  YYSYMBOL_CALL_SYM = 27,                  /* CALL_SYM  */
  YYSYMBOL_CASCADE = 28,                   /* CASCADE  */
  YYSYMBOL_CASE_SYM = 29,                  /* CASE_SYM  */
  YYSYMBOL_CAST_SYM = 30,                  /* CAST_SYM  */
  YYSYMBOL_CHANGE = 31,                    /* CHANGE  */
  YYSYMBOL_CHAR_SYM = 32,                  /* CHAR_SYM  */
  YYSYMBOL_CHECK_SYM = 33,                 /* CHECK_SYM  */
  YYSYMBOL_COLLATE_SYM = 34,               /* COLLATE_SYM  */
  YYSYMBOL_CONDITION_SYM = 35,             /* CONDITION_SYM  */
  YYSYMBOL_CONSTRAINT = 36,                /* CONSTRAINT  */
  YYSYMBOL_CONTINUE_MARIADB_SYM = 37,      /* CONTINUE_MARIADB_SYM  */
  YYSYMBOL_CONTINUE_ORACLE_SYM = 38,       /* CONTINUE_ORACLE_SYM  */
  YYSYMBOL_CONVERT_SYM = 39,               /* CONVERT_SYM  */
  YYSYMBOL_COUNT_SYM = 40,                 /* COUNT_SYM  */
  YYSYMBOL_CREATE = 41,                    /* CREATE  */
  YYSYMBOL_CROSS = 42,                     /* CROSS  */
  YYSYMBOL_CUME_DIST_SYM = 43,             /* CUME_DIST_SYM  */
  YYSYMBOL_CURDATE = 44,                   /* CURDATE  */
  YYSYMBOL_CURRENT_USER = 45,              /* CURRENT_USER  */
  YYSYMBOL_CURRENT_ROLE = 46,              /* CURRENT_ROLE  */
  YYSYMBOL_CURSOR_SYM = 47,                /* CURSOR_SYM  */
  YYSYMBOL_CURTIME = 48,                   /* CURTIME  */
  YYSYMBOL_DATABASE = 49,                  /* DATABASE  */
  YYSYMBOL_DATABASES = 50,                 /* DATABASES  */
  YYSYMBOL_DATE_ADD_INTERVAL = 51,         /* DATE_ADD_INTERVAL  */
  YYSYMBOL_DATE_SUB_INTERVAL = 52,         /* DATE_SUB_INTERVAL  */
  YYSYMBOL_DAY_HOUR_SYM = 53,              /* DAY_HOUR_SYM  */
  YYSYMBOL_DAY_MICROSECOND_SYM = 54,       /* DAY_MICROSECOND_SYM  */
  YYSYMBOL_DAY_MINUTE_SYM = 55,            /* DAY_MINUTE_SYM  */
  YYSYMBOL_DAY_SECOND_SYM = 56,            /* DAY_SECOND_SYM  */
  YYSYMBOL_DECIMAL_NUM = 57,               /* DECIMAL_NUM  */
  YYSYMBOL_DECIMAL_SYM = 58,               /* DECIMAL_SYM  */
  YYSYMBOL_DECLARE_MARIADB_SYM = 59,       /* DECLARE_MARIADB_SYM  */
  YYSYMBOL_DECLARE_ORACLE_SYM = 60,        /* DECLARE_ORACLE_SYM  */
  YYSYMBOL_DEFAULT = 61,                   /* DEFAULT  */
  YYSYMBOL_DELETE_DOMAIN_ID_SYM = 62,      /* DELETE_DOMAIN_ID_SYM  */
  YYSYMBOL_DELETE_SYM = 63,                /* DELETE_SYM  */
  YYSYMBOL_DENSE_RANK_SYM = 64,            /* DENSE_RANK_SYM  */
  YYSYMBOL_DESC = 65,                      /* DESC  */
  YYSYMBOL_DESCRIBE = 66,                  /* DESCRIBE  */
  YYSYMBOL_DETERMINISTIC_SYM = 67,         /* DETERMINISTIC_SYM  */
  YYSYMBOL_DISTINCT = 68,                  /* DISTINCT  */
  YYSYMBOL_DIV_SYM = 69,                   /* DIV_SYM  */
  YYSYMBOL_DOUBLE_SYM = 70,                /* DOUBLE_SYM  */
  YYSYMBOL_DO_DOMAIN_IDS_SYM = 71,         /* DO_DOMAIN_IDS_SYM  */
  YYSYMBOL_DOT_DOT_SYM = 72,               /* DOT_DOT_SYM  */
  YYSYMBOL_DROP = 73,                      /* DROP  */
  YYSYMBOL_DUAL_SYM = 74,                  /* DUAL_SYM  */
  YYSYMBOL_EACH_SYM = 75,                  /* EACH_SYM  */
  YYSYMBOL_ELSE = 76,                      /* ELSE  */
  YYSYMBOL_ELSEIF_MARIADB_SYM = 77,        /* ELSEIF_MARIADB_SYM  */
  YYSYMBOL_ELSIF_ORACLE_SYM = 78,          /* ELSIF_ORACLE_SYM  */
  YYSYMBOL_ENCLOSED = 79,                  /* ENCLOSED  */
  YYSYMBOL_END_OF_INPUT = 80,              /* END_OF_INPUT  */
  YYSYMBOL_EQUAL_SYM = 81,                 /* EQUAL_SYM  */
  YYSYMBOL_ESCAPED = 82,                   /* ESCAPED  */
  YYSYMBOL_EXCEPT_SYM = 83,                /* EXCEPT_SYM  */
  YYSYMBOL_EXISTS = 84,                    /* EXISTS  */
  YYSYMBOL_EXTRACT_SYM = 85,               /* EXTRACT_SYM  */
  YYSYMBOL_FALSE_SYM = 86,                 /* FALSE_SYM  */
  YYSYMBOL_FETCH_SYM = 87,                 /* FETCH_SYM  */
  YYSYMBOL_FIRST_VALUE_SYM = 88,           /* FIRST_VALUE_SYM  */
  YYSYMBOL_FLOAT_NUM = 89,                 /* FLOAT_NUM  */
  YYSYMBOL_FLOAT_SYM = 90,                 /* FLOAT_SYM  */
  YYSYMBOL_FORCE_LOOKAHEAD = 91,           /* FORCE_LOOKAHEAD  */
  YYSYMBOL_FOREIGN = 92,                   /* FOREIGN  */
  YYSYMBOL_FOR_SYM = 93,                   /* FOR_SYM  */
  YYSYMBOL_FOR_SYSTEM_TIME_SYM = 94,       /* FOR_SYSTEM_TIME_SYM  */
  YYSYMBOL_FROM = 95,                      /* FROM  */
  YYSYMBOL_FULLTEXT_SYM = 96,              /* FULLTEXT_SYM  */
  YYSYMBOL_GE = 97,                        /* GE  */
  YYSYMBOL_GOTO_ORACLE_SYM = 98,           /* GOTO_ORACLE_SYM  */
  YYSYMBOL_GRANT = 99,                     /* GRANT  */
  YYSYMBOL_GROUP_SYM = 100,                /* GROUP_SYM  */
  YYSYMBOL_GROUP_CONCAT_SYM = 101,         /* GROUP_CONCAT_SYM  */
  YYSYMBOL_LAG_SYM = 102,                  /* LAG_SYM  */
  YYSYMBOL_LEAD_SYM = 103,                 /* LEAD_SYM  */
  YYSYMBOL_HAVING = 104,                   /* HAVING  */
  YYSYMBOL_HEX_NUM = 105,                  /* HEX_NUM  */
  YYSYMBOL_HEX_STRING = 106,               /* HEX_STRING  */
  YYSYMBOL_HOUR_MICROSECOND_SYM = 107,     /* HOUR_MICROSECOND_SYM  */
  YYSYMBOL_HOUR_MINUTE_SYM = 108,          /* HOUR_MINUTE_SYM  */
  YYSYMBOL_HOUR_SECOND_SYM = 109,          /* HOUR_SECOND_SYM  */
  YYSYMBOL_IDENT = 110,                    /* IDENT  */
  YYSYMBOL_IDENT_QUOTED = 111,             /* IDENT_QUOTED  */
  YYSYMBOL_IF_SYM = 112,                   /* IF_SYM  */
  YYSYMBOL_IGNORE_DOMAIN_IDS_SYM = 113,    /* IGNORE_DOMAIN_IDS_SYM  */
  YYSYMBOL_IGNORE_SYM = 114,               /* IGNORE_SYM  */
  YYSYMBOL_INDEX_SYM = 115,                /* INDEX_SYM  */
  YYSYMBOL_INFILE = 116,                   /* INFILE  */
  YYSYMBOL_INNER_SYM = 117,                /* INNER_SYM  */
  YYSYMBOL_INOUT_SYM = 118,                /* INOUT_SYM  */
  YYSYMBOL_INSENSITIVE_SYM = 119,          /* INSENSITIVE_SYM  */
  YYSYMBOL_INSERT = 120,                   /* INSERT  */
  YYSYMBOL_INTERSECT_SYM = 121,            /* INTERSECT_SYM  */
  YYSYMBOL_INTERVAL_SYM = 122,             /* INTERVAL_SYM  */
  YYSYMBOL_INTO = 123,                     /* INTO  */
  YYSYMBOL_INT_SYM = 124,                  /* INT_SYM  */
  YYSYMBOL_IN_SYM = 125,                   /* IN_SYM  */
  YYSYMBOL_IS = 126,                       /* IS  */
  YYSYMBOL_ITERATE_SYM = 127,              /* ITERATE_SYM  */
  YYSYMBOL_JOIN_SYM = 128,                 /* JOIN_SYM  */
  YYSYMBOL_KEYS = 129,                     /* KEYS  */
  YYSYMBOL_KEY_SYM = 130,                  /* KEY_SYM  */
  YYSYMBOL_KILL_SYM = 131,                 /* KILL_SYM  */
  YYSYMBOL_LE = 132,                       /* LE  */
  YYSYMBOL_LEADING = 133,                  /* LEADING  */
  YYSYMBOL_LEAVE_SYM = 134,                /* LEAVE_SYM  */
  YYSYMBOL_LEFT = 135,                     /* LEFT  */
  YYSYMBOL_LEFT_PAREN_ALT = 136,           /* LEFT_PAREN_ALT  */
  YYSYMBOL_LEFT_PAREN_WITH = 137,          /* LEFT_PAREN_WITH  */
  YYSYMBOL_LEFT_PAREN_LIKE = 138,          /* LEFT_PAREN_LIKE  */
  YYSYMBOL_LEX_HOSTNAME = 139,             /* LEX_HOSTNAME  */
  YYSYMBOL_LIKE = 140,                     /* LIKE  */
  YYSYMBOL_LIMIT = 141,                    /* LIMIT  */
  YYSYMBOL_LINEAR_SYM = 142,               /* LINEAR_SYM  */
  YYSYMBOL_LINES = 143,                    /* LINES  */
  YYSYMBOL_LOAD = 144,                     /* LOAD  */
  YYSYMBOL_LOCATOR_SYM = 145,              /* LOCATOR_SYM  */
  YYSYMBOL_LOCK_SYM = 146,                 /* LOCK_SYM  */
  YYSYMBOL_LONGBLOB = 147,                 /* LONGBLOB  */
  YYSYMBOL_LONGTEXT = 148,                 /* LONGTEXT  */
  YYSYMBOL_LONG_NUM = 149,                 /* LONG_NUM  */
  YYSYMBOL_LONG_SYM = 150,                 /* LONG_SYM  */
  YYSYMBOL_LOOP_SYM = 151,                 /* LOOP_SYM  */
  YYSYMBOL_LOW_PRIORITY = 152,             /* LOW_PRIORITY  */
  YYSYMBOL_MASTER_SSL_VERIFY_SERVER_CERT_SYM = 153, /* MASTER_SSL_VERIFY_SERVER_CERT_SYM  */
  YYSYMBOL_MATCH = 154,                    /* MATCH  */
  YYSYMBOL_MAX_SYM = 155,                  /* MAX_SYM  */
  YYSYMBOL_MAXVALUE_SYM = 156,             /* MAXVALUE_SYM  */
  YYSYMBOL_MEDIAN_SYM = 157,               /* MEDIAN_SYM  */
  YYSYMBOL_MEDIUMBLOB = 158,               /* MEDIUMBLOB  */
  YYSYMBOL_MEDIUMINT = 159,                /* MEDIUMINT  */
  YYSYMBOL_MEDIUMTEXT = 160,               /* MEDIUMTEXT  */
  YYSYMBOL_MINUTE_MICROSECOND_SYM = 161,   /* MINUTE_MICROSECOND_SYM  */
  YYSYMBOL_MINUTE_SECOND_SYM = 162,        /* MINUTE_SECOND_SYM  */
  YYSYMBOL_MIN_SYM = 163,                  /* MIN_SYM  */
  YYSYMBOL_MODIFIES_SYM = 164,             /* MODIFIES_SYM  */
  YYSYMBOL_MOD_SYM = 165,                  /* MOD_SYM  */
  YYSYMBOL_MYSQL_CONCAT_SYM = 166,         /* MYSQL_CONCAT_SYM  */
  YYSYMBOL_NATURAL = 167,                  /* NATURAL  */
  YYSYMBOL_NCHAR_STRING = 168,             /* NCHAR_STRING  */
  YYSYMBOL_NE = 169,                       /* NE  */
  YYSYMBOL_NEG = 170,                      /* NEG  */
  YYSYMBOL_NOT2_SYM = 171,                 /* NOT2_SYM  */
  YYSYMBOL_NOT_SYM = 172,                  /* NOT_SYM  */
  YYSYMBOL_NOW_SYM = 173,                  /* NOW_SYM  */
  YYSYMBOL_NO_WRITE_TO_BINLOG = 174,       /* NO_WRITE_TO_BINLOG  */
  YYSYMBOL_NTILE_SYM = 175,                /* NTILE_SYM  */
  YYSYMBOL_NULL_SYM = 176,                 /* NULL_SYM  */
  YYSYMBOL_NUM = 177,                      /* NUM  */
  YYSYMBOL_NUMERIC_SYM = 178,              /* NUMERIC_SYM  */
  YYSYMBOL_NTH_VALUE_SYM = 179,            /* NTH_VALUE_SYM  */
  YYSYMBOL_ON = 180,                       /* ON  */
  YYSYMBOL_OPTIMIZE = 181,                 /* OPTIMIZE  */
  YYSYMBOL_OPTIONALLY = 182,               /* OPTIONALLY  */
  YYSYMBOL_ORACLE_CONCAT_SYM = 183,        /* ORACLE_CONCAT_SYM  */
  YYSYMBOL_OR2_SYM = 184,                  /* OR2_SYM  */
  YYSYMBOL_ORDER_SYM = 185,                /* ORDER_SYM  */
  YYSYMBOL_OR_SYM = 186,                   /* OR_SYM  */
  YYSYMBOL_OTHERS_ORACLE_SYM = 187,        /* OTHERS_ORACLE_SYM  */
  YYSYMBOL_OUTER = 188,                    /* OUTER  */
  YYSYMBOL_OUTFILE = 189,                  /* OUTFILE  */
  YYSYMBOL_OUT_SYM = 190,                  /* OUT_SYM  */
  YYSYMBOL_OVER_SYM = 191,                 /* OVER_SYM  */
  YYSYMBOL_PACKAGE_ORACLE_SYM = 192,       /* PACKAGE_ORACLE_SYM  */
  YYSYMBOL_PAGE_CHECKSUM_SYM = 193,        /* PAGE_CHECKSUM_SYM  */
  YYSYMBOL_PARAM_MARKER = 194,             /* PARAM_MARKER  */
  YYSYMBOL_PARSE_VCOL_EXPR_SYM = 195,      /* PARSE_VCOL_EXPR_SYM  */
  YYSYMBOL_PARTITION_SYM = 196,            /* PARTITION_SYM  */
  YYSYMBOL_PERCENT_ORACLE_SYM = 197,       /* PERCENT_ORACLE_SYM  */
  YYSYMBOL_PERCENT_RANK_SYM = 198,         /* PERCENT_RANK_SYM  */
  YYSYMBOL_PERCENTILE_CONT_SYM = 199,      /* PERCENTILE_CONT_SYM  */
  YYSYMBOL_PERCENTILE_DISC_SYM = 200,      /* PERCENTILE_DISC_SYM  */
  YYSYMBOL_PORTION_SYM = 201,              /* PORTION_SYM  */
  YYSYMBOL_POSITION_SYM = 202,             /* POSITION_SYM  */
  YYSYMBOL_PRECISION = 203,                /* PRECISION  */
  YYSYMBOL_PRIMARY_SYM = 204,              /* PRIMARY_SYM  */
  YYSYMBOL_PROCEDURE_SYM = 205,            /* PROCEDURE_SYM  */
  YYSYMBOL_PURGE = 206,                    /* PURGE  */
  YYSYMBOL_RAISE_ORACLE_SYM = 207,         /* RAISE_ORACLE_SYM  */
  YYSYMBOL_RANGE_SYM = 208,                /* RANGE_SYM  */
  YYSYMBOL_RANK_SYM = 209,                 /* RANK_SYM  */
  YYSYMBOL_READS_SYM = 210,                /* READS_SYM  */
  YYSYMBOL_READ_SYM = 211,                 /* READ_SYM  */
  YYSYMBOL_READ_WRITE_SYM = 212,           /* READ_WRITE_SYM  */
  YYSYMBOL_REAL = 213,                     /* REAL  */
  YYSYMBOL_RECURSIVE_SYM = 214,            /* RECURSIVE_SYM  */
  YYSYMBOL_REF_SYSTEM_ID_SYM = 215,        /* REF_SYSTEM_ID_SYM  */
  YYSYMBOL_REFERENCES = 216,               /* REFERENCES  */
  YYSYMBOL_REGEXP = 217,                   /* REGEXP  */
  YYSYMBOL_RELEASE_SYM = 218,              /* RELEASE_SYM  */
  YYSYMBOL_RENAME = 219,                   /* RENAME  */
  YYSYMBOL_REPEAT_SYM = 220,               /* REPEAT_SYM  */
  YYSYMBOL_REQUIRE_SYM = 221,              /* REQUIRE_SYM  */
  YYSYMBOL_RESIGNAL_SYM = 222,             /* RESIGNAL_SYM  */
  YYSYMBOL_RESTRICT = 223,                 /* RESTRICT  */
  YYSYMBOL_RETURNING_SYM = 224,            /* RETURNING_SYM  */
  YYSYMBOL_RETURN_MARIADB_SYM = 225,       /* RETURN_MARIADB_SYM  */
  YYSYMBOL_RETURN_ORACLE_SYM = 226,        /* RETURN_ORACLE_SYM  */
  YYSYMBOL_REVOKE = 227,                   /* REVOKE  */
  YYSYMBOL_RIGHT = 228,                    /* RIGHT  */
  YYSYMBOL_ROWS_SYM = 229,                 /* ROWS_SYM  */
  YYSYMBOL_ROWTYPE_ORACLE_SYM = 230,       /* ROWTYPE_ORACLE_SYM  */
  YYSYMBOL_ROW_NUMBER_SYM = 231,           /* ROW_NUMBER_SYM  */
  YYSYMBOL_SECOND_MICROSECOND_SYM = 232,   /* SECOND_MICROSECOND_SYM  */
  YYSYMBOL_SELECT_SYM = 233,               /* SELECT_SYM  */
  YYSYMBOL_SENSITIVE_SYM = 234,            /* SENSITIVE_SYM  */
  YYSYMBOL_SEPARATOR_SYM = 235,            /* SEPARATOR_SYM  */
  YYSYMBOL_SERVER_OPTIONS = 236,           /* SERVER_OPTIONS  */
  YYSYMBOL_SET = 237,                      /* SET  */
  YYSYMBOL_SET_VAR = 238,                  /* SET_VAR  */
  YYSYMBOL_SHIFT_LEFT = 239,               /* SHIFT_LEFT  */
  YYSYMBOL_SHIFT_RIGHT = 240,              /* SHIFT_RIGHT  */
  YYSYMBOL_SHOW = 241,                     /* SHOW  */
  YYSYMBOL_SIGNAL_SYM = 242,               /* SIGNAL_SYM  */
  YYSYMBOL_SMALLINT = 243,                 /* SMALLINT  */
  YYSYMBOL_SPATIAL_SYM = 244,              /* SPATIAL_SYM  */
  YYSYMBOL_SPECIFIC_SYM = 245,             /* SPECIFIC_SYM  */
  YYSYMBOL_SQLEXCEPTION_SYM = 246,         /* SQLEXCEPTION_SYM  */
  YYSYMBOL_SQLSTATE_SYM = 247,             /* SQLSTATE_SYM  */
  YYSYMBOL_SQLWARNING_SYM = 248,           /* SQLWARNING_SYM  */
  YYSYMBOL_SQL_BIG_RESULT = 249,           /* SQL_BIG_RESULT  */
  YYSYMBOL_SQL_SMALL_RESULT = 250,         /* SQL_SMALL_RESULT  */
  YYSYMBOL_SQL_SYM = 251,                  /* SQL_SYM  */
  YYSYMBOL_SSL_SYM = 252,                  /* SSL_SYM  */
  YYSYMBOL_STARTING = 253,                 /* STARTING  */
  YYSYMBOL_STATS_AUTO_RECALC_SYM = 254,    /* STATS_AUTO_RECALC_SYM  */
  YYSYMBOL_STATS_PERSISTENT_SYM = 255,     /* STATS_PERSISTENT_SYM  */
  YYSYMBOL_STATS_SAMPLE_PAGES_SYM = 256,   /* STATS_SAMPLE_PAGES_SYM  */
  YYSYMBOL_STDDEV_SAMP_SYM = 257,          /* STDDEV_SAMP_SYM  */
  YYSYMBOL_STD_SYM = 258,                  /* STD_SYM  */
  YYSYMBOL_STRAIGHT_JOIN = 259,            /* STRAIGHT_JOIN  */
  YYSYMBOL_SUM_SYM = 260,                  /* SUM_SYM  */
  YYSYMBOL_SYSDATE = 261,                  /* SYSDATE  */
  YYSYMBOL_TABLE_REF_PRIORITY = 262,       /* TABLE_REF_PRIORITY  */
  YYSYMBOL_TABLE_SYM = 263,                /* TABLE_SYM  */
  YYSYMBOL_TERMINATED = 264,               /* TERMINATED  */
  YYSYMBOL_TEXT_STRING = 265,              /* TEXT_STRING  */
  YYSYMBOL_THEN_SYM = 266,                 /* THEN_SYM  */
  YYSYMBOL_TINYBLOB = 267,                 /* TINYBLOB  */
  YYSYMBOL_TINYINT = 268,                  /* TINYINT  */
  YYSYMBOL_TINYTEXT = 269,                 /* TINYTEXT  */
  YYSYMBOL_TO_SYM = 270,                   /* TO_SYM  */
  YYSYMBOL_TRAILING = 271,                 /* TRAILING  */
  YYSYMBOL_TRIGGER_SYM = 272,              /* TRIGGER_SYM  */
  YYSYMBOL_TRUE_SYM = 273,                 /* TRUE_SYM  */
  YYSYMBOL_ULONGLONG_NUM = 274,            /* ULONGLONG_NUM  */
  YYSYMBOL_UNDERSCORE_CHARSET = 275,       /* UNDERSCORE_CHARSET  */
  YYSYMBOL_UNDO_SYM = 276,                 /* UNDO_SYM  */
  YYSYMBOL_UNION_SYM = 277,                /* UNION_SYM  */
  YYSYMBOL_UNIQUE_SYM = 278,               /* UNIQUE_SYM  */
  YYSYMBOL_UNLOCK_SYM = 279,               /* UNLOCK_SYM  */
  YYSYMBOL_UNSIGNED = 280,                 /* UNSIGNED  */
  YYSYMBOL_UPDATE_SYM = 281,               /* UPDATE_SYM  */
  YYSYMBOL_USAGE = 282,                    /* USAGE  */
  YYSYMBOL_USE_SYM = 283,                  /* USE_SYM  */
  YYSYMBOL_USING = 284,                    /* USING  */
  YYSYMBOL_UTC_DATE_SYM = 285,             /* UTC_DATE_SYM  */
  YYSYMBOL_UTC_TIMESTAMP_SYM = 286,        /* UTC_TIMESTAMP_SYM  */
  YYSYMBOL_UTC_TIME_SYM = 287,             /* UTC_TIME_SYM  */
  YYSYMBOL_VALUES = 288,                   /* VALUES  */
  YYSYMBOL_VALUES_IN_SYM = 289,            /* VALUES_IN_SYM  */
  YYSYMBOL_VALUES_LESS_SYM = 290,          /* VALUES_LESS_SYM  */
  YYSYMBOL_VARBINARY = 291,                /* VARBINARY  */
  YYSYMBOL_VARCHAR = 292,                  /* VARCHAR  */
  YYSYMBOL_VARIANCE_SYM = 293,             /* VARIANCE_SYM  */
  YYSYMBOL_VARYING = 294,                  /* VARYING  */
  YYSYMBOL_VAR_SAMP_SYM = 295,             /* VAR_SAMP_SYM  */
  YYSYMBOL_WHEN_SYM = 296,                 /* WHEN_SYM  */
  YYSYMBOL_WHERE = 297,                    /* WHERE  */
  YYSYMBOL_WHILE_SYM = 298,                /* WHILE_SYM  */
  YYSYMBOL_WITH = 299,                     /* WITH  */
  YYSYMBOL_WITH_CUBE_SYM = 300,            /* WITH_CUBE_SYM  */
  YYSYMBOL_WITH_ROLLUP_SYM = 301,          /* WITH_ROLLUP_SYM  */
  YYSYMBOL_WITH_SYSTEM_SYM = 302,          /* WITH_SYSTEM_SYM  */
  YYSYMBOL_XOR = 303,                      /* XOR  */
  YYSYMBOL_YEAR_MONTH_SYM = 304,           /* YEAR_MONTH_SYM  */
  YYSYMBOL_ZEROFILL = 305,                 /* ZEROFILL  */
  YYSYMBOL_IMPOSSIBLE_ACTION = 306,        /* IMPOSSIBLE_ACTION  */
  YYSYMBOL_BODY_MARIADB_SYM = 307,         /* BODY_MARIADB_SYM  */
  YYSYMBOL_ELSEIF_ORACLE_SYM = 308,        /* ELSEIF_ORACLE_SYM  */
  YYSYMBOL_ELSIF_MARIADB_SYM = 309,        /* ELSIF_MARIADB_SYM  */
  YYSYMBOL_EXCEPTION_ORACLE_SYM = 310,     /* EXCEPTION_ORACLE_SYM  */
  YYSYMBOL_GOTO_MARIADB_SYM = 311,         /* GOTO_MARIADB_SYM  */
  YYSYMBOL_OTHERS_MARIADB_SYM = 312,       /* OTHERS_MARIADB_SYM  */
  YYSYMBOL_PACKAGE_MARIADB_SYM = 313,      /* PACKAGE_MARIADB_SYM  */
  YYSYMBOL_RAISE_MARIADB_SYM = 314,        /* RAISE_MARIADB_SYM  */
  YYSYMBOL_ROWTYPE_MARIADB_SYM = 315,      /* ROWTYPE_MARIADB_SYM  */
  YYSYMBOL_REPLACE = 316,                  /* REPLACE  */
  YYSYMBOL_SUBSTRING = 317,                /* SUBSTRING  */
  YYSYMBOL_TRIM = 318,                     /* TRIM  */
  YYSYMBOL_ACCOUNT_SYM = 319,              /* ACCOUNT_SYM  */
  YYSYMBOL_ACTION = 320,                   /* ACTION  */
  YYSYMBOL_ADMIN_SYM = 321,                /* ADMIN_SYM  */
  YYSYMBOL_ADDDATE_SYM = 322,              /* ADDDATE_SYM  */
  YYSYMBOL_AFTER_SYM = 323,                /* AFTER_SYM  */
  YYSYMBOL_AGAINST = 324,                  /* AGAINST  */
  YYSYMBOL_AGGREGATE_SYM = 325,            /* AGGREGATE_SYM  */
  YYSYMBOL_ALGORITHM_SYM = 326,            /* ALGORITHM_SYM  */
  YYSYMBOL_ALWAYS_SYM = 327,               /* ALWAYS_SYM  */
  YYSYMBOL_ANY_SYM = 328,                  /* ANY_SYM  */
  YYSYMBOL_ASCII_SYM = 329,                /* ASCII_SYM  */
  YYSYMBOL_AT_SYM = 330,                   /* AT_SYM  */
  YYSYMBOL_ATOMIC_SYM = 331,               /* ATOMIC_SYM  */
  YYSYMBOL_AUTHORS_SYM = 332,              /* AUTHORS_SYM  */
  YYSYMBOL_AUTOEXTEND_SIZE_SYM = 333,      /* AUTOEXTEND_SIZE_SYM  */
  YYSYMBOL_AUTO_INC = 334,                 /* AUTO_INC  */
  YYSYMBOL_AUTO_SYM = 335,                 /* AUTO_SYM  */
  YYSYMBOL_AVG_ROW_LENGTH = 336,           /* AVG_ROW_LENGTH  */
  YYSYMBOL_AVG_SYM = 337,                  /* AVG_SYM  */
  YYSYMBOL_BACKUP_SYM = 338,               /* BACKUP_SYM  */
  YYSYMBOL_BEGIN_MARIADB_SYM = 339,        /* BEGIN_MARIADB_SYM  */
  YYSYMBOL_BEGIN_ORACLE_SYM = 340,         /* BEGIN_ORACLE_SYM  */
  YYSYMBOL_BINLOG_SYM = 341,               /* BINLOG_SYM  */
  YYSYMBOL_BIT_SYM = 342,                  /* BIT_SYM  */
  YYSYMBOL_BLOCK_SYM = 343,                /* BLOCK_SYM  */
  YYSYMBOL_BOOL_SYM = 344,                 /* BOOL_SYM  */
  YYSYMBOL_BOOLEAN_SYM = 345,              /* BOOLEAN_SYM  */
  YYSYMBOL_BTREE_SYM = 346,                /* BTREE_SYM  */
  YYSYMBOL_BYTE_SYM = 347,                 /* BYTE_SYM  */
  YYSYMBOL_CACHE_SYM = 348,                /* CACHE_SYM  */
  YYSYMBOL_CASCADED = 349,                 /* CASCADED  */
  YYSYMBOL_CATALOG_NAME_SYM = 350,         /* CATALOG_NAME_SYM  */
  YYSYMBOL_CHAIN_SYM = 351,                /* CHAIN_SYM  */
  YYSYMBOL_CHANGED = 352,                  /* CHANGED  */
  YYSYMBOL_CHARSET = 353,                  /* CHARSET  */
  YYSYMBOL_CHECKPOINT_SYM = 354,           /* CHECKPOINT_SYM  */
  YYSYMBOL_CHECKSUM_SYM = 355,             /* CHECKSUM_SYM  */
  YYSYMBOL_CIPHER_SYM = 356,               /* CIPHER_SYM  */
  YYSYMBOL_CLASS_ORIGIN_SYM = 357,         /* CLASS_ORIGIN_SYM  */
  YYSYMBOL_CLIENT_SYM = 358,               /* CLIENT_SYM  */
  YYSYMBOL_CLOB_MARIADB_SYM = 359,         /* CLOB_MARIADB_SYM  */
  YYSYMBOL_CLOB_ORACLE_SYM = 360,          /* CLOB_ORACLE_SYM  */
  YYSYMBOL_CLOSE_SYM = 361,                /* CLOSE_SYM  */
  YYSYMBOL_COALESCE = 362,                 /* COALESCE  */
  YYSYMBOL_CODE_SYM = 363,                 /* CODE_SYM  */
  YYSYMBOL_COLLATION_SYM = 364,            /* COLLATION_SYM  */
  YYSYMBOL_COLON_ORACLE_SYM = 365,         /* COLON_ORACLE_SYM  */
  YYSYMBOL_COLUMNS = 366,                  /* COLUMNS  */
  YYSYMBOL_COLUMN_ADD_SYM = 367,           /* COLUMN_ADD_SYM  */
  YYSYMBOL_COLUMN_CHECK_SYM = 368,         /* COLUMN_CHECK_SYM  */
  YYSYMBOL_COLUMN_CREATE_SYM = 369,        /* COLUMN_CREATE_SYM  */
  YYSYMBOL_COLUMN_DELETE_SYM = 370,        /* COLUMN_DELETE_SYM  */
  YYSYMBOL_COLUMN_GET_SYM = 371,           /* COLUMN_GET_SYM  */
  YYSYMBOL_COLUMN_SYM = 372,               /* COLUMN_SYM  */
  YYSYMBOL_COLUMN_NAME_SYM = 373,          /* COLUMN_NAME_SYM  */
  YYSYMBOL_COMMENT_SYM = 374,              /* COMMENT_SYM  */
  YYSYMBOL_COMMITTED_SYM = 375,            /* COMMITTED_SYM  */
  YYSYMBOL_COMMIT_SYM = 376,               /* COMMIT_SYM  */
  YYSYMBOL_COMPACT_SYM = 377,              /* COMPACT_SYM  */
  YYSYMBOL_COMPLETION_SYM = 378,           /* COMPLETION_SYM  */
  YYSYMBOL_COMPRESSED_SYM = 379,           /* COMPRESSED_SYM  */
  YYSYMBOL_CONCURRENT = 380,               /* CONCURRENT  */
  YYSYMBOL_CONNECTION_SYM = 381,           /* CONNECTION_SYM  */
  YYSYMBOL_CONSISTENT_SYM = 382,           /* CONSISTENT_SYM  */
  YYSYMBOL_CONSTRAINT_CATALOG_SYM = 383,   /* CONSTRAINT_CATALOG_SYM  */
  YYSYMBOL_CONSTRAINT_NAME_SYM = 384,      /* CONSTRAINT_NAME_SYM  */
  YYSYMBOL_CONSTRAINT_SCHEMA_SYM = 385,    /* CONSTRAINT_SCHEMA_SYM  */
  YYSYMBOL_CONTAINS_SYM = 386,             /* CONTAINS_SYM  */
  YYSYMBOL_CONTEXT_SYM = 387,              /* CONTEXT_SYM  */
  YYSYMBOL_CONTRIBUTORS_SYM = 388,         /* CONTRIBUTORS_SYM  */
  YYSYMBOL_CPU_SYM = 389,                  /* CPU_SYM  */
  YYSYMBOL_CUBE_SYM = 390,                 /* CUBE_SYM  */
  YYSYMBOL_CURRENT_SYM = 391,              /* CURRENT_SYM  */
  YYSYMBOL_CURRENT_POS_SYM = 392,          /* CURRENT_POS_SYM  */
  YYSYMBOL_CURSOR_NAME_SYM = 393,          /* CURSOR_NAME_SYM  */
  YYSYMBOL_CYCLE_SYM = 394,                /* CYCLE_SYM  */
  YYSYMBOL_DATAFILE_SYM = 395,             /* DATAFILE_SYM  */
  YYSYMBOL_DATA_SYM = 396,                 /* DATA_SYM  */
  YYSYMBOL_DATETIME = 397,                 /* DATETIME  */
  YYSYMBOL_DATE_FORMAT_SYM = 398,          /* DATE_FORMAT_SYM  */
  YYSYMBOL_DATE_SYM = 399,                 /* DATE_SYM  */
  YYSYMBOL_DAY_SYM = 400,                  /* DAY_SYM  */
  YYSYMBOL_DEALLOCATE_SYM = 401,           /* DEALLOCATE_SYM  */
  YYSYMBOL_DEFINER_SYM = 402,              /* DEFINER_SYM  */
  YYSYMBOL_DELAYED_SYM = 403,              /* DELAYED_SYM  */
  YYSYMBOL_DELAY_KEY_WRITE_SYM = 404,      /* DELAY_KEY_WRITE_SYM  */
  YYSYMBOL_DES_KEY_FILE = 405,             /* DES_KEY_FILE  */
  YYSYMBOL_DIAGNOSTICS_SYM = 406,          /* DIAGNOSTICS_SYM  */
  YYSYMBOL_DIRECTORY_SYM = 407,            /* DIRECTORY_SYM  */
  YYSYMBOL_DISABLE_SYM = 408,              /* DISABLE_SYM  */
  YYSYMBOL_DISCARD = 409,                  /* DISCARD  */
  YYSYMBOL_DISK_SYM = 410,                 /* DISK_SYM  */
  YYSYMBOL_DO_SYM = 411,                   /* DO_SYM  */
  YYSYMBOL_DUMPFILE = 412,                 /* DUMPFILE  */
  YYSYMBOL_DUPLICATE_SYM = 413,            /* DUPLICATE_SYM  */
  YYSYMBOL_DYNAMIC_SYM = 414,              /* DYNAMIC_SYM  */
  YYSYMBOL_ENABLE_SYM = 415,               /* ENABLE_SYM  */
  YYSYMBOL_END = 416,                      /* END  */
  YYSYMBOL_ENDS_SYM = 417,                 /* ENDS_SYM  */
  YYSYMBOL_ENGINES_SYM = 418,              /* ENGINES_SYM  */
  YYSYMBOL_ENGINE_SYM = 419,               /* ENGINE_SYM  */
  YYSYMBOL_ENUM = 420,                     /* ENUM  */
  YYSYMBOL_ERROR_SYM = 421,                /* ERROR_SYM  */
  YYSYMBOL_ERRORS = 422,                   /* ERRORS  */
  YYSYMBOL_ESCAPE_SYM = 423,               /* ESCAPE_SYM  */
  YYSYMBOL_EVENTS_SYM = 424,               /* EVENTS_SYM  */
  YYSYMBOL_EVENT_SYM = 425,                /* EVENT_SYM  */
  YYSYMBOL_EVERY_SYM = 426,                /* EVERY_SYM  */
  YYSYMBOL_EXCHANGE_SYM = 427,             /* EXCHANGE_SYM  */
  YYSYMBOL_EXAMINED_SYM = 428,             /* EXAMINED_SYM  */
  YYSYMBOL_EXCLUDE_SYM = 429,              /* EXCLUDE_SYM  */
  YYSYMBOL_EXECUTE_SYM = 430,              /* EXECUTE_SYM  */
  YYSYMBOL_EXCEPTION_MARIADB_SYM = 431,    /* EXCEPTION_MARIADB_SYM  */
  YYSYMBOL_EXIT_MARIADB_SYM = 432,         /* EXIT_MARIADB_SYM  */
  YYSYMBOL_EXIT_ORACLE_SYM = 433,          /* EXIT_ORACLE_SYM  */
  YYSYMBOL_EXPANSION_SYM = 434,            /* EXPANSION_SYM  */
  YYSYMBOL_EXPIRE_SYM = 435,               /* EXPIRE_SYM  */
  YYSYMBOL_EXPORT_SYM = 436,               /* EXPORT_SYM  */
  YYSYMBOL_EXTENDED_SYM = 437,             /* EXTENDED_SYM  */
  YYSYMBOL_EXTENT_SIZE_SYM = 438,          /* EXTENT_SIZE_SYM  */
  YYSYMBOL_FAST_SYM = 439,                 /* FAST_SYM  */
  YYSYMBOL_FAULTS_SYM = 440,               /* FAULTS_SYM  */
  YYSYMBOL_FILE_SYM = 441,                 /* FILE_SYM  */
  YYSYMBOL_FIRST_SYM = 442,                /* FIRST_SYM  */
  YYSYMBOL_FIXED_SYM = 443,                /* FIXED_SYM  */
  YYSYMBOL_FLUSH_SYM = 444,                /* FLUSH_SYM  */
  YYSYMBOL_FOLLOWS_SYM = 445,              /* FOLLOWS_SYM  */
  YYSYMBOL_FOLLOWING_SYM = 446,            /* FOLLOWING_SYM  */
  YYSYMBOL_FORCE_SYM = 447,                /* FORCE_SYM  */
  YYSYMBOL_FORMAT_SYM = 448,               /* FORMAT_SYM  */
  YYSYMBOL_FOUND_SYM = 449,                /* FOUND_SYM  */
  YYSYMBOL_FULL = 450,                     /* FULL  */
  YYSYMBOL_FUNCTION_SYM = 451,             /* FUNCTION_SYM  */
  YYSYMBOL_GENERAL = 452,                  /* GENERAL  */
  YYSYMBOL_GENERATED_SYM = 453,            /* GENERATED_SYM  */
  YYSYMBOL_GEOMETRYCOLLECTION = 454,       /* GEOMETRYCOLLECTION  */
  YYSYMBOL_GEOMETRY_SYM = 455,             /* GEOMETRY_SYM  */
  YYSYMBOL_GET_FORMAT = 456,               /* GET_FORMAT  */
  YYSYMBOL_GET_SYM = 457,                  /* GET_SYM  */
  YYSYMBOL_GLOBAL_SYM = 458,               /* GLOBAL_SYM  */
  YYSYMBOL_GRANTS = 459,                   /* GRANTS  */
  YYSYMBOL_HANDLER_SYM = 460,              /* HANDLER_SYM  */
  YYSYMBOL_HARD_SYM = 461,                 /* HARD_SYM  */
  YYSYMBOL_HASH_SYM = 462,                 /* HASH_SYM  */
  YYSYMBOL_HELP_SYM = 463,                 /* HELP_SYM  */
  YYSYMBOL_HIGH_PRIORITY = 464,            /* HIGH_PRIORITY  */
  YYSYMBOL_HISTORY_SYM = 465,              /* HISTORY_SYM  */
  YYSYMBOL_HOST_SYM = 466,                 /* HOST_SYM  */
  YYSYMBOL_HOSTS_SYM = 467,                /* HOSTS_SYM  */
  YYSYMBOL_HOUR_SYM = 468,                 /* HOUR_SYM  */
  YYSYMBOL_ID_SYM = 469,                   /* ID_SYM  */
  YYSYMBOL_IDENTIFIED_SYM = 470,           /* IDENTIFIED_SYM  */
  YYSYMBOL_IGNORE_SERVER_IDS_SYM = 471,    /* IGNORE_SERVER_IDS_SYM  */
  YYSYMBOL_IMMEDIATE_SYM = 472,            /* IMMEDIATE_SYM  */
  YYSYMBOL_IMPORT = 473,                   /* IMPORT  */
  YYSYMBOL_INCREMENT_SYM = 474,            /* INCREMENT_SYM  */
  YYSYMBOL_INDEXES = 475,                  /* INDEXES  */
  YYSYMBOL_INITIAL_SIZE_SYM = 476,         /* INITIAL_SIZE_SYM  */
  YYSYMBOL_INSERT_METHOD = 477,            /* INSERT_METHOD  */
  YYSYMBOL_INSTALL_SYM = 478,              /* INSTALL_SYM  */
  YYSYMBOL_INVOKER_SYM = 479,              /* INVOKER_SYM  */
  YYSYMBOL_IO_SYM = 480,                   /* IO_SYM  */
  YYSYMBOL_IPC_SYM = 481,                  /* IPC_SYM  */
  YYSYMBOL_ISOLATION = 482,                /* ISOLATION  */
  YYSYMBOL_ISOPEN_SYM = 483,               /* ISOPEN_SYM  */
  YYSYMBOL_ISSUER_SYM = 484,               /* ISSUER_SYM  */
  YYSYMBOL_INVISIBLE_SYM = 485,            /* INVISIBLE_SYM  */
  YYSYMBOL_JSON_SYM = 486,                 /* JSON_SYM  */
  YYSYMBOL_KEY_BLOCK_SIZE = 487,           /* KEY_BLOCK_SIZE  */
  YYSYMBOL_LANGUAGE_SYM = 488,             /* LANGUAGE_SYM  */
  YYSYMBOL_LAST_SYM = 489,                 /* LAST_SYM  */
  YYSYMBOL_LAST_VALUE = 490,               /* LAST_VALUE  */
  YYSYMBOL_LASTVAL_SYM = 491,              /* LASTVAL_SYM  */
  YYSYMBOL_LEAVES = 492,                   /* LEAVES  */
  YYSYMBOL_LESS_SYM = 493,                 /* LESS_SYM  */
  YYSYMBOL_LEVEL_SYM = 494,                /* LEVEL_SYM  */
  YYSYMBOL_LINESTRING = 495,               /* LINESTRING  */
  YYSYMBOL_LIST_SYM = 496,                 /* LIST_SYM  */
  YYSYMBOL_LOCAL_SYM = 497,                /* LOCAL_SYM  */
  YYSYMBOL_LOCKS_SYM = 498,                /* LOCKS_SYM  */
  YYSYMBOL_LOGFILE_SYM = 499,              /* LOGFILE_SYM  */
  YYSYMBOL_LOGS_SYM = 500,                 /* LOGS_SYM  */
  YYSYMBOL_MASTER_CONNECT_RETRY_SYM = 501, /* MASTER_CONNECT_RETRY_SYM  */
  YYSYMBOL_MASTER_DELAY_SYM = 502,         /* MASTER_DELAY_SYM  */
  YYSYMBOL_MASTER_GTID_POS_SYM = 503,      /* MASTER_GTID_POS_SYM  */
  YYSYMBOL_MASTER_HOST_SYM = 504,          /* MASTER_HOST_SYM  */
  YYSYMBOL_MASTER_LOG_FILE_SYM = 505,      /* MASTER_LOG_FILE_SYM  */
  YYSYMBOL_MASTER_LOG_POS_SYM = 506,       /* MASTER_LOG_POS_SYM  */
  YYSYMBOL_MASTER_PASSWORD_SYM = 507,      /* MASTER_PASSWORD_SYM  */
  YYSYMBOL_MASTER_PORT_SYM = 508,          /* MASTER_PORT_SYM  */
  YYSYMBOL_MASTER_SERVER_ID_SYM = 509,     /* MASTER_SERVER_ID_SYM  */
  YYSYMBOL_MASTER_SSL_CAPATH_SYM = 510,    /* MASTER_SSL_CAPATH_SYM  */
  YYSYMBOL_MASTER_SSL_CA_SYM = 511,        /* MASTER_SSL_CA_SYM  */
  YYSYMBOL_MASTER_SSL_CERT_SYM = 512,      /* MASTER_SSL_CERT_SYM  */
  YYSYMBOL_MASTER_SSL_CIPHER_SYM = 513,    /* MASTER_SSL_CIPHER_SYM  */
  YYSYMBOL_MASTER_SSL_CRL_SYM = 514,       /* MASTER_SSL_CRL_SYM  */
  YYSYMBOL_MASTER_SSL_CRLPATH_SYM = 515,   /* MASTER_SSL_CRLPATH_SYM  */
  YYSYMBOL_MASTER_SSL_KEY_SYM = 516,       /* MASTER_SSL_KEY_SYM  */
  YYSYMBOL_MASTER_SSL_SYM = 517,           /* MASTER_SSL_SYM  */
  YYSYMBOL_MASTER_SYM = 518,               /* MASTER_SYM  */
  YYSYMBOL_MASTER_USER_SYM = 519,          /* MASTER_USER_SYM  */
  YYSYMBOL_MASTER_USE_GTID_SYM = 520,      /* MASTER_USE_GTID_SYM  */
  YYSYMBOL_MASTER_HEARTBEAT_PERIOD_SYM = 521, /* MASTER_HEARTBEAT_PERIOD_SYM  */
  YYSYMBOL_MAX_CONNECTIONS_PER_HOUR = 522, /* MAX_CONNECTIONS_PER_HOUR  */
  YYSYMBOL_MAX_QUERIES_PER_HOUR = 523,     /* MAX_QUERIES_PER_HOUR  */
  YYSYMBOL_MAX_ROWS = 524,                 /* MAX_ROWS  */
  YYSYMBOL_MAX_SIZE_SYM = 525,             /* MAX_SIZE_SYM  */
  YYSYMBOL_MAX_UPDATES_PER_HOUR = 526,     /* MAX_UPDATES_PER_HOUR  */
  YYSYMBOL_MAX_STATEMENT_TIME_SYM = 527,   /* MAX_STATEMENT_TIME_SYM  */
  YYSYMBOL_MAX_USER_CONNECTIONS_SYM = 528, /* MAX_USER_CONNECTIONS_SYM  */
  YYSYMBOL_MEDIUM_SYM = 529,               /* MEDIUM_SYM  */
  YYSYMBOL_MEMORY_SYM = 530,               /* MEMORY_SYM  */
  YYSYMBOL_MERGE_SYM = 531,                /* MERGE_SYM  */
  YYSYMBOL_MESSAGE_TEXT_SYM = 532,         /* MESSAGE_TEXT_SYM  */
  YYSYMBOL_MICROSECOND_SYM = 533,          /* MICROSECOND_SYM  */
  YYSYMBOL_MIGRATE_SYM = 534,              /* MIGRATE_SYM  */
  YYSYMBOL_MINUTE_SYM = 535,               /* MINUTE_SYM  */
  YYSYMBOL_MINVALUE_SYM = 536,             /* MINVALUE_SYM  */
  YYSYMBOL_MIN_ROWS = 537,                 /* MIN_ROWS  */
  YYSYMBOL_MODE_SYM = 538,                 /* MODE_SYM  */
  YYSYMBOL_MODIFY_SYM = 539,               /* MODIFY_SYM  */
  YYSYMBOL_MONTH_SYM = 540,                /* MONTH_SYM  */
  YYSYMBOL_MULTILINESTRING = 541,          /* MULTILINESTRING  */
  YYSYMBOL_MULTIPOINT = 542,               /* MULTIPOINT  */
  YYSYMBOL_MULTIPOLYGON = 543,             /* MULTIPOLYGON  */
  YYSYMBOL_MUTEX_SYM = 544,                /* MUTEX_SYM  */
  YYSYMBOL_MYSQL_SYM = 545,                /* MYSQL_SYM  */
  YYSYMBOL_MYSQL_ERRNO_SYM = 546,          /* MYSQL_ERRNO_SYM  */
  YYSYMBOL_NAMES_SYM = 547,                /* NAMES_SYM  */
  YYSYMBOL_NAME_SYM = 548,                 /* NAME_SYM  */
  YYSYMBOL_NATIONAL_SYM = 549,             /* NATIONAL_SYM  */
  YYSYMBOL_NCHAR_SYM = 550,                /* NCHAR_SYM  */
  YYSYMBOL_NEVER_SYM = 551,                /* NEVER_SYM  */
  YYSYMBOL_NEW_SYM = 552,                  /* NEW_SYM  */
  YYSYMBOL_NEXT_SYM = 553,                 /* NEXT_SYM  */
  YYSYMBOL_NEXTVAL_SYM = 554,              /* NEXTVAL_SYM  */
  YYSYMBOL_NOCACHE_SYM = 555,              /* NOCACHE_SYM  */
  YYSYMBOL_NOCYCLE_SYM = 556,              /* NOCYCLE_SYM  */
  YYSYMBOL_NODEGROUP_SYM = 557,            /* NODEGROUP_SYM  */
  YYSYMBOL_NONE_SYM = 558,                 /* NONE_SYM  */
  YYSYMBOL_NOTFOUND_SYM = 559,             /* NOTFOUND_SYM  */
  YYSYMBOL_NO_SYM = 560,                   /* NO_SYM  */
  YYSYMBOL_NOMAXVALUE_SYM = 561,           /* NOMAXVALUE_SYM  */
  YYSYMBOL_NOMINVALUE_SYM = 562,           /* NOMINVALUE_SYM  */
  YYSYMBOL_NO_WAIT_SYM = 563,              /* NO_WAIT_SYM  */
  YYSYMBOL_NOWAIT_SYM = 564,               /* NOWAIT_SYM  */
  YYSYMBOL_NUMBER_MARIADB_SYM = 565,       /* NUMBER_MARIADB_SYM  */
  YYSYMBOL_NUMBER_ORACLE_SYM = 566,        /* NUMBER_ORACLE_SYM  */
  YYSYMBOL_NVARCHAR_SYM = 567,             /* NVARCHAR_SYM  */
  YYSYMBOL_OF_SYM = 568,                   /* OF_SYM  */
  YYSYMBOL_OFFSET_SYM = 569,               /* OFFSET_SYM  */
  YYSYMBOL_OLD_PASSWORD_SYM = 570,         /* OLD_PASSWORD_SYM  */
  YYSYMBOL_ONE_SYM = 571,                  /* ONE_SYM  */
  YYSYMBOL_ONLY_SYM = 572,                 /* ONLY_SYM  */
  YYSYMBOL_ONLINE_SYM = 573,               /* ONLINE_SYM  */
  YYSYMBOL_OPEN_SYM = 574,                 /* OPEN_SYM  */
  YYSYMBOL_OPTIONS_SYM = 575,              /* OPTIONS_SYM  */
  YYSYMBOL_OPTION = 576,                   /* OPTION  */
  YYSYMBOL_OWNER_SYM = 577,                /* OWNER_SYM  */
  YYSYMBOL_PACK_KEYS_SYM = 578,            /* PACK_KEYS_SYM  */
  YYSYMBOL_PAGE_SYM = 579,                 /* PAGE_SYM  */
  YYSYMBOL_PARSER_SYM = 580,               /* PARSER_SYM  */
  YYSYMBOL_PARTIAL = 581,                  /* PARTIAL  */
  YYSYMBOL_PARTITIONS_SYM = 582,           /* PARTITIONS_SYM  */
  YYSYMBOL_PARTITIONING_SYM = 583,         /* PARTITIONING_SYM  */
  YYSYMBOL_PASSWORD_SYM = 584,             /* PASSWORD_SYM  */
  YYSYMBOL_PERIOD_SYM = 585,               /* PERIOD_SYM  */
  YYSYMBOL_PERSISTENT_SYM = 586,           /* PERSISTENT_SYM  */
  YYSYMBOL_PHASE_SYM = 587,                /* PHASE_SYM  */
  YYSYMBOL_PLUGINS_SYM = 588,              /* PLUGINS_SYM  */
  YYSYMBOL_PLUGIN_SYM = 589,               /* PLUGIN_SYM  */
  YYSYMBOL_POINT_SYM = 590,                /* POINT_SYM  */
  YYSYMBOL_POLYGON = 591,                  /* POLYGON  */
  YYSYMBOL_PORT_SYM = 592,                 /* PORT_SYM  */
  YYSYMBOL_PRECEDES_SYM = 593,             /* PRECEDES_SYM  */
  YYSYMBOL_PRECEDING_SYM = 594,            /* PRECEDING_SYM  */
  YYSYMBOL_PREPARE_SYM = 595,              /* PREPARE_SYM  */
  YYSYMBOL_PRESERVE_SYM = 596,             /* PRESERVE_SYM  */
  YYSYMBOL_PREV_SYM = 597,                 /* PREV_SYM  */
  YYSYMBOL_PREVIOUS_SYM = 598,             /* PREVIOUS_SYM  */
  YYSYMBOL_PRIVILEGES = 599,               /* PRIVILEGES  */
  YYSYMBOL_PROCESS = 600,                  /* PROCESS  */
  YYSYMBOL_PROCESSLIST_SYM = 601,          /* PROCESSLIST_SYM  */
  YYSYMBOL_PROFILE_SYM = 602,              /* PROFILE_SYM  */
  YYSYMBOL_PROFILES_SYM = 603,             /* PROFILES_SYM  */
  YYSYMBOL_PROXY_SYM = 604,                /* PROXY_SYM  */
  YYSYMBOL_QUARTER_SYM = 605,              /* QUARTER_SYM  */
  YYSYMBOL_QUERY_SYM = 606,                /* QUERY_SYM  */
  YYSYMBOL_QUICK = 607,                    /* QUICK  */
  YYSYMBOL_RAW_MARIADB_SYM = 608,          /* RAW_MARIADB_SYM  */
  YYSYMBOL_RAW_ORACLE_SYM = 609,           /* RAW_ORACLE_SYM  */
  YYSYMBOL_READ_ONLY_SYM = 610,            /* READ_ONLY_SYM  */
  YYSYMBOL_REBUILD_SYM = 611,              /* REBUILD_SYM  */
  YYSYMBOL_RECOVER_SYM = 612,              /* RECOVER_SYM  */
  YYSYMBOL_REDOFILE_SYM = 613,             /* REDOFILE_SYM  */
  YYSYMBOL_REDO_BUFFER_SIZE_SYM = 614,     /* REDO_BUFFER_SIZE_SYM  */
  YYSYMBOL_REDUNDANT_SYM = 615,            /* REDUNDANT_SYM  */
  YYSYMBOL_RELAY = 616,                    /* RELAY  */
  YYSYMBOL_RELAYLOG_SYM = 617,             /* RELAYLOG_SYM  */
  YYSYMBOL_RELAY_LOG_FILE_SYM = 618,       /* RELAY_LOG_FILE_SYM  */
  YYSYMBOL_RELAY_LOG_POS_SYM = 619,        /* RELAY_LOG_POS_SYM  */
  YYSYMBOL_RELAY_THREAD = 620,             /* RELAY_THREAD  */
  YYSYMBOL_RELOAD = 621,                   /* RELOAD  */
  YYSYMBOL_REMOVE_SYM = 622,               /* REMOVE_SYM  */
  YYSYMBOL_REORGANIZE_SYM = 623,           /* REORGANIZE_SYM  */
  YYSYMBOL_REPAIR = 624,                   /* REPAIR  */
  YYSYMBOL_REPEATABLE_SYM = 625,           /* REPEATABLE_SYM  */
  YYSYMBOL_REPLICATION = 626,              /* REPLICATION  */
  YYSYMBOL_RESET_SYM = 627,                /* RESET_SYM  */
  YYSYMBOL_RESTART_SYM = 628,              /* RESTART_SYM  */
  YYSYMBOL_RESOURCES = 629,                /* RESOURCES  */
  YYSYMBOL_RESTORE_SYM = 630,              /* RESTORE_SYM  */
  YYSYMBOL_RESUME_SYM = 631,               /* RESUME_SYM  */
  YYSYMBOL_RETURNED_SQLSTATE_SYM = 632,    /* RETURNED_SQLSTATE_SYM  */
  YYSYMBOL_RETURNS_SYM = 633,              /* RETURNS_SYM  */
  YYSYMBOL_REUSE_SYM = 634,                /* REUSE_SYM  */
  YYSYMBOL_REVERSE_SYM = 635,              /* REVERSE_SYM  */
  YYSYMBOL_ROLE_SYM = 636,                 /* ROLE_SYM  */
  YYSYMBOL_ROLLBACK_SYM = 637,             /* ROLLBACK_SYM  */
  YYSYMBOL_ROLLUP_SYM = 638,               /* ROLLUP_SYM  */
  YYSYMBOL_ROUTINE_SYM = 639,              /* ROUTINE_SYM  */
  YYSYMBOL_ROWCOUNT_SYM = 640,             /* ROWCOUNT_SYM  */
  YYSYMBOL_ROW_SYM = 641,                  /* ROW_SYM  */
  YYSYMBOL_ROW_COUNT_SYM = 642,            /* ROW_COUNT_SYM  */
  YYSYMBOL_ROW_FORMAT_SYM = 643,           /* ROW_FORMAT_SYM  */
  YYSYMBOL_RTREE_SYM = 644,                /* RTREE_SYM  */
  YYSYMBOL_SAVEPOINT_SYM = 645,            /* SAVEPOINT_SYM  */
  YYSYMBOL_SCHEDULE_SYM = 646,             /* SCHEDULE_SYM  */
  YYSYMBOL_SCHEMA_NAME_SYM = 647,          /* SCHEMA_NAME_SYM  */
  YYSYMBOL_SECOND_SYM = 648,               /* SECOND_SYM  */
  YYSYMBOL_SECURITY_SYM = 649,             /* SECURITY_SYM  */
  YYSYMBOL_SEQUENCE_SYM = 650,             /* SEQUENCE_SYM  */
  YYSYMBOL_SERIALIZABLE_SYM = 651,         /* SERIALIZABLE_SYM  */
  YYSYMBOL_SERIAL_SYM = 652,               /* SERIAL_SYM  */
  YYSYMBOL_SESSION_SYM = 653,              /* SESSION_SYM  */
  YYSYMBOL_SERVER_SYM = 654,               /* SERVER_SYM  */
  YYSYMBOL_SETVAL_SYM = 655,               /* SETVAL_SYM  */
  YYSYMBOL_SHARE_SYM = 656,                /* SHARE_SYM  */
  YYSYMBOL_SHUTDOWN = 657,                 /* SHUTDOWN  */
  YYSYMBOL_SIGNED_SYM = 658,               /* SIGNED_SYM  */
  YYSYMBOL_SIMPLE_SYM = 659,               /* SIMPLE_SYM  */
  YYSYMBOL_SLAVE = 660,                    /* SLAVE  */
  YYSYMBOL_SLAVES = 661,                   /* SLAVES  */
  YYSYMBOL_SLAVE_POS_SYM = 662,            /* SLAVE_POS_SYM  */
  YYSYMBOL_SLOW = 663,                     /* SLOW  */
  YYSYMBOL_SNAPSHOT_SYM = 664,             /* SNAPSHOT_SYM  */
  YYSYMBOL_SOCKET_SYM = 665,               /* SOCKET_SYM  */
  YYSYMBOL_SOFT_SYM = 666,                 /* SOFT_SYM  */
  YYSYMBOL_SONAME_SYM = 667,               /* SONAME_SYM  */
  YYSYMBOL_SOUNDS_SYM = 668,               /* SOUNDS_SYM  */
  YYSYMBOL_SOURCE_SYM = 669,               /* SOURCE_SYM  */
  YYSYMBOL_SQL_BUFFER_RESULT = 670,        /* SQL_BUFFER_RESULT  */
  YYSYMBOL_SQL_CACHE_SYM = 671,            /* SQL_CACHE_SYM  */
  YYSYMBOL_SQL_CALC_FOUND_ROWS = 672,      /* SQL_CALC_FOUND_ROWS  */
  YYSYMBOL_SQL_NO_CACHE_SYM = 673,         /* SQL_NO_CACHE_SYM  */
  YYSYMBOL_SQL_THREAD = 674,               /* SQL_THREAD  */
  YYSYMBOL_STAGE_SYM = 675,                /* STAGE_SYM  */
  YYSYMBOL_STARTS_SYM = 676,               /* STARTS_SYM  */
  YYSYMBOL_START_SYM = 677,                /* START_SYM  */
  YYSYMBOL_STATEMENT_SYM = 678,            /* STATEMENT_SYM  */
  YYSYMBOL_STATUS_SYM = 679,               /* STATUS_SYM  */
  YYSYMBOL_STOP_SYM = 680,                 /* STOP_SYM  */
  YYSYMBOL_STORAGE_SYM = 681,              /* STORAGE_SYM  */
  YYSYMBOL_STORED_SYM = 682,               /* STORED_SYM  */
  YYSYMBOL_STRING_SYM = 683,               /* STRING_SYM  */
  YYSYMBOL_SUBCLASS_ORIGIN_SYM = 684,      /* SUBCLASS_ORIGIN_SYM  */
  YYSYMBOL_SUBDATE_SYM = 685,              /* SUBDATE_SYM  */
  YYSYMBOL_SUBJECT_SYM = 686,              /* SUBJECT_SYM  */
  YYSYMBOL_SUBPARTITIONS_SYM = 687,        /* SUBPARTITIONS_SYM  */
  YYSYMBOL_SUBPARTITION_SYM = 688,         /* SUBPARTITION_SYM  */
  YYSYMBOL_SUPER_SYM = 689,                /* SUPER_SYM  */
  YYSYMBOL_SUSPEND_SYM = 690,              /* SUSPEND_SYM  */
  YYSYMBOL_SWAPS_SYM = 691,                /* SWAPS_SYM  */
  YYSYMBOL_SWITCHES_SYM = 692,             /* SWITCHES_SYM  */
  YYSYMBOL_SYSTEM = 693,                   /* SYSTEM  */
  YYSYMBOL_SYSTEM_TIME_SYM = 694,          /* SYSTEM_TIME_SYM  */
  YYSYMBOL_TABLES = 695,                   /* TABLES  */
  YYSYMBOL_TABLESPACE = 696,               /* TABLESPACE  */
  YYSYMBOL_TABLE_CHECKSUM_SYM = 697,       /* TABLE_CHECKSUM_SYM  */
  YYSYMBOL_TABLE_NAME_SYM = 698,           /* TABLE_NAME_SYM  */
  YYSYMBOL_TEMPORARY = 699,                /* TEMPORARY  */
  YYSYMBOL_TEMPTABLE_SYM = 700,            /* TEMPTABLE_SYM  */
  YYSYMBOL_TEXT_SYM = 701,                 /* TEXT_SYM  */
  YYSYMBOL_THAN_SYM = 702,                 /* THAN_SYM  */
  YYSYMBOL_TIES_SYM = 703,                 /* TIES_SYM  */
  YYSYMBOL_TIMESTAMP = 704,                /* TIMESTAMP  */
  YYSYMBOL_TIMESTAMP_ADD = 705,            /* TIMESTAMP_ADD  */
  YYSYMBOL_TIMESTAMP_DIFF = 706,           /* TIMESTAMP_DIFF  */
  YYSYMBOL_TIME_SYM = 707,                 /* TIME_SYM  */
  YYSYMBOL_TRANSACTION_SYM = 708,          /* TRANSACTION_SYM  */
  YYSYMBOL_TRANSACTIONAL_SYM = 709,        /* TRANSACTIONAL_SYM  */
  YYSYMBOL_TRIGGERS_SYM = 710,             /* TRIGGERS_SYM  */
  YYSYMBOL_TRIM_ORACLE = 711,              /* TRIM_ORACLE  */
  YYSYMBOL_TRUNCATE_SYM = 712,             /* TRUNCATE_SYM  */
  YYSYMBOL_TYPES_SYM = 713,                /* TYPES_SYM  */
  YYSYMBOL_TYPE_SYM = 714,                 /* TYPE_SYM  */
  YYSYMBOL_UDF_RETURNS_SYM = 715,          /* UDF_RETURNS_SYM  */
  YYSYMBOL_UNBOUNDED_SYM = 716,            /* UNBOUNDED_SYM  */
  YYSYMBOL_UNCOMMITTED_SYM = 717,          /* UNCOMMITTED_SYM  */
  YYSYMBOL_UNDEFINED_SYM = 718,            /* UNDEFINED_SYM  */
  YYSYMBOL_UNDOFILE_SYM = 719,             /* UNDOFILE_SYM  */
  YYSYMBOL_UNDO_BUFFER_SIZE_SYM = 720,     /* UNDO_BUFFER_SIZE_SYM  */
  YYSYMBOL_UNICODE_SYM = 721,              /* UNICODE_SYM  */
  YYSYMBOL_UNINSTALL_SYM = 722,            /* UNINSTALL_SYM  */
  YYSYMBOL_UNKNOWN_SYM = 723,              /* UNKNOWN_SYM  */
  YYSYMBOL_UNTIL_SYM = 724,                /* UNTIL_SYM  */
  YYSYMBOL_UPGRADE_SYM = 725,              /* UPGRADE_SYM  */
  YYSYMBOL_USER_SYM = 726,                 /* USER_SYM  */
  YYSYMBOL_USE_FRM = 727,                  /* USE_FRM  */
  YYSYMBOL_VALUE_SYM = 728,                /* VALUE_SYM  */
  YYSYMBOL_VARCHAR2_MARIADB_SYM = 729,     /* VARCHAR2_MARIADB_SYM  */
  YYSYMBOL_VARCHAR2_ORACLE_SYM = 730,      /* VARCHAR2_ORACLE_SYM  */
  YYSYMBOL_VARIABLES = 731,                /* VARIABLES  */
  YYSYMBOL_VERSIONING_SYM = 732,           /* VERSIONING_SYM  */
  YYSYMBOL_VIA_SYM = 733,                  /* VIA_SYM  */
  YYSYMBOL_VIEW_SYM = 734,                 /* VIEW_SYM  */
  YYSYMBOL_VIRTUAL_SYM = 735,              /* VIRTUAL_SYM  */
  YYSYMBOL_WAIT_SYM = 736,                 /* WAIT_SYM  */
  YYSYMBOL_WARNINGS = 737,                 /* WARNINGS  */
  YYSYMBOL_WEEK_SYM = 738,                 /* WEEK_SYM  */
  YYSYMBOL_WEIGHT_STRING_SYM = 739,        /* WEIGHT_STRING_SYM  */
  YYSYMBOL_WINDOW_SYM = 740,               /* WINDOW_SYM  */
  YYSYMBOL_WITHIN = 741,                   /* WITHIN  */
  YYSYMBOL_WITHOUT = 742,                  /* WITHOUT  */
  YYSYMBOL_WORK_SYM = 743,                 /* WORK_SYM  */
  YYSYMBOL_WRAPPER_SYM = 744,              /* WRAPPER_SYM  */
  YYSYMBOL_WRITE_SYM = 745,                /* WRITE_SYM  */
  YYSYMBOL_X509_SYM = 746,                 /* X509_SYM  */
  YYSYMBOL_XA_SYM = 747,                   /* XA_SYM  */
  YYSYMBOL_XML_SYM = 748,                  /* XML_SYM  */
  YYSYMBOL_YEAR_SYM = 749,                 /* YEAR_SYM  */
  YYSYMBOL_CONDITIONLESS_JOIN = 750,       /* CONDITIONLESS_JOIN  */
  YYSYMBOL_ON_SYM = 751,                   /* ON_SYM  */
  YYSYMBOL_PREC_BELOW_NOT = 752,           /* PREC_BELOW_NOT  */
  YYSYMBOL_753_ = 753,                     /* '='  */
  YYSYMBOL_754_ = 754,                     /* '>'  */
  YYSYMBOL_755_ = 755,                     /* '<'  */
  YYSYMBOL_756_ = 756,                     /* '|'  */
  YYSYMBOL_757_ = 757,                     /* '&'  */
  YYSYMBOL_758_ = 758,                     /* '-'  */
  YYSYMBOL_759_ = 759,                     /* '+'  */
  YYSYMBOL_760_ = 760,                     /* '*'  */
  YYSYMBOL_761_ = 761,                     /* '/'  */
  YYSYMBOL_762_ = 762,                     /* '%'  */
  YYSYMBOL_763_ = 763,                     /* '^'  */
  YYSYMBOL_764_ = 764,                     /* '~'  */
  YYSYMBOL_SUBQUERY_AS_EXPR = 765,         /* SUBQUERY_AS_EXPR  */
  YYSYMBOL_PREC_BELOW_IDENTIFIER_OPT_SPECIAL_CASE = 766, /* PREC_BELOW_IDENTIFIER_OPT_SPECIAL_CASE  */
  YYSYMBOL_USER = 767,                     /* USER  */
  YYSYMBOL_PREC_BELOW_CONTRACTION_TOKEN2 = 768, /* PREC_BELOW_CONTRACTION_TOKEN2  */
  YYSYMBOL_769_ = 769,                     /* '('  */
  YYSYMBOL_770_ = 770,                     /* ')'  */
  YYSYMBOL_EMPTY_FROM_CLAUSE = 771,        /* EMPTY_FROM_CLAUSE  */
  YYSYMBOL_772_ = 772,                     /* ','  */
  YYSYMBOL_773_ = 773,                     /* '!'  */
  YYSYMBOL_774_ = 774,                     /* '{'  */
  YYSYMBOL_775_ = 775,                     /* '}'  */
  YYSYMBOL_776_ = 776,                     /* ';'  */
  YYSYMBOL_777_ = 777,                     /* '.'  */
  YYSYMBOL_778_ = 778,                     /* '@'  */
  YYSYMBOL_YYACCEPT = 779,                 /* $accept  */
  YYSYMBOL_query = 780,                    /* query  */
  YYSYMBOL_781_1 = 781,                    /* $@1  */
  YYSYMBOL_opt_end_of_input = 782,         /* opt_end_of_input  */
  YYSYMBOL_verb_clause = 783,              /* verb_clause  */
  YYSYMBOL_statement = 784,                /* statement  */
  YYSYMBOL_deallocate = 785,               /* deallocate  */
  YYSYMBOL_deallocate_or_drop = 786,       /* deallocate_or_drop  */
  YYSYMBOL_prepare = 787,                  /* prepare  */
  YYSYMBOL_788_2 = 788,                    /* $@2  */
  YYSYMBOL_execute = 789,                  /* execute  */
  YYSYMBOL_790_3 = 790,                    /* $@3  */
  YYSYMBOL_791_4 = 791,                    /* $@4  */
  YYSYMBOL_execute_using = 792,            /* execute_using  */
  YYSYMBOL_793_5 = 793,                    /* $@5  */
  YYSYMBOL_execute_params = 794,           /* execute_params  */
  YYSYMBOL_help = 795,                     /* help  */
  YYSYMBOL_796_6 = 796,                    /* $@6  */
  YYSYMBOL_change = 797,                   /* change  */
  YYSYMBOL_798_7 = 798,                    /* $@7  */
  YYSYMBOL_master_defs = 799,              /* master_defs  */
  YYSYMBOL_master_def = 800,               /* master_def  */
  YYSYMBOL_ignore_server_id_list = 801,    /* ignore_server_id_list  */
  YYSYMBOL_ignore_server_id = 802,         /* ignore_server_id  */
  YYSYMBOL_do_domain_id_list = 803,        /* do_domain_id_list  */
  YYSYMBOL_do_domain_id = 804,             /* do_domain_id  */
  YYSYMBOL_ignore_domain_id_list = 805,    /* ignore_domain_id_list  */
  YYSYMBOL_ignore_domain_id = 806,         /* ignore_domain_id  */
  YYSYMBOL_master_file_def = 807,          /* master_file_def  */
  YYSYMBOL_optional_connection_name = 808, /* optional_connection_name  */
  YYSYMBOL_connection_name = 809,          /* connection_name  */
  YYSYMBOL_create = 810,                   /* create  */
  YYSYMBOL_811_8 = 811,                    /* $@8  */
  YYSYMBOL_812_9 = 812,                    /* $@9  */
  YYSYMBOL_813_10 = 813,                   /* $@10  */
  YYSYMBOL_814_11 = 814,                   /* $@11  */
  YYSYMBOL_815_12 = 815,                   /* $@12  */
  YYSYMBOL_816_13 = 816,                   /* $@13  */
  YYSYMBOL_817_14 = 817,                   /* $@14  */
  YYSYMBOL_818_15 = 818,                   /* $@15  */
  YYSYMBOL_819_16 = 819,                   /* $@16  */
  YYSYMBOL_820_17 = 820,                   /* $@17  */
  YYSYMBOL_821_18 = 821,                   /* $@18  */
  YYSYMBOL_822_19 = 822,                   /* $@19  */
  YYSYMBOL_823_20 = 823,                   /* $@20  */
  YYSYMBOL_824_21 = 824,                   /* $@21  */
  YYSYMBOL_825_22 = 825,                   /* $@22  */
  YYSYMBOL_826_23 = 826,                   /* $@23  */
  YYSYMBOL_827_24 = 827,                   /* $@24  */
  YYSYMBOL_828_25 = 828,                   /* $@25  */
  YYSYMBOL_829_26 = 829,                   /* $@26  */
  YYSYMBOL_830_27 = 830,                   /* $@27  */
  YYSYMBOL_831_28 = 831,                   /* $@28  */
  YYSYMBOL_832_29 = 832,                   /* $@29  */
  YYSYMBOL_833_30 = 833,                   /* $@30  */
  YYSYMBOL_834_31 = 834,                   /* $@31  */
  YYSYMBOL_package_implementation_executable_section = 835, /* package_implementation_executable_section  */
  YYSYMBOL_package_implementation_declare_section = 836, /* package_implementation_declare_section  */
  YYSYMBOL_package_implementation_declare_section_list1 = 837, /* package_implementation_declare_section_list1  */
  YYSYMBOL_package_implementation_declare_section_list2 = 838, /* package_implementation_declare_section_list2  */
  YYSYMBOL_package_routine_lex = 839,      /* package_routine_lex  */
  YYSYMBOL_package_specification_function = 840, /* package_specification_function  */
  YYSYMBOL_841_32 = 841,                   /* $@32  */
  YYSYMBOL_package_specification_procedure = 842, /* package_specification_procedure  */
  YYSYMBOL_843_33 = 843,                   /* $@33  */
  YYSYMBOL_package_implementation_routine_definition = 844, /* package_implementation_routine_definition  */
  YYSYMBOL_package_implementation_function_body = 845, /* package_implementation_function_body  */
  YYSYMBOL_846_34 = 846,                   /* $@34  */
  YYSYMBOL_package_implementation_procedure_body = 847, /* package_implementation_procedure_body  */
  YYSYMBOL_848_35 = 848,                   /* $@35  */
  YYSYMBOL_package_implementation_item_declaration = 849, /* package_implementation_item_declaration  */
  YYSYMBOL_opt_package_specification_element_list = 850, /* opt_package_specification_element_list  */
  YYSYMBOL_package_specification_element_list = 851, /* package_specification_element_list  */
  YYSYMBOL_package_specification_element = 852, /* package_specification_element  */
  YYSYMBOL_opt_sequence = 853,             /* opt_sequence  */
  YYSYMBOL_sequence_defs = 854,            /* sequence_defs  */
  YYSYMBOL_sequence_def = 855,             /* sequence_def  */
  YYSYMBOL_force_lookahead = 856,          /* force_lookahead  */
  YYSYMBOL_server_def = 857,               /* server_def  */
  YYSYMBOL_858_36 = 858,                   /* $@36  */
  YYSYMBOL_server_options_list = 859,      /* server_options_list  */
  YYSYMBOL_server_option = 860,            /* server_option  */
  YYSYMBOL_event_tail = 861,               /* event_tail  */
  YYSYMBOL_862_37 = 862,                   /* $@37  */
  YYSYMBOL_ev_schedule_time = 863,         /* ev_schedule_time  */
  YYSYMBOL_864_38 = 864,                   /* $@38  */
  YYSYMBOL_opt_ev_status = 865,            /* opt_ev_status  */
  YYSYMBOL_ev_starts = 866,                /* ev_starts  */
  YYSYMBOL_ev_ends = 867,                  /* ev_ends  */
  YYSYMBOL_opt_ev_on_completion = 868,     /* opt_ev_on_completion  */
  YYSYMBOL_ev_on_completion = 869,         /* ev_on_completion  */
  YYSYMBOL_opt_ev_comment = 870,           /* opt_ev_comment  */
  YYSYMBOL_ev_sql_stmt = 871,              /* ev_sql_stmt  */
  YYSYMBOL_872_39 = 872,                   /* $@39  */
  YYSYMBOL_clear_privileges = 873,         /* clear_privileges  */
  YYSYMBOL_opt_aggregate = 874,            /* opt_aggregate  */
  YYSYMBOL_sp_name = 875,                  /* sp_name  */
  YYSYMBOL_opt_sp_name = 876,              /* opt_sp_name  */
  YYSYMBOL_sp_a_chistics = 877,            /* sp_a_chistics  */
  YYSYMBOL_sp_c_chistics = 878,            /* sp_c_chistics  */
  YYSYMBOL_sp_chistic = 879,               /* sp_chistic  */
  YYSYMBOL_create_package_chistic = 880,   /* create_package_chistic  */
  YYSYMBOL_create_package_chistics = 881,  /* create_package_chistics  */
  YYSYMBOL_opt_create_package_chistics = 882, /* opt_create_package_chistics  */
  YYSYMBOL_opt_create_package_chistics_init = 883, /* opt_create_package_chistics_init  */
  YYSYMBOL_884_40 = 884,                   /* $@40  */
  YYSYMBOL_sp_c_chistic = 885,             /* sp_c_chistic  */
  YYSYMBOL_sp_suid = 886,                  /* sp_suid  */
  YYSYMBOL_call = 887,                     /* call  */
  YYSYMBOL_888_41 = 888,                   /* $@41  */
  YYSYMBOL_889_42 = 889,                   /* $@42  */
  YYSYMBOL_890_43 = 890,                   /* $@43  */
  YYSYMBOL_opt_sp_cparam_list = 891,       /* opt_sp_cparam_list  */
  YYSYMBOL_opt_sp_cparams = 892,           /* opt_sp_cparams  */
  YYSYMBOL_sp_cparams = 893,               /* sp_cparams  */
  YYSYMBOL_sp_fdparam_list = 894,          /* sp_fdparam_list  */
  YYSYMBOL_895_44 = 895,                   /* $@44  */
  YYSYMBOL_sp_fdparams = 896,              /* sp_fdparams  */
  YYSYMBOL_sp_param_name = 897,            /* sp_param_name  */
  YYSYMBOL_sp_param_name_and_type = 898,   /* sp_param_name_and_type  */
  YYSYMBOL_sp_pdparam_list = 899,          /* sp_pdparam_list  */
  YYSYMBOL_sp_pdparams = 900,              /* sp_pdparams  */
  YYSYMBOL_sp_pdparam = 901,               /* sp_pdparam  */
  YYSYMBOL_sp_opt_inout = 902,             /* sp_opt_inout  */
  YYSYMBOL_sp_parenthesized_pdparam_list = 903, /* sp_parenthesized_pdparam_list  */
  YYSYMBOL_904_45 = 904,                   /* $@45  */
  YYSYMBOL_sp_no_param = 905,              /* sp_no_param  */
  YYSYMBOL_opt_sp_parenthesized_fdparam_list = 906, /* opt_sp_parenthesized_fdparam_list  */
  YYSYMBOL_opt_sp_parenthesized_pdparam_list = 907, /* opt_sp_parenthesized_pdparam_list  */
  YYSYMBOL_sp_proc_stmts = 908,            /* sp_proc_stmts  */
  YYSYMBOL_sp_proc_stmts1 = 909,           /* sp_proc_stmts1  */
  YYSYMBOL_sp_proc_stmts1_implicit_block = 910, /* sp_proc_stmts1_implicit_block  */
  YYSYMBOL_911_46 = 911,                   /* $@46  */
  YYSYMBOL_opt_sp_decl_body_list = 912,    /* opt_sp_decl_body_list  */
  YYSYMBOL_sp_decl_body_list = 913,        /* sp_decl_body_list  */
  YYSYMBOL_914_47 = 914,                   /* $@47  */
  YYSYMBOL_sp_decl_non_handler_list = 915, /* sp_decl_non_handler_list  */
  YYSYMBOL_sp_decl_handler_list = 916,     /* sp_decl_handler_list  */
  YYSYMBOL_opt_sp_decl_handler_list = 917, /* opt_sp_decl_handler_list  */
  YYSYMBOL_optionally_qualified_column_ident = 918, /* optionally_qualified_column_ident  */
  YYSYMBOL_row_field_name = 919,           /* row_field_name  */
  YYSYMBOL_row_field_definition = 920,     /* row_field_definition  */
  YYSYMBOL_row_field_definition_list = 921, /* row_field_definition_list  */
  YYSYMBOL_row_type_body = 922,            /* row_type_body  */
  YYSYMBOL_sp_decl_idents_init_vars = 923, /* sp_decl_idents_init_vars  */
  YYSYMBOL_sp_decl_vars = 924,             /* sp_decl_vars  */
  YYSYMBOL_sp_decl_non_handler = 925,      /* sp_decl_non_handler  */
  YYSYMBOL_926_48 = 926,                   /* $@48  */
  YYSYMBOL_sp_decl_handler = 927,          /* sp_decl_handler  */
  YYSYMBOL_928_49 = 928,                   /* $@49  */
  YYSYMBOL_opt_parenthesized_cursor_formal_parameters = 929, /* opt_parenthesized_cursor_formal_parameters  */
  YYSYMBOL_sp_cursor_stmt_lex = 930,       /* sp_cursor_stmt_lex  */
  YYSYMBOL_sp_cursor_stmt = 931,           /* sp_cursor_stmt  */
  YYSYMBOL_932_50 = 932,                   /* $@50  */
  YYSYMBOL_sp_handler_type = 933,          /* sp_handler_type  */
  YYSYMBOL_sp_hcond_list = 934,            /* sp_hcond_list  */
  YYSYMBOL_sp_hcond_element = 935,         /* sp_hcond_element  */
  YYSYMBOL_sp_cond = 936,                  /* sp_cond  */
  YYSYMBOL_sqlstate = 937,                 /* sqlstate  */
  YYSYMBOL_opt_value = 938,                /* opt_value  */
  YYSYMBOL_sp_hcond = 939,                 /* sp_hcond  */
  YYSYMBOL_raise_stmt_oracle = 940,        /* raise_stmt_oracle  */
  YYSYMBOL_signal_stmt = 941,              /* signal_stmt  */
  YYSYMBOL_signal_value = 942,             /* signal_value  */
  YYSYMBOL_opt_signal_value = 943,         /* opt_signal_value  */
  YYSYMBOL_opt_set_signal_information = 944, /* opt_set_signal_information  */
  YYSYMBOL_signal_information_item_list = 945, /* signal_information_item_list  */
  YYSYMBOL_signal_allowed_expr = 946,      /* signal_allowed_expr  */
  YYSYMBOL_signal_condition_information_item_name = 947, /* signal_condition_information_item_name  */
  YYSYMBOL_resignal_stmt = 948,            /* resignal_stmt  */
  YYSYMBOL_get_diagnostics = 949,          /* get_diagnostics  */
  YYSYMBOL_which_area = 950,               /* which_area  */
  YYSYMBOL_diagnostics_information = 951,  /* diagnostics_information  */
  YYSYMBOL_statement_information = 952,    /* statement_information  */
  YYSYMBOL_statement_information_item = 953, /* statement_information_item  */
  YYSYMBOL_simple_target_specification = 954, /* simple_target_specification  */
  YYSYMBOL_statement_information_item_name = 955, /* statement_information_item_name  */
  YYSYMBOL_condition_number = 956,         /* condition_number  */
  YYSYMBOL_condition_information = 957,    /* condition_information  */
  YYSYMBOL_condition_information_item = 958, /* condition_information_item  */
  YYSYMBOL_condition_information_item_name = 959, /* condition_information_item_name  */
  YYSYMBOL_sp_decl_ident = 960,            /* sp_decl_ident  */
  YYSYMBOL_sp_decl_idents = 961,           /* sp_decl_idents  */
  YYSYMBOL_sp_opt_default = 962,           /* sp_opt_default  */
  YYSYMBOL_sp_proc_stmt = 963,             /* sp_proc_stmt  */
  YYSYMBOL_sp_labelable_stmt = 964,        /* sp_labelable_stmt  */
  YYSYMBOL_sp_proc_stmt_compound_ok = 965, /* sp_proc_stmt_compound_ok  */
  YYSYMBOL_sp_proc_stmt_if = 966,          /* sp_proc_stmt_if  */
  YYSYMBOL_967_51 = 967,                   /* $@51  */
  YYSYMBOL_sp_statement = 968,             /* sp_statement  */
  YYSYMBOL_969_52 = 969,                   /* $@52  */
  YYSYMBOL_970_53 = 970,                   /* $@53  */
  YYSYMBOL_971_54 = 971,                   /* $@54  */
  YYSYMBOL_sp_proc_stmt_statement = 972,   /* sp_proc_stmt_statement  */
  YYSYMBOL_973_55 = 973,                   /* $@55  */
  YYSYMBOL_RETURN_ALLMODES_SYM = 974,      /* RETURN_ALLMODES_SYM  */
  YYSYMBOL_sp_proc_stmt_return = 975,      /* sp_proc_stmt_return  */
  YYSYMBOL_976_56 = 976,                   /* $@56  */
  YYSYMBOL_reset_lex_expr = 977,           /* reset_lex_expr  */
  YYSYMBOL_978_57 = 978,                   /* $@57  */
  YYSYMBOL_sp_proc_stmt_exit_oracle = 979, /* sp_proc_stmt_exit_oracle  */
  YYSYMBOL_sp_proc_stmt_continue_oracle = 980, /* sp_proc_stmt_continue_oracle  */
  YYSYMBOL_sp_proc_stmt_leave = 981,       /* sp_proc_stmt_leave  */
  YYSYMBOL_sp_proc_stmt_iterate = 982,     /* sp_proc_stmt_iterate  */
  YYSYMBOL_sp_proc_stmt_goto_oracle = 983, /* sp_proc_stmt_goto_oracle  */
  YYSYMBOL_remember_lex = 984,             /* remember_lex  */
  YYSYMBOL_assignment_source_lex = 985,    /* assignment_source_lex  */
  YYSYMBOL_assignment_source_expr = 986,   /* assignment_source_expr  */
  YYSYMBOL_987_58 = 987,                   /* $@58  */
  YYSYMBOL_for_loop_bound_expr = 988,      /* for_loop_bound_expr  */
  YYSYMBOL_989_59 = 989,                   /* $@59  */
  YYSYMBOL_cursor_actual_parameters = 990, /* cursor_actual_parameters  */
  YYSYMBOL_opt_parenthesized_cursor_actual_parameters = 991, /* opt_parenthesized_cursor_actual_parameters  */
  YYSYMBOL_sp_proc_stmt_open = 992,        /* sp_proc_stmt_open  */
  YYSYMBOL_sp_proc_stmt_fetch_head = 993,  /* sp_proc_stmt_fetch_head  */
  YYSYMBOL_sp_proc_stmt_fetch = 994,       /* sp_proc_stmt_fetch  */
  YYSYMBOL_sp_proc_stmt_close = 995,       /* sp_proc_stmt_close  */
  YYSYMBOL_sp_fetch_list = 996,            /* sp_fetch_list  */
  YYSYMBOL_sp_if = 997,                    /* sp_if  */
  YYSYMBOL_998_60 = 998,                   /* $@60  */
  YYSYMBOL_999_61 = 999,                   /* $@61  */
  YYSYMBOL_1000_62 = 1000,                 /* $@62  */
  YYSYMBOL_sp_elseifs = 1001,              /* sp_elseifs  */
  YYSYMBOL_case_stmt_specification = 1002, /* case_stmt_specification  */
  YYSYMBOL_1003_63 = 1003,                 /* $@63  */
  YYSYMBOL_case_stmt_body = 1004,          /* case_stmt_body  */
  YYSYMBOL_1005_64 = 1005,                 /* $@64  */
  YYSYMBOL_1006_65 = 1006,                 /* $@65  */
  YYSYMBOL_simple_when_clause_list = 1007, /* simple_when_clause_list  */
  YYSYMBOL_searched_when_clause_list = 1008, /* searched_when_clause_list  */
  YYSYMBOL_simple_when_clause = 1009,      /* simple_when_clause  */
  YYSYMBOL_1010_66 = 1010,                 /* $@66  */
  YYSYMBOL_1011_67 = 1011,                 /* $@67  */
  YYSYMBOL_searched_when_clause = 1012,    /* searched_when_clause  */
  YYSYMBOL_1013_68 = 1013,                 /* $@68  */
  YYSYMBOL_1014_69 = 1014,                 /* $@69  */
  YYSYMBOL_else_clause_opt = 1015,         /* else_clause_opt  */
  YYSYMBOL_sp_opt_label = 1016,            /* sp_opt_label  */
  YYSYMBOL_sp_block_label = 1017,          /* sp_block_label  */
  YYSYMBOL_sp_labeled_block = 1018,        /* sp_labeled_block  */
  YYSYMBOL_1019_70 = 1019,                 /* $@70  */
  YYSYMBOL_1020_71 = 1020,                 /* $@71  */
  YYSYMBOL_1021_72 = 1021,                 /* $@72  */
  YYSYMBOL_opt_not_atomic = 1022,          /* opt_not_atomic  */
  YYSYMBOL_sp_unlabeled_block = 1023,      /* sp_unlabeled_block  */
  YYSYMBOL_1024_73 = 1024,                 /* $@73  */
  YYSYMBOL_1025_74 = 1025,                 /* $@74  */
  YYSYMBOL_1026_75 = 1026,                 /* $@75  */
  YYSYMBOL_sp_instr_addr = 1027,           /* sp_instr_addr  */
  YYSYMBOL_sp_body = 1028,                 /* sp_body  */
  YYSYMBOL_1029_76 = 1029,                 /* $@76  */
  YYSYMBOL_1030_77 = 1030,                 /* $@77  */
  YYSYMBOL_1031_78 = 1031,                 /* $@78  */
  YYSYMBOL_sp_block_statements_and_exceptions = 1032, /* sp_block_statements_and_exceptions  */
  YYSYMBOL_1033_79 = 1033,                 /* $@79  */
  YYSYMBOL_opt_exception_clause = 1034,    /* opt_exception_clause  */
  YYSYMBOL_exception_handlers = 1035,      /* exception_handlers  */
  YYSYMBOL_exception_handler = 1036,       /* exception_handler  */
  YYSYMBOL_1037_80 = 1037,                 /* $@80  */
  YYSYMBOL_opt_sp_for_loop_direction = 1038, /* opt_sp_for_loop_direction  */
  YYSYMBOL_sp_for_loop_index_and_bounds = 1039, /* sp_for_loop_index_and_bounds  */
  YYSYMBOL_1040_81 = 1040,                 /* $@81  */
  YYSYMBOL_sp_for_loop_bounds = 1041,      /* sp_for_loop_bounds  */
  YYSYMBOL_loop_body = 1042,               /* loop_body  */
  YYSYMBOL_while_body = 1043,              /* while_body  */
  YYSYMBOL_1044_82 = 1044,                 /* $@82  */
  YYSYMBOL_repeat_body = 1045,             /* repeat_body  */
  YYSYMBOL_1046_83 = 1046,                 /* $@83  */
  YYSYMBOL_pop_sp_loop_label = 1047,       /* pop_sp_loop_label  */
  YYSYMBOL_sp_labeled_control = 1048,      /* sp_labeled_control  */
  YYSYMBOL_1049_84 = 1049,                 /* $@84  */
  YYSYMBOL_1050_85 = 1050,                 /* $@85  */
  YYSYMBOL_1051_86 = 1051,                 /* $@86  */
  YYSYMBOL_1052_87 = 1052,                 /* $@87  */
  YYSYMBOL_1053_88 = 1053,                 /* $@88  */
  YYSYMBOL_1054_89 = 1054,                 /* $@89  */
  YYSYMBOL_sp_unlabeled_control = 1055,    /* sp_unlabeled_control  */
  YYSYMBOL_1056_90 = 1056,                 /* $@90  */
  YYSYMBOL_1057_91 = 1057,                 /* $@91  */
  YYSYMBOL_1058_92 = 1058,                 /* $@92  */
  YYSYMBOL_1059_93 = 1059,                 /* $@93  */
  YYSYMBOL_1060_94 = 1060,                 /* $@94  */
  YYSYMBOL_trg_action_time = 1061,         /* trg_action_time  */
  YYSYMBOL_trg_event = 1062,               /* trg_event  */
  YYSYMBOL_change_tablespace_access = 1063, /* change_tablespace_access  */
  YYSYMBOL_change_tablespace_info = 1064,  /* change_tablespace_info  */
  YYSYMBOL_tablespace_info = 1065,         /* tablespace_info  */
  YYSYMBOL_opt_logfile_group_name = 1066,  /* opt_logfile_group_name  */
  YYSYMBOL_alter_tablespace_info = 1067,   /* alter_tablespace_info  */
  YYSYMBOL_logfile_group_info = 1068,      /* logfile_group_info  */
  YYSYMBOL_alter_logfile_group_info = 1069, /* alter_logfile_group_info  */
  YYSYMBOL_add_log_file = 1070,            /* add_log_file  */
  YYSYMBOL_change_ts_option_list = 1071,   /* change_ts_option_list  */
  YYSYMBOL_1072_95 = 1072,                 /* $@95  */
  YYSYMBOL_change_ts_options = 1073,       /* change_ts_options  */
  YYSYMBOL_change_ts_option = 1074,        /* change_ts_option  */
  YYSYMBOL_tablespace_option_list = 1075,  /* tablespace_option_list  */
  YYSYMBOL_tablespace_options = 1076,      /* tablespace_options  */
  YYSYMBOL_tablespace_option = 1077,       /* tablespace_option  */
  YYSYMBOL_alter_tablespace_option_list = 1078, /* alter_tablespace_option_list  */
  YYSYMBOL_alter_tablespace_options = 1079, /* alter_tablespace_options  */
  YYSYMBOL_alter_tablespace_option = 1080, /* alter_tablespace_option  */
  YYSYMBOL_logfile_group_option_list = 1081, /* logfile_group_option_list  */
  YYSYMBOL_logfile_group_options = 1082,   /* logfile_group_options  */
  YYSYMBOL_logfile_group_option = 1083,    /* logfile_group_option  */
  YYSYMBOL_alter_logfile_group_option_list = 1084, /* alter_logfile_group_option_list  */
  YYSYMBOL_alter_logfile_group_options = 1085, /* alter_logfile_group_options  */
  YYSYMBOL_alter_logfile_group_option = 1086, /* alter_logfile_group_option  */
  YYSYMBOL_ts_datafile = 1087,             /* ts_datafile  */
  YYSYMBOL_lg_undofile = 1088,             /* lg_undofile  */
  YYSYMBOL_lg_redofile = 1089,             /* lg_redofile  */
  YYSYMBOL_tablespace_name = 1090,         /* tablespace_name  */
  YYSYMBOL_logfile_group_name = 1091,      /* logfile_group_name  */
  YYSYMBOL_ts_access_mode = 1092,          /* ts_access_mode  */
  YYSYMBOL_opt_ts_initial_size = 1093,     /* opt_ts_initial_size  */
  YYSYMBOL_opt_ts_autoextend_size = 1094,  /* opt_ts_autoextend_size  */
  YYSYMBOL_opt_ts_max_size = 1095,         /* opt_ts_max_size  */
  YYSYMBOL_opt_ts_extent_size = 1096,      /* opt_ts_extent_size  */
  YYSYMBOL_opt_ts_undo_buffer_size = 1097, /* opt_ts_undo_buffer_size  */
  YYSYMBOL_opt_ts_redo_buffer_size = 1098, /* opt_ts_redo_buffer_size  */
  YYSYMBOL_opt_ts_nodegroup = 1099,        /* opt_ts_nodegroup  */
  YYSYMBOL_opt_ts_comment = 1100,          /* opt_ts_comment  */
  YYSYMBOL_opt_ts_engine = 1101,           /* opt_ts_engine  */
  YYSYMBOL_opt_ts_wait = 1102,             /* opt_ts_wait  */
  YYSYMBOL_ts_wait = 1103,                 /* ts_wait  */
  YYSYMBOL_size_number = 1104,             /* size_number  */
  YYSYMBOL_create_body = 1105,             /* create_body  */
  YYSYMBOL_1106_96 = 1106,                 /* $@96  */
  YYSYMBOL_create_like = 1107,             /* create_like  */
  YYSYMBOL_opt_create_select = 1108,       /* opt_create_select  */
  YYSYMBOL_create_select_query_expression = 1109, /* create_select_query_expression  */
  YYSYMBOL_opt_create_partitioning = 1110, /* opt_create_partitioning  */
  YYSYMBOL_opt_partitioning = 1111,        /* opt_partitioning  */
  YYSYMBOL_partitioning = 1112,            /* partitioning  */
  YYSYMBOL_1113_97 = 1113,                 /* $@97  */
  YYSYMBOL_have_partitioning = 1114,       /* have_partitioning  */
  YYSYMBOL_partition_entry = 1115,         /* partition_entry  */
  YYSYMBOL_1116_98 = 1116,                 /* $@98  */
  YYSYMBOL_partition = 1117,               /* partition  */
  YYSYMBOL_1118_99 = 1118,                 /* $@99  */
  YYSYMBOL_part_type_def = 1119,           /* part_type_def  */
  YYSYMBOL_1120_100 = 1120,                /* $@100  */
  YYSYMBOL_1121_101 = 1121,                /* $@101  */
  YYSYMBOL_1122_102 = 1122,                /* $@102  */
  YYSYMBOL_opt_linear = 1123,              /* opt_linear  */
  YYSYMBOL_opt_key_algo = 1124,            /* opt_key_algo  */
  YYSYMBOL_part_field_list = 1125,         /* part_field_list  */
  YYSYMBOL_part_field_item_list = 1126,    /* part_field_item_list  */
  YYSYMBOL_part_field_item = 1127,         /* part_field_item  */
  YYSYMBOL_part_column_list = 1128,        /* part_column_list  */
  YYSYMBOL_part_func = 1129,               /* part_func  */
  YYSYMBOL_sub_part_func = 1130,           /* sub_part_func  */
  YYSYMBOL_opt_num_parts = 1131,           /* opt_num_parts  */
  YYSYMBOL_opt_sub_part = 1132,            /* opt_sub_part  */
  YYSYMBOL_1133_103 = 1133,                /* $@103  */
  YYSYMBOL_1134_104 = 1134,                /* $@104  */
  YYSYMBOL_sub_part_field_list = 1135,     /* sub_part_field_list  */
  YYSYMBOL_sub_part_field_item = 1136,     /* sub_part_field_item  */
  YYSYMBOL_part_func_expr = 1137,          /* part_func_expr  */
  YYSYMBOL_opt_num_subparts = 1138,        /* opt_num_subparts  */
  YYSYMBOL_part_defs = 1139,               /* part_defs  */
  YYSYMBOL_part_def_list = 1140,           /* part_def_list  */
  YYSYMBOL_part_definition = 1141,         /* part_definition  */
  YYSYMBOL_1142_105 = 1142,                /* $@105  */
  YYSYMBOL_part_name = 1143,               /* part_name  */
  YYSYMBOL_opt_part_values = 1144,         /* opt_part_values  */
  YYSYMBOL_1145_106 = 1145,                /* $@106  */
  YYSYMBOL_1146_107 = 1146,                /* $@107  */
  YYSYMBOL_part_func_max = 1147,           /* part_func_max  */
  YYSYMBOL_part_values_in = 1148,          /* part_values_in  */
  YYSYMBOL_part_value_list = 1149,         /* part_value_list  */
  YYSYMBOL_part_value_item = 1150,         /* part_value_item  */
  YYSYMBOL_1151_108 = 1151,                /* $@108  */
  YYSYMBOL_1152_109 = 1152,                /* $@109  */
  YYSYMBOL_part_value_item_list = 1153,    /* part_value_item_list  */
  YYSYMBOL_part_value_expr_item = 1154,    /* part_value_expr_item  */
  YYSYMBOL_opt_sub_partition = 1155,       /* opt_sub_partition  */
  YYSYMBOL_sub_part_list = 1156,           /* sub_part_list  */
  YYSYMBOL_sub_part_definition = 1157,     /* sub_part_definition  */
  YYSYMBOL_1158_110 = 1158,                /* $@110  */
  YYSYMBOL_sub_name = 1159,                /* sub_name  */
  YYSYMBOL_opt_part_options = 1160,        /* opt_part_options  */
  YYSYMBOL_opt_part_option_list = 1161,    /* opt_part_option_list  */
  YYSYMBOL_opt_part_option = 1162,         /* opt_part_option  */
  YYSYMBOL_opt_versioning_rotation = 1163, /* opt_versioning_rotation  */
  YYSYMBOL_1164_111 = 1164,                /* $@111  */
  YYSYMBOL_opt_versioning_interval_start = 1165, /* opt_versioning_interval_start  */
  YYSYMBOL_opt_as = 1166,                  /* opt_as  */
  YYSYMBOL_opt_create_database_options = 1167, /* opt_create_database_options  */
  YYSYMBOL_create_database_options = 1168, /* create_database_options  */
  YYSYMBOL_create_database_option = 1169,  /* create_database_option  */
  YYSYMBOL_opt_if_not_exists_table_element = 1170, /* opt_if_not_exists_table_element  */
  YYSYMBOL_opt_if_not_exists = 1171,       /* opt_if_not_exists  */
  YYSYMBOL_create_or_replace = 1172,       /* create_or_replace  */
  YYSYMBOL_opt_create_table_options = 1173, /* opt_create_table_options  */
  YYSYMBOL_create_table_options_space_separated = 1174, /* create_table_options_space_separated  */
  YYSYMBOL_create_table_options = 1175,    /* create_table_options  */
  YYSYMBOL_create_table_option = 1176,     /* create_table_option  */
  YYSYMBOL_1177_112 = 1177,                /* $@112  */
  YYSYMBOL_opt_versioning_option = 1178,   /* opt_versioning_option  */
  YYSYMBOL_versioning_option = 1179,       /* versioning_option  */
  YYSYMBOL_default_charset = 1180,         /* default_charset  */
  YYSYMBOL_default_collation = 1181,       /* default_collation  */
  YYSYMBOL_storage_engines = 1182,         /* storage_engines  */
  YYSYMBOL_known_storage_engines = 1183,   /* known_storage_engines  */
  YYSYMBOL_row_types = 1184,               /* row_types  */
  YYSYMBOL_merge_insert_types = 1185,      /* merge_insert_types  */
  YYSYMBOL_udf_type = 1186,                /* udf_type  */
  YYSYMBOL_create_field_list = 1187,       /* create_field_list  */
  YYSYMBOL_create_field_list_parens = 1188, /* create_field_list_parens  */
  YYSYMBOL_field_list = 1189,              /* field_list  */
  YYSYMBOL_field_list_item = 1190,         /* field_list_item  */
  YYSYMBOL_column_def = 1191,              /* column_def  */
  YYSYMBOL_key_def = 1192,                 /* key_def  */
  YYSYMBOL_1193_113 = 1193,                /* $@113  */
  YYSYMBOL_1194_114 = 1194,                /* $@114  */
  YYSYMBOL_1195_115 = 1195,                /* $@115  */
  YYSYMBOL_1196_116 = 1196,                /* $@116  */
  YYSYMBOL_1197_117 = 1197,                /* $@117  */
  YYSYMBOL_1198_118 = 1198,                /* $@118  */
  YYSYMBOL_1199_119 = 1199,                /* $@119  */
  YYSYMBOL_constraint_def = 1200,          /* constraint_def  */
  YYSYMBOL_period_for_system_time = 1201,  /* period_for_system_time  */
  YYSYMBOL_period_for_application_time = 1202, /* period_for_application_time  */
  YYSYMBOL_opt_check_constraint = 1203,    /* opt_check_constraint  */
  YYSYMBOL_check_constraint = 1204,        /* check_constraint  */
  YYSYMBOL_opt_constraint_no_id = 1205,    /* opt_constraint_no_id  */
  YYSYMBOL_opt_constraint = 1206,          /* opt_constraint  */
  YYSYMBOL_constraint = 1207,              /* constraint  */
  YYSYMBOL_field_spec = 1208,              /* field_spec  */
  YYSYMBOL_1209_120 = 1209,                /* @120  */
  YYSYMBOL_field_type_or_serial = 1210,    /* field_type_or_serial  */
  YYSYMBOL_1211_121 = 1211,                /* $@121  */
  YYSYMBOL_1212_122 = 1212,                /* $@122  */
  YYSYMBOL_opt_serial_attribute = 1213,    /* opt_serial_attribute  */
  YYSYMBOL_opt_serial_attribute_list = 1214, /* opt_serial_attribute_list  */
  YYSYMBOL_opt_asrow_attribute = 1215,     /* opt_asrow_attribute  */
  YYSYMBOL_opt_asrow_attribute_list = 1216, /* opt_asrow_attribute_list  */
  YYSYMBOL_field_def = 1217,               /* field_def  */
  YYSYMBOL_1218_123 = 1218,                /* $@123  */
  YYSYMBOL_opt_generated_always = 1219,    /* opt_generated_always  */
  YYSYMBOL_vcol_opt_specifier = 1220,      /* vcol_opt_specifier  */
  YYSYMBOL_vcol_opt_attribute = 1221,      /* vcol_opt_attribute  */
  YYSYMBOL_vcol_opt_attribute_list = 1222, /* vcol_opt_attribute_list  */
  YYSYMBOL_vcol_attribute = 1223,          /* vcol_attribute  */
  YYSYMBOL_parse_vcol_expr = 1224,         /* parse_vcol_expr  */
  YYSYMBOL_1225_124 = 1225,                /* $@124  */
  YYSYMBOL_parenthesized_expr = 1226,      /* parenthesized_expr  */
  YYSYMBOL_virtual_column_func = 1227,     /* virtual_column_func  */
  YYSYMBOL_expr_or_literal = 1228,         /* expr_or_literal  */
  YYSYMBOL_column_default_expr = 1229,     /* column_default_expr  */
  YYSYMBOL_field_type = 1230,              /* field_type  */
  YYSYMBOL_qualified_field_type = 1231,    /* qualified_field_type  */
  YYSYMBOL_field_type_all = 1232,          /* field_type_all  */
  YYSYMBOL_sp_param_field_type = 1233,     /* sp_param_field_type  */
  YYSYMBOL_field_type_numeric = 1234,      /* field_type_numeric  */
  YYSYMBOL_opt_binary_and_compression = 1235, /* opt_binary_and_compression  */
  YYSYMBOL_field_type_string = 1236,       /* field_type_string  */
  YYSYMBOL_sp_param_field_type_string = 1237, /* sp_param_field_type_string  */
  YYSYMBOL_field_type_temporal = 1238,     /* field_type_temporal  */
  YYSYMBOL_field_type_lob = 1239,          /* field_type_lob  */
  YYSYMBOL_field_type_misc = 1240,         /* field_type_misc  */
  YYSYMBOL_spatial_type = 1241,            /* spatial_type  */
  YYSYMBOL_char = 1242,                    /* char  */
  YYSYMBOL_nchar = 1243,                   /* nchar  */
  YYSYMBOL_varchar = 1244,                 /* varchar  */
  YYSYMBOL_nvarchar = 1245,                /* nvarchar  */
  YYSYMBOL_int_type = 1246,                /* int_type  */
  YYSYMBOL_real_type = 1247,               /* real_type  */
  YYSYMBOL_srid_option = 1248,             /* srid_option  */
  YYSYMBOL_float_options = 1249,           /* float_options  */
  YYSYMBOL_precision = 1250,               /* precision  */
  YYSYMBOL_field_options = 1251,           /* field_options  */
  YYSYMBOL_field_length = 1252,            /* field_length  */
  YYSYMBOL_opt_field_length = 1253,        /* opt_field_length  */
  YYSYMBOL_opt_field_length_default_1 = 1254, /* opt_field_length_default_1  */
  YYSYMBOL_opt_field_length_default_sp_param_varchar = 1255, /* opt_field_length_default_sp_param_varchar  */
  YYSYMBOL_opt_field_length_default_sp_param_char = 1256, /* opt_field_length_default_sp_param_char  */
  YYSYMBOL_opt_precision = 1257,           /* opt_precision  */
  YYSYMBOL_attribute_list = 1258,          /* attribute_list  */
  YYSYMBOL_attribute = 1259,               /* attribute  */
  YYSYMBOL_opt_compression_method = 1260,  /* opt_compression_method  */
  YYSYMBOL_opt_compressed = 1261,          /* opt_compressed  */
  YYSYMBOL_compressed = 1262,              /* compressed  */
  YYSYMBOL_compressed_deprecated_data_type_attribute = 1263, /* compressed_deprecated_data_type_attribute  */
  YYSYMBOL_compressed_deprecated_column_attribute = 1264, /* compressed_deprecated_column_attribute  */
  YYSYMBOL_asrow_attribute = 1265,         /* asrow_attribute  */
  YYSYMBOL_serial_attribute = 1266,        /* serial_attribute  */
  YYSYMBOL_with_or_without_system = 1267,  /* with_or_without_system  */
  YYSYMBOL_sp_param_type = 1268,           /* sp_param_type  */
  YYSYMBOL_charset = 1269,                 /* charset  */
  YYSYMBOL_charset_name = 1270,            /* charset_name  */
  YYSYMBOL_charset_name_or_default = 1271, /* charset_name_or_default  */
  YYSYMBOL_opt_load_data_charset = 1272,   /* opt_load_data_charset  */
  YYSYMBOL_old_or_new_charset_name = 1273, /* old_or_new_charset_name  */
  YYSYMBOL_old_or_new_charset_name_or_default = 1274, /* old_or_new_charset_name_or_default  */
  YYSYMBOL_collation_name = 1275,          /* collation_name  */
  YYSYMBOL_opt_collate = 1276,             /* opt_collate  */
  YYSYMBOL_collation_name_or_default = 1277, /* collation_name_or_default  */
  YYSYMBOL_opt_default = 1278,             /* opt_default  */
  YYSYMBOL_charset_or_alias = 1279,        /* charset_or_alias  */
  YYSYMBOL_collate = 1280,                 /* collate  */
  YYSYMBOL_opt_binary = 1281,              /* opt_binary  */
  YYSYMBOL_binary = 1282,                  /* binary  */
  YYSYMBOL_opt_bin_mod = 1283,             /* opt_bin_mod  */
  YYSYMBOL_ws_nweights = 1284,             /* ws_nweights  */
  YYSYMBOL_1285_125 = 1285,                /* $@125  */
  YYSYMBOL_ws_level_flag_desc = 1286,      /* ws_level_flag_desc  */
  YYSYMBOL_ws_level_flag_reverse = 1287,   /* ws_level_flag_reverse  */
  YYSYMBOL_ws_level_flags = 1288,          /* ws_level_flags  */
  YYSYMBOL_ws_level_number = 1289,         /* ws_level_number  */
  YYSYMBOL_ws_level_list_item = 1290,      /* ws_level_list_item  */
  YYSYMBOL_ws_level_list = 1291,           /* ws_level_list  */
  YYSYMBOL_ws_level_range = 1292,          /* ws_level_range  */
  YYSYMBOL_ws_level_list_or_range = 1293,  /* ws_level_list_or_range  */
  YYSYMBOL_opt_ws_levels = 1294,           /* opt_ws_levels  */
  YYSYMBOL_opt_primary = 1295,             /* opt_primary  */
  YYSYMBOL_references = 1296,              /* references  */
  YYSYMBOL_opt_ref_list = 1297,            /* opt_ref_list  */
  YYSYMBOL_ref_list = 1298,                /* ref_list  */
  YYSYMBOL_opt_match_clause = 1299,        /* opt_match_clause  */
  YYSYMBOL_opt_on_update_delete = 1300,    /* opt_on_update_delete  */
  YYSYMBOL_delete_option = 1301,           /* delete_option  */
  YYSYMBOL_constraint_key_type = 1302,     /* constraint_key_type  */
  YYSYMBOL_key_or_index = 1303,            /* key_or_index  */
  YYSYMBOL_opt_key_or_index = 1304,        /* opt_key_or_index  */
  YYSYMBOL_keys_or_index = 1305,           /* keys_or_index  */
  YYSYMBOL_opt_unique = 1306,              /* opt_unique  */
  YYSYMBOL_fulltext = 1307,                /* fulltext  */
  YYSYMBOL_spatial = 1308,                 /* spatial  */
  YYSYMBOL_normal_key_options = 1309,      /* normal_key_options  */
  YYSYMBOL_fulltext_key_options = 1310,    /* fulltext_key_options  */
  YYSYMBOL_spatial_key_options = 1311,     /* spatial_key_options  */
  YYSYMBOL_normal_key_opts = 1312,         /* normal_key_opts  */
  YYSYMBOL_spatial_key_opts = 1313,        /* spatial_key_opts  */
  YYSYMBOL_fulltext_key_opts = 1314,       /* fulltext_key_opts  */
  YYSYMBOL_opt_USING_key_algorithm = 1315, /* opt_USING_key_algorithm  */
  YYSYMBOL_opt_key_algorithm_clause = 1316, /* opt_key_algorithm_clause  */
  YYSYMBOL_key_using_alg = 1317,           /* key_using_alg  */
  YYSYMBOL_all_key_opt = 1318,             /* all_key_opt  */
  YYSYMBOL_normal_key_opt = 1319,          /* normal_key_opt  */
  YYSYMBOL_spatial_key_opt = 1320,         /* spatial_key_opt  */
  YYSYMBOL_fulltext_key_opt = 1321,        /* fulltext_key_opt  */
  YYSYMBOL_btree_or_rtree = 1322,          /* btree_or_rtree  */
  YYSYMBOL_key_list = 1323,                /* key_list  */
  YYSYMBOL_key_part = 1324,                /* key_part  */
  YYSYMBOL_opt_ident = 1325,               /* opt_ident  */
  YYSYMBOL_string_list = 1326,             /* string_list  */
  YYSYMBOL_alter = 1327,                   /* alter  */
  YYSYMBOL_1328_126 = 1328,                /* $@126  */
  YYSYMBOL_1329_127 = 1329,                /* $@127  */
  YYSYMBOL_1330_128 = 1330,                /* $@128  */
  YYSYMBOL_1331_129 = 1331,                /* $@129  */
  YYSYMBOL_1332_130 = 1332,                /* $@130  */
  YYSYMBOL_1333_131 = 1333,                /* $@131  */
  YYSYMBOL_1334_132 = 1334,                /* $@132  */
  YYSYMBOL_1335_133 = 1335,                /* $@133  */
  YYSYMBOL_1336_134 = 1336,                /* $@134  */
  YYSYMBOL_1337_135 = 1337,                /* $@135  */
  YYSYMBOL_1338_136 = 1338,                /* $@136  */
  YYSYMBOL_account_locking_option = 1339,  /* account_locking_option  */
  YYSYMBOL_opt_password_expire_option = 1340, /* opt_password_expire_option  */
  YYSYMBOL_opt_account_locking_and_opt_password_expiration = 1341, /* opt_account_locking_and_opt_password_expiration  */
  YYSYMBOL_ev_alter_on_schedule_completion = 1342, /* ev_alter_on_schedule_completion  */
  YYSYMBOL_opt_ev_rename_to = 1343,        /* opt_ev_rename_to  */
  YYSYMBOL_opt_ev_sql_stmt = 1344,         /* opt_ev_sql_stmt  */
  YYSYMBOL_ident_or_empty = 1345,          /* ident_or_empty  */
  YYSYMBOL_alter_commands = 1346,          /* alter_commands  */
  YYSYMBOL_1347_137 = 1347,                /* $@137  */
  YYSYMBOL_1348_138 = 1348,                /* $@138  */
  YYSYMBOL_1349_139 = 1349,                /* $@139  */
  YYSYMBOL_remove_partitioning = 1350,     /* remove_partitioning  */
  YYSYMBOL_all_or_alt_part_name_list = 1351, /* all_or_alt_part_name_list  */
  YYSYMBOL_add_partition_rule = 1352,      /* add_partition_rule  */
  YYSYMBOL_1353_140 = 1353,                /* $@140  */
  YYSYMBOL_add_part_extra = 1354,          /* add_part_extra  */
  YYSYMBOL_reorg_partition_rule = 1355,    /* reorg_partition_rule  */
  YYSYMBOL_1356_141 = 1356,                /* $@141  */
  YYSYMBOL_reorg_parts_rule = 1357,        /* reorg_parts_rule  */
  YYSYMBOL_1358_142 = 1358,                /* $@142  */
  YYSYMBOL_alt_part_name_list = 1359,      /* alt_part_name_list  */
  YYSYMBOL_alt_part_name_item = 1360,      /* alt_part_name_item  */
  YYSYMBOL_alter_list = 1361,              /* alter_list  */
  YYSYMBOL_add_column = 1362,              /* add_column  */
  YYSYMBOL_alter_list_item = 1363,         /* alter_list_item  */
  YYSYMBOL_opt_index_lock_algorithm = 1364, /* opt_index_lock_algorithm  */
  YYSYMBOL_alter_algorithm_option = 1365,  /* alter_algorithm_option  */
  YYSYMBOL_alter_lock_option = 1366,       /* alter_lock_option  */
  YYSYMBOL_opt_column = 1367,              /* opt_column  */
  YYSYMBOL_opt_ignore = 1368,              /* opt_ignore  */
  YYSYMBOL_alter_options = 1369,           /* alter_options  */
  YYSYMBOL_1370_143 = 1370,                /* $@143  */
  YYSYMBOL_alter_options_part2 = 1371,     /* alter_options_part2  */
  YYSYMBOL_alter_option_list = 1372,       /* alter_option_list  */
  YYSYMBOL_alter_option = 1373,            /* alter_option  */
  YYSYMBOL_opt_restrict = 1374,            /* opt_restrict  */
  YYSYMBOL_opt_place = 1375,               /* opt_place  */
  YYSYMBOL_opt_to = 1376,                  /* opt_to  */
  YYSYMBOL_slave = 1377,                   /* slave  */
  YYSYMBOL_1378_144 = 1378,                /* $@144  */
  YYSYMBOL_1379_145 = 1379,                /* $@145  */
  YYSYMBOL_start = 1380,                   /* start  */
  YYSYMBOL_opt_start_transaction_option_list = 1381, /* opt_start_transaction_option_list  */
  YYSYMBOL_start_transaction_option_list = 1382, /* start_transaction_option_list  */
  YYSYMBOL_start_transaction_option = 1383, /* start_transaction_option  */
  YYSYMBOL_slave_thread_opts = 1384,       /* slave_thread_opts  */
  YYSYMBOL_1385_146 = 1385,                /* $@146  */
  YYSYMBOL_slave_thread_opt_list = 1386,   /* slave_thread_opt_list  */
  YYSYMBOL_slave_thread_opt = 1387,        /* slave_thread_opt  */
  YYSYMBOL_slave_until = 1388,             /* slave_until  */
  YYSYMBOL_slave_until_opts = 1389,        /* slave_until_opts  */
  YYSYMBOL_checksum = 1390,                /* checksum  */
  YYSYMBOL_1391_147 = 1391,                /* $@147  */
  YYSYMBOL_opt_checksum_type = 1392,       /* opt_checksum_type  */
  YYSYMBOL_repair_table_or_view = 1393,    /* repair_table_or_view  */
  YYSYMBOL_1394_148 = 1394,                /* $@148  */
  YYSYMBOL_repair = 1395,                  /* repair  */
  YYSYMBOL_1396_149 = 1396,                /* $@149  */
  YYSYMBOL_opt_mi_repair_type = 1397,      /* opt_mi_repair_type  */
  YYSYMBOL_mi_repair_types = 1398,         /* mi_repair_types  */
  YYSYMBOL_mi_repair_type = 1399,          /* mi_repair_type  */
  YYSYMBOL_opt_view_repair_type = 1400,    /* opt_view_repair_type  */
  YYSYMBOL_analyze = 1401,                 /* analyze  */
  YYSYMBOL_1402_150 = 1402,                /* $@150  */
  YYSYMBOL_analyze_table_list = 1403,      /* analyze_table_list  */
  YYSYMBOL_analyze_table_elem_spec = 1404, /* analyze_table_elem_spec  */
  YYSYMBOL_opt_persistent_stat_clause = 1405, /* opt_persistent_stat_clause  */
  YYSYMBOL_persistent_stat_spec = 1406,    /* persistent_stat_spec  */
  YYSYMBOL_persistent_column_stat_spec = 1407, /* persistent_column_stat_spec  */
  YYSYMBOL_1408_151 = 1408,                /* $@151  */
  YYSYMBOL_persistent_index_stat_spec = 1409, /* persistent_index_stat_spec  */
  YYSYMBOL_1410_152 = 1410,                /* $@152  */
  YYSYMBOL_table_column_list = 1411,       /* table_column_list  */
  YYSYMBOL_table_index_list = 1412,        /* table_index_list  */
  YYSYMBOL_table_index_name = 1413,        /* table_index_name  */
  YYSYMBOL_binlog_base64_event = 1414,     /* binlog_base64_event  */
  YYSYMBOL_check_view_or_table = 1415,     /* check_view_or_table  */
  YYSYMBOL_1416_153 = 1416,                /* $@153  */
  YYSYMBOL_check = 1417,                   /* check  */
  YYSYMBOL_1418_154 = 1418,                /* $@154  */
  YYSYMBOL_opt_mi_check_type = 1419,       /* opt_mi_check_type  */
  YYSYMBOL_mi_check_types = 1420,          /* mi_check_types  */
  YYSYMBOL_mi_check_type = 1421,           /* mi_check_type  */
  YYSYMBOL_opt_view_check_type = 1422,     /* opt_view_check_type  */
  YYSYMBOL_optimize = 1423,                /* optimize  */
  YYSYMBOL_1424_155 = 1424,                /* $@155  */
  YYSYMBOL_opt_no_write_to_binlog = 1425,  /* opt_no_write_to_binlog  */
  YYSYMBOL_rename = 1426,                  /* rename  */
  YYSYMBOL_1427_156 = 1427,                /* $@156  */
  YYSYMBOL_rename_list = 1428,             /* rename_list  */
  YYSYMBOL_table_to_table_list = 1429,     /* table_to_table_list  */
  YYSYMBOL_table_to_table = 1430,          /* table_to_table  */
  YYSYMBOL_keycache = 1431,                /* keycache  */
  YYSYMBOL_1432_157 = 1432,                /* $@157  */
  YYSYMBOL_keycache_list_or_parts = 1433,  /* keycache_list_or_parts  */
  YYSYMBOL_keycache_list = 1434,           /* keycache_list  */
  YYSYMBOL_assign_to_keycache = 1435,      /* assign_to_keycache  */
  YYSYMBOL_assign_to_keycache_parts = 1436, /* assign_to_keycache_parts  */
  YYSYMBOL_key_cache_name = 1437,          /* key_cache_name  */
  YYSYMBOL_preload = 1438,                 /* preload  */
  YYSYMBOL_1439_158 = 1439,                /* $@158  */
  YYSYMBOL_preload_list_or_parts = 1440,   /* preload_list_or_parts  */
  YYSYMBOL_preload_list = 1441,            /* preload_list  */
  YYSYMBOL_preload_keys = 1442,            /* preload_keys  */
  YYSYMBOL_preload_keys_parts = 1443,      /* preload_keys_parts  */
  YYSYMBOL_adm_partition = 1444,           /* adm_partition  */
  YYSYMBOL_1445_159 = 1445,                /* $@159  */
  YYSYMBOL_cache_keys_spec = 1446,         /* cache_keys_spec  */
  YYSYMBOL_1447_160 = 1447,                /* $@160  */
  YYSYMBOL_cache_key_list_or_empty = 1448, /* cache_key_list_or_empty  */
  YYSYMBOL_opt_ignore_leaves = 1449,       /* opt_ignore_leaves  */
  YYSYMBOL_select = 1450,                  /* select  */
  YYSYMBOL_1451_161 = 1451,                /* $@161  */
  YYSYMBOL_1452_162 = 1452,                /* $@162  */
  YYSYMBOL_select_into = 1453,             /* select_into  */
  YYSYMBOL_1454_163 = 1454,                /* $@163  */
  YYSYMBOL_1455_164 = 1455,                /* $@164  */
  YYSYMBOL_simple_table = 1456,            /* simple_table  */
  YYSYMBOL_table_value_constructor = 1457, /* table_value_constructor  */
  YYSYMBOL_1458_165 = 1458,                /* $@165  */
  YYSYMBOL_query_specification_start = 1459, /* query_specification_start  */
  YYSYMBOL_1460_166 = 1460,                /* $@166  */
  YYSYMBOL_1461_167 = 1461,                /* $@167  */
  YYSYMBOL_query_specification = 1462,     /* query_specification  */
  YYSYMBOL_select_into_query_specification = 1463, /* select_into_query_specification  */
  YYSYMBOL_query_expression = 1464,        /* query_expression  */
  YYSYMBOL_query_expression_no_with_clause = 1465, /* query_expression_no_with_clause  */
  YYSYMBOL_query_expression_body_ext = 1466, /* query_expression_body_ext  */
  YYSYMBOL_1467_168 = 1467,                /* $@168  */
  YYSYMBOL_1468_169 = 1468,                /* $@169  */
  YYSYMBOL_query_expression_body_ext_parens = 1469, /* query_expression_body_ext_parens  */
  YYSYMBOL_query_expression_body = 1470,   /* query_expression_body  */
  YYSYMBOL_1471_170 = 1471,                /* $@170  */
  YYSYMBOL_query_primary = 1472,           /* query_primary  */
  YYSYMBOL_query_simple = 1473,            /* query_simple  */
  YYSYMBOL_subselect = 1474,               /* subselect  */
  YYSYMBOL_subquery = 1475,                /* subquery  */
  YYSYMBOL_opt_from_clause = 1476,         /* opt_from_clause  */
  YYSYMBOL_from_clause = 1477,             /* from_clause  */
  YYSYMBOL_table_reference_list = 1478,    /* table_reference_list  */
  YYSYMBOL_select_options = 1479,          /* select_options  */
  YYSYMBOL_opt_history_unit = 1480,        /* opt_history_unit  */
  YYSYMBOL_history_point = 1481,           /* history_point  */
  YYSYMBOL_for_portion_of_time_clause = 1482, /* for_portion_of_time_clause  */
  YYSYMBOL_opt_for_portion_of_time_clause = 1483, /* opt_for_portion_of_time_clause  */
  YYSYMBOL_opt_for_system_time_clause = 1484, /* opt_for_system_time_clause  */
  YYSYMBOL_system_time_expr = 1485,        /* system_time_expr  */
  YYSYMBOL_select_option_list = 1486,      /* select_option_list  */
  YYSYMBOL_select_option = 1487,           /* select_option  */
  YYSYMBOL_select_lock_type = 1488,        /* select_lock_type  */
  YYSYMBOL_opt_select_lock_type = 1489,    /* opt_select_lock_type  */
  YYSYMBOL_opt_lock_wait_timeout_new = 1490, /* opt_lock_wait_timeout_new  */
  YYSYMBOL_select_item_list = 1491,        /* select_item_list  */
  YYSYMBOL_select_item = 1492,             /* select_item  */
  YYSYMBOL_remember_tok_start = 1493,      /* remember_tok_start  */
  YYSYMBOL_remember_name = 1494,           /* remember_name  */
  YYSYMBOL_remember_end = 1495,            /* remember_end  */
  YYSYMBOL_remember_end_opt = 1496,        /* remember_end_opt  */
  YYSYMBOL_select_alias = 1497,            /* select_alias  */
  YYSYMBOL_opt_default_time_precision = 1498, /* opt_default_time_precision  */
  YYSYMBOL_opt_time_precision = 1499,      /* opt_time_precision  */
  YYSYMBOL_optional_braces = 1500,         /* optional_braces  */
  YYSYMBOL_expr = 1501,                    /* expr  */
  YYSYMBOL_boolean_test = 1502,            /* boolean_test  */
  YYSYMBOL_predicate = 1503,               /* predicate  */
  YYSYMBOL_bit_expr = 1504,                /* bit_expr  */
  YYSYMBOL_or = 1505,                      /* or  */
  YYSYMBOL_and = 1506,                     /* and  */
  YYSYMBOL_not = 1507,                     /* not  */
  YYSYMBOL_not2 = 1508,                    /* not2  */
  YYSYMBOL_comp_op = 1509,                 /* comp_op  */
  YYSYMBOL_all_or_any = 1510,              /* all_or_any  */
  YYSYMBOL_opt_dyncol_type = 1511,         /* opt_dyncol_type  */
  YYSYMBOL_dyncol_type = 1512,             /* dyncol_type  */
  YYSYMBOL_numeric_dyncol_type = 1513,     /* numeric_dyncol_type  */
  YYSYMBOL_temporal_dyncol_type = 1514,    /* temporal_dyncol_type  */
  YYSYMBOL_string_dyncol_type = 1515,      /* string_dyncol_type  */
  YYSYMBOL_1516_171 = 1516,                /* $@171  */
  YYSYMBOL_dyncall_create_element = 1517,  /* dyncall_create_element  */
  YYSYMBOL_dyncall_create_list = 1518,     /* dyncall_create_list  */
  YYSYMBOL_plsql_cursor_attr = 1519,       /* plsql_cursor_attr  */
  YYSYMBOL_explicit_cursor_attr = 1520,    /* explicit_cursor_attr  */
  YYSYMBOL_trim_operands = 1521,           /* trim_operands  */
  YYSYMBOL_trim_operands_regular = 1522,   /* trim_operands_regular  */
  YYSYMBOL_trim_operands_special = 1523,   /* trim_operands_special  */
  YYSYMBOL_column_default_non_parenthesized_expr = 1524, /* column_default_non_parenthesized_expr  */
  YYSYMBOL_primary_expr = 1525,            /* primary_expr  */
  YYSYMBOL_string_factor_expr = 1526,      /* string_factor_expr  */
  YYSYMBOL_simple_expr = 1527,             /* simple_expr  */
  YYSYMBOL_mysql_concatenation_expr = 1528, /* mysql_concatenation_expr  */
  YYSYMBOL_function_call_keyword_timestamp = 1529, /* function_call_keyword_timestamp  */
  YYSYMBOL_function_call_keyword = 1530,   /* function_call_keyword  */
  YYSYMBOL_substring_operands = 1531,      /* substring_operands  */
  YYSYMBOL_substring_operands_regular = 1532, /* substring_operands_regular  */
  YYSYMBOL_substring_operands_special = 1533, /* substring_operands_special  */
  YYSYMBOL_function_call_nonkeyword = 1534, /* function_call_nonkeyword  */
  YYSYMBOL_function_call_conflict = 1535,  /* function_call_conflict  */
  YYSYMBOL_geometry_function = 1536,       /* geometry_function  */
  YYSYMBOL_function_call_generic = 1537,   /* function_call_generic  */
  YYSYMBOL_1538_172 = 1538,                /* @172  */
  YYSYMBOL_fulltext_options = 1539,        /* fulltext_options  */
  YYSYMBOL_opt_natural_language_mode = 1540, /* opt_natural_language_mode  */
  YYSYMBOL_opt_query_expansion = 1541,     /* opt_query_expansion  */
  YYSYMBOL_opt_udf_expr_list = 1542,       /* opt_udf_expr_list  */
  YYSYMBOL_udf_expr_list = 1543,           /* udf_expr_list  */
  YYSYMBOL_udf_expr = 1544,                /* udf_expr  */
  YYSYMBOL_sum_expr = 1545,                /* sum_expr  */
  YYSYMBOL_1546_173 = 1546,                /* $@173  */
  YYSYMBOL_1547_174 = 1547,                /* $@174  */
  YYSYMBOL_1548_175 = 1548,                /* $@175  */
  YYSYMBOL_window_func_expr = 1549,        /* window_func_expr  */
  YYSYMBOL_window_func = 1550,             /* window_func  */
  YYSYMBOL_simple_window_func = 1551,      /* simple_window_func  */
  YYSYMBOL_inverse_distribution_function = 1552, /* inverse_distribution_function  */
  YYSYMBOL_percentile_function = 1553,     /* percentile_function  */
  YYSYMBOL_1554_176 = 1554,                /* $@176  */
  YYSYMBOL_inverse_distribution_function_def = 1555, /* inverse_distribution_function_def  */
  YYSYMBOL_order_by_single_element_list = 1556, /* order_by_single_element_list  */
  YYSYMBOL_window_name = 1557,             /* window_name  */
  YYSYMBOL_variable = 1558,                /* variable  */
  YYSYMBOL_1559_177 = 1559,                /* $@177  */
  YYSYMBOL_variable_aux = 1560,            /* variable_aux  */
  YYSYMBOL_opt_distinct = 1561,            /* opt_distinct  */
  YYSYMBOL_opt_gconcat_separator = 1562,   /* opt_gconcat_separator  */
  YYSYMBOL_opt_gorder_clause = 1563,       /* opt_gorder_clause  */
  YYSYMBOL_gorder_list = 1564,             /* gorder_list  */
  YYSYMBOL_opt_glimit_clause = 1565,       /* opt_glimit_clause  */
  YYSYMBOL_glimit_clause_init = 1566,      /* glimit_clause_init  */
  YYSYMBOL_glimit_clause = 1567,           /* glimit_clause  */
  YYSYMBOL_glimit_options = 1568,          /* glimit_options  */
  YYSYMBOL_in_sum_expr = 1569,             /* in_sum_expr  */
  YYSYMBOL_1570_178 = 1570,                /* $@178  */
  YYSYMBOL_cast_type = 1571,               /* cast_type  */
  YYSYMBOL_1572_179 = 1572,                /* $@179  */
  YYSYMBOL_1573_180 = 1573,                /* $@180  */
  YYSYMBOL_1574_181 = 1574,                /* $@181  */
  YYSYMBOL_cast_type_numeric = 1575,       /* cast_type_numeric  */
  YYSYMBOL_cast_type_temporal = 1576,      /* cast_type_temporal  */
  YYSYMBOL_opt_expr_list = 1577,           /* opt_expr_list  */
  YYSYMBOL_expr_list = 1578,               /* expr_list  */
  YYSYMBOL_ident_list_arg = 1579,          /* ident_list_arg  */
  YYSYMBOL_ident_list = 1580,              /* ident_list  */
  YYSYMBOL_when_list = 1581,               /* when_list  */
  YYSYMBOL_when_list_opt_else = 1582,      /* when_list_opt_else  */
  YYSYMBOL_table_ref = 1583,               /* table_ref  */
  YYSYMBOL_join_table_list = 1584,         /* join_table_list  */
  YYSYMBOL_esc_table_ref = 1585,           /* esc_table_ref  */
  YYSYMBOL_derived_table_list = 1586,      /* derived_table_list  */
  YYSYMBOL_join_table = 1587,              /* join_table  */
  YYSYMBOL_1588_182 = 1588,                /* $@182  */
  YYSYMBOL_1589_183 = 1589,                /* $@183  */
  YYSYMBOL_1590_184 = 1590,                /* $@184  */
  YYSYMBOL_1591_185 = 1591,                /* $@185  */
  YYSYMBOL_1592_186 = 1592,                /* $@186  */
  YYSYMBOL_1593_187 = 1593,                /* $@187  */
  YYSYMBOL_inner_join = 1594,              /* inner_join  */
  YYSYMBOL_normal_join = 1595,             /* normal_join  */
  YYSYMBOL_opt_use_partition = 1596,       /* opt_use_partition  */
  YYSYMBOL_use_partition = 1597,           /* use_partition  */
  YYSYMBOL_table_factor = 1598,            /* table_factor  */
  YYSYMBOL_table_primary_ident_opt_parens = 1599, /* table_primary_ident_opt_parens  */
  YYSYMBOL_table_primary_derived_opt_parens = 1600, /* table_primary_derived_opt_parens  */
  YYSYMBOL_table_reference_list_parens = 1601, /* table_reference_list_parens  */
  YYSYMBOL_nested_table_reference_list = 1602, /* nested_table_reference_list  */
  YYSYMBOL_join_table_parens = 1603,       /* join_table_parens  */
  YYSYMBOL_table_primary_ident = 1604,     /* table_primary_ident  */
  YYSYMBOL_table_primary_derived = 1605,   /* table_primary_derived  */
  YYSYMBOL_opt_outer = 1606,               /* opt_outer  */
  YYSYMBOL_index_hint_clause = 1607,       /* index_hint_clause  */
  YYSYMBOL_index_hint_type = 1608,         /* index_hint_type  */
  YYSYMBOL_index_hint_definition = 1609,   /* index_hint_definition  */
  YYSYMBOL_1610_188 = 1610,                /* $@188  */
  YYSYMBOL_1611_189 = 1611,                /* $@189  */
  YYSYMBOL_index_hints_list = 1612,        /* index_hints_list  */
  YYSYMBOL_opt_index_hints_list = 1613,    /* opt_index_hints_list  */
  YYSYMBOL_1614_190 = 1614,                /* $@190  */
  YYSYMBOL_opt_key_definition = 1615,      /* opt_key_definition  */
  YYSYMBOL_1616_191 = 1616,                /* $@191  */
  YYSYMBOL_opt_key_usage_list = 1617,      /* opt_key_usage_list  */
  YYSYMBOL_key_usage_element = 1618,       /* key_usage_element  */
  YYSYMBOL_key_usage_list = 1619,          /* key_usage_list  */
  YYSYMBOL_using_list = 1620,              /* using_list  */
  YYSYMBOL_interval = 1621,                /* interval  */
  YYSYMBOL_interval_time_stamp = 1622,     /* interval_time_stamp  */
  YYSYMBOL_date_time_type = 1623,          /* date_time_type  */
  YYSYMBOL_table_alias = 1624,             /* table_alias  */
  YYSYMBOL_opt_table_alias_clause = 1625,  /* opt_table_alias_clause  */
  YYSYMBOL_table_alias_clause = 1626,      /* table_alias_clause  */
  YYSYMBOL_opt_all = 1627,                 /* opt_all  */
  YYSYMBOL_opt_where_clause = 1628,        /* opt_where_clause  */
  YYSYMBOL_1629_192 = 1629,                /* $@192  */
  YYSYMBOL_opt_having_clause = 1630,       /* opt_having_clause  */
  YYSYMBOL_1631_193 = 1631,                /* $@193  */
  YYSYMBOL_opt_group_clause = 1632,        /* opt_group_clause  */
  YYSYMBOL_group_list = 1633,              /* group_list  */
  YYSYMBOL_olap_opt = 1634,                /* olap_opt  */
  YYSYMBOL_opt_window_clause = 1635,       /* opt_window_clause  */
  YYSYMBOL_window_def_list = 1636,         /* window_def_list  */
  YYSYMBOL_window_def = 1637,              /* window_def  */
  YYSYMBOL_window_spec = 1638,             /* window_spec  */
  YYSYMBOL_1639_194 = 1639,                /* $@194  */
  YYSYMBOL_opt_window_ref = 1640,          /* opt_window_ref  */
  YYSYMBOL_opt_window_partition_clause = 1641, /* opt_window_partition_clause  */
  YYSYMBOL_opt_window_order_clause = 1642, /* opt_window_order_clause  */
  YYSYMBOL_opt_window_frame_clause = 1643, /* opt_window_frame_clause  */
  YYSYMBOL_window_frame_units = 1644,      /* window_frame_units  */
  YYSYMBOL_window_frame_extent = 1645,     /* window_frame_extent  */
  YYSYMBOL_window_frame_start = 1646,      /* window_frame_start  */
  YYSYMBOL_window_frame_bound = 1647,      /* window_frame_bound  */
  YYSYMBOL_opt_window_frame_exclusion = 1648, /* opt_window_frame_exclusion  */
  YYSYMBOL_alter_order_clause = 1649,      /* alter_order_clause  */
  YYSYMBOL_alter_order_list = 1650,        /* alter_order_list  */
  YYSYMBOL_alter_order_item = 1651,        /* alter_order_item  */
  YYSYMBOL_opt_order_clause = 1652,        /* opt_order_clause  */
  YYSYMBOL_order_clause = 1653,            /* order_clause  */
  YYSYMBOL_1654_195 = 1654,                /* $@195  */
  YYSYMBOL_order_list = 1655,              /* order_list  */
  YYSYMBOL_order_dir = 1656,               /* order_dir  */
  YYSYMBOL_opt_limit_clause = 1657,        /* opt_limit_clause  */
  YYSYMBOL_limit_clause = 1658,            /* limit_clause  */
  YYSYMBOL_opt_global_limit_clause = 1659, /* opt_global_limit_clause  */
  YYSYMBOL_limit_options = 1660,           /* limit_options  */
  YYSYMBOL_limit_option = 1661,            /* limit_option  */
  YYSYMBOL_limit_rows_option = 1662,       /* limit_rows_option  */
  YYSYMBOL_delete_limit_clause = 1663,     /* delete_limit_clause  */
  YYSYMBOL_order_limit_lock = 1664,        /* order_limit_lock  */
  YYSYMBOL_opt_order_limit_lock = 1665,    /* opt_order_limit_lock  */
  YYSYMBOL_query_expression_tail = 1666,   /* query_expression_tail  */
  YYSYMBOL_opt_query_expression_tail = 1667, /* opt_query_expression_tail  */
  YYSYMBOL_opt_procedure_or_into = 1668,   /* opt_procedure_or_into  */
  YYSYMBOL_order_or_limit = 1669,          /* order_or_limit  */
  YYSYMBOL_opt_plus = 1670,                /* opt_plus  */
  YYSYMBOL_int_num = 1671,                 /* int_num  */
  YYSYMBOL_ulong_num = 1672,               /* ulong_num  */
  YYSYMBOL_real_ulong_num = 1673,          /* real_ulong_num  */
  YYSYMBOL_longlong_num = 1674,            /* longlong_num  */
  YYSYMBOL_ulonglong_num = 1675,           /* ulonglong_num  */
  YYSYMBOL_real_ulonglong_num = 1676,      /* real_ulonglong_num  */
  YYSYMBOL_dec_num_error = 1677,           /* dec_num_error  */
  YYSYMBOL_dec_num = 1678,                 /* dec_num  */
  YYSYMBOL_choice = 1679,                  /* choice  */
  YYSYMBOL_bool = 1680,                    /* bool  */
  YYSYMBOL_procedure_clause = 1681,        /* procedure_clause  */
  YYSYMBOL_1682_196 = 1682,                /* $@196  */
  YYSYMBOL_procedure_list = 1683,          /* procedure_list  */
  YYSYMBOL_procedure_list2 = 1684,         /* procedure_list2  */
  YYSYMBOL_procedure_item = 1685,          /* procedure_item  */
  YYSYMBOL_select_var_list_init = 1686,    /* select_var_list_init  */
  YYSYMBOL_1687_197 = 1687,                /* $@197  */
  YYSYMBOL_select_var_list = 1688,         /* select_var_list  */
  YYSYMBOL_select_var_ident = 1689,        /* select_var_ident  */
  YYSYMBOL_select_outvar = 1690,           /* select_outvar  */
  YYSYMBOL_into = 1691,                    /* into  */
  YYSYMBOL_into_destination = 1692,        /* into_destination  */
  YYSYMBOL_1693_198 = 1693,                /* $@198  */
  YYSYMBOL_1694_199 = 1694,                /* $@199  */
  YYSYMBOL_do = 1695,                      /* do  */
  YYSYMBOL_1696_200 = 1696,                /* $@200  */
  YYSYMBOL_drop = 1697,                    /* drop  */
  YYSYMBOL_1698_201 = 1698,                /* $@201  */
  YYSYMBOL_1699_202 = 1699,                /* $@202  */
  YYSYMBOL_1700_203 = 1700,                /* $@203  */
  YYSYMBOL_1701_204 = 1701,                /* $@204  */
  YYSYMBOL_table_list = 1702,              /* table_list  */
  YYSYMBOL_table_name = 1703,              /* table_name  */
  YYSYMBOL_table_name_with_opt_use_partition = 1704, /* table_name_with_opt_use_partition  */
  YYSYMBOL_table_alias_ref_list = 1705,    /* table_alias_ref_list  */
  YYSYMBOL_table_alias_ref = 1706,         /* table_alias_ref  */
  YYSYMBOL_opt_if_exists_table_element = 1707, /* opt_if_exists_table_element  */
  YYSYMBOL_opt_if_exists = 1708,           /* opt_if_exists  */
  YYSYMBOL_opt_temporary = 1709,           /* opt_temporary  */
  YYSYMBOL_insert = 1710,                  /* insert  */
  YYSYMBOL_1711_205 = 1711,                /* $@205  */
  YYSYMBOL_1712_206 = 1712,                /* $@206  */
  YYSYMBOL_replace = 1713,                 /* replace  */
  YYSYMBOL_1714_207 = 1714,                /* $@207  */
  YYSYMBOL_1715_208 = 1715,                /* $@208  */
  YYSYMBOL_insert_lock_option = 1716,      /* insert_lock_option  */
  YYSYMBOL_replace_lock_option = 1717,     /* replace_lock_option  */
  YYSYMBOL_insert2 = 1718,                 /* insert2  */
  YYSYMBOL_insert_table = 1719,            /* insert_table  */
  YYSYMBOL_1720_209 = 1720,                /* $@209  */
  YYSYMBOL_insert_field_spec = 1721,       /* insert_field_spec  */
  YYSYMBOL_1722_210 = 1722,                /* $@210  */
  YYSYMBOL_insert_field_list = 1723,       /* insert_field_list  */
  YYSYMBOL_opt_fields = 1724,              /* opt_fields  */
  YYSYMBOL_fields = 1725,                  /* fields  */
  YYSYMBOL_insert_values = 1726,           /* insert_values  */
  YYSYMBOL_values_list = 1727,             /* values_list  */
  YYSYMBOL_ident_eq_list = 1728,           /* ident_eq_list  */
  YYSYMBOL_ident_eq_value = 1729,          /* ident_eq_value  */
  YYSYMBOL_equal = 1730,                   /* equal  */
  YYSYMBOL_opt_equal = 1731,               /* opt_equal  */
  YYSYMBOL_opt_with = 1732,                /* opt_with  */
  YYSYMBOL_opt_by = 1733,                  /* opt_by  */
  YYSYMBOL_no_braces = 1734,               /* no_braces  */
  YYSYMBOL_1735_211 = 1735,                /* $@211  */
  YYSYMBOL_no_braces_with_names = 1736,    /* no_braces_with_names  */
  YYSYMBOL_1737_212 = 1737,                /* $@212  */
  YYSYMBOL_opt_values = 1738,              /* opt_values  */
  YYSYMBOL_opt_values_with_names = 1739,   /* opt_values_with_names  */
  YYSYMBOL_values = 1740,                  /* values  */
  YYSYMBOL_values_with_names = 1741,       /* values_with_names  */
  YYSYMBOL_expr_or_ignore = 1742,          /* expr_or_ignore  */
  YYSYMBOL_expr_or_ignore_or_default = 1743, /* expr_or_ignore_or_default  */
  YYSYMBOL_opt_insert_update = 1744,       /* opt_insert_update  */
  YYSYMBOL_1745_213 = 1745,                /* $@213  */
  YYSYMBOL_1746_214 = 1746,                /* $@214  */
  YYSYMBOL_update_table_list = 1747,       /* update_table_list  */
  YYSYMBOL_update = 1748,                  /* update  */
  YYSYMBOL_1749_215 = 1749,                /* $@215  */
  YYSYMBOL_1750_216 = 1750,                /* $@216  */
  YYSYMBOL_update_list = 1751,             /* update_list  */
  YYSYMBOL_update_elem = 1752,             /* update_elem  */
  YYSYMBOL_insert_update_list = 1753,      /* insert_update_list  */
  YYSYMBOL_insert_update_elem = 1754,      /* insert_update_elem  */
  YYSYMBOL_opt_low_priority = 1755,        /* opt_low_priority  */
  YYSYMBOL_delete = 1756,                  /* delete  */
  YYSYMBOL_1757_217 = 1757,                /* $@217  */
  YYSYMBOL_opt_delete_system_time = 1758,  /* opt_delete_system_time  */
  YYSYMBOL_delete_part2 = 1759,            /* delete_part2  */
  YYSYMBOL_delete_single_table = 1760,     /* delete_single_table  */
  YYSYMBOL_delete_single_table_for_period = 1761, /* delete_single_table_for_period  */
  YYSYMBOL_single_multi = 1762,            /* single_multi  */
  YYSYMBOL_1763_218 = 1763,                /* $@218  */
  YYSYMBOL_1764_219 = 1764,                /* $@219  */
  YYSYMBOL_opt_select_expressions = 1765,  /* opt_select_expressions  */
  YYSYMBOL_table_wild_list = 1766,         /* table_wild_list  */
  YYSYMBOL_table_wild_one = 1767,          /* table_wild_one  */
  YYSYMBOL_opt_wild = 1768,                /* opt_wild  */
  YYSYMBOL_opt_delete_options = 1769,      /* opt_delete_options  */
  YYSYMBOL_opt_delete_option = 1770,       /* opt_delete_option  */
  YYSYMBOL_truncate = 1771,                /* truncate  */
  YYSYMBOL_1772_220 = 1772,                /* $@220  */
  YYSYMBOL_1773_221 = 1773,                /* $@221  */
  YYSYMBOL_opt_truncate_table_storage_clause = 1774, /* opt_truncate_table_storage_clause  */
  YYSYMBOL_opt_table_sym = 1775,           /* opt_table_sym  */
  YYSYMBOL_opt_profile_defs = 1776,        /* opt_profile_defs  */
  YYSYMBOL_profile_defs = 1777,            /* profile_defs  */
  YYSYMBOL_profile_def = 1778,             /* profile_def  */
  YYSYMBOL_opt_profile_args = 1779,        /* opt_profile_args  */
  YYSYMBOL_show = 1780,                    /* show  */
  YYSYMBOL_1781_222 = 1781,                /* $@222  */
  YYSYMBOL_show_param = 1782,              /* show_param  */
  YYSYMBOL_1783_223 = 1783,                /* $@223  */
  YYSYMBOL_1784_224 = 1784,                /* $@224  */
  YYSYMBOL_show_engine_param = 1785,       /* show_engine_param  */
  YYSYMBOL_master_or_binary = 1786,        /* master_or_binary  */
  YYSYMBOL_opt_storage = 1787,             /* opt_storage  */
  YYSYMBOL_opt_db = 1788,                  /* opt_db  */
  YYSYMBOL_opt_full = 1789,                /* opt_full  */
  YYSYMBOL_from_or_in = 1790,              /* from_or_in  */
  YYSYMBOL_binlog_in = 1791,               /* binlog_in  */
  YYSYMBOL_binlog_from = 1792,             /* binlog_from  */
  YYSYMBOL_wild_and_where = 1793,          /* wild_and_where  */
  YYSYMBOL_describe = 1794,                /* describe  */
  YYSYMBOL_1795_225 = 1795,                /* $@225  */
  YYSYMBOL_1796_226 = 1796,                /* $@226  */
  YYSYMBOL_explainable_command = 1797,     /* explainable_command  */
  YYSYMBOL_describe_command = 1798,        /* describe_command  */
  YYSYMBOL_analyze_stmt_command = 1799,    /* analyze_stmt_command  */
  YYSYMBOL_opt_extended_describe = 1800,   /* opt_extended_describe  */
  YYSYMBOL_opt_format_json = 1801,         /* opt_format_json  */
  YYSYMBOL_opt_describe_column = 1802,     /* opt_describe_column  */
  YYSYMBOL_flush = 1803,                   /* flush  */
  YYSYMBOL_1804_227 = 1804,                /* $@227  */
  YYSYMBOL_flush_options = 1805,           /* flush_options  */
  YYSYMBOL_1806_228 = 1806,                /* $@228  */
  YYSYMBOL_opt_flush_lock = 1807,          /* opt_flush_lock  */
  YYSYMBOL_flush_lock = 1808,              /* flush_lock  */
  YYSYMBOL_1809_229 = 1809,                /* $@229  */
  YYSYMBOL_flush_options_list = 1810,      /* flush_options_list  */
  YYSYMBOL_flush_option = 1811,            /* flush_option  */
  YYSYMBOL_opt_table_list = 1812,          /* opt_table_list  */
  YYSYMBOL_backup = 1813,                  /* backup  */
  YYSYMBOL_backup_statements = 1814,       /* backup_statements  */
  YYSYMBOL_1815_230 = 1815,                /* $@230  */
  YYSYMBOL_opt_delete_gtid_domain = 1816,  /* opt_delete_gtid_domain  */
  YYSYMBOL_delete_domain_id_list = 1817,   /* delete_domain_id_list  */
  YYSYMBOL_delete_domain_id = 1818,        /* delete_domain_id  */
  YYSYMBOL_optional_flush_tables_arguments = 1819, /* optional_flush_tables_arguments  */
  YYSYMBOL_reset = 1820,                   /* reset  */
  YYSYMBOL_1821_231 = 1821,                /* $@231  */
  YYSYMBOL_reset_options = 1822,           /* reset_options  */
  YYSYMBOL_reset_option = 1823,            /* reset_option  */
  YYSYMBOL_1824_232 = 1824,                /* $@232  */
  YYSYMBOL_1825_233 = 1825,                /* $@233  */
  YYSYMBOL_slave_reset_options = 1826,     /* slave_reset_options  */
  YYSYMBOL_master_reset_options = 1827,    /* master_reset_options  */
  YYSYMBOL_purge = 1828,                   /* purge  */
  YYSYMBOL_1829_234 = 1829,                /* $@234  */
  YYSYMBOL_kill = 1830,                    /* kill  */
  YYSYMBOL_1831_235 = 1831,                /* $@235  */
  YYSYMBOL_kill_type = 1832,               /* kill_type  */
  YYSYMBOL_kill_option = 1833,             /* kill_option  */
  YYSYMBOL_opt_connection = 1834,          /* opt_connection  */
  YYSYMBOL_kill_expr = 1835,               /* kill_expr  */
  YYSYMBOL_shutdown = 1836,                /* shutdown  */
  YYSYMBOL_1837_236 = 1837,                /* $@236  */
  YYSYMBOL_shutdown_option = 1838,         /* shutdown_option  */
  YYSYMBOL_use = 1839,                     /* use  */
  YYSYMBOL_load = 1840,                    /* load  */
  YYSYMBOL_1841_237 = 1841,                /* $@237  */
  YYSYMBOL_1842_238 = 1842,                /* $@238  */
  YYSYMBOL_1843_239 = 1843,                /* $@239  */
  YYSYMBOL_1844_240 = 1844,                /* $@240  */
  YYSYMBOL_data_or_xml = 1845,             /* data_or_xml  */
  YYSYMBOL_opt_local = 1846,               /* opt_local  */
  YYSYMBOL_load_data_lock = 1847,          /* load_data_lock  */
  YYSYMBOL_opt_duplicate = 1848,           /* opt_duplicate  */
  YYSYMBOL_opt_field_term = 1849,          /* opt_field_term  */
  YYSYMBOL_field_term_list = 1850,         /* field_term_list  */
  YYSYMBOL_field_term = 1851,              /* field_term  */
  YYSYMBOL_opt_line_term = 1852,           /* opt_line_term  */
  YYSYMBOL_line_term_list = 1853,          /* line_term_list  */
  YYSYMBOL_line_term = 1854,               /* line_term  */
  YYSYMBOL_opt_xml_rows_identified_by = 1855, /* opt_xml_rows_identified_by  */
  YYSYMBOL_opt_ignore_lines = 1856,        /* opt_ignore_lines  */
  YYSYMBOL_lines_or_rows = 1857,           /* lines_or_rows  */
  YYSYMBOL_opt_field_or_var_spec = 1858,   /* opt_field_or_var_spec  */
  YYSYMBOL_fields_or_vars = 1859,          /* fields_or_vars  */
  YYSYMBOL_field_or_var = 1860,            /* field_or_var  */
  YYSYMBOL_opt_load_data_set_spec = 1861,  /* opt_load_data_set_spec  */
  YYSYMBOL_load_data_set_list = 1862,      /* load_data_set_list  */
  YYSYMBOL_load_data_set_elem = 1863,      /* load_data_set_elem  */
  YYSYMBOL_text_literal = 1864,            /* text_literal  */
  YYSYMBOL_text_string = 1865,             /* text_string  */
  YYSYMBOL_hex_or_bin_String = 1866,       /* hex_or_bin_String  */
  YYSYMBOL_param_marker = 1867,            /* param_marker  */
  YYSYMBOL_signed_literal = 1868,          /* signed_literal  */
  YYSYMBOL_literal = 1869,                 /* literal  */
  YYSYMBOL_NUM_literal = 1870,             /* NUM_literal  */
  YYSYMBOL_temporal_literal = 1871,        /* temporal_literal  */
  YYSYMBOL_with_clause = 1872,             /* with_clause  */
  YYSYMBOL_1873_241 = 1873,                /* $@241  */
  YYSYMBOL_opt_recursive = 1874,           /* opt_recursive  */
  YYSYMBOL_with_list = 1875,               /* with_list  */
  YYSYMBOL_with_list_element = 1876,       /* with_list_element  */
  YYSYMBOL_1877_242 = 1877,                /* $@242  */
  YYSYMBOL_opt_with_column_list = 1878,    /* opt_with_column_list  */
  YYSYMBOL_with_column_list = 1879,        /* with_column_list  */
  YYSYMBOL_with_element_head = 1880,       /* with_element_head  */
  YYSYMBOL_insert_ident = 1881,            /* insert_ident  */
  YYSYMBOL_table_wild = 1882,              /* table_wild  */
  YYSYMBOL_select_sublist_qualified_asterisk = 1883, /* select_sublist_qualified_asterisk  */
  YYSYMBOL_order_ident = 1884,             /* order_ident  */
  YYSYMBOL_simple_ident = 1885,            /* simple_ident  */
  YYSYMBOL_simple_ident_nospvar = 1886,    /* simple_ident_nospvar  */
  YYSYMBOL_field_ident = 1887,             /* field_ident  */
  YYSYMBOL_table_ident = 1888,             /* table_ident  */
  YYSYMBOL_table_ident_opt_wild = 1889,    /* table_ident_opt_wild  */
  YYSYMBOL_table_ident_nodb = 1890,        /* table_ident_nodb  */
  YYSYMBOL_IDENT_cli = 1891,               /* IDENT_cli  */
  YYSYMBOL_ident_cli = 1892,               /* ident_cli  */
  YYSYMBOL_IDENT_sys = 1893,               /* IDENT_sys  */
  YYSYMBOL_TEXT_STRING_sys = 1894,         /* TEXT_STRING_sys  */
  YYSYMBOL_TEXT_STRING_literal = 1895,     /* TEXT_STRING_literal  */
  YYSYMBOL_TEXT_STRING_filesystem = 1896,  /* TEXT_STRING_filesystem  */
  YYSYMBOL_ident_table_alias = 1897,       /* ident_table_alias  */
  YYSYMBOL_ident_set_usual_case = 1898,    /* ident_set_usual_case  */
  YYSYMBOL_ident_sysvar_name = 1899,       /* ident_sysvar_name  */
  YYSYMBOL_ident = 1900,                   /* ident  */
  YYSYMBOL_ident_directly_assignable = 1901, /* ident_directly_assignable  */
  YYSYMBOL_label_ident = 1902,             /* label_ident  */
  YYSYMBOL_labels_declaration_oracle = 1903, /* labels_declaration_oracle  */
  YYSYMBOL_label_declaration_oracle = 1904, /* label_declaration_oracle  */
  YYSYMBOL_ident_or_text = 1905,           /* ident_or_text  */
  YYSYMBOL_user_maybe_role = 1906,         /* user_maybe_role  */
  YYSYMBOL_user_or_role = 1907,            /* user_or_role  */
  YYSYMBOL_user = 1908,                    /* user  */
  YYSYMBOL_keyword_table_alias = 1909,     /* keyword_table_alias  */
  YYSYMBOL_keyword_ident = 1910,           /* keyword_ident  */
  YYSYMBOL_keyword_label = 1911,           /* keyword_label  */
  YYSYMBOL_keyword_sysvar_name = 1912,     /* keyword_sysvar_name  */
  YYSYMBOL_keyword_sp_decl = 1913,         /* keyword_sp_decl  */
  YYSYMBOL_keyword_set_usual_case = 1914,  /* keyword_set_usual_case  */
  YYSYMBOL_keyword_directly_assignable = 1915, /* keyword_directly_assignable  */
  YYSYMBOL_keyword_sp_var_not_label = 1916, /* keyword_sp_var_not_label  */
  YYSYMBOL_keyword_sp_head = 1917,         /* keyword_sp_head  */
  YYSYMBOL_keyword_verb_clause = 1918,     /* keyword_verb_clause  */
  YYSYMBOL_keyword_set_special_case = 1919, /* keyword_set_special_case  */
  YYSYMBOL_keyword_sp_block_section = 1920, /* keyword_sp_block_section  */
  YYSYMBOL_keyword_sysvar_type = 1921,     /* keyword_sysvar_type  */
  YYSYMBOL_keyword_data_type = 1922,       /* keyword_data_type  */
  YYSYMBOL_keyword_sp_var_and_label = 1923, /* keyword_sp_var_and_label  */
  YYSYMBOL_set = 1924,                     /* set  */
  YYSYMBOL_1925_243 = 1925,                /* $@243  */
  YYSYMBOL_1926_244 = 1926,                /* $@244  */
  YYSYMBOL_1927_245 = 1927,                /* $@245  */
  YYSYMBOL_set_assign = 1928,              /* set_assign  */
  YYSYMBOL_1929_246 = 1929,                /* $@246  */
  YYSYMBOL_1930_247 = 1930,                /* $@247  */
  YYSYMBOL_1931_248 = 1931,                /* $@248  */
  YYSYMBOL_set_stmt_option_value_following_option_type_list = 1932, /* set_stmt_option_value_following_option_type_list  */
  YYSYMBOL_start_option_value_list = 1933, /* start_option_value_list  */
  YYSYMBOL_1934_249 = 1934,                /* $@249  */
  YYSYMBOL_1935_250 = 1935,                /* $@250  */
  YYSYMBOL_1936_251 = 1936,                /* $@251  */
  YYSYMBOL_start_option_value_list_following_option_type = 1937, /* start_option_value_list_following_option_type  */
  YYSYMBOL_1938_252 = 1938,                /* $@252  */
  YYSYMBOL_option_value_list_continued = 1939, /* option_value_list_continued  */
  YYSYMBOL_option_value_list = 1940,       /* option_value_list  */
  YYSYMBOL_1941_253 = 1941,                /* $@253  */
  YYSYMBOL_1942_254 = 1942,                /* $@254  */
  YYSYMBOL_option_value = 1943,            /* option_value  */
  YYSYMBOL_1944_255 = 1944,                /* $@255  */
  YYSYMBOL_option_type = 1945,             /* option_type  */
  YYSYMBOL_opt_var_type = 1946,            /* opt_var_type  */
  YYSYMBOL_opt_var_ident_type = 1947,      /* opt_var_ident_type  */
  YYSYMBOL_option_value_following_option_type = 1948, /* option_value_following_option_type  */
  YYSYMBOL_option_value_no_option_type = 1949, /* option_value_no_option_type  */
  YYSYMBOL_transaction_characteristics = 1950, /* transaction_characteristics  */
  YYSYMBOL_transaction_access_mode = 1951, /* transaction_access_mode  */
  YYSYMBOL_isolation_level = 1952,         /* isolation_level  */
  YYSYMBOL_transaction_access_mode_types = 1953, /* transaction_access_mode_types  */
  YYSYMBOL_isolation_types = 1954,         /* isolation_types  */
  YYSYMBOL_opt_for_user = 1955,            /* opt_for_user  */
  YYSYMBOL_text_or_password = 1956,        /* text_or_password  */
  YYSYMBOL_set_expr_or_default = 1957,     /* set_expr_or_default  */
  YYSYMBOL_lock = 1958,                    /* lock  */
  YYSYMBOL_1959_256 = 1959,                /* $@256  */
  YYSYMBOL_opt_lock_wait_timeout = 1960,   /* opt_lock_wait_timeout  */
  YYSYMBOL_table_or_tables = 1961,         /* table_or_tables  */
  YYSYMBOL_table_lock_list = 1962,         /* table_lock_list  */
  YYSYMBOL_table_lock = 1963,              /* table_lock  */
  YYSYMBOL_lock_option = 1964,             /* lock_option  */
  YYSYMBOL_unlock = 1965,                  /* unlock  */
  YYSYMBOL_1966_257 = 1966,                /* $@257  */
  YYSYMBOL_handler = 1967,                 /* handler  */
  YYSYMBOL_1968_258 = 1968,                /* $@258  */
  YYSYMBOL_handler_tail = 1969,            /* handler_tail  */
  YYSYMBOL_1970_259 = 1970,                /* $@259  */
  YYSYMBOL_handler_read_or_scan = 1971,    /* handler_read_or_scan  */
  YYSYMBOL_handler_scan_function = 1972,   /* handler_scan_function  */
  YYSYMBOL_handler_rkey_function = 1973,   /* handler_rkey_function  */
  YYSYMBOL_1974_260 = 1974,                /* $@260  */
  YYSYMBOL_handler_rkey_mode = 1975,       /* handler_rkey_mode  */
  YYSYMBOL_revoke = 1976,                  /* revoke  */
  YYSYMBOL_revoke_command = 1977,          /* revoke_command  */
  YYSYMBOL_admin_option_for_role = 1978,   /* admin_option_for_role  */
  YYSYMBOL_grant = 1979,                   /* grant  */
  YYSYMBOL_grant_command = 1980,           /* grant_command  */
  YYSYMBOL_opt_with_admin = 1981,          /* opt_with_admin  */
  YYSYMBOL_opt_with_admin_option = 1982,   /* opt_with_admin_option  */
  YYSYMBOL_role_list = 1983,               /* role_list  */
  YYSYMBOL_current_role = 1984,            /* current_role  */
  YYSYMBOL_grant_role = 1985,              /* grant_role  */
  YYSYMBOL_opt_table = 1986,               /* opt_table  */
  YYSYMBOL_grant_privileges = 1987,        /* grant_privileges  */
  YYSYMBOL_opt_privileges = 1988,          /* opt_privileges  */
  YYSYMBOL_object_privilege_list = 1989,   /* object_privilege_list  */
  YYSYMBOL_object_privilege = 1990,        /* object_privilege  */
  YYSYMBOL_1991_261 = 1991,                /* $@261  */
  YYSYMBOL_1992_262 = 1992,                /* $@262  */
  YYSYMBOL_1993_263 = 1993,                /* $@263  */
  YYSYMBOL_1994_264 = 1994,                /* $@264  */
  YYSYMBOL_opt_and = 1995,                 /* opt_and  */
  YYSYMBOL_require_list = 1996,            /* require_list  */
  YYSYMBOL_require_list_element = 1997,    /* require_list_element  */
  YYSYMBOL_grant_ident = 1998,             /* grant_ident  */
  YYSYMBOL_user_list = 1999,               /* user_list  */
  YYSYMBOL_grant_list = 2000,              /* grant_list  */
  YYSYMBOL_user_and_role_list = 2001,      /* user_and_role_list  */
  YYSYMBOL_via_or_with = 2002,             /* via_or_with  */
  YYSYMBOL_using_or_as = 2003,             /* using_or_as  */
  YYSYMBOL_grant_user = 2004,              /* grant_user  */
  YYSYMBOL_auth_expression = 2005,         /* auth_expression  */
  YYSYMBOL_auth_token = 2006,              /* auth_token  */
  YYSYMBOL_opt_auth_str = 2007,            /* opt_auth_str  */
  YYSYMBOL_opt_column_list = 2008,         /* opt_column_list  */
  YYSYMBOL_column_list = 2009,             /* column_list  */
  YYSYMBOL_column_list_id = 2010,          /* column_list_id  */
  YYSYMBOL_opt_require_clause = 2011,      /* opt_require_clause  */
  YYSYMBOL_resource_option = 2012,         /* resource_option  */
  YYSYMBOL_resource_option_list = 2013,    /* resource_option_list  */
  YYSYMBOL_opt_resource_options = 2014,    /* opt_resource_options  */
  YYSYMBOL_opt_grant_options = 2015,       /* opt_grant_options  */
  YYSYMBOL_opt_grant_option = 2016,        /* opt_grant_option  */
  YYSYMBOL_grant_option_list = 2017,       /* grant_option_list  */
  YYSYMBOL_grant_option = 2018,            /* grant_option  */
  YYSYMBOL_begin_stmt_mariadb = 2019,      /* begin_stmt_mariadb  */
  YYSYMBOL_2020_265 = 2020,                /* $@265  */
  YYSYMBOL_compound_statement = 2021,      /* compound_statement  */
  YYSYMBOL_opt_not = 2022,                 /* opt_not  */
  YYSYMBOL_opt_work = 2023,                /* opt_work  */
  YYSYMBOL_opt_chain = 2024,               /* opt_chain  */
  YYSYMBOL_opt_release = 2025,             /* opt_release  */
  YYSYMBOL_commit = 2026,                  /* commit  */
  YYSYMBOL_rollback = 2027,                /* rollback  */
  YYSYMBOL_savepoint = 2028,               /* savepoint  */
  YYSYMBOL_release = 2029,                 /* release  */
  YYSYMBOL_unit_type_decl = 2030,          /* unit_type_decl  */
  YYSYMBOL_union_option = 2031,            /* union_option  */
  YYSYMBOL_query_expression_option = 2032, /* query_expression_option  */
  YYSYMBOL_definer_opt = 2033,             /* definer_opt  */
  YYSYMBOL_no_definer = 2034,              /* no_definer  */
  YYSYMBOL_definer = 2035,                 /* definer  */
  YYSYMBOL_view_algorithm = 2036,          /* view_algorithm  */
  YYSYMBOL_opt_view_suid = 2037,           /* opt_view_suid  */
  YYSYMBOL_view_suid = 2038,               /* view_suid  */
  YYSYMBOL_view_list_opt = 2039,           /* view_list_opt  */
  YYSYMBOL_view_list = 2040,               /* view_list  */
  YYSYMBOL_view_select = 2041,             /* view_select  */
  YYSYMBOL_2042_266 = 2042,                /* $@266  */
  YYSYMBOL_view_check_option = 2043,       /* view_check_option  */
  YYSYMBOL_trigger_action_order = 2044,    /* trigger_action_order  */
  YYSYMBOL_trigger_follows_precedes_clause = 2045, /* trigger_follows_precedes_clause  */
  YYSYMBOL_trigger_tail = 2046,            /* trigger_tail  */
  YYSYMBOL_2047_267 = 2047,                /* $@267  */
  YYSYMBOL_2048_268 = 2048,                /* $@268  */
  YYSYMBOL_2049_269 = 2049,                /* $@269  */
  YYSYMBOL_2050_270 = 2050,                /* $@270  */
  YYSYMBOL_2051_271 = 2051,                /* $@271  */
  YYSYMBOL_sf_return_type = 2052,          /* sf_return_type  */
  YYSYMBOL_2053_272 = 2053,                /* $@272  */
  YYSYMBOL_sf_c_chistics_and_body_standalone = 2054, /* sf_c_chistics_and_body_standalone  */
  YYSYMBOL_2055_273 = 2055,                /* $@273  */
  YYSYMBOL_sp_tail_standalone = 2056,      /* sp_tail_standalone  */
  YYSYMBOL_2057_274 = 2057,                /* $@274  */
  YYSYMBOL_2058_275 = 2058,                /* $@275  */
  YYSYMBOL_opt_package_routine_end_name = 2059, /* opt_package_routine_end_name  */
  YYSYMBOL_sp_tail_is = 2060,              /* sp_tail_is  */
  YYSYMBOL_xa = 2061,                      /* xa  */
  YYSYMBOL_opt_format_xid = 2062,          /* opt_format_xid  */
  YYSYMBOL_xid = 2063,                     /* xid  */
  YYSYMBOL_begin_or_start = 2064,          /* begin_or_start  */
  YYSYMBOL_opt_join_or_resume = 2065,      /* opt_join_or_resume  */
  YYSYMBOL_opt_one_phase = 2066,           /* opt_one_phase  */
  YYSYMBOL_opt_suspend = 2067,             /* opt_suspend  */
  YYSYMBOL_2068_276 = 2068,                /* $@276  */
  YYSYMBOL_opt_migrate = 2069,             /* opt_migrate  */
  YYSYMBOL_install = 2070,                 /* install  */
  YYSYMBOL_uninstall = 2071,               /* uninstall  */
  YYSYMBOL_keep_gcc_happy = 2072           /* keep_gcc_happy  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 304 "/home/buildbot/git/sql/sql_yacc_ora.yy"

bool my_yyoverflow(short **a, YYSTYPE **b, size_t *yystacksize);

#line 2339 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  751
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   94808

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  779
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  1294
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3559
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  6151

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   1012


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   773,     2,     2,     2,   762,   757,     2,
     769,   770,   760,   759,   772,   758,   777,   761,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   776,
     755,   753,   754,     2,   778,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   763,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   774,   756,   775,   764,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   765,   766,
     767,   768,   771
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,  1764,  1764,  1774,  1773,  1798,  1805,  1807,  1811,  1812,
    1813,  1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,  1826,
    1827,  1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,  1836,
    1837,  1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,  1846,
    1847,  1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,  1856,
    1857,  1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,  1866,
    1867,  1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,  1876,
    1877,  1881,  1888,  1889,  1894,  1893,  1904,  1910,  1912,  1909,
    1921,  1923,  1922,  1932,  1937,  1949,  1948,  1965,  1964,  1973,
    1974,  1978,  1982,  1986,  1990,  1994,  1998,  2008,  2013,  2017,
    2021,  2025,  2029,  2033,  2038,  2042,  2047,  2075,  2079,  2083,
    2088,  2091,  2093,  2094,  2098,  2104,  2106,  2107,  2111,  2117,
    2119,  2120,  2124,  2131,  2135,  2150,  2154,  2160,  2166,  2172,
    2182,  2186,  2190,  2204,  2216,  2203,  2239,  2238,  2294,  2301,
    2293,  2313,  2319,  2312,  2331,  2337,  2330,  2349,  2348,  2363,
    2361,  2377,  2375,  2389,  2388,  2399,  2398,  2408,  2407,  2419,
    2417,  2432,  2430,  2446,  2444,  2459,  2457,  2471,  2478,  2485,
    2492,  2496,  2500,  2500,  2507,  2503,  2527,  2539,  2544,  2523,
    2557,  2563,  2571,  2572,  2573,  2579,  2580,  2586,  2587,  2593,
    2604,  2603,  2631,  2630,  2657,  2666,  2675,  2681,  2680,  2699,
    2698,  2717,  2720,  2722,  2726,  2727,  2731,  2738,  2749,  2750,
    2754,  2755,  2759,  2764,  2770,  2776,  2784,  2790,  2796,  2804,
    2812,  2820,  2828,  2836,  2844,  2856,  2872,  2872,  2876,  2875,
    2887,  2888,  2892,  2897,  2902,  2907,  2912,  2917,  2922,  2930,
    2929,  2962,  2961,  2968,  2975,  2976,  2982,  2988,  2998,  3004,
    3010,  3012,  3019,  3020,  3024,  3034,  3035,  3043,  3043,  3085,
    3097,  3098,  3102,  3107,  3115,  3116,  3120,  3121,  3125,  3126,
    3131,  3133,  3135,  3137,  3139,  3141,  3143,  3148,  3150,  3155,
    3156,  3159,  3161,  3165,  3165,  3171,  3172,  3176,  3177,  3182,
    3181,  3192,  3191,  3202,  3201,  3214,  3216,  3219,  3221,  3225,
    3229,  3238,  3243,  3243,  3253,  3254,  3258,  3266,  3271,  3276,
    3281,  3286,  3291,  3299,  3301,  3305,  3306,  3310,  3316,  3322,
    3328,  3334,  3340,  3349,  3350,  3351,  3352,  3353,  3358,  3357,
    3370,  3377,  3378,  3382,  3383,  3387,  3388,  3392,  3393,  3397,
    3397,  3409,  3412,  3417,  3416,  3425,  3429,  3430,  3437,  3438,
    3445,  3446,  3450,  3456,  3462,  3471,  3479,  3483,  3488,  3496,
    3500,  3507,  3517,  3525,  3533,  3544,  3545,  3552,  3563,  3562,
    3581,  3580,  3594,  3596,  3601,  3611,  3610,  3629,  3630,  3631,
    3632,  3637,  3639,  3644,  3659,  3667,  3671,  3691,  3692,  3696,
    3700,  3706,  3712,  3718,  3724,  3734,  3739,  3747,  3755,  3770,
    3776,  3777,  3783,  3786,  3790,  3798,  3815,  3817,  3835,  3841,
    3843,  3845,  3847,  3849,  3851,  3853,  3855,  3857,  3859,  3861,
    3863,  3868,  3876,  3892,  3893,  3898,  3904,  3913,  3920,  3929,
    3938,  3943,  3952,  3954,  3956,  3965,  3970,  3977,  3986,  3995,
    3997,  3999,  4001,  4003,  4005,  4007,  4009,  4011,  4013,  4015,
    4017,  4019,  4024,  4025,  4033,  4045,  4060,  4061,  4062,  4066,
    4067,  4068,  4069,  4070,  4071,  4075,  4076,  4077,  4078,  4079,
    4080,  4081,  4082,  4083,  4084,  4085,  4086,  4087,  4091,  4092,
    4093,  4094,  4099,  4098,  4109,  4111,  4110,  4122,  4121,  4132,
    4131,  4144,  4144,  4166,  4167,  4172,  4171,  4189,  4200,  4200,
    4213,  4218,  4223,  4229,  4238,  4243,  4248,  4254,  4264,  4272,
    4280,  4289,  4295,  4305,  4304,  4326,  4325,  4346,  4352,  4360,
    4361,  4365,  4373,  4378,  4383,  4391,  4392,  4400,  4418,  4433,
    4451,  4457,  4474,  4451,  4493,  4495,  4496,  4501,  4500,  4570,
    4576,  4570,  4586,  4591,  4592,  4596,  4597,  4602,  4608,  4601,
    4629,  4635,  4628,  4654,  4664,  4668,  4669,  4673,  4684,  4682,
    4698,  4702,  4696,  4717,  4719,  4724,  4723,  4738,  4744,  4737,
    4759,  4763,  4767,  4773,  4763,  4784,  4782,  4797,  4798,  4802,
    4803,  4808,  4807,  4823,  4824,  4829,  4828,  4842,  4847,  4854,
    4863,  4878,  4877,  4897,  4896,  4921,  4930,  4929,  4937,  4936,
    4947,  4952,  4961,  4946,  4971,  4970,  4981,  4980,  4990,  4989,
    5002,  5009,  5001,  5026,  5025,  5037,  5039,  5044,  5046,  5048,
    5065,  5070,  5076,  5083,  5084,  5092,  5098,  5107,  5113,  5119,
    5120,  5124,  5124,  5129,  5130,  5131,  5135,  5136,  5137,  5141,
    5145,  5146,  5147,  5151,  5152,  5153,  5154,  5155,  5156,  5157,
    5158,  5162,  5166,  5167,  5168,  5172,  5173,  5174,  5175,  5176,
    5180,  5184,  5185,  5186,  5190,  5191,  5192,  5193,  5194,  5195,
    5196,  5200,  5204,  5205,  5206,  5210,  5211,  5212,  5217,  5225,
    5233,  5241,  5254,  5267,  5272,  5277,  5285,  5293,  5301,  5309,
    5317,  5325,  5333,  5343,  5353,  5363,  5365,  5369,  5374,  5384,
    5385,  5398,  5397,  5400,  5401,  5415,  5416,  5420,  5421,  5430,
    5435,  5446,  5483,  5484,  5489,  5488,  5504,  5519,  5518,  5541,
    5540,  5546,  5554,  5553,  5556,  5558,  5561,  5560,  5569,  5572,
    5571,  5580,  5581,  5587,  5588,  5605,  5606,  5610,  5611,  5615,
    5629,  5639,  5650,  5659,  5660,  5673,  5675,  5674,  5679,  5677,
    5688,  5689,  5693,  5707,  5719,  5720,  5733,  5742,  5764,  5765,
    5770,  5769,  5793,  5805,  5821,  5820,  5835,  5834,  5848,  5853,
    5858,  5878,  5896,  5900,  5927,  5939,  5940,  5945,  5954,  5944,
    5979,  5980,  5984,  5995,  6014,  6027,  6053,  6054,  6059,  6058,
    6095,  6104,  6105,  6109,  6110,  6114,  6116,  6122,  6128,  6130,
    6132,  6134,  6136,  6138,  6143,  6144,  6144,  6151,  6167,  6170,
    6187,  6188,  6192,  6193,  6197,  6198,  6202,  6203,  6208,  6211,
    6219,  6222,  6229,  6233,  6239,  6241,  6245,  6246,  6250,  6251,
    6252,  6256,  6271,  6276,  6281,  6286,  6291,  6296,  6301,  6316,
    6322,  6337,  6342,  6357,  6363,  6381,  6386,  6391,  6396,  6401,
    6406,  6412,  6411,  6437,  6438,  6439,  6444,  6449,  6454,  6456,
    6458,  6460,  6466,  6471,  6476,  6485,  6494,  6500,  6506,  6511,
    6514,  6516,  6520,  6539,  6547,  6562,  6572,  6583,  6584,  6585,
    6586,  6587,  6588,  6589,  6593,  6594,  6595,  6599,  6600,  6601,
    6602,  6607,  6614,  6621,  6622,  6626,  6627,  6628,  6629,  6630,
    6634,  6636,  6642,  6641,  6649,  6648,  6656,  6655,  6663,  6662,
    6672,  6669,  6680,  6678,  6687,  6686,  6725,  6733,  6741,  6749,
    6750,  6754,  6764,  6765,  6769,  6770,  6774,  6779,  6778,  6816,
    6816,  6819,  6818,  6829,  6830,  6834,  6835,  6839,  6840,  6844,
    6845,  6849,  6850,  6851,  6852,  6854,  6853,  6859,  6864,  6872,
    6873,  6878,  6881,  6885,  6889,  6896,  6897,  6901,  6902,  6906,
    6912,  6918,  6919,  6927,  6926,  6948,  6949,  6959,  6967,  6979,
    6979,  6982,  6983,  6990,  6998,  7002,  7010,  7011,  7012,  7013,
    7014,  7019,  7020,  7021,  7022,  7023,  7028,  7029,  7030,  7046,
    7050,  7054,  7058,  7060,  7067,  7069,  7074,  7076,  7077,  7078,
    7082,  7086,  7091,  7096,  7100,  7104,  7109,  7114,  7123,  7127,
    7132,  7137,  7141,  7145,  7150,  7155,  7164,  7182,  7183,  7190,
    7197,  7205,  7210,  7215,  7220,  7225,  7236,  7241,  7246,  7251,
    7253,  7255,  7257,  7259,  7261,  7263,  7265,  7273,  7275,  7280,
    7281,  7282,  7283,  7284,  7285,  7286,  7287,  7291,  7295,  7296,
    7300,  7301,  7305,  7306,  7307,  7308,  7309,  7313,  7314,  7315,
    7316,  7317,  7321,  7327,  7328,  7333,  7335,  7342,  7343,  7344,
    7348,  7352,  7353,  7354,  7355,  7356,  7357,  7361,  7362,  7363,
    7364,  7368,  7369,  7373,  7374,  7395,  7396,  7400,  7401,  7405,
    7406,  7411,  7412,  7416,  7417,  7418,  7425,  7426,  7432,  7439,
    7443,  7444,  7448,  7449,  7453,  7461,  7469,  7478,  7482,  7488,
    7492,  7493,  7502,  7511,  7517,  7523,  7536,  7542,  7552,  7560,
    7561,  7565,  7570,  7574,  7575,  7579,  7580,  7584,  7591,  7595,
    7596,  7600,  7608,  7609,  7613,  7614,  7618,  7619,  7623,  7624,
    7625,  7632,  7636,  7637,  7641,  7642,  7643,  7644,  7645,  7657,
    7661,  7662,  7667,  7666,  7679,  7680,  7684,  7687,  7688,  7689,
    7690,  7694,  7702,  7709,  7710,  7714,  7724,  7725,  7729,  7730,
    7733,  7735,  7739,  7751,  7752,  7756,  7763,  7776,  7777,  7779,
    7781,  7787,  7792,  7798,  7804,  7811,  7821,  7822,  7823,  7824,
    7825,  7829,  7830,  7834,  7835,  7839,  7840,  7844,  7845,  7846,
    7850,  7851,  7855,  7859,  7871,  7872,  7876,  7877,  7881,  7882,
    7886,  7887,  7891,  7892,  7896,  7897,  7901,  7902,  7907,  7908,
    7909,  7913,  7915,  7920,  7925,  7927,  7935,  7943,  7949,  7958,
    7959,  7963,  7967,  7968,  7978,  7979,  7980,  7984,  7988,  7995,
    8001,  8013,  8014,  8018,  8020,  8030,  8046,  8029,  8068,  8067,
    8084,  8093,  8092,  8113,  8112,  8133,  8132,  8151,  8145,  8164,
    8163,  8202,  8207,  8212,  8217,  8223,  8222,  8229,  8236,  8248,
    8235,  8270,  8274,  8282,  8285,  8289,  8293,  8301,  8303,  8304,
    8305,  8306,  8310,  8311,  8312,  8313,  8317,  8318,  8330,  8331,
    8335,  8336,  8339,  8341,  8349,  8357,  8359,  8361,  8362,  8370,
    8371,  8377,  8386,  8384,  8397,  8410,  8409,  8422,  8420,  8433,
    8440,  8450,  8451,  8460,  8467,  8471,  8477,  8475,  8492,  8494,
    8499,  8507,  8506,  8520,  8524,  8523,  8535,  8536,  8540,  8553,
    8554,  8558,  8562,  8569,  8574,  8578,  8585,  8592,  8596,  8601,
    8609,  8617,  8627,  8638,  8648,  8659,  8669,  8675,  8681,  8688,
    8694,  8708,  8722,  8727,  8731,  8736,  8737,  8738,  8743,  8748,
    8752,  8762,  8764,  8765,  8766,  8767,  8771,  8776,  8784,  8789,
    8797,  8798,  8802,  8803,  8807,  8807,  8810,  8812,  8816,  8817,
    8821,  8822,  8830,  8831,  8832,  8836,  8837,  8842,  8851,  8852,
    8853,  8854,  8859,  8858,  8868,  8867,  8875,  8882,  8892,  8909,
    8912,  8919,  8923,  8930,  8934,  8938,  8945,  8945,  8951,  8952,
    8956,  8957,  8958,  8962,  8963,  8972,  8979,  8980,  8985,  8984,
    8996,  8997,  8998,  9002,  9004,  9003,  9010,  9009,  9030,  9031,
    9035,  9036,  9040,  9041,  9042,  9046,  9047,  9052,  9051,  9072,
    9073,  9077,  9082,  9083,  9090,  9092,  9097,  9099,  9098,  9111,
    9113,  9112,  9126,  9127,  9132,  9141,  9142,  9143,  9147,  9154,
    9164,  9172,  9181,  9183,  9182,  9188,  9187,  9210,  9211,  9215,
    9216,  9220,  9221,  9222,  9223,  9224,  9225,  9229,  9230,  9235,
    9234,  9255,  9256,  9257,  9262,  9261,  9271,  9278,  9284,  9293,
    9294,  9298,  9314,  9313,  9326,  9327,  9331,  9332,  9336,  9347,
    9358,  9359,  9364,  9363,  9378,  9379,  9383,  9384,  9388,  9399,
    9411,  9410,  9418,  9418,  9427,  9428,  9433,  9434,  9443,  9442,
    9457,  9456,  9476,  9475,  9492,  9490,  9512,  9513,  9518,  9517,
    9531,  9541,  9530,  9551,  9563,  9627,  9632,  9647,  9648,  9663,
    9662,  9678,  9677,  9690,  9692,  9707,  9715,  9713,  9729,  9747,
    9749,  9759,  9763,  9804,  9813,  9823,  9824,  9828,  9832,  9838,
    9845,  9847,  9856,  9860,  9864,  9871,  9880,  9884,  9891,  9908,
    9911,  9919,  9922,  9929,  9933,  9937,  9941,  9948,  9949,  9953,
    9954,  9963,  9976,  9982,  9992,  9995, 10003, 10006, 10011, 10019,
   10020, 10021, 10035, 10040, 10062, 10068, 10074, 10080, 10089, 10090,
   10091, 10092, 10093, 10097, 10098, 10099, 10103, 10104, 10105, 10109,
   10110, 10115, 10166, 10173, 10216, 10222, 10226, 10232, 10238, 10244,
   10250, 10256, 10262, 10268, 10274, 10280, 10286, 10292, 10296, 10302,
   10311, 10317, 10325, 10331, 10340, 10346, 10354, 10364, 10370, 10377,
   10384, 10392, 10398, 10407, 10411, 10417, 10423, 10429, 10435, 10442,
   10448, 10454, 10460, 10466, 10473, 10479, 10485, 10491, 10497, 10503,
   10509, 10515, 10521, 10525, 10526, 10530, 10531, 10535, 10536, 10540,
   10541, 10545, 10546, 10547, 10548, 10549, 10550, 10554, 10555, 10560,
   10564, 10568, 10569, 10570, 10574, 10575, 10576, 10577, 10578, 10579,
   10583, 10584, 10585, 10590, 10589, 10595, 10603, 10626, 10633, 10642,
   10643, 10644, 10645, 10649, 10658, 10659, 10663, 10667, 10668, 10669,
   10670, 10671, 10672, 10673, 10705, 10706, 10707, 10708, 10709, 10710,
   10711, 10712, 10713, 10721, 10729, 10730, 10737, 10743, 10748, 10758,
   10763, 10768, 10774, 10779, 10785, 10796, 10803, 10808, 10813, 10818,
   10823, 10828, 10833, 10841, 10842, 10843, 10844, 10852, 10853, 10861,
   10862, 10868, 10872, 10878, 10884, 10893, 10894, 10903, 10910, 10924,
   10930, 10936, 10945, 10954, 10960, 10966, 10972, 10978, 10993, 11004,
   11010, 11016, 11022, 11028, 11034, 11042, 11049, 11053, 11059, 11067,
   11076, 11077, 11081, 11085, 11092, 11096, 11116, 11123, 11129, 11136,
   11143, 11149, 11155, 11161, 11167, 11173, 11179, 11186, 11192, 11199,
   11205, 11211, 11229, 11235, 11241, 11246, 11253, 11260, 11268, 11275,
   11282, 11289, 11296, 11313, 11319, 11325, 11331, 11337, 11344, 11350,
   11356, 11365, 11376, 11383, 11389, 11395, 11402, 11410, 11416, 11422,
   11428, 11434, 11442, 11448, 11454, 11460, 11466, 11474, 11486, 11493,
   11508, 11514, 11521, 11528, 11535, 11542, 11549, 11553, 11560, 11578,
   11577, 11646, 11651, 11656, 11661, 11666, 11671, 11676, 11684, 11686,
   11691, 11692, 11696, 11697, 11701, 11702, 11706, 11713, 11721, 11748,
   11754, 11760, 11766, 11772, 11778, 11787, 11794, 11796, 11793, 11803,
   11814, 11820, 11826, 11832, 11838, 11844, 11850, 11856, 11862, 11869,
   11868, 11893, 11902, 11920, 11922, 11924, 11939, 11946, 11953, 11960,
   11967, 11974, 11981, 11988, 11995, 12002, 12013, 12020, 12031, 12042,
   12062, 12061, 12067, 12084, 12090, 12099, 12108, 12118, 12117, 12129,
   12139, 12147, 12152, 12160, 12161, 12166, 12171, 12174, 12176, 12180,
   12185, 12193, 12194, 12198, 12202, 12209, 12216, 12223, 12236, 12235,
   12252, 12255, 12254, 12259, 12258, 12263, 12262, 12266, 12271, 12272,
   12276, 12277, 12278, 12279, 12280, 12281, 12282, 12283, 12287, 12288,
   12289, 12290, 12297, 12298, 12302, 12307, 12315, 12316, 12320, 12327,
   12335, 12344, 12354, 12355, 12366, 12367, 12379, 12390, 12391, 12397,
   12402, 12416, 12424, 12422, 12442, 12440, 12453, 12465, 12463, 12483,
   12482, 12494, 12507, 12505, 12526, 12525, 12538, 12552, 12553, 12554,
   12558, 12559, 12567, 12568, 12572, 12581, 12582, 12583, 12588, 12592,
   12593, 12597, 12598, 12602, 12603, 12611, 12619, 12627, 12628, 12641,
   12659, 12669, 12670, 12675, 12678, 12679, 12680, 12684, 12685, 12690,
   12689, 12695, 12694, 12702, 12703, 12706, 12708, 12708, 12712, 12712,
   12717, 12718, 12722, 12724, 12729, 12730, 12734, 12745, 12759, 12760,
   12761, 12762, 12763, 12764, 12765, 12766, 12767, 12768, 12769, 12770,
   12774, 12775, 12776, 12777, 12778, 12779, 12780, 12781, 12782, 12786,
   12787, 12788, 12789, 12792, 12794, 12795, 12799, 12800, 12804, 12812,
   12814, 12818, 12820, 12819, 12833, 12836, 12835, 12853, 12855, 12859,
   12864, 12872, 12873, 12890, 12913, 12914, 12920, 12921, 12925, 12938,
   12937, 12946, 12947, 12956, 12957, 12961, 12962, 12966, 12967, 12981,
   12982, 12986, 12996, 13005, 13012, 13019, 13029, 13030, 13037, 13047,
   13048, 13050, 13052, 13054, 13056, 13065, 13069, 13070, 13074, 13088,
   13089, 13095, 13094, 13105, 13111, 13120, 13121, 13122, 13127, 13128,
   13133, 13140, 13146, 13156, 13165, 13171, 13177, 13186, 13191, 13196,
   13200, 13206, 13212, 13221, 13230, 13234, 13241, 13242, 13246, 13251,
   13256, 13268, 13272, 13276, 13280, 13285, 13288, 13292, 13306, 13314,
   13327, 13329, 13333, 13334, 13338, 13339, 13340, 13341, 13342, 13343,
   13347, 13348, 13349, 13350, 13351, 13355, 13356, 13357, 13358, 13362,
   13363, 13364, 13365, 13366, 13370, 13371, 13372, 13373, 13374, 13378,
   13383, 13384, 13388, 13389, 13393, 13394, 13395, 13400, 13399, 13431,
   13432, 13436, 13437, 13441, 13451, 13451, 13463, 13464, 13467, 13487,
   13491, 13496, 13504, 13510, 13521, 13509, 13523, 13538, 13550, 13549,
   13572, 13571, 13581, 13580, 13603, 13609, 13617, 13625, 13639, 13654,
   13662, 13666, 13671, 13670, 13679, 13684, 13690, 13695, 13700, 13707,
   13705, 13719, 13720, 13724, 13736, 13749, 13750, 13754, 13768, 13772,
   13781, 13784, 13791, 13792, 13800, 13811, 13799, 13826, 13836, 13825,
   13851, 13859, 13860, 13867, 13871, 13872, 13881, 13882, 13886, 13886,
   13899, 13900, 13902, 13901, 13914, 13920, 13922, 13926, 13928, 13934,
   13938, 13939, 13943, 13944, 13948, 13958, 13959, 13963, 13964, 13968,
   13969, 13973, 13974, 13979, 13978, 13994, 13993, 14008, 14009, 14013,
   14014, 14018, 14023, 14031, 14039, 14050, 14051, 14060, 14061, 14069,
   14071, 14073, 14071, 14083, 14097, 14104, 14114, 14103, 14143, 14144,
   14148, 14155, 14163, 14164, 14168, 14178, 14179, 14186, 14185, 14206,
   14209, 14216, 14217, 14227, 14242, 14250, 14263, 14262, 14277, 14276,
   14292, 14294, 14298, 14299, 14303, 14318, 14336, 14337, 14341, 14342,
   14346, 14347, 14348, 14353, 14364, 14352, 14374, 14376, 14377, 14380,
   14382, 14385, 14387, 14390, 14391, 14394, 14398, 14402, 14406, 14410,
   14414, 14418, 14422, 14426, 14434, 14437, 14447, 14446, 14465, 14472,
   14480, 14488, 14496, 14504, 14512, 14519, 14526, 14532, 14534, 14536,
   14545, 14549, 14554, 14553, 14560, 14559, 14565, 14574, 14581, 14586,
   14591, 14596, 14601, 14606, 14608, 14610, 14612, 14619, 14627, 14629,
   14637, 14644, 14651, 14659, 14665, 14670, 14678, 14686, 14694, 14698,
   14703, 14710, 14715, 14722, 14729, 14735, 14741, 14747, 14755, 14760,
   14767, 14774, 14781, 14788, 14793, 14798, 14803, 14808, 14815, 14837,
   14839, 14841, 14846, 14847, 14850, 14852, 14856, 14857, 14861, 14862,
   14866, 14867, 14871, 14872, 14876, 14877, 14881, 14882, 14890, 14902,
   14901, 14920, 14919, 14929, 14930, 14931, 14932, 14933, 14934, 14938,
   14939, 14943, 14950, 14951, 14953, 14954, 14958, 14959, 14972, 14973,
   14974, 14989, 14988, 15000, 14999, 15011, 15016, 15017, 15032, 15035,
   15034, 15047, 15048, 15053, 15055, 15057, 15059, 15061, 15063, 15071,
   15073, 15075, 15077, 15082, 15084, 15092, 15094, 15096, 15098, 15100,
   15117, 15118, 15122, 15126, 15139, 15138, 15151, 15159, 15160, 15163,
   15165, 15166, 15170, 15186, 15187, 15192, 15191, 15201, 15202, 15206,
   15206, 15210, 15209, 15215, 15219, 15220, 15224, 15225, 15232, 15237,
   15236, 15251, 15250, 15265, 15266, 15267, 15271, 15272, 15273, 15282,
   15283, 15287, 15291, 15299, 15299, 15304, 15305, 15313, 15325, 15339,
   15350, 15363, 15324, 15376, 15377, 15381, 15382, 15386, 15387, 15395,
   15399, 15400, 15401, 15404, 15406, 15410, 15411, 15415, 15420, 15427,
   15432, 15439, 15441, 15445, 15446, 15450, 15455, 15463, 15464, 15468,
   15470, 15478, 15479, 15483, 15484, 15485, 15489, 15491, 15496, 15497,
   15506, 15507, 15511, 15512, 15516, 15529, 15534, 15539, 15544, 15552,
   15560, 15565, 15573, 15581, 15596, 15603, 15609, 15619, 15620, 15628,
   15629, 15630, 15631, 15645, 15651, 15657, 15663, 15669, 15675, 15694,
   15704, 15714, 15720, 15727, 15737, 15744, 15751, 15762, 15761, 15786,
   15787, 15792, 15793, 15800, 15798, 15825, 15826, 15832, 15837, 15846,
   15864, 15865, 15869, 15874, 15882, 15887, 15895, 15900, 15905, 15910,
   15916, 15921, 15929, 15934, 15939, 15944, 15950, 15958, 15959, 15970,
   15978, 15982, 15988, 15994, 16004, 16010, 16019, 16029, 16030, 16034,
   16035, 16036, 16040, 16048, 16056, 16064, 16072, 16073, 16081, 16082,
   16090, 16091, 16096, 16105, 16106, 16114, 16115, 16124, 16125, 16133,
   16134, 16138, 16147, 16148, 16149, 16153, 16164, 16193, 16202, 16202,
   16204, 16214, 16215, 16216, 16217, 16218, 16219, 16220, 16221, 16222,
   16227, 16228, 16229, 16230, 16231, 16232, 16233, 16234, 16235, 16236,
   16244, 16245, 16246, 16247, 16248, 16249, 16253, 16254, 16255, 16256,
   16257, 16258, 16259, 16260, 16261, 16265, 16266, 16267, 16268, 16269,
   16270, 16271, 16275, 16276, 16277, 16278, 16279, 16280, 16281, 16282,
   16283, 16287, 16288, 16289, 16290, 16291, 16292, 16293, 16306, 16307,
   16308, 16309, 16310, 16311, 16312, 16313, 16314, 16315, 16316, 16317,
   16318, 16319, 16320, 16321, 16322, 16323, 16324, 16325, 16326, 16327,
   16328, 16329, 16330, 16331, 16332, 16333, 16334, 16335, 16336, 16337,
   16338, 16339, 16340, 16341, 16342, 16343, 16344, 16345, 16346, 16347,
   16348, 16349, 16350, 16351, 16352, 16353, 16354, 16355, 16356, 16357,
   16358, 16359, 16360, 16401, 16402, 16403, 16404, 16405, 16406, 16417,
   16418, 16419, 16420, 16421, 16422, 16423, 16424, 16425, 16426, 16430,
   16431, 16432, 16439, 16440, 16441, 16445, 16446, 16447, 16456, 16457,
   16458, 16459, 16460, 16461, 16462, 16463, 16464, 16465, 16466, 16467,
   16468, 16469, 16470, 16471, 16472, 16473, 16474, 16475, 16476, 16477,
   16478, 16479, 16480, 16481, 16482, 16483, 16484, 16485, 16486, 16487,
   16488, 16489, 16497, 16498, 16499, 16500, 16501, 16502, 16503, 16504,
   16505, 16506, 16507, 16508, 16509, 16510, 16511, 16512, 16513, 16514,
   16515, 16516, 16517, 16518, 16519, 16520, 16521, 16522, 16523, 16524,
   16525, 16526, 16527, 16528, 16529, 16530, 16531, 16532, 16533, 16534,
   16535, 16536, 16537, 16538, 16539, 16540, 16541, 16542, 16543, 16548,
   16549, 16550, 16551, 16552, 16553, 16554, 16555, 16556, 16557, 16558,
   16559, 16560, 16561, 16562, 16563, 16564, 16565, 16566, 16567, 16568,
   16569, 16570, 16571, 16572, 16573, 16574, 16575, 16576, 16577, 16578,
   16579, 16580, 16581, 16582, 16583, 16584, 16585, 16586, 16587, 16588,
   16589, 16590, 16591, 16592, 16593, 16594, 16595, 16596, 16597, 16598,
   16599, 16600, 16601, 16602, 16603, 16604, 16605, 16606, 16607, 16608,
   16609, 16610, 16611, 16612, 16613, 16614, 16615, 16616, 16617, 16618,
   16619, 16620, 16621, 16622, 16623, 16624, 16625, 16626, 16627, 16628,
   16629, 16630, 16631, 16632, 16633, 16634, 16635, 16636, 16637, 16638,
   16639, 16640, 16641, 16642, 16643, 16644, 16645, 16646, 16647, 16648,
   16649, 16650, 16651, 16652, 16653, 16654, 16655, 16656, 16657, 16658,
   16659, 16660, 16661, 16662, 16663, 16664, 16665, 16666, 16667, 16668,
   16669, 16670, 16671, 16672, 16673, 16674, 16675, 16676, 16677, 16678,
   16679, 16680, 16681, 16682, 16683, 16684, 16685, 16686, 16687, 16688,
   16689, 16690, 16691, 16692, 16693, 16694, 16695, 16696, 16697, 16698,
   16699, 16700, 16701, 16702, 16703, 16704, 16705, 16706, 16707, 16708,
   16709, 16710, 16711, 16712, 16713, 16714, 16715, 16716, 16717, 16718,
   16719, 16720, 16721, 16722, 16723, 16724, 16725, 16726, 16727, 16728,
   16729, 16730, 16731, 16732, 16733, 16734, 16735, 16736, 16737, 16738,
   16739, 16740, 16741, 16742, 16743, 16744, 16745, 16746, 16747, 16748,
   16749, 16750, 16751, 16752, 16753, 16754, 16755, 16756, 16757, 16758,
   16759, 16760, 16761, 16762, 16763, 16764, 16765, 16766, 16767, 16768,
   16769, 16770, 16771, 16772, 16773, 16774, 16775, 16776, 16777, 16778,
   16779, 16780, 16781, 16782, 16783, 16784, 16785, 16786, 16787, 16788,
   16789, 16790, 16791, 16792, 16793, 16794, 16795, 16796, 16797, 16798,
   16799, 16800, 16801, 16802, 16803, 16804, 16805, 16806, 16807, 16808,
   16809, 16810, 16811, 16812, 16813, 16814, 16826, 16825, 16842, 16848,
   16841, 16864, 16863, 16878, 16877, 16894, 16893, 16921, 16922, 16928,
   16927, 16934, 16933, 16943, 16942, 16953, 16952, 16958, 16966, 16968,
   16973, 16973, 16983, 16982, 16997, 16996, 17001, 17005, 17006, 17007,
   17011, 17012, 17013, 17014, 17018, 17019, 17020, 17021, 17026, 17031,
   17036, 17045, 17050, 17055, 17060, 17065, 17070, 17075, 17080, 17094,
   17105, 17124, 17142, 17154, 17162, 17167, 17183, 17184, 17185, 17186,
   17190, 17209, 17227, 17228, 17232, 17233, 17234, 17235, 17239, 17253,
   17257, 17262, 17267, 17278, 17279, 17280, 17286, 17292, 17304, 17303,
   17317, 17318, 17324, 17333, 17334, 17338, 17339, 17343, 17362, 17363,
   17364, 17369, 17370, 17375, 17374, 17392, 17391, 17403, 17412, 17422,
   17421, 17462, 17463, 17467, 17468, 17472, 17473, 17474, 17475, 17477,
   17476, 17489, 17490, 17491, 17492, 17493, 17499, 17504, 17510, 17516,
   17522, 17529, 17536, 17540, 17547, 17556, 17558, 17563, 17568, 17575,
   17582, 17589, 17596, 17603, 17610, 17622, 17623, 17627, 17628, 17632,
   17637, 17645, 17655, 17674, 17677, 17679, 17683, 17684, 17691, 17693,
   17697, 17698, 17703, 17702, 17706, 17705, 17709, 17708, 17712, 17711,
   17714, 17715, 17716, 17717, 17718, 17719, 17720, 17721, 17722, 17723,
   17724, 17725, 17726, 17727, 17728, 17729, 17730, 17731, 17732, 17733,
   17734, 17735, 17736, 17737, 17738, 17739, 17740, 17744, 17745, 17749,
   17750, 17754, 17761, 17768, 17778, 17788, 17797, 17806, 17819, 17824,
   17832, 17837, 17845, 17850, 17857, 17857, 17858, 17858, 17861, 17867,
   17873, 17878, 17885, 17891, 17898, 17907, 17911, 17917, 17927, 17931,
   17935, 17936, 17940, 17968, 17970, 17974, 17978, 17982, 17989, 17994,
   17999, 18004, 18009, 18017, 18018, 18022, 18023, 18028, 18029, 18033,
   18034, 18038, 18039, 18043, 18044, 18049, 18048, 18058, 18067, 18068,
   18072, 18073, 18078, 18079, 18080, 18085, 18086, 18087, 18091, 18103,
   18112, 18118, 18127, 18136, 18149, 18151, 18153, 18161, 18162, 18163,
   18167, 18168, 18174, 18175, 18176, 18177, 18178, 18179, 18180, 18190,
   18191, 18196, 18209, 18223, 18224, 18225, 18229, 18230, 18234, 18235,
   18240, 18241, 18245, 18251, 18260, 18260, 18274, 18275, 18276, 18277,
   18287, 18289, 18295, 18301, 18311, 18320, 18326, 18331, 18335, 18309,
   18383, 18383, 18399, 18398, 18414, 18422, 18413, 18437, 18438, 18442,
   18443, 18449, 18453, 18457, 18461, 18465, 18469, 18477, 18478, 18494,
   18501, 18508, 18518, 18519, 18520, 18524, 18525, 18526, 18530, 18531,
   18536, 18538, 18537, 18543, 18544, 18548, 18553, 18560, 18565, 18574
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ABORT_SYM",
  "ACCESSIBLE_SYM", "ADD", "ALL", "ALTER", "ANALYZE_SYM", "AND_AND_SYM",
  "AND_SYM", "AS", "ASC", "ASENSITIVE_SYM", "BEFORE_SYM", "BETWEEN_SYM",
  "BIGINT", "BINARY", "BIN_NUM", "BIT_AND", "BIT_OR", "BIT_XOR",
  "BLOB_MARIADB_SYM", "BLOB_ORACLE_SYM", "BODY_ORACLE_SYM", "BOTH", "BY",
  "CALL_SYM", "CASCADE", "CASE_SYM", "CAST_SYM", "CHANGE", "CHAR_SYM",
  "CHECK_SYM", "COLLATE_SYM", "CONDITION_SYM", "CONSTRAINT",
  "CONTINUE_MARIADB_SYM", "CONTINUE_ORACLE_SYM", "CONVERT_SYM",
  "COUNT_SYM", "CREATE", "CROSS", "CUME_DIST_SYM", "CURDATE",
  "CURRENT_USER", "CURRENT_ROLE", "CURSOR_SYM", "CURTIME", "DATABASE",
  "DATABASES", "DATE_ADD_INTERVAL", "DATE_SUB_INTERVAL", "DAY_HOUR_SYM",
  "DAY_MICROSECOND_SYM", "DAY_MINUTE_SYM", "DAY_SECOND_SYM", "DECIMAL_NUM",
  "DECIMAL_SYM", "DECLARE_MARIADB_SYM", "DECLARE_ORACLE_SYM", "DEFAULT",
  "DELETE_DOMAIN_ID_SYM", "DELETE_SYM", "DENSE_RANK_SYM", "DESC",
  "DESCRIBE", "DETERMINISTIC_SYM", "DISTINCT", "DIV_SYM", "DOUBLE_SYM",
  "DO_DOMAIN_IDS_SYM", "DOT_DOT_SYM", "DROP", "DUAL_SYM", "EACH_SYM",
  "ELSE", "ELSEIF_MARIADB_SYM", "ELSIF_ORACLE_SYM", "ENCLOSED",
  "END_OF_INPUT", "EQUAL_SYM", "ESCAPED", "EXCEPT_SYM", "EXISTS",
  "EXTRACT_SYM", "FALSE_SYM", "FETCH_SYM", "FIRST_VALUE_SYM", "FLOAT_NUM",
  "FLOAT_SYM", "FORCE_LOOKAHEAD", "FOREIGN", "FOR_SYM",
  "FOR_SYSTEM_TIME_SYM", "FROM", "FULLTEXT_SYM", "GE", "GOTO_ORACLE_SYM",
  "GRANT", "GROUP_SYM", "GROUP_CONCAT_SYM", "LAG_SYM", "LEAD_SYM",
  "HAVING", "HEX_NUM", "HEX_STRING", "HOUR_MICROSECOND_SYM",
  "HOUR_MINUTE_SYM", "HOUR_SECOND_SYM", "IDENT", "IDENT_QUOTED", "IF_SYM",
  "IGNORE_DOMAIN_IDS_SYM", "IGNORE_SYM", "INDEX_SYM", "INFILE",
  "INNER_SYM", "INOUT_SYM", "INSENSITIVE_SYM", "INSERT", "INTERSECT_SYM",
  "INTERVAL_SYM", "INTO", "INT_SYM", "IN_SYM", "IS", "ITERATE_SYM",
  "JOIN_SYM", "KEYS", "KEY_SYM", "KILL_SYM", "LE", "LEADING", "LEAVE_SYM",
  "LEFT", "LEFT_PAREN_ALT", "LEFT_PAREN_WITH", "LEFT_PAREN_LIKE",
  "LEX_HOSTNAME", "LIKE", "LIMIT", "LINEAR_SYM", "LINES", "LOAD",
  "LOCATOR_SYM", "LOCK_SYM", "LONGBLOB", "LONGTEXT", "LONG_NUM",
  "LONG_SYM", "LOOP_SYM", "LOW_PRIORITY",
  "MASTER_SSL_VERIFY_SERVER_CERT_SYM", "MATCH", "MAX_SYM", "MAXVALUE_SYM",
  "MEDIAN_SYM", "MEDIUMBLOB", "MEDIUMINT", "MEDIUMTEXT",
  "MINUTE_MICROSECOND_SYM", "MINUTE_SECOND_SYM", "MIN_SYM", "MODIFIES_SYM",
  "MOD_SYM", "MYSQL_CONCAT_SYM", "NATURAL", "NCHAR_STRING", "NE", "NEG",
  "NOT2_SYM", "NOT_SYM", "NOW_SYM", "NO_WRITE_TO_BINLOG", "NTILE_SYM",
  "NULL_SYM", "NUM", "NUMERIC_SYM", "NTH_VALUE_SYM", "ON", "OPTIMIZE",
  "OPTIONALLY", "ORACLE_CONCAT_SYM", "OR2_SYM", "ORDER_SYM", "OR_SYM",
  "OTHERS_ORACLE_SYM", "OUTER", "OUTFILE", "OUT_SYM", "OVER_SYM",
  "PACKAGE_ORACLE_SYM", "PAGE_CHECKSUM_SYM", "PARAM_MARKER",
  "PARSE_VCOL_EXPR_SYM", "PARTITION_SYM", "PERCENT_ORACLE_SYM",
  "PERCENT_RANK_SYM", "PERCENTILE_CONT_SYM", "PERCENTILE_DISC_SYM",
  "PORTION_SYM", "POSITION_SYM", "PRECISION", "PRIMARY_SYM",
  "PROCEDURE_SYM", "PURGE", "RAISE_ORACLE_SYM", "RANGE_SYM", "RANK_SYM",
  "READS_SYM", "READ_SYM", "READ_WRITE_SYM", "REAL", "RECURSIVE_SYM",
  "REF_SYSTEM_ID_SYM", "REFERENCES", "REGEXP", "RELEASE_SYM", "RENAME",
  "REPEAT_SYM", "REQUIRE_SYM", "RESIGNAL_SYM", "RESTRICT", "RETURNING_SYM",
  "RETURN_MARIADB_SYM", "RETURN_ORACLE_SYM", "REVOKE", "RIGHT", "ROWS_SYM",
  "ROWTYPE_ORACLE_SYM", "ROW_NUMBER_SYM", "SECOND_MICROSECOND_SYM",
  "SELECT_SYM", "SENSITIVE_SYM", "SEPARATOR_SYM", "SERVER_OPTIONS", "SET",
  "SET_VAR", "SHIFT_LEFT", "SHIFT_RIGHT", "SHOW", "SIGNAL_SYM", "SMALLINT",
  "SPATIAL_SYM", "SPECIFIC_SYM", "SQLEXCEPTION_SYM", "SQLSTATE_SYM",
  "SQLWARNING_SYM", "SQL_BIG_RESULT", "SQL_SMALL_RESULT", "SQL_SYM",
  "SSL_SYM", "STARTING", "STATS_AUTO_RECALC_SYM", "STATS_PERSISTENT_SYM",
  "STATS_SAMPLE_PAGES_SYM", "STDDEV_SAMP_SYM", "STD_SYM", "STRAIGHT_JOIN",
  "SUM_SYM", "SYSDATE", "TABLE_REF_PRIORITY", "TABLE_SYM", "TERMINATED",
  "TEXT_STRING", "THEN_SYM", "TINYBLOB", "TINYINT", "TINYTEXT", "TO_SYM",
  "TRAILING", "TRIGGER_SYM", "TRUE_SYM", "ULONGLONG_NUM",
  "UNDERSCORE_CHARSET", "UNDO_SYM", "UNION_SYM", "UNIQUE_SYM",
  "UNLOCK_SYM", "UNSIGNED", "UPDATE_SYM", "USAGE", "USE_SYM", "USING",
  "UTC_DATE_SYM", "UTC_TIMESTAMP_SYM", "UTC_TIME_SYM", "VALUES",
  "VALUES_IN_SYM", "VALUES_LESS_SYM", "VARBINARY", "VARCHAR",
  "VARIANCE_SYM", "VARYING", "VAR_SAMP_SYM", "WHEN_SYM", "WHERE",
  "WHILE_SYM", "WITH", "WITH_CUBE_SYM", "WITH_ROLLUP_SYM",
  "WITH_SYSTEM_SYM", "XOR", "YEAR_MONTH_SYM", "ZEROFILL",
  "IMPOSSIBLE_ACTION", "BODY_MARIADB_SYM", "ELSEIF_ORACLE_SYM",
  "ELSIF_MARIADB_SYM", "EXCEPTION_ORACLE_SYM", "GOTO_MARIADB_SYM",
  "OTHERS_MARIADB_SYM", "PACKAGE_MARIADB_SYM", "RAISE_MARIADB_SYM",
  "ROWTYPE_MARIADB_SYM", "REPLACE", "SUBSTRING", "TRIM", "ACCOUNT_SYM",
  "ACTION", "ADMIN_SYM", "ADDDATE_SYM", "AFTER_SYM", "AGAINST",
  "AGGREGATE_SYM", "ALGORITHM_SYM", "ALWAYS_SYM", "ANY_SYM", "ASCII_SYM",
  "AT_SYM", "ATOMIC_SYM", "AUTHORS_SYM", "AUTOEXTEND_SIZE_SYM", "AUTO_INC",
  "AUTO_SYM", "AVG_ROW_LENGTH", "AVG_SYM", "BACKUP_SYM",
  "BEGIN_MARIADB_SYM", "BEGIN_ORACLE_SYM", "BINLOG_SYM", "BIT_SYM",
  "BLOCK_SYM", "BOOL_SYM", "BOOLEAN_SYM", "BTREE_SYM", "BYTE_SYM",
  "CACHE_SYM", "CASCADED", "CATALOG_NAME_SYM", "CHAIN_SYM", "CHANGED",
  "CHARSET", "CHECKPOINT_SYM", "CHECKSUM_SYM", "CIPHER_SYM",
  "CLASS_ORIGIN_SYM", "CLIENT_SYM", "CLOB_MARIADB_SYM", "CLOB_ORACLE_SYM",
  "CLOSE_SYM", "COALESCE", "CODE_SYM", "COLLATION_SYM", "COLON_ORACLE_SYM",
  "COLUMNS", "COLUMN_ADD_SYM", "COLUMN_CHECK_SYM", "COLUMN_CREATE_SYM",
  "COLUMN_DELETE_SYM", "COLUMN_GET_SYM", "COLUMN_SYM", "COLUMN_NAME_SYM",
  "COMMENT_SYM", "COMMITTED_SYM", "COMMIT_SYM", "COMPACT_SYM",
  "COMPLETION_SYM", "COMPRESSED_SYM", "CONCURRENT", "CONNECTION_SYM",
  "CONSISTENT_SYM", "CONSTRAINT_CATALOG_SYM", "CONSTRAINT_NAME_SYM",
  "CONSTRAINT_SCHEMA_SYM", "CONTAINS_SYM", "CONTEXT_SYM",
  "CONTRIBUTORS_SYM", "CPU_SYM", "CUBE_SYM", "CURRENT_SYM",
  "CURRENT_POS_SYM", "CURSOR_NAME_SYM", "CYCLE_SYM", "DATAFILE_SYM",
  "DATA_SYM", "DATETIME", "DATE_FORMAT_SYM", "DATE_SYM", "DAY_SYM",
  "DEALLOCATE_SYM", "DEFINER_SYM", "DELAYED_SYM", "DELAY_KEY_WRITE_SYM",
  "DES_KEY_FILE", "DIAGNOSTICS_SYM", "DIRECTORY_SYM", "DISABLE_SYM",
  "DISCARD", "DISK_SYM", "DO_SYM", "DUMPFILE", "DUPLICATE_SYM",
  "DYNAMIC_SYM", "ENABLE_SYM", "END", "ENDS_SYM", "ENGINES_SYM",
  "ENGINE_SYM", "ENUM", "ERROR_SYM", "ERRORS", "ESCAPE_SYM", "EVENTS_SYM",
  "EVENT_SYM", "EVERY_SYM", "EXCHANGE_SYM", "EXAMINED_SYM", "EXCLUDE_SYM",
  "EXECUTE_SYM", "EXCEPTION_MARIADB_SYM", "EXIT_MARIADB_SYM",
  "EXIT_ORACLE_SYM", "EXPANSION_SYM", "EXPIRE_SYM", "EXPORT_SYM",
  "EXTENDED_SYM", "EXTENT_SIZE_SYM", "FAST_SYM", "FAULTS_SYM", "FILE_SYM",
  "FIRST_SYM", "FIXED_SYM", "FLUSH_SYM", "FOLLOWS_SYM", "FOLLOWING_SYM",
  "FORCE_SYM", "FORMAT_SYM", "FOUND_SYM", "FULL", "FUNCTION_SYM",
  "GENERAL", "GENERATED_SYM", "GEOMETRYCOLLECTION", "GEOMETRY_SYM",
  "GET_FORMAT", "GET_SYM", "GLOBAL_SYM", "GRANTS", "HANDLER_SYM",
  "HARD_SYM", "HASH_SYM", "HELP_SYM", "HIGH_PRIORITY", "HISTORY_SYM",
  "HOST_SYM", "HOSTS_SYM", "HOUR_SYM", "ID_SYM", "IDENTIFIED_SYM",
  "IGNORE_SERVER_IDS_SYM", "IMMEDIATE_SYM", "IMPORT", "INCREMENT_SYM",
  "INDEXES", "INITIAL_SIZE_SYM", "INSERT_METHOD", "INSTALL_SYM",
  "INVOKER_SYM", "IO_SYM", "IPC_SYM", "ISOLATION", "ISOPEN_SYM",
  "ISSUER_SYM", "INVISIBLE_SYM", "JSON_SYM", "KEY_BLOCK_SIZE",
  "LANGUAGE_SYM", "LAST_SYM", "LAST_VALUE", "LASTVAL_SYM", "LEAVES",
  "LESS_SYM", "LEVEL_SYM", "LINESTRING", "LIST_SYM", "LOCAL_SYM",
  "LOCKS_SYM", "LOGFILE_SYM", "LOGS_SYM", "MASTER_CONNECT_RETRY_SYM",
  "MASTER_DELAY_SYM", "MASTER_GTID_POS_SYM", "MASTER_HOST_SYM",
  "MASTER_LOG_FILE_SYM", "MASTER_LOG_POS_SYM", "MASTER_PASSWORD_SYM",
  "MASTER_PORT_SYM", "MASTER_SERVER_ID_SYM", "MASTER_SSL_CAPATH_SYM",
  "MASTER_SSL_CA_SYM", "MASTER_SSL_CERT_SYM", "MASTER_SSL_CIPHER_SYM",
  "MASTER_SSL_CRL_SYM", "MASTER_SSL_CRLPATH_SYM", "MASTER_SSL_KEY_SYM",
  "MASTER_SSL_SYM", "MASTER_SYM", "MASTER_USER_SYM", "MASTER_USE_GTID_SYM",
  "MASTER_HEARTBEAT_PERIOD_SYM", "MAX_CONNECTIONS_PER_HOUR",
  "MAX_QUERIES_PER_HOUR", "MAX_ROWS", "MAX_SIZE_SYM",
  "MAX_UPDATES_PER_HOUR", "MAX_STATEMENT_TIME_SYM",
  "MAX_USER_CONNECTIONS_SYM", "MEDIUM_SYM", "MEMORY_SYM", "MERGE_SYM",
  "MESSAGE_TEXT_SYM", "MICROSECOND_SYM", "MIGRATE_SYM", "MINUTE_SYM",
  "MINVALUE_SYM", "MIN_ROWS", "MODE_SYM", "MODIFY_SYM", "MONTH_SYM",
  "MULTILINESTRING", "MULTIPOINT", "MULTIPOLYGON", "MUTEX_SYM",
  "MYSQL_SYM", "MYSQL_ERRNO_SYM", "NAMES_SYM", "NAME_SYM", "NATIONAL_SYM",
  "NCHAR_SYM", "NEVER_SYM", "NEW_SYM", "NEXT_SYM", "NEXTVAL_SYM",
  "NOCACHE_SYM", "NOCYCLE_SYM", "NODEGROUP_SYM", "NONE_SYM",
  "NOTFOUND_SYM", "NO_SYM", "NOMAXVALUE_SYM", "NOMINVALUE_SYM",
  "NO_WAIT_SYM", "NOWAIT_SYM", "NUMBER_MARIADB_SYM", "NUMBER_ORACLE_SYM",
  "NVARCHAR_SYM", "OF_SYM", "OFFSET_SYM", "OLD_PASSWORD_SYM", "ONE_SYM",
  "ONLY_SYM", "ONLINE_SYM", "OPEN_SYM", "OPTIONS_SYM", "OPTION",
  "OWNER_SYM", "PACK_KEYS_SYM", "PAGE_SYM", "PARSER_SYM", "PARTIAL",
  "PARTITIONS_SYM", "PARTITIONING_SYM", "PASSWORD_SYM", "PERIOD_SYM",
  "PERSISTENT_SYM", "PHASE_SYM", "PLUGINS_SYM", "PLUGIN_SYM", "POINT_SYM",
  "POLYGON", "PORT_SYM", "PRECEDES_SYM", "PRECEDING_SYM", "PREPARE_SYM",
  "PRESERVE_SYM", "PREV_SYM", "PREVIOUS_SYM", "PRIVILEGES", "PROCESS",
  "PROCESSLIST_SYM", "PROFILE_SYM", "PROFILES_SYM", "PROXY_SYM",
  "QUARTER_SYM", "QUERY_SYM", "QUICK", "RAW_MARIADB_SYM", "RAW_ORACLE_SYM",
  "READ_ONLY_SYM", "REBUILD_SYM", "RECOVER_SYM", "REDOFILE_SYM",
  "REDO_BUFFER_SIZE_SYM", "REDUNDANT_SYM", "RELAY", "RELAYLOG_SYM",
  "RELAY_LOG_FILE_SYM", "RELAY_LOG_POS_SYM", "RELAY_THREAD", "RELOAD",
  "REMOVE_SYM", "REORGANIZE_SYM", "REPAIR", "REPEATABLE_SYM",
  "REPLICATION", "RESET_SYM", "RESTART_SYM", "RESOURCES", "RESTORE_SYM",
  "RESUME_SYM", "RETURNED_SQLSTATE_SYM", "RETURNS_SYM", "REUSE_SYM",
  "REVERSE_SYM", "ROLE_SYM", "ROLLBACK_SYM", "ROLLUP_SYM", "ROUTINE_SYM",
  "ROWCOUNT_SYM", "ROW_SYM", "ROW_COUNT_SYM", "ROW_FORMAT_SYM",
  "RTREE_SYM", "SAVEPOINT_SYM", "SCHEDULE_SYM", "SCHEMA_NAME_SYM",
  "SECOND_SYM", "SECURITY_SYM", "SEQUENCE_SYM", "SERIALIZABLE_SYM",
  "SERIAL_SYM", "SESSION_SYM", "SERVER_SYM", "SETVAL_SYM", "SHARE_SYM",
  "SHUTDOWN", "SIGNED_SYM", "SIMPLE_SYM", "SLAVE", "SLAVES",
  "SLAVE_POS_SYM", "SLOW", "SNAPSHOT_SYM", "SOCKET_SYM", "SOFT_SYM",
  "SONAME_SYM", "SOUNDS_SYM", "SOURCE_SYM", "SQL_BUFFER_RESULT",
  "SQL_CACHE_SYM", "SQL_CALC_FOUND_ROWS", "SQL_NO_CACHE_SYM", "SQL_THREAD",
  "STAGE_SYM", "STARTS_SYM", "START_SYM", "STATEMENT_SYM", "STATUS_SYM",
  "STOP_SYM", "STORAGE_SYM", "STORED_SYM", "STRING_SYM",
  "SUBCLASS_ORIGIN_SYM", "SUBDATE_SYM", "SUBJECT_SYM", "SUBPARTITIONS_SYM",
  "SUBPARTITION_SYM", "SUPER_SYM", "SUSPEND_SYM", "SWAPS_SYM",
  "SWITCHES_SYM", "SYSTEM", "SYSTEM_TIME_SYM", "TABLES", "TABLESPACE",
  "TABLE_CHECKSUM_SYM", "TABLE_NAME_SYM", "TEMPORARY", "TEMPTABLE_SYM",
  "TEXT_SYM", "THAN_SYM", "TIES_SYM", "TIMESTAMP", "TIMESTAMP_ADD",
  "TIMESTAMP_DIFF", "TIME_SYM", "TRANSACTION_SYM", "TRANSACTIONAL_SYM",
  "TRIGGERS_SYM", "TRIM_ORACLE", "TRUNCATE_SYM", "TYPES_SYM", "TYPE_SYM",
  "UDF_RETURNS_SYM", "UNBOUNDED_SYM", "UNCOMMITTED_SYM", "UNDEFINED_SYM",
  "UNDOFILE_SYM", "UNDO_BUFFER_SIZE_SYM", "UNICODE_SYM", "UNINSTALL_SYM",
  "UNKNOWN_SYM", "UNTIL_SYM", "UPGRADE_SYM", "USER_SYM", "USE_FRM",
  "VALUE_SYM", "VARCHAR2_MARIADB_SYM", "VARCHAR2_ORACLE_SYM", "VARIABLES",
  "VERSIONING_SYM", "VIA_SYM", "VIEW_SYM", "VIRTUAL_SYM", "WAIT_SYM",
  "WARNINGS", "WEEK_SYM", "WEIGHT_STRING_SYM", "WINDOW_SYM", "WITHIN",
  "WITHOUT", "WORK_SYM", "WRAPPER_SYM", "WRITE_SYM", "X509_SYM", "XA_SYM",
  "XML_SYM", "YEAR_SYM", "CONDITIONLESS_JOIN", "ON_SYM", "PREC_BELOW_NOT",
  "'='", "'>'", "'<'", "'|'", "'&'", "'-'", "'+'", "'*'", "'/'", "'%'",
  "'^'", "'~'", "SUBQUERY_AS_EXPR",
  "PREC_BELOW_IDENTIFIER_OPT_SPECIAL_CASE", "USER",
  "PREC_BELOW_CONTRACTION_TOKEN2", "'('", "')'", "EMPTY_FROM_CLAUSE",
  "','", "'!'", "'{'", "'}'", "';'", "'.'", "'@'", "$accept", "query",
  "$@1", "opt_end_of_input", "verb_clause", "statement", "deallocate",
  "deallocate_or_drop", "prepare", "$@2", "execute", "$@3", "$@4",
  "execute_using", "$@5", "execute_params", "help", "$@6", "change", "$@7",
  "master_defs", "master_def", "ignore_server_id_list", "ignore_server_id",
  "do_domain_id_list", "do_domain_id", "ignore_domain_id_list",
  "ignore_domain_id", "master_file_def", "optional_connection_name",
  "connection_name", "create", "$@8", "$@9", "$@10", "$@11", "$@12",
  "$@13", "$@14", "$@15", "$@16", "$@17", "$@18", "$@19", "$@20", "$@21",
  "$@22", "$@23", "$@24", "$@25", "$@26", "$@27", "$@28", "$@29", "$@30",
  "$@31", "package_implementation_executable_section",
  "package_implementation_declare_section",
  "package_implementation_declare_section_list1",
  "package_implementation_declare_section_list2", "package_routine_lex",
  "package_specification_function", "$@32",
  "package_specification_procedure", "$@33",
  "package_implementation_routine_definition",
  "package_implementation_function_body", "$@34",
  "package_implementation_procedure_body", "$@35",
  "package_implementation_item_declaration",
  "opt_package_specification_element_list",
  "package_specification_element_list", "package_specification_element",
  "opt_sequence", "sequence_defs", "sequence_def", "force_lookahead",
  "server_def", "$@36", "server_options_list", "server_option",
  "event_tail", "$@37", "ev_schedule_time", "$@38", "opt_ev_status",
  "ev_starts", "ev_ends", "opt_ev_on_completion", "ev_on_completion",
  "opt_ev_comment", "ev_sql_stmt", "$@39", "clear_privileges",
  "opt_aggregate", "sp_name", "opt_sp_name", "sp_a_chistics",
  "sp_c_chistics", "sp_chistic", "create_package_chistic",
  "create_package_chistics", "opt_create_package_chistics",
  "opt_create_package_chistics_init", "$@40", "sp_c_chistic", "sp_suid",
  "call", "$@41", "$@42", "$@43", "opt_sp_cparam_list", "opt_sp_cparams",
  "sp_cparams", "sp_fdparam_list", "$@44", "sp_fdparams", "sp_param_name",
  "sp_param_name_and_type", "sp_pdparam_list", "sp_pdparams", "sp_pdparam",
  "sp_opt_inout", "sp_parenthesized_pdparam_list", "$@45", "sp_no_param",
  "opt_sp_parenthesized_fdparam_list", "opt_sp_parenthesized_pdparam_list",
  "sp_proc_stmts", "sp_proc_stmts1", "sp_proc_stmts1_implicit_block",
  "$@46", "opt_sp_decl_body_list", "sp_decl_body_list", "$@47",
  "sp_decl_non_handler_list", "sp_decl_handler_list",
  "opt_sp_decl_handler_list", "optionally_qualified_column_ident",
  "row_field_name", "row_field_definition", "row_field_definition_list",
  "row_type_body", "sp_decl_idents_init_vars", "sp_decl_vars",
  "sp_decl_non_handler", "$@48", "sp_decl_handler", "$@49",
  "opt_parenthesized_cursor_formal_parameters", "sp_cursor_stmt_lex",
  "sp_cursor_stmt", "$@50", "sp_handler_type", "sp_hcond_list",
  "sp_hcond_element", "sp_cond", "sqlstate", "opt_value", "sp_hcond",
  "raise_stmt_oracle", "signal_stmt", "signal_value", "opt_signal_value",
  "opt_set_signal_information", "signal_information_item_list",
  "signal_allowed_expr", "signal_condition_information_item_name",
  "resignal_stmt", "get_diagnostics", "which_area",
  "diagnostics_information", "statement_information",
  "statement_information_item", "simple_target_specification",
  "statement_information_item_name", "condition_number",
  "condition_information", "condition_information_item",
  "condition_information_item_name", "sp_decl_ident", "sp_decl_idents",
  "sp_opt_default", "sp_proc_stmt", "sp_labelable_stmt",
  "sp_proc_stmt_compound_ok", "sp_proc_stmt_if", "$@51", "sp_statement",
  "$@52", "$@53", "$@54", "sp_proc_stmt_statement", "$@55",
  "RETURN_ALLMODES_SYM", "sp_proc_stmt_return", "$@56", "reset_lex_expr",
  "$@57", "sp_proc_stmt_exit_oracle", "sp_proc_stmt_continue_oracle",
  "sp_proc_stmt_leave", "sp_proc_stmt_iterate", "sp_proc_stmt_goto_oracle",
  "remember_lex", "assignment_source_lex", "assignment_source_expr",
  "$@58", "for_loop_bound_expr", "$@59", "cursor_actual_parameters",
  "opt_parenthesized_cursor_actual_parameters", "sp_proc_stmt_open",
  "sp_proc_stmt_fetch_head", "sp_proc_stmt_fetch", "sp_proc_stmt_close",
  "sp_fetch_list", "sp_if", "$@60", "$@61", "$@62", "sp_elseifs",
  "case_stmt_specification", "$@63", "case_stmt_body", "$@64", "$@65",
  "simple_when_clause_list", "searched_when_clause_list",
  "simple_when_clause", "$@66", "$@67", "searched_when_clause", "$@68",
  "$@69", "else_clause_opt", "sp_opt_label", "sp_block_label",
  "sp_labeled_block", "$@70", "$@71", "$@72", "opt_not_atomic",
  "sp_unlabeled_block", "$@73", "$@74", "$@75", "sp_instr_addr", "sp_body",
  "$@76", "$@77", "$@78", "sp_block_statements_and_exceptions", "$@79",
  "opt_exception_clause", "exception_handlers", "exception_handler",
  "$@80", "opt_sp_for_loop_direction", "sp_for_loop_index_and_bounds",
  "$@81", "sp_for_loop_bounds", "loop_body", "while_body", "$@82",
  "repeat_body", "$@83", "pop_sp_loop_label", "sp_labeled_control", "$@84",
  "$@85", "$@86", "$@87", "$@88", "$@89", "sp_unlabeled_control", "$@90",
  "$@91", "$@92", "$@93", "$@94", "trg_action_time", "trg_event",
  "change_tablespace_access", "change_tablespace_info", "tablespace_info",
  "opt_logfile_group_name", "alter_tablespace_info", "logfile_group_info",
  "alter_logfile_group_info", "add_log_file", "change_ts_option_list",
  "$@95", "change_ts_options", "change_ts_option",
  "tablespace_option_list", "tablespace_options", "tablespace_option",
  "alter_tablespace_option_list", "alter_tablespace_options",
  "alter_tablespace_option", "logfile_group_option_list",
  "logfile_group_options", "logfile_group_option",
  "alter_logfile_group_option_list", "alter_logfile_group_options",
  "alter_logfile_group_option", "ts_datafile", "lg_undofile",
  "lg_redofile", "tablespace_name", "logfile_group_name", "ts_access_mode",
  "opt_ts_initial_size", "opt_ts_autoextend_size", "opt_ts_max_size",
  "opt_ts_extent_size", "opt_ts_undo_buffer_size",
  "opt_ts_redo_buffer_size", "opt_ts_nodegroup", "opt_ts_comment",
  "opt_ts_engine", "opt_ts_wait", "ts_wait", "size_number", "create_body",
  "$@96", "create_like", "opt_create_select",
  "create_select_query_expression", "opt_create_partitioning",
  "opt_partitioning", "partitioning", "$@97", "have_partitioning",
  "partition_entry", "$@98", "partition", "$@99", "part_type_def", "$@100",
  "$@101", "$@102", "opt_linear", "opt_key_algo", "part_field_list",
  "part_field_item_list", "part_field_item", "part_column_list",
  "part_func", "sub_part_func", "opt_num_parts", "opt_sub_part", "$@103",
  "$@104", "sub_part_field_list", "sub_part_field_item", "part_func_expr",
  "opt_num_subparts", "part_defs", "part_def_list", "part_definition",
  "$@105", "part_name", "opt_part_values", "$@106", "$@107",
  "part_func_max", "part_values_in", "part_value_list", "part_value_item",
  "$@108", "$@109", "part_value_item_list", "part_value_expr_item",
  "opt_sub_partition", "sub_part_list", "sub_part_definition", "$@110",
  "sub_name", "opt_part_options", "opt_part_option_list",
  "opt_part_option", "opt_versioning_rotation", "$@111",
  "opt_versioning_interval_start", "opt_as", "opt_create_database_options",
  "create_database_options", "create_database_option",
  "opt_if_not_exists_table_element", "opt_if_not_exists",
  "create_or_replace", "opt_create_table_options",
  "create_table_options_space_separated", "create_table_options",
  "create_table_option", "$@112", "opt_versioning_option",
  "versioning_option", "default_charset", "default_collation",
  "storage_engines", "known_storage_engines", "row_types",
  "merge_insert_types", "udf_type", "create_field_list",
  "create_field_list_parens", "field_list", "field_list_item",
  "column_def", "key_def", "$@113", "$@114", "$@115", "$@116", "$@117",
  "$@118", "$@119", "constraint_def", "period_for_system_time",
  "period_for_application_time", "opt_check_constraint",
  "check_constraint", "opt_constraint_no_id", "opt_constraint",
  "constraint", "field_spec", "@120", "field_type_or_serial", "$@121",
  "$@122", "opt_serial_attribute", "opt_serial_attribute_list",
  "opt_asrow_attribute", "opt_asrow_attribute_list", "field_def", "$@123",
  "opt_generated_always", "vcol_opt_specifier", "vcol_opt_attribute",
  "vcol_opt_attribute_list", "vcol_attribute", "parse_vcol_expr", "$@124",
  "parenthesized_expr", "virtual_column_func", "expr_or_literal",
  "column_default_expr", "field_type", "qualified_field_type",
  "field_type_all", "sp_param_field_type", "field_type_numeric",
  "opt_binary_and_compression", "field_type_string",
  "sp_param_field_type_string", "field_type_temporal", "field_type_lob",
  "field_type_misc", "spatial_type", "char", "nchar", "varchar",
  "nvarchar", "int_type", "real_type", "srid_option", "float_options",
  "precision", "field_options", "field_length", "opt_field_length",
  "opt_field_length_default_1",
  "opt_field_length_default_sp_param_varchar",
  "opt_field_length_default_sp_param_char", "opt_precision",
  "attribute_list", "attribute", "opt_compression_method",
  "opt_compressed", "compressed",
  "compressed_deprecated_data_type_attribute",
  "compressed_deprecated_column_attribute", "asrow_attribute",
  "serial_attribute", "with_or_without_system", "sp_param_type", "charset",
  "charset_name", "charset_name_or_default", "opt_load_data_charset",
  "old_or_new_charset_name", "old_or_new_charset_name_or_default",
  "collation_name", "opt_collate", "collation_name_or_default",
  "opt_default", "charset_or_alias", "collate", "opt_binary", "binary",
  "opt_bin_mod", "ws_nweights", "$@125", "ws_level_flag_desc",
  "ws_level_flag_reverse", "ws_level_flags", "ws_level_number",
  "ws_level_list_item", "ws_level_list", "ws_level_range",
  "ws_level_list_or_range", "opt_ws_levels", "opt_primary", "references",
  "opt_ref_list", "ref_list", "opt_match_clause", "opt_on_update_delete",
  "delete_option", "constraint_key_type", "key_or_index",
  "opt_key_or_index", "keys_or_index", "opt_unique", "fulltext", "spatial",
  "normal_key_options", "fulltext_key_options", "spatial_key_options",
  "normal_key_opts", "spatial_key_opts", "fulltext_key_opts",
  "opt_USING_key_algorithm", "opt_key_algorithm_clause", "key_using_alg",
  "all_key_opt", "normal_key_opt", "spatial_key_opt", "fulltext_key_opt",
  "btree_or_rtree", "key_list", "key_part", "opt_ident", "string_list",
  "alter", "$@126", "$@127", "$@128", "$@129", "$@130", "$@131", "$@132",
  "$@133", "$@134", "$@135", "$@136", "account_locking_option",
  "opt_password_expire_option",
  "opt_account_locking_and_opt_password_expiration",
  "ev_alter_on_schedule_completion", "opt_ev_rename_to", "opt_ev_sql_stmt",
  "ident_or_empty", "alter_commands", "$@137", "$@138", "$@139",
  "remove_partitioning", "all_or_alt_part_name_list", "add_partition_rule",
  "$@140", "add_part_extra", "reorg_partition_rule", "$@141",
  "reorg_parts_rule", "$@142", "alt_part_name_list", "alt_part_name_item",
  "alter_list", "add_column", "alter_list_item",
  "opt_index_lock_algorithm", "alter_algorithm_option",
  "alter_lock_option", "opt_column", "opt_ignore", "alter_options",
  "$@143", "alter_options_part2", "alter_option_list", "alter_option",
  "opt_restrict", "opt_place", "opt_to", "slave", "$@144", "$@145",
  "start", "opt_start_transaction_option_list",
  "start_transaction_option_list", "start_transaction_option",
  "slave_thread_opts", "$@146", "slave_thread_opt_list",
  "slave_thread_opt", "slave_until", "slave_until_opts", "checksum",
  "$@147", "opt_checksum_type", "repair_table_or_view", "$@148", "repair",
  "$@149", "opt_mi_repair_type", "mi_repair_types", "mi_repair_type",
  "opt_view_repair_type", "analyze", "$@150", "analyze_table_list",
  "analyze_table_elem_spec", "opt_persistent_stat_clause",
  "persistent_stat_spec", "persistent_column_stat_spec", "$@151",
  "persistent_index_stat_spec", "$@152", "table_column_list",
  "table_index_list", "table_index_name", "binlog_base64_event",
  "check_view_or_table", "$@153", "check", "$@154", "opt_mi_check_type",
  "mi_check_types", "mi_check_type", "opt_view_check_type", "optimize",
  "$@155", "opt_no_write_to_binlog", "rename", "$@156", "rename_list",
  "table_to_table_list", "table_to_table", "keycache", "$@157",
  "keycache_list_or_parts", "keycache_list", "assign_to_keycache",
  "assign_to_keycache_parts", "key_cache_name", "preload", "$@158",
  "preload_list_or_parts", "preload_list", "preload_keys",
  "preload_keys_parts", "adm_partition", "$@159", "cache_keys_spec",
  "$@160", "cache_key_list_or_empty", "opt_ignore_leaves", "select",
  "$@161", "$@162", "select_into", "$@163", "$@164", "simple_table",
  "table_value_constructor", "$@165", "query_specification_start", "$@166",
  "$@167", "query_specification", "select_into_query_specification",
  "query_expression", "query_expression_no_with_clause",
  "query_expression_body_ext", "$@168", "$@169",
  "query_expression_body_ext_parens", "query_expression_body", "$@170",
  "query_primary", "query_simple", "subselect", "subquery",
  "opt_from_clause", "from_clause", "table_reference_list",
  "select_options", "opt_history_unit", "history_point",
  "for_portion_of_time_clause", "opt_for_portion_of_time_clause",
  "opt_for_system_time_clause", "system_time_expr", "select_option_list",
  "select_option", "select_lock_type", "opt_select_lock_type",
  "opt_lock_wait_timeout_new", "select_item_list", "select_item",
  "remember_tok_start", "remember_name", "remember_end",
  "remember_end_opt", "select_alias", "opt_default_time_precision",
  "opt_time_precision", "optional_braces", "expr", "boolean_test",
  "predicate", "bit_expr", "or", "and", "not", "not2", "comp_op",
  "all_or_any", "opt_dyncol_type", "dyncol_type", "numeric_dyncol_type",
  "temporal_dyncol_type", "string_dyncol_type", "$@171",
  "dyncall_create_element", "dyncall_create_list", "plsql_cursor_attr",
  "explicit_cursor_attr", "trim_operands", "trim_operands_regular",
  "trim_operands_special", "column_default_non_parenthesized_expr",
  "primary_expr", "string_factor_expr", "simple_expr",
  "mysql_concatenation_expr", "function_call_keyword_timestamp",
  "function_call_keyword", "substring_operands",
  "substring_operands_regular", "substring_operands_special",
  "function_call_nonkeyword", "function_call_conflict",
  "geometry_function", "function_call_generic", "@172", "fulltext_options",
  "opt_natural_language_mode", "opt_query_expansion", "opt_udf_expr_list",
  "udf_expr_list", "udf_expr", "sum_expr", "$@173", "$@174", "$@175",
  "window_func_expr", "window_func", "simple_window_func",
  "inverse_distribution_function", "percentile_function", "$@176",
  "inverse_distribution_function_def", "order_by_single_element_list",
  "window_name", "variable", "$@177", "variable_aux", "opt_distinct",
  "opt_gconcat_separator", "opt_gorder_clause", "gorder_list",
  "opt_glimit_clause", "glimit_clause_init", "glimit_clause",
  "glimit_options", "in_sum_expr", "$@178", "cast_type", "$@179", "$@180",
  "$@181", "cast_type_numeric", "cast_type_temporal", "opt_expr_list",
  "expr_list", "ident_list_arg", "ident_list", "when_list",
  "when_list_opt_else", "table_ref", "join_table_list", "esc_table_ref",
  "derived_table_list", "join_table", "$@182", "$@183", "$@184", "$@185",
  "$@186", "$@187", "inner_join", "normal_join", "opt_use_partition",
  "use_partition", "table_factor", "table_primary_ident_opt_parens",
  "table_primary_derived_opt_parens", "table_reference_list_parens",
  "nested_table_reference_list", "join_table_parens",
  "table_primary_ident", "table_primary_derived", "opt_outer",
  "index_hint_clause", "index_hint_type", "index_hint_definition", "$@188",
  "$@189", "index_hints_list", "opt_index_hints_list", "$@190",
  "opt_key_definition", "$@191", "opt_key_usage_list", "key_usage_element",
  "key_usage_list", "using_list", "interval", "interval_time_stamp",
  "date_time_type", "table_alias", "opt_table_alias_clause",
  "table_alias_clause", "opt_all", "opt_where_clause", "$@192",
  "opt_having_clause", "$@193", "opt_group_clause", "group_list",
  "olap_opt", "opt_window_clause", "window_def_list", "window_def",
  "window_spec", "$@194", "opt_window_ref", "opt_window_partition_clause",
  "opt_window_order_clause", "opt_window_frame_clause",
  "window_frame_units", "window_frame_extent", "window_frame_start",
  "window_frame_bound", "opt_window_frame_exclusion", "alter_order_clause",
  "alter_order_list", "alter_order_item", "opt_order_clause",
  "order_clause", "$@195", "order_list", "order_dir", "opt_limit_clause",
  "limit_clause", "opt_global_limit_clause", "limit_options",
  "limit_option", "limit_rows_option", "delete_limit_clause",
  "order_limit_lock", "opt_order_limit_lock", "query_expression_tail",
  "opt_query_expression_tail", "opt_procedure_or_into", "order_or_limit",
  "opt_plus", "int_num", "ulong_num", "real_ulong_num", "longlong_num",
  "ulonglong_num", "real_ulonglong_num", "dec_num_error", "dec_num",
  "choice", "bool", "procedure_clause", "$@196", "procedure_list",
  "procedure_list2", "procedure_item", "select_var_list_init", "$@197",
  "select_var_list", "select_var_ident", "select_outvar", "into",
  "into_destination", "$@198", "$@199", "do", "$@200", "drop", "$@201",
  "$@202", "$@203", "$@204", "table_list", "table_name",
  "table_name_with_opt_use_partition", "table_alias_ref_list",
  "table_alias_ref", "opt_if_exists_table_element", "opt_if_exists",
  "opt_temporary", "insert", "$@205", "$@206", "replace", "$@207", "$@208",
  "insert_lock_option", "replace_lock_option", "insert2", "insert_table",
  "$@209", "insert_field_spec", "$@210", "insert_field_list", "opt_fields",
  "fields", "insert_values", "values_list", "ident_eq_list",
  "ident_eq_value", "equal", "opt_equal", "opt_with", "opt_by",
  "no_braces", "$@211", "no_braces_with_names", "$@212", "opt_values",
  "opt_values_with_names", "values", "values_with_names", "expr_or_ignore",
  "expr_or_ignore_or_default", "opt_insert_update", "$@213", "$@214",
  "update_table_list", "update", "$@215", "$@216", "update_list",
  "update_elem", "insert_update_list", "insert_update_elem",
  "opt_low_priority", "delete", "$@217", "opt_delete_system_time",
  "delete_part2", "delete_single_table", "delete_single_table_for_period",
  "single_multi", "$@218", "$@219", "opt_select_expressions",
  "table_wild_list", "table_wild_one", "opt_wild", "opt_delete_options",
  "opt_delete_option", "truncate", "$@220", "$@221",
  "opt_truncate_table_storage_clause", "opt_table_sym", "opt_profile_defs",
  "profile_defs", "profile_def", "opt_profile_args", "show", "$@222",
  "show_param", "$@223", "$@224", "show_engine_param", "master_or_binary",
  "opt_storage", "opt_db", "opt_full", "from_or_in", "binlog_in",
  "binlog_from", "wild_and_where", "describe", "$@225", "$@226",
  "explainable_command", "describe_command", "analyze_stmt_command",
  "opt_extended_describe", "opt_format_json", "opt_describe_column",
  "flush", "$@227", "flush_options", "$@228", "opt_flush_lock",
  "flush_lock", "$@229", "flush_options_list", "flush_option",
  "opt_table_list", "backup", "backup_statements", "$@230",
  "opt_delete_gtid_domain", "delete_domain_id_list", "delete_domain_id",
  "optional_flush_tables_arguments", "reset", "$@231", "reset_options",
  "reset_option", "$@232", "$@233", "slave_reset_options",
  "master_reset_options", "purge", "$@234", "kill", "$@235", "kill_type",
  "kill_option", "opt_connection", "kill_expr", "shutdown", "$@236",
  "shutdown_option", "use", "load", "$@237", "$@238", "$@239", "$@240",
  "data_or_xml", "opt_local", "load_data_lock", "opt_duplicate",
  "opt_field_term", "field_term_list", "field_term", "opt_line_term",
  "line_term_list", "line_term", "opt_xml_rows_identified_by",
  "opt_ignore_lines", "lines_or_rows", "opt_field_or_var_spec",
  "fields_or_vars", "field_or_var", "opt_load_data_set_spec",
  "load_data_set_list", "load_data_set_elem", "text_literal",
  "text_string", "hex_or_bin_String", "param_marker", "signed_literal",
  "literal", "NUM_literal", "temporal_literal", "with_clause", "$@241",
  "opt_recursive", "with_list", "with_list_element", "$@242",
  "opt_with_column_list", "with_column_list", "with_element_head",
  "insert_ident", "table_wild", "select_sublist_qualified_asterisk",
  "order_ident", "simple_ident", "simple_ident_nospvar", "field_ident",
  "table_ident", "table_ident_opt_wild", "table_ident_nodb", "IDENT_cli",
  "ident_cli", "IDENT_sys", "TEXT_STRING_sys", "TEXT_STRING_literal",
  "TEXT_STRING_filesystem", "ident_table_alias", "ident_set_usual_case",
  "ident_sysvar_name", "ident", "ident_directly_assignable", "label_ident",
  "labels_declaration_oracle", "label_declaration_oracle", "ident_or_text",
  "user_maybe_role", "user_or_role", "user", "keyword_table_alias",
  "keyword_ident", "keyword_label", "keyword_sysvar_name",
  "keyword_sp_decl", "keyword_set_usual_case",
  "keyword_directly_assignable", "keyword_sp_var_not_label",
  "keyword_sp_head", "keyword_verb_clause", "keyword_set_special_case",
  "keyword_sp_block_section", "keyword_sysvar_type", "keyword_data_type",
  "keyword_sp_var_and_label", "set", "$@243", "$@244", "$@245",
  "set_assign", "$@246", "$@247", "$@248",
  "set_stmt_option_value_following_option_type_list",
  "start_option_value_list", "$@249", "$@250", "$@251",
  "start_option_value_list_following_option_type", "$@252",
  "option_value_list_continued", "option_value_list", "$@253", "$@254",
  "option_value", "$@255", "option_type", "opt_var_type",
  "opt_var_ident_type", "option_value_following_option_type",
  "option_value_no_option_type", "transaction_characteristics",
  "transaction_access_mode", "isolation_level",
  "transaction_access_mode_types", "isolation_types", "opt_for_user",
  "text_or_password", "set_expr_or_default", "lock", "$@256",
  "opt_lock_wait_timeout", "table_or_tables", "table_lock_list",
  "table_lock", "lock_option", "unlock", "$@257", "handler", "$@258",
  "handler_tail", "$@259", "handler_read_or_scan", "handler_scan_function",
  "handler_rkey_function", "$@260", "handler_rkey_mode", "revoke",
  "revoke_command", "admin_option_for_role", "grant", "grant_command",
  "opt_with_admin", "opt_with_admin_option", "role_list", "current_role",
  "grant_role", "opt_table", "grant_privileges", "opt_privileges",
  "object_privilege_list", "object_privilege", "$@261", "$@262", "$@263",
  "$@264", "opt_and", "require_list", "require_list_element",
  "grant_ident", "user_list", "grant_list", "user_and_role_list",
  "via_or_with", "using_or_as", "grant_user", "auth_expression",
  "auth_token", "opt_auth_str", "opt_column_list", "column_list",
  "column_list_id", "opt_require_clause", "resource_option",
  "resource_option_list", "opt_resource_options", "opt_grant_options",
  "opt_grant_option", "grant_option_list", "grant_option",
  "begin_stmt_mariadb", "$@265", "compound_statement", "opt_not",
  "opt_work", "opt_chain", "opt_release", "commit", "rollback",
  "savepoint", "release", "unit_type_decl", "union_option",
  "query_expression_option", "definer_opt", "no_definer", "definer",
  "view_algorithm", "opt_view_suid", "view_suid", "view_list_opt",
  "view_list", "view_select", "$@266", "view_check_option",
  "trigger_action_order", "trigger_follows_precedes_clause",
  "trigger_tail", "$@267", "$@268", "$@269", "$@270", "$@271",
  "sf_return_type", "$@272", "sf_c_chistics_and_body_standalone", "$@273",
  "sp_tail_standalone", "$@274", "$@275", "opt_package_routine_end_name",
  "sp_tail_is", "xa", "opt_format_xid", "xid", "begin_or_start",
  "opt_join_or_resume", "opt_one_phase", "opt_suspend", "$@276",
  "opt_migrate", "install", "uninstall", "keep_gcc_happy", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-5376)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-3497)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const int yypact[] =
{
   16367,  4685,  1398, 87465, -5376,   368, -5376,   972, -5376, -5376,
   -5376, -5376,  4518, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376,   376,  1125, -5376,  1131, -5376, -5376,   380, 82985,    18,
    1113, -5376, 84265, -5376, -5376,   375, -5376, 84265, -5376, -5376,
   87465, -5376, -5376,  1282, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376,   636, -5376,  2303,    95, -5376, -5376, -5376,
   -5376, -5376, -5376,  1422, -5376, -5376, -5376, -5376, -5376,  1125,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, 87465, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,   855, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376,  1350, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, 88105,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376,  2053, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376,  1095, -5376, -5376, -5376, -5376, -5376,   718, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376,  1378, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, 87465, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376,  1131, -5376, -5376,   926, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376,   855, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, 87465, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376,   271, -5376, -5376,   300,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376,  1862, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376,  3052, -5376, -5376,   440,  1986,
    2134, -5376, -5376,  1725, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
    4942, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,  2478, -5376,
   -5376, -5376, -5376,  3015,  1957, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, 71445, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376,   440, -5376, -5376,   118, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, 87465, 87465,  1628,  1754, 87465,  2516,  2410, 83625,
   87465,  2410, -5376,   444, -5376, -5376,  1936, -5376,  1866, -5376,
    1125,  2243, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
    1875, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
    2365,  2414,  1157,  2403,  2625, 87465, 50865,  1214,  2410, -5376,
     581,  2410,  2410,  2410,  2410,  2648,  2410,  2410, 87465, -5376,
    2410,  2410,  1000, 91945, 38235, -5376,  1445,   942,  2633, -5376,
   -5376, -5376, -5376, -5376, -5376,  7882,  1125, 24474,  2744, -5376,
   -5376,  2280,  4741,  2084, -5376,  2581, -5376, -5376, 87465, -5376,
   -5376,  7882, -5376,  2581, 38979,  2857, -5376, 36778,  8747,  2581,
    1125,  2679, -5376,  2110, 24474, -5376, -5376,  1544, -5376, -5376,
   87465, -5376,   855, -5376, -5376, -5376,  2560, -5376, 83625, -5376,
   -5376, -5376,  2108, -5376,  2902, 24474,   218,  2639, -5376, -5376,
    2523, 72085, 83625,  2843,  2414,  2846, -5376,  1858,  1489, -5376,
    2229,  2301,  2414,  2276,  2320,  2414,  2754,  2410,  2410, -5376,
   -5376,  2183,  2183,  2183,  2559,  2183, -5376,  2183,  2935,  2265,
     327, -5376, -5376,  2266, 87465,  2843, -5376, -5376, -5376,  2843,
    2843,  2396,  2944,  2949,  2954,   322,  2136,  1961,  1961,  1936,
   52941,  1288,  2778, -5376,  2935,  3144,  1903, -5376, -5376,  1993,
    3144,   440,  3144, -5376,   256,  1866,  2829, 87465, -5376, -5376,
   -5376,  2315, -5376, -5376, -5376, 87465, -5376,  2380, -5376,  2332,
    1549, 51570, -5376, 87465,  3037, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376,  2149, -5376, -5376,  2869,   735,  2477,  2714,
    2439, -5376,  2900, 83625, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, 87465,  2432, -5376,  3110, 24474,  2365, -5376,  2947,
   -5376, -5376, -5376, -5376, 72085, -5376, 87465, -5376,  3216, -5376,
   -5376, 91945, -5376, -5376,   403, -5376, -5376, 54338,  1519, 43853,
   -5376,  2459,  2472,  2795, -5376,  2493,  1299,  1348, -5376,  1438,
   -5376, -5376,  1500,  1531,  1539, -5376, -5376,  3175, -5376, -5376,
   75305,   716, 87465,  3166,  2410, 87465, 87465, 87465, 87465, 87465,
   87465, -5376, 83625,  2593, -5376, -5376,  2410,  2410, -5376, -5376,
    2690,  2655,  3063,  2532,  2840, -5376,  2738, -5376, -5376,  2629,
   -5376, -5376,   246, -5376, -5376, -5376,   134,   183,   269,   299,
    3154,   318,    85,   319,   358, -5376, -5376, -5376,  3070,  3165,
    2585, -5376,  2946, 24474, -5376, -5376, -5376,  3253, -5376, -5376,
     205,  3035,  1272, 72085, 92585, 74655, 93513, 93513, 93513, -5376,
   -5376,   302, 93513, 87465, 93049, 87465,  7228,  2617, -5376, -5376,
   -5376, 17853, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   87465, -5376, -5376, -5376,   417, -5376, -5376, -5376, -5376, -5376,
    7976, -5376, -5376, 29626, -5376,  2642,  2658,  2663, 20058,  2669,
    2676,  2680,  2698,  2713,  2532,  2532,  2532,  2718,  2736,  2742,
    2747, -5376,  2753,  2781,  2810,  2820, -5376,  2825, -5376,  2831,
    2851,  2862, -5376, -5376,   335,   374,  2874,  2885, 25210,  2893,
   -5376, 66325,  2896,  2898,  2908,  2912, -5376, -5376, 24474,  2718,
    2916, -5376, -5376,  2941, -5376,  2958,  2962,  2972,  2975,  2976,
    2988,  2992,  2997,  3227,  2998,  3003,  3009,  2718, -5376, -5376,
   -5376,  2289,  2532,  2718,  2718,  3014,  3059,  3060,  3069,  3076,
    3079,  3089,  3093,  3094,  3097,  3105, 84905,  3111,  3114,  3121,
    3124,  3128,  3129,  3147,   454,  3159,  3174,  3190,  3195,  3200,
    3210,  3222,  3232,  3258,  3261,  3264,  3284,  3287,  3290,  2724,
    3291,  3303,  3321,  3326,  3331,  2764,  3332,  3333,  3334,  3336,
    3337,  3338,  3339,   473,  3343,  3344,   488,  3346,  3353,  3356,
    3357,  3358,  3359,  3360,  3362, 30362, 31098, 29626, 18586, -5376,
   87465, 88745, -5376, -5376, -5376,  3349,   571,  2703,  3465, 29626,
   -5376, -5376, -5376,  3438, -5376,  3371, -5376, -5376, -5376, -5376,
   -5376,  3368,  3372, -5376,  3397, -5376, -5376,  3425,  2803, -5376,
    3385, -5376, -5376, -5376, -5376, -5376,  2855,  3363,  3476,  3481,
   -5376, -5376,   467, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376,  2963,  3031, -5376,  3385, -5376,
   -5376, 52270, 72085,  5791, -5376, -5376,  2690,  3217,  3618, -5376,
    3710, -5376,  3638, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376,  2857, -5376, -5376, 57785,  3587,
    1304,   541,  3090,   562,   622, 43119,   198, 79785,   834,  1246,
    3145, 62485, 46767,  3157,   400,  3178, -5376,  3205,  3245,  3266,
    3341,  3364,  3374,  3375, -5376, -5376, -5376,  3192,  3366,  3131,
    2036, -5376, -5376,   287,   188,  3229, -5376,  3640, -5376,  2036,
   -5376, 39645,  3992,   546, -5376,  1028, -5376,  4043, -5376, -5376,
    3461,  3449,  3482, -5376,  3096, -5376,  2414, -5376,  1011, -5376,
    3992,  2036,   546, -5376,  3653,  3738,  1729,  4064, -5376,  1615,
   -5376, -5376, -5376,  3253, -5376,  3387, -5376, -5376,  2909, 87465,
   -5376,  4037, -5376, 72085, -5376, -5376, -5376, -5376,  3389, 72085,
   72085, 87465,   145,  1067,  3349,  3395, 24474, -5376, -5376,  5914,
   40355,  3595,  1755,   -70, -5376, -5376,  2303, 87465, -5376, -5376,
    1186, -5376,  3825, -5376,  3406, -5376, 89385,  1067,  4082, -5376,
   -5376, -5376,   773,  3802, -5376,  3415, -5376, -5376, -5376, -5376,
   72085, 87465,  2414, -5376, -5376, -5376, -5376,  3421, -5376, -5376,
    3623,  3505, -5376,  3443, -5376, -5376,   537, -5376, -5376,  4118,
   -5376, 87465, -5376, -5376,  2843, -5376,  2843, -5376, -5376,  2843,
    2843,  2490,  2843, -5376, -5376,  3466, -5376,  3751,  3752,  2900,
   -5376, 65685, 87465,  4111, -5376,  3930, -5376, -5376,  3436, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376,  4013,  3947,  3947,
   -5376, 63125, -5376, -5376,  4115,  2778,  3933, 80425,  4091,  4194,
   -5376,  3992, -5376, -5376, -5376,  1878, 87465, -5376,  1878,  1878,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
     440, -5376, -5376,  2243, 48804, 87465,  3144,  1903, 14852,  4003,
    4169,  3847, -5376, 87465, -5376, -5376, -5376,  2532,  3467, -5376,
   -5376, -5376, -5376, -5376,  4241, -5376, -5376, 72085,  3673,  3855,
    3855,  3855,  4254, -5376, -5376, -5376, 51570, 72085, -5376, -5376,
   -5376,   735, -5376,   193, 87465, 72085,  3526, -5376, 72085,  3484,
   24474, -5376, 24474, -5376,  3846,  3349, -5376, -5376, 72085,  1982,
   -5376, -5376, -5376,  4241,  3855, -5376,  3923,  1519,  3488,  3489,
   -5376,  3501,  3501,    33, -5376,  3506,  4073,  3506, -5376,  3901,
     905,  3456,  3901, -5376,   905,  3506, -5376,  3510, -5376,  3901,
   -5376,   905,  3501, -5376,  3501, -5376, -5376,   905,  3501, -5376,
    3512,  3506, -5376, -5376,  3901, -5376, -5376, -5376, -5376,  1477,
    2378,  3506, -5376, -5376, -5376,  3501,  3513,  3501,  3501,  3501,
    3501, -5376,  3501,  4088,  3509,  1838, -5376, -5376, -5376, -5376,
   -5376, -5376,  3506,   477,  3501,  3501,  3501,  3501,  3518, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376,  4196, 87465,  4197, -5376,
   72085,  4281, 72085,  4205,  2778, -5376,  3527, -5376,  3528, -5376,
   -5376,  4220, 87465, 87465, -5376, -5376, -5376, -5376,  3529,  2593,
   53640, -5376,  1587,  3890, 52270, 72085, -5376, -5376,  4162,  4189,
   -5376, -5376, -5376, -5376, -5376,  3620, -5376, -5376,  3546, -5376,
   -5376, -5376,  3550, -5376,  3550,  3550, -5376, -5376,  3550, 52270,
   -5376, -5376, 51570,  2061,  5112,  4209,  2837, -5376,  4037, -5376,
   25946, -5376, 26682, -5376, -5376, -5376,  3829,   323,  1269, -5376,
   -5376, -5376, -5376, -5376,  4039, -5376, -5376, -5376, -5376, -5376,
   87465,  3780,  4244,  4213, -5376, -5376, -5376,  4101, -5376, -5376,
    4048,  3577,  4201,  3572, -5376, -5376, -5376,   131, 24474,  3581,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, 72085,
    3586, 29626, 29626, -5376,  4348,  4348,  4348, 24474,  3300,  1321,
    3940, 24474, 24474, 24474,  2517,  3597, -5376, -5376, -5376,   226,
   -5376,  3598, 24474, 24474, 67605,  3601,  1251,  4539, 24474,  4304,
   24474, 24474, 24474, 24474, 18586,  4110, 24474, -5376, -5376, 88745,
   67605,  4049,  3607, -5376,  3605, -5376,  2659, 24474,  2681, 24474,
   -5376, -5376, 24474, 24474,  3613, 24474, 24474, 31834,  3614, 24474,
   24474,  3616,  3735,  4348,  4348,  2704, -5376, -5376, -5376, -5376,
   -5376, -5376,  4348,  4348, 24474, 24474, 19322, 24474, 24474,  2734,
   24474, 24474, 24474, -5376,  3612, 24474, 24474, 24474, 24474, 24474,
   24474, 24474, -5376, 24474, 24474, 24474, 24474,  1176, 24474, 24474,
   72085, 24474, 24474, 24474, 24474, 24474, 24474, 24474,  4297, 72085,
   24474, 24474, 24474, 24474,  4300, 24474, 24474, 24474,  3624, 24474,
   72085, 24474, -5376, 24474,  4389,  4389, -5376, 24474, 19322, 24474,
    3625, 68245, 24474, 24474, 24474, 24474, 25210, -5376, 25210, -5376,
   -5376,  3626,  2133,   407,   440, 24474,  3621, 63765, -5376, -5376,
   -5376, -5376, 24474, 24474, 24474, 31834, -5376,  1181, -5376, -5376,
   -5376, -5376, -5376, 15614, 31834,  3639, 31834, 31834,  4267,  2321,
   31834, 31834, 31834, 31834, 31834, 31834, 31834, 32570, 33306, 31834,
   31834, 31834, 31834, -5376, 83625, 29626, 73365,  3647,  4309, -5376,
   82345, -5376,  1700,   388, -5376,  2414,  4741, 34769, -5376,  3645,
   -5376,  4148,  3652, -5376,  1537, -5376,  3655,  4332, 52270, 51570,
    2751,  3668, -5376,  3660,   898,  3657, -5376, -5376, 53640, 87465,
   -5376, -5376, -5376, -5376, -5376,  4404, 24474, -5376, 52270, -5376,
    1115, 14852, -5376,  1317,  1732,   400, -5376, -5376, -5376, -5376,
   -5376, 14852, 87465, 58469,  3667,  3762,  3682,  2843, 49452, 87465,
   72085, 87465, 87465, 87465, 72085, 52270, 72085, -5376, -5376, -5376,
    1135,  2036, 87465,  2036,   546,  4319, -5376,  1801,  1801, -5376,
   -5376, -5376, -5376, -5376, -5376,  2036, 87465, 87465,  2036, 51570,
   -5376,   546,  2191, -5376,  3966,  3765, -5376, -5376, -5376,  4012,
   -5376, -5376,  4361,  3686, -5376,  4041, -5376, -5376,  3787, -5376,
   -5376, 72085, -5376, -5376,   546, -5376,   546,   546, 24474,  2036,
    2036,  2036, 66965,  3691,  3699, -5376,  3697, -5376,  3701, -5376,
   -5376, -5376, -5376, 72085, -5376, -5376,  4056,  3696,  4350,  3704,
   -5376, -5376,  4283,   858,  4243, -5376,  4131, -5376,  4270, -5376,
   24474,  3349, 20794,  3990, -5376, -5376,  3993,  3998,  4002, -5376,
   -5376, -5376, -5376,  4158,  4009, -5376,  2414,  4011, -5376, -5376,
    3741, -5376, -5376, -5376, 34769, 83625, -5376,  3747, -5376,  3767,
   -5376,   264, -5376, -5376,  4438,  3856, 24474, -5376, -5376, 72085,
    4257, -5376,  2414,  1858, 87465, -5376, -5376,  4523, -5376,    11,
   -5376, -5376, -5376,  3866,  2276, -5376, -5376,  1537, -5376, -5376,
    2183,  3944, -5376, -5376, -5376, 83625, -5376, -5376, -5376, -5376,
   -5376, -5376, 53640, 51570, 83625, -5376,  2843,  2843, -5376, 72085,
    2843, 87465, -5376, -5376, -5376,  2843,  2843,  2843,  3800,  1935,
    3766,  3769,  3770,  3775,  2001,  3781, 68885,  2920,   279,  4407,
    4422, -5376,  4365,  2462,  4365, -5376, -5376, 68885, 66965,  3785,
    4111, -5376, -5376, -5376, -5376, 83625,  3783, -5376, -5376,  3784,
   -5376, 24474,  4531,  4454,  4115,  1632, -5376, -5376,  4134, -5376,
   84905,  4334,  1337, -5376,  3789,  3913, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, 29626,  2753, -5376,  3349, -5376, -5376, -5376,   281,
   -5376, -5376, -5376,   499,  4172,  2645, -5376, -5376, 83625,  2645,
    1412,  1774, -5376,  3807,  2414,  1449, -5376,  1449, -5376,  4113,
   -5376,  4116,   138, -5376,  1537, -5376, -5376, -5376, -5376, -5376,
   72085,  3808, -5376,  3995, 87465,  2432,  3817,  3819,  3349,  3349,
   -5376,  7882,  4567,  4301,  5622,   173,  3875, -5376, -5376, -5376,
   -5376, -5376, 72085, -5376, -5376,  2377,  3403,  4321,  3836, -5376,
    1519, -5376, -5376, -5376,  2860, -5376, -5376, -5376,  3901,   400,
    3901, -5376, -5376,  3029,  1116, -5376, -5376, -5376,  1116, -5376,
     291, 57101, -5376, -5376, -5376, -5376,   389, 48150,  2668, -5376,
    4232,  3587,  3901, -5376,  4315,   905, -5376, -5376,  1116,  2183,
   -5376, -5376,  3901, -5376, -5376, -5376,  2183,  1116, -5376,  4318,
   -5376, -5376, -5376,  1116,  3901, 91945,  1838,   905, -5376, -5376,
     905,  1116,   481, 87465, 24474, 24474, -5376,  4399, -5376,   389,
    4598,   905,  3901,  1116,  4439, -5376,  1116, -5376, -5376,   243,
    4013,  3925, -5376,  3848, -5376, -5376,   511,  4420, -5376, -5376,
    4440, 87465,  4528, 76585, -5376, -5376,  4444, -5376, 87465,  1587,
    3854, -5376, -5376, -5376, -5376, -5376,   400, -5376,  3857,   228,
   72085, 72085,  7882,  3999, -5376, -5376, -5376, 87465, -5376, -5376,
   -5376, -5376,  4358,   445, 35417, 69525, -5376, 69525, 69525, -5376,
   -5376, -5376, -5376, -5376,    85, -5376, -5376, -5376, -5376, -5376,
   -5376, 24474, 50152,  3349, -5376, -5376, 72085, -5376,  4520, -5376,
   -5376, 90665,   191, -5376, -5376,   342, 72085, -5376, -5376, 24474,
   -5376,  4514,  4001, 87465, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, 87465,  2432,  3349, 87465, 50865, -5376, 91945,  7882,
    7882, 24474,  1620, 24474, -5376,  3870, -5376,  3881,  3883,  3102,
    4238, 24474, 24474, -5376,  3132,   550,   277, -5376,  3888,  3895,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,  3891, -5376,
   -5376, -5376,   448,   456,  3892, -5376, -5376, -5376,  3899,   440,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
    4570, -5376,   357, -5376, -5376,   294,   311,   496,   515,   518,
    3912,   547,  3612,  2088,  3903, 67605, 88745,  4348,  3904,   530,
    4348,  3905,   555,   540,   568, -5376,   572,  1650,  3477, -5376,
     589,   617, -5376, -5376,  3906,  3908,  4348,  3910,  3915,  3916,
     638,   284,  3917, -5376, -5376, 21530, 22266, 23002,  3460,  3919,
   -5376, -5376,   819,  1908,  4348,  3921,  1972,  2224,  2009, 88745,
     968,  2029,  1307, -5376,  2238,  1326,  1340,  1345,  1354,  2049,
    2074,  1430,  2281, -5376, -5376, -5376, -5376,  3911,  2101,  2114,
    3920,  3926,  2374,  2163,  2196,  2227,  2388,  2417,  2422, 72085,
    3928,  2254,  2259,  1524,  2450, 72085,  2293,  2300,  1571, -5376,
    2307,  3931,  1706,   326,  3941,  3942,  2355,  3948,  1744, -5376,
   88745, 87465,  3950,  3896,   336,   270,  1822,  2361,  4110,  4110,
   -5376, 24474,  3951,   251, 88745,  1732, -5376,  4459,  2929,  1459,
   -5376,  2703, -5376, -5376, -5376, -5376,   474, -5376,  3943,  2703,
    3953,  1460, 18586, -5376,  1950,  2303, 31834, 31834,  3956, 31834,
   31834,  3954,  3954,   519,  1954,  1954,  3191,  3642, 25210,   519,
   25210,   519,  3954,  3954,  3954, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376,  4530,  3958,  3960,  3962,  3963,  2087,  3965,
   -5376, -5376, -5376, -5376, -5376, -5376,    35,  4370, -5376,  4156,
    1183, 24474, -5376,  3987,  4476,  4482,  4485, -5376, -5376, -5376,
   -5376, 52270, 52270, 72085,  4487, 24474,  4653, 53640,  4666, -5376,
    3991, 36065, 69525, 69525, 69525, -5376,  3994, -5376, 24474, 87465,
   87465, 14852, 57785,  4669,  4671,   400, 57101, -5376,  3349,   400,
   -5376,  3996,  4005, -5376, -5376,  1684,  4273, -5376,  4006,  4008,
   -5376,  4004,  4010,  4014, 61205, 24474, -5376,   400,  1317, -5376,
   -5376, -5376, -5376, -5376,  4018, 87465, 87465, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376,  2414, 24474, 87465,  2036,
   -5376, -5376, -5376,  2036,  2414,  4675, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376,  2036, -5376, -5376, -5376,
   -5376, -5376,  4166,  3992,  3096,  4319, -5376,   546, 72085,  2036,
    2036,  3349, -5376, -5376, -5376, -5376,  4540,  4013, 20794,  4022,
    4021, -5376, -5376,  7882, 87465, 87465, -5376, -5376,  1366, -5376,
    4013,  7098, -5376, 83625, 59153, 72085, -5376, -5376, -5376,  1898,
   -5376, -5376, -5376, -5376, -5376, -5376,  3349,  2639,  2753, -5376,
    4023,  3349, -5376, -5376,  4717, -5376, -5376, -5376, -5376,  2414,
   -5376, -5376,  5985, -5376, 72085, -5376, 65045, -5376, 65045,  1983,
   -5376, 90025, -5376,  2414,  3349, 72085,  1855,   342, -5376,  4788,
   -5376, -5376,  4135, -5376, -5376, -5376,  4025, -5376,  4074, -5376,
   -5376, -5376,  4031, -5376,  4711, -5376,  1955,   565,   138, -5376,
   87465, 87465, 87465, 72085, -5376, 87465, -5376, 87465,  2843, -5376,
   -5376,  2843, 72085, 87465, 87465,  2843, 68885, -5376, -5376, -5376,
   -5376, -5376, 68885, -5376,  1809, -5376,  4240,  2146,  2146, -5376,
   -5376, -5376, -5376, -5376,  4678,  4365,  4365, 68885,  4681,  4704,
   -5376, 87465,  4380,   421, -5376, 63125, 87465,  3349, 24474, -5376,
    4071,  4454, -5376,   342, -5376, 81705, -5376,  4384, 81705, 81705,
   88745,  4276, 24474,  4046, 14852, -5376,   400,   400,  4268,  4566,
    4568,  4171,  2414,  4571,  4572,  4574, -5376, -5376, -5376,  2414,
    2414, -5376, -5376,   400, -5376,  3028, -5376, -5376, -5376, -5376,
    3982,  2464, -5376,   400,   400, -5376,  2839, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376,  1642, -5376,   312,   958, 51570,  4519,
   -5376,  4646,  4059, -5376, 72085,  4736, -5376, -5376, -5376, -5376,
   24474,  4565,  6802, -5376, -5376,  4301, -5376,  4083,  4084,  4085,
    4093,  4094,  4096,  4097,  4098,  4099,  4100,  4103,  4105,  4107,
    4112,  4117,  4119,  4120,  4122,  4123,  4124,  4126,  4127,  4128,
    4129,  4063, -5376, -5376,  4139, -5376, -5376, -5376, -5376,   400,
     400,   400,   400, -5376,  3055, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376,  4367,  4007, 87465,  4742,  4451,  4104,  4125,
    4132,  4133, -5376, -5376, 87465, -5376,  2547,  4564,  4607, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376,   400, -5376, -5376, -5376, -5376,  2579, -5376, -5376,
    2580, -5376, -5376, -5376, -5376,  7092, -5376,  2610, -5376, -5376,
   -5376, -5376, -5376,  1838,  1838,  4130,  3349,  3349,  4140, -5376,
   -5376, -5376, -5376,  4598, -5376,  4137, -5376, 74005, -5376, -5376,
   -5376, -5376,  2609, -5376, -5376,  2146, 87465,  4604, 76585, -5376,
    4328,  4756, -5376, -5376, 66965, -5376,  4136, 72085, -5376, -5376,
   53640, -5376, 83625, 52270, -5376, -5376, -5376,  4138,  1620,  7569,
   -5376,  4142, -5376,  2638, -5376, 51570,  4577, -5376, 69525,  4144,
   -5376,  4149,  4629,  4635,  4636,  4642, -5376,  1366,  3349, -5376,
   -5376,  4145, -5376, -5376,  4283,  3947, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,  4180,  4417,
    4550, -5376, -5376, -5376,  3349, -5376, -5376, -5376,  4808, -5376,
   -5376, -5376,  2649,   146, -5376, -5376, -5376,  4517, -5376, 93513,
   93513, 93513, -5376,  1849, -5376, 24474, -5376, -5376, 24474, -5376,
    3349,  3556,  3782, 48150, -5376, 48150,  3782, 24474, -5376,  4165,
   -5376,  4815,  4816, -5376, -5376, -5376, 24474, -5376, 24474, -5376,
   24474, -5376, 24474, 24474, 24474, 24474, 24474, 24474, -5376, 31834,
   -5376,  4163,  4176, -5376, -5376,  4186, -5376, 24474, -5376, 24474,
   -5376, -5376, 24474, 24474, 24474, -5376, -5376,  4187, -5376, -5376,
   -5376, 24474, 24474, 24474, -5376, 24474,  3604, 24474,  3716, 24474,
    3728, 24474, -5376, 27418, -5376,  4188, -5376, -5376, -5376, -5376,
   -5376, 24474, -5376, 24474, -5376, 24474, 24474, 24474, 24474, 24474,
   -5376, -5376, 24474, -5376, 24474, -5376,  4750, 24474, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   24474, -5376, -5376, -5376, -5376, 24474, -5376,   153, 28154, -5376,
   24474, 24474, 24474, -5376, -5376, 24474,  4173,  4184, -5376, 87465,
   -5376, 24474,  2373,  3900,   342,  4192, 24474, -5376,  4206,  4207,
    3395, -5376, -5376, -5376, 91305, 24474, -5376, -5376, -5376, -5376,
    1251, 31834,   424, 31834,  2303,  3012, 18586, -5376,  2037,  2303,
    4110,  4110, 87465,  4938,  4198, -5376, 24474, 24474, 19322, 24474,
   88745, 24474,  4203,  4202, -5376,  4208, 31834, -5376, -5376,  4210,
   -5376,  2674,  3900,  4287,  4650, -5376,  3349, 34769,  4708, -5376,
   -5376, 72085,  2683,  4406, -5376, 52270, 51570, 69525,  4885,  4888,
    4891,  4892, -5376,  3349, -5376,  4212,   400,   400, -5376, -5376,
   17110, 52270, 14852, -5376, -5376,  4727,  4730, -5376, -5376,  1080,
    4515,  4787, -5376, -5376, -5376,  4224, -5376, -5376, -5376, -5376,
     934, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,  3349,
   14852, -5376,  3667,  4231, 37491,    24, -5376, -5376, -5376,  3349,
   -5376, -5376, -5376, -5376,  4250, -5376, -5376, -5376,  4825, -5376,
   -5376,  4675,  2778,   546, -5376, -5376, 68245,  3021, -5376, -5376,
   -5376, 20794,  7587, -5376,  2707, -5376,  4999, 68245,  4713, -5376,
   -5376, -5376, -5376,   532, -5376, -5376,  4245,  4705, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,  4251, -5376,
   14852, -5376, 20794,  4261, -5376, -5376, -5376,  4138,   426,  4266,
    4253, -5376, -5376, -5376, -5376, -5376, -5376,   438,   510,  2819,
    2778, -5376, -5376,   262, -5376, -5376, -5376, -5376, -5376,  1315,
   -5376, -5376, -5376, -5376,    11,  3475, -5376,   480,   342,  4488,
   -5376, -5376,  1955,  4702, -5376,  4519,  4936,   535,  4850,  4851,
   -5376,  3982, -5376,  2199,  1691, -5376, -5376, -5376, 87465, -5376,
     404,  -107,   450, 72085,  3930,  3930, -5376,  2146,   501, -5376,
   31834,  5024, -5376,  4765, 68885,  4908,  4911, -5376, 68885, -5376,
   -5376,  2745, -5376, -5376, 47495, -5376, -5376, -5376,  3349,   119,
    1979, 24474, 87465, -5376,  4071, -5376, -5376, -5376, 81705, -5376,
   -5376, -5376,  1632,  4271,  1979,  4275, -5376, 57101, 47495, -5376,
    4652,  4654,  1590, -5376, -5376, -5376, -5376, -5376, -5376,  3968,
    1774, -5376,   400,   400, -5376,   248,   400, -5376, -5376,   258,
   -5376, -5376,  2308,   156,  3982, -5376,  2414,  2414,  2414,  2414,
     342,  2414,  2414,  2775, -5376,  3968,  3968,  1449, -5376,  1402,
   -5376, -5376, -5376, -5376,   199, -5376, -5376, 83625, -5376,  4781,
    4784, -5376,  4786, -5376, -5376,   459, -5376,  3082,  1041,  6263,
     995, -5376,  4833, 87465,  5042,  4059, -5376,   439,  2432,  3349,
   -5376, 24474, -5376,  4285,  4286,   342,  4290,   342,   342,  2414,
    2414,  4250,  2414,   342,  2414,  2414,  2414,  2414,  2414,  2414,
    2414,   342,  2414,  1227,  3162,  2414,   342,  5622, -5376,  2414,
    3900,  3968,  3968,  3403, -5376,  4960,   400, -5376,  4337, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,  2790, 44587,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,  4887,
   -5376, -5376, -5376,   389,  2183,   389, -5376, -5376, 91945, -5376,
   -5376, 87465,  4889, -5376, -5376, -5376, -5376,  3494, -5376, -5376,
   -5376,  4616, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
    4291, 66965,   953, -5376, 81065,  4845,  2778,  4310, -5376,  1537,
   -5376, -5376, -5376, -5376,   483,  4920, -5376, -5376,  5003, -5376,
   87465,   639,  4506,  4813,  4324, 77225, 51570, 51570, 51570, 51570,
   -5376,  4905, 72085, -5376,  4974, -5376, -5376, -5376, -5376, -5376,
   24474, -5376, -5376, 87465,  2432,  4746, 93513,  4939, -5376, -5376,
   -5376, -5376, -5376, 24474,  3349,  3349, 24474,  3501,  3501,  3506,
    3518, -5376,  5036, -5376,  4969,  3501,  3501, -5376,  3501,  4970,
    3501,  3501,  4326, -5376, -5376,  4327,  4329,  4330,  3395, -5376,
   24474, 24474,  2397,   162,  2458,  2463,  1888,  1904,   431, -5376,
    2510,  3603, 88745, -5376, -5376,  2542,  2567,  2583,  2590,  2673,
   -5376,  1929,  3030,  1948,  3349, 24474,  3349, 24474,  3349, 24474,
    3349, 25210,  2723, -5376,  2806,  3760, -5376,  2814,  3885,  2729,
     475,   478,  2768,  2773,  2791,  2823, -5376,  2492,  4924,  2847,
   25210,  2794,  2801,  1952,  1969,  2815, 88745, 87465,  4325,  2827,
    4336,  4336,   293, -5376,  4339, -5376, -5376, -5376,  4340, -5376,
    2852, 24474, 24474,  4331,  3349,  4345,  2703, -5376, 24474,  2303,
   31834,   505, 31834, -5376, -5376,  4530, -5376, 24474, -5376,  4921,
    4346,  3395,  3840,  4347,  4352,  3460,  4353,  4359,  4360,  4349,
    3349, -5376, -5376, 87465,  4362,  3465, -5376,  4250, -5376,  5006,
   -5376,  5105,  4366,  4386,  4368,  4210, -5376, 52270, -5376,  4922,
    5046,  3857, -5376,  5048, 51570, 51570, 51570, 51570, -5376, 42391,
   -5376, 75945, 14852, 14852, -5376, -5376, -5376,  4375,  4376,    96,
    4940, -5376, -5376, -5376, -5376, 87465, 87465, 14852, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376,  3450, -5376,  3992, -5376,
   -5376, -5376,  2036,  4387, -5376,   400,   449, -5376, 20794,  4377,
    4390, -5376,  5007, -5376, 87465,  4395,  4398,  4393, -5376, -5376,
   -5376,  4392,   440, 68245, -5376, -5376,  4874, -5376,  4402, 85545,
   -5376, -5376,  4405, -5376,  4965, -5376, -5376,  4535, 65045, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
    3992,  4633, -5376, -5376, -5376,  4426, -5376,  4408,  4502,  4508,
   -5376, -5376, -5376, 51570,  1041,  4794,  1019,  1019,  5011, 72085,
   72085,  6277,  8139,  3982,  2199, -5376, -5376, -5376,  2414, -5376,
    1691, -5376, -5376,  4424, 87465, -5376,  4059, -5376, -5376,   542,
   -5376, -5376, -5376, -5376, -5376,  3465,  2146,  2146,  4379,  4910,
   68885, 68885,  4602,  4914, 24474,  4430, -5376, 87465, -5376,  1313,
   -5376,  4829, -5376, -5376, 24474, -5376, -5376, -5376, -5376,  3349,
    5196,  4437, -5376, -5376, -5376, -5376, 24474, -5376, 24474,  4442,
    4441, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376,   153,   153, -5376,
   -5376,   153,   153, -5376, -5376, -5376, -5376,   153,   153, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,  2464, -5376,
   -5376, -5376,  1642, -5376, -5376,  4950,   433, -5376,  5030, -5376,
   -5376, -5376, -5376,  1202,   342,   342,   342,  3162,  2449, -5376,
    3082,  2226,  4783, -5376,  4255,  4849,  5026,  4849,  5027,  4954,
    2966,  4819,   400,  5032,  5203,   400, -5376,   253,   400,   400,
     400,   400,  4498,   400,   400,   400,   400,  5038,   400,   400,
    4828,   400,  5107,  4542,  5110,   400,  5044, -5376,  4546,   400,
     400,   400,   400,  4849,   400,   400,  5052,  4668,  5053,  5058,
     400,   400,   962, 87465,   400,   400,  5059, -5376, -5376,  8139,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376,   307, 70165, -5376,
   -5376, -5376, -5376,   400,  2303,  1953,  4986,  1100, -5376,  2881,
   -5376,  5246, -5376,   230, -5376, -5376, -5376,  3349,   280,   441,
   -5376,   457, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   87465,  3968,  4007, -5376, -5376, 87465,  3501,  3501,  3501,  3513,
    3501,   379, -5376, -5376, -5376, -5376, -5376, -5376,   477,  3501,
    3501,  3501, -5376, -5376, -5376,  4489, -5376, -5376, -5376, -5376,
   -5376, -5376, 74005, -5376, -5376, 76585,  2778, -5376, 87465,  4832,
    5033,  3668, -5376, -5376, -5376, -5376, -5376,  4491, 24474, -5376,
   -5376,  5164, -5376, -5376, 51570, -5376, -5376,   138,   138,   138,
     138,  3585,  4854, -5376, -5376, -5376,  4974,  4772, -5376,  1273,
    3349, -5376, -5376, -5376, -5376, -5376,  7882,   431,  3349, -5376,
   -5376, -5376, -5376,  3501, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376,  4500,  4110,  4110, -5376,  5245,
    5037, -5376, -5376, 24474, 24474, -5376, 24474, -5376,  1261,  4504,
    4979, -5376, -5376, -5376, -5376, -5376, -5376, 24474, 24474, 24474,
    3349,  3349,  3349,  4110, -5376, -5376,  2619, -5376, -5376,  3782,
   -5376, -5376, 24474, -5376, 24474, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376,   408,  4110, -5376, -5376, 24474, 24474, -5376,
   -5376, -5376, 87465, -5376,  3900,  4509,  4789, -5376, -5376, -5376,
    3900,  4645, -5376, -5376,  3900,   342, -5376, -5376, -5376, 87465,
   -5376,  2904,  2703, -5376, 24474,  2303,  5096,  4510,  5258,  4516,
   -5376, -5376, -5376, -5376, -5376, -5376, 24474, 42391, -5376,  4521,
    4522, -5376, -5376, -5376, -5376, 24474,  5147,  5094, -5376,  3900,
   87465, -5376, -5376, -5376, 51570, 51570,  3991,  3991,  3991,  3991,
   86185, -5376, -5376, -5376, -5376,  2145, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376,   400,   400, -5376, 37491, 57785, -5376, -5376,
   -5376, -5376, -5376, -5376,  3992, -5376, 68245,  2778, 23738, -5376,
   -5376, -5376, 20794, -5376, -5376,  1251, -5376, 68245, 77865,  4526,
    4525, -5376,   400, -5376,  4874, -5376, 41021, -5376,  4532, -5376,
    4529, -5376,  2081,  4856,  5157, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
    4524, -5376, -5376,  2414,  2895, -5376, -5376, -5376, -5376,  4560,
   -5376, -5376, -5376, -5376, -5376, 72085, -5376, -5376, 41730,  5174,
   72085, -5376, -5376,  5119, -5376,  5466, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376,   493,  5137,  5309, -5376,
    4551, -5376, -5376, -5376, -5376,  4655, -5376,  4551,  4059, -5376,
   -5376, -5376,  5039, -5376, -5376, -5376,  5040,  3349, 87465, -5376,
   -5376, -5376,  1391,  2486,  5182,  1979,  4558, 87465,  1979,  3349,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376,   209, -5376, 83625, -5376, -5376, -5376, -5376,
   -5376,  5152,  5153, -5376, -5376, -5376, -5376,  4748,   688, 70805,
    2843, -5376,  1457,  4605, -5376, -5376, -5376,  2672, -5376,  2843,
    1898,  1898,  5228,  3166,  1131,  3166, 41021,   421,  2322,  5211,
    2410,  1876,  4610,  5139,  3166,  3166,   400, 59837,  1131, 68245,
     234, -5376, -5376, -5376, -5376, 72085,   263,   310,   325, -5376,
   -5376, 60521,  4250,   342,   342,  1131,  2414,  2414,   400,   342,
   -5376, -5376, -5376, 83625, 87465, -5376,  2144,   342,  4250,  4250,
    3166,   334,  2414,  1131, -5376,  1131,  1131,   864,   234, -5376,
   -5376, -5376,   342,   234, 41021, -5376,  9654, -5376, -5376, -5376,
   41730, 87465,  1625,  5130, -5376,  4575, 55031, -5376,  4752, 24474,
   24474,  5169, 87465,  5171, -5376,  4980, -5376, 87465, -5376,  1251,
   -5376, -5376, -5376,  4880,  5090,  2914, -5376, -5376,  2943, -5376,
   -5376,  2980, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376,   389,  5127, 87465,   389,  4598,   389,
    4598,  1251, -5376, -5376,  4136, -5376,  5264, -5376,  4932,  3994,
   -5376,  3349, -5376,  4785,   138,  5063,  5063,  5063,  5063, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376,  5241,  2432,  4949,
    7649,   389, -5376,   389,   389, -5376,  4596,  4597, 24474,  2183,
    5227,  2863,  1975,  2981,  4882,  4834, -5376,  4767, -5376,  2868,
    3349,  3349,  1785,  3506, -5376, -5376, -5376, -5376,  5250,  3501,
   -5376,  5343, -5376,  3501, -5376, -5376, -5376, -5376, -5376, -5376,
    4606,  2871,  2888, -5376, -5376, -5376,  2984,  1797,  2901,  2936,
   -5376, -5376, -5376,  4608, -5376, -5376,   470, -5376,  4611, -5376,
   -5376,  3024,  5351,  2445, 24474, -5376,  4609, -5376, -5376, 87465,
    4110,  1211, -5376,  3032, -5376, -5376,  4612,  3991,  3991, -5376,
   -5376, 78505, 14852, 14852, -5376, -5376, -5376, -5376,  4440,  2753,
   -5376, -5376, -5376, -5376,  4617, -5376, -5376,  4613, -5376, 68245,
   20794, 74005, -5376, -5376,  4621,  4614, -5376, -5376, -5376, 85545,
   -5376,  3036, -5376, -5376,  5385, 20794, -5376, -5376, 83625, -5376,
    4627,  4630, 72725,  3295,  3040, -5376, -5376, -5376, -5376, -5376,
   72085, -5376,   747, -5376,  6749, -5376,  8139, -5376,  1151, 87465,
    4216, -5376, -5376,  2137,  4754, -5376, -5376,  7695,  4628, 87465,
    2414, -5376,  4631,  5391, 24474,  4634, 24474,  4637,  3043, -5376,
    1898, -5376,  1898, -5376,  1391,  5378,  5379,  5328,  5382,  2486,
   -5376,  2390, -5376, -5376, -5376, -5376, -5376, -5376, -5376,  4640,
   -5376, -5376, -5376, -5376,  4981, -5376,  5237, -5376,  5098,  2303,
   -5376, -5376,  1131,  4649,  2303,  5322, -5376,  4651,  5293,  5294,
    1898, -5376,  2843, 72725, -5376,  2843,  2843, -5376, 72725, 41021,
   72725, -5376, 47495, 72725,  3166, 87465, -5376,  5333, -5376,  5297,
   72725, 72725,  2414, -5376, -5376, 41021,  4656, -5376,  1979, -5376,
   -5376, -5376,  2744, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
    4660, -5376, -5376, -5376, -5376, -5376,  3900, -5376, -5376,  2414,
   -5376, -5376,  5131, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   72725, -5376, -5376, -5376, 41021, -5376, 41021, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,  4114,
    3083, -5376,  4661,  4662, -5376, 87465, -5376, -5376, 72085, -5376,
   45321, 87465, -5376, -5376, -5376, -5376, -5376,  3349,  4110,  5054,
   -5376, -5376,  4773,  2414,  5029, -5376,  5136, -5376, 87465,   247,
   -5376, -5376,   342, -5376,   342, -5376,   342, -5376, -5376,   406,
   -5376, -5376, -5376, -5376, -5376,   440, 31834, -5376, -5376,  5063,
    1577, -5376, -5376, -5376, -5376, -5376, -5376,  5307,  5175, -5376,
   93513,  5291, -5376, -5376, -5376, -5376, -5376,  4672,  1979, -5376,
   -5376,  4673, 81705, -5376, -5376, 24474, -5376,  4907, -5376,  5012,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376,   389, -5376, -5376,
   -5376, -5376,  4250, -5376, -5376, -5376,  4677, -5376,   342, -5376,
   24474, -5376, -5376,  4679,  4927,  1979, -5376, -5376,  4774,  4650,
    4682, 87465, -5376,  5094, -5376, -5376, -5376, -5376,  4756, -5376,
   79145, -5376, -5376,   115, -5376, 87465, -5376, -5376,  4250,  5047,
   -5376,  3049,  4877,  4687, 87465, 87465, 87465, -5376, -5376, 41730,
    4684, -5376,  5446, -5376,  5119, 94060, -5376, -5376,  5043,  1151,
   -5376,  2605,  4688,  4689, -5376, -5376, -5376,  5393,  2199, -5376,
   -5376, -5376,  5283,  1953, -5376,  4216, 87465, -5376,  5238,  4693,
   -5376, 87465,  5240, -5376,  3349, 87465,  3349, 87465, -5376,  5374,
    5374, -5376,  2183,  2183,  5442,  2183, -5376,  5447,  5448,  2390,
   -5376,  5207,   688,  5077,  2226,  5395, -5376, 87465,  5396, -5376,
   24474,  2843, -5376, -5376, 72725,  5197,  1266, 72725, 72725,  1813,
   -5376, 72725,  2377,  4404, -5376, 72725,  4614, 87465, -5376, -5376,
     483, -5376, -5376, 68245, -5376, -5376, 72085, -5376, -5376,  5220,
    1625, -5376, 87465, -5376, -5376, -5376,  4715, -5376,  4709,  5452,
   -5376, -5376,  4710, -5376, -5376, -5376, -5376, -5376,  1136, -5376,
    3074, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,   491,
   87465,  3279, -5376,  4912, -5376,  1577, -5376,  5208, 72085, -5376,
   -5376, 24474, -5376, -5376, -5376,  1374,  2973, -5376, -5376, -5376,
    4721, -5376,  4722,  4271, -5376,  4972,  4853,  4476,  4482,  4485,
    4901,  5068, -5376,  4909, -5376,   342, -5376,  4732, 31834, -5376,
    2169, -5376, -5376, -5376, -5376, -5376, -5376, -5376,  5145, -5376,
    4733, 87465,  3084,  1979,  4737,  3098,  4738, -5376, -5376, -5376,
     532,   747, -5376, -5376, -5376, 94060,  1611, -5376, -5376, -5376,
    4734,  4739, -5376,  4740, -5376, -5376, -5376, -5376,  5318, -5376,
   46055, -5376, 87465, -5376, -5376, -5376,  5169,  2199, -5376, -5376,
   -5376, -5376, -5376, -5376,  3103,  3116,  2518, -5376, -5376, -5376,
   -5376,  2183, -5376,  2183,  2183, -5376,  4743, -5376, -5376, -5376,
   72725,   -23,  4745, -5376,  2979, 72725,  5197,  1781,  1019, -5376,
    1019, -5376, -5376,  5453,  5459,  1625, -5376, -5376, -5376, -5376,
   -5376,  1131, -5376,  4751, 72085, -5376, -5376,  4614,  1315, 87465,
    5355,  4320,  7092, -5376, -5376,  4000, 87465,  4846, -5376,  7882,
    4952,  5492,  5493, -5376, 87465, 86825, -5376, -5376,  5334, 31834,
   -5376, -5376, -5376,  4013, 93513,  1979, 81705, 81705, -5376, -5376,
   -5376,  1568, -5376,  5520,  1585, -5376, -5376,   372, -5376, -5376,
   -5376, 87465,  4762,  4848, -5376, -5376,  4837, -5376, -5376,  3327,
   -5376, -5376,  2464,  3133,  1537, 87465, -5376,  5359,  1537, 87465,
    5239, -5376,   238,   254,  2175,  1611, -5376, -5376, -5376, -5376,
   87465, -5376, 87465, 87465, -5376,  3513,   409, -5376, -5376, 87465,
   50865, -5376,  1100, -5376, -5376, -5376, -5376, -5376, -5376,  5514,
   -5376,  5517,  4776,  4777, -5376, -5376, -5376, -5376,  5452,  3900,
    5094, -5376, 87465, -5376, -5376, -5376,  1019, -5376,  4778, -5376,
    4779,  4780, -5376, 34042, -5376, -5376, -5376, -5376,  5427, -5376,
    3139, -5376,  1426,  5372, -5376,  5424, -5376,  2414, -5376,  4863,
   -5376,  4320, -5376, -5376, -5376,  4826,  5429,  5381,   400, -5376,
   83625, 34042, -5376,  5279, -5376,  5234,  5501, -5376,  5552,  4121,
   -5376, -5376, -5376, 24474,  5149,  5473, -5376,  4991,  4992, -5376,
   -5376,  3149, -5376, -5376,  4857,  3465, 68245, -5376, -5376, -5376,
   -5376, -5376, -5376,  4972, -5376, -5376,  4929,  2142, -5376,  3153,
   -5376, -5376, -5376,  3900, -5376,  4803, -5376,  5168,   400,   400,
    5172,   400,   400,   400,   400,  4811,  3327, -5376,  5163,  3186,
    1537,  2151,  1979,  4814,  1945,  4817, -5376, -5376,  4807, -5376,
    4809, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,  5356,
   87465, -5376, -5376, 72085,  4980,  5473, 87465, 87465, -5376, -5376,
   85545, 85545, -5376, -5376,  3193,  4818,  4821,  4824, -5376, 87465,
    4830, 87465, 87465,  3162,  3162, 18586, -5376, -5376, -5376, -5376,
   -5376, -5376,  3363, -5376,  4831, -5376, 87465, -5376, -5376, -5376,
    1833, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, 55724,
   -5376, -5376,  5421, -5376,  4869,  -132,   400, -5376,  4239,  3349,
   24474, -5376, -5376, -5376, -5376, -5376, -5376, 86825, -5376,  4835,
   -5376,   400,   421, -5376, -5376, -5376, -5376, -5376, 87465, -5376,
    4836, -5376, -5376,   132,   400,  2414,  2414,   400,  3927,  3927,
    3900, 83625,  4913, -5376, -5376,   400, -5376,  1891,  5018,  2414,
     400,  1432,  2151, -5376, -5376,   400, -5376, -5376,  1432,  1945,
   -5376, -5376, 87465, -5376, -5376, -5376, -5376,  5186, -5376,  4424,
    4839, -5376,   416,  5263,  5511,  5195, -5376, -5376, -5376,  4840,
    3203, -5376, -5376, 87465, 87465,  4843,  3204, 87465,  3213,  3218,
   -5376, -5376,  4844,  5094, -5376,   455,   455, -5376, -5376, -5376,
   -5376,  4847, -5376,   916, -5376, -5376,  4239,  3349, -5376, 68245,
   20794, -5376,  4848, -5376, -5376,  3226, -5376, 28890, -5376, -5376,
   -5376,  2414, -5376, -5376,  2414, -5376, -5376, -5376, -5376, -5376,
    3242, -5376, 83625,  1019,  1019,  1432,  1891, -5376, -5376, -5376,
    3350, -5376,   342, -5376,  5467,  5289, -5376, 56417, -5376, -5376,
    4852, -5376, -5376, -5376, 87465, -5376,  4551, -5376,  5392,   558,
   87465, -5376, -5376, -5376, -5376, -5376,  3248,  3274, 87465,  1891,
    3280,  2151,  1945, -5376,  3310, -5376, -5376,  2305,  5299,  5440,
    5441,   273, -5376,  2616,  2616,   877, -5376, -5376,  5394, -5376,
   -5376,  4836, -5376,  4855, -5376,  3465, -5376, -5376, 83625, -5376,
    4913, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, 87465, 87465, -5376,  4216,  4858,
   -5376, -5376, -5376,  5428, -5376, -5376, -5376,  5130,  1891,  3311,
   -5376,  1891, -5376, -5376, -5376, -5376, -5376, -5376,  5345,  5561,
   -5376,  4859, -5376,  2616, -5376, -5376, -5376, -5376, -5376,  1622,
    5162,  4829, -5376, 28890,  4865,  3327, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376,  4919,  5221,  5564, -5376, -5376,  1891, -5376,
     455,   455, -5376, -5376, -5376,  1622, -5376,  5610,  5182, -5376,
   -5376, -5376,  4216, -5376, -5376,  5001, -5376, -5376, -5376, -5376,
    2183,  5526, -5376, -5376,  5468,  4878,  1807,  1292, 61845,  5409,
   -5376, -5376, 83625, -5376, -5376, -5376, -5376, -5376, 83625,  3315,
   -5376, -5376, 68245, -5376, -5376,  7882, -5376, -5376, 64405,  4876,
   -5376,   400,  5473, -5376, 68245, -5376, -5376, -5376, 20794, -5376,
   -5376
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,  1245,  2486,     0,   537,     0,  1465,   822,   567,  2337,
    2479,  2480,  2262,     2,   610,   259,  2687,  2688,   482,  2264,
    2551,     0,     0,   606,  1481,   963,   717,     0,   402,     0,
       0,   613,   400,   259,  1530,  3206,  2386,     0,  3303,  2325,
       0,  1528,   608,  2649,  3559,  2911,  2957,  2958,  2986,  2805,
    3081,  3103,  3129,  2267,  2893,  2892,  2895,  2894,  2896,  2897,
    2898,  2899,  2900,  2901,  2778,  2902,  2903,  2904,  2906,  2905,
    2907,  2908,  2909,  2779,  3455,   563,  2780,  2858,  2910,  2860,
    2859,  2912,  2781,  2782,  2913,  2914,  2915,  2916,  2784,  2783,
    2917,  2919,  2918,  2861,  2862,  2920,  2921,  2922,     0,  2924,
    2785,  2786,  2787,  2788,  2789,  2923,  2790,  2925,  3460,  2926,
    2927,  2791,  2928,  2929,  2930,  2931,  2933,  2932,  2934,  2935,
    2937,  2938,  2939,  2936,  2940,  2941,  2943,  2942,  2864,  2944,
    2863,  2945,  2792,  2946,  2947,  2948,  2949,  2950,  2951,  2952,
    2953,  2228,  2954,  2955,  2956,  2978,  2959,  2961,  2960,  2865,
    2962,  2963,  2964,  2966,  2965,  2967,  2969,  2793,  2794,  2795,
    2968,  2970,  2971,  2972,  2973,  2974,  2976,  2975,  2980,  2981,
    2866,  1481,  2797,  2798,  2977,  2979,  2776,  2982,  2983,  2867,
    2868,  2984,  2799,  2855,  2985,  3305,  2988,  2987,    85,  2989,
    2801,  2990,  2991,  2992,  2993,  2994,  2996,  2998,  2995,  2999,
    3000,  3006,  2802,  2997,  3001,  3002,  3003,  3004,  3005,  3007,
    2869,  3008,  3010,  3009,  3011,  3012,  3013,  3014,  2870,  3015,
    2856,  3016,  3017,  3018,  3031,  3032,  3022,  3023,  3025,  3026,
    3029,  3024,  3030,  3035,  3034,  3036,  3037,  3038,  3039,  3040,
    3033,  3020,  3027,  3028,  3021,  3041,  3042,  3019,  3043,  3045,
    3044,  3046,  2871,  3047,  3048,  3049,  3050,  3051,  3052,  3053,
    3054,  3056,  3055,  3057,  2872,  2873,  2874,  3058,  3059,  3060,
    2849,  3061,  2875,  2876,  3064,  3065,  3062,  3063,  3066,  3067,
    3072,  3073,  3074,  3069,  3068,  3070,  3071,  2877,  2878,  2879,
    3075,  3076,  3077,  3078,  3080,  3079,  2804,  2803,  2806,  3082,
    3083,  2807,  3084,  3086,  3085,  2851,  2808,  3087,  3088,  3090,
    3089,  2880,  2881,  2809,  2810,  2811,  3091,  3092,  3093,  3094,
    3095,  3096,  3097,  3098,  3099,  3100,  3101,  3102,  2882,  2883,
    3104,  3105,  3106,  3108,  3107,  3109,  3110,  3111,  3112,  3113,
    3114,  3115,  2812,  3116,  1481,  3117,  3118,  2813,  3120,  3119,
    2814,  3121,  3122,  3123,  3124,  3125,  2850,  3460,  3126,  3127,
    3128,  2884,  3130,  3131,  3132,     0,  3133,  3134,  3135,  2815,
    3136,  3137,  2885,  2857,  2816,  3138,  3140,  2563,  2817,  3139,
    2819,  2820,  3141,  3142,  3143,  2818,  3144,  2821,  3145,  3146,
    3148,  3147,  3149,  3150,  3151,  3152,  2822,  3153,  3154,  2823,
    3155,  2824,  3156,  3157,  3158,  3159,  3161,  3160,  3162,  3163,
    3164,  3165,  3166,  3167,  3169,  3171,  3170,  3168,  3172,  3173,
    2886,  3174,  2825,  2887,  3179,  3180,  2888,  3175,  3176,  3177,
    3178,  2363,  3181,  3182,  3183,  2828,  3184,  3185,  3187,  3186,
    2826,  2827,  3188,  3189,  2832,  3190,  3191,  3196,  2889,  2890,
    3192,  3193,  3205,  3194,  3195,  3198,  3197,  3199,  3200,  2777,
    2829,  3201,  3202,  2830,  3203,  2831,  3204,  2891,     0,     0,
       3,     8,    22,     0,    44,    27,    32,    17,    21,    16,
      46,    60,    52,    29,  3457,   478,   479,   480,   481,    42,
    3491,    41,    11,    63,    64,    19,    49,    12,    15,    18,
      40,    48,    36,    43,    56,    57,  1551,  1527,  1555,  1526,
    1522,  1518,  1537,  1538,  1539,  1545,    25,    26,    33,    50,
      68,    23,    65,    61,    24,  2486,    13,    28,    14,    51,
      45,    37,    62,    69,    38,     0,  2692,  2705,     0,  2706,
    2774,  2772,  2775,  2771,  2773,    58,    59,    39,    67,    31,
      53,    30,     9,    10,    20,    54,    55,    47,    70,    34,
      66,    35,  1290,     0,     0,     0,     0,     0,  2260,     0,
       0,  2260,  1374,  1595,  3489,  3490,  3491,  1482,     0,  1483,
       0,     0,  2853,  2779,  2852,  2780,  2782,  2836,  2783,  2839,
    2840,  2833,  2792,  2841,  2854,  2795,  2796,  2837,  2738,  2799,
    2842,  2800,  2802,  2834,  2835,  2843,  2838,  2811,  2844,  2813,
    2845,  2846,  2847,  2822,  2823,  2848,  2827,  2739,  2831,  2703,
     289,  2704,  2735,  2733,  2737,  2731,  2732,  2736,  2730,  2734,
     539,   130,     0,     0,     0,     0,   341,  2358,  2260,  2232,
    2260,  2260,  2260,  2260,  2260,     0,  2260,  2260,     0,  2263,
    2260,  2260,     0,     0,     0,   530,  2270,  2553,     0,  2573,
    2574,  2568,  3293,  3294,  3288,   491,     0,     0,     0,  2453,
    2452,     0,     0,   387,   399,   402,   395,   398,     0,   259,
    1484,   491,   401,   402,     0,  1560,  3208,     0,  2458,   402,
       0,  2335,  2567,     0,     0,  2650,  2647,  2335,  2524,  2526,
       0,  2522,  3460,  1668,  1667,   565,     0,  2693,     0,  1460,
    1492,  1418,     0,  3461,  3462,     0,    77,    80,  2491,   424,
       0,     0,     0,   820,     0,     0,  1426,     0,  3462,  3472,
    2565,     0,   130,  1399,     0,   130,  2369,  2260,  2260,  3542,
    3543,     0,     0,     0,  3537,     0,  3544,     0,  1555,     0,
    1541,     1,     5,     0,     0,   820,  1202,  1203,  1201,   820,
     820,     0,     0,     0,     0,     0,  3496,  3489,  3490,  3491,
       0,  2214,  2081,  1556,  1555,  2161,  2165,  3476,  3475,  3477,
       0,     0,  2161,  1546,  2973,  2798,  3086,     0,  2471,  2485,
    2469,  2681,  1524,  1520,  3211,     0,  1248,  1291,  1251,   263,
       0,     0,  1253,     0,     0,  1268,  2714,  2713,  2712,  1265,
    1264,  1263,  1261,     0,   681,   259,     0,  1376,     0,     0,
       0,  3497,  3496,     0,  1437,  2473,  2474,  2475,  2476,  2477,
    2478,  2481,     0,   295,   550,   553,     0,   542,   545,     0,
     131,   132,  1463,  1466,     0,   823,     0,   171,     0,   378,
     380,     0,   377,   379,  2761,   568,   342,   343,   345,     0,
     365,     0,     0,     0,   454,   360,   452,     0,   453,  2758,
    2755,  2760,  2756,  2759,  2757,  2362,  2361,     0,  2360,  2338,
       0,  2358,     0,  2258,  2260,     0,     0,     0,     0,     0,
       0,   259,     0,  2454,   259,  2242,  2260,  2260,   611,   585,
    3358,  3373,  3374,  1609,  3370,  3375,     0,  3372,  3364,     0,
    3368,  3362,     0,  3394,  3366,  3371,  2965,  2795,  2980,  3095,
    3099,  3115,  3118,  2847,  3162,  3352,  3337,  3353,     0,     0,
    3356,  3360,     0,     0,  2271,  2272,  2273,  1372,  2554,  2555,
    2559,     0,  2577,     0,   504,     0,     0,     0,     0,   477,
     493,   494,     0,     0,   500,     0,   491,     0,   463,   475,
     465,     0,   495,   474,   467,   466,   468,   469,   470,   471,
       0,   472,   473,   476,     0,   459,   460,   607,   461,   462,
     491,  2709,  1479,     0,  2637,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1609,  1609,  1609,  1606,     0,     0,
       0,  2642,     0,     0,     0,     0,  2633,     0,  2643,     0,
       0,     0,  2635,  2636,  2689,  2690,     0,     0,     0,     0,
    2640,     0,     0,     0,     0,     0,  2616,  1670,     0,  1606,
       0,  2632,  2639,     0,  2624,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1606,  2615,  2634,
    2641,     0,  1609,  1606,  1606,     0,     0,     0,     0,     0,
    2894,  2778,  2909,  2836,  2920,  2922,     0,  2785,  2786,  2787,
    2788,  2789,  2833,  2944,  2863,  2945,  2798,  2867,  2984,  2991,
    3009,  3011,  2870,  3050,  3052,  3057,  2872,  2873,  2874,  3062,
    3063,  3077,  2851,  2880,  2881,  3093,  3100,  3125,  2884,  3130,
    3135,  3138,  3158,  2887,  3179,  3180,  2888,  3178,  2848,  3190,
    3196,  3199,  3200,  2829,  2891,     0,     0,     0,     0,  1669,
       0,     0,  1917,  1553,  1746,   964,  1615,  1627,  1643,     0,
    1744,  1743,  1747,  1749,  1755,  1662,  1776,  1715,  1716,  1718,
    1839,  1717,  1722,  1723,     0,  1893,  1724,     0,     0,  1721,
    2629,  1720,  1719,  2630,  2631,  1714,  2667,  2703,     0,  2691,
     719,   718,     0,   414,   409,   417,   411,   413,   412,   418,
     419,   420,   415,   410,   416,   403,     0,   388,     0,   396,
    3473,     0,     0,   491,   614,   421,  3358,  2895,  3099,  3326,
       0,  3336,     0,  3488,  3482,  3485,  3484,  3480,  3483,  3481,
    3486,  1581,  3487,  1580,  1531,  1561,  1578,  1579,     0,     0,
       0,  1120,  2769,  3237,  3238,  2849,  2851,  2850,  3239,  3175,
    2770,     0,     0,  2698,     0,     0,  2699,  2766,  2764,  2768,
    2763,  2767,  2762,  2765,  3207,  3223,  3219,     0,     0,     0,
    2466,  1198,  1197,     0,     0,     0,  2408,     0,  1120,  2466,
    2409,     0,  2138,  2456,  2459,     0,  3241,  2422,  1199,  3242,
    2452,     0,  2394,  2410,  2371,  2415,   130,  3243,     0,  2455,
    2138,  2466,     0,  2387,     0,     0,     0,     0,  1594,     0,
     397,  3304,  2336,  1372,  2305,  1529,  2291,   609,     0,     0,
    2275,  2278,  2274,     0,  2523,  3456,   570,   564,     0,     0,
       0,     0,     0,  3465,  1964,  2229,     0,    81,    76,     0,
       0,     0,     0,  2686,  3306,    86,     0,     0,  3556,    74,
       0,  2541,     0,  2539,  2536,  2538,     0,  3465,     0,  2564,
    1406,  1406,     0,     0,  1398,  1400,  1401,  1406,  1406,  2370,
       0,     0,     0,  2623,  2621,  2622,  2694,  3539,  2620,  2619,
    3548,  3550,  3533,     0,  3536,  3535,  3545,  1544,  1543,     6,
      71,     0,   259,   259,   820,   173,   820,   141,   144,   820,
     820,   820,   820,   153,   157,     0,   261,     0,     0,  3496,
    1559,     0,     0,  1571,  1557,  1977,  1558,  1979,  1976,  1975,
    1974,  2005,  2006,  2008,  2007,  2009,  2011,  2002,     0,     0,
    2227,     0,  2222,  2082,  2087,  2081,     0,     0,     0,     0,
    2160,  2138,  2169,  2162,  1523,  2158,     0,  1519,  1584,  1584,
    3479,  3478,  3474,  2163,  1542,  1550,  1548,  1549,  2164,  1540,
       0,  2483,  2683,     0,  2488,     0,  2161,  2165,     0,     0,
    1136,     0,   266,     0,  3494,  3495,  3493,  1609,  2715,  2718,
    3492,  2719,   266,  1262,     0,   682,  2261,     0,     0,     0,
       0,     0,     0,   684,   683,   620,     0,     0,  1380,  1381,
    1375,  1377,  1379,     0,     0,     0,     0,  2487,     0,   291,
     297,   290,     0,   339,     0,   540,   546,    87,     0,  1467,
    2251,  2253,   170,     0,     0,   368,     0,   350,     0,     0,
    1061,  1083,  1081,  1102,  1047,  1067,  1063,  1067,  1057,  1102,
     996,   996,  1102,  1060,   996,  1067,  1062,     0,  1059,  1102,
    1058,   996,     0,  1051,  1083,   990,   991,   996,  1081,  1017,
       0,  1067,  1040,  1039,  1102,  1043,  1044,  1042,  1046,     0,
    1048,  1067,  1053,  1041,  1045,     0,     0,  1081,  1081,  1081,
       0,  2761,  1081,     0,   352,   456,   973,   976,   978,   977,
     979,   980,  1067,  1083,  1083,     0,     0,  1081,  1089,   452,
    2758,  2756,  2759,  2757,   346,   348,     0,     0,     0,   367,
       0,  2339,     0,  1569,  2081,  2341,  2346,  2352,  2356,  2359,
    2234,     0,     0,     0,  2235,  2239,  2245,  2244,  2238,  2454,
       0,  2248,   695,     0,     0,     0,  2249,  2230,     0,     0,
    3359,  3357,  3391,  3390,  3395,     0,  3392,  3388,     0,  3351,
    3396,  3381,  3428,  3385,  3428,  3428,  3382,  3389,  3428,     0,
    3387,  3386,     0,  3354,     0,     0,     0,  1373,  2278,  2560,
       0,  2552,     0,  1502,  2579,  2578,  2575,  2073,  3290,  3295,
     498,  2745,  2744,  2707,   505,  2708,  2741,  2743,  2740,  2742,
       0,     0,  3062,     0,   510,   509,   508,     0,   527,   498,
     501,   519,     0,     0,   337,   484,   492,   485,     0,   525,
     528,   560,   558,   600,   596,   604,   598,   464,  2710,     0,
       0,     0,     0,  1750,  2079,  2079,  2079,     0,     0,  1972,
       0,     0,     0,     0,  2079,     0,  1788,  1761,  1762,     0,
    1789,     0,     0,     0,     0,     0,     0,     0,     0,  1923,
       0,     0,     0,     0,     0,     0,     0,  2689,  2690,     0,
       0,     0,  1966,  1968,  2667,  2691,  2079,     0,  2079,     0,
    1614,  1796,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2079,  2079,  2079,  1801,  2617,  2638,  1805,
    1807,  1806,  2079,  2079,     0,     0,     0,     0,     0,  2079,
       0,     0,     0,  2626,  2625,     0,     0,     0,     0,     0,
       0,     0,  2644,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2646,     0,     0,     0,  2645,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1752,     0,  1751,
    1753,     0,  1553,   965,     0,     0,     0,     0,  1666,  1665,
    1664,  1663,     0,     0,     0,     0,  1672,     0,  1674,  1676,
    1671,  1673,  1675,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1754,     0,     0,     0,     0,     0,  2618,
       0,  1849,     0,   731,  2549,     0,     0,     0,   386,  1486,
    2720,     0,  1485,  1489,  3290,   593,  3357,     0,     0,     0,
    3354,  1595,  1577,     0,     0,  3209,  3217,  1119,     0,     0,
    1122,  1124,  2296,  2295,  1123,  1132,     0,  1121,     0,  3278,
       0,     0,  3263,     0,  3244,     0,  1128,  1130,  1129,  3258,
    1127,     0,     0,     0,  3228,     0,     0,   820,     0,     0,
       0,     0,     0,     0,     0,  2437,     0,  1594,  1594,  2388,
       0,  2466,     0,  2466,  2456,  2462,  2421,     0,     0,   876,
    2143,  2139,  2414,  2460,  2461,  2466,     0,     0,  2466,     0,
    2428,  2456,  2466,  2383,     0,     0,  2375,  2380,  2376,     0,
    2382,  2381,  2384,  2372,  2373,     0,  2401,  2430,     0,  2413,
    2420,     0,  2400,  2407,     0,  2418,  2456,  2456,     0,  2466,
    2466,  2466,     0,  1595,     0,   591,  2648,  2651,  2655,  2659,
    2278,  2268,  2277,     0,  2525,   335,     0,     0,     0,  1494,
    1496,  1495,  1512,  1420,     0,  3464,     0,  3466,     0,  3468,
       0,    78,     0,     0,  2518,  2516,     0,     0,     0,  2510,
    2512,  2515,  2511,     0,     0,  2517,   130,     0,  2513,  2492,
    2495,  2502,  1594,  2493,     0,     0,   422,   425,   427,     0,
     430,  2073,  3309,  3308,     0,     0,     0,  1424,  1427,     0,
    2546,  2543,   130,     0,  2846,  3471,  3469,     0,  1394,  1410,
    1392,  1404,  1405,     0,     0,  1397,  1396,  3290,  3557,  3558,
       0,     0,  3534,  3551,  3532,     0,  3546,  3547,  3531,     7,
       4,   147,     0,     0,     0,   138,   820,   820,   133,     0,
     820,     0,   155,  1595,  1595,   820,   820,   820,     0,     0,
    1975,  2005,  2006,  2008,     0,  2007,     0,     0,  2073,     0,
       0,  1997,  2021,     0,  2021,  1999,  2000,     0,     0,     0,
    1571,  2003,  2695,  2223,  2226,     0,  2215,  2217,  2218,  2712,
    2220,     0,     0,  2084,  2087,  1586,  2151,  2152,     0,  2150,
       0,  2140,  2144,  2149,  2147,     0,  2131,  2168,  2159,  2207,
    1585,  2166,  2167,  1547,  2472,  2470,  2489,  2490,  2682,  1525,
    1521,  3286,  3287,  3284,  3285,  3283,  3212,  3213,  1137,  1136,
     814,   817,   816,     0,     0,  1252,   262,  2717,     0,  1254,
       0,  2454,  1269,     0,     0,  2454,   631,  2454,   685,  2718,
    3421,     0,  3433,  3410,  3290,  1378,  3498,  3499,  1259,  1257,
       0,  1438,  1439,  1442,     0,   295,     0,   298,   300,   551,
     554,   491,     0,     0,     0,  1477,     0,  1475,  1474,  1472,
    1473,  1471,     0,  1462,  1468,  1469,  2454,   623,   372,   570,
     351,   344,   347,   349,     0,  1084,  1002,  1082,  1102,  1100,
    1102,  1024,  1103,     0,  1071,  1069,  1068,  1064,  1071,  1027,
    1146,     0,  1139,  1144,  1140,  1033,  1142,     0,  1150,  1149,
     997,  1047,  1102,  1035,     0,   996,  1026,  1032,  1071,     0,
    1021,  1030,  1102,   989,  1034,  1020,     0,  1071,  1036,  1049,
    1052,  1054,  1056,  1071,  1102,     0,   456,   996,  1019,  1018,
     996,  1071,     0,     0,     0,     0,   361,  1065,  1050,  1142,
    1150,   996,  1102,  1071,     0,  1090,  1071,   370,   455,  2170,
    2002,     0,  2342,  2348,  2255,  2257,  2681,     0,  1570,  2344,
    2129,     0,     0,     0,  2354,  2259,     0,  2236,     0,   695,
    2241,  3349,   698,   697,  2246,   696,  2297,  3408,  2240,  1382,
       0,     0,   491,   583,   586,  3384,  1610,     0,  3365,  3369,
    3363,  3367,     0,  3347,     0,     0,  3355,     0,     0,  3393,
    3376,  3380,  3379,  3377,     0,  3378,  3383,  3361,   483,   531,
    2265,  2992,  3190,  2561,  2557,  2556,     0,  2576,     0,  2074,
    2075,     0,     0,  2077,  3292,  2170,     0,  3289,   506,     0,
     498,     0,     0,     0,   522,  2711,   502,   498,   512,   521,
     590,   338,     0,   295,   496,     0,   341,   570,     0,   491,
     491,     0,  3290,     0,  2080,     0,  1938,     0,     0,     0,
       0,     0,     0,  1730,     0,     0,     0,  1876,     0,  1938,
    1900,  2200,  2201,  2181,  2182,  2180,  2183,  1607,     0,  2184,
    2199,  1817,     0,     0,     0,  1898,  1552,  1535,     0,     0,
    2049,  2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,
    2059,  2060,  2062,  2067,  2063,  2064,  2065,  2066,  2061,  2068,
       0,  2048,     0,  1924,  1889,     0,     0,     0,     0,   965,
       0,     0,     0,     0,     0,     0,     0,  2079,     0,     0,
    2079,     0,     0,     0,     0,  1899,     0,     0,     0,  1897,
       0,     0,  1896,  1774,     0,     0,  2079,     0,     0,     0,
       0,     0,     0,  1780,  1781,     0,     0,     0,  1706,     0,
    1704,  1705,     0,     0,  2079,     0,     0,     0,     0,     0,
       0,     0,     0,  1697,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2071,  2069,  2072,  2070,     0,     0,  1964,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1831,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1778,
       0,     0,     0,  2672,     0,  1168,     0,     0,     0,     0,
    1745,     0,     0,     0,     0,  3244,  1918,  1920,  1612,  1611,
    1613,  1624,  1618,  1622,  1616,  1620,     0,  1677,  2901,  1625,
       0,     0,     0,  1628,  1637,  1641,     0,     0,     0,     0,
       0,  1659,  1660,  1648,  1646,  1647,  1644,  1645,     0,  1650,
       0,  1649,  1656,  1657,  1658,  1661,  1748,  1131,  1756,  2099,
    1891,  1892,  1916,  2103,     0,     0,     0,     0,  2668,  1595,
    1700,  1699,  1701,  1702,  1703,   732,     0,   726,   729,   743,
       0,     0,  2548,     0,  2863,  2887,  2888,   404,   407,   406,
     408,     0,     0,     0,     0,     0,     0,     0,     0,  3412,
    3334,     0,     0,     0,     0,  1591,  1532,  1590,     0,     0,
       0,     0,     0,     0,  3261,     0,     0,  3260,  3259,     0,
    3280,     0,     0,  3265,  3264,     0,     0,  3222,  3266,  3267,
    3270,     0,     0,     0,     0,     0,  3251,     0,  3175,  3224,
    3225,  3230,  3220,  2429,     0,     0,     0,  2434,  2432,  2425,
    2436,  2446,  2433,  2427,  2438,  2426,     0,     0,     0,  2466,
    2441,  2443,  2439,  2466,     0,  2464,  2451,  2450,  2449,  2398,
    2397,  2391,  2457,  2444,  2440,   259,  2466,  2396,  2395,  2377,
    2378,  2379,     0,  2138,     0,  2462,  2431,  2456,     0,  2466,
    2466,  2447,  2448,  2417,  2419,  2324,     0,  2002,     0,     0,
    2310,  2303,  2290,   491,     0,     0,  2653,  2276,     0,  2279,
    2002,   491,   566,     0,     0,     0,   716,  1512,  1498,  1514,
    1422,  1421,  1419,  3215,  3463,  3467,  1965,    80,  2318,  2316,
      82,  2315,  2317,    83,  2527,  2504,  2503,  2505,  2509,   130,
    2514,  2506,     0,  2519,  2520,   435,     0,   431,     0,     0,
    3307,     0,   821,     0,    75,     0,  1428,  2170,  2542,  2544,
    2537,  3470,     0,  1395,  1412,  1411,  1407,  1408,  1413,  1403,
    1402,  2364,  3540,  3549,  3553,  3538,   812,  3345,  3433,   228,
       0,     0,     0,     0,   136,     0,   283,     0,   820,   154,
     158,   820,     0,     0,     0,   820,     0,  2018,  2010,  2012,
    2013,  2014,     0,  2017,     0,  1574,     0,  1562,  1562,  1572,
    2020,  2001,  1998,  2022,     0,  2021,  2021,     0,     0,  1981,
    1980,     0,  2073,  1125,  2219,     0,     0,  2083,     0,  2085,
    2094,  2084,  1588,  2170,  1582,     0,  2625,     0,     0,     0,
       0,     0,     0,     0,     0,   815,  2297,  2297,     0,     0,
       0,     0,     0,     0,     0,     0,   267,   276,  2716,     0,
       0,   629,   630,  2297,   628,   671,   672,   675,   676,   677,
       0,     0,   678,  2297,  2297,   625,   651,   652,   655,   656,
     657,   658,   659,   621,     0,   626,     0,     0,     0,  3445,
    1246,  1282,  3500,  1255,     0,     0,  1441,   293,   292,   296,
       0,     0,   491,   538,   547,   541,   543,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    88,    89,   110,     0,  1464,  1476,  2252,  1470,  2297,
    2297,  2297,  2297,   627,   660,   661,   664,   665,   666,   667,
     670,   668,   669,     0,  2454,     0,     0,     0,     0,     0,
       0,     0,  1022,  1104,     0,  1023,     0,  1073,  1074,  1072,
     992,   988,  1147,  1135,  1134,  1141,   999,  1143,  1138,  1151,
    1148,  1145,  1100,   998,  1028,  1029,   994,     0,  1243,  1006,
       0,   995,  1055,   993,  1007,     0,   357,     0,   355,   364,
    1031,  1004,  1016,   456,   456,   353,   457,   458,     0,  1025,
    1000,  1001,  1003,  1150,   986,     0,   987,  2170,  2175,  2171,
     366,   385,     0,   384,  2343,  1562,     0,     0,     0,  2684,
       0,  2154,  2130,  2353,     0,  2357,  2356,     0,  2237,  2247,
       0,  2298,     0,     0,  1384,  1383,  2243,  2250,  3290,   491,
     584,   512,  3432,     0,  3431,     0,     0,  3344,     0,  3404,
    3407,  2681,     0,     0,     0,     0,   339,     0,  2558,  2562,
    1503,  1505,  1506,  1504,  1512,     0,  2729,  2696,  2078,  2697,
    2726,  2724,  2728,  2722,  2723,  2727,  2721,  2725,     0,  3298,
    3299,  3297,  3291,  3296,   499,   507,   523,   526,     0,   503,
     513,   517,     0,   487,   486,   529,   561,     0,   601,   555,
     555,   555,  1480,     0,  1871,     0,  1872,  1873,     0,  1731,
    1973,     0,     0,     0,  1759,     0,     0,     0,  1875,     0,
    1608,     0,     0,  1734,  1726,  1536,     0,  1902,     0,  1907,
       0,  1905,     0,     0,     0,     0,     0,     0,  1967,     0,
    1969,  2668,     0,  1881,  1912,     0,  1879,     0,  1901,     0,
    1913,  1914,     0,     0,     0,  1885,  1883,     0,  1887,  1884,
    1886,     0,     0,     0,  1800,     0,     0,     0,     0,     0,
       0,     0,  1777,     0,  1813,     0,  1869,  1814,  1815,  1816,
    2671,     0,  1810,     0,  1811,     0,     0,     0,     0,     0,
    1763,  1764,     0,  1841,     0,  1765,  1821,     0,  1739,  1842,
    1823,  1770,  1771,  1843,  1844,  1845,  1736,  1737,  1825,  1826,
       0,  1847,  1738,  1827,  1830,     0,  1773,  2170,     0,  1757,
       0,     0,     0,  1775,  1804,     0,     0,     0,  1735,     0,
    1833,     0,     0,     0,  2170,     0,     0,  1779,     0,     0,
     966,  1554,  1727,  2669,     0,     0,  1619,  1623,  1617,  1621,
       0,     0,     0,     0,  1636,     0,     0,  1629,  1639,  1642,
       0,     0,  2101,     0,     0,  1910,  1962,  1962,  1962,  1962,
       0,     0,     0,  1865,  1866,     0,     0,   725,   724,     0,
     728,   804,     0,   745,   733,   722,  2550,     0,     0,  1487,
    1490,     0,     0,     0,  3335,     0,     0,     0,     0,     0,
       0,     0,  1595,  1596,  1596,  2667,     0,     0,  3248,  3218,
       0,     0,     0,  1133,  3279,     0,     0,  3272,  3273,     0,
       0,     0,  3245,  3246,  3247,     0,  2753,  2754,  2700,  2702,
       0,  2701,  2751,  2749,  2752,  2747,  2748,  2746,  2750,  3254,
       0,  3227,  3228,  3229,     0,     0,  2424,  2435,  2467,  2468,
    2445,  2442,  2392,  2463,  2170,  2402,  2423,  2393,     0,  2416,
    2374,  2464,  2081,  2456,  2389,  2390,     0,  1571,  1596,  2306,
    1595,  2307,   491,  2652,     0,  2657,     0,  2285,     0,  2282,
    2289,   709,  2269,     0,  2280,  2254,     0,   577,  1461,  1501,
    1493,  1500,  1497,  1512,  1510,  1499,  1194,  1193,     0,  1513,
       0,    79,     0,     0,  2507,  2508,  2501,  2521,  2496,     0,
     426,   436,   428,   432,   433,   434,   429,  2981,  3062,     0,
    2081,  3311,  3555,  1435,  1433,  1432,  1434,  1423,  1429,  1430,
    2547,  2545,  2540,  2566,  1410,     0,  1393,  2366,  2170,     0,
    3552,   148,   813,     0,   169,  3445,     0,  1218,     0,     0,
     134,   208,   283,     0,   281,  3524,   156,  3514,     0,   149,
       0,   263,     0,     0,  2015,  2016,  1978,  1562,  1564,  1563,
       0,     0,  1566,     0,     0,     0,     0,  1986,     0,  1982,
    1984,     0,  2046,  2038,     0,  2224,  2216,  2221,  2666,  2091,
    2135,     0,     0,  1533,  2094,  1587,  2153,  2142,     0,  2146,
    2145,  2148,  1586,  2132,  2135,  1595,  3214,     0,     0,  1250,
       0,     0,     0,   270,   273,   271,   272,   680,   679,     0,
    2454,   673,  2297,  2297,   222,  2297,  2297,   221,   223,     0,
     217,   214,   224,  2297,  1270,   210,     0,     0,     0,     0,
    2170,     0,     0,     0,   230,     0,     0,  2454,   653,   632,
     633,   636,   637,   638,     0,  3415,  3414,     0,  3435,     0,
       0,  3437,     0,  3436,  3434,  3400,  3411,     0,  1277,  1136,
       0,  1284,  1286,     0,     0,  3500,  1440,     0,   295,   299,
     339,     0,   544,     0,     0,  2170,     0,  2170,  2170,     0,
       0,  2170,     0,  2170,     0,     0,     0,     0,     0,     0,
       0,  2170,     0,     0,     0,     0,  2170,     0,  1478,     0,
       0,     0,     0,  2454,   662,     0,  2297,   622,   639,   640,
     643,   644,   645,   646,   647,   650,   648,   649,     0,     0,
     305,   306,   374,   569,  1079,  1077,  1080,  1078,  1101,     0,
    1075,  1076,  1105,  1142,     0,  1142,   356,   359,     0,   363,
     362,     0,     0,  1005,   394,   393,   391,   491,   381,   389,
     383,     0,   390,  2178,  2179,  2176,  2174,  2177,  2340,  2256,
    2356,     0,  2682,  1594,     0,  2350,  2081,     0,  2355,  3290,
    3350,   694,   875,  3409,  1382,     0,   374,   515,   588,  3429,
       0,  3449,     0,     0,     0,     0,     0,     0,     0,     0,
     532,  2319,     0,  1512,  1516,  2569,  3301,  3302,  3300,   524,
       0,   520,   512,     0,   295,     0,   555,     0,   595,   597,
     556,   605,   599,     0,  1939,  1970,     0,  1081,  1081,  1067,
    1089,  1956,     0,  1950,  1953,     0,  1081,  1958,  1081,  1951,
    1081,     0,     0,  1948,  1949,     0,     0,     0,  1877,  1874,
       0,     0,     0,  1927,     0,     0,     0,     0,     0,  1653,
       0,  1860,     0,  1882,  1880,     0,     0,     0,     0,     0,
    1888,     0,  1785,  1783,  1712,     0,  1710,     0,  1711,     0,
    1713,     0,     0,  1870,     0,  1679,  1698,     0,     0,     0,
       0,     0,     0,  1965,     0,     0,  2186,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2673,     0,
       0,     0,  1157,  1163,  1166,  1167,  1169,  1161,     0,  1835,
       0,     0,     0,  1921,  1919,     0,  1634,  1630,     0,  1638,
       0,     0,     0,  1652,  1651,  2103,  2102,     0,  1909,     0,
       0,  1963,  1964,     0,     0,  1964,     0,     0,     0,  2670,
    1596,  1850,  1595,   735,     0,   753,   727,  2170,   730,     0,
     744,     0,   756,     0,     0,     0,   405,     0,  1491,     0,
       0,  3333,  3413,     0,     0,     0,     0,     0,  1589,  1598,
    1592,     0,     0,     0,  3210,  3262,  3253,     0,     0,     0,
       0,  3277,  3271,  3268,  3269,     0,     0,     0,  3252,  3226,
    3232,  3231,  3234,  3236,  2412,  2411,     0,  2465,  2138,  2385,
    2404,  2406,  2466,  2326,  2329,     0,  2073,  2314,     0,     0,
    2308,  2312,     0,  2656,     0,     0,     0,  2286,  2288,  2661,
    2660,  2672,     0,     0,  2281,   336,     0,   576,     0,  2040,
    3216,    84,     0,  2499,     0,  2494,  2497,     0,     0,  3322,
    3323,  3315,  3318,  3316,  3317,  3321,  3324,  3325,  3312,  3319,
    2138,     0,  1425,  1431,  1409,     0,  1416,  1414,     0,     0,
    2365,  3541,  3554,     0,  1277,     0,     0,     0,     0,     0,
       0,   824,   824,   209,     0,  3530,  3529,  1595,     0,   279,
     282,   284,   278,   330,     0,   239,  3500,   163,   165,     0,
     159,   161,   151,  1573,  1565,  1567,  1562,  1562,     0,  1974,
       0,     0,     0,  1974,     0,     0,   716,     0,  2019,  2035,
    1126,  2583,  2092,  2093,     0,  2088,  2136,  2137,  2090,  2086,
       0,  2095,  2097,  1534,  2141,  1583,     0,  2134,     0,     0,
    2210,  2212,   874,   873,   275,   274,   287,   288,  2196,  2197,
    2194,  2195,   686,   699,  2198,   700,   674,  2170,  2170,  2302,
    2301,  2170,  2170,   216,   213,  2300,  2299,  2170,  2170,   211,
     234,   233,   235,   236,   238,   237,   232,  1266,     0,   687,
     688,   654,     0,   634,  3418,     0,  3425,  3420,  3423,  3403,
    3402,  3401,  3398,     0,  2170,  2170,  2170,     0,  2170,  3444,
    3446,     0,     0,  1267,  1370,  1370,     0,  1370,     0,     0,
    1370,     0,  2297,     0,     0,  2297,   716,  1388,  2297,  2297,
    2297,  2297,     0,  2297,  2297,  2297,  2297,     0,  2297,  2297,
       0,  2297,     0,     0,     0,  2297,     0,  1353,     0,  2297,
    2297,  2297,  2297,  1370,  2297,  2297,     0,     0,     0,     0,
    2297,  2297,     0,     0,  2297,  2297,     0,  1298,  1352,   826,
     869,   853,   854,  1247,  1297,  1299,  1311,   712,     0,  1329,
    1355,  1356,  1354,     0,  3458,     0,     0,   244,  3502,     0,
    3504,     0,  1444,     0,  1443,   294,   552,   548,  2170,  2170,
     103,  2170,    95,    96,    91,   123,   124,    93,    94,    99,
      98,   100,   101,   104,   105,   102,    97,    92,   127,   129,
     128,   106,   125,   126,    90,   693,   692,   691,   690,   663,
       0,     0,  2454,   641,   373,     0,  1087,  1085,  1085,     0,
    1085,     0,  1118,   981,   983,   982,   984,   985,  1087,  1087,
    1085,  1085,   307,   375,   369,     0,  1038,  1244,  1037,   358,
     354,  1066,  2170,   371,   392,     0,  2081,  2685,     0,     0,
    2155,  1595,  2345,  2347,  2233,  2231,   612,     0,     0,   512,
    3430,     0,  3343,  3348,     0,  3406,  3405,  3433,  3433,  3433,
    3433,   534,     0,  2266,  1507,  1512,  1516,     0,  1508,  2580,
     514,   518,   489,   488,   570,   559,   491,     0,  1971,  1940,
    1941,  1955,  1957,     0,  1954,  1943,  1960,  1947,  1952,  1959,
    1945,  1729,  1760,  1733,  1732,     0,     0,     0,  1794,     0,
    1925,  1908,  1906,     0,     0,  1767,     0,  1769,     0,     0,
    1862,  2670,  1824,  1904,  1797,  1828,  1772,     0,     0,     0,
    1709,  1707,  1708,     0,  1786,  1808,     0,  1696,  1809,     0,
    1840,  1792,     0,  1819,     0,  1795,  1822,  1846,  1725,  2188,
    2187,  2185,  1740,  2170,     0,  1798,  1758,     0,     0,  1832,
    2674,  2675,     0,  1834,     0,     0,  1168,  1154,  1155,  1156,
       0,  1158,  1160,  1162,     0,  2170,  1848,  1655,  1654,     0,
    1626,     0,  1635,  1632,     0,  1640,  2105,  2104,     0,     0,
    1853,  1855,  1854,  1857,  1856,  1851,  1962,  1598,  1867,     0,
     736,   737,   739,   741,   807,     0,   731,     0,   720,     0,
     735,   723,  1488,   594,     0,     0,  3330,  3329,  3328,  3327,
       0,  1593,  1602,  1601,  2664,  2668,  3250,  3249,  3282,  3281,
    3275,  3274,  3276,     0,     0,  3255,     0,     0,  2192,  2193,
    2191,  2189,  2190,  2403,  2138,  2399,     0,  2081,     0,  2038,
    1596,  2304,     0,   592,  2658,     0,  2284,     0,     0,     0,
    2283,  2293,     0,   581,   578,   579,     0,  2043,     0,  2044,
    2041,  2042,  2170,     0,     0,   444,   439,   447,   441,   443,
     442,   448,   449,   450,   451,   445,   440,   446,   438,   437,
       0,  3310,  1436,     0,     0,  2367,  2368,  3346,   168,     0,
    1234,  1236,  1235,  1219,  1220,     0,   142,   145,   924,     0,
       0,   135,   704,   712,   825,   828,   701,   137,  1595,   174,
     277,   280,   328,   334,   333,   268,     0,     0,     0,  3520,
     302,   889,   890,   888,   887,     0,  3520,   302,  3500,  1576,
    1575,  1987,     0,  1991,  1996,  1992,     0,  1983,     0,  2004,
    2047,  2039,     0,     0,  2591,  2135,     0,     0,  2135,  1596,
    2208,  1595,   215,   220,   219,   212,   225,   218,   231,   635,
    3419,  3417,  3416,     0,  3424,     0,  3399,  3440,  3438,  3439,
    3442,     0,     0,  3441,  3443,  1271,  1272,  1278,  1273,  1241,
     820,  1371,   818,     0,  1333,  1337,  1334,     0,   925,   820,
    1195,  1195,   818,  2258,  1481,  2258,     0,     0,  2258,     0,
    2260,  2258,     0,     0,  2258,  2258,  2297,     0,  1481,     0,
    2170,   714,  1391,  1389,  1390,     0,  2170,  2170,  2170,   851,
     872,     0,  2170,  2170,  2170,  1481,     0,     0,  2297,  2170,
    1346,  1293,  1347,     0,     0,  1294,     0,  2170,  2170,  2170,
    2258,  2170,     0,  1481,  1313,  1481,  1481,     0,  2170,   859,
     860,   858,  2170,  2170,     0,   827,  1136,  1295,   713,  1296,
     924,     0,  1385,   900,   927,  2677,     0,  3459,     0,     0,
       0,  1283,     0,   247,   245,   255,  3501,     0,  1258,     0,
    3504,  1446,  1447,     0,     0,     0,   116,   118,     0,   120,
     122,     0,   112,   114,   624,   689,   642,   304,  1088,  1010,
    1086,  1014,  1015,   312,  1142,     0,     0,  1142,  1150,  1142,
    1150,     0,  1070,   382,  2356,  2349,     0,  2156,     0,  2351,
     589,   516,   587,     0,  3433,  3447,  3447,  3447,  3447,   339,
     530,   533,  2320,  1509,  1517,  2582,  2581,     0,   295,     0,
     491,  1142,  1961,  1142,  1142,  1878,     0,     0,     0,     0,
    1931,     0,     0,     0,     0,     0,  1728,     0,  1858,     0,
    1784,  1782,     0,  1067,  1686,  1688,  1684,  1687,     0,  1081,
    1690,     0,  1048,  1081,  1693,  1695,  1680,  1681,  1682,  1683,
       0,     0,     0,  2206,  2205,  2204,     0,     0,     0,     0,
    2676,  1152,  1837,     0,  1165,  1159,  1157,  1164,     0,  1922,
    1631,     0,     0,  2107,     0,  1911,     0,  1868,   740,     0,
       0,     0,   760,     0,   758,   734,     0,  3332,  3331,  1600,
    1599,     0,     0,     0,  3233,  3235,  2405,  2328,  2129,  2330,
    2331,  2323,  2313,  2311,     0,  2287,  2662,  2673,   710,     0,
       0,  2170,   580,  1314,     0,  1315,  1326,  1328,  1515,     0,
    2532,     0,  2530,  2500,  2533,     0,  1415,  1417,     0,   139,
       0,     0,  1241,  2808,     0,   893,   895,   896,   897,   898,
       0,   705,  2580,   711,  1136,   829,   824,   176,   202,   313,
    3525,   615,   616,     0,     0,  3504,   268,     0,     0,     0,
       0,   268,     0,     0,     0,     0,     0,     0,     0,  2028,
       0,  2027,     0,  2033,  2037,     0,     0,     0,     0,  2584,
    2586,     0,  2225,  2089,  2098,  2096,  2133,  2213,  2211,     0,
    3426,  3422,  2173,  2172,     0,  1275,     0,  1274,  1279,     0,
     926,  1242,  1481,     0,     0,     0,  1357,     0,     0,     0,
    1195,   916,   820,  1241,  1196,   820,   820,  1331,     0,     0,
       0,  1305,     0,     0,  2258,     0,  1359,     0,  1358,     0,
       0,     0,     0,  1368,  1369,     0,  2125,  2127,  2135,  2203,
    2202,   848,     0,  1350,   841,   840,   843,   842,   845,   844,
       0,  1366,  1367,   837,   834,   846,     0,   836,   861,     0,
     849,   831,     0,   885,   886,   884,   855,   862,   832,   833,
       0,   839,   838,   835,     0,  1321,     0,   877,   882,   880,
     879,   878,   883,   881,   850,   868,   847,   863,  1310,  1370,
    1370,  1330,     0,   891,  2680,     0,  1387,  1332,     0,   901,
       0,     0,   867,   866,   864,   865,   254,   243,     0,     0,
    1285,  1287,     0,     0,  1288,  3503,  3506,  1256,  1452,     0,
     339,   108,  2170,   109,  2170,   107,  2170,  1012,   310,     0,
    1008,  1009,  1011,  1013,   376,     0,     0,  2157,  3450,  3447,
       0,  3341,  3340,  3339,  3338,   536,   535,     0,     0,   490,
     555,     0,  1942,  1944,  1946,  1790,  1791,  1928,  2135,  1926,
    1933,     0,     0,  1932,  1818,     0,  1768,     0,  1859,     0,
    1829,  1787,  1689,  1685,  1692,  1049,  1691,  1142,  1812,  1793,
    1820,  1741,  2170,  1799,  1802,  1803,     0,  1836,  2170,  1633,
       0,  2110,  2109,     0,     0,  2135,  1852,   738,   808,   733,
       0,     0,   757,     0,   721,  2665,  3257,  3256,  2154,  2654,
       0,  2292,  2294,     0,  1511,     0,  2045,  2528,  2170,     0,
    2498,     0,     0,     0,     0,     0,     0,   899,   892,   924,
       0,   703,   810,   830,   712,     0,   511,   511,     0,   203,
     204,   323,     0,   314,   316,   285,   269,     0,     0,   619,
     617,   618,     0,     0,   150,  3522,   264,  3521,     0,   303,
     167,   264,     0,  3504,  1988,     0,  1993,     0,  1985,  2023,
    2023,  2034,     0,     0,     0,     0,  2585,     0,     0,  2592,
    2594,     0,  1273,     0,     0,     0,  1316,     0,     0,  1335,
       0,   820,  1191,  1192,  1241,  1216,  2677,  1241,  1241,     0,
    1304,     0,  1467,  1132,  1342,     0,  1300,     0,  1344,  1345,
    1382,   857,  1302,     0,  2128,   715,  2520,  1309,   856,     0,
    1385,  1301,  1323,  1307,  1336,  1386,  1173,   931,     0,   919,
     929,   974,  2679,   241,   246,   256,   257,  1260,     0,  3505,
       0,  1453,  1449,  1450,  1445,   549,   117,   121,   113,     0,
       0,     0,  3342,     0,  3454,  3448,  3452,     0,     0,   562,
     602,     0,  1930,  1890,  1934,  1935,     0,  1861,  1863,  1694,
       0,  1153,     0,  2106,  2100,     0,     0,     0,     0,     0,
       0,  2119,  2111,     0,  1915,  2170,   806,     0,     0,   746,
     763,   762,   759,  2327,  2663,   339,  1327,  2531,     0,  3320,
       0,     0,     0,  2135,  1239,     0,     0,   894,   706,   811,
       0,  2580,   511,   511,   177,   182,   183,   187,   185,   196,
       0,     0,   189,     0,   189,  1597,   205,   326,   324,   325,
       0,   329,     0,   286,   571,  1595,   252,     0,   265,   164,
    3520,   160,  3520,   152,     0,     0,     0,  2031,  2029,  2589,
    2590,     0,  2587,     0,     0,  2593,     0,  1280,  1276,  1281,
       0,  1318,     0,   819,     0,  1241,  1216,  2677,     0,   902,
       0,   906,   908,     0,     0,  1385,  1306,  1351,  1343,  1360,
    1341,  1481,  2126,     0,     0,  1340,  1322,  1324,  1428,     0,
    1177,   933,     0,   928,   920,   941,     0,   248,  1289,   491,
       0,     0,     0,  1448,     0,  1455,   311,   308,     0,     0,
    3453,  3451,  2321,  2002,   555,  2135,     0,     0,  1766,  1742,
    1838,     0,  2116,     0,     0,  2114,  2113,     0,  2108,  2115,
     809,     0,     0,   754,   770,   766,     0,   768,   769,   791,
     582,  2534,     0,     0,  3290,     0,  1238,     0,  3290,     0,
     870,   702,     0,     0,     0,   184,   186,   188,   201,   207,
       0,   206,     0,   264,   327,     0,     0,   317,   315,   264,
     341,  3515,   244,   253,   571,   268,   268,  1990,  1995,     0,
    2024,     0,     0,     0,  2588,  2596,  2595,  3427,     0,     0,
       0,  1317,     0,   921,   914,   910,     0,  1217,     0,   904,
       0,     0,  1349,     0,  1339,  1303,   852,   716,     0,  1308,
       0,  1176,     0,  1181,  1171,   959,  1116,     0,   962,     0,
     932,   934,  1109,  1110,   936,     0,     0,     0,     0,   975,
       0,     0,  1093,     0,  1096,     0,     0,   930,     0,   942,
    1092,  1099,  2678,     0,   250,   226,  3507,     0,     0,  1454,
    1459,     0,  1456,  1458,     0,  1568,     0,  2570,   603,  1929,
    1937,  1936,  2117,     0,  2118,  2121,     0,     0,  2122,     0,
     750,   752,   742,     0,   747,     0,   764,     0,  2297,  2297,
       0,  2297,  2297,  2297,  2297,   784,   792,   794,     0,     0,
    3290,  1206,  2135,     0,  1208,     0,   708,   871,     0,   511,
       0,   511,   570,   180,   178,   192,   190,   175,   322,     0,
       0,  3526,   572,     0,   255,   226,   264,   264,  2026,  2025,
    2040,     0,  1338,  1320,     0,     0,     0,     0,   912,     0,
       0,     0,     0,     0,     0,     0,   971,   972,  1348,   968,
     969,   970,     0,  1312,     0,  1174,     0,  1178,  1179,  1180,
       0,  1172,   960,   961,  1117,   935,  1115,  1108,  1107,     0,
    1098,  1094,     0,   950,     0,     0,  1100,  1091,   943,   249,
       0,   242,   227,   258,  3508,  3509,  1451,     0,   309,  2322,
    2333,     0,  1125,  2112,  2120,  2124,  2123,   748,     0,   755,
     777,   767,   773,     0,  2297,     0,     0,  2297,     0,     0,
       0,     0,     0,   761,   793,  2297,   229,  1204,     0,     0,
    2297,  1361,  1207,  1232,  1214,     0,  1237,  1240,  1361,  1209,
    1231,  1212,     0,   195,   199,   194,   197,     0,  1597,   330,
     330,   320,     0,     0,     0,     0,  3523,   166,   162,     0,
       0,  1319,   917,     0,     0,     0,     0,     0,     0,     0,
    2628,  2627,     0,     0,  1175,     0,     0,  1114,  1113,  1111,
    1112,  1603,  1097,     0,   945,  1106,   944,   251,  1457,     0,
       0,  2571,   754,   751,   777,     0,   775,     0,   771,   765,
     772,     0,   803,   797,     0,   799,   800,   798,   795,   788,
       0,   786,     0,     0,     0,  1361,  1205,  1230,  1229,  1210,
       0,  1224,  2170,   143,  1363,  1362,  1215,     0,   146,  1213,
       0,   571,   571,   181,   264,   268,   302,   331,     0,     0,
       0,   570,  1595,   257,  2032,  2030,     0,     0,     0,  1204,
       0,  1206,  1208,   967,     0,  1187,  1186,     0,     0,  1183,
    1182,     0,  1095,   937,   937,   951,  2332,  2334,  2597,   749,
     774,     0,   782,   778,   780,   783,   802,   801,     0,   785,
       0,   796,  1221,  1222,   140,  1211,  1233,  1223,  1365,  1364,
    1228,  1227,  1225,  1226,   918,  3527,  3527,   179,   193,     0,
    3520,   321,   318,     0,   573,  3516,   240,     0,  1204,     0,
     903,  1204,   907,   909,  1325,  1190,  1188,  1189,     0,     0,
    1604,     0,   948,   938,   940,   947,   953,   954,   952,   955,
       0,  2583,   776,     0,     0,   791,   790,   787,  3528,   200,
     198,   332,   268,     0,     0,     0,   915,   911,  1204,   905,
       0,     0,  1605,   939,   946,   956,   958,     0,  2591,   781,
     779,   789,   191,   319,   574,     0,   913,  1185,  1184,   957,
       0,  2599,  3517,  2598,     0,  2603,  3512,     0,     0,  2610,
    3510,  3511,     0,  3518,  2601,  2602,  2600,  2605,     0,     0,
    2607,  2608,     0,  2572,  3513,   491,  2609,  2604,     0,  2611,
    2613,     0,   226,  2606,     0,  1595,  3519,  2612,     0,  1596,
    2614
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5376, -5376, -5376, -5376,  2230,  4691, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376,  2822, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376,  1937, -5376,   469, -5376,   471, -5376,   472, -3370,  -620,
    4401, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,   182,
     174,   194, -5376,   189, -5376, -3126, -5376, -5376, -5376, -5376,
     185, -5376, -5376, -4549, -5376,  2105, -2838, -5375, -5376, -5376,
      68,  1483, -5376, -5376,   359, -5376,    42, -5376, -5376, -5376,
   -4525,   -99,  -300, -5376,    30,  4916,  -534, -3612,  4233, -4492,
     883,  1586, -5376, -5376,  2127, -5376, -5376, -3231, -5376, -5376,
   -5376, -5376, -2177, -5376, -5376, -4500, -5376,   671, -4223,  1357,
   -5376, -5376,   202, -5376, -5376, -5376,  -195, -5376,  -193, -5376,
    -626, -3098, -5376, -2374, -5376, -5376, -5376,  4204, -5376, -5376,
   -5376,  1940, -5376, -4151, -5376, -3411,  4860, -5376,  -695, -5376,
   -5376, -5376,  1906, -5376, -5376,   729,  1344,  3378,  2942, -5376,
   -5376, -5376, -5376,  2921, -5376,  2212, -5376, -1900,  3823, -5376,
   -5376, -5376, -5376, -5376,  2865, -2672, -5376, -5376, -5376,  1653,
   -5376,  -849, -5376, -2056,  -929,  4744, -5376,    28, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -1397, -5376,
   -5376, -5376, -5376, -5376, -5376, -3732, -2984,  1892, -5376,  1339,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,   856, -5376,
   -5376, -5376, -5376,    36, -5376, -5376, -5376, -5376, -5376, -5376,
    2720, -5376, -5376,  4886, -5376, -5376, -5376, -3674, -5376, -5376,
   -5376, -5376, -5376, -5376,    38, -5376, -5376, -5376, -5376, -4305,
   -5376, -5376, -5376, -2226, -5376, -5376, -5376,  1142, -5376, -5376,
    3301, -5376, -5376,  3302,  3299, -5376,  3306, -5376, -3144, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376,    39, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376,  4246, -5376, -5376, -5376, -3107, -5376, -5376, -3351,  3525,
   -5376, -2687, -5376, -5376, -2747, -5376, -5376, -2569,  1329, -5376,
   -5376,     8,  1498, -5376, -2035, -2815, -2770, -5376, -5376, -5376,
   -2874, -2865,  -823,  3388, -1524, -3229, -5376, -5376, -5376,   275,
     278,   446,  1470,  2070, -5376, -4003, -5376, -5376,   648, -5376,
   -5376, -5376, -5376, -5376,  1226,   494,  1225, -5376,   817,  3080,
   -3076, -5376, -5376, -5376, -5376, -5376, -5376,   -90,   314,  -172,
   -5376, -4231,   502, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -3764, -5376, -5376, -5376,  -309, -5376, -5376,  -254, -5376,
   -5376,  -308, -5376,    25, -5376, -5376, -5376, -5376, -5376,  2894,
   -2025,  1052,  -748, -5376, -3880,  1507, -4207, -3482, -5376, -5376,
     168, -1354, -1327,  -173, -5376, -5376, -5376, -5376, -5376, -5376,
     991,   495,  1504, -3984, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -3983, -3979,   720, -5376, -3819, -5376, -5376, -5376, -4663,
   -5376, -5376, -5376, -5376, -5376, -5376,  -221, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -4059, -5376, -5376,    -9,   -35, -5376,
     100,  2699, -5376, -3814, -5376, -3611, -1122, -5376, -5376, -3561,
   -3558, -3557, -5376, -1496, -3580, -1493, -3555, -5376, -5376, -5376,
   -1456, -1486,  2109, -1345, -1423,  1520,  -798,  -780,  1956,   -31,
   -5183, -3033, -1227, -1123, -5376, -5376, -3035, -3410, -5376, -3875,
    -679, -2079, -3433,   -49, -5376, -5376, -1849,   436, -2514, -5376,
    3533,  3530, -2265, -1103, -2260,  1884, -5376, -5376,  1318, -5376,
   -1291,  1312, -5376, -5376, -5376,  1327, -5376,  -231, -5376, -5376,
   -5376, -5376, -3589, -5376, -2748, -4279, -5376, -5376,  5332,  5335,
   -2924,  -167,  -174, -5376, -5376, -5376,   297, -5376, -5376, -2566,
    -130,   -52,   -41, -3985, -4556,   227, -3354,  3538, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
     492,   497,  1751, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376,  1560, -2508, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -4568, -4390, -5376, -5376,  1055, -3256, -3610, -3606, -3975,  4555,
   -5376, -5376, -5376, -5376,  4371, -3672, -4835, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376,  3761,  1742, -5376, -5376,  2302, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,   301,  2309,
   -5376, -5376, -5376, -5376, -5376,  2856, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376,    15, -5376, -5376, -5376, -5376, -5376,
     498,  3608, -5376, -5376, -5376, -5376,   -22, -5376, -5376, -5376,
   -5376,  3161, -5376, -5376, -5376, -5376,  3041, -5376, -5376, -5376,
   -5376, -5376, -5376,  2043, -5376,  2684, -5376, -2701, -5376, -5376,
    1465,  -567, -5376, -5376,  -375, -5376, -5376, -5376, -5376, -5376,
      31, -5376, -5376, -5376,  5329, -1671,    13,  -464, -5376, -5376,
      74, -5376, -5376,  4433,  -368,  2505,  -736,  5092, -5376, -5376,
   -5376, -5376, -2735,  2391, -5376,  4490, -5376, -5376,  4670,  1778,
    4452,  2262,  1505,  2465, -1800,  -572, -3358,    -2,  1370, -5376,
    2442,   969,  9151, -5376, -1629, -1730, -5376, -5376,   -17, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,  2595,  2597,
   -5376, -5376,  4075, -5376,  2513, -3007, -5376, -5376,  -788, -5376,
   -2700, -5376, -5376, -5376,  2515, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376,  1932, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,  4019, -1744,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -1437, -5376, -3034, -5376, -5376, -5376, -5376, -5376, -3145,  -565,
   -5376,  4167, -5376,  4200, -1289, -1894,  3758, -5376,  4527, -5376,
   -5376, -5376, -5376, -5376, -5376,  3768, -5376, -2289, -5376, -2691,
    4533,  4534,  4536, -5376,  4538, -5376, -5376, -1879,   569, -5376,
     866, -5376, -5376, -5376, -5376, -5376,  1333, -5376,   124,   927,
     126, -4368, -1690,  1810, -5376, -5376, -1972,  3777,  4217, -1333,
   -5376,  2982, -5376,  3756,  1964, -5376,  2312, -5376,  1235,  1244,
   -5376, -5376,  1977, -5376, -5376, -5376, -5376,   669,   201, -5376,
   -5376, -5376,   554,   970, -2283, -5376,   683, -3504,  4537,  -147,
   -1237, -5376, -1385,  2326,   667,  5156,  -474, -5376, -5376,  4501,
   -5376, -2875, -5376, -2250, -1663,  -168, -3318, -4597, -3484, -5376,
   -1758, -5376, -5376, -5376, -5376, -5376,  1258, -5376, -5376, -5376,
    3016, -5376,  5432, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376,  -726, -1221, -5376, -5376,  2818, -2111,  -547,
    5455,  -366, -5376, -5376,  -359, -5376, -5376, -5376, -5376,  4311,
    3937, -5376,  2783, -5376, -5376, -5376, -5376,  2461, -5376, -5376,
     982, -1136,  2841,  2314, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376,   973, -5376,  1393, -2006, -5376, -5376, -5376, -5376,  -334,
   -5376, -5376, -5376,  1396, -5376,    34,  5262,  -333, -5376, -5376,
   -5376,  5084, -5376, -5376, -5376, -5376, -5376, -5376,  3628, -1544,
    5085, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,  3181,
   -5376, -5376, -5376, -5376, -5376, -5376,  4015,  5282,  -683, -1803,
   -5376, -1009,  3187,  2500,  -840, -5376, -5376, -5376,  4541,  5287,
   -5376, -5376,  5451, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376,  3135,   602, -5376, -5376, -5376, -5376, -5376,   701,
   -5376, -5376, -5376, -5376,  3907, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376,  4341, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,  1582,
     -89, -5376,   945,  -113, -5376,   649, -5376, -5376, -5376, -5376,
   -5376,  -145, -5376, -5376,  -150, -5376, -1415,  4944, -1391, -5376,
   -1845, -3624, -5376,     3, -5376, -5376, -5376,  3194, -5376, -5376,
   -5376, -5376,  1419, -5376, -5376, -2881,  -934, -1815, -2694,  4230,
   -5376, -5376, -5376,  -945,     0,   -12,  1656, -1290, -5376, -5376,
    2643,  3367,    37,  2554, -5376,  5019,   690,  -718,  -761, -1128,
   -5376,  7812, -5376, -5376, -5376, -5376, -5376,   229,  -589,  -586,
     187,  -657,    43,   203,    21, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
    2548, -5376, -5376, -5376,  1448, -5376,  5314, -5376,  3390, -1871,
    5319,  3269,  2577,  2582, -5376, -5376, -5376, -5376, -1804, -5376,
   -5376, -1874,   180, -5376,  3609, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376,  3924,  -577,  -570,  4109,  5326,  4827,
   -5376,  4385, -5376, -5376, -5376, -5376, -5376,  1811, -5376, -2134,
    2613, -1567, -2348, -5376, -5376,  3034,  1328, -5376, -5376,  1719,
   -5376,  2228, -2767, -3019, -5376,  2476, -3443, -5376, -5376,   612,
   -5376, -5376, -5376,  1748,    75,  5305,  4707, -5376, -5376, -5376,
   -5376,  5521, -5376, -5376,  1086,  5546,  5547,  5548,  -393, -5376,
   -3481, -5376, -4440, -5376, -5376, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -4473, -5376, -4709, -5376, -5376, -5376, -5376,
       5, -3929, -5376, -5376,  2434, -5376, -5376, -5376, -5376, -5376,
   -5376, -5376, -5376, -5376
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,   469,   753,  2100,   470,   471,   472,   473,   474,  2066,
     475,  1306,  2827,  1308,  2032,  2830,   476,   722,   477,  2234,
    3031,  3032,  4821,  4822,  4815,  4816,  4818,  4819,  3033,   839,
     840,   478,  2883,  4091,  3561,  2880,  5283,  2106,  4990,  2107,
    4991,  2876,  4106,  4658,  2113,  2887,  2114,  4656,  4657,  4649,
    4650,   761,  5008,  5295,  5614,  5888,  5764,  5474,  5475,  5476,
    5620,  5483,  5890,  5481,  5889,  5477,  5760,  5972,  5758,  5971,
    5478,  5298,  5299,  5479,  4092,  3644,  3645,  5833,  1365,  3556,
    3653,  3654,  2890,  4647,  4801,  5557,  4805,  5704,  5831,  5632,
    3681,  5174,  5558,  5559,   654,  1377,  5498,  5499,  2195,  5315,
    5305,  4099,  4100,  4101,  3563,  3564,  5306,  2957,   479,   833,
    2225,  3688,  1481,  2226,  2227,  5018,  5019,  3738,  3739,  3740,
    5302,  5303,  5304,  5490,  4643,  5009,  4644,  5978,  4645,  2811,
     956,  2230,  2231,   855,   856,  1497,   857,   858,  2251,  1553,
    3095,  3096,  3097,  2306,   859,   860,   861,  2248,   862,  3117,
    3056,  4353,  4354,  4841,   863,  3767,  3768,  3769,  3121,  1178,
    3770,   480,   481,   675,   683,   676,  1175,  2687,  1176,   482,
     483,   720,  2056,  2057,  2058,  2059,  3526,  2846,  3520,  3521,
    4608,   864,   865,  2316,   957,   958,   484,   959,   655,  1676,
    2423,  3824,  4868,   960,   961,   962,   963,  1678,  2408,  2409,
     964,   965,   966,   967,   968,  5482,  3200,  3201,  3820,  3798,
    4378,  3202,  2419,   969,   970,   971,   972,  1679,   932,   933,
    3166,  4391,  4861,   973,   630,   835,   836,  2233,  3005,   837,
    3006,  3691,  4814,   838,  1482,  3001,  1484,  3828,   974,   975,
    2427,  2426,  3825,   705,   976,  1296,   636,  1496,  2015,  5629,
    5630,  5893,  6084,  2016,  3497,  4047,  4584,  4585,  4971,  3151,
     898,  1609,  2364,   977,  1287,  2803,  1184,  2695,  3829,   978,
    2429,  2431,  2428,  3827,  5574,  2430,   979,   665,   694,   653,
    1608,   681,  5013,  5312,   810,   811,   847,  3054,   812,  1492,
    1453,  2201,  2983,  2984,  3659,  3660,  3727,  3728,  3729,  2975,
    2976,  2977,  3043,  3044,  3045,  2964,  2965,  2966,  2205,  2961,
    2962,   813,  1454,  1465,  2978,  2979,  2980,  3733,  3047,  3048,
    3049,  3050,  2981,  2354,  2982,  4162,  4631,  5006,  4632,  5291,
    3490,  5002,  5003,  4788,  5102,  3504,   489,   668,  1161,  1883,
    2679,  3975,  3389,  3391,  2680,  3974,  4519,  4520,  4521,  3387,
    3388,  5449,  3393,  3972,  5593,  5932,  5729,  5730,  3964,  5734,
    4528,  4943,  4944,  5261,  5450,  5599,  5853,  5735,  5939,  5851,
    5935,  5852,  5937,  6074,  6013,  6014,  5863,  5950,  5951,  6018,
    6075,  5745,  5746,  5747,  3968,  3969,  5446,  5470,  3551,  2189,
    2190,  5065,  1317,   490,  4633,  4268,  4634,  4635,  5110,  5756,
    4270,  4271,  4272,  3791,  1958,  5144,  5126,  4655,  5152,  4636,
    4994,  4995,  4996,  4997,  5658,  5790,  5660,  5661,  5787,  5905,
    5786,  4998,  4999,  5287,  5553,  5071,  4733,  4717,  4718,  4793,
    5160,  5389,  5555,  5551,  5680,  5681,  6062,  6063,  5697,  6005,
    5698,  6069,  6094,  6095,  5682,   491,   667,  1831,  5796,  5797,
    5798,  1555,  5390,  1556,  4342,  1557,  2275,  1558,  4344,  1559,
    1560,  1561,  1562,  1563,  1564,  1565,  1566,  1567,  1568,  3109,
    2264,  2265,  3070,  2257,  2258,  2256,  4831,  4829,  2326,  5699,
    5700,  3063,  2261,  2262,  3083,  5828,  5683,  5701,  5685,  4352,
    2277,  1914,  1915,  3595,  1928,  1929,  3074,  2717,  3075,  2193,
    2278,  2279,  3076,  3077,  3081,  4485,  5246,  4491,  4492,  4493,
    3922,  3923,  3924,  3925,  3926,  3345,  5686,  5159,  5550,  5670,
    5673,  5811,  5999,  5072,  4719,  5075,  1272,   762,  4720,  4721,
    5955,  5871,  5878,  5956,  5879,  5872,  5529,  4088,  5957,  5958,
    5959,  5881,  5874,  4623,  5462,  5463,  5060,  3087,   492,   572,
    3679,  1440,  1442,  1452,  3685,  2992,  2991,  1458,  1457,  2970,
    4707,  5058,  4213,  3682,  4287,  5397,   796,  4273,  5541,  5362,
    5548,  4274,  4974,  4275,  5521,  5651,  4276,  5382,  5546,  5668,
    4975,  4976,  4277,  4278,  4279,  5963,  5964,  5965,  4722,  1638,
     816,   817,  1470,  1471,  1472,  3146,  5157,  4745,   493,  2868,
    2863,   494,  1334,  1335,  1336,  2078,  2079,  2866,  2867,  3546,
    4077,   495,  1300,  2822,  2068,  2855,   496,  1320,  3537,  3538,
    3539,  4072,   497,  1478,  2221,  2222,  2996,  4294,  4813,  5178,
    5404,  5565,  5400,  5711,  5712,   498,   843,  1488,   499,   632,
    2243,  2244,  2245,  3035,   500,  1689,   580,   501,  1182,  1889,
    1892,  1893,   502,  1299,  2018,  2019,  2020,  2021,  3500,   503,
    2396,  3170,  3171,  3172,  3173,  2817,  4048,  2818,  2819,  3509,
    4398,   504,   776,  1437,   505,   775,  1436,   506,   507,   693,
     748,   685,  1901,   509,   510,  3491,  2467,   512,   782,   780,
    1123,   514,  1430,  1426,   515,  2468,  1124,   772,   773,  1384,
    1204,  3580,  3581,  2338,  2339,  2922,  2909,  1205,  1206,  1410,
    2171,  2934,  2706,  2707,  1999,  2708,  3989,  5623,  4541,  6002,
    1710,  1619,  1304,  1126,  1127,  1128,  1843,  1844,  1859,  1129,
    1853,  2630,  4457,  4906,  4907,  4908,  4909,  5237,  2553,  2554,
    2674,  1130,  2539,  2540,  2541,  1131,  1132,  1133,  1134,  1135,
    1136,  1137,  2532,  2533,  2534,  1138,  1139,  1140,  1141,  2669,
    4439,  4440,  4888,  3382,  3383,  3384,  1142,  3227,  4425,  3238,
    1143,  1144,  1145,  1146,  1147,  3949,  1148,  4509,  4140,  1149,
    1837,  2616,  2494,  4880,  4430,  5217,  5221,  5222,  5223,  5424,
    2435,  3215,  3852,  4871,  4873,  4874,  3853,  3854,  3950,  3951,
    1731,  1732,  1699,  1700,  1385,  1386,  1387,  1388,  1389,  4124,
    4125,  5024,  4662,  5026,  4666,  2136,  2137,  2140,  2141,  1390,
    1391,  1392,  1393,  2124,  1394,  1395,  1396,  2914,  5507,  5032,
    5033,  5643,  5642,  5034,  4671,  4672,  4128,  4129,  4588,  4589,
    4590,  3591,  2490,  2491,  2567,  2401,  2402,  2403,  2436,  1404,
    2151,  2930,  3601,  2153,  3599,  4135,  3603,  4141,  4142,  2661,
    3372,  3945,  3374,  4933,  5253,  5254,  5441,  5582,  5583,  5588,
    4282,  5096,  5097,  3131,  1411,  2942,  3613,  4138,  1960,  1961,
    1962,  2161,  3606,  3607,  3785,  1413,  1414,  1424,  1429,  1417,
    1415,  3122,  4703,  3123,  3927,  3909,  4980,  4163,  2459,  2460,
    5101,  4916,  1418,  2943,  4149,  4150,  4151,  1400,  1401,  2146,
    2147,  2148,  1419,  1402,  2923,  4131,   516,   715,   517,  2361,
     883,  1605,  2360,  3517,  1490,  2809,  2333,  2334,  1592,   805,
     652,   518,   656,  3167,   519,   697,  2808,   937,  1291,  2011,
    2012,  2013,  3492,  4043,  3493,  4036,  4037,  3494,  1285,  4580,
    4581,  3141,  4176,  4177,  4171,  2802,  3481,  1286,  2003,  4029,
    2799,  4030,  2800,  2832,  4031,  4393,  5207,  5716,  2796,   520,
     691,  4567,  4023,  4024,  5839,  5840,  1283,   521,   637,  2332,
     879,  1581,  1584,  1585,  2342,  3127,  4372,  1586,  1587,  3129,
     880,   881,   522,   736,  3547,  4080,  1340,  1982,  1983,  1984,
    2783,   523,   688,  1273,  4018,  4564,  2769,   671,  1603,  1965,
    1276,  1966,  2765,  3465,  1949,   524,  1434,  1433,   831,   525,
     526,   788,   581,  2175,   527,  1309,  2049,  2844,  4055,  4056,
    4593,  2050,  2051,  3518,   528,   701,  1293,  3514,  4981,  4982,
    5280,   529,   727,  1324,  1325,  2072,  2070,  3542,  2858,   530,
    2681,   531,   657,   940,  1641,  1642,  2394,   532,   730,  1329,
     533,   534,   942,  4399,  5842,  6008,   661,  2398,  1646,  5292,
    4674,  5039,  5040,  5042,  5339,  5340,  6071,  6115,  6126,  6119,
    6129,  6130,  6133,  6139,  6140,  1150,  1347,  1348,  1151,  5801,
    1152,  1153,  1154,  2469,  1289,   696,  2006,  2007,  3486,  2806,
    3484,  2008,  4038,  4039,  3414,  3600,  1155,  4025,  5061,  1491,
    2335,  1312,   536,  1156,   619,   807,  1349,  2143,  3178,  1224,
    3440,  1158,   867,  3830,   980,   981,  1448,  1890,  2210,  2211,
    3179,   621,  1655,  3441,   868,  1226,   539,   622,   623,   624,
     625,   626,   627,   628,   629,   545,   687,  1208,  2713,   546,
    1438,  2944,  3510,  1905,  1234,  1934,  1923,  1933,  2739,  3452,
    2742,  3453,  3454,  4556,  4011,  4557,  4012,  1279,  2734,  1906,
    4013,  2727,  2728,  2729,  2730,  4002,  1920,  2723,  2186,   547,
     943,  2407,   664,  1648,  1649,  3191,   548,   690,   549,   721,
    1314,  2851,  3530,  3531,  4068,  4610,  4069,   550,  1189,  1190,
     551,   926,  3554,  3157,  2350,  1451,  2351,  2378,   929,  1611,
     930,   931,  1625,  1622,  1628,  1624,  4203,  3674,  3675,  3162,
    2358,  2212,  2700,  3667,  4693,  2213,  4197,  4198,  4694,  2368,
    3153,  3154,  2989,  5414,  4210,  3678,  5201,  4382,  5415,  5416,
     552,   702,   553,  5307,   714,  1303,  2029,   554,   555,   556,
     557,   781,  1422,  1207,   573,   574,   575,   576,   820,   821,
    3684,  4289,  4808,  4809,  5399,  6122,  6123,  2889,  4104,  5773,
    6085,  6116,  6135,  5016,  5017,  5316,  5497,  3566,  4103,  5308,
    6079,  4097,   558,  1354,  1350,   747,  2098,  2092,  2094,  2874,
    3550,   559,   560,   561
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     537,   819,   666,   535,   749,  1275,  2602,  1361,  1222,  1271,
    1554,  1362,  1363,   511,   825,  2284,  2163,  2518,  2285,  2176,
    2694,   544,  2162,  3057,   815,  2656,  2833,  1673,   485,   798,
    1230,   508,   802,  1989,  1383,  2500,   486,   538,   487,   488,
    1450,  3124,  2689,   542,  2344,  2466,  2458,   870,  2998,  3752,
     871,  2268,  3206,  1891,  3110,  1183,  3990,  3132,   706,  2288,
    3111,  3614,  2740,   684,   709,  2373,  3831,  3832,  3810,  4280,
    1602,  3508,  2154,  4281,   513,  2297,  1734,   927,  2355,  1916,
    1919,  1921,  2325,  1449,   928,  2303,  2191,  1733,  1931,  2850,
    4321,   882,  2119,   885,   886,   887,   888,   889,  1228,   891,
     892,  1229,  4624,   894,   895,  2295,  2317,   927,  2795,  2144,
    4147,  3555,  1331,  2192,  1191,  1338,  3505,  2724,  1489,  2087,
    4027,  1774,  4375,  4669,  2307,  2308,  2309,  2736,  4343,  2311,
    2641,  2642,  2643,  2644,  2645,  2646,  2647,  2649,  2651,  2652,
    2653,  2654,  2655,  2688,  2323,  4164,  4017,  2756,  2757,   718,
    1305,  2763,  4405,  5010,  2845,  3192,  2255,  5022,  2260,  4349,
    2266,  4130,  2266,  1499,  2945,  4638,  2967,  3797,  2776,  3662,
    2266,  4164,  4164,  3583,  3519,  4076,  1836,  2292,  4345,  2255,
    3734,  4346,  4347,  5021,  4351,  4153,  2266,   541,  4833,  3735,
    1341,  1342,  3857,  2789,  2790,  1693,  2266,  4269,  3078,  5163,
    2304,  3207,  3423,   543,  4291,  2310,   826,  3582,  3582,  2689,
     680,  3046,  4637,  2871,  3663,   827,  2621,  2266,  2255,  2255,
    2321,  2322,   828,  4741,  2629,  2631,  3587,  2634,  2635,   540,
    4714,  4715,  3954,  3957,  3958,  4716,  4811,  4164,  4164,  3731,
    4723,  3163,  4725,  3164,  3165,  4735,  3204,   829,   830,  4095,
    3099,  2340,  2843,  5402,  1673,  2918,  3144,  2223,  2437,  2438,
    1838,  1839,  1431,  1991,  4742,  4095,  3034,  2448,   870,   711,
     870,   871,  2416,   871,  4169,  2399,  5170,   731,  4770,  1838,
    1839,  3342,  2269,  2451,  3732,  2286,  1838,  1839,  5938,  3658,
    2399,  1918,  2290,  1838,  1839,  5099,  1626,  3724, -2996,  2508,
    5028,  2511,  3906,  1838,  1839,  4487,   734,  2298,  1428, -2996,
    2688,  1950,  5321,  3966, -3393,  2452,  2524,  2525,  2527, -2482,
    1838,  1839,   726,  1209,  5104,  2528,  2529,  1827,  1829,  1830,
    2451,  2453,  2545,  4102,  2399,  1838,  1839,  1593,  3664,  3118,
    2990,  1873,  2188,  3188, -2076,  1838,  1839,  4429,  3118,  1606,
    1607,  1594,  1595,  1596,  1597, -2076,   794,  4071,  4488,  2987,
     707, -1249,  2452, -3376,  4096,  2060,  1838,  1839,  3118,   794,
    5177,  5106, -1249,  1375,  5122,  2454, -2482,  4333,  2453,  3272,
    4096,  5455,  -497,  4306,  2187,  3118,  5108,  2276,  2276,  2283,
    3778,  2276,  2287,  -497,  1912,  5131,  3631,   669,  2276,  2291,
    5896,  3385,  3189,  2455,  2276,  2294,  2270,  2280,  2280,  1956,
     777,  2280,  2259,  1427,  4173,  3118,  1838,  1839,  2280,  4132,
    4133,  1209,  2454,  2271,  2280,  3582,  4189,  4190,  5005,  1476,
    3118,  1990,   728,  1838,  1839,  1840,  1912,  1841, -2777,  3118,
    1838,  1839,  5076,  1630,  4691,  4292,  4014,  3118,   778, -3380,
    2455,  3145,  3908,  1209,  1840,  4175,  1841,  1838,  1839,  5300,
    2399,  1840,  2164,  1841,  4194,  1838,  1839,  5380,  1840,  4202,
    1841,  4550,  5725,  3814,   707, -2076,  2357,  1681,  1840, -3379,
    1841,  1884,  4487,  5995,  1838,  1839,  1912,  1838,  1839, -2482,
     673,   658,  4327,  4328,  4913,  1840,  2025,  1841, -3377, -3378,
    2456,  2372, -2996,  4226, -2681,  1838,  1839,  5011,  3477,  5923,
    1840,  3144,  1841,  3118,  1838,  1839,  5827,  5366, -3313,  4053,
    1840,  3495,  1841,  4743,  1838,  1839,  4109,  1838,  1839, -3313,
    2675,  1209, -2687,  2946, -2076,  4488,  2878, -2482, -3383,  1838,
    1839,  1840,   750,  1841, -2482,  5545,  3118,  2456,   793,  1838,
    1839,  1952,  4193,  4078,  1842, -2482,  1838,  1839,  3212,  5649,
    3356,  3225,  3118, -2076,  1838,  1839,   508,  3408,  3409,  3410,
    3411, -2688, -2482,  1842,  2023,  5314,  4835,  1838,  1839, -3313,
    1842,  1838,  1839,  4700,   535,  1369,  1639,  1842,  1860,  4016,
   -3314,  1840,  4296,  1841,   511,  2216,  2676,  1842,  1838,  1839,
    4651, -3314,  4517,  5409,   779,   884,  5769,  3540,  1840,   513,
    1841,  3665,   508,  5979,  1842,  1840,  2104,  1841,  2105,   841,
    2272,  2108,  2109,  2111,  2112,  4648,  1838,  1839,  1412,  1842,
    4107,  2864,  1840,  1412,  1841,  1412,   866,  5795,  1912,  1842,
    1840,  1963,  1841,   848,  1248,  1383,  1985,  1838,  1839,  4524,
    3357, -3314,  1845,   537,   749,   513,   893,   874,  4209,  1840,
    1842,  1841,  1840,   678,  1841,  2096,  4652,  1157,  1846,  3488,
    1443,  1964,  2217,    34,   544,  2872,  4110,  2969,  5996,   873,
    1840,  4914,  1841,  3605,  1861,  2865, -2076,  1223,  1278,  1840,
     899,  1841,  5997,   804,  1157,   818,   542,  1847,  5535,  1840,
    5664,  1841,  1840,  1848,  1841,  2026,  3145,  1435,  1233,  1181,
    1842,  3103,  1318, -2777,  1840,  1157,  1841,  4692,  2272,  1782,
     841,  5566,  3052,   841,  1840,  4054,  1841,  1842,    41,  5465,
    1231,  1840, -2076,  1841,  1842, -3313,  2273,  1885,  1812,  1840,
    1849,  1841,  1248,  5827,  3156,  1631,  5650,  3358,  2209,  5055,
    5486,  1842,  1840,  1816,  1841,  4653,  1840,  1682,  1841,  1842,
     824,  4015,  2235,  5726,  3343,    34,  4114,  6146,  2711,  1734,
    2698,  2318,   659,  1840,  1248,  1841,  2349,  1295,  1842, -2836,
    2464,  1842,   698,  4195,  2502,  1734,  5301,  4269,  6041,  2735,
    2719,  5353,  3478,  5049,  4174, -2356,  1733,  5293, -2800,  1842,
   -2855,  1840,  2254,  1841,  3386,  4293,  4179, -3314,  1842, -2800,
    5056,  1640,   844,  4551,  5547, -3397,  5012,  2754,  1842,  4086,
      41,  1842,  1840,   872,  1841,  2355,  4016,  -707,  1838,  1839,
     875,    43,   897,  1842,  3223,  2191,  1157,  2904,  -707,   543,
     541,  3419,  4113,  1842,  3662,  1466,   982,  4164,  2919,  1468,
    1842,   537,  1248,  3763,  3734,  1425,   543,   866,  1842,  1569,
   -2856,  4865,  2192,  3735,  3553,   869,   825,  1953,   876,  4102,
    1281,  1842,   544,   708,  3088,  1842,  4905,  3582,   874,  2359,
    1573,  3088,   540,  5503,  2677,  5456,   631,  4362,  1495,  3663,
    1232,  4134,  1842,  4119,   542,   795, -2076,  4123,   670,  4531,
     873,  5934,  1572,  1827,  1829,  5603, -3393,  3418,  2422,  1913,
    2988,  3907,  3119,  3731,  2209,   699,  1227,   749,  3348,  3349,
    1842,  1600,  2270,  3823,  1604,  5137,  5776,  5777,  4489,  4257,
    2967,   732,  5727,  1157,  2030,  2668,  3190,  1209,  4381,  2271,
    2218,  1842,  1734, -3397,  1653,  2242,  1653,  1653,  1653,  3661,
    3593,  1913,  1653,  2690,  1653, -3376, -2800,  5504,  3732,  5505,
     735,   537,  2179,  2432,   535,  1659,  1951,  1659,  1659,  1659,
    4191,  5633,  1370,  1659,   511,  1659,  4329,  1838,  1839,   733,
    1627,  4826,   544,  1157,  3472,  2788,  2118,  1657,  1157,  1657,
    1657,  1657,   508,  3119, -2996,  1657,  2457,  1657,  1677,  4812,
    2242,  1913,  3119,  1840,   542,  1841,  4744,  3364,  3365,  3046,
    3368,  3369,  2274,  3195,  5619,  5998,  5403,  2400,  1157,  3730,
    3199,  3037,  3119,   927,  3803, -2482,  3352,  5635,  1157,  5636,
    5621,  3062,  2400,  3065,  2242,   513,  3585,  3586,   541,  3119,
   -2076, -3380,  3344,  6060,   872,  3666,  1571,  3759,  3760,  3226,
    -115,  4490,  -115,   686,   543,  3084,  3273, -1249,   826,  2347,
     543,  4166,  1427,  4866,  3239,  3089,  3240,   827, -2076,  3119,
    3252, -3379, -2857,  3255,   828,  5728,  2400,  3094,  -497,  4786,
     540,  3241,  2678,  3242,  3119,  4689,   869,  2658,  1570,  3267,
   -3377, -3378,  4016,  3119,  3928,  3113,  3329,  1358,  3330,   829,
     830,  3119,  4825,  4152, -2687,  4489,  3340,  3285,  3341,  1734,
    2274,  2760,  4396,  2762,  4079,  1157,  1157,  1157,  1157,  2633,
    2690,  1834,  1842,  3064,   660,  2771,  5294,  3237,  2774,  1157,
   -3383,  1656,  2777,  1656,  1656,  1656,  1912,  2445,  2699,  1656,
    3616,  1656,  5317, -2688,  3855, -3397,  3856,  1658,   541,  1658,
    1658,  1658,  1840,  1913,  1841,  1658,  4836,  1658,   633,  2792,
    2793,  2794,  2276,  3085,   543,  4714,  4715,  3119,  2097,  5560,
    4716,  5043,  1912,  4108,  5046,  4735,  4280,  5023, -3496,  2611,
    4281,  1449,  2280,  5410,  2276,  3100,  5770,  2276,  3101,  2745,
     540,  4704,  1832,  5980,  3937,  3104,  3938,  3359,  2276,  3112,
    3119,  4435,  2400,  4436,  2280,  5567,  2547,  2280,  2775,   468,
    3668,  -119,  4962,  -119, -3313,  2936,  3119,  2988,  2280,  4111,
    3231,  2562,  5918,  1783,  2570,  4654,  2572,  -111,  3232,  -111,
    2576,  2577,  2578,  5906,  2272,  5908,  5909, -2356,  2584,  5057,
    3786,  5138,  1813,  5139,  4987,  4461,  2254,  4462,  4463,  4087,
    4464,  1449,  2273,  4675,   841,  4179,   841,  1817,  1248,   809,
     749,  5945,  5946,   662,  3169,  4678,  1383,  2622,  3243,  5301,
    1813,  1842,  6042,  3983,  3794,  4503,   707,  4504,  5140,  1869,
    1870,  1871,  1872, -2356,  2259,  2027, -3314,  3244,  3128,  1412,
    3245,  3999,  3908,  3908, -2836,  2820,  3908,  3908,  4081,  2064,
    3254,   468,  3908,  3908,  4269,   577,  1157,  5141,  1469,  2052,
    3258,   700,  4164,  3394,  3669, -2855,  1838,  1839, -2836,  3247,
    3224,  5047,  2030,   878,  1850,  1851,  1852,  3257,   875,  5775,
    2089,   927,  6003,  4702, -2705,  1838,  1839,  3140,  2714, -2855,
    3259,  5259,  3260,  2856,   925,  2081,  5391,  5986,  5987,  1838,
    1839,  5990,   703,   704,  1838,  1839,  5296,  2623,  2881,  2882,
    4211,  3263,  2885,  1838,  1839,  4620,   876,  2892,  2893,  2894,
    6031,  4936,  4779,  4284,   925, -2856,   662,  3662,  2968,  5494,
    2720,  4659,  4660,  1578,  1834,  2209,  3519,  4865,   662,  3264,
    1383,  1967,  2102,  2103,  1693,  3797,  3067,  2441,  1298, -2856,
    4184,  1383,  1383,   938,  2747,  2748,  4343,  2750,  2751,  2752,
    3271,  2988,  1315,  5202,  5203,  5204,  3582,  3582,  2761,  5784,
     662,  3068,  3663,  3051,  1644,  4910,  2840, -2036,  4884,  4663,
    4664,  2798,  6049,  2773,  5113,  6124,   535,  4349,  1157,  1838,
    1839,  2969,  3670,  5142, -2535,  4300,   511,  4302,  4303,   662,
    5128,  5129,  2859,  4308,  2624,  1832,  4345, -3221,  3734,  4346,
    4347,  4316,  4351,  6066,   508,  2821,  4323,  3735,  1838,  1839,
    3361,   634,  4734, -2774,  5768,  1854,  6039,  1398,  1986,  5143,
    1157,  4621,  1157,  6038,    34,  5561,   719, -2800,  4356,  2053,
    4358,  1840,  4780,  1841, -2800, -2800,   695,  3976,  2758,  1302,
    2069,  -423,  3487,  3488,  1425,  5029,  4051,   513,  4803,  2299,
    1840,  4295,  1841,  1477,  2947,  4804,  3671,  3731,  2082,  3871,
    3052,  6125,  2191,  -707,  1840,   927,  1841,  2945,  2725,  1840,
    3737,  1841, -2535,  1838,  1839, -2772,  5419,   710,  1840,    41,
    1841,  2888,  2891,  5657,  2163,  5659,  3469,  2163,  2163,  2192,
      43,  5063,  2689,  3609,  3610,  1499,   849,   850,  3669,  6067,
    1734,  3251,  3732,  3398,  3399,  5484, -2775,  6082,  5634,  5064,
    5554,  3250,   577,  2563, -2773,  2564,   766,  2886,  4222,  3422,
    1838,  1839,  1601,  3424,  4794,  1855, -2535, -2857,  3801,  4866,
    6102,  3283,  3788,  6004,  5374,  2967, -2036,   934,   713,    34,
    1856,  3450,  5297,  3489,  3290,  3002,  4885,  3574,   939, -2705,
    1842, -2857,  6068,  3575,  1840,  5627,  1841,  2442,  3996,  4318,
    4855,  4856,  4857,  4858,  3661,  4212,  2274,  2028,   579,  1842,
    2242,   703,   704,  5562,  3147,  3148,  4536,  4537,  4538,  4539,
    1157,  4285,  1157,  1842,  3672,  3395,  4008,  4403,  1842,  5363,
     896,  1913,  1645,  2688,    41,  3336,  3965,  1842,  1579,  1838,
    1839, -1481,   822,  4622,  5803,    43,  6035,  6036,   635,  3353,
    4022,  5788,  4040,  5260,  5030,  2710,  5413,  1857,  1157,   877,
    3943,  3944,  5994,  5759,  5761,  2721,  3670,  1913,  3046,  2466,
    1987,  1157,  1157,  3730,  3814,   663,  1282,  1157,  5540,  2722,
    1399,  1157,  1157,  1157,  3673,  4000,  4050,  1968,  1840,  5501,
    1841,  4006,  1157,  1157,  5422,  1838,  1839,  4016,  1157,  5355,
    1157,  1157,  1157,  1157,  1157, -2356,  1157,  1834, -3221,  3970,
    3787,  4001,  3936,  1842,  3939,  2973,  3149,  1157,  5689,  1157,
    3291,  5484,  1157,  1157,  3184,  1157,  1157,  1157, -2774,  1157,
    1157,  5444,  3534,  1838,  1839,  1840,  5412,  1841,  4233,  1326,
   -2036,  5205,  1842,  3415,  1157,  1157,  1157,  1157,  1157,  2300,
    1157,  1157,  1157,  2223,  3069,  1157,  1157,  1157,  1157,  1157,
    1157,  1157,  2973,  1157,  1157,  1157,  1157,  4319,  1157,  1157,
     513,  1157,  1157,  1157,  1157,  1157,  1157,  1157,  1832,  2726,
    1157,  1157,  1157,  1157,  1183,  1157,  1157,  1157,   663,  1157,
   -2772,  1157,  3181,  1157,  2759,  3182,  5472,  1157,  1157,  1157,
     663,   878,  1157,  1157,  1157,  1157,  1157,  1842,  1157,  5782,
    2626,  1838,  1839,  2404,  1840,  1157,  1841,   870,  5031,   679,
     871, -2775,  1157,  1157,  1157,  1157,   578,  2612,   935, -2773,
    4115,  2129,   663,  1157,  1157,  1379,  1157,  1157,  1838,  1839,
    1157,  1157,  1157,  1157,  1157,  1157,  1157,  1157,  1157,  1157,
    1157,  1157,  1157,  2682,  1842,  1157,  5807,  4016,  2963,  4343,
    2565,   663,  3496,  2566,  5480,  3815,  5533,  4366,  3672,  4320,
    1840,   842,  1841,  4016,  4016,   579,  5915,  1838,  1839,  2314,
    5675,  2060,  3367,  2060,  2625,  1917,  2938,  1922,   513,   936,
    4349,  1925,  1930,  1838,  1839,  4374,  1157,  1838,  1839,  3461,
    2067,  1157,  3535,  3462,  5430,  2963,  2130,  2974,  1840,  4345,
    1841,  1157,  4346,  4347,  4794,  4351,  3467,  2131,  1838,  1839,
    1908,  1959,  2951,  5576,  2132,   -72,  3064,  1290,  5155,  3474,
    3475,   852,   853,  1842,  4697,  4698,  4699,  1838,  1839,  5606,
    2778,  1838,  1839,  1706,  1707,  1708,  2062,   723,  6022,  6023,
    5086,  1406,  5074,  5074,  2974,  2973,  2133,  2129,  1838,  1839,
    5530,  1838,  1839,  4368,  1838,  1839,   751, -1136,  1591, -1136,
    2164,  4136,  4156,  2164,  2164,  3611,  5677,  5218,  1157,  1420,
    5526,    16,    17,  5531,  5532,  2405,  1840,  5808,  1841,  1842,
    6096,  5767,  2352,  3506,  5722,  3793,  2188,  5771,  1838,  1839,
     468,  1759,  4570,  1860,  1408,  2959,   771,  5884,  3507,  5886,
    1157,  5724,  1157,  1840,   841,  1841,  6109,  2134,  1838,  1839,
     777,  2406,  3536,  5161,  4137,   724,  3350,  1842,  4817,  4820,
    5534,  4823,  2130,  5255,  4569,    16,    17,  4326,  1838,  1839,
     841,  1421,  5473,  2131,  5480,  4098,  1157,  5156,  2135,  4157,
    2132,  5719,  1840,  1673,  1841,  2236,  2315,  3446,   778,  3293,
    1444,  1909,  5405,  1838,  1839,  5809,  5936,  5199,  1840,  5940,
    1841,  2150,  1840, -1481,  1841,  1994,  4794,  3381,  3296,  4204,
    4205,  2404,  2133,  4206,  4207,  4208,  2969,  5678,  1416,  2939,
    1838,  1839,  3297,  1840,  5916,  1841,  2063,  3298,  2963,  1861,
     927,   703,   704,  1838,  1839,  1842,  3299,  3404,  1858,  3533,
    1269,  2960,  1840, -2796,  1841,   468,  1840,  1862,  1841,  4021,
    3567,  5684,  2968,  3568, -2796,  3443,  5577,  3573,  3444,  2670,
    2352,  1157,  1842,  1840,  1459,  1841,  1840,  3661,  1841,  1840,
    1383,  1841,  5586,  2134,  5897,  5898,  1383,  2974,   749,  5910,
    5911,  5654,  1838,  1839,  4192,  5953,  1947,  3482,  4869,  5589,
    1460,  1383,  1157,  2671,  2404,  2353,  4947,  4948,  4546,  4547,
    2731,  1842,  2972,  1840,  2135,  1841,  2932,  4070,  2191,  3052,
    5309,  1343,  3302,  4555,  3737,  1838,  1839,  1842,   703,   704,
    4095,  1842,  3457,  1840,   752,  1841,   777,  2163,  5081,  3515,
    1673,  3051,  1461,  4915,  3460,  2192, -1541,   577,  4582,  2732,
    5594,  3736,  1842,  1840,   779,  1841,  1838,  1839,  4367,  4387,
    4388,  4389,  4390,  4348,  3594,  4928,  4350,  6072,  5876,  1445,
    2963,  1842,  6120,  2374,   778,  1842,  3427,  5310,  1840,  2672,
    1841,    16,    17,  1838,  1839,  5869,  2375,  1446,  1838,  1839,
    2209,  5815,  1842,  2405, -1541,  1842,  5148,  2357,  1842, -1541,
    3992,  3993,  5329,  4799,  5330,  1840,  1376,  1841,  1344,  1345,
     925, -2796,  3534,  3995,  2000,  4118,  3320,  3730,  1840,  4122,
    1841,  2766,  1838,  1839,  4007,   537,     9,  1343, -1136,  1838,
    1839,  4502,  1842,  4505,  1157,  1157,  1838,  1839, -1541,  5869,
     754,  1462,  5074,  2353,  2376,  4096,   544,  6000,  1371,  5845,
    1995,  1947,  1842,  1948,  2237,  4164,  2637,  2352,   565,  4357,
    2673,  1372,  3098,  3325,  1493,  2767,  2001,  1840,   542,  1841,
    5617,  3562,  1842,  3565,  2325,  6029,  2405,  5600,  6028,  3570,
    3572,  1463,  6037,    19,  1838,  1839,  6055,  4016,  2933,  3614,
    1838,  1839,  4705,  3363,  4164,  4164,  1321,  1842,  5870,  4800,
    1840,   800,  1841,  4411,  5359,  2733,  5361,   818,  1599,  5364,
    3920,  1157,  2242,  2163,  1344,  1345,  5369,  5370,  1383,  4370,
    6121,  3177,  4734,  4016,  1842,  3921,  1838,  1839,  1373,  1157,
     779,  1840,  -260,  1841,  4409,  4410,  2197,  1842,  5311,  2238,
    3261,  2239,  3187,  4416,  1996,  4417,   866,  4419,   537,  3428,
    5718,  1157,  5870,  1157,  1591,  3959,  4794,  2209,  1840,  1997,
    1841,  1157,  1157,  1840,  3185,  1841,  2638,   874,  1346,   544,
    5868,   737,  1734,  4373,  5846,  1269,   707, -2297,  5595,  5596,
    3942,  2639,  3535,  2690,  1322,   899,  1842,  1838,  1839,   873,
    2236,   542,  1838,  1839,   703,   704,    34,  1840,  3328,  1841,
    2768,  6056,  3235,  4164,  1840, -2297,  1841,  1332,  1948,  5617,
    5100,  1840,   541,  1841,  2266,  5656,  5105,  5107,  5109,  1842,
    4415,  6107,  6108,  5114,  5115,  4706,  4420,   801,   543,  5120,
    2353,  2240,  2377,  3646,  2110,  5762,  3335,  5127,  1323,  1838,
    1839,  5132,   804,  2434,    39,  5869,  -923,  2617,  5100,   738,
    1842,    41,  5146,  5100,   540,  1157,  1157,  1157,  2640,  1840,
    5575,  1841,    43,   513,  3246,  1840,  1912,  1841,  3523,  3524,
     579,  1838,  1839,  1673,  1757,  5231,  3246,  1842,  5161,    53,
    5597,  1374,  1842,   927,  2657,  5035,  4963,  5243,  5036,  5187,
    3790,  5360,  5190,   770,  5192,  1333,  1838,  1839,  5191,  2130,
    5193,  1840,  3536,  1841,  3576,  2447,  5123,  5372,  3183,  2241,
    2131,  5763,  1838,  1839,  3346,  4794,  1842,  2915,   925,  1838,
    1839,   771,  1316,  1842,  3186,  5954,  5212,  4175,  5213,  5214,
    1842,  1157,  5078,   872,  5080,   541,   803,  5083,  5639,   823,
    5087,  3833,  5968,  5090,  5091,  3525,  5381,  2242,  5383,   543,
    3180,   543,  1157,  5124,  5598,  1834,  1157,  1157,  5870,  1157,
    1157,  4469,  1840,  5337,  1841,  3982,  5640,  1840,  1157,  1841,
    1157,  1504,   832,  5251,  5338,   869,  5800,   540,  1842,  5130,
    4433,   834,  3858,  2164,  1842,  2434,  3773,  4794,  5037,  4470,
    2301,  5538,  2302,  3863,  5252,  3132,  4434,  4893,  3284,   707,
    3350,  1157,  1838,  1839,  5800,  3079,  4955,  2434,  1449,  4894,
    2916,  5209,  1838,  1839,  1840,  1157,  1841,  3446,  3774,  6024,
    1842,  4447,  2271,  5641,  5125,  5067,  1832,  2896,  1157,  4895,
    2434,  1157,  1867,  1868,  1869,  1870,  1871,  1872,  1854,   845,
    4449,  2135,  3439,  5487,  4477,   846,  1840,  2507,  1841,  2237,
    5488,  3897,  1838,  1839,  3438,  1157,  4876,  4877,  1838,  1839,
    2434,  4478,  3287,  4896,  3458,  2847, -1170,  5225,   890,  2510,
    5038,  1840,  3463,  1841,  2242,  3448,   941,  1157,  3775,  1464,
    3905,  1842,  4040,  4892,  5068,  3443,  1842,  1840,  3444,  1841,
    1160,  2901,  2526,  2902,  1840,  1222,  1841,  1838,  1839,  3289,
    1162,  4563,  1838,  1839,  4917,  2875,  3776,   703,   704,  2206,
    2207,  6150,   925,  5925,  2879,  5489,  -805,  1230,  1157,  3292,
    1838,  1839,  2544,  1838,  1839,  3466,  1879,  2968,  3737,  2949,
    1838,  1839,  1177,  1842,  2238,  3967,  2239,  4854,   672,  3300,
    5674,  4921, -2796,  2247,  1838,  1839,  5648,   841,  1855, -2796,
   -2796,  1282,  4897,  4611,  1888,  2924,  1838,  1839,  4363,  2164,
    3119,  3532,  2052,  1856,  3301,  1842,  1838,  1839,  1383,  4532,
    3578, -2529,  1383, -2529,  3579,  2950,  3379,  1840,  3248,  1841,
    2505,  1838,  1839,  1193,  3380,  1228,  4945,  1840,  1229,  1841,
    1842,  3305,  1838,  1839,   703,   704,  5069,  1838,  1839,  1284,
    1838,  1839,   513,  3777,  3306,  1301,  1842,  1179,  2958,  4568,
    4341,  1297, -2484,  1842,  5675,  1185,  2951,  1838,  1839,  4898,
    3051,  1280,   749,  1358,  4964,  3736,  2240,  1840,  4028,  1841,
    1838,  1839,  1302,  1840,  3379,  1841,  4059,  3058,  1838,  1839,
    1857,  3445,  4951,  1307,  5098,  1194,  2905,  4441,  1157,  1310,
    3647,  2906,  4817,  3310,  4820,  2907,  4823,  3447,  1838,  1839,
    3623,  1319,  1157,  2701,  1157,  1838,  1839,  3627,  3628, -2484,
    5070,  4060,  1840,   682,  1841,  1316,  2702,  1840,   689,  1841,
    4904,  2657,  1330,  3442,  5272,  1328,  3311,  1917,  6064,  6064,
     674,  4480,  5429,  5365,   674,  1840,  1842,  1841,  1840,   674,
    1841,  1337,  1838,  1839,  2241,  1840,  1842,  1841,  1838,  1839,
    5677,  4828,  4830,  4830,  3288,  4830,  2030,  3312,  5432,  1840,
    1157,  1841,  4728,  4828,  4828,  4830,  4830,  1353,  3294,  3059,
    3295,  1840,   468,  1841,  2376,  2908,  4899,  1339,  4900,  2952,
    5145,  1840,  3940,  1841,  3318,  5147,  1842,  1854,  6093,  3319,
     770,  2953,  1842,  4845,  4105,  1357,  1840,  3060,  1841,  1838,
    1839,  3648,  1359,  4148,  2293,  1383,  4545,  1840,  3649,  1841,
    1364,  3303,  1840,  2030,  1841,  1840,  3650,  1841,  4729,  1366,
    2005,  1913, -2484,  3323,  1367,  6050, -2297, -2297,  4872,  1368,
    3324,  1842,  1840,  2080,  1841,  1403,  1842,  3326,  2956,  2085,
    2086,  3506,  2956,  2319,  2320,  1840,  3058,  1841,  2209,  2209,
    2209,  2209,  1435,  1840,  1842,  1841,  3507,  1842,   777,  3979,
    3771,  5678,  1973,  2389,  1842,  1441,  1195,  1196, -1541,  1443,
   -2484,  1838,  1839,  2060,  2337,  2127,  1197, -2484,  1842,  4728,
    1840,  1456,  1841,  4448,  6087,  3333,  1473,  6089, -2484,  3651,
    1842,  3347,  1467,  2954,  3061,  1198,   778,  1855,  5176,  1474,
    1842,  1838,  1839,  3222,  3309, -2484,  2030,  4796,  5266,  5267,
     870,   818,  1856,   871,  4582,  1842, -1541,  1840,  3313,  1841,
    2030, -1541,  4730,  1840,  6106,  1841,  1842,  4428,  4901,  4902,
    -922,  1842,  2973,  1475,  1842,  4729,  1351,  1352,  3059,  1355,
    1937,  1356,  4565,   703,   704,  5873,  1483,  3314,  5880,  2030,
    3652,  1842,  3315,  2168,  2030,  5590,  2170,  2170,  3506,  4924,
   -1541,  1480,  2703,  4926,  1842,  2955,  3066,  4701,  3119,  1653,
    1653,  1653,  1842,  3507,  1840,  1157,  1841,  1487,  1157,  1001,
    3321,  1494,  2030,  2699,  2699,  2699,  2699,  1157,  4431,  1857,
    1659,  1659,  1659,  4432,  4958,  1574,  1157,  1406,  1157,  1842,
    1157,   513,  1157,  1157,  1157,  1157,  1157,  1157,  1575,  1157,
    5258,  1008,  1657,  1657,  1657,  1576,  5772,  1157, -2454,  1157,
    1860,  4061,  1157,  1157,  1157,  1577,  1449,  1449,  1449,  1449,
    1580,  1157,  1157,  1157,  1269,  1157,  1842,  1157,  1591,  1157,
    4437,  1157,  1842,  1157,  5717,  1407,  1840,  -922,  1841,  1610,
    1408,  1157,   779,  1157,  1612,  1157,  1157,  1157,  1157,  1157,
    4367,  1618,  1157,  3061,  1157,  1620,  5873,  1157,  4062,  1838,
    1839,  1020,  4442,  5880,  1621,  2963,  1840,  3746,  1841,  3749,
    1157,  1199,  4617,  1938,  1623,  1157,  4903,  4956,  1157,  1409,
    1157,  1157,  1157,  1842,  1629,  1157,  1939,  4443,  4711,  1032,
    1632,  1157,  3439,  2369,  2370,  1633,  1157,  2371,  1860,  3753,
    3755,  3754,  3754,  4444,  3438,  1157,  1861,  1634,  1838,  1839,
    4445,  1157,  1635,  1157,  2974,  1449,  1157,  1637,  3218,  1834,
     620,  1858,  4063,  4501,  1862,  3448,  1157,  1157,  1157,  1157,
    3757,  1157,  3758,  1643,  1383,  1383,  1157,   925,  5286,  5063,
    3381,   739,   740,  1674,  1940,   677,  1656,  1656,  1656,   677,
    3014,  3015,  2352,  1941,   677,  1842,  2657,   692,  3799,  5443,
    3800,  1694,  1658,  1658,  1658,  3027,  4064,  4952,  4953,  3821,
     537,  3822,  1157,   535,  1752,  5873,  5880,  1695,   741,  3039,
    1863,  1864,  1696,   511,   513,  1842,  1050,  5232,  1701,  1974,
    1832,   544,  5737,  4446,  1861,  1702,  4970, -2454,   485,  1703,
    1157,   508,  1798,  5377,  1223,  4711,   486,   538,   487,   488,
      16,    17,  1862,   542,  5219,   712,  5411,  1704,   742,  1838,
    1839,  1741,  1874,  2270, -2454,  1233,  5234,  4033,  5393,  4034,
    5236,  1157,  1705,  1975,  1840,  1976,  1841,  1709,  2281,  1756,
    2271,  4042,  1804,  4454,   513,  1760,  1761,  1231,  1654,  4460,
    1664,  1665,  1666,  3498,  2963,  1711,  1667,  4558,  1670,  3736,
    1157,  1712,  1157,  3029,  3030,  4126,  1713,  4127,  1863,  1864,
    1269,  4348,  1714,     4,  4350,  4639,   717,  1200,  1201,  1202,
    1203,  2963,   944,  1840,  1860,  1841,  5887,  1875,  4465,  4559,
    4832,  3445,  4834,  4466,  1878,  4187,  1860,  4188,  2266,  5569,
    1715,  4731,  4839,  4840,     8,  3281,  1942,  3447,  5098, -1895,
    4334,  4467,  4335, -1894,  4475,  1838,  1839,   513,  4837,  4838,
    4646,  4476,  4065,  4066,  4067,  2353,  4455,  1977,  3295,  1716,
    1157,   945,  1943,  3442,  4458,  4479,  2030,    14,  1876,  1717,
    5584,  2352,   946,  4468,  1718,  2030,  1697,  4483, -2484,  4560,
    1719,  1157,  3262,  1842,  4204,  4205,    18,   541,  4206,  4207,
    4208,  3657,  3040,  1838,  1839,  2150,  1877,  4472,  2352,  4473,
    1720,   947,  4496,   543,  2594,  2595,  1978,  4561,   948,  4165,
    1861,  1721,  1880,  5224,  4180,  4181,  4182,  4183,  5230,  4185,
    4186,  5239,  1861,  1722,  1840,    23,  1841,   743,  1862,   540,
    1346,  4806,  1842,  4807,  1723,  4165,  4165,  1232,  5240,  4732,
    1862,  4859,  1726,  4860,   744,  1736,  2209,  1737,  4731,  3041,
     949,  5244,  1860,  1882,  4930,  1979,  2030,  1738, -2704,  4283,
    1858,  1739,   725,  1227,  5181,  1742,  5182,  4304,  4305,   745,
    4307,  1157,  4309,  4310,  4311,  4312,  4313,  4314,  4315,  3885,
    4317,  5738,  1613,  4322,  1863,  1864,  5245,  4325,  5739,  1269,
    1743,  1860,  6027,  5183,    31,  5184,  1863,  1864,  3965,   950,
     951,  4165,  4165,  5740,  4562,  1838,  1839,  1744,  4438,   746,
    5751,  1745,   729,   952,  5754,  1886,  1269,  1838,  1839,  1569,
    1840,  1746,  1841,  5578,  1747,  1748, -2454,  2282,  1523,  5653,
    5185,  5226,  5186,  2030,  5241,  6044,  5242,  1749,   537,  1614,
    1573,  1750,  1615,  1842,  2353,  1980,  1751,  1753,  1861,  1838,
    1839,  4456,  1754,  2699,  2699,  3042,  4732,  3039,  1755,   544,
    4870,  1944,  1572,  1762,  1887,  2272,  1862,  1981,  1840,  1616,
    1841,  2353,    42,  1897,  5249,  3098,  2030,  1617,  1898,  3837,
    3630,   542,  5262,  2273,  5263,  1899,  5277,  1861,  5278,  1248,
    5288,  3887,  5289,  5328,  3838,  4127,  1449,  1449,  1900,  5459,
    1157,  4572,  3836,  3889,  1907,  1862,  1653,  3723,  1763,  1764,
     925,  2163,  3792,  1157,    75,  2259,  1157,  5425,  1765,  5715,
    3839,  5820,  1863,  1864,  5563,  1766,  5564,  1659,  1767,  1838,
    1839,  5741,  3840,  1935,  5604,   953,  5605,  1945,  1768,  1842,
    1157,  1157,  1769,  1770,  5742,  1946,  1771, -2738,  5608,  1657,
    5605,  4883,  3841,  5637,  1772,  4127,  5867,  1222,  5584,  2963,
    1775,  1863,  1864,  1776,  5743,  1157,  5638,  1157,  4127,  1157,
    1777,  1157,   791,  1778,  1838,  1839,  4459,  1779,  1780,  1230,
    1840,  5841,  1841,  5750,  3842,  5605,  3843,  1842,  1954,  5805,
    1157,  5806,  1840,  1917,  1841,  1917,  1781,  5509,  5510,  5836,
    5512,  5837, -2739,  5847,  6007,  5848,  1571,   954,  1784,   797,
     799,  1157,  1157,   799, -2703,  3272,   808,   814,  1157,  4931,
    1157,  1673,  1157,  1785,  1840,   541,  1841,  1157,  1866,  1867,
    1868,  1869,  1870,  1871,  1872,  1932,  5866,  2451,  4188,  1786,
    3040,   543,  5062,  5901,  1787,  5263,  2352,  1228,  1570,  1788,
    1229,  5073,  2129,  5985,  5989,  4979,  5605,  4542,  4075,  1789,
    3014,  3015, -2735,  5991,  2451,  5605,  5783,   540,  5992,  2452,
    5605,  1790,  1157,  1157,  4348,  3027,  6010,  4350,  6011,  4682,
    4683,  1791,   814,  4684,  4685,  2453,  3959,  1157,  1269,  4686,
    4687,  -949,  6019,  1656,  6020,   814,  2452,  3041,  6047,  1842,
    5605,   808, -2733,  5744,  1840,  2451,  1841,  1792,  1157,  1658,
    1793,  1842,  4158,  1794,  5690,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872, -2737,  6048,  1180,  5605,  2130,  5082,  2454,
    6051,   808,  5605,  1795,  1225,  4579,  1796,  2452,  2131,  1797,
    1799,  5691,  3844,  1842,  1955,  2132,  5007,  1294,   955,  1840,
    5849,  1841,  1800,  4158,  3845,   808,  4159,  2455,    16,    17,
    6054,  6088,  5263,  5605,  1269,  6137,  4640,  6138,  1313,   808,
    1801,  4283,  4283,  3029,  3030,  1802,  5644,  2133,  5645,  5646,
    1803,  1805,  1806,  1807,  4160,  1808,  1809,  1810,  1811,  4148,
      16,    17,  1814,  1815,  5841,  1818,   513,  4159, -2732,  1838,
    1839,  1360,  1819,  3042,  1157,  1820,  1821,  1822,  1823,  1824,
   -1170,  1825,  1881,  1407,  1157,  1936,  1969,   791,  3632,  2353,
    1970, -2736,  6149,  1842,  1971,  4160,  1157,  -924,  1157,  1972,
    4709, -2730, -2734,  1992,  1432,  5690,  1993,  1998,  2134,  2004,
    2010,  2017,  1439,  2470,  2471,  2472,  2473,  2030,   808,  2061,
    1455,   703,   704,  2071,  2456,  2077,  5692,  2274,  2073,  3846,
    5693,  3847,  5691,  5085,  2083,  2163,  2163,  2084,  1842,  2135,
     808,  5720,  5721,  2090,  2091,  2093,  2095,  5947,  2099,  1479,
    2115,  4161,  2116,  2117,  5674,  2127,  -924,  6015,  2138,  2139,
     756,   791,  2142,  1455,  2155,  2152,  2165,  2474,  2475,  2476,
    2166,  1865,  1866,  1867,  1868,  1869,  1870,  1871,  1872,  3506,
    2188,    16,    17,  1865,  1866,  1867,  1868,  1869,  1870,  1871,
    1872,  2187,  4161,  2194,  3507,  2198,  2200,  1588,  2203,  1590,
    2204, -1170,   799,   799,   799,   799,  1598,  1455,  2208,   808,
    2220,  2224,  2232,  2249,  2252,  2253,  4362,  4797,  5171,  4283,
    2254,  2477,  2478,  5690,  5194,  2263,  2267,  2164,  5675,  2289,
    2259,  2296,  2305, -3458,  1917,  2312,  2313,  2324,  -924,  2327,
    2329,  4709,   703,   704,  1840,  2331,  1841,  5692,  2337,  2341,
    5691,  5693,  5676,  6131,  2345,  2343,  2348,  2657,  1917,  2356,
     791,  5388,  1663,  2362,  2363,  2365,  2366,  6141,  -924,  2367,
    1668,  2388,  1671,  6131,  5354,  5674,  2397,  5357,  5358,  6141,
    3633,  4165,  3848,  2412,  5694,  2410,  2414,  1680,  6061,  2413,
    2973,  2415,  2479,  6015,  2417,  3771,  2418,  -924,  2421,    16,
      17,   756,  2420,  2425,  2434,  2433,  2443,  4196,   757,  1865,
    1866,  1867,  1868,  1869,  1870,  1871,  1872,  2450,  2461, -1170,
    3506,  2465,  2493,  2504,  5677,  2523,  3634,  3071,  1157,  2505,
    2949,  3039,  2506,  2515,  2519,  3507,  2522,   703,   704,  2549,
    2579,  2399,  -924,  2585,  2589,  2599,  2610,  3086,  2614,  5675,
    1867,  1868,  1869,  1870,  1871,  1872,  3091,  2636,  2632,  2664,
     703,   704,  3093,  1842,  2480,  5692,  2663,  2691,  2692,  5693,
    3102,  2129, -2076,  5676,  2693,  2697,  2950,  2696,  2705,  2712,
      16,    17,  3114,  1157,  1157,  3116,  1157,  2709,  2716,  2741,
    3849,  2743,  2744,  5674,  2764,  3726,  2779,  1157,  1157,  1157,
   -1170,  4710,  2781,  5695,  2782,  5694,  3635,  2780,  2784,  -924,
   -2076, -2309,  1157, -2076,  1157,  2785,  2786,  2951,  2801,  2804,
    2805, -2076,  2812, -2076,  2813,  2814,  2815,  1157,  1157,  2816,
   -2076,  2823,  2824,  2963, -2076,  5678,  4711,  1835,  2825,  3850,
    2834,   703,   704,  2835, -2076,  5677,  2130, -2076,  2836,   757,
    5826, -2076,  2837, -2076,  1157,  4542,  2838,  2131, -2076,  2839,
    2481,  2841,  3851,  2842,  2132, -2076,  1157,  5675,  3636,  2848,
    2849, -2076,  2852,  2853,  5674,  1157, -2076,  2857,  4949,  2862,
    2869,  2873,  2974,  -924,  2895,  2911,  2897,  3637,  3638,  2898,
    2899,  5676,  3639,  3640,  3641,  2900,  2133, -2076,   808,   791,
    2912,  2903,  5819,  2913,  2921,  2925,  1223,  2928,  2929,  4661,
   -2076,  2926,  2935,  2937,  3040, -2076,  2940,   638,  1157,  2941,
    2352,   870,  1157,  5694,   871,  1904,  2971,  1233,  2482,  2948,
    2994,  2995,   808, -2720,   808, -2076,  2986,  2999,   808,   808,
    2952,  3000,  2470,  2471,  2472,  2473,  3003,  3004,  5675,  1231,
    3036,  4986,  2953,  5525,  3053,  3055,  5678,  2134, -2076,  2318,
    3642,  3082,  3092,  5677,  3108,  3079,  3115, -2076,   808,  3125,
    3126,  3130,  5676,  3134,  3137,  1409,  3140,  4711,  3155,  3143,
    5705,  2164,  2164,   639,  3150,  4283,  3175,  3196,  2135, -2076,
    3214,  5626,  3197,  2483,  2129,  2484,  2474,  2475,  2476,   513,
    2485,  3216,  5696,  3217,  3219,  3229,  2009, -2076,  3228,  3643,
     791,  3230,  3233, -2076, -2076,  3236,   791,   791,  2024,  3234,
    2973,  3246,  3249,  3339,  3253,  3256,  3265, -2076,  3266, -2076,
    3268,  5050, -2076,  3304,  2065,  3269,  3270,  3274,  1269,  3282,
    3064,  3286,  3307,  2075,  5677,  6113,  3308,  3355,  3317,  4712,
    2477,  2478,  5079,  3327,  2954,  5930,   870,   791,  2088,   871,
     640,  3039, -1678,  3331,  3332,  2486,  5095,  1872,  3334,  2130,
    3338,  3351,  3360,   641,  5678,  3366,  3373,  3375,  2101,  3376,
    2131,  3377,  3378,  5116,   562, -1864,  3385,  2132,  3392,  5967,
    3397,  1782,  5679,  2353,  5117,  5118,  2129,  1812,   791,  2126,
    1816,  5134,  3403,  5135,  5136,   790, -2454,  3401,  2487,  1232,
    5133,  3405,  3420,  3406,  3421,  3425,  3412,  3429,  2149,  2133,
    3464,  2479,  3468,  5696,  3426,  3726,  2955,  3476,  3430,  3513,
    3431,  3432,  4665,  2169,  5164,  1227,  4283,  3433,  3455,  2481,
     642,  3434,  3479,  3480,  3541,  3512,  3543,  3544,  3545,  1157,
    1157,  2177,  2178,  3548,  3549,  5678,  3584,  4713,  3577,  3588,
    2196,  3602,  3608,  2963,  3612,  3615,  3619,  3620,  3677,  3621,
    3622,  2130,  3624,  3625,   791,  3626,  3680, -2076,  3683,  3687,
    2134,  3690,  2131,   808,   791,  3717,  3693,  3694,  3695,  2132,
    4712,   799,   791,  2480,  5195,   791,  3696,  3697,  2488,  3698,
    3699,  3700,  3701,  3702,   511,   791,  3703,  2482,  3704,  2489,
    3705,  2135,  2974,  5679,  3718,  3706,  3725,  3743,  3742,  3750,
    3707,  2133,  3708,  3709,  3744,  3710,  3711,  3712,  1157,  3713,
    3714,  3715,  3716,   513,  3589,  4595,   870,  3751,  3781,   871,
     563,  5696,  4596,  3762,  3040,  3745,  3783,  3784,  3802,  3806,
    2352,   870,  3746,  3747,   871,  3807,  3808,  3761,  4597,  3749,
    2242,  3796,  3809,  3787,  3817,   513,  5748,  3812,  4598,  4599,
    4600,  3804,  2483,  5631,  2484,  3816,  3805,  5799,  4601,  2485,
    3818,  3819,  2134,  3826,  1157,  3859, -3491,  3860,  3861,  2481,
    3872, -1903,  5435,   643,  2328,   984,  3873,   791,  4713,  2336,
    3916,  1311,  1157,  1157,  3771,  5799,  3874,  3880,  3893,  2346,
     799,  3917,  3929,  2135,  3947,  3931,  3932,   808,  3948,   644,
    1157,   808,   791,  3961,  3962,  3971,  3973,  3963,  3977,  3386,
    3984,  5679,  3980,  3985,  1001,  1157,  3986,  3987,  3590,  3991,
     984,   755,  3997,  4797,  2486,  3998,   808,  2726,  2725,   808,
    1397,  4005,  4019,  4010,  4283,  6145,  4283,  2482,  5320,  3119,
    4035,   564,    43,  1006,  4052,  4046,  1008,   645,  1269,  4057,
    4049,  4045,  4082,  4083,  1157,  4058,  1157,  2411,  4085,  1001,
    4089,  4090,  1012,  1013,  4116,  4117,  4120,  2487,   756,  4121,
    5346,   870,  5345,  4146,   871, -2209,  4199,  5348,  4154,  4200,
    4155,  4201,  4286,  4290,  4298,  4299,   791, -1200,  1006,  4301,
    4330,  1008,  5679,  5748,  4355,  4364,  4361,  4602,  4365,  4371,
    3135,  4376,  2483,  2353,  2484,  4379,  1020,  1012,  1013,  2485,
    5371,  4603,  4383,  4384,  4385,  4392,  4404,   565,  4397,  5799,
    4406,  1163,  4413,  4414,  4418,  1026,  4421,  4422,  1164,  4423,
    4424,  4471,  4482,  1031,  1032,  4484,  4508,  5378,  4499,  4332,
   -3491,  4494,  4495,   -73,  1165,  4500,  4510,  4511,  4516,   901,
   -2076,  1020,  4512,  4513,  1166,  1167,  1168,  2488,  4525,  4514,
    4515,  4526,  4523,  2400,  1169,  4527,   566,  4530,  2489,  4529,
    1026,  4534,  4533,  4535,  2486,  4548,  4549,  4571,  1031,  1032,
   -2076,  4552, -2076,   902,   646, -2076, -2076,   791,  4573,  4566,
    1569,  5395,  4572,  3594,  4575,  4577,   791,  4604,  4576,  4578,
    4583,  4586,   647,  1647,  4592,   904,  4594,   791,  4612,  4613,
    4614,  1573,  4605,  4615,   567,   905,   757,  2487,  2603,  4616,
    4619,  4625,  1048,  4642, -1989,  4673,  1157,  3142, -1994,  4668,
    1049,  1050,  1051,  1572,   808, -2262,  6142,  4676,   793,  4677,
    1653,   906,  4680,  4681,   648,  4690,  4695,   649,  4708,  4606,
     758,  4711,  4724,  4726,  4727,  1157,  4736,   907,  4738,  4739,
    4750,  1659,   908,  4607,  4755,  4758,  4760,  1048,  4761,  4762,
    4764,   808,  4765,  2662,   650,  1049,  1050,  1051,  4773,  4775,
    1157,  4774,   651,  1657,  4776,  4784,  4802,  4810,   909,  4842,
    4847,  4850,  4848,  4853,  4864,   808,   808,  4862,   564,   513,
    4875,  4878,  4879,  1170,  4886,   808,  2715,  2488,  4887,  4922,
    4489,  4932,  4134,  3343,  4934,   808,  4935,  1171,  2489,  2675,
    4942,  4938,  4983,  4985,  4939,  1569,  4968,  4969,  4797,  2737,
    1904,  4979,  4978,  4984,  4988,   799,   799,   791,   799,   799,
     799,   791,   808,   791,  5000,  4226,  1573,  5014,  5436,   799,
    5015,  -301,  5020,  5025,  5027,  5041,  5437,  2659,   910,  5052,
    5053,   749,  5054,  2772,   799,   568,   808,  5066,  1572,   569,
    5064,  5084,  5088,  5089,   565,   911,  5158,  1571,  5166,  5169,
    1157,  5172,  5161,   912,  5173,  5179,  5180,  5188,   791,  5196,
    5197,  5198,  5200,  5436,  5208,  5210,  5215,  5216,  5220,   791,
    5227,  5437,  5228,  5229,  5233,  5235,  5238,  5250,  5247,  5256,
     791,   570,  5264,  5248,   913,  4196,  5275,  5269,  1172,  1570,
    5270,  5274,  5748,   914,   915,  5279,  5284,  1656,  5318,  5285,
    5313,  5322,  5323,  5325,  5332,  5333,  5327,  5334,  5335,  5341,
    6045,   571,  1894,  1658,  5343,  5286,  5342,  5344,  5347, -3491,
    5350,  1157,   808,  5351,  5352,  1173,  5367,  5368,  5373,  5376,
    5379,  5384,  4284,  5394,  5289,  5398,   791,  5417,  5418,  1174,
    5396,  2861,  5420,  5423,  5421,  5427,  5428,  5431,  1157,  5434,
    5445,  5448,  5460,  5121,  5468,  5458,  5461,  5469,  5491,  5485,
    5493,  5492,   808,  5495,  5500,  4335,  5502,  5506,  5511,   808,
     808,   808,  5516,  5513,  5514,  1569,   791,  5518,   799,  5520,
    5523,  5528,  1571,  5544,  5549,  5067,  5552,  5556,  5570,  5572,
    1569,  5579,  5580,   791,  5585,  5586,  1573,  5587, -1136,  5601,
   -1136,  5591,  5602,  5589,   791,   791,  5607,  5609,  5624,  5672,
    5618,  1573,   808,  5647,  5662,  5619,  5621,  5652,  1572,  5665,
    5663,  5666,  5703,  2014,  1570,  5707,  5708,  2188,  5706,  2022,
    5723,  5714,  5732,  1572,  5687,  5733,  5753,  2379,  5687,  5736,
    5778,  4232,  2380,  5779,   513,  5780,  5781,  5789,  5791,  5792,
    5804,  5688,  5810,  2381,  5812,  5688,  5814,  5818,  5816,  5817,
    5822,  5823,  5824,  5825,  5832,   808,  5830,  5834,  5835,  1157,
    5844,  5838,  5850,  6148,  1653,  5854,    16,    17,   759,  5857,
    5862,  4221,  5865,  5883,  5877,  5885,  5891,   791,  5902,  5882,
    5903,  2997, -2262,  5904,  5921,  1659,  -172,  5922,  5960,  5907,
    5913,  5949,  5973,  5981,  5982,  5934,  5983,  5929,  5976,   791,
    5984,  1397,  5988,  4222,  5993,  4233,  6001,  1657,  6040,  6057,
    6058,  6059,  6034,  6070,  6091,  6083,  6090,  6073,  6081,  6092,
     866,  5438,  6097,  6103,  5439,  6100,  6110,  6104,   808,  6105,
    6114,   649,  6112,  5440,   808,  6117,  6132,  6118,  6144,  3511,
    3994,   874,  1675,  5406,  4324,  5408,  5407,  5615,  5622,  4225,
    5616,  5612,  1571,  5802,  5687,  5813,  4093,  5613,   760,  1988,
    5749,  4688,  5496,   873,  5774,  5895,  5438,  1571,  5282,  5439,
    3105,  5688,  5687,  6046,  1378,  2199,  4641,  2202,  5581,  4094,
    5319,  5802,  4827,  3007,  5628,  5977,  5975,  2214,  4359,  5688,
    5273,  2250,  4377,  1157,  1570,  2219,  4843,  3120,  1588,  2683,
    3136,  4609,  2382,  3522,  4401,  3138,  5206,  1498,  4852,  1570,
    4228,  4229,  4230,  1486,  1687,  3692,  4972,   791,   791,  3208,
    3211,  3209,  2985,  2383,  3152,  3008,  3210,  3139,  2384,  2246,
    5471,  3161,  3161,  4231,  3161,  3161,  5611,  4787,  5610,  4267,
    5375,  5875,  4941,  5447,  5875,  4946,  5257,  3390,  5933,   808,
    6009,  1656,  5592,   791,  6099,  5452,  6077,  6101,  4232,  2385,
    3552,  5864,  1917,   791,  5077,  3009,  4785,  1658,  5757,  6021,
    3198,  5153,  4792,  6065,  5467,  5349,  5912,  3617,  3618,  3203,
    5924,  5821,  3205,  5931,  3756,  1157,  4412,  5926,  1834,  5537,
    4234,  2386,  4235,  3072,  3629,  4486,  4927,  5919,  3080,  4925,
    2330,  5687,  2330,  4923,  3655,  3656,  6086,   872,  6053, -1136,
       4,  4236,   763,  5655,  6052,   764,  6025,  5969,  5688,   944,
    1157,  5966,  5752,   543,  3090,  4618,  5519,  4789,  2002,  5517,
    4238,  5151,  2215,  5942,  5943,  2870,  4074,  4239,  4073,  5669,
    3686,     8,  5928,  3038,  3400,  4394,  3502,  5961,  3813,   869,
    5536,  4863,  4240,  2173,   792,  3935,  1405,  5875,  4026,  1832,
    4241,  2172,  5875,  2128,  4145,  1902,  4849,  3988,   945,  5875,
    3719,  3720,  3721,  3722,    14,  4245,  5974,  4937,  3894,   946,
    3896,  3956,  3953,  2597,  4518,  2660,  2920,  2503,  2440,  5508,
    5331,  2917,  4961,    18,  5899,  2910,  5276,  5900,  2120,  5687,
    2931,  4507,  5045,  3604,  2121,  2122,  4143,  2123,   947,  2125,
    5044,  2449,  4506,  5442,  5843,   948,  5688,  5542,  5268,  6016,
    1157,  2033,  6017,  5433,  4144,  5453,  1423,  1157,  2180,  5048,
     774,  3596,    23,  4249,  3779,   765,   791,  2807,  2167,  2390,
    3811,  5271,   791,  4250,  4044,  6032,  5875,  4178,  5281,  1292,
    6026,  4960,  4957,  6006,  1583,  3470,  1589,   949,  3337,  3133,
    1274,  4020,  3471,  2770,  2174,  1277,   789,  3516,  5543,  5457,
    2860,  4867,  6098,  2395,  5336,  6111,  5687,  5687,  5515,  5875,
    4251,  5875,  5875,  6143,  6147,  1758,  4965,  3933,  3483,  1688,
    4009,  1235,  2033,  4252,  4954,  3354,  1236,  3451,  4004,  2704,
    1192,    31,  4003,  1896,  4696,  3193,   950,   951,  3981,  2387,
    2571,  4797,  3676,  5051,    16,    17,  2877,  5571,  4380,  2580,
     952,  4084,  4798,  1327,  2076,   783,   767,   768,   769,     0,
    2591,  6080,     0,     0,  4254,     0,  5687,     0,  5875,     0,
    4255,  5875,     0,     0,     0,     0,     0,     0,   808,   808,
     791,     0,     0,     0,   808,     0,     0,     0,  3161,  3161,
    3161,  3161,     0,  1157,     0,     0,  3416,  3417,     0,  1904,
       0,     0,     0,   808,     0,  4797,     0,     0,  5875,    42,
       0,     0,     0,  3010,     0,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4260,
       0,     0,  3456,   799,     0,     0,  4261,     0,     0,     0,
       0,     0,     0,  3011,  3012,   799,  3013,  3014,  3015,  3016,
    3017,    75,  3018,  3019,  3020,  3021,  3022,  3023,  3024,  3025,
       0,  3026,  3027,  3028,     0,     0,     0,  4262,  1157,     0,
       0,     0,   953,     0,     0,   791,     0,     0,     0,     0,
       0,     0,  4263,  4264,     0,     0,  2034,     0,     0,     0,
    2749,  2009,  3485,     0,  2753,  4265,  2755,   662,     0,     0,
     808,  3501,   791,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   791,     0,     0,     0,     0,     0,     0,  3529,     0,
       0,  2787,   791,     0,   954,     0,     0,     0,     0,     0,
       0,     0,  2797,     0,     0,     0,     0,  2034,  5004,     0,
    3029,  3030,     0,  2810,     0,     0,     0,  3557,  3558,  3559,
     791,     0,   799,     0,   799,     0,     0,     0,     0,   791,
    3571,   799,     0,   791,     0,     0,     0,     0,  4214,   791,
    4215,  4216,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   791,     0,     0,     0,  3592,     0,
       0,     0,  2149,  3597,  4217,     0,  4218,     0,     0,     0,
       0,     0,  4219,     0,     0,     0,     0,     0,     0, -1136,
       0, -1136,     0,     0,     0,     0,     0,     0,     0,  2035,
       0,     0,     0,     0,  2188,     0,     0,     0,     0,     0,
       0,     0,     0,  2036,     0,  2037,  4220,     0,  2188,  2884,
       0,     0,     0, -1292,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0, -1292,   808,  1397,     0,     0,     0,
       0,   791,     0,     0,     0,   955,  2038,  1397,  1397,     0,
       0,     0,     0,    16,    17,     0,     0,     0,  4221,     0,
    2657,  2039,     0,     0,     0,     0,     0,    16,    17,     0,
    2035,     0,  4221,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2036,     0,  2037,     0,     0,  4222,
       0,     0,     0,  4628,  2040,  4629,     0,  4630,     0,     0,
       0,     0,  3741,     0,     0,     0,     0,     0,     0,     0,
       0,  3748,  2041,     0,     0,     0,     0,  2038,     0,     0,
       0,     0,     0,     0,  4223,     0,     0,     0,  4224,     0,
    2993,     0,  2039,     0,     0,     0,  4225,     0,     0,  4226,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4225,     0,     0,  4167,  4168,     0,  4170,  4172,     0,     0,
       0,     0,  4227,     0,  3772,  2040,     0,     0,     0,     0,
       0,     0,     0,  3780,     0,  3782,     0,     0,     0,     0,
       0,   791,     0,  2041,   791,     0,     0,   808,     0,   808,
     808,     0,     0,  2042,     0,  1895,     0,  4228,  4229,  4230,
    2043,     0,   808,     0,     0,  3161,     0,     0,     0,     0,
    2044,  4228,  4229,  4230,     0,     0,     0,     0,     0,     0,
    4231,     0,     0,  2045,     0,     0,     0,     0,     0,     0,
       0,  5948,     0,     0,  4231,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4232,     0,  4331,     0,     0,
       0,     0,     0,     0,  2046,     0,     0,  2047,     0,  4232,
       0,     0,     0,     0,  2042,     0,     0,     0,     0,  4233,
     808,  2043,   808,  2048,     0,     0,     0,  4234,     0,  4235,
       0,  2044,     0,     0,  3160,  3160,     0,  3160,  3160,   663,
       0,  4234,     0,  4235,  2045,     0,     0,     0,  4236,     0,
       0,     0,     0,     0,     0,  4237,  3174,     0,     0,     0,
   -1136,     0,  4236,     0,     0,     0,  1647,  4238,     0,     0,
       0,     0,  3792,     0,  4239,  2046,     0,     0,  2047,     0,
       0,  4238,     0,     0,     0,     0,     0,     0,  4239,  4240,
       0,     0,     0,     0,  2048,     0,     0,  4241,     0,     0,
       0,  4242,  4243,  4240,     0,     0,     0,     0,  4244,     0,
       0,  4241,  4245,     0,     0,     0,     0,     0,     0,     0,
    4246,     0,     0,     0,     0,     0,  4245,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3918,     0,  6076,     0,
    4247,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4248,     0,     0,  3946,
    4249,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4250,     0,     0,     0,  4249,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4250,     0,     0,     0,   791,     0,
       0,     0,   808,   808,  3161,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4251,   808,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4252,  4251,  4253,     0,     0,     0,     0,     0,     0,  3316,
    2188,     0,  6134,     0,  4252,  3322,     0,     0,  6136,     0,
       0,  1225,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     4,     0,     0,     0,     0,     0,     0,     0,     0,
     944,  4254,     0,  2603,     0,     0,     0,  4255,     0,     0,
       0,     0,     0,     0,  4041,  4254,     0,     0,     0,    16,
      17,  4255,     8,     0,  4221,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4256,     0,     0,     0,  -340,     0,
    -340,     0,     0,     0,     0,  4257,  4258,  4259,     0,   945,
       0,     0,     0,     0,     0,    14,     0,     0,     0,     0,
     946,     0,     0,     0,     0,     0,  4260,     0,     0,     0,
       0,     0,     0,  4261,    18,     0,     0,     0,     0,     0,
    4260,     0,     0,  1894,     0,     0,     0,  4261,     0,   947,
       0,  3160,  3160,  3160,  3160,   799,   948,     0,     0,     0,
     791,     0,  4225,     0,  4262,     0,     0,     0,     0,     0,
       0,   791,     0,    23,     0,   791,     0,     0,  4262,  4263,
    4264,   808,     0,     0,     0,     0,     0,     0,     0,  2662,
       0,     0,  4265,  4263,  4264,  4266,     0,     0,   949,     0,
       0,     0,     0,     0,   808,   808,  4265,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4228,  4229,  4230,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3473,     0,
       0,     0,    31,     0,     0,     0,  4231,   950,   951,     0,
       0,     0,     0,     0,   808,     0,     0,     0,     0, -1292,
       0,   952,     0,     0,     0,  3503,     0,     0,     0,     0,
    4288,  4232,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4737,     0,     0,  4740,     0,     0,  4746,
    4747,  4748,  4749,     0,  4751,  4752,  4753,  4754,     0,  4756,
    4757,     0,  4759,  4234,     0,  4235,  4763,     0,     0,     0,
    4766,  4767,  4768,  4769,     0,  4771,  4772,     0,  -340,     0,
      42,  4777,  4778,     0,  4236,  4782,  4783,     0,  1500,  1501,
       0,     0,     0,  3560,  1502,  1503,     0,     0,     0,     0,
       0,     0,  3569,  4238,  1504,     0,  1397,     4,  4360,     0,
    4239,     0,  1397,     0,     0,     0,   944,     0,     0,     0,
       0,     0,    75,     0,     0,  4240,     0,  1397,   791,     0,
    1505,     0,     0,  4241,     0,     0,     0,     0,     8,     0,
       0,     0,  1506,   953,     0,     0,     0,  3152,  4245,     0,
       0,     0,  2178,   808,   808,   808,   808,     0,     0,   791,
       0,     0,  1507,     0,     0,   945,     0,     0,     0,     0,
    4402,    14,     0,     0,     0,     0,   946,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      18,     0,     0,     0,     0,     0,  1508,     0,  -340,     0,
       0,     0,     0,     0,     0,   947,  4249,     0,     0,     0,
       0,     0,   948,     0,     0,   954,  4250,     0,     0,  1509,
    1510,     0,  1511,     0,     0,     0,     0,     0,     0,    23,
    1512,  1513,  1514,     0,     0,     0,     0,     4,     0,     0,
       0,     0,     0,     0,     0,     0,   944,     0,     0,     0,
    1515,     0,     0,  4251,   949,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4481,     0,  4252,     0,     8,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1516,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   945,     0,     0,    31,     0,
       0,    14,     0,   950,   951,     0,   946,  4254,     0,  1517,
    4522,     0,     0,  4255,     0,  1518,     0,   952,     0,     0,
      18,     0,     0,     0,   808,     0,     0,     0,     0,     0,
       0,   808,   808,   808,   808,   947,  4543,     0,     0,  1519,
    1520,  1521,   948,     0,  1397,     0,     0,  3789,     0,     0,
       0,     0,  4553,  4554,     0,     0,   955,     0,     0,    23,
       0,     0,     0,  1522,  1523,     0,     0,     0,  3160,     0,
       0,     0,  4260,     0,     0,     0,    42,     0,     0,  4261,
       0,  4574,     0,     0,   949,     0,     0,     0,  -575,     0,
    2603,     0,     0,     0,     0,     0,  4591,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4262,     0,     0,     0,  1524,     0,  1525,  1526,    75,     0,
       0,     0,     0,     0,     0,  4263,  4264,     0,    31,     0,
     808,     0,  1527,   950,   951,     0,   791,   791,  4265,   953,
       0,     0,     0,     0,     0,     0,     0,   952,     0,     0,
       0,   799,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   791,   791,  1528,
       0,  1529,     0,     0,  4670,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1530,     0,  -575,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    42,     0,     0,     0,
       0,   954,     0,     0,     0,  1531,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1532,  1533,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    75,     0,
       0,     0,     0,     0,     0,     0,     0,  5092,  1534,     0,
       0,     0,     0,     0,     0,     0,     0,  1535,     0,   953,
       0,     0,     0,     0,     0,     0,     0,     0,     4,  5119,
       0,     0,     0,     0,     0,     0,     0,   944,     0,     0,
       0,     0,     0,     0,     0,     0,     4,     0,     0,     0,
       0,     0,     0,     0,     0,   944,     0,     0,     0,     8,
    4781,  3978,     0,  1536,  1537,  1538,     0,  3160,     0,     0,
       0,  1539,  1540,     0,  1672,  4795,     0,     8,     0,     0,
       0,     0,     0,     0,     0,     0,   945,     0,  1541,  1542,
       0,   954,    14,     0,     0,     0,     0,   946,     0,     0,
       0,     0,   955,     0,   945,     0,     0,     0,     4,     0,
      14,    18,  1543,  1544,     0,   946,     0,   944,     0,     0,
       0,     0,     0,     0,     0,     0,   947,  4824,     0,    18,
       0,  1545,  3741,   948,     0,     0,     0,     0,     0,     8,
       0,  1500,  4336,     0,   947,     0,     0,  1502,  1503,     0,
      23,   948,     0,     0,     0,     0,     0,  1504,     0,  3772,
       0,     0,  4844,     0,     0,  4846,   945,     0,    23,     0,
       0,     0,    14,     0,     0,   949,     0,   946,     0,     0,
       0,   808,     0,  1505,     0,     0,     0,     0,     0,     0,
       0,    18,     0,   949,     0,  1506,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   947,     0,     0,     0,
       0,     0,     0,   948,     0,  1507,     0,     0,     0,    31,
       0,     0,     0,  1547,   950,   951,  1548,     0,     0,  1549,
      23,     0,   955,  4112,     0,     0,     0,    31,   952,     0,
       0,     0,   950,   951,  1397,     0,     0,     0,  1397,  1508,
       0,     0,  1550,     0,     0,   949,   952,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1552,  1509,  1510,     0,  1511,     0,     0,     0,  4920,
       0,     0,     0,  1512,  1513,  1514,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4929,    42,     0,    31,
       0,     0,     0,  1515,   950,   951,     0,     0,     0,     0,
       0,     0,     0,     0,  4543,    42,     0,     0,   952,     0,
       0,     0,     0,     0,     0,     0,     0,  4522,     0,     0,
       0,   808,   808,     0,     0,     0,     0,  4950,  1516,    75,
       0,     4,     0,     0,     0,     0,     0,     0,     0,     0,
     944,     0,     0,  1225,  1904,     0,     0,    75,     0,     0,
     953,     0,  1517,  2603,     0,     0,     0,     0,  1518,     0,
       0,     0,     8,     0,  4041,  4967,     0,    42,   953,     0,
       0,     0,     0,  4977,     0,     0,     0,     0,     0,     0,
       0,     0,  1519,  1520,  1521,     0,     0,     0,     0,   945,
       0,     0,     0,     0,     0,    14,     0,     0,     0,     0,
     946,     0,     0,     0,     0,  3795,  4337,  1523,     0,    75,
       0,     0,   791,     0,    18,  4795,     0,   791,     0,     0,
       0,     0,   954,  4032,     0,     4,     0,     0,     0,   947,
     953,  1397,     0,     0,   944,     0,   948,     0,     0,     0,
     954,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    23,     0,  3592,  -557,  1524,     0,  1525,
    1526,     0,  4395,     0,  2662,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1527,     0,     0,   949,     0,
       0,     0,   808,   945,     0,  5211,     0,     0,     0,  1683,
       0,     0,     0,     0,   946,     0,  4795,     0,     0,     0,
       0,     0,   954,     0,     0,     0,     0,     0,    18,     0,
       0,     0,  1528,  4977,  1529,     0,     0,     0,     0,     0,
       0,     0,    31,   947,  5094,     0,  2603,   950,   951,     0,
     948,     0,   791,     0,     0,  1530,     0,     0,  5112,     0,
       0,   952,     0,     0,     0,     0,     0,  1684,     0,     0,
     808,  4977,     0,     0,     0,     0,     0,     0,  1531,     0,
       0,     0,     0,   955,     0,     0,     0,     0,     0,  1532,
    1533,  4977,   949,     0,     0,     0,     0,  4795,  5154,     0,
       0,   955,     0,  5165,     0,     0,     0,     0,     0,   799,
       0, -1136,     0, -1136,  5175,     0,     0,     0,     0,     0,
      42,  1534,     0,     0,     0,     0,     0,     0,     0,     0,
    1535,     0,     0,     0,     0,     0,  1685,     0,     0,     0,
    2188,   950,   951,  5189,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   952,     0,     0,     0,     0,
       0,     0,    75,   955,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1536,  1537,  1538,     0,
       0,     0,     0,   953,  1539,  1540,     0,     0,     0,    16,
      17,     0,     0,     0,  4221,     0,     0,     0,     0,     0,
       0,  1541,  1542,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1686,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1543,  1544,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4338,     0,  4522,     0,     0,     0,
       0,     0,     0,     0,     0,   954,  -557,     0,     0,  4626,
    4627,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4225,     0,     0,     0,  2603,   953,  3772,     0,
       0,     0,     0,     0,     0,     0,  4591,     0,     0,     0,
    1397,  1397,     0,     0,     0,   808,     0,     0,     0,  4795,
       0,     0,     0,     0,     0,     0,     0,   791,     0,     0,
       0,     0,     0,     0,     0,     0,  3741,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3741,     0,     0,     0,
       0,     0,     0,  4228,  4229,  4230,  1547,     0,     0,  1548,
       0,     0,  1549,     0,     0,     0,     0,     0,     0,   954,
       0,     0,     0,     0,     0,     0,  4231,     0,     0,     0,
       0,     0,     0,     0,     0,  4340,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5356,  4232,     0,     0,  1552,  4795,  4977,  4795,     0,   808,
    4795,     0,  4977,     0,     0,     0,   955,  4795,  4795,     0,
       0,     0,  4977,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4234,     0,  4235,     0,     0,     0,  1159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0, -1136,     0,  4236,     0,     0,  4795,     0,     0,
       0,  4977,     0,  4977,     0,     0,  1159,     0,     0,     0,
       0,     0,     0,  4238,     0,     0,     0,     0,     0,     0,
    4239,     0,  5385,     0,     0,   791,     0,  1159,  5392,     0,
       0,     0,     0,     0,     0,  4240,     0,     0,     0,     0,
       0,     0,     0,  4241,     0,  5401,     0,     0,     0,     0,
     955,     0,     0,     0,     0,     0,     0,     0,  4245,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5855,
    5856,     0,  5858,  5859,  5860,  5861,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4249,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4250,     0,  5451,     0,
       0,     0,     0,     0,     0,     0,     0,  4920,     0,     0,
       0,     0,  4977,     0,     0,     0,     0,     0,  1159,     0,
       0,  5464,  5464,  5466,     0,     0,  4795,     0,     0,     0,
       0,     0,     0,  4251,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4252,     0,     0,     0,
       0,     0,     0,   799,     0,     0,     0,     0,   799,     0,
       0,     0,  3592,     0,  3592,  5941,     0,     0,  5944,     0,
       0,     0,     0,     0,     0,     0,  5952,     0,     0,     0,
       0,  5962,     0,     0,  5522,     0,     0,  4254,     0,     0,
       0,  5527,     0,  4255,  4795,  4795,     0,     0,  4795,     0,
       0,     0,  4795,     0,  5539,     0,     0,     0,     0,     0,
    2603,     0,     0,   791,     0,  1159,     0,     0,     0,  4977,
       0,     0,     0,  1237,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   669,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5568,     0,  1209,
       0,     0,  4260,     0,     0,   791,     0,  1238,  1239,  4261,
       0,     0,     0,     0,     0,  1159,     0,  1240,     0,     0,
    1159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    10,    11,     0,     0,     0,     0,     0,     0,
    4262,     0,     0,     0,     0,     0,     0,     0,  5464,     0,
    1159,     0,     0,  1735,     0,  4263,  4264,     0,     0,     0,
    1159,     0,     0,     0,     0,     0,     0,     0,  4265,     0,
       0,     0,     0,     0,     0,  4989,     0,    16,    17,  3741,
    5001,     0,  1241,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1242,     0,  1735,     0,
       0,     0,     0,     0,     0,     0,     0,  4795,     0,     0,
       0,     0,  4795,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   791,     0,     0,     0,     0,  5671,     0,     0,     0,
       0,     0,     0,  5702,     0,     0,     0,  1159,  1159,  1159,
    1159,  5709,  5713,  1735,     0,     0,     0,     0,     0,  1243,
       0,  1159,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1244,     0,     0,     0,     0,     0,  5731,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5464,     0,     0,  5103,  5755,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5765,     0,  5766,
     799,     0,     0,     0,     0,     0,   799,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1245,     0,     0,     0,     0,     0,     0,     0,     0,  5785,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   808,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1246,
       0,     0,     0,  2603,     0,     0,     0,     0,  1247,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1248,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1249,     0,     0,     0,     0,     0,     0,  1159,     0,
       0,     0,  1735,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1250,     0,  5892,     0,     0,
     791,     0,     0,   799,   799,     0,     0,  4591,  4591,     0,
       0,     0,     0,     0,     0,     0,  5464,     0,  5464,  5464,
       0,     0,     0,     0,     0, -2454,  1251,     0,     0,  1252,
       0,  1253,     0,  5914,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5920,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1254,  1255,     0,
       0,     0,     0,     0,  5713,  1256,  1257,     0,     0,     0,
       0,     0,     0,     0,     0,  5731,     0,     0,     0,  1735,
       0,     0,  1258,     0,     0,     0,     0,     0,   808,     0,
    5290,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1259,     0,     0,     0,     0,  5970,
    1159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1260,     0,     0,     0,     0,
    5464,  5464,     0,     0,  5464,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,  1159,     0,  2603,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   808,
       0,  1261,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6033,  1262,     0,     0,     0,     0,
       0,   799,     0,     0,     0,     0,  1263,  6043,     0,  1264,
    1265,     0,     0,     0,     0,  5464,     0,     0,     0,     0,
       0,     0,     0,     0,  1266,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   808,     0,     0,  5386,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1267,     0,  6078,  6078,     0,     0,     0,  1268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0, -3240,     0,  1269,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,  1159,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0, -3240,     0,
       0,     0,     0,     0,  1270,  2603,     0,     0,     0,   808,
    1159,     0,     0,     0,     0,   808,     0,     0,     0,  2603,
       0,     0,     0,  1159,  1159,  2603,     0,     0,     0,  1159,
       0,  2603,     0,  1159,  1159,  1159,     0,     0,     0,     0,
       0,     0,     0,     0,  1159,  1159,  1735,     0,     0,     0,
    1159,     0,  1159,  1159,  1159,  1159,  1159,     0,  1159,     0,
       0,  1735,  1735,     0,     0,     0,     0,     0,     0,  1159,
       0,  1159,     0,     0,  1159,  1159,     0,  1159,  1159,  1159,
       0,  1159,  1159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1159,  1159,  1159,  1159,
    1159,     0,  1159,  1159,  1159,     0,     0,  1159,  1159,  1159,
    1159,  1159,  1159,  1159,     0,  1159,  1159,  1159,  1159,     0,
    1159,  1159,     0,  1159,  1159,  1159,  1159,  1159,  1159,  1159,
       0,     0,  1159,  1159,  1159,  1159,     0,  1159,  1159,  1159,
       0,  1159,     0,  1159,     0,  1159,     0,     0,     0,  1159,
    1159,  1159,     0,     0,  1159,  1159,  1159,  1159,  1159,     0,
    1159,     0,     0,     0,     0,     0,     0,  1159,  5573,     0,
       0,     0,     0,     0,  1159,  1159,  1159,  1159,     0,  5149,
       0,  4215,     0,     0,     0,  1159,  1159,     0,  1159,  1159,
       0,     0,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,
    1159,  1159,  1159,  1159,  1159,  4217,     0,  1159,     0,     0,
       0,     0,  1735,  4219,     0,     0,     0,     0,     0,  1735,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2188,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5150,  1159,     0,
       0,     0,     0,  1159,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1159,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    16,    17,     0,     0,     0,  4221,
       0,     0,     0,     0,  5667,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4222,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1159,     0,     0,     0,     0,     0,     0,     0,  1125,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4224,
       0,     0,  1159,     0,  1159,  1288,     0,  4225,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1735,     0,     0,     0,
       0,     0,     0,  4227,     0,     0,     0,     0,  1159,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4228,  4229,
    4230,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4231,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4232,     0,     0,     0,
       0,     0,     0,  1159,     0,     0,     0,     0,     0,     0,
       0,     0,  1735,     0,     0,     0,     0,     0,     0,     0,
    4233,     0,     0,     0,     0,     0,     0,  1485,  4234,     0,
    4235,     0,     0,     0,  1159,     0,     0,     0,     0,     0,
       0,     0,     0,  5894,     0,     0,     0,     0,     0,  4236,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4238,     0,
       0,     0,     0,     0,     0,  4239,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4240,     0,     0,     0,     0,     0,     0,     0,  4241,     0,
       0,     0,  4242,     0,     0,     0,     0,     0,     0,  4244,
       0,     0,     0,  4245,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1636,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4247,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1159,  1159,     0,     0,
       0,  4249,     0,     0,     0,     0,     0,     0,     0,  1698,
       0,  4250,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1725,
       0,     0,     0,     0,     0,     0,     0,     0,  4251,  1740,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4252,     0,  4253,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1159,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1159,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4254,     0,     0,     0,     0,     0,  4255,     0,
       0,     0,     0,  1159,     0,  1159,     0,     0,     0,     0,
       0,     0,     0,  1159,  1159,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1833,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4260,     0,     0,
       0,     0,     0,     0,  4261,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1735,  1735,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4262,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1159,  1159,  1159,
    4263,  4264,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1735,     0,  4265,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1735,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1159,     0,     0,  1735,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1159,     0,     0,     0,  1159,  1159,
       0,  1159,  1159,     0,     0,     0,     0,  2031,     0,     0,
    1159,     0,  1159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1159,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1159,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1159,     0,     0,  1159,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1159,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2185,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2228,     0,  2229,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1735,     0,
    1735,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1159,     0,     0,     0,     0,     0,     0,  1735,     0,     0,
    1735,  1735,  1735,     0,  1159,     0,  1159,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2393,     0,  2393,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2424,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2439,     0,
       0,     0,  2444,     0,  2446,     0,     0,     0,     0,     0,
       0,     0,     0,  2462,  2463,     0,     0,     0,     0,  2492,
       0,  2495,  2496,  2497,  2498,  2499,     0,  2501,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2509,     0,
    2512,     0,     0,  2513,  2514,     0,  2516,  2517,     0,     0,
    2520,  2521,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2530,  2531,  2538,  2542,  2543,
       0,  2546,     0,  2548,     0,     0,  2550,  2551,  2552,  2555,
    2556,  2557,  2558,     0,  2559,  2560,  2561,     0,     0,  2568,
    2569,     0,     0,  2573,  2574,  2575,     0,     0,     0,     0,
       0,  2581,  2582,  2583,     0,     0,  2586,  2587,  2588,     0,
    2590,     0,  2592,     0,  2593,     0,     0,     0,  2596,  2538,
    2598,     0,     0,  2604,  2605,  2606,  2607,  2608,     0,  2609,
       0,     0,     0,     0,     0,     0,  2613,     0,     0,     0,
       0,     0,     0,  2618,  2619,  2620,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1159,     0,     0,
    1159,     0,     0,     0,     0,     0,     0,     0,     0,  1159,
       0,     0,     0,     0,     0,     0,     0,     0,  1159,     0,
    1159,     0,  1159,     0,  1159,  1159,  1159,  1159,  1159,  1159,
       0,  1159,     0,     0,     0,     0,     0,  2718,     0,  1159,
       0,  1159,  2185,     0,  1159,  1159,  1159,     0,     0,     0,
       0,     0,  2185,  1159,  1159,  1159,     0,  1159,     0,  1159,
       0,  1159,     0,  1159,     0,  1159,     0,     0,     0,     0,
       0,     0,     0,  1159,     0,  1159,     0,  1159,  1159,  1159,
    1159,  1159,     0,     0,  1159,     0,  1159,     0,     0,  1159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,     0,     0,     0,  1159,     0,     0,
    1159,     0,  1159,  1159,  1159,     0,     0,  1159,     0,  2791,
       0,     0,     0,  1159,     0,     0,     0,     0,  1159,     0,
       0,     0,     0,     0,     0,     0,     0,  1159,     0,     0,
       0,     0,     0,  1159,     0,  1159,     0,     0,  1159,     0,
       0,  2826,     0,  2831,     0,     0,     0,     0,  1159,  1159,
    1159,  1159,  1735,  1159,     0,     0,     0,     0,  1159,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1735,
       0,     0,     0,     0,     0,     0,     0,  2854,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1159,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1159,     0,     0,     0,     0,     0,     0,
       0,     0,  2927,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,  1159,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1159,     0,     0,     0,     0,     0,     0,
    1735,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3106,  3107,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1159,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3168,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3194,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1288,     0,  3213,     0,     0,     0,     0,     0,
       0,     0,  3220,  3221,     0,     0,  1735,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1159,     0,     0,  1159,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,  1159,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1735,     0,  3276,  3278,  3280,     0,
       0,     0,     0,     0,     0,     0,     0,  1159,     0,  1159,
       0,  1159,     0,  1159,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,     0,     0,     0,     0,  1735,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1159,  1159,     0,     0,     0,     0,     0,
    1159,     0,  1159,     0,  1159,     0,     0,     0,     0,  1159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3362,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3370,
       0,  3371,     0,  1735,  1159,  1159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3396,     0,     0,     0,     0,     0,     0,     0,
    1159,     0,     0,     0,     0,     0,  3402,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3413,
       0,     0,  2185,     0,     0,     0,     0,     0,     0,     0,
    1735,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3449,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3459,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1159,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1159,     0,     0,  2831,
       0,     0,     0,     0,     0,     0,     0,     0,  1159,     0,
    1159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3598,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3598,     0,  2185,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3689,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1159,  1159,     0,  1159,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1159,
    1159,  1159,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1159,     0,  1159,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1159,
    1159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1159,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1159,     0,
       0,     0,     0,     0,     0,     0,     0,  1159,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3834,     0,     0,  3835,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1159,     0,     0,     0,  1159,     0,     0,  3862,     0,     0,
       0,  3864,     0,  3865,  3866,  3867,  3868,  3869,  3870,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3875,     0,
    3876,     0,     0,  3877,  3878,  3879,     0,     0,     0,     0,
       0,     0,  3881,  3882,  3883,     0,  3884,     0,  3886,     0,
    3888,     0,  3890,     0,  3892,     0,     0,     0,     0,     0,
       0,     0,  2552,     0,  3895,     0,  2552,     0,  3898,  3899,
    3900,     0,     0,  3901,     0,  3902,     0,     0,  3903,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3904,     0,     0,     0,     0,     0,     0,     0,  3911,
       0,  3912,  3913,  3914,     0,     0,  3915,     0,     0,     0,
       0,     0,  3919,     0,     0,     0,     0,  3930,     0,     0,
       0,     0,     0,     0,     0,     0,  3934,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3941,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3952,  3955,
       0,     0,  3960,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2185,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2185,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1159,  1159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2831,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2185,     0,  2831,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1159,     0,     0,     0,
       0,     0,  4139,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1735,  1159,  1159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1159,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1159,     0,  1159,     0,
       0,     0,  4297,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4400,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4407,     0,     0,  4408,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1159,     0,
       0,  4426,  4427,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1735,     0,  4450,  1159,  4451,     0,
    4452,     0,  4453,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4474,  1159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4497,  4498,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3598,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2185,  2185,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2185,     0,
       0,     0,  1159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2831,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1159,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4667,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3598,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3598,     0,  4679,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1159,     0,     0,     0,     0,     0,     0,  1735,  1735,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1735,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1735,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4851,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4881,  4882,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4889,  4890,
    4891,     0,     0,     0,     0,     0,     0,  1159,     0,     0,
       0,     0,     0,  4911,     0,  4912,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4918,  4919,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4940,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2831,
       0,     0,     0,  2831,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1159,     0,     0,     0,     0,     0,     0,  1159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5167,  5168,     0,     0,     0,     0,     0,     0,     0,     0,
    1159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3598,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3598,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2185,  2185,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2831,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2831,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5324,     0,  5326,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5426,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3598,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5524,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3598,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5829,     0,     0,     0,  2181,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2182,
     984,   985,   986,   987,     0,     0,     0,     0,     0,     0,
       0,   988,   989,     0,   990,     0,     0,     0,     0,     0,
       0,   991,   992,     0,     0,   993,   994,   995,   996,     0,
     997,   998,     0,   999,  1000,     0,     0,     0,     0,  1001,
       0,     0,     0,  2183,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,  1005,  1006,     0,
    1007,  1008,     0,     0,     0,     0,  1833,     0,     0,     0,
       0,     0,     0,  1009,  1010,  1011,     0,  1012,  1013,     0,
       0,     0,  1014,  1015,  1016,     0,     0,     0,     0,     0,
       0,     0,  1017,     0,  1018,     0,     0,     0,     0,     0,
       0,  5927,     0,     0,     0,     0,     0,  1019,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1020,     0,     0,     0,     0,  1021,  1022,     0,  1023,
       0,     0,     0,     0,     0,  1024,     0,  1025,     0,     0,
    1026,     0,     0,  1027,  1028,  1029,     0,  1030,  1031,  1032,
       0,  1033,  2184,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1034,     0,     0,     0,
    1035,  1036,  1037,     0,  1038,     0,     0,     0,     0,     0,
       0,  1039,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1040,     0,     0,     0,     0,     0,     0,     0,
    1041,  2831,     0,  1042,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,     0,     0,     0,  1044,
    1045,     0,  1046,  1047,     0,     0,     0,  1048,     0,     0,
       0,     0,     0,     0,     0,  1049,  1050,  1051,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1052,  1053,  1054,
       0,     0,     0,     0,     0,  1055,     0,  1056,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   582,    48,    49,    50,    51,    52,  1057,  1058,
    1059,    54,    55,    56,  1060,    58,    59,    60,    61,    62,
      63,  1061,    65,    66,    67,    68,    69,    70,    71,  1062,
     583,     0,   584,   585,    77,    78,    79,    80,    81,    82,
     586,    84,    85,    86,    87,  1063,    88,   588,    90,    91,
      92,    93,    94,   589,  1064,    96,  1065,  1066,    99,  1067,
    1068,  1069,  1070,  1071,     0,   105,   106,   107,   590,   109,
     110,   111,   112,   113,   114,   115,   116,   117,  1072,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
    1073,  1074,  1075,   592,   133,     0,   134,   135,   136,   137,
     138,   139,   140,   593,   142,   143,   144,   145,   594,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   595,   160,     0,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   596,   597,   172,  2831,
    1076,   174,   175,   598,   177,   178,  1077,   180,  1078,   599,
     183,   184,   600,   186,   187,   601,     0,   189,   190,   191,
    1079,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     602,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     603,   212,  1080,  1081,   215,   216,   217,  1082,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,  1083,   257,  1084,   259,   260,
     261,   262,  1085,  1086,  1087,  1088,   267,   268,   269,   270,
     271,   272,   273,   274,   275,  1089,  1090,   278,   279,   280,
     281,   282,   604,   283,   284,   285,   286,   287,   288,   289,
     290,   291,  1091,   293,   294,   295,   605,   296,   297,   298,
     299,   300,   301,   302,   303,   304,  1092,   306,   307,   308,
     309,   310,  1093,  1094,   313,   606,   314,   607,   316,   317,
    1095,   319,   320,   321,   322,   323,   324,  1096,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   608,   345,   346,   609,
     348,   349,   350,   351,   352,   353,   354,  1097,   356,   610,
     358,   359,   360,  1098,  1099,   363,   364,   611,   366,   367,
    1100,   369,   370,   371,   372,   373,   374,  1101,   376,   612,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,     0,   392,   393,   394,   395,   613,
     397,   398,   614,   400,   401,   402,   403,  1102,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,  1103,  1104,  1105,  1106,
     427,   428,   429,  1107,  1108,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   616,   442,   443,   444,  1109,   446,
    1110,   448,   449,   450,   451,   452,   453,   454,   455,   456,
    1111,  1112,   617,  1113,   461,   462,   463,     0,   464,   618,
     466,  1114,     0,     0,     0,     0,     0,     0,     0,     0,
    1115,  1116,     0,     0,     0,     0,  1117,     0,     0,     0,
    2627,  1118,     0,     0,     0,  1119,  1120,     0,     0,  1121,
    1122,   983,   984,   985,   986,   987,     0,     0,     0,     0,
       0,     0,     0,   988,   989,     0,   990,     0,     0,     0,
       0,     0,     0,   991,   992,     0,     0,   993,   994,   995,
     996,     0,   997,   998,     0,   999,  1000,     0,     0,     0,
       0,  1001,     0,     0,     0,  1002,     0,     0,  1003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1004,  1005,
    1006,     0,  1007,  1008,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1009,  1010,  1011,     0,  1012,
    1013,     0,     0,     0,  1014,  1015,  1016,     0,     0,     0,
       0,     0,     0,     0,  1017,     0,  1018,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1019,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1020,     0,     0,     0,     0,  1021,  1022,
       0,  1023,     0,     0,     0,     0,     0,  1024,     0,  1025,
       0,     0,  1026,     0,     0,  1027,     0,  1029,     0,  1030,
    1031,  1032,     0,  1033,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1034,     0,
       0,     0,  1035,  1036,  1037,     0,  1038,     0,     0,     0,
       0,     0,     0,  1039,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1040,     0,     0,     0,     0,     0,
       0,     0,  1041,     0,     0,  1042,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1043,     0,     0,     0,     0,
       0,  1044,  1045,     0,  1046,  1047,     0,     0,     0,  1048,
       0,     0,     0,     0,     0,     0,     0,  1049,  1050,  1051,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1052,
    1053,  1054,     0,     0,     0,     0,     0,  1055,     0,  1056,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   582,    48,    49,    50,    51,    52,
    1057,  1058,  1059,    54,    55,    56,  1060,    58,    59,    60,
      61,    62,  2628,  1061,    65,    66,    67,    68,    69,    70,
      71,  1062,   583,     0,   584,   585,    77,    78,    79,    80,
      81,    82,   586,    84,    85,    86,    87,  1063,    88,   588,
      90,    91,    92,    93,    94,   589,  1064,    96,  1065,  1066,
      99,  1067,  1068,  1069,  1070,  1071,     0,   105,   106,   107,
     590,   109,   110,   111,   112,   113,   114,   115,   116,   117,
    1072,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,  1073,  1074,  1075,   592,   133,     0,   134,   135,
     136,   137,   138,   139,   140,   593,   142,   143,   144,   145,
     594,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   595,   160,     0,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   596,   597,
     172,     0,  1076,   174,   175,   598,   177,   178,  1077,   180,
    1078,   599,   183,   184,   600,   186,   187,   601,     0,   189,
     190,   191,  1079,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   602,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   603,   212,  1080,  1081,   215,   216,   217,  1082,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,  1083,   257,  1084,
     259,   260,   261,   262,  1085,  1086,  1087,  1088,   267,   268,
     269,   270,   271,   272,   273,   274,   275,  1089,  1090,   278,
     279,   280,   281,   282,   604,   283,   284,   285,   286,   287,
     288,   289,   290,   291,  1091,   293,   294,   295,   605,   296,
     297,   298,   299,   300,   301,   302,   303,   304,  1092,   306,
     307,   308,   309,   310,  1093,  1094,   313,   606,   314,   607,
     316,   317,  1095,   319,   320,   321,   322,   323,   324,  1096,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   608,   345,
     346,   609,   348,   349,   350,   351,   352,   353,   354,  1097,
     356,   610,   358,   359,   360,  1098,  1099,   363,   364,   611,
     366,   367,  1100,   369,   370,   371,   372,   373,   374,  1101,
     376,   612,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,   393,   394,
     395,   613,   397,   398,   614,   400,   401,   402,   403,  1102,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,  1103,  1104,
    1105,  1106,   427,   428,   429,  1107,  1108,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   616,   442,   443,   444,
    1109,   446,  1110,   448,   449,   450,   451,   452,   453,   454,
     455,   456,  1111,  1112,   617,  1113,   461,   462,   463,     0,
     464,   618,   466,  1114,     0,     0,     0,     0,     0,     0,
       0,     0,  1115,  1116,     1,     2,     0,     0,  1117,     0,
       0,     0,     0,  1118,     0,     0,     0,  1119,  1120,     0,
       0,  1121,  1122,     0,     3,     0,     4,     0,     5,     0,
       6,     0,     0,     0,     0,     0,     0,     0,     7,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     8,     0,     0,
       9,     0,    10,    11,     0,     0,     0,     0,     0,     0,
      12,     0,     0,     0,     0,     0,     0,    13,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      14,     0,     0,     0,     0,     0,    15,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,    17,    18,
       0,     0,     0,     0,     0,     0,     0,    19,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    20,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    21,     0,    22,     0,     0,     0,     0,    23,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    24,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    25,    26,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    27,    28,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    29,    30,    31,     0,    32,
       0,     0,     0,     0,    33,     0,     0,     0,     0,     0,
      34,     0,     0,     0,    35,     0,     0,     0,    36,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    38,     0,    39,     0,
      40,     0,     0,     0,     0,    41,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    42,    43,     0,     0,     0,
       0,     0,     0,    44,    45,    46,    47,     0,    48,    49,
      50,    51,    52,    53,     0,     0,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
       0,    88,    89,    90,    91,    92,    93,    94,     0,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,     0,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,     0,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
       0,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,     0,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,     0,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,     0,   172,     0,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,     0,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,     0,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,     0,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
       0,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,     0,   464,   465,   466,   467,     1,     2,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   468,     3,     0,     4,
       0,     5,     0,     6,     0,     0,     0,     0,     0,     0,
       0,     7,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       8,     0,     0,     9,     0,    10,    11,     0,     0,     0,
       0,     0,     0,    12,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    14,     0,     0,     0,     0,     0,    15,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      16,    17,    18,     0,     0,     0,     0,     0,     0,     0,
      19,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    20,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    21,     0,    22,     0,     0,     0,
       0,    23,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    24,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    25,    26,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    27,    28,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    29,    30,
      31,     0,    32,     0,     0,     0,     0,    33,     0,     0,
       0,     0,     0,    34,     0,     0,     0,    35,     0,     0,
       0,    36,    37,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    38,
       0,    39,     0,    40,     0,     0,     0,     0,    41,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    42,    43,
       0,     0,     0,     0,     0,     0,    44,    45,    46,    47,
       0,    48,    49,    50,    51,    52,    53,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,     0,    88,    89,    90,    91,    92,    93,
      94,     0,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,     0,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,     0,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,     0,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,     0,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,     0,   172,     0,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,     0,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,     0,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
       0,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,     0,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,     0,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,     0,   464,   465,   466,   467,
       1,     2,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   468,
       3,     0,     0,     0,     5,     0,     6,     0,     0,     0,
       0,     0,     0,     0,     7,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     9,     0,    10,    11,
       0,     0,     0,     0,     0,     0,    12,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    15,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,    17,     0,     0,     0,     0,     0,
       0,     0,     0,    19,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    20,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    21,     0,    22,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    24,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    25,    26,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    27,
      28,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    29,    30,     0,     0,    32,     0,     0,     0,     0,
      33,     0,     0,     0,     0,     0,    34,     0,     0,     0,
      35,     0,     0,     0,    36,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    38,     0,    39,     0,    40,     0,     0,     0,
       0,    41,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    43,     0,     0,     0,     0,     0,     0,    44,
      45,    46,    47,     0,    48,    49,    50,    51,    52,    53,
       0,     0,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,     0,     0,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     0,    88,    89,    90,
      91,    92,    93,    94,     0,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,     0,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,     0,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,     0,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,     0,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,     0,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,     0,   172,
       0,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,     0,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,     0,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,     0,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,     0,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   983,   984,   985,   986,   987,     0,     0,
       0,     0,     0,     0,     0,   988,   989,     0,   990,     0,
       0,     0,   468,     0,     0,   991,   992,     0,     0,   993,
     994,   995,   996,     0,   997,   998,     0,   999,  1000,     0,
       0,     0,     0,  1001,     0,     0,     0,  1002,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,  1005,  1006,     0,  1007,  1008,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1009,  1010,  1011,
       0,  1012,  1013,     0,     0,     0,  1014,  1015,  1016,     0,
       0,     0,     0,     0,     0,     0,  1017,     0,  1018,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1019,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1020,     0,     0,     0,     0,
    1021,  1022,     0,  1023,     0,     0,     0,     0,     0,  1024,
       0,  1025,     0,     0,  1026,     0,     0,  1027,  1028,  1029,
       0,  1030,  1031,  1032,     0,  1033,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1034,     0,     0,     0,  1035,  1036,  1037,     0,  1038,     0,
       0,     0,     0,     0,     0,  1039,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1040,     0,     0,     0,
       0,     0,     0,     0,  1041,     0,     0,  1042,     0,    34,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,     0,
       0,     0,     0,  1044,  1045,     0,  1046,  1047,     0,     0,
       0,  1048,     0,     0,     0,     0,     0,     0,     0,  1049,
    1050,  1051,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1052,  1053,  1054,    41,     0,     0,     0,     0,  1055,
       0,  1056,     0,     0,     0,    43,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   582,    48,    49,    50,
      51,    52,  1057,  1058,  1059,    54,    55,    56,  1060,    58,
      59,    60,    61,    62,    63,  1061,    65,    66,    67,    68,
      69,    70,    71,  1062,   583,     0,   584,   585,    77,    78,
      79,    80,    81,    82,   586,    84,    85,    86,    87,  1063,
      88,   588,    90,    91,    92,    93,    94,   589,  1064,    96,
    1065,  1066,    99,  1067,  1068,  1069,  1070,  1071,     0,   105,
     106,   107,   590,   109,   110,   111,   112,   113,   114,   115,
     116,   117,  1072,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,  1073,  1074,  1075,   592,   133,     0,
     134,   135,   136,   137,   138,   139,   140,   593,   142,   143,
     144,   145,   594,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   595,   160,     0,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     596,   597,   172,     0,  1076,   174,   175,   598,   177,   178,
    1077,   180,  1078,   599,   183,   184,   600,   186,   187,   601,
       0,   189,   190,   191,  1079,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   602,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   603,   212,  1080,  1081,   215,   216,
     217,  1082,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,  1083,
     257,  1084,   259,   260,   261,   262,  1085,  1086,  1087,  1088,
     267,   268,   269,   270,   271,   272,   273,   274,   275,  1089,
    1090,   278,   279,   280,   281,   282,   604,   283,   284,   285,
     286,   287,   288,   289,   290,   291,  1091,   293,   294,   295,
     605,   296,   297,   298,   299,   300,   301,   302,   303,   304,
    1092,   306,   307,   308,   309,   310,  1093,  1094,   313,   606,
     314,   607,   316,   317,  1095,   319,   320,   321,   322,   323,
     324,  1096,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     608,   345,   346,   609,   348,   349,   350,   351,   352,   353,
     354,  1097,   356,   610,   358,   359,   360,  1098,  1099,   363,
     364,   611,   366,   367,  1100,   369,   370,   371,   372,   373,
     374,  1101,   376,   612,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,     0,   392,
     393,   394,   395,   613,   397,   398,   614,   400,   401,   402,
     403,  1102,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
    1103,  1104,  1105,  1106,   427,   428,   429,  1107,  1108,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   616,   442,
     443,   444,  1109,   446,  1110,   448,   449,   450,   451,   452,
     453,   454,   455,   456,  1111,  1112,   617,  1113,   461,   462,
     463,     0,   464,   618,   466,  1114,     0,     0,     0,   983,
     984,   985,   986,   987,  1115,  1116,     0,  2535,     0,     0,
    1117,   988,   989,     0,   990,  1118,     0,     0,     0,  1119,
    1120,   991,   992,  1121,  1122,   993,   994,   995,   996,     0,
     997,   998,     0,   999,  1000,     0,     0,     0,     0,  1001,
       0,     0,     0,  1002,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,  1005,  1006,     0,
    1007,  1008,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1009,  1010,  1011,     0,  1012,  1013,     0,
       0,     0,  1014,  1015,  1016,     0,     0,     0,     0,     0,
       0,     0,  1017,     0,  1018,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2536,     0,  1019,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1020,     0,     0,     0,     0,  1021,  1022,     0,  1023,
       0,     0,     0,     0,     0,  1024,     0,  1025,     0,     0,
    1026,     0,     0,  1027,  1028,  1029,     0,  1030,  1031,  1032,
       0,  1033,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1034,     0,     0,     0,
    1035,  1036,  1037,     0,  1038,     0,     0,     0,     0,     0,
       0,  1039,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1040,     0,     0,     0,     0,     0,     0,     0,
    1041,     0,     0,  1042,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,     0,     0,     0,  1044,
    1045,     0,  1046,  1047,     0,     0,     0,  1048,     0,     0,
       0,     0,     0,  2537,     0,  1049,  1050,  1051,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1052,  1053,  1054,
       0,     0,     0,     0,     0,  1055,     0,  1056,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   582,    48,    49,    50,    51,    52,  1057,  1058,
    1059,    54,    55,    56,  1060,    58,    59,    60,    61,    62,
      63,  1061,    65,    66,    67,    68,    69,    70,    71,  1062,
     583,     0,   584,   585,    77,    78,    79,    80,    81,    82,
     586,    84,    85,    86,    87,  1063,    88,   588,    90,    91,
      92,    93,    94,   589,  1064,    96,  1065,  1066,    99,  1067,
    1068,  1069,  1070,  1071,     0,   105,   106,   107,   590,   109,
     110,   111,   112,   113,   114,   115,   116,   117,  1072,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
    1073,  1074,  1075,   592,   133,     0,   134,   135,   136,   137,
     138,   139,   140,   593,   142,   143,   144,   145,   594,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   595,   160,     0,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   596,   597,   172,     0,
    1076,   174,   175,   598,   177,   178,  1077,   180,  1078,   599,
     183,   184,   600,   186,   187,   601,     0,   189,   190,   191,
    1079,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     602,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     603,   212,  1080,  1081,   215,   216,   217,  1082,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,  1083,   257,  1084,   259,   260,
     261,   262,  1085,  1086,  1087,  1088,   267,   268,   269,   270,
     271,   272,   273,   274,   275,  1089,  1090,   278,   279,   280,
     281,   282,   604,   283,   284,   285,   286,   287,   288,   289,
     290,   291,  1091,   293,   294,   295,   605,   296,   297,   298,
     299,   300,   301,   302,   303,   304,  1092,   306,   307,   308,
     309,   310,  1093,  1094,   313,   606,   314,   607,   316,   317,
    1095,   319,   320,   321,   322,   323,   324,  1096,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   608,   345,   346,   609,
     348,   349,   350,   351,   352,   353,   354,  1097,   356,   610,
     358,   359,   360,  1098,  1099,   363,   364,   611,   366,   367,
    1100,   369,   370,   371,   372,   373,   374,  1101,   376,   612,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,     0,   392,   393,   394,   395,   613,
     397,   398,   614,   400,   401,   402,   403,  1102,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,  1103,  1104,  1105,  1106,
     427,   428,   429,  1107,  1108,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   616,   442,   443,   444,  1109,   446,
    1110,   448,   449,   450,   451,   452,   453,   454,   455,   456,
    1111,  1112,   617,  1113,   461,   462,   463,     0,   464,   618,
     466,  1114,     0,     0,     0,   983,   984,   985,   986,   987,
    1115,  1116,     0,     0,     0,     0,  1117,   988,   989,     0,
     990,  1118,     0,     0,     0,  1119,  1120,   991,   992,  1121,
    1122,   993,   994,   995,   996,     0,   997,   998,     0,   999,
    1000,     0,     0,     0,     0,  1001,     0,     0,     0,  1002,
       0,     0,  1003,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,  1007,  1008,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1009,
    1010,  1011,     0,  1012,  1013,     0,     0,     0,  1014,  1015,
    1016,     0,     0,     0,     0,     0,     0,     0,  1017,     0,
    1018,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1019,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1020,     0,     0,
       0,     0,  1021,  1022,     0,  1023,     0,     0,     0,     0,
       0,  1024,     0,  1025,     0,     0,  1026,     0,     0,  1027,
    1028,  1029,     0,  1030,  1031,  1032,     0,  1033,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1034,     0,     0,     0,  1035,  1036,  1037,     0,
    1038,     0,     0,     0,     0,     0,     0,  1039,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1040,     0,
       0,     0,     0,     0,     0,     0,  1041,     0,     0,  1042,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,     0,     0,     0,  1044,  1045,     0,  1046,  1047,
       0,     0,     0,  1048,     0,     0,     0,     0,     0,     0,
       0,  1049,  1050,  1051,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1052,  1053,  1054,     0,     0,     0,     0,
       0,  1055,     0,  1056,  1697,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   582,    48,
      49,    50,    51,    52,  1057,  1058,  1059,    54,    55,    56,
    1060,    58,    59,    60,    61,    62,    63,  1061,    65,    66,
      67,    68,    69,    70,    71,  1062,   583,     0,   584,   585,
      77,    78,    79,    80,    81,    82,   586,    84,    85,    86,
      87,  1063,    88,   588,    90,    91,    92,    93,    94,   589,
    1064,    96,  1065,  1066,    99,  1067,  1068,  1069,  1070,  1071,
       0,   105,   106,   107,   590,   109,   110,   111,   112,   113,
     114,   115,   116,   117,  1072,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,  1073,  1074,  1075,   592,
     133,     0,   134,   135,   136,   137,   138,   139,   140,   593,
     142,   143,   144,   145,   594,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   595,   160,
       0,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   596,   597,   172,     0,  1076,   174,   175,   598,
     177,   178,  1077,   180,  1078,   599,   183,   184,   600,   186,
     187,   601,     0,   189,   190,   191,  1079,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   602,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   603,   212,  1080,  1081,
     215,   216,   217,  1082,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,  1083,   257,  1084,   259,   260,   261,   262,  1085,  1086,
    1087,  1088,   267,   268,   269,   270,   271,   272,   273,   274,
     275,  1089,  1090,   278,   279,   280,   281,   282,   604,   283,
     284,   285,   286,   287,   288,   289,   290,   291,  1091,   293,
     294,   295,   605,   296,   297,   298,   299,   300,   301,   302,
     303,   304,  1092,   306,   307,   308,   309,   310,  1093,  1094,
     313,   606,   314,   607,   316,   317,  1095,   319,   320,   321,
     322,   323,   324,  1096,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   608,   345,   346,   609,   348,   349,   350,   351,
     352,   353,   354,  1097,   356,   610,   358,   359,   360,  1098,
    1099,   363,   364,   611,   366,   367,  1100,   369,   370,   371,
     372,   373,   374,  1101,   376,   612,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
       0,   392,   393,   394,   395,   613,   397,   398,   614,   400,
     401,   402,   403,  1102,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,  1103,  1104,  1105,  1106,   427,   428,   429,  1107,
    1108,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     616,   442,   443,   444,  1109,   446,  1110,   448,   449,   450,
     451,   452,   453,   454,   455,   456,  1111,  1112,   617,  1113,
     461,   462,   463,     0,   464,   618,   466,  1114,     0,     0,
       0,   983,   984,   985,   986,   987,  1115,  1116,     0,     0,
       0,     0,  1117,   988,   989,     0,   990,  1118,     0,     0,
       0,  1119,  1120,   991,   992,  1121,  1122,   993,   994,   995,
     996,     0,   997,   998,     0,   999,  1000,     0,     0,     0,
       0,  1001,     0,     0,     0,  2828,     0,     0,  1003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1004,  1005,
    1006,     0,  1007,  1008,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1009,  1010,  1011,     0,  1012,
    1013,     0,     0,     0,  1014,  1015,  1016,     0,  2829,     0,
       0,     0,     0,     0,  1017,     0,  1018,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1019,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1020,     0,     0,     0,     0,  1021,  1022,
       0,  1023,     0,     0,     0,     0,     0,  1024,     0,  1025,
       0,     0,  1026,     0,     0,  1027,  1028,  1029,     0,  1030,
    1031,  1032,     0,  1033,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1034,     0,
       0,     0,  1035,  1036,  1037,     0,  1038,     0,     0,     0,
       0,     0,     0,  1039,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1040,     0,     0,     0,     0,     0,
       0,     0,  1041,     0,     0,  1042,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1043,     0,     0,     0,     0,
       0,  1044,  1045,     0,  1046,  1047,     0,     0,     0,  1048,
       0,     0,     0,     0,     0,     0,     0,  1049,  1050,  1051,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1052,
    1053,  1054,     0,     0,     0,     0,     0,  1055,     0,  1056,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   582,    48,    49,    50,    51,    52,
    1057,  1058,  1059,    54,    55,    56,  1060,    58,    59,    60,
      61,    62,    63,  1061,    65,    66,    67,    68,    69,    70,
      71,  1062,   583,     0,   584,   585,    77,    78,    79,    80,
      81,    82,   586,    84,    85,    86,    87,  1063,    88,   588,
      90,    91,    92,    93,    94,   589,  1064,    96,  1065,  1066,
      99,  1067,  1068,  1069,  1070,  1071,     0,   105,   106,   107,
     590,   109,   110,   111,   112,   113,   114,   115,   116,   117,
    1072,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,  1073,  1074,  1075,   592,   133,     0,   134,   135,
     136,   137,   138,   139,   140,   593,   142,   143,   144,   145,
     594,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   595,   160,     0,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   596,   597,
     172,     0,  1076,   174,   175,   598,   177,   178,  1077,   180,
    1078,   599,   183,   184,   600,   186,   187,   601,     0,   189,
     190,   191,  1079,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   602,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   603,   212,  1080,  1081,   215,   216,   217,  1082,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,  1083,   257,  1084,
     259,   260,   261,   262,  1085,  1086,  1087,  1088,   267,   268,
     269,   270,   271,   272,   273,   274,   275,  1089,  1090,   278,
     279,   280,   281,   282,   604,   283,   284,   285,   286,   287,
     288,   289,   290,   291,  1091,   293,   294,   295,   605,   296,
     297,   298,   299,   300,   301,   302,   303,   304,  1092,   306,
     307,   308,   309,   310,  1093,  1094,   313,   606,   314,   607,
     316,   317,  1095,   319,   320,   321,   322,   323,   324,  1096,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   608,   345,
     346,   609,   348,   349,   350,   351,   352,   353,   354,  1097,
     356,   610,   358,   359,   360,  1098,  1099,   363,   364,   611,
     366,   367,  1100,   369,   370,   371,   372,   373,   374,  1101,
     376,   612,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,   393,   394,
     395,   613,   397,   398,   614,   400,   401,   402,   403,  1102,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,  1103,  1104,
    1105,  1106,   427,   428,   429,  1107,  1108,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   616,   442,   443,   444,
    1109,   446,  1110,   448,   449,   450,   451,   452,   453,   454,
     455,   456,  1111,  1112,   617,  1113,   461,   462,   463,     0,
     464,   618,   466,  1114,     0,     0,     0,   983,   984,   985,
     986,   987,  1115,  1116,     0,     0,     0,     0,  1117,   988,
     989,     0,   990,  1118,     0,     0,     0,  1119,  1120,   991,
     992,  1121,  1122,   993,   994,   995,   996,     0,   997,   998,
       0,   999,  1000,     0,     0,     0,     0,  1001,     0,     0,
       0,  1002,     0,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1004,  1005,  1006,     0,  1007,  1008,
       0,     0,     0,     0,     0,  3275,     0,     0,     0,     0,
       0,  1009,  1010,  1011,     0,  1012,  1013,     0,     0,     0,
    1014,  1015,  1016,     0,     0,     0,     0,     0,     0,     0,
    1017,     0,  1018,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1019,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1020,
       0,     0,     0,     0,  1021,  1022,     0,  1023,     0,     0,
       0,     0,     0,  1024,     0,  1025,     0,     0,  1026,     0,
       0,  1027,  1028,  1029,     0,  1030,  1031,  1032,     0,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1034,     0,     0,     0,  1035,  1036,
    1037,     0,  1038,     0,     0,     0,     0,     0,     0,  1039,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1040,     0,     0,     0,     0,     0,     0,     0,  1041,     0,
       0,  1042,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1043,     0,     0,     0,     0,     0,  1044,  1045,     0,
    1046,  1047,     0,     0,     0,  1048,     0,     0,     0,     0,
       0,     0,     0,  1049,  1050,  1051,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1052,  1053,  1054,     0,     0,
       0,     0,     0,  1055,     0,  1056,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     582,    48,    49,    50,    51,    52,  1057,  1058,  1059,    54,
      55,    56,  1060,    58,    59,    60,    61,    62,    63,  1061,
      65,    66,    67,    68,    69,    70,    71,  1062,   583,     0,
     584,   585,    77,    78,    79,    80,    81,    82,   586,    84,
      85,    86,    87,  1063,    88,   588,    90,    91,    92,    93,
      94,   589,  1064,    96,  1065,  1066,    99,  1067,  1068,  1069,
    1070,  1071,     0,   105,   106,   107,   590,   109,   110,   111,
     112,   113,   114,   115,   116,   117,  1072,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,  1073,  1074,
    1075,   592,   133,     0,   134,   135,   136,   137,   138,   139,
     140,   593,   142,   143,   144,   145,   594,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     595,   160,     0,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   596,   597,   172,     0,  1076,   174,
     175,   598,   177,   178,  1077,   180,  1078,   599,   183,   184,
     600,   186,   187,   601,     0,   189,   190,   191,  1079,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   602,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   603,   212,
    1080,  1081,   215,   216,   217,  1082,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,  1083,   257,  1084,   259,   260,   261,   262,
    1085,  1086,  1087,  1088,   267,   268,   269,   270,   271,   272,
     273,   274,   275,  1089,  1090,   278,   279,   280,   281,   282,
     604,   283,   284,   285,   286,   287,   288,   289,   290,   291,
    1091,   293,   294,   295,   605,   296,   297,   298,   299,   300,
     301,   302,   303,   304,  1092,   306,   307,   308,   309,   310,
    1093,  1094,   313,   606,   314,   607,   316,   317,  1095,   319,
     320,   321,   322,   323,   324,  1096,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   608,   345,   346,   609,   348,   349,
     350,   351,   352,   353,   354,  1097,   356,   610,   358,   359,
     360,  1098,  1099,   363,   364,   611,   366,   367,  1100,   369,
     370,   371,   372,   373,   374,  1101,   376,   612,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,     0,   392,   393,   394,   395,   613,   397,   398,
     614,   400,   401,   402,   403,  1102,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1103,  1104,  1105,  1106,   427,   428,
     429,  1107,  1108,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   616,   442,   443,   444,  1109,   446,  1110,   448,
     449,   450,   451,   452,   453,   454,   455,   456,  1111,  1112,
     617,  1113,   461,   462,   463,     0,   464,   618,   466,  1114,
       0,     0,     0,   983,   984,   985,   986,   987,  1115,  1116,
       0,     0,     0,     0,  1117,   988,   989,     0,   990,  1118,
       0,     0,     0,  1119,  1120,   991,   992,  1121,  1122,   993,
     994,   995,   996,     0,   997,   998,     0,   999,  1000,     0,
       0,     0,     0,  1001,     0,     0,     0,  1002,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,  1005,  1006,     0,  1007,  1008,     0,     0,     0,     0,
       0,  3277,     0,     0,     0,     0,     0,  1009,  1010,  1011,
       0,  1012,  1013,     0,     0,     0,  1014,  1015,  1016,     0,
       0,     0,     0,     0,     0,     0,  1017,     0,  1018,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1019,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1020,     0,     0,     0,     0,
    1021,  1022,     0,  1023,     0,     0,     0,     0,     0,  1024,
       0,  1025,     0,     0,  1026,     0,     0,  1027,  1028,  1029,
       0,  1030,  1031,  1032,     0,  1033,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1034,     0,     0,     0,  1035,  1036,  1037,     0,  1038,     0,
       0,     0,     0,     0,     0,  1039,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1040,     0,     0,     0,
       0,     0,     0,     0,  1041,     0,     0,  1042,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,     0,
       0,     0,     0,  1044,  1045,     0,  1046,  1047,     0,     0,
       0,  1048,     0,     0,     0,     0,     0,     0,     0,  1049,
    1050,  1051,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1052,  1053,  1054,     0,     0,     0,     0,     0,  1055,
       0,  1056,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   582,    48,    49,    50,
      51,    52,  1057,  1058,  1059,    54,    55,    56,  1060,    58,
      59,    60,    61,    62,    63,  1061,    65,    66,    67,    68,
      69,    70,    71,  1062,   583,     0,   584,   585,    77,    78,
      79,    80,    81,    82,   586,    84,    85,    86,    87,  1063,
      88,   588,    90,    91,    92,    93,    94,   589,  1064,    96,
    1065,  1066,    99,  1067,  1068,  1069,  1070,  1071,     0,   105,
     106,   107,   590,   109,   110,   111,   112,   113,   114,   115,
     116,   117,  1072,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,  1073,  1074,  1075,   592,   133,     0,
     134,   135,   136,   137,   138,   139,   140,   593,   142,   143,
     144,   145,   594,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   595,   160,     0,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     596,   597,   172,     0,  1076,   174,   175,   598,   177,   178,
    1077,   180,  1078,   599,   183,   184,   600,   186,   187,   601,
       0,   189,   190,   191,  1079,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   602,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   603,   212,  1080,  1081,   215,   216,
     217,  1082,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,  1083,
     257,  1084,   259,   260,   261,   262,  1085,  1086,  1087,  1088,
     267,   268,   269,   270,   271,   272,   273,   274,   275,  1089,
    1090,   278,   279,   280,   281,   282,   604,   283,   284,   285,
     286,   287,   288,   289,   290,   291,  1091,   293,   294,   295,
     605,   296,   297,   298,   299,   300,   301,   302,   303,   304,
    1092,   306,   307,   308,   309,   310,  1093,  1094,   313,   606,
     314,   607,   316,   317,  1095,   319,   320,   321,   322,   323,
     324,  1096,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     608,   345,   346,   609,   348,   349,   350,   351,   352,   353,
     354,  1097,   356,   610,   358,   359,   360,  1098,  1099,   363,
     364,   611,   366,   367,  1100,   369,   370,   371,   372,   373,
     374,  1101,   376,   612,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,     0,   392,
     393,   394,   395,   613,   397,   398,   614,   400,   401,   402,
     403,  1102,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
    1103,  1104,  1105,  1106,   427,   428,   429,  1107,  1108,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   616,   442,
     443,   444,  1109,   446,  1110,   448,   449,   450,   451,   452,
     453,   454,   455,   456,  1111,  1112,   617,  1113,   461,   462,
     463,     0,   464,   618,   466,  1114,     0,     0,     0,   983,
     984,   985,   986,   987,  1115,  1116,     0,     0,     0,     0,
    1117,   988,   989,     0,   990,  1118,     0,     0,     0,  1119,
    1120,   991,   992,  1121,  1122,   993,   994,   995,   996,     0,
     997,   998,     0,   999,  1000,     0,     0,     0,     0,  1001,
       0,     0,     0,  1002,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,  1005,  1006,     0,
    1007,  1008,     0,     0,     0,     0,     0,  3279,     0,     0,
       0,     0,     0,  1009,  1010,  1011,     0,  1012,  1013,     0,
       0,     0,  1014,  1015,  1016,     0,     0,     0,     0,     0,
       0,     0,  1017,     0,  1018,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1019,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1020,     0,     0,     0,     0,  1021,  1022,     0,  1023,
       0,     0,     0,     0,     0,  1024,     0,  1025,     0,     0,
    1026,     0,     0,  1027,  1028,  1029,     0,  1030,  1031,  1032,
       0,  1033,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1034,     0,     0,     0,
    1035,  1036,  1037,     0,  1038,     0,     0,     0,     0,     0,
       0,  1039,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1040,     0,     0,     0,     0,     0,     0,     0,
    1041,     0,     0,  1042,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,     0,     0,     0,  1044,
    1045,     0,  1046,  1047,     0,     0,     0,  1048,     0,     0,
       0,     0,     0,     0,     0,  1049,  1050,  1051,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1052,  1053,  1054,
       0,     0,     0,     0,     0,  1055,     0,  1056,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   582,    48,    49,    50,    51,    52,  1057,  1058,
    1059,    54,    55,    56,  1060,    58,    59,    60,    61,    62,
      63,  1061,    65,    66,    67,    68,    69,    70,    71,  1062,
     583,     0,   584,   585,    77,    78,    79,    80,    81,    82,
     586,    84,    85,    86,    87,  1063,    88,   588,    90,    91,
      92,    93,    94,   589,  1064,    96,  1065,  1066,    99,  1067,
    1068,  1069,  1070,  1071,     0,   105,   106,   107,   590,   109,
     110,   111,   112,   113,   114,   115,   116,   117,  1072,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
    1073,  1074,  1075,   592,   133,     0,   134,   135,   136,   137,
     138,   139,   140,   593,   142,   143,   144,   145,   594,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   595,   160,     0,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   596,   597,   172,     0,
    1076,   174,   175,   598,   177,   178,  1077,   180,  1078,   599,
     183,   184,   600,   186,   187,   601,     0,   189,   190,   191,
    1079,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     602,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     603,   212,  1080,  1081,   215,   216,   217,  1082,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,  1083,   257,  1084,   259,   260,
     261,   262,  1085,  1086,  1087,  1088,   267,   268,   269,   270,
     271,   272,   273,   274,   275,  1089,  1090,   278,   279,   280,
     281,   282,   604,   283,   284,   285,   286,   287,   288,   289,
     290,   291,  1091,   293,   294,   295,   605,   296,   297,   298,
     299,   300,   301,   302,   303,   304,  1092,   306,   307,   308,
     309,   310,  1093,  1094,   313,   606,   314,   607,   316,   317,
    1095,   319,   320,   321,   322,   323,   324,  1096,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   608,   345,   346,   609,
     348,   349,   350,   351,   352,   353,   354,  1097,   356,   610,
     358,   359,   360,  1098,  1099,   363,   364,   611,   366,   367,
    1100,   369,   370,   371,   372,   373,   374,  1101,   376,   612,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,     0,   392,   393,   394,   395,   613,
     397,   398,   614,   400,   401,   402,   403,  1102,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,  1103,  1104,  1105,  1106,
     427,   428,   429,  1107,  1108,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   616,   442,   443,   444,  1109,   446,
    1110,   448,   449,   450,   451,   452,   453,   454,   455,   456,
    1111,  1112,   617,  1113,   461,   462,   463,     0,   464,   618,
     466,  1114,     0,     0,     0,   983,   984,   985,   986,   987,
    1115,  1116,     0,     0,     0,     0,  1117,   988,   989,     0,
     990,  1118,     0,     0,     0,  1119,  1120,   991,   992,  1121,
    1122,   993,   994,   995,   996,     0,   997,   998,     0,   999,
    1000,     0,     0,     0,     0,  1001,     0,     0,     0,  4959,
       0,     0,  1003,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,  1007,  1008,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1009,
    1010,  1011,     0,  1012,  1013,     0,     0,     0,  1014,  1015,
    1016,     0,  2829,     0,     0,     0,     0,     0,  1017,     0,
    1018,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1019,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1020,     0,     0,
       0,     0,  1021,  1022,     0,  1023,     0,     0,     0,     0,
       0,  1024,     0,  1025,     0,     0,  1026,     0,     0,  1027,
    1028,  1029,     0,  1030,  1031,  1032,     0,  1033,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1034,     0,     0,     0,  1035,  1036,  1037,     0,
    1038,     0,     0,     0,     0,     0,     0,  1039,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1040,     0,
       0,     0,     0,     0,     0,     0,  1041,     0,     0,  1042,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,     0,     0,     0,  1044,  1045,     0,  1046,  1047,
       0,     0,     0,  1048,     0,     0,     0,     0,     0,     0,
       0,  1049,  1050,  1051,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1052,  1053,  1054,     0,     0,     0,     0,
       0,  1055,     0,  1056,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   582,    48,
      49,    50,    51,    52,  1057,  1058,  1059,    54,    55,    56,
    1060,    58,    59,    60,    61,    62,    63,  1061,    65,    66,
      67,    68,    69,    70,    71,  1062,   583,     0,   584,   585,
      77,    78,    79,    80,    81,    82,   586,    84,    85,    86,
      87,  1063,    88,   588,    90,    91,    92,    93,    94,   589,
    1064,    96,  1065,  1066,    99,  1067,  1068,  1069,  1070,  1071,
       0,   105,   106,   107,   590,   109,   110,   111,   112,   113,
     114,   115,   116,   117,  1072,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,  1073,  1074,  1075,   592,
     133,     0,   134,   135,   136,   137,   138,   139,   140,   593,
     142,   143,   144,   145,   594,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   595,   160,
       0,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   596,   597,   172,     0,  1076,   174,   175,   598,
     177,   178,  1077,   180,  1078,   599,   183,   184,   600,   186,
     187,   601,     0,   189,   190,   191,  1079,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   602,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   603,   212,  1080,  1081,
     215,   216,   217,  1082,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,  1083,   257,  1084,   259,   260,   261,   262,  1085,  1086,
    1087,  1088,   267,   268,   269,   270,   271,   272,   273,   274,
     275,  1089,  1090,   278,   279,   280,   281,   282,   604,   283,
     284,   285,   286,   287,   288,   289,   290,   291,  1091,   293,
     294,   295,   605,   296,   297,   298,   299,   300,   301,   302,
     303,   304,  1092,   306,   307,   308,   309,   310,  1093,  1094,
     313,   606,   314,   607,   316,   317,  1095,   319,   320,   321,
     322,   323,   324,  1096,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   608,   345,   346,   609,   348,   349,   350,   351,
     352,   353,   354,  1097,   356,   610,   358,   359,   360,  1098,
    1099,   363,   364,   611,   366,   367,  1100,   369,   370,   371,
     372,   373,   374,  1101,   376,   612,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
       0,   392,   393,   394,   395,   613,   397,   398,   614,   400,
     401,   402,   403,  1102,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,  1103,  1104,  1105,  1106,   427,   428,   429,  1107,
    1108,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     616,   442,   443,   444,  1109,   446,  1110,   448,   449,   450,
     451,   452,   453,   454,   455,   456,  1111,  1112,   617,  1113,
     461,   462,   463,     0,   464,   618,   466,  1114,     0,     0,
       0,   983,   984,   985,   986,   987,  1115,  1116,     0,     0,
       0,     0,  1117,   988,   989,     0,   990,  1118,     0,     0,
       0,  1119,  1120,   991,   992,  1121,  1122,   993,   994,   995,
     996,     0,   997,   998,     0,   999,  1000,     0,     0,     0,
       0,  1001,     0,     0,     0,  1002,     0,     0,  1003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1004,  1005,
    1006,     0,  1007,  1008,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1009,  1010,  1011,     0,  1012,
    1013,     0,     0,     0,  1014,  1015,  1016,     0,     0,     0,
       0,     0,     0,     0,  1017,     0,  1018,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1019,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1020,     0,     0,     0,     0,  1021,  1022,
       0,  1023,     0,     0,     0,     0,     0,  1024,     0,  1025,
       0,     0,  1026,     0,     0,  1027,  1028,  1029,     0,  1030,
    1031,  1032,     0,  1033,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1034,     0,
       0,     0,  1035,  1036,  1037,     0,  1038,     0,     0,     0,
       0,     0,     0,  1039,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1040,     0,     0,     0,     0,     0,
       0,     0,  1041,     0,     0,  1042,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1043,     0,     0,     0,     0,
       0,  1044,  1045,     0,  1046,  1047,     0,     0,     0,  1048,
       0,     0,     0,     0,     0,     0,     0,  1049,  1050,  1051,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1052,
    1053,  1054,     0,     0,     0,     0,     0,  1055,     0,  1056,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   582,    48,    49,    50,    51,    52,
    1057,  1058,  1059,    54,    55,    56,  1060,    58,    59,    60,
      61,    62,    63,  1061,    65,    66,    67,    68,    69,    70,
      71,  1062,   583,     0,   584,   585,    77,    78,    79,    80,
      81,    82,   586,    84,    85,    86,    87,  1063,    88,   588,
      90,    91,    92,    93,    94,   589,  1064,    96,  1065,  1066,
      99,  1067,  1068,  1069,  1070,  1071,     0,   105,   106,   107,
     590,   109,   110,   111,   112,   113,   114,   115,   116,   117,
    1072,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,  1073,  1074,  1075,   592,   133,     0,   134,   135,
     136,   137,   138,   139,   140,   593,   142,   143,   144,   145,
     594,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   595,   160,     0,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   596,   597,
     172,     0,  1076,   174,   175,   598,   177,   178,  1077,   180,
    1078,   599,   183,   184,   600,   186,   187,   601,     0,   189,
     190,   191,  1079,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   602,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   603,   212,  1080,  1081,   215,   216,   217,  1082,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,  1083,   257,  1084,
     259,   260,   261,   262,  1085,  1086,  1087,  1088,   267,   268,
     269,   270,   271,   272,   273,   274,   275,  1089,  1090,   278,
     279,   280,   281,   282,   604,   283,   284,   285,   286,   287,
     288,   289,   290,   291,  1091,   293,   294,   295,   605,   296,
     297,   298,   299,   300,   301,   302,   303,   304,  1092,   306,
     307,   308,   309,   310,  1093,  1094,   313,   606,   314,   607,
     316,   317,  1095,   319,   320,   321,   322,   323,   324,  1096,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   608,   345,
     346,   609,   348,   349,   350,   351,   352,   353,   354,  1097,
     356,   610,   358,   359,   360,  1098,  1099,   363,   364,   611,
     366,   367,  1100,   369,   370,   371,   372,   373,   374,  1101,
     376,   612,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,   393,   394,
     395,   613,   397,   398,   614,   400,   401,   402,   403,  1102,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,  1103,  1104,
    1105,  1106,   427,   428,   429,  1107,  1108,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   616,   442,   443,   444,
    1109,   446,  1110,   448,   449,   450,   451,   452,   453,   454,
     455,   456,  1111,  1112,   617,  1113,   461,   462,   463,     0,
     464,   618,   466,  1114,     0,     0,     0,   983,   984,   985,
     986,   987,  1115,  1116,     0,     0,     0,     0,  1117,   988,
     989,     0,   990,  1118,     0,     0,     0,  1119,  1120,   991,
     992,  1121,  1122,   993,   994,   995,   996,     0,   997,   998,
       0,   999,  1000,     0,     0,     0,     0,  1001,     0,     0,
       0,  1002,     0,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1004,  1005,  1006,     0,  1007,  1008,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1009,  1010,  1011,     0,  1012,  1013,     0,     0,     0,
    1014,  1015,  1016,     0,     0,     0,     0,     0,     0,     0,
    1017,     0,  1018,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1019,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1020,
       0,     0,     0,     0,  1021,  1022,     0,  1023,     0,     0,
       0,     0,     0,  1024,     0,  1025,     0,     0,  1026,     0,
       0,  1027,  1028,  1029,     0,  1030,  1031,  1032,     0,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1034,     0,     0,     0,  1035,  1036,
    1037,     0,  1038,     0,     0,     0,     0,     0,     0,  1039,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1040,     0,     0,     0,     0,     0,     0,     0,  1041,     0,
       0,  1042,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1043,     0,     0,     0,     0,     0,  1044,  1045,     0,
    1046,  1047,     0,     0,     0,  1048,     0,     0,     0,     0,
       0,     0,     0,  1049,  1050,  1051,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1052,  1053,  1054,     0,     0,
       0,     0,     0,  1055,     0,  1056,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     582,    48,    49,    50,    51,    52,  1057,  1058,  1059,    54,
      55,    56,  1060,    58,    59,    60,    61,    62,    63,  1061,
      65,    66,    67,    68,    69,    70,    71,  1062,   583,     0,
     584,   585,    77,    78,    79,    80,    81,    82,   586,    84,
      85,    86,    87,  1063,    88,   588,    90,    91,    92,    93,
      94,   589,  1064,    96,  1065,  1066,    99,  1067,  1068,  1069,
    1070,  1071,     0,   105,   106,   107,   590,   109,   110,   111,
     112,   113,   114,   115,   116,   117,  1072,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,  1073,  1074,
    1075,   592,   133,     0,   134,   135,   136,   137,   138,   139,
     140,   593,   142,   143,   144,   145,   594,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     595,   160,     0,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   596,   597,   172,     0,  1076,   174,
     175,   598,   177,   178,  1077,   180,  1078,   599,   183,   184,
     600,   186,   187,   601,     0,   189,   190,   191,  1079,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   602,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   603,   212,
    1080,  1081,   215,   216,   217,  1082,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,  1083,   257,  1084,   259,   260,   261,   262,
    1085,  1086,  1087,  1088,   267,   268,   269,   270,   271,   272,
     273,   274,   275,  1089,  1090,   278,   279,   280,   281,   282,
     604,   283,   284,   285,   286,   287,   288,   289,   290,   291,
    1091,   293,   294,   295,   605,   296,   297,   298,   299,   300,
     301,   302,   303,   304,  1092,   306,   307,   308,   309,   310,
    1093,  1094,   313,   606,   314,   607,   316,   317,  1095,   319,
     320,   321,   322,   323,   324,  1096,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   608,   345,   346,   609,   348,   349,
     350,   351,   352,   353,   354,  1097,   356,   610,   358,   359,
     360,  1098,  1099,   363,   364,   611,   366,   367,  1100,   369,
     370,   371,   372,   373,   374,  1101,   376,   612,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,     0,   392,   393,   394,   395,   613,   397,   398,
     614,   400,   401,   402,   403,  1102,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1103,  1104,  1105,  1106,   427,   428,
     429,  1107,  1108,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   616,   442,   443,   444,  1109,   446,  1110,   448,
     449,   450,   451,   452,   453,   454,   455,   456,  1111,  1112,
     617,  1113,   461,   462,   463,     0,   464,   618,   466,  1114,
       0,     0,     0,   983,   984,   985,   986,   987,  1115,  1116,
       0,     0,     0,     0,  1117,   988,   989,     0,   990,  1724,
       0,     0,     0,  1119,  1120,   991,   992,  1121,  1122,   993,
     994,   995,   996,     0,   997,   998,     0,   999,  1000,     0,
       0,     0,     0,  1001,     0,     0,     0,  1002,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,  1005,  1006,     0,  1007,  1008,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1009,  1010,  1011,
       0,  1012,  1013,     0,     0,     0,  1014,  1015,  1016,     0,
       0,     0,     0,     0,     0,     0,  1017,     0,  1018,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1019,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1020,     0,     0,     0,     0,
    1021,  1022,     0,  1023,     0,     0,     0,     0,     0,  1024,
       0,  1025,     0,     0,  1026,     0,     0,  1027,  1028,  1029,
       0,  1030,  1031,  1032,     0,  1033,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1034,     0,     0,     0,  1035,  1036,  1037,     0,  1038,     0,
       0,     0,     0,     0,     0,  1039,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1040,     0,     0,     0,
       0,     0,     0,     0,  1041,     0,     0,  1042,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,     0,
       0,     0,     0,  1044,  1045,     0,  1046,  1047,     0,     0,
       0,  1048,     0,     0,     0,     0,     0,     0,     0,  1049,
    1050,  1051,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1052,  1053,  1054,     0,     0,     0,     0,     0,  1055,
       0,  1056,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   582,    48,    49,    50,
      51,    52,  1057,  1058,  1059,    54,    55,    56,  1060,    58,
      59,    60,    61,    62,    63,  1061,    65,    66,    67,    68,
      69,    70,    71,  1062,   583,     0,   584,   585,    77,    78,
      79,    80,    81,    82,   586,    84,    85,    86,    87,  1063,
      88,   588,    90,    91,    92,    93,    94,   589,  1064,    96,
    1065,  1066,    99,  1067,  1068,  1069,  1070,  1071,     0,   105,
     106,   107,   590,   109,   110,   111,   112,   113,   114,   115,
     116,   117,  1072,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,  1073,  1074,  1075,   592,   133,     0,
     134,   135,   136,   137,   138,   139,   140,   593,   142,   143,
     144,   145,   594,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   595,   160,     0,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     596,   597,   172,     0,  1076,   174,   175,   598,   177,   178,
    1077,   180,  1078,   599,   183,   184,   600,   186,   187,   601,
       0,   189,   190,   191,  1079,  2391,   194,   195,   196,   197,
     198,   199,   200,   201,   602,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   603,   212,  1080,  1081,   215,   216,
     217,  1082,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,  1083,
     257,  1084,   259,   260,   261,   262,  1085,  1086,  1087,  1088,
     267,   268,   269,   270,   271,   272,   273,   274,   275,  1089,
    1090,   278,   279,   280,   281,   282,   604,   283,   284,   285,
     286,   287,   288,   289,   290,   291,  1091,   293,   294,   295,
     605,   296,   297,   298,   299,   300,   301,   302,   303,   304,
    1092,   306,   307,   308,   309,   310,  1093,  1094,   313,   606,
     314,   607,   316,   317,  1095,   319,   320,   321,   322,   323,
     324,  1096,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     608,   345,   346,   609,   348,   349,   350,   351,   352,   353,
     354,  1097,   356,   610,   358,   359,   360,  1098,  1099,   363,
     364,   611,   366,   367,  1100,   369,   370,   371,   372,   373,
     374,  1101,   376,   612,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,     0,   392,
     393,   394,   395,   613,   397,   398,   614,   400,   401,   402,
     403,  1102,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
    1103,  1104,  1105,  1106,   427,   428,   429,  1107,  1108,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   616,   442,
     443,   444,  2392,   446,  1110,   448,   449,   450,   451,   452,
     453,   454,   455,   456,  1111,  1112,   617,  1113,   461,   462,
     463,     0,   464,   618,   466,  1114,     0,     0,     0,   983,
     984,   985,   986,   987,  1115,  1116,     0,     0,     0,     0,
    1117,   988,   989,     0,   990,  1118,     0,     0,     0,  1119,
    1120,   991,   992,  1121,  1122,   993,   994,   995,   996,     0,
     997,   998,     0,   999,  1000,     0,     0,     0,     0,  1001,
       0,     0,     0,  1002,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,  1005,  1006,     0,
    1007,  1008,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1009,  1010,  1011,     0,  1012,  1013,     0,
       0,     0,  1014,  1015,  1016,     0,     0,     0,     0,     0,
       0,     0,  1017,     0,  1018,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1019,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1020,     0,     0,     0,     0,  1021,  1022,     0,  1023,
       0,     0,     0,     0,     0,  1024,     0,  1025,     0,     0,
    1026,     0,     0,  1027,  1028,  1029,     0,  1030,  1031,  1032,
       0,  1033,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1034,     0,     0,     0,
    1035,  1036,  1037,     0,  1038,     0,     0,     0,     0,     0,
       0,  1039,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1040,     0,     0,     0,     0,     0,     0,     0,
    1041,     0,     0,  1042,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,     0,     0,     0,  1044,
    1045,     0,  1046,  1047,     0,     0,     0,  1048,     0,     0,
       0,     0,     0,     0,     0,  1049,  1050,  1051,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1052,  1053,  1054,
       0,     0,     0,     0,     0,  1055,     0,  1056,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   582,    48,    49,    50,    51,    52,  1057,  1058,
    1059,    54,    55,    56,  1060,    58,    59,    60,    61,    62,
      63,  1061,    65,    66,    67,    68,    69,    70,    71,  1062,
     583,     0,   584,   585,    77,    78,    79,    80,    81,    82,
     586,    84,    85,    86,    87,  1063,    88,   588,    90,    91,
      92,    93,    94,   589,  1064,    96,  1065,  1066,    99,  1067,
    1068,  1069,  1070,  1071,     0,   105,   106,   107,   590,   109,
     110,   111,   112,   113,   114,   115,   116,   117,  1072,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
    1073,  1074,  1075,   592,   133,     0,   134,   135,   136,   137,
     138,   139,   140,   593,   142,   143,   144,   145,   594,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   595,   160,     0,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   596,   597,   172,     0,
    1076,   174,   175,   598,   177,   178,  1077,   180,  1078,   599,
     183,   184,   600,   186,   187,   601,     0,   189,   190,   191,
    1079,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     602,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     603,   212,  1080,  1081,   215,   216,   217,  1082,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,  1083,   257,  1084,   259,   260,
     261,   262,  1085,  1086,  1087,  1088,   267,   268,   269,   270,
     271,   272,   273,   274,   275,  1089,  1090,   278,   279,   280,
     281,   282,   604,   283,   284,   285,   286,   287,   288,   289,
     290,   291,  1091,   293,   294,   295,   605,   296,   297,   298,
     299,   300,   301,   302,   303,   304,  1092,   306,   307,   308,
     309,   310,  1093,  1094,   313,   606,   314,   607,   316,   317,
    1095,   319,   320,   321,   322,   323,   324,  1096,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   608,   345,   346,   609,
     348,   349,   350,   351,   352,   353,   354,  1097,   356,   610,
     358,   359,   360,  1098,  1099,   363,   364,   611,   366,   367,
    1100,   369,   370,   371,   372,   373,   374,  1101,   376,   612,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,     0,   392,   393,   394,   395,   613,
     397,   398,   614,   400,   401,   402,   403,  1102,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,  1103,  1104,  1105,  1106,
     427,   428,   429,  1107,  1108,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   616,   442,   443,   444,  2392,   446,
    1110,   448,   449,   450,   451,   452,   453,   454,   455,   456,
    1111,  1112,   617,  1113,   461,   462,   463,     0,   464,   618,
     466,  1114,     0,     0,     0,   983,   984,   985,   986,   987,
    1115,  1116,     0,     0,     0,     0,  1117,   988,   989,     0,
     990,  1118,     0,     0,     0,  1119,  1120,   991,   992,  1121,
    1122,   993,   994,   995,   996,     0,   997,   998,     0,   999,
    1000,     0,     0,     0,     0,  1001,     0,     0,     0,  1002,
       0,     0,  1003,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,  1007,  1008,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1009,
    1010,  1011,     0,  1012,  1013,     0,     0,     0,  1014,  1015,
    1016,     0,     0,     0,     0,     0,     0,     0,  1017,     0,
    3891,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1019,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1020,     0,     0,
       0,     0,  1021,  1022,     0,  1023,     0,     0,     0,     0,
       0,  1024,     0,  1025,     0,     0,  1026,     0,     0,  1027,
    1028,  1029,     0,  1030,  1031,  1032,     0,  1033,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1034,     0,     0,     0,  1035,  1036,  1037,     0,
    1038,     0,     0,     0,     0,     0,     0,  1039,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1040,     0,
       0,     0,     0,     0,     0,     0,  1041,     0,     0,  1042,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,     0,     0,     0,  1044,  1045,     0,  1046,  1047,
       0,     0,     0,  1048,     0,     0,     0,     0,     0,     0,
       0,  1049,  1050,  1051,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1052,  1053,  1054,     0,     0,     0,     0,
       0,  1055,     0,  1056,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   582,    48,
      49,    50,    51,    52,  1057,  1058,  1059,    54,    55,    56,
    1060,    58,    59,    60,    61,    62,    63,  1061,    65,    66,
      67,    68,    69,    70,    71,  1062,   583,     0,   584,   585,
      77,    78,    79,    80,    81,    82,   586,    84,    85,    86,
      87,  1063,    88,   588,    90,    91,    92,    93,    94,   589,
    1064,    96,  1065,  1066,    99,  1067,  1068,  1069,  1070,  1071,
       0,   105,   106,   107,   590,   109,   110,   111,   112,   113,
     114,   115,   116,   117,  1072,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,  1073,  1074,  1075,   592,
     133,     0,   134,   135,   136,   137,   138,   139,   140,   593,
     142,   143,   144,   145,   594,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   595,   160,
       0,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   596,   597,   172,     0,  1076,   174,   175,   598,
     177,   178,  1077,   180,  1078,   599,   183,   184,   600,   186,
     187,   601,     0,   189,   190,   191,  1079,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   602,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   603,   212,  1080,  1081,
     215,   216,   217,  1082,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,  1083,   257,  1084,   259,   260,   261,   262,  1085,  1086,
    1087,  1088,   267,   268,   269,   270,   271,   272,   273,   274,
     275,  1089,  1090,   278,   279,   280,   281,   282,   604,   283,
     284,   285,   286,   287,   288,   289,   290,   291,  1091,   293,
     294,   295,   605,   296,   297,   298,   299,   300,   301,   302,
     303,   304,  1092,   306,   307,   308,   309,   310,  1093,  1094,
     313,   606,   314,   607,   316,   317,  1095,   319,   320,   321,
     322,   323,   324,  1096,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   608,   345,   346,   609,   348,   349,   350,   351,
     352,   353,   354,  1097,   356,   610,   358,   359,   360,  1098,
    1099,   363,   364,   611,   366,   367,  1100,   369,   370,   371,
     372,   373,   374,  1101,   376,   612,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
       0,   392,   393,   394,   395,   613,   397,   398,   614,   400,
     401,   402,   403,  1102,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,  1103,  1104,  1105,  1106,   427,   428,   429,  1107,
    1108,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     616,   442,   443,   444,  1109,   446,  1110,   448,   449,   450,
     451,   452,   453,   454,   455,   456,  1111,  1112,   617,  1113,
     461,   462,   463,     0,   464,   618,   466,  1114,     0,     0,
       0,   983,   984,   985,   986,   987,  1115,  1116,     0,     0,
       0,     0,  1117,   988,   989,     0,   990,  1118,     0,     0,
       0,  1119,  1120,   991,   992,  1121,  1122,   993,   994,   995,
     996,     0,   997,   998,     0,   999,  1000,     0,     0,     0,
       0,  1001,     0,     0,     0,  1002,     0,     0,  1003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1004,  1005,
    1006,     0,  1007,  1008,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1009,  1010,  1011,     0,  1012,
    1013,     0,     0,     0,  1014,  1015,  1016,     0,     0,     0,
       0,     0,     0,     0,  1017,     0,  3910,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1019,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1020,     0,     0,     0,     0,  1021,  1022,
       0,  1023,     0,     0,     0,     0,     0,  1024,     0,  1025,
       0,     0,  1026,     0,     0,  1027,  1028,  1029,     0,  1030,
    1031,  1032,     0,  1033,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1034,     0,
       0,     0,  1035,  1036,  1037,     0,  1038,     0,     0,     0,
       0,     0,     0,  1039,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1040,     0,     0,     0,     0,     0,
       0,     0,  1041,     0,     0,  1042,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1043,     0,     0,     0,     0,
       0,  1044,  1045,     0,  1046,  1047,     0,     0,     0,  1048,
       0,     0,     0,     0,     0,     0,     0,  1049,  1050,  1051,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1052,
    1053,  1054,     0,     0,     0,     0,     0,  1055,     0,  1056,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   582,    48,    49,    50,    51,    52,
    1057,  1058,  1059,    54,    55,    56,  1060,    58,    59,    60,
      61,    62,    63,  1061,    65,    66,    67,    68,    69,    70,
      71,  1062,   583,     0,   584,   585,    77,    78,    79,    80,
      81,    82,   586,    84,    85,    86,    87,  1063,    88,   588,
      90,    91,    92,    93,    94,   589,  1064,    96,  1065,  1066,
      99,  1067,  1068,  1069,  1070,  1071,     0,   105,   106,   107,
     590,   109,   110,   111,   112,   113,   114,   115,   116,   117,
    1072,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,  1073,  1074,  1075,   592,   133,     0,   134,   135,
     136,   137,   138,   139,   140,   593,   142,   143,   144,   145,
     594,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   595,   160,     0,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   596,   597,
     172,     0,  1076,   174,   175,   598,   177,   178,  1077,   180,
    1078,   599,   183,   184,   600,   186,   187,   601,     0,   189,
     190,   191,  1079,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   602,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   603,   212,  1080,  1081,   215,   216,   217,  1082,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,  1083,   257,  1084,
     259,   260,   261,   262,  1085,  1086,  1087,  1088,   267,   268,
     269,   270,   271,   272,   273,   274,   275,  1089,  1090,   278,
     279,   280,   281,   282,   604,   283,   284,   285,   286,   287,
     288,   289,   290,   291,  1091,   293,   294,   295,   605,   296,
     297,   298,   299,   300,   301,   302,   303,   304,  1092,   306,
     307,   308,   309,   310,  1093,  1094,   313,   606,   314,   607,
     316,   317,  1095,   319,   320,   321,   322,   323,   324,  1096,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   608,   345,
     346,   609,   348,   349,   350,   351,   352,   353,   354,  1097,
     356,   610,   358,   359,   360,  1098,  1099,   363,   364,   611,
     366,   367,  1100,   369,   370,   371,   372,   373,   374,  1101,
     376,   612,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,   393,   394,
     395,   613,   397,   398,   614,   400,   401,   402,   403,  1102,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,  1103,  1104,
    1105,  1106,   427,   428,   429,  1107,  1108,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   616,   442,   443,   444,
    1109,   446,  1110,   448,   449,   450,   451,   452,   453,   454,
     455,   456,  1111,  1112,   617,  1113,   461,   462,   463,     0,
     464,   618,   466,  1114,     0,     0,     0,   983,   984,   985,
     986,   987,  1115,  1116,     0,     0,     0,     0,  1117,   988,
     989,     0,   990,  1118,     0,     0,     0,  1119,  1120,   991,
     992,  1121,  1122,   993,   994,   995,   996,     0,   997,   998,
       0,   999,  1000,     0,     0,     0,     0,  1001,     0,     0,
       0,  1002,     0,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1004,  1005,  1006,     0,  1007,  1008,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1009,  1010,  1011,     0,  1012,  1013,     0,     0,     0,
    1014,  1015,  1016,     0,     0,     0,     0,     0,     0,     0,
    1017,     0,  1018,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1019,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1020,
       0,     0,     0,     0,  1021,  1022,  6012,  1023,     0,     0,
       0,     0,     0,  1024,     0,  1025,     0,     0,  1026,     0,
       0,  1027,     0,  1029,     0,  1030,  1031,  1032,     0,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1034,     0,     0,     0,  1035,  1036,
    1037,     0,  1038,     0,     0,     0,     0,     0,     0,  1039,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1040,     0,     0,     0,     0,     0,     0,     0,  1041,     0,
       0,  1042,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1043,     0,     0,     0,     0,     0,  1044,  1045,     0,
    1046,  1047,     0,     0,     0,  1048,     0,     0,     0,     0,
       0,     0,     0,  1049,  1050,  1051,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1052,  1053,  1054,     0,     0,
       0,     0,     0,  1055,     0,  1056,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     582,    48,    49,    50,    51,    52,  1057,  1058,  1059,    54,
      55,    56,  1060,    58,    59,    60,    61,    62,    63,  1061,
      65,    66,    67,    68,    69,    70,    71,  1062,   583,     0,
     584,   585,    77,    78,    79,    80,    81,    82,   586,    84,
      85,    86,    87,  1063,    88,   588,    90,    91,    92,    93,
      94,   589,  1064,    96,  1065,  1066,    99,  1067,  1068,  1069,
    1070,  1071,     0,   105,   106,   107,   590,   109,   110,   111,
     112,   113,   114,   115,   116,   117,  1072,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,  1073,  1074,
    1075,   592,   133,     0,   134,   135,   136,   137,   138,   139,
     140,   593,   142,   143,   144,   145,   594,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     595,   160,     0,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   596,   597,   172,     0,  1076,   174,
     175,   598,   177,   178,  1077,   180,  1078,   599,   183,   184,
     600,   186,   187,   601,     0,   189,   190,   191,  1079,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   602,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   603,   212,
    1080,  1081,   215,   216,   217,  1082,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,  1083,   257,  1084,   259,   260,   261,   262,
    1085,  1086,  1087,  1088,   267,   268,   269,   270,   271,   272,
     273,   274,   275,  1089,  1090,   278,   279,   280,   281,   282,
     604,   283,   284,   285,   286,   287,   288,   289,   290,   291,
    1091,   293,   294,   295,   605,   296,   297,   298,   299,   300,
     301,   302,   303,   304,  1092,   306,   307,   308,   309,   310,
    1093,  1094,   313,   606,   314,   607,   316,   317,  1095,   319,
     320,   321,   322,   323,   324,  1096,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   608,   345,   346,   609,   348,   349,
     350,   351,   352,   353,   354,  1097,   356,   610,   358,   359,
     360,  1098,  1099,   363,   364,   611,   366,   367,  1100,   369,
     370,   371,   372,   373,   374,  1101,   376,   612,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,     0,   392,   393,   394,   395,   613,   397,   398,
     614,   400,   401,   402,   403,  1102,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1103,  1104,  1105,  1106,   427,   428,
     429,  1107,  1108,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   616,   442,   443,   444,  1109,   446,  1110,   448,
     449,   450,   451,   452,   453,   454,   455,   456,  1111,  1112,
     617,  1113,   461,   462,   463,     0,   464,   618,   466,  1114,
       0,     0,     0,   983,   984,   985,   986,   987,  1115,  1116,
       0,     0,     0,     0,  1117,   988,   989,     0,   990,  1118,
       0,     0,     0,  1119,  1120,   991,   992,  1121,  1122,   993,
     994,   995,   996,     0,   997,   998,     0,   999,  1000,     0,
       0,     0,     0,  1001,     0,     0,     0,  1002,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,  1005,  1006,     0,  1007,  1008,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1009,  1010,  1011,
       0,  1012,  1013,     0,     0,     0,  1014,  1015,  1016,     0,
       0,     0,     0,     0,     0,     0,  1017,     0,  1690,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1019,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1020,     0,     0,     0,     0,
    1021,  1022,     0,  1023,     0,     0,     0,     0,     0,  1024,
       0,  1025,     0,     0,  1026,     0,     0,  1027,     0,  1029,
       0,  1030,  1031,  1032,     0,  1033,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1034,     0,     0,     0,  1035,  1036,  1037,     0,  1038,     0,
       0,     0,     0,     0,     0,  1039,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1040,     0,     0,     0,
       0,     0,     0,     0,  1041,     0,     0,  1042,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,     0,
       0,     0,     0,  1044,  1045,     0,  1046,  1047,     0,     0,
       0,  1048,     0,     0,     0,     0,     0,     0,     0,  1049,
    1050,  1051,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1052,  1053,  1054,     0,     0,     0,     0,     0,  1055,
       0,  1056,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   582,    48,    49,    50,
      51,    52,  1057,  1058,  1059,    54,    55,    56,  1060,    58,
      59,    60,    61,    62,    63,  1061,    65,    66,    67,    68,
      69,    70,    71,  1062,   583,     0,   584,   585,    77,    78,
      79,    80,    81,    82,   586,    84,    85,    86,    87,  1063,
      88,   588,    90,    91,    92,    93,    94,   589,  1064,    96,
    1065,  1066,    99,  1067,  1068,  1069,  1070,  1071,     0,   105,
     106,   107,   590,   109,   110,   111,   112,   113,   114,   115,
     116,   117,  1072,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,  1073,  1074,  1075,   592,   133,     0,
     134,   135,   136,   137,   138,   139,   140,   593,   142,   143,
     144,   145,   594,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   595,   160,     0,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     596,   597,   172,     0,  1076,   174,   175,   598,   177,   178,
    1077,   180,  1078,   599,   183,   184,   600,   186,   187,   601,
       0,   189,   190,   191,  1079,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   602,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   603,   212,  1080,  1081,   215,   216,
     217,  1082,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,  1083,
     257,  1084,   259,   260,   261,   262,  1085,  1086,  1087,  1088,
     267,   268,   269,   270,   271,   272,   273,   274,   275,  1089,
    1090,   278,   279,   280,   281,   282,   604,   283,   284,   285,
     286,   287,   288,   289,   290,   291,  1091,   293,   294,   295,
     605,   296,   297,   298,   299,   300,   301,   302,   303,   304,
    1092,   306,   307,   308,   309,   310,  1093,  1094,   313,   606,
     314,   607,   316,   317,  1095,   319,   320,   321,   322,   323,
     324,  1096,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     608,   345,   346,   609,   348,   349,   350,   351,   352,   353,
     354,  1097,   356,   610,   358,   359,   360,  1098,  1099,   363,
     364,   611,   366,   367,  1100,   369,   370,   371,   372,   373,
     374,  1101,   376,   612,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,     0,   392,
     393,   394,   395,   613,   397,   398,   614,   400,   401,   402,
     403,  1102,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
    1103,  1104,  1105,  1106,   427,   428,   429,  1107,  1108,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   616,   442,
     443,   444,  1109,   446,  1110,   448,   449,   450,   451,   452,
     453,   454,   455,   456,  1111,  1112,   617,  1113,   461,   462,
     463,     0,   464,   618,   466,  1114,     0,     0,     0,   983,
     984,   985,   986,   987,  1691,  1692,     0,     0,     0,     0,
    1117,   988,   989,     0,   990,  1118,     0,     0,     0,  1119,
    1120,   991,   992,  1121,  1122,   993,   994,   995,   996,     0,
     997,   998,     0,   999,  1000,     0,     0,     0,     0,  1001,
       0,     0,     0,  1002,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,  1005,  1006,     0,
    1007,  1008,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1009,  1010,  1011,     0,  1012,  1013,     0,
       0,     0,  1014,  1015,  1016,     0,     0,     0,     0,     0,
       0,     0,  1017,     0,  1826,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1019,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1020,     0,     0,     0,     0,  1021,  1022,     0,  1023,
       0,     0,     0,     0,     0,  1024,     0,  1025,     0,     0,
    1026,     0,     0,  1027,     0,  1029,     0,  1030,  1031,  1032,
       0,  1033,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1034,     0,     0,     0,
    1035,  1036,  1037,     0,  1038,     0,     0,     0,     0,     0,
       0,  1039,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1040,     0,     0,     0,     0,     0,     0,     0,
    1041,     0,     0,  1042,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,     0,     0,     0,  1044,
    1045,     0,  1046,  1047,     0,     0,     0,  1048,     0,     0,
       0,     0,     0,     0,     0,  1049,  1050,  1051,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1052,  1053,  1054,
       0,     0,     0,     0,     0,  1055,     0,  1056,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   582,    48,    49,    50,    51,    52,  1057,  1058,
    1059,    54,    55,    56,  1060,    58,    59,    60,    61,    62,
      63,  1061,    65,    66,    67,    68,    69,    70,    71,  1062,
     583,     0,   584,   585,    77,    78,    79,    80,    81,    82,
     586,    84,    85,    86,    87,  1063,    88,   588,    90,    91,
      92,    93,    94,   589,  1064,    96,  1065,  1066,    99,  1067,
    1068,  1069,  1070,  1071,     0,   105,   106,   107,   590,   109,
     110,   111,   112,   113,   114,   115,   116,   117,  1072,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
    1073,  1074,  1075,   592,   133,     0,   134,   135,   136,   137,
     138,   139,   140,   593,   142,   143,   144,   145,   594,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   595,   160,     0,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   596,   597,   172,     0,
    1076,   174,   175,   598,   177,   178,  1077,   180,  1078,   599,
     183,   184,   600,   186,   187,   601,     0,   189,   190,   191,
    1079,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     602,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     603,   212,  1080,  1081,   215,   216,   217,  1082,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,  1083,   257,  1084,   259,   260,
     261,   262,  1085,  1086,  1087,  1088,   267,   268,   269,   270,
     271,   272,   273,   274,   275,  1089,  1090,   278,   279,   280,
     281,   282,   604,   283,   284,   285,   286,   287,   288,   289,
     290,   291,  1091,   293,   294,   295,   605,   296,   297,   298,
     299,   300,   301,   302,   303,   304,  1092,   306,   307,   308,
     309,   310,  1093,  1094,   313,   606,   314,   607,   316,   317,
    1095,   319,   320,   321,   322,   323,   324,  1096,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   608,   345,   346,   609,
     348,   349,   350,   351,   352,   353,   354,  1097,   356,   610,
     358,   359,   360,  1098,  1099,   363,   364,   611,   366,   367,
    1100,   369,   370,   371,   372,   373,   374,  1101,   376,   612,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,     0,   392,   393,   394,   395,   613,
     397,   398,   614,   400,   401,   402,   403,  1102,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,  1103,  1104,  1105,  1106,
     427,   428,   429,  1107,  1108,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   616,   442,   443,   444,  1109,   446,
    1110,   448,   449,   450,   451,   452,   453,   454,   455,   456,
    1111,  1112,   617,  1113,   461,   462,   463,     0,   464,   618,
     466,  1114,     0,     0,     0,   983,   984,   985,   986,   987,
    1691,  1692,     0,     0,     0,     0,  1117,   988,   989,     0,
     990,  1118,     0,     0,     0,  1119,  1120,   991,   992,  1121,
    1122,   993,   994,   995,   996,     0,   997,   998,     0,   999,
    1000,     0,     0,     0,     0,  1001,     0,     0,     0,  1002,
       0,     0,  1003,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,  1005,  1006,     0,  1007,  1008,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1009,
    1010,  1011,     0,  1012,  1013,     0,     0,     0,  1014,  1015,
    1016,     0,     0,     0,     0,     0,     0,     0,  1017,     0,
    1828,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1019,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1020,     0,     0,
       0,     0,  1021,  1022,     0,  1023,     0,     0,     0,     0,
       0,  1024,     0,  1025,     0,     0,  1026,     0,     0,  1027,
       0,  1029,     0,  1030,  1031,  1032,     0,  1033,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1034,     0,     0,     0,  1035,  1036,  1037,     0,
    1038,     0,     0,     0,     0,     0,     0,  1039,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1040,     0,
       0,     0,     0,     0,     0,     0,  1041,     0,     0,  1042,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,     0,     0,     0,  1044,  1045,     0,  1046,  1047,
       0,     0,     0,  1048,     0,     0,     0,     0,     0,     0,
       0,  1049,  1050,  1051,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1052,  1053,  1054,     0,     0,     0,     0,
       0,  1055,     0,  1056,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   582,    48,
      49,    50,    51,    52,  1057,  1058,  1059,    54,    55,    56,
    1060,    58,    59,    60,    61,    62,    63,  1061,    65,    66,
      67,    68,    69,    70,    71,  1062,   583,     0,   584,   585,
      77,    78,    79,    80,    81,    82,   586,    84,    85,    86,
      87,  1063,    88,   588,    90,    91,    92,    93,    94,   589,
    1064,    96,  1065,  1066,    99,  1067,  1068,  1069,  1070,  1071,
       0,   105,   106,   107,   590,   109,   110,   111,   112,   113,
     114,   115,   116,   117,  1072,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,  1073,  1074,  1075,   592,
     133,     0,   134,   135,   136,   137,   138,   139,   140,   593,
     142,   143,   144,   145,   594,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   595,   160,
       0,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   596,   597,   172,     0,  1076,   174,   175,   598,
     177,   178,  1077,   180,  1078,   599,   183,   184,   600,   186,
     187,   601,     0,   189,   190,   191,  1079,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   602,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   603,   212,  1080,  1081,
     215,   216,   217,  1082,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,  1083,   257,  1084,   259,   260,   261,   262,  1085,  1086,
    1087,  1088,   267,   268,   269,   270,   271,   272,   273,   274,
     275,  1089,  1090,   278,   279,   280,   281,   282,   604,   283,
     284,   285,   286,   287,   288,   289,   290,   291,  1091,   293,
     294,   295,   605,   296,   297,   298,   299,   300,   301,   302,
     303,   304,  1092,   306,   307,   308,   309,   310,  1093,  1094,
     313,   606,   314,   607,   316,   317,  1095,   319,   320,   321,
     322,   323,   324,  1096,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   608,   345,   346,   609,   348,   349,   350,   351,
     352,   353,   354,  1097,   356,   610,   358,   359,   360,  1098,
    1099,   363,   364,   611,   366,   367,  1100,   369,   370,   371,
     372,   373,   374,  1101,   376,   612,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
       0,   392,   393,   394,   395,   613,   397,   398,   614,   400,
     401,   402,   403,  1102,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,  1103,  1104,  1105,  1106,   427,   428,   429,  1107,
    1108,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     616,   442,   443,   444,  1109,   446,  1110,   448,   449,   450,
     451,   452,   453,   454,   455,   456,  1111,  1112,   617,  1113,
     461,   462,   463,     0,   464,   618,   466,  1114,     0,     0,
       0,   983,   984,   985,   986,   987,  1691,  1692,     0,     0,
       0,     0,  1117,   988,   989,     0,   990,  1118,     0,     0,
       0,  1119,  1120,   991,   992,  1121,  1122,   993,   994,   995,
     996,     0,   997,   998,     0,   999,  1000,     0,     0,     0,
       0,  1001,     0,     0,     0,  1002,     0,     0,  1003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1004,  1005,
    1006,     0,  1007,  1008,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1009,  1010,  1011,     0,  1012,
    1013,     0,     0,     0,  1014,  1015,  1016,     0,     0,     0,
       0,     0,     0,     0,  1017,     0,  1018,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1019,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1020,     0,     0,     0,     0,  1021,  1022,
       0,  1023,     0,     0,     0,     0,     0,  1024,     0,  1025,
       0,     0,  1026,     0,     0,  1027,     0,  1029,     0,  1030,
    1031,  1032,     0,  1033,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1034,     0,
       0,     0,  1035,  1036,  1037,     0,  1038,     0,     0,     0,
       0,     0,     0,  1039,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1040,     0,     0,     0,     0,     0,
       0,     0,  1041,     0,     0,  1042,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1043,     0,     0,     0,     0,
       0,  1044,  1045,     0,  1046,  1047,     0,     0,     0,  1048,
       0,     0,     0,     0,     0,     0,     0,  1049,  1050,  1051,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1052,
    1053,  1054,     0,     0,     0,     0,     0,  1055,     0,  1056,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   582,    48,    49,    50,    51,    52,
    1057,  1058,  1059,    54,    55,    56,  1060,    58,    59,    60,
      61,    62,    63,  1061,    65,    66,    67,    68,    69,    70,
      71,  1062,   583,     0,   584,   585,    77,    78,    79,    80,
      81,    82,   586,    84,    85,    86,    87,  1063,    88,   588,
      90,    91,    92,    93,    94,   589,  1064,    96,  1065,  1066,
      99,  1067,  1068,  1069,  1070,  1071,     0,   105,   106,   107,
     590,   109,   110,   111,   112,   113,   114,   115,   116,   117,
    1072,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,  1073,  1074,  1075,   592,   133,     0,   134,   135,
     136,   137,   138,   139,   140,   593,   142,   143,   144,   145,
     594,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   595,   160,     0,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   596,   597,
     172,     0,  1076,   174,   175,   598,   177,   178,  1077,   180,
    1078,   599,   183,   184,   600,   186,   187,   601,     0,   189,
     190,   191,  1079,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   602,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   603,   212,  1080,  1081,   215,   216,   217,  1082,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,  1083,   257,  1084,
     259,   260,   261,   262,  1085,  1086,  1087,  1088,   267,   268,
     269,   270,   271,   272,   273,   274,   275,  1089,  1090,   278,
     279,   280,   281,   282,   604,   283,   284,   285,   286,   287,
     288,   289,   290,   291,  1091,   293,   294,   295,   605,   296,
     297,   298,   299,   300,   301,   302,   303,   304,  1092,   306,
     307,   308,   309,   310,  1093,  1094,   313,   606,   314,   607,
     316,   317,  1095,   319,   320,   321,   322,   323,   324,  1096,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   608,   345,
     346,   609,   348,   349,   350,   351,   352,   353,   354,  1097,
     356,   610,   358,   359,   360,  1098,  1099,   363,   364,   611,
     366,   367,  1100,   369,   370,   371,   372,   373,   374,  1101,
     376,   612,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,   393,   394,
     395,   613,   397,   398,   614,   400,   401,   402,   403,  1102,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,  1103,  1104,
    1105,  1106,   427,   428,   429,  1107,  1108,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   616,   442,   443,   444,
    1109,   446,  1110,   448,   449,   450,   451,   452,   453,   454,
     455,   456,  1111,  1112,   617,  1113,   461,   462,   463,     0,
     464,   618,   466,  1114,     0,     0,     0,   983,   984,   985,
     986,   987,  1115,  1116,     0,     0,     0,     0,  1117,   988,
     989,     0,   990,  1118,     0,     0,     0,  1119,  1120,   991,
     992,  1121,  1122,   993,   994,   995,   996,     0,   997,   998,
       0,   999,  1000,     0,     0,     0,     0,  1001,     0,     0,
       0,  1002,     0,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1004,  1005,  1006,     0,  1007,  1008,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1009,  1010,  1011,     0,  1012,  1013,     0,     0,     0,
    1014,  1015,  1016,     0,     0,     0,     0,     0,     0,     0,
    1017,     0,  2648,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1019,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1020,
       0,     0,     0,     0,  1021,  1022,     0,  1023,     0,     0,
       0,     0,     0,  1024,     0,  1025,     0,     0,  1026,     0,
       0,  1027,     0,  1029,     0,  1030,  1031,  1032,     0,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1034,     0,     0,     0,  1035,  1036,
    1037,     0,  1038,     0,     0,     0,     0,     0,     0,  1039,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1040,     0,     0,     0,     0,     0,     0,     0,  1041,     0,
       0,  1042,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1043,     0,     0,     0,     0,     0,  1044,  1045,     0,
    1046,  1047,     0,     0,     0,  1048,     0,     0,     0,     0,
       0,     0,     0,  1049,  1050,  1051,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1052,  1053,  1054,     0,     0,
       0,     0,     0,  1055,     0,  1056,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     582,    48,    49,    50,    51,    52,  1057,  1058,  1059,    54,
      55,    56,  1060,    58,    59,    60,    61,    62,    63,  1061,
      65,    66,    67,    68,    69,    70,    71,  1062,   583,     0,
     584,   585,    77,    78,    79,    80,    81,    82,   586,    84,
      85,    86,    87,  1063,    88,   588,    90,    91,    92,    93,
      94,   589,  1064,    96,  1065,  1066,    99,  1067,  1068,  1069,
    1070,  1071,     0,   105,   106,   107,   590,   109,   110,   111,
     112,   113,   114,   115,   116,   117,  1072,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,  1073,  1074,
    1075,   592,   133,     0,   134,   135,   136,   137,   138,   139,
     140,   593,   142,   143,   144,   145,   594,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     595,   160,     0,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   596,   597,   172,     0,  1076,   174,
     175,   598,   177,   178,  1077,   180,  1078,   599,   183,   184,
     600,   186,   187,   601,     0,   189,   190,   191,  1079,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   602,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   603,   212,
    1080,  1081,   215,   216,   217,  1082,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,  1083,   257,  1084,   259,   260,   261,   262,
    1085,  1086,  1087,  1088,   267,   268,   269,   270,   271,   272,
     273,   274,   275,  1089,  1090,   278,   279,   280,   281,   282,
     604,   283,   284,   285,   286,   287,   288,   289,   290,   291,
    1091,   293,   294,   295,   605,   296,   297,   298,   299,   300,
     301,   302,   303,   304,  1092,   306,   307,   308,   309,   310,
    1093,  1094,   313,   606,   314,   607,   316,   317,  1095,   319,
     320,   321,   322,   323,   324,  1096,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   608,   345,   346,   609,   348,   349,
     350,   351,   352,   353,   354,  1097,   356,   610,   358,   359,
     360,  1098,  1099,   363,   364,   611,   366,   367,  1100,   369,
     370,   371,   372,   373,   374,  1101,   376,   612,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,     0,   392,   393,   394,   395,   613,   397,   398,
     614,   400,   401,   402,   403,  1102,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1103,  1104,  1105,  1106,   427,   428,
     429,  1107,  1108,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   616,   442,   443,   444,  1109,   446,  1110,   448,
     449,   450,   451,   452,   453,   454,   455,   456,  1111,  1112,
     617,  1113,   461,   462,   463,     0,   464,   618,   466,  1114,
       0,     0,     0,   983,   984,   985,   986,   987,  1115,  1116,
       0,     0,     0,     0,  1117,   988,   989,     0,   990,  1118,
       0,     0,     0,  1119,  1120,   991,   992,  1121,  1122,   993,
     994,   995,   996,     0,   997,   998,     0,   999,  1000,     0,
       0,     0,     0,  1001,     0,     0,     0,  1002,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,  1005,  1006,     0,  1007,  1008,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1009,  1010,  1011,
       0,  1012,  1013,     0,     0,     0,  1014,  1015,  1016,     0,
       0,     0,     0,     0,     0,     0,  1017,     0,  2650,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1019,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1020,     0,     0,     0,     0,
    1021,  1022,     0,  1023,     0,     0,     0,     0,     0,  1024,
       0,  1025,     0,     0,  1026,     0,     0,  1027,     0,  1029,
       0,  1030,  1031,  1032,     0,  1033,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1034,     0,     0,     0,  1035,  1036,  1037,     0,  1038,     0,
       0,     0,     0,     0,     0,  1039,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1040,     0,     0,     0,
       0,     0,     0,     0,  1041,     0,     0,  1042,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,     0,
       0,     0,     0,  1044,  1045,     0,  1046,  1047,     0,     0,
       0,  1048,     0,     0,     0,     0,     0,     0,     0,  1049,
    1050,  1051,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1052,  1053,  1054,     0,     0,     0,     0,     0,  1055,
       0,  1056,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   582,    48,    49,    50,
      51,    52,  1057,  1058,  1059,    54,    55,    56,  1060,    58,
      59,    60,    61,    62,    63,  1061,    65,    66,    67,    68,
      69,    70,    71,  1062,   583,     0,   584,   585,    77,    78,
      79,    80,    81,    82,   586,    84,    85,    86,    87,  1063,
      88,   588,    90,    91,    92,    93,    94,   589,  1064,    96,
    1065,  1066,    99,  1067,  1068,  1069,  1070,  1071,     0,   105,
     106,   107,   590,   109,   110,   111,   112,   113,   114,   115,
     116,   117,  1072,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,  1073,  1074,  1075,   592,   133,     0,
     134,   135,   136,   137,   138,   139,   140,   593,   142,   143,
     144,   145,   594,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   595,   160,     0,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     596,   597,   172,     0,  1076,   174,   175,   598,   177,   178,
    1077,   180,  1078,   599,   183,   184,   600,   186,   187,   601,
       0,   189,   190,   191,  1079,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   602,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   603,   212,  1080,  1081,   215,   216,
     217,  1082,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,  1083,
     257,  1084,   259,   260,   261,   262,  1085,  1086,  1087,  1088,
     267,   268,   269,   270,   271,   272,   273,   274,   275,  1089,
    1090,   278,   279,   280,   281,   282,   604,   283,   284,   285,
     286,   287,   288,   289,   290,   291,  1091,   293,   294,   295,
     605,   296,   297,   298,   299,   300,   301,   302,   303,   304,
    1092,   306,   307,   308,   309,   310,  1093,  1094,   313,   606,
     314,   607,   316,   317,  1095,   319,   320,   321,   322,   323,
     324,  1096,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     608,   345,   346,   609,   348,   349,   350,   351,   352,   353,
     354,  1097,   356,   610,   358,   359,   360,  1098,  1099,   363,
     364,   611,   366,   367,  1100,   369,   370,   371,   372,   373,
     374,  1101,   376,   612,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,     0,   392,
     393,   394,   395,   613,   397,   398,   614,   400,   401,   402,
     403,  1102,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
    1103,  1104,  1105,  1106,   427,   428,   429,  1107,  1108,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   616,   442,
     443,   444,  1109,   446,  1110,   448,   449,   450,   451,   452,
     453,   454,   455,   456,  1111,  1112,   617,  1113,   461,   462,
     463,     0,   464,   618,   466,  1114,     0,     0,     0,     0,
     984,   985,   986,   987,  1115,  1116,     0,     0,     0,     0,
    1117,   988,   989,     0,   990,  1118,     0,     0,     0,  1119,
    1120,   991,   992,  1121,  1122,   993,   994,   995,   996,     0,
     997,   998,     0,   999,  1000,     0,     0,     0,     0,  1001,
       0,     0,     0,  1002,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,  1005,  1006,     0,
    1007,  1008,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1009,  1010,  1011,     0,  1012,  1013,     0,
       0,     0,  1014,  1015,  1016,     0,     0,     0,     0,     0,
       0,     0,  1017,     0,  1690,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1019,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1020,     0,     0,     0,     0,  1021,  1022,     0,  1023,
       0,     0,     0,     0,     0,  1024,     0,  1025,     0,     0,
    1026,     0,     0,     0,     0,  1029,     0,  1030,  1031,  1032,
       0,  1033,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1034,     0,     0,     0,
    1035,  1036,  1037,     0,  1038,     0,     0,     0,     0,     0,
       0,  1039,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1040,     0,     0,     0,     0,     0,     0,     0,
    1041,     0,     0,  1042,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,     0,     0,     0,  1044,
    1045,     0,  1046,  1047,     0,     0,     0,  1048,     0,     0,
       0,     0,     0,     0,     0,  1049,  1050,  1051,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1052,  1053,  1054,
       0,     0,     0,     0,     0,  1055,     0,  1056,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   582,    48,    49,    50,    51,    52,  1057,  1058,
    1059,    54,    55,    56,  1060,    58,    59,    60,    61,    62,
      63,  1061,    65,    66,    67,    68,    69,    70,    71,  1062,
     583,     0,   584,   585,    77,    78,    79,    80,    81,    82,
     586,    84,    85,    86,    87,  1063,    88,   588,    90,    91,
      92,    93,    94,   589,  1064,    96,  1065,  1066,    99,  1067,
    1068,  1069,  1070,  1071,     0,   105,   106,   107,   590,   109,
     110,   111,   112,   113,   114,   115,   116,   117,  1072,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
    1073,  1074,  1075,   592,   133,     0,   134,   135,   136,   137,
     138,   139,   140,   593,   142,   143,   144,   145,   594,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   595,   160,     0,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   596,   597,   172,     0,
    1076,   174,   175,   598,   177,   178,  1077,   180,  1078,   599,
     183,   184,   600,   186,   187,   601,     0,   189,   190,   191,
    1079,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     602,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     603,   212,  1080,  1081,   215,   216,   217,  1082,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,  1083,   257,  1084,   259,   260,
     261,   262,  1085,  1086,  1087,  1088,   267,   268,   269,   270,
     271,   272,   273,   274,   275,  1089,  1090,   278,   279,   280,
     281,   282,   604,   283,   284,   285,   286,   287,   288,   289,
     290,   291,  1091,   293,   294,   295,   605,   296,   297,   298,
     299,   300,   301,   302,   303,   304,  1092,   306,   307,   308,
     309,   310,  1093,  1094,   313,   606,   314,   607,   316,   317,
    1095,   319,   320,   321,   322,   323,   324,  1096,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   608,   345,   346,   609,
     348,   349,   350,   351,   352,   353,   354,  1097,   356,   610,
     358,   359,   360,  1098,  1099,   363,   364,   611,   366,   367,
    1100,   369,   370,   371,   372,   373,   374,  1101,   376,   612,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,     0,   392,   393,   394,   395,   613,
     397,   398,   614,   400,   401,   402,   403,  1102,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,  1103,  1104,  1105,  1106,
     427,   428,   429,  1107,  1108,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   616,   442,   443,   444,  1109,   446,
    1110,   448,   449,   450,   451,   452,   453,   454,   455,   456,
    1111,  1112,   617,  1113,   461,   462,   463,   984,   464,   618,
     466,  1114,     0,     0,     0,     0,     0,     0,     0,     0,
    5793,  5794,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5795,     0,     0,     0,     0,  1120,     0,     0,  1121,
    1122,     0,     0,     0,     0,     0,  1001,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1006,     0,     0,  1008,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1012,  1013,     0,     0,     0,  1727,
    1728,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1020,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1026,     0,     0,
       0,     0,     0,     0,     0,  1031,  1032,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1048,     0,     0,     0,     0,     0,
       0,     0,  1049,  1050,  1051,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    45,    46,    47,   582,
      48,    49,    50,    51,    52,     0,     0,     0,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,   583,     0,   584,
     585,    77,    78,    79,    80,    81,    82,   586,    84,    85,
      86,    87,   587,    88,   588,    90,    91,    92,    93,    94,
     589,    95,    96,    97,  1729,    99,   100,   101,   102,   103,
     104,     0,   105,   106,   107,   590,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   591,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,  2684,   131,
     592,   133,     0,   134,   135,   136,   137,   138,   139,   140,
     593,   142,   143,   144,   145,   594,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   595,
     160,     0,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   596,   597,   172,     0,   173,   174,   175,
     598,   177,   178,   179,   180,   181,   599,   183,   184,   600,
     186,   187,   601,     0,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   602,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   603,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   604,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   605,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   606,   314,   607,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   608,   345,   346,   609,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   610,   358,   359,   360,
     361,   362,   363,   364,   611,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   612,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,  3158,   392,   393,   394,   395,   613,   397,   398,   614,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,  2685,   424,   425,  2686,   427,   428,   429,
     430,   615,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   616,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   617,
     460,   461,   462,   463,     0,   464,   618,   466,   467,     0,
       0,     0,     0,     0,     0,     0,     0,    16,    17,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1121,  1122,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,   582,    48,    49,
      50,    51,    52,     0,     0,     0,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,   583,     0,   584,   585,    77,
      78,    79,    80,    81,    82,   586,    84,    85,    86,    87,
     587,    88,   588,    90,    91,    92,    93,    94,   589,    95,
      96,    97,     0,    99,   100,   101,   102,   103,   104,     0,
     105,   106,   107,   590,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   591,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   592,   133,
       0,   134,   135,   136,   137,   138,   139,   140,   593,   142,
     143,   144,   145,   594,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   595,   160,     0,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   596,   597,   172,     0,   173,   174,   175,   598,   177,
     178,   179,   180,   181,   599,   183,   184,   600,   186,   187,
     601,     0,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   602,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   603,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   604,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   605,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     606,   314,   607,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   608,   345,   346,   609,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   610,   358,   359,   360,   361,   362,
     363,   364,   611,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   612,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,  3407,
     392,   393,   394,   395,   613,   397,   398,   614,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   615,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   616,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   617,   460,   461,
     462,   463,     0,   464,   618,   466,   467,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,  3159,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   787,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
    1209,   464,   618,   466,   467,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1210,
       0,     0,   787,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    16,    17,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   582,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   583,     0,   584,   585,
      77,    78,    79,    80,    81,    82,   586,    84,    85,    86,
      87,  1211,    88,   588,    90,    91,    92,    93,    94,   589,
      95,    96,    97,     0,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   590,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   591,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   592,
     133,     0,   134,   135,   136,   137,   138,   139,   140,   593,
     142,   143,   144,   145,   594,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   595,   160,
       0,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   596,   597,   172,     0,   173,   174,   175,  1212,
     177,   178,   179,   180,   181,   599,  1213,   184,   600,   186,
     187,   601,     0,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   602,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   603,   212,   213,   214,
     215,   216,   217,   218,   219,  1214,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,  1215,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   604,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   605,   296,   297,   298,   299,   300,   301,   302,
     303,   304,  1216,   306,   307,   308,   309,   310,   311,   312,
     313,   606,   314,   607,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   608,   345,   346,   609,   348,   349,   350,   351,
     352,   353,   354,   355,  1217,   610,   358,   359,   360,   361,
     362,   363,   364,   611,   366,   367,   368,   369,   370,   371,
     372,  1218,   374,   375,   376,   612,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
       0,   392,   393,   394,   395,   613,   397,   398,   614,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,  1219,   428,   429,   430,
     615,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     616,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,  1220,   460,
     461,   462,   463,  1209,   464,   618,   466,   467,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1210,     0,     0,     0,  1221,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,  1211,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,  1212,   177,   178,   179,   180,   181,   599,  1213,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,  1214,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,  1215,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,  1216,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,  1217,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,  1218,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,  1220,   460,   461,   462,   463,     0,   464,   618,   466,
     467,   900,   901,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1221,
       0,     0,     0,     0,     0,     0,   902,     0,     0,     0,
       0,   903,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   904,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   905,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   906,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,     0,     0,     0,
     907,     0,     0,     0,     0,   908,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   806,     0,     0,     0,     0,     0,
       0,   909,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   910,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   911,     0,
       0,     0,     0,     0,     0,     0,   912,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     707,     0,     0,     0,     0,     0,     0,   913,     0,     0,
       0,     0,     0,     0,     0,     0,   914,   915,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     916,   155,   156,   157,   158,   917,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   918,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   919,   321,   322,   323,   920,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   921,   342,   343,   608,
     345,   922,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   923,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   924,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,  1186,   901,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     902,     0,     0,     0,     0,   903,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   904,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   905,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   906,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    16,
      17,     0,     0,     0,   907,     0,     0,     0,     0,   908,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   806,     0,
       0,     0,     0,     0,     0,   909,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   910,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   911,     0,     0,     0,     0,     0,     0,     0,
     912,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   707,     0,     0,     0,     0,     0,
       0,   913,     0,     0,     0,     0,     0,     0,     0,     0,
     914,   915,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    45,    46,    47,   582,
      48,    49,    50,    51,    52,     0,     0,     0,    54,    55,
    1187,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,   583,     0,   584,
     585,    77,    78,    79,    80,    81,    82,   586,    84,    85,
      86,    87,   587,    88,   588,    90,    91,    92,    93,    94,
     589,    95,    96,    97,     0,    99,   100,   101,   102,   103,
     104,     0,   105,   106,   107,   590,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   591,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     592,   133,     0,   134,   135,   136,   137,   138,   139,   140,
     593,   142,   143,   144,   145,   594,   146,   147,   148,   149,
     150,   151,   152,   153,   916,   155,   156,   157,   158,   917,
     160,     0,     0,   161,   162,   163,   164,   165,   166,   167,
     918,   169,   170,   596,   597,   172,     0,   173,   174,   175,
     598,   177,   178,   179,   180,   181,   599,   183,   184,   600,
     186,   187,   601,     0,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   602,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   603,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   604,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   605,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   606,   314,   607,   316,   317,   318,   319,   919,
     321,   322,   323,  1188,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     921,   342,   343,   608,   345,   922,   609,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   610,   358,   359,   360,
     361,   362,   363,   364,   611,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   923,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,  1957,   392,   393,   394,   395,   613,   397,   398,   614,
     400,   401,   402,   403,   404,   405,   406,   407,   924,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   615,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   616,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   617,
     460,   461,   462,   463,     0,   464,   618,   466,   467,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   806,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     707,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
    2054,   464,   618,   466,   467,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1727,  1728,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,  4973,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,  2055,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,  4992,   464,   618,   466,
     467,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   756,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      16,    17,     0,     0,     0,  3506,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3507,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   757,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     582,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   583,     0,
     584,   585,    77,    78,    79,    80,    81,    82,   586,    84,
      85,    86,    87,   587,    88,   588,    90,    91,    92,    93,
      94,   589,    95,    96,    97,     0,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   590,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   591,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   592,   133,     0,   134,   135,   136,   137,   138,   139,
     140,   593,   142,   143,   144,   145,   594,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     595,   160,     0,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   596,   597,   172,     0,   173,   174,
     175,   598,   177,   178,   179,   180,   181,   599,   183,   184,
     600,   186,   187,   601,     0,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   602,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   603,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     604,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   605,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,  4993,   307,   308,   309,   310,
     311,   312,   313,   606,   314,   607,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   608,   345,   346,   609,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   610,   358,   359,
     360,   361,   362,   363,   364,   611,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   612,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,  4540,   392,   393,   394,   395,   613,   397,   398,
     614,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   615,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   616,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     617,   460,   461,   462,   463,     0,   464,   618,   466,   467,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,     0,     0,     0,     0,  4791,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   707,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,  1910,   464,   618,   466,
     467,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1911,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    16,
      17,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   806,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1912,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   707,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    45,    46,    47,   582,
      48,    49,    50,    51,    52,     0,     0,     0,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,   583,     0,   584,
     585,    77,    78,    79,    80,    81,    82,   586,    84,    85,
      86,    87,   587,    88,   588,    90,    91,    92,    93,    94,
     589,    95,    96,    97,     0,    99,   100,   101,   102,   103,
     104,     0,   105,   106,   107,   590,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   591,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     592,   133,     0,   134,   135,   136,   137,   138,   139,   140,
     593,   142,   143,   144,   145,   594,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   595,
     160,     0,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   596,   597,   172,     0,   173,   174,   175,
     598,   177,   178,   179,   180,   181,   599,   183,   184,   600,
     186,   187,   601,     0,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   602,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   603,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   604,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   605,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   606,   314,   607,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   608,   345,   346,   609,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   610,   358,   359,   360,
     361,   362,   363,   364,   611,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   612,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   613,   397,   398,   614,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   615,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   616,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   617,
     460,   461,   462,   463,     0,   464,   618,   466,   467,  1500,
    1501,     0,  1913,     0,     0,  1502,  1503,     0,     0,     0,
       0,     0,     0,     0,     0,  1504,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1505,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1506,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1507,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,    17,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1508,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1509,  1510,     0,  1511,     0,     0,     0,     0,     0,     0,
       0,  1512,  1513,  1514,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1515,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1516,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1517,     0,     0,     0,     0,     0,  1518,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1519,  1520,  1521,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1522,  1523,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      45,    46,    47,     0,    48,    49,    50,    51,    52,     0,
       0,     0,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,   583,     0,     0,   585,  1524,    78,  1525,  1526,    81,
      82,   586,    84,    85,    86,    87,   587,    88,   588,    90,
      91,    92,     0,  1527,   589,    95,    96,    97,     0,    99,
     100,   101,   102,   103,   104,     0,   105,   106,   107,   590,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   591,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
    1528,   129,  1529,   131,   592,   133,     0,   134,   135,   136,
     137,   138,   139,   140,   593,   142,   143,   144,   145,     0,
     146,   147,   148,  1530,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   595,   160,     0,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,  1531,   596,   597,   172,
       0,   173,   174,   175,     0,   177,   178,  1532,  1533,   181,
     599,   183,   184,   600,   186,   187,   601,     0,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   602,   203,   204,   205,   206,   207,   208,   209,  1534,
     211,   603,   212,   213,   214,   215,   216,   217,  1535,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,  1536,  1537,  1538,   267,   268,   269,
     270,   271,  1539,  1540,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   604,   283,   284,   285,   286,     0,  1541,
    1542,   290,   291,   292,   293,   294,   295,   605,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,  1543,  1544,   313,   606,   314,   607,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,     0,  1545,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   608,   345,   346,
     609,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     610,   358,   359,   360,  1546,   362,   363,   364,   611,   366,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
     612,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     613,   397,   398,   614,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,  1547,   421,   422,  1548,   424,   425,
    1549,   427,   428,   429,   430,   615,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   616,   442,   443,   444,   445,
     446,   447,     0,  1550,   450,   451,   452,   453,   454,   455,
     456,   457,   458,  1551,   460,   461,   462,   463,     0,   464,
     618,   466,  1552,  1500,  4336,     0,     0,     0,     0,  1502,
    1503,     0,     0,     0,     0,     0,     0,     0,     0,  1504,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1505,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1506,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1507,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,    17,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1508,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1509,  1510,     0,  1511,     0,     0,
       0,     0,     0,     0,     0,  1512,  1513,  1514,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1515,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1516,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1517,     0,     0,     0,     0,     0,
    1518,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1519,  1520,  1521,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4337,  1523,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,     0,    48,    49,
      50,    51,    52,     0,     0,     0,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,   583,     0,     0,   585,  1524,
      78,  1525,  1526,    81,    82,   586,    84,    85,    86,    87,
     587,    88,   588,    90,    91,    92,     0,  1527,   589,    95,
      96,    97,     0,    99,   100,   101,   102,   103,   104,     0,
     105,   106,   107,   590,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   591,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,  1528,   129,  1529,   131,   592,   133,
       0,   134,   135,   136,   137,   138,   139,   140,   593,   142,
     143,   144,   145,     0,   146,   147,   148,  1530,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   595,   160,     0,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
    1531,   596,   597,   172,     0,   173,   174,   175,     0,   177,
     178,  1532,  1533,   181,   599,   183,   184,   600,   186,   187,
     601,     0,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   602,   203,   204,   205,   206,
     207,   208,   209,  1534,   211,   603,   212,   213,   214,   215,
     216,   217,  1535,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,  1536,  1537,
    1538,   267,   268,   269,   270,   271,  1539,  1540,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   604,   283,   284,
     285,   286,     0,  1541,  1542,   290,   291,   292,   293,   294,
     295,   605,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,  1543,  1544,   313,
     606,   314,   607,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,     0,  4338,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   608,   345,   346,   609,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   610,   358,   359,   360,  4339,   362,
     363,   364,   611,   366,   367,   368,   369,   370,   371,     0,
     373,   374,   375,   376,   612,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   613,   397,   398,   614,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,  1547,   421,
     422,  1548,   424,   425,  1549,   427,   428,   429,   430,   615,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   616,
     442,   443,   444,   445,   446,   447,     0,  4340,   450,   451,
     452,   453,   454,   455,   456,   457,   458,  1551,   460,   461,
     462,   463,     0,   464,   618,   466,  1552,  1500,  1501,     0,
       0,     0,     0,  1502,  1503,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1505,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1506,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1507,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1508,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1509,  1510,
       0,  1511,     0,     0,     0,     0,     0,     0,     0,  1512,
    1513,  1514,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1515,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1516,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1517,     0,
       0,     0,     0,     0,  1518,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1519,  1520,
    1521,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1522,  1523,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,     0,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,     0,   585,  1524,    78,  1525,  1526,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
       0,  1527,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,  1528,   129,
    1529,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,     0,   146,   147,
     148,  1530,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,  1531,   596,   597,   172,     0,   173,
     174,   175,     0,   177,   178,  1532,  1533,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,  1534,   211,   603,
     212,   213,   214,   215,   216,   217,  1535,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,  1536,  1537,  1538,   267,   268,   269,   270,   271,
    1539,  1540,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,     0,  1541,  1542,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,  1543,  1544,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,     0,
    1545,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,     0,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,  5387,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,  1547,   421,   422,  1548,   424,   425,  1549,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
       0,  1550,   450,   451,   452,   453,   454,   455,   456,   457,
     458,  1551,   460,   461,   462,   463,     0,   464,   618,   466,
    1552,  1500,  4336,     0,     0,     0,     0,  1502,  1503,     0,
       0,     0,     0,     0,     0,     0,     0,  1504,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1505,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1506,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1507,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1508,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1509,  1510,     0,  1511,     0,     0,     0,     0,
       0,     0,     0,  1512,  1513,  1514,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1515,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1516,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1517,     0,     0,     0,     0,     0,  1518,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1519,  1520,  1521,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4337,  1523,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,     0,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,     0,   585,  1524,    78,  1525,
    1526,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,     0,  1527,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,  1528,   129,  1529,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,     0,   146,   147,   148,  1530,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,  1531,   596,
     597,   172,     0,   173,   174,   175,     0,   177,   178,  1532,
    1533,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,  1534,   211,   603,   212,   213,   214,   215,   216,   217,
    1535,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,  1536,  1537,  1538,   267,
     268,   269,   270,   271,  1539,  1540,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
       0,  1541,  1542,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,  1543,  1544,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,     0,  4338,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,  5625,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,     0,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,  1547,   421,   422,  1548,
     424,   425,  1549,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,  1926,  4340,   450,   451,   452,   453,
     454,   455,   456,   457,   458,  1551,   460,   461,   462,   463,
       0,   464,   618,   466,  1552,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1927,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,    17,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   806,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   707,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,   582,    48,    49,
      50,    51,    52,     0,     0,     0,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,   583,     0,   584,   585,    77,
      78,    79,    80,    81,    82,   586,    84,    85,    86,    87,
     587,    88,   588,    90,    91,    92,    93,    94,   589,    95,
      96,    97,     0,    99,   100,   101,   102,   103,   104,     0,
     105,   106,   107,   590,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   591,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   592,   133,
       0,   134,   135,   136,   137,   138,   139,   140,   593,   142,
     143,   144,   145,   594,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   595,   160,     0,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   596,   597,   172,     0,   173,   174,   175,   598,   177,
     178,   179,   180,   181,   599,   183,   184,   600,   186,   187,
     601,     0,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   602,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   603,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   604,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   605,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     606,   314,   607,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   608,   345,   346,   609,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   610,   358,   359,   360,   361,   362,
     363,   364,   611,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   612,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   613,   397,   398,   614,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   615,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   616,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   617,   460,   461,
     462,   463,  1910,   464,   618,   466,   467,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1911,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   806,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     707,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,  1910,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      16,    17,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   806,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   707,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     582,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   583,     0,
     584,   585,    77,    78,    79,    80,    81,    82,   586,    84,
      85,    86,    87,   587,    88,   588,    90,    91,    92,    93,
      94,   589,    95,    96,    97,     0,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   590,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   591,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   592,   133,     0,   134,   135,   136,   137,   138,   139,
     140,   593,   142,   143,   144,   145,   594,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     595,   160,     0,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   596,   597,   172,     0,   173,   174,
     175,   598,   177,   178,   179,   180,   181,   599,   183,   184,
     600,   186,   187,   601,     0,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   602,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   603,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     604,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   605,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   606,   314,   607,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   608,   345,   346,   609,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   610,   358,   359,
     360,   361,   362,   363,   364,   611,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   612,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,  1343,   392,   393,   394,   395,   613,   397,   398,
     614,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   615,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   616,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     617,   460,   461,   462,   463,     0,   464,   618,   466,   467,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1344,
    1345,     0,     0,     0,    16,    17,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1346,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   582,    48,    49,    50,    51,    52,
       0,     0,     0,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,   583,     0,   584,   585,    77,    78,    79,    80,
      81,    82,   586,    84,    85,    86,    87,   587,    88,   588,
      90,    91,    92,    93,    94,   589,    95,    96,    97,     0,
      99,   100,   101,   102,   103,   104,     0,   105,   106,   107,
     590,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     591,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   592,   133,     0,   134,   135,
     136,   137,   138,   139,   140,   593,   142,   143,   144,   145,
     594,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   595,   160,     0,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   596,   597,
     172,     0,   173,   174,   175,   598,   177,   178,   179,   180,
     181,   599,   183,   184,   600,   186,   187,   601,     0,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   602,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   603,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   604,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   605,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   606,   314,   607,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   608,   345,
     346,   609,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   610,   358,   359,   360,   361,   362,   363,   364,   611,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   612,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,  2746,   392,   393,   394,
     395,   613,   397,   398,   614,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   615,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   616,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   617,   460,   461,   462,   463,     0,
     464,   618,   466,   467,     0,     0,     0,     0,     0,     0,
       0,     0,    16,    17,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   582,    48,    49,    50,    51,    52,     0,     0,
       0,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
     583,     0,   584,   585,    77,    78,    79,    80,    81,    82,
     586,    84,    85,    86,    87,   587,    88,   588,    90,    91,
      92,    93,    94,   589,    95,    96,    97,     0,    99,   100,
     101,   102,   103,   104,     0,   105,   106,   107,   590,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   591,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   592,   133,     0,   134,   135,   136,   137,
     138,   139,   140,   593,   142,   143,   144,   145,   594,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   595,   160,     0,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   596,   597,   172,     0,
     173,   174,   175,   598,   177,   178,   179,   180,   181,   599,
     183,   184,   600,   186,   187,   601,     0,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     602,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     603,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   604,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   605,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   606,   314,   607,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   608,   345,   346,   609,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   610,
     358,   359,   360,   361,   362,   363,   364,   611,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   612,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,     0,   392,   393,   394,   395,   613,
     397,   398,   614,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   615,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   616,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   617,   460,   461,   462,   463,  1447,   464,   618,
     466,   467,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    16,    17,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   806,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   707,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   582,    48,    49,    50,    51,    52,     0,     0,
       0,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
     583,     0,   584,   585,    77,    78,    79,    80,    81,    82,
     586,    84,    85,    86,    87,   587,    88,   588,    90,    91,
      92,    93,    94,   589,    95,    96,    97,     0,    99,   100,
     101,   102,   103,   104,     0,   105,   106,   107,   590,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   591,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   592,   133,     0,   134,   135,   136,   137,
     138,   139,   140,   593,   142,   143,   144,   145,   594,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   595,   160,     0,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   596,   597,   172,     0,
     173,   174,   175,   598,   177,   178,   179,   180,   181,   599,
     183,   184,   600,   186,   187,   601,     0,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     602,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     603,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   604,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   605,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   606,   314,   607,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   608,   345,   346,   609,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   610,
     358,   359,   360,   361,   362,   363,   364,   611,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   612,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,   389,   390,   391,     0,   392,   393,   394,   395,   613,
     397,   398,   614,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   615,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   616,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   617,   460,   461,   462,   463,     0,   464,   618,
     466,   467,   849,   850,     0,     0,     0,     0,     0,     0,
       0,     0,   851,     0,     0,     0,     0,     0,     0,     0,
       0,  1820,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,     0,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,     0,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,     0,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,   852,   853,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   854,   460,   461,   462,   463,
       0,   464,   618,   466,   467,  1447,   903,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      16,    17,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   806,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   707,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     582,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   583,     0,
     584,   585,    77,    78,    79,    80,    81,    82,   586,    84,
      85,    86,    87,   587,    88,   588,    90,    91,    92,    93,
      94,   589,    95,    96,    97,     0,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   590,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   591,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   592,   133,     0,   134,   135,   136,   137,   138,   139,
     140,   593,   142,   143,   144,   145,   594,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     595,   160,     0,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   596,   597,   172,     0,   173,   174,
     175,   598,   177,   178,   179,   180,   181,   599,   183,   184,
     600,   186,   187,   601,     0,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   602,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   603,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     604,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   605,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   606,   314,   607,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   608,   345,   346,   609,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   610,   358,   359,
     360,   361,   362,   363,   364,   611,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   612,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,     0,   392,   393,   394,   395,   613,   397,   398,
     614,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   615,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   616,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     617,   460,   461,   462,   463,  1447,   464,   618,   466,   467,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      16,    17,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   806,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   707,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     582,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   583,     0,
     584,   585,    77,    78,    79,    80,    81,    82,   586,    84,
      85,    86,    87,   587,    88,   588,    90,    91,    92,    93,
      94,   589,    95,    96,    97,     0,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   590,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   591,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   592,   133,     0,   134,   135,   136,   137,   138,   139,
     140,   593,   142,   143,   144,   145,   594,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     595,   160,     0,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   596,   597,   172,     0,   173,   174,
     175,   598,   177,   178,   179,   180,   181,   599,   183,   184,
     600,   186,   187,   601,     0,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   602,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   603,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     604,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   605,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   606,   314,   607,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   608,   345,   346,   609,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   610,   358,   359,
     360,   361,   362,   363,   364,   611,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   612,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,     0,   392,   393,   394,   395,   613,   397,   398,
     614,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   615,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   616,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     617,   460,   461,   462,   463,  1380,   464,   618,   466,   467,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,   903,   464,   618,   466,
     467,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1381,     0,     0,     0,     0,  1382,     0,     0,   787,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      16,    17,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   806,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   707,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     582,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   583,     0,
     584,   585,    77,    78,    79,    80,    81,    82,   586,    84,
      85,    86,    87,   587,    88,   588,    90,    91,    92,    93,
      94,   589,    95,    96,    97,     0,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   590,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   591,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   592,   133,     0,   134,   135,   136,   137,   138,   139,
     140,   593,   142,   143,   144,   145,   594,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     595,   160,     0,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   596,   597,   172,     0,   173,   174,
     175,   598,   177,   178,   179,   180,   181,   599,   183,   184,
     600,   186,   187,   601,     0,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   602,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   603,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     604,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   605,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   606,   314,   607,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   608,   345,   346,   609,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   610,   358,   359,
     360,   361,   362,   363,   364,   611,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   612,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,     0,   392,   393,   394,   395,   613,   397,   398,
     614,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   615,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   616,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     617,   460,   461,   462,   463,   851,   464,   618,   466,   467,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    16,    17,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,     0,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   583,     0,     0,   585,
      77,    78,    79,    80,    81,    82,   586,    84,    85,    86,
      87,   587,    88,   588,    90,    91,    92,    93,    94,   589,
      95,    96,    97,     0,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   590,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   591,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   592,
     133,     0,   134,   135,   136,   137,   138,   139,   140,   593,
     142,   143,   144,   145,     0,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   595,   160,
       0,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   596,   597,   172,     0,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   599,   183,   184,   600,   186,
     187,   601,     0,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   602,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   603,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   604,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   605,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   606,   314,   607,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   608,   345,   346,   609,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   610,   358,   359,   360,   361,
     362,   363,   364,   611,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   612,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
       0,   392,   393,   394,   395,   613,   397,   398,   614,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     615,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     616,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   854,   460,
     461,   462,   463,     0,   464,   618,   466,   467,  2451,     0,
       0,     0,  5162,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2452,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4158,     0,     0,     0,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4160,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   707,     0,     0,     0,
       0,     0,     0,     0,     0,  4161,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,     0,   464,   618,   466,
     467,  2451,     0,     0,     0,  5917,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2452,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4158,
       0,     0,     0,     0,    16,    17,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4159,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4160,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   707,
       0,     0,     0,     0,     0,     0,     0,     0,  4161,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   582,    48,    49,    50,    51,    52,
       0,     0,     0,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,   583,     0,   584,   585,    77,    78,    79,    80,
      81,    82,   586,    84,    85,    86,    87,   587,    88,   588,
      90,    91,    92,    93,    94,   589,    95,    96,    97,     0,
      99,   100,   101,   102,   103,   104,     0,   105,   106,   107,
     590,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     591,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   592,   133,     0,   134,   135,
     136,   137,   138,   139,   140,   593,   142,   143,   144,   145,
     594,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   595,   160,     0,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   596,   597,
     172,     0,   173,   174,   175,   598,   177,   178,   179,   180,
     181,   599,   183,   184,   600,   186,   187,   601,     0,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   602,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   603,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   604,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   605,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   606,   314,   607,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   608,   345,
     346,   609,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   610,   358,   359,   360,   361,   362,   363,   364,   611,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   612,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,   393,   394,
     395,   613,   397,   398,   614,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   615,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   616,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   617,   460,   461,   462,   463,     0,
     464,   618,   466,   467,  2451,     0,     0,     0,  6030,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2452,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4158,     0,     0,     0,     0,    16,    17,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4159,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4160,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   707,     0,     0,     0,     0,     0,     0,     0,
       0,  4161,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,   582,    48,    49,
      50,    51,    52,     0,     0,     0,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,   583,     0,   584,   585,    77,
      78,    79,    80,    81,    82,   586,    84,    85,    86,    87,
     587,    88,   588,    90,    91,    92,    93,    94,   589,    95,
      96,    97,     0,    99,   100,   101,   102,   103,   104,     0,
     105,   106,   107,   590,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   591,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   592,   133,
       0,   134,   135,   136,   137,   138,   139,   140,   593,   142,
     143,   144,   145,   594,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   595,   160,     0,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   596,   597,   172,     0,   173,   174,   175,   598,   177,
     178,   179,   180,   181,   599,   183,   184,   600,   186,   187,
     601,     0,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   602,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   603,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   604,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   605,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     606,   314,   607,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   608,   345,   346,   609,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   610,   358,   359,   360,   361,   362,
     363,   364,   611,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   612,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   613,   397,   398,   614,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   615,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   616,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   617,   460,   461,
     462,   463,  3073,   464,   618,   466,   467,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     806,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   707,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,  1903,   464,   618,   466,
     467,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
    1903,   464,   618,   466,   467,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    16,
      17,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    45,    46,    47,   582,
      48,    49,    50,    51,    52,     0,     0,     0,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,   583,     0,   584,
     585,    77,    78,    79,    80,    81,    82,   586,    84,    85,
      86,    87,   587,    88,   588,    90,    91,    92,    93,    94,
     589,    95,    96,    97,     0,    99,   100,   101,   102,   103,
     104,     0,   105,   106,   107,   590,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   591,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     592,   133,     0,   134,   135,   136,   137,   138,   139,   140,
     593,   142,   143,   144,   145,   594,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   595,
     160,     0,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   596,   597,   172,     0,   173,   174,   175,
     598,   177,   178,   179,   180,   181,   599,   183,   184,   600,
     186,   187,   601,     0,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   602,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   603,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   604,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   605,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   606,   314,   607,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   608,   345,   346,   609,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   610,   358,   359,   360,
     361,   362,   363,   364,   611,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   612,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   613,   397,   398,   614,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,  2738,   428,   429,
     430,   615,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   616,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   617,
     460,   461,   462,   463,  3499,   464,   618,   466,   467,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,    17,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      45,    46,    47,   582,    48,    49,    50,    51,    52,     0,
       0,     0,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,   583,     0,   584,   585,    77,    78,    79,    80,    81,
      82,   586,    84,    85,    86,    87,   587,    88,   588,    90,
      91,    92,    93,    94,   589,    95,    96,    97,     0,    99,
     100,   101,   102,   103,   104,     0,   105,   106,   107,   590,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   591,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   592,   133,     0,   134,   135,   136,
     137,   138,   139,   140,   593,   142,   143,   144,   145,   594,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   595,   160,     0,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   596,   597,   172,
       0,   173,   174,   175,   598,   177,   178,   179,   180,   181,
     599,   183,   184,   600,   186,   187,   601,     0,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   602,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   603,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   604,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   605,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   606,   314,   607,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   608,   345,   346,
     609,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     610,   358,   359,   360,   361,   362,   363,   364,   611,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     612,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     613,   397,   398,   614,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   615,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   616,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   617,   460,   461,   462,   463,  5093,   464,
     618,   466,   467,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,    17,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,   582,    48,    49,
      50,    51,    52,     0,     0,     0,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,   583,     0,   584,   585,    77,
      78,    79,    80,    81,    82,   586,    84,    85,    86,    87,
     587,    88,   588,    90,    91,    92,    93,    94,   589,    95,
      96,    97,     0,    99,   100,   101,   102,   103,   104,     0,
     105,   106,   107,   590,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   591,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   592,   133,
       0,   134,   135,   136,   137,   138,   139,   140,   593,   142,
     143,   144,   145,   594,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   595,   160,     0,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   596,   597,   172,     0,   173,   174,   175,   598,   177,
     178,   179,   180,   181,   599,   183,   184,   600,   186,   187,
     601,     0,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   602,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   603,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   604,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   605,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     606,   314,   607,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   608,   345,   346,   609,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   610,   358,   359,   360,   361,   362,
     363,   364,   611,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   612,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   613,   397,   398,   614,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   615,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   616,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   617,   460,   461,
     462,   463,  5111,   464,   618,   466,   467,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   582,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   583,
       0,   584,   585,    77,    78,    79,    80,    81,    82,   586,
      84,    85,    86,    87,   587,    88,   588,    90,    91,    92,
      93,    94,   589,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   590,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   591,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   592,   133,     0,   134,   135,   136,   137,   138,
     139,   140,   593,   142,   143,   144,   145,   594,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   595,   160,     0,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   596,   597,   172,     0,   173,
     174,   175,   598,   177,   178,   179,   180,   181,   599,   183,
     184,   600,   186,   187,   601,     0,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   602,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   603,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   604,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   605,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   606,   314,   607,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   608,   345,   346,   609,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   610,   358,
     359,   360,   361,   362,   363,   364,   611,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   612,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   613,   397,
     398,   614,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   615,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   616,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   617,   460,   461,   462,   463,  3435,   464,   618,   466,
     467,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     707,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,  3436,   177,   178,   179,
     180,   181,   599,     0,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,     0,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,  3437,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
    2600,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6127,     0,     0,     0,     0,
       0,     0,  2601,  6128,   806,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     707,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1924,   806,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     707,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2145,   806,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     707,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2615,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
    2600,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,  1727,  1728,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2601,  6128,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2055,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    34,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    41,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    43,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,  1727,  1728,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1381,     0,     0,     0,     0,     0,
       0,     0,   787,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
    1729,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1730,     0,     0,     0,     0,     0,
       0,     0,  1121,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,  1727,  1728,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1381,     0,     0,     0,     0,  1382,
       0,     0,   787,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
    1729,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1121,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
    2600,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2601,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1381,     0,     0,     0,     0,     0,
       0,     0,   787,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,  3159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   787,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,  5059,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4790,     0,     0,     0,     0,     0,
       0,     0,  4791,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4791,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   784,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   785,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   786,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   787,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   787,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4791,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
    3118,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2659,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   703,   704,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3764,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3765,   673,  3766,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
    1660,   464,   618,   466,   467,  1661,     0,     0,     0,     0,
       0,     0,     0,     0,  3119,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,  1662,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
    1582,   464,   618,   466,   467,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,  1727,  1728,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,  2665,  2666,  2667,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,  4544,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,  3135,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,  4386,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,  1727,  1728,     0,     0,     0,
       0,     0,     0,     0,     0,  4966,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,  5265,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,  5454,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   806,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1912,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     707,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,  1727,  1728,     0,  1913,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2156,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2157,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1034,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2158,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
    2160,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,  1727,  1728,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2156,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2157,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1034,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4369,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
    2160,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,  1727,  1728,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2156,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2157,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1034,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
    2160,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,  1727,  1728,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,  2665,  2666,  2667,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   672,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   673,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   806,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     707,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   673,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,  1727,  1728,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1773,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4587,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     707,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5710,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   716,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,  1727,  1728,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
    2074,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,  3527,   170,   596,
     597,   172,     0,   173,   174,   175,   598,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,  3528,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   617,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,  3176,   177,   178,   179,
     180,   181,   599,   183,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,     0,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     707,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   582,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,   584,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,   587,    88,
     588,    90,    91,    92,    93,    94,   589,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   590,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   591,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,   593,   142,   143,   144,
     145,   594,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
     597,   172,     0,   173,   174,   175,  3436,   177,   178,   179,
     180,   181,   599,     0,   184,   600,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   603,   212,   213,   214,   215,   216,   217,
     218,   219,     0,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   604,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   605,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   606,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   608,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   610,   358,   359,   360,   361,   362,   363,   364,
     611,   366,   367,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   612,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   615,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,  3437,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,     0,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   583,     0,     0,   585,    77,    78,    79,
      80,    81,    82,   586,    84,    85,    86,    87,     0,    88,
     588,    90,    91,    92,    93,    94,     0,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,     0,   109,   110,   111,   112,   113,   114,   115,   116,
     117,     0,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   592,   133,     0,   134,
     135,   136,   137,   138,   139,   140,     0,   142,   143,   144,
     145,     0,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   595,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   596,
       0,   172,     0,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   599,   183,   184,     0,   186,   187,   601,     0,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   602,   203,   204,   205,   206,   207,   208,
     209,   210,   211,     0,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,     0,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,     0,   314,
     607,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     345,   346,   609,   348,   349,   350,   351,   352,   353,   354,
     355,   356,     0,   358,   359,   360,   361,   362,   363,   364,
       0,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,     0,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   613,   397,   398,   614,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,     0,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   616,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
       0,   464,   618,   466,   467,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1650,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,     0,    48,     0,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,     0,    65,    66,    67,    68,    69,
      70,    71,    72,     0,     0,     0,     0,    77,    78,    79,
      80,    81,     0,     0,    84,    85,    86,    87,     0,     0,
       0,    90,    91,    92,    93,    94,     0,    95,    96,    97,
       0,    99,     0,     0,     0,     0,     0,     0,   105,     0,
     107,     0,   109,   110,  1651,   112,   113,   114,   115,   116,
     117,     0,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,     0,   133,     0,   134,
     135,   136,   137,   138,   139,   140,     0,   142,   143,   144,
     145,     0,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,     0,     0,     0,   160,     0,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,   174,   175,  1652,   177,   178,   179,
     180,   181,     0,   183,   184,     0,   186,   187,     0,     0,
     189,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,     0,   203,   204,   205,   206,   207,   208,
     209,   210,   211,     0,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,     0,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    16,
      17,     0,     0,   299,   300,     0,   302,   303,   304,   305,
       0,   307,   308,   309,   310,   311,   312,     0,     0,     0,
       0,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,     0,   343,     0,
     345,   346,     0,   348,   349,     0,   351,   352,   353,   354,
     355,   356,     0,   358,   359,   360,   361,   362,   363,   364,
       0,   366,   367,   368,     0,   370,   371,   372,   373,     0,
     375,   376,     0,     0,   379,     0,     0,   382,   383,   384,
       0,   386,     0,   388,   389,   390,   391,     0,   392,   393,
     394,   395,     0,   397,   398,     0,   400,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   423,
     424,   425,   426,   427,   428,   429,   430,     0,   432,   433,
     434,     0,   436,   437,   438,   439,     0,     0,   442,   443,
       0,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,     0,     0,   461,   462,     0,
       0,   464,     0,   466,   467,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1669,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    45,    46,    47,     0,
      48,     0,    50,    51,    52,     0,     0,     0,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,     0,    65,
      66,    67,    68,    69,    70,    71,    72,     0,     0,     0,
       0,    77,    78,    79,    80,    81,     0,     0,    84,    85,
      86,    87,     0,     0,     0,    90,    91,    92,    93,    94,
       0,    95,    96,    97,     0,    99,     0,     0,     0,     0,
       0,     0,   105,     0,   107,     0,   109,   110,  1651,   112,
     113,   114,   115,   116,   117,     0,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
       0,   133,     0,   134,   135,   136,   137,   138,   139,   140,
       0,   142,   143,   144,   145,     0,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,     0,     0,     0,
     160,     0,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,   174,   175,
    1652,   177,   178,   179,   180,   181,     0,   183,   184,     0,
     186,   187,     0,     0,   189,     0,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,     0,   203,   204,
     205,   206,   207,   208,   209,   210,   211,     0,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,     0,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    16,    17,     0,     0,   299,   300,     0,
     302,   303,   304,   305,     0,   307,   308,   309,   310,   311,
     312,     0,     0,     0,     0,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,     0,   343,     0,   345,   346,     0,   348,   349,     0,
     351,   352,   353,   354,   355,   356,     0,   358,   359,   360,
     361,   362,   363,   364,     0,   366,   367,   368,     0,   370,
     371,   372,   373,     0,   375,   376,     0,     0,   379,     0,
       0,   382,   383,   384,     0,   386,     0,   388,   389,   390,
     391,     0,   392,   393,   394,   395,     0,   397,   398,     0,
     400,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,     0,   423,   424,   425,   426,   427,   428,   429,
     430,     0,   432,   433,   434,     0,   436,   437,   438,   439,
       0,     0,   442,   443,     0,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,     0,
       0,   461,   462,     0,     0,   464,     0,   466,   467,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      45,    46,    47,     0,    48,     0,    50,    51,    52,     0,
       0,     0,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,     0,    65,    66,    67,    68,    69,    70,    71,
      72,     0,     0,     0,     0,    77,    78,    79,    80,    81,
       0,     0,    84,    85,    86,    87,     0,     0,     0,    90,
      91,    92,    93,    94,     0,    95,    96,    97,     0,    99,
       0,     0,     0,     0,     0,     0,   105,     0,   107,     0,
     109,   110,  1651,   112,   113,   114,   115,   116,   117,     0,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,     0,   133,     0,   134,   135,   136,
     137,   138,   139,   140,     0,   142,   143,   144,   145,     0,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,     0,     0,     0,   160,     0,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,   174,   175,  1652,   177,   178,   179,   180,   181,
       0,   183,   184,     0,   186,   187,     0,     0,   189,     0,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,     0,   203,   204,   205,   206,   207,   208,   209,   210,
     211,     0,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,     0,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,     0,     0,     0,
       0,   299,   300,     0,   302,   303,   304,   305,     0,   307,
     308,   309,   310,   311,   312,     0,     0,     0,     0,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,     0,   343,     0,   345,   346,
       0,   348,   349,     0,   351,   352,   353,   354,   355,   356,
       0,   358,   359,   360,   361,   362,   363,   364,     0,   366,
     367,   368,     0,   370,   371,   372,   373,     0,   375,   376,
      16,    17,   379,     0,     0,   382,   383,   384,     0,   386,
       0,   388,   389,   390,   391,     0,   392,   393,   394,   395,
       0,   397,   398,     0,   400,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,     0,   423,   424,   425,
     426,   427,   428,   429,   430,     0,   432,   433,   434,     0,
     436,   437,   438,   439,     0,     0,   442,   443,     0,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,     0,     0,   461,   462,     0,     0,   464,
       0,   466,   467,     0,     0,  5472,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
       0,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   583,     0,
       0,   585,     0,    78,     0,     0,    81,    82,   586,    84,
      85,    86,    87,   587,    88,   588,    90,    91,    92,     0,
       0,   589,    95,    96,    97,     0,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   590,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   591,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,     0,   129,     0,
     131,   592,   133,     0,   134,   135,   136,   137,   138,   139,
     140,   593,   142,   143,   144,   145,     0,   146,   147,   148,
       0,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     595,   160,     0,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,     0,   596,   597,   172,     0,   173,   174,
     175,  5473,   177,   178,     0,     0,   181,   599,   183,   184,
     600,   186,   187,   601,     0,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   602,   203,
     204,   205,   206,   207,   208,   209,     0,   211,   603,   212,
     213,   214,   215,   216,   217,     0,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,     0,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,     0,     0,   267,   268,   269,   270,   271,     0,
       0,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     604,   283,   284,   285,   286,     0,     0,     0,   290,   291,
     292,   293,   294,   295,   605,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,     0,   313,   606,   314,   607,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,     0,     0,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   608,   345,   346,   609,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   610,   358,   359,
     360,     0,   362,   363,   364,   611,   366,   367,   368,   369,
     370,   371,     0,   373,   374,   375,   376,   612,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,     0,   392,   393,   394,   395,   613,   397,   398,
     614,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     0,   421,   422,     0,   424,   425,     0,   427,   428,
     429,   430,   615,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   616,   442,   443,   444,   445,   446,   447,     0,
       0,   450,   451,   452,   453,   454,   455,   456,   457,   458,
    1551,   460,   461,   462,   463,     0,   464,   618,   466
};

static const yytype_int16 yycheck[] =
{
       0,   573,    24,     0,   468,   688,  1821,   755,   687,   688,
     859,   759,   760,     0,   581,  1511,  1407,  1747,  1511,  1434,
    1894,     0,  1407,  2249,   571,  1874,  2032,   956,     0,   563,
     687,     0,   566,  1270,   770,  1725,     0,     0,     0,     0,
     801,  2330,  1887,     0,  1588,  1716,  1709,   636,  2225,  3082,
     636,  1507,  2426,  1181,  2319,   681,  3414,  2340,    75,  1515,
    2320,  2942,  1933,    33,    76,  1632,  3210,  3211,  3166,  3679,
     893,  2819,  1405,  3679,     0,  1531,  1021,   654,  1602,  1215,
    1216,  1217,  1568,   801,   654,  1541,  1440,  1021,  1224,  2061,
    3714,   638,  1381,   640,   641,   642,   643,   644,   687,   646,
     647,   687,  4087,   650,   651,  1528,  1562,   684,  2002,  1399,
    3614,  2878,   732,  1440,   684,   735,  2817,  1921,   844,  1340,
    3478,  1066,  3794,  4126,  1547,  1548,  1549,  1931,  3739,  1552,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1887,  1567,  3629,  3464,  1947,  1948,   171,
     715,  1954,  3826,  4645,  2054,  2405,  1501,  4657,  1503,  3739,
    1505,  3594,  1507,   858,  2189,  4094,  2201,  3151,  1971,  2984,
    1515,  3655,  3656,  2908,  2846,  3545,  1121,  1522,  3739,  1524,
    3054,  3739,  3739,  4656,  3739,  3618,  1531,     0,  4339,  3054,
     737,   738,  3226,  1996,  1997,   983,  1541,  3679,  2277,  4796,
    1545,  2427,  2716,     0,  3685,  1550,   581,  2907,  2908,  2054,
      30,  2246,  4092,  2087,  2984,   581,  1845,  1562,  1563,  1564,
    1565,  1566,   581,  4226,  1853,  1854,  2917,  1856,  1857,     0,
    4214,  4214,  3377,  3378,  3379,  4214,     6,  3721,  3722,  3054,
    4215,  2375,  4217,  2377,  2378,  4220,  2423,   581,   581,    11,
    2306,  1584,  2052,     6,  1183,  2134,    28,  1478,  1695,  1696,
       9,    10,     6,  1272,    11,    11,    93,  1704,   857,    89,
     859,   857,  1669,   859,    26,    11,  4801,     6,  4253,     9,
      10,    11,  1509,    57,  3054,  1512,     9,    10,   156,  2976,
      11,    93,  1519,     9,    10,    61,    50,  3044,    80,  1736,
    4668,  1738,   149,     9,    10,    12,     6,  1534,   782,    91,
    2054,    24,  5021,  3389,   180,    89,  1753,  1754,  1755,    63,
       9,    10,   344,    32,    61,  1762,  1763,  1115,  1116,  1117,
      57,   105,  1769,  3564,    11,     9,    10,   884,    26,   105,
    2214,  1129,    61,   152,    80,     9,    10,   185,   105,   896,
     897,   885,   886,   887,   888,    91,   238,    95,    65,   221,
     265,    80,    89,   180,   126,  1310,     9,    10,   105,   238,
    4810,    61,    91,   766,  4764,   149,   120,  3728,   105,    95,
     126,   266,    80,  3701,   238,   105,    61,  1510,  1511,  1511,
    3125,  1514,  1514,    91,   238,    61,  2965,    17,  1521,  1521,
    5775,   366,   211,   177,  1527,  1527,    17,  1510,  1511,  1249,
      83,  1514,   379,   781,   156,   105,     9,    10,  1521,   300,
     301,    32,   149,    34,  1527,  3125,  3655,  3656,  4635,   822,
     105,  1271,   357,     9,    10,   184,   238,   186,    35,   105,
       9,    10,  4721,   358,    11,     6,   422,   105,   121,   180,
     177,   223,  3327,    32,   184,   299,   186,     9,    10,  5008,
      11,   184,  1407,   186,   265,     9,    10,  5130,   184,    10,
     186,   375,   100,  3174,   265,   152,  1604,    60,   184,   180,
     186,    14,    12,    28,     9,    10,   238,     9,    10,   233,
     247,   115,  3721,  3722,    86,   184,   351,   186,   180,   180,
     274,  1629,   284,   196,   574,     9,    10,    14,  2797,   641,
     184,    28,   186,   105,     9,    10,  5699,  5085,    80,    93,
     184,  2810,   186,   270,     9,    10,   633,     9,    10,    91,
     142,    32,   197,    34,   211,    65,  2103,   281,   180,     9,
      10,   184,   468,   186,   288,  5380,   105,   274,   535,     9,
      10,   363,  3659,    73,   303,   299,     9,    10,  2432,   582,
      86,   284,   105,   114,     9,    10,   535,  2701,  2702,  2703,
    2704,   197,   316,   303,  1300,  5015,   197,     9,    10,   141,
     303,     9,    10,  4207,   581,   263,   381,   303,    69,  3464,
      80,   184,  3690,   186,   581,   402,   208,   303,     9,    10,
      58,    91,  3960,   197,   277,    24,   197,  2857,   184,   535,
     186,   299,   581,   197,   303,   184,  1364,   186,  1366,   631,
     329,  1369,  1370,  1371,  1372,  4106,     9,    10,   775,   303,
     226,   620,   184,   780,   186,   782,   636,   769,   238,   303,
     184,    95,   186,   635,   353,  1381,  1266,     9,    10,  3967,
     176,   141,    81,   653,  1118,   581,   648,   636,  3677,   184,
     303,   186,   184,   645,   186,   128,   124,   667,    97,   137,
     777,   125,   479,   233,   653,  2090,   226,  2201,   223,   636,
     184,   273,   186,  2933,   165,   674,   237,   687,   688,   184,
     653,   186,   237,   112,   694,   251,   653,   126,  5361,   184,
    5535,   186,   184,   132,   186,   560,   223,   777,   687,   679,
     303,   230,   724,   310,   184,   715,   186,   284,   329,   265,
     732,   230,  2246,   735,   184,   299,   186,   303,   288,  5285,
     687,   184,   283,   186,   303,   297,   347,   270,   265,   184,
     169,   186,   353,  5926,   299,   660,   769,   273,  1466,    61,
    5299,   303,   184,   265,   186,   213,   184,   340,   186,   303,
     580,   737,  1488,   391,   494,   233,   265,  6142,  1904,  1714,
    1898,   294,   396,   184,   353,   186,  1599,   702,   303,   238,
    1714,   303,   146,   584,  1729,  1730,  5009,  4269,   230,  1925,
    1918,  5070,  2798,   584,   536,   284,  1730,  5004,    80,   303,
     238,   184,   769,   186,   769,   366,  3644,   297,   303,    91,
     122,   606,   632,   717,  5382,   356,   323,  1945,   303,   284,
     288,   303,   184,   636,   186,  2349,  3701,    80,     9,    10,
     114,   299,   652,   303,   284,  2189,   836,  2126,    91,   636,
     653,  2712,  3577,   303,  3659,   815,   666,  4331,  2137,   114,
     303,   851,   353,  3113,  3728,   781,   653,   857,   303,   859,
     238,   114,  2189,  3728,   299,   636,  1433,   679,   152,  4100,
     690,   303,   851,   778,  2289,   303,  4456,  3577,   857,  1605,
     859,  2296,   653,  5323,   496,  5275,   518,   772,   851,  3659,
     687,   772,   303,  3584,   851,   777,   447,  3588,   518,  3975,
     857,   769,   859,  1691,  1692,  5461,   772,  2711,   777,   753,
     772,   758,   759,  3728,  1632,   279,   687,  1381,  2608,  2609,
     303,   891,    17,   777,   894,    61,  5635,  5636,   635,   622,
    2965,   660,   560,   933,   772,  1880,   745,    32,   299,    34,
    1474,   303,  1887,   484,   944,   772,   946,   947,   948,  2984,
    2922,   753,   952,  1887,   954,   772,   238,  5325,  3728,  5327,
     660,   961,  1436,  1689,   961,   944,   679,   946,   947,   948,
    3657,  5496,   650,   952,   961,   954,  3723,     9,    10,   708,
     734,  4332,   961,   983,  2787,  1994,  1379,   944,   988,   946,
     947,   948,   961,   759,   776,   952,   770,   954,   961,   769,
     772,   753,   759,   184,   961,   186,   753,  2636,  2637,  3044,
    2639,  2640,   721,  2410,   776,   560,   769,   753,  1018,  3054,
    2417,  2242,   759,  1600,  3158,   769,   775,  5500,  1028,  5502,
     776,  2258,   753,  2260,   772,   961,  2915,  2916,   851,   759,
     776,   772,   772,   770,   857,   733,   859,  3103,  3104,   772,
     770,   758,   772,   678,   851,  2282,   772,   776,  1433,  1593,
     857,  3630,  1430,   316,   770,  2292,   772,  1433,   745,   759,
    2507,   772,   238,  2510,  1433,   703,   753,  2304,   776,   772,
     851,   770,   694,   772,   759,  4192,   857,  1875,   859,  2526,
     772,   772,  3967,   759,  3344,  2322,   770,   770,   772,  1433,
    1433,   759,  4331,  3617,   769,   635,   770,  2544,   772,  2054,
     721,  1951,  3813,  1953,   634,  1115,  1116,  1117,  1118,  1855,
    2054,  1118,   303,  2259,   748,  1965,  5006,   770,  1968,  1129,
     772,   944,  1972,   946,   947,   948,   238,  1702,  1899,   952,
    2944,   954,  5017,   769,  3223,   686,  3225,   944,   961,   946,
     947,   948,   184,   753,   186,   952,   777,   954,   186,  1999,
    2000,  2001,  2285,  2285,   961,  5149,  5149,   759,   631,    33,
    5149,  4675,   238,   769,  4678,  5150,  4786,  4658,   734,   772,
    4786,  1899,  2285,   777,  2307,  2307,   777,  2310,  2310,  1937,
     961,  4210,  1118,   777,   770,   714,   772,   723,  2321,  2321,
     759,   770,   753,   772,  2307,   714,  1771,  2310,  1969,   769,
     252,   770,  4570,   772,   776,  2160,   759,   772,  2321,   769,
     772,  1786,  5819,   769,  1789,   683,  1791,   770,   772,   772,
    1795,  1796,  1797,  5789,   329,  5791,  5792,   284,  1803,   551,
    3134,   377,   769,   379,  4614,   770,   769,   772,   770,   714,
     772,  1969,   347,  4134,  1266,  4093,  1268,   769,   353,   569,
    1724,  5858,  5859,   263,  2392,  4146,  2002,    86,   772,  5492,
     769,   303,   714,  3407,  3148,   770,   265,   772,   414,   760,
     761,   762,   763,   772,   379,   218,   776,   772,   777,  1436,
     772,   211,  4167,  4168,   753,   437,  4171,  4172,  3548,  1316,
     770,   769,  4177,  4178,  4786,   174,  1306,   443,   573,  1309,
     770,   675,  4796,   130,   356,   753,     9,    10,   777,   772,
     770,  4679,   772,   607,   753,   754,   755,   772,   114,  5634,
    1342,  1908,   416,  4208,    35,     9,    10,   772,  1908,   777,
     772,   130,   770,  2069,   654,   572,  5160,  5903,  5904,     9,
      10,  5907,   171,   172,     9,    10,   205,   176,  2106,  2107,
     319,   772,  2110,     9,    10,   346,   152,  2115,  2116,  2117,
    5967,  4516,   410,   378,   684,   753,   263,  4192,  2201,  5308,
     265,  4116,  4117,    35,  1381,  2103,  4058,   114,   263,   772,
    2126,   363,  1362,  1363,  2182,  4379,   280,    76,   708,   777,
    3650,  2137,  2138,   461,  1938,  1939,  5017,  1941,  1942,  1943,
     772,   772,   722,  4856,  4857,  4858,  4116,  4117,  1952,  5650,
     263,   305,  4192,  2246,   152,  4459,  2046,   114,   167,  4120,
    4121,  2003,  5988,  1967,  4752,   143,  1433,  5017,  1438,     9,
      10,  2965,   484,   579,   518,  3695,  1433,  3697,  3698,   263,
    4768,  4769,  2072,  3703,   273,  1381,  5017,   211,  4332,  5017,
    5017,  3711,  5017,   586,  1433,   607,  3716,  4332,     9,    10,
      10,   499,  4220,    35,  5625,    15,  5976,   189,   467,   615,
    1480,   462,  1482,  5975,   233,   349,   391,   769,  3753,  1309,
    3755,   184,   530,   186,   776,   777,   214,  3397,   363,    10,
    1320,   406,   136,   137,  1430,   114,  3512,  1433,   408,    32,
     184,  3688,   186,   823,  2193,   415,   558,  4332,   745,  3249,
    3044,   229,  2876,   776,   184,  2102,   186,  3552,   211,   184,
    3054,   186,   606,     9,    10,    35,  5210,   115,   184,   288,
     186,  2113,  2114,  5528,  2935,  5530,  2783,  2938,  2939,  2876,
     299,    94,  3397,  2938,  2939,  2250,    37,    38,   356,   682,
    2505,  2506,  4332,  2691,  2692,  5297,    35,  6040,  5497,   112,
    5389,  2505,   174,   397,    35,   399,   490,  2111,   146,  2715,
       9,    10,   892,  2719,  4278,   125,   660,   753,  3155,   316,
    6082,   772,  3136,   677,  5098,  3630,   283,   152,   743,   233,
     140,  2737,   451,   237,  2549,  2231,   345,  2896,   666,   310,
     303,   777,   735,  2902,   184,  5490,   186,   296,  3422,   392,
    4387,  4388,  4389,  4390,  3659,   584,   721,   560,   497,   303,
     772,   171,   172,   497,  2360,  2361,  3984,  3985,  3986,  3987,
    1640,   646,  1642,   303,   686,   462,  3450,  3824,   303,  5082,
     650,   753,   380,  3397,   288,  2600,  3386,   303,   310,     9,
      10,   263,   576,   644,  5667,   299,  5971,  5972,   696,  2614,
    3473,  5656,  3487,   462,   283,   777,    99,   217,  1678,   465,
    3370,  3371,  5913,  5612,  5613,   570,   484,   753,  3723,  3360,
     679,  1691,  1692,  3728,  4395,   695,   152,  1697,  5370,   584,
     412,  1701,  1702,  1703,   746,   625,  3510,   679,   184,  5321,
     186,   777,  1712,  1713,  5218,     9,    10,  4592,  1718,  5073,
    1720,  1721,  1722,  1723,  1724,   772,  1726,  1724,   482,  3392,
     777,   651,  3361,   303,  3363,   333,  2362,  1737,  5552,  1739,
     772,  5473,  1742,  1743,  2401,  1745,  1746,  1747,   310,  1749,
    1750,  5255,   437,     9,    10,   184,  5199,   186,   326,   270,
     447,  4859,   303,  2708,  1764,  1765,  1766,  1767,  1768,   292,
    1770,  1771,  1772,  2994,   658,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,   333,  1783,  1784,  1785,  1786,   560,  1788,  1789,
    1716,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1724,   482,
    1800,  1801,  1802,  1803,  2430,  1805,  1806,  1807,   695,  1809,
     310,  1811,  2401,  1813,   679,  2401,   205,  1817,  1818,  1819,
     695,   607,  1822,  1823,  1824,  1825,  1826,   303,  1828,  5648,
    1847,     9,    10,   564,   184,  1835,   186,  2426,   447,   726,
    2426,   310,  1842,  1843,  1844,  1845,   448,  1834,   403,   310,
    3580,    42,   695,  1853,  1854,   769,  1856,  1857,     9,    10,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1885,   303,  1875,   450,  4752,   476,  5490,
     704,   695,  2811,   707,  5295,  3175,    73,  3781,   686,   662,
     184,   734,   186,  4768,  4769,   497,    63,     9,    10,    61,
     278,  2846,  2638,  2848,   723,  1215,   569,  1217,  1834,   464,
    5490,  1221,  1222,     9,    10,  3789,  1916,     9,    10,  2759,
     734,  1921,   607,  2763,  5242,   476,   117,   525,   184,  5490,
     186,  1931,  5490,  5490,  4628,  5490,  2776,   128,     9,    10,
     636,  1251,   251,   569,   135,   595,  3082,   403,   323,  2789,
    2790,   432,   433,   303,  4204,  4205,  4206,     9,    10,  5463,
    1972,     9,    10,   994,   995,   996,   211,   589,  5953,  5954,
      94,    93,  4720,  4721,   525,   333,   167,    42,     9,    10,
     714,     9,    10,  3783,     9,    10,     0,    32,   112,    34,
    2935,    12,   402,  2938,  2939,  2940,   374,  4878,  1998,     6,
    5354,   110,   111,  5357,  5358,   736,   184,   581,   186,   303,
    6069,  5623,   563,   115,   446,  3143,    61,  5629,     9,    10,
     769,  1052,  4028,    69,   146,   613,   123,  5759,   130,  5761,
    2030,   446,  2032,   184,  2046,   186,  6095,   228,     9,    10,
      83,   772,   727,   777,    65,   667,  2611,   303,  4298,  4299,
     237,  4301,   117,  4934,  4026,   110,   111,  3720,     9,    10,
    2072,    68,   451,   128,  5475,   374,  2066,   442,   259,   479,
     135,  5575,   184,  3002,   186,    93,   238,  2734,   121,   772,
     531,   777,  5180,     9,    10,   659,  5850,  4854,   184,  5853,
     186,  1401,   184,   695,   186,   366,  4790,  2669,   772,   522,
     523,   564,   167,   526,   527,   528,  3630,   485,   205,   772,
       9,    10,   772,   184,   281,   186,   361,   772,   476,   165,
    2697,   171,   172,     9,    10,   303,   772,  2697,   668,  2855,
     681,   719,   184,    80,   186,   769,   184,   183,   186,  3472,
    2888,  5551,  2965,  2891,    91,  2734,   772,  2895,  2734,   449,
     563,  2151,   303,   184,     5,   186,   184,  4192,   186,   184,
    2896,   186,   594,   228,  5776,  5777,  2902,   525,  2632,  5793,
    5794,  5525,     9,    10,   772,   284,   140,  2803,  4404,   594,
      31,  2917,  2182,   483,   564,   736,  4534,  4535,  3992,  3993,
     458,   303,  2204,   184,   259,   186,   564,  3530,  3552,  3723,
      63,    18,   772,  4007,  3728,     9,    10,   303,   171,   172,
      11,   303,  2746,   184,    80,   186,    83,  3608,  4726,  2839,
    3149,  3044,    73,  4473,  2758,  3552,    93,   174,  4043,   497,
      61,  3054,   303,   184,   277,   186,     9,    10,  3782,  3806,
    3807,  3808,  3809,  3739,  2923,  4495,  3739,  6011,  5752,   700,
     476,   303,   445,   192,   121,   303,   572,   120,   184,   559,
     186,   110,   111,     9,    10,   374,   205,   718,     9,    10,
    2988,  5681,   303,   736,   141,   303,  4784,  3405,   303,   146,
    3416,  3417,  5030,   330,  5032,   184,   325,   186,   105,   106,
    1600,   238,   437,  3421,   679,  3584,   772,  4332,   184,  3588,
     186,   500,     9,    10,  3440,  2305,    63,    18,   353,     9,
      10,  3940,   303,  3942,  2314,  2315,     9,    10,   185,   374,
     595,   172,  5070,   736,   263,   126,  2305,  5916,   192,   187,
     601,   140,   303,   297,   352,  5819,    15,   563,   402,  3754,
     640,   205,  2305,   772,   846,   544,   731,   184,  2305,   186,
    5476,  2885,   303,  2887,  3840,  5965,   736,  5455,  5964,  2893,
    2894,   212,  5974,   120,     9,    10,    61,  5242,   736,  5250,
       9,    10,   146,   423,  5858,  5859,   518,   303,   487,   426,
     184,   753,   186,  3839,  5078,   653,  5080,   251,   890,  5083,
      17,  2391,   772,  3784,   105,   106,  5090,  5091,  3134,  3784,
     593,  2401,  5150,  5278,   303,    32,     9,    10,   272,  2409,
     277,   184,   451,   186,  3837,  3838,  1447,   303,   281,   437,
     770,   439,  2401,  3846,   695,  3848,  2426,  3850,  2428,   745,
    5574,  2431,   487,  2433,   112,  3380,  5130,  3155,   184,   710,
     186,  2441,  2442,   184,  2401,   186,   125,  2426,   265,  2428,
     299,   589,  3397,  3786,   312,   681,   265,   149,   289,   290,
     423,   140,   607,  3397,   606,  2428,   303,     9,    10,  2426,
      93,  2428,     9,    10,   171,   172,   233,   184,   772,   186,
     679,   176,  2469,  5967,   184,   177,   186,   211,   297,  5615,
    4740,   184,  2305,   186,  3839,   714,  4746,  4747,  4748,   303,
    3845,  6090,  6091,  4753,  4754,   279,  3851,   753,  2305,  4759,
     736,   529,   451,    49,    24,   340,   772,  4767,   660,     9,
      10,  4771,   112,     6,   281,   374,   204,  1837,  4778,   667,
     303,   288,  4782,  4783,  2305,  2535,  2536,  2537,   217,   184,
    5421,   186,   299,  2469,   759,   184,   238,   186,   565,   566,
     497,     9,    10,  3482,   265,   770,   759,   303,   777,   316,
     391,   425,   303,  3140,  1874,    79,  4572,   770,    82,  4834,
    3140,  5079,  4837,    95,  4839,   299,     9,    10,  4838,   117,
    4840,   184,   727,   186,   775,    68,   442,  5095,  2401,   607,
     128,   416,     9,    10,   772,  5289,   303,   135,  1908,     9,
      10,   123,   112,   303,  2401,   714,  4871,   299,  4873,  4874,
     303,  2611,  4723,  2426,  4725,  2428,   100,  4728,   100,   753,
    4731,   772,  5878,  4734,  4735,   642,  5134,   772,  5136,  2426,
    2401,  2428,  2632,   489,   465,  2632,  2636,  2637,   487,  2639,
    2640,   149,   184,   253,   186,  3406,   128,   184,  2648,   186,
    2650,    32,   777,   208,   264,  2426,  5663,  2428,   303,  4770,
     772,   296,  3227,  3608,   303,     6,    57,  5361,   182,   177,
     292,  5365,   294,  3238,   229,  4958,   772,    58,   770,   265,
    3245,  2681,     9,    10,  5691,    17,  4557,     6,  3406,    70,
     228,  4868,     9,    10,   184,  2695,   186,  3354,    89,  5955,
     303,   772,    34,   185,   560,    33,  2632,   772,  2708,    90,
       6,  2711,   758,   759,   760,   761,   762,   763,    15,   316,
     772,   259,  2734,   118,   772,   100,   184,    68,   186,   352,
     125,  3296,     9,    10,  2734,  2735,  4426,  4427,     9,    10,
       6,   772,   770,   124,  2756,  2055,   130,   772,   100,    68,
     264,   184,  2764,   186,   772,  2734,   123,  2757,   149,   610,
    3325,   303,  4577,  4453,    92,  3354,   303,   184,  3354,   186,
      26,   770,    68,   772,   184,  3454,   186,     9,    10,   770,
     500,  4018,     9,    10,  4474,  2095,   177,   171,   172,  1460,
    1461,  6149,  2102,  5826,  2104,   190,   122,  3454,  2798,   770,
       9,    10,    68,     9,    10,  2775,  1150,  3630,  4332,   164,
       9,    10,   728,   303,   437,   141,   439,  4384,   237,   770,
     204,  4484,   769,  1494,     9,    10,  5520,  2839,   125,   776,
     777,   152,   213,  4070,  1178,  2145,     9,    10,  3767,  3784,
     759,  2853,  2842,   140,   770,   303,     9,    10,  3584,  3977,
     704,   770,  3588,   772,   708,   210,   769,   184,   770,   186,
     772,     9,    10,     6,   777,  3454,  4529,   184,  3454,   186,
     303,   770,     9,    10,   171,   172,   204,     9,    10,   769,
       9,    10,  2808,   274,   770,   777,   303,   675,  2198,  4025,
    3739,   331,    63,   303,   278,   683,   251,     9,    10,   280,
    3723,   689,  3366,   770,  4575,  3728,   529,   184,  3480,   186,
       9,    10,    10,   184,   769,   186,    97,    57,     9,    10,
     217,  2734,   777,   284,  4739,    68,     6,  3872,  2928,   406,
     466,    11,  5182,   770,  5184,    15,  5186,  2734,     9,    10,
    2952,    95,  2942,   192,  2944,     9,    10,  2959,  2960,   120,
     278,   132,   184,    32,   186,   112,   205,   184,    37,   186,
    4456,  2271,   661,  2734,  4970,   736,   770,  2277,  6003,  6004,
      28,  3916,  5237,  5084,    32,   184,   303,   186,   184,    37,
     186,   661,     9,    10,   607,   184,   303,   186,     9,    10,
     374,  4336,  4337,  4338,   770,  4340,   772,   770,  5248,   184,
    3000,   186,    36,  4348,  4349,  4350,  4351,   448,   770,   149,
     772,   184,   769,   186,   263,    95,   397,   263,   399,   374,
    4778,   184,    10,   186,   770,  4783,   303,    15,  6063,   770,
      95,   386,   303,  4366,  3568,   770,   184,   177,   186,     9,
      10,   577,   776,  3615,  1524,  3781,  3991,   184,   584,   186,
     654,   770,   184,   772,   186,   184,   592,   186,    92,   115,
     151,   753,   233,   770,   115,  5989,   758,   759,  4413,   115,
     770,   303,   184,  1331,   186,   297,   303,   770,  2195,  1337,
    1338,   115,  2199,  1563,  1564,   184,    57,   186,  3806,  3807,
    3808,  3809,   777,   184,   303,   186,   130,   303,    83,   416,
    3117,   485,     6,   266,   303,   725,   249,   250,    93,   777,
     281,     9,    10,  4058,    93,    94,   259,   288,   303,    36,
     184,    84,   186,    93,  6048,   770,   649,  6051,   299,   665,
     303,   770,   263,   488,   274,   278,   121,   125,  4809,   425,
     303,     9,    10,    11,   770,   316,   772,  4283,  4952,  4953,
    3739,   251,   140,  3739,  4969,   303,   141,   184,   770,   186,
     772,   146,   196,   184,  6088,   186,   303,   770,   549,   550,
     204,   303,   333,   734,   303,    92,   742,   743,   149,   745,
      49,   747,  4022,   171,   172,  5751,    76,   770,  5754,   772,
     726,   303,   770,  1415,   772,  5445,  1418,  1419,   115,  4490,
     185,   769,   451,  4494,   303,   560,   177,   758,   759,  3209,
    3210,  3211,   303,   130,   184,  3215,   186,   270,  3218,    57,
     770,     5,   772,  3984,  3985,  3986,  3987,  3227,   770,   217,
    3209,  3210,  3211,   770,  4567,   776,  3236,    93,  3238,   303,
    3240,  3167,  3242,  3243,  3244,  3245,  3246,  3247,   776,  3249,
    4940,    89,  3209,  3210,  3211,   460,  5630,  3257,   419,  3259,
      69,   442,  3262,  3263,  3264,   772,  3984,  3985,  3986,  3987,
      95,  3271,  3272,  3273,   681,  3275,   303,  3277,   112,  3279,
     770,  3281,   303,  3283,  5573,   141,   184,   204,   186,   599,
     146,  3291,   277,  3293,   639,  3295,  3296,  3297,  3298,  3299,
    4844,   769,  3302,   274,  3304,   465,  5872,  3307,   489,     9,
      10,   149,   770,  5879,   576,   476,   184,   770,   186,   772,
    3320,   464,  4083,   192,   695,  3325,   707,  4564,  3328,   185,
    3330,  3331,  3332,   303,   180,  3335,   205,   770,   372,   177,
     270,  3341,  3354,  1624,  1625,   180,  3346,  1628,    69,   770,
     770,   772,   772,   770,  3354,  3355,   165,   772,     9,    10,
     770,  3361,   416,  3363,   525,  4083,  3366,   114,   266,  3366,
       3,   668,   553,  3938,   183,  3354,  3376,  3377,  3378,  3379,
     770,  3381,   772,   348,  4120,  4121,  3386,  2697,    93,    94,
    3962,   339,   340,   776,   263,    28,  3209,  3210,  3211,    32,
     505,   506,   563,   272,    37,   303,  2716,    40,   770,  5254,
     772,   769,  3209,  3210,  3211,   520,   597,  4553,  4554,   770,
    3420,   772,  3422,  3420,   197,  5991,  5992,   769,   376,   374,
     239,   240,   769,  3420,  3360,   303,   274,  4893,   769,   343,
    3366,  3420,   115,   770,   165,   769,  4582,   419,  3420,   769,
    3450,  3420,   728,  5116,  3454,   372,  3420,  3420,  3420,  3420,
     110,   111,   183,  3420,  4879,    98,  5196,   769,   416,     9,
      10,  1029,    34,    17,   419,  3454,  4899,   770,  5168,   772,
    4903,  3481,   769,   387,   184,   389,   186,   769,    32,  1047,
      34,  3488,   728,   770,  3420,  1053,  1054,  3454,   944,   770,
     946,   947,   948,  2813,   476,   769,   952,    57,   954,  4332,
    3510,   769,  3512,   618,   619,   770,   769,   772,   239,   240,
     681,  5017,   769,    29,  5017,  4097,   159,   670,   671,   672,
     673,   476,    38,   184,    69,   186,  5762,   166,   770,    89,
    4338,  3354,  4340,   770,   741,   770,    69,   772,  4893,   270,
     769,   585,  4350,  4351,    60,    95,   425,  3354,  5373,   191,
     770,   770,   772,   191,   770,     9,    10,  3493,  4348,  4349,
    4104,   770,   753,   754,   755,   736,   770,   481,   772,   769,
    3580,    87,   451,  3354,   770,   770,   772,    93,   191,   769,
    5435,   563,    98,   770,   769,   772,   296,   770,   769,   149,
     769,  3601,   125,   303,   522,   523,   112,  3420,   526,   527,
     528,   772,   557,     9,    10,  2925,   191,   770,   563,   772,
     769,   127,   770,  3420,  1814,  1815,   530,   177,   134,  3629,
     165,   769,   777,   770,  3646,  3647,  3648,  3649,   770,  3651,
    3652,   770,   165,   769,   184,   151,   186,   595,   183,  3420,
     265,   770,   303,   772,   769,  3655,  3656,  3454,   770,   693,
     183,    76,   769,    78,   612,   769,  4384,   769,   585,   614,
     176,   770,    69,   197,   770,   579,   772,   769,   197,  3679,
     668,   769,   315,  3454,   770,   769,   772,  3699,  3700,   637,
    3702,  3691,  3704,  3705,  3706,  3707,  3708,  3709,  3710,    95,
    3712,   374,   639,  3715,   239,   240,   770,  3719,   381,   681,
     769,    69,  5962,   770,   220,   772,   239,   240,  5448,   225,
     226,  3721,  3722,   396,   274,     9,    10,   769,   125,   677,
    5604,   769,   365,   239,  5608,   772,   681,     9,    10,  3739,
     184,   769,   186,   770,   769,   769,   419,   291,   292,   770,
     770,   770,   772,   772,   770,  5981,   772,   769,  3758,   696,
    3739,   769,   699,   303,   736,   669,   769,   769,   165,     9,
      10,    11,   769,  4534,  4535,   720,   693,   374,   769,  3758,
    4406,   650,  3739,   769,   753,   329,   183,   691,   184,   726,
     186,   736,   298,   576,   770,  3758,   772,   734,   180,    17,
     772,  3758,   770,   347,   772,    95,   770,   165,   772,   353,
     770,    95,   772,   770,    32,   772,  4534,  4535,   180,   770,
    3820,   772,   266,    95,   237,   183,  3826,   772,   769,   769,
    3140,  5222,  3142,  3833,   340,   379,  3836,  5222,   769,  5569,
      58,  5690,   239,   240,   770,   769,   772,  3826,   769,     9,
      10,   524,    70,   661,   770,   361,   772,   726,   769,   303,
    3860,  3861,   769,   769,   537,   734,   769,   777,   770,  3826,
     772,  4436,    90,   770,   769,   772,  5750,  4556,  5723,   476,
     769,   239,   240,   769,   557,  3885,   770,  3887,   772,  3889,
     769,  3891,   525,   769,     9,    10,    11,   769,   769,  4556,
     184,  5716,   186,   770,   122,   772,   124,   303,   679,   770,
    3910,   772,   184,  3223,   186,  3225,   769,  5332,  5333,   770,
    5335,   772,   777,   770,  5930,   772,  3739,   433,   769,   562,
     563,  3931,  3932,   566,   777,    95,   569,   570,  3938,  4504,
    3940,  4870,  3942,   769,   184,  3758,   186,  3947,   757,   758,
     759,   760,   761,   762,   763,   777,   770,    57,   772,   769,
     557,  3758,  4710,   770,   769,   772,   563,  4556,  3739,   769,
    4556,  4719,    42,   770,   770,   772,   772,  3989,   503,   769,
     505,   506,   777,   770,    57,   772,  5649,  3758,   770,    89,
     772,   769,  3992,  3993,  5490,   520,   770,  5490,   772,  4167,
    4168,   769,   635,  4171,  4172,   105,  4951,  4007,   681,  4177,
    4178,    11,   770,  3826,   772,   648,    89,   614,   770,   303,
     772,   654,   777,   696,   184,    57,   186,   769,  4028,  3826,
     769,   303,   105,   769,    34,   756,   757,   758,   759,   760,
     761,   762,   763,   777,   770,   678,   772,   117,  4727,   149,
     770,   684,   772,   769,   687,  4042,   769,    89,   128,   769,
     769,    61,   280,   303,   424,   135,  4638,   700,   574,   184,
    5733,   186,   769,   105,   292,   708,   149,   177,   110,   111,
     770,   770,   772,   772,   681,   770,  4098,   772,   721,   722,
     769,  4091,  4092,   618,   619,   769,  5511,   167,  5513,  5514,
     769,   769,   769,   769,   177,   769,   769,   769,   769,  4681,
     110,   111,   769,   769,  5929,   769,  4042,   149,   777,     9,
      10,   754,   769,   720,  4124,   769,   769,   769,   769,   769,
     130,   769,   769,   141,  4134,   769,    93,   770,   156,   736,
     679,   777,  6148,   303,   695,   177,  4146,    33,  4148,   667,
      36,   777,   777,   500,   787,    34,   418,    93,   228,   772,
     123,   772,   795,    53,    54,    55,    56,   772,   801,   574,
     803,   171,   172,   348,   274,    93,   176,   721,   772,   397,
     180,   399,    61,  4730,   382,  5576,  5577,   772,   303,   259,
     823,  5576,  5577,   772,   571,   690,   753,  5860,    80,   832,
     734,   274,   451,   451,   204,    94,    92,  5937,   772,   196,
      96,   844,   265,   846,   281,   100,   125,   107,   108,   109,
      26,   756,   757,   758,   759,   760,   761,   762,   763,   115,
      61,   110,   111,   756,   757,   758,   759,   760,   761,   762,
     763,   238,   274,   396,   130,   778,     5,   880,   575,   882,
     395,   130,   885,   886,   887,   888,   889,   890,     4,   892,
     734,   777,   416,   340,   776,   776,   772,  4284,  4802,  4269,
     769,   161,   162,    34,  4841,   769,   203,  5222,   278,   769,
     379,   769,   769,    67,  3594,   197,   777,   769,    33,    93,
      93,    36,   171,   172,   184,    14,   186,   176,    93,   772,
      61,   180,   302,  6118,    84,   777,   777,  3617,  3618,   419,
     943,  5160,   945,   151,   125,   695,   770,  6132,   204,   769,
     953,   112,   955,  6138,  5072,   204,   497,  5075,  5076,  6144,
     348,  4331,   550,   553,   334,   296,   123,   970,  6001,    95,
     333,   240,   232,  6073,   296,  4362,   769,    92,   776,   110,
     111,    96,   151,   772,     6,   769,   416,  3667,   244,   756,
     757,   758,   759,   760,   761,   762,   763,   770,   770,   130,
     115,   770,    68,   324,   374,   640,   394,  2268,  4378,   772,
     164,   374,   777,   770,   770,   130,   770,   171,   172,   777,
      93,    11,   278,    93,   770,   770,   770,  2288,   777,   278,
     758,   759,   760,   761,   762,   763,  2297,   140,   769,   100,
     171,   172,  2303,   303,   304,   176,   769,   772,   270,   180,
    2311,    42,    42,   302,   772,    93,   210,   772,   760,   772,
     110,   111,  2323,  4433,  4434,  2326,  4436,   777,    34,   772,
     658,   679,   760,   204,   125,   438,   480,  4447,  4448,  4449,
     130,   196,   440,   453,    93,   334,   474,   692,   772,   204,
      80,   770,  4462,    83,  4464,   424,   679,   251,   769,   772,
     769,    91,   416,    93,   778,   125,   772,  4477,  4478,   196,
     100,   238,   351,   476,   104,   485,   372,  1120,   218,   707,
     500,   171,   172,   500,   114,   374,   117,   117,   500,   244,
     379,   121,   500,   123,  4504,  4517,   348,   128,   128,   500,
     400,   500,   730,   772,   135,   135,  4516,   278,   536,   772,
     753,   141,    84,   667,   204,  4525,   146,   270,  4540,     6,
     664,   587,   525,   278,   734,   128,   770,   555,   556,   770,
     770,   302,   560,   561,   562,   770,   167,   167,  1181,  1182,
     128,   770,  5688,   188,   769,   772,  4556,    26,   104,   180,
     180,   777,   428,   229,   557,   185,   777,    49,  4568,   656,
     563,  5160,  4572,   334,  5160,  1208,   769,  4556,   468,   407,
     772,   586,  1215,   470,  1217,   205,   470,   770,  1221,  1222,
     374,   772,    53,    54,    55,    56,    29,   296,   278,  4556,
     725,  4613,   386,  5351,   283,   769,   485,   228,   228,   294,
     628,   379,   294,   374,   215,    17,   177,   237,  1251,   694,
     772,   201,   302,    95,   180,   185,   772,   372,   270,   772,
    5559,  5576,  5577,   115,   635,  4635,   116,   123,   259,   259,
     770,  5490,   641,   533,    42,   535,   107,   108,   109,  4575,
     540,   770,   652,   770,   416,   760,  1289,   277,   770,   677,
    1293,   770,   770,   283,   284,    95,  1299,  1300,  1301,   770,
     333,   759,   769,   777,   770,   770,   770,   297,   770,   299,
     770,  4693,   302,   772,  1317,   770,   770,   770,   681,   770,
    5826,   770,   772,  1326,   374,  6110,   770,   238,   770,   585,
     161,   162,  4724,   772,   488,  5841,  5295,  1340,  1341,  5295,
     192,   374,   769,   772,   772,   605,  4738,   763,   770,   117,
     770,   770,   769,   205,   485,   769,   196,   769,  1361,   769,
     128,   769,   769,  4755,    49,   770,   366,   135,   582,  5875,
     753,   265,   742,   736,  4756,  4757,    42,   265,  1381,  1382,
     265,  4773,    99,  4775,  4776,   525,   419,   270,   648,  4556,
    4772,    95,    93,   772,    93,   769,   772,   494,  1401,   167,
      95,   232,   606,   652,   769,   438,   560,   237,   772,    62,
     772,   777,   180,  1416,  4796,  4556,  4786,   777,   770,   400,
     272,   777,   770,   772,     6,   772,   661,   772,   724,  4799,
    4800,  1434,  1435,   772,    93,   485,   128,   693,   568,   128,
    1443,   740,   428,   476,   538,   769,   548,   251,   299,   251,
     649,   117,   251,   251,  1457,   251,   180,   447,   769,    93,
     228,   266,   128,  1466,  1467,   772,   753,   753,   753,   135,
     585,  1474,  1475,   304,  4841,  1478,   753,   753,   738,   753,
     753,   753,   753,   753,  4841,  1488,   753,   468,   753,   749,
     753,   259,   525,   742,   725,   753,   499,   416,   126,   305,
     753,   167,   753,   753,   770,   753,   753,   753,  4878,   753,
     753,   753,   753,  4809,   180,   350,  5475,   280,   284,  5475,
     205,   652,   357,   753,   557,   770,   568,   141,   321,   270,
     563,  5490,   770,   770,  5490,   270,   270,   777,   373,   772,
     772,   769,   270,   777,   497,  4841,  5599,   772,   383,   384,
     385,   777,   533,  5495,   535,   745,   777,  5663,   393,   540,
     380,   123,   228,   416,  4934,   770,   251,   122,   122,   400,
     777,   191,    15,   425,  1577,    18,   770,  1580,   693,  1582,
     777,   721,  4952,  4953,  4971,  5691,   770,   770,   770,  1592,
    1593,   777,   770,   259,    26,   759,   759,  1600,   770,   451,
    4970,  1604,  1605,   770,   772,   688,   326,   769,   270,   769,
      95,   742,   576,    95,    57,  4985,    95,    95,   284,   777,
      18,    49,   265,  5010,   605,   265,  1629,   482,   211,  1632,
     770,   777,   177,   772,  5004,  6141,  5006,   468,  5020,   759,
      11,   326,   299,    86,   753,   310,    89,   499,   681,   753,
     769,   776,   534,   321,  5024,   772,  5026,  1660,    92,    57,
     180,   180,   105,   106,    10,   270,   128,   648,    96,   128,
    5062,  5630,  5059,   772,  5630,   770,   265,  5064,   396,   265,
     396,   265,   219,    11,   769,   769,  1689,   115,    86,   769,
     100,    89,   742,  5746,   177,   449,   177,   532,   777,   224,
     760,   151,   533,   736,   535,    72,   149,   105,   106,   540,
    5092,   546,   576,   270,   760,   180,   340,   402,   114,  5825,
     151,   350,    56,   124,   124,   168,   770,   770,   357,   770,
     770,   177,   777,   176,   177,   769,   185,  5119,   777,   772,
     425,   772,   772,   595,   373,   770,   770,   770,   769,     7,
     740,   149,   770,   770,   383,   384,   385,   738,   122,   770,
     770,    26,   770,   753,   393,   769,   451,   769,   749,   753,
     168,    95,   220,    95,   605,   770,   770,   770,   176,   177,
     770,   211,   772,    41,   636,   775,   776,  1790,   151,   772,
    5160,  5173,   772,  5842,   769,   772,  1799,   632,   770,   777,
     296,   769,   654,   943,   769,    63,   211,  1810,   545,   753,
     772,  5160,   647,   681,   499,    73,   244,   648,  1821,   681,
     396,   180,   265,   769,   284,   366,  5196,  2356,   284,   769,
     273,   274,   275,  5160,  1837,   263,  6135,    11,  5195,   772,
    5210,    99,   770,   772,   696,   265,   186,   699,   435,   684,
     278,   372,   196,   196,   270,  5225,   407,   115,   196,    26,
     732,  5210,   120,   698,   196,   407,   129,   265,   696,   129,
     196,  1874,   696,  1876,   726,   273,   274,   275,   196,   196,
    5250,   583,   734,  5210,   196,   196,   270,    11,   146,   770,
     428,   770,   229,    99,   492,  1898,  1899,   413,   326,  5195,
     770,    26,   235,   532,   770,  1908,  1909,   738,   299,   770,
     635,   185,   772,   494,    26,  1918,   770,   546,   749,   142,
     196,   770,   436,   769,   772,  5295,   770,   772,  5315,  1932,
    1933,   772,   770,   146,   744,  1938,  1939,  1940,  1941,  1942,
    1943,  1944,  1945,  1946,   140,   196,  5295,   180,   391,  1952,
      11,   770,   667,   284,   284,   143,   399,   769,   216,   177,
     177,  5795,   584,  1966,  1967,   650,  1969,   732,  5295,   654,
     112,   130,   732,   204,   402,   233,   216,  5160,   596,   180,
    5350,   180,   777,   241,   374,   475,   266,   230,  1991,    95,
     428,   576,   299,   391,   123,   416,   770,   770,   141,  2002,
     488,   399,   538,   606,   124,    32,   770,    26,   770,   770,
    2013,   696,   770,   772,   272,  4695,   772,   770,   647,  5160,
     777,   770,  6075,   281,   282,    10,   769,  5210,   770,   769,
     646,   770,    11,   769,    26,    26,   769,    79,    26,   769,
    5982,   726,  1182,  5210,   177,    93,   435,   319,   769,   734,
     769,  5421,  2055,   130,   130,   684,    93,   130,   772,   769,
     299,   770,   378,   660,   772,   299,  2069,   130,   263,   698,
     411,  2074,   151,   770,   772,   538,   434,   770,  5448,   770,
     676,   769,   575,  4763,   770,   408,   769,    11,   770,   416,
      67,   772,  2095,   180,   226,   772,   226,    93,    26,  2102,
    2103,  2104,   265,    26,    26,  5475,  2109,   400,  2111,    84,
      84,   284,  5295,   263,   769,    33,   777,   777,   576,   281,
    5490,   770,   770,  2126,   641,   594,  5475,   429,    32,   354,
      34,   769,   769,   594,  2137,  2138,   769,   769,   190,   154,
     776,  5490,  2145,   770,    61,   776,   776,   772,  5475,  5541,
      61,   770,   676,  1293,  5295,    33,    33,    61,   576,  1299,
      10,   197,   770,  5490,  5551,   687,   177,   425,  5555,   702,
      26,   302,   430,    26,  5470,   769,   769,   769,   769,   769,
     123,  5551,   180,   441,   130,  5555,   693,   176,   732,   130,
     281,   327,    61,    11,    91,  2198,   417,   576,   576,  5569,
     641,   714,   769,  6145,  5574,   407,   110,   111,   636,   407,
     769,   115,   419,   776,   770,   776,   230,  2220,   770,   772,
     769,  2224,   650,   769,   173,  5574,   654,   728,   580,   769,
     769,   688,   416,   340,    93,   769,   411,   772,   769,  2242,
     770,  1381,   769,   146,   770,   326,   769,  5574,   226,   320,
     180,   180,   770,   229,    63,   197,   281,   772,   770,   770,
    5630,   704,   470,   714,   707,   770,    26,   416,  2271,    75,
     114,   699,   641,   716,  2277,   177,   237,   769,   772,  2827,
    3420,  5630,   961,  5182,  3717,  5186,  5184,  5475,  5484,   193,
    5475,  5472,  5475,  5663,  5681,  5677,  3561,  5473,   726,  1268,
    5602,  4188,  5313,  5630,  5632,  5774,   704,  5490,  4988,   707,
    2313,  5681,  5699,  5983,   768,  1452,  4100,  1457,   716,  3562,
    5019,  5691,  4335,    71,  5492,  5890,  5889,  1467,  3758,  5699,
    4971,  1497,  3796,  5703,  5475,  1475,  4362,  2329,  2341,  1886,
    2343,  4058,   600,  2848,  3822,  2348,  4860,   857,  4379,  5490,
     254,   255,   256,   837,   980,  3005,  4584,  2360,  2361,  2428,
    2431,  2429,  2207,   621,  2367,   113,  2430,  2349,   626,  1493,
    5294,  2374,  2375,   277,  2377,  2378,  5471,  4277,  5470,  3679,
    5102,  5751,  4526,  5259,  5754,  4530,  4939,  2677,  5848,  2392,
    5932,  5574,  5448,  2396,  6073,  5263,  6020,  6075,   302,   657,
    2876,  5746,  5082,  2406,  4722,   153,  4269,  5574,  5610,  5952,
    2413,  4790,  4278,  6004,  5289,  5065,  5795,  2946,  2947,  2422,
    5825,  5691,  2425,  5842,  3095,  5795,  3840,  5828,  5795,  5363,
     334,   689,   336,  2270,  2963,  3921,  4494,  5819,  2278,  4491,
    1580,  5828,  1582,  4486,  2973,  2974,  6047,  5630,  5992,   353,
      29,   355,   490,  5526,  5991,   490,  5956,  5879,  5828,    38,
    5830,  5872,  5605,  5630,  2296,  4084,  5344,  4277,  1283,  5342,
     374,  4786,  1471,  5855,  5856,  2084,  3544,   381,  3539,  5548,
    2994,    60,  5837,  2245,  2693,  3812,  2815,  5869,  3174,  5630,
    5362,  4396,   396,  1430,   535,  3360,   774,  5867,  3477,  5795,
     404,  1419,  5872,  1383,  3612,  1205,  4371,  3412,    87,  5879,
    3039,  3040,  3041,  3042,    93,   419,  5888,  4517,  3291,    98,
    3295,  3378,  3377,  1818,  3962,  1876,  2138,  1730,  1698,  5330,
    5034,  2133,  4569,   112,  5780,  2128,  4979,  5781,  1381,  5926,
    2154,  3947,  4677,  2931,  1381,  1381,  3604,  1381,   127,  1381,
    4676,  1704,  3945,  5254,  5723,   134,  5926,  5373,  4958,  5941,
    5930,    17,  5944,  5250,  3608,  5268,   780,  5937,  1437,  4681,
     508,  2925,   151,   477,  3126,   490,  2579,  2010,  1411,  1638,
    3167,  4969,  2585,   487,  3493,  5967,  5956,  3643,  4985,   697,
    5960,  4568,  4566,  5929,   880,  2784,   881,   176,  2601,  2341,
     688,  3471,  2785,  1958,  1433,   688,   525,  2842,  5376,  5278,
    2073,  4399,  6071,  1642,  5039,  6098,  6003,  6004,  5339,  5989,
     524,  5991,  5992,  6138,  6144,  1051,  4577,  3354,  2804,   980,
    3452,   687,    17,   537,  4556,  2615,   687,  2738,  3431,  1900,
     684,   220,  3430,  1186,  4203,  2406,   225,   226,  3405,  1634,
    1790,  6038,  2988,  4695,   110,   111,  2102,  5415,  3800,  1799,
     239,  3555,  4284,   728,  1327,   514,   490,   490,   490,    -1,
    1810,  6036,    -1,    -1,   578,    -1,  6063,    -1,  6048,    -1,
     584,  6051,    -1,    -1,    -1,    -1,    -1,    -1,  2691,  2692,
    2693,    -1,    -1,    -1,  2697,    -1,    -1,    -1,  2701,  2702,
    2703,  2704,    -1,  6073,    -1,    -1,  2709,  2710,    -1,  2712,
      -1,    -1,    -1,  2716,    -1,  6102,    -1,    -1,  6088,   298,
      -1,    -1,    -1,   471,    -1,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   643,
      -1,    -1,  2745,  2746,    -1,    -1,   650,    -1,    -1,    -1,
      -1,    -1,    -1,   501,   502,  2758,   504,   505,   506,   507,
     508,   340,   510,   511,   512,   513,   514,   515,   516,   517,
      -1,   519,   520,   521,    -1,    -1,    -1,   681,  6148,    -1,
      -1,    -1,   361,    -1,    -1,  2788,    -1,    -1,    -1,    -1,
      -1,    -1,   696,   697,    -1,    -1,   252,    -1,    -1,    -1,
    1940,  2804,  2805,    -1,  1944,   709,  1946,   263,    -1,    -1,
    2813,  2814,  2815,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2844,    -1,    -1,    -1,    -1,    -1,    -1,  2851,    -1,
      -1,  1991,  2855,    -1,   433,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2002,    -1,    -1,    -1,    -1,   252,   772,    -1,
     618,   619,    -1,  2013,    -1,    -1,    -1,  2880,  2881,  2882,
    2883,    -1,  2885,    -1,  2887,    -1,    -1,    -1,    -1,  2892,
    2893,  2894,    -1,  2896,    -1,    -1,    -1,    -1,     5,  2902,
       7,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2917,    -1,    -1,    -1,  2921,    -1,
      -1,    -1,  2925,  2926,    31,    -1,    33,    -1,    -1,    -1,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   405,
      -1,    -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   419,    -1,   421,    73,    -1,    61,  2109,
      -1,    -1,    -1,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,  2988,  2126,    -1,    -1,    -1,
      -1,  2994,    -1,    -1,    -1,   574,   452,  2137,  2138,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,   115,    -1,
    5690,   467,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
     405,    -1,   115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   419,    -1,   421,    -1,    -1,   146,
      -1,    -1,    -1,   136,   500,   138,    -1,   140,    -1,    -1,
      -1,    -1,  3055,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3064,   518,    -1,    -1,    -1,    -1,   452,    -1,    -1,
      -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,   185,    -1,
    2220,    -1,   467,    -1,    -1,    -1,   193,    -1,    -1,   196,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     193,    -1,    -1,  3632,  3633,    -1,  3635,  3636,    -1,    -1,
      -1,    -1,   219,    -1,  3117,   500,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3126,    -1,  3128,    -1,    -1,    -1,    -1,
      -1,  3134,    -1,   518,  3137,    -1,    -1,  3140,    -1,  3142,
    3143,    -1,    -1,   599,    -1,   724,    -1,   254,   255,   256,
     606,    -1,  3155,    -1,    -1,  3158,    -1,    -1,    -1,    -1,
     616,   254,   255,   256,    -1,    -1,    -1,    -1,    -1,    -1,
     277,    -1,    -1,   629,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5861,    -1,    -1,   277,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   302,    -1,  3726,    -1,    -1,
      -1,    -1,    -1,    -1,   660,    -1,    -1,   663,    -1,   302,
      -1,    -1,    -1,    -1,   599,    -1,    -1,    -1,    -1,   326,
    3223,   606,  3225,   679,    -1,    -1,    -1,   334,    -1,   336,
      -1,   616,    -1,    -1,  2374,  2375,    -1,  2377,  2378,   695,
      -1,   334,    -1,   336,   629,    -1,    -1,    -1,   355,    -1,
      -1,    -1,    -1,    -1,    -1,   362,  2396,    -1,    -1,    -1,
     353,    -1,   355,    -1,    -1,    -1,  2406,   374,    -1,    -1,
      -1,    -1,  5952,    -1,   381,   660,    -1,    -1,   663,    -1,
      -1,   374,    -1,    -1,    -1,    -1,    -1,    -1,   381,   396,
      -1,    -1,    -1,    -1,   679,    -1,    -1,   404,    -1,    -1,
      -1,   408,   409,   396,    -1,    -1,    -1,    -1,   415,    -1,
      -1,   404,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     427,    -1,    -1,    -1,    -1,    -1,   419,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3339,    -1,  6018,    -1,
     447,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   473,    -1,    -1,  3372,
     477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     487,    -1,    -1,    -1,   477,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   487,    -1,    -1,    -1,  3401,    -1,
      -1,    -1,  3405,  3406,  3407,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   524,  3421,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     537,   524,   539,    -1,    -1,    -1,    -1,    -1,    -1,  2579,
      61,    -1,  6122,    -1,   537,  2585,    -1,    -1,  6128,    -1,
      -1,  3454,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      38,   578,    -1,  3476,    -1,    -1,    -1,   584,    -1,    -1,
      -1,    -1,    -1,    -1,  3487,   578,    -1,    -1,    -1,   110,
     111,   584,    60,    -1,   115,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   611,    -1,    -1,    -1,    76,    -1,
      78,    -1,    -1,    -1,    -1,   622,   623,   624,    -1,    87,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,    -1,    -1,   643,    -1,    -1,    -1,
      -1,    -1,    -1,   650,   112,    -1,    -1,    -1,    -1,    -1,
     643,    -1,    -1,  2693,    -1,    -1,    -1,   650,    -1,   127,
      -1,  2701,  2702,  2703,  2704,  3568,   134,    -1,    -1,    -1,
    3573,    -1,   193,    -1,   681,    -1,    -1,    -1,    -1,    -1,
      -1,  3584,    -1,   151,    -1,  3588,    -1,    -1,   681,   696,
     697,  3594,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3602,
      -1,    -1,   709,   696,   697,   712,    -1,    -1,   176,    -1,
      -1,    -1,    -1,    -1,  3617,  3618,   709,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   254,   255,   256,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2788,    -1,
      -1,    -1,   220,    -1,    -1,    -1,   277,   225,   226,    -1,
      -1,    -1,    -1,    -1,  3667,    -1,    -1,    -1,    -1,   776,
      -1,   239,    -1,    -1,    -1,  2815,    -1,    -1,    -1,    -1,
    3683,   302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4222,    -1,    -1,  4225,    -1,    -1,  4228,
    4229,  4230,  4231,    -1,  4233,  4234,  4235,  4236,    -1,  4238,
    4239,    -1,  4241,   334,    -1,   336,  4245,    -1,    -1,    -1,
    4249,  4250,  4251,  4252,    -1,  4254,  4255,    -1,   296,    -1,
     298,  4260,  4261,    -1,   355,  4264,  4265,    -1,    16,    17,
      -1,    -1,    -1,  2883,    22,    23,    -1,    -1,    -1,    -1,
      -1,    -1,  2892,   374,    32,    -1,  2896,    29,  3761,    -1,
     381,    -1,  2902,    -1,    -1,    -1,    38,    -1,    -1,    -1,
      -1,    -1,   340,    -1,    -1,   396,    -1,  2917,  3781,    -1,
      58,    -1,    -1,   404,    -1,    -1,    -1,    -1,    60,    -1,
      -1,    -1,    70,   361,    -1,    -1,    -1,  3800,   419,    -1,
      -1,    -1,  3805,  3806,  3807,  3808,  3809,    -1,    -1,  3812,
      -1,    -1,    90,    -1,    -1,    87,    -1,    -1,    -1,    -1,
    3823,    93,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     112,    -1,    -1,    -1,    -1,    -1,   124,    -1,   416,    -1,
      -1,    -1,    -1,    -1,    -1,   127,   477,    -1,    -1,    -1,
      -1,    -1,   134,    -1,    -1,   433,   487,    -1,    -1,   147,
     148,    -1,   150,    -1,    -1,    -1,    -1,    -1,    -1,   151,
     158,   159,   160,    -1,    -1,    -1,    -1,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    38,    -1,    -1,    -1,
     178,    -1,    -1,   524,   176,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3917,    -1,   537,    -1,    60,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   213,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,   220,    -1,
      -1,    93,    -1,   225,   226,    -1,    98,   578,    -1,   237,
    3963,    -1,    -1,   584,    -1,   243,    -1,   239,    -1,    -1,
     112,    -1,    -1,    -1,  3977,    -1,    -1,    -1,    -1,    -1,
      -1,  3984,  3985,  3986,  3987,   127,  3989,    -1,    -1,   267,
     268,   269,   134,    -1,  3134,    -1,    -1,  3137,    -1,    -1,
      -1,    -1,  4005,  4006,    -1,    -1,   574,    -1,    -1,   151,
      -1,    -1,    -1,   291,   292,    -1,    -1,    -1,  3158,    -1,
      -1,    -1,   643,    -1,    -1,    -1,   298,    -1,    -1,   650,
      -1,  4034,    -1,    -1,   176,    -1,    -1,    -1,   310,    -1,
    4043,    -1,    -1,    -1,    -1,    -1,  4049,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     681,    -1,    -1,    -1,   342,    -1,   344,   345,   340,    -1,
      -1,    -1,    -1,    -1,    -1,   696,   697,    -1,   220,    -1,
    4083,    -1,   360,   225,   226,    -1,  4089,  4090,   709,   361,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,    -1,    -1,
      -1,  4104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4120,  4121,   397,
      -1,   399,    -1,    -1,  4127,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   420,    -1,   416,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,
      -1,   433,    -1,    -1,    -1,   443,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   454,   455,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   340,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4736,   486,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   495,    -1,   361,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    29,  4758,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    38,    -1,    -1,    -1,    60,
    4263,  3401,    -1,   541,   542,   543,    -1,  3407,    -1,    -1,
      -1,   549,   550,    -1,   416,  4278,    -1,    60,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,   566,   567,
      -1,   433,    93,    -1,    -1,    -1,    -1,    98,    -1,    -1,
      -1,    -1,   574,    -1,    87,    -1,    -1,    -1,    29,    -1,
      93,   112,   590,   591,    -1,    98,    -1,    38,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   127,  4330,    -1,   112,
      -1,   609,  4335,   134,    -1,    -1,    -1,    -1,    -1,    60,
      -1,    16,    17,    -1,   127,    -1,    -1,    22,    23,    -1,
     151,   134,    -1,    -1,    -1,    -1,    -1,    32,    -1,  4362,
      -1,    -1,  4365,    -1,    -1,  4368,    87,    -1,   151,    -1,
      -1,    -1,    93,    -1,    -1,   176,    -1,    98,    -1,    -1,
      -1,  4384,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   112,    -1,   176,    -1,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,
      -1,    -1,    -1,   134,    -1,    90,    -1,    -1,    -1,   220,
      -1,    -1,    -1,   701,   225,   226,   704,    -1,    -1,   707,
     151,    -1,   574,  3573,    -1,    -1,    -1,   220,   239,    -1,
      -1,    -1,   225,   226,  3584,    -1,    -1,    -1,  3588,   124,
      -1,    -1,   730,    -1,    -1,   176,   239,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   749,   147,   148,    -1,   150,    -1,    -1,    -1,  4482,
      -1,    -1,    -1,   158,   159,   160,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4499,   298,    -1,   220,
      -1,    -1,    -1,   178,   225,   226,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4517,   298,    -1,    -1,   239,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4530,    -1,    -1,
      -1,  4534,  4535,    -1,    -1,    -1,    -1,  4540,   213,   340,
      -1,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      38,    -1,    -1,  4556,  4557,    -1,    -1,   340,    -1,    -1,
     361,    -1,   237,  4566,    -1,    -1,    -1,    -1,   243,    -1,
      -1,    -1,    60,    -1,  4577,  4578,    -1,   298,   361,    -1,
      -1,    -1,    -1,  4586,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   267,   268,   269,    -1,    -1,    -1,    -1,    87,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,    -1,   416,   291,   292,    -1,   340,
      -1,    -1,  4625,    -1,   112,  4628,    -1,  4630,    -1,    -1,
      -1,    -1,   433,   416,    -1,    29,    -1,    -1,    -1,   127,
     361,  3781,    -1,    -1,    38,    -1,   134,    -1,    -1,    -1,
     433,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   151,    -1,  4668,    60,   342,    -1,   344,
     345,    -1,  3812,    -1,  4677,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   360,    -1,    -1,   176,    -1,
      -1,    -1,  4695,    87,    -1,   416,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,    98,    -1,  4709,    -1,    -1,    -1,
      -1,    -1,   433,    -1,    -1,    -1,    -1,    -1,   112,    -1,
      -1,    -1,   397,  4726,   399,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,   127,  4737,    -1,  4739,   225,   226,    -1,
     134,    -1,  4745,    -1,    -1,   420,    -1,    -1,  4751,    -1,
      -1,   239,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,
    4763,  4764,    -1,    -1,    -1,    -1,    -1,    -1,   443,    -1,
      -1,    -1,    -1,   574,    -1,    -1,    -1,    -1,    -1,   454,
     455,  4784,   176,    -1,    -1,    -1,    -1,  4790,  4791,    -1,
      -1,   574,    -1,  4796,    -1,    -1,    -1,    -1,    -1,  4802,
      -1,    32,    -1,    34,  4807,    -1,    -1,    -1,    -1,    -1,
     298,   486,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     495,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      61,   225,   226,  4836,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   239,    -1,    -1,    -1,    -1,
      -1,    -1,   340,   574,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   541,   542,   543,    -1,
      -1,    -1,    -1,   361,   549,   550,    -1,    -1,    -1,   110,
     111,    -1,    -1,    -1,   115,    -1,    -1,    -1,    -1,    -1,
      -1,   566,   567,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   590,   591,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   609,    -1,  4939,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   433,   340,    -1,    -1,  4089,
    4090,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   193,    -1,    -1,    -1,  4969,   361,  4971,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4979,    -1,    -1,    -1,
    4120,  4121,    -1,    -1,    -1,  4988,    -1,    -1,    -1,  4992,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5000,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5009,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5019,    -1,    -1,    -1,
      -1,    -1,    -1,   254,   255,   256,   701,    -1,    -1,   704,
      -1,    -1,   707,    -1,    -1,    -1,    -1,    -1,    -1,   433,
      -1,    -1,    -1,    -1,    -1,    -1,   277,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   730,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5073,   302,    -1,    -1,   749,  5078,  5079,  5080,    -1,  5082,
    5083,    -1,  5085,    -1,    -1,    -1,   574,  5090,  5091,    -1,
      -1,    -1,  5095,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   334,    -1,   336,    -1,    -1,    -1,   667,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   353,    -1,   355,    -1,    -1,  5130,    -1,    -1,
      -1,  5134,    -1,  5136,    -1,    -1,   694,    -1,    -1,    -1,
      -1,    -1,    -1,   374,    -1,    -1,    -1,    -1,    -1,    -1,
     381,    -1,  5155,    -1,    -1,  5158,    -1,   715,  5161,    -1,
      -1,    -1,    -1,    -1,    -1,   396,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   404,    -1,  5178,    -1,    -1,    -1,    -1,
     574,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   419,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5738,
    5739,    -1,  5741,  5742,  5743,  5744,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   477,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   487,    -1,  5261,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5270,    -1,    -1,
      -1,    -1,  5275,    -1,    -1,    -1,    -1,    -1,   836,    -1,
      -1,  5284,  5285,  5286,    -1,    -1,  5289,    -1,    -1,    -1,
      -1,    -1,    -1,   524,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   537,    -1,    -1,    -1,
      -1,    -1,    -1,  5316,    -1,    -1,    -1,    -1,  5321,    -1,
      -1,    -1,  5325,    -1,  5327,  5854,    -1,    -1,  5857,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5865,    -1,    -1,    -1,
      -1,  5870,    -1,    -1,  5347,    -1,    -1,   578,    -1,    -1,
      -1,  5354,    -1,   584,  5357,  5358,    -1,    -1,  5361,    -1,
      -1,    -1,  5365,    -1,  5367,    -1,    -1,    -1,    -1,    -1,
    5373,    -1,    -1,  5376,    -1,   933,    -1,    -1,    -1,  5382,
      -1,    -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    17,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5410,    -1,    32,
      -1,    -1,   643,    -1,    -1,  5418,    -1,    40,    41,   650,
      -1,    -1,    -1,    -1,    -1,   983,    -1,    50,    -1,    -1,
     988,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    66,    -1,    -1,    -1,    -1,    -1,    -1,
     681,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5461,    -1,
    1018,    -1,    -1,  1021,    -1,   696,   697,    -1,    -1,    -1,
    1028,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   709,    -1,
      -1,    -1,    -1,    -1,    -1,  4625,    -1,   110,   111,  5492,
    4630,    -1,   115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   129,    -1,  1066,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5520,    -1,    -1,
      -1,    -1,  5525,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5544,    -1,    -1,    -1,    -1,  5549,    -1,    -1,    -1,
      -1,    -1,    -1,  5556,    -1,    -1,    -1,  1115,  1116,  1117,
    1118,  5564,  5565,  1121,    -1,    -1,    -1,    -1,    -1,   192,
      -1,  1129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   205,    -1,    -1,    -1,    -1,    -1,  5591,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5605,    -1,    -1,  4745,  5609,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5620,    -1,  5622,
    5623,    -1,    -1,    -1,    -1,    -1,  5629,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     263,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5652,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5690,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   332,
      -1,    -1,    -1,  5716,    -1,    -1,    -1,    -1,   341,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     353,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   364,    -1,    -1,    -1,    -1,    -1,    -1,  1306,    -1,
      -1,    -1,  1310,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   388,    -1,  5770,    -1,    -1,
    5773,    -1,    -1,  5776,  5777,    -1,    -1,  5780,  5781,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5789,    -1,  5791,  5792,
      -1,    -1,    -1,    -1,    -1,   418,   419,    -1,    -1,   422,
      -1,   424,    -1,  5806,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5819,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   450,   451,    -1,
      -1,    -1,    -1,    -1,  5837,   458,   459,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5848,    -1,    -1,    -1,  1407,
      -1,    -1,   475,    -1,    -1,    -1,    -1,    -1,  5861,    -1,
    5000,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   497,    -1,    -1,    -1,    -1,  5882,
    1438,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   518,    -1,    -1,    -1,    -1,
    5903,  5904,    -1,    -1,  5907,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1480,    -1,  1482,    -1,  5929,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5952,
      -1,   574,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5967,   588,    -1,    -1,    -1,    -1,
      -1,  5974,    -1,    -1,    -1,    -1,   599,  5980,    -1,   602,
     603,    -1,    -1,    -1,    -1,  5988,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   617,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6018,    -1,    -1,  5158,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     653,    -1,  6035,  6036,    -1,    -1,    -1,   660,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   679,    -1,   681,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1640,    -1,  1642,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   731,    -1,
      -1,    -1,    -1,    -1,   737,  6118,    -1,    -1,    -1,  6122,
    1678,    -1,    -1,    -1,    -1,  6128,    -1,    -1,    -1,  6132,
      -1,    -1,    -1,  1691,  1692,  6138,    -1,    -1,    -1,  1697,
      -1,  6144,    -1,  1701,  1702,  1703,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1712,  1713,  1714,    -1,    -1,    -1,
    1718,    -1,  1720,  1721,  1722,  1723,  1724,    -1,  1726,    -1,
      -1,  1729,  1730,    -1,    -1,    -1,    -1,    -1,    -1,  1737,
      -1,  1739,    -1,    -1,  1742,  1743,    -1,  1745,  1746,  1747,
      -1,  1749,  1750,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1764,  1765,  1766,  1767,
    1768,    -1,  1770,  1771,  1772,    -1,    -1,  1775,  1776,  1777,
    1778,  1779,  1780,  1781,    -1,  1783,  1784,  1785,  1786,    -1,
    1788,  1789,    -1,  1791,  1792,  1793,  1794,  1795,  1796,  1797,
      -1,    -1,  1800,  1801,  1802,  1803,    -1,  1805,  1806,  1807,
      -1,  1809,    -1,  1811,    -1,  1813,    -1,    -1,    -1,  1817,
    1818,  1819,    -1,    -1,  1822,  1823,  1824,  1825,  1826,    -1,
    1828,    -1,    -1,    -1,    -1,    -1,    -1,  1835,  5418,    -1,
      -1,    -1,    -1,    -1,  1842,  1843,  1844,  1845,    -1,     5,
      -1,     7,    -1,    -1,    -1,  1853,  1854,    -1,  1856,  1857,
      -1,    -1,  1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,
    1868,  1869,  1870,  1871,  1872,    31,    -1,  1875,    -1,    -1,
      -1,    -1,  1880,    39,    -1,    -1,    -1,    -1,    -1,  1887,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,  1916,    -1,
      -1,    -1,    -1,  1921,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1931,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,   115,
      -1,    -1,    -1,    -1,  5544,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1998,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   667,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   185,
      -1,    -1,  2030,    -1,  2032,   694,    -1,   193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2054,    -1,    -1,    -1,
      -1,    -1,    -1,   219,    -1,    -1,    -1,    -1,  2066,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   254,   255,
     256,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   302,    -1,    -1,    -1,
      -1,    -1,    -1,  2151,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     326,    -1,    -1,    -1,    -1,    -1,    -1,   836,   334,    -1,
     336,    -1,    -1,    -1,  2182,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5773,    -1,    -1,    -1,    -1,    -1,   355,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   374,    -1,
      -1,    -1,    -1,    -1,    -1,   381,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     396,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,
      -1,    -1,   408,    -1,    -1,    -1,    -1,    -1,    -1,   415,
      -1,    -1,    -1,   419,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   933,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   447,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2314,  2315,    -1,    -1,
      -1,   477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   988,
      -1,   487,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1018,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   524,  1028,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   537,    -1,   539,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2391,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   578,    -1,    -1,    -1,    -1,    -1,   584,    -1,
      -1,    -1,    -1,  2431,    -1,  2433,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2441,  2442,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1118,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   643,    -1,    -1,
      -1,    -1,    -1,    -1,   650,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2505,  2506,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   681,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2535,  2536,  2537,
     696,   697,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2549,    -1,   709,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2600,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2611,    -1,    -1,  2614,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2632,    -1,    -1,    -1,  2636,  2637,
      -1,  2639,  2640,    -1,    -1,    -1,    -1,  1306,    -1,    -1,
    2648,    -1,  2650,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2681,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2695,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2708,    -1,    -1,  2711,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2735,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2757,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1438,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2798,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1480,    -1,  1482,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2846,    -1,
    2848,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2928,    -1,    -1,    -1,    -1,    -1,    -1,  2935,    -1,    -1,
    2938,  2939,  2940,    -1,  2942,    -1,  2944,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1640,    -1,  1642,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3000,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1678,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1697,    -1,
      -1,    -1,  1701,    -1,  1703,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1712,  1713,    -1,    -1,    -1,    -1,  1718,
      -1,  1720,  1721,  1722,  1723,  1724,    -1,  1726,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1737,    -1,
    1739,    -1,    -1,  1742,  1743,    -1,  1745,  1746,    -1,    -1,
    1749,  1750,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1764,  1765,  1766,  1767,  1768,
      -1,  1770,    -1,  1772,    -1,    -1,  1775,  1776,  1777,  1778,
    1779,  1780,  1781,    -1,  1783,  1784,  1785,    -1,    -1,  1788,
    1789,    -1,    -1,  1792,  1793,  1794,    -1,    -1,    -1,    -1,
      -1,  1800,  1801,  1802,    -1,    -1,  1805,  1806,  1807,    -1,
    1809,    -1,  1811,    -1,  1813,    -1,    -1,    -1,  1817,  1818,
    1819,    -1,    -1,  1822,  1823,  1824,  1825,  1826,    -1,  1828,
      -1,    -1,    -1,    -1,    -1,    -1,  1835,    -1,    -1,    -1,
      -1,    -1,    -1,  1842,  1843,  1844,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3215,    -1,    -1,
    3218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3227,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3236,    -1,
    3238,    -1,  3240,    -1,  3242,  3243,  3244,  3245,  3246,  3247,
      -1,  3249,    -1,    -1,    -1,    -1,    -1,  1916,    -1,  3257,
      -1,  3259,  1921,    -1,  3262,  3263,  3264,    -1,    -1,    -1,
      -1,    -1,  1931,  3271,  3272,  3273,    -1,  3275,    -1,  3277,
      -1,  3279,    -1,  3281,    -1,  3283,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3291,    -1,  3293,    -1,  3295,  3296,  3297,
    3298,  3299,    -1,    -1,  3302,    -1,  3304,    -1,    -1,  3307,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3320,    -1,    -1,    -1,    -1,  3325,    -1,    -1,
    3328,    -1,  3330,  3331,  3332,    -1,    -1,  3335,    -1,  1998,
      -1,    -1,    -1,  3341,    -1,    -1,    -1,    -1,  3346,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3355,    -1,    -1,
      -1,    -1,    -1,  3361,    -1,  3363,    -1,    -1,  3366,    -1,
      -1,  2030,    -1,  2032,    -1,    -1,    -1,    -1,  3376,  3377,
    3378,  3379,  3380,  3381,    -1,    -1,    -1,    -1,  3386,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3397,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2066,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3422,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3450,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3481,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3510,    -1,  3512,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3580,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3601,    -1,    -1,    -1,    -1,    -1,    -1,
    3608,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2314,  2315,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3691,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2391,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2431,    -1,  2433,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2441,  2442,    -1,    -1,  3784,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3820,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3833,    -1,    -1,  3836,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3860,  3861,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3872,    -1,  2535,  2536,  2537,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3885,    -1,  3887,
      -1,  3889,    -1,  3891,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3910,    -1,    -1,    -1,    -1,    -1,  3916,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3931,  3932,    -1,    -1,    -1,    -1,    -1,
    3938,    -1,  3940,    -1,  3942,    -1,    -1,    -1,    -1,  3947,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2632,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2648,
      -1,  2650,    -1,  3991,  3992,  3993,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4007,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2681,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4028,    -1,    -1,    -1,    -1,    -1,  2695,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2708,
      -1,    -1,  2711,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4058,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2735,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2757,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4124,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4134,    -1,    -1,  2798,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4146,    -1,
    4148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2928,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2942,    -1,  2944,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3000,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4433,  4434,    -1,  4436,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4447,
    4448,  4449,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4462,    -1,  4464,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4477,
    4478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4504,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4516,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4525,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3215,    -1,    -1,  3218,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4568,    -1,    -1,    -1,  4572,    -1,    -1,  3236,    -1,    -1,
      -1,  3240,    -1,  3242,  3243,  3244,  3245,  3246,  3247,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3257,    -1,
    3259,    -1,    -1,  3262,  3263,  3264,    -1,    -1,    -1,    -1,
      -1,    -1,  3271,  3272,  3273,    -1,  3275,    -1,  3277,    -1,
    3279,    -1,  3281,    -1,  3283,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3291,    -1,  3293,    -1,  3295,    -1,  3297,  3298,
    3299,    -1,    -1,  3302,    -1,  3304,    -1,    -1,  3307,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3320,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3328,
      -1,  3330,  3331,  3332,    -1,    -1,  3335,    -1,    -1,    -1,
      -1,    -1,  3341,    -1,    -1,    -1,    -1,  3346,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3355,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3366,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3377,  3378,
      -1,    -1,  3381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3422,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3450,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4799,  4800,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3510,    -1,  3512,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4878,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4934,    -1,    -1,    -1,
      -1,    -1,  3601,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4951,  4952,  4953,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4970,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4985,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5024,    -1,  5026,    -1,
      -1,    -1,  3691,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3820,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3833,    -1,    -1,  3836,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5196,    -1,
      -1,  3860,  3861,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5222,    -1,  3885,  5225,  3887,    -1,
    3889,    -1,  3891,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3910,  5250,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3931,  3932,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3947,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3992,  3993,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4007,    -1,
      -1,    -1,  5350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4028,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5421,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5448,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4124,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4134,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4146,    -1,  4148,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5569,    -1,    -1,    -1,    -1,    -1,    -1,  5576,  5577,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5663,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5691,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5703,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4378,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4433,  4434,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4447,  4448,
    4449,    -1,    -1,    -1,    -1,    -1,    -1,  5795,    -1,    -1,
      -1,    -1,    -1,  4462,    -1,  4464,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4477,  4478,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5830,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4525,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4568,
      -1,    -1,    -1,  4572,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5930,    -1,    -1,    -1,    -1,    -1,    -1,  5937,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6073,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4799,  4800,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4878,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4934,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4952,  4953,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4970,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4985,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5024,    -1,  5026,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5225,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5250,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5421,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5703,    -1,    -1,    -1,     6,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    29,    30,    -1,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    -1,    43,    44,    45,    46,    -1,
      48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,
      -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,
      88,    89,    -1,    -1,    -1,    -1,  5795,    -1,    -1,    -1,
      -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,
      -1,  5830,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,
      -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,
     168,    -1,    -1,   171,   172,   173,    -1,   175,   176,   177,
      -1,   179,   180,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,
     198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,  5930,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,
     258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,
      -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,  6148,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,    -1,   746,   747,
     748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     758,   759,    -1,    -1,    -1,    -1,   764,    -1,    -1,    -1,
       6,   769,    -1,    -1,    -1,   773,   774,    -1,    -1,   777,
     778,    17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    29,    30,    -1,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    -1,    -1,    43,    44,    45,
      46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,
      -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,
     106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,
      -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,
      -1,    -1,   168,    -1,    -1,   171,    -1,   173,    -1,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,
      -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,
      -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,
     286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    -1,
     746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   758,   759,     7,     8,    -1,    -1,   764,    -1,
      -1,    -1,    -1,   769,    -1,    -1,    -1,   773,   774,    -1,
      -1,   777,   778,    -1,    27,    -1,    29,    -1,    31,    -1,
      33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    -1,    -1,
      63,    -1,    65,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      73,    -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    -1,    -1,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   144,    -1,   146,    -1,    -1,    -1,    -1,   151,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   181,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   195,   196,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   206,   207,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   218,   219,   220,    -1,   222,
      -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,    -1,    -1,
     233,    -1,    -1,    -1,   237,    -1,    -1,    -1,   241,   242,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   279,    -1,   281,    -1,
     283,    -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   298,   299,    -1,    -1,    -1,
      -1,    -1,    -1,   306,   307,   308,   309,    -1,   311,   312,
     313,   314,   315,   316,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,    -1,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,    -1,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,    -1,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,    -1,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,    -1,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
      -1,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    -1,   746,   747,   748,   749,     7,     8,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   769,    27,    -1,    29,
      -1,    31,    -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    -1,    -1,    63,    -1,    65,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,    -1,    99,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   144,    -1,   146,    -1,    -1,    -1,
      -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   195,   196,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   206,   207,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,   219,
     220,    -1,   222,    -1,    -1,    -1,    -1,   227,    -1,    -1,
      -1,    -1,    -1,   233,    -1,    -1,    -1,   237,    -1,    -1,
      -1,   241,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   279,
      -1,   281,    -1,   283,    -1,    -1,    -1,    -1,   288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   298,   299,
      -1,    -1,    -1,    -1,    -1,    -1,   306,   307,   308,   309,
      -1,   311,   312,   313,   314,   315,   316,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
      -1,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,    -1,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,    -1,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
       7,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,
      27,    -1,    -1,    -1,    31,    -1,    33,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   144,    -1,   146,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   195,   196,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,
     207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   218,   219,    -1,    -1,   222,    -1,    -1,    -1,    -1,
     227,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
     237,    -1,    -1,    -1,   241,   242,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   279,    -1,   281,    -1,   283,    -1,    -1,    -1,
      -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   299,    -1,    -1,    -1,    -1,    -1,    -1,   306,
     307,   308,   309,    -1,   311,   312,   313,   314,   315,   316,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,    -1,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,    -1,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,    -1,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,    -1,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,    -1,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    -1,   746,
     747,   748,   749,    17,    18,    19,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    29,    30,    -1,    32,    -1,
      -1,    -1,   769,    -1,    -1,    39,    40,    -1,    -1,    43,
      44,    45,    46,    -1,    48,    49,    -1,    51,    52,    -1,
      -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,
      -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
     154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,
      -1,   165,    -1,    -1,   168,    -1,    -1,   171,   172,   173,
      -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,   233,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,
     274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   285,   286,   287,   288,    -1,    -1,    -1,    -1,   293,
      -1,   295,    -1,    -1,    -1,   299,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,    17,
      18,    19,    20,    21,   758,   759,    -1,    25,    -1,    -1,
     764,    29,    30,    -1,    32,   769,    -1,    -1,    -1,   773,
     774,    39,    40,   777,   778,    43,    44,    45,    46,    -1,
      48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,
      -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   133,    -1,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,
      -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,
     168,    -1,    -1,   171,   172,   173,    -1,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,
     198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,
     258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,   271,    -1,   273,   274,   275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,
      -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,    -1,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,    -1,   746,   747,
     748,   749,    -1,    -1,    -1,    17,    18,    19,    20,    21,
     758,   759,    -1,    -1,    -1,    -1,   764,    29,    30,    -1,
      32,   769,    -1,    -1,    -1,   773,   774,    39,    40,   777,
     778,    43,    44,    45,    46,    -1,    48,    49,    -1,    51,
      52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,
      -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,
     102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,
      -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,
     172,   173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,
     202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,
      -1,   293,    -1,   295,   296,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    -1,   746,   747,   748,   749,    -1,    -1,
      -1,    17,    18,    19,    20,    21,   758,   759,    -1,    -1,
      -1,    -1,   764,    29,    30,    -1,    32,   769,    -1,    -1,
      -1,   773,   774,    39,    40,   777,   778,    43,    44,    45,
      46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,
      -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,
     106,    -1,    -1,    -1,   110,   111,   112,    -1,   114,    -1,
      -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,
      -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,
      -1,    -1,   168,    -1,    -1,   171,   172,   173,    -1,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,
      -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,
      -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,
     286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    -1,
     746,   747,   748,   749,    -1,    -1,    -1,    17,    18,    19,
      20,    21,   758,   759,    -1,    -1,    -1,    -1,   764,    29,
      30,    -1,    32,   769,    -1,    -1,    -1,   773,   774,    39,
      40,   777,   778,    43,    44,    45,    46,    -1,    48,    49,
      -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,
      -1,    -1,    -1,    -1,    -1,    95,    -1,    -1,    -1,    -1,
      -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,
      -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,
      -1,   171,   172,   173,    -1,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,
     200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,
      -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,
     260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,
      -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
      -1,    -1,    -1,    17,    18,    19,    20,    21,   758,   759,
      -1,    -1,    -1,    -1,   764,    29,    30,    -1,    32,   769,
      -1,    -1,    -1,   773,   774,    39,    40,   777,   778,    43,
      44,    45,    46,    -1,    48,    49,    -1,    51,    52,    -1,
      -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    95,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,
      -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
     154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,
      -1,   165,    -1,    -1,   168,    -1,    -1,   171,   172,   173,
      -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,
     274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,
      -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,    17,
      18,    19,    20,    21,   758,   759,    -1,    -1,    -1,    -1,
     764,    29,    30,    -1,    32,   769,    -1,    -1,    -1,   773,
     774,    39,    40,   777,   778,    43,    44,    45,    46,    -1,
      48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,
      -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    95,    -1,    -1,
      -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,
      -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,
     168,    -1,    -1,   171,   172,   173,    -1,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,
     198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,
     258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,
      -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,    -1,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,    -1,   746,   747,
     748,   749,    -1,    -1,    -1,    17,    18,    19,    20,    21,
     758,   759,    -1,    -1,    -1,    -1,   764,    29,    30,    -1,
      32,   769,    -1,    -1,    -1,   773,   774,    39,    40,   777,
     778,    43,    44,    45,    46,    -1,    48,    49,    -1,    51,
      52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,
      -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,
     102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,
     112,    -1,   114,    -1,    -1,    -1,    -1,    -1,   120,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,
      -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,
     172,   173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,
     202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,
      -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    -1,   746,   747,   748,   749,    -1,    -1,
      -1,    17,    18,    19,    20,    21,   758,   759,    -1,    -1,
      -1,    -1,   764,    29,    30,    -1,    32,   769,    -1,    -1,
      -1,   773,   774,    39,    40,   777,   778,    43,    44,    45,
      46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,
      -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,
     106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,
      -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,
      -1,    -1,   168,    -1,    -1,   171,   172,   173,    -1,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,
      -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,
      -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,
     286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    -1,
     746,   747,   748,   749,    -1,    -1,    -1,    17,    18,    19,
      20,    21,   758,   759,    -1,    -1,    -1,    -1,   764,    29,
      30,    -1,    32,   769,    -1,    -1,    -1,   773,   774,    39,
      40,   777,   778,    43,    44,    45,    46,    -1,    48,    49,
      -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,
      -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,
      -1,   171,   172,   173,    -1,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,
     200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,
      -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,
     260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,
      -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
      -1,    -1,    -1,    17,    18,    19,    20,    21,   758,   759,
      -1,    -1,    -1,    -1,   764,    29,    30,    -1,    32,   769,
      -1,    -1,    -1,   773,   774,    39,    40,   777,   778,    43,
      44,    45,    46,    -1,    48,    49,    -1,    51,    52,    -1,
      -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,
      -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
     154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,
      -1,   165,    -1,    -1,   168,    -1,    -1,   171,   172,   173,
      -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,
     274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,
      -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,    17,
      18,    19,    20,    21,   758,   759,    -1,    -1,    -1,    -1,
     764,    29,    30,    -1,    32,   769,    -1,    -1,    -1,   773,
     774,    39,    40,   777,   778,    43,    44,    45,    46,    -1,
      48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,
      -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,
      -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,
     168,    -1,    -1,   171,   172,   173,    -1,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,
     198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,
     258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,
      -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,    -1,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,    -1,   746,   747,
     748,   749,    -1,    -1,    -1,    17,    18,    19,    20,    21,
     758,   759,    -1,    -1,    -1,    -1,   764,    29,    30,    -1,
      32,   769,    -1,    -1,    -1,   773,   774,    39,    40,   777,
     778,    43,    44,    45,    46,    -1,    48,    49,    -1,    51,
      52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,
      -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,
     102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,
      -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,
     172,   173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,
     202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,
      -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    -1,   746,   747,   748,   749,    -1,    -1,
      -1,    17,    18,    19,    20,    21,   758,   759,    -1,    -1,
      -1,    -1,   764,    29,    30,    -1,    32,   769,    -1,    -1,
      -1,   773,   774,    39,    40,   777,   778,    43,    44,    45,
      46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,
      -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,
     106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,
      -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,
      -1,    -1,   168,    -1,    -1,   171,   172,   173,    -1,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,
      -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,
      -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,
     286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    -1,
     746,   747,   748,   749,    -1,    -1,    -1,    17,    18,    19,
      20,    21,   758,   759,    -1,    -1,    -1,    -1,   764,    29,
      30,    -1,    32,   769,    -1,    -1,    -1,   773,   774,    39,
      40,   777,   778,    43,    44,    45,    46,    -1,    48,    49,
      -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,   154,   155,   156,   157,    -1,    -1,
      -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,
      -1,   171,    -1,   173,    -1,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,
     200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,
      -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,
     260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,
      -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
      -1,    -1,    -1,    17,    18,    19,    20,    21,   758,   759,
      -1,    -1,    -1,    -1,   764,    29,    30,    -1,    32,   769,
      -1,    -1,    -1,   773,   774,    39,    40,   777,   778,    43,
      44,    45,    46,    -1,    48,    49,    -1,    51,    52,    -1,
      -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,
      -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
     154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,
      -1,   165,    -1,    -1,   168,    -1,    -1,   171,    -1,   173,
      -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,
     274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,
      -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,    17,
      18,    19,    20,    21,   758,   759,    -1,    -1,    -1,    -1,
     764,    29,    30,    -1,    32,   769,    -1,    -1,    -1,   773,
     774,    39,    40,   777,   778,    43,    44,    45,    46,    -1,
      48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,
      -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,
      -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,
     168,    -1,    -1,   171,    -1,   173,    -1,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,
     198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,
     258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,
      -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,    -1,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,    -1,   746,   747,
     748,   749,    -1,    -1,    -1,    17,    18,    19,    20,    21,
     758,   759,    -1,    -1,    -1,    -1,   764,    29,    30,    -1,
      32,   769,    -1,    -1,    -1,   773,   774,    39,    40,   777,
     778,    43,    44,    45,    46,    -1,    48,    49,    -1,    51,
      52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,
      -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,
     102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,
      -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,
      -1,   173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,
     202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,
      -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    -1,   746,   747,   748,   749,    -1,    -1,
      -1,    17,    18,    19,    20,    21,   758,   759,    -1,    -1,
      -1,    -1,   764,    29,    30,    -1,    32,   769,    -1,    -1,
      -1,   773,   774,    39,    40,   777,   778,    43,    44,    45,
      46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,
      -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,
     106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,
      -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,
      -1,    -1,   168,    -1,    -1,   171,    -1,   173,    -1,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,
      -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,
      -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,
     286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    -1,
     746,   747,   748,   749,    -1,    -1,    -1,    17,    18,    19,
      20,    21,   758,   759,    -1,    -1,    -1,    -1,   764,    29,
      30,    -1,    32,   769,    -1,    -1,    -1,   773,   774,    39,
      40,   777,   778,    43,    44,    45,    46,    -1,    48,    49,
      -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,
      -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,
      -1,   171,    -1,   173,    -1,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,
     200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,
      -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,
     260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,
      -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
      -1,    -1,    -1,    17,    18,    19,    20,    21,   758,   759,
      -1,    -1,    -1,    -1,   764,    29,    30,    -1,    32,   769,
      -1,    -1,    -1,   773,   774,    39,    40,   777,   778,    43,
      44,    45,    46,    -1,    48,    49,    -1,    51,    52,    -1,
      -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,
      -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
     154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,
      -1,   165,    -1,    -1,   168,    -1,    -1,   171,    -1,   173,
      -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,
     274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,
      -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,    -1,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,    -1,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,   758,   759,    -1,    -1,    -1,    -1,
     764,    29,    30,    -1,    32,   769,    -1,    -1,    -1,   773,
     774,    39,    40,   777,   778,    43,    44,    45,    46,    -1,
      48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,
      -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,
      -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,
     168,    -1,    -1,    -1,    -1,   173,    -1,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,
     198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,
     258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,
      -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,    -1,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,    18,   746,   747,
     748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     758,   759,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   769,    -1,    -1,    -1,    -1,   774,    -1,    -1,   777,
     778,    -1,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,   106,    -1,    -1,    -1,   110,
     111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   176,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,    -1,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    24,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   777,   778,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    24,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    -1,   746,   747,   748,   749,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,   760,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      32,   746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   760,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    32,   746,   747,   748,   749,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    61,    -1,    -1,    -1,   778,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,     6,     7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   778,
      -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    99,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
     115,    -1,    -1,    -1,    -1,   120,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,
      -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,   272,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   281,   282,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,     6,     7,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      41,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    63,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    99,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,    -1,    -1,   115,    -1,    -1,    -1,    -1,   120,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,
      -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   216,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     241,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,   272,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     281,   282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,    -1,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,     6,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      35,   746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,     6,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   778,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    36,   746,   747,   748,
     749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,   115,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   244,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    11,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    17,   746,   747,   748,
     749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,    -1,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    -1,   746,   747,   748,   749,    16,
      17,    -1,   753,    -1,    -1,    22,    23,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   124,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     147,   148,    -1,   150,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   158,   159,   160,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   213,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     237,    -1,    -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     267,   268,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   291,   292,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,    -1,   311,   312,   313,   314,   315,    -1,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,    -1,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,    -1,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,    -1,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,    -1,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,    -1,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,    -1,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    -1,   746,
     747,   748,   749,    16,    17,    -1,    -1,    -1,    -1,    22,
      23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   147,   148,    -1,   150,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   158,   159,   160,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   178,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   237,    -1,    -1,    -1,    -1,    -1,
     243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   267,   268,   269,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   291,   292,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,    -1,   311,   312,
     313,   314,   315,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,    -1,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,    -1,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,    -1,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,    -1,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,    -1,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,    -1,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    -1,   746,   747,   748,   749,    16,    17,    -1,
      -1,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   124,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   147,   148,
      -1,   150,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   158,
     159,   160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   213,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   237,    -1,
      -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   267,   268,
     269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   291,   292,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,    -1,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,    -1,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
      -1,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,    -1,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,    -1,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,    -1,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
      -1,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,    16,    17,    -1,    -1,    -1,    -1,    22,    23,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   124,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   147,   148,    -1,   150,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   158,   159,   160,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   178,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   213,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   237,    -1,    -1,    -1,    -1,    -1,   243,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   267,   268,   269,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   291,   292,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,    -1,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,    -1,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,    -1,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
      -1,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,    -1,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,    -1,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,    17,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    17,   746,   747,   748,   749,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    17,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    18,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    24,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    -1,
     746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,    -1,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,    -1,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,    45,   746,   747,
     748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,    -1,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
      -1,   669,   670,   671,    -1,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,    -1,   746,   747,
     748,   749,    37,    38,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    47,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   769,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,    -1,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,    45,    46,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    45,   746,   747,   748,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    74,   746,   747,   748,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    46,   746,   747,   748,
     749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     769,    -1,    -1,    -1,    -1,   774,    -1,    -1,   777,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    47,   746,   747,   748,   749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,    -1,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
      -1,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,    -1,   746,   747,   748,   749,    57,    -1,
      -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    -1,   746,   747,   748,
     749,    57,    -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,    -1,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,    -1,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,    -1,
     746,   747,   748,   749,    57,    -1,    -1,    -1,    61,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    61,   746,   747,   748,   749,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    61,   746,   747,   748,
     749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      61,   746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,    -1,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,    61,   746,   747,   748,   749,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
      -1,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,    61,   746,
     747,   748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,    -1,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,    61,   746,   747,   748,   749,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,    -1,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,    61,   746,   747,   748,
     749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,    -1,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,    -1,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   770,    -1,    -1,    -1,    -1,
      -1,    -1,   777,   778,   139,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   778,   139,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   778,   139,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   778,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   777,   778,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   778,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   299,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   769,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   769,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   769,    -1,    -1,    -1,    -1,   774,
      -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   769,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   760,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,   112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   769,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     105,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   769,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   171,   172,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   187,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   246,   247,   248,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      95,   746,   747,   748,   749,   100,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   759,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      95,   746,   747,   748,   749,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   760,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   760,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   760,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   760,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   760,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   760,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,   753,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   237,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   204,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   204,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,    -1,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    -1,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,    -1,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,    -1,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,    -1,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,    -1,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,    -1,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
      -1,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,    -1,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,    -1,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,    -1,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,    -1,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,    -1,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,    -1,   638,   639,   640,   641,   642,   643,   644,
      -1,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,    -1,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,    -1,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
      -1,   746,   747,   748,   749,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,    -1,   311,    -1,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,    -1,    -1,    -1,    -1,   342,   343,   344,
     345,   346,    -1,    -1,   349,   350,   351,   352,    -1,    -1,
      -1,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
      -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,    -1,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,    -1,   402,    -1,   404,
     405,   406,   407,   408,   409,   410,    -1,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,    -1,    -1,    -1,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
      -1,    -1,    -1,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,    -1,   458,   459,    -1,   461,   462,    -1,    -1,
     465,    -1,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,    -1,   479,   480,   481,   482,   483,   484,
     485,   486,   487,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,    -1,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   110,
     111,    -1,    -1,   578,   579,    -1,   581,   582,   583,   584,
      -1,   586,   587,   588,   589,   590,   591,    -1,    -1,    -1,
      -1,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,    -1,   623,    -1,
     625,   626,    -1,   628,   629,    -1,   631,   632,   633,   634,
     635,   636,    -1,   638,   639,   640,   641,   642,   643,   644,
      -1,   646,   647,   648,    -1,   650,   651,   652,   653,    -1,
     655,   656,    -1,    -1,   659,    -1,    -1,   662,   663,   664,
      -1,   666,    -1,   668,   669,   670,   671,    -1,   673,   674,
     675,   676,    -1,   678,   679,    -1,   681,    -1,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,    -1,   704,
     705,   706,   707,   708,   709,   710,   711,    -1,   713,   714,
     715,    -1,   717,   718,   719,   720,    -1,    -1,   723,   724,
      -1,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,    -1,    -1,   742,   743,    -1,
      -1,   746,    -1,   748,   749,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,    -1,
     311,    -1,   313,   314,   315,    -1,    -1,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,    -1,    -1,
      -1,   342,   343,   344,   345,   346,    -1,    -1,   349,   350,
     351,   352,    -1,    -1,    -1,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,    -1,   366,    -1,    -1,    -1,    -1,
      -1,    -1,   373,    -1,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,   384,   385,    -1,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
      -1,   402,    -1,   404,   405,   406,   407,   408,   409,   410,
      -1,   412,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,    -1,    -1,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,    -1,    -1,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,    -1,   458,   459,    -1,
     461,   462,    -1,    -1,   465,    -1,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,    -1,   479,   480,
     481,   482,   483,   484,   485,   486,   487,    -1,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,    -1,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   110,   111,    -1,    -1,   578,   579,    -1,
     581,   582,   583,   584,    -1,   586,   587,   588,   589,   590,
     591,    -1,    -1,    -1,    -1,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,    -1,   623,    -1,   625,   626,    -1,   628,   629,    -1,
     631,   632,   633,   634,   635,   636,    -1,   638,   639,   640,
     641,   642,   643,   644,    -1,   646,   647,   648,    -1,   650,
     651,   652,   653,    -1,   655,   656,    -1,    -1,   659,    -1,
      -1,   662,   663,   664,    -1,   666,    -1,   668,   669,   670,
     671,    -1,   673,   674,   675,   676,    -1,   678,   679,    -1,
     681,    -1,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,    -1,   704,   705,   706,   707,   708,   709,   710,
     711,    -1,   713,   714,   715,    -1,   717,   718,   719,   720,
      -1,    -1,   723,   724,    -1,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,    -1,
      -1,   742,   743,    -1,    -1,   746,    -1,   748,   749,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,    -1,   311,    -1,   313,   314,   315,    -1,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,    -1,    -1,    -1,    -1,   342,   343,   344,   345,   346,
      -1,    -1,   349,   350,   351,   352,    -1,    -1,    -1,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,    -1,   366,
      -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,   384,   385,    -1,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,    -1,   402,    -1,   404,   405,   406,
     407,   408,   409,   410,    -1,   412,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,    -1,    -1,    -1,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,    -1,    -1,
      -1,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
      -1,   458,   459,    -1,   461,   462,    -1,    -1,   465,    -1,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,    -1,   479,   480,   481,   482,   483,   484,   485,   486,
     487,    -1,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,    -1,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,    -1,    -1,    -1,
      -1,   578,   579,    -1,   581,   582,   583,   584,    -1,   586,
     587,   588,   589,   590,   591,    -1,    -1,    -1,    -1,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,    -1,   623,    -1,   625,   626,
      -1,   628,   629,    -1,   631,   632,   633,   634,   635,   636,
      -1,   638,   639,   640,   641,   642,   643,   644,    -1,   646,
     647,   648,    -1,   650,   651,   652,   653,    -1,   655,   656,
     110,   111,   659,    -1,    -1,   662,   663,   664,    -1,   666,
      -1,   668,   669,   670,   671,    -1,   673,   674,   675,   676,
      -1,   678,   679,    -1,   681,    -1,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,    -1,   704,   705,   706,
     707,   708,   709,   710,   711,    -1,   713,   714,   715,    -1,
     717,   718,   719,   720,    -1,    -1,   723,   724,    -1,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,    -1,    -1,   742,   743,    -1,    -1,   746,
      -1,   748,   749,    -1,    -1,   205,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
      -1,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
      -1,   341,    -1,   343,    -1,    -1,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
      -1,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,    -1,
     400,   401,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
      -1,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,    -1,   487,   488,   489,
     490,   491,   492,   493,   494,    -1,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,    -1,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,    -1,    -1,    -1,   544,   545,   546,   547,   548,    -1,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,    -1,    -1,    -1,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
      -1,    -1,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,    -1,    -1,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,    -1,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,    -1,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,    -1,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,    -1,   702,   703,    -1,   705,   706,    -1,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,    -1,
      -1,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,    -1,   746,   747,   748
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     7,     8,    27,    29,    31,    33,    41,    60,    63,
      65,    66,    73,    80,    93,    99,   110,   111,   112,   120,
     131,   144,   146,   151,   181,   195,   196,   206,   207,   218,
     219,   220,   222,   227,   233,   237,   241,   242,   279,   281,
     283,   288,   298,   299,   306,   307,   308,   309,   311,   312,
     313,   314,   315,   316,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   354,   355,
     356,   357,   358,   359,   360,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   446,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,   746,   747,   748,   749,   769,   780,
     783,   784,   785,   786,   787,   789,   795,   797,   810,   887,
     940,   941,   948,   949,   965,   966,  1002,  1023,  1055,  1115,
    1172,  1224,  1327,  1377,  1380,  1390,  1395,  1401,  1414,  1417,
    1423,  1426,  1431,  1438,  1450,  1453,  1456,  1457,  1459,  1462,
    1463,  1465,  1466,  1469,  1470,  1473,  1695,  1697,  1710,  1713,
    1748,  1756,  1771,  1780,  1794,  1798,  1799,  1803,  1813,  1820,
    1828,  1830,  1836,  1839,  1840,  1872,  1891,  1893,  1901,  1915,
    1916,  1919,  1921,  1922,  1923,  1924,  1928,  1958,  1965,  1967,
    1976,  1979,  2019,  2021,  2026,  2027,  2028,  2029,  2061,  2070,
    2071,  2072,    49,   205,   326,   402,   451,   499,   650,   654,
     696,   726,  1328,  2033,  2034,  2035,  2036,   174,   448,   497,
    1425,  1801,   310,   338,   340,   341,   348,   353,   355,   361,
     376,   386,   401,   411,   416,   430,   444,   445,   451,   457,
     460,   463,   478,   488,   560,   574,   593,   595,   624,   627,
     637,   645,   657,   677,   680,   712,   722,   740,   747,  1893,
    1900,  1910,  1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,
    1003,   518,  1418,   186,   499,   696,  1025,  1757,    49,   115,
     192,   205,   272,   425,   451,   499,   636,   654,   696,   699,
     726,   734,  1709,  1058,   873,   967,  1711,  1831,   115,   396,
     748,  1845,   263,   695,  1961,  1056,  1425,  1225,  1116,    17,
     518,  1786,   237,   247,   937,   942,   944,  1900,   645,   726,
    1961,  1060,   942,   943,   873,  1460,   678,  1925,  1781,   942,
    1966,  1749,  1900,  1458,  1057,   214,  1874,  1714,   146,   279,
     675,  1814,  2020,   171,   172,  1022,  1507,   265,   778,  1894,
     115,  1961,  1900,   743,  2023,  1696,   472,  1900,  1425,   391,
     950,  1968,   796,   589,   667,  1900,  1425,  1821,  2023,  1900,
    1837,     6,   660,   708,     6,   660,  1772,   589,   667,   339,
     340,   376,   416,   595,   612,   637,   677,  2064,  1459,  1466,
    1469,     0,    80,   781,   595,    49,    96,   244,   278,   636,
     726,   830,  1306,  1307,  1308,  1709,  2033,  2034,  2035,  2036,
      95,   123,  1476,  1477,  1691,  1454,  1451,    83,   121,   277,
    1468,  2030,  1467,  2030,   437,   448,   582,   777,  1800,  1801,
    1888,  1900,  1463,  1465,   238,   777,  1345,  1900,   875,  1900,
     753,   753,   875,   100,   112,  1708,   139,  1894,  1900,  1905,
    1063,  1064,  1067,  1090,  1900,  1708,  1369,  1370,   251,  1494,
    2037,  2038,  2033,   753,  1961,  1450,  1453,  1710,  1713,  1748,
    1756,  1797,   777,   888,   296,  1004,  1005,  1008,  1012,   808,
     809,  1894,   734,  1415,  1961,   316,   100,  1065,  1090,    37,
      38,    47,   432,   433,   740,   912,   913,   915,   916,   923,
     924,   925,   927,   933,   960,   961,  1893,  1901,  1913,  1916,
    1917,  1918,  1919,  1921,  1923,   114,   152,   465,   607,  1759,
    1769,  1770,  1708,  1699,    24,  1708,  1708,  1708,  1708,  1708,
     100,  1708,  1708,  1090,  1708,  1708,   650,  1961,  1039,  1901,
       6,     7,    41,    46,    63,    73,    99,   115,   120,   146,
     216,   233,   241,   272,   281,   282,   425,   430,   441,   600,
     604,   621,   626,   657,   689,  1905,  1980,  1984,  1985,  1987,
    1989,  1990,   997,   998,   152,   403,   464,  1716,   461,   666,
    1832,   123,  1841,  1959,    38,    87,    98,   127,   134,   176,
     225,   226,   239,   361,   433,   574,   909,   963,   964,   966,
     972,   973,   974,   975,   979,   980,   981,   982,   983,   992,
     993,   994,   995,  1002,  1017,  1018,  1023,  1042,  1048,  1055,
    1903,  1904,  1961,    17,    18,    19,    20,    21,    29,    30,
      32,    39,    40,    43,    44,    45,    46,    48,    49,    51,
      52,    57,    61,    64,    84,    85,    86,    88,    89,   101,
     102,   103,   105,   106,   110,   111,   112,   120,   122,   135,
     149,   154,   155,   157,   163,   165,   168,   171,   172,   173,
     175,   176,   177,   179,   194,   198,   199,   200,   202,   209,
     220,   228,   231,   251,   257,   258,   260,   261,   265,   273,
     274,   275,   285,   286,   287,   293,   295,   316,   317,   318,
     322,   329,   337,   353,   362,   364,   365,   367,   368,   369,
     370,   371,   386,   398,   399,   400,   448,   454,   456,   468,
     490,   491,   495,   533,   535,   540,   541,   542,   543,   553,
     554,   570,   584,   590,   591,   598,   605,   635,   641,   642,
     648,   655,   685,   704,   705,   706,   707,   711,   712,   726,
     728,   738,   739,   741,   749,   758,   759,   764,   769,   773,
     774,   777,   778,  1469,  1475,  1501,  1502,  1503,  1504,  1508,
    1520,  1524,  1525,  1526,  1527,  1528,  1529,  1530,  1534,  1535,
    1536,  1537,  1545,  1549,  1550,  1551,  1552,  1553,  1555,  1558,
    1864,  1867,  1869,  1870,  1871,  1885,  1892,  1893,  1900,  1910,
      26,  1117,   500,   350,   357,   373,   383,   384,   385,   393,
     532,   546,   647,   684,   698,   945,   947,   728,   938,   944,
    1900,   873,  1427,   909,  1045,   944,     6,   321,   604,  1977,
    1978,  1985,  1987,     6,    68,   249,   250,   259,   278,   464,
     670,   671,   672,   673,  1479,  1486,  1487,  2032,  1926,    32,
      61,   353,   451,   458,   497,   547,   584,   636,   653,   708,
     740,   778,  1269,  1893,  1898,  1900,  1914,  1916,  1917,  1918,
    1920,  1921,  1922,  1923,  1933,  1945,  1949,     6,    40,    41,
      50,   115,   129,   192,   205,   263,   332,   341,   353,   364,
     388,   419,   422,   424,   450,   451,   458,   459,   475,   497,
     518,   574,   588,   599,   602,   603,   617,   653,   660,   681,
     737,  1269,  1305,  1782,  1786,  1787,  1789,  1798,  1893,  1946,
     944,  1961,   152,  1755,   769,  1727,  1736,  1043,  1501,  1873,
     403,  1717,  1755,  1815,  1900,  2023,  1024,   331,  1905,  1432,
    1391,   777,    10,  2024,  1501,  1578,   790,   284,   792,  1804,
     406,  1888,  1890,  1900,  1969,  1905,   112,  1171,  1894,    95,
    1396,   518,   606,   660,  1822,  1823,   270,  2024,   736,  1838,
     661,   808,   211,   299,  1381,  1382,  1383,   661,   808,   263,
    1775,  1708,  1708,    18,   105,   106,   265,  1865,  1866,  1895,
    2063,  2063,  2063,   448,  2062,  2063,  2063,   770,   770,   776,
    1900,  1171,  1171,  1171,   654,   857,   115,   115,   115,   263,
     650,   192,   205,   272,   425,  2037,   325,   874,   874,  2033,
      74,   769,   774,  1475,  1478,  1583,  1584,  1585,  1586,  1587,
    1598,  1599,  1600,  1601,  1603,  1604,  1605,  1888,   189,   412,
    1686,  1687,  1692,   297,  1628,  1476,    93,   141,   146,   185,
    1488,  1653,  1658,  1664,  1665,  1669,   205,  1668,  1681,  1691,
       6,    68,  2031,  1664,  1666,  1469,  1472,  1473,  1665,  1667,
    1471,     6,  1900,  1796,  1795,   777,  1455,  1452,  1929,  1900,
    1330,   725,  1331,   777,   531,   700,   718,    45,  1905,  1906,
    1907,  1984,  1332,  1069,  1091,  1900,    84,  1337,  1336,     5,
      31,    73,   172,   212,   610,  1092,   873,   263,   114,   573,
    1371,  1372,  1373,   649,   425,   734,  2037,  1905,  1402,  1900,
     769,   891,  1013,    76,  1015,  1501,  1012,   270,  1416,  1702,
    1703,  1888,  1068,  1091,     5,  1901,  1026,   914,   925,   927,
      16,    17,    22,    23,    32,    58,    70,    90,   124,   147,
     148,   150,   158,   159,   160,   178,   213,   237,   243,   267,
     268,   269,   291,   292,   342,   344,   345,   360,   397,   399,
     420,   443,   454,   455,   486,   495,   541,   542,   543,   549,
     550,   566,   567,   590,   591,   609,   641,   701,   704,   707,
     730,   740,   749,   918,   960,  1230,  1232,  1234,  1236,  1238,
    1239,  1240,  1241,  1242,  1243,  1244,  1245,  1246,  1247,  1893,
    1916,  1919,  1921,  1923,   776,   776,   460,   772,    35,   310,
      95,  1760,    95,  1760,  1761,  1762,  1766,  1767,  1900,  1769,
    1900,   112,  1707,  1708,   875,   875,   875,   875,  1900,  1091,
     873,  1905,  1101,  1787,   873,  1700,  1708,  1708,  1059,  1040,
     599,  1988,   639,   639,   696,   699,   726,   734,   769,  1500,
     465,   576,  1992,   695,  1994,  1991,    50,   734,  1993,   180,
     358,   660,   270,   180,   772,   416,  1501,   114,  1368,   381,
     606,  1833,  1834,   348,   152,   380,  1847,  1888,  1962,  1963,
     296,   379,   451,  1893,  1902,  1911,  1919,  1921,  1922,  1923,
      95,   100,   553,  1900,  1902,  1902,  1902,  1902,  1900,   296,
    1902,  1900,   416,   963,   776,   784,   968,  1901,   976,   996,
    1900,    60,   340,    93,   151,   220,   298,   964,  1904,  1424,
     122,   758,   759,  1527,   769,   769,   769,   296,  1501,  1581,
    1582,   769,   769,   769,   769,   769,  1500,  1500,  1500,   769,
    1499,   769,   769,   769,   769,   769,   769,   769,   769,   769,
     769,   769,   769,   769,   769,  1501,   769,   110,   111,   365,
     769,  1579,  1580,  1885,  1892,  1910,   769,   769,   769,   769,
    1501,  1499,   769,   769,   769,   769,   769,   769,   769,   769,
     769,   769,   197,   769,   769,   769,  1499,   265,  1866,  1500,
    1499,  1499,   769,   769,   769,   769,   769,   769,   769,   769,
     769,   769,   769,   177,  1892,   769,   769,   769,   769,   769,
     769,   769,   265,   769,   769,   769,   769,   769,   769,   769,
     769,   769,   769,   769,   769,   769,   769,   769,   728,   769,
     769,   769,   769,   769,   728,   769,   769,   769,   769,   769,
     769,   769,   265,   769,   769,   769,   265,   769,   769,   769,
     769,   769,   769,   769,   769,   769,   122,  1527,   122,  1527,
    1527,  1226,  1469,  1501,  1872,  1900,  1892,  1559,     9,    10,
     184,   186,   303,  1505,  1506,    81,    97,   126,   132,   169,
     753,   754,   755,  1509,    15,   125,   140,   217,   668,  1507,
      69,   165,   183,   239,   240,   756,   757,   758,   759,   760,
     761,   762,   763,  1527,    34,   166,   191,   191,   741,  1895,
     777,   769,   197,  1118,    14,   270,   772,   753,  1895,  1428,
    1906,  1908,  1429,  1430,  1888,   724,  1988,   576,   180,    95,
     180,  1461,  1487,    61,  1900,  1932,  1948,   237,   636,   777,
      17,    61,   238,   753,  1270,  1271,  1730,  1905,    93,  1730,
    1955,  1730,  1905,  1935,   778,  1905,    17,    61,  1273,  1274,
    1905,  1730,   777,  1936,  1934,   661,   769,    49,   192,   205,
     263,   272,   425,   451,   650,   726,   734,   140,   297,  1793,
      24,   679,   363,   679,   679,   424,  1793,     6,  1183,  1905,
    1657,  1658,  1659,    95,   125,  1788,  1790,   363,   679,    93,
     679,   695,   667,     6,   343,   387,   389,   481,   530,   579,
     669,   691,  1776,  1777,  1778,   808,   467,   679,   809,  1659,
    1793,  1790,   500,   418,   366,   601,   695,   710,    93,  1493,
     679,   731,  1368,  1737,   772,   151,  1875,  1876,  1880,  1900,
     123,  1718,  1719,  1720,  1888,  1027,  1032,   772,  1433,  1434,
    1435,  1436,  1888,  1702,  1900,   351,   560,   218,   560,  2025,
     772,  1501,   793,    17,   252,   405,   419,   421,   452,   467,
     500,   518,   599,   606,   616,   629,   660,   663,   679,  1805,
    1810,  1811,  1893,  1961,    35,   778,   951,   952,   953,   954,
    1892,   574,   211,   361,  1507,  1900,   788,   734,  1393,  1961,
    1825,   348,  1824,   772,   645,  1900,  2025,    93,  1384,  1385,
    1384,   572,   745,   382,   772,  1384,  1384,  1703,  1900,  1894,
     772,   571,  2066,   690,  2067,   753,   128,   631,  2065,    80,
     782,  1900,   873,   873,  1171,  1171,   816,   818,  1171,  1171,
      24,  1171,  1171,   823,   825,   734,   451,   451,  2037,  1583,
    1587,  1599,  1600,  1601,  1602,  1603,  1900,    94,  1484,    42,
     117,   128,   135,   167,   228,   259,  1594,  1595,   772,   196,
    1596,  1597,   265,  1896,  1896,   778,  1688,  1689,  1690,  1900,
    1905,  1629,   100,  1632,  1628,   281,   149,   177,   229,   274,
     365,  1660,  1661,  1867,  1892,   125,    26,  1657,  1488,  1900,
    1488,  1489,  1489,  1472,  1797,  1802,  1865,  1900,  1900,  1665,
    1668,     6,    17,    61,   180,  1501,  1957,   238,    61,  1168,
    1169,  1180,  1181,  1278,   396,   877,  1900,  1500,   778,   877,
       5,  1070,  1888,   575,   395,  1087,  1087,  1087,     4,  1906,
    1907,  1908,  2000,  2004,  1888,  1373,   402,   479,   875,  1888,
     734,  1403,  1404,  1703,   777,   889,   892,   893,  1501,  1501,
     910,   911,   416,  1006,   798,  1702,    93,   352,   437,   439,
     529,   607,   772,  1419,  1420,  1421,  1070,  1087,   926,   340,
     916,   917,   776,   776,   769,  1252,  1254,  1252,  1253,   379,
    1252,  1261,  1262,   769,  1249,  1250,  1252,   203,  1249,  1261,
      17,    34,   329,   347,   721,  1235,  1262,  1269,  1279,  1280,
    1282,    32,   291,  1235,  1242,  1244,  1261,  1235,  1249,   769,
    1261,  1235,  1252,  1254,  1235,  1253,   769,  1249,  1261,    32,
     292,   292,   294,  1249,  1252,   769,   922,  1253,  1253,  1253,
    1252,  1253,   197,   777,    61,   238,   962,  1249,   294,  1254,
    1254,  1252,  1252,  1253,   769,  1250,  1257,    93,  1900,    93,
    1888,    14,  1758,  1705,  1706,  1889,  1900,    93,  1482,  1483,
    1628,   772,  1763,   777,  1768,    84,  1900,   875,   777,  1101,
    1983,  1985,   563,   736,  1102,  1103,   419,  1908,  1999,  1702,
    1701,  1698,   151,   125,  1041,   695,   770,   769,  2008,  2008,
    2008,  2008,  1908,  2000,   192,   205,   263,   451,  1986,   425,
     430,   441,   600,   621,   626,   657,   689,  1990,   112,   266,
    1718,   469,   726,  1501,  1835,  1835,  1439,   497,  1846,    11,
     753,  1624,  1625,  1626,   564,   736,   772,  1960,   977,   978,
     296,  1900,   553,    95,   123,   240,   977,   296,   769,   991,
     151,   776,   777,   969,  1501,   772,  1020,  1019,  1051,  1049,
    1054,  1050,  1702,   769,     6,  1569,  1627,  1569,  1569,  1501,
    1582,    76,   296,   416,  1501,  1578,  1501,    68,  1569,  1627,
     770,    57,    89,   105,   149,   177,   274,   770,  1673,  1677,
    1678,   770,  1501,  1501,  1885,   770,  1464,  1465,  1474,  1872,
      53,    54,    55,    56,   107,   108,   109,   161,   162,   232,
     304,   400,   468,   533,   535,   540,   605,   648,   738,   749,
    1621,  1622,  1501,    68,  1561,  1501,  1501,  1501,  1501,  1501,
    1621,  1501,  1892,  1580,   324,   772,   777,    68,  1569,  1501,
      68,  1569,  1501,  1501,  1501,   770,  1501,  1501,  1504,   770,
    1501,  1501,   770,   640,  1569,  1569,    68,  1569,  1569,  1569,
    1501,  1501,  1531,  1532,  1533,    25,   133,   271,  1501,  1521,
    1522,  1523,  1501,  1501,    68,  1569,  1501,  1578,  1501,   777,
    1501,  1501,  1501,  1517,  1518,  1501,  1501,  1501,  1501,  1501,
    1501,  1501,  1578,   397,   399,   704,   707,  1623,  1501,  1501,
    1578,  1888,  1578,  1501,  1501,  1501,  1578,  1578,  1578,    93,
    1888,  1501,  1501,  1501,  1578,    93,  1501,  1501,  1501,   770,
    1501,  1888,  1501,  1501,  1622,  1622,  1501,  1521,  1501,   770,
     365,   777,  1886,  1900,  1501,  1501,  1501,  1501,  1501,  1501,
     770,   772,  1465,  1501,   777,   778,  1560,  1905,  1501,  1501,
    1501,  1503,    86,   176,   273,   723,  1507,     6,   328,  1503,
    1510,  1503,   769,  1475,  1503,  1503,   140,    15,   125,   140,
     217,  1504,  1504,  1504,  1504,  1504,  1504,  1504,   122,  1504,
     122,  1504,  1504,  1504,  1504,  1504,  1275,  1905,  1527,   769,
    1557,  1638,  1900,   769,   100,   316,   317,   318,  1892,  1538,
     449,   483,   559,   640,  1519,   142,   208,   496,   694,  1119,
    1123,  1829,  1894,   947,   399,   704,   707,   946,  1558,  1869,
    1885,   772,   270,   772,  1960,  1046,   772,    93,  1908,  1907,
    2001,   192,   205,   451,  1986,   760,  1491,  1492,  1494,   777,
     777,  1730,   772,  1927,  1985,  1900,    34,  1276,  1501,  1908,
     265,   570,   584,  1956,  1957,   211,   482,  1950,  1951,  1952,
    1953,   458,   497,   653,  1947,  1730,  1957,  1900,   708,  1937,
    1948,   772,  1939,   679,   760,  1171,    24,   875,   875,  1888,
     875,   875,   875,  1888,  1908,  1888,  1493,  1493,   363,   679,
    1793,   875,  1793,  1788,   125,  1791,   500,   544,   679,  1785,
    1785,  1793,  1900,   875,  1793,  1907,  1788,  1793,  1894,   480,
     692,   440,    93,  1779,   772,   424,   679,  1888,  1790,  1788,
    1788,  1501,  1793,  1793,  1793,  1584,  1747,  1888,  1494,  1739,
    1741,   769,  1734,  1044,   772,   769,  1878,  1719,  1715,  1704,
    1888,   908,   416,   778,   125,   772,   196,  1444,  1446,  1447,
     437,   607,  1392,   238,   351,   218,  1501,   791,    61,   114,
     794,  1501,  1742,  1743,   500,   500,   500,   500,   348,   500,
     808,   500,   772,  1493,  1806,   946,   956,  1905,   772,   753,
    1625,  1970,    84,   667,  1501,  1394,  1702,   270,  1827,   808,
    1823,  1900,     6,  1379,   620,   674,  1386,  1387,  1378,   664,
    1383,  1960,  1865,   587,  2068,  1905,   820,  1983,  2000,  1905,
     814,  1171,  1171,   811,  1888,  1171,   875,   824,  1494,  2046,
     861,  1494,  1171,  1171,  1171,   734,   772,   770,   770,   770,
     770,   770,   772,   770,  1583,     6,    11,    15,    95,  1485,
    1626,   128,   128,   188,  1606,   135,   228,  1594,  1606,  1583,
    1585,   769,  1484,  1693,  1905,   772,   777,  1501,    26,   104,
    1630,  1632,   564,   736,  1490,   428,  1892,   229,   569,   772,
     777,   656,  1654,  1682,  1930,  1169,    34,  1269,   407,   164,
     210,   251,   374,   386,   488,   560,   879,   886,  1905,   613,
     719,  1088,  1089,   476,  1084,  1085,  1086,  1093,  1101,  1103,
    1338,   769,  1894,   333,   525,  1078,  1079,  1080,  1093,  1094,
    1095,  1101,  1103,  1071,  1072,  1078,   470,   221,   772,  2011,
    1960,  1335,  1334,  1888,   772,   586,  1405,  1900,   891,   770,
     772,  1014,   909,    29,   296,  1007,  1009,    71,   113,   153,
     471,   501,   502,   504,   505,   506,   507,   508,   510,   511,
     512,   513,   514,   515,   516,   517,   519,   520,   521,   618,
     619,   799,   800,   807,    93,  1422,   725,  1703,  1420,   374,
     557,   614,   720,  1081,  1082,  1083,  1093,  1097,  1098,  1099,
    1100,  1101,  1103,   283,  1066,   769,   929,  1032,    57,   149,
     177,   274,  1261,  1260,  1730,  1261,   177,   280,   305,   658,
    1251,  1251,  1279,    61,  1275,  1277,  1281,  1282,  1270,    17,
    1280,  1283,   379,  1263,  1261,  1235,  1251,  1326,  1865,  1261,
    1326,  1251,   294,  1251,  1261,   919,   920,   921,  1901,   962,
    1235,  1235,  1251,   230,   714,  1900,  1501,  1501,   215,  1248,
    1281,  1283,  1235,  1261,  1251,   177,  1251,   928,   105,   759,
     936,   937,  1670,  1672,  1596,   694,   772,  1764,   777,  1768,
     201,  1652,  1653,  1767,    95,   760,  1900,   180,  1900,  1102,
     772,  1730,  1731,   772,    28,   223,  1374,  1702,  1702,   909,
     635,  1038,  1900,  2009,  2010,   270,   299,  1982,    24,   760,
    1888,  1900,  1998,  1998,  1998,  1998,   999,  1712,  1501,  1908,
    1440,  1441,  1442,  1443,  1888,   116,   451,  1893,  1897,  1909,
    1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,   152,   211,
     745,  1964,  1672,  1963,  1501,   977,   123,   641,  1900,   977,
     985,   986,   990,  1900,   891,  1900,   912,  1032,  1039,  1042,
    1045,  1043,  1960,  1501,   770,  1570,   770,   770,   266,   416,
    1501,  1501,    11,   284,   770,   284,   772,  1546,   770,   760,
     770,   772,   772,   770,   770,  1465,    95,   770,  1548,   770,
     772,   770,   772,   772,   772,   772,   759,   772,   770,   769,
    1885,  1892,  1569,   770,   770,  1569,   770,   772,   770,   772,
     770,   770,   125,   772,   772,   770,   770,  1569,   770,   770,
     770,   772,    95,   772,   770,    95,  1501,    95,  1501,    95,
    1501,    95,   770,   772,   770,  1569,   770,   770,   770,   770,
    1892,   772,   770,   772,   770,   772,   772,   772,   772,   772,
     770,   770,   772,   770,   772,   770,   770,   772,   770,   770,
     770,   770,   770,   770,   770,   770,  1888,   770,   770,   770,
     772,   770,  1888,   770,   770,   772,   770,   772,   772,   770,
     772,   772,   772,   770,   770,   772,  1892,  1900,   770,   777,
     770,   772,    11,   494,   772,  1294,   772,   770,  1621,  1621,
    1578,   770,   775,  1892,  1947,   238,    86,   176,   273,   723,
     769,    10,  1501,   423,  1503,  1503,   769,  1475,  1503,  1503,
    1501,  1501,  1639,   196,  1641,   769,   769,   769,   769,   769,
     777,  1494,  1542,  1543,  1544,   366,   769,  1128,  1129,  1121,
    1128,  1122,   582,  1131,   130,   462,  1501,   753,  1908,  1908,
    1430,   270,  1501,    99,  1985,    95,   772,    24,  1998,  1998,
    1998,  1998,   772,  1501,  1883,  1892,  1900,  1900,  1957,  1948,
      93,    93,  1730,  1277,  1730,   769,   769,   572,   745,   494,
     772,   772,   777,   777,   777,    61,   451,   740,  1893,  1894,
    1899,  1912,  1916,  1917,  1918,  1919,  1920,  1922,  1923,  1501,
    1730,  1950,  1938,  1940,  1941,   770,  1900,   875,  1894,  1501,
     875,  1793,  1793,  1894,    95,  1792,   873,  1793,   606,  1659,
    1778,  1791,  1788,  1888,  1793,  1793,   237,  1596,  1743,   770,
     772,  1735,   909,  1876,  1879,  1900,  1877,   136,   137,   237,
    1109,  1464,  1721,  1723,  1726,  1596,   963,  1033,  1905,    61,
    1437,  1900,  1435,  1888,  1114,  1446,   115,   130,  1303,  1448,
    1931,   792,   772,    62,  1816,   808,  1811,  1702,  1812,   954,
     957,   958,   953,   565,   566,   642,   955,   442,   553,  1900,
    1971,  1972,  1894,  1702,   437,   607,   727,  1397,  1398,  1399,
    1672,     6,  1826,   661,   772,   724,  1388,  1773,   772,    93,
    2069,  1167,  1168,   299,  1981,  2011,   858,  1900,  1900,  1900,
    1888,   813,   875,   883,   884,   875,  2056,  1171,  1171,  1888,
     875,  1900,   875,  1171,  1583,  1583,   775,   568,   704,   708,
    1480,  1481,  1529,  1481,   128,  1606,  1606,  1598,   128,   180,
     284,  1620,  1900,  1625,  1269,  1272,  1689,  1900,  1501,  1633,
    1884,  1631,   740,  1635,  1630,  1672,  1661,  1662,   428,  1661,
    1661,  1892,   538,  1655,  1884,   769,  1957,  1731,  1731,   548,
     251,   251,   649,  1894,   251,   251,   251,  1894,  1894,  1731,
     772,  1086,   156,   348,   394,   474,   536,   555,   556,   560,
     561,   562,   628,   677,   854,   855,    49,   466,   577,   584,
     592,   665,   726,   859,   860,  1731,  1731,   772,  1080,  1073,
    1074,  1093,  1094,  1095,    26,   299,   733,  2002,   252,   356,
     484,   558,   686,   746,  1996,  1997,  2004,   299,  2014,  1329,
     180,   869,  1342,   769,  2039,  1333,  1404,    93,   890,  1501,
     266,  1010,  1009,   753,   753,   753,   753,   753,   753,   753,
     753,   753,   753,   753,   753,   753,   753,   753,   753,   753,
     753,   753,   753,   753,   753,   753,   753,   772,   725,  1731,
    1731,  1731,  1731,   772,  1083,   499,   438,  1075,  1076,  1077,
    1093,  1094,  1095,  1096,  1099,  1100,  1101,  1103,   896,   897,
     898,  1900,   126,   416,   770,   770,   770,   770,  1900,   772,
     305,   280,  1260,   770,   772,   770,  1230,   770,   772,   962,
     962,   777,   753,  1283,   187,   246,   248,   934,   935,   936,
     939,  1507,  1900,    57,    89,   149,   177,   274,  1481,  1706,
    1900,   284,  1900,   568,   141,  1663,  1584,   777,  1768,  1888,
    1985,  1182,  1905,  1908,  1960,   416,   769,   985,   988,   770,
     772,  2000,   321,  1998,   777,   777,   270,   270,   270,   270,
     910,  1721,   772,  1444,  1446,  1896,   745,   497,   380,   123,
     987,   770,   772,   777,   970,  1021,   416,  1052,  1016,  1047,
    1902,  1047,  1047,   772,  1501,  1501,   266,    17,    32,    58,
      70,    90,   122,   124,   280,   292,   397,   399,   550,   658,
     707,   730,  1571,  1575,  1576,  1270,  1270,  1571,  1578,   770,
     122,   122,  1501,  1578,  1501,  1501,  1501,  1501,  1501,  1501,
    1501,  1504,   777,   770,   770,  1501,  1501,  1501,  1501,  1501,
     770,  1501,  1501,  1501,  1501,    95,  1501,    95,  1501,    95,
    1501,   122,  1501,   770,  1518,  1501,  1517,  1578,  1501,  1501,
    1501,  1501,  1501,  1501,  1501,  1578,   149,   758,  1670,  1674,
     122,  1501,  1501,  1501,  1501,  1501,   777,   777,  1900,  1501,
      17,    32,  1289,  1290,  1291,  1292,  1293,  1673,  1672,   770,
    1501,   759,   759,  1899,  1501,  1474,  1503,   770,   772,  1503,
      10,  1501,   423,  1621,  1621,  1640,  1900,    26,   770,  1554,
    1577,  1578,  1501,  1533,  1577,  1501,  1523,  1577,  1577,  1892,
    1501,   770,   772,   769,  1137,  1504,  1129,   141,  1163,  1164,
    1673,   688,  1132,   326,  1124,  1120,   946,   270,  1888,   416,
     576,  1999,  1907,  1998,    95,    95,    95,    95,  1492,  1495,
    1495,   777,  1730,  1730,   783,  1908,  1957,   265,   265,   211,
     625,   651,  1954,  1952,  1951,   777,   777,  1730,  1957,  1939,
     772,  1943,  1945,  1949,   422,   737,  1670,  1675,  1783,   177,
    1792,  1628,  1788,  1751,  1752,  1886,  1482,  1495,  1494,  1738,
    1740,  1743,   416,   770,   772,    11,  1724,  1725,  1881,  1882,
    1886,  1900,  1872,  1722,  1726,   776,   310,  1034,  1445,   769,
    1957,  1743,   753,    93,   299,  1807,  1808,   753,   772,    97,
     132,   442,   489,   553,   597,   753,   754,   755,  1973,  1975,
    1628,    95,  1400,  1398,  1387,   503,   807,  1389,    73,   634,
    1774,  1672,   534,   321,  2014,    92,   284,   714,  1316,   180,
     180,   812,   853,   854,   883,    11,   126,  2060,   374,   880,
     881,   882,   886,  2057,  2047,   875,   821,   226,   769,   633,
     226,   769,  1888,  1481,   265,  1504,    10,   270,  1583,  1598,
     128,   128,  1583,  1598,  1588,  1589,   770,   772,  1615,  1616,
    1271,  1694,   300,   301,   772,  1634,    12,    65,  1656,  1501,
    1557,  1636,  1637,  1635,  1662,  1490,   772,  1656,  1494,  1683,
    1684,  1685,  1277,  1271,   396,   396,   402,   479,   105,   149,
     177,   274,  1104,  1676,  1677,  1893,  1086,  1731,  1731,    26,
    1731,  1733,  1731,   156,   536,   299,  1731,  1732,  1732,   855,
    1894,  1894,  1894,  1894,  1672,  1894,  1894,   770,   772,  1104,
    1104,  1080,   772,  1074,   265,   584,  1905,  2005,  2006,   265,
     265,   265,    10,  1995,   522,   523,   526,   527,   528,  2012,
    2013,   319,   584,  1341,     5,     7,     8,    31,    33,    39,
      73,   115,   146,   181,   185,   193,   196,   219,   254,   255,
     256,   277,   302,   326,   334,   336,   355,   362,   374,   381,
     396,   404,   408,   409,   415,   419,   427,   447,   473,   477,
     487,   524,   537,   539,   578,   584,   611,   622,   623,   624,
     643,   650,   681,   696,   697,   709,   712,  1112,  1174,  1176,
    1179,  1180,  1181,  1346,  1350,  1352,  1355,  1361,  1362,  1363,
    1365,  1366,  1649,  1893,   378,   646,   219,  1343,  1900,  2040,
      11,  2039,     6,   366,  1406,   891,   910,  1501,   769,   769,
    1672,   769,  1672,  1672,  1894,  1894,  1675,  1894,  1672,  1894,
    1894,  1894,  1894,  1894,  1894,  1894,  1672,  1894,   392,   560,
     662,  1870,  1894,  1672,   800,  1894,  1673,  1104,  1104,  1083,
     100,  1731,   772,  1077,   770,   772,    17,   291,   609,   641,
     730,   960,  1233,  1234,  1237,  1238,  1239,  1240,  1242,  1243,
    1244,  1245,  1268,   930,   931,   177,  1281,  1865,  1281,   920,
    1900,   177,   772,   963,   449,   777,  1584,  1768,  1493,   229,
    1661,   224,  1765,  1628,  1960,  1374,   151,   931,   989,    72,
    2010,   299,  2016,   576,   270,   760,   760,  2000,  2000,  2000,
    2000,  1000,   180,  1744,  1442,  1888,  1446,   114,  1449,  1842,
    1501,   986,  1900,   891,   340,  1016,   151,  1501,  1501,  1253,
    1253,  1249,  1257,    56,   124,  1252,  1253,  1253,   124,  1253,
    1252,   770,   770,   770,   770,  1547,  1501,  1501,   770,   185,
    1563,   770,   770,   772,   772,   770,   772,   770,   125,  1539,
    1540,  1892,   770,   770,   770,   770,   770,   772,    93,   772,
    1501,  1501,  1501,  1501,   770,   770,    11,  1511,   770,    11,
     770,   770,   772,   770,   772,   770,   770,   770,   770,   149,
     177,   177,   770,   772,  1501,   770,   770,   772,   772,   770,
    1892,  1900,   777,   770,   769,  1284,  1284,    12,    65,   635,
     758,  1286,  1287,  1288,   772,   772,   770,  1501,  1501,   777,
     770,  1578,  1503,   770,   772,  1503,  1641,  1633,   185,  1556,
     770,   770,   770,   770,   770,   770,   769,  1495,  1544,  1125,
    1126,  1127,  1900,   770,  1675,   122,    26,   769,  1139,   753,
     769,  1129,  1908,   220,    95,    95,  2001,  2001,  2001,  2001,
      11,  1497,  1894,  1900,   760,  1892,  1957,  1957,   770,   770,
     375,   717,   211,  1900,  1900,  1957,  1942,  1944,    57,    89,
     149,   177,   274,  1659,  1784,  1793,   772,  1750,  1730,  1625,
    1743,   770,   772,   151,  1900,   769,   770,   772,   777,  1465,
    1728,  1729,  1886,   296,  1035,  1036,   769,   204,  1617,  1618,
    1619,  1900,   769,  1809,   211,   350,   357,   373,   383,   384,
     385,   393,   532,   546,   632,   647,   684,   698,   959,   958,
    1974,  1659,   545,   753,   772,   681,   681,  1907,  1341,   396,
     346,   462,   644,  1322,  1322,   180,  1888,  1888,   136,   138,
     140,  1105,  1107,  1173,  1175,  1176,  1188,  1173,  2060,  1494,
    1894,   880,   769,   903,   905,   907,   875,   862,  2039,   828,
     829,    58,   124,   213,   683,  1186,   826,   827,   822,  1481,
    1481,   180,  1591,  1598,  1598,   180,  1593,  1501,   769,  1114,
    1900,  1613,  1614,   366,  1849,  1884,    11,   772,  1884,  1501,
     770,   772,  1674,  1674,  1674,  1674,  1674,  1674,   860,  1074,
     265,    11,   284,  2003,  2007,   186,  1996,  1672,  1672,  1672,
    1870,   758,  1670,  1671,  2012,   146,   279,  1339,   435,    36,
     196,   372,   585,   693,  1192,  1200,  1201,  1206,  1207,  1303,
    1307,  1308,  1367,  1367,   196,  1367,   196,   270,    36,    92,
     196,   585,   693,  1205,  1303,  1367,   407,  1731,   196,    26,
    1731,  1114,    11,   270,   753,  1376,  1731,  1731,  1731,  1731,
     732,  1731,  1731,  1731,  1731,   196,  1731,  1731,   407,  1731,
     129,   696,   129,  1731,   196,   696,  1731,  1731,  1731,  1731,
    1367,  1731,  1731,   196,   583,   196,   196,  1731,  1731,   410,
     530,  1900,  1731,  1731,   196,  1174,   772,  1111,  1112,  1350,
     769,   777,  1191,  1208,  1887,  1900,  1730,  1507,  2022,   330,
     426,   863,   270,   408,   415,   865,   770,   772,  2041,  2042,
      11,     6,   769,  1407,  1011,   803,   804,  1672,   805,   806,
    1672,   801,   802,  1672,  1900,  1104,  1077,   898,  1252,  1256,
    1252,  1255,  1255,   922,  1255,   197,   777,  1256,  1256,  1255,
    1255,   932,   770,   935,  1900,  1628,  1900,   428,   229,  1491,
     770,  1501,   988,    99,  2000,  2011,  2011,  2011,  2011,    76,
      78,  1001,   413,  1449,   492,   114,   316,  1848,   971,  1032,
     909,  1572,  1252,  1573,  1574,   770,  1621,  1621,    26,   235,
    1562,  1501,  1501,  1578,   167,   345,   770,   299,  1541,  1501,
    1501,  1501,  1621,    58,    70,    90,   124,   213,   280,   397,
     399,   549,   550,   707,  1242,  1243,  1512,  1513,  1514,  1515,
    1571,  1501,  1501,    86,   273,  1672,  1680,  1621,  1501,  1501,
    1900,  1673,   770,  1294,  1289,  1287,  1289,  1290,  1672,  1900,
     770,  1578,   185,  1642,    26,   770,  1577,  1497,   770,   772,
    1501,  1123,   196,  1140,  1141,  1673,  1125,  2001,  2001,  1894,
    1900,   777,  1730,  1730,  1943,  1948,  1659,  1752,  1628,    61,
    1742,  1615,  1495,  1743,  1464,  1881,   760,  1900,   770,   772,
    1730,  1037,  1036,     6,  1351,  1359,  1360,  1900,   770,   772,
    1675,  1817,  1818,   436,   146,   769,  1894,   807,   744,  1888,
     817,   819,    36,   585,  1189,  1190,  1191,  1192,  1200,  1201,
     140,  1888,  1110,  1111,   772,  1175,  1106,  1494,   831,   904,
     878,    14,   323,  1061,   180,    11,  2052,  2053,   894,   895,
     667,  2052,   894,  2039,  1590,   284,  1592,   284,  1620,   114,
     283,   447,  1608,  1609,  1612,    79,    82,   182,   264,  1850,
    1851,   143,  1852,  1656,  1638,  1637,  1656,  1495,  1685,   584,
    1894,  2005,   177,   177,   584,    61,   122,   551,  1340,   112,
    1325,  1887,  1171,    94,   112,  1170,   732,    33,    92,   204,
     278,  1204,  1302,  1171,  1303,  1304,  1304,  1170,  1707,  1425,
    1707,  1351,  1269,  1707,   130,  1708,    94,  1707,   732,   204,
    1707,  1707,  1731,    61,  1900,  1425,  1650,  1651,  1886,    61,
    1672,  1679,  1113,  1888,    61,  1672,    61,  1672,    61,  1672,
    1177,    61,  1900,  1675,  1672,  1672,  1425,  1894,  1894,  1731,
    1672,  1905,  1360,   442,   489,   560,  1185,  1672,  1675,  1675,
    1707,    61,  1672,  1894,  1425,  1425,  1425,    61,   377,   379,
     414,   443,   579,   615,  1184,  1679,  1672,  1679,  1351,     5,
      73,  1363,  1187,  1189,  1900,   323,   442,  1375,   216,  1296,
    1209,   777,    61,  1676,  1894,  1900,   596,  1501,  1501,   180,
     869,   875,   180,   374,   870,  1900,  1464,  2041,  1408,   475,
     266,   770,   772,   770,   772,   770,   772,  1281,   230,  1900,
    1281,  1283,  1281,  1283,  1450,  1872,    95,   428,   576,  2011,
     299,  2015,  2015,  2015,  2015,   910,   997,  1745,   123,   891,
     416,   416,  1281,  1281,  1281,   770,   770,  1564,  1884,  1865,
     141,  1565,  1566,  1567,   770,   772,   770,   488,   538,   606,
     770,   770,  1249,   124,  1253,    32,  1253,  1516,   770,   770,
     770,   770,   772,   770,   770,   770,  1285,   770,   772,   770,
      26,   208,   229,  1643,  1644,  1884,   770,  1127,  1621,   130,
     462,  1142,   770,   772,   770,   760,  1957,  1957,  1652,   770,
     777,  1729,  1743,   934,   770,   772,  1618,   770,   772,    10,
    1819,  1740,  1905,   815,   769,   769,    93,  1202,   770,   772,
    1888,  1108,  1848,  1175,  1173,   832,   205,   451,   850,   851,
     852,   897,   899,   900,   901,   879,   885,  2022,  2058,    63,
     120,   281,  1062,   646,  2041,   878,  2054,  1268,   770,   896,
    1894,  2054,   770,    11,  1501,   769,  1501,   769,   770,  1303,
    1303,  1609,    26,    26,    79,    26,  1851,   253,   264,  1853,
    1854,   769,   435,   177,   319,  1507,  1425,   769,  1507,  1202,
     769,   130,   130,  1304,  1171,  1325,  1900,  1171,  1171,  1887,
    1351,  1887,  1348,  1271,  1887,  1707,  1359,    93,   130,  1887,
    1887,  1894,  1351,   772,  1656,  1117,   769,  1673,  1894,   299,
    1208,  1351,  1356,  1351,   770,  1900,  1888,   652,   960,  1210,
    1231,  1232,  1900,  1621,   660,  1894,   411,  1344,   299,  2043,
    1411,  1900,     6,   769,  1409,   910,   804,   806,   802,   197,
     777,  1504,  2015,    99,  2012,  2017,  2018,   130,   263,  1016,
     151,   772,  1656,   770,  1568,  1661,  1501,   538,   434,  1281,
    1675,   770,  1672,  1655,   770,    15,   391,   399,   704,   707,
     716,  1645,  1646,  1869,  1656,   676,  1165,  1124,   769,  1130,
    1143,  1900,  1141,  1663,   760,   266,  1360,  1818,   408,   770,
     575,   769,  1323,  1324,  1900,  1323,  1900,  1190,   770,    11,
    1166,  1110,   205,   451,   836,   837,   838,   844,   849,   852,
     924,   842,   984,   840,   984,   416,   852,   118,   125,   190,
     902,   770,   772,    67,  2060,   180,   863,  2055,   875,   876,
     226,   876,   226,  2041,  1620,  1620,    93,  1607,  1607,  1865,
    1865,    26,  1865,    26,    26,  1854,   265,  1340,   400,  1339,
      84,  1353,  1900,    84,  1501,  1171,  1325,  1900,   284,  1315,
     714,  1325,  1325,    73,   237,  1208,  1419,  1276,  1887,  1900,
    1374,  1347,  1651,  1812,   263,  1375,  1357,  1359,  1349,   769,
    1297,  1212,   777,  1203,  1204,  1211,   777,   864,   871,   872,
      33,   349,   497,   770,   772,  1410,   230,   714,  1900,   270,
     576,  2018,   281,  1888,  1053,  1884,   569,   772,   770,   770,
     770,   716,  1646,  1647,  1869,   641,   594,   429,  1648,   594,
    1672,   769,  1137,  1133,    61,   289,   290,   391,   465,  1144,
     910,   354,   769,  1323,   770,   772,  1656,   769,   770,   769,
    1109,  1108,   842,   840,   833,   838,   849,   844,   776,   776,
     839,   776,   839,  1496,   190,   641,   960,  1268,   901,  1028,
    1029,  1494,   868,   869,  2060,  2052,  2052,   770,   770,   100,
     128,   185,  1611,  1610,  1865,  1865,  1865,   770,  1887,   582,
     769,  1354,   772,   770,  1325,  1315,   714,  1322,  1193,  1322,
    1195,  1196,    61,    61,  1375,  1425,   770,  1888,  1358,  1397,
    1298,  1900,   154,  1299,   204,   278,   302,   374,   485,   742,
    1213,  1214,  1223,  1265,  1266,  1267,  1295,  1507,  1893,  1232,
      34,    61,   176,   180,   334,   453,   652,  1217,  1219,  1258,
    1259,  1266,  1900,   676,   866,   963,   576,    33,    33,  1900,
     204,  1412,  1413,  1900,   197,  1504,  1746,  1596,  1047,  1656,
    1661,  1661,   446,    10,   446,   100,   391,   560,   703,  1135,
    1136,  1900,   770,   687,  1138,  1146,   702,   115,   374,   381,
     396,   524,   537,   557,   696,  1160,  1161,  1162,  1787,   859,
     770,  1960,  1324,   177,  1960,  1900,  1178,  1179,   847,  2060,
     845,  2060,   340,   416,   835,  1900,  1900,   876,   922,   197,
     777,   876,   912,  2048,   865,  1028,  2054,  2054,    26,    26,
     769,   769,  1204,  1673,  1140,  1900,  1199,  1197,  1322,   769,
    1194,   769,   769,   758,   759,   769,  1227,  1228,  1229,  1475,
    1524,  1868,  1893,  1114,   123,   770,   772,   450,   581,   659,
     180,  1300,   130,  1894,   693,  1266,   732,   130,   176,  1730,
    1275,  1229,   281,   327,    61,    11,   379,  1259,  1264,  1501,
     417,   867,    91,   856,   576,   576,   770,   772,   714,  1753,
    1754,  1886,  1843,  1647,   641,   187,   312,   770,   772,  1673,
     769,  1148,  1150,  1145,   407,  1731,  1731,   407,  1731,  1731,
    1731,  1731,   769,  1155,  1162,   419,   770,  1960,   299,   374,
     487,  1310,  1314,  1318,  1321,  1893,  1656,   770,  1311,  1313,
    1318,  1320,   772,   776,   984,   776,   984,  1032,   834,   843,
     841,   230,  1900,  1030,  1888,   870,   856,   876,   876,  1617,
    1619,   770,   770,   769,   769,  1198,  1323,   769,  1323,  1323,
    1870,  1870,  1226,   769,  1900,    63,   281,    61,  1676,  1894,
    1900,   173,   728,   641,  1227,  1260,  1258,  1501,  1413,   772,
    1730,  1272,  1134,  1136,   769,  1149,  1150,  1151,   156,  1147,
    1150,  1731,  1894,  1894,  1731,  1676,  1676,  1673,  1905,   688,
    1156,  1157,  1731,   284,   714,  1309,  1312,  1317,  1318,  1319,
     580,  1894,  1731,  1364,  1365,  1366,  1321,  1730,  1364,  1320,
    1900,   848,   846,   416,  1496,   907,   769,   905,   906,   197,
     777,   340,    93,   411,   770,   770,  1323,  1323,   769,   770,
    1323,   770,   770,   770,  1140,    28,   223,   237,   560,  1301,
    1301,   769,  1498,   416,   677,  1218,  1754,  1743,  1844,  1138,
     770,   772,   156,  1153,  1154,  1504,  1894,  1894,  1158,   770,
     772,  1182,  1322,  1322,  1364,  1319,  1893,  1672,  1366,  1365,
      61,  1676,  1894,  1900,   770,  1028,  1028,   876,   878,   894,
     226,   230,   714,  1900,  1032,  1494,   871,   770,   770,  1323,
    1309,   770,  1310,  1311,   770,    61,   176,   320,   180,   180,
     770,  1673,  1215,  1216,  1265,  1215,   586,   682,   735,  1220,
     229,  1855,  1150,   772,  1152,  1159,  1905,  1157,  1900,  2059,
    2059,   770,  2052,   197,  1031,  2049,  1296,  1309,   770,  1309,
     281,    63,   770,  1265,  1221,  1222,  1223,   470,  1849,  1154,
     770,  1160,   878,   714,   416,    75,  1309,  1301,  1301,  1223,
      26,  1852,   641,  1865,   114,  1856,  2050,   177,   769,  1858,
     445,   593,  2044,  2045,   143,   229,  1857,   770,   778,  1859,
    1860,  1886,   237,  1861,  1905,  2051,  1905,   770,   772,  1862,
    1863,  1886,   963,  1860,   772,  1730,   856,  1863,  1494,  1743,
    1495
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   779,   780,   781,   780,   780,   782,   782,   783,   783,
     783,   784,   784,   784,   784,   784,   784,   784,   784,   784,
     784,   784,   784,   784,   784,   784,   784,   784,   784,   784,
     784,   784,   784,   784,   784,   784,   784,   784,   784,   784,
     784,   784,   784,   784,   784,   784,   784,   784,   784,   784,
     784,   784,   784,   784,   784,   784,   784,   784,   784,   784,
     784,   784,   784,   784,   784,   784,   784,   784,   784,   784,
     784,   785,   786,   786,   788,   787,   789,   790,   791,   789,
     792,   793,   792,   794,   794,   796,   795,   798,   797,   799,
     799,   800,   800,   800,   800,   800,   800,   800,   800,   800,
     800,   800,   800,   800,   800,   800,   800,   800,   800,   800,
     800,   801,   801,   801,   802,   803,   803,   803,   804,   805,
     805,   805,   806,   807,   807,   807,   807,   807,   807,   807,
     808,   808,   809,   811,   812,   810,   813,   810,   814,   815,
     810,   816,   817,   810,   818,   819,   810,   820,   810,   821,
     810,   822,   810,   823,   810,   824,   810,   825,   810,   826,
     810,   827,   810,   828,   810,   829,   810,   810,   810,   810,
     810,   810,   830,   810,   831,   810,   832,   833,   834,   810,
     835,   835,   836,   836,   836,   837,   837,   838,   838,   839,
     841,   840,   843,   842,   844,   844,   844,   846,   845,   848,
     847,   849,   850,   850,   851,   851,   852,   852,   853,   853,
     854,   854,   855,   855,   855,   855,   855,   855,   855,   855,
     855,   855,   855,   855,   855,   855,   856,   856,   858,   857,
     859,   859,   860,   860,   860,   860,   860,   860,   860,   862,
     861,   864,   863,   863,   865,   865,   865,   865,   866,   866,
     867,   867,   868,   868,   869,   870,   870,   872,   871,   873,
     874,   874,   875,   875,   876,   876,   877,   877,   878,   878,
     879,   879,   879,   879,   879,   879,   879,   880,   880,   881,
     881,   882,   882,   884,   883,   885,   885,   886,   886,   888,
     887,   889,   887,   890,   887,   891,   891,   892,   892,   893,
     893,   894,   895,   894,   896,   896,   897,   898,   898,   898,
     898,   898,   898,   899,   899,   900,   900,   901,   901,   901,
     901,   901,   901,   902,   902,   902,   902,   902,   904,   903,
     905,   906,   906,   907,   907,   908,   908,   909,   909,   911,
     910,   912,   912,   914,   913,   913,   915,   915,   916,   916,
     917,   917,   918,   918,   918,   919,   920,   921,   921,   922,
     923,   924,   924,   924,   924,   925,   925,   925,   926,   925,
     928,   927,   929,   929,   930,   932,   931,   933,   933,   933,
     933,   934,   934,   935,   936,   936,   937,   938,   938,   939,
     939,   939,   939,   939,   939,   940,   940,   941,   942,   942,
     943,   943,   944,   944,   945,   945,   946,   946,   946,   947,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   947,
     947,   948,   949,   950,   950,   951,   951,   952,   952,   953,
     954,   954,   955,   955,   955,   956,   957,   957,   958,   959,
     959,   959,   959,   959,   959,   959,   959,   959,   959,   959,
     959,   959,   960,   960,   961,   961,   962,   962,   962,   963,
     963,   963,   963,   963,   963,   964,   964,   964,   964,   964,
     964,   964,   964,   964,   964,   964,   964,   964,   965,   965,
     965,   965,   967,   966,   968,   969,   968,   970,   968,   971,
     968,   973,   972,   974,   974,   976,   975,   975,   978,   977,
     979,   979,   979,   979,   980,   980,   980,   980,   981,   982,
     983,   984,   985,   987,   986,   989,   988,   990,   990,   991,
     991,   992,   993,   993,   993,   994,   994,   995,   996,   996,
     998,   999,  1000,   997,  1001,  1001,  1001,  1003,  1002,  1005,
    1006,  1004,  1004,  1007,  1007,  1008,  1008,  1010,  1011,  1009,
    1013,  1014,  1012,  1015,  1015,  1016,  1016,  1017,  1019,  1018,
    1020,  1021,  1018,  1022,  1022,  1024,  1023,  1025,  1026,  1023,
    1027,  1029,  1030,  1031,  1028,  1033,  1032,  1034,  1034,  1035,
    1035,  1037,  1036,  1038,  1038,  1040,  1039,  1041,  1041,  1041,
    1042,  1044,  1043,  1046,  1045,  1047,  1049,  1048,  1050,  1048,
    1051,  1052,  1053,  1048,  1054,  1048,  1056,  1055,  1057,  1055,
    1058,  1059,  1055,  1060,  1055,  1061,  1061,  1062,  1062,  1062,
    1063,  1064,  1065,  1066,  1066,  1067,  1067,  1068,  1069,  1070,
    1070,  1072,  1071,  1073,  1073,  1073,  1074,  1074,  1074,  1075,
    1076,  1076,  1076,  1077,  1077,  1077,  1077,  1077,  1077,  1077,
    1077,  1078,  1079,  1079,  1079,  1080,  1080,  1080,  1080,  1080,
    1081,  1082,  1082,  1082,  1083,  1083,  1083,  1083,  1083,  1083,
    1083,  1084,  1085,  1085,  1085,  1086,  1086,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1092,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,  1102,  1103,  1103,  1104,
    1104,  1106,  1105,  1105,  1105,  1107,  1107,  1108,  1108,  1109,
    1109,  1110,  1111,  1111,  1113,  1112,  1114,  1116,  1115,  1118,
    1117,  1119,  1120,  1119,  1119,  1119,  1121,  1119,  1119,  1122,
    1119,  1123,  1123,  1124,  1124,  1125,  1125,  1126,  1126,  1127,
    1128,  1129,  1130,  1131,  1131,  1132,  1133,  1132,  1134,  1132,
    1135,  1135,  1136,  1137,  1138,  1138,  1139,  1139,  1140,  1140,
    1142,  1141,  1143,  1144,  1145,  1144,  1146,  1144,  1144,  1144,
    1144,  1147,  1147,  1148,  1148,  1149,  1149,  1151,  1152,  1150,
    1153,  1153,  1154,  1154,  1155,  1155,  1156,  1156,  1158,  1157,
    1159,  1160,  1160,  1161,  1161,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1162,  1162,  1163,  1164,  1163,  1163,  1165,  1165,
    1166,  1166,  1167,  1167,  1168,  1168,  1169,  1169,  1170,  1170,
    1171,  1171,  1172,  1172,  1173,  1173,  1174,  1174,  1175,  1175,
    1175,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1177,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1178,  1178,  1179,  1180,  1181,  1182,  1183,  1184,  1184,  1184,
    1184,  1184,  1184,  1184,  1185,  1185,  1185,  1186,  1186,  1186,
    1186,  1187,  1188,  1189,  1189,  1190,  1190,  1190,  1190,  1190,
    1191,  1191,  1193,  1192,  1194,  1192,  1195,  1192,  1196,  1192,
    1197,  1192,  1198,  1192,  1199,  1192,  1200,  1201,  1202,  1203,
    1203,  1204,  1205,  1205,  1206,  1206,  1207,  1209,  1208,  1211,
    1210,  1212,  1210,  1213,  1213,  1214,  1214,  1215,  1215,  1216,
    1216,  1217,  1217,  1217,  1217,  1218,  1217,  1217,  1217,  1219,
    1219,  1220,  1220,  1220,  1220,  1221,  1221,  1222,  1222,  1223,
    1223,  1223,  1223,  1225,  1224,  1226,  1226,  1227,  1227,  1228,
    1228,  1229,  1229,  1230,  1231,  1231,  1232,  1232,  1232,  1232,
    1232,  1233,  1233,  1233,  1233,  1233,  1234,  1234,  1234,  1234,
    1234,  1234,  1234,  1234,  1234,  1234,  1235,  1235,  1235,  1235,
    1236,  1236,  1236,  1236,  1236,  1236,  1236,  1236,  1237,  1237,
    1237,  1237,  1237,  1237,  1237,  1237,  1238,  1238,  1238,  1238,
    1238,  1239,  1239,  1239,  1239,  1239,  1239,  1239,  1239,  1239,
    1239,  1239,  1239,  1239,  1239,  1239,  1239,  1240,  1240,  1241,
    1241,  1241,  1241,  1241,  1241,  1241,  1241,  1242,  1243,  1243,
    1244,  1244,  1245,  1245,  1245,  1245,  1245,  1246,  1246,  1246,
    1246,  1246,  1247,  1247,  1247,  1248,  1248,  1249,  1249,  1249,
    1250,  1251,  1251,  1251,  1251,  1251,  1251,  1252,  1252,  1252,
    1252,  1253,  1253,  1254,  1254,  1255,  1255,  1256,  1256,  1257,
    1257,  1258,  1258,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1260,  1260,  1261,  1261,  1262,  1263,  1264,  1265,  1265,  1265,
    1266,  1266,  1266,  1266,  1266,  1266,  1267,  1267,  1268,  1269,
    1269,  1270,  1270,  1271,  1271,  1272,  1272,  1273,  1273,  1274,
    1274,  1275,  1276,  1276,  1277,  1277,  1278,  1278,  1279,  1279,
    1279,  1280,  1281,  1281,  1282,  1282,  1282,  1282,  1282,  1282,
    1283,  1283,  1285,  1284,  1286,  1286,  1287,  1288,  1288,  1288,
    1288,  1289,  1290,  1291,  1291,  1292,  1293,  1293,  1294,  1294,
    1295,  1295,  1296,  1297,  1297,  1298,  1298,  1299,  1299,  1299,
    1299,  1300,  1300,  1300,  1300,  1300,  1301,  1301,  1301,  1301,
    1301,  1302,  1302,  1303,  1303,  1304,  1304,  1305,  1305,  1305,
    1306,  1306,  1307,  1308,  1309,  1309,  1310,  1310,  1311,  1311,
    1312,  1312,  1313,  1313,  1314,  1314,  1315,  1315,  1316,  1316,
    1316,  1317,  1317,  1318,  1318,  1318,  1318,  1318,  1318,  1319,
    1319,  1320,  1321,  1321,  1322,  1322,  1322,  1323,  1323,  1324,
    1324,  1325,  1325,  1326,  1326,  1328,  1329,  1327,  1330,  1327,
    1327,  1331,  1327,  1332,  1327,  1333,  1327,  1334,  1327,  1335,
    1327,  1327,  1327,  1327,  1327,  1336,  1327,  1327,  1337,  1338,
    1327,  1339,  1339,  1340,  1340,  1340,  1340,  1341,  1341,  1341,
    1341,  1341,  1342,  1342,  1342,  1342,  1343,  1343,  1344,  1344,
    1345,  1345,  1346,  1346,  1346,  1346,  1346,  1346,  1346,  1346,
    1346,  1346,  1347,  1346,  1346,  1348,  1346,  1349,  1346,  1346,
    1346,  1346,  1346,  1350,  1351,  1351,  1353,  1352,  1354,  1354,
    1354,  1356,  1355,  1357,  1358,  1357,  1359,  1359,  1360,  1361,
    1361,  1362,  1363,  1363,  1363,  1363,  1363,  1363,  1363,  1363,
    1363,  1363,  1363,  1363,  1363,  1363,  1363,  1363,  1363,  1363,
    1363,  1363,  1363,  1363,  1363,  1363,  1363,  1363,  1363,  1363,
    1363,  1364,  1364,  1364,  1364,  1364,  1365,  1365,  1366,  1366,
    1367,  1367,  1368,  1368,  1370,  1369,  1371,  1371,  1372,  1372,
    1373,  1373,  1374,  1374,  1374,  1375,  1375,  1375,  1376,  1376,
    1376,  1376,  1378,  1377,  1379,  1377,  1377,  1377,  1380,  1381,
    1381,  1382,  1382,  1383,  1383,  1383,  1385,  1384,  1386,  1386,
    1387,  1387,  1387,  1388,  1388,  1388,  1389,  1389,  1391,  1390,
    1392,  1392,  1392,  1393,  1394,  1393,  1396,  1395,  1397,  1397,
    1398,  1398,  1399,  1399,  1399,  1400,  1400,  1402,  1401,  1403,
    1403,  1404,  1405,  1405,  1406,  1406,  1407,  1408,  1407,  1409,
    1410,  1409,  1411,  1411,  1411,  1412,  1412,  1412,  1413,  1413,
    1414,  1414,  1415,  1416,  1415,  1418,  1417,  1419,  1419,  1420,
    1420,  1421,  1421,  1421,  1421,  1421,  1421,  1422,  1422,  1424,
    1423,  1425,  1425,  1425,  1427,  1426,  1426,  1428,  1428,  1429,
    1429,  1430,  1432,  1431,  1433,  1433,  1434,  1434,  1435,  1436,
    1437,  1437,  1439,  1438,  1440,  1440,  1441,  1441,  1442,  1443,
    1445,  1444,  1447,  1446,  1448,  1448,  1449,  1449,  1451,  1450,
    1452,  1450,  1454,  1453,  1455,  1453,  1456,  1456,  1458,  1457,
    1460,  1461,  1459,  1462,  1463,  1464,  1464,  1465,  1465,  1467,
    1466,  1468,  1466,  1469,  1469,  1470,  1471,  1470,  1470,  1472,
    1472,  1473,  1474,  1475,  1475,  1476,  1476,  1477,  1478,  1478,
    1479,  1479,  1480,  1480,  1480,  1481,  1481,  1481,  1482,  1483,
    1483,  1484,  1484,  1485,  1485,  1485,  1485,  1486,  1486,  1487,
    1487,  1487,  1488,  1488,  1489,  1489,  1490,  1490,  1490,  1491,
    1491,  1491,  1492,  1492,  1493,  1494,  1495,  1496,  1497,  1497,
    1497,  1497,  1497,  1498,  1498,  1498,  1499,  1499,  1499,  1500,
    1500,  1501,  1501,  1501,  1501,  1501,  1502,  1502,  1502,  1502,
    1502,  1502,  1502,  1502,  1502,  1502,  1502,  1502,  1503,  1503,
    1503,  1503,  1503,  1503,  1503,  1503,  1503,  1503,  1503,  1503,
    1503,  1503,  1503,  1503,  1504,  1504,  1504,  1504,  1504,  1504,
    1504,  1504,  1504,  1504,  1504,  1504,  1504,  1504,  1504,  1504,
    1504,  1504,  1504,  1505,  1505,  1506,  1506,  1507,  1507,  1508,
    1508,  1509,  1509,  1509,  1509,  1509,  1509,  1510,  1510,  1511,
    1511,  1512,  1512,  1512,  1513,  1513,  1513,  1513,  1513,  1513,
    1514,  1514,  1514,  1516,  1515,  1515,  1517,  1518,  1518,  1519,
    1519,  1519,  1519,  1520,  1521,  1521,  1522,  1523,  1523,  1523,
    1523,  1523,  1523,  1523,  1524,  1524,  1524,  1524,  1524,  1524,
    1524,  1524,  1524,  1524,  1524,  1524,  1524,  1524,  1524,  1524,
    1524,  1524,  1524,  1524,  1524,  1524,  1524,  1524,  1524,  1524,
    1524,  1524,  1524,  1525,  1525,  1525,  1525,  1526,  1526,  1527,
    1527,  1527,  1527,  1527,  1527,  1528,  1528,  1529,  1529,  1530,
    1530,  1530,  1530,  1530,  1530,  1530,  1530,  1530,  1530,  1530,
    1530,  1530,  1530,  1530,  1530,  1530,  1530,  1530,  1530,  1530,
    1531,  1531,  1532,  1532,  1533,  1533,  1534,  1534,  1534,  1534,
    1534,  1534,  1534,  1534,  1534,  1534,  1534,  1534,  1534,  1534,
    1534,  1534,  1534,  1534,  1534,  1534,  1534,  1534,  1534,  1534,
    1534,  1534,  1534,  1535,  1535,  1535,  1535,  1535,  1535,  1535,
    1535,  1535,  1535,  1535,  1535,  1535,  1535,  1535,  1535,  1535,
    1535,  1535,  1535,  1535,  1535,  1535,  1535,  1535,  1535,  1535,
    1536,  1536,  1536,  1536,  1536,  1536,  1536,  1536,  1536,  1538,
    1537,  1537,  1537,  1537,  1537,  1537,  1537,  1537,  1539,  1539,
    1540,  1540,  1541,  1541,  1542,  1542,  1543,  1543,  1544,  1545,
    1545,  1545,  1545,  1545,  1545,  1545,  1546,  1547,  1545,  1545,
    1545,  1545,  1545,  1545,  1545,  1545,  1545,  1545,  1545,  1548,
    1545,  1549,  1549,  1550,  1550,  1550,  1551,  1551,  1551,  1551,
    1551,  1551,  1551,  1551,  1551,  1551,  1551,  1551,  1551,  1552,
    1554,  1553,  1553,  1555,  1555,  1556,  1557,  1559,  1558,  1560,
    1560,  1560,  1560,  1561,  1561,  1562,  1562,  1563,  1563,  1564,
    1564,  1565,  1565,  1566,  1567,  1568,  1568,  1568,  1570,  1569,
    1571,  1572,  1571,  1573,  1571,  1574,  1571,  1571,  1571,  1571,
    1575,  1575,  1575,  1575,  1575,  1575,  1575,  1575,  1576,  1576,
    1576,  1576,  1577,  1577,  1578,  1578,  1579,  1579,  1580,  1580,
    1581,  1581,  1582,  1582,  1583,  1583,  1584,  1585,  1585,  1586,
    1586,  1587,  1588,  1587,  1589,  1587,  1587,  1590,  1587,  1591,
    1587,  1587,  1592,  1587,  1593,  1587,  1587,  1594,  1594,  1594,
    1595,  1595,  1596,  1596,  1597,  1598,  1598,  1598,  1598,  1599,
    1599,  1600,  1600,  1601,  1601,  1602,  1602,  1603,  1603,  1604,
    1605,  1606,  1606,  1607,  1607,  1607,  1607,  1608,  1608,  1610,
    1609,  1611,  1609,  1612,  1612,  1613,  1614,  1613,  1616,  1615,
    1617,  1617,  1618,  1618,  1619,  1619,  1620,  1620,  1621,  1621,
    1621,  1621,  1621,  1621,  1621,  1621,  1621,  1621,  1621,  1621,
    1622,  1622,  1622,  1622,  1622,  1622,  1622,  1622,  1622,  1623,
    1623,  1623,  1623,  1624,  1624,  1624,  1625,  1625,  1626,  1627,
    1627,  1628,  1629,  1628,  1630,  1631,  1630,  1632,  1632,  1633,
    1633,  1634,  1634,  1634,  1635,  1635,  1636,  1636,  1637,  1639,
    1638,  1640,  1640,  1641,  1641,  1642,  1642,  1643,  1643,  1644,
    1644,  1645,  1645,  1646,  1646,  1646,  1647,  1647,  1647,  1648,
    1648,  1648,  1648,  1648,  1648,  1649,  1650,  1650,  1651,  1652,
    1652,  1654,  1653,  1655,  1655,  1656,  1656,  1656,  1657,  1657,
    1658,  1658,  1658,  1659,  1660,  1660,  1660,  1661,  1661,  1661,
    1661,  1661,  1661,  1662,  1663,  1663,  1663,  1663,  1664,  1664,
    1664,  1665,  1665,  1666,  1667,  1668,  1668,  1668,  1669,  1669,
    1670,  1670,  1671,  1671,  1672,  1672,  1672,  1672,  1672,  1672,
    1673,  1673,  1673,  1673,  1673,  1674,  1674,  1674,  1674,  1675,
    1675,  1675,  1675,  1675,  1676,  1676,  1676,  1676,  1676,  1677,
    1678,  1678,  1679,  1679,  1680,  1680,  1680,  1682,  1681,  1683,
    1683,  1684,  1684,  1685,  1687,  1686,  1688,  1688,  1689,  1690,
    1690,  1690,  1691,  1693,  1694,  1692,  1692,  1692,  1696,  1695,
    1698,  1697,  1699,  1697,  1697,  1697,  1697,  1697,  1697,  1697,
    1697,  1697,  1700,  1697,  1697,  1697,  1697,  1697,  1697,  1701,
    1697,  1702,  1702,  1703,  1704,  1705,  1705,  1706,  1707,  1707,
    1708,  1708,  1709,  1709,  1711,  1712,  1710,  1714,  1715,  1713,
    1716,  1716,  1716,  1716,  1717,  1717,  1718,  1718,  1720,  1719,
    1721,  1721,  1722,  1721,  1723,  1724,  1724,  1725,  1725,  1726,
    1727,  1727,  1728,  1728,  1729,  1730,  1730,  1731,  1731,  1732,
    1732,  1733,  1733,  1735,  1734,  1737,  1736,  1738,  1738,  1739,
    1739,  1740,  1740,  1741,  1741,  1742,  1742,  1743,  1743,  1744,
    1745,  1746,  1744,  1747,  1747,  1749,  1750,  1748,  1751,  1751,
    1752,  1752,  1753,  1753,  1754,  1755,  1755,  1757,  1756,  1758,
    1758,  1759,  1759,  1760,  1761,  1762,  1763,  1762,  1764,  1762,
    1765,  1765,  1766,  1766,  1767,  1767,  1768,  1768,  1769,  1769,
    1770,  1770,  1770,  1772,  1773,  1771,  1774,  1774,  1774,  1775,
    1775,  1776,  1776,  1777,  1777,  1778,  1778,  1778,  1778,  1778,
    1778,  1778,  1778,  1778,  1779,  1779,  1781,  1780,  1782,  1782,
    1782,  1782,  1782,  1782,  1782,  1782,  1782,  1782,  1782,  1782,
    1782,  1782,  1783,  1782,  1784,  1782,  1782,  1782,  1782,  1782,
    1782,  1782,  1782,  1782,  1782,  1782,  1782,  1782,  1782,  1782,
    1782,  1782,  1782,  1782,  1782,  1782,  1782,  1782,  1782,  1782,
    1782,  1782,  1782,  1782,  1782,  1782,  1782,  1782,  1782,  1782,
    1782,  1782,  1782,  1782,  1782,  1782,  1782,  1782,  1782,  1785,
    1785,  1785,  1786,  1786,  1787,  1787,  1788,  1788,  1789,  1789,
    1790,  1790,  1791,  1791,  1792,  1792,  1793,  1793,  1793,  1795,
    1794,  1796,  1794,  1797,  1797,  1797,  1797,  1797,  1797,  1798,
    1798,  1799,  1800,  1800,  1800,  1800,  1801,  1801,  1802,  1802,
    1802,  1804,  1803,  1806,  1805,  1805,  1807,  1807,  1808,  1809,
    1808,  1810,  1810,  1811,  1811,  1811,  1811,  1811,  1811,  1811,
    1811,  1811,  1811,  1811,  1811,  1811,  1811,  1811,  1811,  1811,
    1812,  1812,  1813,  1814,  1815,  1814,  1814,  1816,  1816,  1817,
    1817,  1817,  1818,  1819,  1819,  1821,  1820,  1822,  1822,  1824,
    1823,  1825,  1823,  1823,  1826,  1826,  1827,  1827,  1828,  1829,
    1828,  1831,  1830,  1832,  1832,  1832,  1833,  1833,  1833,  1834,
    1834,  1835,  1835,  1837,  1836,  1838,  1838,  1839,  1841,  1842,
    1843,  1844,  1840,  1845,  1845,  1846,  1846,  1847,  1847,  1847,
    1848,  1848,  1848,  1849,  1849,  1850,  1850,  1851,  1851,  1851,
    1851,  1852,  1852,  1853,  1853,  1854,  1854,  1855,  1855,  1856,
    1856,  1857,  1857,  1858,  1858,  1858,  1859,  1859,  1860,  1860,
    1861,  1861,  1862,  1862,  1863,  1864,  1864,  1864,  1864,  1865,
    1865,  1866,  1866,  1866,  1867,  1867,  1867,  1868,  1868,  1869,
    1869,  1869,  1869,  1869,  1869,  1869,  1869,  1869,  1869,  1870,
    1870,  1870,  1870,  1870,  1871,  1871,  1871,  1873,  1872,  1874,
    1874,  1875,  1875,  1877,  1876,  1878,  1878,  1879,  1879,  1880,
    1881,  1881,  1882,  1882,  1883,  1883,  1884,  1885,  1885,  1885,
    1885,  1885,  1886,  1886,  1886,  1886,  1886,  1887,  1887,  1887,
    1887,  1888,  1888,  1888,  1889,  1889,  1890,  1891,  1891,  1892,
    1892,  1892,  1893,  1894,  1895,  1896,  1897,  1897,  1898,  1898,
    1899,  1899,  1899,  1900,  1900,  1901,  1901,  1902,  1902,  1903,
    1903,  1904,  1905,  1905,  1905,  1906,  1906,  1906,  1907,  1907,
    1908,  1909,  1909,  1909,  1909,  1909,  1909,  1909,  1909,  1909,
    1910,  1910,  1910,  1910,  1910,  1910,  1910,  1910,  1910,  1910,
    1911,  1911,  1911,  1911,  1911,  1911,  1912,  1912,  1912,  1912,
    1912,  1912,  1912,  1912,  1912,  1913,  1913,  1913,  1913,  1913,
    1913,  1913,  1914,  1914,  1914,  1914,  1914,  1914,  1914,  1914,
    1914,  1915,  1915,  1915,  1915,  1915,  1915,  1915,  1916,  1916,
    1916,  1916,  1916,  1916,  1916,  1916,  1916,  1916,  1916,  1916,
    1916,  1916,  1916,  1916,  1916,  1916,  1916,  1916,  1916,  1916,
    1916,  1916,  1916,  1916,  1916,  1916,  1916,  1916,  1916,  1916,
    1916,  1916,  1916,  1916,  1916,  1916,  1916,  1916,  1916,  1916,
    1916,  1916,  1916,  1916,  1916,  1916,  1916,  1916,  1916,  1916,
    1916,  1916,  1916,  1917,  1917,  1917,  1917,  1917,  1917,  1918,
    1918,  1918,  1918,  1918,  1918,  1918,  1918,  1918,  1918,  1919,
    1919,  1919,  1920,  1920,  1920,  1921,  1921,  1921,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1925,  1924,  1926,  1927,
    1924,  1929,  1928,  1930,  1928,  1931,  1928,  1932,  1932,  1934,
    1933,  1935,  1933,  1936,  1933,  1938,  1937,  1937,  1939,  1939,
    1941,  1940,  1942,  1940,  1944,  1943,  1943,  1945,  1945,  1945,
    1946,  1946,  1946,  1946,  1947,  1947,  1947,  1947,  1948,  1948,
    1948,  1949,  1949,  1949,  1949,  1949,  1949,  1949,  1949,  1949,
    1949,  1949,  1949,  1949,  1949,  1949,  1950,  1950,  1950,  1950,
    1951,  1952,  1953,  1953,  1954,  1954,  1954,  1954,  1955,  1955,
    1956,  1956,  1956,  1957,  1957,  1957,  1957,  1957,  1959,  1958,
    1960,  1960,  1960,  1961,  1961,  1962,  1962,  1963,  1964,  1964,
    1964,  1964,  1964,  1966,  1965,  1968,  1967,  1969,  1969,  1970,
    1969,  1971,  1971,  1972,  1972,  1973,  1973,  1973,  1973,  1974,
    1973,  1975,  1975,  1975,  1975,  1975,  1976,  1977,  1977,  1977,
    1977,  1977,  1977,  1977,  1977,  1978,  1978,  1979,  1980,  1980,
    1980,  1980,  1980,  1980,  1980,  1981,  1981,  1982,  1982,  1983,
    1983,  1984,  1985,  1985,  1986,  1986,  1987,  1987,  1988,  1988,
    1989,  1989,  1991,  1990,  1992,  1990,  1993,  1990,  1994,  1990,
    1990,  1990,  1990,  1990,  1990,  1990,  1990,  1990,  1990,  1990,
    1990,  1990,  1990,  1990,  1990,  1990,  1990,  1990,  1990,  1990,
    1990,  1990,  1990,  1990,  1990,  1990,  1990,  1995,  1995,  1996,
    1996,  1997,  1997,  1997,  1998,  1998,  1998,  1998,  1999,  1999,
    2000,  2000,  2001,  2001,  2002,  2002,  2003,  2003,  2004,  2004,
    2004,  2004,  2005,  2005,  2006,  2007,  2007,  2007,  2008,  2008,
    2009,  2009,  2010,  2011,  2011,  2011,  2011,  2011,  2012,  2012,
    2012,  2012,  2012,  2013,  2013,  2014,  2014,  2015,  2015,  2016,
    2016,  2017,  2017,  2018,  2018,  2020,  2019,  2021,  2022,  2022,
    2023,  2023,  2024,  2024,  2024,  2025,  2025,  2025,  2026,  2027,
    2027,  2027,  2028,  2029,  2030,  2030,  2030,  2031,  2031,  2031,
    2032,  2032,  2032,  2032,  2032,  2032,  2032,  2032,  2032,  2033,
    2033,  2034,  2035,  2036,  2036,  2036,  2037,  2037,  2038,  2038,
    2039,  2039,  2040,  2040,  2042,  2041,  2043,  2043,  2043,  2043,
    2044,  2044,  2045,  2045,  2047,  2048,  2049,  2050,  2051,  2046,
    2053,  2052,  2055,  2054,  2057,  2058,  2056,  2059,  2059,  2060,
    2060,  2061,  2061,  2061,  2061,  2061,  2061,  2062,  2062,  2063,
    2063,  2063,  2064,  2064,  2064,  2065,  2065,  2065,  2066,  2066,
    2067,  2068,  2067,  2069,  2069,  2070,  2070,  2071,  2071,  2072
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     4,     2,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     0,     5,     3,     0,     0,     6,
       0,     0,     3,     1,     3,     0,     3,     0,     6,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     5,     5,     5,
       1,     0,     1,     3,     1,     0,     1,     3,     1,     0,
       1,     3,     1,     3,     3,     3,     3,     3,     3,     3,
       0,     1,     1,     0,     0,     8,     0,     8,     0,     0,
      16,     0,     0,    15,     0,     0,    15,     0,     6,     0,
      10,     0,    11,     0,     5,     0,     6,     0,     5,     0,
      11,     0,    14,     0,    11,     0,    14,    10,     8,     6,
       4,     3,     0,     3,     0,    13,     0,     0,     0,    16,
       1,     3,     1,     1,     2,     1,     2,     1,     2,     0,
       0,     8,     0,     6,     4,     4,     1,     0,     5,     0,
       5,     2,     0,     1,     1,     2,     3,     3,     0,     1,
       1,     2,     3,     2,     1,     3,     2,     1,     3,     3,
       3,     1,     1,     1,     1,     3,     0,     1,     0,    12,
       1,     3,     2,     2,     2,     2,     2,     2,     2,     0,
      12,     0,     6,     2,     0,     1,     3,     1,     0,     2,
       0,     2,     0,     1,     4,     0,     2,     0,     3,     0,
       0,     1,     3,     1,     0,     1,     0,     2,     0,     2,
       2,     2,     2,     2,     3,     3,     1,     2,     1,     1,
       2,     0,     1,     0,     2,     1,     2,     3,     3,     0,
       4,     0,     6,     0,     8,     0,     3,     0,     1,     3,
       1,     0,     0,     2,     3,     1,     1,     2,     6,     8,
       4,     6,     3,     0,     1,     3,     1,     3,     7,     9,
       5,     7,     4,     0,     1,     1,     1,     2,     0,     4,
       0,     1,     3,     1,     1,     0,     3,     2,     3,     0,
       2,     0,     1,     0,     3,     1,     2,     3,     2,     3,
       0,     1,     1,     3,     5,     1,     2,     1,     3,     3,
       1,     3,     5,     5,     4,     1,     4,     2,     0,     6,
       0,     6,     0,     3,     0,     0,     3,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     3,     0,     1,     1,
       1,     1,     2,     1,     1,     2,     3,     3,     1,     1,
       0,     1,     0,     2,     3,     5,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     4,     0,     1,     1,     3,     1,     3,     3,
       1,     2,     1,     1,     1,     1,     1,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     0,     2,     2,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     5,     1,     0,     3,     0,     5,     0,
       7,     0,     2,     1,     1,     0,     3,     1,     0,     2,
       1,     2,     3,     4,     1,     2,     3,     4,     2,     2,
       2,     0,     0,     0,     3,     0,     3,     1,     3,     0,
       3,     3,     3,     4,     5,     2,     4,     2,     1,     3,
       0,     0,     0,     7,     0,     2,     2,     0,     6,     0,
       0,     4,     1,     1,     2,     1,     2,     0,     0,     6,
       0,     0,     6,     0,     2,     0,     1,     1,     0,     6,
       0,     0,     9,     0,     2,     0,     5,     0,     0,     7,
       0,     0,     0,     0,     7,     0,     4,     0,     2,     1,
       2,     0,     5,     0,     1,     0,     3,     5,     3,     5,
       3,     0,     6,     0,     6,     1,     0,     5,     0,     5,
       0,     0,     0,    11,     0,     5,     0,     3,     0,     3,
       0,     0,     8,     0,     3,     1,     1,     1,     1,     1,
       2,     4,     5,     0,     4,     4,     4,     3,     3,     2,
       2,     0,     2,     1,     2,     3,     1,     1,     1,     1,
       1,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     1,     1,     1,     2,     2,
       2,     1,     1,     1,     1,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     0,     1,     1,     1,     1,
       1,     0,     5,     3,     1,     2,     4,     0,     4,     1,
       4,     1,     0,     1,     0,     4,     0,     0,     3,     0,
       6,     6,     0,     4,     2,     2,     0,     3,     2,     0,
       3,     0,     1,     0,     3,     0,     1,     1,     3,     1,
       4,     3,     3,     0,     2,     0,     0,     7,     0,    10,
       1,     3,     1,     1,     0,     2,     0,     3,     1,     3,
       0,     6,     1,     0,     0,     4,     0,     3,     1,     1,
       1,     1,     1,     1,     3,     1,     3,     0,     0,     5,
       1,     3,     1,     1,     0,     3,     1,     3,     0,     4,
       1,     0,     1,     2,     1,     3,     4,     3,     3,     3,
       3,     4,     4,     3,     0,     0,     5,     2,     0,     2,
       0,     1,     0,     1,     1,     2,     1,     1,     0,     3,
       0,     3,     1,     3,     0,     1,     1,     2,     1,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     0,     6,     1,     1,     3,     4,     4,     2,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       0,     1,     2,     4,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     2,
       1,     2,     0,     9,     0,    10,     0,     9,     0,     9,
       0,    10,     0,    11,     0,    10,     2,     7,     7,     0,
       1,     4,     0,     1,     0,     1,     2,     0,     4,     0,
       3,     0,     3,     0,     1,     2,     1,     0,     1,     2,
       1,     0,     1,     2,     3,     0,     6,     5,     5,     0,
       2,     0,     1,     1,     1,     0,     1,     2,     1,     1,
       2,     2,     1,     0,     3,     1,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     2,
       1,     1,     3,     3,     3,     3,     0,     1,     2,     2,
       3,     3,     2,     3,     3,     4,     3,     3,     3,     3,
       2,     3,     3,     3,     2,     2,     3,     1,     2,     2,
       2,     2,     3,     3,     2,     3,     2,     2,     3,     3,
       2,     3,     2,     2,     2,     2,     2,     5,     5,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     1,     2,     1,     2,     3,     2,     1,     1,     1,
       1,     1,     1,     1,     2,     0,     3,     0,     1,     1,
       5,     0,     1,     1,     1,     2,     2,     3,     3,     3,
       3,     0,     1,     0,     1,     0,     1,     0,     1,     0,
       1,     2,     1,     1,     2,     4,     1,     3,     2,     1,
       0,     2,     0,     1,     2,     2,     2,     2,     2,     1,
       1,     3,     3,     3,     3,     2,     1,     2,     1,     2,
       1,     1,     1,     1,     1,     0,     2,     1,     1,     1,
       1,     1,     0,     2,     1,     1,     0,     1,     2,     1,
       1,     2,     0,     1,     1,     2,     1,     2,     2,     1,
       0,     1,     0,     4,     1,     1,     1,     0,     1,     2,
       1,     1,     2,     1,     3,     3,     1,     1,     0,     2,
       0,     1,     5,     0,     3,     3,     1,     0,     2,     2,
       2,     0,     3,     3,     6,     6,     1,     1,     2,     2,
       2,     2,     2,     1,     1,     0,     1,     1,     1,     1,
       0,     1,     1,     1,     0,     1,     0,     1,     0,     1,
       1,     2,     1,     2,     1,     2,     0,     2,     0,     2,
       2,     2,     2,     3,     2,     3,     3,     3,     3,     1,
       1,     1,     1,     3,     1,     1,     1,     4,     2,     1,
       4,     0,     1,     1,     3,     0,     0,     8,     0,     5,
       7,     0,     5,     0,     5,     0,    10,     0,     9,     0,
      11,     3,     4,     3,     3,     0,     8,     8,     0,     0,
       7,     1,     1,     0,     1,     1,     3,     0,     2,     3,
       5,     5,     0,     3,     1,     4,     0,     3,     0,     2,
       0,     1,     0,     2,     2,     2,     2,     1,     1,     1,
       4,     4,     0,     6,     4,     0,     5,     0,     6,     4,
       3,     1,     7,     2,     1,     1,     0,     6,     0,     3,
       2,     0,     5,     0,     0,     6,     1,     3,     1,     1,
       3,     3,     3,     2,     2,     4,     4,     2,     7,     6,
       5,     5,     4,     5,     4,     4,     2,     2,     7,     6,
       3,     5,     1,     1,     1,     1,     1,     3,     3,     3,
       5,     0,     1,     1,     2,     2,     3,     3,     3,     3,
       0,     1,     0,     1,     0,     2,     0,     1,     2,     1,
       1,     1,     0,     1,     1,     0,     2,     1,     0,     1,
       1,     1,     0,     6,     0,     5,     4,     4,     3,     0,
       1,     1,     3,     3,     2,     2,     0,     2,     1,     3,
       0,     1,     1,     0,     2,     4,     1,     3,     0,     5,
       0,     1,     1,     3,     0,     4,     0,     4,     0,     1,
       1,     2,     1,     1,     1,     0,     2,     0,     5,     1,
       3,     2,     0,     3,     1,     4,     1,     0,     4,     1,
       0,     4,     0,     1,     3,     0,     1,     3,     1,     1,
       2,     6,     3,     0,     4,     0,     3,     0,     1,     1,
       2,     1,     1,     1,     1,     1,     2,     0,     2,     0,
       6,     0,     1,     1,     0,     4,     4,     3,     5,     1,
       3,     4,     0,     6,     1,     1,     1,     3,     2,     3,
       1,     1,     0,     6,     1,     1,     1,     3,     3,     4,
       0,     6,     0,     2,     0,     4,     0,     2,     0,     3,
       0,     4,     0,     3,     0,     4,     1,     1,     0,     3,
       0,     0,     5,     6,     7,     1,     2,     1,     1,     0,
       3,     0,     3,     3,     3,     1,     0,     4,     3,     1,
       1,     1,     1,     1,     4,     0,     1,     2,     1,     1,
       0,     1,     0,     1,     1,     2,     1,     2,     9,     0,
       1,     0,     2,     3,     1,     4,     4,     2,     1,     1,
       1,     1,     3,     5,     0,     1,     0,     2,     1,     3,
       1,     1,     3,     4,     0,     0,     0,     0,     0,     2,
       2,     1,     1,     0,     2,     3,     0,     2,     3,     0,
       2,     3,     3,     3,     2,     1,     3,     4,     3,     4,
       3,     4,     3,     4,     3,     3,     6,     1,     3,     4,
       5,     7,     6,     8,     5,     6,     4,     3,     5,     4,
       6,     3,     4,     1,     3,     3,     3,     3,     3,     3,
       3,     5,     5,     5,     6,     6,     3,     3,     3,     3,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       2,     1,     1,     1,     1,     2,     1,     1,     1,     2,
       1,     2,     2,     0,     3,     1,     4,     1,     3,     1,
       1,     1,     1,     3,     1,     1,     1,     4,     4,     4,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     6,     4,     4,     7,     6,
       3,     4,     6,     6,     4,     4,     4,     4,     4,     4,
       6,     8,    10,     1,     1,     3,     1,     1,     3,     1,
       2,     2,     2,     2,     2,     1,     3,     4,     6,     4,
       6,     2,     2,     4,     4,     4,    10,     6,     8,     6,
       4,     4,     6,     4,     3,     4,     1,     4,     3,     4,
       1,     1,     5,     3,     5,     3,     6,     8,     2,     2,
       8,     8,     6,     8,     6,     6,     2,     6,     6,     8,
       4,     2,     8,     8,     4,     2,     2,     2,     6,     6,
       4,     4,     8,     4,     4,     4,     4,     3,     8,     6,
       8,     4,     6,     4,     6,     4,     4,     4,     6,     8,
       4,     3,     6,     4,     6,     5,     8,     7,    10,     1,
       6,     4,     4,     4,     4,     4,     6,     4,     6,     0,
       5,     6,     8,     6,     6,     6,     6,     6,     2,     3,
       0,     4,     0,     3,     0,     1,     1,     3,     4,     4,
       5,     4,     4,     4,     5,     4,     0,     0,     7,     4,
       5,     4,     5,     4,     4,     4,     4,     4,     5,     0,
       9,     3,     3,     1,     1,     1,     3,     3,     3,     3,
       3,     4,     4,     4,     6,     4,     6,     4,     6,     5,
       0,     7,     4,     4,     4,     4,     1,     0,     3,     3,
       1,     3,     5,     0,     1,     0,     2,     0,     3,     4,
       2,     0,     1,     1,     2,     1,     3,     3,     0,     3,
       2,     0,     4,     0,     4,     0,     4,     2,     1,     1,
       1,     1,     2,     1,     2,     2,     1,     2,     1,     2,
       2,     3,     0,     1,     1,     3,     1,     3,     1,     3,
       4,     5,     1,     3,     1,     1,     1,     1,     4,     1,
       3,     3,     0,     6,     0,     8,     4,     0,     8,     0,
      10,     6,     0,     8,     0,    10,     6,     1,     2,     1,
       1,     2,     0,     1,     5,     1,     1,     1,     1,     1,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     5,
       3,     0,     1,     0,     2,     3,     3,     1,     1,     0,
       7,     0,     7,     1,     2,     0,     0,     2,     0,     2,
       0,     1,     1,     1,     1,     3,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     1,     0,     1,     2,     0,
       1,     0,     0,     3,     0,     0,     3,     0,     4,     4,
       2,     0,     1,     1,     0,     2,     3,     1,     3,     0,
       7,     0,     1,     0,     3,     0,     3,     0,     3,     1,
       1,     1,     4,     2,     2,     2,     1,     2,     2,     0,
       3,     2,     2,     3,     3,     3,     3,     1,     2,     0,
       1,     0,     4,     4,     2,     0,     1,     1,     0,     1,
       2,     5,     4,     1,     1,     3,     3,     1,     3,     1,
       1,     1,     1,     1,     0,     2,     3,     4,     1,     2,
       1,     0,     1,     1,     1,     0,     2,     2,     2,     1,
       0,     1,     2,     2,     2,     1,     2,     2,     2,     2,
       1,     1,     1,     1,     1,     2,     1,     2,     2,     2,
       2,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     6,     0,
       1,     3,     1,     3,     0,     2,     3,     1,     1,     2,
       1,     3,     2,     0,     0,     7,     2,     1,     0,     3,
       0,     8,     0,     8,     4,     4,     5,     6,     4,     4,
       5,     5,     0,     6,     4,     4,     5,     6,     4,     0,
       6,     1,     3,     1,     2,     1,     3,     1,     0,     2,
       0,     2,     0,     1,     0,     0,     8,     0,     0,     6,
       0,     1,     1,     1,     1,     1,     2,     1,     0,     2,
       1,     2,     0,     3,     3,     0,     1,     3,     1,     1,
       3,     1,     3,     1,     3,     1,     1,     0,     1,     1,
       1,     1,     1,     0,     4,     0,     4,     0,     1,     0,
       1,     3,     1,     5,     3,     1,     1,     1,     1,     0,
       0,     0,     7,     5,     1,     0,     0,    11,     3,     1,
       3,     3,     3,     1,     3,     0,     1,     0,     3,     0,
       3,     2,     3,     3,     2,     5,     0,     5,     0,     6,
       0,     2,     1,     3,     2,     4,     0,     2,     0,     2,
       1,     1,     1,     0,     0,     7,     0,     2,     2,     0,
       1,     0,     1,     1,     3,     1,     1,     2,     2,     2,
       1,     1,     1,     1,     0,     3,     0,     3,     2,     4,
       4,     3,     4,     4,     1,     3,     3,     3,     3,     6,
       2,     2,     0,     6,     0,     7,     5,     2,     1,     1,
       1,     5,     5,     2,     2,     1,     4,     3,     2,     3,
       2,     2,     1,     4,     4,     3,     3,     3,     2,     3,
       2,     3,     3,     3,     3,     4,     3,     2,     3,     3,
       3,     3,     4,     3,     3,     4,     3,     3,     3,     1,
       1,     1,     1,     1,     0,     1,     0,     2,     0,     1,
       1,     1,     0,     2,     0,     2,     0,     3,     3,     0,
       4,     0,     4,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     2,     1,     1,     0,     3,     0,     1,
       1,     0,     4,     0,     4,     1,     0,     1,     4,     0,
       3,     3,     1,     2,     2,     2,     2,     3,     3,     2,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     2,
       0,     1,     2,     2,     0,     3,     1,     0,     5,     0,
       1,     3,     1,     0,     3,     0,     3,     3,     1,     0,
       4,     0,     3,     2,     0,     1,     0,     2,     5,     0,
       6,     0,     4,     0,     1,     1,     2,     2,     3,     0,
       1,     1,     2,     0,     3,     0,     4,     2,     0,     0,
       0,     0,    22,     1,     1,     0,     1,     0,     1,     1,
       0,     1,     1,     0,     2,     2,     1,     3,     4,     3,
       3,     0,     2,     2,     1,     3,     3,     0,     4,     0,
       3,     1,     1,     0,     3,     2,     3,     1,     1,     2,
       0,     2,     3,     1,     5,     1,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     2,     2,     2,     0,     4,     0,
       1,     1,     3,     0,     7,     0,     3,     1,     3,     1,
       1,     1,     3,     5,     3,     5,     1,     1,     3,     4,
       5,     4,     1,     3,     4,     4,     5,     1,     5,     3,
       2,     1,     3,     2,     2,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     3,     1,     1,     1,     1,     3,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     3,     0,     0,
       7,     0,     4,     0,     6,     0,     7,     1,     3,     0,
       3,     0,     3,     0,     3,     0,     3,     2,     0,     2,
       0,     2,     0,     4,     0,     3,     1,     1,     1,     1,
       0,     1,     1,     1,     0,     2,     2,     2,     3,     5,
       5,     3,     5,     5,     4,     6,     8,     8,     2,     3,
       3,     3,     5,     2,     3,     3,     1,     1,     3,     3,
       1,     3,     2,     2,     2,     2,     2,     1,     1,     3,
       1,     4,     4,     1,     1,     1,     1,     1,     0,     5,
       0,     2,     1,     1,     1,     1,     3,     3,     1,     1,
       2,     2,     2,     0,     3,     0,     3,     3,     2,     0,
       6,     1,     2,     1,     1,     1,     1,     1,     1,     0,
       5,     1,     1,     1,     1,     1,     3,     6,     6,     6,
       6,     7,     7,     5,     3,     4,     1,     3,     8,     8,
       8,     8,     9,     6,     4,     0,     3,     0,     3,     1,
       3,     2,     1,     1,     0,     1,     1,     2,     0,     1,
       1,     3,     0,     3,     0,     3,     0,     3,     0,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     1,     3,     2,     2,     2,     2,     2,
       2,     2,     2,     1,     1,     2,     2,     0,     1,     3,
       1,     2,     2,     2,     1,     3,     3,     1,     1,     3,
       1,     3,     1,     3,     1,     1,     1,     1,     4,     5,
       4,     1,     3,     1,     2,     0,     2,     5,     0,     3,
       3,     1,     1,     0,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     1,     0,     2,     0,     2,     0,
       3,     2,     1,     2,     1,     0,     3,     1,     0,     1,
       0,     1,     0,     3,     2,     0,     1,     2,     4,     4,
       5,     4,     2,     3,     2,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     3,     3,     3,     3,     0,     1,     3,     3,
       0,     3,     1,     3,     0,     3,     0,     3,     4,     4,
       1,     1,     0,     2,     0,     0,     0,     0,     0,    20,
       0,     2,     0,     5,     0,     0,     8,     0,     1,     1,
       1,     4,     4,     3,     4,     3,     3,     0,     3,     1,
       3,     5,     1,     1,     1,     0,     1,     1,     0,     2,
       0,     0,     3,     0,     2,     6,     3,     4,     4,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (thd, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, thd); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, THD *thd)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (thd);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, THD *thd)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, thd);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, THD *thd)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], thd);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, thd); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, THD *thd)
{
  YY_USE (yyvaluep);
  YY_USE (thd);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (THD *thd)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, thd);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* query: END_OF_INPUT  */
#line 1765 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!thd->bootstrap &&
              (!(thd->lex->lex_options & OPTION_LEX_FOUND_COMMENT)))
              my_yyabort_error((ER_EMPTY_QUERY, MYF(0)));

            thd->lex->sql_command= SQLCOM_EMPTY_QUERY;
            YYLIP->found_semicolon= NULL;
          }
#line 26032 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3: /* $@1: %empty  */
#line 1774 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex_input_stream *lip = YYLIP;

            if ((thd->client_capabilities & CLIENT_MULTI_QUERIES) &&
                lip->multi_statements &&
                ! lip->eof())
            {
              /*
                We found a well formed query, and multi queries are allowed:
                - force the parser to stop after the ';'
                - mark the start of the next query for the next invocation
                  of the parser.
              */
              lip->next_state= MY_LEX_END;
              lip->found_semicolon= lip->get_ptr();
            }
            else
            {
              /* Single query, terminated. */
              lip->found_semicolon= NULL;
            }
          }
#line 26059 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 5: /* query: verb_clause END_OF_INPUT  */
#line 1799 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* Single query, not terminated. */
            YYLIP->found_semicolon= NULL;
          }
#line 26068 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 71: /* deallocate: deallocate_or_drop PREPARE_SYM ident  */
#line 1882 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->stmt_deallocate_prepare((yyvsp[0].ident_sys));
          }
#line 26076 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 74: /* $@2: %empty  */
#line 1894 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->clause_that_disallows_subselect= "PREPARE..FROM"; }
#line 26082 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 75: /* prepare: PREPARE_SYM ident FROM $@2 expr  */
#line 1896 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->clause_that_disallows_subselect= NULL;
            if (Lex->stmt_prepare((yyvsp[-3].ident_sys), (yyvsp[0].item)))
              MYSQL_YYABORT;
          }
#line 26092 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 76: /* execute: EXECUTE_SYM ident execute_using  */
#line 1905 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_execute((yyvsp[-1].ident_sys), (yyvsp[0].item_list)))
              MYSQL_YYABORT;
          }
#line 26101 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 77: /* $@3: %empty  */
#line 1910 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->clause_that_disallows_subselect= "EXECUTE IMMEDIATE"; }
#line 26107 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 78: /* $@4: %empty  */
#line 1912 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->clause_that_disallows_subselect= NULL; }
#line 26113 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 79: /* execute: EXECUTE_SYM IMMEDIATE_SYM $@3 expr $@4 execute_using  */
#line 1914 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_execute_immediate((yyvsp[-2].item), (yyvsp[0].item_list)))
              MYSQL_YYABORT;
          }
#line 26122 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 80: /* execute_using: %empty  */
#line 1921 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.item_list)= NULL; }
#line 26128 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 81: /* $@5: %empty  */
#line 1923 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->clause_that_disallows_subselect= "EXECUTE..USING"; }
#line 26134 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 82: /* execute_using: USING $@5 execute_params  */
#line 1925 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_list)= (yyvsp[0].item_list);
            Lex->clause_that_disallows_subselect= NULL;
          }
#line 26143 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 83: /* execute_params: expr_or_ignore_or_default  */
#line 1933 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_list)= List<Item>::make(thd->mem_root, (yyvsp[0].item)))))
              MYSQL_YYABORT;
          }
#line 26152 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 84: /* execute_params: execute_params ',' expr_or_ignore_or_default  */
#line 1938 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (((yyval.item_list)= (yyvsp[-2].item_list))->push_back((yyvsp[0].item), thd->mem_root))
              MYSQL_YYABORT;
          }
#line 26161 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 85: /* $@6: %empty  */
#line 1949 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HELP"));
          }
#line 26170 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 86: /* help: HELP_SYM $@6 ident_or_text  */
#line 1954 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_HELP;
            lex->help_arg= (yyvsp[0].lex_str).str;
          }
#line 26180 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 87: /* $@7: %empty  */
#line 1965 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_CHANGE_MASTER;
          }
#line 26188 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 88: /* change: CHANGE MASTER_SYM optional_connection_name TO_SYM $@7 master_defs  */
#line 1969 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 26194 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 91: /* master_def: MASTER_HOST_SYM '=' TEXT_STRING_sys  */
#line 1979 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.host = (yyvsp[0].lex_str).str;
          }
#line 26202 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 92: /* master_def: MASTER_USER_SYM '=' TEXT_STRING_sys  */
#line 1983 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.user = (yyvsp[0].lex_str).str;
          }
#line 26210 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 93: /* master_def: MASTER_PASSWORD_SYM '=' TEXT_STRING_sys  */
#line 1987 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.password = (yyvsp[0].lex_str).str;
          }
#line 26218 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 94: /* master_def: MASTER_PORT_SYM '=' ulong_num  */
#line 1991 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.port = (yyvsp[0].ulong_num);
          }
#line 26226 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 95: /* master_def: MASTER_CONNECT_RETRY_SYM '=' ulong_num  */
#line 1995 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.connect_retry = (yyvsp[0].ulong_num);
          }
#line 26234 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 96: /* master_def: MASTER_DELAY_SYM '=' ulong_num  */
#line 1999 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[0].ulong_num) > MASTER_DELAY_MAX)
            {
              my_error(ER_MASTER_DELAY_VALUE_OUT_OF_RANGE, MYF(0),
                       (ulong) (yyvsp[0].ulong_num), (ulong) MASTER_DELAY_MAX);
            }
            else
              Lex->mi.sql_delay = (yyvsp[0].ulong_num);
          }
#line 26248 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 97: /* master_def: MASTER_SSL_SYM '=' ulong_num  */
#line 2009 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl= (yyvsp[0].ulong_num) ? 
              LEX_MASTER_INFO::LEX_MI_ENABLE : LEX_MASTER_INFO::LEX_MI_DISABLE;
          }
#line 26257 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 98: /* master_def: MASTER_SSL_CA_SYM '=' TEXT_STRING_sys  */
#line 2014 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_ca= (yyvsp[0].lex_str).str;
          }
#line 26265 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 99: /* master_def: MASTER_SSL_CAPATH_SYM '=' TEXT_STRING_sys  */
#line 2018 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_capath= (yyvsp[0].lex_str).str;
          }
#line 26273 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 100: /* master_def: MASTER_SSL_CERT_SYM '=' TEXT_STRING_sys  */
#line 2022 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_cert= (yyvsp[0].lex_str).str;
          }
#line 26281 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 101: /* master_def: MASTER_SSL_CIPHER_SYM '=' TEXT_STRING_sys  */
#line 2026 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_cipher= (yyvsp[0].lex_str).str;
          }
#line 26289 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 102: /* master_def: MASTER_SSL_KEY_SYM '=' TEXT_STRING_sys  */
#line 2030 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_key= (yyvsp[0].lex_str).str;
          }
#line 26297 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 103: /* master_def: MASTER_SSL_VERIFY_SERVER_CERT_SYM '=' ulong_num  */
#line 2034 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_verify_server_cert= (yyvsp[0].ulong_num) ?
              LEX_MASTER_INFO::LEX_MI_ENABLE : LEX_MASTER_INFO::LEX_MI_DISABLE;
          }
#line 26306 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 104: /* master_def: MASTER_SSL_CRL_SYM '=' TEXT_STRING_sys  */
#line 2039 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_crl= (yyvsp[0].lex_str).str;
          }
#line 26314 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 105: /* master_def: MASTER_SSL_CRLPATH_SYM '=' TEXT_STRING_sys  */
#line 2043 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_crlpath= (yyvsp[0].lex_str).str;
          }
#line 26322 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 106: /* master_def: MASTER_HEARTBEAT_PERIOD_SYM '=' NUM_literal  */
#line 2048 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.heartbeat_period= (float) (yyvsp[0].item_num)->val_real();
            if (unlikely(Lex->mi.heartbeat_period >
                         SLAVE_MAX_HEARTBEAT_PERIOD) ||
                unlikely(Lex->mi.heartbeat_period < 0.0))
               my_yyabort_error((ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE, MYF(0),
                                 SLAVE_MAX_HEARTBEAT_PERIOD));

            if (unlikely(Lex->mi.heartbeat_period > slave_net_timeout))
            {
              push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                                  ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MAX,
                                  ER_THD(thd, ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MAX));
            }
            if (unlikely(Lex->mi.heartbeat_period < 0.001))
            {
              if (unlikely(Lex->mi.heartbeat_period != 0.0))
              {
                push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                                    ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MIN,
                                    ER_THD(thd, ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MIN));
                Lex->mi.heartbeat_period= 0.0;
              }
              Lex->mi.heartbeat_opt=  LEX_MASTER_INFO::LEX_MI_DISABLE;
            }
            Lex->mi.heartbeat_opt=  LEX_MASTER_INFO::LEX_MI_ENABLE;
          }
#line 26354 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 107: /* master_def: IGNORE_SERVER_IDS_SYM '=' '(' ignore_server_id_list ')'  */
#line 2076 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.repl_ignore_server_ids_opt= LEX_MASTER_INFO::LEX_MI_ENABLE;
           }
#line 26362 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 108: /* master_def: DO_DOMAIN_IDS_SYM '=' '(' do_domain_id_list ')'  */
#line 2080 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.repl_do_domain_ids_opt= LEX_MASTER_INFO::LEX_MI_ENABLE;
          }
#line 26370 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 109: /* master_def: IGNORE_DOMAIN_IDS_SYM '=' '(' ignore_domain_id_list ')'  */
#line 2084 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.repl_ignore_domain_ids_opt= LEX_MASTER_INFO::LEX_MI_ENABLE;
          }
#line 26378 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 114: /* ignore_server_id: ulong_num  */
#line 2099 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            insert_dynamic(&Lex->mi.repl_ignore_server_ids, (uchar*) &((yyvsp[0].ulong_num)));
          }
#line 26386 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 118: /* do_domain_id: ulong_num  */
#line 2112 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            insert_dynamic(&Lex->mi.repl_do_domain_ids, (uchar*) &((yyvsp[0].ulong_num)));
          }
#line 26394 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 122: /* ignore_domain_id: ulong_num  */
#line 2125 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            insert_dynamic(&Lex->mi.repl_ignore_domain_ids, (uchar*) &((yyvsp[0].ulong_num)));
          }
#line 26402 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 123: /* master_file_def: MASTER_LOG_FILE_SYM '=' TEXT_STRING_sys  */
#line 2132 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.log_file_name = (yyvsp[0].lex_str).str;
          }
#line 26410 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 124: /* master_file_def: MASTER_LOG_POS_SYM '=' ulonglong_num  */
#line 2136 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* 
               If the user specified a value < BIN_LOG_HEADER_SIZE, adjust it
               instead of causing subsequent errors. 
               We need to do it in this file, because only there we know that 
               MASTER_LOG_POS has been explicitly specified. On the contrary
               in change_master() (sql_repl.cc) we cannot distinguish between 0
               (MASTER_LOG_POS explicitly specified as 0) and 0 (unspecified),
               whereas we want to distinguish (specified 0 means "read the binlog
               from 0" (4 in fact), unspecified means "don't change the position
               (keep the preceding value)").
            */
            Lex->mi.pos= MY_MAX(BIN_LOG_HEADER_SIZE, (yyvsp[0].ulonglong_number));
          }
#line 26429 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 125: /* master_file_def: RELAY_LOG_FILE_SYM '=' TEXT_STRING_sys  */
#line 2151 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.relay_log_name = (yyvsp[0].lex_str).str;
          }
#line 26437 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 126: /* master_file_def: RELAY_LOG_POS_SYM '=' ulong_num  */
#line 2155 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.relay_log_pos = (yyvsp[0].ulong_num);
            /* Adjust if < BIN_LOG_HEADER_SIZE (same comment as Lex->mi.pos) */
            Lex->mi.relay_log_pos= MY_MAX(BIN_LOG_HEADER_SIZE, Lex->mi.relay_log_pos);
          }
#line 26447 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 127: /* master_file_def: MASTER_USE_GTID_SYM '=' CURRENT_POS_SYM  */
#line 2161 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->mi.use_gtid_opt != LEX_MASTER_INFO::LEX_GTID_UNCHANGED))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MASTER_use_gtid"));
            Lex->mi.use_gtid_opt= LEX_MASTER_INFO::LEX_GTID_CURRENT_POS;
          }
#line 26457 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 128: /* master_file_def: MASTER_USE_GTID_SYM '=' SLAVE_POS_SYM  */
#line 2167 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->mi.use_gtid_opt != LEX_MASTER_INFO::LEX_GTID_UNCHANGED))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MASTER_use_gtid"));
            Lex->mi.use_gtid_opt= LEX_MASTER_INFO::LEX_GTID_SLAVE_POS;
          }
#line 26467 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 129: /* master_file_def: MASTER_USE_GTID_SYM '=' NO_SYM  */
#line 2173 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->mi.use_gtid_opt != LEX_MASTER_INFO::LEX_GTID_UNCHANGED))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MASTER_use_gtid"));
            Lex->mi.use_gtid_opt= LEX_MASTER_INFO::LEX_GTID_NO;
          }
#line 26477 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 130: /* optional_connection_name: %empty  */
#line 2182 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->mi.connection_name= null_clex_str;
          }
#line 26486 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 132: /* connection_name: TEXT_STRING_sys  */
#line 2191 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
           Lex->mi.connection_name= (yyvsp[0].lex_str);
#ifdef HAVE_REPLICATION
           if (unlikely(check_master_connection_name(&(yyvsp[0].lex_str))))
              my_yyabort_error((ER_WRONG_ARGUMENTS, MYF(0), "MASTER_CONNECTION_NAME"));
#endif
         }
#line 26498 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 133: /* $@8: %empty  */
#line 2204 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            if (!(lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_create_table()))
              MYSQL_YYABORT;
            lex->create_info.init();
            if (lex->main_select_push())
              MYSQL_YYABORT;
            lex->current_select->parsing_place= BEFORE_OPT_LIST;
            if (lex->set_command_with_check(SQLCOM_CREATE_TABLE, (yyvsp[-2].num), (yyvsp[-3].object_ddl_options) | (yyvsp[0].object_ddl_options)))
               MYSQL_YYABORT;
          }
#line 26514 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 134: /* $@9: %empty  */
#line 2216 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            if (!lex->first_select_lex()->
                add_table_to_list(thd, (yyvsp[0].table), NULL, TL_OPTION_UPDATING,
                                  TL_WRITE, MDL_SHARED_UPGRADABLE))
              MYSQL_YYABORT;
            lex->alter_info.reset();
            /*
              For CREATE TABLE we should not open the table even if it exists.
              If the table exists, we should either not create it or replace it
            */
            lex->query_tables->open_strategy= TABLE_LIST::OPEN_STUB;
            lex->create_info.default_table_charset= NULL;
            lex->name= null_clex_str;
            lex->create_last_non_select_table= lex->last_table();
          }
#line 26535 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 135: /* create: create_or_replace opt_temporary TABLE_SYM opt_if_not_exists $@8 table_ident $@9 create_body  */
#line 2233 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            create_table_set_open_action_and_adjust_tables(lex);
            Lex->pop_select(); //main select
          }
#line 26545 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 136: /* $@10: %empty  */
#line 2239 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           LEX *lex= thd->lex;
           if (lex->main_select_push())
             MYSQL_YYABORT;
           if (!(lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_create_sequence()))
              MYSQL_YYABORT;
           lex->create_info.init();
           if (unlikely(lex->set_command_with_check(SQLCOM_CREATE_SEQUENCE, (yyvsp[-3].num),
                        (yyvsp[-4].object_ddl_options) | (yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;

           if (!lex->first_select_lex()->
               add_table_to_list(thd, (yyvsp[0].table), NULL, TL_OPTION_UPDATING,
                                 TL_WRITE, MDL_EXCLUSIVE))
             MYSQL_YYABORT;

               /*
                 For CREATE TABLE, an non-existing table is not an error.
                 Instruct open_tables() to just take an MDL lock if the
                 table does not exist.
               */
             lex->alter_info.reset();
             lex->query_tables->open_strategy= TABLE_LIST::OPEN_STUB;
             lex->name= null_clex_str;
             lex->create_last_non_select_table= lex->last_table();
             if (unlikely(!(lex->create_info.seq_create_info=
                            new (thd->mem_root) sequence_definition())))
               MYSQL_YYABORT;
         }
#line 26579 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 137: /* create: create_or_replace opt_temporary SEQUENCE_SYM opt_if_not_exists table_ident $@10 opt_sequence opt_create_table_options  */
#line 2269 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
            LEX *lex= thd->lex;

            if (unlikely(lex->create_info.seq_create_info->check_and_adjust(1)))
            {
              my_error(ER_SEQUENCE_INVALID_DATA, MYF(0),
                       lex->first_select_lex()->table_list.first->db.str,
                       lex->first_select_lex()->table_list.first->
                         table_name.str);
              MYSQL_YYABORT;
            }

            /* No fields specified, generate them */
            if (unlikely(prepare_sequence_fields(thd,
                         &lex->alter_info.create_list)))
               MYSQL_YYABORT;

            /* CREATE SEQUENCE always creates a sequence */
	    Lex->create_info.used_fields|= HA_CREATE_USED_SEQUENCE;
            Lex->create_info.sequence= 1;

            create_table_set_open_action_and_adjust_tables(lex);
            Lex->pop_select(); //main select
          }
#line 26608 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 138: /* $@11: %empty  */
#line 2294 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 26617 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 139: /* $@12: %empty  */
#line 2301 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->add_create_index_prepare((yyvsp[0].table)))
              MYSQL_YYABORT;
            if (Lex->add_create_index((yyvsp[-7].key_type), &(yyvsp[-3].ident_sys), (yyvsp[-2].key_alg), (yyvsp[-8].object_ddl_options) | (yyvsp[-5].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 26628 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 140: /* create: create_or_replace opt_unique INDEX_SYM opt_if_not_exists $@11 ident opt_key_algorithm_clause ON table_ident $@12 '(' key_list ')' opt_lock_wait_timeout normal_key_options opt_index_lock_algorithm  */
#line 2309 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26636 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 141: /* $@13: %empty  */
#line 2313 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 26645 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 142: /* $@14: %empty  */
#line 2319 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->add_create_index_prepare((yyvsp[0].table)))
              MYSQL_YYABORT;
            if (Lex->add_create_index((yyvsp[-6].key_type), &(yyvsp[-2].ident_sys), HA_KEY_ALG_UNDEF, (yyvsp[-7].object_ddl_options) | (yyvsp[-3].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 26656 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 143: /* create: create_or_replace fulltext INDEX_SYM $@13 opt_if_not_exists ident ON table_ident $@14 '(' key_list ')' opt_lock_wait_timeout fulltext_key_options opt_index_lock_algorithm  */
#line 2327 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26664 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 144: /* $@15: %empty  */
#line 2331 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 26673 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 145: /* $@16: %empty  */
#line 2337 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->add_create_index_prepare((yyvsp[0].table)))
              MYSQL_YYABORT;
            if (Lex->add_create_index((yyvsp[-6].key_type), &(yyvsp[-2].ident_sys), HA_KEY_ALG_UNDEF, (yyvsp[-7].object_ddl_options) | (yyvsp[-3].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 26684 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 146: /* create: create_or_replace spatial INDEX_SYM $@15 opt_if_not_exists ident ON table_ident $@16 '(' key_list ')' opt_lock_wait_timeout spatial_key_options opt_index_lock_algorithm  */
#line 2345 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26692 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 147: /* $@17: %empty  */
#line 2349 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.default_table_charset= NULL;
            Lex->create_info.used_fields= 0;
          }
#line 26701 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 148: /* create: create_or_replace DATABASE opt_if_not_exists ident $@17 opt_create_database_options  */
#line 2354 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->set_command_with_check(SQLCOM_CREATE_DB, 0,
                         (yyvsp[-5].object_ddl_options) | (yyvsp[-3].object_ddl_options))))
               MYSQL_YYABORT;
            lex->name= (yyvsp[-2].ident_sys);
          }
#line 26713 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 149: /* $@18: %empty  */
#line 2363 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->inc_select_stack_outer_barrier();
            if (Lex->add_create_view(thd, (yyvsp[-5].object_ddl_options) | (yyvsp[-1].object_ddl_options),
                                     DTYPE_ALGORITHM_UNDEFINED, (yyvsp[-3].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
          }
#line 26726 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 150: /* create: create_or_replace definer_opt opt_view_suid VIEW_SYM opt_if_not_exists table_ident $@18 view_list_opt AS view_select  */
#line 2372 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26734 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 151: /* $@19: %empty  */
#line 2377 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            if (Lex->add_create_view(thd, (yyvsp[-6].object_ddl_options) | (yyvsp[-1].object_ddl_options), (yyvsp[-5].num), (yyvsp[-3].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
            Lex->inc_select_stack_outer_barrier();
          }
#line 26746 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 152: /* create: create_or_replace view_algorithm definer_opt opt_view_suid VIEW_SYM opt_if_not_exists table_ident $@19 view_list_opt AS view_select  */
#line 2385 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26754 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 153: /* $@20: %empty  */
#line 2389 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->create_info.set((yyvsp[-2].object_ddl_options));
          }
#line 26764 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 154: /* create: create_or_replace definer_opt TRIGGER_SYM $@20 trigger_tail  */
#line 2395 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26772 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 155: /* $@21: %empty  */
#line 2399 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_procedure_start((yyvsp[-3].object_ddl_options) | (yyvsp[0].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 26781 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 156: /* create: create_or_replace definer_opt PROCEDURE_SYM opt_if_not_exists $@21 sp_tail_standalone  */
#line 2404 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->stmt_create_routine_finalize();
          }
#line 26789 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 157: /* $@22: %empty  */
#line 2408 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->create_info.set((yyvsp[-2].object_ddl_options));
          }
#line 26799 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 158: /* create: create_or_replace definer_opt EVENT_SYM $@22 event_tail  */
#line 2414 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26807 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 159: /* $@23: %empty  */
#line 2419 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_start((yyvsp[-6].object_ddl_options) | (yyvsp[-2].object_ddl_options), (yyvsp[-4].sp_aggregate_type), (yyvsp[-1].spname)))
              MYSQL_YYABORT;
          }
#line 26816 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 160: /* create: create_or_replace definer opt_aggregate FUNCTION_SYM opt_if_not_exists sp_name RETURN_ORACLE_SYM $@23 sf_return_type sf_c_chistics_and_body_standalone opt_sp_name  */
#line 2426 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_finalize_standalone((yyvsp[0].spname)))
              MYSQL_YYABORT;
          }
#line 26825 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 161: /* $@24: %empty  */
#line 2432 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_start((yyvsp[-6].object_ddl_options) | (yyvsp[-2].object_ddl_options), (yyvsp[-4].sp_aggregate_type), (yyvsp[-1].spname)))
              MYSQL_YYABORT;
          }
#line 26834 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 162: /* create: create_or_replace definer opt_aggregate FUNCTION_SYM opt_if_not_exists sp_name '(' $@24 sp_fdparam_list ')' RETURN_ORACLE_SYM sf_return_type sf_c_chistics_and_body_standalone opt_sp_name  */
#line 2440 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_finalize_standalone((yyvsp[0].spname)))
              MYSQL_YYABORT;
          }
#line 26843 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 163: /* $@25: %empty  */
#line 2446 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_start((yyvsp[-6].object_ddl_options) | (yyvsp[-2].object_ddl_options), (yyvsp[-4].sp_aggregate_type), (yyvsp[-1].spname)))
              MYSQL_YYABORT;
          }
#line 26852 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 164: /* create: create_or_replace no_definer opt_aggregate FUNCTION_SYM opt_if_not_exists sp_name RETURN_ORACLE_SYM $@25 sf_return_type sf_c_chistics_and_body_standalone opt_sp_name  */
#line 2453 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_finalize_standalone((yyvsp[0].spname)))
              MYSQL_YYABORT;
          }
#line 26861 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 165: /* $@26: %empty  */
#line 2459 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_start((yyvsp[-6].object_ddl_options) | (yyvsp[-2].object_ddl_options), (yyvsp[-4].sp_aggregate_type), (yyvsp[-1].spname)))
              MYSQL_YYABORT;
          }
#line 26870 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 166: /* create: create_or_replace no_definer opt_aggregate FUNCTION_SYM opt_if_not_exists sp_name '(' $@26 sp_fdparam_list ')' RETURN_ORACLE_SYM sf_return_type sf_c_chistics_and_body_standalone opt_sp_name  */
#line 2467 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_finalize_standalone((yyvsp[0].spname)))
              MYSQL_YYABORT;
          }
#line 26879 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 167: /* create: create_or_replace no_definer opt_aggregate FUNCTION_SYM opt_if_not_exists ident RETURNS_SYM udf_type SONAME_SYM TEXT_STRING_sys  */
#line 2473 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_udf_function((yyvsp[-9].object_ddl_options) | (yyvsp[-5].object_ddl_options), (yyvsp[-7].sp_aggregate_type), (yyvsp[-4].ident_sys),
                                              (Item_result) (yyvsp[-2].num), (yyvsp[0].lex_str)))
              MYSQL_YYABORT;
          }
#line 26889 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 168: /* create: create_or_replace USER_SYM opt_if_not_exists clear_privileges grant_list opt_require_clause opt_resource_options opt_account_locking_and_opt_password_expiration  */
#line 2480 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_command_with_check(SQLCOM_CREATE_USER,
                                                     (yyvsp[-7].object_ddl_options) | (yyvsp[-5].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 26899 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 169: /* create: create_or_replace ROLE_SYM opt_if_not_exists clear_privileges role_list opt_with_admin  */
#line 2487 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_command_with_check(SQLCOM_CREATE_ROLE,
                         (yyvsp[-5].object_ddl_options) | (yyvsp[-3].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 26909 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 170: /* create: CREATE LOGFILE_SYM GROUP_SYM logfile_group_info  */
#line 2493 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_tablespace_info->ts_cmd_type= CREATE_LOGFILE_GROUP;
          }
#line 26917 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 171: /* create: CREATE TABLESPACE tablespace_info  */
#line 2497 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_tablespace_info->ts_cmd_type= CREATE_TABLESPACE;
          }
#line 26925 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 172: /* $@27: %empty  */
#line 2500 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->set_command(SQLCOM_CREATE_SERVER, (yyvsp[0].object_ddl_options)); }
#line 26931 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 173: /* create: create_or_replace $@27 server_def  */
#line 2502 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 26937 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 174: /* $@28: %empty  */
#line 2507 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg;
            if (unlikely(!(pkg= Lex->
                           create_package_start(thd,
                                                SQLCOM_CREATE_PACKAGE,
                                                &sp_handler_package_spec,
                                                (yyvsp[-3].spname), (yyvsp[-7].object_ddl_options) | (yyvsp[-4].object_ddl_options)))))
              MYSQL_YYABORT;
            pkg->set_c_chistics(Lex->sp_chistics);
          }
#line 26952 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 175: /* create: create_or_replace definer_opt PACKAGE_ORACLE_SYM opt_if_not_exists sp_name opt_create_package_chistics_init sp_tail_is remember_name $@28 opt_package_specification_element_list END remember_end_opt opt_sp_name  */
#line 2519 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_package_finalize(thd, (yyvsp[-8].spname), (yyvsp[0].spname), (yyvsp[-5].simple_string), (yyvsp[-1].simple_string))))
              MYSQL_YYABORT;
          }
#line 26961 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 176: /* $@29: %empty  */
#line 2527 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg;
            if (unlikely(!(pkg= Lex->
                           create_package_start(thd,
                                                SQLCOM_CREATE_PACKAGE_BODY,
                                                &sp_handler_package_body,
                                                (yyvsp[-3].spname), (yyvsp[-8].object_ddl_options) | (yyvsp[-4].object_ddl_options)))))
              MYSQL_YYABORT;
            pkg->set_c_chistics(Lex->sp_chistics);
            Lex->sp_block_init(thd);
          }
#line 26977 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 177: /* $@30: %empty  */
#line 2539 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_finalize_declarations(thd)))
              MYSQL_YYABORT;
          }
#line 26986 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 178: /* $@31: %empty  */
#line 2544 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-2].spblock).hndlrs+= (yyvsp[0].spblock_handlers).hndlrs;
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-2].spblock))))
              MYSQL_YYABORT;
          }
#line 26996 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 179: /* create: create_or_replace definer_opt PACKAGE_ORACLE_SYM BODY_ORACLE_SYM opt_if_not_exists sp_name opt_create_package_chistics_init sp_tail_is remember_name $@29 package_implementation_declare_section $@30 package_implementation_executable_section $@31 remember_end_opt opt_sp_name  */
#line 2550 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_package_finalize(thd, (yyvsp[-10].spname), (yyvsp[0].spname), (yyvsp[-7].simple_string), (yyvsp[-1].simple_string))))
              MYSQL_YYABORT;
          }
#line 27005 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 180: /* package_implementation_executable_section: END  */
#line 2558 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_add_empty(thd)))
              MYSQL_YYABORT;
            (yyval.spblock_handlers).init(0);
          }
#line 27015 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 181: /* package_implementation_executable_section: BEGIN_ORACLE_SYM sp_block_statements_and_exceptions END  */
#line 2563 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                                  { (yyval.spblock_handlers)= (yyvsp[-1].spblock_handlers); }
#line 27021 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 184: /* package_implementation_declare_section: package_implementation_declare_section_list1 package_implementation_declare_section_list2  */
#line 2575 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.spblock).join((yyvsp[-1].spblock), (yyvsp[0].spblock)); }
#line 27027 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 186: /* package_implementation_declare_section_list1: package_implementation_declare_section_list1 package_implementation_item_declaration  */
#line 2582 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.spblock).join((yyvsp[-1].spblock), (yyvsp[0].spblock)); }
#line 27033 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 188: /* package_implementation_declare_section_list2: package_implementation_declare_section_list2 package_implementation_routine_definition  */
#line 2589 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.spblock).join((yyvsp[-1].spblock), (yyvsp[0].spblock)); }
#line 27039 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 189: /* package_routine_lex: %empty  */
#line 2593 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.lex)= new (thd->mem_root)
                           sp_lex_local(thd, thd->lex))))
              MYSQL_YYABORT;
            thd->m_parser_state->m_yacc.reset_before_substatement();
          }
#line 27050 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 190: /* $@32: %empty  */
#line 2604 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT((yyvsp[-2].lex)->sphead->get_package());
            (yyvsp[-1].lex)->sql_command= SQLCOM_CREATE_FUNCTION;
            sp_name *spname= (yyvsp[-2].lex)->make_sp_name_package_routine(thd, &(yyvsp[0].ident_sys));
            if (unlikely(!spname))
              MYSQL_YYABORT;
            thd->lex= (yyvsp[-1].lex);
            if (unlikely(!(yyvsp[-1].lex)->make_sp_head_no_recursive(thd, spname,
                                                        &sp_handler_package_function,
                                                        NOT_AGGREGATE)))
              MYSQL_YYABORT;
            (yyvsp[-2].lex)->sphead->get_package()->m_current_routine= (yyvsp[-1].lex);
            (void) is_native_function_with_warn(thd, &(yyvsp[0].ident_sys));
          }
#line 27069 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 191: /* package_specification_function: remember_lex package_routine_lex ident $@32 opt_sp_parenthesized_fdparam_list RETURN_ORACLE_SYM sf_return_type sp_c_chistics  */
#line 2621 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_head *sp= thd->lex->sphead;
            sp->restore_thd_mem_root(thd);
            thd->lex= (yyvsp[-7].lex);
            (yyval.lex)= (yyvsp[-6].lex);
          }
#line 27080 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 192: /* $@33: %empty  */
#line 2631 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT((yyvsp[-2].lex)->sphead->get_package());
            (yyvsp[-1].lex)->sql_command= SQLCOM_CREATE_PROCEDURE;
            sp_name *spname= (yyvsp[-2].lex)->make_sp_name_package_routine(thd, &(yyvsp[0].ident_sys));
            if (unlikely(!spname))
              MYSQL_YYABORT;
            thd->lex= (yyvsp[-1].lex);
            if (unlikely(!(yyvsp[-1].lex)->make_sp_head_no_recursive(thd, spname,
                                                        &sp_handler_package_procedure,
                                                        DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;
            (yyvsp[-2].lex)->sphead->get_package()->m_current_routine= (yyvsp[-1].lex);
          }
#line 27098 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 193: /* package_specification_procedure: remember_lex package_routine_lex ident $@33 opt_sp_parenthesized_pdparam_list sp_c_chistics  */
#line 2646 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_head *sp= thd->lex->sphead;
            sp->restore_thd_mem_root(thd);
            thd->lex= (yyvsp[-5].lex);
            (yyval.lex)= (yyvsp[-4].lex);

          }
#line 27110 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 194: /* package_implementation_routine_definition: FUNCTION_SYM package_specification_function package_implementation_function_body ';'  */
#line 2659 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg= Lex->get_sp_package();
            if (unlikely(pkg->add_routine_implementation((yyvsp[-2].lex))))
              MYSQL_YYABORT;
            pkg->m_current_routine= NULL;
            (yyval.spblock).init();
          }
#line 27122 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 195: /* package_implementation_routine_definition: PROCEDURE_SYM package_specification_procedure package_implementation_procedure_body ';'  */
#line 2668 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg= Lex->get_sp_package();
            if (unlikely(pkg->add_routine_implementation((yyvsp[-2].lex))))
              MYSQL_YYABORT;
            pkg->m_current_routine= NULL;
            (yyval.spblock).init();
          }
#line 27134 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 196: /* package_implementation_routine_definition: package_specification_element  */
#line 2675 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                        { (yyval.spblock).init(); }
#line 27140 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 197: /* $@34: %empty  */
#line 2681 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg= Lex->get_sp_package();
            sp_head *sp= pkg->m_current_routine->sphead;
            thd->lex= pkg->m_current_routine;
            sp->reset_thd_mem_root(thd);
            sp->set_body_start(thd, YYLIP->get_cpp_tok_start());
          }
#line 27152 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 198: /* package_implementation_function_body: sp_tail_is remember_lex $@34 sp_body opt_package_routine_end_name  */
#line 2689 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(thd->lex->sp_body_finalize_function(thd) ||
                         thd->lex->sphead->check_package_routine_end_name((yyvsp[0].lex_str))))
              MYSQL_YYABORT;
            thd->lex= (yyvsp[-3].lex);
          }
#line 27163 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 199: /* $@35: %empty  */
#line 2699 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg= Lex->get_sp_package();
            sp_head *sp= pkg->m_current_routine->sphead;
            thd->lex= pkg->m_current_routine;
            sp->reset_thd_mem_root(thd);
            sp->set_body_start(thd, YYLIP->get_cpp_tok_start());
          }
#line 27175 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 200: /* package_implementation_procedure_body: sp_tail_is remember_lex $@35 sp_body opt_package_routine_end_name  */
#line 2707 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(thd->lex->sp_body_finalize_procedure(thd) ||
                         thd->lex->sphead->check_package_routine_end_name((yyvsp[0].lex_str))))
              MYSQL_YYABORT;
            thd->lex= (yyvsp[-3].lex);
          }
#line 27186 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 206: /* package_specification_element: FUNCTION_SYM package_specification_function ';'  */
#line 2732 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg= Lex->get_sp_package();
            if (unlikely(pkg->add_routine_declaration((yyvsp[-1].lex))))
              MYSQL_YYABORT;
            pkg->m_current_routine= NULL;
          }
#line 27197 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 207: /* package_specification_element: PROCEDURE_SYM package_specification_procedure ';'  */
#line 2739 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg= Lex->get_sp_package();
            if (unlikely(pkg->add_routine_declaration((yyvsp[-1].lex))))
              MYSQL_YYABORT;
            pkg->m_current_routine= NULL;
          }
#line 27208 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 208: /* opt_sequence: %empty  */
#line 2749 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { }
#line 27214 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 212: /* sequence_def: MINVALUE_SYM opt_equal longlong_num  */
#line 2760 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.seq_create_info->min_value= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_min_value;
          }
#line 27223 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 213: /* sequence_def: NO_SYM MINVALUE_SYM  */
#line 2765 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_min_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MINVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_min_value;
          }
#line 27233 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 214: /* sequence_def: NOMINVALUE_SYM  */
#line 2771 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_min_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MINVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_min_value;
          }
#line 27243 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 215: /* sequence_def: MAXVALUE_SYM opt_equal longlong_num  */
#line 2777 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
           if (unlikely(Lex->create_info.seq_create_info->used_fields &
               seq_field_used_max_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MAXVALUE"));
            Lex->create_info.seq_create_info->max_value= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_max_value;
          }
#line 27255 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 216: /* sequence_def: NO_SYM MAXVALUE_SYM  */
#line 2785 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_max_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MAXVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_max_value;
          }
#line 27265 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 217: /* sequence_def: NOMAXVALUE_SYM  */
#line 2791 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_max_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MAXVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_max_value;
          }
#line 27275 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 218: /* sequence_def: START_SYM opt_with longlong_num  */
#line 2797 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                         seq_field_used_start))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "START"));
            Lex->create_info.seq_create_info->start= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_start;
          }
#line 27287 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 219: /* sequence_def: INCREMENT_SYM opt_by longlong_num  */
#line 2805 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_increment))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "INCREMENT"));
            Lex->create_info.seq_create_info->increment= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_increment;
          }
#line 27299 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 220: /* sequence_def: CACHE_SYM opt_equal longlong_num  */
#line 2813 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cache))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CACHE"));
            Lex->create_info.seq_create_info->cache= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cache;
          }
#line 27311 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 221: /* sequence_def: NOCACHE_SYM  */
#line 2821 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cache))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CACHE"));
            Lex->create_info.seq_create_info->cache= 0;
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cache;
          }
#line 27323 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 222: /* sequence_def: CYCLE_SYM  */
#line 2829 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cycle))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CYCLE"));
            Lex->create_info.seq_create_info->cycle= 1;
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cycle;
          }
#line 27335 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 223: /* sequence_def: NOCYCLE_SYM  */
#line 2837 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cycle))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CYCLE"));
            Lex->create_info.seq_create_info->cycle= 0;
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cycle;
          }
#line 27347 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 224: /* sequence_def: RESTART_SYM  */
#line 2845 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sql_command != SQLCOM_ALTER_SEQUENCE))
            {
              thd->parse_error(ER_SYNTAX_ERROR, "RESTART");
              YYABORT;
            }
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                         seq_field_used_restart))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "RESTART"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_restart;
          }
#line 27363 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 225: /* sequence_def: RESTART_SYM opt_with longlong_num  */
#line 2857 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sql_command != SQLCOM_ALTER_SEQUENCE))
            {
              thd->parse_error(ER_SYNTAX_ERROR, "RESTART");
              YYABORT;
            }
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                         seq_field_used_restart))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "RESTART"));
            Lex->create_info.seq_create_info->restart= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_restart | seq_field_used_restart_value;
          }
#line 27380 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 226: /* force_lookahead: %empty  */
#line 2872 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 {}
#line 27386 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 227: /* force_lookahead: FORCE_LOOKAHEAD  */
#line 2872 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      {}
#line 27392 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 228: /* $@36: %empty  */
#line 2876 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_create_options_with_check((yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
            Lex->server_options.reset((yyvsp[0].lex_str));
          }
#line 27402 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 229: /* server_def: SERVER_SYM opt_if_not_exists ident_or_text $@36 FOREIGN DATA_SYM WRAPPER_SYM ident_or_text OPTIONS_SYM '(' server_options_list ')'  */
#line 2883 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->server_options.scheme= (yyvsp[-4].lex_str); }
#line 27408 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 232: /* server_option: USER_SYM TEXT_STRING_sys  */
#line 2893 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.username.str == 0);
            Lex->server_options.username= (yyvsp[0].lex_str);
          }
#line 27417 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 233: /* server_option: HOST_SYM TEXT_STRING_sys  */
#line 2898 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.host.str == 0);
            Lex->server_options.host= (yyvsp[0].lex_str);
          }
#line 27426 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 234: /* server_option: DATABASE TEXT_STRING_sys  */
#line 2903 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.db.str == 0);
            Lex->server_options.db= (yyvsp[0].lex_str);
          }
#line 27435 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 235: /* server_option: OWNER_SYM TEXT_STRING_sys  */
#line 2908 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.owner.str == 0);
            Lex->server_options.owner= (yyvsp[0].lex_str);
          }
#line 27444 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 236: /* server_option: PASSWORD_SYM TEXT_STRING_sys  */
#line 2913 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.password.str == 0);
            Lex->server_options.password= (yyvsp[0].lex_str);
          }
#line 27453 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 237: /* server_option: SOCKET_SYM TEXT_STRING_sys  */
#line 2918 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.socket.str == 0);
            Lex->server_options.socket= (yyvsp[0].lex_str);
          }
#line 27462 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 238: /* server_option: PORT_SYM ulong_num  */
#line 2923 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->server_options.port= (yyvsp[0].ulong_num);
          }
#line 27470 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 239: /* $@37: %empty  */
#line 2930 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;

            lex->stmt_definition_begin= (yyvsp[-2].simple_string);
            if (unlikely(lex->add_create_options_with_check((yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
            if (unlikely(!(lex->event_parse_data=
                           Event_parse_data::new_instance(thd))))
              MYSQL_YYABORT;
            lex->event_parse_data->identifier= (yyvsp[0].spname);
            lex->event_parse_data->on_completion=
                                  Event_parse_data::ON_COMPLETION_DROP;

            lex->sql_command= SQLCOM_CREATE_EVENT;
            /* We need that for disallowing subqueries */
          }
#line 27491 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 240: /* event_tail: remember_name opt_if_not_exists sp_name $@37 ON SCHEDULE_SYM ev_schedule_time opt_ev_on_completion opt_ev_status opt_ev_comment DO_SYM ev_sql_stmt  */
#line 2951 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              sql_command is set here because some rules in ev_sql_stmt
              can overwrite it
            */
            Lex->sql_command= SQLCOM_CREATE_EVENT;
          }
#line 27503 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 241: /* $@38: %empty  */
#line 2962 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->item_expression= (yyvsp[-1].item);
            Lex->event_parse_data->interval= (yyvsp[0].interval);
          }
#line 27512 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 243: /* ev_schedule_time: AT_SYM expr  */
#line 2969 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->item_execute_at= (yyvsp[0].item);
          }
#line 27520 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 244: /* opt_ev_status: %empty  */
#line 2975 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0; }
#line 27526 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 245: /* opt_ev_status: ENABLE_SYM  */
#line 2977 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->status= Event_parse_data::ENABLED;
            Lex->event_parse_data->status_changed= true;
            (yyval.num)= 1;
          }
#line 27536 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 246: /* opt_ev_status: DISABLE_SYM ON SLAVE  */
#line 2983 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->status= Event_parse_data::SLAVESIDE_DISABLED;
            Lex->event_parse_data->status_changed= true; 
            (yyval.num)= 1;
          }
#line 27546 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 247: /* opt_ev_status: DISABLE_SYM  */
#line 2989 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->status= Event_parse_data::DISABLED;
            Lex->event_parse_data->status_changed= true;
            (yyval.num)= 1;
          }
#line 27556 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 248: /* ev_starts: %empty  */
#line 2998 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_func_now_local(thd, 0);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            Lex->event_parse_data->item_starts= item;
          }
#line 27567 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 249: /* ev_starts: STARTS_SYM expr  */
#line 3005 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->item_starts= (yyvsp[0].item);
          }
#line 27575 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 251: /* ev_ends: ENDS_SYM expr  */
#line 3013 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->item_ends= (yyvsp[0].item);
          }
#line 27583 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 252: /* opt_ev_on_completion: %empty  */
#line 3019 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0; }
#line 27589 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 254: /* ev_on_completion: ON COMPLETION_SYM opt_not PRESERVE_SYM  */
#line 3025 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->on_completion= (yyvsp[-1].num)
                                    ? Event_parse_data::ON_COMPLETION_DROP
                                    : Event_parse_data::ON_COMPLETION_PRESERVE;
            (yyval.num)= 1;
          }
#line 27600 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 255: /* opt_ev_comment: %empty  */
#line 3034 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0; }
#line 27606 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 256: /* opt_ev_comment: COMMENT_SYM TEXT_STRING_sys  */
#line 3036 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->comment= Lex->event_parse_data->comment= (yyvsp[0].lex_str);
            (yyval.num)= 1;
          }
#line 27615 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 257: /* $@39: %empty  */
#line 3043 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            Lex_input_stream *lip= YYLIP;

            /*
              This stops the following :
              - CREATE EVENT ... DO CREATE EVENT ...;
              - ALTER  EVENT ... DO CREATE EVENT ...;
              - CREATE EVENT ... DO ALTER EVENT DO ....;
              - CREATE PROCEDURE ... BEGIN CREATE EVENT ... END|
              This allows:
              - CREATE EVENT ... DO DROP EVENT yyy;
              - CREATE EVENT ... DO ALTER EVENT yyy;
                (the nested ALTER EVENT can have anything but DO clause)
              - ALTER  EVENT ... DO ALTER EVENT yyy;
                (the nested ALTER EVENT can have anything but DO clause)
              - ALTER  EVENT ... DO DROP EVENT yyy;
              - CREATE PROCEDURE ... BEGIN ALTER EVENT ... END|
                (the nested ALTER EVENT can have anything but DO clause)
              - CREATE PROCEDURE ... BEGIN DROP EVENT ... END|
            */
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_EVENT_RECURSION_FORBIDDEN, MYF(0)));
              
            if (unlikely(!lex->make_sp_head(thd,
                                            lex->event_parse_data->identifier,
                                            &sp_handler_procedure,
                                            DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;

            lex->sphead->set_body_start(thd, lip->get_cpp_ptr());
          }
#line 27652 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 258: /* ev_sql_stmt: $@39 sp_proc_stmt force_lookahead  */
#line 3076 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* return back to the original memory root ASAP */
            if (Lex->sp_body_finalize_event(thd))
              MYSQL_YYABORT;
          }
#line 27662 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 259: /* clear_privileges: %empty  */
#line 3085 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
           LEX *lex=Lex;
           lex->users_list.empty();
           lex->columns.empty();
           lex->grant= lex->grant_tot_col= 0;
           lex->all_privileges= 0;
           lex->first_select_lex()->db= null_clex_str;
           lex->account_options.reset();
         }
#line 27676 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 260: /* opt_aggregate: %empty  */
#line 3097 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.sp_aggregate_type)= NOT_AGGREGATE; }
#line 27682 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 261: /* opt_aggregate: AGGREGATE_SYM  */
#line 3098 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.sp_aggregate_type)= GROUP_AGGREGATE; }
#line 27688 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 262: /* sp_name: ident '.' ident  */
#line 3103 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.spname)= Lex->make_sp_name(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 27697 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 263: /* sp_name: ident  */
#line 3108 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.spname)= Lex->make_sp_name(thd, &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 27706 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 264: /* opt_sp_name: %empty  */
#line 3115 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.spname)= NULL; }
#line 27712 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 265: /* opt_sp_name: sp_name  */
#line 3116 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.spname)= (yyvsp[0].spname); }
#line 27718 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 266: /* sp_a_chistics: %empty  */
#line 3120 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 27724 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 267: /* sp_a_chistics: sp_a_chistics sp_chistic  */
#line 3121 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   {}
#line 27730 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 268: /* sp_c_chistics: %empty  */
#line 3125 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 27736 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 269: /* sp_c_chistics: sp_c_chistics sp_c_chistic  */
#line 3126 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                     {}
#line 27742 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 270: /* sp_chistic: COMMENT_SYM TEXT_STRING_sys  */
#line 3132 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.comment= (yyvsp[0].lex_str); }
#line 27748 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 271: /* sp_chistic: LANGUAGE_SYM SQL_SYM  */
#line 3134 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* Just parse it, we only have one language for now. */ }
#line 27754 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 272: /* sp_chistic: NO_SYM SQL_SYM  */
#line 3136 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.daccess= SP_NO_SQL; }
#line 27760 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 273: /* sp_chistic: CONTAINS_SYM SQL_SYM  */
#line 3138 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.daccess= SP_CONTAINS_SQL; }
#line 27766 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 274: /* sp_chistic: READS_SYM SQL_SYM DATA_SYM  */
#line 3140 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.daccess= SP_READS_SQL_DATA; }
#line 27772 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 275: /* sp_chistic: MODIFIES_SYM SQL_SYM DATA_SYM  */
#line 3142 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.daccess= SP_MODIFIES_SQL_DATA; }
#line 27778 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 276: /* sp_chistic: sp_suid  */
#line 3144 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.suid= (yyvsp[0].sp_suid); }
#line 27784 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 277: /* create_package_chistic: COMMENT_SYM TEXT_STRING_sys  */
#line 3149 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.comment= (yyvsp[0].lex_str); }
#line 27790 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 278: /* create_package_chistic: sp_suid  */
#line 3151 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.suid= (yyvsp[0].sp_suid); }
#line 27796 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 279: /* create_package_chistics: create_package_chistic  */
#line 3155 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 {}
#line 27802 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 280: /* create_package_chistics: create_package_chistics create_package_chistic  */
#line 3156 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                         { }
#line 27808 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 282: /* opt_create_package_chistics: create_package_chistics  */
#line 3161 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { }
#line 27814 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 283: /* $@40: %empty  */
#line 3165 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.init(); }
#line 27820 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 285: /* sp_c_chistic: sp_chistic  */
#line 3171 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { }
#line 27826 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 286: /* sp_c_chistic: opt_not DETERMINISTIC_SYM  */
#line 3172 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                    { Lex->sp_chistics.detistic= ! (yyvsp[-1].num); }
#line 27832 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 287: /* sp_suid: SQL_SYM SECURITY_SYM DEFINER_SYM  */
#line 3176 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.sp_suid)= SP_IS_SUID; }
#line 27838 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 288: /* sp_suid: SQL_SYM SECURITY_SYM INVOKER_SYM  */
#line 3177 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.sp_suid)= SP_IS_NOT_SUID; }
#line 27844 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 289: /* $@41: %empty  */
#line 3182 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 27853 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 290: /* call: CALL_SYM ident $@41 opt_sp_cparam_list  */
#line 3187 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 27862 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 291: /* $@42: %empty  */
#line 3192 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 27871 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 292: /* call: CALL_SYM ident '.' ident $@42 opt_sp_cparam_list  */
#line 3197 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 27880 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 293: /* $@43: %empty  */
#line 3202 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys), (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 27889 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 294: /* call: CALL_SYM ident '.' ident '.' ident $@43 opt_sp_cparam_list  */
#line 3207 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 27898 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 299: /* sp_cparams: sp_cparams ',' expr  */
#line 3226 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
           Lex->value_list.push_back((yyvsp[0].item), thd->mem_root);
          }
#line 27906 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 300: /* sp_cparams: expr  */
#line 3230 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->value_list.push_back((yyvsp[0].item), thd->mem_root);
          }
#line 27914 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 301: /* sp_fdparam_list: %empty  */
#line 3238 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->m_param_begin= YYLIP->get_cpp_tok_start();
            Lex->sphead->m_param_end= Lex->sphead->m_param_begin;
          }
#line 27923 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 302: /* $@44: %empty  */
#line 3243 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->m_param_begin= YYLIP->get_cpp_tok_start();
          }
#line 27931 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 303: /* sp_fdparam_list: $@44 sp_fdparams  */
#line 3247 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->m_param_end= YYLIP->get_cpp_tok_start();
          }
#line 27939 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 306: /* sp_param_name: ident  */
#line 3259 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.spvar)= Lex->sp_param_init(&(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 27948 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 307: /* sp_param_name_and_type: sp_param_name sp_param_type  */
#line 3267 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_param_fill_definition((yyval.spvar)= (yyvsp[-1].spvar))))
              MYSQL_YYABORT;
          }
#line 27957 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 308: /* sp_param_name_and_type: sp_param_name sp_decl_ident '.' ident PERCENT_ORACLE_SYM TYPE_SYM  */
#line 3272 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_type_reference(thd, (yyval.spvar)= (yyvsp[-5].spvar), (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 27966 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 309: /* sp_param_name_and_type: sp_param_name sp_decl_ident '.' ident '.' ident PERCENT_ORACLE_SYM TYPE_SYM  */
#line 3277 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_type_reference(thd, (yyval.spvar)= (yyvsp[-7].spvar), (yyvsp[-6].ident_sys), (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 27975 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 310: /* sp_param_name_and_type: sp_param_name sp_decl_ident PERCENT_ORACLE_SYM ROWTYPE_ORACLE_SYM  */
#line 3282 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_table_rowtype_reference(thd, (yyval.spvar)= (yyvsp[-3].spvar), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 27984 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 311: /* sp_param_name_and_type: sp_param_name sp_decl_ident '.' ident PERCENT_ORACLE_SYM ROWTYPE_ORACLE_SYM  */
#line 3287 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_table_rowtype_reference(thd, (yyval.spvar)= (yyvsp[-5].spvar), (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 27993 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 312: /* sp_param_name_and_type: sp_param_name ROW_SYM row_type_body  */
#line 3292 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_row(thd, (yyval.spvar)= (yyvsp[-2].spvar), (yyvsp[0].spvar_definition_list))))
              MYSQL_YYABORT;
          }
#line 28002 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 317: /* sp_pdparam: sp_param_name sp_opt_inout sp_param_type  */
#line 3311 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-2].spvar)->mode= (yyvsp[-1].spvar_mode);
            if (unlikely(Lex->sp_param_fill_definition((yyvsp[-2].spvar))))
              MYSQL_YYABORT;
          }
#line 28012 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 318: /* sp_pdparam: sp_param_name sp_opt_inout sp_decl_ident '.' ident PERCENT_ORACLE_SYM TYPE_SYM  */
#line 3317 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-6].spvar)->mode= (yyvsp[-5].spvar_mode);
            if (unlikely(Lex->sphead->spvar_fill_type_reference(thd, (yyvsp[-6].spvar), (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28022 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 319: /* sp_pdparam: sp_param_name sp_opt_inout sp_decl_ident '.' ident '.' ident PERCENT_ORACLE_SYM TYPE_SYM  */
#line 3323 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-8].spvar)->mode= (yyvsp[-7].spvar_mode);
            if (unlikely(Lex->sphead->spvar_fill_type_reference(thd, (yyvsp[-8].spvar), (yyvsp[-6].ident_sys), (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28032 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 320: /* sp_pdparam: sp_param_name sp_opt_inout sp_decl_ident PERCENT_ORACLE_SYM ROWTYPE_ORACLE_SYM  */
#line 3329 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-4].spvar)->mode= (yyvsp[-3].spvar_mode);
            if (unlikely(Lex->sphead->spvar_fill_table_rowtype_reference(thd, (yyvsp[-4].spvar), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28042 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 321: /* sp_pdparam: sp_param_name sp_opt_inout sp_decl_ident '.' ident PERCENT_ORACLE_SYM ROWTYPE_ORACLE_SYM  */
#line 3335 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-6].spvar)->mode= (yyvsp[-5].spvar_mode);
            if (unlikely(Lex->sphead->spvar_fill_table_rowtype_reference(thd, (yyvsp[-6].spvar), (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28052 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 322: /* sp_pdparam: sp_param_name sp_opt_inout ROW_SYM row_type_body  */
#line 3341 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-3].spvar)->mode= (yyvsp[-2].spvar_mode);
            if (unlikely(Lex->sphead->spvar_fill_row(thd, (yyvsp[-3].spvar), (yyvsp[0].spvar_definition_list))))
              MYSQL_YYABORT;
          }
#line 28062 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 323: /* sp_opt_inout: %empty  */
#line 3349 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_IN; }
#line 28068 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 324: /* sp_opt_inout: IN_SYM  */
#line 3350 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_IN; }
#line 28074 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 325: /* sp_opt_inout: OUT_SYM  */
#line 3351 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_OUT; }
#line 28080 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 326: /* sp_opt_inout: INOUT_SYM  */
#line 3352 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_INOUT; }
#line 28086 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 327: /* sp_opt_inout: IN_SYM OUT_SYM  */
#line 3353 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.spvar_mode)= sp_variable::MODE_INOUT; }
#line 28092 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 328: /* $@45: %empty  */
#line 3358 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->m_param_begin= YYLIP->get_cpp_tok_start() + 1;
          }
#line 28100 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 329: /* sp_parenthesized_pdparam_list: '(' $@45 sp_pdparam_list ')'  */
#line 3363 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->m_param_end= YYLIP->get_cpp_tok_start();
          }
#line 28108 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 330: /* sp_no_param: %empty  */
#line 3370 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->m_param_begin= Lex->sphead->m_param_end=
              YYLIP->get_cpp_tok_start() + 1;
          }
#line 28117 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 335: /* sp_proc_stmts: %empty  */
#line 3387 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 28123 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 337: /* sp_proc_stmts1: sp_proc_stmt ';'  */
#line 3392 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           {}
#line 28129 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 339: /* $@46: %empty  */
#line 3397 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_block_init(thd);
          }
#line 28137 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 340: /* sp_proc_stmts1_implicit_block: $@46 sp_proc_stmts1  */
#line 3401 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_finalize(thd)))
              MYSQL_YYABORT;
          }
#line 28146 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 341: /* opt_sp_decl_body_list: %empty  */
#line 3409 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spblock).init();
          }
#line 28154 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 342: /* opt_sp_decl_body_list: sp_decl_body_list  */
#line 3412 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { (yyval.spblock)= (yyvsp[0].spblock); }
#line 28160 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 343: /* $@47: %empty  */
#line 3417 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->sp_add_instr_cpush_for_cursors(thd, Lex->spcont)))
              MYSQL_YYABORT;
          }
#line 28169 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 344: /* sp_decl_body_list: sp_decl_non_handler_list $@47 opt_sp_decl_handler_list  */
#line 3422 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spblock).join((yyvsp[-2].spblock), (yyvsp[0].spblock));
          }
#line 28177 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 346: /* sp_decl_non_handler_list: sp_decl_non_handler ';'  */
#line 3429 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.spblock)= (yyvsp[-1].spblock); }
#line 28183 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 347: /* sp_decl_non_handler_list: sp_decl_non_handler_list sp_decl_non_handler ';'  */
#line 3431 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spblock).join((yyvsp[-2].spblock), (yyvsp[-1].spblock));
          }
#line 28191 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 348: /* sp_decl_handler_list: sp_decl_handler ';'  */
#line 3437 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.spblock)= (yyvsp[-1].spblock); }
#line 28197 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 349: /* sp_decl_handler_list: sp_decl_handler_list sp_decl_handler ';'  */
#line 3439 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spblock).join((yyvsp[-2].spblock), (yyvsp[-1].spblock));
          }
#line 28205 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 350: /* opt_sp_decl_handler_list: %empty  */
#line 3445 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.spblock).init(); }
#line 28211 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 352: /* optionally_qualified_column_ident: sp_decl_ident  */
#line 3451 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.qualified_column_ident)= new (thd->mem_root)
                         Qualified_column_ident(&(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 28221 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 353: /* optionally_qualified_column_ident: sp_decl_ident '.' ident  */
#line 3457 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.qualified_column_ident)= new (thd->mem_root)
                           Qualified_column_ident(&(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 28231 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 354: /* optionally_qualified_column_ident: sp_decl_ident '.' ident '.' ident  */
#line 3463 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.qualified_column_ident)= new (thd->mem_root)
                           Qualified_column_ident(thd, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 28241 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 355: /* row_field_name: ident_directly_assignable  */
#line 3472 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.spvar_definition)= Lex->row_field_name(thd, (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28250 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 357: /* row_field_definition_list: row_field_definition  */
#line 3484 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.spvar_definition_list)= Row_definition_list::make(thd->mem_root, (yyvsp[0].spvar_definition))))
              MYSQL_YYABORT;
          }
#line 28259 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 358: /* row_field_definition_list: row_field_definition_list ',' row_field_definition  */
#line 3489 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (((yyval.spvar_definition_list)= (yyvsp[-2].spvar_definition_list))->append_uniq(thd->mem_root, (yyvsp[0].spvar_definition)))
              MYSQL_YYABORT;
          }
#line 28268 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 359: /* row_type_body: '(' row_field_definition_list ')'  */
#line 3496 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                            { (yyval.spvar_definition_list)= (yyvsp[-1].spvar_definition_list); }
#line 28274 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 360: /* sp_decl_idents_init_vars: sp_decl_idents  */
#line 3501 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_variable_declarations_init(thd, (yyvsp[0].num));
          }
#line 28282 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 361: /* sp_decl_vars: sp_decl_idents_init_vars field_type sp_opt_default  */
#line 3510 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_finalize(thd, (yyvsp[-2].num),
                                                                &Lex->last_field[0],
                                                                (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-2].num));
          }
#line 28294 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 362: /* sp_decl_vars: sp_decl_idents_init_vars optionally_qualified_column_ident PERCENT_ORACLE_SYM TYPE_SYM sp_opt_default  */
#line 3520 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_with_ref_finalize(thd, (yyvsp[-4].num), (yyvsp[-3].qualified_column_ident), (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-4].num));
          }
#line 28304 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 363: /* sp_decl_vars: sp_decl_idents_init_vars optionally_qualified_column_ident PERCENT_ORACLE_SYM ROWTYPE_ORACLE_SYM sp_opt_default  */
#line 3528 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_rowtype_finalize(thd, (yyvsp[-4].num), (yyvsp[-3].qualified_column_ident), (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-4].num));
          }
#line 28314 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 364: /* sp_decl_vars: sp_decl_idents_init_vars ROW_SYM row_type_body sp_opt_default  */
#line 3536 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_row_finalize(thd, (yyvsp[-3].num), (yyvsp[-1].spvar_definition_list), (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-3].num));
          }
#line 28324 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 366: /* sp_decl_non_handler: ident_directly_assignable CONDITION_SYM FOR_SYM sp_cond  */
#line 3546 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->spcont->declare_condition(thd, &(yyvsp[-3].ident_sys), (yyvsp[0].spcondvalue))))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).hndlrs= (yyval.spblock).curs= 0;
            (yyval.spblock).conds= 1;
          }
#line 28335 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 367: /* sp_decl_non_handler: ident_directly_assignable EXCEPTION_ORACLE_SYM  */
#line 3553 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_condition_value *spcond= new (thd->mem_root)
                                        sp_condition_value_user_defined();
            if (unlikely(!spcond) ||
                unlikely(Lex->spcont->declare_condition(thd, &(yyvsp[-1].ident_sys), spcond)))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).hndlrs= (yyval.spblock).curs= 0;
            (yyval.spblock).conds= 1;
          }
#line 28349 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 368: /* $@48: %empty  */
#line 3563 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_block_init(thd);
          }
#line 28357 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 369: /* sp_decl_non_handler: CURSOR_SYM ident_directly_assignable $@48 opt_parenthesized_cursor_formal_parameters IS sp_cursor_stmt  */
#line 3568 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_pcontext *param_ctx= Lex->spcont;
            if (unlikely(Lex->sp_block_finalize(thd)))
              MYSQL_YYABORT;
            if (unlikely(Lex->sp_declare_cursor(thd, &(yyvsp[-4].ident_sys), (yyvsp[0].sp_cursor_stmt), param_ctx, false)))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).conds= (yyval.spblock).hndlrs= 0;
            (yyval.spblock).curs= 1;
          }
#line 28371 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 370: /* $@49: %empty  */
#line 3581 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_handler_declaration_init(thd, (yyvsp[-2].num))))
              MYSQL_YYABORT;
          }
#line 28380 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 371: /* sp_decl_handler: sp_handler_type HANDLER_SYM FOR_SYM $@49 sp_hcond_list sp_proc_stmt  */
#line 3586 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_handler_declaration_finalize(thd, (yyvsp[-5].num))))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).conds= (yyval.spblock).curs= 0;
            (yyval.spblock).hndlrs= 1;
          }
#line 28391 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 374: /* sp_cursor_stmt_lex: %empty  */
#line 3601 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(thd->lex->sphead);
            if (unlikely(!((yyval.sp_cursor_stmt)= new (thd->mem_root)
                           sp_lex_cursor(thd, thd->lex))))
              MYSQL_YYABORT;
          }
#line 28402 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 375: /* $@50: %empty  */
#line 3611 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(thd->free_list == NULL);
            Lex->sphead->reset_lex(thd, (yyvsp[0].sp_cursor_stmt));
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 28413 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 376: /* sp_cursor_stmt: sp_cursor_stmt_lex $@50 select  */
#line 3618 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex == (yyvsp[-2].sp_cursor_stmt));
            Lex->pop_select(); //main select
            if (unlikely((yyvsp[-2].sp_cursor_stmt)->stmt_finalize(thd)) ||
                unlikely((yyvsp[-2].sp_cursor_stmt)->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
            (yyval.sp_cursor_stmt)= (yyvsp[-2].sp_cursor_stmt);
          }
#line 28426 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 377: /* sp_handler_type: EXIT_MARIADB_SYM  */
#line 3629 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.num)= sp_handler::EXIT; }
#line 28432 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 378: /* sp_handler_type: CONTINUE_MARIADB_SYM  */
#line 3630 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.num)= sp_handler::CONTINUE; }
#line 28438 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 379: /* sp_handler_type: EXIT_ORACLE_SYM  */
#line 3631 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.num)= sp_handler::EXIT; }
#line 28444 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 380: /* sp_handler_type: CONTINUE_ORACLE_SYM  */
#line 3632 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.num)= sp_handler::CONTINUE; }
#line 28450 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 381: /* sp_hcond_list: sp_hcond_element  */
#line 3638 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)= 1; }
#line 28456 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 382: /* sp_hcond_list: sp_hcond_list ',' sp_hcond_element  */
#line 3640 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)+= 1; }
#line 28462 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 383: /* sp_hcond_element: sp_hcond  */
#line 3645 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *ctx= lex->spcont->parent_context();

            if (unlikely(ctx->check_duplicate_handler((yyvsp[0].spcondvalue))))
              my_yyabort_error((ER_SP_DUP_HANDLER, MYF(0)));

            sp_instr_hpush_jump *i= (sp_instr_hpush_jump *)sp->last_instruction();
            i->add_condition((yyvsp[0].spcondvalue));
          }
#line 28478 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 384: /* sp_cond: ulong_num  */
#line 3660 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* mysql errno */
            if (unlikely((yyvsp[0].ulong_num) == 0))
              my_yyabort_error((ER_WRONG_VALUE, MYF(0), "CONDITION", "0"));
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value((yyvsp[0].ulong_num));
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 28490 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 386: /* sqlstate: SQLSTATE_SYM opt_value TEXT_STRING_literal  */
#line 3672 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* SQLSTATE */

            /*
              An error is triggered:
                - if the specified string is not a valid SQLSTATE,
                - or if it represents the completion condition -- it is not
                  allowed to SIGNAL, or declare a handler for the completion
                  condition.
            */
            if (unlikely(!is_sqlstate_valid(&(yyvsp[0].lex_str)) ||
                         is_sqlstate_completion((yyvsp[0].lex_str).str)))
              my_yyabort_error((ER_SP_BAD_SQLSTATE, MYF(0), (yyvsp[0].lex_str).str));
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value((yyvsp[0].lex_str).str);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 28511 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 387: /* opt_value: %empty  */
#line 3691 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 28517 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 388: /* opt_value: VALUE_SYM  */
#line 3692 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 28523 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 389: /* sp_hcond: sp_cond  */
#line 3697 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spcondvalue)= (yyvsp[0].spcondvalue);
          }
#line 28531 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 390: /* sp_hcond: ident  */
#line 3701 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spcondvalue)= Lex->spcont->find_declared_or_predefined_condition(thd, &(yyvsp[0].ident_sys));
            if (unlikely((yyval.spcondvalue) == NULL))
              my_yyabort_error((ER_SP_COND_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 28541 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 391: /* sp_hcond: SQLWARNING_SYM  */
#line 3707 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::WARNING);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 28551 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 392: /* sp_hcond: not FOUND_SYM  */
#line 3713 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::NOT_FOUND);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 28561 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 393: /* sp_hcond: SQLEXCEPTION_SYM  */
#line 3719 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::EXCEPTION);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 28571 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 394: /* sp_hcond: OTHERS_ORACLE_SYM  */
#line 3725 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::EXCEPTION);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 28581 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 395: /* raise_stmt_oracle: RAISE_ORACLE_SYM opt_set_signal_information  */
#line 3735 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_resignal_statement(thd, NULL)))
              MYSQL_YYABORT;
          }
#line 28590 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 396: /* raise_stmt_oracle: RAISE_ORACLE_SYM signal_value opt_set_signal_information  */
#line 3740 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_signal_statement(thd, (yyvsp[-1].spcondvalue))))
              MYSQL_YYABORT;
          }
#line 28599 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 397: /* signal_stmt: SIGNAL_SYM signal_value opt_set_signal_information  */
#line 3748 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->add_signal_statement(thd, (yyvsp[-1].spcondvalue)))
              MYSQL_YYABORT;
          }
#line 28608 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 398: /* signal_value: ident  */
#line 3756 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_condition_value *cond;

            /* SIGNAL foo cannot be used outside of stored programs */
            if (unlikely(lex->spcont == NULL))
              my_yyabort_error((ER_SP_COND_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
            cond= lex->spcont->find_declared_or_predefined_condition(thd, &(yyvsp[0].ident_sys));
            if (unlikely(cond == NULL))
              my_yyabort_error((ER_SP_COND_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
            if (unlikely(!cond->has_sql_state()))
              my_yyabort_error((ER_SIGNAL_BAD_CONDITION_TYPE, MYF(0)));
            (yyval.spcondvalue)= cond;
          }
#line 28627 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 399: /* signal_value: sqlstate  */
#line 3771 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.spcondvalue)= (yyvsp[0].spcondvalue); }
#line 28633 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 400: /* opt_signal_value: %empty  */
#line 3776 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.spcondvalue)= NULL; }
#line 28639 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 401: /* opt_signal_value: signal_value  */
#line 3778 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.spcondvalue)= (yyvsp[0].spcondvalue); }
#line 28645 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 402: /* opt_set_signal_information: %empty  */
#line 3783 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            thd->m_parser_state->m_yacc.m_set_signal_info.clear();
          }
#line 28653 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 404: /* signal_information_item_list: signal_condition_information_item_name '=' signal_allowed_expr  */
#line 3791 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Set_signal_information *info;
            info= &thd->m_parser_state->m_yacc.m_set_signal_info;
            int index= (int) (yyvsp[-2].diag_condition_item_name);
            info->clear();
            info->m_item[index]= (yyvsp[0].item);
          }
#line 28665 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 405: /* signal_information_item_list: signal_information_item_list ',' signal_condition_information_item_name '=' signal_allowed_expr  */
#line 3800 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Set_signal_information *info;
            info= &thd->m_parser_state->m_yacc.m_set_signal_info;
            int index= (int) (yyvsp[-2].diag_condition_item_name);
            if (unlikely(info->m_item[index] != NULL))
              my_yyabort_error((ER_DUP_SIGNAL_SET, MYF(0),
                                Diag_condition_item_names[index].str));
            info->m_item[index]= (yyvsp[0].item);
          }
#line 28679 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 406: /* signal_allowed_expr: literal  */
#line 3816 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.item)= (yyvsp[0].item); }
#line 28685 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 407: /* signal_allowed_expr: variable  */
#line 3818 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[0].item)->type() == Item::FUNC_ITEM)
            {
              Item_func *item= (Item_func*) (yyvsp[0].item);
              if (unlikely(item->functype() == Item_func::SUSERVAR_FUNC))
              {
                /*
                  Don't allow the following syntax:
                    SIGNAL/RESIGNAL ...
                    SET <signal condition item name> = @foo := expr
                */
                thd->parse_error();
                MYSQL_YYABORT;
              }
            }
            (yyval.item)= (yyvsp[0].item);
          }
#line 28707 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 408: /* signal_allowed_expr: simple_ident  */
#line 3836 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.item)= (yyvsp[0].item); }
#line 28713 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 409: /* signal_condition_information_item_name: CLASS_ORIGIN_SYM  */
#line 3842 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_CLASS_ORIGIN; }
#line 28719 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 410: /* signal_condition_information_item_name: SUBCLASS_ORIGIN_SYM  */
#line 3844 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_SUBCLASS_ORIGIN; }
#line 28725 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 411: /* signal_condition_information_item_name: CONSTRAINT_CATALOG_SYM  */
#line 3846 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_CONSTRAINT_CATALOG; }
#line 28731 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 412: /* signal_condition_information_item_name: CONSTRAINT_SCHEMA_SYM  */
#line 3848 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_CONSTRAINT_SCHEMA; }
#line 28737 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 413: /* signal_condition_information_item_name: CONSTRAINT_NAME_SYM  */
#line 3850 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_CONSTRAINT_NAME; }
#line 28743 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 414: /* signal_condition_information_item_name: CATALOG_NAME_SYM  */
#line 3852 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_CATALOG_NAME; }
#line 28749 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 415: /* signal_condition_information_item_name: SCHEMA_NAME_SYM  */
#line 3854 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_SCHEMA_NAME; }
#line 28755 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 416: /* signal_condition_information_item_name: TABLE_NAME_SYM  */
#line 3856 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_TABLE_NAME; }
#line 28761 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 417: /* signal_condition_information_item_name: COLUMN_NAME_SYM  */
#line 3858 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_COLUMN_NAME; }
#line 28767 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 418: /* signal_condition_information_item_name: CURSOR_NAME_SYM  */
#line 3860 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_CURSOR_NAME; }
#line 28773 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 419: /* signal_condition_information_item_name: MESSAGE_TEXT_SYM  */
#line 3862 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_MESSAGE_TEXT; }
#line 28779 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 420: /* signal_condition_information_item_name: MYSQL_ERRNO_SYM  */
#line 3864 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_MYSQL_ERRNO; }
#line 28785 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 421: /* resignal_stmt: RESIGNAL_SYM opt_signal_value opt_set_signal_information  */
#line 3869 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_resignal_statement(thd, (yyvsp[-1].spcondvalue))))
              MYSQL_YYABORT;
          }
#line 28794 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 422: /* get_diagnostics: GET_SYM which_area DIAGNOSTICS_SYM diagnostics_information  */
#line 3877 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Diagnostics_information *info= (yyvsp[0].diag_info);

            info->set_which_da((yyvsp[-2].diag_area));

            Lex->sql_command= SQLCOM_GET_DIAGNOSTICS;
            Lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_get_diagnostics(info);

            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 28810 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 423: /* which_area: %empty  */
#line 3892 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_area)= Diagnostics_information::CURRENT_AREA; }
#line 28816 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 424: /* which_area: CURRENT_SYM  */
#line 3894 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_area)= Diagnostics_information::CURRENT_AREA; }
#line 28822 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 425: /* diagnostics_information: statement_information  */
#line 3899 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.diag_info)= new (thd->mem_root) Statement_information((yyvsp[0].stmt_info_list));
            if (unlikely((yyval.diag_info) == NULL))
              MYSQL_YYABORT;
          }
#line 28832 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 426: /* diagnostics_information: CONDITION_SYM condition_number condition_information  */
#line 3905 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.diag_info)= new (thd->mem_root) Condition_information((yyvsp[-1].item), (yyvsp[0].cond_info_list));
            if (unlikely((yyval.diag_info) == NULL))
              MYSQL_YYABORT;
          }
#line 28842 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 427: /* statement_information: statement_information_item  */
#line 3914 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.stmt_info_list)= new (thd->mem_root) List<Statement_information_item>;
            if (unlikely((yyval.stmt_info_list) == NULL) ||
                unlikely((yyval.stmt_info_list)->push_back((yyvsp[0].stmt_info_item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 28853 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 428: /* statement_information: statement_information ',' statement_information_item  */
#line 3921 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[-2].stmt_info_list)->push_back((yyvsp[0].stmt_info_item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.stmt_info_list)= (yyvsp[-2].stmt_info_list);
          }
#line 28863 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 429: /* statement_information_item: simple_target_specification '=' statement_information_item_name  */
#line 3930 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.stmt_info_item)= new (thd->mem_root) Statement_information_item((yyvsp[0].stmt_info_item_name), (yyvsp[-2].item));
            if (unlikely((yyval.stmt_info_item) == NULL))
              MYSQL_YYABORT;
          }
#line 28873 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 430: /* simple_target_specification: ident_cli  */
#line 3939 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= thd->lex->create_item_for_sp_var(&(yyvsp[0].ident_cli), NULL))))
              MYSQL_YYABORT;
          }
#line 28882 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 431: /* simple_target_specification: '@' ident_or_text  */
#line 3944 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_get_user_var(thd, &(yyvsp[0].lex_str));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 28892 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 432: /* statement_information_item_name: NUMBER_MARIADB_SYM  */
#line 3953 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.stmt_info_item_name)= Statement_information_item::NUMBER; }
#line 28898 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 433: /* statement_information_item_name: NUMBER_ORACLE_SYM  */
#line 3955 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.stmt_info_item_name)= Statement_information_item::NUMBER; }
#line 28904 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 434: /* statement_information_item_name: ROW_COUNT_SYM  */
#line 3957 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.stmt_info_item_name)= Statement_information_item::ROW_COUNT; }
#line 28910 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 435: /* condition_number: signal_allowed_expr  */
#line 3966 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.item)= (yyvsp[0].item); }
#line 28916 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 436: /* condition_information: condition_information_item  */
#line 3971 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.cond_info_list)= new (thd->mem_root) List<Condition_information_item>;
            if (unlikely((yyval.cond_info_list) == NULL) ||
                unlikely((yyval.cond_info_list)->push_back((yyvsp[0].cond_info_item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 28927 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 437: /* condition_information: condition_information ',' condition_information_item  */
#line 3978 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[-2].cond_info_list)->push_back((yyvsp[0].cond_info_item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.cond_info_list)= (yyvsp[-2].cond_info_list);
          }
#line 28937 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 438: /* condition_information_item: simple_target_specification '=' condition_information_item_name  */
#line 3987 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.cond_info_item)= new (thd->mem_root) Condition_information_item((yyvsp[0].cond_info_item_name), (yyvsp[-2].item));
            if (unlikely((yyval.cond_info_item) == NULL))
              MYSQL_YYABORT;
          }
#line 28947 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 439: /* condition_information_item_name: CLASS_ORIGIN_SYM  */
#line 3996 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CLASS_ORIGIN; }
#line 28953 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 440: /* condition_information_item_name: SUBCLASS_ORIGIN_SYM  */
#line 3998 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::SUBCLASS_ORIGIN; }
#line 28959 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 441: /* condition_information_item_name: CONSTRAINT_CATALOG_SYM  */
#line 4000 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CONSTRAINT_CATALOG; }
#line 28965 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 442: /* condition_information_item_name: CONSTRAINT_SCHEMA_SYM  */
#line 4002 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CONSTRAINT_SCHEMA; }
#line 28971 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 443: /* condition_information_item_name: CONSTRAINT_NAME_SYM  */
#line 4004 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CONSTRAINT_NAME; }
#line 28977 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 444: /* condition_information_item_name: CATALOG_NAME_SYM  */
#line 4006 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CATALOG_NAME; }
#line 28983 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 445: /* condition_information_item_name: SCHEMA_NAME_SYM  */
#line 4008 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::SCHEMA_NAME; }
#line 28989 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 446: /* condition_information_item_name: TABLE_NAME_SYM  */
#line 4010 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::TABLE_NAME; }
#line 28995 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 447: /* condition_information_item_name: COLUMN_NAME_SYM  */
#line 4012 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::COLUMN_NAME; }
#line 29001 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 448: /* condition_information_item_name: CURSOR_NAME_SYM  */
#line 4014 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CURSOR_NAME; }
#line 29007 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 449: /* condition_information_item_name: MESSAGE_TEXT_SYM  */
#line 4016 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::MESSAGE_TEXT; }
#line 29013 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 450: /* condition_information_item_name: MYSQL_ERRNO_SYM  */
#line 4018 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::MYSQL_ERRNO; }
#line 29019 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 451: /* condition_information_item_name: RETURNED_SQLSTATE_SYM  */
#line 4020 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::RETURNED_SQLSTATE; }
#line 29025 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 453: /* sp_decl_ident: keyword_sp_decl  */
#line 4026 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_ident_cli(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 29034 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 454: /* sp_decl_idents: sp_decl_ident  */
#line 4034 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* NOTE: field definition is filled in sp_decl section. */

            LEX *lex= Lex;
            sp_pcontext *spc= lex->spcont;

            if (unlikely(spc->find_variable(&(yyvsp[0].ident_sys), TRUE)))
              my_yyabort_error((ER_SP_DUP_VAR, MYF(0), (yyvsp[0].ident_sys).str));
            spc->add_variable(thd, &(yyvsp[0].ident_sys));
            (yyval.num)= 1;
          }
#line 29050 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 455: /* sp_decl_idents: sp_decl_idents ',' ident  */
#line 4046 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* NOTE: field definition is filled in sp_decl section. */

            LEX *lex= Lex;
            sp_pcontext *spc= lex->spcont;

            if (unlikely(spc->find_variable(&(yyvsp[0].ident_sys), TRUE)))
              my_yyabort_error((ER_SP_DUP_VAR, MYF(0), (yyvsp[0].ident_sys).str));
            spc->add_variable(thd, &(yyvsp[0].ident_sys));
            (yyval.num)= (yyvsp[-2].num) + 1;
          }
#line 29066 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 456: /* sp_opt_default: %empty  */
#line 4060 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.item) = NULL; }
#line 29072 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 457: /* sp_opt_default: DEFAULT expr  */
#line 4061 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.item) = (yyvsp[0].item); }
#line 29078 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 458: /* sp_opt_default: SET_VAR expr  */
#line 4062 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.item) = (yyvsp[0].item); }
#line 29084 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 464: /* sp_proc_stmt: labels_declaration_oracle sp_labelable_stmt  */
#line 4071 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                      {}
#line 29090 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 477: /* sp_labelable_stmt: NULL_SYM  */
#line 4087 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { }
#line 29096 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 482: /* $@51: %empty  */
#line 4099 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sphead->new_cont_backpatch(NULL);
          }
#line 29106 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 483: /* sp_proc_stmt_if: IF_SYM $@51 sp_if END IF_SYM  */
#line 4105 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sphead->do_cont_backpatch(); }
#line 29112 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 485: /* $@52: %empty  */
#line 4111 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            // Direct procedure call (without the CALL keyword)
            if (unlikely(Lex->call_statement_start(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29122 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 486: /* sp_statement: ident_directly_assignable $@52 opt_sp_cparam_list  */
#line 4117 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 29131 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 487: /* $@53: %empty  */
#line 4122 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29140 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 488: /* sp_statement: ident_directly_assignable '.' ident $@53 opt_sp_cparam_list  */
#line 4127 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 29149 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 489: /* $@54: %empty  */
#line 4132 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys), (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29158 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 490: /* sp_statement: ident_directly_assignable '.' ident '.' ident $@54 opt_sp_cparam_list  */
#line 4137 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 29167 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 491: /* $@55: %empty  */
#line 4144 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            Lex_input_stream *lip= YYLIP;

            lex->sphead->reset_lex(thd);
            /*
              We should not push main select here, it will be done or not
              done by the statement, we just provide only new LEX for the
              statement here as if it is start of parsing new statement.
            */
            lex->sphead->m_tmp_query= lip->get_tok_start();
          }
#line 29184 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 492: /* sp_proc_stmt_statement: $@55 sp_statement  */
#line 4157 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->sp_proc_stmt_statement_finalize(thd, yychar == YYEMPTY) ||
                Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29194 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 495: /* $@56: %empty  */
#line 4172 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29204 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 496: /* sp_proc_stmt_return: RETURN_ALLMODES_SYM $@56 expr  */
#line 4178 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            Lex->pop_select(); //main select
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
            if (unlikely(sp->m_handler->add_instr_freturn(thd, sp, lex->spcont,
                                                          (yyvsp[0].item), lex)) ||
                unlikely(sp->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 29220 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 497: /* sp_proc_stmt_return: RETURN_ORACLE_SYM  */
#line 4190 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            if (unlikely(sp->m_handler->add_instr_preturn(thd, sp,
                                                               lex->spcont)))
              MYSQL_YYABORT;
          }
#line 29232 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 498: /* $@57: %empty  */
#line 4200 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29242 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 499: /* reset_lex_expr: $@57 expr  */
#line 4206 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= (yyvsp[0].item);
            Lex->pop_select(); //main select
          }
#line 29251 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 500: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM  */
#line 4214 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_exit_statement(thd, NULL)))
              MYSQL_YYABORT;
          }
#line 29260 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 501: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM label_ident  */
#line 4219 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_exit_statement(thd, &(yyvsp[0].ident_sys), NULL)))
              MYSQL_YYABORT;
          }
#line 29269 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 502: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM WHEN_SYM reset_lex_expr  */
#line 4224 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->sp_exit_statement(thd, (yyvsp[0].item)) ||
                Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29279 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 503: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM label_ident WHEN_SYM reset_lex_expr  */
#line 4230 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->sp_exit_statement(thd, &(yyvsp[-2].ident_sys), (yyvsp[0].item)) ||
                Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29289 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 504: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM  */
#line 4239 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_continue_statement(thd, NULL)))
              MYSQL_YYABORT;
          }
#line 29298 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 505: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM label_ident  */
#line 4244 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_continue_statement(thd, &(yyvsp[0].ident_sys), NULL)))
              MYSQL_YYABORT;
          }
#line 29307 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 506: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM WHEN_SYM reset_lex_expr  */
#line 4249 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->sp_continue_statement(thd, (yyvsp[0].item)) ||
                Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29317 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 507: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM label_ident WHEN_SYM reset_lex_expr  */
#line 4255 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->sp_continue_statement(thd, &(yyvsp[-2].ident_sys), (yyvsp[0].item)) ||
                Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29327 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 508: /* sp_proc_stmt_leave: LEAVE_SYM label_ident  */
#line 4265 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_leave_statement(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29336 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 509: /* sp_proc_stmt_iterate: ITERATE_SYM label_ident  */
#line 4273 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_iterate_statement(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29345 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 510: /* sp_proc_stmt_goto_oracle: GOTO_ORACLE_SYM label_ident  */
#line 4281 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_goto_statement(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29354 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 511: /* remember_lex: %empty  */
#line 4289 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex)= thd->lex;
          }
#line 29362 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 512: /* assignment_source_lex: %empty  */
#line 4295 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->sphead);
            if (unlikely(!((yyval.assignment_lex)= new (thd->mem_root)
                           sp_assignment_lex(thd, thd->lex))))
              MYSQL_YYABORT;
          }
#line 29373 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 513: /* $@58: %empty  */
#line 4305 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(thd->free_list == NULL);
            Lex->sphead->reset_lex(thd, (yyvsp[0].assignment_lex));
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29384 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 514: /* assignment_source_expr: assignment_source_lex $@58 expr  */
#line 4312 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT((yyvsp[-2].assignment_lex) == thd->lex);
            (yyval.assignment_lex)= (yyvsp[-2].assignment_lex);
            (yyval.assignment_lex)->sp_lex_in_use= true;
            (yyval.assignment_lex)->set_item_and_free_list((yyvsp[0].item), thd->free_list);
            thd->free_list= NULL;
            Lex->pop_select(); //main select
            if ((yyval.assignment_lex)->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29399 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 515: /* $@59: %empty  */
#line 4326 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd, (yyvsp[0].assignment_lex));
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
            Lex->current_select->parsing_place= FOR_LOOP_BOUND;
          }
#line 29410 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 516: /* for_loop_bound_expr: assignment_source_lex $@59 expr  */
#line 4333 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT((yyvsp[-2].assignment_lex) == thd->lex);
            (yyval.assignment_lex)= (yyvsp[-2].assignment_lex);
            (yyval.assignment_lex)->sp_lex_in_use= true;
            (yyval.assignment_lex)->set_item_and_free_list((yyvsp[0].item), NULL);
            Lex->pop_select(); //main select
            if (unlikely((yyval.assignment_lex)->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
            Lex->current_select->parsing_place= NO_MATTER;
          }
#line 29425 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 517: /* cursor_actual_parameters: assignment_source_expr  */
#line 4347 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.sp_assignment_lex_list)= new (thd->mem_root) List<sp_assignment_lex>)))
              MYSQL_YYABORT;
            (yyval.sp_assignment_lex_list)->push_back((yyvsp[0].assignment_lex), thd->mem_root);
          }
#line 29435 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 518: /* cursor_actual_parameters: cursor_actual_parameters ',' assignment_source_expr  */
#line 4353 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.sp_assignment_lex_list)= (yyvsp[-2].sp_assignment_lex_list);
            (yyval.sp_assignment_lex_list)->push_back((yyvsp[0].assignment_lex), thd->mem_root);
          }
#line 29444 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 519: /* opt_parenthesized_cursor_actual_parameters: %empty  */
#line 4360 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                             { (yyval.sp_assignment_lex_list)= NULL; }
#line 29450 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 520: /* opt_parenthesized_cursor_actual_parameters: '(' cursor_actual_parameters ')'  */
#line 4361 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                             { (yyval.sp_assignment_lex_list)= (yyvsp[-1].sp_assignment_lex_list); }
#line 29456 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 521: /* sp_proc_stmt_open: OPEN_SYM ident opt_parenthesized_cursor_actual_parameters  */
#line 4366 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_open_cursor(thd, &(yyvsp[-1].ident_sys), (yyvsp[0].sp_assignment_lex_list))))
              MYSQL_YYABORT;
          }
#line 29465 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 522: /* sp_proc_stmt_fetch_head: FETCH_SYM ident INTO  */
#line 4374 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_add_cfetch(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29474 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 523: /* sp_proc_stmt_fetch_head: FETCH_SYM FROM ident INTO  */
#line 4379 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_add_cfetch(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29483 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 524: /* sp_proc_stmt_fetch_head: FETCH_SYM NEXT_SYM FROM ident INTO  */
#line 4384 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_add_cfetch(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29492 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 525: /* sp_proc_stmt_fetch: sp_proc_stmt_fetch_head sp_fetch_list  */
#line 4391 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                               { }
#line 29498 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 526: /* sp_proc_stmt_fetch: FETCH_SYM GROUP_SYM NEXT_SYM ROW_SYM  */
#line 4393 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           if (unlikely(Lex->sp_add_agg_cfetch()))
             MYSQL_YYABORT;
         }
#line 29507 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 527: /* sp_proc_stmt_close: CLOSE_SYM ident  */
#line 4401 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            uint offset;
            sp_instr_cclose *i;

            if (unlikely(!lex->spcont->find_cursor(&(yyvsp[0].ident_sys), &offset, false)))
              my_yyabort_error((ER_SP_CURSOR_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
            i= new (thd->mem_root)
              sp_instr_cclose(sp->instructions(), lex->spcont,  offset);
            if (unlikely(i == NULL) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
          }
#line 29526 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 528: /* sp_fetch_list: ident  */
#line 4419 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *spc= lex->spcont;
            sp_variable *spv= likely(spc != NULL)
              ? spc->find_variable(&(yyvsp[0].ident_sys), false)
              : NULL;
            if (unlikely(!spv))
              my_yyabort_error((ER_SP_UNDECLARED_VAR, MYF(0), (yyvsp[0].ident_sys).str));

            /* An SP local variable */
            sp_instr_cfetch *i= (sp_instr_cfetch *)sp->last_instruction();
            i->add_to_varlist(spv);
          }
#line 29545 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 529: /* sp_fetch_list: sp_fetch_list ',' ident  */
#line 4434 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *spc= lex->spcont;
            sp_variable *spv= likely(spc != NULL)
              ? spc->find_variable(&(yyvsp[0].ident_sys), false)
              : NULL;
            if (unlikely(!spv))
              my_yyabort_error((ER_SP_UNDECLARED_VAR, MYF(0), (yyvsp[0].ident_sys).str));

            /* An SP local variable */
            sp_instr_cfetch *i= (sp_instr_cfetch *)sp->last_instruction();
            i->add_to_varlist(spv);
          }
#line 29564 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 530: /* $@60: %empty  */
#line 4451 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29574 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 531: /* $@61: %empty  */
#line 4457 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *ctx= lex->spcont;
            uint ip= sp->instructions();
            sp_instr_jump_if_not *i= new (thd->mem_root)
              sp_instr_jump_if_not(ip, ctx, (yyvsp[-1].item), lex);
            if (unlikely(i == NULL) ||
                unlikely(sp->push_backpatch(thd, i, ctx->push_label(thd, &empty_clex_str, 0))) ||
                unlikely(sp->add_cont_backpatch(i)) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (unlikely(sp->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 29595 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 532: /* $@62: %empty  */
#line 4474 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_head *sp= Lex->sphead;
            sp_pcontext *ctx= Lex->spcont;
            uint ip= sp->instructions();
            sp_instr_jump *i= new (thd->mem_root) sp_instr_jump(ip, ctx);
            if (unlikely(i == NULL) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
            sp->backpatch(ctx->pop_label());
            sp->push_backpatch(thd, i, ctx->push_label(thd, &empty_clex_str, 0));
          }
#line 29611 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 533: /* sp_if: $@60 expr THEN_SYM $@61 sp_proc_stmts1_implicit_block $@62 sp_elseifs  */
#line 4486 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            lex->sphead->backpatch(lex->spcont->pop_label());
          }
#line 29621 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 537: /* $@63: %empty  */
#line 4501 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;

            /**
              An example of the CASE statement in use is
            <pre>
            CREATE PROCEDURE proc_19194_simple(i int)
            BEGIN
              DECLARE str CHAR(10);

              CASE i
                WHEN 1 THEN SET str="1";
                WHEN 2 THEN SET str="2";
                WHEN 3 THEN SET str="3";
                ELSE SET str="unknown";
              END CASE;

              SELECT str;
            END
            </pre>
              The actions are used to generate the following code:
            <pre>
            SHOW PROCEDURE CODE proc_19194_simple;
            Pos     Instruction
            0       set str@1 NULL
            1       set_case_expr (12) 0 i@0
            2       jump_if_not 5(12) (case_expr@0 = 1)
            3       set str@1 _latin1'1'
            4       jump 12
            5       jump_if_not 8(12) (case_expr@0 = 2)
            6       set str@1 _latin1'2'
            7       jump 12
            8       jump_if_not 11(12) (case_expr@0 = 3)
            9       set str@1 _latin1'3'
            10      jump 12
            11      set str@1 _latin1'unknown'
            12      stmt 0 "SELECT str"
            </pre>
            */

            Lex->sphead->new_cont_backpatch(NULL);

            /*
              BACKPATCH: Creating target label for the jump to after END CASE
              (instruction 12 in the example)
            */
            Lex->spcont->push_label(thd, &empty_clex_str, Lex->sphead->instructions());
          }
#line 29675 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 538: /* case_stmt_specification: CASE_SYM $@63 case_stmt_body else_clause_opt END CASE_SYM  */
#line 4554 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              BACKPATCH: Resolving forward jump from
              "case_stmt_action_then" to after END CASE
              (jump from instruction 4 to 12, 7 to 12 ... in the example)
            */
            Lex->sphead->backpatch(Lex->spcont->pop_label());

            if ((yyvsp[-3].num))
              Lex->spcont->pop_case_expr_id();

            Lex->sphead->do_cont_backpatch();
          }
#line 29693 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 539: /* $@64: %empty  */
#line 4570 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd); /* For expr $2 */
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29703 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 540: /* $@65: %empty  */
#line 4576 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->case_stmt_action_expr((yyvsp[0].item))))
              MYSQL_YYABORT;

            Lex->pop_select(); //main select
            if (Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29716 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 541: /* case_stmt_body: $@64 expr $@65 simple_when_clause_list  */
#line 4585 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)= 1; }
#line 29722 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 542: /* case_stmt_body: searched_when_clause_list  */
#line 4587 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)= 0; }
#line 29728 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 547: /* $@66: %empty  */
#line 4602 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd); /* For expr $3 */
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29738 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 548: /* $@67: %empty  */
#line 4608 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* Simple case: <caseval> = <whenval> */

            LEX *lex= Lex;
            if (unlikely(lex->case_stmt_action_when((yyvsp[0].item), true)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            /* For expr $3 */
            if (unlikely(lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 29754 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 549: /* simple_when_clause: WHEN_SYM $@66 expr $@67 THEN_SYM sp_proc_stmts1_implicit_block  */
#line 4621 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->case_stmt_action_then()))
              MYSQL_YYABORT;
          }
#line 29763 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 550: /* $@68: %empty  */
#line 4629 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd); /* For expr $3 */
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29773 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 551: /* $@69: %empty  */
#line 4635 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->case_stmt_action_when((yyvsp[0].item), false)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            /* For expr $3 */
            if (unlikely(lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 29787 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 552: /* searched_when_clause: WHEN_SYM $@68 expr $@69 THEN_SYM sp_proc_stmts1_implicit_block  */
#line 4646 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->case_stmt_action_then()))
              MYSQL_YYABORT;
          }
#line 29796 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 553: /* else_clause_opt: %empty  */
#line 4654 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            uint ip= sp->instructions();
            sp_instr_error *i= new (thd->mem_root)
              sp_instr_error(ip, lex->spcont, ER_SP_CASE_NOT_FOUND);
            if (unlikely(i == NULL) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
          }
#line 29811 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 555: /* sp_opt_label: %empty  */
#line 4668 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.lex_str)= null_clex_str; }
#line 29817 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 556: /* sp_opt_label: label_ident  */
#line 4669 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 29823 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 557: /* sp_block_label: labels_declaration_oracle  */
#line 4674 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->spcont->block_label_declare(&(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
            (yyval.lex_str)= (yyvsp[0].lex_str);
          }
#line 29833 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 558: /* $@70: %empty  */
#line 4684 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_block_init(thd, &(yyvsp[-1].lex_str));
            if (unlikely(Lex->sp_block_with_exceptions_finalize_declarations(thd)))
              MYSQL_YYABORT;
          }
#line 29843 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 559: /* sp_labeled_block: sp_block_label BEGIN_ORACLE_SYM $@70 sp_block_statements_and_exceptions END sp_opt_label  */
#line 4692 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_finalize(thd, Lex_spblock((yyvsp[-2].spblock_handlers)), &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 29852 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 560: /* $@71: %empty  */
#line 4698 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_block_init(thd, &(yyvsp[-1].lex_str));
          }
#line 29860 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 561: /* $@72: %empty  */
#line 4702 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_finalize_declarations(thd)))
              MYSQL_YYABORT;
          }
#line 29869 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 562: /* sp_labeled_block: sp_block_label DECLARE_ORACLE_SYM $@71 opt_sp_decl_body_list $@72 BEGIN_ORACLE_SYM sp_block_statements_and_exceptions END sp_opt_label  */
#line 4710 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-5].spblock).hndlrs+= (yyvsp[-2].spblock_handlers).hndlrs;
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-5].spblock), &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 29879 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 565: /* $@73: %empty  */
#line 4724 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sp_block_init(thd);
            if (unlikely(Lex->sp_block_with_exceptions_finalize_declarations(thd)))
              MYSQL_YYABORT;
          }
#line 29891 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 566: /* sp_unlabeled_block: BEGIN_ORACLE_SYM opt_not_atomic $@73 sp_block_statements_and_exceptions END  */
#line 4733 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_finalize(thd, Lex_spblock((yyvsp[-1].spblock_handlers)))))
              MYSQL_YYABORT;
          }
#line 29900 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 567: /* $@74: %empty  */
#line 4738 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sp_block_init(thd);
          }
#line 29910 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 568: /* $@75: %empty  */
#line 4744 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_finalize_declarations(thd)))
              MYSQL_YYABORT;
          }
#line 29919 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 569: /* sp_unlabeled_block: DECLARE_ORACLE_SYM $@74 opt_sp_decl_body_list $@75 BEGIN_ORACLE_SYM sp_block_statements_and_exceptions END  */
#line 4751 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-4].spblock).hndlrs+= (yyvsp[-1].spblock_handlers).hndlrs;
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-4].spblock))))
              MYSQL_YYABORT;
          }
#line 29929 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 570: /* sp_instr_addr: %empty  */
#line 4759 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.sp_instr_addr)= Lex->sphead->instructions(); }
#line 29935 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 571: /* $@76: %empty  */
#line 4763 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_block_init(thd);
          }
#line 29943 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 572: /* $@77: %empty  */
#line 4767 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_finalize_declarations(thd)))
              MYSQL_YYABORT;
          }
#line 29952 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 573: /* $@78: %empty  */
#line 4773 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-3].spblock).hndlrs+= (yyvsp[0].spblock_handlers).hndlrs;
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-3].spblock))))
              MYSQL_YYABORT;
          }
#line 29962 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 575: /* $@79: %empty  */
#line 4784 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_finalize_executable_section(thd, (yyvsp[-1].sp_instr_addr))))
              MYSQL_YYABORT;
          }
#line 29971 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 576: /* sp_block_statements_and_exceptions: sp_instr_addr sp_proc_stmts $@79 opt_exception_clause  */
#line 4789 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_finalize_exceptions(thd, (yyvsp[-3].sp_instr_addr), (yyvsp[0].num))))
              MYSQL_YYABORT;
            (yyval.spblock_handlers).init((yyvsp[0].num));
          }
#line 29981 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 577: /* opt_exception_clause: %empty  */
#line 4797 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                  { (yyval.num)= 0; }
#line 29987 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 578: /* opt_exception_clause: EXCEPTION_ORACLE_SYM exception_handlers  */
#line 4798 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                  { (yyval.num)= (yyvsp[0].num); }
#line 29993 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 579: /* exception_handlers: exception_handler  */
#line 4802 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.num)= 1; }
#line 29999 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 580: /* exception_handlers: exception_handlers exception_handler  */
#line 4803 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.num)= (yyvsp[-1].num) + 1; }
#line 30005 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 581: /* $@80: %empty  */
#line 4808 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_handler_declaration_init(thd, sp_handler::EXIT)))
              MYSQL_YYABORT;
          }
#line 30014 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 582: /* exception_handler: WHEN_SYM $@80 sp_hcond_list THEN_SYM sp_proc_stmts1_implicit_block  */
#line 4815 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_handler_declaration_finalize(thd, sp_handler::EXIT)))
              MYSQL_YYABORT;
          }
#line 30023 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 583: /* opt_sp_for_loop_direction: %empty  */
#line 4823 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.num)= 1; }
#line 30029 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 584: /* opt_sp_for_loop_direction: REVERSE_SYM  */
#line 4824 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.num)= -1; }
#line 30035 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 585: /* $@81: %empty  */
#line 4829 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30044 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 586: /* sp_for_loop_index_and_bounds: ident_directly_assignable $@81 sp_for_loop_bounds  */
#line 4834 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (unlikely(Lex->sp_for_loop_declarations(thd, &(yyval.for_loop), &(yyvsp[-2].ident_sys), (yyvsp[0].for_loop_bounds))))
              MYSQL_YYABORT;
          }
#line 30054 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 587: /* sp_for_loop_bounds: IN_SYM opt_sp_for_loop_direction for_loop_bound_expr DOT_DOT_SYM for_loop_bound_expr  */
#line 4844 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.for_loop_bounds)= Lex_for_loop_bounds_intrange((yyvsp[-3].num), (yyvsp[-2].assignment_lex), (yyvsp[0].assignment_lex));
          }
#line 30062 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 588: /* sp_for_loop_bounds: IN_SYM opt_sp_for_loop_direction for_loop_bound_expr  */
#line 4848 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.for_loop_bounds).m_direction= (yyvsp[-1].num);
            (yyval.for_loop_bounds).m_index= (yyvsp[0].assignment_lex);
            (yyval.for_loop_bounds).m_target_bound= NULL;
            (yyval.for_loop_bounds).m_implicit_cursor= false;
          }
#line 30073 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 589: /* sp_for_loop_bounds: IN_SYM opt_sp_for_loop_direction '(' sp_cursor_stmt ')'  */
#line 4855 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_for_loop_implicit_cursor_statement(thd, &(yyval.for_loop_bounds),
                                                                    (yyvsp[-1].sp_cursor_stmt))))
              MYSQL_YYABORT;
          }
#line 30083 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 590: /* loop_body: sp_proc_stmts1 END LOOP_SYM  */
#line 4864 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            uint ip= lex->sphead->instructions();
            sp_label *lab= lex->spcont->last_label();  /* Jumping back */
            sp_instr_jump *i= new (thd->mem_root)
              sp_instr_jump(ip, lex->spcont, lab->ip);
            if (unlikely(i == NULL) ||
                unlikely(lex->sphead->add_instr(i)))
              MYSQL_YYABORT;
          }
#line 30098 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 591: /* $@82: %empty  */
#line 4878 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sp_while_loop_expression(thd, (yyvsp[-1].item))))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
            if (lex->main_select_push(true))
               MYSQL_YYABORT;
          }
#line 30113 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 592: /* while_body: expr LOOP_SYM $@82 sp_proc_stmts1 END LOOP_SYM  */
#line 4889 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_while_loop_finalize(thd)))
              MYSQL_YYABORT;
          }
#line 30122 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 593: /* $@83: %empty  */
#line 4897 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30132 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 594: /* repeat_body: sp_proc_stmts1 UNTIL_SYM $@83 expr END REPEAT_SYM  */
#line 4903 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            uint ip= lex->sphead->instructions();
            sp_label *lab= lex->spcont->last_label();  /* Jumping back */
            sp_instr_jump_if_not *i= new (thd->mem_root)
              sp_instr_jump_if_not(ip, lex->spcont, (yyvsp[-2].item), lab->ip, lex);
            if (unlikely(i == NULL) ||
                unlikely(lex->sphead->add_instr(i)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
            /* We can shortcut the cont_backpatch here */
            i->m_cont_dest= ip+1;
          }
#line 30152 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 595: /* pop_sp_loop_label: sp_opt_label  */
#line 4922 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_pop_loop_label(thd, &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 30161 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 596: /* $@84: %empty  */
#line 4930 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-1].lex_str))))
              MYSQL_YYABORT;
          }
#line 30170 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 597: /* sp_labeled_control: labels_declaration_oracle LOOP_SYM $@84 loop_body pop_sp_loop_label  */
#line 4935 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 30176 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 598: /* $@85: %empty  */
#line 4937 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-1].lex_str))))
              MYSQL_YYABORT;
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30188 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 599: /* sp_labeled_control: labels_declaration_oracle WHILE_SYM $@85 while_body pop_sp_loop_label  */
#line 4945 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 30194 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 600: /* $@86: %empty  */
#line 4947 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            // See "The FOR LOOP statement" comments in sql_lex.cc
            Lex->sp_block_init(thd); // The outer DECLARE..BEGIN..END block
          }
#line 30203 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 601: /* $@87: %empty  */
#line 4952 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-3].lex_str)))) // The inner WHILE block
              MYSQL_YYABORT;
            if (unlikely(Lex->sp_for_loop_condition_test(thd, (yyvsp[0].for_loop))))
              MYSQL_YYABORT;
          }
#line 30214 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 602: /* $@88: %empty  */
#line 4961 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_for_loop_finalize(thd, (yyvsp[-5].for_loop))))
              MYSQL_YYABORT;
          }
#line 30223 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 603: /* sp_labeled_control: labels_declaration_oracle FOR_SYM $@86 sp_for_loop_index_and_bounds $@87 LOOP_SYM sp_proc_stmts1 END LOOP_SYM $@88 pop_sp_loop_label  */
#line 4966 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_for_loop_outer_block_finalize(thd, (yyvsp[-7].for_loop))))
              MYSQL_YYABORT;
          }
#line 30232 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 604: /* $@89: %empty  */
#line 4971 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-1].lex_str))))
              MYSQL_YYABORT;
          }
#line 30241 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 605: /* sp_labeled_control: labels_declaration_oracle REPEAT_SYM $@89 repeat_body pop_sp_loop_label  */
#line 4976 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 30247 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 606: /* $@90: %empty  */
#line 4981 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd)))
              MYSQL_YYABORT;
          }
#line 30256 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 607: /* sp_unlabeled_control: LOOP_SYM $@90 loop_body  */
#line 4986 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_pop_loop_empty_label(thd);
          }
#line 30264 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 608: /* $@91: %empty  */
#line 4990 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd)))
              MYSQL_YYABORT;
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30276 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 609: /* sp_unlabeled_control: WHILE_SYM $@91 while_body  */
#line 4998 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_pop_loop_empty_label(thd);
          }
#line 30284 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 610: /* $@92: %empty  */
#line 5002 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            // See "The FOR LOOP statement" comments in sql_lex.cc
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sp_block_init(thd); // The outer DECLARE..BEGIN..END block
          }
#line 30295 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 611: /* $@93: %empty  */
#line 5009 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd))) // The inner WHILE block
              MYSQL_YYABORT;
            if (unlikely(Lex->sp_for_loop_condition_test(thd, (yyvsp[0].for_loop))))
              MYSQL_YYABORT;
          }
#line 30306 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 612: /* sp_unlabeled_control: FOR_SYM $@92 sp_for_loop_index_and_bounds $@93 LOOP_SYM sp_proc_stmts1 END LOOP_SYM  */
#line 5018 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_for_loop_finalize(thd, (yyvsp[-5].for_loop))))
              MYSQL_YYABORT;
            Lex->sp_pop_loop_empty_label(thd); // The inner WHILE block
            if (unlikely(Lex->sp_for_loop_outer_block_finalize(thd, (yyvsp[-5].for_loop))))
              MYSQL_YYABORT;
          }
#line 30318 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 613: /* $@94: %empty  */
#line 5026 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd)))
              MYSQL_YYABORT;
          }
#line 30327 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 614: /* sp_unlabeled_control: REPEAT_SYM $@94 repeat_body  */
#line 5031 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_pop_loop_empty_label(thd);
          }
#line 30335 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 615: /* trg_action_time: BEFORE_SYM  */
#line 5038 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { Lex->trg_chistics.action_time= TRG_ACTION_BEFORE; }
#line 30341 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 616: /* trg_action_time: AFTER_SYM  */
#line 5040 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { Lex->trg_chistics.action_time= TRG_ACTION_AFTER; }
#line 30347 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 617: /* trg_event: INSERT  */
#line 5045 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { Lex->trg_chistics.event= TRG_EVENT_INSERT; }
#line 30353 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 618: /* trg_event: UPDATE_SYM  */
#line 5047 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { Lex->trg_chistics.event= TRG_EVENT_UPDATE; }
#line 30359 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 619: /* trg_event: DELETE_SYM  */
#line 5049 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { Lex->trg_chistics.event= TRG_EVENT_DELETE; }
#line 30365 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 623: /* opt_logfile_group_name: %empty  */
#line 5083 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30371 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 624: /* opt_logfile_group_name: USE_SYM LOGFILE_SYM GROUP_SYM ident  */
#line 5085 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->logfile_group_name= (yyvsp[0].ident_sys).str;
          }
#line 30380 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 625: /* alter_tablespace_info: tablespace_name ADD ts_datafile alter_tablespace_option_list  */
#line 5095 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            Lex->alter_tablespace_info->ts_alter_tablespace_type= ALTER_TABLESPACE_ADD_FILE; 
          }
#line 30388 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 626: /* alter_tablespace_info: tablespace_name DROP ts_datafile alter_tablespace_option_list  */
#line 5101 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            Lex->alter_tablespace_info->ts_alter_tablespace_type= ALTER_TABLESPACE_DROP_FILE; 
          }
#line 30396 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 631: /* $@95: %empty  */
#line 5124 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30402 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 678: /* ts_datafile: DATAFILE_SYM TEXT_STRING_sys  */
#line 5218 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->data_file_name= (yyvsp[0].lex_str).str;
          }
#line 30411 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 679: /* lg_undofile: UNDOFILE_SYM TEXT_STRING_sys  */
#line 5226 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->undo_file_name= (yyvsp[0].lex_str).str;
          }
#line 30420 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 680: /* lg_redofile: REDOFILE_SYM TEXT_STRING_sys  */
#line 5234 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->redo_file_name= (yyvsp[0].lex_str).str;
          }
#line 30429 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 681: /* tablespace_name: ident  */
#line 5242 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info= (new (thd->mem_root)
                                         st_alter_tablespace());
            if (unlikely(lex->alter_tablespace_info == NULL))
              MYSQL_YYABORT;
            lex->alter_tablespace_info->tablespace_name= (yyvsp[0].ident_sys).str;
            lex->sql_command= SQLCOM_ALTER_TABLESPACE;
          }
#line 30443 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 682: /* logfile_group_name: ident  */
#line 5255 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info= (new (thd->mem_root)
                                         st_alter_tablespace());
            if (unlikely(lex->alter_tablespace_info == NULL))
              MYSQL_YYABORT;
            lex->alter_tablespace_info->logfile_group_name= (yyvsp[0].ident_sys).str;
            lex->sql_command= SQLCOM_ALTER_TABLESPACE;
          }
#line 30457 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 683: /* ts_access_mode: READ_ONLY_SYM  */
#line 5268 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_access_mode= TS_READ_ONLY;
          }
#line 30466 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 684: /* ts_access_mode: READ_WRITE_SYM  */
#line 5273 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_access_mode= TS_READ_WRITE;
          }
#line 30475 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 685: /* ts_access_mode: NOT_SYM ACCESSIBLE_SYM  */
#line 5278 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_access_mode= TS_NOT_ACCESSIBLE;
          }
#line 30484 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 686: /* opt_ts_initial_size: INITIAL_SIZE_SYM opt_equal size_number  */
#line 5286 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->initial_size= (yyvsp[0].ulonglong_number);
          }
#line 30493 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 687: /* opt_ts_autoextend_size: AUTOEXTEND_SIZE_SYM opt_equal size_number  */
#line 5294 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->autoextend_size= (yyvsp[0].ulonglong_number);
          }
#line 30502 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 688: /* opt_ts_max_size: MAX_SIZE_SYM opt_equal size_number  */
#line 5302 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->max_size= (yyvsp[0].ulonglong_number);
          }
#line 30511 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 689: /* opt_ts_extent_size: EXTENT_SIZE_SYM opt_equal size_number  */
#line 5310 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->extent_size= (yyvsp[0].ulonglong_number);
          }
#line 30520 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 690: /* opt_ts_undo_buffer_size: UNDO_BUFFER_SIZE_SYM opt_equal size_number  */
#line 5318 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->undo_buffer_size= (yyvsp[0].ulonglong_number);
          }
#line 30529 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 691: /* opt_ts_redo_buffer_size: REDO_BUFFER_SIZE_SYM opt_equal size_number  */
#line 5326 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->redo_buffer_size= (yyvsp[0].ulonglong_number);
          }
#line 30538 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 692: /* opt_ts_nodegroup: NODEGROUP_SYM opt_equal real_ulong_num  */
#line 5334 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->alter_tablespace_info->nodegroup_id != UNDEF_NODEGROUP))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE,MYF(0),"NODEGROUP"));
            lex->alter_tablespace_info->nodegroup_id= (yyvsp[0].ulong_num);
          }
#line 30549 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 693: /* opt_ts_comment: COMMENT_SYM opt_equal TEXT_STRING_sys  */
#line 5344 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->alter_tablespace_info->ts_comment != NULL))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE,MYF(0),"COMMENT"));
            lex->alter_tablespace_info->ts_comment= (yyvsp[0].lex_str).str;
          }
#line 30560 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 694: /* opt_ts_engine: opt_storage ENGINE_SYM opt_equal storage_engines  */
#line 5354 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->alter_tablespace_info->storage_engine != NULL))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE, MYF(0),
                                "STORAGE ENGINE"));
            lex->alter_tablespace_info->storage_engine= (yyvsp[0].db_type);
          }
#line 30572 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 697: /* ts_wait: WAIT_SYM  */
#line 5370 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->wait_until_completed= TRUE;
          }
#line 30581 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 698: /* ts_wait: NO_WAIT_SYM  */
#line 5375 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!(lex->alter_tablespace_info->wait_until_completed)))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE,MYF(0),"NO_WAIT"));
            lex->alter_tablespace_info->wait_until_completed= FALSE;
          }
#line 30592 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 699: /* size_number: real_ulonglong_num  */
#line 5384 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.ulonglong_number)= (yyvsp[0].ulonglong_number);}
#line 30598 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 700: /* size_number: IDENT_sys  */
#line 5386 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[0].ident_sys).to_size_number(&(yyval.ulonglong_number)))
              MYSQL_YYABORT;
          }
#line 30607 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 701: /* $@96: %empty  */
#line 5398 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->create_info.option_list= NULL; }
#line 30613 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 702: /* create_body: create_field_list_parens $@96 opt_create_table_options opt_create_partitioning opt_create_select  */
#line 5399 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                                             {}
#line 30619 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 703: /* create_body: opt_create_table_options opt_create_partitioning opt_create_select  */
#line 5400 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                                             {}
#line 30625 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 704: /* create_body: create_like  */
#line 5402 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {

            Lex->create_info.add(DDL_options_st::OPT_LIKE);
            TABLE_LIST *src_table= Lex->first_select_lex()->
              add_table_to_list(thd, (yyvsp[0].table), NULL, 0, TL_READ, MDL_SHARED_READ);
            if (unlikely(! src_table))
              MYSQL_YYABORT;
            /* CREATE TABLE ... LIKE is not allowed for views. */
            src_table->required_type= TABLE_TYPE_NORMAL;
          }
#line 30640 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 705: /* create_like: LIKE table_ident  */
#line 5415 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.table)= (yyvsp[0].table); }
#line 30646 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 706: /* create_like: LEFT_PAREN_LIKE LIKE table_ident ')'  */
#line 5416 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.table)= (yyvsp[-1].table); }
#line 30652 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 707: /* opt_create_select: %empty  */
#line 5420 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30658 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 708: /* opt_create_select: opt_duplicate opt_as create_select_query_expression opt_versioning_option  */
#line 5423 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 30667 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 709: /* create_select_query_expression: query_expression  */
#line 5431 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->parsed_insert_select((yyvsp[0].select_lex_unit)->first_select()))
              MYSQL_YYABORT;
          }
#line 30676 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 710: /* create_select_query_expression: LEFT_PAREN_WITH with_clause query_expression_no_with_clause ')'  */
#line 5436 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *first_select= (yyvsp[-1].select_lex_unit)->first_select();
            (yyvsp[-1].select_lex_unit)->set_with_clause((yyvsp[-2].with_clause));
            (yyvsp[-2].with_clause)->attach_to(first_select);
            if (Lex->parsed_insert_select(first_select))
              MYSQL_YYABORT;
          }
#line 30688 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 711: /* opt_create_partitioning: opt_partitioning  */
#line 5447 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Remove all tables used in PARTITION clause from the global table
              list. Partitioning with subqueries is not allowed anyway.
            */
            TABLE_LIST *last_non_sel_table= Lex->create_last_non_select_table;
            last_non_sel_table->next_global= 0;
            Lex->query_tables_last= &last_non_sel_table->next_global;
          }
#line 30702 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 712: /* opt_partitioning: %empty  */
#line 5483 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30708 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 714: /* $@97: %empty  */
#line 5489 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->part_info= new (thd->mem_root) partition_info();
            if (unlikely(!lex->part_info))
              MYSQL_YYABORT;
            if (lex->sql_command == SQLCOM_ALTER_TABLE)
            {
              lex->alter_info.partition_flags|= ALTER_PARTITION_INFO;
            }
          }
#line 30723 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 716: /* have_partitioning: %empty  */
#line 5504 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
#ifdef WITH_PARTITION_STORAGE_ENGINE
            LEX_CSTRING partition_name={STRING_WITH_LEN("partition")};
            if (unlikely(!plugin_is_ready(&partition_name, MYSQL_STORAGE_ENGINE_PLUGIN)))
              my_yyabort_error((ER_OPTION_PREVENTS_STATEMENT, MYF(0),
                                "--skip-partition"));
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), "partitioning",
                              "--with-plugin-partition"));
#endif
          }
#line 30739 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 717: /* $@98: %empty  */
#line 5519 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Lex->part_info))
            {
              thd->parse_error(ER_PARTITION_ENTRY_ERROR);
              MYSQL_YYABORT;
            }
            DBUG_ASSERT(Lex->part_info->table);
            /*
              We enter here when opening the frm file to translate
              partition info string into part_info data structure.
            */
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 30758 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 718: /* partition_entry: PARTITION_SYM $@98 partition  */
#line 5534 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 30766 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 719: /* $@99: %empty  */
#line 5541 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->safe_to_cache_query= 1; }
#line 30772 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 721: /* part_type_def: opt_linear KEY_SYM opt_key_algo '(' part_field_list ')'  */
#line 5547 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->list_of_part_fields= TRUE;
            part_info->column_list= FALSE;
            part_info->part_type= HASH_PARTITION;
          }
#line 30783 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 722: /* $@100: %empty  */
#line 5554 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->part_type= HASH_PARTITION; }
#line 30789 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 723: /* part_type_def: opt_linear HASH_SYM $@100 part_func  */
#line 5555 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 30795 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 724: /* part_type_def: RANGE_SYM part_func  */
#line 5557 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->part_type= RANGE_PARTITION; }
#line 30801 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 725: /* part_type_def: RANGE_SYM part_column_list  */
#line 5559 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->part_type= RANGE_PARTITION; }
#line 30807 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 726: /* $@101: %empty  */
#line 5561 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    Select->parsing_place= IN_PART_FUNC;
          }
#line 30815 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 727: /* part_type_def: LIST_SYM $@101 part_func  */
#line 5565 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
	    Lex->part_info->part_type= LIST_PARTITION; 
	    Select->parsing_place= NO_MATTER;
	  }
#line 30824 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 728: /* part_type_def: LIST_SYM part_column_list  */
#line 5570 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->part_type= LIST_PARTITION; }
#line 30830 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 729: /* $@102: %empty  */
#line 5572 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             if (unlikely(Lex->part_info->vers_init_info(thd)))
               MYSQL_YYABORT;
          }
#line 30839 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 731: /* opt_linear: %empty  */
#line 5580 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30845 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 732: /* opt_linear: LINEAR_SYM  */
#line 5582 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->linear_hash_ind= TRUE;}
#line 30851 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 733: /* opt_key_algo: %empty  */
#line 5587 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->key_algorithm= partition_info::KEY_ALGORITHM_NONE;}
#line 30857 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 734: /* opt_key_algo: ALGORITHM_SYM '=' real_ulong_num  */
#line 5589 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            switch ((yyvsp[0].ulong_num)) {
            case 1:
              Lex->part_info->key_algorithm= partition_info::KEY_ALGORITHM_51;
              break;
            case 2:
              Lex->part_info->key_algorithm= partition_info::KEY_ALGORITHM_55;
              break;
            default:
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 30875 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 735: /* part_field_list: %empty  */
#line 5605 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30881 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 736: /* part_field_list: part_field_item_list  */
#line 5606 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               {}
#line 30887 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 737: /* part_field_item_list: part_field_item  */
#line 5610 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 30893 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 738: /* part_field_item_list: part_field_item_list ',' part_field_item  */
#line 5611 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                   {}
#line 30899 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 739: /* part_field_item: ident  */
#line 5616 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->num_columns++;
            if (unlikely(part_info->part_field_list.push_back((yyvsp[0].ident_sys).str,
                         thd->mem_root)))
              MYSQL_YYABORT;
            if (unlikely(part_info->num_columns > MAX_REF_PARTS))
              my_yyabort_error((ER_TOO_MANY_PARTITION_FUNC_FIELDS_ERROR, MYF(0),
                                "list of partition fields"));
          }
#line 30914 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 740: /* part_column_list: COLUMNS '(' part_field_list ')'  */
#line 5630 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->column_list= TRUE;
            part_info->list_of_part_fields= TRUE;
          }
#line 30924 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 741: /* part_func: '(' part_func_expr ')'  */
#line 5640 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->set_part_expr(thd, (yyvsp[-1].item), FALSE)))
              MYSQL_YYABORT;
            part_info->num_columns= 1;
            part_info->column_list= FALSE;
          }
#line 30936 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 742: /* sub_part_func: '(' part_func_expr ')'  */
#line 5651 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->part_info->set_part_expr(thd, (yyvsp[-1].item), TRUE)))
              MYSQL_YYABORT;
          }
#line 30945 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 743: /* opt_num_parts: %empty  */
#line 5659 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30951 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 744: /* opt_num_parts: PARTITIONS_SYM real_ulong_num  */
#line 5661 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            uint num_parts= (yyvsp[0].ulong_num);
            partition_info *part_info= Lex->part_info;
            if (unlikely(num_parts == 0))
              my_yyabort_error((ER_NO_PARTS_ERROR, MYF(0), "partitions"));

            part_info->num_parts= num_parts;
            part_info->use_default_num_partitions= FALSE;
          }
#line 30965 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 745: /* opt_sub_part: %empty  */
#line 5673 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30971 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 746: /* $@103: %empty  */
#line 5675 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->subpart_type= HASH_PARTITION; }
#line 30977 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 747: /* opt_sub_part: SUBPARTITION_SYM BY opt_linear HASH_SYM sub_part_func $@103 opt_num_subparts  */
#line 5676 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           {}
#line 30983 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 748: /* $@104: %empty  */
#line 5679 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->subpart_type= HASH_PARTITION;
            part_info->list_of_subpart_fields= TRUE;
          }
#line 30993 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 749: /* opt_sub_part: SUBPARTITION_SYM BY opt_linear KEY_SYM opt_key_algo '(' sub_part_field_list ')' $@104 opt_num_subparts  */
#line 5684 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           {}
#line 30999 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 750: /* sub_part_field_list: sub_part_field_item  */
#line 5688 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              {}
#line 31005 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 751: /* sub_part_field_list: sub_part_field_list ',' sub_part_field_item  */
#line 5689 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                      {}
#line 31011 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 752: /* sub_part_field_item: ident  */
#line 5694 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->subpart_field_list.push_back((yyvsp[0].ident_sys).str,
                         thd->mem_root)))
              MYSQL_YYABORT;

            if (unlikely(part_info->subpart_field_list.elements > MAX_REF_PARTS))
              my_yyabort_error((ER_TOO_MANY_PARTITION_FUNC_FIELDS_ERROR, MYF(0),
                                "list of subpartition fields"));
          }
#line 31026 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 753: /* part_func_expr: bit_expr  */
#line 5708 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Lex->safe_to_cache_query))
            {
              thd->parse_error(ER_WRONG_EXPR_IN_PARTITION_FUNC_ERROR);
              MYSQL_YYABORT;
            }
            (yyval.item)=(yyvsp[0].item);
          }
#line 31039 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 754: /* opt_num_subparts: %empty  */
#line 5719 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 31045 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 755: /* opt_num_subparts: SUBPARTITIONS_SYM real_ulong_num  */
#line 5721 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            uint num_parts= (yyvsp[0].ulong_num);
            LEX *lex= Lex;
            if (unlikely(num_parts == 0))
              my_yyabort_error((ER_NO_PARTS_ERROR, MYF(0), "subpartitions"));
            lex->part_info->num_subparts= num_parts;
            lex->part_info->use_default_num_subpartitions= FALSE;
          }
#line 31058 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 756: /* part_defs: %empty  */
#line 5733 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->part_type == RANGE_PARTITION))
              my_yyabort_error((ER_PARTITIONS_MUST_BE_DEFINED_ERROR, MYF(0),
                                "RANGE"));
            if (unlikely(part_info->part_type == LIST_PARTITION))
              my_yyabort_error((ER_PARTITIONS_MUST_BE_DEFINED_ERROR, MYF(0),
                                "LIST"));
          }
#line 31072 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 757: /* part_defs: '(' part_def_list ')'  */
#line 5743 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            uint count_curr_parts= part_info->partitions.elements;
            if (part_info->num_parts != 0)
            {
              if (unlikely(part_info->num_parts !=
                           count_curr_parts))
              {
                thd->parse_error(ER_PARTITION_WRONG_NO_PART_ERROR);
                MYSQL_YYABORT;
              }
            }
            else if (count_curr_parts > 0)
            {
              part_info->num_parts= count_curr_parts;
            }
            part_info->count_curr_subparts= 0;
          }
#line 31095 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 758: /* part_def_list: part_definition  */
#line 5764 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 31101 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 759: /* part_def_list: part_def_list ',' part_definition  */
#line 5765 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                            {}
#line 31107 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 760: /* $@105: %empty  */
#line 5770 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            partition_element *p_elem= new (thd->mem_root) partition_element();

            if (unlikely(!p_elem) ||
                unlikely(part_info->partitions.push_back(p_elem, thd->mem_root)))
              MYSQL_YYABORT;

            p_elem->part_state= PART_NORMAL;
            p_elem->id= part_info->partitions.elements - 1;
            part_info->curr_part_elem= p_elem;
            part_info->current_partition= p_elem;
            part_info->use_default_partitions= FALSE;
            part_info->use_default_num_partitions= FALSE;
          }
#line 31127 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 761: /* part_definition: PARTITION_SYM $@105 part_name opt_part_values opt_part_options opt_sub_partition  */
#line 5789 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 31133 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 762: /* part_name: ident  */
#line 5794 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            partition_element *p_elem= part_info->curr_part_elem;
            if (unlikely(check_ident_length(&(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
            p_elem->partition_name= (yyvsp[0].ident_sys).str;
          }
#line 31145 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 763: /* opt_part_values: %empty  */
#line 5805 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->error_if_requires_values()))
                MYSQL_YYABORT;
              if (unlikely(part_info->part_type == VERSIONING_PARTITION))
                my_yyabort_error((ER_VERS_WRONG_PARTS, MYF(0),
                                  lex->create_last_non_select_table->
                                  table_name.str));
            }
            else
              part_info->part_type= HASH_PARTITION;
          }
#line 31165 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 764: /* $@106: %empty  */
#line 5821 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->part_type != RANGE_PARTITION))
                my_yyabort_error((ER_PARTITION_WRONG_VALUES_ERROR, MYF(0),
                                  "RANGE", "LESS THAN"));
            }
            else
              part_info->part_type= RANGE_PARTITION;
          }
#line 31182 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 765: /* opt_part_values: VALUES_LESS_SYM THAN_SYM $@106 part_func_max  */
#line 5833 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        {}
#line 31188 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 766: /* $@107: %empty  */
#line 5835 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->part_type != LIST_PARTITION))
                my_yyabort_error((ER_PARTITION_WRONG_VALUES_ERROR, MYF(0),
                                  "LIST", "IN"));
            }
            else
              part_info->part_type= LIST_PARTITION;
          }
#line 31205 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 767: /* opt_part_values: VALUES_IN_SYM $@107 part_values_in  */
#line 5847 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         {}
#line 31211 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 768: /* opt_part_values: CURRENT_SYM  */
#line 5849 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->part_values_current(thd))
              MYSQL_YYABORT;
          }
#line 31220 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 769: /* opt_part_values: HISTORY_SYM  */
#line 5854 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->part_values_history(thd))
              MYSQL_YYABORT;
          }
#line 31229 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 770: /* opt_part_values: DEFAULT  */
#line 5859 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->part_type != LIST_PARTITION))
                my_yyabort_error((ER_PARTITION_WRONG_VALUES_ERROR, MYF(0),
                                  "LIST", "DEFAULT"));
            }
            else
              part_info->part_type= LIST_PARTITION;
            if (unlikely(part_info->init_column_part(thd)))
              MYSQL_YYABORT;
            if (unlikely(part_info->add_max_value(thd)))
              MYSQL_YYABORT;
         }
#line 31250 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 771: /* part_func_max: MAXVALUE_SYM  */
#line 5879 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;

            if (unlikely(part_info->num_columns &&
                         part_info->num_columns != 1U))
            {
              part_info->print_debug("Kilroy II", NULL);
              thd->parse_error(ER_PARTITION_COLUMN_LIST_ERROR);
              MYSQL_YYABORT;
            }
            else
              part_info->num_columns= 1U;
            if (unlikely(part_info->init_column_part(thd)))
              MYSQL_YYABORT;
            if (unlikely(part_info->add_max_value(thd)))
              MYSQL_YYABORT;
          }
#line 31272 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 772: /* part_func_max: part_value_item  */
#line 5896 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 31278 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 773: /* part_values_in: part_value_item  */
#line 5901 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            part_info->print_debug("part_values_in: part_value_item", NULL);

            if (part_info->num_columns != 1U)
            {
              if (unlikely(!lex->is_partition_management() ||
                           part_info->num_columns == 0 ||
                           part_info->num_columns > MAX_REF_PARTS))
              {
                part_info->print_debug("Kilroy III", NULL);
                thd->parse_error(ER_PARTITION_COLUMN_LIST_ERROR);
                MYSQL_YYABORT;
              }
              /*
                Reorganize the current large array into a list of small
                arrays with one entry in each array. This can happen
                in the first partition of an ALTER TABLE statement where
                we ADD or REORGANIZE partitions. Also can only happen
                for LIST partitions.
              */
              if (unlikely(part_info->reorganize_into_single_field_col_val(thd)))
                MYSQL_YYABORT;
            }
          }
#line 31309 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 774: /* part_values_in: '(' part_value_list ')'  */
#line 5928 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->num_columns < 2U))
            {
              thd->parse_error(ER_ROW_SINGLE_PARTITION_FIELD_ERROR);
              MYSQL_YYABORT;
            }
          }
#line 31322 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 775: /* part_value_list: part_value_item  */
#line 5939 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 31328 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 776: /* part_value_list: part_value_list ',' part_value_item  */
#line 5940 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              {}
#line 31334 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 777: /* $@108: %empty  */
#line 5945 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->print_debug("( part_value_item", NULL);
            /* Initialisation code needed for each list of value expressions */
            if (unlikely(!(part_info->part_type == LIST_PARTITION &&
                           part_info->num_columns == 1U) &&
                           part_info->init_column_part(thd)))
              MYSQL_YYABORT;
          }
#line 31348 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 778: /* $@109: %empty  */
#line 5954 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               {}
#line 31354 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 779: /* part_value_item: '(' $@108 part_value_item_list $@109 ')'  */
#line 5956 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->print_debug(") part_value_item", NULL);
            if (part_info->num_columns == 0)
              part_info->num_columns= part_info->curr_list_object;
            if (unlikely(part_info->num_columns != part_info->curr_list_object))
            {
              /*
                All value items lists must be of equal length, in some cases
                which is covered by the above if-statement we don't know yet
                how many columns is in the partition so the assignment above
                ensures that we only report errors when we know we have an
                error.
              */
              part_info->print_debug("Kilroy I", NULL);
              thd->parse_error(ER_PARTITION_COLUMN_LIST_ERROR);
              MYSQL_YYABORT;
            }
            part_info->curr_list_object= 0;
          }
#line 31379 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 780: /* part_value_item_list: part_value_expr_item  */
#line 5979 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               {}
#line 31385 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 781: /* part_value_item_list: part_value_item_list ',' part_value_expr_item  */
#line 5980 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                        {}
#line 31391 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 782: /* part_value_expr_item: MAXVALUE_SYM  */
#line 5985 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->part_type == LIST_PARTITION))
            {
              thd->parse_error(ER_MAXVALUE_IN_VALUES_IN);
              MYSQL_YYABORT;
            }
            if (unlikely(part_info->add_max_value(thd)))
              MYSQL_YYABORT;
          }
#line 31406 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 783: /* part_value_expr_item: bit_expr  */
#line 5996 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            Item *part_expr= (yyvsp[0].item);

            if (unlikely(!lex->safe_to_cache_query))
            {
              thd->parse_error(ER_WRONG_EXPR_IN_PARTITION_FUNC_ERROR);
              MYSQL_YYABORT;
            }
            if (unlikely(part_info->add_column_list_value(thd, part_expr)))
              MYSQL_YYABORT;
          }
#line 31424 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 784: /* opt_sub_partition: %empty  */
#line 6014 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->num_subparts != 0 &&
                         !part_info->use_default_subpartitions))
            {
              /*
                We come here when we have defined subpartitions on the first
                partition but not on all the subsequent partitions. 
              */
              thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
              MYSQL_YYABORT;
            }
          }
#line 31442 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 785: /* opt_sub_partition: '(' sub_part_list ')'  */
#line 6028 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (part_info->num_subparts != 0)
            {
              if (unlikely(part_info->num_subparts !=
                           part_info->count_curr_subparts))
              {
                thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
                MYSQL_YYABORT;
              }
            }
            else if (part_info->count_curr_subparts > 0)
            {
              if (unlikely(part_info->partitions.elements > 1))
              {
                thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
                MYSQL_YYABORT;
              }
              part_info->num_subparts= part_info->count_curr_subparts;
            }
            part_info->count_curr_subparts= 0;
          }
#line 31469 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 786: /* sub_part_list: sub_part_definition  */
#line 6053 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              {}
#line 31475 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 787: /* sub_part_list: sub_part_list ',' sub_part_definition  */
#line 6054 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                {}
#line 31481 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 788: /* $@110: %empty  */
#line 6059 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            partition_element *curr_part= part_info->current_partition;
            partition_element *sub_p_elem= new (thd->mem_root)
                                           partition_element(curr_part);
            if (unlikely(part_info->use_default_subpartitions &&
                         part_info->partitions.elements >= 2))
            {
              /*
                create table t1 (a int)
                partition by list (a) subpartition by hash (a)
                (partition p0 values in (1),
                 partition p1 values in (2) subpartition sp11);
                causes use to arrive since we are on the second
                partition, but still use_default_subpartitions
                is set. When we come here we're processing at least
                the second partition (the current partition processed
                have already been put into the partitions list.
              */
              thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
              MYSQL_YYABORT;
            }
            if (unlikely(!sub_p_elem) ||
                unlikely(curr_part->subpartitions.push_back(sub_p_elem, thd->mem_root)))
              MYSQL_YYABORT;

            sub_p_elem->id= curr_part->subpartitions.elements - 1;
            part_info->curr_part_elem= sub_p_elem;
            part_info->use_default_subpartitions= FALSE;
            part_info->use_default_num_subpartitions= FALSE;
            part_info->count_curr_subparts++;
          }
#line 31518 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 789: /* sub_part_definition: SUBPARTITION_SYM $@110 sub_name opt_part_options  */
#line 6091 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                    {}
#line 31524 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 790: /* sub_name: ident_or_text  */
#line 6096 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(check_ident_length(&(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
            Lex->part_info->curr_part_elem->partition_name= (yyvsp[0].lex_str).str;
          }
#line 31534 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 791: /* opt_part_options: %empty  */
#line 6104 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     {}
#line 31540 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 792: /* opt_part_options: opt_part_option_list  */
#line 6105 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              {}
#line 31546 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 793: /* opt_part_option_list: opt_part_option_list opt_part_option  */
#line 6109 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              {}
#line 31552 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 794: /* opt_part_option_list: opt_part_option  */
#line 6110 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         {}
#line 31558 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 795: /* opt_part_option: TABLESPACE opt_equal ident_or_text  */
#line 6115 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->tablespace_name= (yyvsp[0].lex_str).str; }
#line 31564 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 796: /* opt_part_option: opt_storage ENGINE_SYM opt_equal storage_engines  */
#line 6117 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->curr_part_elem->engine_type= (yyvsp[0].db_type);
            part_info->default_engine_type= (yyvsp[0].db_type);
          }
#line 31574 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 797: /* opt_part_option: CONNECTION_SYM opt_equal TEXT_STRING_sys  */
#line 6123 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->part_info->curr_part_elem->connect_string.str= (yyvsp[0].lex_str).str;
            lex->part_info->curr_part_elem->connect_string.length= (yyvsp[0].lex_str).length;
          }
#line 31584 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 798: /* opt_part_option: NODEGROUP_SYM opt_equal real_ulong_num  */
#line 6129 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->nodegroup_id= (uint16) (yyvsp[0].ulong_num); }
#line 31590 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 799: /* opt_part_option: MAX_ROWS opt_equal real_ulonglong_num  */
#line 6131 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->part_max_rows= (ha_rows) (yyvsp[0].ulonglong_number); }
#line 31596 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 800: /* opt_part_option: MIN_ROWS opt_equal real_ulonglong_num  */
#line 6133 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->part_min_rows= (ha_rows) (yyvsp[0].ulonglong_number); }
#line 31602 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 801: /* opt_part_option: DATA_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6135 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->data_file_name= (yyvsp[0].lex_str).str; }
#line 31608 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 802: /* opt_part_option: INDEX_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6137 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->index_file_name= (yyvsp[0].lex_str).str; }
#line 31614 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 803: /* opt_part_option: COMMENT_SYM opt_equal TEXT_STRING_sys  */
#line 6139 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->part_comment= (yyvsp[0].lex_str).str; }
#line 31620 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 804: /* opt_versioning_rotation: %empty  */
#line 6143 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     {}
#line 31626 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 805: /* $@111: %empty  */
#line 6144 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         { Lex->clause_that_disallows_subselect= "INTERVAL"; }
#line 31632 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 806: /* opt_versioning_rotation: $@111 INTERVAL_SYM expr interval opt_versioning_interval_start  */
#line 6146 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           partition_info *part_info= Lex->part_info;
           if (unlikely(part_info->vers_set_interval(thd, (yyvsp[-2].item), (yyvsp[-1].interval), (yyvsp[0].ulong_num))))
             MYSQL_YYABORT;
         }
#line 31642 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 807: /* opt_versioning_rotation: LIMIT ulonglong_num  */
#line 6152 "/home/buildbot/git/sql/sql_yacc_ora.yy"
       {
         partition_info *part_info= Lex->part_info;
         if (unlikely(part_info->vers_set_limit((yyvsp[0].ulonglong_number))))
         {
           my_error(ER_PART_WRONG_VALUE, MYF(0),
                    Lex->create_last_non_select_table->table_name.str,
                    "LIMIT");
           MYSQL_YYABORT;
         }
       }
#line 31657 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 808: /* opt_versioning_interval_start: %empty  */
#line 6167 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           (yyval.ulong_num)= thd->query_start();
         }
#line 31665 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 809: /* opt_versioning_interval_start: STARTS_SYM ulong_num  */
#line 6171 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           /* only allowed from mysql_unpack_partition() */
           if (unlikely(!Lex->part_info->table))
           {
             thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-1].kwd).pos());
             MYSQL_YYABORT;
           }
           (yyval.ulong_num)= (ulong)(yyvsp[0].ulong_num);
         }
#line 31679 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 810: /* opt_as: %empty  */
#line 6187 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 31685 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 811: /* opt_as: AS  */
#line 6188 "/home/buildbot/git/sql/sql_yacc_ora.yy"
             {}
#line 31691 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 812: /* opt_create_database_options: %empty  */
#line 6192 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 31697 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 813: /* opt_create_database_options: create_database_options  */
#line 6193 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  {}
#line 31703 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 814: /* create_database_options: create_database_option  */
#line 6197 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 {}
#line 31709 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 815: /* create_database_options: create_database_options create_database_option  */
#line 6198 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                         {}
#line 31715 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 816: /* create_database_option: default_collation  */
#line 6202 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            {}
#line 31721 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 817: /* create_database_option: default_charset  */
#line 6203 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 31727 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 818: /* opt_if_not_exists_table_element: %empty  */
#line 6208 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->check_exists= FALSE;
          }
#line 31735 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 819: /* opt_if_not_exists_table_element: IF_SYM not EXISTS  */
#line 6212 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->check_exists= TRUE;
          }
#line 31743 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 820: /* opt_if_not_exists: %empty  */
#line 6219 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.object_ddl_options).init();
          }
#line 31751 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 821: /* opt_if_not_exists: IF_SYM not EXISTS  */
#line 6223 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.object_ddl_options).set(DDL_options_st::OPT_IF_NOT_EXISTS);
          }
#line 31759 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 822: /* create_or_replace: CREATE  */
#line 6230 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.object_ddl_options).init();
          }
#line 31767 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 823: /* create_or_replace: CREATE OR_SYM REPLACE  */
#line 6234 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.object_ddl_options).set(DDL_options_st::OPT_OR_REPLACE);
          }
#line 31775 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 831: /* create_table_option: ENGINE_SYM opt_equal ident_or_text  */
#line 6257 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (!lex->m_sql_cmd)
            {
              DBUG_ASSERT(lex->sql_command == SQLCOM_ALTER_TABLE);
              if (!(lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_alter_table()))
                MYSQL_YYABORT;
            }
            Storage_engine_name *opt=
              lex->m_sql_cmd->option_storage_engine_name();
            DBUG_ASSERT(opt); // Expect a proper Sql_cmd
            *opt= Storage_engine_name((yyvsp[0].lex_str));
            lex->create_info.used_fields|= HA_CREATE_USED_ENGINE;
          }
#line 31794 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 832: /* create_table_option: MAX_ROWS opt_equal ulonglong_num  */
#line 6272 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.max_rows= (yyvsp[0].ulonglong_number);
            Lex->create_info.used_fields|= HA_CREATE_USED_MAX_ROWS;
          }
#line 31803 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 833: /* create_table_option: MIN_ROWS opt_equal ulonglong_num  */
#line 6277 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.min_rows= (yyvsp[0].ulonglong_number);
            Lex->create_info.used_fields|= HA_CREATE_USED_MIN_ROWS;
          }
#line 31812 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 834: /* create_table_option: AVG_ROW_LENGTH opt_equal ulong_num  */
#line 6282 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.avg_row_length=(yyvsp[0].ulong_num);
            Lex->create_info.used_fields|= HA_CREATE_USED_AVG_ROW_LENGTH;
          }
#line 31821 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 835: /* create_table_option: PASSWORD_SYM opt_equal TEXT_STRING_sys  */
#line 6287 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.password=(yyvsp[0].lex_str).str;
            Lex->create_info.used_fields|= HA_CREATE_USED_PASSWORD;
          }
#line 31830 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 836: /* create_table_option: COMMENT_SYM opt_equal TEXT_STRING_sys  */
#line 6292 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.comment=(yyvsp[0].lex_str);
            Lex->create_info.used_fields|= HA_CREATE_USED_COMMENT;
          }
#line 31839 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 837: /* create_table_option: AUTO_INC opt_equal ulonglong_num  */
#line 6297 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.auto_increment_value=(yyvsp[0].ulonglong_number);
            Lex->create_info.used_fields|= HA_CREATE_USED_AUTO;
          }
#line 31848 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 838: /* create_table_option: PACK_KEYS_SYM opt_equal ulong_num  */
#line 6302 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            switch((yyvsp[0].ulong_num)) {
            case 0:
                Lex->create_info.table_options|= HA_OPTION_NO_PACK_KEYS;
                break;
            case 1:
                Lex->create_info.table_options|= HA_OPTION_PACK_KEYS;
                break;
            default:
                thd->parse_error();
                MYSQL_YYABORT;
            }
            Lex->create_info.used_fields|= HA_CREATE_USED_PACK_KEYS;
          }
#line 31867 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 839: /* create_table_option: PACK_KEYS_SYM opt_equal DEFAULT  */
#line 6317 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.table_options&=
              ~(HA_OPTION_PACK_KEYS | HA_OPTION_NO_PACK_KEYS);
            Lex->create_info.used_fields|= HA_CREATE_USED_PACK_KEYS;
          }
#line 31877 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 840: /* create_table_option: STATS_AUTO_RECALC_SYM opt_equal ulong_num  */
#line 6323 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            switch((yyvsp[0].ulong_num)) {
            case 0:
                Lex->create_info.stats_auto_recalc= HA_STATS_AUTO_RECALC_OFF;
                break;
            case 1:
                Lex->create_info.stats_auto_recalc= HA_STATS_AUTO_RECALC_ON;
                break;
            default:
                thd->parse_error();
                MYSQL_YYABORT;
            }
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_AUTO_RECALC;
          }
#line 31896 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 841: /* create_table_option: STATS_AUTO_RECALC_SYM opt_equal DEFAULT  */
#line 6338 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.stats_auto_recalc= HA_STATS_AUTO_RECALC_DEFAULT;
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_AUTO_RECALC;
          }
#line 31905 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 842: /* create_table_option: STATS_PERSISTENT_SYM opt_equal ulong_num  */
#line 6343 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            switch((yyvsp[0].ulong_num)) {
            case 0:
                Lex->create_info.table_options|= HA_OPTION_NO_STATS_PERSISTENT;
                break;
            case 1:
                Lex->create_info.table_options|= HA_OPTION_STATS_PERSISTENT;
                break;
            default:
                thd->parse_error();
                MYSQL_YYABORT;
            }
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_PERSISTENT;
          }
#line 31924 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 843: /* create_table_option: STATS_PERSISTENT_SYM opt_equal DEFAULT  */
#line 6358 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.table_options&=
              ~(HA_OPTION_STATS_PERSISTENT | HA_OPTION_NO_STATS_PERSISTENT);
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_PERSISTENT;
          }
#line 31934 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 844: /* create_table_option: STATS_SAMPLE_PAGES_SYM opt_equal ulong_num  */
#line 6364 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* From user point of view STATS_SAMPLE_PAGES can be specified as
            STATS_SAMPLE_PAGES=N (where 0<N<=65535, it does not make sense to
            scan 0 pages) or STATS_SAMPLE_PAGES=default. Internally we record
            =default as 0. See create_frm() in sql/table.cc, we use only two
            bytes for stats_sample_pages and this is why we do not allow
            larger values. 65535 pages, 16kb each means to sample 1GB, which
            is impractical. If at some point this needs to be extended, then
            we can store the higher bits from stats_sample_pages in .frm too. */
            if (unlikely((yyvsp[0].ulong_num) == 0 || (yyvsp[0].ulong_num) > 0xffff))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
            Lex->create_info.stats_sample_pages=(yyvsp[0].ulong_num);
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_SAMPLE_PAGES;
          }
#line 31956 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 845: /* create_table_option: STATS_SAMPLE_PAGES_SYM opt_equal DEFAULT  */
#line 6382 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.stats_sample_pages=0;
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_SAMPLE_PAGES;
          }
#line 31965 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 846: /* create_table_option: CHECKSUM_SYM opt_equal ulong_num  */
#line 6387 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.table_options|= (yyvsp[0].ulong_num) ? HA_OPTION_CHECKSUM : HA_OPTION_NO_CHECKSUM;
            Lex->create_info.used_fields|= HA_CREATE_USED_CHECKSUM;
          }
#line 31974 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 847: /* create_table_option: TABLE_CHECKSUM_SYM opt_equal ulong_num  */
#line 6392 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             Lex->create_info.table_options|= (yyvsp[0].ulong_num) ? HA_OPTION_CHECKSUM : HA_OPTION_NO_CHECKSUM;
             Lex->create_info.used_fields|= HA_CREATE_USED_CHECKSUM;
          }
#line 31983 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 848: /* create_table_option: PAGE_CHECKSUM_SYM opt_equal choice  */
#line 6397 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.used_fields|= HA_CREATE_USED_PAGE_CHECKSUM;
            Lex->create_info.page_checksum= (yyvsp[0].choice);
          }
#line 31992 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 849: /* create_table_option: DELAY_KEY_WRITE_SYM opt_equal ulong_num  */
#line 6402 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.table_options|= (yyvsp[0].ulong_num) ? HA_OPTION_DELAY_KEY_WRITE : HA_OPTION_NO_DELAY_KEY_WRITE;
            Lex->create_info.used_fields|= HA_CREATE_USED_DELAY_KEY_WRITE;
          }
#line 32001 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 850: /* create_table_option: ROW_FORMAT_SYM opt_equal row_types  */
#line 6407 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.row_type= (yyvsp[0].row_type);
            Lex->create_info.used_fields|= HA_CREATE_USED_ROW_FORMAT;
          }
#line 32010 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 851: /* $@112: %empty  */
#line 6412 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->first_select_lex()->table_list.save_and_clear(&Lex->save_list);
          }
#line 32018 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 852: /* create_table_option: UNION_SYM opt_equal $@112 '(' opt_table_list ')'  */
#line 6416 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Move the union list to the merge_list and exclude its tables
              from the global list.
            */
            LEX *lex=Lex;
            lex->create_info.merge_list= lex->first_select_lex()->table_list.first;
            lex->first_select_lex()->table_list= lex->save_list;
            /*
              When excluding union list from the global list we assume that
              elements of the former immediately follow elements which represent
              table being created/altered and parent tables.
            */
            TABLE_LIST *last_non_sel_table= lex->create_last_non_select_table;
            DBUG_ASSERT(last_non_sel_table->next_global ==
                        lex->create_info.merge_list);
            last_non_sel_table->next_global= 0;
            Lex->query_tables_last= &last_non_sel_table->next_global;

            lex->create_info.used_fields|= HA_CREATE_USED_UNION;
          }
#line 32044 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 855: /* create_table_option: INSERT_METHOD opt_equal merge_insert_types  */
#line 6440 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.merge_insert_method= (yyvsp[0].ulong_num);
            Lex->create_info.used_fields|= HA_CREATE_USED_INSERT_METHOD;
          }
#line 32053 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 856: /* create_table_option: DATA_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6445 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.data_file_name= (yyvsp[0].lex_str).str;
            Lex->create_info.used_fields|= HA_CREATE_USED_DATADIR;
          }
#line 32062 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 857: /* create_table_option: INDEX_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6450 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.index_file_name= (yyvsp[0].lex_str).str;
            Lex->create_info.used_fields|= HA_CREATE_USED_INDEXDIR;
          }
#line 32071 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 858: /* create_table_option: TABLESPACE ident  */
#line 6455 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {Lex->create_info.tablespace= (yyvsp[0].ident_sys).str;}
#line 32077 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 859: /* create_table_option: STORAGE_SYM DISK_SYM  */
#line 6457 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {Lex->create_info.storage_media= HA_SM_DISK;}
#line 32083 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 860: /* create_table_option: STORAGE_SYM MEMORY_SYM  */
#line 6459 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {Lex->create_info.storage_media= HA_SM_MEMORY;}
#line 32089 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 861: /* create_table_option: CONNECTION_SYM opt_equal TEXT_STRING_sys  */
#line 6461 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.connect_string.str= (yyvsp[0].lex_str).str;
            Lex->create_info.connect_string.length= (yyvsp[0].lex_str).length;
            Lex->create_info.used_fields|= HA_CREATE_USED_CONNECTION;
          }
#line 32099 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 862: /* create_table_option: KEY_BLOCK_SIZE opt_equal ulong_num  */
#line 6467 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.used_fields|= HA_CREATE_USED_KEY_BLOCK_SIZE;
            Lex->create_info.key_block_size= (yyvsp[0].ulong_num);
          }
#line 32108 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 863: /* create_table_option: TRANSACTIONAL_SYM opt_equal choice  */
#line 6472 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    Lex->create_info.used_fields|= HA_CREATE_USED_TRANSACTIONAL;
            Lex->create_info.transactional= (yyvsp[0].choice);
          }
#line 32117 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 864: /* create_table_option: IDENT_sys equal TEXT_STRING_sys  */
#line 6477 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[0].lex_str).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].lex_str), true,
                                       &Lex->create_info.option_list,
                                       &Lex->option_list_last);
          }
#line 32130 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 865: /* create_table_option: IDENT_sys equal ident  */
#line 6486 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[0].ident_sys).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ident_sys), false,
                                       &Lex->create_info.option_list,
                                       &Lex->option_list_last);
          }
#line 32143 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 866: /* create_table_option: IDENT_sys equal real_ulonglong_num  */
#line 6495 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ulonglong_number), &Lex->create_info.option_list,
                                       &Lex->option_list_last, thd->mem_root);
          }
#line 32153 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 867: /* create_table_option: IDENT_sys equal DEFAULT  */
#line 6501 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), &Lex->create_info.option_list,
                                       &Lex->option_list_last);
          }
#line 32163 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 868: /* create_table_option: SEQUENCE_SYM opt_equal choice  */
#line 6507 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    Lex->create_info.used_fields|= HA_CREATE_USED_SEQUENCE;
            Lex->create_info.sequence= ((yyvsp[0].choice) == HA_CHOICE_YES);
	  }
#line 32172 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 872: /* versioning_option: WITH_SYSTEM_SYM VERSIONING_SYM  */
#line 6521 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.options & HA_LEX_CREATE_TMP_TABLE))
            {
              if (DBUG_EVALUATE_IF("sysvers_force", 0, 1))
              {
                my_error(ER_VERS_NOT_SUPPORTED, MYF(0), "CREATE TEMPORARY TABLE");
                MYSQL_YYABORT;
              }
            }
            else
            {
              Lex->alter_info.flags|= ALTER_ADD_SYSTEM_VERSIONING;
              Lex->create_info.options|= HA_VERSIONED_TABLE;
            }
          }
#line 32192 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 873: /* default_charset: opt_default charset opt_equal charset_name_or_default  */
#line 6540 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.add_table_option_default_charset((yyvsp[0].charset))))
              MYSQL_YYABORT;
          }
#line 32201 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 874: /* default_collation: opt_default COLLATE_SYM opt_equal collation_name_or_default  */
#line 6548 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            HA_CREATE_INFO *cinfo= &Lex->create_info;
            if (unlikely((cinfo->used_fields & HA_CREATE_USED_DEFAULT_CHARSET) &&
                         cinfo->default_table_charset && (yyvsp[0].charset) &&
                         !((yyvsp[0].charset)= merge_charset_and_collation(cinfo->default_table_charset,
                                                           (yyvsp[0].charset)))))
              MYSQL_YYABORT;

            Lex->create_info.default_table_charset= (yyvsp[0].charset);
            Lex->create_info.used_fields|= HA_CREATE_USED_DEFAULT_CHARSET;
          }
#line 32217 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 875: /* storage_engines: ident_or_text  */
#line 6563 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Storage_engine_name((yyvsp[0].lex_str)).
                 resolve_storage_engine_with_error(thd, &(yyval.db_type),
                                            thd->lex->create_info.tmp_table()))
              MYSQL_YYABORT;
          }
#line 32228 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 876: /* known_storage_engines: ident_or_text  */
#line 6573 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            plugin_ref plugin;
            if (likely((plugin= ha_resolve_by_name(thd, &(yyvsp[0].lex_str), false))))
              (yyval.db_type)= plugin_hton(plugin);
            else
              my_yyabort_error((ER_UNKNOWN_STORAGE_ENGINE, MYF(0), (yyvsp[0].lex_str).str));
          }
#line 32240 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 877: /* row_types: DEFAULT  */
#line 6583 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_DEFAULT; }
#line 32246 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 878: /* row_types: FIXED_SYM  */
#line 6584 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_FIXED; }
#line 32252 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 879: /* row_types: DYNAMIC_SYM  */
#line 6585 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_DYNAMIC; }
#line 32258 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 880: /* row_types: COMPRESSED_SYM  */
#line 6586 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_COMPRESSED; }
#line 32264 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 881: /* row_types: REDUNDANT_SYM  */
#line 6587 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_REDUNDANT; }
#line 32270 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 882: /* row_types: COMPACT_SYM  */
#line 6588 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_COMPACT; }
#line 32276 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 883: /* row_types: PAGE_SYM  */
#line 6589 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_PAGE; }
#line 32282 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 884: /* merge_insert_types: NO_SYM  */
#line 6593 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.ulong_num)= MERGE_INSERT_DISABLED; }
#line 32288 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 885: /* merge_insert_types: FIRST_SYM  */
#line 6594 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.ulong_num)= MERGE_INSERT_TO_FIRST; }
#line 32294 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 886: /* merge_insert_types: LAST_SYM  */
#line 6595 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.ulong_num)= MERGE_INSERT_TO_LAST; }
#line 32300 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 887: /* udf_type: STRING_SYM  */
#line 6599 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     {(yyval.num) = (int) STRING_RESULT; }
#line 32306 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 888: /* udf_type: REAL  */
#line 6600 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               {(yyval.num) = (int) REAL_RESULT; }
#line 32312 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 889: /* udf_type: DECIMAL_SYM  */
#line 6601 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {(yyval.num) = (int) DECIMAL_RESULT; }
#line 32318 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 890: /* udf_type: INT_SYM  */
#line 6602 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {(yyval.num) = (int) INT_RESULT; }
#line 32324 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 891: /* create_field_list: field_list  */
#line 6608 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->create_last_non_select_table= Lex->last_table();
        }
#line 32332 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 892: /* create_field_list_parens: LEFT_PAREN_ALT field_list ')'  */
#line 6615 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->create_last_non_select_table= Lex->last_table();
        }
#line 32340 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 895: /* field_list_item: column_def  */
#line 6626 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { }
#line 32346 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 899: /* field_list_item: PERIOD_SYM period_for_application_time  */
#line 6630 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                 { }
#line 32352 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 900: /* column_def: field_spec  */
#line 6635 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.create_field)= (yyvsp[0].create_field); }
#line 32358 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 901: /* column_def: field_spec references  */
#line 6637 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.create_field)= (yyvsp[-1].create_field); }
#line 32364 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 902: /* $@113: %empty  */
#line 6642 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key(Key::MULTIPLE, &(yyvsp[-1].lex_str), (yyvsp[0].key_alg), (yyvsp[-2].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 32374 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 903: /* key_def: key_or_index opt_if_not_exists opt_ident opt_USING_key_algorithm $@113 '(' key_list ')' normal_key_options  */
#line 6647 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              { }
#line 32380 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 904: /* $@114: %empty  */
#line 6649 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key(Key::MULTIPLE, &(yyvsp[-2].ident_sys), (yyvsp[0].key_alg), (yyvsp[-3].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 32390 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 905: /* key_def: key_or_index opt_if_not_exists ident TYPE_SYM btree_or_rtree $@114 '(' key_list ')' normal_key_options  */
#line 6654 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              { }
#line 32396 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 906: /* $@115: %empty  */
#line 6656 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-3].key_type), &(yyvsp[0].lex_str), HA_KEY_ALG_UNDEF, (yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 32406 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 907: /* key_def: fulltext opt_key_or_index opt_if_not_exists opt_ident $@115 '(' key_list ')' fulltext_key_options  */
#line 6661 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { }
#line 32412 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 908: /* $@116: %empty  */
#line 6663 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-3].key_type), &(yyvsp[0].lex_str), HA_KEY_ALG_UNDEF, (yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 32422 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 909: /* key_def: spatial opt_key_or_index opt_if_not_exists opt_ident $@116 '(' key_list ')' spatial_key_options  */
#line 6668 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                               { }
#line 32428 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 910: /* $@117: %empty  */
#line 6672 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-3].key_type), (yyvsp[-1].lex_str).str ? &(yyvsp[-1].lex_str) : &(yyvsp[-4].lex_str), (yyvsp[0].key_alg), (yyvsp[-2].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 32438 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 911: /* key_def: opt_constraint constraint_key_type opt_if_not_exists opt_ident opt_USING_key_algorithm $@117 '(' key_list ')' normal_key_options  */
#line 6677 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              { }
#line 32444 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 912: /* $@118: %empty  */
#line 6680 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-4].key_type), (yyvsp[-2].ident_sys).str ? &(yyvsp[-2].ident_sys) : &(yyvsp[-5].lex_str), (yyvsp[0].key_alg), (yyvsp[-3].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 32454 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 913: /* key_def: opt_constraint constraint_key_type opt_if_not_exists ident TYPE_SYM btree_or_rtree $@118 '(' key_list ')' normal_key_options  */
#line 6685 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              { }
#line 32460 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 914: /* $@119: %empty  */
#line 6687 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->check_add_key((yyvsp[-1].object_ddl_options))) ||
                unlikely(!(Lex->last_key= (new (thd->mem_root)
                                           Key(Key::MULTIPLE,
                                           (yyvsp[-4].lex_str).str ? &(yyvsp[-4].lex_str) : &(yyvsp[0].lex_str),
                                           HA_KEY_ALG_UNDEF, true, (yyvsp[-1].object_ddl_options))))))
              MYSQL_YYABORT;
            Lex->option_list= NULL;
          }
#line 32474 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 915: /* key_def: opt_constraint FOREIGN KEY_SYM opt_if_not_exists opt_ident $@119 '(' key_list ')' references  */
#line 6697 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Key *key= (new (thd->mem_root)
                       Foreign_key((yyvsp[-5].lex_str).str ? &(yyvsp[-5].lex_str) : &(yyvsp[-9].lex_str),
                                   &lex->last_key->columns,
                                   &(yyvsp[0].table)->db,
                                   &(yyvsp[0].table)->table,
                                   &lex->ref_list,
                                   lex->fk_delete_opt,
                                   lex->fk_update_opt,
                                   lex->fk_match_option,
                                    (yyvsp[-6].object_ddl_options)));
            if (unlikely(key == NULL))
              MYSQL_YYABORT;
            /*
              handle_if_exists_options() expectes the two keys in this order:
              the Foreign_key, followed by its auto-generated Key.
            */
            lex->alter_info.key_list.push_back(key, thd->mem_root);
            lex->alter_info.key_list.push_back(Lex->last_key, thd->mem_root);
            lex->option_list= NULL;

            /* Only used for ALTER TABLE. Ignored otherwise. */
            lex->alter_info.flags|= ALTER_ADD_FOREIGN_KEY;
          }
#line 32504 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 916: /* constraint_def: opt_constraint check_constraint  */
#line 6726 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           Lex->add_constraint((yyvsp[-1].lex_str), (yyvsp[0].virtual_column), FALSE);
         }
#line 32512 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 917: /* period_for_system_time: PERIOD_SYM FOR_SYSTEM_TIME_SYM '(' ident ',' ident ')'  */
#line 6734 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Vers_parse_info &info= Lex->vers_get_info();
            info.set_period((yyvsp[-3].ident_sys), (yyvsp[-1].ident_sys));
          }
#line 32521 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 918: /* period_for_application_time: FOR_SYM ident '(' ident ',' ident ')'  */
#line 6742 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->add_period((yyvsp[-5].ident_sys), (yyvsp[-3].ident_sys), (yyvsp[-1].ident_sys)))
              MYSQL_YYABORT;
          }
#line 32530 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 919: /* opt_check_constraint: %empty  */
#line 6749 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.virtual_column)= (Virtual_column_info*) 0; }
#line 32536 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 920: /* opt_check_constraint: check_constraint  */
#line 6750 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.virtual_column)= (yyvsp[0].virtual_column);}
#line 32542 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 921: /* check_constraint: CHECK_SYM '(' expr ')'  */
#line 6755 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Virtual_column_info *v= add_virtual_expression(thd, (yyvsp[-1].item));
            if (unlikely(!v))
              MYSQL_YYABORT;
            (yyval.virtual_column)= v;
          }
#line 32553 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 922: /* opt_constraint_no_id: %empty  */
#line 6764 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 32559 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 923: /* opt_constraint_no_id: CONSTRAINT  */
#line 6765 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 32565 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 924: /* opt_constraint: %empty  */
#line 6769 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str)= null_clex_str; }
#line 32571 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 925: /* opt_constraint: constraint  */
#line 6770 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.lex_str)= (yyvsp[0].lex_str); }
#line 32577 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 926: /* constraint: CONSTRAINT opt_ident  */
#line 6774 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.lex_str)=(yyvsp[0].lex_str); }
#line 32583 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 927: /* @120: %empty  */
#line 6779 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Create_field *f= new (thd->mem_root) Create_field();

            if (unlikely(check_string_char_length(&(yyvsp[0].lex_str), 0, NAME_CHAR_LEN,
                                                  system_charset_info, 1)))
              my_yyabort_error((ER_TOO_LONG_IDENT, MYF(0), (yyvsp[0].lex_str).str));

            if (unlikely(!f))
              MYSQL_YYABORT;

            lex->init_last_field(f, &(yyvsp[0].lex_str), NULL);
            (yyval.create_field)= f;
            lex->parsing_options.lookup_keywords_after_qualifier= true;
          }
#line 32603 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 928: /* field_spec: field_ident @120 field_type_or_serial opt_check_constraint  */
#line 6795 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->parsing_options.lookup_keywords_after_qualifier= false;
            (yyval.create_field)= (yyvsp[-2].create_field);

            (yyval.create_field)->check_constraint= (yyvsp[0].virtual_column);

            if (unlikely((yyval.create_field)->check(thd)))
              MYSQL_YYABORT;

            lex->alter_info.create_list.push_back((yyval.create_field), thd->mem_root);

            (yyval.create_field)->create_if_not_exists= Lex->check_exists;
            if ((yyval.create_field)->flags & PRI_KEY_FLAG)
              lex->add_key_to_list(&(yyvsp[-3].lex_str), Key::PRIMARY, lex->check_exists);
            else if ((yyval.create_field)->flags & UNIQUE_KEY_FLAG)
              lex->add_key_to_list(&(yyvsp[-3].lex_str), Key::UNIQUE, lex->check_exists);
          }
#line 32626 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 929: /* $@121: %empty  */
#line 6816 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { Lex->last_field->set_attributes((yyvsp[0].Lex_field_type), Lex->charset); }
#line 32632 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 931: /* $@122: %empty  */
#line 6819 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->set_handler(&type_handler_longlong);
            Lex->last_field->flags|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG
                                     | UNSIGNED_FLAG | UNIQUE_KEY_FLAG;
            Lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 32643 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 933: /* opt_serial_attribute: %empty  */
#line 6829 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 32649 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 934: /* opt_serial_attribute: opt_serial_attribute_list  */
#line 6830 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                    {}
#line 32655 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 935: /* opt_serial_attribute_list: opt_serial_attribute_list serial_attribute  */
#line 6834 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                     {}
#line 32661 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 937: /* opt_asrow_attribute: %empty  */
#line 6839 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 32667 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 938: /* opt_asrow_attribute: opt_asrow_attribute_list  */
#line 6840 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   {}
#line 32673 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 939: /* opt_asrow_attribute_list: opt_asrow_attribute_list asrow_attribute  */
#line 6844 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                   {}
#line 32679 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 941: /* field_def: %empty  */
#line 6849 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { }
#line 32685 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 945: /* $@123: %empty  */
#line 6854 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           Lex->last_field->vcol_info= (yyvsp[0].virtual_column);
           Lex->last_field->flags&= ~NOT_NULL_FLAG; // undo automatic NOT NULL for timestamps
         }
#line 32694 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 947: /* field_def: opt_generated_always AS ROW_SYM START_SYM opt_asrow_attribute  */
#line 6860 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->last_field_generated_always_as_row_start())
              MYSQL_YYABORT;
          }
#line 32703 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 948: /* field_def: opt_generated_always AS ROW_SYM END opt_asrow_attribute  */
#line 6865 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->last_field_generated_always_as_row_end())
              MYSQL_YYABORT;
          }
#line 32712 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 949: /* opt_generated_always: %empty  */
#line 6872 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 32718 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 950: /* opt_generated_always: GENERATED_SYM ALWAYS_SYM  */
#line 6873 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   {}
#line 32724 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 951: /* vcol_opt_specifier: %empty  */
#line 6878 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(FALSE);
          }
#line 32732 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 952: /* vcol_opt_specifier: VIRTUAL_SYM  */
#line 6882 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(FALSE);
          }
#line 32740 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 953: /* vcol_opt_specifier: PERSISTENT_SYM  */
#line 6886 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(TRUE);
          }
#line 32748 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 954: /* vcol_opt_specifier: STORED_SYM  */
#line 6890 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(TRUE);
          }
#line 32756 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 955: /* vcol_opt_attribute: %empty  */
#line 6896 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 32762 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 956: /* vcol_opt_attribute: vcol_opt_attribute_list  */
#line 6897 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  {}
#line 32768 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 957: /* vcol_opt_attribute_list: vcol_opt_attribute_list vcol_attribute  */
#line 6901 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                 {}
#line 32774 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 959: /* vcol_attribute: UNIQUE_SYM  */
#line 6907 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= UNIQUE_KEY_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 32784 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 960: /* vcol_attribute: UNIQUE_SYM KEY_SYM  */
#line 6913 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= UNIQUE_KEY_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 32794 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 961: /* vcol_attribute: COMMENT_SYM TEXT_STRING_sys  */
#line 6918 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->last_field->comment= (yyvsp[0].lex_str); }
#line 32800 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 962: /* vcol_attribute: INVISIBLE_SYM  */
#line 6920 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->invisible= INVISIBLE_USER;
          }
#line 32808 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 963: /* $@124: %empty  */
#line 6927 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              "PARSE_VCOL_EXPR" can only be used by the SQL server
              when reading a '*.frm' file.
              Prevent the end user from invoking this command.
            */
            MYSQL_YYABORT_UNLESS(Lex->parse_vcol_expr);
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 32823 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 964: /* parse_vcol_expr: PARSE_VCOL_EXPR_SYM $@124 expr  */
#line 6938 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Virtual_column_info *v= add_virtual_expression(thd, (yyvsp[0].item));
            if (unlikely(!v))
              MYSQL_YYABORT;
            Lex->last_field->vcol_info= v;
            Lex->pop_select(); //main select
          }
#line 32835 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 966: /* parenthesized_expr: expr ',' expr_list  */
#line 6950 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[0].item_list)->push_front((yyvsp[-2].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_row(thd, *(yyvsp[0].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 32846 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 967: /* virtual_column_func: '(' parenthesized_expr ')'  */
#line 6960 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Virtual_column_info *v=
              add_virtual_expression(thd, (yyvsp[-1].item));
            if (unlikely(!v))
              MYSQL_YYABORT;
            (yyval.virtual_column)= v;
          }
#line 32858 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 968: /* virtual_column_func: subquery  */
#line 6968 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item;
            if (!(item= new (thd->mem_root) Item_singlerow_subselect(thd, (yyvsp[0].select_lex))))
              MYSQL_YYABORT;
            Virtual_column_info *v= add_virtual_expression(thd, item);
            if (unlikely(!v))
              MYSQL_YYABORT;
            (yyval.virtual_column)= v;
          }
#line 32872 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 972: /* column_default_expr: expr_or_literal  */
#line 6984 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.virtual_column)= add_virtual_expression(thd, (yyvsp[0].item)))))
              MYSQL_YYABORT;
          }
#line 32881 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 973: /* field_type: field_type_all  */
#line 6991 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->map_data_type(Lex_ident_sys(), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type)));
          Lex->last_field->set_attributes((yyval.Lex_field_type), Lex->charset);
        }
#line 32890 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 974: /* qualified_field_type: field_type_all  */
#line 6999 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->map_data_type(Lex_ident_sys(), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type)));
          }
#line 32898 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 975: /* qualified_field_type: sp_decl_ident '.' field_type_all  */
#line 7003 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->map_data_type((yyvsp[-2].ident_sys), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type))))
              MYSQL_YYABORT;
          }
#line 32907 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 986: /* field_type_numeric: int_type opt_field_length field_options  */
#line 7028 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                  { (yyval.Lex_field_type).set((yyvsp[-2].type_handler), (yyvsp[-1].const_simple_string)); }
#line 32913 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 987: /* field_type_numeric: real_type opt_precision field_options  */
#line 7029 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                  { (yyval.Lex_field_type).set((yyvsp[-2].type_handler), (yyvsp[-1].Lex_length_and_dec)); }
#line 32919 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 988: /* field_type_numeric: FLOAT_SYM float_options field_options  */
#line 7031 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_float, (yyvsp[-1].Lex_length_and_dec));
            if ((yyvsp[-1].Lex_length_and_dec).length() && !(yyvsp[-1].Lex_length_and_dec).dec())
            {
              int err;
              ulonglong tmp_length= my_strtoll10((yyvsp[-1].Lex_length_and_dec).length(), NULL, &err);
              if (unlikely(err || tmp_length > PRECISION_FOR_DOUBLE))
                my_yyabort_error((ER_WRONG_FIELD_SPEC, MYF(0),
                                  Lex->last_field->field_name.str));
              if (tmp_length > PRECISION_FOR_FLOAT)
                (yyval.Lex_field_type).set(&type_handler_double);
              else
                (yyval.Lex_field_type).set(&type_handler_float);
            }
          }
#line 32939 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 989: /* field_type_numeric: BIT_SYM opt_field_length_default_1  */
#line 7047 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_bit, (yyvsp[0].const_simple_string));
          }
#line 32947 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 990: /* field_type_numeric: BOOL_SYM  */
#line 7051 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_tiny, "1");
          }
#line 32955 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 991: /* field_type_numeric: BOOLEAN_SYM  */
#line 7055 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_tiny, "1");
          }
#line 32963 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 992: /* field_type_numeric: DECIMAL_SYM float_options field_options  */
#line 7059 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));}
#line 32969 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 993: /* field_type_numeric: NUMBER_ORACLE_SYM float_options field_options  */
#line 7061 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[-1].Lex_length_and_dec).length() != 0)
              (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));
            else
              (yyval.Lex_field_type).set(&type_handler_double);
          }
#line 32980 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 994: /* field_type_numeric: NUMERIC_SYM float_options field_options  */
#line 7068 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));}
#line 32986 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 995: /* field_type_numeric: FIXED_SYM float_options field_options  */
#line 7070 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));}
#line 32992 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1000: /* field_type_string: char opt_field_length_default_1 opt_binary  */
#line 7083 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_string, (yyvsp[-1].const_simple_string));
          }
#line 33000 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1001: /* field_type_string: nchar opt_field_length_default_1 opt_bin_mod  */
#line 7087 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_string, (yyvsp[-1].const_simple_string));
            bincmp_collation(national_charset_info, (yyvsp[0].num));
          }
#line 33009 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1002: /* field_type_string: BINARY opt_field_length_default_1  */
#line 7092 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_string, (yyvsp[0].const_simple_string));
          }
#line 33018 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1003: /* field_type_string: varchar field_length opt_binary_and_compression  */
#line 7097 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33026 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1004: /* field_type_string: VARCHAR2_ORACLE_SYM field_length opt_binary_and_compression  */
#line 7101 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33034 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1005: /* field_type_string: nvarchar field_length opt_compressed opt_bin_mod  */
#line 7105 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-2].const_simple_string));
            bincmp_collation(national_charset_info, (yyvsp[0].num));
          }
#line 33043 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1006: /* field_type_string: VARBINARY field_length opt_compressed  */
#line 7110 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33052 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1007: /* field_type_string: RAW_ORACLE_SYM field_length opt_compressed  */
#line 7115 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset= &my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33061 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1008: /* sp_param_field_type_string: char opt_field_length_default_sp_param_char opt_binary  */
#line 7124 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].Lex_length_and_dec));
          }
#line 33069 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1009: /* sp_param_field_type_string: nchar opt_field_length_default_sp_param_char opt_bin_mod  */
#line 7128 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].Lex_length_and_dec));
            bincmp_collation(national_charset_info, (yyvsp[0].num));
          }
#line 33078 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1010: /* sp_param_field_type_string: BINARY opt_field_length_default_sp_param_char  */
#line 7133 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[0].Lex_length_and_dec));
          }
#line 33087 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1011: /* sp_param_field_type_string: varchar opt_field_length_default_sp_param_varchar opt_binary  */
#line 7138 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].Lex_length_and_dec));
          }
#line 33095 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1012: /* sp_param_field_type_string: VARCHAR2_ORACLE_SYM opt_field_length_default_sp_param_varchar opt_binary  */
#line 7142 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].Lex_length_and_dec));
          }
#line 33103 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1013: /* sp_param_field_type_string: nvarchar opt_field_length_default_sp_param_varchar opt_bin_mod  */
#line 7146 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].Lex_length_and_dec));
            bincmp_collation(national_charset_info, (yyvsp[0].num));
          }
#line 33112 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1014: /* sp_param_field_type_string: VARBINARY opt_field_length_default_sp_param_varchar  */
#line 7151 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset= &my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[0].Lex_length_and_dec));
          }
#line 33121 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1015: /* sp_param_field_type_string: RAW_ORACLE_SYM opt_field_length_default_sp_param_varchar  */
#line 7156 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset= &my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[0].Lex_length_and_dec));
          }
#line 33130 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1016: /* field_type_temporal: YEAR_SYM opt_field_length field_options  */
#line 7165 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[-1].const_simple_string))
            {
              errno= 0;
              ulong length= strtoul((yyvsp[-1].const_simple_string), NULL, 10);
              if (errno == 0 && length <= MAX_FIELD_BLOBLENGTH && length != 4)
              {
                char buff[sizeof("YEAR()") + MY_INT64_NUM_DECIMAL_DIGITS + 1];
                my_snprintf(buff, sizeof(buff), "YEAR(%lu)", length);
                push_warning_printf(thd, Sql_condition::WARN_LEVEL_NOTE,
                                    ER_WARN_DEPRECATED_SYNTAX,
                                    ER_THD(thd, ER_WARN_DEPRECATED_SYNTAX),
                                    buff, "YEAR(4)");
              }
            }
            (yyval.Lex_field_type).set(&type_handler_year, (yyvsp[-1].const_simple_string));
          }
#line 33152 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1017: /* field_type_temporal: DATE_SYM  */
#line 7182 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { (yyval.Lex_field_type).set(&type_handler_newdate); }
#line 33158 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1018: /* field_type_temporal: TIME_SYM opt_field_length  */
#line 7184 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(opt_mysql56_temporal_format ?
                   static_cast<const Type_handler*>(&type_handler_time2) :
                   static_cast<const Type_handler*>(&type_handler_time),
                   (yyvsp[0].const_simple_string));
          }
#line 33169 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1019: /* field_type_temporal: TIMESTAMP opt_field_length  */
#line 7191 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(opt_mysql56_temporal_format ?
                   static_cast<const Type_handler*>(&type_handler_timestamp2):
                   static_cast<const Type_handler*>(&type_handler_timestamp),
                   (yyvsp[0].const_simple_string));
          }
#line 33180 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1020: /* field_type_temporal: DATETIME opt_field_length  */
#line 7198 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(thd->type_handler_for_datetime(), (yyvsp[0].const_simple_string));
          }
#line 33188 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1021: /* field_type_lob: TINYBLOB opt_compressed  */
#line 7206 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_tiny_blob);
          }
#line 33197 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1022: /* field_type_lob: BLOB_MARIADB_SYM opt_field_length opt_compressed  */
#line 7211 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_blob, (yyvsp[-1].const_simple_string));
          }
#line 33206 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1023: /* field_type_lob: BLOB_ORACLE_SYM field_length opt_compressed  */
#line 7216 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_blob, (yyvsp[-1].const_simple_string));
          }
#line 33215 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1024: /* field_type_lob: BLOB_ORACLE_SYM opt_compressed  */
#line 7221 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_long_blob);
          }
#line 33224 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1025: /* field_type_lob: spatial_type float_options srid_option  */
#line 7226 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
#ifdef HAVE_SPATIAL
            Lex->charset=&my_charset_bin;
            Lex->last_field->geom_type= (yyvsp[-2].geom_type);
            (yyval.Lex_field_type).set(&type_handler_geometry, (yyvsp[-1].Lex_length_and_dec));
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), sym_group_geom.name,
                              sym_group_geom.needed_define));
#endif
          }
#line 33239 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1026: /* field_type_lob: MEDIUMBLOB opt_compressed  */
#line 7237 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_medium_blob);
          }
#line 33248 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1027: /* field_type_lob: LONGBLOB opt_compressed  */
#line 7242 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_long_blob);
          }
#line 33257 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1028: /* field_type_lob: LONG_SYM VARBINARY opt_compressed  */
#line 7247 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_medium_blob);
          }
#line 33266 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1029: /* field_type_lob: LONG_SYM varchar opt_binary_and_compression  */
#line 7252 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_medium_blob); }
#line 33272 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1030: /* field_type_lob: TINYTEXT opt_binary_and_compression  */
#line 7254 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_tiny_blob); }
#line 33278 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1031: /* field_type_lob: TEXT_SYM opt_field_length opt_binary_and_compression  */
#line 7256 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_blob, (yyvsp[-1].const_simple_string)); }
#line 33284 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1032: /* field_type_lob: MEDIUMTEXT opt_binary_and_compression  */
#line 7258 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_medium_blob); }
#line 33290 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1033: /* field_type_lob: LONGTEXT opt_binary_and_compression  */
#line 7260 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_long_blob); }
#line 33296 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1034: /* field_type_lob: CLOB_ORACLE_SYM opt_binary_and_compression  */
#line 7262 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_long_blob); }
#line 33302 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1035: /* field_type_lob: LONG_SYM opt_binary_and_compression  */
#line 7264 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_medium_blob); }
#line 33308 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1036: /* field_type_lob: JSON_SYM opt_compressed  */
#line 7266 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset= &my_charset_utf8mb4_bin;
            (yyval.Lex_field_type).set(&type_handler_json_longtext);
          }
#line 33317 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1037: /* field_type_misc: ENUM '(' string_list ')' opt_binary  */
#line 7274 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_enum); }
#line 33323 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1038: /* field_type_misc: SET '(' string_list ')' opt_binary  */
#line 7276 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_set); }
#line 33329 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1039: /* spatial_type: GEOMETRY_SYM  */
#line 7280 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_GEOMETRY; }
#line 33335 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1040: /* spatial_type: GEOMETRYCOLLECTION  */
#line 7281 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_GEOMETRYCOLLECTION; }
#line 33341 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1041: /* spatial_type: POINT_SYM  */
#line 7282 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_POINT; }
#line 33347 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1042: /* spatial_type: MULTIPOINT  */
#line 7283 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_MULTIPOINT; }
#line 33353 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1043: /* spatial_type: LINESTRING  */
#line 7284 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_LINESTRING; }
#line 33359 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1044: /* spatial_type: MULTILINESTRING  */
#line 7285 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_MULTILINESTRING; }
#line 33365 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1045: /* spatial_type: POLYGON  */
#line 7286 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_POLYGON; }
#line 33371 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1046: /* spatial_type: MULTIPOLYGON  */
#line 7287 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_MULTIPOLYGON; }
#line 33377 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1047: /* char: CHAR_SYM  */
#line 7291 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   {}
#line 33383 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1048: /* nchar: NCHAR_SYM  */
#line 7295 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 33389 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1049: /* nchar: NATIONAL_SYM CHAR_SYM  */
#line 7296 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                {}
#line 33395 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1050: /* varchar: char VARYING  */
#line 7300 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 33401 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1051: /* varchar: VARCHAR  */
#line 7301 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 33407 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1052: /* nvarchar: NATIONAL_SYM VARCHAR  */
#line 7305 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               {}
#line 33413 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1053: /* nvarchar: NVARCHAR_SYM  */
#line 7306 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 33419 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1054: /* nvarchar: NCHAR_SYM VARCHAR  */
#line 7307 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            {}
#line 33425 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1055: /* nvarchar: NATIONAL_SYM CHAR_SYM VARYING  */
#line 7308 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                        {}
#line 33431 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1056: /* nvarchar: NCHAR_SYM VARYING  */
#line 7309 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            {}
#line 33437 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1057: /* int_type: INT_SYM  */
#line 7313 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.type_handler)= &type_handler_long; }
#line 33443 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1058: /* int_type: TINYINT  */
#line 7314 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.type_handler)= &type_handler_tiny; }
#line 33449 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1059: /* int_type: SMALLINT  */
#line 7315 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.type_handler)= &type_handler_short; }
#line 33455 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1060: /* int_type: MEDIUMINT  */
#line 7316 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.type_handler)= &type_handler_int24; }
#line 33461 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1061: /* int_type: BIGINT  */
#line 7317 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.type_handler)= &type_handler_longlong; }
#line 33467 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1062: /* real_type: REAL  */
#line 7322 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.type_handler)= thd->variables.sql_mode & MODE_REAL_AS_FLOAT ?
              static_cast<const Type_handler *>(&type_handler_float) :
              static_cast<const Type_handler *>(&type_handler_double);
          }
#line 33477 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1063: /* real_type: DOUBLE_SYM  */
#line 7327 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.type_handler)= &type_handler_double; }
#line 33483 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1064: /* real_type: DOUBLE_SYM PRECISION  */
#line 7328 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.type_handler)= &type_handler_double; }
#line 33489 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1065: /* srid_option: %empty  */
#line 7333 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->last_field->srid= 0; }
#line 33495 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1066: /* srid_option: REF_SYSTEM_ID_SYM '=' NUM  */
#line 7336 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->srid=atoi((yyvsp[0].lex_str).str);
          }
#line 33503 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1067: /* float_options: %empty  */
#line 7342 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec).set(0, 0);  }
#line 33509 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1068: /* float_options: field_length  */
#line 7343 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec).set((yyvsp[0].const_simple_string), 0); }
#line 33515 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1069: /* float_options: precision  */
#line 7344 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec)= (yyvsp[0].Lex_length_and_dec); }
#line 33521 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1070: /* precision: '(' NUM ',' NUM ')'  */
#line 7348 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.Lex_length_and_dec).set((yyvsp[-3].lex_str).str, (yyvsp[-1].lex_str).str); }
#line 33527 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1071: /* field_options: %empty  */
#line 7352 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 33533 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1072: /* field_options: SIGNED_SYM  */
#line 7353 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     {}
#line 33539 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1073: /* field_options: UNSIGNED  */
#line 7354 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { Lex->last_field->flags|= UNSIGNED_FLAG;}
#line 33545 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1074: /* field_options: ZEROFILL  */
#line 7355 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { Lex->last_field->flags|= UNSIGNED_FLAG | ZEROFILL_FLAG; }
#line 33551 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1075: /* field_options: UNSIGNED ZEROFILL  */
#line 7356 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->last_field->flags|= UNSIGNED_FLAG | ZEROFILL_FLAG; }
#line 33557 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1076: /* field_options: ZEROFILL UNSIGNED  */
#line 7357 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->last_field->flags|= UNSIGNED_FLAG | ZEROFILL_FLAG; }
#line 33563 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1077: /* field_length: '(' LONG_NUM ')'  */
#line 7361 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 33569 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1078: /* field_length: '(' ULONGLONG_NUM ')'  */
#line 7362 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 33575 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1079: /* field_length: '(' DECIMAL_NUM ')'  */
#line 7363 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 33581 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1080: /* field_length: '(' NUM ')'  */
#line 7364 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 33587 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1081: /* opt_field_length: %empty  */
#line 7368 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.const_simple_string)= (char*) 0; /* use default length */ }
#line 33593 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1082: /* opt_field_length: field_length  */
#line 7369 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.const_simple_string)= (yyvsp[0].const_simple_string); }
#line 33599 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1083: /* opt_field_length_default_1: %empty  */
#line 7373 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.const_simple_string)= (char*) "1"; }
#line 33605 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1084: /* opt_field_length_default_1: field_length  */
#line 7374 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.const_simple_string)= (yyvsp[0].const_simple_string); }
#line 33611 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1085: /* opt_field_length_default_sp_param_varchar: %empty  */
#line 7395 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec).set("4000", "4000"); }
#line 33617 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1086: /* opt_field_length_default_sp_param_varchar: field_length  */
#line 7396 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec).set((yyvsp[0].const_simple_string), NULL); }
#line 33623 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1087: /* opt_field_length_default_sp_param_char: %empty  */
#line 7400 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec).set("2000", "2000"); }
#line 33629 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1088: /* opt_field_length_default_sp_param_char: field_length  */
#line 7401 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec).set((yyvsp[0].const_simple_string), NULL); }
#line 33635 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1089: /* opt_precision: %empty  */
#line 7405 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.Lex_length_and_dec).set(0, 0); }
#line 33641 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1090: /* opt_precision: precision  */
#line 7406 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.Lex_length_and_dec)= (yyvsp[0].Lex_length_and_dec); }
#line 33647 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1091: /* attribute_list: attribute_list attribute  */
#line 7411 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   {}
#line 33653 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1093: /* attribute: NULL_SYM  */
#line 7416 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { Lex->last_field->flags&= ~ NOT_NULL_FLAG; }
#line 33659 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1094: /* attribute: DEFAULT column_default_expr  */
#line 7417 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->last_field->default_value= (yyvsp[0].virtual_column); }
#line 33665 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1095: /* attribute: ON UPDATE_SYM NOW_SYM opt_default_time_precision  */
#line 7419 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_func_now_local(thd, (yyvsp[0].num));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            Lex->last_field->on_update= item;
          }
#line 33676 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1096: /* attribute: AUTO_INC  */
#line 7425 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { Lex->last_field->flags|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG; }
#line 33682 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1097: /* attribute: SERIAL_SYM DEFAULT VALUE_SYM  */
#line 7427 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG | UNIQUE_KEY_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 33692 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1098: /* attribute: COLLATE_SYM collation_name  */
#line 7433 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->charset && !my_charset_same(Lex->charset,(yyvsp[0].charset))))
              my_yyabort_error((ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                                (yyvsp[0].charset)->name,Lex->charset->csname));
            Lex->last_field->charset= (yyvsp[0].charset);
          }
#line 33703 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1100: /* opt_compression_method: %empty  */
#line 7443 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.const_simple_string)= NULL; }
#line 33709 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1101: /* opt_compression_method: equal ident  */
#line 7444 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.const_simple_string)= (yyvsp[0].ident_sys).str; }
#line 33715 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1102: /* opt_compressed: %empty  */
#line 7448 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 33721 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1103: /* opt_compressed: compressed  */
#line 7449 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { }
#line 33727 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1104: /* compressed: COMPRESSED_SYM opt_compression_method  */
#line 7454 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->last_field->set_compressed((yyvsp[0].const_simple_string))))
              MYSQL_YYABORT;
          }
#line 33736 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1105: /* compressed_deprecated_data_type_attribute: COMPRESSED_SYM opt_compression_method  */
#line 7462 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->last_field->set_compressed_deprecated(thd, (yyvsp[0].const_simple_string))))
              MYSQL_YYABORT;
          }
#line 33745 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1106: /* compressed_deprecated_column_attribute: COMPRESSED_SYM opt_compression_method  */
#line 7470 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->last_field->
                set_compressed_deprecated_column_attribute(thd, (yyvsp[-1].kwd).pos(), (yyvsp[0].const_simple_string))))
              MYSQL_YYABORT;
          }
#line 33755 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1107: /* asrow_attribute: not NULL_SYM  */
#line 7479 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->flags|= NOT_NULL_FLAG;
          }
#line 33763 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1108: /* asrow_attribute: opt_primary KEY_SYM  */
#line 7483 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= PRI_KEY_FLAG | NOT_NULL_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 33773 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1111: /* serial_attribute: IDENT_sys equal TEXT_STRING_sys  */
#line 7494 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[0].lex_str).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].lex_str), true,
                                       &Lex->last_field->option_list,
                                       &Lex->option_list_last);
          }
#line 33786 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1112: /* serial_attribute: IDENT_sys equal ident  */
#line 7503 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[0].ident_sys).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ident_sys), false,
                                       &Lex->last_field->option_list,
                                       &Lex->option_list_last);
          }
#line 33799 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1113: /* serial_attribute: IDENT_sys equal real_ulonglong_num  */
#line 7512 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ulonglong_number), &Lex->last_field->option_list,
                                       &Lex->option_list_last, thd->mem_root);
          }
#line 33809 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1114: /* serial_attribute: IDENT_sys equal DEFAULT  */
#line 7518 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), &Lex->last_field->option_list,
                                       &Lex->option_list_last);
          }
#line 33819 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1115: /* serial_attribute: with_or_without_system VERSIONING_SYM  */
#line 7524 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->versioning= (yyvsp[-1].vers_column_versioning);
            Lex->create_info.options|= HA_VERSIONED_TABLE;
            if (Lex->alter_info.flags & ALTER_DROP_SYSTEM_VERSIONING)
            {
              my_yyabort_error((ER_VERS_NOT_VERSIONED, MYF(0),
                       Lex->create_last_non_select_table->table_name.str));
            }
          }
#line 33833 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1116: /* with_or_without_system: WITH_SYSTEM_SYM  */
#line 7537 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_COLUMN_UNVERSIONED;
            Lex->create_info.vers_info.versioned_fields= true;
            (yyval.vers_column_versioning)= Column_definition::WITH_VERSIONING;
          }
#line 33843 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1117: /* with_or_without_system: WITHOUT SYSTEM  */
#line 7543 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_COLUMN_UNVERSIONED;
            Lex->create_info.vers_info.unversioned_fields= true;
            (yyval.vers_column_versioning)= Column_definition::WITHOUT_VERSIONING;
          }
#line 33853 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1118: /* sp_param_type: sp_param_field_type  */
#line 7553 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->map_data_type(Lex_ident_sys(), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type)));
          Lex->last_field->set_attributes((yyval.Lex_field_type), Lex->charset);
        }
#line 33862 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1119: /* charset: CHAR_SYM SET  */
#line 7560 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 33868 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1120: /* charset: CHARSET  */
#line 7561 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 33874 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1121: /* charset_name: ident_or_text  */
#line 7566 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.charset)=get_charset_by_csname((yyvsp[0].lex_str).str,MY_CS_PRIMARY,MYF(0)))))
              my_yyabort_error((ER_UNKNOWN_CHARACTER_SET, MYF(0), (yyvsp[0].lex_str).str));
          }
#line 33883 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1122: /* charset_name: BINARY  */
#line 7570 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.charset)= &my_charset_bin; }
#line 33889 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1123: /* charset_name_or_default: charset_name  */
#line 7574 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.charset)=(yyvsp[0].charset);   }
#line 33895 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1124: /* charset_name_or_default: DEFAULT  */
#line 7575 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.charset)=NULL; }
#line 33901 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1125: /* opt_load_data_charset: %empty  */
#line 7579 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.charset)= NULL; }
#line 33907 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1126: /* opt_load_data_charset: charset charset_name_or_default  */
#line 7580 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.charset)= (yyvsp[0].charset); }
#line 33913 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1127: /* old_or_new_charset_name: ident_or_text  */
#line 7585 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.charset)=get_charset_by_csname((yyvsp[0].lex_str).str,
                                                    MY_CS_PRIMARY,MYF(0))) &&
                         !((yyval.charset)=get_old_charset_by_name((yyvsp[0].lex_str).str))))
              my_yyabort_error((ER_UNKNOWN_CHARACTER_SET, MYF(0), (yyvsp[0].lex_str).str));
          }
#line 33924 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1128: /* old_or_new_charset_name: BINARY  */
#line 7591 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.charset)= &my_charset_bin; }
#line 33930 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1129: /* old_or_new_charset_name_or_default: old_or_new_charset_name  */
#line 7595 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.charset)=(yyvsp[0].charset);   }
#line 33936 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1130: /* old_or_new_charset_name_or_default: DEFAULT  */
#line 7596 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.charset)=NULL; }
#line 33942 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1131: /* collation_name: ident_or_text  */
#line 7601 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.charset)= mysqld_collation_get_by_name((yyvsp[0].lex_str).str))))
              MYSQL_YYABORT;
          }
#line 33951 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1132: /* opt_collate: %empty  */
#line 7608 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.charset)=NULL; }
#line 33957 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1133: /* opt_collate: COLLATE_SYM collation_name_or_default  */
#line 7609 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.charset)=(yyvsp[0].charset); }
#line 33963 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1134: /* collation_name_or_default: collation_name  */
#line 7613 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.charset)=(yyvsp[0].charset); }
#line 33969 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1135: /* collation_name_or_default: DEFAULT  */
#line 7614 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.charset)=NULL; }
#line 33975 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1136: /* opt_default: %empty  */
#line 7618 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 33981 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1137: /* opt_default: DEFAULT  */
#line 7619 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 33987 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1138: /* charset_or_alias: charset charset_name  */
#line 7623 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.charset)= (yyvsp[0].charset); }
#line 33993 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1139: /* charset_or_alias: ASCII_SYM  */
#line 7624 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.charset)= &my_charset_latin1; }
#line 33999 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1140: /* charset_or_alias: UNICODE_SYM  */
#line 7626 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.charset)= get_charset_by_csname("ucs2", MY_CS_PRIMARY,MYF(0)))))
              my_yyabort_error((ER_UNKNOWN_CHARACTER_SET, MYF(0), "ucs2"));
          }
#line 34008 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1141: /* collate: COLLATE_SYM collation_name_or_default  */
#line 7632 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                               { (yyval.charset)= (yyvsp[0].charset); }
#line 34014 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1142: /* opt_binary: %empty  */
#line 7636 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { bincmp_collation(NULL, false); }
#line 34020 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1143: /* opt_binary: binary  */
#line 7637 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 {}
#line 34026 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1144: /* binary: BYTE_SYM  */
#line 7641 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { bincmp_collation(&my_charset_bin, false); }
#line 34032 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1145: /* binary: charset_or_alias opt_bin_mod  */
#line 7642 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                       { bincmp_collation((yyvsp[-1].charset), (yyvsp[0].num)); }
#line 34038 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1146: /* binary: BINARY  */
#line 7643 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { bincmp_collation(NULL, true); }
#line 34044 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1147: /* binary: BINARY charset_or_alias  */
#line 7644 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { bincmp_collation((yyvsp[0].charset), true); }
#line 34050 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1148: /* binary: charset_or_alias collate  */
#line 7646 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!(yyvsp[0].charset))
              Lex->charset= (yyvsp[-1].charset); // CHARACTER SET cs COLLATE DEFAULT
            else
            {
              if (!my_charset_same((yyvsp[0].charset), (yyvsp[-1].charset)))
                my_yyabort_error((ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                                  (yyvsp[0].charset)->name, (yyvsp[-1].charset)->csname));
              Lex->charset= (yyvsp[0].charset);
            }
          }
#line 34066 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1149: /* binary: collate  */
#line 7657 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { Lex->charset= (yyvsp[0].charset); }
#line 34072 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1150: /* opt_bin_mod: %empty  */
#line 7661 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.num)= false; }
#line 34078 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1151: /* opt_bin_mod: BINARY  */
#line 7662 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.num)= true; }
#line 34084 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1152: /* $@125: %empty  */
#line 7667 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          if (unlikely((yyvsp[0].ulong_num) == 0))
          {
            thd->parse_error();
            MYSQL_YYABORT;
          }
        }
#line 34096 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1153: /* ws_nweights: '(' real_ulong_num $@125 ')'  */
#line 7675 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        { (yyval.ulong_num)= (yyvsp[-2].ulong_num); }
#line 34102 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1154: /* ws_level_flag_desc: ASC  */
#line 7679 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { (yyval.ulong_num)= 0; }
#line 34108 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1155: /* ws_level_flag_desc: DESC  */
#line 7680 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               { (yyval.ulong_num)= 1 << MY_STRXFRM_DESC_SHIFT; }
#line 34114 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1156: /* ws_level_flag_reverse: REVERSE_SYM  */
#line 7684 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.ulong_num)= 1 << MY_STRXFRM_REVERSE_SHIFT; }
#line 34120 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1157: /* ws_level_flags: %empty  */
#line 7687 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.ulong_num)= 0; }
#line 34126 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1158: /* ws_level_flags: ws_level_flag_desc  */
#line 7688 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34132 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1159: /* ws_level_flags: ws_level_flag_desc ws_level_flag_reverse  */
#line 7689 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                   { (yyval.ulong_num)= (yyvsp[-1].ulong_num) | (yyvsp[0].ulong_num); }
#line 34138 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1160: /* ws_level_flags: ws_level_flag_reverse  */
#line 7690 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.ulong_num)= (yyvsp[0].ulong_num) ; }
#line 34144 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1161: /* ws_level_number: real_ulong_num  */
#line 7695 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.ulong_num)= (yyvsp[0].ulong_num) < 1 ? 1 : ((yyvsp[0].ulong_num) > MY_STRXFRM_NLEVELS ? MY_STRXFRM_NLEVELS : (yyvsp[0].ulong_num));
          (yyval.ulong_num)--;
        }
#line 34153 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1162: /* ws_level_list_item: ws_level_number ws_level_flags  */
#line 7703 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.ulong_num)= (1 | (yyvsp[0].ulong_num)) << (yyvsp[-1].ulong_num);
        }
#line 34161 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1163: /* ws_level_list: ws_level_list_item  */
#line 7709 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34167 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1164: /* ws_level_list: ws_level_list ',' ws_level_list_item  */
#line 7710 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                               { (yyval.ulong_num)|= (yyvsp[0].ulong_num); }
#line 34173 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1165: /* ws_level_range: ws_level_number '-' ws_level_number  */
#line 7715 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          uint start= (yyvsp[-2].ulong_num);
          uint end= (yyvsp[0].ulong_num);
          for ((yyval.ulong_num)= 0; start <= end; start++)
            (yyval.ulong_num)|= (1 << start);
        }
#line 34184 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1166: /* ws_level_list_or_range: ws_level_list  */
#line 7724 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34190 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1167: /* ws_level_list_or_range: ws_level_range  */
#line 7725 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34196 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1168: /* opt_ws_levels: %empty  */
#line 7729 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { (yyval.ulong_num)= 0; }
#line 34202 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1169: /* opt_ws_levels: LEVEL_SYM ws_level_list_or_range  */
#line 7730 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34208 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1172: /* references: REFERENCES table_ident opt_ref_list opt_match_clause opt_on_update_delete  */
#line 7744 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.table)=(yyvsp[-3].table);
          }
#line 34216 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1173: /* opt_ref_list: %empty  */
#line 7751 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->ref_list.empty(); }
#line 34222 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1175: /* ref_list: ref_list ',' ident  */
#line 7757 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Key_part_spec *key= new (thd->mem_root) Key_part_spec(&(yyvsp[0].ident_sys), 0);
            if (unlikely(key == NULL))
              MYSQL_YYABORT;
            Lex->ref_list.push_back(key, thd->mem_root);
          }
#line 34233 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1176: /* ref_list: ident  */
#line 7764 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Key_part_spec *key= new (thd->mem_root) Key_part_spec(&(yyvsp[0].ident_sys), 0);
            if (unlikely(key == NULL))
              MYSQL_YYABORT;
            LEX *lex= Lex;
            lex->ref_list.empty();
            lex->ref_list.push_back(key, thd->mem_root);
          }
#line 34246 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1177: /* opt_match_clause: %empty  */
#line 7776 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_UNDEF; }
#line 34252 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1178: /* opt_match_clause: MATCH FULL  */
#line 7778 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_FULL; }
#line 34258 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1179: /* opt_match_clause: MATCH PARTIAL  */
#line 7780 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_PARTIAL; }
#line 34264 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1180: /* opt_match_clause: MATCH SIMPLE_SYM  */
#line 7782 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_SIMPLE; }
#line 34270 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1181: /* opt_on_update_delete: %empty  */
#line 7787 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= FK_OPTION_UNDEF;
            lex->fk_delete_opt= FK_OPTION_UNDEF;
          }
#line 34280 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1182: /* opt_on_update_delete: ON UPDATE_SYM delete_option  */
#line 7793 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= (yyvsp[0].m_fk_option);
            lex->fk_delete_opt= FK_OPTION_UNDEF;
          }
#line 34290 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1183: /* opt_on_update_delete: ON DELETE_SYM delete_option  */
#line 7799 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= FK_OPTION_UNDEF;
            lex->fk_delete_opt= (yyvsp[0].m_fk_option);
          }
#line 34300 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1184: /* opt_on_update_delete: ON UPDATE_SYM delete_option ON DELETE_SYM delete_option  */
#line 7806 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= (yyvsp[-3].m_fk_option);
            lex->fk_delete_opt= (yyvsp[0].m_fk_option);
          }
#line 34310 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1185: /* opt_on_update_delete: ON DELETE_SYM delete_option ON UPDATE_SYM delete_option  */
#line 7813 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= (yyvsp[0].m_fk_option);
            lex->fk_delete_opt= (yyvsp[-3].m_fk_option);
          }
#line 34320 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1186: /* delete_option: RESTRICT  */
#line 7821 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.m_fk_option)= FK_OPTION_RESTRICT; }
#line 34326 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1187: /* delete_option: CASCADE  */
#line 7822 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.m_fk_option)= FK_OPTION_CASCADE; }
#line 34332 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1188: /* delete_option: SET NULL_SYM  */
#line 7823 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.m_fk_option)= FK_OPTION_SET_NULL; }
#line 34338 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1189: /* delete_option: NO_SYM ACTION  */
#line 7824 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.m_fk_option)= FK_OPTION_NO_ACTION; }
#line 34344 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1190: /* delete_option: SET DEFAULT  */
#line 7825 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.m_fk_option)= FK_OPTION_SET_DEFAULT; }
#line 34350 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1191: /* constraint_key_type: PRIMARY_SYM KEY_SYM  */
#line 7829 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.key_type)= Key::PRIMARY; }
#line 34356 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1192: /* constraint_key_type: UNIQUE_SYM opt_key_or_index  */
#line 7830 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { (yyval.key_type)= Key::UNIQUE; }
#line 34362 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1193: /* key_or_index: KEY_SYM  */
#line 7834 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 34368 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1194: /* key_or_index: INDEX_SYM  */
#line 7835 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 34374 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1195: /* opt_key_or_index: %empty  */
#line 7839 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 34380 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1197: /* keys_or_index: KEYS  */
#line 7844 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               {}
#line 34386 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1198: /* keys_or_index: INDEX_SYM  */
#line 7845 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 34392 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1199: /* keys_or_index: INDEXES  */
#line 7846 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 34398 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1200: /* opt_unique: %empty  */
#line 7850 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.key_type)= Key::MULTIPLE; }
#line 34404 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1201: /* opt_unique: UNIQUE_SYM  */
#line 7851 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.key_type)= Key::UNIQUE; }
#line 34410 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1202: /* fulltext: FULLTEXT_SYM  */
#line 7855 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.key_type)= Key::FULLTEXT;}
#line 34416 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1203: /* spatial: SPATIAL_SYM  */
#line 7860 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
#ifdef HAVE_SPATIAL
            (yyval.key_type)= Key::SPATIAL;
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), sym_group_geom.name,
                              sym_group_geom.needed_define));
#endif
          }
#line 34429 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1204: /* normal_key_options: %empty  */
#line 7871 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 34435 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1205: /* normal_key_options: normal_key_opts  */
#line 7872 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { Lex->last_key->option_list= Lex->option_list; }
#line 34441 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1206: /* fulltext_key_options: %empty  */
#line 7876 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 34447 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1207: /* fulltext_key_options: fulltext_key_opts  */
#line 7877 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->last_key->option_list= Lex->option_list; }
#line 34453 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1208: /* spatial_key_options: %empty  */
#line 7881 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 34459 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1209: /* spatial_key_options: spatial_key_opts  */
#line 7882 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { Lex->last_key->option_list= Lex->option_list; }
#line 34465 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1216: /* opt_USING_key_algorithm: %empty  */
#line 7901 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.key_alg)= HA_KEY_ALG_UNDEF; }
#line 34471 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1217: /* opt_USING_key_algorithm: USING btree_or_rtree  */
#line 7902 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.key_alg)= (yyvsp[0].key_alg); }
#line 34477 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1218: /* opt_key_algorithm_clause: %empty  */
#line 7907 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.key_alg)= HA_KEY_ALG_UNDEF; }
#line 34483 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1219: /* opt_key_algorithm_clause: USING btree_or_rtree  */
#line 7908 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.key_alg)= (yyvsp[0].key_alg); }
#line 34489 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1220: /* opt_key_algorithm_clause: TYPE_SYM btree_or_rtree  */
#line 7909 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.key_alg)= (yyvsp[0].key_alg); }
#line 34495 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1221: /* key_using_alg: USING btree_or_rtree  */
#line 7914 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->last_key->key_create_info.algorithm= (yyvsp[0].key_alg); }
#line 34501 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1222: /* key_using_alg: TYPE_SYM btree_or_rtree  */
#line 7916 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->last_key->key_create_info.algorithm= (yyvsp[0].key_alg); }
#line 34507 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1223: /* all_key_opt: KEY_BLOCK_SIZE opt_equal ulong_num  */
#line 7921 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_key->key_create_info.block_size= (yyvsp[0].ulong_num);
            Lex->last_key->key_create_info.flags|= HA_USES_BLOCK_SIZE;
         }
#line 34516 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1224: /* all_key_opt: COMMENT_SYM TEXT_STRING_sys  */
#line 7926 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->last_key->key_create_info.comment= (yyvsp[0].lex_str); }
#line 34522 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1225: /* all_key_opt: IDENT_sys equal TEXT_STRING_sys  */
#line 7928 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[0].lex_str).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].lex_str), true, &Lex->option_list,
                                       &Lex->option_list_last);
          }
#line 34534 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1226: /* all_key_opt: IDENT_sys equal ident  */
#line 7936 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[0].ident_sys).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ident_sys), false, &Lex->option_list,
                                       &Lex->option_list_last);
          }
#line 34546 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1227: /* all_key_opt: IDENT_sys equal real_ulonglong_num  */
#line 7944 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (void) new (thd->mem_root)
                  engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ulonglong_number), &Lex->option_list,
                                      &Lex->option_list_last, thd->mem_root);
          }
#line 34556 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1228: /* all_key_opt: IDENT_sys equal DEFAULT  */
#line 7950 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), &Lex->option_list,
                                       &Lex->option_list_last);
          }
#line 34566 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1233: /* fulltext_key_opt: WITH PARSER_SYM IDENT_sys  */
#line 7969 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (likely(plugin_is_ready(&(yyvsp[0].ident_sys), MYSQL_FTPARSER_PLUGIN)))
              Lex->last_key->key_create_info.parser_name= (yyvsp[0].ident_sys);
            else
              my_yyabort_error((ER_FUNCTION_NOT_DEFINED, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 34577 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1234: /* btree_or_rtree: BTREE_SYM  */
#line 7978 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.key_alg)= HA_KEY_ALG_BTREE; }
#line 34583 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1235: /* btree_or_rtree: RTREE_SYM  */
#line 7979 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.key_alg)= HA_KEY_ALG_RTREE; }
#line 34589 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1236: /* btree_or_rtree: HASH_SYM  */
#line 7980 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.key_alg)= HA_KEY_ALG_HASH; }
#line 34595 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1237: /* key_list: key_list ',' key_part order_dir  */
#line 7985 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_key->columns.push_back((yyvsp[-1].key_part), thd->mem_root);
          }
#line 34603 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1238: /* key_list: key_part order_dir  */
#line 7989 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_key->columns.push_back((yyvsp[-1].key_part), thd->mem_root);
          }
#line 34611 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1239: /* key_part: ident  */
#line 7996 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.key_part)= new (thd->mem_root) Key_part_spec(&(yyvsp[0].ident_sys), 0);
            if (unlikely((yyval.key_part) == NULL))
              MYSQL_YYABORT;
          }
#line 34621 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1240: /* key_part: ident '(' NUM ')'  */
#line 8002 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            int key_part_len= atoi((yyvsp[-1].lex_str).str);
            if (unlikely(!key_part_len))
              my_yyabort_error((ER_KEY_PART_0, MYF(0), (yyvsp[-3].ident_sys).str));
            (yyval.key_part)= new (thd->mem_root) Key_part_spec(&(yyvsp[-3].ident_sys), (uint) key_part_len);
            if (unlikely((yyval.key_part) == NULL))
              MYSQL_YYABORT;
          }
#line 34634 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1241: /* opt_ident: %empty  */
#line 8013 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str)= null_clex_str; }
#line 34640 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1242: /* opt_ident: field_ident  */
#line 8014 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str)= (yyvsp[0].lex_str); }
#line 34646 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1243: /* string_list: text_string  */
#line 8019 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->last_field->interval_list.push_back((yyvsp[0].string), thd->mem_root); }
#line 34652 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1244: /* string_list: string_list ',' text_string  */
#line 8021 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->last_field->interval_list.push_back((yyvsp[0].string), thd->mem_root); }
#line 34658 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1245: /* $@126: %empty  */
#line 8030 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->name= null_clex_str;
            Lex->table_type= TABLE_TYPE_UNKNOWN;
            Lex->sql_command= SQLCOM_ALTER_TABLE;
            Lex->duplicates= DUP_ERROR;
            Lex->first_select_lex()->order_list.empty();
            Lex->create_info.init();
            Lex->create_info.row_type= ROW_TYPE_NOT_USED;
            Lex->alter_info.reset();
            Lex->no_write_to_binlog= 0;
            Lex->create_info.storage_media= HA_SM_DEFAULT;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            DBUG_ASSERT(!Lex->m_sql_cmd);
          }
#line 34678 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1246: /* $@127: %empty  */
#line 8046 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!Lex->first_select_lex()->
                  add_table_to_list(thd, (yyvsp[-1].table), NULL, TL_OPTION_UPDATING,
                                    TL_READ_NO_INSERT, MDL_SHARED_UPGRADABLE))
              MYSQL_YYABORT;
            Lex->first_select_lex()->db=
              (Lex->first_select_lex()->table_list.first)->db;
            Lex->create_last_non_select_table= Lex->last_table();
            Lex->mark_first_table_as_inserting();
          }
#line 34693 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1247: /* alter: ALTER $@126 alter_options TABLE_SYM table_ident opt_lock_wait_timeout $@127 alter_commands  */
#line 8057 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (likely(!Lex->m_sql_cmd))
            {
              /* Create a generic ALTER TABLE statment. */
              Lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_alter_table();
              if (unlikely(Lex->m_sql_cmd == NULL))
                MYSQL_YYABORT;
            }
            Lex->pop_select(); //main select
          }
#line 34708 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1248: /* $@128: %empty  */
#line 8068 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.default_table_charset= NULL;
            Lex->create_info.used_fields= 0;
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 34719 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1249: /* alter: ALTER DATABASE ident_or_empty $@128 create_database_options  */
#line 8075 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_ALTER_DB;
            lex->name= (yyvsp[-2].ident_sys);
            if (lex->name.str == NULL &&
                unlikely(lex->copy_db_to(&lex->name)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
          }
#line 34733 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1250: /* alter: ALTER DATABASE ident UPGRADE_SYM DATA_SYM DIRECTORY_SYM NAME_SYM  */
#line 8085 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "DATABASE"));
            lex->sql_command= SQLCOM_ALTER_DB_UPGRADE;
            lex->name= (yyvsp[-4].ident_sys);
          }
#line 34745 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1251: /* $@129: %empty  */
#line 8093 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "PROCEDURE"));
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            lex->sp_chistics.init();
          }
#line 34759 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1252: /* alter: ALTER PROCEDURE_SYM sp_name $@129 sp_a_chistics  */
#line 8103 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;

            lex->sql_command= SQLCOM_ALTER_PROCEDURE;
            lex->spname= (yyvsp[-2].spname);
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 34773 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1253: /* $@130: %empty  */
#line 8113 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "FUNCTION"));
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            lex->sp_chistics.init();
          }
#line 34787 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1254: /* alter: ALTER FUNCTION_SYM sp_name $@130 sp_a_chistics  */
#line 8123 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;

            lex->sql_command= SQLCOM_ALTER_FUNCTION;
            lex->spname= (yyvsp[-2].spname);
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 34801 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1255: /* $@131: %empty  */
#line 8133 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            if (Lex->add_alter_view(thd, (yyvsp[-4].num), (yyvsp[-2].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
          }
#line 34812 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1256: /* alter: ALTER view_algorithm definer_opt opt_view_suid VIEW_SYM table_ident $@131 view_list_opt AS view_select  */
#line 8140 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 34822 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1257: /* $@132: %empty  */
#line 8151 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            if (Lex->add_alter_view(thd, VIEW_ALGORITHM_INHERIT, (yyvsp[-2].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
          }
#line 34833 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1258: /* alter: ALTER definer_opt opt_view_suid VIEW_SYM table_ident $@132 view_list_opt AS view_select  */
#line 8158 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 34843 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1259: /* $@133: %empty  */
#line 8164 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            /*
              It is safe to use Lex->spname because
              ALTER EVENT xxx RENATE TO yyy DO ALTER EVENT RENAME TO
              is not allowed. Lex->spname is used in the case of RENAME TO
              If it had to be supported spname had to be added to
              Event_parse_data.
            */

            if (unlikely(!(Lex->event_parse_data= Event_parse_data::new_instance(thd))))
              MYSQL_YYABORT;
            Lex->event_parse_data->identifier= (yyvsp[0].spname);

            Lex->sql_command= SQLCOM_ALTER_EVENT;
            Lex->stmt_definition_begin= (yyvsp[-2].simple_string);
          }
#line 34866 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1260: /* alter: ALTER definer_opt remember_name EVENT_SYM sp_name $@133 ev_alter_on_schedule_completion opt_ev_rename_to opt_ev_status opt_ev_comment opt_ev_sql_stmt  */
#line 8187 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyvsp[-4].num) || (yyvsp[-3].num) || (yyvsp[-2].num) || (yyvsp[-1].num) || (yyvsp[0].num))))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
            /*
              sql_command is set here because some rules in ev_sql_stmt
              can overwrite it
            */
            Lex->sql_command= SQLCOM_ALTER_EVENT;
            Lex->stmt_definition_end= (char*)YYLIP->get_cpp_ptr();

            Lex->pop_select(); //main select
          }
#line 34886 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1261: /* alter: ALTER TABLESPACE alter_tablespace_info  */
#line 8203 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= ALTER_TABLESPACE;
          }
#line 34895 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1262: /* alter: ALTER LOGFILE_SYM GROUP_SYM alter_logfile_group_info  */
#line 8208 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= ALTER_LOGFILE_GROUP;
          }
#line 34904 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1263: /* alter: ALTER TABLESPACE change_tablespace_info  */
#line 8213 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= CHANGE_FILE_TABLESPACE;
          }
#line 34913 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1264: /* alter: ALTER TABLESPACE change_tablespace_access  */
#line 8218 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= ALTER_ACCESS_MODE_TABLESPACE;
          }
#line 34922 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1265: /* $@134: %empty  */
#line 8223 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_ALTER_SERVER;
            lex->server_options.reset((yyvsp[0].lex_str));
          }
#line 34932 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1266: /* alter: ALTER SERVER_SYM ident_or_text $@134 OPTIONS_SYM '(' server_options_list ')'  */
#line 8227 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                    { }
#line 34938 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1267: /* alter: ALTER USER_SYM opt_if_exists clear_privileges grant_list opt_require_clause opt_resource_options opt_account_locking_and_opt_password_expiration  */
#line 8231 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.set((yyvsp[-5].object_ddl_options));
            Lex->sql_command= SQLCOM_ALTER_USER;
          }
#line 34947 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1268: /* $@135: %empty  */
#line 8236 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->name= null_clex_str;
            lex->table_type= TABLE_TYPE_UNKNOWN;
            lex->sql_command= SQLCOM_ALTER_SEQUENCE;
            lex->create_info.init();
            lex->no_write_to_binlog= 0;
            DBUG_ASSERT(!lex->m_sql_cmd);
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 34963 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1269: /* $@136: %empty  */
#line 8248 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (!(lex->create_info.seq_create_info= new (thd->mem_root)
                                                     sequence_definition()) ||
                !lex->first_select_lex()->
                  add_table_to_list(thd, (yyvsp[0].table), NULL, TL_OPTION_SEQUENCE,
                                    TL_WRITE, MDL_EXCLUSIVE))
              MYSQL_YYABORT;
          }
#line 34977 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1270: /* alter: ALTER SEQUENCE_SYM opt_if_exists $@135 table_ident $@136 sequence_defs  */
#line 8258 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* Create a generic ALTER SEQUENCE statment. */
            Lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_alter_sequence((yyvsp[-4].object_ddl_options));
            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 34991 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1271: /* account_locking_option: LOCK_SYM  */
#line 8271 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.account_locked= ACCOUNTLOCK_LOCKED;
          }
#line 34999 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1272: /* account_locking_option: UNLOCK_SYM  */
#line 8275 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.account_locked= ACCOUNTLOCK_UNLOCKED;
          }
#line 35007 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1273: /* opt_password_expire_option: %empty  */
#line 8282 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_NOW;
          }
#line 35015 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1274: /* opt_password_expire_option: NEVER_SYM  */
#line 8286 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_NEVER;
          }
#line 35023 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1275: /* opt_password_expire_option: DEFAULT  */
#line 8290 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_DEFAULT;
          }
#line 35031 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1276: /* opt_password_expire_option: INTERVAL_SYM NUM DAY_SYM  */
#line 8294 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_INTERVAL;
            if (!(Lex->account_options.num_expiration_days= atoi((yyvsp[-1].lex_str).str)))
              my_yyabort_error((ER_WRONG_VALUE, MYF(0), "DAY", (yyvsp[-1].lex_str).str));
          }
#line 35041 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1282: /* ev_alter_on_schedule_completion: %empty  */
#line 8310 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0;}
#line 35047 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1283: /* ev_alter_on_schedule_completion: ON SCHEDULE_SYM ev_schedule_time  */
#line 8311 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.num)= 1; }
#line 35053 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1284: /* ev_alter_on_schedule_completion: ev_on_completion  */
#line 8312 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.num)= 1; }
#line 35059 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1285: /* ev_alter_on_schedule_completion: ON SCHEDULE_SYM ev_schedule_time ev_on_completion  */
#line 8313 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                            { (yyval.num)= 1; }
#line 35065 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1286: /* opt_ev_rename_to: %empty  */
#line 8317 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0;}
#line 35071 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1287: /* opt_ev_rename_to: RENAME TO_SYM sp_name  */
#line 8319 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Use lex's spname to hold the new name.
              The original name is in the Event_parse_data object
            */
            Lex->spname= (yyvsp[0].spname); 
            (yyval.num)= 1;
          }
#line 35084 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1288: /* opt_ev_sql_stmt: %empty  */
#line 8330 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.num)= 0;}
#line 35090 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1289: /* opt_ev_sql_stmt: DO_SYM ev_sql_stmt  */
#line 8331 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num)= 1; }
#line 35096 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1290: /* ident_or_empty: %empty  */
#line 8335 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.ident_sys)= Lex_ident_sys(); }
#line 35102 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1293: /* alter_commands: DISCARD TABLESPACE  */
#line 8342 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->m_sql_cmd= new (thd->mem_root)
              Sql_cmd_discard_import_tablespace(
                Sql_cmd_discard_import_tablespace::DISCARD_TABLESPACE);
            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35114 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1294: /* alter_commands: IMPORT TABLESPACE  */
#line 8350 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->m_sql_cmd= new (thd->mem_root)
              Sql_cmd_discard_import_tablespace(
                Sql_cmd_discard_import_tablespace::IMPORT_TABLESPACE);
            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35126 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1300: /* alter_commands: DROP PARTITION_SYM opt_if_exists alt_part_name_list  */
#line 8372 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_DROP;
            DBUG_ASSERT(!Lex->if_exists());
            Lex->create_info.add((yyvsp[-1].object_ddl_options));
          }
#line 35136 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1301: /* alter_commands: REBUILD_SYM PARTITION_SYM opt_no_write_to_binlog all_or_alt_part_name_list  */
#line 8379 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_info.partition_flags|= ALTER_PARTITION_REBUILD;
            lex->no_write_to_binlog= (yyvsp[-1].num);
          }
#line 35146 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1302: /* $@137: %empty  */
#line 8386 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_optimize_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35161 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1304: /* alter_commands: ANALYZE_SYM PARTITION_SYM opt_no_write_to_binlog all_or_alt_part_name_list  */
#line 8399 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_analyze_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
               MYSQL_YYABORT;
          }
#line 35176 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1305: /* $@138: %empty  */
#line 8410 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_check_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35190 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1307: /* $@139: %empty  */
#line 8422 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_repair_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35205 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1309: /* alter_commands: COALESCE PARTITION_SYM opt_no_write_to_binlog real_ulong_num  */
#line 8434 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_info.partition_flags|= ALTER_PARTITION_COALESCE;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->alter_info.num_parts= (yyvsp[0].ulong_num);
          }
#line 35216 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1310: /* alter_commands: TRUNCATE_SYM PARTITION_SYM all_or_alt_part_name_list  */
#line 8441 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_truncate_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35230 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1312: /* alter_commands: EXCHANGE_SYM PARTITION_SYM alt_part_name_item WITH TABLE_SYM table_ident have_partitioning  */
#line 8453 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_alter_table_exchange_partition((yyvsp[-1].table)))
              MYSQL_YYABORT;
          }
#line 35239 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1313: /* remove_partitioning: REMOVE_SYM PARTITIONING_SYM  */
#line 8461 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_REMOVE;
          }
#line 35247 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1314: /* all_or_alt_part_name_list: ALL  */
#line 8468 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_ALL;
          }
#line 35255 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1316: /* $@140: %empty  */
#line 8477 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->part_info= new (thd->mem_root) partition_info();
            if (unlikely(!lex->part_info))
              MYSQL_YYABORT;

            lex->alter_info.partition_flags|= ALTER_PARTITION_ADD;
            DBUG_ASSERT(!Lex->create_info.if_not_exists());
            lex->create_info.set((yyvsp[-1].object_ddl_options));
            lex->no_write_to_binlog= (yyvsp[0].num);
          }
#line 35271 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1317: /* add_partition_rule: ADD PARTITION_SYM opt_if_not_exists opt_no_write_to_binlog $@140 add_part_extra  */
#line 8489 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 35277 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1319: /* add_part_extra: '(' part_def_list ')'  */
#line 8495 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->part_info->num_parts= lex->part_info->partitions.elements;
          }
#line 35286 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1320: /* add_part_extra: PARTITIONS_SYM real_ulong_num  */
#line 8500 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->part_info->num_parts= (yyvsp[0].ulong_num);
          }
#line 35294 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1321: /* $@141: %empty  */
#line 8507 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->part_info= new (thd->mem_root) partition_info();
            if (unlikely(!lex->part_info))
              MYSQL_YYABORT;

            lex->no_write_to_binlog= (yyvsp[0].num);
          }
#line 35307 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1323: /* reorg_parts_rule: %empty  */
#line 8520 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_TABLE_REORG;
          }
#line 35315 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1324: /* $@142: %empty  */
#line 8524 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_REORGANIZE;
          }
#line 35323 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1325: /* reorg_parts_rule: alt_part_name_list $@142 INTO '(' part_def_list ')'  */
#line 8528 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->num_parts= part_info->partitions.elements;
          }
#line 35332 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1326: /* alt_part_name_list: alt_part_name_item  */
#line 8535 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             {}
#line 35338 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1327: /* alt_part_name_list: alt_part_name_list ',' alt_part_name_item  */
#line 8536 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                    {}
#line 35344 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1328: /* alt_part_name_item: ident  */
#line 8541 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->alter_info.partition_names.push_back((yyvsp[0].ident_sys).str,
                                                                   thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 35354 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1332: /* alter_list_item: add_column column_def opt_place  */
#line 8563 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->create_last_non_select_table= lex->last_table();
            lex->alter_info.flags|= ALTER_PARSER_ADD_COLUMN;
            (yyvsp[-1].create_field)->after= (yyvsp[0].lex_str);
          }
#line 35365 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1333: /* alter_list_item: ADD key_def  */
#line 8570 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_last_non_select_table= Lex->last_table();
            Lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 35374 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1334: /* alter_list_item: ADD period_for_system_time  */
#line 8575 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_ADD_PERIOD;
          }
#line 35382 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1335: /* alter_list_item: ADD PERIOD_SYM opt_if_not_exists_table_element period_for_application_time  */
#line 8580 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Table_period_info &period= Lex->create_info.period_info;
            period.create_if_not_exists= Lex->check_exists;
            Lex->alter_info.flags|= ALTER_ADD_CHECK_CONSTRAINT;
          }
#line 35392 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1336: /* alter_list_item: add_column '(' create_field_list ')'  */
#line 8586 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.flags|= ALTER_PARSER_ADD_COLUMN;
            if (!lex->alter_info.key_list.is_empty())
              lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 35403 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1337: /* alter_list_item: ADD constraint_def  */
#line 8593 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_ADD_CHECK_CONSTRAINT;
	  }
#line 35411 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1338: /* alter_list_item: ADD CONSTRAINT IF_SYM not EXISTS field_ident check_constraint  */
#line 8597 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           Lex->alter_info.flags|= ALTER_ADD_CHECK_CONSTRAINT;
           Lex->add_constraint((yyvsp[-1].lex_str), (yyvsp[0].virtual_column), TRUE);
         }
#line 35420 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1339: /* alter_list_item: CHANGE opt_column opt_if_exists_table_element field_ident field_spec opt_place  */
#line 8603 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_CHANGE_COLUMN | ALTER_RENAME_COLUMN;
            Lex->create_last_non_select_table= Lex->last_table();
            (yyvsp[-1].create_field)->change= (yyvsp[-2].lex_str);
            (yyvsp[-1].create_field)->after= (yyvsp[0].lex_str);
          }
#line 35431 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1340: /* alter_list_item: MODIFY_SYM opt_column opt_if_exists_table_element field_spec opt_place  */
#line 8611 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_CHANGE_COLUMN;
            Lex->create_last_non_select_table= Lex->last_table();
            (yyvsp[-1].create_field)->change= (yyvsp[-1].create_field)->field_name;
            (yyvsp[-1].create_field)->after= (yyvsp[0].lex_str);
          }
#line 35442 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1341: /* alter_list_item: DROP opt_column opt_if_exists_table_element field_ident opt_restrict  */
#line 8618 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::COLUMN, (yyvsp[-1].lex_str).str, (yyvsp[-2].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_PARSER_DROP_COLUMN;
          }
#line 35456 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1342: /* alter_list_item: DROP CONSTRAINT opt_if_exists_table_element field_ident  */
#line 8628 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::CHECK_CONSTRAINT,
                                        (yyvsp[0].lex_str).str, (yyvsp[-1].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_CHECK_CONSTRAINT;
          }
#line 35471 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1343: /* alter_list_item: DROP FOREIGN KEY_SYM opt_if_exists_table_element field_ident  */
#line 8639 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::FOREIGN_KEY, (yyvsp[0].lex_str).str, (yyvsp[-1].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_FOREIGN_KEY;
          }
#line 35485 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1344: /* alter_list_item: DROP opt_constraint_no_id PRIMARY_SYM KEY_SYM  */
#line 8649 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::KEY, primary_key_name,
                                        FALSE));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_INDEX;
          }
#line 35500 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1345: /* alter_list_item: DROP key_or_index opt_if_exists_table_element field_ident  */
#line 8660 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::KEY, (yyvsp[0].lex_str).str, (yyvsp[-1].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_INDEX;
          }
#line 35514 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1346: /* alter_list_item: DISABLE_SYM KEYS  */
#line 8670 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.keys_onoff= Alter_info::DISABLE;
            lex->alter_info.flags|= ALTER_KEYS_ONOFF;
          }
#line 35524 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1347: /* alter_list_item: ENABLE_SYM KEYS  */
#line 8676 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.keys_onoff= Alter_info::ENABLE;
            lex->alter_info.flags|= ALTER_KEYS_ONOFF;
          }
#line 35534 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1348: /* alter_list_item: ALTER opt_column opt_if_exists_table_element field_ident SET DEFAULT column_default_expr  */
#line 8682 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (check_expression((yyvsp[0].virtual_column), &(yyvsp[-3].lex_str), VCOL_DEFAULT))
              MYSQL_YYABORT;
            if (unlikely(Lex->add_alter_list((yyvsp[-3].lex_str).str, (yyvsp[0].virtual_column), (yyvsp[-4].num))))
              MYSQL_YYABORT;
          }
#line 35545 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1349: /* alter_list_item: ALTER opt_column opt_if_exists_table_element field_ident DROP DEFAULT  */
#line 8689 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_alter_list((yyvsp[-2].lex_str).str, (Virtual_column_info*) 0,
                                             (yyvsp[-3].num))))
              MYSQL_YYABORT;
          }
#line 35555 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1350: /* alter_list_item: RENAME opt_to table_ident  */
#line 8695 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->first_select_lex()->db= (yyvsp[0].table)->db;
            if (lex->first_select_lex()->db.str == NULL &&
                lex->copy_db_to(&lex->first_select_lex()->db))
              MYSQL_YYABORT;
            if (unlikely(check_table_name((yyvsp[0].table)->table.str,(yyvsp[0].table)->table.length,
                                          FALSE)) ||
                ((yyvsp[0].table)->db.str && unlikely(check_db_name((LEX_STRING*) &(yyvsp[0].table)->db))))
              my_yyabort_error((ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[0].table)->table.str));
            lex->name= (yyvsp[0].table)->table;
            lex->alter_info.flags|= ALTER_RENAME;
          }
#line 35573 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1351: /* alter_list_item: CONVERT_SYM TO_SYM charset charset_name_or_default opt_collate  */
#line 8709 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!(yyvsp[-1].charset))
            {
              (yyvsp[-1].charset)= thd->variables.collation_database;
            }
            (yyvsp[0].charset)= (yyvsp[0].charset) ? (yyvsp[0].charset) : (yyvsp[-1].charset);
            if (unlikely(!my_charset_same((yyvsp[-1].charset),(yyvsp[0].charset))))
              my_yyabort_error((ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                                (yyvsp[0].charset)->name, (yyvsp[-1].charset)->csname));
            if (unlikely(Lex->create_info.add_alter_list_item_convert_to_charset((yyvsp[0].charset))))
              MYSQL_YYABORT;
            Lex->alter_info.flags|= ALTER_CONVERT_TO;
          }
#line 35591 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1352: /* alter_list_item: create_table_options_space_separated  */
#line 8723 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.flags|= ALTER_OPTIONS;
          }
#line 35600 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1353: /* alter_list_item: FORCE_SYM  */
#line 8728 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_RECREATE;
          }
#line 35608 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1354: /* alter_list_item: alter_order_clause  */
#line 8732 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.flags|= ALTER_ORDER;
          }
#line 35617 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1357: /* alter_list_item: ADD SYSTEM VERSIONING_SYM  */
#line 8739 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_ADD_SYSTEM_VERSIONING;
            Lex->create_info.options|= HA_VERSIONED_TABLE;
          }
#line 35626 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1358: /* alter_list_item: DROP SYSTEM VERSIONING_SYM  */
#line 8744 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_DROP_SYSTEM_VERSIONING;
            Lex->create_info.options&= ~HA_VERSIONED_TABLE;
          }
#line 35635 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1359: /* alter_list_item: DROP PERIOD_SYM FOR_SYSTEM_TIME_SYM  */
#line 8749 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_DROP_PERIOD;
          }
#line 35643 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1360: /* alter_list_item: DROP PERIOD_SYM opt_if_exists_table_element FOR_SYM ident  */
#line 8753 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Alter_drop *ad= new Alter_drop(Alter_drop::PERIOD, (yyvsp[0].ident_sys).str, (yyvsp[-2].num));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            Lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            Lex->alter_info.flags|= ALTER_DROP_CHECK_CONSTRAINT;
          }
#line 35655 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1366: /* alter_algorithm_option: ALGORITHM_SYM opt_equal DEFAULT  */
#line 8772 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.set_requested_algorithm(
              Alter_info::ALTER_TABLE_ALGORITHM_DEFAULT);
          }
#line 35664 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1367: /* alter_algorithm_option: ALGORITHM_SYM opt_equal ident  */
#line 8777 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->alter_info.set_requested_algorithm(&(yyvsp[0].ident_sys))))
              my_yyabort_error((ER_UNKNOWN_ALTER_ALGORITHM, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 35673 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1368: /* alter_lock_option: LOCK_SYM opt_equal DEFAULT  */
#line 8785 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.requested_lock=
              Alter_info::ALTER_TABLE_LOCK_DEFAULT;
          }
#line 35682 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1369: /* alter_lock_option: LOCK_SYM opt_equal ident  */
#line 8790 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->alter_info.set_requested_lock(&(yyvsp[0].ident_sys))))
              my_yyabort_error((ER_UNKNOWN_ALTER_LOCK, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 35691 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1370: /* opt_column: %empty  */
#line 8797 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 35697 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1371: /* opt_column: COLUMN_SYM  */
#line 8798 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     {}
#line 35703 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1372: /* opt_ignore: %empty  */
#line 8802 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->ignore= 0;}
#line 35709 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1373: /* opt_ignore: IGNORE_SYM  */
#line 8803 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { Lex->ignore= 1;}
#line 35715 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1374: /* $@143: %empty  */
#line 8807 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        { Lex->ignore= 0;}
#line 35721 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1380: /* alter_option: IGNORE_SYM  */
#line 8821 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { Lex->ignore= 1;}
#line 35727 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1381: /* alter_option: ONLINE_SYM  */
#line 8823 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.requested_lock=
              Alter_info::ALTER_TABLE_LOCK_NONE;
          }
#line 35736 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1382: /* opt_restrict: %empty  */
#line 8830 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->drop_mode= DROP_DEFAULT; }
#line 35742 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1383: /* opt_restrict: RESTRICT  */
#line 8831 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->drop_mode= DROP_RESTRICT; }
#line 35748 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1384: /* opt_restrict: CASCADE  */
#line 8832 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->drop_mode= DROP_CASCADE; }
#line 35754 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1385: /* opt_place: %empty  */
#line 8836 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.lex_str)= null_clex_str; }
#line 35760 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1386: /* opt_place: AFTER_SYM ident  */
#line 8838 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_str)= (yyvsp[0].ident_sys);
            Lex->alter_info.flags |= ALTER_COLUMN_ORDER;
          }
#line 35769 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1387: /* opt_place: FIRST_SYM  */
#line 8843 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_str).str=    first_keyword;
	    (yyval.lex_str).length= 5; /* Length of "first" */
            Lex->alter_info.flags |= ALTER_COLUMN_ORDER;
          }
#line 35779 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1388: /* opt_to: %empty  */
#line 8851 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 35785 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1389: /* opt_to: TO_SYM  */
#line 8852 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 {}
#line 35791 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1390: /* opt_to: '='  */
#line 8853 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              {}
#line 35797 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1391: /* opt_to: AS  */
#line 8854 "/home/buildbot/git/sql/sql_yacc_ora.yy"
             {}
#line 35803 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1392: /* $@144: %empty  */
#line 8859 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_START;
            lex->type = 0;
            /* If you change this code don't forget to update SLAVE START too */
          }
#line 35814 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1393: /* slave: START_SYM SLAVE optional_connection_name slave_thread_opts $@144 slave_until  */
#line 8866 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 35820 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1394: /* $@145: %empty  */
#line 8868 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_ALL_START;
            lex->type = 0;
            /* If you change this code don't forget to update STOP SLAVE too */
          }
#line 35831 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1395: /* slave: START_SYM ALL SLAVES slave_thread_opts $@145  */
#line 8874 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 35837 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1396: /* slave: STOP_SYM SLAVE optional_connection_name slave_thread_opts  */
#line 8876 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_STOP;
            lex->type = 0;
            /* If you change this code don't forget to update SLAVE STOP too */
          }
#line 35848 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1397: /* slave: STOP_SYM ALL SLAVES slave_thread_opts  */
#line 8883 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_ALL_STOP;
            lex->type = 0;
            /* If you change this code don't forget to update SLAVE STOP too */
          }
#line 35859 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1398: /* start: START_SYM TRANSACTION_SYM opt_start_transaction_option_list  */
#line 8893 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_BEGIN;
            /* READ ONLY and READ WRITE are mutually exclusive. */
            if (unlikely(((yyvsp[0].num) & MYSQL_START_TRANS_OPT_READ_WRITE) &&
                         ((yyvsp[0].num) & MYSQL_START_TRANS_OPT_READ_ONLY)))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
            lex->start_transaction_opt= (yyvsp[0].num);
          }
#line 35876 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1399: /* opt_start_transaction_option_list: %empty  */
#line 8909 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= 0;
          }
#line 35884 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1400: /* opt_start_transaction_option_list: start_transaction_option_list  */
#line 8913 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= (yyvsp[0].num);
          }
#line 35892 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1401: /* start_transaction_option_list: start_transaction_option  */
#line 8920 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= (yyvsp[0].num);
          }
#line 35900 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1402: /* start_transaction_option_list: start_transaction_option_list ',' start_transaction_option  */
#line 8924 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= (yyvsp[-2].num) | (yyvsp[0].num);
          }
#line 35908 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1403: /* start_transaction_option: WITH CONSISTENT_SYM SNAPSHOT_SYM  */
#line 8931 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= MYSQL_START_TRANS_OPT_WITH_CONS_SNAPSHOT;
          }
#line 35916 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1404: /* start_transaction_option: READ_SYM ONLY_SYM  */
#line 8935 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= MYSQL_START_TRANS_OPT_READ_ONLY;
          }
#line 35924 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1405: /* start_transaction_option: READ_SYM WRITE_SYM  */
#line 8939 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= MYSQL_START_TRANS_OPT_READ_WRITE;
          }
#line 35932 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1406: /* $@146: %empty  */
#line 8945 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->slave_thd_opt= 0; }
#line 35938 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1407: /* slave_thread_opts: $@146 slave_thread_opt_list  */
#line 8947 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 35944 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1410: /* slave_thread_opt: %empty  */
#line 8956 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 35950 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1411: /* slave_thread_opt: SQL_THREAD  */
#line 8957 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->slave_thd_opt|=SLAVE_SQL; }
#line 35956 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1412: /* slave_thread_opt: RELAY_THREAD  */
#line 8958 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->slave_thd_opt|=SLAVE_IO; }
#line 35962 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1413: /* slave_until: %empty  */
#line 8962 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 35968 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1414: /* slave_until: UNTIL_SYM slave_until_opts  */
#line 8964 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(((lex->mi.log_file_name || lex->mi.pos) &&
                         (lex->mi.relay_log_name || lex->mi.relay_log_pos)) ||
                         !((lex->mi.log_file_name && lex->mi.pos) ||
                           (lex->mi.relay_log_name && lex->mi.relay_log_pos))))
               my_yyabort_error((ER_BAD_SLAVE_UNTIL_COND, MYF(0)));
          }
#line 35981 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1415: /* slave_until: UNTIL_SYM MASTER_GTID_POS_SYM '=' TEXT_STRING_sys  */
#line 8973 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.gtid_pos_str = (yyvsp[0].lex_str);
          }
#line 35989 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1418: /* $@147: %empty  */
#line 8985 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_CHECKSUM;
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36000 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1419: /* checksum: CHECKSUM_SYM table_or_tables $@147 table_list opt_checksum_type  */
#line 8992 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 36006 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1420: /* opt_checksum_type: %empty  */
#line 8996 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->check_opt.flags= 0; }
#line 36012 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1421: /* opt_checksum_type: QUICK  */
#line 8997 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->check_opt.flags= T_QUICK; }
#line 36018 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1422: /* opt_checksum_type: EXTENDED_SYM  */
#line 8998 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->check_opt.flags= T_EXTEND; }
#line 36024 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1424: /* $@148: %empty  */
#line 9004 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->table_type= TABLE_TYPE_VIEW; }
#line 36030 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1426: /* $@149: %empty  */
#line 9010 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_REPAIR;
            lex->no_write_to_binlog= (yyvsp[0].num);
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36044 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1427: /* repair: REPAIR opt_no_write_to_binlog $@149 repair_table_or_view  */
#line 9020 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_repair_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 36056 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1428: /* opt_mi_repair_type: %empty  */
#line 9030 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->check_opt.flags = T_MEDIUM; }
#line 36062 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1429: /* opt_mi_repair_type: mi_repair_types  */
#line 9031 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 36068 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1430: /* mi_repair_types: mi_repair_type  */
#line 9035 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         {}
#line 36074 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1431: /* mi_repair_types: mi_repair_type mi_repair_types  */
#line 9036 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         {}
#line 36080 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1432: /* mi_repair_type: QUICK  */
#line 9040 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->check_opt.flags|= T_QUICK; }
#line 36086 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1433: /* mi_repair_type: EXTENDED_SYM  */
#line 9041 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->check_opt.flags|= T_EXTEND; }
#line 36092 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1434: /* mi_repair_type: USE_FRM  */
#line 9042 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->check_opt.sql_flags|= TT_USEFRM; }
#line 36098 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1435: /* opt_view_repair_type: %empty  */
#line 9046 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { }
#line 36104 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1436: /* opt_view_repair_type: FROM MYSQL_SYM  */
#line 9047 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { Lex->check_opt.sql_flags|= TT_FROM_MYSQL; }
#line 36110 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1437: /* $@150: %empty  */
#line 9052 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_ANALYZE;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36124 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1438: /* analyze: ANALYZE_SYM opt_no_write_to_binlog table_or_tables $@150 analyze_table_list  */
#line 9062 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_analyze_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 36136 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1442: /* opt_persistent_stat_clause: %empty  */
#line 9082 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 36142 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1443: /* opt_persistent_stat_clause: PERSISTENT_SYM FOR_SYM persistent_stat_spec  */
#line 9084 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            thd->lex->with_persistent_for_clause= TRUE;
          }
#line 36150 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1444: /* persistent_stat_spec: ALL  */
#line 9091 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 36156 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1445: /* persistent_stat_spec: COLUMNS persistent_column_stat_spec INDEXES persistent_index_stat_spec  */
#line 9093 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 36162 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1446: /* persistent_column_stat_spec: ALL  */
#line 9097 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              {}
#line 36168 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1447: /* $@151: %empty  */
#line 9099 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            LEX* lex= thd->lex;
            lex->column_list= new (thd->mem_root) List<LEX_STRING>;
            if (unlikely(lex->column_list == NULL))
              MYSQL_YYABORT;
          }
#line 36179 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1448: /* persistent_column_stat_spec: '(' $@151 table_column_list ')'  */
#line 9107 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 36185 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1449: /* persistent_index_stat_spec: ALL  */
#line 9111 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              {}
#line 36191 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1450: /* $@152: %empty  */
#line 9113 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            LEX* lex= thd->lex;
            lex->index_list= new (thd->mem_root) List<LEX_STRING>;
            if (unlikely(lex->index_list == NULL))
              MYSQL_YYABORT;
          }
#line 36202 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1451: /* persistent_index_stat_spec: '(' $@152 table_index_list ')'  */
#line 9121 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 36208 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1452: /* table_column_list: %empty  */
#line 9126 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 36214 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1453: /* table_column_list: ident  */
#line 9128 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->column_list->push_back((LEX_STRING*)
                thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_STRING)), thd->mem_root);
          }
#line 36223 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1454: /* table_column_list: table_column_list ',' ident  */
#line 9133 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->column_list->push_back((LEX_STRING*)
                thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_STRING)), thd->mem_root);
          }
#line 36232 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1455: /* table_index_list: %empty  */
#line 9141 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 36238 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1458: /* table_index_name: ident  */
#line 9148 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->index_list->push_back((LEX_STRING*)
                                       thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_STRING)),
                                       thd->mem_root);
          }
#line 36248 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1459: /* table_index_name: PRIMARY_SYM  */
#line 9155 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX_STRING str= {(char*) "PRIMARY", 7};
            Lex->index_list->push_back((LEX_STRING*)
                                        thd->memdup(&str, sizeof(LEX_STRING)),
                                        thd->mem_root);
          }
#line 36259 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1460: /* binlog_base64_event: BINLOG_SYM TEXT_STRING_sys  */
#line 9165 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_BINLOG_BASE64_EVENT;
            Lex->comment= (yyvsp[0].lex_str);
            Lex->ident.str=    NULL;
            Lex->ident.length= 0;
          }
#line 36270 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1461: /* binlog_base64_event: BINLOG_SYM '@' ident_or_text ',' '@' ident_or_text  */
#line 9173 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_BINLOG_BASE64_EVENT;
            Lex->comment= (yyvsp[-3].lex_str);
            Lex->ident=   (yyvsp[0].lex_str);
          }
#line 36280 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1463: /* $@153: %empty  */
#line 9183 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->table_type= TABLE_TYPE_VIEW; }
#line 36286 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1465: /* $@154: %empty  */
#line 9188 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;

            lex->sql_command = SQLCOM_CHECK;
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36300 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1466: /* check: CHECK_SYM $@154 check_view_or_table  */
#line 9198 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX* lex= thd->lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "CHECK"));
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_check_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 36314 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1467: /* opt_mi_check_type: %empty  */
#line 9210 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->check_opt.flags = T_MEDIUM; }
#line 36320 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1468: /* opt_mi_check_type: mi_check_types  */
#line 9211 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         {}
#line 36326 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1469: /* mi_check_types: mi_check_type  */
#line 9215 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        {}
#line 36332 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1470: /* mi_check_types: mi_check_type mi_check_types  */
#line 9216 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                       {}
#line 36338 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1471: /* mi_check_type: QUICK  */
#line 9220 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.flags|= T_QUICK; }
#line 36344 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1472: /* mi_check_type: FAST_SYM  */
#line 9221 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.flags|= T_FAST; }
#line 36350 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1473: /* mi_check_type: MEDIUM_SYM  */
#line 9222 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.flags|= T_MEDIUM; }
#line 36356 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1474: /* mi_check_type: EXTENDED_SYM  */
#line 9223 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.flags|= T_EXTEND; }
#line 36362 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1475: /* mi_check_type: CHANGED  */
#line 9224 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.flags|= T_CHECK_ONLY_CHANGED; }
#line 36368 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1476: /* mi_check_type: FOR_SYM UPGRADE_SYM  */
#line 9225 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.sql_flags|= TT_FOR_UPGRADE; }
#line 36374 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1477: /* opt_view_check_type: %empty  */
#line 9229 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { }
#line 36380 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1478: /* opt_view_check_type: FOR_SYM UPGRADE_SYM  */
#line 9230 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.sql_flags|= TT_FOR_UPGRADE; }
#line 36386 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1479: /* $@155: %empty  */
#line 9235 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_OPTIMIZE;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36400 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1480: /* optimize: OPTIMIZE opt_no_write_to_binlog table_or_tables $@155 table_list opt_lock_wait_timeout  */
#line 9245 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_optimize_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 36412 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1481: /* opt_no_write_to_binlog: %empty  */
#line 9255 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0; }
#line 36418 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1482: /* opt_no_write_to_binlog: NO_WRITE_TO_BINLOG  */
#line 9256 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num)= 1; }
#line 36424 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1483: /* opt_no_write_to_binlog: LOCAL_SYM  */
#line 9257 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.num)= 1; }
#line 36430 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1484: /* $@156: %empty  */
#line 9262 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_RENAME_TABLE;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 36440 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1485: /* rename: RENAME table_or_tables $@156 table_to_table_list  */
#line 9268 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 36448 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1486: /* rename: RENAME USER_SYM clear_privileges rename_list  */
#line 9272 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_RENAME_USER;
          }
#line 36456 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1487: /* rename_list: user TO_SYM user  */
#line 9279 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[-2].lex_user), thd->mem_root) ||
                         Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 36466 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1488: /* rename_list: rename_list ',' user TO_SYM user  */
#line 9285 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[-2].lex_user), thd->mem_root) ||
                         Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 36476 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1491: /* table_to_table: table_ident opt_lock_wait_timeout TO_SYM table_ident  */
#line 9299 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            SELECT_LEX *sl= lex->current_select;
            if (unlikely(!sl->add_table_to_list(thd, (yyvsp[-3].table),NULL,
                                                TL_OPTION_UPDATING,
                                                TL_IGNORE, MDL_EXCLUSIVE)) ||
                unlikely(!sl->add_table_to_list(thd, (yyvsp[0].table), NULL,
                                                TL_OPTION_UPDATING,
                                                TL_IGNORE, MDL_EXCLUSIVE)))
              MYSQL_YYABORT;
          }
#line 36492 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1492: /* $@157: %empty  */
#line 9314 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.reset();
          }
#line 36500 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1493: /* keycache: CACHE_SYM INDEX_SYM $@157 keycache_list_or_parts IN_SYM key_cache_name  */
#line 9318 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ASSIGN_TO_KEYCACHE;
            lex->ident= (yyvsp[0].lex_str);
          }
#line 36510 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1498: /* assign_to_keycache: table_ident cache_keys_spec  */
#line 9337 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-1].table), NULL, 0, TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 36522 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1499: /* assign_to_keycache_parts: table_ident adm_partition cache_keys_spec  */
#line 9348 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-2].table), NULL, 0, TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 36534 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1500: /* key_cache_name: ident  */
#line 9358 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 36540 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1501: /* key_cache_name: DEFAULT  */
#line 9359 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { (yyval.lex_str) = default_key_cache_base; }
#line 36546 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1502: /* $@158: %empty  */
#line 9364 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_PRELOAD_KEYS;
            lex->alter_info.reset();
            if (lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 36558 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1503: /* preload: LOAD INDEX_SYM INTO CACHE_SYM $@158 preload_list_or_parts  */
#line 9372 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 36566 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1508: /* preload_keys: table_ident cache_keys_spec opt_ignore_leaves  */
#line 9389 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-2].table), NULL, (yyvsp[0].num), TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 36578 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1509: /* preload_keys_parts: table_ident adm_partition cache_keys_spec opt_ignore_leaves  */
#line 9400 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-3].table), NULL, (yyvsp[0].num), TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 36590 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1510: /* $@159: %empty  */
#line 9411 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_ADMIN;
          }
#line 36598 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1512: /* $@160: %empty  */
#line 9418 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->first_select_lex()->alloc_index_hints(thd);
            Lex->first_select_lex()->set_index_hint_type(INDEX_HINT_USE,
                                                         INDEX_HINT_MASK_ALL);
          }
#line 36608 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1514: /* cache_key_list_or_empty: %empty  */
#line 9427 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { }
#line 36614 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1516: /* opt_ignore_leaves: %empty  */
#line 9433 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)= 0; }
#line 36620 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1517: /* opt_ignore_leaves: IGNORE_SYM LEAVES  */
#line 9434 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { (yyval.num)= TL_OPTION_IGNORE_LEAVES; }
#line 36626 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1518: /* $@161: %empty  */
#line 9443 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex_unit)->fake_select_lex ?
                                 (yyvsp[0].select_lex_unit)->fake_select_lex :
                                 (yyvsp[0].select_lex_unit)->first_select()))
              MYSQL_YYABORT;
          }
#line 36637 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1519: /* select: query_expression_no_with_clause $@161 opt_procedure_or_into  */
#line 9450 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select();
            (yyvsp[-2].select_lex_unit)->set_with_clause(NULL);
            if (Lex->select_finalize((yyvsp[-2].select_lex_unit), (yyvsp[0].select_lock)))
              MYSQL_YYABORT;
          }
#line 36648 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1520: /* $@162: %empty  */
#line 9457 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex_unit)->fake_select_lex ?
                                 (yyvsp[0].select_lex_unit)->fake_select_lex :
                                 (yyvsp[0].select_lex_unit)->first_select()))
              MYSQL_YYABORT;
          }
#line 36659 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1521: /* select: with_clause query_expression_no_with_clause $@162 opt_procedure_or_into  */
#line 9464 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select();
            (yyvsp[-2].select_lex_unit)->set_with_clause((yyvsp[-3].with_clause));
            (yyvsp[-3].with_clause)->attach_to((yyvsp[-2].select_lex_unit)->first_select());
            if (Lex->select_finalize((yyvsp[-2].select_lex_unit), (yyvsp[0].select_lock)))
              MYSQL_YYABORT;
          }
#line 36671 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1522: /* $@163: %empty  */
#line 9476 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex)))
              MYSQL_YYABORT;
          }
#line 36680 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1523: /* select_into: select_into_query_specification $@163 opt_order_limit_lock  */
#line 9481 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX_UNIT *unit;
            if (!(unit  = Lex->create_unit((yyvsp[-2].select_lex))))
              MYSQL_YYABORT;
            if ((yyvsp[0].order_limit_lock))
              unit= Lex->add_tail_to_query_expression_body(unit, (yyvsp[0].order_limit_lock));
            if (Lex->select_finalize(unit))
              MYSQL_YYABORT;
           }
#line 36694 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1524: /* $@164: %empty  */
#line 9492 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex)))
              MYSQL_YYABORT;
          }
#line 36703 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1525: /* select_into: with_clause select_into_query_specification $@164 opt_order_limit_lock  */
#line 9497 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX_UNIT *unit;
            if (!(unit  = Lex->create_unit((yyvsp[-2].select_lex))))
              MYSQL_YYABORT;
            if ((yyvsp[0].order_limit_lock))
              unit= Lex->add_tail_to_query_expression_body(unit, (yyvsp[0].order_limit_lock));
            unit->set_with_clause((yyvsp[-3].with_clause));
            (yyvsp[-3].with_clause)->attach_to((yyvsp[-2].select_lex));
            if (Lex->select_finalize(unit))
              MYSQL_YYABORT;
          }
#line 36719 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1526: /* simple_table: query_specification  */
#line 9512 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.select_lex)= (yyvsp[0].select_lex); }
#line 36725 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1527: /* simple_table: table_value_constructor  */
#line 9513 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.select_lex)= (yyvsp[0].select_lex); }
#line 36731 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1528: /* $@165: %empty  */
#line 9518 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->parsed_TVC_start())
              MYSQL_YYABORT;
	  }
#line 36740 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1529: /* table_value_constructor: VALUES $@165 values_list  */
#line 9523 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.select_lex)= Lex->parsed_TVC_end()))
	      MYSQL_YYABORT;
	  }
#line 36749 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1530: /* $@166: %empty  */
#line 9531 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel;
            LEX *lex= Lex;
            if (!(sel= lex->alloc_select(TRUE)) ||
                  lex->push_select(sel))
              MYSQL_YYABORT;
            sel->init_select();
            sel->braces= FALSE;
          }
#line 36763 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1531: /* $@167: %empty  */
#line 9541 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->parsing_place= SELECT_LIST;
          }
#line 36771 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1532: /* query_specification_start: SELECT_SYM $@166 select_options $@167 select_item_list  */
#line 9545 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->parsing_place= NO_MATTER;
          }
#line 36779 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1533: /* query_specification: query_specification_start opt_from_clause opt_where_clause opt_group_clause opt_having_clause opt_window_clause  */
#line 9557 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_lex)= Lex->pop_select();
          }
#line 36787 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1534: /* select_into_query_specification: query_specification_start into opt_from_clause opt_where_clause opt_group_clause opt_having_clause opt_window_clause  */
#line 9570 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_lex)= Lex->pop_select();
          }
#line 36795 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1535: /* query_expression: query_expression_no_with_clause  */
#line 9628 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[0].select_lex_unit)->set_with_clause(NULL);
            (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit);
          }
#line 36804 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1536: /* query_expression: with_clause query_expression_no_with_clause  */
#line 9634 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[0].select_lex_unit)->set_with_clause((yyvsp[-1].with_clause));
            (yyvsp[-1].with_clause)->attach_to((yyvsp[0].select_lex_unit)->first_select());
            (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit);
          }
#line 36814 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1537: /* query_expression_no_with_clause: query_expression_body_ext  */
#line 9647 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                    { (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit); }
#line 36820 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1538: /* query_expression_no_with_clause: query_expression_body_ext_parens  */
#line 9648 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit); }
#line 36826 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1539: /* $@168: %empty  */
#line 9663 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[0].select_lex_unit)->first_select()->next_select())
            {
              if (Lex->parsed_multi_operand_query_expression_body((yyvsp[0].select_lex_unit)))
                MYSQL_YYABORT;
            }
          }
#line 36838 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1540: /* query_expression_body_ext: query_expression_body $@168 opt_query_expression_tail  */
#line 9671 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!(yyvsp[0].order_limit_lock))
              (yyval.select_lex_unit)= (yyvsp[-2].select_lex_unit);
            else
              (yyval.select_lex_unit)= Lex->add_tail_to_query_expression_body((yyvsp[-2].select_lex_unit), (yyvsp[0].order_limit_lock));
          }
#line 36849 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1541: /* $@169: %empty  */
#line 9678 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->push_select(!(yyvsp[0].select_lex_unit)->first_select()->next_select() ?
                               (yyvsp[0].select_lex_unit)->first_select() : (yyvsp[0].select_lex_unit)->fake_select_lex);
          }
#line 36858 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1542: /* query_expression_body_ext: query_expression_body_ext_parens $@169 query_expression_tail  */
#line 9683 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.select_lex_unit)= Lex->add_tail_to_query_expression_body_ext_parens((yyvsp[-2].select_lex_unit), (yyvsp[0].order_limit_lock))))
               MYSQL_YYABORT;
          }
#line 36867 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1543: /* query_expression_body_ext_parens: '(' query_expression_body_ext_parens ')'  */
#line 9691 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_lex_unit)= (yyvsp[-1].select_lex_unit); }
#line 36873 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1544: /* query_expression_body_ext_parens: '(' query_expression_body_ext ')'  */
#line 9693 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= (yyvsp[-1].select_lex_unit)->first_select()->next_select() ?
                               (yyvsp[-1].select_lex_unit)->fake_select_lex : (yyvsp[-1].select_lex_unit)->first_select();
            sel->braces= true;
            (yyval.select_lex_unit)= (yyvsp[-1].select_lex_unit);
          }
#line 36884 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1545: /* query_expression_body: query_simple  */
#line 9708 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->push_select((yyvsp[0].select_lex));
            if (!((yyval.select_lex_unit)= Lex->create_unit((yyvsp[0].select_lex))))
              MYSQL_YYABORT;
          }
#line 36894 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1546: /* $@170: %empty  */
#line 9715 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!(yyvsp[-1].select_lex_unit)->first_select()->next_select())
            {
              Lex->pop_select();
            }
          }
#line 36905 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1547: /* query_expression_body: query_expression_body unit_type_decl $@170 query_primary  */
#line 9722 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.select_lex_unit)= Lex->add_primary_to_query_expression_body((yyvsp[-3].select_lex_unit), (yyvsp[0].select_lex),
                                                                (yyvsp[-2].unit_operation).unit_type,
                                                                (yyvsp[-2].unit_operation).distinct,
                                                                TRUE)))
              MYSQL_YYABORT;
          }
#line 36917 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1548: /* query_expression_body: query_expression_body_ext_parens unit_type_decl query_primary  */
#line 9732 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.select_lex_unit)= Lex->add_primary_to_query_expression_body_ext_parens(
                                                                (yyvsp[-2].select_lex_unit), (yyvsp[0].select_lex),
                                                                (yyvsp[-1].unit_operation).unit_type,
                                                                (yyvsp[-1].unit_operation).distinct)))
              MYSQL_YYABORT;
          }
#line 36929 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1549: /* query_primary: query_simple  */
#line 9748 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_lex)= (yyvsp[0].select_lex); }
#line 36935 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1550: /* query_primary: query_expression_body_ext_parens  */
#line 9750 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_lex)= (yyvsp[0].select_lex_unit)->first_select(); }
#line 36941 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1551: /* query_simple: simple_table  */
#line 9759 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.select_lex)= (yyvsp[0].select_lex);}
#line 36947 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1552: /* subselect: query_expression  */
#line 9764 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.select_lex)= Lex->parsed_subselect((yyvsp[0].select_lex_unit))))
              YYABORT;
          }
#line 36956 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1553: /* subquery: query_expression_body_ext_parens  */
#line 9805 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!(yyvsp[0].select_lex_unit)->fake_select_lex)
              (yyvsp[0].select_lex_unit)->first_select()->braces= false;
            else
              (yyvsp[0].select_lex_unit)->fake_select_lex->braces= false;
            if (!((yyval.select_lex)= Lex->parsed_subselect((yyvsp[0].select_lex_unit))))
              YYABORT;
          }
#line 36969 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1554: /* subquery: '(' with_clause query_expression_no_with_clause ')'  */
#line 9814 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-1].select_lex_unit)->set_with_clause((yyvsp[-2].with_clause));
            (yyvsp[-2].with_clause)->attach_to((yyvsp[-1].select_lex_unit)->first_select());
            if (!((yyval.select_lex)= Lex->parsed_subselect((yyvsp[-1].select_lex_unit))))
              YYABORT;
          }
#line 36980 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1558: /* table_reference_list: join_table_list  */
#line 9833 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->context.table_list=
              Select->context.first_name_resolution_table=
                Select->table_list.first;
          }
#line 36990 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1561: /* select_options: select_option_list  */
#line 9848 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((Select->options & SELECT_DISTINCT) &&
                         (Select->options & SELECT_ALL)))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "ALL", "DISTINCT"));
          }
#line 37000 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1562: /* opt_history_unit: %empty  */
#line 9857 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.vers_range_unit)= VERS_UNDEFINED;
          }
#line 37008 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1563: /* opt_history_unit: TRANSACTION_SYM  */
#line 9861 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.vers_range_unit)= VERS_TRX_ID;
          }
#line 37016 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1564: /* opt_history_unit: TIMESTAMP  */
#line 9865 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.vers_range_unit)= VERS_TIMESTAMP;
          }
#line 37024 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1565: /* history_point: TIMESTAMP TEXT_STRING  */
#line 9872 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item;
            if (!(item= type_handler_datetime2.create_literal_item(thd,
                                                      (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                      YYCSCL, true)))
              MYSQL_YYABORT;
            (yyval.vers_history_point)= Vers_history_point(VERS_TIMESTAMP, item);
          }
#line 37037 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1566: /* history_point: function_call_keyword_timestamp  */
#line 9881 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.vers_history_point)= Vers_history_point(VERS_TIMESTAMP, (yyvsp[0].item));
          }
#line 37045 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1567: /* history_point: opt_history_unit bit_expr  */
#line 9885 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.vers_history_point)= Vers_history_point((yyvsp[-1].vers_range_unit), (yyvsp[0].item));
          }
#line 37053 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1568: /* for_portion_of_time_clause: FOR_SYM PORTION_SYM OF_SYM remember_tok_start ident FROM bit_expr TO_SYM bit_expr  */
#line 9893 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(0 == strcasecmp((yyvsp[-4].ident_sys).str, "SYSTEM_TIME")))
            {
              thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-5].simple_string));
              MYSQL_YYABORT;
            }
            Lex->period_conditions.init(SYSTEM_TIME_FROM_TO,
                                        Vers_history_point(VERS_TIMESTAMP, (yyvsp[-2].item)),
                                        Vers_history_point(VERS_TIMESTAMP, (yyvsp[0].item)),
                                        (yyvsp[-4].ident_sys));
          }
#line 37069 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1569: /* opt_for_portion_of_time_clause: %empty  */
#line 9908 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= false;
          }
#line 37077 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1570: /* opt_for_portion_of_time_clause: for_portion_of_time_clause  */
#line 9912 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            {
            (yyval.num)= true;
          }
#line 37085 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1571: /* opt_for_system_time_clause: %empty  */
#line 9919 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= false;
          }
#line 37093 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1572: /* opt_for_system_time_clause: FOR_SYSTEM_TIME_SYM system_time_expr  */
#line 9923 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= true;
          }
#line 37101 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1573: /* system_time_expr: AS OF_SYM history_point  */
#line 9930 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_AS_OF, (yyvsp[0].vers_history_point));
          }
#line 37109 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1574: /* system_time_expr: ALL  */
#line 9934 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_ALL);
          }
#line 37117 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1575: /* system_time_expr: FROM history_point TO_SYM history_point  */
#line 9938 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_FROM_TO, (yyvsp[-2].vers_history_point), (yyvsp[0].vers_history_point));
          }
#line 37125 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1576: /* system_time_expr: BETWEEN_SYM history_point AND_SYM history_point  */
#line 9942 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_BETWEEN, (yyvsp[-2].vers_history_point), (yyvsp[0].vers_history_point));
          }
#line 37133 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1580: /* select_option: SQL_NO_CACHE_SYM  */
#line 9955 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Allow this flag once per query.
            */
            if (Select->options & OPTION_NO_QUERY_CACHE)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "SQL_NO_CACHE"));
            Select->options|= OPTION_NO_QUERY_CACHE;
          }
#line 37146 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1581: /* select_option: SQL_CACHE_SYM  */
#line 9964 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Allow this flag once per query.
            */
            if (Select->options & OPTION_TO_QUERY_CACHE)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "SQL_CACHE"));
            Select->options|= OPTION_TO_QUERY_CACHE;
          }
#line 37159 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1582: /* select_lock_type: FOR_SYM UPDATE_SYM opt_lock_wait_timeout_new  */
#line 9977 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_lock)= (yyvsp[0].select_lock);
            (yyval.select_lock).defined_lock= TRUE;
            (yyval.select_lock).update_lock= TRUE;
          }
#line 37169 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1583: /* select_lock_type: LOCK_SYM IN_SYM SHARE_SYM MODE_SYM opt_lock_wait_timeout_new  */
#line 9983 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_lock)= (yyvsp[0].select_lock);
            (yyval.select_lock).defined_lock= TRUE;
            (yyval.select_lock).update_lock= FALSE;
          }
#line 37179 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1584: /* opt_select_lock_type: %empty  */
#line 9992 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.select_lock).empty();
        }
#line 37187 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1585: /* opt_select_lock_type: select_lock_type  */
#line 9996 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.select_lock)= (yyvsp[0].select_lock);
        }
#line 37195 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1586: /* opt_lock_wait_timeout_new: %empty  */
#line 10003 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.select_lock).empty();
        }
#line 37203 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1587: /* opt_lock_wait_timeout_new: WAIT_SYM ulong_num  */
#line 10007 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.select_lock).defined_timeout= TRUE;
          (yyval.select_lock).timeout= (yyvsp[0].ulong_num);
        }
#line 37212 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1588: /* opt_lock_wait_timeout_new: NOWAIT_SYM  */
#line 10012 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.select_lock).defined_timeout= TRUE;
          (yyval.select_lock).timeout= 0;
        }
#line 37221 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1591: /* select_item_list: '*'  */
#line 10022 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root)
                          Item_field(thd, &thd->lex->current_select->context,
                                     NULL, NULL, &star_clex_str);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            if (unlikely(add_item_to_list(thd, item)))
              MYSQL_YYABORT;
            (thd->lex->current_select->with_wild)++;
          }
#line 37236 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1592: /* select_item: remember_name select_sublist_qualified_asterisk remember_end  */
#line 10036 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(add_item_to_list(thd, (yyvsp[-1].item))))
              MYSQL_YYABORT;
          }
#line 37245 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1593: /* select_item: remember_name expr remember_end select_alias  */
#line 10041 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT((yyvsp[-3].simple_string) < (yyvsp[-1].simple_string));

            if (unlikely(add_item_to_list(thd, (yyvsp[-2].item))))
              MYSQL_YYABORT;
            if ((yyvsp[0].lex_str).str)
            {
              if (unlikely(Lex->sql_command == SQLCOM_CREATE_VIEW &&
                          check_column_name((yyvsp[0].lex_str).str)))
                my_yyabort_error((ER_WRONG_COLUMN_NAME, MYF(0), (yyvsp[0].lex_str).str));
              (yyvsp[-2].item)->is_autogenerated_name= FALSE;
              (yyvsp[-2].item)->set_name(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length, system_charset_info);
            }
            else if (!(yyvsp[-2].item)->name.str || (yyvsp[-2].item)->name.str == item_empty_name)
            {
              (yyvsp[-2].item)->set_name(thd, (yyvsp[-3].simple_string), (uint) ((yyvsp[-1].simple_string) - (yyvsp[-3].simple_string)), thd->charset());
            }
          }
#line 37268 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1594: /* remember_tok_start: %empty  */
#line 10062 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.simple_string)= (char*) YYLIP->get_tok_start();
          }
#line 37276 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1595: /* remember_name: %empty  */
#line 10068 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.simple_string)= (char*) YYLIP->get_cpp_tok_start();
          }
#line 37284 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1596: /* remember_end: %empty  */
#line 10074 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.simple_string)= (char*) YYLIP->get_cpp_tok_end_rtrim();
          }
#line 37292 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1597: /* remember_end_opt: %empty  */
#line 10080 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (yychar == YYEMPTY)
              (yyval.simple_string)= (char*) YYLIP->get_cpp_ptr_rtrim();
            else
              (yyval.simple_string)= (char*) YYLIP->get_cpp_tok_end_rtrim();
          }
#line 37303 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1598: /* select_alias: %empty  */
#line 10089 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str)=null_clex_str;}
#line 37309 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1599: /* select_alias: AS ident  */
#line 10090 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { (yyval.lex_str)=(yyvsp[0].ident_sys); }
#line 37315 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1600: /* select_alias: AS TEXT_STRING_sys  */
#line 10091 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.lex_str)=(yyvsp[0].lex_str); }
#line 37321 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1601: /* select_alias: ident  */
#line 10092 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                { (yyval.lex_str)=(yyvsp[0].ident_sys); }
#line 37327 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1602: /* select_alias: TEXT_STRING_sys  */
#line 10093 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.lex_str)=(yyvsp[0].lex_str); }
#line 37333 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1603: /* opt_default_time_precision: %empty  */
#line 10097 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.num)= NOT_FIXED_DEC;  }
#line 37339 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1604: /* opt_default_time_precision: '(' ')'  */
#line 10098 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.num)= NOT_FIXED_DEC;  }
#line 37345 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1605: /* opt_default_time_precision: '(' real_ulong_num ')'  */
#line 10099 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.num)= (yyvsp[-1].ulong_num); }
#line 37351 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1606: /* opt_time_precision: %empty  */
#line 10103 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.num)= 0;  }
#line 37357 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1607: /* opt_time_precision: '(' ')'  */
#line 10104 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.num)= 0;  }
#line 37363 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1608: /* opt_time_precision: '(' real_ulong_num ')'  */
#line 10105 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.num)= (yyvsp[-1].ulong_num); }
#line 37369 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1609: /* optional_braces: %empty  */
#line 10109 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 37375 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1610: /* optional_braces: '(' ')'  */
#line 10110 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 37381 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1611: /* expr: expr or expr  */
#line 10116 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Design notes:
              Do not use a manually maintained stack like thd->lex->xxx_list,
              but use the internal bison stack ($$, $1 and $3) instead.
              Using the bison stack is:
              - more robust to changes in the grammar,
              - guaranteed to be in sync with the parser state,
              - better for performances (no memory allocation).
            */
            Item_cond_or *item1;
            Item_cond_or *item3;
            if (is_cond_or((yyvsp[-2].item)))
            {
              item1= (Item_cond_or*) (yyvsp[-2].item);
              if (is_cond_or((yyvsp[0].item)))
              {
                item3= (Item_cond_or*) (yyvsp[0].item);
                /*
                  (X1 OR X2) OR (Y1 OR Y2) ==> OR (X1, X2, Y1, Y2)
                */
                item3->add_at_head(item1->argument_list());
                (yyval.item) = (yyvsp[0].item);
              }
              else
              {
                /*
                  (X1 OR X2) OR Y ==> OR (X1, X2, Y)
                */
                item1->add((yyvsp[0].item), thd->mem_root);
                (yyval.item) = (yyvsp[-2].item);
              }
            }
            else if (is_cond_or((yyvsp[0].item)))
            {
              item3= (Item_cond_or*) (yyvsp[0].item);
              /*
                X OR (Y1 OR Y2) ==> OR (X, Y1, Y2)
              */
              item3->add_at_head((yyvsp[-2].item), thd->mem_root);
              (yyval.item) = (yyvsp[0].item);
            }
            else
            {
              /* X OR Y */
              (yyval.item)= new (thd->mem_root) Item_cond_or(thd, (yyvsp[-2].item), (yyvsp[0].item));
              if (unlikely((yyval.item) == NULL))
                MYSQL_YYABORT;
            }
          }
#line 37436 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1612: /* expr: expr XOR expr  */
#line 10167 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* XOR is a proprietary extension */
            (yyval.item)= new (thd->mem_root) Item_func_xor(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37447 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1613: /* expr: expr and expr  */
#line 10174 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* See comments in rule expr: expr or expr */
            Item_cond_and *item1;
            Item_cond_and *item3;
            if (is_cond_and((yyvsp[-2].item)))
            {
              item1= (Item_cond_and*) (yyvsp[-2].item);
              if (is_cond_and((yyvsp[0].item)))
              {
                item3= (Item_cond_and*) (yyvsp[0].item);
                /*
                  (X1 AND X2) AND (Y1 AND Y2) ==> AND (X1, X2, Y1, Y2)
                */
                item3->add_at_head(item1->argument_list());
                (yyval.item) = (yyvsp[0].item);
              }
              else
              {
                /*
                  (X1 AND X2) AND Y ==> AND (X1, X2, Y)
                */
                item1->add((yyvsp[0].item), thd->mem_root);
                (yyval.item) = (yyvsp[-2].item);
              }
            }
            else if (is_cond_and((yyvsp[0].item)))
            {
              item3= (Item_cond_and*) (yyvsp[0].item);
              /*
                X AND (Y1 AND Y2) ==> AND (X, Y1, Y2)
              */
              item3->add_at_head((yyvsp[-2].item), thd->mem_root);
              (yyval.item) = (yyvsp[0].item);
            }
            else
            {
              /* X AND Y */
              (yyval.item)= new (thd->mem_root) Item_cond_and(thd, (yyvsp[-2].item), (yyvsp[0].item));
              if (unlikely((yyval.item) == NULL))
                MYSQL_YYABORT;
            }
          }
#line 37494 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1614: /* expr: NOT_SYM expr  */
#line 10217 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= negate_expression(thd, (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37504 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1616: /* boolean_test: boolean_test IS TRUE_SYM  */
#line 10227 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_istrue(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37514 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1617: /* boolean_test: boolean_test IS not TRUE_SYM  */
#line 10233 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnottrue(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37524 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1618: /* boolean_test: boolean_test IS FALSE_SYM  */
#line 10239 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isfalse(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37534 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1619: /* boolean_test: boolean_test IS not FALSE_SYM  */
#line 10245 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnotfalse(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37544 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1620: /* boolean_test: boolean_test IS UNKNOWN_SYM  */
#line 10251 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnull(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37554 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1621: /* boolean_test: boolean_test IS not UNKNOWN_SYM  */
#line 10257 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnotnull(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37564 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1622: /* boolean_test: boolean_test IS NULL_SYM  */
#line 10263 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnull(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37574 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1623: /* boolean_test: boolean_test IS not NULL_SYM  */
#line 10269 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnotnull(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37584 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1624: /* boolean_test: boolean_test EQUAL_SYM predicate  */
#line 10275 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_equal(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37594 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1625: /* boolean_test: boolean_test comp_op predicate  */
#line 10281 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= (*(yyvsp[-1].boolfunc2creator))(0)->create(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37604 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1626: /* boolean_test: boolean_test comp_op all_or_any '(' subselect ')'  */
#line 10287 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= all_any_subquery_creator(thd, (yyvsp[-5].item), (yyvsp[-4].boolfunc2creator), (yyvsp[-3].num), (yyvsp[-1].select_lex));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37614 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1628: /* predicate: predicate IN_SYM subquery  */
#line 10297 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_in_subselect(thd, (yyvsp[-2].item), (yyvsp[0].select_lex));
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 37624 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1629: /* predicate: predicate not IN_SYM subquery  */
#line 10303 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_in_subselect(thd, (yyvsp[-3].item), (yyvsp[0].select_lex));
            if (unlikely(!item))
              MYSQL_YYABORT;
            (yyval.item)= negate_expression(thd, item);
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 37637 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1630: /* predicate: predicate IN_SYM '(' expr ')'  */
#line 10312 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= handle_sql2003_note184_exception(thd, (yyvsp[-4].item), true, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37647 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1631: /* predicate: predicate IN_SYM '(' expr ',' expr_list ')'  */
#line 10318 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyvsp[-1].item_list)->push_front((yyvsp[-6].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_func_in(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37659 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1632: /* predicate: predicate not IN_SYM '(' expr ')'  */
#line 10326 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= handle_sql2003_note184_exception(thd, (yyvsp[-5].item), false, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37669 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1633: /* predicate: predicate not IN_SYM '(' expr ',' expr_list ')'  */
#line 10332 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyvsp[-1].item_list)->push_front((yyvsp[-7].item), thd->mem_root);
            Item_func_in *item= new (thd->mem_root) Item_func_in(thd, *(yyvsp[-1].item_list));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 37682 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1634: /* predicate: predicate BETWEEN_SYM predicate AND_SYM predicate  */
#line 10341 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_between(thd, (yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37692 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1635: /* predicate: predicate not BETWEEN_SYM predicate AND_SYM predicate  */
#line 10347 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item_func_between *item;
            item= new (thd->mem_root) Item_func_between(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 37704 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1636: /* predicate: predicate SOUNDS_SYM LIKE predicate  */
#line 10355 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item1= new (thd->mem_root) Item_func_soundex(thd, (yyvsp[-3].item));
            Item *item4= new (thd->mem_root) Item_func_soundex(thd, (yyvsp[0].item));
            if (unlikely(item1 == NULL) || unlikely(item4 == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_func_eq(thd, item1, item4);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37718 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1637: /* predicate: predicate LIKE predicate  */
#line 10365 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_like(thd, (yyvsp[-2].item), (yyvsp[0].item), escape(thd), false);
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 37728 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1638: /* predicate: predicate LIKE predicate ESCAPE_SYM predicate  */
#line 10371 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->escape_used= true;
            (yyval.item)= new (thd->mem_root) Item_func_like(thd, (yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item), true);
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 37739 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1639: /* predicate: predicate not LIKE predicate  */
#line 10378 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_func_like(thd, (yyvsp[-3].item), (yyvsp[0].item), escape(thd), false);
            if (unlikely(!item))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 37750 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1640: /* predicate: predicate not LIKE predicate ESCAPE_SYM predicate  */
#line 10385 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->escape_used= true;
            Item *item= new (thd->mem_root) Item_func_like(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[0].item), true);
            if (unlikely(!item))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 37762 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1641: /* predicate: predicate REGEXP predicate  */
#line 10393 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_regex(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37772 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1642: /* predicate: predicate not REGEXP predicate  */
#line 10399 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_func_regex(thd, (yyvsp[-3].item), (yyvsp[0].item));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= negate_expression(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37785 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1644: /* bit_expr: bit_expr '|' bit_expr  */
#line 10412 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_or(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37795 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1645: /* bit_expr: bit_expr '&' bit_expr  */
#line 10418 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_and(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37805 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1646: /* bit_expr: bit_expr SHIFT_LEFT bit_expr  */
#line 10424 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_shift_left(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37815 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1647: /* bit_expr: bit_expr SHIFT_RIGHT bit_expr  */
#line 10430 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_shift_right(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37825 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1648: /* bit_expr: bit_expr ORACLE_CONCAT_SYM bit_expr  */
#line 10436 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_concat_operator_oracle(thd,
                                                                     (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37836 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1649: /* bit_expr: bit_expr '+' bit_expr  */
#line 10443 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_plus(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37846 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1650: /* bit_expr: bit_expr '-' bit_expr  */
#line 10449 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_minus(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37856 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1651: /* bit_expr: bit_expr '+' INTERVAL_SYM expr interval  */
#line 10455 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-4].item), (yyvsp[-1].item), (yyvsp[0].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37866 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1652: /* bit_expr: bit_expr '-' INTERVAL_SYM expr interval  */
#line 10461 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-4].item), (yyvsp[-1].item), (yyvsp[0].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37876 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1653: /* bit_expr: INTERVAL_SYM expr interval '+' expr  */
#line 10468 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[0].item), (yyvsp[-3].item), (yyvsp[-2].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37886 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1654: /* bit_expr: '+' INTERVAL_SYM expr interval '+' expr  */
#line 10474 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[0].item), (yyvsp[-3].item), (yyvsp[-2].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37896 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1655: /* bit_expr: '-' INTERVAL_SYM expr interval '+' expr  */
#line 10480 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[0].item), (yyvsp[-3].item), (yyvsp[-2].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37906 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1656: /* bit_expr: bit_expr '*' bit_expr  */
#line 10486 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mul(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37916 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1657: /* bit_expr: bit_expr '/' bit_expr  */
#line 10492 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_div(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37926 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1658: /* bit_expr: bit_expr '%' bit_expr  */
#line 10498 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mod(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37936 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1659: /* bit_expr: bit_expr DIV_SYM bit_expr  */
#line 10504 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_int_div(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37946 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1660: /* bit_expr: bit_expr MOD_SYM bit_expr  */
#line 10510 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mod(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37956 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1661: /* bit_expr: bit_expr '^' bit_expr  */
#line 10516 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_xor(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37966 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1671: /* comp_op: '='  */
#line 10545 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.boolfunc2creator) = &comp_eq_creator; }
#line 37972 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1672: /* comp_op: GE  */
#line 10546 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.boolfunc2creator) = &comp_ge_creator; }
#line 37978 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1673: /* comp_op: '>'  */
#line 10547 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              { (yyval.boolfunc2creator) = &comp_gt_creator; }
#line 37984 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1674: /* comp_op: LE  */
#line 10548 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.boolfunc2creator) = &comp_le_creator; }
#line 37990 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1675: /* comp_op: '<'  */
#line 10549 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.boolfunc2creator) = &comp_lt_creator; }
#line 37996 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1676: /* comp_op: NE  */
#line 10550 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.boolfunc2creator) = &comp_ne_creator; }
#line 38002 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1677: /* all_or_any: ALL  */
#line 10554 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.num) = 1; }
#line 38008 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1678: /* all_or_any: ANY_SYM  */
#line 10555 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.num) = 0; }
#line 38014 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1679: /* opt_dyncol_type: %empty  */
#line 10560 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_dyncol_type).set(DYN_COL_NULL); /* automatic type */
            Lex->charset= NULL;
	  }
#line 38023 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1680: /* opt_dyncol_type: AS dyncol_type  */
#line 10564 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); }
#line 38029 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1681: /* dyncol_type: numeric_dyncol_type  */
#line 10568 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); Lex->charset= NULL; }
#line 38035 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1682: /* dyncol_type: temporal_dyncol_type  */
#line 10569 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); Lex->charset= NULL; }
#line 38041 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1683: /* dyncol_type: string_dyncol_type  */
#line 10570 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); }
#line 38047 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1684: /* numeric_dyncol_type: INT_SYM  */
#line 10574 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_INT); }
#line 38053 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1685: /* numeric_dyncol_type: UNSIGNED INT_SYM  */
#line 10575 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_UINT);  }
#line 38059 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1686: /* numeric_dyncol_type: DOUBLE_SYM  */
#line 10576 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DOUBLE);  }
#line 38065 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1687: /* numeric_dyncol_type: REAL  */
#line 10577 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DOUBLE); }
#line 38071 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1688: /* numeric_dyncol_type: FLOAT_SYM  */
#line 10578 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DOUBLE); }
#line 38077 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1689: /* numeric_dyncol_type: DECIMAL_SYM float_options  */
#line 10579 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DECIMAL, (yyvsp[0].Lex_length_and_dec)); }
#line 38083 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1690: /* temporal_dyncol_type: DATE_SYM  */
#line 10583 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DATE); }
#line 38089 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1691: /* temporal_dyncol_type: TIME_SYM opt_field_length  */
#line 10584 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_TIME, 0, (yyvsp[0].const_simple_string)); }
#line 38095 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1692: /* temporal_dyncol_type: DATETIME opt_field_length  */
#line 10585 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DATETIME, 0, (yyvsp[0].const_simple_string)); }
#line 38101 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1693: /* $@171: %empty  */
#line 10590 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 38107 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1694: /* string_dyncol_type: char $@171 opt_binary  */
#line 10592 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_dyncol_type).set(DYN_COL_STRING);
          }
#line 38115 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1695: /* string_dyncol_type: nchar  */
#line 10596 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_dyncol_type).set(DYN_COL_STRING);
            Lex->charset= national_charset_info;
          }
#line 38124 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1696: /* dyncall_create_element: expr ',' expr opt_dyncol_type  */
#line 10604 "/home/buildbot/git/sql/sql_yacc_ora.yy"
   {
     LEX *lex= Lex;
     (yyval.dyncol_def)= (DYNCALL_CREATE_DEF *)
       alloc_root(thd->mem_root, sizeof(DYNCALL_CREATE_DEF));
     if (unlikely((yyval.dyncol_def) == NULL))
       MYSQL_YYABORT;
     (yyval.dyncol_def)->key= (yyvsp[-3].item);
     (yyval.dyncol_def)->value= (yyvsp[-1].item);
     (yyval.dyncol_def)->type= (DYNAMIC_COLUMN_TYPE)(yyvsp[0].Lex_dyncol_type).dyncol_type();
     (yyval.dyncol_def)->cs= lex->charset;
     if ((yyvsp[0].Lex_dyncol_type).length())
       (yyval.dyncol_def)->len= strtoul((yyvsp[0].Lex_dyncol_type).length(), NULL, 10);
     else
       (yyval.dyncol_def)->len= 0;
     if ((yyvsp[0].Lex_dyncol_type).dec())
       (yyval.dyncol_def)->frac= strtoul((yyvsp[0].Lex_dyncol_type).dec(), NULL, 10);
     else
       (yyval.dyncol_def)->len= 0;
   }
#line 38148 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1697: /* dyncall_create_list: dyncall_create_element  */
#line 10627 "/home/buildbot/git/sql/sql_yacc_ora.yy"
       {
         (yyval.dyncol_def_list)= new (thd->mem_root) List<DYNCALL_CREATE_DEF>;
         if (unlikely((yyval.dyncol_def_list) == NULL))
           MYSQL_YYABORT;
         (yyval.dyncol_def_list)->push_back((yyvsp[0].dyncol_def), thd->mem_root);
       }
#line 38159 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1698: /* dyncall_create_list: dyncall_create_list ',' dyncall_create_element  */
#line 10634 "/home/buildbot/git/sql/sql_yacc_ora.yy"
       {
         (yyvsp[-2].dyncol_def_list)->push_back((yyvsp[0].dyncol_def), thd->mem_root);
         (yyval.dyncol_def_list)= (yyvsp[-2].dyncol_def_list);
       }
#line 38168 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1699: /* plsql_cursor_attr: ISOPEN_SYM  */
#line 10642 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_ISOPEN; }
#line 38174 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1700: /* plsql_cursor_attr: FOUND_SYM  */
#line 10643 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_FOUND; }
#line 38180 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1701: /* plsql_cursor_attr: NOTFOUND_SYM  */
#line 10644 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_NOTFOUND; }
#line 38186 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1702: /* plsql_cursor_attr: ROWCOUNT_SYM  */
#line 10645 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_ROWCOUNT; }
#line 38192 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1703: /* explicit_cursor_attr: ident PERCENT_ORACLE_SYM plsql_cursor_attr  */
#line 10650 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_plsql_cursor_attr(thd, &(yyvsp[-2].ident_sys), (yyvsp[0].plsql_cursor_attr)))))
              MYSQL_YYABORT;
          }
#line 38201 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1706: /* trim_operands_regular: expr  */
#line 10663 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[0].item));         }
#line 38207 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1707: /* trim_operands_special: LEADING expr FROM expr  */
#line 10667 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_LEADING, (yyvsp[-2].item), (yyvsp[0].item));  }
#line 38213 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1708: /* trim_operands_special: TRAILING expr FROM expr  */
#line 10668 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_TRAILING, (yyvsp[-2].item), (yyvsp[0].item)); }
#line 38219 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1709: /* trim_operands_special: BOTH expr FROM expr  */
#line 10669 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[-2].item), (yyvsp[0].item));     }
#line 38225 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1710: /* trim_operands_special: LEADING FROM expr  */
#line 10670 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_LEADING, (yyvsp[0].item));      }
#line 38231 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1711: /* trim_operands_special: TRAILING FROM expr  */
#line 10671 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_TRAILING, (yyvsp[0].item));     }
#line 38237 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1712: /* trim_operands_special: BOTH FROM expr  */
#line 10672 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[0].item));         }
#line 38243 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1713: /* trim_operands_special: expr FROM expr  */
#line 10673 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[-2].item), (yyvsp[0].item));     }
#line 38249 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1720: /* column_default_non_parenthesized_expr: param_marker  */
#line 10711 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.item)= (yyvsp[0].item_param); }
#line 38255 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1722: /* column_default_non_parenthesized_expr: sum_expr  */
#line 10714 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!Lex->select_stack_top)
            {
              my_error(ER_INVALID_GROUP_FUNC_USE, MYF(0));
              MYSQL_YYABORT;
            }
          }
#line 38267 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1723: /* column_default_non_parenthesized_expr: window_func_expr  */
#line 10722 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!Lex->select_stack_top)
            {
               my_error(ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION, MYF(0));
               MYSQL_YYABORT;
            }
          }
#line 38279 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1725: /* column_default_non_parenthesized_expr: ROW_SYM '(' expr ',' expr_list ')'  */
#line 10731 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_row(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38290 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1726: /* column_default_non_parenthesized_expr: EXISTS '(' subselect ')'  */
#line 10738 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_exists_subselect(thd, (yyvsp[-1].select_lex));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38300 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1727: /* column_default_non_parenthesized_expr: '{' ident expr '}'  */
#line 10744 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].item)->make_odbc_literal(thd, &(yyvsp[-2].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 38309 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1728: /* column_default_non_parenthesized_expr: MATCH ident_list_arg AGAINST '(' bit_expr fulltext_options ')'  */
#line 10749 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-5].item_list)->push_front((yyvsp[-2].item), thd->mem_root);
            Item_func_match *i1= new (thd->mem_root) Item_func_match(thd, *(yyvsp[-5].item_list),
                                                                     (yyvsp[-1].num));
            if (unlikely(i1 == NULL))
              MYSQL_YYABORT;
            Select->add_ftfunc_to_list(thd, i1);
            (yyval.item)= i1;
          }
#line 38323 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1729: /* column_default_non_parenthesized_expr: CAST_SYM '(' expr AS cast_type ')'  */
#line 10759 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].Lex_cast_type).create_typecast_item(thd, (yyvsp[-3].item), Lex->charset))))
              MYSQL_YYABORT;
          }
#line 38332 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1730: /* column_default_non_parenthesized_expr: CASE_SYM when_list_opt_else END  */
#line 10764 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= new(thd->mem_root) Item_func_case_searched(thd, *(yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 38341 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1731: /* column_default_non_parenthesized_expr: CASE_SYM expr when_list_opt_else END  */
#line 10769 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-2].item), thd->mem_root);
            if (unlikely(!((yyval.item)= new (thd->mem_root) Item_func_case_simple(thd, *(yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 38351 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1732: /* column_default_non_parenthesized_expr: CONVERT_SYM '(' expr ',' cast_type ')'  */
#line 10775 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].Lex_cast_type).create_typecast_item(thd, (yyvsp[-3].item), Lex->charset))))
              MYSQL_YYABORT;
          }
#line 38360 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1733: /* column_default_non_parenthesized_expr: CONVERT_SYM '(' expr USING charset_name ')'  */
#line 10780 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_conv_charset(thd, (yyvsp[-3].item), (yyvsp[-1].charset));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38370 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1734: /* column_default_non_parenthesized_expr: DEFAULT '(' simple_ident ')'  */
#line 10786 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item_splocal *il= (yyvsp[-1].item)->get_item_splocal();
            if (unlikely(il))
              my_yyabort_error((ER_WRONG_COLUMN_NAME, MYF(0), il->my_name()->str));
            (yyval.item)= new (thd->mem_root) Item_default_value(thd, Lex->current_context(),
                                                         (yyvsp[-1].item), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->default_used= TRUE;
          }
#line 38385 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1735: /* column_default_non_parenthesized_expr: VALUE_SYM '(' simple_ident_nospvar ')'  */
#line 10797 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_insert_value(thd, Lex->current_context(),
                                                        (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38396 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1736: /* column_default_non_parenthesized_expr: NEXT_SYM VALUE_SYM FOR_SYM table_ident  */
#line 10804 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_nextval(thd, (yyvsp[0].table)))))
              MYSQL_YYABORT;
          }
#line 38405 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1737: /* column_default_non_parenthesized_expr: NEXTVAL_SYM '(' table_ident ')'  */
#line 10809 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_nextval(thd, (yyvsp[-1].table)))))
              MYSQL_YYABORT;
          }
#line 38414 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1738: /* column_default_non_parenthesized_expr: PREVIOUS_SYM VALUE_SYM FOR_SYM table_ident  */
#line 10814 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_lastval(thd, (yyvsp[0].table)))))
              MYSQL_YYABORT;
          }
#line 38423 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1739: /* column_default_non_parenthesized_expr: LASTVAL_SYM '(' table_ident ')'  */
#line 10819 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_lastval(thd, (yyvsp[-1].table)))))
              MYSQL_YYABORT;
          }
#line 38432 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1740: /* column_default_non_parenthesized_expr: SETVAL_SYM '(' table_ident ',' longlong_num ')'  */
#line 10824 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_setval(thd, (yyvsp[-3].table), (yyvsp[-1].longlong_number), 0, 1))))
              MYSQL_YYABORT;
          }
#line 38441 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1741: /* column_default_non_parenthesized_expr: SETVAL_SYM '(' table_ident ',' longlong_num ',' bool ')'  */
#line 10829 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_setval(thd, (yyvsp[-5].table), (yyvsp[-3].longlong_number), 0, (yyvsp[-1].ulong_num)))))
              MYSQL_YYABORT;
          }
#line 38450 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1742: /* column_default_non_parenthesized_expr: SETVAL_SYM '(' table_ident ',' longlong_num ',' bool ',' ulonglong_num ')'  */
#line 10834 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_setval(thd, (yyvsp[-7].table), (yyvsp[-5].longlong_number), (yyvsp[-1].ulonglong_number), (yyvsp[-3].ulong_num)))))
              MYSQL_YYABORT;
          }
#line 38459 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1745: /* primary_expr: '(' parenthesized_expr ')'  */
#line 10843 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                     { (yyval.item)= (yyvsp[-1].item); }
#line 38465 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1746: /* primary_expr: subquery  */
#line 10845 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.item)= Lex->create_item_query_expression(thd, (yyvsp[0].select_lex)->master_unit())))
              MYSQL_YYABORT;
          }
#line 38474 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1748: /* string_factor_expr: string_factor_expr COLLATE_SYM collation_name  */
#line 10854 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= new (thd->mem_root) Item_func_set_collation(thd, (yyvsp[-2].item), (yyvsp[0].charset)))))
              MYSQL_YYABORT;
          }
#line 38483 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1750: /* simple_expr: BINARY simple_expr  */
#line 10863 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Type_cast_attributes at(&my_charset_bin);
            if (unlikely(!((yyval.item)= type_handler_long_blob.create_typecast_item(thd, (yyvsp[0].item), at))))
              MYSQL_YYABORT;
          }
#line 38493 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1751: /* simple_expr: '+' simple_expr  */
#line 10869 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= (yyvsp[0].item);
          }
#line 38501 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1752: /* simple_expr: '-' simple_expr  */
#line 10873 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= (yyvsp[0].item)->neg(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38511 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1753: /* simple_expr: '~' simple_expr  */
#line 10879 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_neg(thd, (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38521 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1754: /* simple_expr: not2 simple_expr  */
#line 10885 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= negate_expression(thd, (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38531 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1756: /* mysql_concatenation_expr: mysql_concatenation_expr MYSQL_CONCAT_SYM simple_expr  */
#line 10895 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_concat(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38541 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1757: /* function_call_keyword_timestamp: TIMESTAMP '(' expr ')'  */
#line 10904 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_datetime_typecast(thd, (yyvsp[-1].item),
                                      AUTO_SEC_PART_DIGITS);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38552 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1758: /* function_call_keyword_timestamp: TIMESTAMP '(' expr ',' expr ')'  */
#line 10911 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_timestamp(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38562 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1759: /* function_call_keyword: CHAR_SYM '(' expr_list ')'  */
#line 10925 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_char(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38572 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1760: /* function_call_keyword: CHAR_SYM '(' expr_list USING charset_name ')'  */
#line 10931 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_char(thd, *(yyvsp[-3].item_list), (yyvsp[-1].charset));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38582 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1761: /* function_call_keyword: CURRENT_USER optional_braces  */
#line 10937 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_current_user(thd,
                                      Lex->current_context());
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 38595 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1762: /* function_call_keyword: CURRENT_ROLE optional_braces  */
#line 10946 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_current_role(thd,
                                      Lex->current_context());
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 38608 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1763: /* function_call_keyword: DATE_SYM '(' expr ')'  */
#line 10955 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_typecast(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38618 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1764: /* function_call_keyword: DAY_SYM '(' expr ')'  */
#line 10961 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_dayofmonth(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38628 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1765: /* function_call_keyword: HOUR_SYM '(' expr ')'  */
#line 10967 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_hour(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38638 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1766: /* function_call_keyword: INSERT '(' expr ',' expr ',' expr ',' expr ')'  */
#line 10973 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_insert(thd, (yyvsp[-7].item), (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38648 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1767: /* function_call_keyword: INTERVAL_SYM '(' expr ',' expr ')'  */
#line 10979 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            List<Item> *list= new (thd->mem_root) List<Item>;
            if (unlikely(list == NULL))
              MYSQL_YYABORT;
            if (unlikely(list->push_front((yyvsp[-1].item), thd->mem_root)) ||
                unlikely(list->push_front((yyvsp[-3].item), thd->mem_root)))
              MYSQL_YYABORT;
            Item_row *item= new (thd->mem_root) Item_row(thd, *list);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_func_interval(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38667 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1768: /* function_call_keyword: INTERVAL_SYM '(' expr ',' expr ',' expr_list ')'  */
#line 10994 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyvsp[-1].item_list)->push_front((yyvsp[-5].item), thd->mem_root);
            Item_row *item= new (thd->mem_root) Item_row(thd, *(yyvsp[-1].item_list));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_func_interval(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38682 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1769: /* function_call_keyword: LEFT '(' expr ',' expr ')'  */
#line 11005 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_left(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38692 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1770: /* function_call_keyword: MINUTE_SYM '(' expr ')'  */
#line 11011 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_minute(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38702 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1771: /* function_call_keyword: MONTH_SYM '(' expr ')'  */
#line 11017 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_month(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38712 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1772: /* function_call_keyword: RIGHT '(' expr ',' expr ')'  */
#line 11023 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_right(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38722 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1773: /* function_call_keyword: SECOND_SYM '(' expr ')'  */
#line 11029 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_second(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38732 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1774: /* function_call_keyword: SQL_SYM PERCENT_ORACLE_SYM ROWCOUNT_SYM  */
#line 11035 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_oracle_sql_rowcount(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 38744 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1775: /* function_call_keyword: TIME_SYM '(' expr ')'  */
#line 11043 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_time_typecast(thd, (yyvsp[-1].item),
                                      AUTO_SEC_PART_DIGITS);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38755 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1776: /* function_call_keyword: function_call_keyword_timestamp  */
#line 11050 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= (yyvsp[0].item);
          }
#line 38763 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1777: /* function_call_keyword: TRIM '(' trim_operands ')'  */
#line 11054 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Schema::find_implied(thd)->
                                 make_item_func_trim(thd, (yyvsp[-1].trim)))))
              MYSQL_YYABORT;
          }
#line 38773 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1778: /* function_call_keyword: USER_SYM '(' ')'  */
#line 11060 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_user(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query=0;
          }
#line 38785 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1779: /* function_call_keyword: YEAR_SYM '(' expr ')'  */
#line 11068 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_year(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38795 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1782: /* substring_operands_regular: expr ',' expr ',' expr  */
#line 11082 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item));
          }
#line 38803 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1783: /* substring_operands_regular: expr ',' expr  */
#line 11086 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-2].item), (yyvsp[0].item));
          }
#line 38811 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1784: /* substring_operands_special: expr FROM expr FOR_SYM expr  */
#line 11093 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item));
          }
#line 38819 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1785: /* substring_operands_special: expr FROM expr  */
#line 11097 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-2].item), (yyvsp[0].item));
          }
#line 38827 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1786: /* function_call_nonkeyword: ADDDATE_SYM '(' expr ',' expr ')'  */
#line 11117 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                             INTERVAL_DAY, 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38838 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1787: /* function_call_nonkeyword: ADDDATE_SYM '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11124 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38848 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1788: /* function_call_nonkeyword: CURDATE optional_braces  */
#line 11130 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curdate_local(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 38859 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1789: /* function_call_nonkeyword: CURTIME opt_time_precision  */
#line 11137 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curtime_local(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 38870 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1790: /* function_call_nonkeyword: DATE_ADD_INTERVAL '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11144 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38880 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1791: /* function_call_nonkeyword: DATE_SUB_INTERVAL '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11150 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38890 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1792: /* function_call_nonkeyword: DATE_FORMAT_SYM '(' expr ',' expr ')'  */
#line 11156 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_date_format(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38900 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1793: /* function_call_nonkeyword: DATE_FORMAT_SYM '(' expr ',' expr ',' expr ')'  */
#line 11162 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_date_format(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38910 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1794: /* function_call_nonkeyword: EXTRACT_SYM '(' interval FROM expr ')'  */
#line 11168 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_extract(thd, (yyvsp[-3].interval), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38920 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1795: /* function_call_nonkeyword: GET_FORMAT '(' date_time_type ',' expr ')'  */
#line 11174 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_get_format(thd, (yyvsp[-3].date_time_type), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38930 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1796: /* function_call_nonkeyword: NOW_SYM opt_time_precision  */
#line 11180 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_now_local(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 38941 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1797: /* function_call_nonkeyword: POSITION_SYM '(' bit_expr IN_SYM expr ')'  */
#line 11187 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_locate(thd, (yyvsp[-1].item), (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38951 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1798: /* function_call_nonkeyword: SUBDATE_SYM '(' expr ',' expr ')'  */
#line 11193 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                             INTERVAL_DAY, 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38962 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1799: /* function_call_nonkeyword: SUBDATE_SYM '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11200 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38972 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1800: /* function_call_nonkeyword: SUBSTRING '(' substring_operands ')'  */
#line 11206 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Schema::find_implied(thd)->
                                 make_item_func_substr(thd, (yyvsp[-1].substring_spec)))))
              MYSQL_YYABORT;
          }
#line 38982 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1801: /* function_call_nonkeyword: SYSDATE opt_time_precision  */
#line 11212 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Unlike other time-related functions, SYSDATE() is
              replication-unsafe because it is not affected by the
              TIMESTAMP variable.  It is unsafe even if
              sysdate_is_now=1, because the slave may have
              sysdate_is_now=0.
            */
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            if (global_system_variables.sysdate_is_now == 0)
              (yyval.item)= new (thd->mem_root) Item_func_sysdate_local(thd, (yyvsp[0].num));
            else
              (yyval.item)= new (thd->mem_root) Item_func_now_local(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39004 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1802: /* function_call_nonkeyword: TIMESTAMP_ADD '(' interval_time_stamp ',' expr ',' expr ')'  */
#line 11230 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-1].item), (yyvsp[-3].item), (yyvsp[-5].interval_time_st), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39014 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1803: /* function_call_nonkeyword: TIMESTAMP_DIFF '(' interval_time_stamp ',' expr ',' expr ')'  */
#line 11236 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_timestamp_diff(thd, (yyvsp[-3].item), (yyvsp[-1].item), (yyvsp[-5].interval_time_st));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39024 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1804: /* function_call_nonkeyword: TRIM_ORACLE '(' trim_operands ')'  */
#line 11242 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].trim).make_item_func_trim_oracle(thd))))
              MYSQL_YYABORT;
          }
#line 39033 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1805: /* function_call_nonkeyword: UTC_DATE_SYM optional_braces  */
#line 11247 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curdate_utc(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39044 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1806: /* function_call_nonkeyword: UTC_TIME_SYM opt_time_precision  */
#line 11254 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curtime_utc(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39055 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1807: /* function_call_nonkeyword: UTC_TIMESTAMP_SYM opt_time_precision  */
#line 11261 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_now_utc(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39066 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1808: /* function_call_nonkeyword: COLUMN_ADD_SYM '(' expr ',' dyncall_create_list ')'  */
#line 11269 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= create_func_dyncol_add(thd, (yyvsp[-3].item), *(yyvsp[-1].dyncol_def_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39076 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1809: /* function_call_nonkeyword: COLUMN_DELETE_SYM '(' expr ',' expr_list ')'  */
#line 11276 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= create_func_dyncol_delete(thd, (yyvsp[-3].item), *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39086 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1810: /* function_call_nonkeyword: COLUMN_CHECK_SYM '(' expr ')'  */
#line 11283 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_dyncol_check(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39096 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1811: /* function_call_nonkeyword: COLUMN_CREATE_SYM '(' dyncall_create_list ')'  */
#line 11290 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= create_func_dyncol_create(thd, *(yyvsp[-1].dyncol_def_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39106 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1812: /* function_call_nonkeyword: COLUMN_GET_SYM '(' expr ',' expr AS cast_type ')'  */
#line 11297 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            (yyval.item)= create_func_dyncol_get(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].Lex_cast_type).type_handler(),
                                        (yyvsp[-1].Lex_cast_type).length(), (yyvsp[-1].Lex_cast_type).dec(),
                                        lex->charset);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39119 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1813: /* function_call_conflict: ASCII_SYM '(' expr ')'  */
#line 11314 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_ascii(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39129 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1814: /* function_call_conflict: CHARSET '(' expr ')'  */
#line 11320 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_charset(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39139 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1815: /* function_call_conflict: COALESCE '(' expr_list ')'  */
#line 11326 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_coalesce(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39149 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1816: /* function_call_conflict: COLLATION_SYM '(' expr ')'  */
#line 11332 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_collation(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39159 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1817: /* function_call_conflict: DATABASE '(' ')'  */
#line 11338 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_database(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39170 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1818: /* function_call_conflict: IF_SYM '(' expr ',' expr ',' expr ')'  */
#line 11345 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_if(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39180 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1819: /* function_call_conflict: FORMAT_SYM '(' expr ',' expr ')'  */
#line 11351 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_format(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39190 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1820: /* function_call_conflict: FORMAT_SYM '(' expr ',' expr ',' expr ')'  */
#line 11357 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_format(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39200 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1821: /* function_call_conflict: LAST_VALUE '(' expr ')'  */
#line 11366 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            List<Item> *list= new (thd->mem_root) List<Item>;
            if (unlikely(list == NULL))
              MYSQL_YYABORT;
            list->push_back((yyvsp[-1].item), thd->mem_root);

            (yyval.item)= new (thd->mem_root) Item_func_last_value(thd, *list);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39215 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1822: /* function_call_conflict: LAST_VALUE '(' expr_list ',' expr ')'  */
#line 11377 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-3].item_list)->push_back((yyvsp[-1].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_func_last_value(thd, *(yyvsp[-3].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39226 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1823: /* function_call_conflict: MICROSECOND_SYM '(' expr ')'  */
#line 11384 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_microsecond(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39236 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1824: /* function_call_conflict: MOD_SYM '(' expr ',' expr ')'  */
#line 11390 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mod(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39246 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1825: /* function_call_conflict: OLD_PASSWORD_SYM '(' expr ')'  */
#line 11396 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)=  new (thd->mem_root)
              Item_func_password(thd, (yyvsp[-1].item), Item_func_password::OLD);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39257 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1826: /* function_call_conflict: PASSWORD_SYM '(' expr ')'  */
#line 11403 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item* i1;
            i1= new (thd->mem_root) Item_func_password(thd, (yyvsp[-1].item));
            if (unlikely(i1 == NULL))
              MYSQL_YYABORT;
            (yyval.item)= i1;
          }
#line 39269 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1827: /* function_call_conflict: QUARTER_SYM '(' expr ')'  */
#line 11411 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_quarter(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39279 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1828: /* function_call_conflict: REPEAT_SYM '(' expr ',' expr ')'  */
#line 11417 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_repeat(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39289 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1829: /* function_call_conflict: REPLACE '(' expr ',' expr ',' expr ')'  */
#line 11423 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Schema::find_implied(thd)->
                                 make_item_func_replace(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item)))))
              MYSQL_YYABORT;
          }
#line 39299 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1830: /* function_call_conflict: REVERSE_SYM '(' expr ')'  */
#line 11429 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_reverse(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39309 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1831: /* function_call_conflict: ROW_COUNT_SYM '(' ')'  */
#line 11435 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_row_count(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 39321 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1832: /* function_call_conflict: TRUNCATE_SYM '(' expr ',' expr ')'  */
#line 11443 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_round(thd, (yyvsp[-3].item), (yyvsp[-1].item), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39331 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1833: /* function_call_conflict: WEEK_SYM '(' expr ')'  */
#line 11449 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_week(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39341 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1834: /* function_call_conflict: WEEK_SYM '(' expr ',' expr ')'  */
#line 11455 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_week(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39351 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1835: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr opt_ws_levels ')'  */
#line 11461 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_weight_string(thd, (yyvsp[-2].item), 0, 0, (yyvsp[-1].ulong_num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39361 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1836: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr AS CHAR_SYM ws_nweights opt_ws_levels ')'  */
#line 11467 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root)
                Item_func_weight_string(thd, (yyvsp[-5].item), 0, (yyvsp[-2].ulong_num),
                                        (yyvsp[-1].ulong_num) | MY_STRXFRM_PAD_WITH_SPACE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39373 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1837: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr AS BINARY ws_nweights ')'  */
#line 11475 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_char_typecast(thd, (yyvsp[-4].item), (yyvsp[-1].ulong_num),
                                                               &my_charset_bin);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root)
                Item_func_weight_string(thd, item, 0, (yyvsp[-1].ulong_num),
                                        MY_STRXFRM_PAD_WITH_SPACE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39389 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1838: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr ',' ulong_num ',' ulong_num ',' ulong_num ')'  */
#line 11487 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_weight_string(thd, (yyvsp[-7].item), (yyvsp[-5].ulong_num), (yyvsp[-3].ulong_num),
                                                            (yyvsp[-1].ulong_num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39400 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1839: /* function_call_conflict: geometry_function  */
#line 11494 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
#ifdef HAVE_SPATIAL
            (yyval.item)= (yyvsp[0].item);
            /* $1 may be NULL, GEOM_NEW not tested for out of memory */
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), sym_group_geom.name,
                              sym_group_geom.needed_define));
#endif
          }
#line 39416 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1840: /* geometry_function: CONTAINS_SYM '(' expr ',' expr ')'  */
#line 11509 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_precise_rel(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                 Item_func::SP_CONTAINS_FUNC));
          }
#line 39426 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1841: /* geometry_function: GEOMETRYCOLLECTION '(' expr_list ')'  */
#line 11515 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_geometrycollection,
                           Geometry::wkb_point));
          }
#line 39437 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1842: /* geometry_function: LINESTRING '(' expr_list ')'  */
#line 11522 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_linestring,
                           Geometry::wkb_point));
          }
#line 39448 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1843: /* geometry_function: MULTILINESTRING '(' expr_list ')'  */
#line 11529 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_multilinestring,
                           Geometry::wkb_linestring));
          }
#line 39459 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1844: /* geometry_function: MULTIPOINT '(' expr_list ')'  */
#line 11536 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_multipoint,
                           Geometry::wkb_point));
          }
#line 39470 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1845: /* geometry_function: MULTIPOLYGON '(' expr_list ')'  */
#line 11543 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_multipolygon,
                           Geometry::wkb_polygon));
          }
#line 39481 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1846: /* geometry_function: POINT_SYM '(' expr ',' expr ')'  */
#line 11550 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd, Item_func_point(thd, (yyvsp[-3].item), (yyvsp[-1].item)));
          }
#line 39489 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1847: /* geometry_function: POLYGON '(' expr_list ')'  */
#line 11554 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_polygon,
                           Geometry::wkb_linestring));
          }
#line 39500 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1848: /* geometry_function: WITHIN '(' expr ',' expr ')'  */
#line 11561 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd, Item_func_spatial_precise_rel(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                    Item_func::SP_WITHIN_FUNC));
          }
#line 39509 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1849: /* @172: %empty  */
#line 11578 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
#ifdef HAVE_DLOPEN
            udf_func *udf= 0;
            LEX *lex= Lex;
            if (using_udf_functions &&
                (udf= find_udf((yyvsp[-1].ident_sys).str, (yyvsp[-1].ident_sys).length)) &&
                udf->type == UDFTYPE_AGGREGATE)
            {
              if (unlikely(lex->current_select->inc_in_sum_expr()))
              {
                thd->parse_error();
                MYSQL_YYABORT;
              }
            }
            /* Temporary placing the result of find_udf in $3 */
            (yyval.udf)= udf;
#endif
          }
#line 39532 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1850: /* function_call_generic: IDENT_sys '(' @172 opt_udf_expr_list ')'  */
#line 11597 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Create_func *builder;
            Item *item= NULL;

            if (unlikely(check_routine_name(&(yyvsp[-4].ident_sys))))
              MYSQL_YYABORT;

            /*
              Implementation note:
              names are resolved with the following order:
              - MySQL native functions,
              - User Defined Functions,
              - Stored Functions (assuming the current <use> database)

              This will be revised with WL#2128 (SQL PATH)
            */
            builder= Schema::find_implied(thd)->
                       find_native_function_builder(thd, (yyvsp[-4].ident_sys));
            if (builder)
            {
              item= builder->create_func(thd, &(yyvsp[-4].ident_sys), (yyvsp[-1].item_list));
            }
            else
            {
#ifdef HAVE_DLOPEN
              /* Retrieving the result of find_udf */
              udf_func *udf= (yyvsp[-2].udf);

              if (udf)
              {
                if (udf->type == UDFTYPE_AGGREGATE)
                {
                  Select->in_sum_expr--;
                }

                item= Create_udf_func::s_singleton.create(thd, udf, (yyvsp[-1].item_list));
              }
              else
#endif
              {
                builder= find_qualified_function_builder(thd);
                DBUG_ASSERT(builder);
                item= builder->create_func(thd, &(yyvsp[-4].ident_sys), (yyvsp[-1].item_list));
              }
            }

            if (unlikely(! ((yyval.item)= item)))
              MYSQL_YYABORT;
          }
#line 39586 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1851: /* function_call_generic: ident_cli '.' ident_cli '(' opt_expr_list ')'  */
#line 11647 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_call_generic(thd, &(yyvsp[-5].ident_cli), &(yyvsp[-3].ident_cli), (yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 39595 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1852: /* function_call_generic: ident_cli '.' ident_cli '.' ident_cli '(' opt_expr_list ')'  */
#line 11652 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_call_generic(thd, &(yyvsp[-7].ident_cli), &(yyvsp[-5].ident_cli), &(yyvsp[-3].ident_cli), (yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 39604 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1853: /* function_call_generic: ident_cli '.' REPLACE '(' opt_expr_list ')'  */
#line 11657 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_replace(thd, (yyvsp[-5].ident_cli), (yyvsp[-3].kwd), (yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 39613 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1854: /* function_call_generic: ident_cli '.' SUBSTRING '(' opt_expr_list ')'  */
#line 11662 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_substr(thd, (yyvsp[-5].ident_cli), (yyvsp[-3].kwd), (yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 39622 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1855: /* function_call_generic: ident_cli '.' SUBSTRING '(' substring_operands_special ')'  */
#line 11667 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_substr(thd, (yyvsp[-5].ident_cli), (yyvsp[-3].kwd), (yyvsp[-1].substring_spec)))))
              MYSQL_YYABORT;
          }
#line 39631 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1856: /* function_call_generic: ident_cli '.' TRIM '(' opt_expr_list ')'  */
#line 11672 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_trim(thd, (yyvsp[-5].ident_cli), (yyvsp[-3].kwd), (yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 39640 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1857: /* function_call_generic: ident_cli '.' TRIM '(' trim_operands_special ')'  */
#line 11677 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_trim(thd, (yyvsp[-5].ident_cli), (yyvsp[-3].kwd), (yyvsp[-1].trim)))))
              MYSQL_YYABORT;
          }
#line 39649 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1858: /* fulltext_options: opt_natural_language_mode opt_query_expansion  */
#line 11685 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)= (yyvsp[-1].num) | (yyvsp[0].num); }
#line 39655 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1859: /* fulltext_options: IN_SYM BOOLEAN_SYM MODE_SYM  */
#line 11687 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)= FT_BOOL; }
#line 39661 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1860: /* opt_natural_language_mode: %empty  */
#line 11691 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.num)= FT_NL; }
#line 39667 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1861: /* opt_natural_language_mode: IN_SYM NATURAL LANGUAGE_SYM MODE_SYM  */
#line 11692 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.num)= FT_NL; }
#line 39673 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1862: /* opt_query_expansion: %empty  */
#line 11696 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.num)= 0;         }
#line 39679 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1863: /* opt_query_expansion: WITH QUERY_SYM EXPANSION_SYM  */
#line 11697 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.num)= FT_EXPAND; }
#line 39685 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1864: /* opt_udf_expr_list: %empty  */
#line 11701 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.item_list)= NULL; }
#line 39691 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1865: /* opt_udf_expr_list: udf_expr_list  */
#line 11702 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.item_list)= (yyvsp[0].item_list); }
#line 39697 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1866: /* udf_expr_list: udf_expr  */
#line 11707 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL))
              MYSQL_YYABORT;
            (yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root);
          }
#line 39708 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1867: /* udf_expr_list: udf_expr_list ',' udf_expr  */
#line 11714 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root);
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 39717 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1868: /* udf_expr: remember_name expr remember_end select_alias  */
#line 11722 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
             Use Item::name as a storage for the attribute value of user
             defined function argument. It is safe to use Item::name
             because the syntax will not allow having an explicit name here.
             See WL#1017 re. udf attributes.
            */
            if ((yyvsp[0].lex_str).str)
            {
              (yyvsp[-2].item)->is_autogenerated_name= FALSE;
              (yyvsp[-2].item)->set_name(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length, system_charset_info);
            }
            /* 
               A field has to have its proper name in order for name
               resolution to work, something we are only guaranteed if we
               parse it out. If we hijack the input stream with
               remember_name we may get quoted or escaped names.
            */
            else if ((yyvsp[-2].item)->type() != Item::FIELD_ITEM &&
                     (yyvsp[-2].item)->type() != Item::REF_ITEM /* For HAVING */ )
              (yyvsp[-2].item)->set_name(thd, (yyvsp[-3].simple_string), (uint) ((yyvsp[-1].simple_string) - (yyvsp[-3].simple_string)), thd->charset());
            (yyval.item)= (yyvsp[-2].item);
          }
#line 39745 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1869: /* sum_expr: AVG_SYM '(' in_sum_expr ')'  */
#line 11749 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_avg(thd, (yyvsp[-1].item), FALSE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39755 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1870: /* sum_expr: AVG_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11755 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_avg(thd, (yyvsp[-1].item), TRUE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39765 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1871: /* sum_expr: BIT_AND '(' in_sum_expr ')'  */
#line 11761 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_and(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39775 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1872: /* sum_expr: BIT_OR '(' in_sum_expr ')'  */
#line 11767 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_or(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39785 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1873: /* sum_expr: BIT_XOR '(' in_sum_expr ')'  */
#line 11773 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_xor(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39795 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1874: /* sum_expr: COUNT_SYM '(' opt_all '*' ')'  */
#line 11779 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_int(thd, (int32) 0L, 1);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_sum_count(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39808 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1875: /* sum_expr: COUNT_SYM '(' in_sum_expr ')'  */
#line 11788 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_count(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39818 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1876: /* $@173: %empty  */
#line 11794 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->in_sum_expr++; }
#line 39824 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1877: /* $@174: %empty  */
#line 11796 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->in_sum_expr--; }
#line 39830 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1878: /* sum_expr: COUNT_SYM '(' DISTINCT $@173 expr_list $@174 ')'  */
#line 11798 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_count(thd, *(yyvsp[-2].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39840 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1879: /* sum_expr: MIN_SYM '(' in_sum_expr ')'  */
#line 11804 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_min(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39850 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1880: /* sum_expr: MIN_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11815 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_min(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39860 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1881: /* sum_expr: MAX_SYM '(' in_sum_expr ')'  */
#line 11821 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_max(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39870 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1882: /* sum_expr: MAX_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11827 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_max(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39880 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1883: /* sum_expr: STD_SYM '(' in_sum_expr ')'  */
#line 11833 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_std(thd, (yyvsp[-1].item), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39890 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1884: /* sum_expr: VARIANCE_SYM '(' in_sum_expr ')'  */
#line 11839 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_variance(thd, (yyvsp[-1].item), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39900 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1885: /* sum_expr: STDDEV_SAMP_SYM '(' in_sum_expr ')'  */
#line 11845 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_std(thd, (yyvsp[-1].item), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39910 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1886: /* sum_expr: VAR_SAMP_SYM '(' in_sum_expr ')'  */
#line 11851 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_variance(thd, (yyvsp[-1].item), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39920 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1887: /* sum_expr: SUM_SYM '(' in_sum_expr ')'  */
#line 11857 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_sum(thd, (yyvsp[-1].item), FALSE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39930 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1888: /* sum_expr: SUM_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11863 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_sum(thd, (yyvsp[-1].item), TRUE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39940 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1889: /* $@175: %empty  */
#line 11869 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->in_sum_expr++; }
#line 39946 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1890: /* sum_expr: GROUP_CONCAT_SYM '(' opt_distinct $@175 expr_list opt_gorder_clause opt_gconcat_separator opt_glimit_clause ')'  */
#line 11873 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->in_sum_expr--;
            (yyval.item)= new (thd->mem_root)
                  Item_func_group_concat(thd, Lex->current_context(),
                                        (yyvsp[-6].num), (yyvsp[-4].item_list),
                                        sel->gorder_list, (yyvsp[-2].string), (yyvsp[-1].num),
                                        sel->select_limit,
                                        sel->offset_limit);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            sel->select_limit= NULL;
            sel->offset_limit= NULL;
            sel->explicit_limit= 0;
            (yyvsp[-4].item_list)->empty();
            sel->gorder_list.empty();
          }
#line 39968 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1891: /* window_func_expr: window_func OVER_SYM window_name  */
#line 11894 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_window_func(thd, (Item_sum *) (yyvsp[-2].item), (yyvsp[0].lex_str_ptr));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            if (unlikely(Select->add_window_func((Item_window_func *) (yyval.item))))
              MYSQL_YYABORT;
          }
#line 39980 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1892: /* window_func_expr: window_func OVER_SYM window_spec  */
#line 11903 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(Select->add_window_spec(thd, lex->win_ref,
                                                 Select->group_list,
                                                 Select->order_list,
                                                 lex->win_frame)))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_window_func(thd, (Item_sum *) (yyvsp[-2].item),
                                                      thd->lex->win_spec); 
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            if (unlikely(Select->add_window_func((Item_window_func *) (yyval.item))))
              MYSQL_YYABORT;
          }
#line 39999 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1895: /* window_func: function_call_generic  */
#line 11925 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item* item = (Item*)(yyvsp[0].item);
            /* Only UDF aggregate here possible */
            if ((item == NULL) ||
                (item->type() != Item::SUM_FUNC_ITEM)
                || (((Item_sum *)item)->sum_func() != Item_sum::UDF_SUM_FUNC))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 40015 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1896: /* simple_window_func: ROW_NUMBER_SYM '(' ')'  */
#line 11940 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_row_number(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40025 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1897: /* simple_window_func: RANK_SYM '(' ')'  */
#line 11947 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_rank(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40035 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1898: /* simple_window_func: DENSE_RANK_SYM '(' ')'  */
#line 11954 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_dense_rank(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40045 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1899: /* simple_window_func: PERCENT_RANK_SYM '(' ')'  */
#line 11961 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_percent_rank(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40055 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1900: /* simple_window_func: CUME_DIST_SYM '(' ')'  */
#line 11968 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_cume_dist(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40065 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1901: /* simple_window_func: NTILE_SYM '(' expr ')'  */
#line 11975 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_ntile(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40075 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1902: /* simple_window_func: FIRST_VALUE_SYM '(' expr ')'  */
#line 11982 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_first_value(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40085 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1903: /* simple_window_func: LAST_VALUE '(' expr ')'  */
#line 11989 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_last_value(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40095 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1904: /* simple_window_func: NTH_VALUE_SYM '(' expr ',' expr ')'  */
#line 11996 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_nth_value(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40105 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1905: /* simple_window_func: LEAD_SYM '(' expr ')'  */
#line 12003 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* No second argument defaults to 1. */
            Item* item_offset= new (thd->mem_root) Item_uint(thd, 1);
            if (unlikely(item_offset == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_sum_lead(thd, (yyvsp[-1].item), item_offset);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40119 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1906: /* simple_window_func: LEAD_SYM '(' expr ',' expr ')'  */
#line 12014 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_lead(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40129 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1907: /* simple_window_func: LAG_SYM '(' expr ')'  */
#line 12021 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* No second argument defaults to 1. */
            Item* item_offset= new (thd->mem_root) Item_uint(thd, 1);
            if (unlikely(item_offset == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_sum_lag(thd, (yyvsp[-1].item), item_offset);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40143 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1908: /* simple_window_func: LAG_SYM '(' expr ',' expr ')'  */
#line 12032 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_lag(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40153 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1909: /* inverse_distribution_function: percentile_function OVER_SYM '(' opt_window_partition_clause ')'  */
#line 12044 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(Select->add_window_spec(thd, lex->win_ref,
                                                 Select->group_list,
                                                 Select->order_list,
                                                 NULL)))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_window_func(thd, (Item_sum *) (yyvsp[-4].item),
                                                     thd->lex->win_spec);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            if (unlikely(Select->add_window_func((Item_window_func *) (yyval.item))))
              MYSQL_YYABORT;
          }
#line 40172 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1910: /* $@176: %empty  */
#line 12062 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           { Select->prepare_add_window_spec(thd); }
#line 40178 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1911: /* percentile_function: inverse_distribution_function_def WITHIN GROUP_SYM '(' $@176 order_by_single_element_list ')'  */
#line 12064 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             (yyval.item)= (yyvsp[-6].item);
           }
#line 40186 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1912: /* percentile_function: MEDIAN_SYM '(' expr ')'  */
#line 12068 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *args= new (thd->mem_root) Item_decimal(thd, "0.5", 3,
                                                   thd->charset());
            if (unlikely(args == NULL) || unlikely(thd->is_error()))
              MYSQL_YYABORT;
            Select->prepare_add_window_spec(thd);
            if (unlikely(add_order_to_list(thd, (yyvsp[-1].item),FALSE)))
              MYSQL_YYABORT;

            (yyval.item)= new (thd->mem_root) Item_sum_percentile_cont(thd, args);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40204 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1913: /* inverse_distribution_function_def: PERCENTILE_CONT_SYM '(' expr ')'  */
#line 12085 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_percentile_cont(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40214 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1914: /* inverse_distribution_function_def: PERCENTILE_DISC_SYM '(' expr ')'  */
#line 12091 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_percentile_disc(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40224 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1915: /* order_by_single_element_list: ORDER_SYM BY order_ident order_dir  */
#line 12100 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(add_order_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
          }
#line 40233 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1916: /* window_name: ident  */
#line 12109 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_str_ptr)= (LEX_CSTRING *) thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING));
            if (unlikely((yyval.lex_str_ptr) == NULL))
              MYSQL_YYABORT;
          }
#line 40243 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1917: /* $@177: %empty  */
#line 12118 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(! Lex->parsing_options.allows_variable))
              my_yyabort_error((ER_VIEW_SELECT_VARIABLE, MYF(0)));
          }
#line 40252 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1918: /* variable: '@' $@177 variable_aux  */
#line 12123 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= (yyvsp[0].item);
          }
#line 40260 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1919: /* variable_aux: ident_or_text SET_VAR expr  */
#line 12130 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item_func_set_user_var *item;
            (yyval.item)= item= new (thd->mem_root) Item_func_set_user_var(thd, &(yyvsp[-2].lex_str), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            LEX *lex= Lex;
            lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
            lex->set_var_list.push_back(item, thd->mem_root);
          }
#line 40274 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1920: /* variable_aux: ident_or_text  */
#line 12140 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_get_user_var(thd, &(yyvsp[0].lex_str));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            LEX *lex= Lex;
            lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
          }
#line 40286 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1921: /* variable_aux: '@' opt_var_ident_type ident_sysvar_name  */
#line 12148 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_sysvar(thd, (yyvsp[-1].var_type), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 40295 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1922: /* variable_aux: '@' opt_var_ident_type ident_sysvar_name '.' ident  */
#line 12153 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_sysvar(thd, (yyvsp[-3].var_type), &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 40304 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1923: /* opt_distinct: %empty  */
#line 12160 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num) = 0; }
#line 40310 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1924: /* opt_distinct: DISTINCT  */
#line 12161 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num) = 1; }
#line 40316 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1925: /* opt_gconcat_separator: %empty  */
#line 12166 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.string)= new (thd->mem_root) String(",", 1, &my_charset_latin1);
            if (unlikely((yyval.string) == NULL))
              MYSQL_YYABORT;
          }
#line 40326 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1926: /* opt_gconcat_separator: SEPARATOR_SYM text_string  */
#line 12171 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                    { (yyval.string) = (yyvsp[0].string); }
#line 40332 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1929: /* gorder_list: gorder_list ',' order_ident order_dir  */
#line 12181 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(add_gorder_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
           }
#line 40341 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1930: /* gorder_list: order_ident order_dir  */
#line 12186 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(add_gorder_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
           }
#line 40350 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1931: /* opt_glimit_clause: %empty  */
#line 12193 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num) = 0; }
#line 40356 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1932: /* opt_glimit_clause: glimit_clause  */
#line 12194 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.num) = 1; }
#line 40362 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1933: /* glimit_clause_init: LIMIT  */
#line 12198 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               {}
#line 40368 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1934: /* glimit_clause: glimit_clause_init glimit_options  */
#line 12203 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 40376 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1935: /* glimit_options: limit_option  */
#line 12210 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[0].item);
            sel->offset_limit= 0;
            sel->explicit_limit= 1;
          }
#line 40387 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1936: /* glimit_options: limit_option ',' limit_option  */
#line 12217 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[0].item);
            sel->offset_limit= (yyvsp[-2].item);
            sel->explicit_limit= 1;
          }
#line 40398 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1937: /* glimit_options: limit_option OFFSET_SYM limit_option  */
#line 12224 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[-2].item);
            sel->offset_limit= (yyvsp[0].item);
            sel->explicit_limit= 1;
          }
#line 40409 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1938: /* $@178: %empty  */
#line 12236 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->current_select->inc_in_sum_expr()))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 40422 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1939: /* in_sum_expr: opt_all $@178 expr  */
#line 12245 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->in_sum_expr--;
            (yyval.item)= (yyvsp[0].item);
          }
#line 40431 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1940: /* cast_type: BINARY opt_field_length  */
#line 12253 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[0].const_simple_string)); Lex->charset= &my_charset_bin; }
#line 40437 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1941: /* $@179: %empty  */
#line 12255 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 40443 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1942: /* cast_type: CHAR_SYM opt_field_length $@179 opt_binary  */
#line 12257 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[-2].const_simple_string)); }
#line 40449 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1943: /* $@180: %empty  */
#line 12259 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 40455 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1944: /* cast_type: VARCHAR field_length $@180 opt_binary  */
#line 12261 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[-2].const_simple_string)); }
#line 40461 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1945: /* $@181: %empty  */
#line 12263 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 40467 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1946: /* cast_type: VARCHAR2_ORACLE_SYM field_length $@181 opt_binary  */
#line 12265 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[-2].const_simple_string)); }
#line 40473 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1947: /* cast_type: NCHAR_SYM opt_field_length  */
#line 12267 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset= national_charset_info;
            (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[0].const_simple_string), 0);
          }
#line 40482 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1948: /* cast_type: cast_type_numeric  */
#line 12271 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.Lex_cast_type)= (yyvsp[0].Lex_cast_type); Lex->charset= NULL; }
#line 40488 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1949: /* cast_type: cast_type_temporal  */
#line 12272 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.Lex_cast_type)= (yyvsp[0].Lex_cast_type); Lex->charset= NULL; }
#line 40494 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1950: /* cast_type_numeric: INT_SYM  */
#line 12276 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_longlong); }
#line 40500 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1951: /* cast_type_numeric: SIGNED_SYM  */
#line 12277 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_longlong); }
#line 40506 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1952: /* cast_type_numeric: SIGNED_SYM INT_SYM  */
#line 12278 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_longlong); }
#line 40512 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1953: /* cast_type_numeric: UNSIGNED  */
#line 12279 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_ulonglong); }
#line 40518 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1954: /* cast_type_numeric: UNSIGNED INT_SYM  */
#line 12280 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_ulonglong); }
#line 40524 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1955: /* cast_type_numeric: DECIMAL_SYM float_options  */
#line 12281 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_newdecimal, (yyvsp[0].Lex_length_and_dec)); }
#line 40530 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1956: /* cast_type_numeric: FLOAT_SYM  */
#line 12282 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_float); }
#line 40536 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1957: /* cast_type_numeric: DOUBLE_SYM opt_precision  */
#line 12283 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_double, (yyvsp[0].Lex_length_and_dec));  }
#line 40542 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1958: /* cast_type_temporal: DATE_SYM  */
#line 12287 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_newdate); }
#line 40548 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1959: /* cast_type_temporal: TIME_SYM opt_field_length  */
#line 12288 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_time2, 0, (yyvsp[0].const_simple_string)); }
#line 40554 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1960: /* cast_type_temporal: DATETIME opt_field_length  */
#line 12289 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_datetime2, 0, (yyvsp[0].const_simple_string)); }
#line 40560 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1961: /* cast_type_temporal: INTERVAL_SYM DAY_SECOND_SYM field_length  */
#line 12291 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_cast_type).set(&type_handler_interval_DDhhmmssff, 0, (yyvsp[0].const_simple_string));
          }
#line 40568 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1962: /* opt_expr_list: %empty  */
#line 12297 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.item_list)= NULL; }
#line 40574 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1963: /* opt_expr_list: expr_list  */
#line 12298 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.item_list)= (yyvsp[0].item_list);}
#line 40580 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1964: /* expr_list: expr  */
#line 12303 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_list)= List<Item>::make(thd->mem_root, (yyvsp[0].item)))))
              MYSQL_YYABORT;
          }
#line 40589 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1965: /* expr_list: expr_list ',' expr  */
#line 12308 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root);
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 40598 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1966: /* ident_list_arg: ident_list  */
#line 12315 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.item_list)= (yyvsp[0].item_list); }
#line 40604 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1967: /* ident_list_arg: '(' ident_list ')'  */
#line 12316 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.item_list)= (yyvsp[-1].item_list); }
#line 40610 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1968: /* ident_list: simple_ident  */
#line 12321 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL) ||
                unlikely((yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 40621 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1969: /* ident_list: ident_list ',' simple_ident  */
#line 12328 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root);
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 40630 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1970: /* when_list: WHEN_SYM expr THEN_SYM expr  */
#line 12336 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL))
              MYSQL_YYABORT;
            if (unlikely((yyval.item_list)->push_back((yyvsp[-2].item), thd->mem_root) ||
                         (yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 40643 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1971: /* when_list: when_list WHEN_SYM expr THEN_SYM expr  */
#line 12345 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[-4].item_list)->push_back((yyvsp[-2].item), thd->mem_root) ||
                         (yyvsp[-4].item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.item_list)= (yyvsp[-4].item_list);
          }
#line 40654 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1973: /* when_list_opt_else: when_list ELSE expr  */
#line 12356 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 40664 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1974: /* table_ref: table_factor  */
#line 12366 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.table_list)= (yyvsp[0].table_list); }
#line 40670 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1975: /* table_ref: join_table  */
#line 12368 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->nest_last_join(thd))))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 40683 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1976: /* join_table_list: derived_table_list  */
#line 12379 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { MYSQL_YYABORT_UNLESS((yyval.table_list)=(yyvsp[0].table_list)); }
#line 40689 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1977: /* esc_table_ref: table_ref  */
#line 12390 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.table_list)=(yyvsp[0].table_list); }
#line 40695 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1978: /* esc_table_ref: '{' ident table_ref '}'  */
#line 12391 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.table_list)=(yyvsp[-1].table_list); }
#line 40701 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1979: /* derived_table_list: esc_table_ref  */
#line 12398 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.table_list)=(yyvsp[0].table_list);
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 40710 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1980: /* derived_table_list: derived_table_list ',' esc_table_ref  */
#line 12403 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-2].table_list) && ((yyval.table_list)=(yyvsp[0].table_list)));
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 40719 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1981: /* join_table: table_ref normal_join table_ref  */
#line 12417 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-2].table_list) && ((yyval.table_list)=(yyvsp[0].table_list)));
            if (unlikely(Select->add_cross_joined_table((yyvsp[-2].table_list), (yyvsp[0].table_list), (yyvsp[-1].num))))
              MYSQL_YYABORT;
          }
#line 40729 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1982: /* $@182: %empty  */
#line 12424 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-3].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-3].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
            /* Change the current name resolution context to a local context. */
            if (unlikely(push_new_name_resolution_context(thd, (yyvsp[-3].table_list), (yyvsp[-1].table_list))))
              MYSQL_YYABORT;
            Select->parsing_place= IN_ON;
          }
#line 40743 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1983: /* join_table: table_ref normal_join table_ref ON $@182 expr  */
#line 12434 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-3].table_list)->straight=(yyvsp[-4].num);
            add_join_on(thd, (yyvsp[-3].table_list), (yyvsp[0].item));
            (yyvsp[-3].table_list)->on_context= Lex->pop_context();
            Select->parsing_place= NO_MATTER;
          }
#line 40754 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1984: /* $@183: %empty  */
#line 12442 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-3].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-3].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
          }
#line 40764 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1985: /* join_table: table_ref normal_join table_ref USING $@183 '(' using_list ')'  */
#line 12448 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    (yyvsp[-5].table_list)->straight=(yyvsp[-6].num);
            add_join_natural((yyvsp[-7].table_list),(yyvsp[-5].table_list),(yyvsp[-1].string_list),Select); 
	    (yyval.table_list)=(yyvsp[-5].table_list); 
          }
#line 40774 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1986: /* join_table: table_ref NATURAL inner_join table_factor  */
#line 12454 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-3].table_list) && ((yyval.table_list)=(yyvsp[0].table_list)));
            Select->add_joined_table((yyvsp[-3].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
	    (yyvsp[0].table_list)->straight=(yyvsp[-1].num);
            add_join_natural((yyvsp[-3].table_list),(yyvsp[0].table_list),NULL,Select);
          }
#line 40786 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1987: /* $@184: %empty  */
#line 12465 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
            /* Change the current name resolution context to a local context. */
            if (unlikely(push_new_name_resolution_context(thd, (yyvsp[-5].table_list), (yyvsp[-1].table_list))))
              MYSQL_YYABORT;
            Select->parsing_place= IN_ON;
          }
#line 40800 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1988: /* join_table: table_ref LEFT opt_outer JOIN_SYM table_ref ON $@184 expr  */
#line 12475 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            add_join_on(thd, (yyvsp[-3].table_list), (yyvsp[0].item));
            (yyvsp[-3].table_list)->on_context= Lex->pop_context();
            (yyvsp[-3].table_list)->outer_join|=JOIN_TYPE_LEFT;
            (yyval.table_list)=(yyvsp[-3].table_list);
            Select->parsing_place= NO_MATTER;
          }
#line 40812 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1989: /* $@185: %empty  */
#line 12483 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-4].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-4].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 40822 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1990: /* join_table: table_ref LEFT opt_outer JOIN_SYM table_factor $@185 USING '(' using_list ')'  */
#line 12489 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            add_join_natural((yyvsp[-9].table_list),(yyvsp[-5].table_list),(yyvsp[-1].string_list),Select); 
            (yyvsp[-5].table_list)->outer_join|=JOIN_TYPE_LEFT; 
            (yyval.table_list)=(yyvsp[-5].table_list); 
          }
#line 40832 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1991: /* join_table: table_ref NATURAL LEFT opt_outer JOIN_SYM table_factor  */
#line 12495 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
            add_join_natural((yyvsp[-5].table_list),(yyvsp[0].table_list),NULL,Select);
            (yyvsp[0].table_list)->outer_join|=JOIN_TYPE_LEFT;
            (yyval.table_list)=(yyvsp[0].table_list);
          }
#line 40845 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1992: /* $@186: %empty  */
#line 12507 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
            /* Change the current name resolution context to a local context. */
            if (unlikely(push_new_name_resolution_context(thd, (yyvsp[-5].table_list), (yyvsp[-1].table_list))))
              MYSQL_YYABORT;
            Select->parsing_place= IN_ON;
          }
#line 40859 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1993: /* join_table: table_ref RIGHT opt_outer JOIN_SYM table_ref ON $@186 expr  */
#line 12517 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->convert_right_join())))
              MYSQL_YYABORT;
            add_join_on(thd, (yyval.table_list), (yyvsp[0].item));
            (yyvsp[-7].table_list)->on_context= Lex->pop_context();
            Select->parsing_place= NO_MATTER;
          }
#line 40872 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1994: /* $@187: %empty  */
#line 12526 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-4].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-4].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 40882 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1995: /* join_table: table_ref RIGHT opt_outer JOIN_SYM table_factor $@187 USING '(' using_list ')'  */
#line 12532 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->convert_right_join())))
              MYSQL_YYABORT;
            add_join_natural((yyval.table_list),(yyvsp[-5].table_list),(yyvsp[-1].string_list),Select);
          }
#line 40893 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1996: /* join_table: table_ref NATURAL RIGHT opt_outer JOIN_SYM table_factor  */
#line 12539 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
            add_join_natural((yyvsp[0].table_list),(yyvsp[-5].table_list),NULL,Select);
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->convert_right_join())))
              MYSQL_YYABORT;
          }
#line 40907 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1997: /* inner_join: JOIN_SYM  */
#line 12552 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num) = 0; }
#line 40913 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1998: /* inner_join: INNER_SYM JOIN_SYM  */
#line 12553 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num) = 0; }
#line 40919 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1999: /* inner_join: STRAIGHT_JOIN  */
#line 12554 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num) = 1; }
#line 40925 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2000: /* normal_join: inner_join  */
#line 12558 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num) = (yyvsp[0].num); }
#line 40931 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2001: /* normal_join: CROSS JOIN_SYM  */
#line 12559 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num) = 0; }
#line 40937 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2002: /* opt_use_partition: %empty  */
#line 12567 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.string_list)= 0;}
#line 40943 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2004: /* use_partition: PARTITION_SYM '(' using_list ')' have_partitioning  */
#line 12573 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.string_list)= (yyvsp[-2].string_list);
            Select->parsing_place= Select->save_parsing_place;
            Select->save_parsing_place= NO_MATTER;
          }
#line 40953 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2005: /* table_factor: table_primary_ident_opt_parens  */
#line 12581 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.table_list)= (yyvsp[0].table_list); }
#line 40959 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2006: /* table_factor: table_primary_derived_opt_parens  */
#line 12582 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.table_list)= (yyvsp[0].table_list); }
#line 40965 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2007: /* table_factor: join_table_parens  */
#line 12584 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            (yyvsp[0].table_list)->nested_join->nest_type= 0;
            (yyval.table_list)= (yyvsp[0].table_list);
          }
#line 40974 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2008: /* table_factor: table_reference_list_parens  */
#line 12588 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { (yyval.table_list)= (yyvsp[0].table_list); }
#line 40980 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2009: /* table_primary_ident_opt_parens: table_primary_ident  */
#line 12592 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.table_list)= (yyvsp[0].table_list); }
#line 40986 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2010: /* table_primary_ident_opt_parens: '(' table_primary_ident_opt_parens ')'  */
#line 12593 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                 { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 40992 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2011: /* table_primary_derived_opt_parens: table_primary_derived  */
#line 12597 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.table_list)= (yyvsp[0].table_list); }
#line 40998 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2012: /* table_primary_derived_opt_parens: '(' table_primary_derived_opt_parens ')'  */
#line 12598 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                   { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 41004 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2013: /* table_reference_list_parens: '(' table_reference_list_parens ')'  */
#line 12602 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 41010 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2014: /* table_reference_list_parens: '(' nested_table_reference_list ')'  */
#line 12604 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.table_list)= Select->end_nested_join(thd)))
              MYSQL_YYABORT;
          }
#line 41019 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2015: /* nested_table_reference_list: table_ref ',' table_ref  */
#line 12612 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Select->init_nested_join(thd))
              MYSQL_YYABORT;
            Select->add_joined_table((yyvsp[-2].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
            (yyval.table_list)= (yyvsp[-2].table_list)->embedding;
          }
#line 41031 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2016: /* nested_table_reference_list: nested_table_reference_list ',' table_ref  */
#line 12620 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->add_joined_table((yyvsp[0].table_list));
            (yyval.table_list)= (yyvsp[-2].table_list);
          }
#line 41040 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2017: /* join_table_parens: '(' join_table_parens ')'  */
#line 12627 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                    { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 41046 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2018: /* join_table_parens: '(' join_table ')'  */
#line 12629 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (!((yyval.table_list)= lex->current_select->nest_last_join(thd)))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 41059 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2019: /* table_primary_ident: table_ident opt_use_partition opt_for_system_time_clause opt_table_alias_clause opt_key_definition  */
#line 12643 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->table_join_options= 0;
            if (!((yyval.table_list)= Select->add_table_to_list(thd, (yyvsp[-4].table), (yyvsp[-1].lex_str_ptr),
                                                Select->get_table_join_options(),
                                                YYPS->m_lock_type,
                                                YYPS->m_mdl_type,
                                                Select->pop_index_hints(),
                                                (yyvsp[-3].string_list))))
              MYSQL_YYABORT;
            if ((yyvsp[-2].num))
              (yyval.table_list)->vers_conditions= Lex->vers_conditions;
          }
#line 41077 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2020: /* table_primary_derived: subquery opt_for_system_time_clause table_alias_clause  */
#line 12661 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.table_list)= Lex->parsed_derived_table((yyvsp[-2].select_lex)->master_unit(), (yyvsp[-1].num), (yyvsp[0].lex_str_ptr))))
              MYSQL_YYABORT;
          }
#line 41086 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2021: /* opt_outer: %empty  */
#line 12669 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 41092 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2022: /* opt_outer: OUTER  */
#line 12670 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                {}
#line 41098 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2023: /* index_hint_clause: %empty  */
#line 12675 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= thd->variables.old_mode ?  INDEX_HINT_MASK_JOIN : INDEX_HINT_MASK_ALL; 
          }
#line 41106 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2024: /* index_hint_clause: FOR_SYM JOIN_SYM  */
#line 12678 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.num)= INDEX_HINT_MASK_JOIN;  }
#line 41112 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2025: /* index_hint_clause: FOR_SYM ORDER_SYM BY  */
#line 12679 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.num)= INDEX_HINT_MASK_ORDER; }
#line 41118 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2026: /* index_hint_clause: FOR_SYM GROUP_SYM BY  */
#line 12680 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.num)= INDEX_HINT_MASK_GROUP; }
#line 41124 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2027: /* index_hint_type: FORCE_SYM  */
#line 12684 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.index_hint)= INDEX_HINT_FORCE; }
#line 41130 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2028: /* index_hint_type: IGNORE_SYM  */
#line 12685 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.index_hint)= INDEX_HINT_IGNORE; }
#line 41136 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2029: /* $@188: %empty  */
#line 12690 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->set_index_hint_type((yyvsp[-2].index_hint), (yyvsp[0].num));
          }
#line 41144 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2031: /* $@189: %empty  */
#line 12695 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->set_index_hint_type(INDEX_HINT_USE, (yyvsp[0].num));
          }
#line 41152 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2036: /* $@190: %empty  */
#line 12708 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->alloc_index_hints(thd); }
#line 41158 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2038: /* $@191: %empty  */
#line 12712 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {  Select->clear_index_hints(); }
#line 41164 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2040: /* opt_key_usage_list: %empty  */
#line 12717 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Select->add_index_hint(thd, NULL, 0); }
#line 41170 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2041: /* opt_key_usage_list: key_usage_list  */
#line 12718 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         {}
#line 41176 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2042: /* key_usage_element: ident  */
#line 12723 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->add_index_hint(thd, (yyvsp[0].ident_sys).str, (yyvsp[0].ident_sys).length); }
#line 41182 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2043: /* key_usage_element: PRIMARY_SYM  */
#line 12725 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->add_index_hint(thd, "PRIMARY", 7); }
#line 41188 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2046: /* using_list: ident  */
#line 12735 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.string_list)= new (thd->mem_root) List<String>)))
              MYSQL_YYABORT;
            String *s= new (thd->mem_root) String((const char *) (yyvsp[0].ident_sys).str,
                                                    (yyvsp[0].ident_sys).length,
                                                    system_charset_info);
            if (unlikely(unlikely(s == NULL)))
              MYSQL_YYABORT;
            (yyval.string_list)->push_back(s, thd->mem_root);
          }
#line 41203 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2047: /* using_list: using_list ',' ident  */
#line 12746 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            String *s= new (thd->mem_root) String((const char *) (yyvsp[0].ident_sys).str,
                                                    (yyvsp[0].ident_sys).length,
                                                    system_charset_info);
            if (unlikely(unlikely(s == NULL)))
              MYSQL_YYABORT;
            if (unlikely((yyvsp[-2].string_list)->push_back(s, thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.string_list)= (yyvsp[-2].string_list);
          }
#line 41218 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2048: /* interval: interval_time_stamp  */
#line 12759 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 {}
#line 41224 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2049: /* interval: DAY_HOUR_SYM  */
#line 12760 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_DAY_HOUR; }
#line 41230 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2050: /* interval: DAY_MICROSECOND_SYM  */
#line 12761 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_DAY_MICROSECOND; }
#line 41236 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2051: /* interval: DAY_MINUTE_SYM  */
#line 12762 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_DAY_MINUTE; }
#line 41242 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2052: /* interval: DAY_SECOND_SYM  */
#line 12763 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_DAY_SECOND; }
#line 41248 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2053: /* interval: HOUR_MICROSECOND_SYM  */
#line 12764 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_HOUR_MICROSECOND; }
#line 41254 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2054: /* interval: HOUR_MINUTE_SYM  */
#line 12765 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_HOUR_MINUTE; }
#line 41260 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2055: /* interval: HOUR_SECOND_SYM  */
#line 12766 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_HOUR_SECOND; }
#line 41266 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2056: /* interval: MINUTE_MICROSECOND_SYM  */
#line 12767 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_MINUTE_MICROSECOND; }
#line 41272 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2057: /* interval: MINUTE_SECOND_SYM  */
#line 12768 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_MINUTE_SECOND; }
#line 41278 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2058: /* interval: SECOND_MICROSECOND_SYM  */
#line 12769 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_SECOND_MICROSECOND; }
#line 41284 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2059: /* interval: YEAR_MONTH_SYM  */
#line 12770 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_YEAR_MONTH; }
#line 41290 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2060: /* interval_time_stamp: DAY_SYM  */
#line 12774 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_DAY; }
#line 41296 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2061: /* interval_time_stamp: WEEK_SYM  */
#line 12775 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_WEEK; }
#line 41302 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2062: /* interval_time_stamp: HOUR_SYM  */
#line 12776 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_HOUR; }
#line 41308 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2063: /* interval_time_stamp: MINUTE_SYM  */
#line 12777 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_MINUTE; }
#line 41314 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2064: /* interval_time_stamp: MONTH_SYM  */
#line 12778 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_MONTH; }
#line 41320 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2065: /* interval_time_stamp: QUARTER_SYM  */
#line 12779 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_QUARTER; }
#line 41326 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2066: /* interval_time_stamp: SECOND_SYM  */
#line 12780 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_SECOND; }
#line 41332 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2067: /* interval_time_stamp: MICROSECOND_SYM  */
#line 12781 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_MICROSECOND; }
#line 41338 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2068: /* interval_time_stamp: YEAR_SYM  */
#line 12782 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_YEAR; }
#line 41344 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2069: /* date_time_type: DATE_SYM  */
#line 12786 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_DATE;}
#line 41350 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2070: /* date_time_type: TIME_SYM  */
#line 12787 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_TIME;}
#line 41356 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2071: /* date_time_type: DATETIME  */
#line 12788 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_DATETIME;}
#line 41362 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2072: /* date_time_type: TIMESTAMP  */
#line 12789 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_DATETIME;}
#line 41368 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2076: /* opt_table_alias_clause: %empty  */
#line 12799 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str_ptr)=0; }
#line 41374 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2077: /* opt_table_alias_clause: table_alias_clause  */
#line 12800 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.lex_str_ptr)= (yyvsp[0].lex_str_ptr); }
#line 41380 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2078: /* table_alias_clause: table_alias ident_table_alias  */
#line 12805 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_str_ptr)= (LEX_CSTRING*) thd->memdup(&(yyvsp[0].ident_sys),sizeof(LEX_STRING));
            if (unlikely((yyval.lex_str_ptr) == NULL))
              MYSQL_YYABORT;
          }
#line 41390 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2081: /* opt_where_clause: %empty  */
#line 12818 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Select->where= 0; }
#line 41396 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2082: /* $@192: %empty  */
#line 12820 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->parsing_place= IN_WHERE;
          }
#line 41404 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2083: /* opt_where_clause: WHERE $@192 expr  */
#line 12824 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *select= Select;
            select->where= normalize_cond(thd, (yyvsp[0].item));
            select->parsing_place= NO_MATTER;
            if ((yyvsp[0].item))
              (yyvsp[0].item)->top_level_item();
          }
#line 41416 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2085: /* $@193: %empty  */
#line 12836 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->parsing_place= IN_HAVING;
          }
#line 41424 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2086: /* opt_having_clause: HAVING $@193 expr  */
#line 12840 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->having= normalize_cond(thd, (yyvsp[0].item));
            sel->parsing_place= NO_MATTER;
            if ((yyvsp[0].item))
              (yyvsp[0].item)->top_level_item();
          }
#line 41436 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2089: /* group_list: group_list ',' order_ident order_dir  */
#line 12860 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             if (unlikely(add_group_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
               MYSQL_YYABORT;
           }
#line 41445 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2090: /* group_list: order_ident order_dir  */
#line 12865 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(add_group_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
           }
#line 41454 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2091: /* olap_opt: %empty  */
#line 12872 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 41460 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2092: /* olap_opt: WITH_CUBE_SYM  */
#line 12874 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              'WITH CUBE' is reserved in the MySQL syntax, but not implemented,
              and cause LALR(2) conflicts.
              This syntax is not standard.
              MySQL syntax: GROUP BY col1, col2, col3 WITH CUBE
              SQL-2003: GROUP BY ... CUBE(col1, col2, col3)
            */
            LEX *lex=Lex;
            if (unlikely(lex->current_select->get_linkage() == GLOBAL_OPTIONS_TYPE))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "WITH CUBE",
                                "global union parameters"));
            lex->current_select->olap= CUBE_TYPE;

            my_yyabort_error((ER_NOT_SUPPORTED_YET, MYF(0), "CUBE"));
          }
#line 41481 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2093: /* olap_opt: WITH_ROLLUP_SYM  */
#line 12891 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              'WITH ROLLUP' is needed for backward compatibility,
              and cause LALR(2) conflicts.
              This syntax is not standard.
              MySQL syntax: GROUP BY col1, col2, col3 WITH ROLLUP
              SQL-2003: GROUP BY ... ROLLUP(col1, col2, col3)
            */
            LEX *lex= Lex;
            if (unlikely(lex->current_select->get_linkage() == GLOBAL_OPTIONS_TYPE))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "WITH ROLLUP",
                                "global union parameters"));
            lex->current_select->olap= ROLLUP_TYPE;
          }
#line 41500 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2094: /* opt_window_clause: %empty  */
#line 12913 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 41506 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2095: /* opt_window_clause: WINDOW_SYM window_def_list  */
#line 12916 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 41512 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2098: /* window_def: window_name AS window_spec  */
#line 12926 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            LEX *lex= Lex;
            if (unlikely(Select->add_window_def(thd, (yyvsp[-2].lex_str_ptr), lex->win_ref,
                                                Select->group_list,
                                                Select->order_list,
                                                lex->win_frame)))
              MYSQL_YYABORT;
          }
#line 41525 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2099: /* $@194: %empty  */
#line 12938 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->prepare_add_window_spec(thd); }
#line 41531 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2100: /* window_spec: '(' $@194 opt_window_ref opt_window_partition_clause opt_window_order_clause opt_window_frame_clause ')'  */
#line 12942 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 41537 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2101: /* opt_window_ref: %empty  */
#line 12946 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 41543 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2102: /* opt_window_ref: ident  */
#line 12948 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            thd->lex->win_ref= (LEX_CSTRING *) thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING));
            if (unlikely(thd->lex->win_ref == NULL))
              MYSQL_YYABORT;
          }
#line 41553 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2103: /* opt_window_partition_clause: %empty  */
#line 12956 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { }
#line 41559 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2105: /* opt_window_order_clause: %empty  */
#line 12961 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { }
#line 41565 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2106: /* opt_window_order_clause: ORDER_SYM BY order_list  */
#line 12962 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Select->order_list= *((yyvsp[0].select_order)); }
#line 41571 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2107: /* opt_window_frame_clause: %empty  */
#line 12966 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 41577 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2108: /* opt_window_frame_clause: window_frame_units window_frame_extent opt_window_frame_exclusion  */
#line 12968 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->win_frame=
              new (thd->mem_root) Window_frame((yyvsp[-2].frame_units),
                                               lex->frame_top_bound,
                                               lex->frame_bottom_bound,
                                               (yyvsp[0].frame_exclusion));
            if (unlikely(lex->win_frame == NULL))
              MYSQL_YYABORT;
          }
#line 41592 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2109: /* window_frame_units: ROWS_SYM  */
#line 12981 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { (yyval.frame_units)= Window_frame::UNITS_ROWS; }
#line 41598 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2110: /* window_frame_units: RANGE_SYM  */
#line 12982 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.frame_units)= Window_frame::UNITS_RANGE; }
#line 41604 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2111: /* window_frame_extent: window_frame_start  */
#line 12987 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->frame_top_bound= (yyvsp[0].window_frame_bound);
            lex->frame_bottom_bound=
              new (thd->mem_root)
                Window_frame_bound(Window_frame_bound::CURRENT, NULL);
            if (unlikely(lex->frame_bottom_bound == NULL))
              MYSQL_YYABORT;
          }
#line 41618 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2112: /* window_frame_extent: BETWEEN_SYM window_frame_bound AND_SYM window_frame_bound  */
#line 12997 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->frame_top_bound= (yyvsp[-2].window_frame_bound);
            lex->frame_bottom_bound= (yyvsp[0].window_frame_bound);
          }
#line 41628 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2113: /* window_frame_start: UNBOUNDED_SYM PRECEDING_SYM  */
#line 13006 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root) 
                  Window_frame_bound(Window_frame_bound::PRECEDING, NULL); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 41639 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2114: /* window_frame_start: CURRENT_SYM ROW_SYM  */
#line 13013 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::CURRENT, NULL); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 41650 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2115: /* window_frame_start: literal PRECEDING_SYM  */
#line 13020 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::PRECEDING, (yyvsp[-1].item)); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 41661 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2116: /* window_frame_bound: window_frame_start  */
#line 13029 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.window_frame_bound)= (yyvsp[0].window_frame_bound); }
#line 41667 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2117: /* window_frame_bound: UNBOUNDED_SYM FOLLOWING_SYM  */
#line 13031 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::FOLLOWING, NULL); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 41678 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2118: /* window_frame_bound: literal FOLLOWING_SYM  */
#line 13038 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::FOLLOWING, (yyvsp[-1].item)); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 41689 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2119: /* opt_window_frame_exclusion: %empty  */
#line 13047 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.frame_exclusion)= Window_frame::EXCL_NONE; }
#line 41695 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2120: /* opt_window_frame_exclusion: EXCLUDE_SYM CURRENT_SYM ROW_SYM  */
#line 13049 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_CURRENT_ROW; }
#line 41701 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2121: /* opt_window_frame_exclusion: EXCLUDE_SYM GROUP_SYM  */
#line 13051 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_GROUP; }
#line 41707 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2122: /* opt_window_frame_exclusion: EXCLUDE_SYM TIES_SYM  */
#line 13053 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_TIES; }
#line 41713 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2123: /* opt_window_frame_exclusion: EXCLUDE_SYM NO_SYM OTHERS_MARIADB_SYM  */
#line 13055 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_NONE; }
#line 41719 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2124: /* opt_window_frame_exclusion: EXCLUDE_SYM NO_SYM OTHERS_ORACLE_SYM  */
#line 13057 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_NONE; }
#line 41725 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2128: /* alter_order_item: simple_ident_nospvar order_dir  */
#line 13075 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            bool ascending= ((yyvsp[0].num) == 1) ? true : false;
            if (unlikely(add_order_to_list(thd, (yyvsp[-1].item), ascending)))
              MYSQL_YYABORT;
          }
#line 41735 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2129: /* opt_order_clause: %empty  */
#line 13088 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_order)= NULL; }
#line 41741 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2130: /* opt_order_clause: order_clause  */
#line 13090 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_order)= (yyvsp[0].select_order); }
#line 41747 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2131: /* $@195: %empty  */
#line 13095 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            thd->where= "ORDER clause";
          }
#line 41755 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2132: /* order_clause: ORDER_SYM BY $@195 order_list  */
#line 13099 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_order)= (yyvsp[0].select_order);
          }
#line 41763 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2133: /* order_list: order_list ',' order_ident order_dir  */
#line 13106 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_order)= (yyvsp[-3].select_order);
            if (add_to_list(thd, *(yyval.select_order), (yyvsp[-1].item),(bool) (yyvsp[0].num)))
              MYSQL_YYABORT;
          }
#line 41773 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2134: /* order_list: order_ident order_dir  */
#line 13112 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_order)= new (thd->mem_root) SQL_I_List<ORDER>();
            if (add_to_list(thd, *(yyval.select_order), (yyvsp[-1].item), (bool) (yyvsp[0].num)))
              MYSQL_YYABORT;
          }
#line 41783 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2135: /* order_dir: %empty  */
#line 13120 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num) =  1; }
#line 41789 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2136: /* order_dir: ASC  */
#line 13121 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               { (yyval.num) =1; }
#line 41795 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2137: /* order_dir: DESC  */
#line 13122 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               { (yyval.num) =0; }
#line 41801 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2138: /* opt_limit_clause: %empty  */
#line 13127 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_limit).empty(); }
#line 41807 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2139: /* opt_limit_clause: limit_clause  */
#line 13129 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_limit)= (yyvsp[0].select_limit); }
#line 41813 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2140: /* limit_clause: LIMIT limit_options  */
#line 13134 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_limit)= (yyvsp[0].select_limit);
            if (!(yyval.select_limit).select_limit->basic_const_item() ||
                (yyval.select_limit).select_limit->val_int() > 0)
              Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 41824 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2141: /* limit_clause: LIMIT limit_options ROWS_SYM EXAMINED_SYM limit_rows_option  */
#line 13142 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_limit)= (yyvsp[-3].select_limit);
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 41833 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2142: /* limit_clause: LIMIT ROWS_SYM EXAMINED_SYM limit_rows_option  */
#line 13147 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_limit).select_limit= 0;
            (yyval.select_limit).offset_limit= 0;
            (yyval.select_limit).explicit_limit= 1;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 41844 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2143: /* opt_global_limit_clause: opt_limit_clause  */
#line 13157 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->explicit_limit= (yyvsp[0].select_limit).explicit_limit;
            Select->select_limit= (yyvsp[0].select_limit).select_limit;
            Select->offset_limit= (yyvsp[0].select_limit).offset_limit;
          }
#line 41854 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2144: /* limit_options: limit_option  */
#line 13166 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_limit).select_limit= (yyvsp[0].item);
            (yyval.select_limit).offset_limit= 0;
            (yyval.select_limit).explicit_limit= 1;
          }
#line 41864 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2145: /* limit_options: limit_option ',' limit_option  */
#line 13172 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_limit).select_limit= (yyvsp[0].item);
            (yyval.select_limit).offset_limit= (yyvsp[-2].item);
            (yyval.select_limit).explicit_limit= 1;
          }
#line 41874 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2146: /* limit_options: limit_option OFFSET_SYM limit_option  */
#line 13178 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_limit).select_limit= (yyvsp[-2].item);
            (yyval.select_limit).offset_limit= (yyvsp[0].item);
            (yyval.select_limit).explicit_limit= 1;
          }
#line 41884 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2147: /* limit_option: ident_cli  */
#line 13187 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_limit(thd, &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 41893 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2148: /* limit_option: ident_cli '.' ident_cli  */
#line 13192 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_limit(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 41902 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2149: /* limit_option: param_marker  */
#line 13197 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[0].item_param)->limit_clause_param= TRUE;
          }
#line 41910 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2150: /* limit_option: ULONGLONG_NUM  */
#line 13201 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 41920 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2151: /* limit_option: LONG_NUM  */
#line 13207 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 41930 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2152: /* limit_option: NUM  */
#line 13213 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 41940 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2153: /* limit_rows_option: limit_option  */
#line 13222 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            LEX *lex=Lex;
            lex->limit_rows_examined= (yyvsp[0].item);
          }
#line 41949 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2154: /* delete_limit_clause: %empty  */
#line 13230 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->current_select->select_limit= 0;
          }
#line 41958 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2155: /* delete_limit_clause: LIMIT limit_option  */
#line 13235 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[0].item);
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
            sel->explicit_limit= 1;
          }
#line 41969 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2156: /* delete_limit_clause: LIMIT ROWS_SYM EXAMINED_SYM  */
#line 13241 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                     { thd->parse_error(); MYSQL_YYABORT; }
#line 41975 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2157: /* delete_limit_clause: LIMIT limit_option ROWS_SYM EXAMINED_SYM  */
#line 13242 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                  { thd->parse_error(); MYSQL_YYABORT; }
#line 41981 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2158: /* order_limit_lock: order_or_limit  */
#line 13247 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.order_limit_lock)= (yyvsp[0].order_limit_lock);
            (yyval.order_limit_lock)->lock.empty();
          }
#line 41990 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2159: /* order_limit_lock: order_or_limit select_lock_type  */
#line 13252 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.order_limit_lock)= (yyvsp[-1].order_limit_lock);
            (yyval.order_limit_lock)->lock= (yyvsp[0].select_lock);
          }
#line 41999 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2160: /* order_limit_lock: select_lock_type  */
#line 13257 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.order_limit_lock)= new(thd->mem_root) Lex_order_limit_lock;
            if (!(yyval.order_limit_lock))
              YYABORT;
            (yyval.order_limit_lock)->order_list= NULL;
            (yyval.order_limit_lock)->limit.empty();
            (yyval.order_limit_lock)->lock= (yyvsp[0].select_lock);
          }
#line 42012 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2161: /* opt_order_limit_lock: %empty  */
#line 13268 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select();
            (yyval.order_limit_lock)= NULL;
          }
#line 42021 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2162: /* opt_order_limit_lock: order_limit_lock  */
#line 13272 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.order_limit_lock)= (yyvsp[0].order_limit_lock); }
#line 42027 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2165: /* opt_procedure_or_into: %empty  */
#line 13285 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_lock).empty();
          }
#line 42035 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2166: /* opt_procedure_or_into: procedure_clause opt_select_lock_type  */
#line 13289 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_lock)= (yyvsp[0].select_lock);
          }
#line 42043 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2167: /* opt_procedure_or_into: into opt_select_lock_type  */
#line 13293 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                                ER_WARN_DEPRECATED_SYNTAX,
                                ER_THD(thd, ER_WARN_DEPRECATED_SYNTAX),
                                "<select expression> INTO <destination>;",
                                "'SELECT <select list> INTO <destination>"
                                " FROM...'");
            (yyval.select_lock)= (yyvsp[0].select_lock);
          }
#line 42057 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2168: /* order_or_limit: order_clause opt_limit_clause  */
#line 13307 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.order_limit_lock)= new(thd->mem_root) Lex_order_limit_lock;
            if (!(yyval.order_limit_lock))
              YYABORT;
            (yyval.order_limit_lock)->order_list= (yyvsp[-1].select_order);
            (yyval.order_limit_lock)->limit= (yyvsp[0].select_limit);
          }
#line 42069 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2169: /* order_or_limit: limit_clause  */
#line 13315 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex_order_limit_lock *op= (yyval.order_limit_lock)= new(thd->mem_root) Lex_order_limit_lock;
            if (!(yyval.order_limit_lock))
              YYABORT;
            op->order_list= NULL;
            op->limit= (yyvsp[0].select_limit);
            (yyval.order_limit_lock)->order_list= NULL;
            (yyval.order_limit_lock)->limit= (yyvsp[0].select_limit);
          }
#line 42083 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2172: /* int_num: opt_plus NUM  */
#line 13333 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.num)= (int) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42089 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2173: /* int_num: '-' NUM  */
#line 13334 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.num)= -(int) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42095 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2174: /* ulong_num: opt_plus NUM  */
#line 13338 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42101 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2175: /* ulong_num: HEX_NUM  */
#line 13339 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.ulong_num)= (ulong) strtol((yyvsp[0].lex_str).str, (char**) 0, 16); }
#line 42107 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2176: /* ulong_num: opt_plus LONG_NUM  */
#line 13340 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42113 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2177: /* ulong_num: opt_plus ULONGLONG_NUM  */
#line 13341 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42119 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2178: /* ulong_num: opt_plus DECIMAL_NUM  */
#line 13342 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42125 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2179: /* ulong_num: opt_plus FLOAT_NUM  */
#line 13343 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42131 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2180: /* real_ulong_num: NUM  */
#line 13347 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42137 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2181: /* real_ulong_num: HEX_NUM  */
#line 13348 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.ulong_num)= (ulong) strtol((yyvsp[0].lex_str).str, (char**) 0, 16); }
#line 42143 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2182: /* real_ulong_num: LONG_NUM  */
#line 13349 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42149 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2183: /* real_ulong_num: ULONGLONG_NUM  */
#line 13350 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42155 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2184: /* real_ulong_num: dec_num_error  */
#line 13351 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { MYSQL_YYABORT; }
#line 42161 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2185: /* longlong_num: opt_plus NUM  */
#line 13355 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.longlong_number)= (longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42167 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2186: /* longlong_num: LONG_NUM  */
#line 13356 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.longlong_number)= (longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42173 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2187: /* longlong_num: '-' NUM  */
#line 13357 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { int error; (yyval.longlong_number)= -(longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42179 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2188: /* longlong_num: '-' LONG_NUM  */
#line 13358 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.longlong_number)= -(longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42185 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2189: /* ulonglong_num: opt_plus NUM  */
#line 13362 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42191 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2190: /* ulonglong_num: opt_plus ULONGLONG_NUM  */
#line 13363 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42197 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2191: /* ulonglong_num: opt_plus LONG_NUM  */
#line 13364 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42203 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2192: /* ulonglong_num: opt_plus DECIMAL_NUM  */
#line 13365 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42209 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2193: /* ulonglong_num: opt_plus FLOAT_NUM  */
#line 13366 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42215 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2194: /* real_ulonglong_num: NUM  */
#line 13370 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42221 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2195: /* real_ulonglong_num: ULONGLONG_NUM  */
#line 13371 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42227 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2196: /* real_ulonglong_num: HEX_NUM  */
#line 13372 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.ulonglong_number)= strtoull((yyvsp[0].lex_str).str, (char**) 0, 16); }
#line 42233 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2197: /* real_ulonglong_num: LONG_NUM  */
#line 13373 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42239 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2198: /* real_ulonglong_num: dec_num_error  */
#line 13374 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { MYSQL_YYABORT; }
#line 42245 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2199: /* dec_num_error: dec_num  */
#line 13379 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { thd->parse_error(ER_ONLY_INTEGERS_ALLOWED); }
#line 42251 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2202: /* choice: ulong_num  */
#line 13388 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.choice)= (yyvsp[0].ulong_num) != 0 ? HA_CHOICE_YES : HA_CHOICE_NO; }
#line 42257 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2203: /* choice: DEFAULT  */
#line 13389 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.choice)= HA_CHOICE_UNDEF; }
#line 42263 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2204: /* bool: ulong_num  */
#line 13393 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.ulong_num)= (yyvsp[0].ulong_num) != 0; }
#line 42269 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2205: /* bool: TRUE_SYM  */
#line 13394 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.ulong_num)= 1; }
#line 42275 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2206: /* bool: FALSE_SYM  */
#line 13395 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.ulong_num)= 0; }
#line 42281 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2207: /* $@196: %empty  */
#line 13400 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;

            lex->proc_list.elements=0;
            lex->proc_list.first=0;
            lex->proc_list.next= &lex->proc_list.first;
            Item_field *item= new (thd->mem_root)
                                Item_field(thd, &lex->current_select->context,
                                           NULL, NULL, &(yyvsp[0].ident_sys));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            if (unlikely(add_proc_to_list(thd, item)))
              MYSQL_YYABORT;
            Lex->uncacheable(UNCACHEABLE_SIDEEFFECT);

            /*
              PROCEDURE CLAUSE cannot handle subquery as one of its parameter,
              so disallow any subqueries further.
              Alow subqueries back once the parameters are reduced.
            */
            Lex->clause_that_disallows_subselect= "PROCEDURE";
            Select->options|= OPTION_PROCEDURE_CLAUSE;
          }
#line 42309 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2208: /* procedure_clause: PROCEDURE_SYM ident $@196 '(' procedure_list ')'  */
#line 13424 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* Subqueries are allowed from now.*/
            Lex->clause_that_disallows_subselect= NULL;
          }
#line 42318 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2209: /* procedure_list: %empty  */
#line 13431 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 42324 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2210: /* procedure_list: procedure_list2  */
#line 13432 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 42330 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2213: /* procedure_item: remember_name expr remember_end  */
#line 13442 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(add_proc_to_list(thd, (yyvsp[-1].item))))
              MYSQL_YYABORT;
            if (!(yyvsp[-1].item)->name.str || (yyvsp[-1].item)->name.str == item_empty_name)
              (yyvsp[-1].item)->set_name(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
          }
#line 42341 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2214: /* $@197: %empty  */
#line 13451 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (!lex->describe &&
                unlikely((!(lex->result= new (thd->mem_root)
                            select_dumpvar(thd)))))
              MYSQL_YYABORT;
          }
#line 42353 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2215: /* select_var_list_init: $@197 select_var_list  */
#line 13459 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 42359 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2217: /* select_var_list: select_var_ident  */
#line 13464 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           {}
#line 42365 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2218: /* select_var_ident: select_outvar  */
#line 13468 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->result)
            {
              if (unlikely((yyvsp[0].myvar) == NULL))
                MYSQL_YYABORT;
              ((select_dumpvar *)Lex->result)->var_list.push_back((yyvsp[0].myvar), thd->mem_root);
            }
            else
            {
              /*
                The parser won't create select_result instance only
                if it's an EXPLAIN.
              */
              DBUG_ASSERT(Lex->describe);
            }
          }
#line 42386 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2219: /* select_outvar: '@' ident_or_text  */
#line 13488 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.myvar) = Lex->result ? new (thd->mem_root) my_var_user(&(yyvsp[0].lex_str)) : NULL;
          }
#line 42394 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2220: /* select_outvar: ident_or_text  */
#line 13492 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.myvar)= Lex->create_outvar(thd, &(yyvsp[0].lex_str))) && Lex->result))
              MYSQL_YYABORT;
          }
#line 42403 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2221: /* select_outvar: ident '.' ident  */
#line 13497 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.myvar)= Lex->create_outvar(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys))) && Lex->result))
              MYSQL_YYABORT;
          }
#line 42412 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2222: /* into: INTO into_destination  */
#line 13505 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 42418 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2223: /* $@198: %empty  */
#line 13510 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
            if (unlikely(!(lex->exchange=
                         new (thd->mem_root) sql_exchange((yyvsp[0].lex_str).str, 0))) ||
                unlikely(!(lex->result=
                         new (thd->mem_root)
                         select_export(thd, lex->exchange))))
              MYSQL_YYABORT;
          }
#line 42433 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2224: /* $@199: %empty  */
#line 13521 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->exchange->cs= (yyvsp[0].charset); }
#line 42439 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2226: /* into_destination: DUMPFILE TEXT_STRING_filesystem  */
#line 13524 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (!lex->describe)
            {
              lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
              if (unlikely(!(lex->exchange=
                             new (thd->mem_root) sql_exchange((yyvsp[0].lex_str).str,1))))
                MYSQL_YYABORT;
              if (unlikely(!(lex->result=
                           new (thd->mem_root)
                           select_dump(thd, lex->exchange))))
                MYSQL_YYABORT;
            }
          }
#line 42458 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2227: /* into_destination: select_var_list_init  */
#line 13539 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
          }
#line 42466 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2228: /* $@200: %empty  */
#line 13550 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_DO;
            if (lex->main_select_push(true))
              MYSQL_YYABORT;
            mysql_init_select(lex);
          }
#line 42478 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2229: /* do: DO_SYM $@200 expr_list  */
#line 13558 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->insert_list= (yyvsp[0].item_list);
            Lex->pop_select(); //main select
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 42489 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2230: /* $@201: %empty  */
#line 13572 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->set_command(SQLCOM_DROP_TABLE, (yyvsp[-2].num), (yyvsp[0].object_ddl_options));
            YYPS->m_lock_type= TL_UNLOCK;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 42500 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2231: /* drop: DROP opt_temporary table_or_tables opt_if_exists $@201 table_list opt_lock_wait_timeout opt_restrict  */
#line 13579 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 42506 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2232: /* $@202: %empty  */
#line 13581 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 42515 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2233: /* drop: DROP INDEX_SYM $@202 opt_if_exists_table_element ident ON table_ident opt_lock_wait_timeout  */
#line 13586 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::KEY, (yyvsp[-3].ident_sys).str, (yyvsp[-4].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->sql_command= SQLCOM_DROP_INDEX;
            lex->alter_info.reset();
            lex->alter_info.flags= ALTER_DROP_INDEX;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            if (unlikely(!lex->current_select->
                         add_table_to_list(thd, (yyvsp[-1].table), NULL, TL_OPTION_UPDATING,
                                           TL_READ_NO_INSERT,
                                           MDL_SHARED_UPGRADABLE)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
          }
#line 42537 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2234: /* drop: DROP DATABASE opt_if_exists ident  */
#line 13604 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->set_command(SQLCOM_DROP_DB, (yyvsp[-1].object_ddl_options));
            lex->name= (yyvsp[0].ident_sys);
          }
#line 42547 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2235: /* drop: DROP PACKAGE_ORACLE_SYM opt_if_exists sp_name  */
#line 13610 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_PACKAGE, (yyvsp[-1].object_ddl_options));
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "PACKAGE"));
            lex->spname= (yyvsp[0].spname);
          }
#line 42559 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2236: /* drop: DROP PACKAGE_ORACLE_SYM BODY_ORACLE_SYM opt_if_exists sp_name  */
#line 13618 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_PACKAGE_BODY, (yyvsp[-1].object_ddl_options));
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "PACKAGE BODY"));
            lex->spname= (yyvsp[0].spname);
          }
#line 42571 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2237: /* drop: DROP FUNCTION_SYM opt_if_exists ident '.' ident  */
#line 13626 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            sp_name *spname;
            if (unlikely((yyvsp[-2].ident_sys).str && check_db_name((LEX_STRING*) &(yyvsp[-2].ident_sys))))
              my_yyabort_error((ER_WRONG_DB_NAME, MYF(0), (yyvsp[-2].ident_sys).str));
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "FUNCTION"));
            lex->set_command(SQLCOM_DROP_FUNCTION, (yyvsp[-3].object_ddl_options));
            spname= new (thd->mem_root) sp_name(&(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys), true);
            if (unlikely(spname == NULL))
              MYSQL_YYABORT;
            lex->spname= spname;
          }
#line 42589 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2238: /* drop: DROP FUNCTION_SYM opt_if_exists ident  */
#line 13640 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            LEX_CSTRING db= {0, 0};
            sp_name *spname;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "FUNCTION"));
            if (thd->db.str && unlikely(lex->copy_db_to(&db)))
              MYSQL_YYABORT;
            lex->set_command(SQLCOM_DROP_FUNCTION, (yyvsp[-1].object_ddl_options));
            spname= new (thd->mem_root) sp_name(&db, &(yyvsp[0].ident_sys), false);
            if (unlikely(spname == NULL))
              MYSQL_YYABORT;
            lex->spname= spname;
          }
#line 42608 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2239: /* drop: DROP PROCEDURE_SYM opt_if_exists sp_name  */
#line 13655 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "PROCEDURE"));
            lex->set_command(SQLCOM_DROP_PROCEDURE, (yyvsp[-1].object_ddl_options));
            lex->spname= (yyvsp[0].spname);
          }
#line 42620 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2240: /* drop: DROP USER_SYM opt_if_exists clear_privileges user_list  */
#line 13663 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->set_command(SQLCOM_DROP_USER, (yyvsp[-2].object_ddl_options));
          }
#line 42628 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2241: /* drop: DROP ROLE_SYM opt_if_exists clear_privileges role_list  */
#line 13667 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->set_command(SQLCOM_DROP_ROLE, (yyvsp[-2].object_ddl_options));
          }
#line 42636 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2242: /* $@203: %empty  */
#line 13671 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_VIEW, (yyvsp[0].object_ddl_options));
            YYPS->m_lock_type= TL_UNLOCK;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 42647 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2243: /* drop: DROP VIEW_SYM opt_if_exists $@203 table_list opt_restrict  */
#line 13678 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 42653 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2244: /* drop: DROP EVENT_SYM opt_if_exists sp_name  */
#line 13680 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->spname= (yyvsp[0].spname);
            Lex->set_command(SQLCOM_DROP_EVENT, (yyvsp[-1].object_ddl_options));
          }
#line 42662 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2245: /* drop: DROP TRIGGER_SYM opt_if_exists sp_name  */
#line 13685 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_TRIGGER, (yyvsp[-1].object_ddl_options));
            lex->spname= (yyvsp[0].spname);
          }
#line 42672 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2246: /* drop: DROP TABLESPACE tablespace_name opt_ts_engine opt_ts_wait  */
#line 13691 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= DROP_TABLESPACE;
          }
#line 42681 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2247: /* drop: DROP LOGFILE_SYM GROUP_SYM logfile_group_name opt_ts_engine opt_ts_wait  */
#line 13696 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= DROP_LOGFILE_GROUP;
          }
#line 42690 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2248: /* drop: DROP SERVER_SYM opt_if_exists ident_or_text  */
#line 13701 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->set_command(SQLCOM_DROP_SERVER, (yyvsp[-1].object_ddl_options));
            Lex->server_options.reset((yyvsp[0].lex_str));
          }
#line 42699 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2249: /* $@204: %empty  */
#line 13707 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_SEQUENCE, (yyvsp[-2].num), (yyvsp[0].object_ddl_options));
            lex->table_type= TABLE_TYPE_SEQUENCE;
            YYPS->m_lock_type= TL_UNLOCK;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 42711 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2250: /* drop: DROP opt_temporary SEQUENCE_SYM opt_if_exists $@204 table_list  */
#line 13715 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 42717 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2253: /* table_name: table_ident  */
#line 13725 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!thd->lex->current_select_or_default()->
                                           add_table_to_list(thd, (yyvsp[0].table), NULL,
                                           TL_OPTION_UPDATING,
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type))
              MYSQL_YYABORT;
          }
#line 42730 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2254: /* table_name_with_opt_use_partition: table_ident opt_use_partition  */
#line 13737 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-1].table), NULL,
                                                    TL_OPTION_UPDATING,
                                                    YYPS->m_lock_type,
                                                    YYPS->m_mdl_type,
                                                    NULL,
                                                    (yyvsp[0].string_list))))
              MYSQL_YYABORT;
          }
#line 42744 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2257: /* table_alias_ref: table_ident_opt_wild  */
#line 13755 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->
                         add_table_to_list(thd, (yyvsp[0].table), NULL,
                                           (TL_OPTION_UPDATING |
                                            TL_OPTION_ALIAS),
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type)))
              MYSQL_YYABORT;
          }
#line 42758 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2258: /* opt_if_exists_table_element: %empty  */
#line 13768 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->check_exists= FALSE;
          (yyval.num)= 0;
        }
#line 42767 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2259: /* opt_if_exists_table_element: IF_SYM EXISTS  */
#line 13773 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->check_exists= TRUE;
          (yyval.num)= 1;
        }
#line 42776 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2260: /* opt_if_exists: %empty  */
#line 13781 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.object_ddl_options).set(DDL_options_st::OPT_NONE);
        }
#line 42784 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2261: /* opt_if_exists: IF_SYM EXISTS  */
#line 13785 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.object_ddl_options).set(DDL_options_st::OPT_IF_EXISTS);
        }
#line 42792 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2262: /* opt_temporary: %empty  */
#line 13791 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0; }
#line 42798 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2263: /* opt_temporary: TEMPORARY  */
#line 13792 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.num)= HA_LEX_CREATE_TMP_TABLE; }
#line 42804 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2264: /* $@205: %empty  */
#line 13800 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_INSERT;
            lex->duplicates= DUP_ERROR;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->current_select->parsing_place= BEFORE_OPT_LIST;
          }
#line 42818 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2265: /* $@206: %empty  */
#line 13811 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->set_lock_for_tables((yyvsp[-2].lock_type), true);
            Lex->current_select= Lex->first_select_lex();
          }
#line 42827 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2266: /* insert: INSERT $@205 insert_lock_option opt_ignore insert2 $@206 insert_field_spec opt_insert_update  */
#line 13816 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
            Lex->mark_first_table_as_inserting();
          }
#line 42838 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2267: /* $@207: %empty  */
#line 13826 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_REPLACE;
            lex->duplicates= DUP_REPLACE;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->current_select->parsing_place= BEFORE_OPT_LIST;
          }
#line 42852 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2268: /* $@208: %empty  */
#line 13836 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->set_lock_for_tables((yyvsp[-1].lock_type), true);
            Lex->current_select= Lex->first_select_lex();
          }
#line 42861 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2269: /* replace: REPLACE $@207 replace_lock_option insert2 $@208 insert_field_spec  */
#line 13841 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
            Lex->mark_first_table_as_inserting();
          }
#line 42872 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2270: /* insert_lock_option: %empty  */
#line 13851 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              If it is SP we do not allow insert optimisation when result of
              insert visible only after the table unlocking but everyone can
              read table.
            */
            (yyval.lock_type)= (Lex->sphead ? TL_WRITE_DEFAULT : TL_WRITE_CONCURRENT_INSERT);
          }
#line 42885 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2271: /* insert_lock_option: LOW_PRIORITY  */
#line 13859 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.lock_type)= TL_WRITE_LOW_PRIORITY; }
#line 42891 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2272: /* insert_lock_option: DELAYED_SYM  */
#line 13861 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
         // QQ: why was +1?
          Lex->keyword_delayed_begin_offset= (uint)((yyvsp[0].kwd).pos() - thd->query());
          Lex->keyword_delayed_end_offset= (uint)((yyvsp[0].kwd).end() - thd->query());
          (yyval.lock_type)= TL_WRITE_DELAYED;
        }
#line 42902 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2273: /* insert_lock_option: HIGH_PRIORITY  */
#line 13867 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.lock_type)= TL_WRITE; }
#line 42908 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2274: /* replace_lock_option: opt_low_priority  */
#line 13871 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.lock_type)= (yyvsp[0].lock_type); }
#line 42914 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2275: /* replace_lock_option: DELAYED_SYM  */
#line 13873 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->keyword_delayed_begin_offset= (uint)((yyvsp[0].kwd).pos() - thd->query());
          Lex->keyword_delayed_end_offset= (uint)((yyvsp[0].kwd).end() - thd->query());
          (yyval.lock_type)= TL_WRITE_DELAYED;
        }
#line 42924 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2276: /* insert2: INTO insert_table  */
#line 13881 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            {}
#line 42930 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2277: /* insert2: insert_table  */
#line 13882 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 42936 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2278: /* $@209: %empty  */
#line 13886 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->save_parsing_place= Select->parsing_place;
          }
#line 42944 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2279: /* insert_table: $@209 table_name_with_opt_use_partition  */
#line 13890 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            //lex->field_list.empty();
            lex->many_values.empty();
            lex->insert_list=0;
          }
#line 42955 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2280: /* insert_field_spec: insert_values  */
#line 13899 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        {}
#line 42961 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2281: /* insert_field_spec: insert_field_list insert_values  */
#line 13900 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          {}
#line 42967 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2282: /* $@210: %empty  */
#line 13902 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(!(lex->insert_list= new (thd->mem_root) List_item)) ||
                unlikely(lex->many_values.push_back(lex->insert_list,
                         thd->mem_root)))
              MYSQL_YYABORT;
            lex->current_select->parsing_place= NO_MATTER;
          }
#line 42980 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2284: /* insert_field_list: LEFT_PAREN_ALT opt_fields ')'  */
#line 13915 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->current_select->parsing_place= AFTER_LIST;
          }
#line 42988 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2287: /* fields: fields ',' insert_ident  */
#line 13927 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 42994 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2288: /* fields: insert_ident  */
#line 13928 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 43000 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2289: /* insert_values: create_select_query_expression  */
#line 13934 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                        {}
#line 43006 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2294: /* ident_eq_value: simple_ident_nospvar equal expr_or_ignore_or_default  */
#line 13949 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->field_list.push_back((yyvsp[-2].item), thd->mem_root)) ||
                unlikely(lex->insert_list->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43017 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2295: /* equal: '='  */
#line 13958 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              {}
#line 43023 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2296: /* equal: SET_VAR  */
#line 13959 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 43029 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2297: /* opt_equal: %empty  */
#line 13963 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 43035 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2298: /* opt_equal: equal  */
#line 13964 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                {}
#line 43041 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2299: /* opt_with: opt_equal  */
#line 13968 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 43047 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2300: /* opt_with: WITH  */
#line 13969 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               {}
#line 43053 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2301: /* opt_by: opt_equal  */
#line 13973 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 43059 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2302: /* opt_by: BY  */
#line 13974 "/home/buildbot/git/sql/sql_yacc_ora.yy"
             {}
#line 43065 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2303: /* $@211: %empty  */
#line 13979 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!(Lex->insert_list= new (thd->mem_root) List_item)))
              MYSQL_YYABORT;
          }
#line 43074 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2304: /* no_braces: '(' $@211 opt_values ')'  */
#line 13984 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->many_values.push_back(lex->insert_list,
                                                    thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43085 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2305: /* $@212: %empty  */
#line 13994 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!(Lex->insert_list= new (thd->mem_root) List_item)))
              MYSQL_YYABORT;
          }
#line 43094 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2306: /* no_braces_with_names: '(' $@212 opt_values_with_names ')'  */
#line 13999 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->many_values.push_back(lex->insert_list,
                                                    thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43105 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2307: /* opt_values: %empty  */
#line 14008 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 43111 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2309: /* opt_values_with_names: %empty  */
#line 14013 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 43117 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2311: /* values: values ',' expr_or_ignore_or_default  */
#line 14019 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43126 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2312: /* values: expr_or_ignore_or_default  */
#line 14024 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43135 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2313: /* values_with_names: values_with_names ',' remember_name expr_or_ignore_or_default remember_end  */
#line 14032 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[-1].item), thd->mem_root)))
               MYSQL_YYABORT;
            // give some name in case of using in table value constuctor (TVC)
            if (!(yyvsp[-1].item)->name.str || (yyvsp[-1].item)->name.str == item_empty_name)
              (yyvsp[-1].item)->set_name(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
           }
#line 43147 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2314: /* values_with_names: remember_name expr_or_ignore_or_default remember_end  */
#line 14040 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[-1].item), thd->mem_root)))
               MYSQL_YYABORT;
            // give some name in case of using in table value constuctor (TVC)
            if (!(yyvsp[-1].item)->name.str || (yyvsp[-1].item)->name.str == item_empty_name)
              (yyvsp[-1].item)->set_name(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
          }
#line 43159 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2315: /* expr_or_ignore: expr  */
#line 14050 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               { (yyval.item)= (yyvsp[0].item);}
#line 43165 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2316: /* expr_or_ignore: IGNORE_SYM  */
#line 14052 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_ignore_specification(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 43175 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2317: /* expr_or_ignore_or_default: expr_or_ignore  */
#line 14060 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.item)= (yyvsp[0].item);}
#line 43181 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2318: /* expr_or_ignore_or_default: DEFAULT  */
#line 14062 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_default_specification(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 43191 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2320: /* $@213: %empty  */
#line 14071 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { Lex->duplicates= DUP_UPDATE; }
#line 43197 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2321: /* $@214: %empty  */
#line 14073 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    Select->parsing_place= IN_UPDATE_ON_DUP_KEY;
          }
#line 43205 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2322: /* opt_insert_update: ON DUPLICATE_SYM $@213 KEY_SYM UPDATE_SYM $@214 insert_update_list  */
#line 14077 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    Select->parsing_place= NO_MATTER;
          }
#line 43213 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2323: /* update_table_list: table_ident opt_use_partition for_portion_of_time_clause opt_table_alias_clause opt_key_definition  */
#line 14085 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->table_join_options= 0;
            if (!((yyval.table_list)= Select->add_table_to_list(thd, (yyvsp[-4].table), (yyvsp[-1].lex_str_ptr),
                                                Select->get_table_join_options(),
                                                YYPS->m_lock_type,
                                                YYPS->m_mdl_type,
                                                Select->pop_index_hints(),
                                                (yyvsp[-3].string_list))))
              MYSQL_YYABORT;
            (yyval.table_list)->period_conditions= Lex->period_conditions;
          }
#line 43230 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2324: /* update_table_list: join_table_list  */
#line 14097 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.table_list)= (yyvsp[0].table_list); }
#line 43236 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2325: /* $@215: %empty  */
#line 14104 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->sql_command= SQLCOM_UPDATE;
            lex->duplicates= DUP_ERROR; 
          }
#line 43249 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2326: /* $@216: %empty  */
#line 14114 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *slex= Lex->first_select_lex();
            if (slex->table_list.elements > 1)
              Lex->sql_command= SQLCOM_UPDATE_MULTI;
            else if (slex->get_table_list()->derived)
            {
              /* it is single table update and it is update of derived table */
              my_error(ER_NON_UPDATABLE_TABLE, MYF(0),
                       slex->get_table_list()->alias.str, "UPDATE");
              MYSQL_YYABORT;
            }
            /*
              In case of multi-update setting write lock for all tables may
              be too pessimistic. We will decrease lock level if possible in
              mysql_multi_update().
            */
            slex->set_lock_for_tables((yyvsp[-4].lock_type), slex->table_list.elements == 1);
          }
#line 43272 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2327: /* update: UPDATE_SYM $@215 opt_low_priority opt_ignore update_table_list SET update_list $@216 opt_where_clause opt_order_clause delete_limit_clause  */
#line 14133 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[-1].select_order))
              Select->order_list= *((yyvsp[-1].select_order));
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43284 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2330: /* update_elem: simple_ident_nospvar equal DEFAULT  */
#line 14149 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *def= new (thd->mem_root) Item_default_value(thd,
                                             Lex->current_context(), (yyvsp[-2].item), 1);
            if (!def || add_item_to_list(thd, (yyvsp[-2].item)) || add_value_to_list(thd, def))
              MYSQL_YYABORT;
          }
#line 43295 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2331: /* update_elem: simple_ident_nospvar equal expr_or_ignore  */
#line 14156 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (add_item_to_list(thd, (yyvsp[-2].item)) || add_value_to_list(thd, (yyvsp[0].item)))
              MYSQL_YYABORT;
          }
#line 43304 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2334: /* insert_update_elem: simple_ident_nospvar equal expr_or_ignore_or_default  */
#line 14169 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
          LEX *lex= Lex;
          if (unlikely(lex->update_list.push_back((yyvsp[-2].item), thd->mem_root)) ||
              unlikely(lex->value_list.push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43315 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2335: /* opt_low_priority: %empty  */
#line 14178 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lock_type)= TL_WRITE_DEFAULT; }
#line 43321 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2336: /* opt_low_priority: LOW_PRIORITY  */
#line 14179 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.lock_type)= TL_WRITE_LOW_PRIORITY; }
#line 43327 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2337: /* $@217: %empty  */
#line 14186 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_DELETE;
            YYPS->m_lock_type= TL_WRITE_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_WRITE;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->ignore= 0;
            lex->first_select_lex()->order_list.empty();
          }
#line 43343 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2338: /* delete: DELETE_SYM $@217 delete_part2  */
#line 14198 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 43352 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2339: /* opt_delete_system_time: %empty  */
#line 14206 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_ALL);
          }
#line 43360 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2340: /* opt_delete_system_time: BEFORE_SYM SYSTEM_TIME_SYM history_point  */
#line 14210 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_BEFORE, (yyvsp[0].vers_history_point));
          }
#line 43368 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2341: /* delete_part2: opt_delete_options single_multi  */
#line 14216 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          {}
#line 43374 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2342: /* delete_part2: HISTORY_SYM delete_single_table opt_delete_system_time  */
#line 14218 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_table()->vers_conditions= Lex->vers_conditions;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43385 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2343: /* delete_single_table: FROM table_ident opt_use_partition  */
#line 14228 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->
                         add_table_to_list(thd, (yyvsp[-1].table), NULL, TL_OPTION_UPDATING,
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type,
                                           NULL,
                                           (yyvsp[0].string_list))))
              MYSQL_YYABORT;
            YYPS->m_lock_type= TL_READ_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_READ;
          }
#line 43401 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2344: /* delete_single_table_for_period: delete_single_table opt_for_portion_of_time_clause  */
#line 14243 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
          if ((yyvsp[0].num))
            Lex->last_table()->period_conditions= Lex->period_conditions;
          }
#line 43410 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2345: /* single_multi: delete_single_table_for_period opt_where_clause opt_order_clause delete_limit_clause opt_select_expressions  */
#line 14255 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[-2].select_order))
              Select->order_list= *((yyvsp[-2].select_order));
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43422 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2346: /* $@218: %empty  */
#line 14263 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            mysql_init_multi_delete(Lex);
            YYPS->m_lock_type= TL_READ_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_READ;
          }
#line 43432 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2347: /* single_multi: table_wild_list $@218 FROM join_table_list opt_where_clause  */
#line 14269 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(multi_delete_set_locks_and_link_aux_tables(Lex)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43444 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2348: /* $@219: %empty  */
#line 14277 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            mysql_init_multi_delete(Lex);
            YYPS->m_lock_type= TL_READ_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_READ;
          }
#line 43454 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2349: /* single_multi: FROM table_alias_ref_list $@219 USING join_table_list opt_where_clause  */
#line 14283 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(multi_delete_set_locks_and_link_aux_tables(Lex)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43466 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2354: /* table_wild_one: ident opt_wild  */
#line 14304 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Table_ident *ti= new (thd->mem_root) Table_ident(&(yyvsp[-1].ident_sys));
            if (unlikely(ti == NULL))
              MYSQL_YYABORT;
            if (unlikely(!Select->
                         add_table_to_list(thd,
                                           ti,
                                           NULL,
                                           (TL_OPTION_UPDATING |
                                            TL_OPTION_ALIAS),
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type)))
              MYSQL_YYABORT;
          }
#line 43485 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2355: /* table_wild_one: ident '.' ident opt_wild  */
#line 14319 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Table_ident *ti= new (thd->mem_root) Table_ident(thd, &(yyvsp[-3].ident_sys), &(yyvsp[-1].ident_sys), 0);
            if (unlikely(ti == NULL))
              MYSQL_YYABORT;
            if (unlikely(!Select->
                         add_table_to_list(thd,
                                           ti,
                                           NULL,
                                           (TL_OPTION_UPDATING |
                                            TL_OPTION_ALIAS),
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type)))
              MYSQL_YYABORT;
          }
#line 43504 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2356: /* opt_wild: %empty  */
#line 14336 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 43510 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2357: /* opt_wild: '.' '*'  */
#line 14337 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 43516 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2358: /* opt_delete_options: %empty  */
#line 14341 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 43522 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2359: /* opt_delete_options: opt_delete_option opt_delete_options  */
#line 14342 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                               {}
#line 43528 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2360: /* opt_delete_option: QUICK  */
#line 14346 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Select->options|= OPTION_QUICK; }
#line 43534 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2361: /* opt_delete_option: LOW_PRIORITY  */
#line 14347 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { YYPS->m_lock_type= TL_WRITE_LOW_PRIORITY; }
#line 43540 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2362: /* opt_delete_option: IGNORE_SYM  */
#line 14348 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->ignore= 1; }
#line 43546 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2363: /* $@220: %empty  */
#line 14353 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX* lex= Lex;
            lex->sql_command= SQLCOM_TRUNCATE;
            lex->alter_info.reset();
            lex->first_select_lex()->options= 0;
            lex->sql_cache= LEX::SQL_CACHE_UNSPECIFIED;
            lex->first_select_lex()->order_list.empty();
            YYPS->m_lock_type= TL_WRITE;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 43561 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2364: /* $@221: %empty  */
#line 14364 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_truncate_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 43573 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2365: /* truncate: TRUNCATE_SYM $@220 opt_table_sym table_name opt_lock_wait_timeout $@221 opt_truncate_table_storage_clause  */
#line 14371 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                            { }
#line 43579 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2375: /* profile_def: CPU_SYM  */
#line 14395 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_CPU;
    }
#line 43587 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2376: /* profile_def: MEMORY_SYM  */
#line 14399 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_MEMORY;
    }
#line 43595 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2377: /* profile_def: BLOCK_SYM IO_SYM  */
#line 14403 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_BLOCK_IO;
    }
#line 43603 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2378: /* profile_def: CONTEXT_SYM SWITCHES_SYM  */
#line 14407 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_CONTEXT;
    }
#line 43611 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2379: /* profile_def: PAGE_SYM FAULTS_SYM  */
#line 14411 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_PAGE_FAULTS;
    }
#line 43619 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2380: /* profile_def: IPC_SYM  */
#line 14415 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_IPC;
    }
#line 43627 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2381: /* profile_def: SWAPS_SYM  */
#line 14419 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_SWAPS;
    }
#line 43635 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2382: /* profile_def: SOURCE_SYM  */
#line 14423 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_SOURCE;
    }
#line 43643 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2383: /* profile_def: ALL  */
#line 14427 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_ALL;
    }
#line 43651 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2384: /* opt_profile_args: %empty  */
#line 14434 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_query_id= 0;
    }
#line 43659 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2385: /* opt_profile_args: FOR_SYM QUERY_SYM NUM  */
#line 14438 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_query_id= atoi((yyvsp[0].lex_str).str);
    }
#line 43667 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2386: /* $@222: %empty  */
#line 14447 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->wild=0;
            lex->ident= null_clex_str;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->current_select->parsing_place= SELECT_LIST;
            lex->create_info.init();
          }
#line 43682 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2387: /* show: SHOW $@222 show_param  */
#line 14458 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->parsing_place= NO_MATTER;
            Lex->pop_select(); //main select
          }
#line 43691 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2388: /* show_param: DATABASES wild_and_where  */
#line 14466 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_DATABASES;
             if (unlikely(prepare_schema_table(thd, lex, 0, SCH_SCHEMATA)))
               MYSQL_YYABORT;
           }
#line 43702 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2389: /* show_param: opt_full TABLES opt_db wild_and_where  */
#line 14473 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_TABLES;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_TABLE_NAMES))
               MYSQL_YYABORT;
           }
#line 43714 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2390: /* show_param: opt_full TRIGGERS_SYM opt_db wild_and_where  */
#line 14481 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_TRIGGERS;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_TRIGGERS))
               MYSQL_YYABORT;
           }
#line 43726 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2391: /* show_param: EVENTS_SYM opt_db wild_and_where  */
#line 14489 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_EVENTS;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_EVENTS))
               MYSQL_YYABORT;
           }
#line 43738 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2392: /* show_param: TABLE_SYM STATUS_SYM opt_db wild_and_where  */
#line 14497 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_TABLE_STATUS;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_TABLES))
               MYSQL_YYABORT;
           }
#line 43750 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2393: /* show_param: OPEN_SYM TABLES opt_db wild_and_where  */
#line 14505 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_OPEN_TABLES;
            lex->first_select_lex()->db= (yyvsp[-1].lex_str);
            if (prepare_schema_table(thd, lex, 0, SCH_OPEN_TABLES))
              MYSQL_YYABORT;
          }
#line 43762 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2394: /* show_param: PLUGINS_SYM  */
#line 14513 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_PLUGINS;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PLUGINS)))
              MYSQL_YYABORT;
          }
#line 43773 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2395: /* show_param: PLUGINS_SYM SONAME_SYM TEXT_STRING_sys  */
#line 14520 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->ident= (yyvsp[0].lex_str);
            Lex->sql_command= SQLCOM_SHOW_PLUGINS;
            if (unlikely(prepare_schema_table(thd, Lex, 0, SCH_ALL_PLUGINS)))
              MYSQL_YYABORT;
          }
#line 43784 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2396: /* show_param: PLUGINS_SYM SONAME_SYM wild_and_where  */
#line 14527 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_PLUGINS;
            if (unlikely(prepare_schema_table(thd, Lex, 0, SCH_ALL_PLUGINS)))
              MYSQL_YYABORT;
          }
#line 43794 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2397: /* show_param: ENGINE_SYM known_storage_engines show_engine_param  */
#line 14533 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->create_info.db_type= (yyvsp[-1].db_type); }
#line 43800 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2398: /* show_param: ENGINE_SYM ALL show_engine_param  */
#line 14535 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->create_info.db_type= NULL; }
#line 43806 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2399: /* show_param: opt_full COLUMNS from_or_in table_ident opt_db wild_and_where  */
#line 14537 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_FIELDS;
            if ((yyvsp[-1].lex_str).str)
              (yyvsp[-2].table)->change_db(&(yyvsp[-1].lex_str));
            if (unlikely(prepare_schema_table(thd, lex, (yyvsp[-2].table), SCH_COLUMNS)))
              MYSQL_YYABORT;
          }
#line 43819 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2400: /* show_param: master_or_binary LOGS_SYM  */
#line 14546 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_BINLOGS;
          }
#line 43827 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2401: /* show_param: SLAVE HOSTS_SYM  */
#line 14550 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_SLAVE_HOSTS;
          }
#line 43835 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2402: /* $@223: %empty  */
#line 14554 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_BINLOG_EVENTS;
          }
#line 43844 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2404: /* $@224: %empty  */
#line 14560 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_RELAYLOG_EVENTS;
          }
#line 43853 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2406: /* show_param: keys_or_index from_or_in table_ident opt_db opt_where_clause  */
#line 14566 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_KEYS;
            if ((yyvsp[-1].lex_str).str)
              (yyvsp[-2].table)->change_db(&(yyvsp[-1].lex_str));
            if (unlikely(prepare_schema_table(thd, lex, (yyvsp[-2].table), SCH_STATISTICS)))
              MYSQL_YYABORT;
          }
#line 43866 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2407: /* show_param: opt_storage ENGINES_SYM  */
#line 14575 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_STORAGE_ENGINES;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_ENGINES)))
              MYSQL_YYABORT;
          }
#line 43877 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2408: /* show_param: AUTHORS_SYM  */
#line 14582 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_AUTHORS;
          }
#line 43886 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2409: /* show_param: CONTRIBUTORS_SYM  */
#line 14587 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_CONTRIBUTORS;
          }
#line 43895 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2410: /* show_param: PRIVILEGES  */
#line 14592 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_PRIVILEGES;
          }
#line 43904 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2411: /* show_param: COUNT_SYM '(' '*' ')' WARNINGS  */
#line 14597 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX_CSTRING var= {STRING_WITH_LEN("warning_count")};
            (void) create_select_for_variable(thd, &var);
          }
#line 43913 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2412: /* show_param: COUNT_SYM '(' '*' ')' ERRORS  */
#line 14602 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX_CSTRING var= {STRING_WITH_LEN("error_count")};
            (void) create_select_for_variable(thd, &var);
          }
#line 43922 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2413: /* show_param: WARNINGS opt_global_limit_clause  */
#line 14607 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command = SQLCOM_SHOW_WARNS;}
#line 43928 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2414: /* show_param: ERRORS opt_global_limit_clause  */
#line 14609 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command = SQLCOM_SHOW_ERRORS;}
#line 43934 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2415: /* show_param: PROFILES_SYM  */
#line 14611 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command = SQLCOM_SHOW_PROFILES; }
#line 43940 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2416: /* show_param: PROFILE_SYM opt_profile_defs opt_profile_args opt_global_limit_clause  */
#line 14613 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_PROFILE;
            if (unlikely(prepare_schema_table(thd, lex, NULL, SCH_PROFILES)))
              MYSQL_YYABORT;
          }
#line 43951 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2417: /* show_param: opt_var_type STATUS_SYM wild_and_where  */
#line 14620 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS;
            lex->option_type= (yyvsp[-2].var_type);
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_SESSION_STATUS)))
              MYSQL_YYABORT;
          }
#line 43963 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2418: /* show_param: opt_full PROCESSLIST_SYM  */
#line 14628 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command= SQLCOM_SHOW_PROCESSLIST;}
#line 43969 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2419: /* show_param: opt_var_type VARIABLES wild_and_where  */
#line 14630 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_VARIABLES;
            lex->option_type= (yyvsp[-2].var_type);
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_SESSION_VARIABLES)))
              MYSQL_YYABORT;
          }
#line 43981 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2420: /* show_param: charset wild_and_where  */
#line 14638 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_CHARSETS;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_CHARSETS)))
              MYSQL_YYABORT;
          }
#line 43992 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2421: /* show_param: COLLATION_SYM wild_and_where  */
#line 14645 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_COLLATIONS;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_COLLATIONS)))
              MYSQL_YYABORT;
          }
#line 44003 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2422: /* show_param: GRANTS  */
#line 14652 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_GRANTS;
            if (unlikely(!(Lex->grant_user=
                          (LEX_USER*)thd->alloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            Lex->grant_user->user= current_user_and_current_role;
          }
#line 44015 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2423: /* show_param: GRANTS FOR_SYM user_or_role clear_privileges  */
#line 14660 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_GRANTS;
            lex->grant_user=(yyvsp[-1].lex_user);
          }
#line 44025 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2424: /* show_param: CREATE DATABASE opt_if_not_exists ident  */
#line 14666 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->set_command(SQLCOM_SHOW_CREATE_DB, (yyvsp[-1].object_ddl_options));
            Lex->name= (yyvsp[0].ident_sys);
          }
#line 44034 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2425: /* show_param: CREATE TABLE_SYM table_ident  */
#line 14671 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE;
            if (!lex->first_select_lex()->add_table_to_list(thd, (yyvsp[0].table), NULL,0))
              MYSQL_YYABORT;
            lex->create_info.storage_media= HA_SM_DEFAULT;
          }
#line 44046 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2426: /* show_param: CREATE VIEW_SYM table_ident  */
#line 14679 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE;
            if (!lex->first_select_lex()->add_table_to_list(thd, (yyvsp[0].table), NULL, 0))
              MYSQL_YYABORT;
            lex->table_type= TABLE_TYPE_VIEW;
          }
#line 44058 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2427: /* show_param: CREATE SEQUENCE_SYM table_ident  */
#line 14687 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE;
            if (!lex->first_select_lex()->add_table_to_list(thd, (yyvsp[0].table), NULL, 0))
              MYSQL_YYABORT;
            lex->table_type= TABLE_TYPE_SEQUENCE;
          }
#line 44070 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2428: /* show_param: MASTER_SYM STATUS_SYM  */
#line 14695 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_MASTER_STAT;
          }
#line 44078 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2429: /* show_param: ALL SLAVES STATUS_SYM  */
#line 14699 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_SLAVE_STAT;
            Lex->verbose= 1;
          }
#line 44087 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2430: /* show_param: SLAVE STATUS_SYM  */
#line 14704 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->mi.connection_name= null_clex_str;
            lex->sql_command = SQLCOM_SHOW_SLAVE_STAT;
            lex->verbose= 0;
          }
#line 44098 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2431: /* show_param: SLAVE connection_name STATUS_SYM  */
#line 14711 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_SLAVE_STAT;
            Lex->verbose= 0;
          }
#line 44107 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2432: /* show_param: CREATE PROCEDURE_SYM sp_name  */
#line 14716 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            lex->sql_command = SQLCOM_SHOW_CREATE_PROC;
            lex->spname= (yyvsp[0].spname);
          }
#line 44118 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2433: /* show_param: CREATE FUNCTION_SYM sp_name  */
#line 14723 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            lex->sql_command = SQLCOM_SHOW_CREATE_FUNC;
            lex->spname= (yyvsp[0].spname);
          }
#line 44129 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2434: /* show_param: CREATE PACKAGE_ORACLE_SYM sp_name  */
#line 14730 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE_PACKAGE;
            lex->spname= (yyvsp[0].spname);
          }
#line 44139 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2435: /* show_param: CREATE PACKAGE_ORACLE_SYM BODY_ORACLE_SYM sp_name  */
#line 14736 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE_PACKAGE_BODY;
            lex->spname= (yyvsp[0].spname);
          }
#line 44149 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2436: /* show_param: CREATE TRIGGER_SYM sp_name  */
#line 14742 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_CREATE_TRIGGER;
            lex->spname= (yyvsp[0].spname);
          }
#line 44159 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2437: /* show_param: CREATE USER_SYM  */
#line 14748 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_CREATE_USER;
            if (unlikely(!(Lex->grant_user=
                          (LEX_USER*)thd->alloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            Lex->grant_user->user= current_user;
          }
#line 44171 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2438: /* show_param: CREATE USER_SYM user  */
#line 14756 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             Lex->sql_command= SQLCOM_SHOW_CREATE_USER;
             Lex->grant_user= (yyvsp[0].lex_user);
          }
#line 44180 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2439: /* show_param: PROCEDURE_SYM STATUS_SYM wild_and_where  */
#line 14761 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_PROC;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44191 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2440: /* show_param: FUNCTION_SYM STATUS_SYM wild_and_where  */
#line 14768 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_FUNC;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44202 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2441: /* show_param: PACKAGE_ORACLE_SYM STATUS_SYM wild_and_where  */
#line 14775 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_PACKAGE;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44213 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2442: /* show_param: PACKAGE_ORACLE_SYM BODY_ORACLE_SYM STATUS_SYM wild_and_where  */
#line 14782 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_PACKAGE_BODY;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44224 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2443: /* show_param: PROCEDURE_SYM CODE_SYM sp_name  */
#line 14789 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_PROC_CODE;
            Lex->spname= (yyvsp[0].spname);
          }
#line 44233 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2444: /* show_param: FUNCTION_SYM CODE_SYM sp_name  */
#line 14794 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_FUNC_CODE;
            Lex->spname= (yyvsp[0].spname);
          }
#line 44242 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2445: /* show_param: PACKAGE_ORACLE_SYM BODY_ORACLE_SYM CODE_SYM sp_name  */
#line 14799 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_PACKAGE_BODY_CODE;
            Lex->spname= (yyvsp[0].spname);
          }
#line 44251 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2446: /* show_param: CREATE EVENT_SYM sp_name  */
#line 14804 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->spname= (yyvsp[0].spname);
            Lex->sql_command = SQLCOM_SHOW_CREATE_EVENT;
          }
#line 44260 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2447: /* show_param: describe_command FOR_SYM expr  */
#line 14809 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_EXPLAIN;
            if (unlikely(prepare_schema_table(thd, Lex, 0, SCH_EXPLAIN)))
              MYSQL_YYABORT;
            add_value_to_list(thd, (yyvsp[0].item));
          }
#line 44271 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2448: /* show_param: IDENT_sys remember_tok_start wild_and_where  */
#line 14816 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             LEX *lex= Lex;
             bool in_plugin;
             lex->sql_command= SQLCOM_SHOW_GENERIC;
             ST_SCHEMA_TABLE *table= find_schema_table(thd, &(yyvsp[-2].ident_sys), &in_plugin);
             if (unlikely(!table || !table->old_format || !in_plugin))
             {
               thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-1].simple_string));
               MYSQL_YYABORT;
             }
             if (unlikely(lex->wild && table->idx_field1 < 0))
             {
               thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[0].simple_string));
               MYSQL_YYABORT;
             }
             if (unlikely(make_schema_select(thd, Lex->current_select, table)))
               MYSQL_YYABORT;
           }
#line 44294 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2449: /* show_engine_param: STATUS_SYM  */
#line 14838 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command= SQLCOM_SHOW_ENGINE_STATUS; }
#line 44300 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2450: /* show_engine_param: MUTEX_SYM  */
#line 14840 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command= SQLCOM_SHOW_ENGINE_MUTEX; }
#line 44306 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2451: /* show_engine_param: LOGS_SYM  */
#line 14842 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command= SQLCOM_SHOW_ENGINE_LOGS; }
#line 44312 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2456: /* opt_db: %empty  */
#line 14856 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.lex_str)= null_clex_str; }
#line 44318 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2457: /* opt_db: from_or_in ident  */
#line 14857 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 44324 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2458: /* opt_full: %empty  */
#line 14861 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->verbose=0; }
#line 44330 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2459: /* opt_full: FULL  */
#line 14862 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->verbose=1; }
#line 44336 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2462: /* binlog_in: %empty  */
#line 14871 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { Lex->mi.log_file_name = 0; }
#line 44342 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2463: /* binlog_in: IN_SYM TEXT_STRING_sys  */
#line 14872 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { Lex->mi.log_file_name = (yyvsp[0].lex_str).str; }
#line 44348 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2464: /* binlog_from: %empty  */
#line 14876 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { Lex->mi.pos = 4; /* skip magic number */ }
#line 44354 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2465: /* binlog_from: FROM ulonglong_num  */
#line 14877 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { Lex->mi.pos = (yyvsp[0].ulonglong_number); }
#line 44360 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2466: /* wild_and_where: %empty  */
#line 14881 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.simple_string)= 0; }
#line 44366 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2467: /* wild_and_where: LIKE remember_tok_start TEXT_STRING_sys  */
#line 14883 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->wild= new (thd->mem_root) String((yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length,
                                                    system_charset_info);
            if (unlikely(Lex->wild == NULL))
              MYSQL_YYABORT;
            (yyval.simple_string)= (yyvsp[-1].simple_string);
          }
#line 44378 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2468: /* wild_and_where: WHERE remember_tok_start expr  */
#line 14891 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->where= normalize_cond(thd, (yyvsp[0].item));
            if ((yyvsp[0].item))
              (yyvsp[0].item)->top_level_item();
            (yyval.simple_string)= (yyvsp[-1].simple_string);
          }
#line 44389 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2469: /* $@225: %empty  */
#line 14902 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->current_select->parsing_place= SELECT_LIST;
            lex->sql_command= SQLCOM_SHOW_FIELDS;
            lex->first_select_lex()->db= null_clex_str;
            lex->verbose= 0;
            if (unlikely(prepare_schema_table(thd, lex, (yyvsp[0].table), SCH_COLUMNS)))
              MYSQL_YYABORT;
          }
#line 44406 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2470: /* describe: describe_command table_ident $@225 opt_describe_column  */
#line 14915 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->parsing_place= NO_MATTER;
            Lex->pop_select(); //main select
          }
#line 44415 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2471: /* $@226: %empty  */
#line 14920 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->describe|= DESCRIBE_NORMAL; }
#line 44421 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2472: /* describe: describe_command opt_extended_describe $@226 explainable_command  */
#line 14922 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->first_select_lex()->options|= SELECT_DESCRIBE;
          }
#line 44430 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2481: /* analyze_stmt_command: ANALYZE_SYM opt_format_json explainable_command  */
#line 14944 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->analyze_stmt= true;
          }
#line 44438 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2482: /* opt_extended_describe: EXTENDED_SYM  */
#line 14950 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { Lex->describe|= DESCRIBE_EXTENDED; }
#line 44444 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2483: /* opt_extended_describe: EXTENDED_SYM ALL  */
#line 14952 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->describe|= DESCRIBE_EXTENDED | DESCRIBE_EXTENDED2; }
#line 44450 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2484: /* opt_extended_describe: PARTITIONS_SYM  */
#line 14953 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { Lex->describe|= DESCRIBE_PARTITIONS; }
#line 44456 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2485: /* opt_extended_describe: opt_format_json  */
#line 14954 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 44462 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2486: /* opt_format_json: %empty  */
#line 14958 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 44468 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2487: /* opt_format_json: FORMAT_SYM '=' ident_or_text  */
#line 14960 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("JSON")))
              Lex->explain_json= true;
            else if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("TRADITIONAL")))
              DBUG_ASSERT(Lex->explain_json==false);
            else
              my_yyabort_error((ER_UNKNOWN_EXPLAIN_FORMAT, MYF(0), "EXPLAIN",
                               (yyvsp[0].lex_str).str));
          }
#line 44482 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2488: /* opt_describe_column: %empty  */
#line 14972 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 44488 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2489: /* opt_describe_column: text_string  */
#line 14973 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->wild= (yyvsp[0].string); }
#line 44494 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2490: /* opt_describe_column: ident  */
#line 14975 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->wild= new (thd->mem_root) String((const char*) (yyvsp[0].ident_sys).str,
                                                    (yyvsp[0].ident_sys).length,
                                                    system_charset_info);
            if (unlikely(Lex->wild == NULL))
              MYSQL_YYABORT;
          }
#line 44506 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2491: /* $@227: %empty  */
#line 14989 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_FLUSH;
            lex->type= 0;
            lex->no_write_to_binlog= (yyvsp[0].num);
          }
#line 44517 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2492: /* flush: FLUSH_SYM opt_no_write_to_binlog $@227 flush_options  */
#line 14995 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        {}
#line 44523 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2493: /* $@228: %empty  */
#line 15000 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->type|= REFRESH_TABLES;
            /*
              Set type of metadata and table locks for
              FLUSH TABLES table_list [WITH READ LOCK].
            */
            YYPS->m_lock_type= TL_READ_NO_INSERT;
            YYPS->m_mdl_type= MDL_SHARED_HIGH_PRIO;
          }
#line 44537 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2494: /* flush_options: table_or_tables $@228 opt_table_list opt_flush_lock  */
#line 15010 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 44543 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2495: /* flush_options: flush_options_list  */
#line 15012 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 44549 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2496: /* opt_flush_lock: %empty  */
#line 15016 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 44555 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2497: /* opt_flush_lock: flush_lock  */
#line 15018 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          TABLE_LIST *tables= Lex->query_tables;
          for (; tables; tables= tables->next_global)
          {
            tables->mdl_request.set_type(MDL_SHARED_NO_WRITE);
            /* Don't try to flush views. */
            tables->required_type= TABLE_TYPE_NORMAL;
            /* Ignore temporary tables. */
            tables->open_type= OT_BASE_ONLY;
          }
        }
#line 44571 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2498: /* flush_lock: WITH READ_SYM LOCK_SYM optional_flush_tables_arguments  */
#line 15033 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_READ_LOCK | (yyvsp[0].num); }
#line 44577 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2499: /* $@229: %empty  */
#line 15035 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->query_tables == NULL))
            {
              // Table list can't be empty
              thd->parse_error(ER_NO_TABLES_USED);
              MYSQL_YYABORT;
            } 
            Lex->type|= REFRESH_FOR_EXPORT;
          }
#line 44591 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2500: /* flush_lock: FOR_SYM $@229 EXPORT_SYM  */
#line 15043 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 44597 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2502: /* flush_options_list: flush_option  */
#line 15049 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 44603 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2503: /* flush_option: ERROR_SYM LOGS_SYM  */
#line 15054 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_ERROR_LOG; }
#line 44609 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2504: /* flush_option: ENGINE_SYM LOGS_SYM  */
#line 15056 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_ENGINE_LOG; }
#line 44615 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2505: /* flush_option: GENERAL LOGS_SYM  */
#line 15058 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_GENERAL_LOG; }
#line 44621 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2506: /* flush_option: SLOW LOGS_SYM  */
#line 15060 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_SLOW_LOG; }
#line 44627 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2507: /* flush_option: BINARY LOGS_SYM opt_delete_gtid_domain  */
#line 15062 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_BINARY_LOG; }
#line 44633 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2508: /* flush_option: RELAY LOGS_SYM optional_connection_name  */
#line 15064 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->type & REFRESH_RELAY_LOG))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "FLUSH", "RELAY LOGS"));
            lex->type|= REFRESH_RELAY_LOG;
            lex->relay_log_connection_name= lex->mi.connection_name;
           }
#line 44645 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2509: /* flush_option: QUERY_SYM CACHE_SYM  */
#line 15072 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_QUERY_CACHE_FREE; }
#line 44651 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2510: /* flush_option: HOSTS_SYM  */
#line 15074 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_HOSTS; }
#line 44657 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2511: /* flush_option: PRIVILEGES  */
#line 15076 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_GRANT; }
#line 44663 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2512: /* flush_option: LOGS_SYM  */
#line 15078 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->type|= REFRESH_LOG;
            Lex->relay_log_connection_name= empty_clex_str;
          }
#line 44672 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2513: /* flush_option: STATUS_SYM  */
#line 15083 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_STATUS; }
#line 44678 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2514: /* flush_option: SLAVE optional_connection_name  */
#line 15085 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            LEX *lex= Lex;
            if (unlikely(lex->type & REFRESH_SLAVE))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "FLUSH","SLAVE"));
            lex->type|= REFRESH_SLAVE;
            lex->reset_slave_info.all= false;
          }
#line 44690 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2515: /* flush_option: MASTER_SYM  */
#line 15093 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_MASTER; }
#line 44696 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2516: /* flush_option: DES_KEY_FILE  */
#line 15095 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_DES_KEY_FILE; }
#line 44702 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2517: /* flush_option: RESOURCES  */
#line 15097 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_USER_RESOURCES; }
#line 44708 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2518: /* flush_option: SSL_SYM  */
#line 15099 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_SSL;}
#line 44714 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2519: /* flush_option: IDENT_sys remember_tok_start  */
#line 15101 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             Lex->type|= REFRESH_GENERIC;
             ST_SCHEMA_TABLE *table= find_schema_table(thd, &(yyvsp[-1].ident_sys));
             if (unlikely(!table || !table->reset_table))
             {
               thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[0].simple_string));
               MYSQL_YYABORT;
             }
             if (unlikely(Lex->view_list.push_back((LEX_CSTRING*)
                                                   thd->memdup(&(yyvsp[-1].ident_sys), sizeof(LEX_CSTRING)),
                                                   thd->mem_root)))
               MYSQL_YYABORT;
           }
#line 44732 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2520: /* opt_table_list: %empty  */
#line 15117 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 44738 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2521: /* opt_table_list: table_list  */
#line 15118 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     {}
#line 44744 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2522: /* backup: BACKUP_SYM backup_statements  */
#line 15122 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                     {}
#line 44750 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2523: /* backup_statements: STAGE_SYM ident  */
#line 15127 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          int type;
          if (unlikely(Lex->sphead))
            my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "BACKUP STAGE"));
          if ((type= find_type((yyvsp[0].ident_sys).str, &backup_stage_names,
                               FIND_TYPE_NO_PREFIX)) <= 0)
            my_yyabort_error((ER_BACKUP_UNKNOWN_STAGE, MYF(0), (yyvsp[0].ident_sys).str));
          Lex->sql_command= SQLCOM_BACKUP;
          Lex->backup_stage= (backup_stages) (type-1);
          break;
        }
#line 44766 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2524: /* $@230: %empty  */
#line 15139 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 44775 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2525: /* backup_statements: LOCK_SYM $@230 table_ident  */
#line 15144 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    if (unlikely(!Select->add_table_to_list(thd, (yyvsp[0].table), NULL, 0,
                                                    TL_READ, MDL_SHARED_HIGH_PRIO)))
             MYSQL_YYABORT;
            Lex->sql_command= SQLCOM_BACKUP_LOCK;
            Lex->pop_select(); //main select
          }
#line 44787 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2526: /* backup_statements: UNLOCK_SYM  */
#line 15152 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    /* Table list is empty for unlock */
            Lex->sql_command= SQLCOM_BACKUP_LOCK;
          }
#line 44796 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2527: /* opt_delete_gtid_domain: %empty  */
#line 15159 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 44802 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2528: /* opt_delete_gtid_domain: DELETE_DOMAIN_ID_SYM '=' '(' delete_domain_id_list ')'  */
#line 15161 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 44808 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2532: /* delete_domain_id: ulonglong_num  */
#line 15171 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            uint32 value= (uint32) (yyvsp[0].ulonglong_number);
            if ((yyvsp[0].ulonglong_number) > UINT_MAX32)
            {
              my_printf_error(ER_BINLOG_CANT_DELETE_GTID_DOMAIN,
                              "The value of gtid domain being deleted ('%llu') "
                              "exceeds its maximum size "
                              "of 32 bit unsigned integer", MYF(0), (yyvsp[0].ulonglong_number));
              MYSQL_YYABORT;
            }
            insert_dynamic(&Lex->delete_gtid_domain, (uchar*) &value);
          }
#line 44825 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2533: /* optional_flush_tables_arguments: %empty  */
#line 15186 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             {(yyval.num)= 0;}
#line 44831 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2534: /* optional_flush_tables_arguments: AND_SYM DISABLE_SYM CHECKPOINT_SYM  */
#line 15187 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                             {(yyval.num)= REFRESH_CHECKPOINT; }
#line 44837 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2535: /* $@231: %empty  */
#line 15192 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_RESET; lex->type=0;
          }
#line 44846 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2536: /* reset: RESET_SYM $@231 reset_options  */
#line 15197 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 44852 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2539: /* $@232: %empty  */
#line 15206 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->type|= REFRESH_SLAVE; }
#line 44858 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2540: /* reset_option: SLAVE $@232 optional_connection_name slave_reset_options  */
#line 15208 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { }
#line 44864 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2541: /* $@233: %empty  */
#line 15210 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             Lex->type|= REFRESH_MASTER;
             Lex->next_binlog_file_number= 0;
          }
#line 44873 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2543: /* reset_option: QUERY_SYM CACHE_SYM  */
#line 15215 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->type|= REFRESH_QUERY_CACHE;}
#line 44879 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2544: /* slave_reset_options: %empty  */
#line 15219 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->reset_slave_info.all= false; }
#line 44885 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2545: /* slave_reset_options: ALL  */
#line 15220 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->reset_slave_info.all= true; }
#line 44891 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2546: /* master_reset_options: %empty  */
#line 15224 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 44897 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2547: /* master_reset_options: TO_SYM ulong_num  */
#line 15226 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->next_binlog_file_number = (yyvsp[0].ulong_num);
          }
#line 44905 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2548: /* purge: PURGE master_or_binary LOGS_SYM TO_SYM TEXT_STRING_sys  */
#line 15233 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->stmt_purge_to((yyvsp[0].lex_str));
          }
#line 44913 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2549: /* $@234: %empty  */
#line 15237 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->clause_that_disallows_subselect= "PURGE..BEFORE"; }
#line 44919 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2550: /* purge: PURGE master_or_binary LOGS_SYM BEFORE_SYM $@234 expr  */
#line 15239 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->clause_that_disallows_subselect= NULL;
            if (Lex->stmt_purge_before((yyvsp[0].item)))
              MYSQL_YYABORT;
          }
#line 44929 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2551: /* $@235: %empty  */
#line 15251 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->value_list.empty();
            lex->users_list.empty();
            lex->sql_command= SQLCOM_KILL;
            lex->kill_type= KILL_TYPE_ID;
          }
#line 44941 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2552: /* kill: KILL_SYM $@235 kill_type kill_option  */
#line 15259 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->kill_signal= (killed_state) ((yyvsp[-1].num) | (yyvsp[0].num));
          }
#line 44949 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2553: /* kill_type: %empty  */
#line 15265 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.num)= (int) KILL_HARD_BIT; }
#line 44955 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2554: /* kill_type: HARD_SYM  */
#line 15266 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.num)= (int) KILL_HARD_BIT; }
#line 44961 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2555: /* kill_type: SOFT_SYM  */
#line 15267 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.num)= 0; }
#line 44967 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2556: /* kill_option: opt_connection kill_expr  */
#line 15271 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.num)= (int) KILL_CONNECTION; }
#line 44973 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2557: /* kill_option: QUERY_SYM kill_expr  */
#line 15272 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.num)= (int) KILL_QUERY; }
#line 44979 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2558: /* kill_option: QUERY_SYM ID_SYM expr  */
#line 15274 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= (int) KILL_QUERY;
            Lex->kill_type= KILL_TYPE_QUERY;
            Lex->value_list.push_front((yyvsp[0].item), thd->mem_root);
          }
#line 44989 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2559: /* opt_connection: %empty  */
#line 15282 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { }
#line 44995 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2560: /* opt_connection: CONNECTION_SYM  */
#line 15283 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { }
#line 45001 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2561: /* kill_expr: expr  */
#line 15288 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->value_list.push_front((yyval.item), thd->mem_root);
         }
#line 45009 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2562: /* kill_expr: USER_SYM user  */
#line 15292 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root);
            Lex->kill_type= KILL_TYPE_USER;
          }
#line 45018 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2563: /* $@236: %empty  */
#line 15299 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { Lex->sql_command= SQLCOM_SHUTDOWN; }
#line 45024 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2564: /* shutdown: SHUTDOWN $@236 shutdown_option  */
#line 15300 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        {}
#line 45030 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2565: /* shutdown_option: %empty  */
#line 15304 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->is_shutdown_wait_for_slaves= false; }
#line 45036 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2566: /* shutdown_option: WAIT_SYM FOR_SYM ALL SLAVES  */
#line 15306 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->is_shutdown_wait_for_slaves= true;
        }
#line 45044 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2567: /* use: USE_SYM ident  */
#line 15314 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_CHANGE_DB;
            lex->first_select_lex()->db= (yyvsp[0].ident_sys);
          }
#line 45054 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2568: /* $@237: %empty  */
#line 15325 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;

            if (unlikely(lex->sphead))
            {
              my_error(ER_SP_BADSTATEMENT, MYF(0), 
                       (yyvsp[0].filetype) == FILETYPE_CSV ? "LOAD DATA" : "LOAD XML");
              MYSQL_YYABORT;
            }
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
          }
#line 45072 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2569: /* $@238: %empty  */
#line 15339 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_LOAD;
            lex->local_file=  (yyvsp[-2].num);
            lex->duplicates= DUP_ERROR;
            lex->ignore= 0;
            if (unlikely(!(lex->exchange= new (thd->mem_root)
                         sql_exchange((yyvsp[0].lex_str).str, 0, (yyvsp[-5].filetype)))))
              MYSQL_YYABORT;
          }
#line 45087 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2570: /* $@239: %empty  */
#line 15350 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-1].table), NULL,
                                                   TL_OPTION_UPDATING,
                                                   (yyvsp[-9].lock_type), MDL_SHARED_WRITE,
                                                   NULL, (yyvsp[0].string_list))))
              MYSQL_YYABORT;
            lex->field_list.empty();
            lex->update_list.empty();
            lex->value_list.empty();
            lex->many_values.empty();
          }
#line 45104 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2571: /* $@240: %empty  */
#line 15363 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->exchange->cs= (yyvsp[0].charset); }
#line 45110 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2572: /* load: LOAD data_or_xml $@237 load_data_lock opt_local INFILE TEXT_STRING_filesystem $@238 opt_duplicate INTO TABLE_SYM table_ident opt_use_partition $@239 opt_load_data_charset $@240 opt_xml_rows_identified_by opt_field_term opt_line_term opt_ignore_lines opt_field_or_var_spec opt_load_data_set_spec  */
#line 15367 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
            Lex->mark_first_table_as_inserting();
          }
#line 45121 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2573: /* data_or_xml: DATA_SYM  */
#line 15376 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.filetype)= FILETYPE_CSV; }
#line 45127 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2574: /* data_or_xml: XML_SYM  */
#line 15377 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.filetype)= FILETYPE_XML; }
#line 45133 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2575: /* opt_local: %empty  */
#line 15381 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)=0;}
#line 45139 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2576: /* opt_local: LOCAL_SYM  */
#line 15382 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.num)=1;}
#line 45145 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2577: /* load_data_lock: %empty  */
#line 15386 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lock_type)= TL_WRITE_DEFAULT; }
#line 45151 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2578: /* load_data_lock: CONCURRENT  */
#line 15388 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Ignore this option in SP to avoid problem with query cache and
              triggers with non default priority locks
            */
            (yyval.lock_type)= (Lex->sphead ? TL_WRITE_DEFAULT : TL_WRITE_CONCURRENT_INSERT);
          }
#line 45163 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2579: /* load_data_lock: LOW_PRIORITY  */
#line 15395 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.lock_type)= TL_WRITE_LOW_PRIORITY; }
#line 45169 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2580: /* opt_duplicate: %empty  */
#line 15399 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->duplicates=DUP_ERROR; }
#line 45175 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2581: /* opt_duplicate: REPLACE  */
#line 15400 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { Lex->duplicates=DUP_REPLACE; }
#line 45181 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2582: /* opt_duplicate: IGNORE_SYM  */
#line 15401 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { Lex->ignore= 1; }
#line 45187 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2587: /* field_term: TERMINATED BY text_string  */
#line 15416 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->field_term= (yyvsp[0].string);
          }
#line 45196 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2588: /* field_term: OPTIONALLY ENCLOSED BY text_string  */
#line 15421 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            DBUG_ASSERT(lex->exchange != 0);
            lex->exchange->enclosed= (yyvsp[0].string);
            lex->exchange->opt_enclosed= 1;
          }
#line 45207 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2589: /* field_term: ENCLOSED BY text_string  */
#line 15428 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->enclosed= (yyvsp[0].string);
          }
#line 45216 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2590: /* field_term: ESCAPED BY text_string  */
#line 15433 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->escaped= (yyvsp[0].string);
          }
#line 45225 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2595: /* line_term: TERMINATED BY text_string  */
#line 15451 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->line_term= (yyvsp[0].string);
          }
#line 45234 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2596: /* line_term: STARTING BY text_string  */
#line 15456 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->line_start= (yyvsp[0].string);
          }
#line 45243 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2597: /* opt_xml_rows_identified_by: %empty  */
#line 15463 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { }
#line 45249 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2598: /* opt_xml_rows_identified_by: ROWS_SYM IDENTIFIED_SYM BY text_string  */
#line 15465 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->exchange->line_term = (yyvsp[0].string); }
#line 45255 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2600: /* opt_ignore_lines: IGNORE_SYM NUM lines_or_rows  */
#line 15471 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->skip_lines= atol((yyvsp[-1].lex_str).str);
          }
#line 45264 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2601: /* lines_or_rows: LINES  */
#line 15478 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                { }
#line 45270 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2602: /* lines_or_rows: ROWS_SYM  */
#line 15479 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { }
#line 45276 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2603: /* opt_field_or_var_spec: %empty  */
#line 15483 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 45282 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2604: /* opt_field_or_var_spec: '(' fields_or_vars ')'  */
#line 15484 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 {}
#line 45288 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2605: /* opt_field_or_var_spec: '(' ')'  */
#line 15485 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 45294 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2606: /* fields_or_vars: fields_or_vars ',' field_or_var  */
#line 15490 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 45300 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2607: /* fields_or_vars: field_or_var  */
#line 15492 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 45306 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2608: /* field_or_var: simple_ident_nospvar  */
#line 15496 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               {(yyval.item)= (yyvsp[0].item);}
#line 45312 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2609: /* field_or_var: '@' ident_or_text  */
#line 15498 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_user_var_as_out_param(thd, &(yyvsp[0].lex_str));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45322 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2610: /* opt_load_data_set_spec: %empty  */
#line 15506 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 45328 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2611: /* opt_load_data_set_spec: SET load_data_set_list  */
#line 15507 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 {}
#line 45334 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2614: /* load_data_set_elem: simple_ident_nospvar equal remember_name expr_or_ignore_or_default remember_end  */
#line 15517 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->update_list.push_back((yyvsp[-4].item), thd->mem_root)) ||
                unlikely(lex->value_list.push_back((yyvsp[-1].item), thd->mem_root)))
                MYSQL_YYABORT;
            (yyvsp[-1].item)->set_name_no_truncate(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
          }
#line 45346 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2615: /* text_literal: TEXT_STRING  */
#line 15530 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= thd->make_string_literal((yyvsp[0].lex_string_with_metadata)))))
              MYSQL_YYABORT;
          }
#line 45355 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2616: /* text_literal: NCHAR_STRING  */
#line 15535 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= thd->make_string_literal_nchar((yyvsp[0].lex_string_with_metadata)))))
              MYSQL_YYABORT;
          }
#line 45364 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2617: /* text_literal: UNDERSCORE_CHARSET TEXT_STRING  */
#line 15540 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= thd->make_string_literal_charset((yyvsp[0].lex_string_with_metadata), (yyvsp[-1].charset)))))
              MYSQL_YYABORT;
          }
#line 45373 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2618: /* text_literal: text_literal TEXT_STRING_literal  */
#line 15545 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= (yyvsp[-1].item_basic_constant)->make_string_literal_concat(thd, &(yyvsp[0].lex_str)))))
              MYSQL_YYABORT;
          }
#line 45382 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2619: /* text_string: TEXT_STRING_literal  */
#line 15553 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.string)= new (thd->mem_root) String((yyvsp[0].lex_str).str,
                                             (yyvsp[0].lex_str).length,
                                             thd->variables.collation_connection);
            if (unlikely((yyval.string) == NULL))
              MYSQL_YYABORT;
          }
#line 45394 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2620: /* text_string: hex_or_bin_String  */
#line 15560 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.string)= (yyvsp[0].string); }
#line 45400 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2621: /* hex_or_bin_String: HEX_NUM  */
#line 15566 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *tmp= new (thd->mem_root) Item_hex_hybrid(thd, (yyvsp[0].lex_str).str,
                                                           (yyvsp[0].lex_str).length);
            if (unlikely(tmp == NULL))
              MYSQL_YYABORT;
            (yyval.string)= tmp->val_str((String*) 0);
          }
#line 45412 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2622: /* hex_or_bin_String: HEX_STRING  */
#line 15574 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *tmp= new (thd->mem_root) Item_hex_string(thd, (yyvsp[0].lex_str).str,
                                                           (yyvsp[0].lex_str).length);
            if (unlikely(tmp == NULL))
              MYSQL_YYABORT;
            (yyval.string)= tmp->val_str((String*) 0);
          }
#line 45424 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2623: /* hex_or_bin_String: BIN_NUM  */
#line 15582 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *tmp= new (thd->mem_root) Item_bin_string(thd, (yyvsp[0].lex_str).str,
                                                           (yyvsp[0].lex_str).length);
            if (unlikely(tmp == NULL))
              MYSQL_YYABORT;
            /*
              it is OK only emulate fix_fields, because we need only
              value of constant
            */
            (yyval.string)= tmp->val_str((String*) 0);
          }
#line 45440 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2624: /* param_marker: PARAM_MARKER  */
#line 15597 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_param)= Lex->add_placeholder(thd, &param_clex_str,
                                                    YYLIP->get_tok_start(),
                                                    YYLIP->get_tok_start() + 1))))
              MYSQL_YYABORT;
          }
#line 45451 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2625: /* param_marker: COLON_ORACLE_SYM ident_cli  */
#line 15604 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_param)= Lex->add_placeholder(thd, &null_clex_str,
                                                    (yyvsp[-1].kwd).pos(), (yyvsp[0].ident_cli).end()))))
              MYSQL_YYABORT;
          }
#line 45461 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2626: /* param_marker: COLON_ORACLE_SYM NUM  */
#line 15610 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_param)= Lex->add_placeholder(thd, &null_clex_str,
                                                    (yyvsp[-1].kwd).pos(),
                                                    YYLIP->get_ptr()))))
              MYSQL_YYABORT;
          }
#line 45472 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2627: /* signed_literal: '+' NUM_literal  */
#line 15619 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.item) = (yyvsp[0].item_num); }
#line 45478 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2628: /* signed_literal: '-' NUM_literal  */
#line 15621 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[0].item_num)->max_length++;
            (yyval.item)= (yyvsp[0].item_num)->neg(thd);
          }
#line 45487 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2629: /* literal: text_literal  */
#line 15628 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.item) = (yyvsp[0].item_basic_constant); }
#line 45493 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2630: /* literal: NUM_literal  */
#line 15629 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.item) = (yyvsp[0].item_num); }
#line 45499 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2631: /* literal: temporal_literal  */
#line 15630 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.item)= (yyvsp[0].item); }
#line 45505 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2632: /* literal: NULL_SYM  */
#line 15632 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              For the digest computation, in this context only,
              NULL is considered a literal, hence reduced to '?'
              REDUCE:
                TOK_GENERIC_VALUE := NULL_SYM
            */
            YYLIP->reduce_digest_token(TOK_GENERIC_VALUE, NULL_SYM);
            (yyval.item)= new (thd->mem_root) Item_null(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            YYLIP->next_state= MY_LEX_OPERATOR_OR_IDENT;
          }
#line 45523 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2633: /* literal: FALSE_SYM  */
#line 15646 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_bool(thd, (char*) "FALSE",0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45533 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2634: /* literal: TRUE_SYM  */
#line 15652 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_bool(thd, (char*) "TRUE",1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45543 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2635: /* literal: HEX_NUM  */
#line 15658 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_hex_hybrid(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45553 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2636: /* literal: HEX_STRING  */
#line 15664 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_hex_string(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45563 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2637: /* literal: BIN_NUM  */
#line 15670 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_bin_string(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45573 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2638: /* literal: UNDERSCORE_CHARSET hex_or_bin_String  */
#line 15676 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item_string_with_introducer *item_str;
            /*
              Pass NULL as name. Name will be set in the "select_item" rule and
              will include the introducer and the original hex/bin notation.
            */
            item_str= new (thd->mem_root)
               Item_string_with_introducer(thd, NULL, (yyvsp[0].string)->ptr(), (yyvsp[0].string)->length(),
                                           (yyvsp[-1].charset));
            if (unlikely(!item_str ||
                         !item_str->check_well_formed_result(true)))
              MYSQL_YYABORT;

            (yyval.item)= item_str;
          }
#line 45593 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2639: /* NUM_literal: NUM  */
#line 15695 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            int error;
            (yyval.item_num)= new (thd->mem_root)
                  Item_int(thd, (yyvsp[0].lex_str).str,
                           (longlong) my_strtoll10((yyvsp[0].lex_str).str, NULL, &error),
                           (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL))
              MYSQL_YYABORT;
          }
#line 45607 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2640: /* NUM_literal: LONG_NUM  */
#line 15705 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            int error;
            (yyval.item_num)= new (thd->mem_root)
                  Item_int(thd, (yyvsp[0].lex_str).str,
                           (longlong) my_strtoll10((yyvsp[0].lex_str).str, NULL, &error),
                           (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL))
              MYSQL_YYABORT;
          }
#line 45621 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2641: /* NUM_literal: ULONGLONG_NUM  */
#line 15715 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_num)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL))
              MYSQL_YYABORT;
          }
#line 45631 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2642: /* NUM_literal: DECIMAL_NUM  */
#line 15721 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_num)= new (thd->mem_root) Item_decimal(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length,
                                                   thd->charset());
            if (unlikely((yyval.item_num) == NULL) || unlikely(thd->is_error()))
              MYSQL_YYABORT;
          }
#line 45642 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2643: /* NUM_literal: FLOAT_NUM  */
#line 15728 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_num)= new (thd->mem_root) Item_float(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL) || unlikely(thd->is_error()))
              MYSQL_YYABORT;
          }
#line 45652 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2644: /* temporal_literal: DATE_SYM TEXT_STRING  */
#line 15738 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= type_handler_newdate.create_literal_item(thd,
                                                           (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                           YYCSCL, true))))
              MYSQL_YYABORT;
          }
#line 45663 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2645: /* temporal_literal: TIME_SYM TEXT_STRING  */
#line 15745 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= type_handler_time2.create_literal_item(thd,
                                                         (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                         YYCSCL, true))))
              MYSQL_YYABORT;
          }
#line 45674 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2646: /* temporal_literal: TIMESTAMP TEXT_STRING  */
#line 15752 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= type_handler_datetime2.create_literal_item(thd,
                                                             (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                             YYCSCL, true))))
              MYSQL_YYABORT;
          }
#line 45685 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2647: /* $@241: %empty  */
#line 15762 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             LEX *lex= Lex;
             With_clause *with_clause=
             new With_clause((yyvsp[0].num), Lex->curr_with_clause);
             if (unlikely(with_clause == NULL))
               MYSQL_YYABORT;
             lex->derived_tables|= DERIVED_WITH;
             lex->with_cte_resolution= true;
             lex->curr_with_clause= with_clause;
             with_clause->add_to_list(&lex->with_clauses_list,
                                      lex->with_clauses_list_last_next);
             if (lex->current_select &&
                 lex->current_select->parsing_place == BEFORE_OPT_LIST)
               lex->current_select->parsing_place= NO_MATTER;
          }
#line 45705 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2648: /* with_clause: WITH opt_recursive $@241 with_list  */
#line 15778 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.with_clause)= Lex->curr_with_clause;
            Lex->curr_with_clause= Lex->curr_with_clause->pop();
          }
#line 45714 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2649: /* opt_recursive: %empty  */
#line 15786 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.num)= 0; }
#line 45720 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2650: /* opt_recursive: RECURSIVE_SYM  */
#line 15787 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.num)= 1; }
#line 45726 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2653: /* $@242: %empty  */
#line 15800 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[0].lex_str_list)= new List<LEX_CSTRING> (Lex->with_column_list);
            if (unlikely((yyvsp[0].lex_str_list) == NULL))
              MYSQL_YYABORT;
            Lex->with_column_list.empty();
          }
#line 45737 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2654: /* with_list_element: with_element_head opt_with_column_list $@242 AS '(' query_expression ')'  */
#line 15807 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            const char *query_start= lex->sphead ? lex->sphead->m_tmp_query
                                                 : thd->query();
            const char *spec_start= (yyvsp[-2].kwd).pos() + 1;
            With_element *elem= new With_element((yyvsp[-6].with_element_head), *(yyvsp[-5].lex_str_list), (yyvsp[-1].select_lex_unit));
	    if (elem == NULL || Lex->curr_with_clause->add_with_element(elem))
	      MYSQL_YYABORT;
            if (elem->set_unparsed_spec(thd, spec_start, (yyvsp[0].kwd).pos(),
                                        spec_start - query_start))
              MYSQL_YYABORT;
            elem->set_tables_end_pos(lex->query_tables_last);
	  }
#line 45755 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2655: /* opt_with_column_list: %empty  */
#line 15825 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.lex_str_list)= NULL; }
#line 45761 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2656: /* opt_with_column_list: '(' with_column_list ')'  */
#line 15827 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.lex_str_list)= NULL; }
#line 45767 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2657: /* with_column_list: ident  */
#line 15833 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->with_column_list.push_back((LEX_CSTRING*)
                    thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)));
	  }
#line 45776 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2658: /* with_column_list: with_column_list ',' ident  */
#line 15838 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->with_column_list.push_back((LEX_CSTRING*)
                    thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)));
          }
#line 45785 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2659: /* with_element_head: ident  */
#line 15847 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX_CSTRING *name=
              (LEX_CSTRING *) thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING));
            (yyval.with_element_head)= new (thd->mem_root) With_element_head(name);
            if (unlikely(name == NULL || (yyval.with_element_head) == NULL))
              MYSQL_YYABORT;
            (yyval.with_element_head)->tables_pos.set_start_pos(Lex->query_tables_last);
          }
#line 45798 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2660: /* insert_ident: simple_ident_nospvar  */
#line 15864 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.item)=(yyvsp[0].item); }
#line 45804 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2661: /* insert_ident: table_wild  */
#line 15865 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.item)=(yyvsp[0].item); }
#line 45810 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2662: /* table_wild: ident '.' '*'  */
#line 15870 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-2].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 45819 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2663: /* table_wild: ident '.' ident '.' '*'  */
#line 15875 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 45828 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2664: /* select_sublist_qualified_asterisk: ident_cli '.' '*'  */
#line 15883 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-2].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 45837 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2665: /* select_sublist_qualified_asterisk: ident_cli '.' ident_cli '.' '*'  */
#line 15888 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-4].ident_cli), &(yyvsp[-2].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 45846 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2666: /* order_ident: expr  */
#line 15895 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               { (yyval.item)=(yyvsp[0].item); }
#line 45852 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2667: /* simple_ident: ident_cli  */
#line 15901 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 45861 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2668: /* simple_ident: ident_cli '.' ident_cli  */
#line 15906 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 45870 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2669: /* simple_ident: '.' ident_cli '.' ident_cli  */
#line 15911 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex_ident_cli empty((yyvsp[-2].ident_cli).pos(), 0);
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &empty, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 45880 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2670: /* simple_ident: ident_cli '.' ident_cli '.' ident_cli  */
#line 15917 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[-4].ident_cli), &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 45889 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2671: /* simple_ident: COLON_ORACLE_SYM ident_cli '.' ident_cli  */
#line 15922 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_colon_ident_ident(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 45898 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2672: /* simple_ident_nospvar: ident  */
#line 15930 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident_nosp(thd, &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 45907 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2673: /* simple_ident_nospvar: ident '.' ident  */
#line 15935 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident_nospvar(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 45916 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2674: /* simple_ident_nospvar: COLON_ORACLE_SYM ident_cli '.' ident_cli  */
#line 15940 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_colon_ident_ident(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 45925 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2675: /* simple_ident_nospvar: '.' ident '.' ident  */
#line 15945 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex_ident_sys none;
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &none, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 45935 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2676: /* simple_ident_nospvar: ident '.' ident '.' ident  */
#line 15951 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 45944 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2677: /* field_ident: ident  */
#line 15958 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                { (yyval.lex_str)=(yyvsp[0].ident_sys);}
#line 45950 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2678: /* field_ident: ident '.' ident '.' ident  */
#line 15960 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            TABLE_LIST *table= Select->table_list.first;
            if (unlikely(my_strcasecmp(table_alias_charset, (yyvsp[-4].ident_sys).str,
                                       table->db.str)))
              my_yyabort_error((ER_WRONG_DB_NAME, MYF(0), (yyvsp[-4].ident_sys).str));
            if (unlikely(my_strcasecmp(table_alias_charset, (yyvsp[-2].ident_sys).str,
                                       table->table_name.str)))
              my_yyabort_error((ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[-2].ident_sys).str));
            (yyval.lex_str)=(yyvsp[0].ident_sys);
          }
#line 45965 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2679: /* field_ident: ident '.' ident  */
#line 15971 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            TABLE_LIST *table= Select->table_list.first;
            if (unlikely(my_strcasecmp(table_alias_charset, (yyvsp[-2].ident_sys).str,
                         table->alias.str)))
              my_yyabort_error((ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[-2].ident_sys).str));
            (yyval.lex_str)=(yyvsp[0].ident_sys);
          }
#line 45977 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2680: /* field_ident: '.' ident  */
#line 15978 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.lex_str)=(yyvsp[0].ident_sys);}
#line 45983 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2681: /* table_ident: ident  */
#line 15983 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(&(yyvsp[0].ident_sys));
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 45993 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2682: /* table_ident: ident '.' ident  */
#line 15989 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys), 0);
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46003 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2683: /* table_ident: '.' ident  */
#line 15995 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* For Delphi */
            (yyval.table)= new (thd->mem_root) Table_ident(&(yyvsp[0].ident_sys));
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46014 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2684: /* table_ident_opt_wild: ident opt_wild  */
#line 16005 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(&(yyvsp[-1].ident_sys));
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46024 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2685: /* table_ident_opt_wild: ident '.' ident opt_wild  */
#line 16011 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(thd, &(yyvsp[-3].ident_sys), &(yyvsp[-1].ident_sys), 0);
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46034 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2686: /* table_ident_nodb: ident  */
#line 16020 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX_CSTRING db={(char*) any_db,3};
            (yyval.table)= new (thd->mem_root) Table_ident(thd, &db, &(yyvsp[0].ident_sys), 0);
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46045 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2691: /* ident_cli: keyword_ident  */
#line 16036 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.ident_cli)= (yyvsp[0].kwd); }
#line 46051 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2692: /* IDENT_sys: IDENT_cli  */
#line 16041 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(thd->to_ident_sys_alloc(&(yyval.ident_sys), &(yyvsp[0].ident_cli))))
              MYSQL_YYABORT;
          }
#line 46060 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2693: /* TEXT_STRING_sys: TEXT_STRING  */
#line 16049 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (thd->make_text_string_sys(&(yyval.lex_str), &(yyvsp[0].lex_string_with_metadata)))
              MYSQL_YYABORT;
          }
#line 46069 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2694: /* TEXT_STRING_literal: TEXT_STRING  */
#line 16057 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (thd->make_text_string_connection(&(yyval.lex_str), &(yyvsp[0].lex_string_with_metadata)))
              MYSQL_YYABORT;
          }
#line 46078 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2695: /* TEXT_STRING_filesystem: TEXT_STRING  */
#line 16065 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (thd->make_text_string_filesystem(&(yyval.lex_str), &(yyvsp[0].lex_string_with_metadata)))
              MYSQL_YYABORT;
          }
#line 46087 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2697: /* ident_table_alias: keyword_table_alias  */
#line 16074 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46096 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2699: /* ident_set_usual_case: keyword_set_usual_case  */
#line 16083 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46105 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2701: /* ident_sysvar_name: keyword_sysvar_name  */
#line 16092 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46114 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2702: /* ident_sysvar_name: TEXT_STRING_sys  */
#line 16097 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_sys(thd, &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 46123 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2704: /* ident: keyword_ident  */
#line 16107 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46132 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2706: /* ident_directly_assignable: keyword_directly_assignable  */
#line 16116 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46141 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2708: /* label_ident: keyword_label  */
#line 16126 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46150 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2709: /* labels_declaration_oracle: label_declaration_oracle  */
#line 16133 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.lex_str)= (yyvsp[0].lex_str); }
#line 46156 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2710: /* labels_declaration_oracle: labels_declaration_oracle label_declaration_oracle  */
#line 16134 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                             { (yyval.lex_str)= (yyvsp[0].lex_str); }
#line 46162 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2711: /* label_declaration_oracle: SHIFT_LEFT label_ident SHIFT_RIGHT  */
#line 16139 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_goto_label(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
            (yyval.lex_str)= (yyvsp[-1].ident_sys);
          }
#line 46172 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2712: /* ident_or_text: ident  */
#line 16147 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.lex_str)=(yyvsp[0].ident_sys);}
#line 46178 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2713: /* ident_or_text: TEXT_STRING_sys  */
#line 16148 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.lex_str)=(yyvsp[0].lex_str);}
#line 46184 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2714: /* ident_or_text: LEX_HOSTNAME  */
#line 16149 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.lex_str)=(yyvsp[0].lex_str);}
#line 46190 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2715: /* user_maybe_role: ident_or_text  */
#line 16154 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user = (yyvsp[0].lex_str);

            if (unlikely(check_string_char_length(&(yyval.lex_user)->user, ER_USERNAME,
                                                  username_char_length,
                                                  system_charset_info, 0)))
              MYSQL_YYABORT;
          }
#line 46205 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2716: /* user_maybe_role: ident_or_text '@' ident_or_text  */
#line 16165 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user = (yyvsp[-2].lex_str); (yyval.lex_user)->host=(yyvsp[0].lex_str);

            if (unlikely(check_string_char_length(&(yyval.lex_user)->user, ER_USERNAME,
                                                  username_char_length,
                                                 system_charset_info, 0)) ||
                unlikely(check_host_name(&(yyval.lex_user)->host)))
              MYSQL_YYABORT;
            if ((yyval.lex_user)->host.str[0])
            {
              /*
                Convert hostname part of username to lowercase.
                It's OK to use in-place lowercase as long as
                the character set is utf8.
              */
              my_casedn_str(system_charset_info, (char*) (yyval.lex_user)->host.str);
            }
            else
            {
              /*
                fix historical undocumented convention that empty host is the
                same as '%'
              */
              (yyval.lex_user)->host= host_not_specified;
            }
          }
#line 46238 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2717: /* user_maybe_role: CURRENT_USER optional_braces  */
#line 16194 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*)thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user= current_user;
            (yyval.lex_user)->auth= new (thd->mem_root) USER_AUTH();
          }
#line 46249 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2720: /* user: user_maybe_role  */
#line 16205 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           if ((yyvsp[0].lex_user)->user.str != current_user.str && (yyvsp[0].lex_user)->host.str == 0)
             (yyvsp[0].lex_user)->host= host_not_specified;
           (yyval.lex_user)= (yyvsp[0].lex_user);
         }
#line 46259 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3206: /* $@243: %empty  */
#line 16826 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (lex->main_select_push(true))
              MYSQL_YYABORT;
            lex->set_stmt_init();
            lex->var_list.empty();
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46273 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3207: /* set: SET $@243 start_option_value_list  */
#line 16836 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 46283 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3208: /* $@244: %empty  */
#line 16842 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->set_stmt_init();
          }
#line 46293 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3209: /* $@245: %empty  */
#line 16848 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->table_or_sp_used()))
              my_yyabort_error((ER_SUBQUERIES_NOT_SUPPORTED, MYF(0), "SET STATEMENT"));
            lex->stmt_var_list= lex->var_list;
            lex->var_list.empty();
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 46308 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3210: /* set: SET STATEMENT_SYM $@244 set_stmt_option_value_following_option_type_list $@245 FOR_SYM verb_clause  */
#line 16859 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 46314 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3211: /* $@246: %empty  */
#line 16864 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->set_stmt_init();
            lex->var_list.empty();
            if(sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46326 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3212: /* set_assign: ident_directly_assignable SET_VAR $@246 set_expr_or_default  */
#line 16872 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-3].ident_sys), (yyvsp[0].item))) ||
                unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46336 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3213: /* $@247: %empty  */
#line 16878 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->set_stmt_init();
            lex->var_list.empty();
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46348 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3214: /* set_assign: ident_directly_assignable '.' ident SET_VAR $@247 set_expr_or_default  */
#line 16886 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            DBUG_ASSERT(lex->var_list.is_empty());
            if (unlikely(lex->set_variable(&(yyvsp[-5].ident_sys), &(yyvsp[-3].ident_sys), (yyvsp[0].item))) ||
                unlikely(lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 46360 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3215: /* $@248: %empty  */
#line 16894 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!lex->is_trigger_new_or_old_reference(&(yyvsp[-3].ident_sys))))
            {
              thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-4].kwd).pos());
              MYSQL_YYABORT;
            }
            lex->set_stmt_init();
            lex->var_list.empty();
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46377 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3216: /* set_assign: COLON_ORACLE_SYM ident '.' ident SET_VAR $@248 set_expr_or_default  */
#line 16907 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX_CSTRING tmp= { (yyvsp[-5].ident_sys).str, (yyvsp[-5].ident_sys).length };
            if (unlikely(Lex->set_trigger_field(&tmp, &(yyvsp[-3].ident_sys), (yyvsp[0].item))) ||
                unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46388 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3219: /* $@249: %empty  */
#line 16928 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46397 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3221: /* $@250: %empty  */
#line 16934 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_type= OPT_DEFAULT;
          }
#line 46405 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3222: /* start_option_value_list: TRANSACTION_SYM $@250 transaction_characteristics  */
#line 16938 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46414 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3223: /* $@251: %empty  */
#line 16943 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_type= (yyvsp[0].var_type);
          }
#line 46422 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3225: /* $@252: %empty  */
#line 16953 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46431 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3227: /* start_option_value_list_following_option_type: TRANSACTION_SYM transaction_characteristics  */
#line 16959 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46440 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3230: /* $@253: %empty  */
#line 16973 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46449 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3231: /* option_value_list: $@253 option_value  */
#line 16978 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46458 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3232: /* $@254: %empty  */
#line 16983 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46467 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3233: /* option_value_list: option_value_list ',' $@254 option_value  */
#line 16988 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46476 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3234: /* $@255: %empty  */
#line 16997 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_type= (yyvsp[0].var_type);
          }
#line 46484 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3237: /* option_type: GLOBAL_SYM  */
#line 17005 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_GLOBAL; }
#line 46490 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3238: /* option_type: LOCAL_SYM  */
#line 17006 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46496 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3239: /* option_type: SESSION_SYM  */
#line 17007 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46502 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3240: /* opt_var_type: %empty  */
#line 17011 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46508 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3241: /* opt_var_type: GLOBAL_SYM  */
#line 17012 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_GLOBAL; }
#line 46514 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3242: /* opt_var_type: LOCAL_SYM  */
#line 17013 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46520 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3243: /* opt_var_type: SESSION_SYM  */
#line 17014 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46526 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3244: /* opt_var_ident_type: %empty  */
#line 17018 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.var_type)=OPT_DEFAULT; }
#line 46532 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3245: /* opt_var_ident_type: GLOBAL_SYM '.'  */
#line 17019 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.var_type)=OPT_GLOBAL; }
#line 46538 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3246: /* opt_var_ident_type: LOCAL_SYM '.'  */
#line 17020 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.var_type)=OPT_SESSION; }
#line 46544 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3247: /* opt_var_ident_type: SESSION_SYM '.'  */
#line 17021 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.var_type)=OPT_SESSION; }
#line 46550 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3248: /* option_value_following_option_type: ident equal set_expr_or_default  */
#line 17027 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_system_variable(Lex->option_type, &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46559 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3249: /* option_value_following_option_type: ident '.' ident equal set_expr_or_default  */
#line 17032 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_system_variable(thd, Lex->option_type, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46568 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3250: /* option_value_following_option_type: DEFAULT '.' ident equal set_expr_or_default  */
#line 17037 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_default_system_variable(Lex->option_type, &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46577 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3251: /* option_value_no_option_type: ident_set_usual_case equal set_expr_or_default  */
#line 17046 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46586 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3252: /* option_value_no_option_type: ident '.' ident equal set_expr_or_default  */
#line 17051 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46595 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3253: /* option_value_no_option_type: DEFAULT '.' ident equal set_expr_or_default  */
#line 17056 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_default_system_variable(Lex->option_type, &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46604 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3254: /* option_value_no_option_type: '@' ident_or_text equal expr  */
#line 17061 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_user_variable(thd, &(yyvsp[-2].lex_str), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46613 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3255: /* option_value_no_option_type: '@' '@' opt_var_ident_type ident_sysvar_name equal set_expr_or_default  */
#line 17066 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_system_variable((yyvsp[-3].var_type), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46622 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3256: /* option_value_no_option_type: '@' '@' opt_var_ident_type ident_sysvar_name '.' ident equal set_expr_or_default  */
#line 17071 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_system_variable(thd, (yyvsp[-5].var_type), &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46631 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3257: /* option_value_no_option_type: '@' '@' opt_var_ident_type DEFAULT '.' ident equal set_expr_or_default  */
#line 17076 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_default_system_variable((yyvsp[-5].var_type), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46640 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3258: /* option_value_no_option_type: charset old_or_new_charset_name_or_default  */
#line 17081 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            CHARSET_INFO *cs2;
            cs2= (yyvsp[0].charset) ? (yyvsp[0].charset): global_system_variables.character_set_client;
            set_var_collation_client *var;
            var= (new (thd->mem_root)
                  set_var_collation_client(cs2,
                                           thd->variables.collation_database,
                                            cs2));
            if (unlikely(var == NULL))
              MYSQL_YYABORT;
            lex->var_list.push_back(var, thd->mem_root);
          }
#line 46658 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3259: /* option_value_no_option_type: NAMES_SYM equal expr  */
#line 17095 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_pcontext *spc= lex->spcont;
            LEX_CSTRING names= { STRING_WITH_LEN("names") };
            if (unlikely(spc && spc->find_variable(&names, false)))
              my_error(ER_SP_BAD_VAR_SHADOW, MYF(0), names.str);
            else
              thd->parse_error();
            MYSQL_YYABORT;
          }
#line 46673 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3260: /* option_value_no_option_type: NAMES_SYM charset_name_or_default opt_collate  */
#line 17106 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            CHARSET_INFO *cs2;
            CHARSET_INFO *cs3;
            cs2= (yyvsp[-1].charset) ? (yyvsp[-1].charset) : global_system_variables.character_set_client;
            cs3= (yyvsp[0].charset) ? (yyvsp[0].charset) : cs2;
            if (unlikely(!my_charset_same(cs2, cs3)))
            {
              my_error(ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                       cs3->name, cs2->csname);
              MYSQL_YYABORT;
            }
            set_var_collation_client *var;
            var= new (thd->mem_root) set_var_collation_client(cs3, cs3, cs3);
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 46696 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3261: /* option_value_no_option_type: DEFAULT ROLE_SYM grant_role  */
#line 17125 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex = Lex;
            LEX_USER *user;
            if (unlikely(!(user=(LEX_USER *) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            user->user= current_user;
            set_var_default_role *var= (new (thd->mem_root)
                                        set_var_default_role(user,
                                                             (yyvsp[0].lex_user)->user));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;

            thd->lex->autocommit= TRUE;
            if (lex->sphead)
              lex->sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;
          }
#line 46718 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3262: /* option_value_no_option_type: DEFAULT ROLE_SYM grant_role FOR_SYM user  */
#line 17143 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex = Lex;
            set_var_default_role *var= (new (thd->mem_root)
                                        set_var_default_role((yyvsp[0].lex_user), (yyvsp[-2].lex_user)->user));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
            thd->lex->autocommit= TRUE;
            if (lex->sphead)
              lex->sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;
          }
#line 46734 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3263: /* option_value_no_option_type: ROLE_SYM ident_or_text  */
#line 17155 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex = Lex;
            set_var_role *var= new (thd->mem_root) set_var_role((yyvsp[0].lex_str));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 46746 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3264: /* option_value_no_option_type: ROLE_SYM equal set_expr_or_default  */
#line 17163 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-2].kwd), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46755 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3265: /* option_value_no_option_type: PASSWORD_SYM opt_for_user text_or_password  */
#line 17168 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex = Lex;
            set_var_password *var= (new (thd->mem_root)
                                    set_var_password(lex->definer));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
            lex->autocommit= TRUE;
            if (lex->sphead)
              lex->sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;
          }
#line 46771 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3270: /* transaction_access_mode: transaction_access_mode_types  */
#line 17191 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Item *item= new (thd->mem_root) Item_int(thd, (int32) (yyvsp[0].num));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            set_var *var= (new (thd->mem_root)
                           set_var(thd, lex->option_type,
                                   find_sys_var(thd, "tx_read_only"),
                                   &null_clex_str,
                                   item));
            if (unlikely(var == NULL))
              MYSQL_YYABORT;
            if (unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 46791 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3271: /* isolation_level: ISOLATION LEVEL_SYM isolation_types  */
#line 17210 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Item *item= new (thd->mem_root) Item_int(thd, (int32) (yyvsp[0].tx_isolation));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            set_var *var= (new (thd->mem_root)
                           set_var(thd, lex->option_type,
                                   find_sys_var(thd, "tx_isolation"),
                                   &null_clex_str,
                                   item));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 46810 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3272: /* transaction_access_mode_types: READ_SYM ONLY_SYM  */
#line 17227 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { (yyval.num)= true; }
#line 46816 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3273: /* transaction_access_mode_types: READ_SYM WRITE_SYM  */
#line 17228 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num)= false; }
#line 46822 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3274: /* isolation_types: READ_SYM UNCOMMITTED_SYM  */
#line 17232 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.tx_isolation)= ISO_READ_UNCOMMITTED; }
#line 46828 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3275: /* isolation_types: READ_SYM COMMITTED_SYM  */
#line 17233 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.tx_isolation)= ISO_READ_COMMITTED; }
#line 46834 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3276: /* isolation_types: REPEATABLE_SYM READ_SYM  */
#line 17234 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.tx_isolation)= ISO_REPEATABLE_READ; }
#line 46840 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3277: /* isolation_types: SERIALIZABLE_SYM  */
#line 17235 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.tx_isolation)= ISO_SERIALIZABLE; }
#line 46846 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3278: /* opt_for_user: equal  */
#line 17240 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            sp_pcontext *spc= lex->spcont;
            LEX_CSTRING pw= { STRING_WITH_LEN("password") };

            if (unlikely(spc && spc->find_variable(&pw, false)))
              my_yyabort_error((ER_SP_BAD_VAR_SHADOW, MYF(0), pw.str));
            if (unlikely(!(lex->definer= (LEX_USER*)
                           thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            lex->definer->user= current_user;
            lex->definer->auth= new (thd->mem_root) USER_AUTH();
          }
#line 46864 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3279: /* opt_for_user: FOR_SYM user equal  */
#line 17253 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { Lex->definer= (yyvsp[-1].lex_user); }
#line 46870 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3280: /* text_or_password: TEXT_STRING  */
#line 17258 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->definer->auth= new (thd->mem_root) USER_AUTH();
            Lex->definer->auth->auth_str= (yyvsp[0].lex_string_with_metadata);
          }
#line 46879 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3281: /* text_or_password: PASSWORD_SYM '(' TEXT_STRING ')'  */
#line 17263 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->definer->auth= new (thd->mem_root) USER_AUTH();
            Lex->definer->auth->pwtext= (yyvsp[-1].lex_string_with_metadata);
          }
#line 46888 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3282: /* text_or_password: OLD_PASSWORD_SYM '(' TEXT_STRING ')'  */
#line 17268 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->definer->auth= new (thd->mem_root) USER_AUTH();
            Lex->definer->auth->pwtext= (yyvsp[-1].lex_string_with_metadata);
            Lex->definer->auth->auth_str.str= Item_func_password::alloc(thd,
                                   (yyvsp[-1].lex_string_with_metadata).str, (yyvsp[-1].lex_string_with_metadata).length, Item_func_password::OLD);
            Lex->definer->auth->auth_str.length=  SCRAMBLED_PASSWORD_CHAR_LENGTH_323;
          }
#line 46900 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3283: /* set_expr_or_default: expr  */
#line 17278 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               { (yyval.item)=(yyvsp[0].item); }
#line 46906 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3284: /* set_expr_or_default: DEFAULT  */
#line 17279 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.item)=0; }
#line 46912 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3285: /* set_expr_or_default: ON  */
#line 17281 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_string_sys(thd, "ON",  2);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46922 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3286: /* set_expr_or_default: ALL  */
#line 17287 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_string_sys(thd, "ALL", 3);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46932 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3287: /* set_expr_or_default: BINARY  */
#line 17293 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_string_sys(thd, "binary", 6);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46942 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3288: /* $@256: %empty  */
#line 17304 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "LOCK"));
            lex->sql_command= SQLCOM_LOCK_TABLES;
          }
#line 46954 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3289: /* lock: LOCK_SYM table_or_tables $@256 table_lock_list opt_lock_wait_timeout  */
#line 17312 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 46960 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3290: /* opt_lock_wait_timeout: %empty  */
#line 17317 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {}
#line 46966 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3291: /* opt_lock_wait_timeout: WAIT_SYM ulong_num  */
#line 17319 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          if (unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("lock_wait_timeout"), (yyvsp[0].ulong_num))) ||
              unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("innodb_lock_wait_timeout"), (yyvsp[0].ulong_num))))
            MYSQL_YYABORT;
        }
#line 46976 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3292: /* opt_lock_wait_timeout: NOWAIT_SYM  */
#line 17325 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          if (unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("lock_wait_timeout"), 0)) ||
              unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("innodb_lock_wait_timeout"), 0)))
            MYSQL_YYABORT;
        }
#line 46986 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3293: /* table_or_tables: TABLE_SYM  */
#line 17333 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { }
#line 46992 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3294: /* table_or_tables: TABLES  */
#line 17334 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { }
#line 46998 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3297: /* table_lock: table_ident opt_table_alias_clause lock_option  */
#line 17344 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            thr_lock_type lock_type= (thr_lock_type) (yyvsp[0].num);
            bool lock_for_write= (lock_type >= TL_WRITE_ALLOW_WRITE);
            ulong table_options= lock_for_write ? TL_OPTION_UPDATING : 0;
            enum_mdl_type mdl_type= !lock_for_write
                                    ? MDL_SHARED_READ
                                    : lock_type == TL_WRITE_CONCURRENT_INSERT
                                      ? MDL_SHARED_WRITE
                                      : MDL_SHARED_NO_READ_WRITE;

            if (unlikely(!Lex->current_select_or_default()->
                         add_table_to_list(thd, (yyvsp[-2].table), (yyvsp[-1].lex_str_ptr), table_options,
                                           lock_type, mdl_type)))
              MYSQL_YYABORT;
          }
#line 47018 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3298: /* lock_option: READ_SYM  */
#line 17362 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.num)= TL_READ_NO_INSERT; }
#line 47024 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3299: /* lock_option: WRITE_SYM  */
#line 17363 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.num)= TL_WRITE_DEFAULT; }
#line 47030 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3300: /* lock_option: WRITE_SYM CONCURRENT  */
#line 17365 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= (Lex->sphead ? TL_WRITE_DEFAULT : TL_WRITE_CONCURRENT_INSERT);
          }
#line 47038 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3301: /* lock_option: LOW_PRIORITY WRITE_SYM  */
#line 17369 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.num)= TL_WRITE_LOW_PRIORITY; }
#line 47044 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3302: /* lock_option: READ_SYM LOCAL_SYM  */
#line 17370 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.num)= TL_READ; }
#line 47050 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3303: /* $@257: %empty  */
#line 17375 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "UNLOCK"));
            lex->sql_command= SQLCOM_UNLOCK_TABLES;
          }
#line 47062 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3304: /* unlock: UNLOCK_SYM $@257 table_or_tables  */
#line 17383 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 47068 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3305: /* $@258: %empty  */
#line 17392 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 47077 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3306: /* handler: HANDLER_SYM $@258 handler_tail  */
#line 17397 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 47085 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3307: /* handler_tail: table_ident OPEN_SYM opt_table_alias_clause  */
#line 17404 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HANDLER"));
            lex->sql_command = SQLCOM_HA_OPEN;
            if (!lex->current_select->add_table_to_list(thd, (yyvsp[-2].table), (yyvsp[0].lex_str_ptr), 0))
              MYSQL_YYABORT;
          }
#line 47098 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3308: /* handler_tail: table_ident_nodb CLOSE_SYM  */
#line 17413 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HANDLER"));
            lex->sql_command = SQLCOM_HA_CLOSE;
            if (!lex->current_select->add_table_to_list(thd, (yyvsp[-1].table), 0, 0))
              MYSQL_YYABORT;
          }
#line 47111 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3309: /* $@259: %empty  */
#line 17422 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HANDLER"));
            lex->clause_that_disallows_subselect= "HANDLER..READ";
            lex->sql_command = SQLCOM_HA_READ;
            lex->ha_rkey_mode= HA_READ_KEY_EXACT; /* Avoid purify warnings */
            Item *one= new (thd->mem_root) Item_int(thd, (int32) 1);
            if (unlikely(one == NULL))
              MYSQL_YYABORT;
            lex->current_select->select_limit= one;
            lex->current_select->offset_limit= 0;
            lex->limit_rows_examined= 0;
            if (!lex->current_select->add_table_to_list(thd, (yyvsp[-1].table), 0, 0))
              MYSQL_YYABORT;
          }
#line 47132 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3310: /* handler_tail: table_ident_nodb READ_SYM $@259 handler_read_or_scan opt_where_clause opt_global_limit_clause  */
#line 17439 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->clause_that_disallows_subselect= NULL;
            if (!lex->current_select->explicit_limit)
            {
              Item *one= new (thd->mem_root) Item_int(thd, (int32) 1);
              if (one == NULL)
                MYSQL_YYABORT;
              lex->current_select->select_limit= one;
              lex->current_select->offset_limit= 0;
              lex->limit_rows_examined= 0;
            }
            /* Stored functions are not supported for HANDLER READ. */
            if (lex->uses_stored_routines())
            {
              my_error(ER_NOT_SUPPORTED_YET, MYF(0),
                       "stored functions in HANDLER ... READ");
              MYSQL_YYABORT;
            }
          }
#line 47157 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3311: /* handler_read_or_scan: handler_scan_function  */
#line 17462 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->ident= null_clex_str; }
#line 47163 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3312: /* handler_read_or_scan: ident handler_rkey_function  */
#line 17463 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->ident= (yyvsp[-1].ident_sys); }
#line 47169 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3313: /* handler_scan_function: FIRST_SYM  */
#line 17467 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { Lex->ha_read_mode = RFIRST; }
#line 47175 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3314: /* handler_scan_function: NEXT_SYM  */
#line 17468 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { Lex->ha_read_mode = RNEXT;  }
#line 47181 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3315: /* handler_rkey_function: FIRST_SYM  */
#line 17472 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { Lex->ha_read_mode = RFIRST; }
#line 47187 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3316: /* handler_rkey_function: NEXT_SYM  */
#line 17473 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { Lex->ha_read_mode = RNEXT;  }
#line 47193 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3317: /* handler_rkey_function: PREV_SYM  */
#line 17474 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { Lex->ha_read_mode = RPREV;  }
#line 47199 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3318: /* handler_rkey_function: LAST_SYM  */
#line 17475 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { Lex->ha_read_mode = RLAST;  }
#line 47205 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3319: /* $@260: %empty  */
#line 17477 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->ha_read_mode = RKEY;
            lex->ha_rkey_mode=(yyvsp[0].ha_rkey_mode);
            if (unlikely(!(lex->insert_list= new (thd->mem_root) List_item)))
              MYSQL_YYABORT;
          }
#line 47217 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3320: /* handler_rkey_function: handler_rkey_mode $@260 '(' values ')'  */
#line 17485 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 47223 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3321: /* handler_rkey_mode: '='  */
#line 17489 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.ha_rkey_mode)=HA_READ_KEY_EXACT;   }
#line 47229 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3322: /* handler_rkey_mode: GE  */
#line 17490 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.ha_rkey_mode)=HA_READ_KEY_OR_NEXT; }
#line 47235 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3323: /* handler_rkey_mode: LE  */
#line 17491 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.ha_rkey_mode)=HA_READ_KEY_OR_PREV; }
#line 47241 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3324: /* handler_rkey_mode: '>'  */
#line 17492 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              { (yyval.ha_rkey_mode)=HA_READ_AFTER_KEY;   }
#line 47247 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3325: /* handler_rkey_mode: '<'  */
#line 17493 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.ha_rkey_mode)=HA_READ_BEFORE_KEY;  }
#line 47253 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3326: /* revoke: REVOKE clear_privileges revoke_command  */
#line 17500 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 47259 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3327: /* revoke_command: grant_privileges ON opt_table grant_ident FROM user_and_role_list  */
#line 17505 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_REVOKE;
            lex->type= 0;
          }
#line 47269 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3328: /* revoke_command: grant_privileges ON FUNCTION_SYM grant_ident FROM user_and_role_list  */
#line 17511 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                                                TYPE_ENUM_FUNCTION)))
              MYSQL_YYABORT;
          }
#line 47279 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3329: /* revoke_command: grant_privileges ON PROCEDURE_SYM grant_ident FROM user_and_role_list  */
#line 17517 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                         TYPE_ENUM_PROCEDURE)))
              MYSQL_YYABORT;
          }
#line 47289 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3330: /* revoke_command: grant_privileges ON PACKAGE_ORACLE_SYM grant_ident FROM user_and_role_list  */
#line 17524 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                                                TYPE_ENUM_PACKAGE)))
              MYSQL_YYABORT;
          }
#line 47299 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3331: /* revoke_command: grant_privileges ON PACKAGE_ORACLE_SYM BODY_ORACLE_SYM grant_ident FROM user_and_role_list  */
#line 17531 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                                                TYPE_ENUM_PACKAGE_BODY)))
              MYSQL_YYABORT;
          }
#line 47309 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3332: /* revoke_command: ALL opt_privileges ',' GRANT OPTION FROM user_and_role_list  */
#line 17537 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_REVOKE_ALL;
          }
#line 47317 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3333: /* revoke_command: PROXY_SYM ON user FROM user_list  */
#line 17541 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->users_list.push_front ((yyvsp[-2].lex_user));
            lex->sql_command= SQLCOM_REVOKE;
            lex->type= TYPE_ENUM_PROXY;
          }
#line 47328 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3334: /* revoke_command: admin_option_for_role FROM user_and_role_list  */
#line 17548 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_REVOKE_ROLE;
            if (unlikely(Lex->users_list.push_front((yyvsp[-2].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47338 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3335: /* admin_option_for_role: ADMIN_SYM OPTION FOR_SYM grant_role  */
#line 17557 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        { Lex->with_admin_option= true; (yyval.lex_user)= (yyvsp[0].lex_user); }
#line 47344 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3336: /* admin_option_for_role: grant_role  */
#line 17559 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        { Lex->with_admin_option= false; (yyval.lex_user)= (yyvsp[0].lex_user); }
#line 47350 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3337: /* grant: GRANT clear_privileges grant_command  */
#line 17564 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 47356 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3338: /* grant_command: grant_privileges ON opt_table grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17570 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_GRANT;
            lex->type= 0;
          }
#line 47366 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3339: /* grant_command: grant_privileges ON FUNCTION_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17577 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_FUNCTION)))
              MYSQL_YYABORT;
          }
#line 47376 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3340: /* grant_command: grant_privileges ON PROCEDURE_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17584 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_PROCEDURE)))
              MYSQL_YYABORT;
          }
#line 47386 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3341: /* grant_command: grant_privileges ON PACKAGE_ORACLE_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17591 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_PACKAGE)))
              MYSQL_YYABORT;
          }
#line 47396 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3342: /* grant_command: grant_privileges ON PACKAGE_ORACLE_SYM BODY_ORACLE_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17598 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_PACKAGE_BODY)))
              MYSQL_YYABORT;
          }
#line 47406 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3343: /* grant_command: PROXY_SYM ON user TO_SYM grant_list opt_grant_option  */
#line 17604 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->users_list.push_front ((yyvsp[-3].lex_user));
            lex->sql_command= SQLCOM_GRANT;
            lex->type= TYPE_ENUM_PROXY;
          }
#line 47417 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3344: /* grant_command: grant_role TO_SYM grant_list opt_with_admin_option  */
#line 17611 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_GRANT_ROLE;
            /* The first role is the one that is granted */
            if (unlikely(Lex->users_list.push_front((yyvsp[-3].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47429 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3345: /* opt_with_admin: %empty  */
#line 17622 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->definer = 0; }
#line 47435 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3346: /* opt_with_admin: WITH ADMIN_SYM user_or_role  */
#line 17623 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->definer = (yyvsp[0].lex_user); }
#line 47441 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3347: /* opt_with_admin_option: %empty  */
#line 17627 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->with_admin_option= false; }
#line 47447 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3348: /* opt_with_admin_option: WITH ADMIN_SYM OPTION  */
#line 17628 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->with_admin_option= true; }
#line 47453 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3349: /* role_list: grant_role  */
#line 17633 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47462 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3350: /* role_list: role_list ',' grant_role  */
#line 17638 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47471 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3351: /* current_role: CURRENT_ROLE optional_braces  */
#line 17646 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user= current_role;
            (yyval.lex_user)->auth= NULL;
          }
#line 47482 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3352: /* grant_role: ident_or_text  */
#line 17656 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            CHARSET_INFO *cs= system_charset_info;
            /* trim end spaces (as they'll be lost in mysql.user anyway) */
            (yyvsp[0].lex_str).length= cs->cset->lengthsp(cs, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            ((char*) (yyvsp[0].lex_str).str)[(yyvsp[0].lex_str).length] = '\0';
            if (unlikely((yyvsp[0].lex_str).length == 0))
              my_yyabort_error((ER_INVALID_ROLE, MYF(0), ""));
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->alloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user= (yyvsp[0].lex_str);
            (yyval.lex_user)->host= empty_clex_str;
            (yyval.lex_user)->auth= NULL;

            if (unlikely(check_string_char_length(&(yyval.lex_user)->user, ER_USERNAME,
                                                  username_char_length,
                                                  cs, 0)))
              MYSQL_YYABORT;
          }
#line 47505 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3356: /* grant_privileges: object_privilege_list  */
#line 17683 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                {}
#line 47511 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3357: /* grant_privileges: ALL opt_privileges  */
#line 17685 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            Lex->all_privileges= 1; 
            Lex->grant= GLOBAL_ACLS;
          }
#line 47520 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3362: /* $@261: %empty  */
#line 17703 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->which_columns = SELECT_ACL;}
#line 47526 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3363: /* object_privilege: SELECT_SYM $@261 opt_column_list  */
#line 17704 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 47532 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3364: /* $@262: %empty  */
#line 17706 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->which_columns = INSERT_ACL;}
#line 47538 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3365: /* object_privilege: INSERT $@262 opt_column_list  */
#line 17707 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 47544 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3366: /* $@263: %empty  */
#line 17709 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->which_columns = UPDATE_ACL; }
#line 47550 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3367: /* object_privilege: UPDATE_SYM $@263 opt_column_list  */
#line 17710 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 47556 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3368: /* $@264: %empty  */
#line 17712 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->which_columns = REFERENCES_ACL;}
#line 47562 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3369: /* object_privilege: REFERENCES $@264 opt_column_list  */
#line 17713 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 47568 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3370: /* object_privilege: DELETE_SYM  */
#line 17714 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= DELETE_ACL;}
#line 47574 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3371: /* object_privilege: USAGE  */
#line 17715 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  {}
#line 47580 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3372: /* object_privilege: INDEX_SYM  */
#line 17716 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= INDEX_ACL;}
#line 47586 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3373: /* object_privilege: ALTER  */
#line 17717 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= ALTER_ACL;}
#line 47592 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3374: /* object_privilege: CREATE  */
#line 17718 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= CREATE_ACL;}
#line 47598 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3375: /* object_privilege: DROP  */
#line 17719 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= DROP_ACL;}
#line 47604 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3376: /* object_privilege: EXECUTE_SYM  */
#line 17720 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= EXECUTE_ACL;}
#line 47610 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3377: /* object_privilege: RELOAD  */
#line 17721 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= RELOAD_ACL;}
#line 47616 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3378: /* object_privilege: SHUTDOWN  */
#line 17722 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= SHUTDOWN_ACL;}
#line 47622 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3379: /* object_privilege: PROCESS  */
#line 17723 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= PROCESS_ACL;}
#line 47628 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3380: /* object_privilege: FILE_SYM  */
#line 17724 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= FILE_ACL;}
#line 47634 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3381: /* object_privilege: GRANT OPTION  */
#line 17725 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= GRANT_ACL;}
#line 47640 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3382: /* object_privilege: SHOW DATABASES  */
#line 17726 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= SHOW_DB_ACL;}
#line 47646 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3383: /* object_privilege: SUPER_SYM  */
#line 17727 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= SUPER_ACL;}
#line 47652 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3384: /* object_privilege: CREATE TEMPORARY TABLES  */
#line 17728 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= CREATE_TMP_ACL;}
#line 47658 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3385: /* object_privilege: LOCK_SYM TABLES  */
#line 17729 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= LOCK_TABLES_ACL; }
#line 47664 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3386: /* object_privilege: REPLICATION SLAVE  */
#line 17730 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= REPL_SLAVE_ACL; }
#line 47670 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3387: /* object_privilege: REPLICATION CLIENT_SYM  */
#line 17731 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= REPL_CLIENT_ACL; }
#line 47676 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3388: /* object_privilege: CREATE VIEW_SYM  */
#line 17732 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= CREATE_VIEW_ACL; }
#line 47682 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3389: /* object_privilege: SHOW VIEW_SYM  */
#line 17733 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= SHOW_VIEW_ACL; }
#line 47688 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3390: /* object_privilege: CREATE ROUTINE_SYM  */
#line 17734 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= CREATE_PROC_ACL; }
#line 47694 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3391: /* object_privilege: ALTER ROUTINE_SYM  */
#line 17735 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= ALTER_PROC_ACL; }
#line 47700 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3392: /* object_privilege: CREATE USER_SYM  */
#line 17736 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= CREATE_USER_ACL; }
#line 47706 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3393: /* object_privilege: EVENT_SYM  */
#line 17737 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= EVENT_ACL;}
#line 47712 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3394: /* object_privilege: TRIGGER_SYM  */
#line 17738 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= TRIGGER_ACL; }
#line 47718 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3395: /* object_privilege: CREATE TABLESPACE  */
#line 17739 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= CREATE_TABLESPACE_ACL; }
#line 47724 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3396: /* object_privilege: DELETE_SYM HISTORY_SYM  */
#line 17740 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= DELETE_HISTORY_ACL; }
#line 47730 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3397: /* opt_and: %empty  */
#line 17744 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 47736 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3398: /* opt_and: AND_SYM  */
#line 17745 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 47742 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3401: /* require_list_element: SUBJECT_SYM TEXT_STRING  */
#line 17755 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (lex->account_options.x509_subject.str)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "SUBJECT"));
            lex->account_options.x509_subject= (yyvsp[0].lex_string_with_metadata);
          }
#line 47753 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3402: /* require_list_element: ISSUER_SYM TEXT_STRING  */
#line 17762 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (lex->account_options.x509_issuer.str)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "ISSUER"));
            lex->account_options.x509_issuer= (yyvsp[0].lex_string_with_metadata);
          }
#line 47764 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3403: /* require_list_element: CIPHER_SYM TEXT_STRING  */
#line 17769 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (lex->account_options.ssl_cipher.str)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CIPHER"));
            lex->account_options.ssl_cipher= (yyvsp[0].lex_string_with_metadata);
          }
#line 47775 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3404: /* grant_ident: '*'  */
#line 17779 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->copy_db_to(&lex->first_select_lex()->db)))
              MYSQL_YYABORT;
            if (lex->grant == GLOBAL_ACLS)
              lex->grant = DB_ACLS & ~GRANT_ACL;
            else if (unlikely(lex->columns.elements))
              my_yyabort_error((ER_ILLEGAL_GRANT_FOR_TABLE, MYF(0)));
          }
#line 47789 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3405: /* grant_ident: ident '.' '*'  */
#line 17789 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->first_select_lex()->db= (yyvsp[-2].ident_sys);
            if (lex->grant == GLOBAL_ACLS)
              lex->grant = DB_ACLS & ~GRANT_ACL;
            else if (unlikely(lex->columns.elements))
              my_yyabort_error((ER_ILLEGAL_GRANT_FOR_TABLE, MYF(0)));
          }
#line 47802 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3406: /* grant_ident: '*' '.' '*'  */
#line 17798 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->first_select_lex()->db= null_clex_str;
            if (lex->grant == GLOBAL_ACLS)
              lex->grant= GLOBAL_ACLS & ~GRANT_ACL;
            else if (unlikely(lex->columns.elements))
              my_yyabort_error((ER_ILLEGAL_GRANT_FOR_TABLE, MYF(0)));
          }
#line 47815 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3407: /* grant_ident: table_ident  */
#line 17807 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(!lex->first_select_lex()->
                         add_table_to_list(thd, (yyvsp[0].table),NULL,
                                           TL_OPTION_UPDATING)))
              MYSQL_YYABORT;
            if (lex->grant == GLOBAL_ACLS)
              lex->grant =  TABLE_ACLS & ~GRANT_ACL;
          }
#line 47829 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3408: /* user_list: user  */
#line 17820 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47838 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3409: /* user_list: user_list ',' user  */
#line 17825 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47847 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3410: /* grant_list: grant_user  */
#line 17833 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47856 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3411: /* grant_list: grant_list ',' grant_user  */
#line 17838 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47865 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3412: /* user_and_role_list: user_or_role  */
#line 17846 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47874 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3413: /* user_and_role_list: user_and_role_list ',' user_or_role  */
#line 17851 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47883 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3418: /* grant_user: user IDENTIFIED_SYM BY TEXT_STRING  */
#line 17862 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_user)= (yyvsp[-3].lex_user);
            (yyvsp[-3].lex_user)->auth= new (thd->mem_root) USER_AUTH();
            (yyvsp[-3].lex_user)->auth->pwtext= (yyvsp[0].lex_string_with_metadata);
          }
#line 47893 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3419: /* grant_user: user IDENTIFIED_SYM BY PASSWORD_SYM TEXT_STRING  */
#line 17868 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            (yyval.lex_user)= (yyvsp[-4].lex_user); 
            (yyvsp[-4].lex_user)->auth= new (thd->mem_root) USER_AUTH();
            (yyvsp[-4].lex_user)->auth->auth_str= (yyvsp[0].lex_string_with_metadata);
          }
#line 47903 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3420: /* grant_user: user IDENTIFIED_SYM via_or_with auth_expression  */
#line 17874 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_user)= (yyvsp[-3].lex_user);
            (yyvsp[-3].lex_user)->auth= (yyvsp[0].user_auth);
          }
#line 47912 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3421: /* grant_user: user_or_role  */
#line 17879 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_user)= (yyvsp[0].lex_user);
          }
#line 47920 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3422: /* auth_expression: auth_token OR_SYM auth_expression  */
#line 17886 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.user_auth)= (yyvsp[-2].user_auth);
            DBUG_ASSERT((yyval.user_auth)->next == NULL);
            (yyval.user_auth)->next= (yyvsp[0].user_auth);
          }
#line 47930 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3423: /* auth_expression: auth_token  */
#line 17892 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.user_auth)= (yyvsp[0].user_auth);
          }
#line 47938 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3424: /* auth_token: ident_or_text opt_auth_str  */
#line 17899 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.user_auth)= (yyvsp[0].user_auth);
          (yyval.user_auth)->plugin= (yyvsp[-1].lex_str);
        }
#line 47947 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3425: /* opt_auth_str: %empty  */
#line 17907 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          if (!((yyval.user_auth)=(USER_AUTH*) thd->calloc(sizeof(USER_AUTH))))
            MYSQL_YYABORT;
        }
#line 47956 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3426: /* opt_auth_str: using_or_as TEXT_STRING_sys  */
#line 17912 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          if (!((yyval.user_auth)=(USER_AUTH*) thd->calloc(sizeof(USER_AUTH))))
            MYSQL_YYABORT;
          (yyval.user_auth)->auth_str= (yyvsp[0].lex_str);
        }
#line 47966 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3427: /* opt_auth_str: using_or_as PASSWORD_SYM '(' TEXT_STRING ')'  */
#line 17918 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          if (!((yyval.user_auth)=(USER_AUTH*) thd->calloc(sizeof(USER_AUTH))))
            MYSQL_YYABORT;
          (yyval.user_auth)->pwtext= (yyvsp[-1].lex_string_with_metadata);
        }
#line 47976 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3428: /* opt_column_list: %empty  */
#line 17927 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->grant |= lex->which_columns;
          }
#line 47985 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3429: /* opt_column_list: '(' column_list ')'  */
#line 17931 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { }
#line 47991 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3432: /* column_list_id: ident  */
#line 17941 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            String *new_str= new (thd->mem_root) String((const char*) (yyvsp[0].ident_sys).str,(yyvsp[0].ident_sys).length,system_charset_info);
            if (unlikely(new_str == NULL))
              MYSQL_YYABORT;
            List_iterator <LEX_COLUMN> iter(Lex->columns);
            class LEX_COLUMN *point;
            LEX *lex=Lex;
            while ((point=iter++))
            {
              if (!my_strcasecmp(system_charset_info,
                                 point->column.c_ptr(), new_str->c_ptr()))
                break;
            }
            lex->grant_tot_col|= lex->which_columns;
            if (point)
              point->rights |= lex->which_columns;
            else
            {
              LEX_COLUMN *col= (new (thd->mem_root)
                                LEX_COLUMN(*new_str,lex->which_columns));
              if (unlikely(col == NULL))
                MYSQL_YYABORT;
              lex->columns.push_back(col, thd->mem_root);
            }
          }
#line 48021 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3434: /* opt_require_clause: REQUIRE_SYM require_list  */
#line 17971 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_SPECIFIED;
          }
#line 48029 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3435: /* opt_require_clause: REQUIRE_SYM SSL_SYM  */
#line 17975 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_ANY;
          }
#line 48037 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3436: /* opt_require_clause: REQUIRE_SYM X509_SYM  */
#line 17979 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_X509;
          }
#line 48045 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3437: /* opt_require_clause: REQUIRE_SYM NONE_SYM  */
#line 17983 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_NONE;
          }
#line 48053 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3438: /* resource_option: MAX_QUERIES_PER_HOUR ulong_num  */
#line 17990 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.questions=(yyvsp[0].ulong_num);
            Lex->account_options.specified_limits|= USER_RESOURCES::QUERIES_PER_HOUR;
          }
#line 48062 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3439: /* resource_option: MAX_UPDATES_PER_HOUR ulong_num  */
#line 17995 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.updates=(yyvsp[0].ulong_num);
            Lex->account_options.specified_limits|= USER_RESOURCES::UPDATES_PER_HOUR;
          }
#line 48071 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3440: /* resource_option: MAX_CONNECTIONS_PER_HOUR ulong_num  */
#line 18000 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.conn_per_hour= (yyvsp[0].ulong_num);
            Lex->account_options.specified_limits|= USER_RESOURCES::CONNECTIONS_PER_HOUR;
          }
#line 48080 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3441: /* resource_option: MAX_USER_CONNECTIONS_SYM int_num  */
#line 18005 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.user_conn= (yyvsp[0].num);
            Lex->account_options.specified_limits|= USER_RESOURCES::USER_CONNECTIONS;
          }
#line 48089 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3442: /* resource_option: MAX_STATEMENT_TIME_SYM NUM_literal  */
#line 18010 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.max_statement_time= (yyvsp[0].item_num)->val_real();
            Lex->account_options.specified_limits|= USER_RESOURCES::MAX_STATEMENT_TIME;
          }
#line 48098 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3443: /* resource_option_list: resource_option_list resource_option  */
#line 18017 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                               {}
#line 48104 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3444: /* resource_option_list: resource_option  */
#line 18018 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 48110 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3445: /* opt_resource_options: %empty  */
#line 18022 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 48116 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3447: /* opt_grant_options: %empty  */
#line 18028 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 48122 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3448: /* opt_grant_options: WITH grant_option_list  */
#line 18029 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 {}
#line 48128 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3449: /* opt_grant_option: %empty  */
#line 18033 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 48134 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3450: /* opt_grant_option: WITH GRANT OPTION  */
#line 18034 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->grant |= GRANT_ACL;}
#line 48140 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3451: /* grant_option_list: grant_option_list grant_option  */
#line 18038 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         {}
#line 48146 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3452: /* grant_option_list: grant_option  */
#line 18039 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 48152 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3453: /* grant_option: GRANT OPTION  */
#line 18043 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->grant |= GRANT_ACL;}
#line 48158 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3454: /* grant_option: resource_option  */
#line 18044 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 48164 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3455: /* $@265: %empty  */
#line 18049 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_BEGIN;
            lex->start_transaction_opt= 0;
          }
#line 48174 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3456: /* begin_stmt_mariadb: BEGIN_MARIADB_SYM $@265 opt_work  */
#line 18054 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   {}
#line 48180 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3457: /* compound_statement: sp_proc_stmt_compound_ok  */
#line 18059 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_COMPOUND;
            if (Lex->sp_body_finalize_procedure(thd))
              MYSQL_YYABORT;
          }
#line 48190 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3458: /* opt_not: %empty  */
#line 18067 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.num)= 0; }
#line 48196 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3459: /* opt_not: not  */
#line 18068 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.num)= 1; }
#line 48202 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3460: /* opt_work: %empty  */
#line 18072 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 48208 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3461: /* opt_work: WORK_SYM  */
#line 18073 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 48214 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3462: /* opt_chain: %empty  */
#line 18078 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.m_yes_no_unk)= TVL_UNKNOWN; }
#line 48220 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3463: /* opt_chain: AND_SYM NO_SYM CHAIN_SYM  */
#line 18079 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.m_yes_no_unk)= TVL_NO; }
#line 48226 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3464: /* opt_chain: AND_SYM CHAIN_SYM  */
#line 18080 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.m_yes_no_unk)= TVL_YES; }
#line 48232 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3465: /* opt_release: %empty  */
#line 18085 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.m_yes_no_unk)= TVL_UNKNOWN; }
#line 48238 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3466: /* opt_release: RELEASE_SYM  */
#line 18086 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.m_yes_no_unk)= TVL_YES; }
#line 48244 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3467: /* opt_release: NO_SYM RELEASE_SYM  */
#line 18087 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.m_yes_no_unk)= TVL_NO; }
#line 48250 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3468: /* commit: COMMIT_SYM opt_work opt_chain opt_release  */
#line 18092 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_COMMIT;
            /* Don't allow AND CHAIN RELEASE. */
            MYSQL_YYABORT_UNLESS((yyvsp[-1].m_yes_no_unk) != TVL_YES || (yyvsp[0].m_yes_no_unk) != TVL_YES);
            lex->tx_chain= (yyvsp[-1].m_yes_no_unk);
            lex->tx_release= (yyvsp[0].m_yes_no_unk);
          }
#line 48263 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3469: /* rollback: ROLLBACK_SYM opt_work opt_chain opt_release  */
#line 18104 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK;
            /* Don't allow AND CHAIN RELEASE. */
            MYSQL_YYABORT_UNLESS((yyvsp[-1].m_yes_no_unk) != TVL_YES || (yyvsp[0].m_yes_no_unk) != TVL_YES);
            lex->tx_chain= (yyvsp[-1].m_yes_no_unk);
            lex->tx_release= (yyvsp[0].m_yes_no_unk);
          }
#line 48276 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3470: /* rollback: ROLLBACK_SYM opt_work TO_SYM SAVEPOINT_SYM ident  */
#line 18113 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK_TO_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48286 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3471: /* rollback: ROLLBACK_SYM opt_work TO_SYM ident  */
#line 18119 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK_TO_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48296 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3472: /* savepoint: SAVEPOINT_SYM ident  */
#line 18128 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48306 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3473: /* release: RELEASE_SYM SAVEPOINT_SYM ident  */
#line 18137 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_RELEASE_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48316 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3474: /* unit_type_decl: UNION_SYM union_option  */
#line 18150 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.unit_operation).unit_type= UNION_TYPE; (yyval.unit_operation).distinct= (yyvsp[0].num); }
#line 48322 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3475: /* unit_type_decl: INTERSECT_SYM  */
#line 18152 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.unit_operation).unit_type= INTERSECT_TYPE; (yyval.unit_operation).distinct= 1; }
#line 48328 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3476: /* unit_type_decl: EXCEPT_SYM  */
#line 18154 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.unit_operation).unit_type= EXCEPT_TYPE; (yyval.unit_operation).distinct= 1; }
#line 48334 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3477: /* union_option: %empty  */
#line 18161 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)=1; }
#line 48340 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3478: /* union_option: DISTINCT  */
#line 18162 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.num)=1; }
#line 48346 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3479: /* union_option: ALL  */
#line 18163 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.num)=0; }
#line 48352 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3480: /* query_expression_option: STRAIGHT_JOIN  */
#line 18167 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Select->options|= SELECT_STRAIGHT_JOIN; }
#line 48358 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3481: /* query_expression_option: HIGH_PRIORITY  */
#line 18169 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            YYPS->m_lock_type= TL_READ_HIGH_PRIORITY;
            YYPS->m_mdl_type= MDL_SHARED_READ;
            Select->options|= SELECT_HIGH_PRIORITY;
          }
#line 48368 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3482: /* query_expression_option: DISTINCT  */
#line 18174 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { Select->options|= SELECT_DISTINCT; }
#line 48374 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3483: /* query_expression_option: UNIQUE_SYM  */
#line 18175 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { Select->options|= SELECT_DISTINCT; }
#line 48380 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3484: /* query_expression_option: SQL_SMALL_RESULT  */
#line 18176 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { Select->options|= SELECT_SMALL_RESULT; }
#line 48386 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3485: /* query_expression_option: SQL_BIG_RESULT  */
#line 18177 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { Select->options|= SELECT_BIG_RESULT; }
#line 48392 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3486: /* query_expression_option: SQL_BUFFER_RESULT  */
#line 18178 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Select->options|= OPTION_BUFFER_RESULT; }
#line 48398 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3487: /* query_expression_option: SQL_CALC_FOUND_ROWS  */
#line 18179 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Select->options|= OPTION_FOUND_ROWS; }
#line 48404 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3488: /* query_expression_option: ALL  */
#line 18180 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              { Select->options|= SELECT_ALL; }
#line 48410 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3491: /* no_definer: %empty  */
#line 18196 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              We have to distinguish missing DEFINER-clause from case when
              CURRENT_USER specified as definer explicitly in order to properly
              handle CREATE TRIGGER statements which come to replication thread
              from older master servers (i.e. to create non-suid trigger in this
              case).
            */
            thd->lex->definer= 0;
          }
#line 48425 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3492: /* definer: DEFINER_SYM '=' user_or_role  */
#line 18210 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->definer= (yyvsp[0].lex_user);
            Lex->account_options.reset();
          }
#line 48434 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3493: /* view_algorithm: ALGORITHM_SYM '=' UNDEFINED_SYM  */
#line 18223 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= DTYPE_ALGORITHM_UNDEFINED; }
#line 48440 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3494: /* view_algorithm: ALGORITHM_SYM '=' MERGE_SYM  */
#line 18224 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= VIEW_ALGORITHM_MERGE; }
#line 48446 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3495: /* view_algorithm: ALGORITHM_SYM '=' TEMPTABLE_SYM  */
#line 18225 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= VIEW_ALGORITHM_TMPTABLE; }
#line 48452 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3496: /* opt_view_suid: %empty  */
#line 18229 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.view_suid)= VIEW_SUID_DEFAULT; }
#line 48458 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3497: /* opt_view_suid: view_suid  */
#line 18230 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.view_suid)= (yyvsp[0].view_suid); }
#line 48464 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3498: /* view_suid: SQL_SYM SECURITY_SYM DEFINER_SYM  */
#line 18234 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.view_suid)= VIEW_SUID_DEFINER; }
#line 48470 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3499: /* view_suid: SQL_SYM SECURITY_SYM INVOKER_SYM  */
#line 18235 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.view_suid)= VIEW_SUID_INVOKER; }
#line 48476 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3500: /* view_list_opt: %empty  */
#line 18240 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 48482 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3501: /* view_list_opt: '(' view_list ')'  */
#line 18241 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { }
#line 48488 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3502: /* view_list: ident  */
#line 18246 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->view_list.push_back((LEX_CSTRING*)
                                     thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)),
                                     thd->mem_root);
          }
#line 48498 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3503: /* view_list: view_list ',' ident  */
#line 18252 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->view_list.push_back((LEX_CSTRING*)
                                     thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)),
                                     thd->mem_root);
          }
#line 48508 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3504: /* $@266: %empty  */
#line 18260 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->parsing_options.allows_variable= FALSE;
            lex->create_view->select.str= (char *) YYLIP->get_cpp_ptr();
          }
#line 48518 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3505: /* view_select: $@266 query_expression view_check_option  */
#line 18267 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->parsed_create_view((yyvsp[-1].select_lex_unit), (yyvsp[0].num)))
              MYSQL_YYABORT;
          }
#line 48527 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3506: /* view_check_option: %empty  */
#line 18274 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= VIEW_CHECK_NONE; }
#line 48533 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3507: /* view_check_option: WITH CHECK_SYM OPTION  */
#line 18275 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= VIEW_CHECK_CASCADED; }
#line 48539 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3508: /* view_check_option: WITH CASCADED CHECK_SYM OPTION  */
#line 18276 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= VIEW_CHECK_CASCADED; }
#line 48545 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3509: /* view_check_option: WITH LOCAL_SYM CHECK_SYM OPTION  */
#line 18277 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= VIEW_CHECK_LOCAL; }
#line 48551 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3510: /* trigger_action_order: FOLLOWS_SYM  */
#line 18288 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { (yyval.trigger_action_order_type)= TRG_ORDER_FOLLOWS; }
#line 48557 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3511: /* trigger_action_order: PRECEDES_SYM  */
#line 18290 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { (yyval.trigger_action_order_type)= TRG_ORDER_PRECEDES; }
#line 48563 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3512: /* trigger_follows_precedes_clause: %empty  */
#line 18295 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            {
              (yyval.trg_execution_order).ordering_clause= TRG_ORDER_NONE;
              (yyval.trg_execution_order).anchor_trigger_name.str= NULL;
              (yyval.trg_execution_order).anchor_trigger_name.length= 0;
            }
#line 48573 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3513: /* trigger_follows_precedes_clause: trigger_action_order ident_or_text  */
#line 18302 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            {
              (yyval.trg_execution_order).ordering_clause= (yyvsp[-1].trigger_action_order_type);
              (yyval.trg_execution_order).anchor_trigger_name= (yyvsp[0].lex_str);
            }
#line 48582 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3514: /* $@267: %empty  */
#line 18311 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_create_options_with_check((yyvsp[0].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 48591 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3515: /* $@268: %empty  */
#line 18320 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* $9 */
            Lex->raw_trg_on_table_name_begin= YYLIP->get_tok_start();
          }
#line 48599 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3516: /* $@269: %empty  */
#line 18326 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* $13 */
            Lex->raw_trg_on_table_name_end= YYLIP->get_tok_start();
          }
#line 48607 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3517: /* $@270: %empty  */
#line 18331 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->trg_chistics.ordering_clause_begin= YYLIP->get_cpp_ptr();
          }
#line 48615 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3518: /* $@271: %empty  */
#line 18335 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* $18 */
            LEX *lex= thd->lex;
            Lex_input_stream *lip= YYLIP;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_RECURSIVE_CREATE, MYF(0), "TRIGGER"));

            lex->stmt_definition_begin= (yyvsp[-16].simple_string);
            lex->ident.str= (yyvsp[-9].simple_string);
            lex->ident.length= (yyvsp[-5].simple_string) - (yyvsp[-9].simple_string);
            lex->spname= (yyvsp[-13].spname);
            (*static_cast<st_trg_execution_order*>(&lex->trg_chistics))= ((yyvsp[0].trg_execution_order));
            lex->trg_chistics.ordering_clause_end= lip->get_cpp_ptr();

            if (unlikely(!lex->make_sp_head(thd, (yyvsp[-13].spname), &sp_handler_trigger,
                                            DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;

            lex->sphead->set_body_start(thd, lip->get_cpp_tok_start());
          }
#line 48640 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3519: /* trigger_tail: remember_name opt_if_not_exists $@267 sp_name trg_action_time trg_event ON remember_name $@268 table_ident FOR_SYM remember_name $@269 EACH_SYM ROW_SYM $@270 trigger_follows_precedes_clause $@271 sp_proc_stmt force_lookahead  */
#line 18356 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* $21 */
            LEX *lex= Lex;

            lex->sql_command= SQLCOM_CREATE_TRIGGER;
            if (lex->sp_body_finalize_trigger(thd))
              MYSQL_YYABORT;

            /*
              We have to do it after parsing trigger body, because some of
              sp_proc_stmt alternatives are not saving/restoring LEX, so
              lex->query_tables can be wiped out.
            */
            if (!lex->first_select_lex()->
                  add_table_to_list(thd, (yyvsp[-10].table), (LEX_CSTRING*) 0,
                                    TL_OPTION_UPDATING, TL_READ_NO_INSERT,
                                    MDL_SHARED_NO_WRITE))
              MYSQL_YYABORT;
          }
#line 48663 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3520: /* $@272: %empty  */
#line 18383 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->init_last_field(&lex->sphead->m_return_field_def,
                                 &empty_clex_str,
                                 thd->variables.collation_database);
          }
#line 48674 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3521: /* sf_return_type: $@272 sp_param_type  */
#line 18390 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->fill_field_definition(thd,
                                                            Lex->last_field)))
              MYSQL_YYABORT;
          }
#line 48684 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3522: /* $@273: %empty  */
#line 18399 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->sphead->set_c_chistics(lex->sp_chistics);
            lex->sphead->set_body_start(thd, YYLIP->get_cpp_tok_start());
          }
#line 48694 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3523: /* sf_c_chistics_and_body_standalone: sp_c_chistics $@273 sp_tail_is sp_body force_lookahead  */
#line 18406 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_body_finalize_function(thd)))
              MYSQL_YYABORT;
          }
#line 48703 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3524: /* $@274: %empty  */
#line 18414 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Lex->make_sp_head_no_recursive(thd, (yyvsp[0].spname),
                                                         &sp_handler_procedure,
                                                         DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;
          }
#line 48714 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3525: /* $@275: %empty  */
#line 18422 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->set_c_chistics(Lex->sp_chistics);
            Lex->sphead->set_body_start(thd, YYLIP->get_cpp_tok_start());
          }
#line 48723 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3526: /* sp_tail_standalone: sp_name $@274 opt_sp_parenthesized_pdparam_list sp_c_chistics $@275 sp_tail_is sp_body opt_sp_name  */
#line 18429 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_body_finalize_procedure_standalone(thd, (yyvsp[0].spname))))
              MYSQL_YYABORT;
          }
#line 48732 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3527: /* opt_package_routine_end_name: %empty  */
#line 18437 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str)= null_clex_str; }
#line 48738 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3528: /* opt_package_routine_end_name: ident  */
#line 18438 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 48744 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3531: /* xa: XA_SYM begin_or_start xid opt_join_or_resume  */
#line 18450 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_XA_START;
          }
#line 48752 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3532: /* xa: XA_SYM END xid opt_suspend  */
#line 18454 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_XA_END;
          }
#line 48760 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3533: /* xa: XA_SYM PREPARE_SYM xid  */
#line 18458 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_XA_PREPARE;
          }
#line 48768 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3534: /* xa: XA_SYM COMMIT_SYM xid opt_one_phase  */
#line 18462 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_XA_COMMIT;
          }
#line 48776 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3535: /* xa: XA_SYM ROLLBACK_SYM xid  */
#line 18466 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_XA_ROLLBACK;
          }
#line 48784 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3536: /* xa: XA_SYM RECOVER_SYM opt_format_xid  */
#line 18470 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_XA_RECOVER;
            Lex->verbose= (yyvsp[0].num);
          }
#line 48793 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3537: /* opt_format_xid: %empty  */
#line 18477 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.num)= false; }
#line 48799 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3538: /* opt_format_xid: FORMAT_SYM '=' ident_or_text  */
#line 18479 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("SQL")))
              (yyval.num)= true;
            else if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("RAW")))
              (yyval.num)= false;
            else
            {
              my_yyabort_error((ER_UNKNOWN_EXPLAIN_FORMAT, MYF(0),
                               "XA RECOVER", (yyvsp[0].lex_str).str));
              (yyval.num)= false;
            }
          }
#line 48816 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3539: /* xid: text_string  */
#line 18495 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[0].string)->length() <= MAXGTRIDSIZE);
            if (unlikely(!(Lex->xid=(XID *)thd->alloc(sizeof(XID)))))
              MYSQL_YYABORT;
            Lex->xid->set(1L, (yyvsp[0].string)->ptr(), (yyvsp[0].string)->length(), 0, 0);
          }
#line 48827 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3540: /* xid: text_string ',' text_string  */
#line 18502 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-2].string)->length() <= MAXGTRIDSIZE && (yyvsp[0].string)->length() <= MAXBQUALSIZE);
            if (unlikely(!(Lex->xid=(XID *)thd->alloc(sizeof(XID)))))
              MYSQL_YYABORT;
            Lex->xid->set(1L, (yyvsp[-2].string)->ptr(), (yyvsp[-2].string)->length(), (yyvsp[0].string)->ptr(), (yyvsp[0].string)->length());
          }
#line 48838 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3541: /* xid: text_string ',' text_string ',' ulong_num  */
#line 18509 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-4].string)->length() <= MAXGTRIDSIZE && (yyvsp[-2].string)->length() <= MAXBQUALSIZE);
            if (unlikely(!(Lex->xid=(XID *)thd->alloc(sizeof(XID)))))
              MYSQL_YYABORT;
            Lex->xid->set((yyvsp[0].ulong_num), (yyvsp[-4].string)->ptr(), (yyvsp[-4].string)->length(), (yyvsp[-2].string)->ptr(), (yyvsp[-2].string)->length());
          }
#line 48849 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3542: /* begin_or_start: BEGIN_MARIADB_SYM  */
#line 18518 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            {}
#line 48855 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3543: /* begin_or_start: BEGIN_ORACLE_SYM  */
#line 18519 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           {}
#line 48861 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3544: /* begin_or_start: START_SYM  */
#line 18520 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 48867 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3545: /* opt_join_or_resume: %empty  */
#line 18524 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->xa_opt=XA_NONE;        }
#line 48873 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3546: /* opt_join_or_resume: JOIN_SYM  */
#line 18525 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->xa_opt=XA_JOIN;        }
#line 48879 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3547: /* opt_join_or_resume: RESUME_SYM  */
#line 18526 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->xa_opt=XA_RESUME;      }
#line 48885 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3548: /* opt_one_phase: %empty  */
#line 18530 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->xa_opt=XA_NONE;        }
#line 48891 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3549: /* opt_one_phase: ONE_SYM PHASE_SYM  */
#line 18531 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->xa_opt=XA_ONE_PHASE;   }
#line 48897 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3550: /* opt_suspend: %empty  */
#line 18536 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->xa_opt=XA_NONE;        }
#line 48903 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3551: /* $@276: %empty  */
#line 18538 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->xa_opt=XA_SUSPEND;     }
#line 48909 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3553: /* opt_migrate: %empty  */
#line 18543 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              {}
#line 48915 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3554: /* opt_migrate: FOR_SYM MIGRATE_SYM  */
#line 18544 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->xa_opt=XA_FOR_MIGRATE; }
#line 48921 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3555: /* install: INSTALL_SYM PLUGIN_SYM opt_if_not_exists ident SONAME_SYM TEXT_STRING_sys  */
#line 18549 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_install_plugin((yyvsp[-3].object_ddl_options), (yyvsp[-2].ident_sys), (yyvsp[0].lex_str)))
              MYSQL_YYABORT;
          }
#line 48930 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3556: /* install: INSTALL_SYM SONAME_SYM TEXT_STRING_sys  */
#line 18554 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->stmt_install_plugin((yyvsp[0].lex_str));
          }
#line 48938 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3557: /* uninstall: UNINSTALL_SYM PLUGIN_SYM opt_if_exists ident  */
#line 18561 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_uninstall_plugin_by_name((yyvsp[-1].object_ddl_options), (yyvsp[0].ident_sys)))
              MYSQL_YYABORT;
          }
#line 48947 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3558: /* uninstall: UNINSTALL_SYM SONAME_SYM opt_if_exists TEXT_STRING_sys  */
#line 18566 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_uninstall_plugin_by_soname((yyvsp[-1].object_ddl_options), (yyvsp[0].lex_str)))
              MYSQL_YYABORT;
          }
#line 48956 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3559: /* keep_gcc_happy: IMPOSSIBLE_ACTION  */
#line 18575 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            YYERROR;
          }
#line 48964 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;


#line 48968 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (thd, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, thd);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, thd);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (thd, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, thd);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, thd);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

